(* ---------------------------------------------------------------
Title         Q&D Rapport
Author        PhG
Overview      display data
Usage         see help
Notes         very, very, very quick & dirty... :-(
              aspect nature 0=conjonction, 1=dissonant, 2=harmonique USED
              we handle $if HARMONIQUE / $if DISSONANT (aspects received by a planet)
              but for now, we consider all aspects with real planets, whether enabled or not,
              and we ignore fictitious points
Bugs          faudra vrifier l'effet de la correction deltaTU (P, L, etc.)

		XDS does not like cast on strings passed to a function
		it won't support changing a string passed as a constant
		BUT it won't complain when compiling !
		we have to copy passed strings to local copies so dmp#() work as they do with TS

Wish List     filter if ASMCDSFC and abs(lat)> 66 ? in dmpByAspect/Object ?
              not done yet : conditionalist analysis !
              add a third ponderation : if planet at 5 before ASMCDSFC,
              then count it in the two houses -- if planet at 1 from next,
              count to next -- add 2 for planets in domicile

--------------------------------------------------------------- *)

MODULE Rapport;

IMPORT FIO;
IMPORT Str;
IMPORT Lib;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, chkJoker,
isOption, GetOptIndex, GetLongCard, GetString, CharCount, same, cleantabs,
aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,str1024, isoleItemS,dmpTTX, str2048, Elapsed,
GetLongInt, str4096, str16,pathtype;

FROM QD_Sky IMPORT int, frac, mod, DateToJD, JDtoDate, JDtoJD0H,
JDtoWeekday, JDtoT, isDigit, MatchFormat, getLastCard, stripCard,
getCard, parseDate, parseTime, parseLongitude, DateTimeToJD,
CalcBornes, chkZoneFR, ToggleSign, parseLatitude, parseDeltaTU,
DateToStr, TimeToStr, themeFile, themeID, themetype, displayfmt,
AngleToStr, isDirect, loadTheme, saveTheme, PadsSetup, AngleToPos,
fmtLatitude, fmtLongitude, fmtDeltaTU, between, inAspect,
isAngulaire, inAspectBeta, inZone, swapBool, sepline,
chkThemeVersion,  minorbeplus, maxorbeplus,
processGender, stringToVal, greater, smaller;

FROM QD_Calc IMPORT Calc, InitCalc, calcmode, objet, cuspide, sens,
domificationtype, solarsystemtype,housetype,skypos, InitCalcLocal,
CalcDomification, CalcTrueHouse, CalcAzimutAltitude,
getLastCusp, chkDomificationRange, angleIsCusp, firstCusp, lastCusp,
clockwiseDom;

FROM QD_Ini IMPORT readIniFile, listSections, findEntry,
getItemStrUp, getItemCard, getItemBool, getItemChar,
readIniFileEnh, FreeIni, getItemReal0_1, getItemReal;

FROM QD_Names IMPORT astroToolsName,
sRessources, eTraditionnelle, eConditionaliste,
sReport, eMethod, ePadChar, ePadSign, ePadComa, eDecimal,
eFavoriteHouse, eData, eSynthesis, eInSign, eInHouse, eInTrueHouse,
eMotion, ePlacidus, eCampanus, eRegiomontanus, ePtolemeus, eKoch,
eByAspect, eByAspectWithFictitious, eByObject, eByObjectWithFictitious,
eAngularities, eAnalysisRET, eCoefficients, eTradition, eGeocentric,
eEquatorial, eLocal, eHeliocentric, eUseTabs, eCoefficientsWithFictitious,
sObjectEnabled, sAspectEnabled, sAspectRank, sObjectRank, sObjectGroup,
sObjectWeight, sOrbe11, sOrbe22, sOrbe33, sOrbe12, sOrbe13, sOrbe23,
sInfo,eRET,eByAspectWithBeta,eByAspectWithBetaWithAngles,
eByObjectWithBeta,eByObjectWithBetaWithAngles,
eOrbeAngulaireAS,eOrbeAngulaireMC, eOrbeAngulaireDS, eOrbeAngulaireFC,
aspecttype,getObjectName, getCuspideName, getMotionStr,
getDomificationStr, getAspectName, getRomanStr,
objectinfotype, aspectinfotype, objectinfoarray, aspectinfoarray, signtype,
firstObject, lastObject, firstAspect, lastAspect, getSignName,
isPlanete, isFictitious, getSectorName, isAngle, getMotionAbrev,
getEcart, grouptype, getGroupClass, firstSign,lastSign,
dignitytype, getDignityName, getDignity, getMaitrise, getDignityAlt,
eInterpret, eLineWidth, eTextes,ePointeurs,readIndexFile,
sREM, sEntry, sEOF, eKeepEmptyLine,
sfWarning, sfAngulaires, sfSignes, sfMaisons, sfSante, stIntro,
stEt, stConjonction, stHarmonique, stDissonant, stSoleilAS,
st000, st180, st090, st120, st060, stnil, findIndexFileOffset,
findFileEntry, readFileEntry, findFileEntryAspect,
natNeutral, natDissonant, natHarmonic, stDux, eUseBetaForTexts, ProgCopyright,
sRETzoneLimits, e1_xii, e1_i, e2_x, e2_ix,
e3_vii, e3_vi, e4_iii, e4_iv, eHalf, eTwoThird, getCuspideNameAlt,
eHDStateUsingEnabledState, eHDStateAlwaysIgnoringASMC, isDSFC,
getObjectNameFR, getAspectNameFR, getSectorNameAlt,
isAxisOrUseless, eAvoidAxisOrUseless,
txtDomKeys, txtDomParms,
eUseAltOrbesNatal, sAltOrbesNatal, seasontype, getSaison, getSeasonName,
objectindexarray, aspectindexarray, msgUnsafeOption,msgUnsafeChart;




IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "RAPPORT";
    ProgTitle     = "Q&D Rapport (Win32)";
    ProgVersion   = "v0.9 (v1.2e DOS)";
    ProgBanner    = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extEXE        = ".EXE"; (* upper case *)
    extTHM        = ".TM";
    extRPT        = ".RPT";
    extINI        = ".INI";
    extRSC        = ".RSC";
    extNDX        = ".RSX"; (* was ndx *)
    extHID        = ".HID";
    extHIX        = ".HIX";

    extTXT       = ".TXT";
    extASP       = ".ASP";
    extHOU       = ".HOU";

    extMAS       = ".MAS";

    extTRA       = ".TRA"; (* transits : metteurs sur rcepteurs *)
    extCUS       = ".CUS"; (* transits : metteurs dans les maisons *)
    extCMP       = ".CMP";

CONST
    errNone              = 0;
    errHelp              = 1;
    errOption            = 2;
    errParmOverflow      = 3;
    errMissingTheme      = 4;
    errBadName           = 5;
    errExists            = 6;
    errReadOnly          = 7;
    errThemeNotFound     = 8;
    errIniNotFound       = 9;
    errThemeFormat       = 10;
    errIniRead           = 12;
    errRscNotFound       = 13;
    errRscRead           = 14;
    errThemeVersion	 = 15;
    errConflictInterpret = 16;
    errBadOrbePlus       = 17;
    errBadDomification   = 18;
    errConflictOrbes     = 19;

    errAborted       = 253;


VAR
    DEBUG         : BOOLEAN;
CONST
    nullchar    = CHR(0);
    semicolon   = ";";
    pound       = "#";
    openbracket = "[";
    closebracket= "]";
    quote       = "'";
    doublequote = '"';
    blank       = " ";
    tab         = CHR(9);
    coma        = ","; comma = coma;
    dash        = "-";
    slash       = "/";
    bar         = "|";
    underbar    = "_";
    dollar      = "$";
    antislash   = "\";
    backslash   = "\";
    dot         = ".";
    sAlpha      = 340C; (* CHR(0E0H); *)
    sDelta      = 353C; (* CHR(0EBH); *)
    sLambda     = "lambda"; (* no char ! *)
    sBeta       = 0341C; (* CHR(0E1H); *)
CONST
    codeParis      = "P";
    codeLocal      = "L";
    tabul = "        "; (* default 8 front spaces, later check for possible paragraph TAB *)
    pleasewait     = "Patience, cration du rapport... Temps coul : ";

(* ------------------------------------------------------------ *)

PROCEDURE eyeCandy(command:CARDINAL);
VAR
    i : CARDINAL;
BEGIN
    Elapsed(command);
END eyeCandy;

VAR
  PATIENCE : BOOLEAN;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    nl     = 015C+012C; (* CHR(13)+CHR(10); *)
    ex2 ="Exemple : "+ProgEXEname+" PIERREB af /a:-1"+nl;

VAR
    S : str256;
BEGIN
  IF PATIENCE THEN
      eyeCandy(cmdStop);
      video(pleasewait,FALSE);
      PATIENCE:=FALSE; (* who knows ? ;-) *)
  END;
    CASE e OF
    | errHelp :
        (*
               00000000011111111112222222222333333333344444444445555555555666666666677777777778
               1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
        *)
        WrLn;

        WrStr("Titre   : "+ProgBanner+nl);
        WrLn;
        WrStr("Syntaxe : "+ProgEXEname+" <thme["+extTHM+"]> [rapport["+extRPT+"]] [option]..."+nl);
        WrLn;
        WrStr("Utilit : cration du rapport correspondant  un thme"+nl);
        WrLn;
        WrStr("Options : /o pour remplacer l'ventuel rapport existant"+nl);
        WrStr("          /i pour ajouter les lments d'interprtation"+nl);
        WrStr("          /w pour forcer "+eUseTabs+"  Yes et "+eLineWidth+"  0"+nl);
        WrStr("          /l pour forcer "+eUseBetaForTexts+"  No (interprtation des aspects)"+nl);
        WrStr("          /b pour forcer "+eUseBetaForTexts+"  Yes (interprtation des aspects)"+nl);
        WrStr("          /pg pour forcer "+eUseAltOrbesNatal+"  No (orbes par groupe)"+nl);
        WrStr("          /po pour forcer "+eUseAltOrbesNatal+"  Yes (orbes par objet)"+nl);
        WrStr("          /e pour forcer un rapport exhaustif avec toutes les rubriques"+nl);
        WrStr("          /d:# pour forcer le type de domification"+nl);
        WrStr("               "+txtDomParms+nl);
        WrStr("          /a:# pour ajouter la valeur # aux orbes"+nl);
        WrStr("          /f:$ pour spcifier le fichier des interprtations ("+extRSC+", "+extNDX+")"+nl);

        WrLn;
        WrStr(ex2);
	WrLn;
    | errOption :
        Str.Concat(S,"L'option ",einfo);
        Str.Append(S," est illgale !");
    | errParmOverflow :
        Str.Concat(S,"Le paramtre ",einfo);
        Str.Append(S," est de trop !");
    | errMissingTheme :
        S := "Le fichier thme est indispensable !";
    | errBadName :
        Str.Concat(S,"Le nom de fichier (",einfo);
        Str.Append(S,") est incorrect !");
    | errExists :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") existe dj !");
    | errReadOnly :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") est protg contre l'criture !");
    | errThemeNotFound :
        Str.Concat(S,"Le thme (",einfo);
        Str.Append(S,") n'existe pas !");
    | errIniNotFound :
        Str.Concat(S,"Le fichier de configuration (",einfo);
        Str.Append(S,") n'existe pas !");
    | errThemeFormat :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") n'est pas un thme !");
    | errIniRead :
        Str.Concat(S,"Le fichier de configuration (",einfo);
        Str.Append(S,") ne tient pas en mmoire !");
    | errRscNotFound :
        Str.Concat(S,"Le fichier ressource (",einfo);
        Str.Append(S,") n'existe pas !");
    | errRscRead :
        Str.Concat(S,"Le fichier ressource (",einfo);
        Str.Append(S,") ne tient pas en mmoire !");
    | errThemeVersion :
        Str.Concat(S,"Le thme (",einfo);
        Str.Append(S,") exige une autre version du programme !");
    | errConflictInterpret :
        S := "Les options /l et /b sont mutuellement exclusives !";
    | errBadOrbePlus:
        S := "La valeur de la correction ajoute aux orbes est illgale !";
    | errBadDomification:
        S := "La valeur du type de domification est illgale !";
    | errConflictOrbes :
        S := "Les options /pg et /po sont mutuellement exclusives !";

    | errAborted :
        S := "Interruption du programme ! Sage dcision avec Windows ! ;-)";


    ELSE
        S := "This is illogical, Captain !"; (* S := "Can Such Things B(i)e(rce) ???"; *)
    END;
    CASE e OF
    | errNone, errHelp : ;
    ELSE
        WrLn;
        WrStr(ProgEXEname+" : ");
        WrStr(S);
        WrLn;
    END;


    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    orbePlus : INTEGER;

PROCEDURE initOrbePlus ();
BEGIN
    orbePlus := 0;
END initOrbePlus;

PROCEDURE chkOrbePlusRange (k:LONGINT) : BOOLEAN;
BEGIN
    RETURN ( ABS(k) <= maxorbeplus);
END chkOrbePlusRange;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBuffer        : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
    ioBufferTextes  : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    hndOut : FIO.File;
    hndTextes : FIO.File;

PROCEDURE nl ();
BEGIN
    (* WrLn; *)
    FIO.WrLn(hndOut);
END nl;

PROCEDURE wr (S:ARRAY OF CHAR);
BEGIN
    (* WrStr(S); *)
    FIO.WrStr(hndOut,S);
END wr;

PROCEDURE header (S:ARRAY OF CHAR);
BEGIN
    nl;
    wr(sepline);
    nl;
    wr(S);
    nl;
    wr(sepline);
    nl;
    nl;
END header;

PROCEDURE headertwo (S,S1:ARRAY OF CHAR);
BEGIN
    nl;
    wr(sepline);
    nl;
    wr(S);
    nl;
    wr(S1);
    nl;
    wr(sepline);
    nl;
    nl;
END headertwo;

(* ------------------------------------------------------------ *)

VAR
    themenatal : themeFile;
VAR
    rscfile    : str128;
    methodname : str128;
    exedir     : str128;
    textes     : str128;
    indextextes: str128;
VAR
    thePadChar                  : CHAR;
    thePadSign                  : CHAR;
    thePadComa                  : CHAR;
    flagUseTabs                 : BOOLEAN;
    flagDecimal                 : BOOLEAN;
    LineWidth                   : CARDINAL;
    flagKeepEmptyLine               : BOOLEAN;
    theFavoriteHouse            : CARDINAL;

    flagData                    : BOOLEAN;
    flagSynthesis               : BOOLEAN;
    flagInSign                  : BOOLEAN;
    flagInHouse                 : BOOLEAN;
    flagInTrueHouse             : BOOLEAN;
    flagMotion                  : BOOLEAN;
    flagPlacidus                : BOOLEAN;
    flagCampanus                : BOOLEAN;
    flagRegiomontanus           : BOOLEAN;
    flagPtolemeus               : BOOLEAN;
    flagKoch                    : BOOLEAN;
    flagNonsensical                 : BOOLEAN;

    flagByAspect                : BOOLEAN;
    flagByAspectWithFictitious  : BOOLEAN;
    flagByObject                : BOOLEAN;
    flagByObjectWithFictitious  : BOOLEAN;
    flagByAspectWithBeta        : BOOLEAN;
    flagByAspectWithBetaWithAngles : BOOLEAN;
    flagByObjectWithBeta        : BOOLEAN;
    flagByObjectWithBetaWithAngles : BOOLEAN;

    flagAngularities            : BOOLEAN;
    flagCoefficients            : BOOLEAN;
    flagCoefficientsWithFictitious: BOOLEAN;
    flagTradition               : BOOLEAN;
    flagGeocentric              : BOOLEAN;
    flagEquatorial              : BOOLEAN;
    flagLocal                   : BOOLEAN;
    flagHeliocentric            : BOOLEAN;
    flagAnalysisRET             : BOOLEAN;
    flagInterpret               : BOOLEAN;

    (* flags for interpretation of aspects *)
    flagUseBeta                 : BOOLEAN;
    (* when finding out $if harmonique/dissonant *)
    flagHDStateUsingEnabledState: BOOLEAN;
    flagHDStateAlwaysIgnoringASMC:BOOLEAN;
    flagAvoidAxisOrUseless     : BOOLEAN;

VAR
    k1_xii,k1_i,k2_x,k2_ix,k3_vii,k3_vi,k4_iii,k4_iv : LONGREAL;
VAR
    ObjectInfo          : objectinfoarray;
    AspectInfo          : aspectinfoarray;
    flagRET             : BOOLEAN;
    OrbeAngulaireAS     : CARDINAL;
    OrbeAngulaireMC     : CARDINAL;
    OrbeAngulaireDS     : CARDINAL;
    OrbeAngulaireFC     : CARDINAL;
    flagUseAltOrbesNatal: BOOLEAN;
    objectindex         : objectindexarray;
    aspectindex         : aspectindexarray;

(* bugfix ! how stupid I was... *)

PROCEDURE doFixSomeFlags (  );
BEGIN
    swapBool(flagByAspect                  ,flagByObject               );
    swapBool(flagByAspectWithFictitious    ,flagByObjectWithFictitious );
    swapBool(flagByAspectWithBeta          ,flagByObjectWithBeta       );
    swapBool(flagByAspectWithBetaWithAngles,flagByObjectWithBetaWithAngles);
END doFixSomeFlags;

(* from CIEL.INI *)

(* maybe we could check legal pad chars, favorite house and others... *)

PROCEDURE initReportFlags (  );
VAR
    S : str128;
    entry : str128;
BEGIN
    Str.Copy(S,sReport);
    getItemStrUp(S,eMethod,"?",entry);
    Str.Copy(methodname,entry);
    getItemChar(S,ePadChar           ,"0",thePadChar);
    getItemChar(S,ePadSign           ,"+",thePadSign);
    getItemChar(S,ePadComa           ,",",thePadComa);
    getItemBool(S,eUseTabs           ,"n",flagUseTabs);
    getItemBool(S,eDecimal           ,"n",flagDecimal);
    getItemCard(S,eLineWidth         ,"66",LineWidth);
    getItemBool(S,eKeepEmptyLine         ,"y",flagKeepEmptyLine);
    Str.Copy(S,sRessources);
    getItemStrUp(S,entry,"?",rscfile);
    PadsSetup(thePadChar,thePadSign,thePadComa);
    getItemStrUp(S,eTextes,"?",textes);
    getItemStrUp(S,ePointeurs,"?",indextextes);
END initReportFlags;

(* from RSC file *)

(* maybe we could check for legal values... *)

PROCEDURE initMethodFlags (  );
VAR
    i,k,value : CARDINAL;
    entry : str128;
    S,sorbes,svalue : str128; (* section *)
BEGIN
    FOR i := ORD(soleil) TO ORD(blacksun) DO
  eyeCandy(cmdSHOW);
        getObjectNameFR(objet(i),entry);
        getItemBool(sObjectEnabled,entry,"n",ObjectInfo[i].enabled);
        getItemCard(sObjectRank   ,entry,"0",ObjectInfo[i].rank);
        getItemCard(sObjectWeight ,entry,"0",ObjectInfo[i].weight);
        getItemCard(sObjectGroup  ,entry,"0",ObjectInfo[i].group);

        (* do not bother with a default string nor with counting items *)
        getItemStrUp(sAltOrbesNatal,entry,"", sorbes );
        FOR k:=firstAspect TO lastAspect DO
   eyeCandy(cmdSHOW);
            isoleItemS(svalue, sorbes, comma , k); (* function is 0-based *)
            IF stringToVal(svalue, value)=FALSE THEN value:=90; END;
            ObjectInfo[i].altorbenatal[k]:=value;
        END;

        ObjectInfo[i].sector := 0;
        ObjectInfo[i].angular:=FALSE;
        (* WARNING ! remember rank is 1.. while object is 0.. *)
        objectindex[ObjectInfo[i].rank -1 ]:=i;
    END;
    FOR i := ORD(conjonction) TO ORD(sesquicarre) DO
  eyeCandy(cmdSHOW);
        getAspectNameFR(aspecttype(i),entry);
        getItemBool(sAspectEnabled,entry,"n",AspectInfo[i].enabled);
        getItemCard(sAspectRank   ,entry,"0",AspectInfo[i].rank);
        getItemCard(sOrbe11       ,entry,"0",AspectInfo[i].orbe11);
        getItemCard(sOrbe22       ,entry,"0",AspectInfo[i].orbe22);
        getItemCard(sOrbe33       ,entry,"0",AspectInfo[i].orbe33);
        getItemCard(sOrbe12       ,entry,"0",AspectInfo[i].orbe12);
        getItemCard(sOrbe13       ,entry,"0",AspectInfo[i].orbe13);
        getItemCard(sOrbe23       ,entry,"0",AspectInfo[i].orbe23);
        getItemCard(sReport,entry,"0",AspectInfo[i].nature); (* 0=conj=neutral, 1=dissonant, 2=harmonique *)
        AspectInfo[i].ecart:=getEcart( aspecttype(i) );
        (* WARNING ! remember rank is 1.. while aspect is 0.. *)
        aspectindex[AspectInfo[i].rank -1 ]:=i;
    END;
  eyeCandy(cmdSHOW);
    Str.Copy(S,sInfo);
    getItemBool(S,eRET,"n",flagRET);
    getItemCard(S,eOrbeAngulaireAS,"10",OrbeAngulaireAS);
    getItemCard(S,eOrbeAngulaireMC,"10",OrbeAngulaireMC);
    getItemCard(S,eOrbeAngulaireDS,"10",OrbeAngulaireDS);
    getItemCard(S,eOrbeAngulaireFC,"10",OrbeAngulaireFC);

    getItemBool(S,eUseAltOrbesNatal,"n",flagUseAltOrbesNatal);

    Str.Copy(S,sReport);
    getItemCard(S,eFavoriteHouse     ,"1",theFavoriteHouse);
    getItemBool(S,eData              ,"y",flagData);
    getItemBool(S,eSynthesis         ,"y",flagSynthesis);
    getItemBool(S,eInSign            ,"y",flagInSign);
    getItemBool(S,eInHouse           ,"y",flagInHouse);
    getItemBool(S,eInTrueHouse       ,"y",flagInTrueHouse);
    getItemBool(S,eMotion            ,"y",flagMotion);
    getItemBool(S,ePlacidus          ,"y",flagPlacidus);
    getItemBool(S,eCampanus          ,"n",flagCampanus);
    getItemBool(S,eRegiomontanus     ,"n",flagRegiomontanus);
    getItemBool(S,ePtolemeus         ,"n",flagPtolemeus);
    getItemBool(S,eKoch              ,"n",flagKoch);
    getItemBool(S,eByAspect          ,"y",flagByAspect);
    getItemBool(S,eByAspectWithFictitious,"y",flagByAspectWithFictitious);
    getItemBool(S,eByObject          ,"y",flagByObject);
    getItemBool(S,eByObjectWithFictitious,"y",flagByObjectWithFictitious);
    getItemBool(S,eByAspectWithBeta  ,"y",flagByAspectWithBeta);
    getItemBool(S,eByAspectWithBetaWithAngles,"y",flagByAspectWithBetaWithAngles);
    getItemBool(S,eByObjectWithBeta  ,"y",flagByObjectWithBeta);
    getItemBool(S,eByObjectWithBetaWithAngles,"y",flagByObjectWithBetaWithAngles);
    getItemBool(S,eAngularities      ,"y",flagAngularities);
    getItemBool(S,eCoefficients      ,"y",flagCoefficients);
    getItemBool(S,eCoefficientsWithFictitious,"y",flagCoefficientsWithFictitious);
    getItemBool(S,eTradition         ,"y",flagTradition);
    getItemBool(S,eGeocentric        ,"y",flagGeocentric);
    getItemBool(S,eEquatorial        ,"n",flagEquatorial);
    getItemBool(S,eLocal             ,"n",flagLocal);
    getItemBool(S,eHeliocentric      ,"n",flagHeliocentric);
    getItemBool(S,eAnalysisRET       ,"n",flagAnalysisRET);
    getItemBool(S,eInterpret         ,"n",flagInterpret);
    getItemBool(S,eUseBetaForTexts           ,"n",flagUseBeta); (* for interpretation of aspects *)

    getItemBool(S,eHDStateUsingEnabledState ,"n",flagHDStateUsingEnabledState);
    getItemBool(S,eHDStateAlwaysIgnoringASMC,"y",flagHDStateAlwaysIgnoringASMC);
    getItemBool(S,eAvoidAxisOrUseless,"y",flagAvoidAxisOrUseless);

  eyeCandy(cmdSHOW);
    Str.Copy(S,sRETzoneLimits);
    getItemReal0_1(S,e1_xii             ,eTwoThird,k1_xii);
    getItemReal0_1(S,e1_i               ,eHalf    ,k1_i);
    getItemReal0_1(S,e2_x               ,eTwoThird,k2_x);
    getItemReal0_1(S,e2_ix              ,eTwoThird,k2_ix);
    getItemReal0_1(S,e3_vii             ,eTwoThird,k3_vii);
    getItemReal0_1(S,e3_vi              ,eHalf    ,k3_vi);
    getItemReal0_1(S,e4_iii             ,eHalf    ,k4_iii);
    getItemReal0_1(S,e4_iv              ,eHalf    ,k4_iv);
END initMethodFlags;

(* ------------------------------------------------------------ *)

PROCEDURE exhaustiveReport (  );
BEGIN
    flagData                    := TRUE;
    flagSynthesis               := TRUE;
    flagInSign                  := TRUE;
    flagInHouse                 := TRUE;
    flagInTrueHouse             := TRUE;
    flagMotion                  := TRUE;
    flagPlacidus                := TRUE;
    flagCampanus                := TRUE;
    flagRegiomontanus           := TRUE;
    flagPtolemeus               := TRUE;
    flagKoch                    := TRUE;
    flagNonsensical                 := FALSE;

    flagByAspect                := TRUE;
    flagByAspectWithFictitious  := TRUE;
    flagByObject                := TRUE;
    flagByObjectWithFictitious  := TRUE;
    flagByAspectWithBeta        := TRUE;
    flagByAspectWithBetaWithAngles := TRUE;
    flagByObjectWithBeta        := TRUE;
    flagByObjectWithBetaWithAngles := TRUE;
    flagAngularities            := TRUE;
    flagCoefficients            := TRUE;
    flagCoefficientsWithFictitious:= TRUE;
    flagTradition               := TRUE;
    flagGeocentric              := TRUE;
    flagEquatorial              := TRUE;
    flagLocal                   := TRUE;
    flagHeliocentric            := TRUE;
    flagAnalysisRET             := TRUE;
    (* flagAvoidAxisOrUseless      := FALSE; *)
END exhaustiveReport;

PROCEDURE enableFlagForThisHouse (i:CARDINAL);
BEGIN
    CASE i OF
    | ORD(placidus):     flagPlacidus      := TRUE;
    | ORD(campanus):     flagCampanus      := TRUE;
    | ORD(regiomontanus):flagRegiomontanus := TRUE;
    | ORD(ptolemeus):    flagPtolemeus     := TRUE;
    | ORD(koch):         flagKoch          := TRUE;
    | ORD(nonsensical):
                         flagNonsensical       := FALSE;
    ELSE ; (* //ISO fixed silly requirement *) END;
END enableFlagForThisHouse;

(* ------------------------------------------------------------ *)

(* before we found out that Milieu du Ciel could be an object in synthesis,
an not only a cusp, we had wiObjetLong = 15 for "++++Soleil Noir" > "Milieu du Ciel" *)
CONST
    spaces        = "                                        "; (* 40 should do *)
    interval      = "    "; (* 4 should do *)
    wiRoman       =  4;   (* "viii" *)
    wiMotionAbrev =  5;   (* "--D--" *)
    wiInfo        = 23;   (* "Correction pour le T.U." is longest of all strings *)
    wiObjet       = 14;   (* "milieu du ciel" *)
    wiCorps       =  7;   (* "jupiter" *)
    wiSigne       = 10;   (* "capricorne" *)
    wiAspect      = 12;   (* "sesqui-carr" *)
    wiObjetLong   = 18;   (* "++++Milieu du Ciel" is now longest in synthesis *)
    wiCoeff       = 13;   (* was 12 for "secteur viii" but now "Objectivation" *)
    wiMaitrise    = 17;   (* "maitrise sur viii" : this is for dmpCoefficients *)
    wiDignite     = 10;   (* "exaltation" *)
    wiSaison      =  9;   (* "printemps" *)

PROCEDURE pad (wi:CARDINAL;VAR S : ARRAY OF CHAR); (* never pass a string constant to this sub ! *)
VAR
    n : CARDINAL;
    R : str128;
BEGIN
    CASE flagUseTabs OF
    | TRUE :
        (* do nothing *)
    | FALSE :
        n := Str.Length(S);
        IF n = wi THEN
            (* nothing *)
        ELSIF n < wi THEN
            Str.Slice(R,spaces,0,wi-n);
            Str.Append(S,R);
        ELSE
            Str.Slice(R,S,0,wi-3);
            Str.Append(R,"...");
            Str.Copy(S,R);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
END pad;

PROCEDURE add (VAR S:ARRAY OF CHAR;R:ARRAY OF CHAR );
BEGIN
    CASE flagUseTabs OF
    | TRUE :   Str.Append(S,tab);
    | FALSE :  Str.Append(S,interval);
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Append(S,R);
END add;

PROCEDURE dmp1 (S : ARRAY OF CHAR);
BEGIN
    wr(S);
    nl;
END dmp1;

PROCEDURE dmp2 (wi:CARDINAL;Z,Z1 : ARRAY OF CHAR);
VAR
	S:str256;
	S1:str128;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);
    pad(wi,S);
    add(S,S1);
    wr(S);
    nl;
END dmp2;

PROCEDURE dmp3 (wi:CARDINAL;Z,Z1,Z2:ARRAY OF CHAR);
VAR
	S:str256;
	S1,S2:str128;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);Str.Copy(S2,Z2);
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    wr(S);
    nl;
END dmp3;

PROCEDURE dmp4 (wi:CARDINAL;Z,Z1,Z2,Z3:ARRAY OF CHAR);
VAR
	S:str256;
	S1,S2,S3:str128;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);Str.Copy(S2,Z2);Str.Copy(S3,Z3);
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    add(S,S3);
    wr(S);
    nl;
END dmp4;

PROCEDURE dmp5 (wi:CARDINAL;S,S1,S2,S3,S4:ARRAY OF CHAR);
BEGIN
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    add(S,S3);
    add(S,S4);
    wr(S);
    nl;
END dmp5;

PROCEDURE dmp6 (wi:CARDINAL;S,S1,S2,S3,S4,S5:ARRAY OF CHAR);
BEGIN
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    add(S,S3);
    add(S,S4);
    add(S,S5);
    wr(S);
    nl;
END dmp6;

(* ------------------------------------------------------------ *)

(* reverse priority order for our search *)

PROCEDURE infosep (S:ARRAY OF CHAR) : CHAR;
BEGIN
    IF    CharCount(S,antislash) = 4 THEN RETURN antislash;
    ELSIF CharCount(S,dollar) = 4 THEN RETURN dollar;
    ELSIF CharCount(S,slash)=4 THEN RETURN slash;
    ELSIF CharCount(S,underbar)=4 THEN RETURN underbar;
    ELSIF CharCount(S,semicolon)=4 THEN RETURN semicolon;
    ELSIF CharCount(S,coma) = 4 THEN RETURN coma;
    ELSE RETURN "?";
    END;
END infosep;

PROCEDURE infostr (n:CARDINAL;sep:CHAR;VAR R : ARRAY OF CHAR);
BEGIN
    isoleItemS(R,themenatal.orenseignements,sep,n);
    LtrimBlanks(R);
    RtrimBlanks(R);
    IF Str.Length(R)=0 THEN Str.Copy(R,"?"); END;
END infostr;

PROCEDURE genrestring (VAR S : ARRAY OF CHAR);
CONST
    sMasc = "Masculin";
    sFem  = "Fminin";
    sNA   = "Indtermin";
VAR
    R : str128;
    i : CARDINAL;
BEGIN
    Str.Copy(R,S);
    UpperCase(R);
    i:=getStrIndex(delim,R,
                   "H"+delim+"M"+delim+"+"+delim+"HOMME"+delim+"MAN"+delim+"MASCULIN"+delim+
                   "F"+delim+"W"+delim+"-"+delim+"FEMME"+delim+"WOMAN"+delim+"FEMININ"+delim+
                   "N"+delim+"?"+delim+"NEUTRE"+delim+"NEUTRAL");
    CASE i OF
    | 1..6 :   Str.Copy(S,sMasc);
    | 7..12 :  Str.Copy(S,sFem);
    | 13..16 : Str.Copy(S,sNA);
    ELSE
               (* ignore *)
    END;
END genrestring;

VAR
    sex:(man,woman,undefined);

PROCEDURE findsex ();
VAR
    ch:CHAR;
    information : (ville,pays,nom,genre,remarque);
    R : str128;
    i : CARDINAL;
BEGIN
    ch:=infosep(themenatal.orenseignements);
    infostr(ORD(genre),ch,R);
    UpperCase(R);
    i:=getStrIndex(delim,R,
                   "H"+delim+"M"+delim+"+"+delim+"HOMME"+delim+"MAN"+delim+"MASCULIN"+delim+
                   "F"+delim+"W"+delim+"-"+delim+"FEMME"+delim+"WOMAN"+delim+"FEMININ"+delim+
                   "N"+delim+"?"+delim+"NEUTRE"+delim+"NEUTRAL");
    CASE i OF
    | 1..6 :   sex:=man;
    | 7..12 :  sex:=woman;
    ELSE
               sex:=undefined;
    END;
END findsex;

VAR
    hugestring : str4096; (* should be enough : longest paragraph is about 4050 chars *)

PROCEDURE dmpPara (S : ARRAY OF CHAR);
VAR
    continue:BOOLEAN;
    R:str128;
BEGIN
    processGender(S,(sex=woman));
    CASE LineWidth OF
    | 0 :
        dmp1(S);
    ELSE
        continue:=dmpTTX(S,LineWidth,R,TRUE);
        WHILE continue DO
            dmp1(R);
            continue:=dmpTTX(S,LineWidth,R,FALSE);
        END;
    END;
END dmpPara;

(* ------------------------------------------------------------ *)

(* thoriquement une sortie genre dmpTTX avec marge de wiInfo ou tab au cas o la ligne serait longue *)

PROCEDURE dmprenseignements ();
CONST
    sVille     = "Ville";
    sPays      = "Pays";
    sNom       = "Nom";
    sGenre     = "Genre";
    sRemarque  = "Remarque";
VAR
    ch:CHAR;
    S : str256; (* required for remarque *)
    information : (ville,pays,nom,genre,remarque);

    ok:BOOLEAN;
    linewidth:CARDINAL;
    S1,S2:str256;
BEGIN
    ch:=infosep(themenatal.orenseignements);
    infostr(ORD(ville),ch,S);
    dmp2(wiInfo,sVille,S);
    infostr(ORD(pays),ch,S);
    dmp2(wiInfo,sPays,S);
    infostr(ORD(nom),ch,S);
    dmp2(wiInfo,sNom,S);
    infostr(ORD(genre),ch,S);
    genrestring(S);
    dmp2(wiInfo,sGenre,S);
    infostr(ORD(remarque),ch,S);

    IF ((flagUseTabs=TRUE) OR (LineWidth=0)) THEN
        dmp2(wiInfo,sRemarque,S); (* leave room for a very big string ! *)
    ELSE
        IF LineWidth < wiInfo THEN
            linewidth:=LineWidth; (* not the best choice but... *)
        ELSE
            linewidth:=LineWidth-wiInfo;
        END;
        S1:="";
        ok:=dmpTTX(S,linewidth,S2,TRUE);
        IF ok THEN
            dmp2(wiInfo,sRemarque,S2);
            LOOP
                ok:=dmpTTX(S,linewidth,S2,FALSE);
                IF ok=FALSE THEN EXIT; END;
                dmp2(wiInfo,S1,S2);
            END;
        END;
    END;
END dmprenseignements;

(* //XDS BUG : they don't support str() cast !!! *)

PROCEDURE dmpData (  );
CONST
    sOr          = " ou ";
    sBirthData   = "Coordonnes de naissance";
    sDate        = "Date";
    sHeure       = "Heure";
    sLatitude    = "Latitude";
    sLongitude   = "Longitude";
    sDeltaTU     = "Correction pour le T.U.";
    sTSL         = "Temps sidral local";
    sJourJulien  = "Jour julien";
    sMethode     = "Mthode";
    sFichier     = "Fichier";
    sTextes      = "Textes";

VAR
    ok,flag:BOOLEAN;
    d,m,y,hh,mm:CARDINAL;
    S:str128;
    S1,S2,S3:str128;
BEGIN
    header(sBirthData);

    flag:=(themenatal.typeof=unsafenatal);

    ok:=parseDate(flag,themenatal.odate,d,m,y); (* // no longer assume unsafe *)
    DateToStr(d,m,y,S);
    dmp2(wiInfo,sDate,S);

    ok:=parseTime(themenatal.otime,hh,mm);
    TimeToStr(hh,mm,S);
    dmp2(wiInfo,sHeure,S);

    fmtLatitude(themenatal.latitude,S1,S2);
    LtrimBlanks(S2);
    Str.Prepend(S2,"(");
    Str.Append(S2,")");
    dmp3(wiInfo,sLatitude,S1,S2);

    fmtLongitude(themenatal.longitude,S1,S2,S3);
    LtrimBlanks(S2);
    LtrimBlanks(S3);
    Str.Prepend(S2,"(");
    Str.Append(S2,sOr);
    Str.Append(S2,S3);
    Str.Append(S2,")");
    dmp3(wiInfo,sLongitude,S1,S2);

    fmtDeltaTU(themenatal.odeltaTU,S);
    dmp2(wiInfo,sDeltaTU,S);  (* //XDS does not like cast str128() *)
    nl;
    dmprenseignements;
    nl;
    AngleToStr(themenatal.tsl,HHMMSS,S);
    dmp2(wiInfo,sTSL,S);

    Str.FixRealToStr(themenatal.jd,5,S,ok);
    Str.Subst(S,dot,thePadComa);
    dmp2(wiInfo,sJourJulien,S);
    nl;
    Str.Copy(S,methodname);
    LowerCase(S);
    S[0]:=CAP(S[0]); (* ugly, ugly, ugly ! *)
    dmp2(wiInfo,sMethode,S);
    Str.Copy(S,rscfile);
    LowerCase(S);
    dmp2(wiInfo,sFichier,S);
    Str.Copy(S,textes);
    LowerCase(S);
    dmp2(wiInfo,sTextes,S);
END dmpData;

(* ------------------------------------------------------------ *)

PROCEDURE fmtPos (v:LONGREAL;VAR S1,S2:ARRAY OF CHAR);
VAR
    i : CARDINAL;
BEGIN
    CASE flagDecimal OF
    | TRUE :  AngleToPos(v,DDdd,S1,i);
    | FALSE : AngleToPos(v,DDMM,S1,i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    getSignName(signtype(i),S2);
END fmtPos;

PROCEDURE fmtPosDomitude (v:LONGREAL;VAR S1,S2:ARRAY OF CHAR);
VAR
    i : CARDINAL;
BEGIN
    CASE flagDecimal OF
    | TRUE :  AngleToPos(v,DDdd,S1,i);
    | FALSE : AngleToPos(v,DDMM,S1,i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    getRomanStr(i+1,S2); (* remember 0 means maison I, 11 means XII *)
END fmtPosDomitude;

(* ------------------------------------------------------------ *)

PROCEDURE matchObjectToHouse (id:domificationtype);
VAR
    cusp : ARRAY [firstCusp..lastCusp] OF LONGREAL;
    v : LONGREAL;
    i : CARDINAL;
    ndx : CARDINAL;
    inhouse,cuspSup,cuspInf,lastCuspHere:CARDINAL;
    BorneInf,BorneSup:LONGREAL;
BEGIN
    lastCuspHere := getLastCusp(id);
    FOR i := firstCusp TO lastCusp DO
        v:= themenatal.maisonData[ORD(id)][i];
        cusp[i]:=v;
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        ObjectInfo[ndx].sector:=0; (* useless but... *)
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF ( (isAngle( objet(ndx) )=FALSE) OR (angleIsCusp(id)=FALSE) ) THEN
                v:=themenatal.planete[ndx].lambda;
                inhouse:=1;
                cuspSup := firstCusp;
                LOOP
                    cuspInf:=cuspSup;
                    INC(cuspSup);
                    IF cuspSup > lastCuspHere THEN cuspSup := firstCusp; END;
                    IF clockwiseDom(id) THEN (* reverse positions to fake normal anticlockwise progression *)
                        BorneSup:=cusp[cuspInf];
                        BorneInf:=cusp[cuspSup];
                    ELSE
                        BorneInf:=cusp[cuspInf];
                        BorneSup:=cusp[cuspSup];
                    END;
                    IF between(BorneInf,v,BorneSup) THEN
                        ObjectInfo[ndx].sector:=inhouse;
                        EXIT;
                    END;
                    INC(inhouse);
                    IF inhouse > (lastCuspHere+1) THEN (* > 12 should never happen ! *)
                        inhouse:=0;
                        EXIT;
                    END;
                END;
            END;
        END;
    END;
END matchObjectToHouse;

(* ------------------------------------------------------------ *)

TYPE
    posentry = RECORD
                   lambda : LONGREAL;
                   index  : CARDINAL;
                   cusp   : BOOLEAN;
               END;
CONST
    first = 1; (* must be from 1 for QSort *)
    max  = first+ORD(blacksun)+ORD(m12)+2; (* safety *)
VAR
    pos : ARRAY [first..max] OF posentry; (* no risk ! objects+cuspides *)

PROCEDURE isLess (i,j:CARDINAL) : BOOLEAN;
BEGIN
    IF pos[i].lambda < pos[j].lambda THEN RETURN TRUE; END;
    RETURN FALSE;
END isLess;

PROCEDURE isLessNOT (i,j:CARDINAL) : BOOLEAN;
BEGIN
    RETURN NOT(isLess(i,j));
END isLessNOT;

PROCEDURE doSwap (i,j:CARDINAL);
VAR
    tmp : posentry;
BEGIN
    tmp := pos[i];
    pos[i]:=pos[j];
    pos[j]:=tmp;
END doSwap;

PROCEDURE dmpSynthesis (id:domificationtype);
CONST
    sTitle = "Tableau rcapitulatif (domification ";
VAR
    i : CARDINAL;
    ndx : CARDINAL;
    S,S1,S2,S3,S4,S5 : str128;
    actual : domificationtype;
    v : LONGREAL;
    last : CARDINAL;
    tmp:posentry;
BEGIN
    IF id = notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    getDomificationStr(id,S);
    Str.Append(S,")");
    Str.Prepend(S,sTitle);
    header(S);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;

    matchObjectToHouse(id);
    (* add objects to tmp array *)
    last := first;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF isAngle( objet(ndx) )=FALSE THEN (* here, we ignore AS MC DS FC *)
            pos[last].lambda:=themenatal.planete[ndx].lambda;
            pos[last].index :=ndx;   (* we keep direct index to objet here *)
            pos[last].cusp  :=FALSE;
            INC(last);
        END;
    END;
    (* now add cuspides *)
    FOR i := firstCusp TO getLastCusp(id) DO
        v:= themenatal.maisonData[ORD(id)][i];
        pos[last].lambda:=v;
        pos[last].index :=i;
        pos[last].cusp  :=TRUE;
        INC(last);
    END;
    (* now add AS MC DS FC if ptolemeus or nonsensical *)
    IF angleIsCusp(id)=FALSE THEN
        FOR i := firstObject TO lastObject DO
            ndx:=objectindex[i];
            IF isAngle( objet(ndx) ) THEN (* here, we keep only AS MC DS FC *)
                pos[last].lambda:=themenatal.planete[ndx].lambda;
                pos[last].index :=ndx;   (* we keep direct index to objet here *)
                pos[last].cusp  :=FALSE;
                INC(last);
            END;
        END;
    END;

    DEC(last); (* we were at last+1 ! *)
    IF clockwiseDom(id) THEN
        Lib.QSort(last,isLessNOT,doSwap);
    ELSE
        Lib.QSort(last,isLess,doSwap);
    END;
    (* now move positions so that AS is the first in listing *)
    LOOP
        IF (pos[first].cusp=TRUE) AND (pos[first].index=firstCusp) THEN EXIT; END;
        tmp:=pos[first];
        FOR i := first TO (last-1) DO
            pos[i]:=pos[i+1];
        END;
        pos[last]:=tmp;
    END;
    FOR i := first TO last DO
        ndx := pos[i].index;
        CASE pos[i].cusp OF
        | FALSE :
            IF ObjectInfo[ndx].enabled THEN
                getObjectName( objet(ndx) ,S);
                Str.Prepend(S,interval);
                fmtPos( pos[i].lambda,S1,S2);
                pad(wiSigne,S2);
                getRomanStr(ObjectInfo[ndx].sector,S3); (* direct index *)
                IF isPlanete ( objet(ndx) ) THEN
                    pad(wiRoman,S3);
                    IF themenatal.domificationFlag[ORD(placidus)] = placidus THEN
                        getRomanStr(themenatal.planete[ndx].truehouse,S4); (* direct index *)
                        LowerCase(S4);
                    ELSE
                        S4:="";
                    END;
                    pad(wiRoman,S4);
                    getMotionAbrev(themenatal.planete[ndx].motion,S5); (* direct index *)
                    dmp6(wiObjetLong,S,S1,S2,S3,S4,S5);
                ELSE
                    dmp4(wiObjetLong,S,S1,S2,S3); (* ignore motion and true house *)
                END;
            END;
        | TRUE :
            IF angleIsCusp(id) THEN
                getSectorName(cuspide(ndx),S);
            ELSE
                getSectorNameAlt(cuspide(ndx),S);
            END;
            fmtPos( pos[i].lambda,S1,S2);
            dmp3(wiObjetLong,S,S1,S2);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
END dmpSynthesis;

(* ------------------------------------------------------------ *)

PROCEDURE dmpInSign (  );
CONST
    sTitle="Position et signe de chaque objet";
VAR
    i,ndx : CARDINAL;
    v,v2:LONGREAL;
    S,S1,S2:str128;
BEGIN
    header(sTitle);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            getObjectName(objet(ndx),S);
            v:=themenatal.planete[ndx].lambda;
            fmtPos(v,S1,S2);
            dmp3(wiObjet,S,S1,S2);
        END;
    END;
END dmpInSign;

(* ------------------------------------------------------------ *)

PROCEDURE dmpInHouse (id:domificationtype);
CONST
    sTitle = "Secteur de chaque objet (domification ";
VAR
    actual:domificationtype;
    S,S1 : str128;
    i,ndx,num:CARDINAL;
BEGIN
    IF id =notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    getDomificationStr(id,S);
    Str.Append(S,")");
    Str.Prepend(S,sTitle);
    header(S);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    matchObjectToHouse(id);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isAngle( objet(ndx) )=FALSE THEN
                getObjectName(objet(ndx),S);
                num:=ObjectInfo[ndx].sector;
                getRomanStr(num,S1);
                dmp2(wiObjet,S,S1);
            END;
        END;
    END;
END dmpInHouse;

(* ------------------------------------------------------------ *)

PROCEDURE dmpInTrueHouse (  );
CONST
    sTitle = "Vraie maison et domitude de chaque corps";
VAR
    i,ndx : CARDINAL;
    truehouse : CARDINAL;
    S,S1,S2,S3:str128;
    pos : LONGREAL;
BEGIN
    header(sTitle);
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                truehouse:=themenatal.planete[ndx].truehouse;
                getRomanStr(truehouse,S1);
                LowerCase(S1);
                pad(wiRoman,S1);
                pos := themenatal.planete[ndx].domitude;
                fmtPosDomitude(pos,S2,S3);
                dmp4(wiCorps,S,S1,S2,S3);
            END;
        END;
    END;
END dmpInTrueHouse;

(* ------------------------------------------------------------ *)

PROCEDURE dmpMotion (  );
CONST
    sTitle ="Mouvement de chaque corps";
VAR
    i,ndx : CARDINAL;
    mv : sens;
    S,S1:str128;
BEGIN
    header(sTitle);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                mv:=themenatal.planete[ndx].motion;
                getMotionStr(mv,S1);
                dmp2(wiCorps,S,S1);
            END;
        END;
    END;
END dmpMotion;

(* ------------------------------------------------------------ *)

PROCEDURE headerDom (id:domificationtype);
CONST
    sTitle ="Position et signe de chaque cuspide (domification ";
VAR
    S : str128;
BEGIN
    getDomificationStr(id,S);
    Str.Append(S,")");
    Str.Prepend(S,sTitle);
    header(S);
END headerDom;

PROCEDURE dmpDom (id:domificationtype);
VAR
    i : CARDINAL;
    S,S1,S2 : str128;
    v : LONGREAL;
    actual : domificationtype;
BEGIN
    IF id = notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    headerDom(id);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    FOR i := firstCusp TO getLastCusp( id ) DO
        IF angleIsCusp(id) THEN
            getCuspideName(cuspide(i),S);
        ELSE
            getCuspideNameAlt(cuspide(i),S);
        END;
        v:= themenatal.maisonData[ORD(id)][i];
        fmtPos(v,S1,S2);
        dmp3(wiObjet,S,S1,S2);
    END;
END dmpDom;

(* ------------------------------------------------------------ *)

PROCEDURE smallerNonZero(ndx1,ndx2,ndxaspect:CARDINAL):BOOLEAN;
VAR
    minorbe : CARDINAL;
BEGIN
IF flagUseAltOrbesNatal THEN
    minorbe:=smaller( ObjectInfo[ndx1].altorbenatal[ndxaspect], ObjectInfo[ndx2].altorbenatal[ndxaspect] );
	RETURN (minorbe # 0); (* any orbe=0 means ignore aspect *)
ELSE
    RETURN TRUE; (* always, here *)
END;
END smallerNonZero;

PROCEDURE getOrbe (group1,group2,ndxaspect, ndx1,ndx2:CARDINAL  ):CARDINAL;
VAR
    groupclass : grouptype;
    orbe: CARDINAL;
    i:INTEGER;
BEGIN
IF flagUseAltOrbesNatal THEN
    orbe:=greater( ObjectInfo[ndx1].altorbenatal[ndxaspect], ObjectInfo[ndx2].altorbenatal[ndxaspect] );
ELSE
    groupclass:=getGroupClass(group1,group2);
    CASE groupclass OF
    | group11 : orbe:=AspectInfo[ndxaspect].orbe11;
    | group22 : orbe:=AspectInfo[ndxaspect].orbe22;
    | group33 : orbe:=AspectInfo[ndxaspect].orbe33;
    | group12 : orbe:=AspectInfo[ndxaspect].orbe12;
    | group13 : orbe:=AspectInfo[ndxaspect].orbe13;
    | group23 : orbe:=AspectInfo[ndxaspect].orbe23;
    ELSE ; (* //ISO fixed silly requirement *) END;
END;
    IF orbePlus # 0 THEN
        i:=INTEGER(orbe)+orbePlus;
        IF i < minorbeplus THEN i:= minorbeplus; END;
        orbe := CARDINAL(i);
    END;
    RETURN orbe;
END getOrbe;

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByAspect (useFictifs:BOOLEAN);
CONST
    sTitle ="Aspects de chaque corps avec les autres corps";
    sTitle2="Aspects de chaque objet avec les angles et plantes fictives";
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;
BEGIN
    CASE useFictifs OF
    | FALSE :
        header(sTitle);
        wide:=wiCorps;
    | TRUE  :
        header(sTitle2);
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR i := firstObject TO (lastObject-1) DO
        ndx1     := objectindex[i];
        enabled1 := ObjectInfo[ndx1].enabled;
        real1    := isPlanete ( objet(ndx1) );
        lambda1  := themenatal.planete[ndx1].lambda;
        group1   := ObjectInfo[ndx1].group;
        getObjectName( objet(ndx1) ,P1);

        FOR j := (i+1) TO lastObject DO
            ndx2     := objectindex[j];
            enabled2 := ObjectInfo[ndx2].enabled;
            real2    := isPlanete ( objet(ndx2) );
            lambda2  := themenatal.planete[ndx2].lambda;
            group2   := ObjectInfo[ndx2].group;
            getObjectName( objet(ndx2) ,P2);
            pad(wide,P2); (* real body or longer unreal body such as MC *)

            CASE useFictifs OF
            | FALSE : ok := ((real1) AND (real2))  ;
            | TRUE :
                (*  ok := (real2=FALSE); (* ((real1) AND (real2=FALSE)); *) PRECEDENCE BUG *)
                ok:=(real1 AND (real2=FALSE)) OR ((real1=FALSE) AND real2);
                IF flagAvoidAxisOrUseless THEN
                      ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;

            FOR k := firstAspect TO lastAspect DO
                ndxaspect:=aspectindex[k];
                enabledaspect:=AspectInfo[ndxaspect].enabled;
                ecartaspect:=AspectInfo[ndxaspect].ecart;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff) THEN
                            getAspectName( aspecttype(ndxaspect),S);
                            pad(wiAspect,S);
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=i;
                            ELSIF last # i THEN
                                nl;
                                last:=i;
                            END;
                            dmp4(wide,P1,P2,S,S1);
                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByAspect;

(* ------------------------------------------------------------ *)

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByObject (useFictifs:BOOLEAN);
CONST
    sTitle ="Aspects de chaque corps avec les autres corps";
    sTitle2="Aspects de chaque objet avec les angles et plantes fictives";
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;
BEGIN
    CASE useFictifs OF
    | FALSE :
        header(sTitle);
        wide:=wiCorps;
    | TRUE :
        header(sTitle2);
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR k := firstAspect TO lastAspect DO
        ndxaspect:=aspectindex[k];
        enabledaspect:=AspectInfo[ndxaspect].enabled;
        ecartaspect:=AspectInfo[ndxaspect].ecart;
        getAspectName( aspecttype(ndxaspect),S);

        FOR i := firstObject TO (lastObject-1) DO
            ndx1     := objectindex[i];
            enabled1 := ObjectInfo[ndx1].enabled;
            real1    := isPlanete ( objet(ndx1) );
            lambda1  := themenatal.planete[ndx1].lambda;
            group1   := ObjectInfo[ndx1].group;
            getObjectName( objet(ndx1) ,P1);
            pad(wide,P1);

            FOR j := (i+1) TO lastObject DO
                ndx2     := objectindex[j];
                enabled2 := ObjectInfo[ndx2].enabled;
                real2    := isPlanete ( objet(ndx2) );
                lambda2  := themenatal.planete[ndx2].lambda;
                group2   := ObjectInfo[ndx2].group;
                getObjectName( objet(ndx2) ,P2);
                pad(wide,P2); (* can be real body or long unreal thing such as MC *)

                CASE useFictifs OF
                | FALSE : ok:= ((real1) AND (real2));
                | TRUE :
                    (* ok:= (real2=FALSE); (* ((real1) AND (real2=FALSE)); *) PRECEDENCE BUG *)
                    ok:=(real1 AND (real2=FALSE)) OR ((real1=FALSE) AND real2);
                    IF flagAvoidAxisOrUseless THEN
                          ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff) THEN
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=k;
                            ELSIF last # k THEN
                                nl;
                                last:=k;
                            END;
                            dmp4(wiAspect,S,P1,P2,S1);
                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByObject;

(* ------------------------------------------------------------ *)

PROCEDURE fmtLongLat (long,lat:LONGREAL;
                      VAR longS,latS:ARRAY OF CHAR);
BEGIN
    CASE flagDecimal OF
    | TRUE :
        AngleToStr(long,DDDdd,longS);
        AngleToStr(lat ,latDDdd,latS);
    | FALSE :
        AngleToStr(long,DDDMM,longS);
        AngleToStr(lat ,latDDMM,latS);
    ELSE ; (* //ISO fixed silly requirement *) END;
END fmtLongLat;

(* ------------------------------------------------------------ *)

PROCEDURE dmpGeocentric ();
CONST
    sTitle ="Coordonnes gocentriques";
    sInfo  ="("+sLambda+" et "+sBeta+" -- longitude et latitude)";
VAR
    i,ndx : CARDINAL;
    v1,v2:LONGREAL;
    S,S1,S2:str128;
BEGIN
    headertwo(sTitle,sInfo);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                v1:=themenatal.planete[ndx].lambda;
                v2:=themenatal.planete[ndx].beta;
                fmtLongLat(v1,v2,S1,S2);
                dmp3(wiCorps,S,S1,S2);
            END;
        END;
    END;
END dmpGeocentric;

(* ------------------------------------------------------------ *)

PROCEDURE dmpEquatorial (  );
CONST
    sTitle ="Coordonnes quatoriales";
    sInfo  ="("+sAlpha+" et "+sDelta+" -- ascension droite et dclinaison)";
VAR
    i,ndx : CARDINAL;
    v1,v2:LONGREAL;
    S,S1,S2:str128;
BEGIN
    headertwo(sTitle,sInfo);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                v1:=themenatal.planete[ndx].alpha;
                v2:=themenatal.planete[ndx].delta;
                AngleToStr(v1,HHMMSS,S1); (* always hms and ' for equatorial coors *)
                AngleToStr(v2,latDDMM,S2);
                dmp3(wiCorps,S,S1,S2);
            END;
        END;
    END;
END dmpEquatorial;

(* ------------------------------------------------------------ *)

PROCEDURE dmpLocal (  );
CONST
    sTitle ="Coordonnes locales";
    sInfo  ="(A et h -- azimut et hauteur)";
VAR
    i,ndx : CARDINAL;
    v1,v2:LONGREAL;
    S,S1,S2:str128;
BEGIN
    headertwo(sTitle,sInfo);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                v1:=themenatal.planete[ndx].azimut;
                v2:=themenatal.planete[ndx].altitude;
                fmtLongLat(v1,v2,S1,S2);
                dmp3(wiCorps,S,S1,S2);
            END;
        END;
    END;
END dmpLocal;

(* ------------------------------------------------------------ *)

PROCEDURE dmpHeliocentric (  );
CONST
    sTitle ="Coordonnes hliocentriques";
    sInfo  ="(l, b et r -- longitude, latitude et rayon vecteur)";
VAR
    i,ndx : CARDINAL;
    v1,v2,v3:LONGREAL;
    S,S1,S2,S3:str128;
BEGIN
    headertwo(sTitle,sInfo);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                CASE objet(ndx) OF
                | soleil, lune :
                    (* ignore for these were not computed *)
                ELSE
                    getObjectName(objet(ndx),S);
                    v1:=themenatal.planete[ndx].l;
                    v2:=themenatal.planete[ndx].b;
                    v3:=themenatal.planete[ndx].r;
                    fmtLongLat(v1,v2,S1,S2);
                    AngleToStr(v3,DDddddd,S3);
                    dmp4(wiCorps,S,S1,S2,S3);
                END;
            END;
        END;
    END;
END dmpHeliocentric;

(* ------------------------------------------------------------ *)

(* defaultorbe=12; (* from TRANSIT.BAS, else could be 10 +1(sun) +2(moon) *) *)

PROCEDURE dmpAngularities (orbeAS,orbeMC,orbeDS,orbeFC:CARDINAL);
CONST
    sTitle ="Objets angulaires"; (* " et non-angulaires" *)
VAR
    S,S1,S2 : str128;
    defaultorbe,i,j,ndx,orbe: CARDINAL;
    posangle,pos,diff:LONGREAL;
    last:CARDINAL;
BEGIN
    header(sTitle);
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        ObjectInfo[ndx].angular := FALSE; (* already done earlier but... *)
    END;
    last:=MAX(CARDINAL);
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        IF isAngle( objet(ndx) ) THEN
            CASE objet(ndx) OF
            | as: defaultorbe:=orbeAS;
            | mc: defaultorbe:=orbeMC;
            | ds: defaultorbe:=orbeDS;
            | fc: defaultorbe:=orbeFC;
            ELSE ; (* //ISO fixed silly requirement *) END;
            getObjectName( objet(ndx) ,S1);
            pad(wiObjet,S1);
            posangle:=themenatal.planete[ ndx ].lambda;
            FOR i := firstObject TO lastObject DO
                ndx:=objectindex[i];
                IF ObjectInfo[ndx].enabled THEN
                    IF isAngle( objet(ndx) )=FALSE THEN
                        getObjectName( objet(ndx) ,S);
                        pos:=themenatal.planete[ndx].lambda;
                        CASE objet(ndx) OF
                        | soleil :
                            orbe:=defaultorbe; (* +1 *)
                        | lune :
                            orbe:=defaultorbe; (* +2 *)
                        ELSE
                            orbe:=defaultorbe;
                        END;
                        IF isAngulaire(pos, posangle, orbe, diff) THEN
                            IF last = MAX(CARDINAL) THEN
                                last:=j;
                            ELSIF last # j THEN
                                nl;
                                last:=j;
                            END;
                            AngleToStr(diff,DDd,S2);
                            Str.Prepend(S2,"[");
                            Str.Append(S2,"]");
                            dmp3(wiObjet,S,S1,S2);
                            ObjectInfo[ndx].angular:=TRUE;
                        END;
                    END;
                END;
            END;
        END;
    END;
(* ignore unqualified
    j:=lastObject+1; (* just in case *)
    (* dump remaining non angular if any *)
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isAngle( objet(ndx) )=FALSE THEN
                getObjectName( objet(ndx) ,S);
                IF ObjectInfo[ndx].angular=FALSE THEN
                     IF last = MAX(CARDINAL) THEN
                         last:=j;
                     ELSIF last # j THEN
                         nl;
                         last:=j;
                     END;
                     dmp1(S);
                END;
            END;
        END;
    END;
*)
END dmpAngularities;

(* ------------------------------------------------------------ *)

PROCEDURE valToStr (v:CARDINAL;VAR S : ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(LONGCARD(v),S,10,ok);
    IF v < 10 THEN Str.Prepend(S," "); END;
END valToStr;

(* see fmtPos : sign is real, not rounded for display *)

PROCEDURE getRealSign (v:LONGREAL):signtype;
VAR
    i : CARDINAL;
    S : str128;
BEGIN
    CASE flagDecimal OF
    | TRUE :  AngleToPos(v,DDdd,S,i);
    | FALSE : AngleToPos(v,DDMM,S,i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN signtype(i); (* result should be the same whatever AngleToPos DDdd or DDMM *)
END getRealSign;

TYPE
    info=(cardinal,fixe,mutable,
          feu,terre,air,eau,
          masculin,feminin,
          printemps,ete,automne,hiver,
          jour,nuit,
          orient,occident,
          quadrantNE,quadrantNW,quadrantSE,quadrantSW,
          pouvoir,avoir,etre,valoir,servir);
    infoPlus= (theSoleil,theLune,
               objectivation,alligation,individuation,participation,
               diurne,nocturne);
CONST
    infos="Cardinal,Fixe,Mutable,"+
          "Feu,Terre,Air,Eau,"+
          "Masculin,Fminin,"+
          "Printemps,Et,Automne,Hiver,"+
          "Jour,Nuit,"+
          "Orient,Occident,"+
          "Nord-Est,Nord-Ouest,Sud-Est,Sud-Ouest,"+
          "Pouvoir,Avoir,Etre,Valoir,Servir";
    infosPlus= "Soleil,Lune,"+
               "Objectivation,Alligation,Individuation,Participation,"+
               "Diurne,Nocturne";

PROCEDURE getInfoStr (i:info;VAR R:ARRAY OF CHAR);
BEGIN
    Str.ItemS(R,infos,delim,ORD(i));
END getInfoStr;

PROCEDURE getInfoPlusStr (i:infoPlus;VAR R:ARRAY OF CHAR);
BEGIN
    Str.ItemS(R,infosPlus,delim,ORD(i));
END getInfoPlusStr;

PROCEDURE dmpCoefficients (useFictifs:BOOLEAN;id:domificationtype);
CONST
    sTitle ="Pondration en domification ";
    sInfo1 ="(sans les angles ni les plantes fictives)";
    sInfo2 ="(avec les angles et les plantes fictives)";
    sSecteur="Secteur ";
CONST
    firstInfo=ORD(cardinal);
    lastInfo=ORD(servir);
    firstInfoPlus=ORD(theSoleil);
    lastInfoPlus=ORD(nocturne);
    (* wiInfo = 10; (* nord ouest *) *)
VAR
    i,ndx,K:CARDINAL;
    S,S1:str128;
    pos:LONGREAL;
    ok : BOOLEAN;
    actual:domificationtype;
    kSign    : ARRAY [firstSign..lastSign] OF CARDINAL;
    kHouse   : ARRAY [firstCusp..lastCusp] OF CARDINAL;
    kInfo    : ARRAY [firstInfo..lastInfo] OF CARDINAL;
    kInfoPlus: ARRAY [firstInfoPlus..lastInfoPlus] OF CARDINAL;
    currhouse:CARDINAL;
    currsign:signtype;
    S2,S3,S4:str128;
    wi : CARDINAL;
BEGIN
    (* IF flagRET THEN RETURN; END; (* avoid nonsense ! *) *)
    IF id= notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    getDomificationStr(id,S);
    Str.Prepend(S,sTitle);
    CASE useFictifs OF
    | FALSE : headertwo(S,sInfo1);
    | TRUE  : headertwo(S,sInfo2);
        IF actual # id THEN
            getDomificationStr(notapplicable,S);
            dmp1(S);
            RETURN;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    FOR i:=firstSign TO lastSign DO
        kSign[i]:=0;
    END;
    FOR i:=firstCusp TO lastCusp DO
        kHouse[i]:=0;
    END;
    FOR i:=firstInfo TO lastInfo DO
        kInfo[i]:=0;
    END;
    (* always zero *)
    FOR i:=firstInfoPlus TO lastInfoPlus DO
        kInfoPlus[i]:=0;
    END;
    matchObjectToHouse(id); (* calc house for each objectinfoarray *)
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            CASE useFictifs OF
            | FALSE : ok:=isPlanete( objet(ndx) );
            | TRUE :  ok:=TRUE; (* all enabled objects are taken into account here *)
            ELSE ; (* //ISO fixed silly requirement *) END;
            IF ok THEN
                pos:=themenatal.planete[ndx].lambda;
                currsign:=getRealSign(pos);
                K:=ObjectInfo[ndx].weight;
                currhouse:=ObjectInfo[ndx].sector;

                INC(kSign[ORD(currsign)],K);
                IF isAngle( objet(ndx) )=FALSE THEN
                    INC(kHouse[currhouse-1],K);
                    IF angleIsCusp(id) THEN (* avoid ptol here ! *)
                        CASE currhouse OF
                        | 1,2,3,4,5,6    : INC(kInfo[ ORD(nuit) ],K);
                        | 7,8,9,10,11,12 : INC(kInfo[ ORD(jour) ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE currhouse OF
                        | 10,11,12,1,2,3 : INC(kInfo[ ORD(orient)   ],K);
                        | 4,5,6,7,8,9    : INC(kInfo[ ORD(occident) ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE currhouse OF
                        | 1,2,3    : INC(kInfo[ ORD(quadrantSE) ],K);
                        | 4,5,6    : INC(kInfo[ ORD(quadrantSW) ],K);
                        | 7,8,9    : INC(kInfo[ ORD(quadrantNW) ],K);
                        | 10,11,12 : INC(kInfo[ ORD(quadrantNE) ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    END;
                    IF id=nonsensical THEN (* here, we only have planets *)
                        CASE currhouse OF
                        | 1,2,3,4 : INC(kInfoPlus[ ORD(diurne)    ],K);
                        | 5,6,7,8 : INC(kInfoPlus[ ORD(nocturne)  ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE currhouse OF
                        | 1,6 : INC(kInfoPlus[ ORD(objectivation )],K);
                        | 2,5 : INC(kInfoPlus[ ORD(alligation    )],K);
                        | 3,8 : INC(kInfoPlus[ ORD(individuation )],K);
                        | 4,7 : INC(kInfoPlus[ ORD(participation )],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE objet(ndx) OF
                        | soleil : kInfoPlus[ ORD(theSoleil) ] := currhouse;
                        | lune   : kInfoPlus[ ORD(theLune)   ] := currhouse;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    END;
                END;
                CASE currsign OF
                | belier,gemeaux,lion,balance,sagittaire,verseau:
                    INC(kInfo[ ORD(masculin) ],K);
                | taureau,cancer,vierge,scorpion,capricorne,poissons:
                    INC(kInfo[ ORD(feminin)  ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
                CASE currsign OF
                | belier,cancer,balance,capricorne:
                    INC(kInfo[ ORD(cardinal) ],K);
                | taureau,lion,scorpion,verseau:
                    INC(kInfo[ ORD(fixe)     ],K);
                | gemeaux,vierge,sagittaire,poissons:
                    INC(kInfo[ ORD(mutable)  ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
                CASE currsign OF
                | belier,lion,sagittaire:
                    INC(kInfo[ ORD(feu)   ],K);
                | taureau,vierge,capricorne:
                    INC(kInfo[ ORD(terre) ],K);
                | gemeaux,balance,verseau:
                    INC(kInfo[ ORD(air)   ],K);
                | cancer,scorpion,poissons:
                    INC(kInfo[ ORD(eau)   ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
                CASE currsign OF
                | belier,taureau,gemeaux:
                    INC(kInfo[ ORD(printemps) ],K);
                | cancer,lion,vierge:
                    INC(kInfo[ ORD(ete)       ],K);
                | balance,scorpion,sagittaire:
                    INC(kInfo[ ORD(automne)   ],K);
                | capricorne,verseau,poissons:
                    INC(kInfo[ ORD(hiver)     ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;

                CASE currsign OF
                | belier:     INC(kInfo[ ORD(pouvoir) ],K);
                | taureau:    INC(kInfo[ ORD(avoir)   ],K);
                | gemeaux:    INC(kInfo[ ORD(etre)    ],K);
                | cancer:     INC(kInfo[ ORD(servir)  ],K);
                | lion:       INC(kInfo[ ORD(pouvoir) ],K);
                              INC(kInfo[ ORD(valoir)  ],K);
                | vierge:     INC(kInfo[ ORD(servir)  ],K);
                | balance:    INC(kInfo[ ORD(etre)    ],K);
                | scorpion:   INC(kInfo[ ORD(pouvoir) ],K);
                              INC(kInfo[ ORD(avoir)   ],K);
                | sagittaire: INC(kInfo[ ORD(etre)    ],K);
                              INC(kInfo[ ORD(valoir)  ],K);
                | capricorne: INC(kInfo[ ORD(pouvoir) ],K);
                | verseau:    INC(kInfo[ ORD(etre)    ],K);
                              INC(kInfo[ ORD(valoir)  ],K);
                | poissons:   INC(kInfo[ ORD(servir)  ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
        END;
    END;
    FOR i:= firstSign TO lastSign DO
        getSignName(signtype(i),S);
        valToStr(kSign[i],S1);
        dmp2(wiCoeff,S,S1);
    END;
    nl;
    FOR i:= firstCusp TO getLastCusp(id) DO
        getRomanStr(i+1,S); (* remember housetype is 0..11 ! *)
        Str.Prepend(S,sSecteur);
        valToStr(kHouse[i],S1);
        IF (useFictifs OR (id # nonsensical) ) THEN
            dmp2(wiCoeff,S,S1);
        END;
    END;
    IF ( (useFictifs=FALSE) AND (id=nonsensical) ) THEN
        FOR i:=firstInfoPlus TO lastInfoPlus DO
            CASE infoPlus(i) OF
            | theSoleil,objectivation,diurne: nl;
            ELSE ; (* //ISO fixed silly requirement *) END;
            getInfoPlusStr(infoPlus(i),S);
            CASE infoPlus(i) OF
            | theSoleil,theLune:
                K := kInfoPlus[i] - 1; (* we kept 1..8, we need 0..7 *)
                getRomanStr(K+1,S1); (* remember housetype is 0..11 ! *)
                (*
                *)
                Str.Prepend(S,"; ");
                Str.Append(S," en ");Str.Append(S,S1);
                Str.Copy(S1,""); (* do not pass constants ! *)
                Str.Copy(S2,"  "); (* fake two digits ! *)
                dmp3(wiCoeff,S1,S2,S);
            ELSE
                valToStr(kInfoPlus[i],S1);
                dmp2(wiCoeff,S,S1);
            END;
        END;
    END;
    FOR i:= firstInfo TO lastInfo DO
        CASE info(i) OF
        | cardinal,feu,masculin,printemps,pouvoir : nl;
        | jour,orient,quadrantNE: IF angleIsCusp(id) THEN nl; END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        CASE info(i) OF
        | jour,nuit,
          orient,occident,
          quadrantNE,quadrantNW,quadrantSE,quadrantSW :
            ok:=angleIsCusp(id);
        ELSE
            ok:=TRUE;
        END;
        IF ok THEN
            getInfoStr(info(i),S);
            valToStr(kInfo[i],S1);
            dmp2(wiCoeff,S,S1);
        END;
    END;
END dmpCoefficients;

(* ------------------------------------------------------------ *)

PROCEDURE dmpTradition (id:domificationtype);
CONST
    sTitle ="Informations de la "+doublequote+"Tradition"+doublequote;
VAR
    i,ndx:CARDINAL;
    actual:domificationtype;
    S,S1,S2,S3:str128;
    pos:LONGREAL;
    currhouse:CARDINAL;
    currsign:signtype;
    v:LONGREAL;
    cusp : ARRAY [firstCusp..lastCusp] OF LONGREAL;
    currdignity:dignitytype;
    body:objet;
BEGIN
    IF id = notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    header(sTitle);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    matchObjectToHouse(id); (* calc house for each objectinfoarray *)
    FOR i := firstCusp TO lastCusp DO
        v:= themenatal.maisonData[ORD(id)][i];
        cusp[i]:=v;
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                pos:=themenatal.planete[ndx].lambda;
                currsign:=getRealSign(pos);
                currdignity:=getDignity( objet(ndx) ,currsign);
                IF currdignity # aucunedignite THEN
                   getDignityName(currdignity,S1);
                   dmp2(wiCorps,S,S1);
                ELSE
                   (* try for mercure/venus which have two domiciles/exils *)
                   currdignity:=getDignityAlt( objet(ndx) ,currsign);
                   IF currdignity # aucunedignite THEN
                       getDignityName(currdignity,S1);
                       dmp2(wiCorps,S,S1);
                   (* ignore unqualified
                   ELSE
                       dmp1(S);
                   *)
                   END;
                END;
            END;
        END;
    END;
    nl;
    FOR i := firstCusp TO getLastCusp(id) DO
        getRomanStr(i+1,S); (* remember housetype is 0..11 ! *)
        Str.Prepend(S,"Matrise sur ");
        pos:=cusp[i];
        currsign:=getRealSign(pos);
        body:=getMaitrise( currsign );
        getObjectName(body,S1);
        pad(wiCorps,S1);

        pos:=themenatal.planete[ORD(body)].lambda;
        currsign:=getRealSign(pos);
        getSignName(currsign,S2);
        pad(wiSigne,S2);

        currhouse:=ObjectInfo[ORD(body)].sector;
        getRomanStr(currhouse,S3);

        dmp4(wiMaitrise,S,S1,S2,S3);
    END;
END dmpTradition;

(* ------------------------------------------------------------ *)

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByAspectWithBeta (useAngles:BOOLEAN);
CONST
    sTitle1 = "Aspects de chaque corps avec les autres corps";
    sInfo   = "("+sBeta+" prise en compte)";
    sTitle2 = "Aspects de chaque corps et angle avec les angles";
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;
    beta1,beta2:LONGREAL;
    real1a,real2a:BOOLEAN;
BEGIN
    CASE useAngles OF
    | FALSE :
        headertwo(sTitle1,sInfo);
        wide:=wiCorps;
    | TRUE  :
        headertwo(sTitle2,sInfo);
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR i := firstObject TO (lastObject-1) DO
        ndx1     := objectindex[i];
        enabled1 := ObjectInfo[ndx1].enabled;
        real1    := isPlanete ( objet(ndx1) );
        real1a   := isAngle ( objet(ndx1) );
        lambda1  := themenatal.planete[ndx1].lambda;
        beta1    := themenatal.planete[ndx1].beta;
        group1   := ObjectInfo[ndx1].group;
        getObjectName( objet(ndx1) ,P1);

        FOR j := (i+1) TO lastObject DO
            ndx2     := objectindex[j];
            enabled2 := ObjectInfo[ndx2].enabled;
            real2    := isPlanete ( objet(ndx2) );
            real2a   := isAngle ( objet(ndx2) );
            lambda2  := themenatal.planete[ndx2].lambda;
            beta2    := themenatal.planete[ndx2].beta;
            group2   := ObjectInfo[ndx2].group;
            getObjectName( objet(ndx2) ,P2);
            pad(wide,P2); (* real body or longer unreal body such as MC *)

            CASE useAngles OF
            | FALSE : ok := ((real1) AND (real2))  ;
            | TRUE :
                (* ok := ( ((real1) OR (real1a)) AND (real2a) ); PRECEDENCE BUG *)
                ok:=((real1 OR real1a) AND real2a) OR (real1a AND (real2 OR real2a));
                IF flagAvoidAxisOrUseless THEN
                      ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;

            FOR k := firstAspect TO lastAspect DO
                ndxaspect:=aspectindex[k];
                enabledaspect:=AspectInfo[ndxaspect].enabled;
                ecartaspect:=AspectInfo[ndxaspect].ecart;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff) THEN
                            getAspectName( aspecttype(ndxaspect),S);
                            pad(wiAspect,S);
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=i;
                            ELSIF last # i THEN
                                nl;
                                last:=i;
                            END;
                            dmp4(wide,P1,P2,S,S1);
                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByAspectWithBeta;

(* ------------------------------------------------------------ *)

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByObjectWithBeta (useAngles:BOOLEAN);
CONST
    sTitle1 = "Aspects de chaque corps avec les autres corps";
    sInfo   = "("+sBeta+" prise en compte)";
    sTitle2 = "Aspects de chaque corps et angle avec les angles";
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;
    beta1,beta2:LONGREAL;
    real1a,real2a:BOOLEAN;
BEGIN
    CASE useAngles OF
    | FALSE :
        headertwo(sTitle1,sInfo);
        wide:=wiCorps;
    | TRUE :
        headertwo(sTitle2,sInfo);
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR k := firstAspect TO lastAspect DO
        ndxaspect:=aspectindex[k];
        enabledaspect:=AspectInfo[ndxaspect].enabled;
        ecartaspect:=AspectInfo[ndxaspect].ecart;
        getAspectName( aspecttype(ndxaspect),S);

        FOR i := firstObject TO (lastObject-1) DO
            ndx1     := objectindex[i];
            enabled1 := ObjectInfo[ndx1].enabled;
            real1    := isPlanete ( objet(ndx1) );
            real1a   := isAngle ( objet(ndx1) );
            lambda1  := themenatal.planete[ndx1].lambda;
            beta1    := themenatal.planete[ndx1].beta;
            group1   := ObjectInfo[ndx1].group;
            getObjectName( objet(ndx1) ,P1);
            pad(wide,P1);

            FOR j := (i+1) TO lastObject DO
                ndx2     := objectindex[j];
                enabled2 := ObjectInfo[ndx2].enabled;
                real2    := isPlanete ( objet(ndx2) );
                real2a   := isAngle ( objet(ndx2) );
                lambda2  := themenatal.planete[ndx2].lambda;
                beta2    := themenatal.planete[ndx2].beta;
                group2   := ObjectInfo[ndx2].group;
                getObjectName( objet(ndx2) ,P2);
                pad(wide,P2); (* can be real body or long unreal thing such as MC *)

                CASE useAngles OF
                | FALSE : ok:= ((real1) AND (real2));
                | TRUE :
                    (* ok:=( ((real1) OR (real1a)) AND (real2a) ); PRECEDENCE BUG *)
                    ok:=( (real1 OR real1a) AND real2a) OR (real1a AND (real2 OR real2a) );
                    IF flagAvoidAxisOrUseless THEN
                          ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff) THEN
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=k;
                            ELSIF last # k THEN
                                nl;
                                last:=k;
                            END;
                            dmp4(wiAspect,S,P1,P2,S1);
                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByObjectWithBeta;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dmpAnalysisRET (  ); (* conditionalist angularities and aspects *)
CONST
(*
    twothird = 2.0 / 3.0;
    half     = 0.5;
*)
    wiRank = 2;
    sZone = "Zone ";
    sTitle ="Corps angulaires et non-angulaires selon les rgles conditionalistes";
VAR
    S,S1,S2 : str128;
    i,j,ndx : CARDINAL;
    currangle:objet;
    pos:LONGREAL;
    ki,ks:LONGREAL;
    mi,mm,ms:cuspide;
    pi,pm,ps:LONGREAL;
    last:CARDINAL;
    rank:CARDINAL;
    angulaires : CARDINAL;
BEGIN
    (* IF flagRET=FALSE THEN RETURN; END; (* avoid nonsense ! *) *)
    header(sTitle);
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    (* matchObjectToHouse(placidus); (* calc house for each objectinfoarray *) *)
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        ObjectInfo[ndx].RETzone:=0; (* init to zone 0 *)
    END;
    angulaires:=0;
    rank:=1;
    last:=MAX(CARDINAL);
    FOR i := 1 TO 4 DO
        CASE i OF
        | 1 :
            currangle := as;
            ki:= k1_xii; (* twothird *)
            ks:= k1_i;   (* half *)
            mi:= m12;
            mm:= mAS;
            ms:= m2;
            S:="1";
        | 2 :
            currangle := mc;
            ki:= k2_ix;  (* twothird *)
            ks:= k2_x;   (* twothird *)
            mi:= m9;
            mm:= mMC;
            ms:= m11;
            S:="2";
        | 3 :
            currangle := ds;
            ki:= k3_vi;  (* half *)
            ks:= k3_vii; (* twothird *)
            mi:= m6;
            mm:= mDS;
            ms:= m8;
            S:="3";
        | 4 :
            currangle := fc;
            ki:= k4_iii; (* half *)
            ks:= k4_iv;  (* half *)
            mi:= m3;
            mm:= mFC;
            ms:= m5;
            S:="4";
        ELSE ; (* //ISO fixed silly requirement *) END;
        getObjectName(currangle,S2);
        Str.Prepend(S,sZone);
        Str.Append(S," (");
        Str.Prepend(S2,S);
        Str.Append(S2,")");
        pi:=themenatal.maisonData[ORD(placidus)][ ORD(mi) ];
        pm:=themenatal.maisonData[ORD(placidus)][ ORD(mm) ];
        ps:=themenatal.maisonData[ORD(placidus)][ ORD(ms) ];

        FOR j := firstObject TO lastObject DO
            ndx:=objectindex[j];
            IF isPlanete( objet(ndx) ) THEN
                getObjectName( objet(ndx) ,S1);
                pos:=themenatal.planete[ ndx ].lambda;
                IF inZone(pos,pi,pm,ps,ki,ks) THEN
                    IF last = MAX(CARDINAL) THEN
                        last:=i;
                    ELSIF last # i THEN
                        nl;
                        last:=i;
                    END;
                    pad(wiCorps,S1);
                    valToStr(rank,S);
                    INC(rank);
                    dmp3(wiRank,S,S1,S2);
                    ObjectInfo[ndx].RETrank:=rank;
                    ObjectInfo[ndx].RETzone:=i;
                    INC(angulaires);
                END;
            END;
        END;
    END;
    i:=4+1; (* just in case *)
    (* dump remaining non angular if any *)
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName( objet(ndx) ,S1);
                IF ObjectInfo[ndx].RETzone=0 THEN
                    IF last = MAX(CARDINAL) THEN
                        last:=i;
                    ELSIF last # i THEN
                        nl;
                        last:=i;
                    END;
                    valToStr(rank,S);
                    INC(rank);
                    pad(wiCorps,S1);
                    S2:=sZone+"0";
                    dmp3(wiRank,S,S1,S2);
                    ObjectInfo[ndx].RETrank:=rank;
                END;
            END;
        END;
    END;
    (*
    nl;
    dmp1("Des promesses, toujours des promesses... ;-)");

    (* now try better : pages 356 sq *)

(* isplanete   ObjectInfo([ndx].RETorder 1..10, RETzone 1..4 et 0 *)

    IF angulaires # 0 THEN

    ELSE

    END;
    *)
END dmpAnalysisRET;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    stateAspectsReceived :( gettingnone, gettingH, gettingD, gettingHD,
                            gettingC   , gettingHC,gettingDC,gettingHDC  );

(*

   - if useEnabled=true, we use enabled field
     else we use only all real solar system bodies
   - if ignoreASMC=true, we ignore AS and MC whether enabled or not
     else we care (if they are enabled)
   - DS, FC always always ignored anyway

   warning ! we do not care about state of ndx1 body RECEIVING aspects !
   only ndx2 data is taken into account

*)

PROCEDURE countReceived(useBeta,useEnabled,ignoreASMC:BOOLEAN;ndx1:CARDINAL;VAR nh,nd,nc:CARDINAL);
VAR
    lambda1,beta1:LONGREAL;
    group1:CARDINAL;
    lambda2,beta2:LONGREAL;
    group2:CARDINAL;
    j,ndx2:CARDINAL;
    k,ndxaspect,ecartaspect,nature : CARDINAL;
    enabledaspect : BOOLEAN;
    orbe : CARDINAL;
    okay : BOOLEAN;
    diff:LONGREAL;
    enabled2,ok:BOOLEAN;
BEGIN
    lambda1  := themenatal.planete[ndx1].lambda;
    group1   := ObjectInfo[ndx1].group;

    IF useBeta THEN beta1 := themenatal.planete[ndx1].beta; END;

    FOR j := firstObject TO lastObject DO
        ndx2     := objectindex[j];
        lambda2  := themenatal.planete[ndx2].lambda;
        group2   := ObjectInfo[ndx2].group;
        enabled2 := ObjectInfo[ndx2].enabled;
        IF useBeta THEN beta2 := themenatal.planete[ndx2].beta; END;

        CASE useEnabled OF
        | TRUE :
            CASE ignoreASMC OF
            | TRUE        : ok := (enabled2 AND (isAngle(objet(ndx2))=FALSE));
            | FALSE       : ok := enabled2;
            ELSE ; (* //ISO fixed silly requirement *) END;
        | FALSE :
            CASE ignoreASMC OF
            | TRUE        : ok := isPlanete (objet(ndx2));
            | FALSE       : ok := (isPlanete (objet(ndx2)) OR isAngle(objet(ndx2)));
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        (* in all cases, ignore DS FC ! *)
        IF isDSFC(objet(ndx2)) THEN ok:=FALSE; END;

        IF ( (ndx2 # ndx1) AND ok  ) THEN (* avoid planet with itself ! *)
            FOR k := firstAspect TO lastAspect DO
                ndxaspect:=aspectindex[k];
                enabledaspect:=AspectInfo[ndxaspect].enabled;
                ecartaspect:=AspectInfo[ndxaspect].ecart;
                nature:=AspectInfo[ndxaspect].nature;

                IF (enabledaspect AND smallerNonZero(ndx1,ndx2,ndxaspect)) THEN (* was enabledaspect alone *)

                    orbe:=getOrbe(group1,group2,ndxaspect,ndx1,ndx2);
                    IF useBeta THEN
                        okay:=inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff);
                    ELSE
                        okay:=inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff);
                    END;
                    IF okay THEN
                        CASE nature OF
                        | natHarmonic:  INC(nh);
                        | natDissonant: INC(nd);
                        | natNeutral:   INC(nc);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    END;
                END;
            END;
        END;
    END;
END countReceived;

PROCEDURE getStateAspectsReceived (ndx:CARDINAL;
                                   usebeta,useEnabled,ignoreASMC:BOOLEAN ); (* ndx is objet *)
VAR
    nh,nd,nc : CARDINAL; (* count of harmonic/dissonant/conjonctions *)
BEGIN
    (* these will be autoincremented *)

    nh := 0;
    nd := 0;
    nc := 0;

    countReceived(usebeta,useEnabled,ignoreASMC, ndx, nh,nd,nc);

    (* here, what is important is =0 or is # 0 *)

    IF nc=0 THEN                    (* aucune conjonction *)
        IF nh=0 THEN                 (* aucun harmonique *)
            IF nd=0 THEN              (* aucun dissonant *)
                stateAspectsReceived:=gettingnone;
            ELSE                      (* dissonant *)
                stateAspectsReceived:=gettingD;
            END;
        ELSE                         (* harmonique *)
            IF nd=0 THEN              (* aucun dissonant *)
                stateAspectsReceived:=gettingH;
            ELSE                      (* dissonant *)
                stateAspectsReceived:=gettingHD;
            END;
        END;
    ELSE                            (* conjonction *)
        IF nh=0 THEN                 (* aucun harmonique *)
            IF nd=0 THEN              (* aucun dissonant *)
                stateAspectsReceived:=gettingC;
            ELSE                      (* dissonant *)
                stateAspectsReceived:=gettingDC;
            END;
        ELSE                         (* harmonique *)
            IF nd=0 THEN               (* aucun dissonant *)
                stateAspectsReceived:=gettingHC;
            ELSE                       (* dissonant *)
                stateAspectsReceived:=gettingHDC;
            END;
        END;
    END;
(*
WrLn;WrStr("usefield,ignoreasmc,index,h,d,c:");
IO.WrBool(useEnabled,5);IO.WrBool(ignoreASMC,5);
IO.WrCard(ndx,4);IO.WrCard(nh,4);IO.WrCard(nd,4);IO.WrCard(nc,4);WrLn;
*)
END getStateAspectsReceived;

(* ------------------------------------------------------------ *)

CONST
    underscore = "_";
    hilite     = "======= ";
    blurb      = "INTRODUCTION : ";

PROCEDURE findCetObjet (S:ARRAY OF CHAR; VAR index:CARDINAL  ):BOOLEAN;
VAR
    S1:str128;
    i:CARDINAL;
BEGIN
    FOR i := firstObject TO lastObject DO
        index:=i;
        getObjectName(objet(i),S1);
        UpperCase(S1);
        IF same(S,S1) THEN RETURN TRUE; END;
    END;
    RETURN FALSE;
END findCetObjet;

PROCEDURE cleanIt (VAR R : ARRAY OF CHAR );
BEGIN
    LtrimBlanks(R);
    RtrimBlanks(R);
    UpperCase(R);
END cleanIt;

(*

*)

(* in these subs, VAR S for speed, but do NOT modify S ! *)

PROCEDURE getPresentIndex (VAR S:ARRAY OF CHAR;possible:ARRAY OF CHAR) : CARDINAL;
VAR
    i : CARDINAL;
    str:str128;
BEGIN
    Str.Append(possible,delim);
    i := 0;
    LOOP
        Str.ItemS(str,possible,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.Pos(S,str) # MAX(CARDINAL) THEN RETURN (i+1); END;
        INC(i);
    END;
END getPresentIndex;

PROCEDURE present (VAR S:ARRAY OF CHAR;lower,upper:ARRAY OF CHAR):CARDINAL;
VAR
    p:CARDINAL;
    T:str128;
BEGIN
    p:=Str.Pos(S,lower);
    IF p # MAX(CARDINAL) THEN RETURN p; END;
    (* RETURN Str.Pos(S,upper); *)
    p:=Str.Pos(S,upper);
    IF p # MAX(CARDINAL) THEN RETURN p; END;
    Str.Copy(T,S);
    UpperCase(T);
    RETURN Str.Pos(T,upper);
END present;

PROCEDURE presence (VAR S : ARRAY OF CHAR;searched:ARRAY OF CHAR  ) : BOOLEAN;
BEGIN
    IF Str.Pos(S,searched) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END presence;

(* taken from COMPARER.MOD *)
(* find THE aspect between two longitudes, for "there can be only one" ! *)
(* return boolean, ndxaspect (max(cardinal) if none) and nature *)

PROCEDURE findAspect(lambda1,lambda2:LONGREAL;group1,group2, ndx1,ndx2:CARDINAL;
                     VAR ndxaspect,nature: CARDINAL;VAR diff:LONGREAL):BOOLEAN;
VAR
    k:CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect:CARDINAL;
    orbe : CARDINAL;
BEGIN
    k:=firstAspect;
    LOOP
        IF k > lastAspect THEN EXIT; END;
        ndxaspect     :=aspectindex[k];
        enabledaspect :=AspectInfo[ndxaspect].enabled;
        ecartaspect   :=AspectInfo[ndxaspect].ecart;
        nature        :=AspectInfo[ndxaspect].nature;
        IF (enabledaspect AND smallerNonZero(ndx1,ndx2,ndxaspect)) THEN (* was enabledaspect alone *)
            orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
            IF inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff) THEN
                RETURN TRUE;
            END;
        END;
        INC(k);
    END;
    ndxaspect:=MAX(CARDINAL);
    nature:=MAX(CARDINAL);
    diff:=180.0;
    RETURN FALSE;
END findAspect;

PROCEDURE findAspectBeta(lambda1,beta1,lambda2,beta2:LONGREAL;group1,group2, ndx1,ndx2:CARDINAL;
                         VAR ndxaspect,nature: CARDINAL;VAR diff:LONGREAL):BOOLEAN;
VAR
    k:CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect:CARDINAL;
    orbe : CARDINAL;
BEGIN
    k:=firstAspect;
    LOOP
        IF k > lastAspect THEN EXIT; END;
        ndxaspect     :=aspectindex[k];
        enabledaspect :=AspectInfo[ndxaspect].enabled;
        ecartaspect   :=AspectInfo[ndxaspect].ecart;
        nature        :=AspectInfo[ndxaspect].nature;
        IF (enabledaspect AND smallerNonZero(ndx1,ndx2,ndxaspect)) THEN (* was enabledaspect alone *)
            orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
            IF inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff) THEN
                RETURN TRUE;
            END;
        END;
        INC(k);
    END;
    ndxaspect:=MAX(CARDINAL);
    nature:=MAX(CARDINAL);
    diff:=180.0;
    RETURN FALSE;
END findAspectBeta;

(* ------------------------------------------------------------ *)

(* S2 is report section header, S is :::looked for *)

PROCEDURE dmpIt (objet1,objet2:CARDINAL;
                 offset:LONGCARD; S2,S : ARRAY OF CHAR);
CONST
    dummyecart = 360; (* cannot happen ! not used here anyway *)
VAR
    result:BOOLEAN;
    state:(normal,include,skip);
BEGIN
    IF Str.Length(S2) # 0 THEN
        Str.Prepend(S2,hilite);
        dmp1(S2);
        nl;
    END;
    IF findFileEntry(hndTextes,offset,S) THEN
        state:=normal;
        LOOP
  eyeCandy(cmdSHOW);
            IF readFileEntry(hndTextes,hugestring)=FALSE THEN EXIT; END;
            IF Str.Length(hugestring) # 0 THEN
                CASE state OF
                | normal :
                    IF evalIfCondition(dummyecart,objet1,objet2,hugestring,result) THEN
                        CASE result OF
                        | TRUE :
                            state:=include;
                        | FALSE:
                            state:=skip;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    ELSE
                        dmpPara(hugestring);
                    END;
                | include :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=skip;
                    ELSE
                        dmpPara(hugestring);
                    END;
                | skip :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=include;
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            ELSE
                IF flagKeepEmptyLine THEN nl; END;
            END;
        END;
    END;
    nl;
END dmpIt;

(* ------------------------------------------------------------ *)

(*
   here we don't care about enabled, and we use all real planets only
   remember that A could be in conjonction with B but not B with A !
   that's why we need ndxToSkip, as not to taken current conjonction into account
*)

PROCEDURE countReceivedRET (useBeta:BOOLEAN;ndx1,ndxToSkip:CARDINAL;VAR nh,nd,nc:CARDINAL);
VAR
    lambda1,beta1:LONGREAL;
    group1:CARDINAL;
    lambda2,beta2:LONGREAL;
    group2:CARDINAL;
    j,ndx2:CARDINAL;
    k,ndxaspect,ecartaspect,nature : CARDINAL;
    enabledaspect : BOOLEAN;
    orbe : CARDINAL;
    okay : BOOLEAN;
    diff:LONGREAL;
BEGIN
    lambda1  := themenatal.planete[ndx1].lambda;
    group1   := ObjectInfo[ndx1].group;
    IF useBeta THEN beta1 := themenatal.planete[ndx1].beta; END;

    FOR j := firstObject TO lastObject DO
        ndx2     := objectindex[j];
        lambda2  := themenatal.planete[ndx2].lambda;
        group2   := ObjectInfo[ndx2].group;
        IF useBeta THEN beta2 := themenatal.planete[ndx2].beta; END;

        IF ( (ndx2 # ndx1) AND (isPlanete ( objet(ndx2) )) ) THEN (* avoid planet with itself ! *)
            FOR k := firstAspect TO lastAspect DO
                ndxaspect:=aspectindex[k];
                enabledaspect:=AspectInfo[ndxaspect].enabled;
                ecartaspect:=AspectInfo[ndxaspect].ecart;
                nature:=AspectInfo[ndxaspect].nature;

                IF (enabledaspect AND smallerNonZero(ndx1,ndx2,ndxaspect)) THEN (* was enabledaspect alone *)
                    orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                    IF useBeta THEN
                        okay:=inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff);
                    ELSE
                        okay:=inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff);
                    END;
                    IF okay THEN
                        CASE nature OF
                        | natHarmonic:  INC(nh);
                        | natDissonant: INC(nd);
                        | natNeutral:   IF ndx2 # ndxToSkip THEN INC(nc); END; (* avoid counting conjonction we already know of ! *)
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    END;
                END;
            END;
        END;
    END;
END countReceivedRET;

PROCEDURE countReceivedByConjRET (useBeta:BOOLEAN; ndx1,ndx2:CARDINAL;
                                  VAR nh,nd,nc:CARDINAL);
BEGIN
    nh:=0;
    nd:=0;
    nc:=0;
    countReceivedRET(useBeta,ndx1,ndx2,nh,nd,nc); (* auto incr *)
    countReceivedRET(useBeta,ndx2,ndx1,nh,nd,nc); (* auto incr *)
END countReceivedByConjRET;

(* ------------------------------------------------------------ *)

PROCEDURE dmpItAspect (ASPECT,P1,P2:ARRAY OF CHAR;
                       objet1,objet2,nature,ecartaspect:CARDINAL;
                       showTitle : BOOLEAN;VAR dumped:CARDINAL );
VAR
    TITRE,ABREV,FICHIER:str128;
    offset:LONGCARD;
    result:BOOLEAN;
    state:(normal,include,skip);
BEGIN
    dumped:=0;
    Str.Concat(TITRE,P1," et ");
    Str.Append(TITRE,P2);
    Str.Append(TITRE," en ");
    Str.Append(TITRE,ASPECT);
    CASE nature OF
    | natNeutral  : ABREV:=stConjonction;
    | natDissonant: ABREV:=stDissonant;
    | natHarmonic : ABREV:=stHarmonique;
    ELSE ; (* //ISO fixed silly requirement *) END;
    (* in CIEL.W51, definitions are always in the order of objects, so... *)
    IF objet1 < objet2 THEN
        Str.Copy(FICHIER,P1);
    ELSE
        Str.Copy(FICHIER,P2);
    END;

    cleanIt(FICHIER);
    ReplaceChar(FICHIER,blank,underscore);
    IF Str.Length(FICHIER) > 8 THEN FICHIER[7+1]:=CHR(0); END;

    IF findIndexFileOffset(FICHIER,extASP,offset)=FALSE THEN
        Str.Concat(TITRE,FICHIER,extASP);
        Str.Append(TITRE," introuvable !");
        Str.Prepend(TITRE,hilite);
        dmp1(TITRE);
        RETURN;
    END;

    (* okay, we may try : if showtitle is false, skip *)
    IF showTitle THEN
        IF Str.Length(TITRE) # 0 THEN
            Str.Prepend(TITRE,hilite);
            dmp1(TITRE);
            nl;
        END;
    END;

    IF findFileEntryAspect(hndTextes,offset,ABREV,P1,P2) THEN
        state:=normal;
        LOOP
  eyeCandy(cmdSHOW);
            IF readFileEntry(hndTextes,hugestring)=FALSE THEN EXIT; END;
            IF Str.Length(hugestring) # 0 THEN
                CASE state OF
                | normal :
                    IF evalIfCondition(ecartaspect,objet1,objet2,hugestring,result) THEN
                        CASE result OF
                        | TRUE :
                            state:=include;
                        | FALSE:
                            state:=skip;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    ELSE
                        dmpPara(hugestring);
                        INC(dumped);
                    END;
                | include :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=skip;
                    ELSE
                        dmpPara(hugestring);
                        INC(dumped);
                    END;
                | skip :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=include;
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            ELSE
                IF flagKeepEmptyLine THEN nl; END;
            END;
        END;
    END;
    nl;
END dmpItAspect;

(* handle conjunction according to the aspects it receives *)
(* already filtered for planets only, and beta taken into account *)
(* was handleConjRET, but now we used dumped : if # 0, just show conjonction state *)

PROCEDURE handleConj (useBeta:BOOLEAN;ndx1,ndx2,i,j:CARDINAL;
                      S,P1,P2:ARRAY OF CHAR;dumped:CARDINAL);
CONST
    msgH =tabul+"Interprtation de la conjonction harmonique :";
    msgD =tabul+"Interprtation de la conjonction dissonante :";
    dummyecart = 360; (* cannot happen ! not used here anyway *)
VAR
    nh,nd,nc:CARDINAL; (* count of harmonic/dissonant/neutral *)
    message:str128;
    dumpHarmonic,dumpDissonant:BOOLEAN;
    dummy:CARDINAL;
BEGIN
    countReceivedByConjRET(useBeta,ndx1,ndx2,nh,nd,nc);

    dumpHarmonic:=TRUE;
    dumpDissonant:=TRUE;

    IF nh = 0 THEN              (* absence d'aspects harmoniques *)
        IF nd = 0 THEN          (*     absence d'aspects dissonants *)
            IF nc=0 THEN
                message:="La conjonction est neutre ( la fois positive et ngative)";
            ELSE
                message:="La conjonction est neutre ( la fois positive et ngative), et elle appartient  un groupe";
            END;
        ELSE                    (*     prsence d'aspects dissonants *)
            dumpHarmonic := FALSE;
            IF nc=0 THEN
                message:="La conjonction ne reoit que des aspects dissonants";
            ELSE
                message:="La conjonction ne reoit que des aspects dissonants, et elle appartient  un groupe";
            END;
        END;
    ELSE                        (* prsence d'aspects harmoniques *)
        IF nd = 0 THEN          (*     absence d'aspects dissonants *)
            dumpDissonant:=FALSE;
            IF nc=0 THEN
                message:="La conjonction ne reoit que des aspects harmoniques";
            ELSE
                message:="La conjonction ne reoit que des aspects harmoniques, et elle appartient  un groupe";
            END;
        ELSE                    (*     prsence d'aspects dissonants *)
            IF nc=0 THEN
                message:="La conjonction reoit des aspects harmoniques et des aspects dissonants";
            ELSE
                message:="La conjonction reoit des aspects harmoniques et des aspects dissonants, et elle appartient  un groupe";
            END;
        END;
    END;
    Str.Prepend(message,tabul);
    Str.Append(message,"."); (* was " :" *)

    dmpPara(message); (* dmp1 with constant NOT ok ! *)
    nl;

    IF dumped # 0 THEN RETURN; END; (* stop here if there was an interpretation for conjonction *)

    IF dumpHarmonic THEN
        dmpPara(msgH);
        nl;
        dmpItAspect(S,P1,P2,ndx1,ndx2,natHarmonic  ,dummyecart,FALSE,dummy);
    END;
    IF dumpDissonant THEN
        dmpPara(msgD);
        nl;
        dmpItAspect(S,P1,P2,ndx1,ndx2,natDissonant ,dummyecart,FALSE,dummy);
    END;
END handleConj;

PROCEDURE intWarning (  );
VAR
    offset:LONGCARD;
    S:str128;
BEGIN
    IF findIndexFileOffset(sfWarning,extTXT,offset)=FALSE THEN
        Str.Concat(S,sfWarning,extTXT);
        Str.Append(S," introuvable !");
        Str.Prepend(S,hilite);
        dmp1(S);
    ELSE
        Str.Copy(S,"POST SCRIPTUM");
        dmpIt(0,0,offset,S, stIntro);
    END;
END intWarning;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE buildRscPath (VAR file:ARRAY OF CHAR);
VAR
    fullpath,u,d,n,e : str128;
BEGIN
    IF CharCount(file,backslash)=0 THEN
        Lib.ParamStr(fullpath,0);
        UpperCase(fullpath); (* useless but... *)
        Lib.SplitAllPath(fullpath,u,d,n,e); (* dot is included in extension *)
        Str.Concat(fullpath,u,d);
        Str.Append(fullpath,file);
        Str.Copy(file,fullpath);
    END;
END buildRscPath;

PROCEDURE buildIniPath (VAR fullpath:ARRAY OF CHAR);
VAR
    u,d,n,e : str128;
BEGIN
    Lib.ParamStr(fullpath,0);
    UpperCase(fullpath); (* useless but... *)
    Lib.SplitAllPath(fullpath,u,d,n,e); (* dot is included in extension *)
    Lib.MakeAllPath(fullpath,u,d,astroToolsName,extRSC);
    Str.Concat(exedir,u,d);
END buildIniPath;

PROCEDURE removeExt(VAR fullpath:ARRAY OF CHAR);
VAR
    u,d,n,e : str128;
BEGIN
    UpperCase(fullpath); (* useless but... *)
    Lib.SplitAllPath(fullpath,u,d,n,e); (* dot is included in extension *)
    Lib.MakeAllPath(fullpath,u,d,n,"");
END removeExt;

PROCEDURE chkFile (ext:ARRAY OF CHAR;VAR S:ARRAY OF CHAR  ) : BOOLEAN;
VAR
    u,d,n,e:str128;
BEGIN
    CASE CharCount(S,".") OF
    | 0 :
        Str.Append(S,ext);
    | 1 :
        (* nada *)
    ELSE
        RETURN FALSE;
    END;
    IF chkJoker(S) THEN RETURN FALSE; END;
    Lib.SplitAllPath(S,u,d,n,e);
    (* either we say ERROR or we silently truncate *)

    IF Str.Length(n) > 8 THEN RETURN FALSE; END;
    IF Str.Length(e) > (1+3) THEN RETURN FALSE; END;
(*
    IF Str.Length(n) > 8 THEN
        n[8]:=CHR(0);
    END;
    IF Str.Length(e) > (1+3) THEN
        e[1+3]:=CHR(0);
    END;
    Lib.MakeAllPath(S,u,d,n,e);
*)
    RETURN TRUE;
END chkFile;

(* ------------------------------------------------------------ *)

VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    opt       : CARDINAL;
    S         : pathtype;
    R         : pathtype;
    state     : (waiting,
                 gotTheme,gotReport);
    overwrite : BOOLEAN;
    datafile  : pathtype;
    reportfile: pathtype;
    inifile   : pathtype;
    extTEXTES,extINDEX:str128;
    forceinterpret:BOOLEAN;
    forceWP   : BOOLEAN;
    forcebeta : BOOLEAN;
    forcelambda:BOOLEAN;
    forcebygroup:BOOLEAN;
    forcebyobject:BOOLEAN;
    forcefile : BOOLEAN;
    forceexhaustive  : BOOLEAN;
    forcedomification:BOOLEAN;
    forcedHouseType : LONGCARD;
    myinterfile: str128;
    k         : LONGINT;

    firsttime : BOOLEAN;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    DEBUG := FALSE;
  PATIENCE:=FALSE;
    overwrite  := FALSE;
    forceinterpret:=FALSE;
    forceWP:=FALSE;
    forcelambda:=FALSE;
    forcebeta := FALSE;
    forcebygroup:=FALSE;
    forcebyobject :=FALSE;
    forcefile := FALSE;
    forceexhaustive  := FALSE;
    forcedomification:=FALSE;
    initOrbePlus();


    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,""); END;

    state:=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "DEBUG"+delim+
                                 "O"+delim+"OVERWRITE"+delim+
                                 "I"+delim+"INTERPRET"+delim+
                                 "W"+delim+"WP"+delim+
                                 "L"+delim+"LAMBDA"+delim+
                                 "B"+delim+"BETA"+delim+
                                 "A:"+delim+"ADD:"+delim+
                                 "F:"+delim+"FILE:"+delim+
                                 "E"+delim+"EXHAUSTIVE"+delim+
                                 "D:"+delim+"HOUSE:"+delim+
                                 "PG"+delim+"BYGROUP"+delim+
                                 "PO"+delim+"BYOBJECT"
                                 );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4 :
                DEBUG := TRUE;
            | 5,6 :
                overwrite := TRUE;
            | 7,8 :
                forceinterpret:=TRUE;
            | 9,10:
                forceWP := TRUE;
            | 11,12 :
                forcelambda:=TRUE;
            | 13,14 :
                forcebeta := TRUE;
            | 15,16:
                IF GetLongInt(S,k) = FALSE THEN abort(errBadOrbePlus,""); END;
                IF chkOrbePlusRange(k)=FALSE THEN abort(errBadOrbePlus,""); END;
                orbePlus := INTEGER(k);
            | 17,18:
                GetString(S,myinterfile);
                forcefile := TRUE;
            | 19,20:
                forceexhaustive :=TRUE;
            | 21,22:
                IF GetLongCard(S,forcedHouseType)=FALSE THEN abort(errBadDomification,"");END;
                IF chkDomificationRange(forcedHouseType)=FALSE THEN abort(errBadDomification,"");END;
                forcedomification:=TRUE;
            | 23,24:
                forcebygroup:=TRUE;
            | 25,26:
                forcebyobject:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Copy(datafile,R); (* keep uppercase *)
                state := gotTheme;
            | gotTheme :
                Str.Copy(reportfile,R); (* keep uppercase *)
                state := gotReport;
            | gotReport :
                abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    IF state = waiting THEN
        abort(errMissingTheme,""); (* could be errHelp *)
    END;
    (* gotTheme or gotReport ok *)

    IF (forcelambda AND forcebeta) THEN abort(errConflictInterpret,"");END;
    IF (forcebygroup AND forcebyobject) THEN abort(errConflictOrbes,"");END;

    (* now check datafile *)

    IF chkFile(extTHM,datafile)=FALSE THEN abort(errBadName,datafile); END;
    IF FIO.Exists(datafile)=FALSE THEN abort(errThemeNotFound,datafile); END;

    IF state = gotTheme THEN
        Str.Copy(reportfile,datafile);
        removeExt(reportfile);
    END;

    IF chkFile(extRPT,reportfile)=FALSE THEN abort(errBadName,reportfile); END;
    IF FIO.Exists(reportfile) THEN
        CASE overwrite OF
        | FALSE :
            abort(errExists,reportfile);
        | TRUE :
            IF isReadOnly(reportfile) THEN abort(errReadOnly,reportfile);END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;



  video(pleasewait,TRUE);
  eyeCandy(cmdInit);
  eyeCandy(cmdSHOW);
  PATIENCE:=TRUE;
    IF loadTheme(themenatal,datafile)=FALSE THEN abort(errThemeFormat,datafile); END;
    IF chkThemeVersion(themenatal)=FALSE THEN abort(errThemeVersion,datafile); END;

  eyeCandy(cmdSHOW);
    buildIniPath(inifile);
    IF FIO.Exists(inifile)=FALSE THEN abort(errIniNotFound,inifile); END;
    IF readIniFileEnh(inifile)=FALSE THEN abort(errIniRead,inifile); END;

  eyeCandy(cmdSHOW);
    initReportFlags();
    FreeIni(); (* we can and MUST do it NOW ! *)

  eyeCandy(cmdSHOW);
    IF chkFile(extRSC,rscfile)=FALSE THEN abort(errBadName,rscfile); END;
    buildRscPath(rscfile);
    IF FIO.Exists(rscfile)=FALSE THEN abort(errRscNotFound,rscfile); END;
    IF readIniFileEnh(rscfile)=FALSE THEN abort(errRscRead,rscfile); END;

  eyeCandy(cmdSHOW);
    initMethodFlags();
    FreeIni(); (* we can and MUST do it NOW ! *)

    (* we know it's one OR the other *)
    IF forcebeta THEN flagUseBeta := TRUE; END;
    IF forcelambda THEN flagUseBeta := FALSE; END;
    (* we know it's one OR the other *)
    IF forcebygroup THEN flagUseAltOrbesNatal := FALSE; END;
    IF forcebyobject THEN flagUseAltOrbesNatal:= TRUE;END;

    IF forceWP THEN
        flagUseTabs:=TRUE;
        LineWidth := 0;
    END;
    IF forceinterpret THEN flagInterpret:=TRUE; END;

    IF forceexhaustive THEN exhaustiveReport(); END;
    IF forcedomification THEN
        theFavoriteHouse:=CARDINAL(forcedHouseType);
        enableFlagForThisHouse(theFavoriteHouse);
    END;
    IF theFavoriteHouse=CARDINAL(nonsensical) THEN
        theFavoriteHouse:=CARDINAL(placidus);
        enableFlagForThisHouse(theFavoriteHouse);
    END;

    flagInterpret:=FALSE;

    (* ------------------------------------------------------------ *)

    IF flagInterpret THEN
        hndTextes:=FIO.OpenRead(textes);
        FIO.AssignBuffer(hndTextes,ioBufferTextes);
    END;

    hndOut:=FIO.Create(reportfile);
    FIO.AssignBuffer(hndOut,ioBuffer);
    header(ProgBanner);
    doFixSomeFlags();

  eyeCandy(cmdSHOW);
    IF themenatal.typeof=unsafenatal THEN
        header (msgUnsafeChart);
    END;

  eyeCandy(cmdSHOW);
    IF flagData                   THEN dmpData; END;
  eyeCandy(cmdSHOW);
    IF flagSynthesis              THEN
        dmpSynthesis(domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagInSign                 THEN dmpInSign; END;
  eyeCandy(cmdSHOW);
    IF flagInHouse                THEN
        dmpInHouse(domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagInTrueHouse            THEN dmpInTrueHouse; END;
  eyeCandy(cmdSHOW);
    IF flagMotion                 THEN dmpMotion; END;
  eyeCandy(cmdSHOW);
    IF flagPlacidus               THEN dmpDom(placidus); END;
  eyeCandy(cmdSHOW);
    IF flagNonsensical                THEN dmpDom(nonsensical); END;
  eyeCandy(cmdSHOW);
    IF flagKoch                   THEN dmpDom(koch); END;
  eyeCandy(cmdSHOW);
    IF flagCampanus               THEN dmpDom(campanus); END;
  eyeCandy(cmdSHOW);
    IF flagRegiomontanus          THEN dmpDom(regiomontanus); END;
  eyeCandy(cmdSHOW);
    IF flagPtolemeus              THEN dmpDom(ptolemeus); END;
  eyeCandy(cmdSHOW);
    IF flagByAspect               THEN dmpByAspect(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByAspectWithFictitious THEN dmpByAspect(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagByObject               THEN dmpByObject(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByObjectWithFictitious THEN dmpByObject(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagByAspectWithBeta       THEN dmpByAspectWithBeta(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByAspectWithBetaWithAngles THEN dmpByAspectWithBeta(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagByObjectWithBeta       THEN dmpByObjectWithBeta(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByObjectWithBetaWithAngles THEN dmpByObjectWithBeta(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagAngularities           THEN dmpAngularities(OrbeAngulaireAS,OrbeAngulaireMC,OrbeAngulaireDS,OrbeAngulaireFC); END;
  eyeCandy(cmdSHOW);
    IF flagCoefficients           THEN
        dmpCoefficients(FALSE,domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagCoefficientsWithFictitious THEN
        dmpCoefficients(TRUE,domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagTradition              THEN
        dmpTradition(domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagAnalysisRET            THEN dmpAnalysisRET; END;
  eyeCandy(cmdSHOW);
    IF flagGeocentric             THEN dmpGeocentric; END;
  eyeCandy(cmdSHOW);
    IF flagEquatorial             THEN dmpEquatorial; END;
  eyeCandy(cmdSHOW);
    IF flagLocal                  THEN dmpLocal; END;
  eyeCandy(cmdSHOW);
    IF flagHeliocentric           THEN dmpHeliocentric; END;

  eyeCandy(cmdSHOW);

    header(ProgBanner);

    FIO.Flush(hndOut);
    FIO.Close(hndOut);

    IF flagInterpret THEN FIO.Close(hndTextes); END;

  eyeCandy(cmdStop);
  video(pleasewait,FALSE);
  PATIENCE:=FALSE;

    WrLn;
    WrStr(ProgBanner);
    WrLn;

    WrLn;
    WrStr("Le fichier ");
    WrStr(reportfile);
    WrStr(" contient le rapport !");

    WrLn;

    abort(errNone,"");
END Rapport.