(* ---------------------------------------------------------------
Title         Q&D Rapport R.E.T.
Author        PhG
Overview      display data
Usage         see help
Notes         very, very, very quick & dirty... :-(
              aspect nature 0=conjonction, 1=dissonant, 2=harmonique USED
              alternate coeffs for RET data : bah, not very very useful (ALTERNATE const)
Bugs          faudra vrifier l'effet de la correction deltaTU (P, L, etc.)
Wish List     filter if ASMCDSFC and abs(lat)> 66 ? in dmpByAspect/Object ?
              add a third ponderation : if planet at 5 before ASMCDSFC,
              then count it in the two houses -- if planet at 1 from next,
              count to next -- add 2 for planets in domicile
              plus tard, intgrer les textes traditionnels (aspects) aux
              paragraphes conditionalistes au lieu de les mettre aprs ?
              dans les aspects, rappel des natures RET des astres en cause ?
              intro globale pour expliquer les pondrations ?

--------------------------------------------------------------- *)

MODULE RET;

IMPORT FIO;
IMPORT Str;
IMPORT Lib;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey,  chkJoker,
isOption, GetOptIndex, GetLongCard, GetString, CharCount, same, cleantabs,
aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,str1024, isoleItemS,dmpTTX, str2048, Elapsed,
GetLongInt, str4096,pathtype;

FROM QD_Sky IMPORT int, frac, mod, DateToJD, JDtoDate, JDtoJD0H,
JDtoWeekday, JDtoT, isDigit, MatchFormat, getLastCard, stripCard,
getCard, parseDate, parseTime, parseLongitude, DateTimeToJD,
CalcBornes, chkZoneFR, ToggleSign, parseLatitude, parseDeltaTU,
DateToStr, TimeToStr, themeFile, themeID, themetype, displayfmt,
AngleToStr, isDirect, loadTheme, saveTheme, PadsSetup, AngleToPos,
fmtLatitude, fmtLongitude, fmtDeltaTU, between, inAspect,
isAngulaire, inAspectBeta, inZone, swapBool, sepline,
chkThemeVersion,  minorbeplus, maxorbeplus,
processGender, stringToVal, greater, smaller;


FROM QD_Calc IMPORT Calc, InitCalc, calcmode, objet, cuspide, sens,
domificationtype, solarsystemtype,housetype,skypos, InitCalcLocal,
CalcDomification, CalcTrueHouse, CalcAzimutAltitude,
getLastCusp, chkDomificationRange, angleIsCusp,
firstCusp, lastCusp, clockwiseDom;

FROM QD_Ini IMPORT readIniFile, listSections, findEntry,
getItemStrUp, getItemCard, getItemBool, getItemChar,
readIniFileEnh, FreeIni, getItemReal0_1;

FROM QD_Names IMPORT astroToolsName,
sRessources, eTraditionnelle, eConditionaliste,
sReport, eMethod, ePadChar, ePadSign, ePadComa, eDecimal,
eFavoriteHouse, eData, eSynthesis, eInSign, eInHouse, eInTrueHouse,
eMotion, ePlacidus, eCampanus, eRegiomontanus, ePtolemeus, eKoch,
eByAspect, eByAspectWithFictitious, eByObject, eByObjectWithFictitious,
eAngularities, eAnalysisRET, eCoefficients, eTradition, eGeocentric,
eEquatorial, eLocal, eHeliocentric, eUseTabs, eCoefficientsWithFictitious,
sObjectEnabled, sAspectEnabled, sAspectRank, sObjectRank, sObjectGroup,
sObjectWeight, sOrbe11, sOrbe22, sOrbe33, sOrbe12, sOrbe13, sOrbe23,
sInfo,eRET,eByAspectWithBeta,eByAspectWithBetaWithAngles,
eByObjectWithBeta,eByObjectWithBetaWithAngles,
eOrbeAngulaireAS,eOrbeAngulaireMC, eOrbeAngulaireDS, eOrbeAngulaireFC,
aspecttype,getObjectName, getCuspideName, getMotionStr,
getDomificationStr, getAspectName, getRomanStr,
objectinfotype, aspectinfotype, objectinfoarray, aspectinfoarray, signtype,
firstObject, lastObject, firstAspect, lastAspect, getSignName,
isPlanete, isFictitious, getSectorName, isAngle, getMotionAbrev,
getEcart, grouptype, getGroupClass, firstSign,lastSign,
dignitytype, getDignityName, getDignity, getMaitrise, getDignityAlt,
eInterpret, eLineWidth, eTextes,ePointeurs,readIndexFile,
sREM, sEntry, sEOF, sIF, sENDIF,
sfWarning, sfAngulaires, sfSignes, sfMaisons, sfSante, stIntro,
stEt, stConjonction, stHarmonique, stDissonant, stSoleilAS,
st000, st180, st090, st120, st060, stnil, findIndexFileOffset,
findFileEntry, readFileEntry, findFileEntryAspect,
natNeutral, natDissonant, natHarmonic, stDux, sReportRET, eInRETzone,
eRETfamilies, eRETsigns, eInterpretTradition, eUseBetaForTexts, eInterpretMix,
ProgCopyright, eKeepEmptyLine,
sRETzoneLimits, e1_xii, e1_i, e2_x, e2_ix,
e3_vii, e3_vi, e4_iii, e4_iv, eHalf, eTwoThird, getCuspideNameAlt,
getAspectNameFR, getObjectNameFR, getSignNameFR, getSectorNameAlt,
isAxisOrUseless, eAvoidAxisOrUseless,
txtDomKeys, txtDomParms,
eUseAltOrbesNatal, sAltOrbesNatal,
objectindexarray, aspectindexarray, msgUnsafeChart,msgUnsafeOption;


IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)

CONST
    ALTERNATE = FALSE; (* not very, very useful in fact : let it to FALSE *)

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "RET";
    ProgTitle     = "Q&D R.E.T. (Win32)";
    ProgVersion   = "v0.9 (v1.1d DOS)";
    ProgBanner    = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    nicolaBanner  = "Modle R.E.T. (C) Copyright par Jean-Pierre Nicola";
CONST
    extEXE        = ".EXE"; (* upper case *)
    extTHM        = ".TM";
    extRPT        = ".RPT";
    extINI        = ".INI";
    extRSC        = ".RSC";
    extNDX        = ".RSX"; (* was ndx *)
    extHID        = ".HID";
    extHIX        = ".HIX";

    extTXT       = ".TXT";
    extASP       = ".ASP";
    extHOU       = ".HOU";

    extMAS       = ".MAS";

    extTRA       = ".TRA"; (* transits : metteurs sur rcepteurs *)
    extCUS       = ".CUS"; (* transits : metteurs dans les maisons *)
    extCMP       = ".CMP";

    extRET       = ".RET"; (* for RET aspects *)
    extDOM       = ".DOM"; (* for RET doms *)

CONST
    errNone              = 0;
    errHelp              = 1;
    errOption            = 2;
    errParmOverflow      = 3;
    errMissingTheme      = 4;
    errBadName           = 5;
    errExists            = 6;
    errReadOnly          = 7;
    errThemeNotFound     = 8;
    errIniNotFound       = 9;
    errThemeFormat       = 10;
    errIniRead           = 12;
    errRscNotFound       = 13;
    errRscRead           = 14;
    errThemeVersion	 = 15;

    errBadPlanetZone     = 16;
    errRedefined         = 17;
    errBadHierarchy      = 18;
    errConflictInterpret = 19;
    errBadOrbePlus       = 20;
    errBadDomification   = 21;
    errConflictOrbes     = 22;

    errAborted       = 253;

VAR
    DEBUG         : BOOLEAN;
CONST
    nullchar    = CHR(0);
    semicolon   = ";";
    pound       = "#";
    openbracket = "[";
    closebracket= "]";
    quote       = "'";
    doublequote = '"';
    blank       = " ";
    tab         = CHR(9);
    coma        = ","; comma = coma;
    dash        = "-";
    slash       = "/";
    bar         = "|";
    underbar    = "_";
    dollar      = "$";
    antislash   = "\";
    backslash   = "\";
    dot         = ".";
    sAlpha      = CHR(0E0H);
    sDelta      = CHR(0EBH);
    sLambda     = "lambda"; (* no char ! *)
    sBeta       = CHR(0E1H);
CONST
    codeParis      = "P";
    codeLocal      = "L";
    pleasewait     = "Patience, cration du rapport... Temps coul : ";
CONST
    tabul = "        "; (* default 8 front spaces, later check for possible paragraph TAB *)
    msgT  = tabul+"En astropsychologie :";

(* ------------------------------------------------------------ *)

PROCEDURE eyeCandy(command:CARDINAL);
VAR
    i : CARDINAL;
BEGIN
    Elapsed(command);
END eyeCandy;

VAR
  PATIENCE : BOOLEAN;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    nl     = 015C+012C; (* CHR(13)+CHR(10); *)
VAR
    S : str256;
BEGIN
  IF PATIENCE=TRUE THEN
      eyeCandy(cmdStop);
      video(pleasewait,FALSE);
      PATIENCE:=FALSE; (* who knows ? ;-) *)
  END;
    CASE e OF
    | errHelp :
        (*
               00000000011111111112222222222333333333344444444445555555555666666666677777777778
               1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
        *)
        WrLn;
        WrStr("Titre   : "+ProgBanner+nl);
        WrLn;
        WrStr("Syntaxe : "+ProgEXEname+" <thme["+extTHM+"]> <hirarchie> [rapport["+extRPT+"]] [option]..."+nl);
        WrLn;
        WrStr("Utilit : cration du rapport conditionaliste correspondant  un thme"+nl);
        WrLn;
        WrStr("Options : /o pour remplacer l'ventuel rapport existant"+nl);
        WrStr("          /i pour ajouter les lments d'interprtation conditionaliste"+nl);
        WrStr("          /t pour ajouter les lments d'interprtation traditionnelle"+nl);
        WrStr("          /m pour intgrer les lments d'interprtation traditionnelle aux"+nl);
        WrStr("             lments d'interprtation conditionaliste (dominantes et aspects)"+nl);
        WrStr("          /w pour forcer "+eUseTabs+"  Yes et "+eLineWidth+"  0"+nl);
        WrStr("          /l pour forcer "+eUseBetaForTexts+"  No (interprtation des aspects)"+nl);
        WrStr("          /b pour forcer "+eUseBetaForTexts+"  Yes (interprtation des aspects)"+nl);
        WrStr("          /pg pour forcer "+eUseAltOrbesNatal+"  No (orbes par groupe)"+nl);
        WrStr("          /po pour forcer "+eUseAltOrbesNatal+"  Yes (orbes par objet)"+nl);
        WrStr("          /e pour forcer un rapport exhaustif avec toutes les rubriques"+nl);
        WrStr("          /d:# pour forcer le type de domification"+nl);
        WrStr("               "+txtDomParms+nl);
        WrStr("          /a:# pour ajouter la valeur # aux orbes"+nl);
        WrStr("          /f:$ pour spcifier le fichier des interprtations ("+extRSC+", "+extNDX+")"+nl);
        WrLn;
        WrStr("Note 1  : La dtermination de la hirarchie est laisse  l'astrologue !"+nl);
        WrStr("          En prsence d'angulaires, valoriser l'ordre AS, MC, DS, FC. Utiliser"+nl);
        WrStr("          la proximit  l'angle, le rang R.E.T. et l'arc diurne. Chercher les"+nl);
        WrStr("          plantes lies aux angulaires. Valoriser l'aspect (0, 180, 90, 120,"+nl);
        WrStr("          60), le rang R.E.T. et l'arc diurne. Classer les amas proches des"+nl);
        WrStr("          angles. Valoriser les aspects reus et l'arc diurne."+nl);
        WrStr("          En l'absence d'angulaires, privilgier les astres les plus hauts sur"+nl);
        WrStr("          l'arc diurne, puis les amas."+nl);
        WrStr("Note 2  : La hirarchie exige videmment l'numration des 10 plantes."+nl);
        WrStr("          Voici les abrviations admises : L S M V J MA SA U N P, ## ou ###"+nl);
        WrStr("Note 3  : La zone conditionaliste est redfinissable par un suffixe facultatif."+nl);
        WrStr("          En l'absence d'un suffixe, la zone sera dtermine par le programme."+nl);
        WrStr("          Voici les seuls suffixes admis : 1=AS, 2=MC, 3=DS, 4=FC, 0=neutre"+nl);
        WrStr("Note 4  : "+nicolaBanner+"."+nl);
        WrLn;
        WrStr("Exemple : "+ProgEXEname+" vangogh ma ve ne so lu ju me pl ur sa /o /i /m /a:+4"+nl);
    | errOption :
        Str.Concat(S,"L'option ",einfo);
        Str.Append(S," est illgale !");
    | errParmOverflow :
        Str.Concat(S,"Le paramtre ",einfo);
        Str.Append(S," est de trop !");
    | errMissingTheme :
        S := "Le fichier thme est indispensable !";
    | errBadName :
        Str.Concat(S,"Le nom de fichier (",einfo);
        Str.Append(S,") est incorrect !");
    | errExists :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") existe dj !");
    | errReadOnly :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") est protg contre l'criture !");
    | errThemeNotFound :
        Str.Concat(S,"Le thme (",einfo);
        Str.Append(S,") n'existe pas !");
    | errIniNotFound :
        Str.Concat(S,"Le fichier de configuration (",einfo);
        Str.Append(S,") n'existe pas !");
    | errThemeFormat :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") n'est pas un thme !");
    | errIniRead :
        Str.Concat(S,"Le fichier de configuration (",einfo);
        Str.Append(S,") ne tient pas en mmoire !");
    | errRscNotFound :
        Str.Concat(S,"Le fichier ressource (",einfo);
        Str.Append(S,") n'existe pas !");
    | errRscRead :
        Str.Concat(S,"Le fichier ressource (",einfo);
        Str.Append(S,") ne tient pas en mmoire !");
    | errThemeVersion :
        Str.Concat(S,"Le thme (",einfo);
        Str.Append(S,") exige une autre version du programme !");
    | errConflictInterpret :
        S := "Les options /l et /b sont mutuellement exclusives !";
    | errBadOrbePlus:
        S := "La valeur de la correction ajoute aux orbes est illgale !";
    | errBadDomification:
        S := "La valeur du type de domification est illgale !";
    | errConflictOrbes :
        S := "Les options /pg et /po sont mutuellement exclusives !";


    | errAborted :
        S := "Interruption du programme ! Sage dcision avec Windows ! ;-)";

    | errBadPlanetZone  :
        Str.Concat(S,"La combinaison plante[zone] (",einfo);
        Str.Append(S,") est illgale !");
    | errRedefined  :
        Str.Concat(S,"La plante (",einfo);
        Str.Append(S,") est dj dfinie !");
    | errBadHierarchy:
        S:="La hirarchie est incomplte !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    IF (e <> errNone) AND (e <> errHelp) THEN
        WrLn;
        WrStr(ProgEXEname+" : ");
        WrStr(S);
        WrLn;
    END;


    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    orbePlus : INTEGER;

PROCEDURE initOrbePlus ();
BEGIN
    orbePlus := 0;
END initOrbePlus;

PROCEDURE chkOrbePlusRange (k:LONGINT) : BOOLEAN;
BEGIN
    RETURN ( ABS(k) <= maxorbeplus);
END chkOrbePlusRange;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBuffer        : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
    ioBufferTextes  : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    hndOut : FIO.File;
    hndTextes : FIO.File;

PROCEDURE nl ();
BEGIN
    (* WrLn; *)
    FIO.WrLn(hndOut);
END nl;

PROCEDURE wr (S:ARRAY OF CHAR);
BEGIN
    (* WrStr(S); *)
    FIO.WrStr(hndOut,S);
END wr;

PROCEDURE header (S:ARRAY OF CHAR);
BEGIN
    nl;
    wr(sepline);
    nl;
    wr(S);
    nl;
    wr(sepline);
    nl;
    nl;
END header;

PROCEDURE headertwo (S,S1:ARRAY OF CHAR);
BEGIN
    nl;
    wr(sepline);
    nl;
    wr(S);
    nl;
    wr(S1);
    nl;
    wr(sepline);
    nl;
    nl;
END headertwo;

(* ------------------------------------------------------------ *)

VAR
    themenatal : themeFile;
VAR
    rscfile    : str128;
    methodname : str128;
    exedir     : str128;
    textes     : str128;
    indextextes: str128;
VAR
    thePadChar                  : CHAR;
    thePadSign                  : CHAR;
    thePadComa                  : CHAR;
    flagUseTabs                 : BOOLEAN;
    flagDecimal                 : BOOLEAN;
    LineWidth                   : CARDINAL;
    flagKeepEmptyLine               : BOOLEAN;
    theFavoriteHouse            : CARDINAL;

    flagData                    : BOOLEAN;
    flagSynthesis               : BOOLEAN;
    flagInRETzone               : BOOLEAN; (* for RET only *)
    flagRETfamilies             : BOOLEAN; (* for RET only *)
    flagRETsigns                : BOOLEAN; (* for RET only *)
    flagInSign                  : BOOLEAN;
    flagInHouse                 : BOOLEAN;
    flagInTrueHouse             : BOOLEAN;
    flagMotion                  : BOOLEAN;
    flagPlacidus                : BOOLEAN;
    flagCampanus                : BOOLEAN;
    flagRegiomontanus           : BOOLEAN;
    flagPtolemeus               : BOOLEAN;
    flagKoch                    : BOOLEAN;
    flagNonsensical                 : BOOLEAN;

    flagByAspect                : BOOLEAN;
    flagByAspectWithFictitious  : BOOLEAN;
    flagByObject                : BOOLEAN;
    flagByObjectWithFictitious  : BOOLEAN;
    flagByAspectWithBeta        : BOOLEAN;
    flagByAspectWithBetaWithAngles : BOOLEAN;
    flagByObjectWithBeta        : BOOLEAN;
    flagByObjectWithBetaWithAngles : BOOLEAN;

    flagAngularities            : BOOLEAN;
    flagCoefficients            : BOOLEAN;
    flagCoefficientsWithFictitious: BOOLEAN;
    flagTradition               : BOOLEAN;
    flagGeocentric              : BOOLEAN;
    flagEquatorial              : BOOLEAN;
    flagLocal                   : BOOLEAN;
    flagHeliocentric            : BOOLEAN;
    flagAnalysisRET             : BOOLEAN;
    flagInterpret               : BOOLEAN;
    flagInterpretTradition      : BOOLEAN; (* for RET only *)
    flagUseBeta                 : BOOLEAN; (* for interpretation of aspects *)
    flagInterpretMix            : BOOLEAN; (* for RET *)
    flagAvoidAxisOrUseless     : BOOLEAN;

VAR
    k1_xii,k1_i,k2_x,k2_ix,k3_vii,k3_vi,k4_iii,k4_iv : LONGREAL;
VAR
    ObjectInfo          : objectinfoarray;
    AspectInfo          : aspectinfoarray;
    flagRET             : BOOLEAN;
    OrbeAngulaireAS     : CARDINAL;
    OrbeAngulaireMC     : CARDINAL;
    OrbeAngulaireDS     : CARDINAL;
    OrbeAngulaireFC     : CARDINAL;
    flagUseAltOrbesNatal     : BOOLEAN;
    objectindex         : objectindexarray;
    aspectindex         : aspectindexarray;

(* bugfix ! how stupid I was... *)

PROCEDURE doFixSomeFlags (  );
BEGIN
    swapBool(flagByAspect                  ,flagByObject               );
    swapBool(flagByAspectWithFictitious    ,flagByObjectWithFictitious );
    swapBool(flagByAspectWithBeta          ,flagByObjectWithBeta       );
    swapBool(flagByAspectWithBetaWithAngles,flagByObjectWithBetaWithAngles);
END doFixSomeFlags;

(* from CIEL.INI *)

(* maybe we could check legal pad chars, favorite house and others... *)

PROCEDURE initReportFlags (  );
VAR
    S : str128;
    entry : str128;
BEGIN
    Str.Copy(S,sReportRET);
    getItemStrUp(S,eMethod,"?",entry);
    Str.Copy(methodname,entry);
    getItemChar(S,ePadChar           ,"0",thePadChar);
    getItemChar(S,ePadSign           ,"+",thePadSign);
    getItemChar(S,ePadComa           ,",",thePadComa);
    getItemBool(S,eUseTabs           ,"n",flagUseTabs);
    getItemBool(S,eDecimal           ,"n",flagDecimal);
    getItemCard(S,eLineWidth         ,"66",LineWidth);
    getItemBool(S,eKeepEmptyLine         ,"y",flagKeepEmptyLine);
    Str.Copy(S,sRessources);
    getItemStrUp(S,entry,"?",rscfile);
    PadsSetup(thePadChar,thePadSign,thePadComa);
    getItemStrUp(S,eTextes,"?",textes);
    getItemStrUp(S,ePointeurs,"?",indextextes);
END initReportFlags;

(* from RSC file *)

(* maybe we could check for legal values... *)

PROCEDURE initMethodFlags (  );
VAR
    i,k,value : CARDINAL;
    entry : str128;
    S,sorbes,svalue : str128; (* section *)
BEGIN
    FOR i := ORD(soleil) TO ORD(blacksun) DO
  eyeCandy(cmdSHOW);
        getObjectNameFR(objet(i),entry);
        getItemBool(sObjectEnabled,entry,"n",ObjectInfo[i].enabled);
        getItemCard(sObjectRank   ,entry,"0",ObjectInfo[i].rank);
        getItemCard(sObjectWeight ,entry,"0",ObjectInfo[i].weight);
        getItemCard(sObjectGroup  ,entry,"0",ObjectInfo[i].group);

        (* do not bother with a default string nor with counting items *)
        getItemStrUp(sAltOrbesNatal,entry,"", sorbes );
        FOR k:=firstAspect TO lastAspect DO
   eyeCandy(cmdSHOW);
            isoleItemS(svalue, sorbes, comma , k); (* function is 0-based *)
            IF stringToVal(svalue, value)=FALSE THEN value:=90; END;
            ObjectInfo[i].altorbenatal[k]:=value;
        END;

        ObjectInfo[i].sector := 0;
        ObjectInfo[i].angular:=FALSE;
        (* WARNING ! remember rank is 1.. while object is 0.. *)
        objectindex[ObjectInfo[i].rank -1 ]:=i;
    END;
    FOR i := ORD(conjonction) TO ORD(sesquicarre) DO
  eyeCandy(cmdSHOW);
        getAspectNameFR(aspecttype(i),entry);
        getItemBool(sAspectEnabled,entry,"n",AspectInfo[i].enabled);
        getItemCard(sAspectRank   ,entry,"0",AspectInfo[i].rank);
        getItemCard(sOrbe11       ,entry,"0",AspectInfo[i].orbe11);
        getItemCard(sOrbe22       ,entry,"0",AspectInfo[i].orbe22);
        getItemCard(sOrbe33       ,entry,"0",AspectInfo[i].orbe33);
        getItemCard(sOrbe12       ,entry,"0",AspectInfo[i].orbe12);
        getItemCard(sOrbe13       ,entry,"0",AspectInfo[i].orbe13);
        getItemCard(sOrbe23       ,entry,"0",AspectInfo[i].orbe23);
        getItemCard(sReport,entry,"0",AspectInfo[i].nature); (* 0=conj=neutral, 1=dissonant, 2=harmonique *)
        AspectInfo[i].ecart:=getEcart( aspecttype(i) );
        (* WARNING ! remember rank is 1.. while aspect is 0.. *)
        aspectindex[AspectInfo[i].rank -1 ]:=i;
    END;
  eyeCandy(cmdSHOW);
    Str.Copy(S,sInfo);
    getItemBool(S,eRET,"n",flagRET);
    getItemCard(S,eOrbeAngulaireAS,"10",OrbeAngulaireAS);
    getItemCard(S,eOrbeAngulaireMC,"10",OrbeAngulaireMC);
    getItemCard(S,eOrbeAngulaireDS,"10",OrbeAngulaireDS);
    getItemCard(S,eOrbeAngulaireFC,"10",OrbeAngulaireFC);
    getItemBool(S,eUseAltOrbesNatal,"n",flagUseAltOrbesNatal);

    Str.Copy(S,sReportRET);
    getItemCard(S,eFavoriteHouse     ,"1",theFavoriteHouse);
    getItemBool(S,eData              ,"y",flagData);
    getItemBool(S,eSynthesis         ,"y",flagSynthesis);
    getItemBool(S,eInRETzone         ,"y",flagInRETzone); (* for RET only *)

    getItemBool(S,eRETfamilies       ,"y",flagRETfamilies);  (* for RET only *)
    getItemBool(S,eRETsigns          ,"y",flagRETsigns);  (* for RET only *)

    getItemBool(S,eInSign            ,"y",flagInSign);
    getItemBool(S,eInHouse           ,"y",flagInHouse);
    getItemBool(S,eInTrueHouse       ,"y",flagInTrueHouse);
    getItemBool(S,eMotion            ,"y",flagMotion);
    getItemBool(S,ePlacidus          ,"y",flagPlacidus);
    getItemBool(S,eCampanus          ,"n",flagCampanus);
    getItemBool(S,eRegiomontanus     ,"n",flagRegiomontanus);
    getItemBool(S,ePtolemeus         ,"n",flagPtolemeus);
    getItemBool(S,eKoch              ,"n",flagKoch);
    getItemBool(S,eByAspect          ,"y",flagByAspect);
    getItemBool(S,eByAspectWithFictitious,"y",flagByAspectWithFictitious);
    getItemBool(S,eByObject          ,"y",flagByObject);
    getItemBool(S,eByObjectWithFictitious,"y",flagByObjectWithFictitious);
    getItemBool(S,eByAspectWithBeta  ,"y",flagByAspectWithBeta);
    getItemBool(S,eByAspectWithBetaWithAngles,"y",flagByAspectWithBetaWithAngles);
    getItemBool(S,eByObjectWithBeta  ,"y",flagByObjectWithBeta);
    getItemBool(S,eByObjectWithBetaWithAngles,"y",flagByObjectWithBetaWithAngles);
    getItemBool(S,eAngularities      ,"y",flagAngularities);
    getItemBool(S,eCoefficients      ,"y",flagCoefficients);
    getItemBool(S,eCoefficientsWithFictitious,"y",flagCoefficientsWithFictitious);
    getItemBool(S,eTradition         ,"y",flagTradition);
    getItemBool(S,eGeocentric        ,"y",flagGeocentric);
    getItemBool(S,eEquatorial        ,"n",flagEquatorial);
    getItemBool(S,eLocal             ,"n",flagLocal);
    getItemBool(S,eHeliocentric      ,"n",flagHeliocentric);
    getItemBool(S,eAnalysisRET       ,"n",flagAnalysisRET);
    getItemBool(S,eInterpret         ,"n",flagInterpret);
    getItemBool(S,eInterpretTradition,"n",flagInterpretTradition); (* for RET only *)
    getItemBool(S,eUseBetaForTexts           ,"n",flagUseBeta); (* for interpretation of aspects *)
    getItemBool(S,eInterpretMix      ,"n",flagInterpretMix); (* for RET *)
    getItemBool(S,eAvoidAxisOrUseless,"y",flagAvoidAxisOrUseless);

  eyeCandy(cmdSHOW);
    Str.Copy(S,sRETzoneLimits);
    getItemReal0_1(S,e1_xii             ,eTwoThird,k1_xii);
    getItemReal0_1(S,e1_i               ,eHalf    ,k1_i);
    getItemReal0_1(S,e2_x               ,eTwoThird,k2_x);
    getItemReal0_1(S,e2_ix              ,eTwoThird,k2_ix);
    getItemReal0_1(S,e3_vii             ,eTwoThird,k3_vii);
    getItemReal0_1(S,e3_vi              ,eHalf    ,k3_vi);
    getItemReal0_1(S,e4_iii             ,eHalf    ,k4_iii);
    getItemReal0_1(S,e4_iv              ,eHalf    ,k4_iv);
END initMethodFlags;

(* ------------------------------------------------------------ *)

PROCEDURE exhaustiveReport (  );
BEGIN
    flagData                    := TRUE;
    flagSynthesis               := TRUE;
    flagInRETzone               := TRUE;
    flagRETfamilies             := TRUE;
    flagRETsigns                := TRUE;

    flagInSign                  := TRUE;
    flagInHouse                 := TRUE;
    flagInTrueHouse             := TRUE;
    flagMotion                  := TRUE;
    flagPlacidus                := TRUE;
    flagCampanus                := TRUE;
    flagRegiomontanus           := TRUE;
    flagPtolemeus               := TRUE;
    flagKoch                    := TRUE;
    flagNonsensical                 := TRUE;
    flagNonsensical                 := FALSE;

    flagByAspect                := TRUE;
    flagByAspectWithFictitious  := TRUE;
    flagByObject                := TRUE;
    flagByObjectWithFictitious  := TRUE;
    flagByAspectWithBeta        := TRUE;
    flagByAspectWithBetaWithAngles := TRUE;
    flagByObjectWithBeta        := TRUE;
    flagByObjectWithBetaWithAngles := TRUE;
    flagAngularities            := TRUE;
    flagCoefficients            := TRUE;
    flagCoefficientsWithFictitious:= TRUE;
    flagTradition               := TRUE;
    flagGeocentric              := TRUE;
    flagEquatorial              := TRUE;
    flagLocal                   := TRUE;
    flagHeliocentric            := TRUE;
    flagAnalysisRET             := TRUE;
    (* flagAvoidAxisOrUseless      := FALSE; *)
END exhaustiveReport;

PROCEDURE enableFlagForThisHouse (i:CARDINAL);
BEGIN
    CASE i OF
    | ORD(placidus):     flagPlacidus      := TRUE;
    | ORD(campanus):     flagCampanus      := TRUE;
    | ORD(regiomontanus):flagRegiomontanus := TRUE;
    | ORD(ptolemeus):    flagPtolemeus     := TRUE;
    | ORD(koch):         flagKoch          := TRUE;
    | ORD(nonsensical):
                         flagNonsensical       := FALSE;
    ELSE ; (* //ISO fixed silly requirement *) END;
END enableFlagForThisHouse;

(* ------------------------------------------------------------ *)

(* before we found out that Milieu du Ciel could be an object in synthesis,
an not only a cusp, we had wiObjetLong = 15 for "++++Soleil Noir" > "Milieu du Ciel" *)
CONST
    wiInfo = 23; (* longest string seems to be TSL *)
    wiObjet= 14; (* milieu du ciel *)
    wiCorps= 7;  (* jupiter *)
    wiSigne= 10; (* capricorne *)
    wiRoman= 4;  (* viii *)
    wiMotionAbrev=5; (* --D-- *)
    wiAspect = 12 ; (* sesqui-carr *)
    spaces  = "                                        "; (* 40 should do *)
    interval= "    "; (* 4 should do *)
    wiObjetLong   = 18;   (* "++++Milieu du Ciel" is now longest in synthesis *)
    wiCoeff = 13; (* was 12 for "secteur viii" but now "Objectivation" *)

PROCEDURE pad (wi:CARDINAL;VAR S : ARRAY OF CHAR); (* never pass a string constant to this sub ! *)
VAR
    n : CARDINAL;
    R : str128;
BEGIN
    CASE flagUseTabs OF
    | TRUE :
        (* do nothing *)
    | FALSE :
        n := Str.Length(S);
        IF n = wi THEN
            (* nothing *)
        ELSIF n < wi THEN
            Str.Slice(R,spaces,0,wi-n);
            Str.Append(S,R);
        ELSE
            Str.Slice(R,S,0,wi-3);
            Str.Append(R,"...");
            Str.Copy(S,R);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
END pad;

PROCEDURE add (VAR S:ARRAY OF CHAR;R:ARRAY OF CHAR );
BEGIN
    CASE flagUseTabs OF
    | TRUE :   Str.Append(S,tab);
    | FALSE :  Str.Append(S,interval);
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Append(S,R);
END add;

PROCEDURE dmp1 (S : ARRAY OF CHAR);
BEGIN
    wr(S);
    nl;
END dmp1;

PROCEDURE dmp2 (wi:CARDINAL;Z,Z1 : ARRAY OF CHAR);
VAR
	S,S1:str256;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);
    pad(wi,S);
    add(S,S1);
    wr(S);
    nl;
END dmp2;

PROCEDURE dmp3 (wi:CARDINAL;Z,Z1,Z2:ARRAY OF CHAR);
VAR
 	S,S1,S2:str256;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);Str.Copy(S2,Z2);
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    wr(S);
    nl;
END dmp3;

PROCEDURE dmp4 (wi:CARDINAL;Z,Z1,Z2,Z3:ARRAY OF CHAR);
VAR
	S,S1,S2,S3:str256;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);Str.Copy(S2,Z2);Str.Copy(S3,Z3);
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    add(S,S3);
    wr(S);
    nl;
END dmp4;

PROCEDURE dmp5 (wi:CARDINAL;Z,Z1,Z2,Z3,Z4:ARRAY OF CHAR);
VAR
	S,S1,S2,S3,S4:str256;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);Str.Copy(S2,Z2);Str.Copy(S3,Z3);Str.Copy(S4,Z4);
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    add(S,S3);
    add(S,S4);
    wr(S);
    nl;
END dmp5;

PROCEDURE dmp6 (wi:CARDINAL;Z,Z1,Z2,Z3,Z4,Z5:ARRAY OF CHAR);
VAR
	S,S1,S2,S3,S4,S5:str256;
BEGIN
Str.Copy(S,Z);Str.Copy(S1,Z1);Str.Copy(S2,Z2);Str.Copy(S3,Z3);Str.Copy(S4,Z4);Str.Copy(S5,Z5);
    pad(wi,S);
    add(S,S1);
    add(S,S2);
    add(S,S3);
    add(S,S4);
    add(S,S5);
    wr(S);
    nl;
END dmp6;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* es, we use hard coded values instead of ini defined values ! *)

VAR
    flagAngularitiesHere : BOOLEAN; (* for RET only *)
CONST
    wiAspectCoeff = 2;  (* ## at most ((9+10)*3) *)
    wiFamilyCoeff = 3;  (* ## *)
    wiSignCoeff   = 3;  (* ## *)

PROCEDURE valToStr (v:CARDINAL;VAR S : ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(LONGCARD(v),S,10,ok);
    IF v < 10 THEN Str.Prepend(S,thePadChar); END;
END valToStr;

PROCEDURE kvalToStr (v:CARDINAL;VAR S : ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(LONGCARD(v),S,10,ok);
    IF v < 10 THEN Str.Prepend(S,thePadChar); END;
    IF wiAspectCoeff = 3 THEN
        IF v < 100 THEN Str.Prepend(S,thePadChar); END;
    END;
END kvalToStr;

PROCEDURE intvalToStr (v:INTEGER;VAR S : ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
BEGIN
    IF v < 0 THEN
        valToStr(ABS(v),S); (* ## ! *)
        Str.Prepend(S,"-");
    ELSE
        valToStr(ABS(v),S); (* ## ! *)
        Str.Prepend(S,thePadChar);
    END;
END intvalToStr;


(* i and j are ranks in hierarchy, with i > j *)
(* S is string to receive aspect coefficient, S1 is string for zone symbols *)

PROCEDURE computeAspectCoeff (i,j:CARDINAL;VAR S,S1 : ARRAY OF CHAR) : CARDINAL;
CONST
    (* all strings are 2 chars long, thus eliminating the need for padding *)
    domdom = "++";
    domnul = "+-";
    nuldom = "-+"; (* should never happen *)
    nulnul = "--";


CONST
    k11 = 1;    k12 = 1;    k13 = 1;    k14 = 1;    k10 = 2;
    k21 = 1;    k22 = 1;    k23 = 1;    k24 = 1;    k20 = 2;
    k31 = 1;    k32 = 1;    k33 = 1;    k34 = 1;    k30 = 2;
    k41 = 1;    k42 = 1;    k43 = 1;    k44 = 1;    k40 = 2;
    k01 = 2;    k02 = 2;    k03 = 2;    k04 = 2;    k00 = 3;


VAR
    ndx1,ndx2:CARDINAL;
    zone1,zone2:CARDINAL;
    coeff : CARDINAL;
BEGIN
    ndx1  := objectindex[i];
    zone1 := ObjectInfo[ndx1].RETzone;
    ndx2  := objectindex[j];
    zone2 := ObjectInfo[ndx2].RETzone;

    (* remember hierarchy begins at 1, not 0 ! *)
    INC(i);
    INC(j);

    coeff := i+j;
    Str.Copy(S1,nulnul); (* yes, we could patch code nearby computeCoeff calls and remove -- *)

    IF flagAngularitiesHere THEN (* multiply only if any angularity here *)
        CASE zone1 OF
        | 1 :
            CASE zone2 OF
            | 1 : coeff := coeff * k11; Str.Copy(S1,domdom);
            | 2 : coeff := coeff * k12; Str.Copy(S1,domdom);
            | 3 : coeff := coeff * k13; Str.Copy(S1,domdom);
            | 4 : coeff := coeff * k14; Str.Copy(S1,domdom);
            | 0 : coeff := coeff * k10; Str.Copy(S1,domnul);
            ELSE ; (* //ISO fixed silly requirement *) END;
        | 2 :
            CASE zone2 OF
            | 1 : coeff := coeff * k21; Str.Copy(S1,domdom);
            | 2 : coeff := coeff * k22; Str.Copy(S1,domdom);
            | 3 : coeff := coeff * k23; Str.Copy(S1,domdom);
            | 4 : coeff := coeff * k24; Str.Copy(S1,domdom);
            | 0 : coeff := coeff * k20; Str.Copy(S1,domnul);
            ELSE ; (* //ISO fixed silly requirement *) END;
        | 3 :
            CASE zone2 OF
            | 1 : coeff := coeff * k31; Str.Copy(S1,domdom);
            | 2 : coeff := coeff * k32; Str.Copy(S1,domdom);
            | 3 : coeff := coeff * k33; Str.Copy(S1,domdom);
            | 4 : coeff := coeff * k34; Str.Copy(S1,domdom);
            | 0 : coeff := coeff * k30; Str.Copy(S1,domnul);
            ELSE ; (* //ISO fixed silly requirement *) END;
        | 4 :
            CASE zone2 OF
            | 1 : coeff := coeff * k41; Str.Copy(S1,domdom);
            | 2 : coeff := coeff * k42; Str.Copy(S1,domdom);
            | 3 : coeff := coeff * k43; Str.Copy(S1,domdom);
            | 4 : coeff := coeff * k44; Str.Copy(S1,domdom);
            | 0 : coeff := coeff * k40; Str.Copy(S1,domnul);
            ELSE ; (* //ISO fixed silly requirement *) END;
        | 0 :
            CASE zone2 OF
            | 1 : coeff := coeff * k01; Str.Copy(S1,nuldom); (* cannot be ! *)
            | 2 : coeff := coeff * k02; Str.Copy(S1,nuldom); (* cannot be ! *)
            | 3 : coeff := coeff * k03; Str.Copy(S1,nuldom); (* cannot be ! *)
            | 4 : coeff := coeff * k04; Str.Copy(S1,nuldom); (* cannot be ! *)
            | 0 : coeff := coeff * k00; Str.Copy(S1,nulnul);
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        (* should we add some symbol if any of i or j is in zones 1234 and the other in 0 ??? *)
    END;
    kvalToStr(coeff,S); (* ## ! or ### ! *)
    (* useless to pad S1 here for all  strings are 2 chars long *)
    RETURN coeff;
END computeAspectCoeff;

(* ------------------------------------------------------------ *)

(* start, target, power *)

PROCEDURE getObjectFamilies (n : objet; VAR S : ARRAY OF CHAR);
BEGIN
    CASE n OF
    | soleil  : Str.Copy(S,"RrP");
    | mercure : Str.Copy(S,"Rt.");
    | venus   : Str.Copy(S,"Re.");
    | mars    : Str.Copy(S,"EeP");
    | jupiter : Str.Copy(S,"Er.");
    | saturne : Str.Copy(S,"Et.");
    | uranus  : Str.Copy(S,"Tr.");
    | neptune : Str.Copy(S,"Te.");
    | pluton  : Str.Copy(S,"TtP");
    | lune    : Str.Copy(S,"..p"); (* only moon has "p" ! *)
    ELSE ; (* //ISO fixed silly requirement *) END;
END getObjectFamilies;

PROCEDURE dmpFamilies (  );
TYPE
    RETinfo=(Rmajor,Emajor,Tmajor,
             rminor,eminor,tminor,
             Pmajor,pminor);
CONST
    RETinfoC="R,E,T,r,e,t,P,p";
    RETinfoS="Sociabilit naturelle,"+
             "Sens du concret,"+
             "Expression intuitive de l'inconscient,"+
             "Autorit manifeste,"+
             "Intensit des motions ressenties,"+
             "Esprit critique,"+
             "Sens du pouvoir quitable,"+
             "Maintien de l'harmonie personnelle";
    (*
    RETinfoS="Sociabilit,"+
             "Ralisme,"+
             "Intuition,"+
             "Autorit,"+
             "Sensorialit,"+
             "Esprit critique,"+
             "Pouvoir,"+
             "Harmonie";
    *)
CONST
    valZone1 = 3; (* alternate coeffs here ? *)
    valZone2 = 3;
    valZone3 = 2;
    valZone4 = 2;
    valZone0 = 1;
    valMulLune = 3;
    valNone    = 0;
VAR
    S,S1,S2 : str128;
    i,ndx   : CARDINAL;
    n,v     : INTEGER;
    R,E,T,r,e,t,P,p:INTEGER; (* can be less than 0 with substractions ! *)
BEGIN
    (* IF flagRET=FALSE THEN RETURN; END; (* avoid nonsense ! *) *)
    header("Pondration conditionaliste des familles R.E.T.");


    R := 0;
    E := 0;
    T := 0;
    r := 0;
    e := 0;
    t := 0;
    P := 0;
    p := 0;

    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];             (* do not care about enabled *)
        IF isPlanete( objet(ndx) ) THEN
            CASE flagAngularitiesHere OF
            | FALSE:
                v := valNone; (* substract nothing *)
            | TRUE :
                CASE ObjectInfo[ndx].RETzone OF
                | 1 : v:= valZone1;
                | 2 : v:= valZone2;
                | 3 : v:= valZone3;
                | 4 : v:= valZone4;
                | 0 : v:= valZone0;
                ELSE ; (* //ISO fixed silly requirement *) END;
            ELSE ; (* //ISO fixed silly requirement *) END;

            n := INTEGER(i) + 1;  (* remember hierarchy begins at 1, not 0 ! *)

            getObjectFamilies( objet(ndx),S);
            CASE S[0] OF
            | "R": INC(R,n); DEC(R,v);
            | "E": INC(E,n); DEC(E,v);
            | "T": INC(T,n); DEC(T,v);
            ELSE ; (* //ISO fixed silly requirement *) END;
            CASE S[1] OF
            | "r": INC(r,n); DEC(r,v);
            | "e": INC(e,n); DEC(e,v);
            | "t": INC(t,n); DEC(t,v);
            ELSE ; (* //ISO fixed silly requirement *) END;
            CASE S[2] OF
            | "P": INC(P,n); DEC(P,v);
            | "p": p:=n * valMulLune; DEC(p,v); (* only moon has "p" ! *)
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    FOR i := ORD(Rmajor) TO ORD(pminor) DO
        Str.ItemS(S1,RETinfoC,delim,ORD(i));
        Str.ItemS(S2,RETinfoS,delim,ORD(i));
        CASE RETinfo(i) OF
        | Rmajor: v:=R;
        | Emajor: v:=E;
        | Tmajor: v:=T;
        | rminor: v:=r;
        | eminor: v:=e;
        | tminor: v:=t;
        | Pmajor: v:=P;
        | pminor: v:=p;
        ELSE ; (* //ISO fixed silly requirement *) END;
        intvalToStr(v,S);
        (* S is padded, S1 is always a char, and S2 is the last to be dumped *)
        dmp3(wiFamilyCoeff,S,S1,S2);
    END;

END dmpFamilies;

(*
 F+     force d'excitation
 F-     force d'inhibition

 V+     vitesse d'excitation
 V-     vitesse d'inhibition
 L+     lenteur d'excitation
 L-     lenteur d'inhibition

 O      sens des contraires
 C      sens des combinaisons
 E      sens des ensembles

 f-     faiblesse d'inhibition
 f+     faiblesse d'excitation

 l-     inertie d'inhibition
 l+     inertie d'excitation
 v-     labilit d'inhibition
 v+     labilit d'excitation

 e      phase galitaire
 p      phase paradoxale
 u      phase ultraparadoxale
*)

PROCEDURE getSignFamilies (n : signtype; VAR S : ARRAY OF CHAR);
BEGIN
    CASE n OF
    | belier     : Str.Copy(S,"F+V+Of-l-e");
    | taureau    : Str.Copy(S,"F-V+Cf+l-p");
    | gemeaux    : Str.Copy(S,"F+V+Ef-l-u");
    | cancer     : Str.Copy(S,"F-L+Ef+v-u");
    | lion       : Str.Copy(S,"F+L+Cf-v-p");
    | vierge     : Str.Copy(S,"F-L+Of+v-e");
    | balance    : Str.Copy(S,"F+V-Of-l+e");
    | scorpion   : Str.Copy(S,"F-V-Cf+l+p");
    | sagittaire : Str.Copy(S,"F+V-Ef-l+u");
    | capricorne : Str.Copy(S,"F-L-Ef+v+u");
    | verseau    : Str.Copy(S,"F+L-Cf-v+p");
    | poissons   : Str.Copy(S,"F-L-Of+v+e");
    ELSE ; (* //ISO fixed silly requirement *) END;
END getSignFamilies;

PROCEDURE dmpx (v:INTEGER;S1,S2:ARRAY OF CHAR);
VAR
    S : str128;
BEGIN
    intvalToStr(v,S);
    (* S is padded, S1 is always two chars, and S2 is the last to be dumped *)
    dmp3(wiFamilyCoeff,S,S1,S2);
END dmpx;

PROCEDURE dmpRETsigns ();
CONST
    valEmptyAngle = 3;
    valNearAngle  = 4;
VAR
    i,ndx,currsign,n : CARDINAL;
    S,S1 : str128;
    ksign           : ARRAY [firstSign..lastSign] OF INTEGER; (* we may be < 0 ! *)
    inThisSign      : ARRAY [firstSign..lastSign] OF CARDINAL;
    signOfObject    : ARRAY [firstObject..lastObject] OF CARDINAL;
    v               : INTEGER;
    sas,smc,sds,sfc : CARDINAL;
VAR
    Fplus  ,Fminus ,Vplus  ,Vminus ,Lplus  ,Lminus : INTEGER;
    SO     ,SC     ,SE : INTEGER;
BEGIN
    headertwo("Pondration conditionaliste des signes",
              "(Attention ! Ici, la force est proportionnelle au coefficient !)");


    FOR i := firstSign TO lastSign DO
        ksign[i]      := 0;
        inThisSign[i] := 0;
    END;

    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i]; (* do not care about enabled *)
        CASE objet(ndx) OF                  (* alternate coeffs here ? *)
        | as                    : v:= 5;
        | mc                    : v:= 4;
        | soleil,lune           : v:= 4;
        | ds                    : v:= 3;
        | mercure,venus,mars    : v:= 3;
        | fc                    : v:= 2;
        | jupiter,saturne       : v:= 2;
        | uranus,neptune,pluton : v:= 1;
        ELSE
                                  v:= MAX(INTEGER);
        END;
        IF v # MAX(INTEGER) THEN
            AngleToPos(themenatal.planete[ndx].lambda,DDdd,S,currsign);

            INC( ksign[currsign] , v );

            n := i+1; (* remember hierarchy begins at 1, not 0 ! *)
            CASE n OF
            | 1..5  : INC( ksign[currsign] , 1 );
            | 6..10 : DEC( ksign[currsign] , 1 );
            ELSE ; (* //ISO fixed silly requirement *) END;

            signOfObject[ndx]:=currsign;
            IF isPlanete( objet(ndx) ) THEN INC(inThisSign[currsign]); END;
        END;
    END;

    FOR i := firstObject TO lastObject DO
        ndx := objectindex[i];
        IF isAngle( objet(ndx) ) THEN
            currsign := signOfObject[ndx];
            IF inThisSign[currsign] = 0 THEN DEC( ksign[currsign], valEmptyAngle); END;
            CASE objet(ndx) OF
            | as : sas := currsign;
            | mc : smc := currsign;
            | ds : sds := currsign;
            | fc : sfc := currsign;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;

    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];   (* do not care about enabled *)
        IF isPlanete( objet(ndx) ) THEN
            currsign := signOfObject[ndx];
            CASE ObjectInfo[ndx].RETzone OF
            | 1 : IF sas # currsign THEN INC( ksign[currsign], valNearAngle); END;
            | 2 : IF smc # currsign THEN INC( ksign[currsign], valNearAngle); END;
            | 3 : IF sds # currsign THEN INC( ksign[currsign], valNearAngle); END;
            | 4 : IF sfc # currsign THEN INC( ksign[currsign], valNearAngle); END;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;

    FOR i := firstSign TO lastSign DO
        intvalToStr(ksign[i],S);
        getSignName( signtype(i),S1);
        dmp2(wiSignCoeff,S,S1);
    END;

    nl;

    Fplus  := 0;
    Fminus := 0;
    Vplus  := 0;
    Vminus := 0;
    Lplus  := 0;
    Lminus := 0;
    SO     := 0;
    SC     := 0;
    SE     := 0;

    FOR i := firstSign TO lastSign DO
        v := ksign[i];
        getSignFamilies( signtype(i),S);
        CASE S[0] OF
        | "F" : CASE S[1] OF
                | "+" : INC(Fplus ,v);
                | "-" : INC(Fminus,v);
                ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        CASE S[2] OF
        | "V" : CASE S[3] OF
                | "+" : INC(Vplus ,v);
                | "-" : INC(Vminus,v);
                ELSE ; (* //ISO fixed silly requirement *) END;
        | "L" : CASE S[3] OF
                | "+" : INC(Lplus ,v);
                | "-" : INC(Lminus,v);
                ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        CASE S[4] OF
        | "O" : INC(SO,v);
        | "C" : INC(SC,v);
        | "E" : INC(SE,v);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    dmpx(Fplus ,"F+","Force d'excitation");
    dmpx(Fminus,"F-","Force d'inhibition");
    nl;
    dmpx(Vplus ,"V+","Vitesse d'excitation");
    dmpx(Vminus,"V-","Vitesse d'inhibition");
    dmpx(Lplus ,"L+","Lenteur d'excitation");
    dmpx(Lminus,"L-","Lenteur d'inhibition");
    nl;
    dmpx(SO    ,"SO","Sens des contraires");
    dmpx(SC    ,"SC","Sens des combinaisons");
    dmpx(SE    ,"SE","Sens des ensembles");


END dmpRETsigns;

(* adapted from dmpAnalysisRET, assume user defined hierarchy has been set ! *)

PROCEDURE dmpInRETzone (  );
CONST
    wiRank = 2;
    sZone = "Zone ";
VAR
    S,S1,S2 : str128;
    i,ndx,z : CARDINAL;
    last    : CARDINAL; (* for crlf between different zones *)
BEGIN
    (* IF flagRET=FALSE THEN RETURN; END; (* avoid nonsense ! *) *)
    header("Hirarchie conditionaliste utilise dans l'analyse");
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    last:=MAX(CARDINAL);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];    (* do not care about enabled *)
        IF isPlanete( objet(ndx) ) THEN
            getObjectName( objet(ndx) ,S1);
            z:=ObjectInfo[ndx].RETzone;
            CASE z OF
            | 1 : S:="1"; getObjectName(as,S2);
            | 2 : S:="2"; getObjectName(mc,S2);
            | 3 : S:="3"; getObjectName(ds,S2);
            | 4 : S:="4"; getObjectName(fc,S2);
            | 0 : S:="0"; S2 := "";
            ELSE ; (* //ISO fixed silly requirement *) END;
            Str.Prepend(S,sZone);
            IF z = 0 THEN
                Str.Copy(S2,S);
            ELSE
                Str.Append(S," (");
                Str.Prepend(S2,S);
                Str.Append(S2,")");
            END;
            pad(wiCorps,S1);
            valToStr(i+1,S);   (* remember hierarchy begins at 1, not 0 ! *)
            IF last = MAX(CARDINAL) THEN
                last := z;
            ELSIF last # z THEN
                nl;
                last := z;
            END;
            dmp3(wiRank,S,S1,S2);
        END;
    END;
END dmpInRETzone;

(* adapted from CARTE.MOD, itself adapted from RAPPORT.MOD *)

PROCEDURE findAnalysisRET (  ); (* conditionalist angularities *)
(*
CONST
    twothird = 2.0 / 3.0;
    half     = 0.5;
*)
VAR
    i,j,ndx : CARDINAL;
    currangle:objet;
    pos:LONGREAL;
    ki,ks:LONGREAL;
    mi,mm,ms:cuspide;
    pi,pm,ps:LONGREAL;
BEGIN
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        FOR j := firstObject TO lastObject DO
            ndx:=objectindex[j];
            IF ObjectInfo[ndx].RETzone = MAX(CARDINAL) THEN
                ObjectInfo[ndx].RETzone := 0; (* force nada zone if it was not user defined *)
            END;
        END;
        RETURN;
    END;

    FOR i := 1 TO 4 DO
        CASE i OF
        | 1 :
            currangle := as;
            ki:= k1_xii; (* twothird *)
            ks:= k1_i;   (* half *)
            mi:= m12;
            mm:= mAS;
            ms:= m2;
        | 2 :
            currangle := mc;
            ki:= k2_ix;  (* twothird *)
            ks:= k2_x;   (* twothird *)
            mi:= m9;
            mm:= mMC;
            ms:= m11;
        | 3 :
            currangle := ds;
            ki:= k3_vi;  (* half *)
            ks:= k3_vii; (* twothird *)
            mi:= m6;
            mm:= mDS;
            ms:= m8;
        | 4 :
            currangle := fc;
            ki:= k4_iii; (* half *)
            ks:= k4_iv;  (* half *)
            mi:= m3;
            mm:= mFC;
            ms:= m5;
        ELSE ; (* //ISO fixed silly requirement *) END;
        pi:=themenatal.maisonData[ORD(placidus)][ ORD(mi) ];
        pm:=themenatal.maisonData[ORD(placidus)][ ORD(mm) ];
        ps:=themenatal.maisonData[ORD(placidus)][ ORD(ms) ];

        FOR j := firstObject TO lastObject DO
            ndx:=objectindex[j];   (* do not care about enabled *)
            IF isPlanete( objet(ndx) ) THEN
                pos:=themenatal.planete[ ndx ].lambda;
                IF inZone(pos,pi,pm,ps,ki,ks) THEN
                    IF ObjectInfo[ndx].RETzone = MAX(CARDINAL) THEN
                        ObjectInfo[ndx].RETzone:=i; (* user did not bother to define zone *)
                    END;
                END;
            END;
        END;
    END;
    (* now set remaing zone 0 bodies *)
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];   (* do not care about enabled *)
        IF isPlanete( objet(ndx) ) THEN
            IF ObjectInfo[ndx].RETzone = MAX(CARDINAL) THEN
                ObjectInfo[ndx].RETzone:=0; (* user did not bother to define zone *)
            END;
        END;
    END;

END findAnalysisRET;

PROCEDURE chkAngularitiesHere (  ) : BOOLEAN;
VAR
    j,ndx,sum : CARDINAL;
BEGIN
    sum := 0;
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];   (* do not care about enabled *)
        IF isPlanete( objet(ndx) ) THEN
            IF ObjectInfo[ndx].RETzone # 0 THEN INC(sum); END;
        END;
    END;
    RETURN (sum # 0);
END chkAngularitiesHere;

(* ------------------------------------------------------------ *)

TYPE
    forcedentrytype = RECORD
        planetndx : CARDINAL; (* ORD(objet) *)
        zone      : CARDINAL;
    END;
CONST
    firstHierarchy = 1; (* must be 1 *)
    lastHierarchy  = firstHierarchy-1+ORD(pluton)-ORD(soleil)+1; (* complicated way to say 10 ! *)
VAR
    forcedentry  : ARRAY [firstHierarchy..lastHierarchy] OF forcedentrytype;
    hierarchyndx : CARDINAL;

PROCEDURE inithierarchy ();
VAR
    i : CARDINAL;
BEGIN
    hierarchyndx := firstHierarchy;
END inithierarchy;

(*
    assume S is passed in uppercase

    L S M V J MA SA U N P    --    1=AS, 2=MC, 3=DS, 4=FC, 0=aucune

    later, add a "nothing" char to MatchFormat : it IS useful !

    very, very, very Q&D function !
*)

(* older version

PROCEDURE addToHierarchy (S:ARRAY OF CHAR) : CARDINAL;
CONST
    sMars     = "MA";
    sSaturne  = "SA";
    sOthers   = "[LSMVJUNP]";
    sZones    = "[12340]";
    cMars     = "m";
    cSaturne  = "s";
VAR
    i : CARDINAL;
    p : objet;
    z : CARDINAL;
BEGIN
    IF    ( MatchFormat(sMars   ,S) OR MatchFormat(sMars+sZones   ,S) ) THEN
        Str.Subst(S,sMars,cMars);
    ELSIF ( MatchFormat(sSaturne,S) OR MatchFormat(sSaturne+sZones,S) ) THEN
        Str.Subst(S,sSaturne,cSaturne);
    ELSIF ( MatchFormat(sOthers ,S) OR MatchFormat(sOthers+sZones ,S) ) THEN
        (* nada for now *)
    ELSE
        RETURN errBadPlanetZone;
    END;

    CASE S[0] OF
    | "L"      : p := lune;
    | "S"      : p := soleil;
    | "M"      : p := mercure;
    | "V"      : p := venus;
    | cMars    : p := mars;
    | "J"      : p := jupiter;
    | cSaturne : p := saturne;
    | "U"      : p := uranus;
    | "N"      : p := neptune;
    | "P"      : p := pluton;
    END;
    CASE S[1] OF
    | "1" : z := 1;
    | "2" : z := 2;
    | "3" : z := 3;
    | "4" : z := 4;
    | "0" : z := 0;
    ELSE
            z:= MAX(CARDINAL); (* let program use computed zone *)
    END;
    FOR i := firstHierarchy TO (hierarchyndx-1) DO
        IF objet(forcedentry[i].planetndx) = p THEN RETURN errRedefined; END;
    END;
    forcedentry[hierarchyndx].planetndx := ORD(p);
    forcedentry[hierarchyndx].zone      := z;
    INC(hierarchyndx);
    RETURN errNone;
END addToHierarchy;

*)

PROCEDURE addToHierarchy (S:ARRAY OF CHAR) : CARDINAL;
CONST
    sDigits = "0123456789";
VAR
    i : CARDINAL;
    p : objet;
    z : CARDINAL;
    planetstr,zonestr : str80;
    ch :CHAR;
    len:CARDINAL;
    ok :BOOLEAN;
BEGIN
    len:=Str.Length(S);
    i := 1;
    LOOP
        IF i > len THEN (* end of S, which does not contain any digit *)
            Str.Copy(planetstr,S);
            zonestr:="";
            EXIT;
        END;
        ch:=S[i-1];
        IF Str.CharPos(sDigits,ch) # MAX(CARDINAL) THEN
            Str.Slice(planetstr,S,0,i-1);
            Str.Slice(zonestr,S,i-1,len-i+1);
            EXIT;
        END;
        INC(i);
    END;
    i := getStrIndex(coma,planetstr, "L,LU,LUN,LUNE,"+
                                     "S,SO,SOL,SOLEIL,"+
                                     "M,ME,MER,MERCURE,"+
                                     "V,VE,VEN,VENUS,"+
                                       "MA,MAR,MARS,"+
                                     "J,JU,JUP,JUPITER,"+
                                       "SA,SAT,SATURNE,"+
                                     "U,UR,URA,URANUS,"+
                                     "N,NE,NEP,NEPTUNE,"+
                                     "P,PL,PLU,PLUTON"
                                     );
    CASE i OF
    |  1, 2, 3, 4 : p := lune;
    |  5, 6, 7, 8 : p := soleil;
    |  9,10,11,12 : p := mercure;
    | 13,14,15,16 : p := venus;
    |    17,18,19 : p := mars;
    | 20,21,22,23 : p := jupiter;
    |    24,25,26 : p := saturne;
    | 27,28,29,30 : p := uranus;
    | 31,32,33,34 : p := neptune;
    | 35,36,37,38 : p := pluton;
    ELSE
        RETURN errBadPlanetZone;
    END;
    IF same(zonestr,"") THEN
        z:= MAX(CARDINAL); (* let program use computed zone *)
    ELSE
        i := CARDINAL(Str.StrToCard(zonestr,10,ok));
        IF ok = FALSE THEN RETURN errBadPlanetZone; END;
        CASE i OF
        | 1 : z := 1;
        | 2 : z := 2;
        | 3 : z := 3;
        | 4 : z := 4;
        | 0 : z := 0;
        ELSE
            RETURN errBadPlanetZone;
        END;
    END;
    FOR i := firstHierarchy TO (hierarchyndx-1) DO
        IF objet(forcedentry[i].planetndx) = p THEN RETURN errRedefined; END;
    END;
    forcedentry[hierarchyndx].planetndx := ORD(p);
    forcedentry[hierarchyndx].zone      := z;
    INC(hierarchyndx);
    RETURN errNone;
END addToHierarchy;

(*
   do NOT assume the first 10 are soleil..pluton !
   reindex so that planets are the 10 first,
   and everything else in original reordered order
   set user-defined zones too
*)

PROCEDURE initHierarchyAndZonesIndexes ();
VAR
    tmpindex : ARRAY [firstObject..lastObject] OF CARDINAL; (* ORD(soleil)..ORD(blacksun) *)
    i,j,ndx  : CARDINAL;
BEGIN
    (* assign the first 10 positions to planets in hierarchical order *)

    j := firstObject;
    FOR i := firstHierarchy TO lastHierarchy DO
        ndx         := forcedentry[i].planetndx;
        tmpindex[j] := ndx;
        ObjectInfo[ndx].RETzone := forcedentry[i].zone;
        INC(j);
    END;

    (* now assign remaining positions to bodies others than soleil..pluton in their original order *)
    FOR i := firstObject TO lastObject DO
        ndx := objectindex[i];
        IF isPlanete( objet(ndx) )=FALSE THEN
            tmpindex[j] := ndx;
            INC(j);
        END;
    END;
    (* copy new resulting indexes array *)
    FOR i := firstObject TO lastObject DO
        objectindex[i] := tmpindex[i];
    END;

    (* now assign not user defined zones with program defined *)
    findAnalysisRET();

    (* now, at last, set flag to reflect any angularities user or computer defined *)
    flagAngularitiesHere := chkAngularitiesHere();

END initHierarchyAndZonesIndexes;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* reverse priority order for our search *)

PROCEDURE infosep (S:ARRAY OF CHAR) : CHAR;
BEGIN
    IF    CharCount(S,antislash) = 4 THEN RETURN antislash;
    ELSIF CharCount(S,dollar) = 4 THEN RETURN dollar;
    ELSIF CharCount(S,slash)=4 THEN RETURN slash;
    ELSIF CharCount(S,underbar)=4 THEN RETURN underbar;
    ELSIF CharCount(S,semicolon)=4 THEN RETURN semicolon;
    ELSIF CharCount(S,coma) = 4 THEN RETURN coma;
    ELSE RETURN "?";
    END;
END infosep;

PROCEDURE infostr (n:CARDINAL;sep:CHAR;VAR R : ARRAY OF CHAR);
BEGIN
    isoleItemS(R,themenatal.orenseignements,sep,n);
    LtrimBlanks(R);
    RtrimBlanks(R);
    IF Str.Length(R)=0 THEN Str.Copy(R,"?"); END;
END infostr;

PROCEDURE genrestring (VAR S : ARRAY OF CHAR);
VAR
    R : str128;
    i : CARDINAL;
BEGIN
    Str.Copy(R,S);
    UpperCase(R);
    i:=getStrIndex(delim,R,
                   "H"+delim+"M"+delim+"+"+delim+"HOMME"+delim+"MAN"+delim+"MASCULIN"+delim+
                   "F"+delim+"W"+delim+"-"+delim+"FEMME"+delim+"WOMAN"+delim+"FEMININ"+delim+
                   "N"+delim+"?"+delim+"NEUTRE"+delim+"NEUTRAL");
    CASE i OF
    | 1..6 :   Str.Copy(S,"Masculin");
    | 7..12 :  Str.Copy(S,"Fminin");
    | 13..16 : Str.Copy(S,"Indtermin");
    ELSE
               (* ignore *)
    END;
END genrestring;

(* thoriquement une sortie genre dmpTTX avec marge de wiInfo ou tab au cas o la ligne serait longue *)

PROCEDURE dmprenseignements ();
VAR
    ch:CHAR;
    S : str256; (* required for remarque *)
    information : (ville,pays,nom,genre,remarque);

    ok:BOOLEAN;
    linewidth:CARDINAL;
    S1,S2:str256;
BEGIN
    ch:=infosep(themenatal.orenseignements);
    infostr(ORD(ville),ch,S);
    dmp2(wiInfo,"Ville",S);
    infostr(ORD(pays),ch,S);
    dmp2(wiInfo,"Pays",S);
    infostr(ORD(nom),ch,S);
    dmp2(wiInfo,"Nom",S);
    infostr(ORD(genre),ch,S);
    genrestring(S);
    dmp2(wiInfo,"Genre",S);
    infostr(ORD(remarque),ch,S);

    IF ((flagUseTabs=TRUE) OR (LineWidth=0)) THEN
        dmp2(wiInfo,"Remarque",S); (* leave room for a very big string ! *)
    ELSE
        IF LineWidth < wiInfo THEN
            linewidth:=LineWidth; (* not the best choice but... *)
        ELSE
            linewidth:=LineWidth-wiInfo;
        END;
        S1:="";
        ok:=dmpTTX(S,linewidth,S2,TRUE);
        IF ok THEN
            dmp2(wiInfo,"Remarque",S2);
            LOOP
                ok:=dmpTTX(S,linewidth,S2,FALSE);
                IF ok=FALSE THEN EXIT; END;
                dmp2(wiInfo,S1,S2);
            END;
        END;
    END;
END dmprenseignements;

PROCEDURE dmpData (  );
VAR
    ok,flag:BOOLEAN;
    d,m,y,hh,mm:CARDINAL;
    S:str128;
    S1,S2,S3:str128;
BEGIN
    header("Coordonnes de naissance");

    flag:=(themenatal.typeof=unsafenatal);

    ok:=parseDate(flag,themenatal.odate,d,m,y); (* // no longer assume unsafe *)
    DateToStr(d,m,y,S);
    dmp2(wiInfo,"Date",S);

    ok:=parseTime(themenatal.otime,hh,mm);
    TimeToStr(hh,mm,S);
    dmp2(wiInfo,"Heure",S);

    fmtLatitude(themenatal.latitude,S1,S2);
    LtrimBlanks(S2);
    Str.Prepend(S2,"(");
    Str.Append(S2,")");
    dmp3(wiInfo,"Latitude",S1,S2);

    fmtLongitude(themenatal.longitude,S1,S2,S3);
    LtrimBlanks(S2);
    LtrimBlanks(S3);
    Str.Prepend(S2,"(");
    Str.Append(S2," ou ");
    Str.Append(S2,S3);
    Str.Append(S2,")");
    dmp3(wiInfo,"Longitude",S1,S2);

    fmtDeltaTU(themenatal.odeltaTU,S);
    dmp2(wiInfo,"Correction pour le T.U.",S);
    nl;
    dmprenseignements;
    nl;
    AngleToStr(themenatal.tsl,HHMMSS,S);
    dmp2(wiInfo,"Temps sidral local",S);

    Str.FixRealToStr(themenatal.jd,5,S,ok);
    Str.Subst(S,dot,thePadComa);
    dmp2(wiInfo,"Jour julien",S);
    nl;
    Str.Copy(S,methodname);
    LowerCase(S);
    S[0]:=CAP(S[0]); (* ugly, ugly, ugly ! *)
    dmp2(wiInfo,"Mthode",S);
    Str.Copy(S,rscfile);
    LowerCase(S);
    dmp2(wiInfo,"Fichier",S);
    Str.Copy(S,textes);
    LowerCase(S);
    dmp2(wiInfo,"Textes",S);
END dmpData;

(* ------------------------------------------------------------ *)

PROCEDURE fmtPos (v:LONGREAL;VAR S1,S2:ARRAY OF CHAR);
VAR
    i : CARDINAL;
BEGIN
    CASE flagDecimal OF
    | TRUE :  AngleToPos(v,DDdd,S1,i);
    | FALSE : AngleToPos(v,DDMM,S1,i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    getSignName(signtype(i),S2);
END fmtPos;

PROCEDURE fmtPosDomitude (v:LONGREAL;VAR S1,S2:ARRAY OF CHAR);
VAR
    i : CARDINAL;
BEGIN
    CASE flagDecimal OF
    | TRUE :  AngleToPos(v,DDdd,S1,i);
    | FALSE : AngleToPos(v,DDMM,S1,i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    getRomanStr(i+1,S2); (* remember 0 means maison I, 11 means XII *)
END fmtPosDomitude;

(* ------------------------------------------------------------ *)

PROCEDURE matchObjectToHouse (id:domificationtype);
VAR
    cusp : ARRAY [firstCusp..lastCusp] OF LONGREAL;
    v : LONGREAL;
    i : CARDINAL;
    ndx : CARDINAL;
    inhouse,cuspSup,cuspInf,lastCuspHere:CARDINAL;
    BorneInf,BorneSup:LONGREAL;
BEGIN
    lastCuspHere := getLastCusp(id);
    FOR i := firstCusp TO lastCusp DO
        v:= themenatal.maisonData[ORD(id)][i];
        cusp[i]:=v;
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        ObjectInfo[ndx].sector:=0; (* useless but... *)
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF ( (isAngle( objet(ndx) )=FALSE) OR (angleIsCusp(id)=FALSE) ) THEN
                v:=themenatal.planete[ndx].lambda;
                inhouse:=1;
                cuspSup := firstCusp;
                LOOP
                    cuspInf:=cuspSup;
                    INC(cuspSup);
                    IF cuspSup > lastCuspHere THEN cuspSup := firstCusp; END;
                    IF clockwiseDom(id) THEN (* reverse positions to fake normal anticlockwise progression *)
                        BorneSup:=cusp[cuspInf];
                        BorneInf:=cusp[cuspSup];
                    ELSE
                        BorneInf:=cusp[cuspInf];
                        BorneSup:=cusp[cuspSup];
                    END;
                    IF between(BorneInf,v,BorneSup) THEN
                        ObjectInfo[ndx].sector:=inhouse;
                        EXIT;
                    END;
                    INC(inhouse);
                    IF inhouse > (lastCuspHere+1) THEN (* > 12 should never happen ! *)
                        inhouse:=0;
                        EXIT;
                    END;
                END;
            END;
        END;
    END;
END matchObjectToHouse;

(* ------------------------------------------------------------ *)

TYPE
    posentry = RECORD
                   lambda : LONGREAL;
                   index  : CARDINAL;
                   cusp   : BOOLEAN;
               END;
CONST
    first = 1; (* must be from 1 for QSort *)
    max  = first+ORD(blacksun)+ORD(m12)+2; (* safety *)
VAR
    pos : ARRAY [first..max] OF posentry; (* no risk ! objects+cuspides *)

PROCEDURE isLess (i,j:CARDINAL) : BOOLEAN;
BEGIN
    IF pos[i].lambda < pos[j].lambda THEN RETURN TRUE; END;
    RETURN FALSE;
END isLess;

PROCEDURE isLessNOT (i,j:CARDINAL) : BOOLEAN;
BEGIN
    RETURN NOT(isLess(i,j));
END isLessNOT;

PROCEDURE doSwap (i,j:CARDINAL);
VAR
    tmp : posentry;
BEGIN
    tmp := pos[i];
    pos[i]:=pos[j];
    pos[j]:=tmp;
END doSwap;

PROCEDURE dmpSynthesis (id:domificationtype);
VAR
    i : CARDINAL;
    ndx : CARDINAL;
    S,S1,S2,S3,S4,S5 : str128;
    actual : domificationtype;
    v : LONGREAL;
    last : CARDINAL;
    tmp:posentry;
BEGIN
    IF id = notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    getDomificationStr(id,S);
    Str.Append(S,")");
    Str.Prepend(S,"Tableau rcapitulatif (domification ");
    header(S);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    matchObjectToHouse(id);
    (* add objects to tmp array *)
    last := first;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF isAngle( objet(ndx) )=FALSE THEN (* here, we ignore AS MC DS FC *)
            pos[last].lambda:=themenatal.planete[ndx].lambda;
            pos[last].index :=ndx;   (* we keep direct index to objet here *)
            pos[last].cusp  :=FALSE;
            INC(last);
        END;
    END;
    (* now add cuspides *)
    FOR i := firstCusp TO getLastCusp(id) DO
        v:= themenatal.maisonData[ORD(id)][i];
        pos[last].lambda:=v;
        pos[last].index :=i;
        pos[last].cusp  :=TRUE;
        INC(last);
    END;
    (* now add AS MC DS FC if ptolemeus or nonsensical *)
    IF angleIsCusp(id)=FALSE THEN
        FOR i := firstObject TO lastObject DO
            ndx:=objectindex[i];
            IF isAngle( objet(ndx) ) THEN (* here, we keep only AS MC DS FC *)
                pos[last].lambda:=themenatal.planete[ndx].lambda;
                pos[last].index :=ndx;   (* we keep direct index to objet here *)
                pos[last].cusp  :=FALSE;
                INC(last);
            END;
        END;
    END;

    DEC(last); (* we were at last+1 ! *)
    IF clockwiseDom(id) THEN
        Lib.QSort(last,isLessNOT,doSwap);
    ELSE
        Lib.QSort(last,isLess,doSwap);
    END;

    (* now move positions so that AS is the first in listing *)
    LOOP
        IF (pos[first].cusp=TRUE) AND (pos[first].index=firstCusp) THEN EXIT; END;
        tmp:=pos[first];
        FOR i := first TO (last-1) DO
            pos[i]:=pos[i+1];
        END;
        pos[last]:=tmp;
    END;
    FOR i := first TO last DO
        ndx := pos[i].index;
        CASE pos[i].cusp OF
        | FALSE :
            IF ObjectInfo[ndx].enabled THEN
                getObjectName( objet(ndx) ,S);
                Str.Prepend(S,interval);
                fmtPos( pos[i].lambda,S1,S2);
                pad(wiSigne,S2);
                getRomanStr(ObjectInfo[ndx].sector,S3); (* direct index *)
                IF isPlanete ( objet(ndx) ) THEN
                    pad(wiRoman,S3);
                    IF themenatal.domificationFlag[ORD(placidus)] = placidus THEN
                        getRomanStr(themenatal.planete[ndx].truehouse,S4); (* direct index *)
                        LowerCase(S4);
                    ELSE
                        S4:="";
                    END;
                    pad(wiRoman,S4);
                    getMotionAbrev(themenatal.planete[ndx].motion,S5); (* direct index *)
                    dmp6(wiObjetLong,S,S1,S2,S3,S4,S5);
                ELSE
                    dmp4(wiObjetLong,S,S1,S2,S3); (* ignore motion and true house *)
                END;
            END;
        | TRUE :
            IF angleIsCusp(id) THEN
                getSectorName(cuspide(ndx),S);
            ELSE
                getSectorNameAlt(cuspide(ndx),S);
            END;
            fmtPos( pos[i].lambda,S1,S2);
            dmp3(wiObjetLong,S,S1,S2);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
END dmpSynthesis;

(* ------------------------------------------------------------ *)

PROCEDURE dmpInSign (  );
VAR
    i,ndx : CARDINAL;
    v,v2:LONGREAL;
    S,S1,S2:str128;
BEGIN
    header("Position et signe de chaque objet");
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            getObjectName(objet(ndx),S);
            v:=themenatal.planete[ndx].lambda;
            fmtPos(v,S1,S2);
            dmp3(wiObjet,S,S1,S2);
        END;
    END;
END dmpInSign;

(* ------------------------------------------------------------ *)

PROCEDURE dmpInHouse (id:domificationtype);
VAR
    actual:domificationtype;
    S,S1 : str128;
    i,ndx,num:CARDINAL;
BEGIN
    IF id =notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    getDomificationStr(id,S);
    Str.Append(S,")");
    Str.Prepend(S,"Secteur de chaque objet (domification ");
    header(S);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    matchObjectToHouse(id);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isAngle( objet(ndx) )=FALSE THEN
                getObjectName(objet(ndx),S);
                num:=ObjectInfo[ndx].sector;
                getRomanStr(num,S1);
                dmp2(wiObjet,S,S1);
            END;
        END;
    END;
END dmpInHouse;

(* ------------------------------------------------------------ *)

PROCEDURE dmpInTrueHouse (  );
VAR
    i,ndx : CARDINAL;
    truehouse : CARDINAL;
    S,S1,S2,S3:str128;
    pos : LONGREAL;
BEGIN
    header("Vraie maison et domitude de chaque corps");
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                truehouse:=themenatal.planete[ndx].truehouse;
                getRomanStr(truehouse,S1);
                LowerCase(S1);
                pad(wiRoman,S1);
                pos := themenatal.planete[ndx].domitude;
                fmtPosDomitude(pos,S2,S3);
                dmp4(wiCorps,S,S1,S2,S3);
            END;
        END;
    END;
END dmpInTrueHouse;

(* ------------------------------------------------------------ *)

PROCEDURE dmpMotion (  );
VAR
    i,ndx : CARDINAL;
    mv : sens;
    S,S1:str128;
BEGIN
    header("Mouvement de chaque corps");
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                mv:=themenatal.planete[ndx].motion;
                getMotionStr(mv,S1);
                dmp2(wiCorps,S,S1);
            END;
        END;
    END;
END dmpMotion;

(* ------------------------------------------------------------ *)

PROCEDURE headerDom (id:domificationtype);
VAR
    S : str128;
BEGIN
    getDomificationStr(id,S);
    Str.Append(S,")");
    Str.Prepend(S,"Position et signe de chaque cuspide (domification ");
    header(S);
END headerDom;

PROCEDURE dmpDom (id:domificationtype);
VAR
    i: CARDINAL;
    S,S1,S2 : str128;
    v : LONGREAL;
    actual : domificationtype;
BEGIN
    IF id = notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    headerDom(id);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    FOR i := firstCusp TO getLastCusp( id ) DO
        IF angleIsCusp(id) THEN
            getCuspideName(cuspide(i),S);
        ELSE
            getCuspideNameAlt(cuspide(i),S);
        END;
        v:= themenatal.maisonData[ORD(id)][i];
        fmtPos(v,S1,S2);
        dmp3(wiObjet,S,S1,S2);
    END;
END dmpDom;

(* ------------------------------------------------------------ *)

PROCEDURE smallerNonZero(ndx1,ndx2,ndxaspect:CARDINAL):BOOLEAN;
VAR
    minorbe : CARDINAL;
BEGIN
IF flagUseAltOrbesNatal THEN
    minorbe:=smaller( ObjectInfo[ndx1].altorbenatal[ndxaspect], ObjectInfo[ndx2].altorbenatal[ndxaspect] );
	RETURN (minorbe # 0); (* any orbe=0 means ignore aspect *)
ELSE
    RETURN TRUE; (* always, here *)
END;
END smallerNonZero;

PROCEDURE getOrbe (group1,group2,ndxaspect, ndx1,ndx2:CARDINAL  ):CARDINAL;
VAR
    groupclass : grouptype;
    orbe: CARDINAL;
    i:INTEGER;
BEGIN
IF flagUseAltOrbesNatal THEN
    orbe:=greater( ObjectInfo[ndx1].altorbenatal[ndxaspect], ObjectInfo[ndx2].altorbenatal[ndxaspect] );
ELSE
    groupclass:=getGroupClass(group1,group2);
    CASE groupclass OF
    | group11 : orbe:=AspectInfo[ndxaspect].orbe11;
    | group22 : orbe:=AspectInfo[ndxaspect].orbe22;
    | group33 : orbe:=AspectInfo[ndxaspect].orbe33;
    | group12 : orbe:=AspectInfo[ndxaspect].orbe12;
    | group13 : orbe:=AspectInfo[ndxaspect].orbe13;
    | group23 : orbe:=AspectInfo[ndxaspect].orbe23;
    ELSE ; (* //ISO fixed silly requirement *) END;
END;
    IF orbePlus # 0 THEN
        i:=INTEGER(orbe)+orbePlus;
        IF i < minorbeplus THEN i:= minorbeplus; END;
        orbe := CARDINAL(i);
    END;
    RETURN orbe;
END getOrbe;

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByAspect (useFictifs:BOOLEAN);
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;

    K,Ksymbol : str128;
    val : CARDINAL;
BEGIN
    CASE useFictifs OF
    | FALSE :
        header("Aspects de chaque corps avec les autres corps");
        wide:=wiCorps;
    | TRUE  :
        header("Aspects de chaque objet avec les angles et plantes fictives");
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR i := firstObject TO (lastObject-1) DO
        ndx1     := objectindex[i];
        enabled1 := ObjectInfo[ndx1].enabled;
        real1    := isPlanete ( objet(ndx1) );
        lambda1  := themenatal.planete[ndx1].lambda;
        group1   := ObjectInfo[ndx1].group;
        getObjectName( objet(ndx1) ,P1);

        FOR j := (i+1) TO lastObject DO
            ndx2     := objectindex[j];
            enabled2 := ObjectInfo[ndx2].enabled;
            real2    := isPlanete ( objet(ndx2) );
            lambda2  := themenatal.planete[ndx2].lambda;
            group2   := ObjectInfo[ndx2].group;
            getObjectName( objet(ndx2) ,P2);
            pad(wide,P2); (* real body or longer unreal body such as MC *)

            CASE useFictifs OF
            | FALSE : ok := ((real1) AND (real2))  ;
            | TRUE :  ok := (real2=FALSE); (* ((real1) AND (real2=FALSE)); *)
                IF flagAvoidAxisOrUseless THEN
                      ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;

            FOR k := firstAspect TO lastAspect DO
                ndxaspect:=aspectindex[k];
                enabledaspect:=AspectInfo[ndxaspect].enabled;
                ecartaspect:=AspectInfo[ndxaspect].ecart;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff) THEN
                            getAspectName( aspecttype(ndxaspect),S);
                            pad(wiAspect,S);
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=i;
                            ELSIF last # i THEN
                                nl;
                                last:=i;
                            END;
                            CASE useFictifs OF
                            | TRUE : dmp4(wide,P1,P2,S,S1);
                            | FALSE: pad(wide,P1);
                                     val := computeAspectCoeff(i,j,K,Ksymbol); (* is filtered for real and real *)
                                     dmp6(wiAspectCoeff,K,Ksymbol,P1,P2,S,S1);
                            ELSE ; (* //ISO fixed silly requirement *) END;
                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByAspect;

(* ------------------------------------------------------------ *)

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByObject (useFictifs:BOOLEAN);
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;

    K,Ksymbol : str128;
    val:CARDINAL;
BEGIN
    CASE useFictifs OF
    | FALSE :
        header("Aspects de chaque corps avec les autres corps");
        wide:=wiCorps;
    | TRUE :
        header("Aspects de chaque objet avec les angles et plantes fictives");
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR k := firstAspect TO lastAspect DO
        ndxaspect:=aspectindex[k];
        enabledaspect:=AspectInfo[ndxaspect].enabled;
        ecartaspect:=AspectInfo[ndxaspect].ecart;
        getAspectName( aspecttype(ndxaspect),S);

        FOR i := firstObject TO (lastObject-1) DO
            ndx1     := objectindex[i];
            enabled1 := ObjectInfo[ndx1].enabled;
            real1    := isPlanete ( objet(ndx1) );
            lambda1  := themenatal.planete[ndx1].lambda;
            group1   := ObjectInfo[ndx1].group;
            getObjectName( objet(ndx1) ,P1);
            pad(wide,P1);

            FOR j := (i+1) TO lastObject DO
                ndx2     := objectindex[j];
                enabled2 := ObjectInfo[ndx2].enabled;
                real2    := isPlanete ( objet(ndx2) );
                lambda2  := themenatal.planete[ndx2].lambda;
                group2   := ObjectInfo[ndx2].group;
                getObjectName( objet(ndx2) ,P2);
                pad(wide,P2); (* can be real body or long unreal thing such as MC *)

                CASE useFictifs OF
                | FALSE : ok:= ((real1) AND (real2));
                | TRUE :  ok:= (real2=FALSE); (* ((real1) AND (real2=FALSE)); *)
                    IF flagAvoidAxisOrUseless THEN
                          ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff) THEN
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=k;
                            ELSIF last # k THEN
                                nl;
                                last:=k;
                            END;
                            CASE useFictifs OF
                            | TRUE : dmp4(wiAspect,S,P1,P2,S1);
                            | FALSE: pad(wiAspect,S);
                                     val := computeAspectCoeff(i,j,K,Ksymbol); (* is filtered for real and real *)
                                     dmp6(wiAspectCoeff,K,Ksymbol,S,P1,P2,S1);
                            ELSE ; (* //ISO fixed silly requirement *) END;
                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByObject;

(* ------------------------------------------------------------ *)

PROCEDURE fmtLongLat (long,lat:LONGREAL;
                      VAR longS,latS:ARRAY OF CHAR);
BEGIN
    CASE flagDecimal OF
    | TRUE :
        AngleToStr(long,DDDdd,longS);
        AngleToStr(lat ,latDDdd,latS);
    | FALSE :
        AngleToStr(long,DDDMM,longS);
        AngleToStr(lat ,latDDMM,latS);
    ELSE ; (* //ISO fixed silly requirement *) END;
END fmtLongLat;

(* ------------------------------------------------------------ *)

PROCEDURE dmpGeocentric ();
VAR
    i,ndx : CARDINAL;
    v1,v2:LONGREAL;
    S,S1,S2:str128;
    Z,Z1:str256;
BEGIN
    Z:="Coordonnes gocentriques";
    Str.Concat(Z1,"(",sLambda);
    Str.Append(Z1," et ");
    Str.Append(Z1,sBeta);
    Str.Append(Z1," -- longitude et latitude)");
    (* headertwo("Coordonnes gocentriques","("+sLambda+" et "+sBeta+" -- longitude et latitude)"); *)
    headertwo(Z,Z1);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                v1:=themenatal.planete[ndx].lambda;
                v2:=themenatal.planete[ndx].beta;
                fmtLongLat(v1,v2,S1,S2);
                dmp3(wiCorps,S,S1,S2);
            END;
        END;
    END;
END dmpGeocentric;

(* ------------------------------------------------------------ *)

PROCEDURE dmpEquatorial (  );
VAR
    i,ndx : CARDINAL;
    v1,v2:LONGREAL;
    S,S1,S2:str128;
    Z,Z1:str256;
BEGIN
    Z:="Coordonnes quatoriales";
    Str.Concat(Z1,"(",sAlpha);
    Str.Append(Z1," et ");
    Str.Append(Z1,sDelta);
    Str.Append(Z1," -- ascension droite et dclinaison)");
    (* headertwo("Coordonnes quatoriales","("+sAlpha+" et "+sDelta+" -- ascension droite et dclinaison)"); *)
    headertwo(Z,Z1);
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                v1:=themenatal.planete[ndx].alpha;
                v2:=themenatal.planete[ndx].delta;
                AngleToStr(v1,HHMMSS,S1); (* always hms and ' for equatorial coors *)
                AngleToStr(v2,latDDMM,S2);
                dmp3(wiCorps,S,S1,S2);
            END;
        END;
    END;
END dmpEquatorial;

(* ------------------------------------------------------------ *)

PROCEDURE dmpLocal (  );
VAR
    i,ndx : CARDINAL;
    v1,v2:LONGREAL;
    S,S1,S2:str128;
BEGIN
    headertwo("Coordonnes locales","(A et h -- azimut et hauteur)");
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                v1:=themenatal.planete[ndx].azimut;
                v2:=themenatal.planete[ndx].altitude;
                fmtLongLat(v1,v2,S1,S2);
                dmp3(wiCorps,S,S1,S2);
            END;
        END;
    END;
END dmpLocal;

(* ------------------------------------------------------------ *)

PROCEDURE dmpHeliocentric (  );
VAR
    i,ndx : CARDINAL;
    v1,v2,v3:LONGREAL;
    S,S1,S2,S3:str128;
BEGIN
    headertwo("Coordonnes hliocentriques","(l, b et r -- longitude, latitude et rayon vecteur)");
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                CASE objet(ndx) OF
                | soleil, lune :
                    (* ignore for these were not computed *)
                ELSE
                    getObjectName(objet(ndx),S);
                    v1:=themenatal.planete[ndx].l;
                    v2:=themenatal.planete[ndx].b;
                    v3:=themenatal.planete[ndx].r;
                    fmtLongLat(v1,v2,S1,S2);
                    AngleToStr(v3,DDddddd,S3);
                    dmp4(wiCorps,S,S1,S2,S3);
                END;
            END;
        END;
    END;
END dmpHeliocentric;

(* ------------------------------------------------------------ *)

(* defaultorbe=12; (* from TRANSIT.BAS, else could be 10 +1(sun) +2(moon) *) *)

PROCEDURE dmpAngularities (orbeAS,orbeMC,orbeDS,orbeFC:CARDINAL);
VAR
    S,S1,S2 : str128;
    defaultorbe,i,j,ndx,orbe: CARDINAL;
    posangle,pos,diff:LONGREAL;
    last:CARDINAL;
BEGIN
    header("Objets angulaires"); (* " et non-angulaires" *)
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        ObjectInfo[ndx].angular := FALSE; (* already done earlier but... *)
    END;
    last:=MAX(CARDINAL);
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        IF isAngle( objet(ndx) ) THEN
            CASE objet(ndx) OF
            | as: defaultorbe:=orbeAS;
            | mc: defaultorbe:=orbeMC;
            | ds: defaultorbe:=orbeDS;
            | fc: defaultorbe:=orbeFC;
            ELSE ; (* //ISO fixed silly requirement *) END;
            getObjectName( objet(ndx) ,S1);
            pad(wiObjet,S1);
            posangle:=themenatal.planete[ ndx ].lambda;
            FOR i := firstObject TO lastObject DO
                ndx:=objectindex[i];
                IF ObjectInfo[ndx].enabled THEN
                    IF isAngle( objet(ndx) )=FALSE THEN
                        getObjectName( objet(ndx) ,S);
                        pos:=themenatal.planete[ndx].lambda;
                        CASE objet(ndx) OF
                        | soleil :
                            orbe:=defaultorbe; (* +1 *)
                        | lune :
                            orbe:=defaultorbe; (* +2 *)
                        ELSE
                            orbe:=defaultorbe;
                        END;
                        IF isAngulaire(pos, posangle, orbe, diff) THEN
                            IF last = MAX(CARDINAL) THEN
                                last:=j;
                            ELSIF last # j THEN
                                nl;
                                last:=j;
                            END;
                            AngleToStr(diff,DDd,S2);
                            Str.Prepend(S2,"[");
                            Str.Append(S2,"]");
                            dmp3(wiObjet,S,S1,S2);
                            ObjectInfo[ndx].angular:=TRUE;
                        END;
                    END;
                END;
            END;
        END;
    END;
(* ignore unqualified
    j:=lastObject+1; (* just in case *)
    (* dump remaining non angular if any *)
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isAngle( objet(ndx) )=FALSE THEN
                getObjectName( objet(ndx) ,S);
                IF ObjectInfo[ndx].angular=FALSE THEN
                     IF last = MAX(CARDINAL) THEN
                         last:=j;
                     ELSIF last # j THEN
                         nl;
                         last:=j;
                     END;
                     dmp1(S);
                END;
            END;
        END;
    END;
*)
END dmpAngularities;

(* ------------------------------------------------------------ *)

(* see fmtPos : sign is real, not rounded for display *)

PROCEDURE getRealSign (v:LONGREAL):signtype;
VAR
    i : CARDINAL;
    S : str128;
BEGIN
    CASE flagDecimal OF
    | TRUE :  AngleToPos(v,DDdd,S,i);
    | FALSE : AngleToPos(v,DDMM,S,i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN signtype(i); (* result should be the same whatever AngleToPos DDdd or DDMM *)
END getRealSign;

TYPE
    info=(cardinal,fixe,mutable,
          feu,terre,air,eau,
          masculin,feminin,
          printemps,ete,automne,hiver,
          jour,nuit,
          orient,occident,
          quadrantNE,quadrantNW,quadrantSE,quadrantSW,
          pouvoir,avoir,etre,valoir,servir);
    infoPlus= (theSoleil,theLune,
               objectivation,alligation,individuation,participation,
               diurne,nocturne);
CONST
    infos="Cardinal,Fixe,Mutable,"+
          "Feu,Terre,Air,Eau,"+
          "Masculin,Fminin,"+
          "Printemps,Et,Automne,Hiver,"+
          "Jour,Nuit,"+
          "Orient,Occident,"+
          "Nord-Est,Nord-Ouest,Sud-Est,Sud-Ouest,"+
          "Pouvoir,Avoir,Etre,Valoir,Servir";
    infosPlus= "Soleil,Lune,"+
               "Objectivation,Alligation,Individuation,Participation,"+
               "Diurne,Nocturne";

PROCEDURE getInfoStr (i:info;VAR R:ARRAY OF CHAR);
BEGIN
    Str.ItemS(R,infos,delim,ORD(i));
END getInfoStr;

PROCEDURE getInfoPlusStr (i:infoPlus;VAR R:ARRAY OF CHAR);
BEGIN
    Str.ItemS(R,infosPlus,delim,ORD(i));
END getInfoPlusStr;

PROCEDURE dmpCoefficients (useFictifs:BOOLEAN;id:domificationtype);
CONST
    sTitle ="Pondration en domification ";
    sInfo1 ="(sans les angles ni les plantes fictives)";
    sInfo2 ="(avec les angles et les plantes fictives)";
    sSecteur="Secteur ";
CONST
    firstInfo=ORD(cardinal);
    lastInfo=ORD(servir);
    firstInfoPlus=ORD(theSoleil);
    lastInfoPlus=ORD(nocturne);
    (* wiInfo = 10; (* nord ouest *) *)
VAR
    i,ndx,K:CARDINAL;
    S,S1:str128;
    pos:LONGREAL;
    ok : BOOLEAN;
    actual:domificationtype;
    kSign    : ARRAY [firstSign..lastSign] OF CARDINAL;
    kHouse   : ARRAY [firstCusp..lastCusp] OF CARDINAL;
    kInfo    : ARRAY [firstInfo..lastInfo] OF CARDINAL;
    kInfoPlus: ARRAY [firstInfoPlus..lastInfoPlus] OF CARDINAL;
    currhouse:CARDINAL;
    currsign:signtype;
    S2,S3,S4:str128;
    wi : CARDINAL;
BEGIN
    (* IF flagRET THEN RETURN; END; (* avoid nonsense ! *) *)
    IF id= notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    getDomificationStr(id,S);
    Str.Prepend(S,sTitle);
    CASE useFictifs OF
    | FALSE : headertwo(S,sInfo1);
    | TRUE  : headertwo(S,sInfo2);
        IF actual # id THEN
            getDomificationStr(notapplicable,S);
            dmp1(S);
            RETURN;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    FOR i:=firstSign TO lastSign DO
        kSign[i]:=0;
    END;
    FOR i:=firstCusp TO lastCusp DO
        kHouse[i]:=0;
    END;
    FOR i:=firstInfo TO lastInfo DO
        kInfo[i]:=0;
    END;
    (* always zero *)
    FOR i:=firstInfoPlus TO lastInfoPlus DO
        kInfoPlus[i]:=0;
    END;
    matchObjectToHouse(id); (* calc house for each objectinfoarray *)
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            CASE useFictifs OF
            | FALSE : ok:=isPlanete( objet(ndx) );
            | TRUE :  ok:=TRUE; (* all enabled objects are taken into account here *)
            ELSE ; (* //ISO fixed silly requirement *) END;
            IF ok THEN
                pos:=themenatal.planete[ndx].lambda;
                currsign:=getRealSign(pos);
                K:=ObjectInfo[ndx].weight;
                currhouse:=ObjectInfo[ndx].sector;

                INC(kSign[ORD(currsign)],K);
                IF isAngle( objet(ndx) )=FALSE THEN
                    INC(kHouse[currhouse-1],K);
                    IF angleIsCusp(id) THEN (* avoid ptol here ! *)
                        CASE currhouse OF
                        | 1,2,3,4,5,6    : INC(kInfo[ ORD(nuit) ],K);
                        | 7,8,9,10,11,12 : INC(kInfo[ ORD(jour) ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE currhouse OF
                        | 10,11,12,1,2,3 : INC(kInfo[ ORD(orient)   ],K);
                        | 4,5,6,7,8,9    : INC(kInfo[ ORD(occident) ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE currhouse OF
                        | 1,2,3    : INC(kInfo[ ORD(quadrantSE) ],K);
                        | 4,5,6    : INC(kInfo[ ORD(quadrantSW) ],K);
                        | 7,8,9    : INC(kInfo[ ORD(quadrantNW) ],K);
                        | 10,11,12 : INC(kInfo[ ORD(quadrantNE) ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    END;
                    IF id=nonsensical THEN (* here, we only have planets *)
                        CASE currhouse OF
                        | 1,2,3,4 : INC(kInfoPlus[ ORD(diurne)    ],K);
                        | 5,6,7,8 : INC(kInfoPlus[ ORD(nocturne)  ],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE currhouse OF
                        | 1,6 : INC(kInfoPlus[ ORD(objectivation )],K);
                        | 2,5 : INC(kInfoPlus[ ORD(alligation    )],K);
                        | 3,8 : INC(kInfoPlus[ ORD(individuation )],K);
                        | 4,7 : INC(kInfoPlus[ ORD(participation )],K);
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        CASE objet(ndx) OF
                        | soleil : kInfoPlus[ ORD(theSoleil) ] := currhouse;
                        | lune   : kInfoPlus[ ORD(theLune)   ] := currhouse;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    END;
                END;
                CASE currsign OF
                | belier,gemeaux,lion,balance,sagittaire,verseau:
                    INC(kInfo[ ORD(masculin) ],K);
                | taureau,cancer,vierge,scorpion,capricorne,poissons:
                    INC(kInfo[ ORD(feminin)  ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
                CASE currsign OF
                | belier,cancer,balance,capricorne:
                    INC(kInfo[ ORD(cardinal) ],K);
                | taureau,lion,scorpion,verseau:
                    INC(kInfo[ ORD(fixe)     ],K);
                | gemeaux,vierge,sagittaire,poissons:
                    INC(kInfo[ ORD(mutable)  ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
                CASE currsign OF
                | belier,lion,sagittaire:
                    INC(kInfo[ ORD(feu)   ],K);
                | taureau,vierge,capricorne:
                    INC(kInfo[ ORD(terre) ],K);
                | gemeaux,balance,verseau:
                    INC(kInfo[ ORD(air)   ],K);
                | cancer,scorpion,poissons:
                    INC(kInfo[ ORD(eau)   ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
                CASE currsign OF
                | belier,taureau,gemeaux:
                    INC(kInfo[ ORD(printemps) ],K);
                | cancer,lion,vierge:
                    INC(kInfo[ ORD(ete)       ],K);
                | balance,scorpion,sagittaire:
                    INC(kInfo[ ORD(automne)   ],K);
                | capricorne,verseau,poissons:
                    INC(kInfo[ ORD(hiver)     ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;

                CASE currsign OF
                | belier:     INC(kInfo[ ORD(pouvoir) ],K);
                | taureau:    INC(kInfo[ ORD(avoir)   ],K);
                | gemeaux:    INC(kInfo[ ORD(etre)    ],K);
                | cancer:     INC(kInfo[ ORD(servir)  ],K);
                | lion:       INC(kInfo[ ORD(pouvoir) ],K);
                              INC(kInfo[ ORD(valoir)  ],K);
                | vierge:     INC(kInfo[ ORD(servir)  ],K);
                | balance:    INC(kInfo[ ORD(etre)    ],K);
                | scorpion:   INC(kInfo[ ORD(pouvoir) ],K);
                              INC(kInfo[ ORD(avoir)   ],K);
                | sagittaire: INC(kInfo[ ORD(etre)    ],K);
                              INC(kInfo[ ORD(valoir)  ],K);
                | capricorne: INC(kInfo[ ORD(pouvoir) ],K);
                | verseau:    INC(kInfo[ ORD(etre)    ],K);
                              INC(kInfo[ ORD(valoir)  ],K);
                | poissons:   INC(kInfo[ ORD(servir)  ],K);
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
        END;
    END;
    FOR i:= firstSign TO lastSign DO
        getSignName(signtype(i),S);
        valToStr(kSign[i],S1);
        dmp2(wiCoeff,S,S1);
    END;
    nl;
    FOR i:= firstCusp TO getLastCusp(id) DO
        getRomanStr(i+1,S); (* remember housetype is 0..11 ! *)
        Str.Prepend(S,sSecteur);
        valToStr(kHouse[i],S1);
        IF (useFictifs OR (id # nonsensical) ) THEN
            dmp2(wiCoeff,S,S1);
        END;
    END;
    IF ( (useFictifs=FALSE) AND (id=nonsensical) ) THEN
        FOR i:=firstInfoPlus TO lastInfoPlus DO
            CASE infoPlus(i) OF
            | theSoleil,objectivation,diurne: nl;
            ELSE ; (* //ISO fixed silly requirement *) END;
            getInfoPlusStr(infoPlus(i),S);
            CASE infoPlus(i) OF
            | theSoleil,theLune:
                K := kInfoPlus[i] - 1; (* we kept 1..8, we need 0..7 *)
                getRomanStr(K+1,S1); (* remember housetype is 0..11 ! *)
                (*
                *)
                Str.Prepend(S,"; ");
                Str.Append(S," en ");Str.Append(S,S1);
                Str.Copy(S1,""); (* do not pass constants ! *)
                Str.Copy(S2,"  "); (* fake two digits ! *)
                dmp3(wiCoeff,S1,S2,S);
            ELSE
                valToStr(kInfoPlus[i],S1);
                dmp2(wiCoeff,S,S1);
            END;
        END;
    END;
    FOR i:= firstInfo TO lastInfo DO
        CASE info(i) OF
        | cardinal,feu,masculin,printemps,pouvoir : nl;
        | jour,orient,quadrantNE: IF angleIsCusp(id) THEN nl; END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        CASE info(i) OF
        | jour,nuit,
          orient,occident,
          quadrantNE,quadrantNW,quadrantSE,quadrantSW :
            ok:=angleIsCusp(id);
        ELSE
            ok:=TRUE;
        END;
        IF ok THEN
            getInfoStr(info(i),S);
            valToStr(kInfo[i],S1);
            dmp2(wiCoeff,S,S1);
        END;
    END;
END dmpCoefficients;

(* ------------------------------------------------------------ *)

PROCEDURE dmpTradition (id:domificationtype);
CONST
    wiMaitrise = 17; (* maitrise sur viii *)
VAR
    i,ndx:CARDINAL;
    actual:domificationtype;
    S,S1,S2,S3:str128;
    pos:LONGREAL;
    currhouse:CARDINAL;
    currsign:signtype;
    v:LONGREAL;
    cusp : ARRAY [firstCusp..lastCusp] OF LONGREAL;
    currdignity:dignitytype;
    body:objet;
BEGIN
    IF id = notapplicable THEN RETURN; END; (* should never happen ! *)
    actual := themenatal.domificationFlag[ORD(id)];
    header("Informations de la "+doublequote+"Tradition"+doublequote);
    IF actual # id THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    matchObjectToHouse(id); (* calc house for each objectinfoarray *)
    FOR i := firstCusp TO lastCusp DO
        v:= themenatal.maisonData[ORD(id)][i];
        cusp[i]:=v;
    END;
    FOR i := firstObject TO lastObject DO
        ndx:=objectindex[i];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName(objet(ndx),S);
                pos:=themenatal.planete[ndx].lambda;
                currsign:=getRealSign(pos);
                currdignity:=getDignity( objet(ndx) ,currsign);
                IF currdignity # aucunedignite THEN
                   getDignityName(currdignity,S1);
                   dmp2(wiCorps,S,S1);
                ELSE
                   (* try for mercure/venus which have two domiciles/exils *)
                   currdignity:=getDignityAlt( objet(ndx) ,currsign);
                   IF currdignity # aucunedignite THEN
                       getDignityName(currdignity,S1);
                       dmp2(wiCorps,S,S1);
                   (* ignore unqualified
                   ELSE
                       dmp1(S);
                   *)
                   END;
                END;
            END;
        END;
    END;
    nl;
    FOR i := firstCusp TO getLastCusp(id) DO
        getRomanStr(i+1,S); (* remember housetype is 0..11 ! *)
        Str.Prepend(S,"Matrise sur ");
        pos:=cusp[i];
        currsign:=getRealSign(pos);
        body:=getMaitrise( currsign );
        getObjectName(body,S1);
        pad(wiCorps,S1);

        pos:=themenatal.planete[ORD(body)].lambda;
        currsign:=getRealSign(pos);
        getSignName(currsign,S2);
        pad(wiSigne,S2);

        currhouse:=ObjectInfo[ORD(body)].sector;
        getRomanStr(currhouse,S3);

        dmp4(wiMaitrise,S,S1,S2,S3);
    END;
END dmpTradition;

(* ------------------------------------------------------------ *)

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByAspectWithBeta (useAngles:BOOLEAN);
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;
    beta1,beta2:LONGREAL;
    real1a,real2a:BOOLEAN;

    K,Ksymbol : str128;
    val : CARDINAL;
	Z,Z1:str256;
BEGIN
    CASE useAngles OF
    | FALSE :
        (* headertwo("Aspects de chaque corps avec les autres corps","("+sBeta+" prise en compte)"); *)
        Z:="Aspects de chaque corps avec les autres corps";
	Str.Concat(Z1,"(",sBeta);
	Str.Append(Z1," prise en compte)");
	headertwo(Z,Z1);
        wide:=wiCorps;
    | TRUE  :
        (* headertwo("Aspects de chaque corps et angle avec les angles","("+sBeta+" prise en compte)"); *)
        Z:="Aspects de chaque corps et angle avec les angles";
	Str.Concat(Z1,"(",sBeta);
	Str.Append(Z1," prise en compte)");
	headertwo(Z,Z1);
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR i := firstObject TO (lastObject-1) DO
        ndx1     := objectindex[i];
        enabled1 := ObjectInfo[ndx1].enabled;
        real1    := isPlanete ( objet(ndx1) );
        real1a   := isAngle ( objet(ndx1) );
        lambda1  := themenatal.planete[ndx1].lambda;
        beta1    := themenatal.planete[ndx1].beta;
        group1   := ObjectInfo[ndx1].group;
        getObjectName( objet(ndx1) ,P1);

        FOR j := (i+1) TO lastObject DO
            ndx2     := objectindex[j];
            enabled2 := ObjectInfo[ndx2].enabled;
            real2    := isPlanete ( objet(ndx2) );
            real2a   := isAngle ( objet(ndx2) );
            lambda2  := themenatal.planete[ndx2].lambda;
            beta2    := themenatal.planete[ndx2].beta;
            group2   := ObjectInfo[ndx2].group;
            getObjectName( objet(ndx2) ,P2);
            pad(wide,P2); (* real body or longer unreal body such as MC *)

            CASE useAngles OF
            | FALSE : ok := ((real1) AND (real2))  ;
            | TRUE :  ok := ( ((real1) OR (real1a)) AND (real2a) );
                IF flagAvoidAxisOrUseless THEN
                      ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;

            FOR k := firstAspect TO lastAspect DO
                ndxaspect:=aspectindex[k];
                enabledaspect:=AspectInfo[ndxaspect].enabled;
                ecartaspect:=AspectInfo[ndxaspect].ecart;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff) THEN
                            getAspectName( aspecttype(ndxaspect),S);
                            pad(wiAspect,S);
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=i;
                            ELSIF last # i THEN
                                nl;
                                last:=i;
                            END;

                            CASE useAngles OF
                            | TRUE : dmp4(wide,P1,P2,S,S1);
                            | FALSE: pad(wide,P1);
                                     val := computeAspectCoeff(i,j,K,Ksymbol); (* is filtered for real and real *)
                                     dmp6(wiAspectCoeff,K,Ksymbol,P1,P2,S,S1);
                            ELSE ; (* //ISO fixed silly requirement *) END;

                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByAspectWithBeta;

(* ------------------------------------------------------------ *)

(* maybe we should filter AS MC DS FC if not placidus ? *)

PROCEDURE dmpByObjectWithBeta (useAngles:BOOLEAN);
VAR
    i,j,k,orbe:CARDINAL;

    ndx1,group1:CARDINAL;
    enabled1,real1:BOOLEAN;
    lambda1:LONGREAL;
    P1 : str128;

    ndx2,group2:CARDINAL;
    enabled2,real2:BOOLEAN;
    lambda2:LONGREAL;
    P2 : str128;

    ndxaspect    : CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect  : CARDINAL;

    diff : LONGREAL;
    S,S1:str128;
    last:CARDINAL;
    wide:CARDINAL;
    ok:BOOLEAN;
    beta1,beta2:LONGREAL;
    real1a,real2a:BOOLEAN;

    K,Ksymbol : str128;
    val : CARDINAL;
    Z,Z1:str256;
BEGIN
    CASE useAngles OF
    | FALSE :
        (* headertwo("Aspects de chaque corps avec les autres corps","("+sBeta+" prise en compte)"); *)
        Z:="Aspects de chaque corps avec les autres corps";
	Str.Concat(Z1,"(",sBeta);
	Str.Append(Z1," prise en compte)");
	headertwo(Z,Z1);
        wide:=wiCorps;
    | TRUE :
        (* headertwo("Aspects de chaque corps et angle avec les angles","("+sBeta+" prise en compte)"); *)
        Z := "Aspects de chaque corps et angle avec les angles";
	Str.Concat(Z1,"(",sBeta);
	Str.Append(Z1," prise en compte)");
	headertwo(Z,Z1);
        wide:=wiObjet;
    ELSE ; (* //ISO fixed silly requirement *) END;
    last := MAX(CARDINAL);
    FOR k := firstAspect TO lastAspect DO
        ndxaspect:=aspectindex[k];
        enabledaspect:=AspectInfo[ndxaspect].enabled;
        ecartaspect:=AspectInfo[ndxaspect].ecart;
        getAspectName( aspecttype(ndxaspect),S);

        FOR i := firstObject TO (lastObject-1) DO
            ndx1     := objectindex[i];
            enabled1 := ObjectInfo[ndx1].enabled;
            real1    := isPlanete ( objet(ndx1) );
            real1a   := isAngle ( objet(ndx1) );
            lambda1  := themenatal.planete[ndx1].lambda;
            beta1    := themenatal.planete[ndx1].beta;
            group1   := ObjectInfo[ndx1].group;
            getObjectName( objet(ndx1) ,P1);
            pad(wide,P1);

            FOR j := (i+1) TO lastObject DO
                ndx2     := objectindex[j];
                enabled2 := ObjectInfo[ndx2].enabled;
                real2    := isPlanete ( objet(ndx2) );
                real2a   := isAngle ( objet(ndx2) );
                lambda2  := themenatal.planete[ndx2].lambda;
                beta2    := themenatal.planete[ndx2].beta;
                group2   := ObjectInfo[ndx2].group;
                getObjectName( objet(ndx2) ,P2);
                pad(wide,P2); (* can be real body or long unreal thing such as MC *)

                CASE useAngles OF
                | FALSE : ok:= ((real1) AND (real2));
                | TRUE :  ok:= ( ((real1) OR (real1a)) AND (real2a) );
                    IF flagAvoidAxisOrUseless THEN
                          ok:=ok AND (NOT (isAxisOrUseless( objet(ndx1), objet(ndx2)) )); (* prevent side effect *)
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;

                IF ((enabled1) AND (enabled2) AND (enabledaspect)) THEN
                    ok:=(ok AND smallerNonZero(ndx1,ndx2,ndxaspect)); (* 24 Nov 01 *)
                    IF ok THEN
                        orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
                        IF inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff) THEN
                            AngleToStr(diff,DDd,S1);
                            Str.Prepend(S1,"[");
                            Str.Append(S1,"]");
                            IF last = MAX(CARDINAL) THEN
                                last:=k;
                            ELSIF last # k THEN
                                nl;
                                last:=k;
                            END;

                            CASE useAngles OF
                            | TRUE : dmp4(wiAspect,S,P1,P2,S1);
                            | FALSE: pad(wiAspect,S);
                                     val := computeAspectCoeff(i,j,K,Ksymbol); (* is filtered for real and real *)
                                     dmp6(wiAspectCoeff,K,Ksymbol,S,P1,P2,S1);
                            ELSE ; (* //ISO fixed silly requirement *) END;

                        END;
                    END;
                END;
            END;
        END;
    END;
END dmpByObjectWithBeta;

(* ------------------------------------------------------------ *)

(* ------------------------------------------------------------ *)

(* warning ! this sub replaces user-defined zones with program-defined ones ! *)
(* prevent this with a dummy internal array *)

PROCEDURE dmpAnalysisRET (  ); (* conditionalist angularities and aspects *)
CONST
(*
    twothird = 2.0 / 3.0;
    half     = 0.5;
*)
    wiRank = 2;
    sZone = "Zone ";
VAR
    S,S1,S2 : str128;
    i,j,ndx : CARDINAL;
    currangle:objet;
    pos:LONGREAL;
    ki,ks:LONGREAL;
    mi,mm,ms:cuspide;
    pi,pm,ps:LONGREAL;
    last:CARDINAL;
    rank:CARDINAL;
    angulaires : CARDINAL;
    (* be sure to use these renamed arrays !!! *)
    ObjectInfoRETzone : ARRAY [firstObject..lastObject] OF CARDINAL; (* dummy to avoid modification of current one *)
    ObjectInfoRETrank : ARRAY [firstObject..lastObject] OF CARDINAL; (* dummy to avoid modification of current one *)
BEGIN
    (* IF flagRET=FALSE THEN RETURN; END; (* avoid nonsense ! *) *)
    header("Corps angulaires et non-angulaires selon les rgles conditionalistes");
    IF themenatal.domificationFlag[ORD(placidus)] # placidus THEN
        getDomificationStr(notapplicable,S);
        dmp1(S);
        RETURN;
    END;
    (* matchObjectToHouse(placidus); (* calc house for each objectinfoarray *) *)
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        ObjectInfoRETzone[ndx]:=0; (* init to zone 0 *)
    END;
    angulaires:=0;
    rank:=1;
    last:=MAX(CARDINAL);
    FOR i := 1 TO 4 DO
        CASE i OF
        | 1 :
            currangle := as;
            ki:= k1_xii; (* twothird *)
            ks:= k1_i;   (* half *)
            mi:= m12;
            mm:= mAS;
            ms:= m2;
            S:="1";
        | 2 :
            currangle := mc;
            ki:= k2_ix;  (* twothird *)
            ks:= k2_x;   (* twothird *)
            mi:= m9;
            mm:= mMC;
            ms:= m11;
            S:="2";
        | 3 :
            currangle := ds;
            ki:= k3_vi;  (* half *)
            ks:= k3_vii; (* twothird *)
            mi:= m6;
            mm:= mDS;
            ms:= m8;
            S:="3";
        | 4 :
            currangle := fc;
            ki:= k4_iii; (* half *)
            ks:= k4_iv;  (* half *)
            mi:= m3;
            mm:= mFC;
            ms:= m5;
            S:="4";
        ELSE ; (* //ISO fixed silly requirement *) END;
        getObjectName(currangle,S2);
        Str.Prepend(S,sZone);
        Str.Append(S," (");
        Str.Prepend(S2,S);
        Str.Append(S2,")");
        pi:=themenatal.maisonData[ORD(placidus)][ ORD(mi) ];
        pm:=themenatal.maisonData[ORD(placidus)][ ORD(mm) ];
        ps:=themenatal.maisonData[ORD(placidus)][ ORD(ms) ];

        FOR j := firstObject TO lastObject DO
            ndx:=objectindex[j];
            IF isPlanete( objet(ndx) ) THEN
                getObjectName( objet(ndx) ,S1);
                pos:=themenatal.planete[ ndx ].lambda;
                IF inZone(pos,pi,pm,ps,ki,ks) THEN
                    IF last = MAX(CARDINAL) THEN
                        last:=i;
                    ELSIF last # i THEN
                        nl;
                        last:=i;
                    END;
                    pad(wiCorps,S1);
                    valToStr(rank,S);
                    INC(rank);
                    dmp3(wiRank,S,S1,S2);
                    ObjectInfoRETrank[ndx]:=rank;
                    ObjectInfoRETzone[ndx]:=i;
                    INC(angulaires);
                END;
            END;
        END;
    END;
    i:=4+1; (* just in case *)
    (* dump remaining non angular if any *)
    FOR j := firstObject TO lastObject DO
        ndx:=objectindex[j];
        IF ObjectInfo[ndx].enabled THEN
            IF isPlanete( objet(ndx) ) THEN
                getObjectName( objet(ndx) ,S1);
                IF ObjectInfoRETzone[ndx]=0 THEN
                    IF last = MAX(CARDINAL) THEN
                        last:=i;
                    ELSIF last # i THEN
                        nl;
                        last:=i;
                    END;
                    valToStr(rank,S);
                    INC(rank);
                    pad(wiCorps,S1);
                    S2:=sZone+"0";
                    dmp3(wiRank,S,S1,S2);
                    ObjectInfoRETrank[ndx]:=rank;
                END;
            END;
        END;
    END;

END dmpAnalysisRET;

(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    underscore = "_";
    hilite = "======= ";
    blurb = "INTRODUCTION : ";
VAR
    sex:(man,woman,undefined);

PROCEDURE findsex ();
VAR
    ch:CHAR;
    information : (ville,pays,nom,genre,remarque);
    R : str128;
    i : CARDINAL;
BEGIN
    ch:=infosep(themenatal.orenseignements);
    infostr(ORD(genre),ch,R);
    UpperCase(R);
    i:=getStrIndex(delim,R,
                   "H"+delim+"M"+delim+"+"+delim+"HOMME"+delim+"MAN"+delim+"MASCULIN"+delim+
                   "F"+delim+"W"+delim+"-"+delim+"FEMME"+delim+"WOMAN"+delim+"FEMININ"+delim+
                   "N"+delim+"?"+delim+"NEUTRE"+delim+"NEUTRAL");
    CASE i OF
    | 1..6 :   sex:=man;
    | 7..12 :  sex:=woman;
    ELSE
               sex:=undefined;
    END;
END findsex;

PROCEDURE findCetObjet (S:ARRAY OF CHAR; VAR index:CARDINAL  ):BOOLEAN;
VAR
    S1:str128;
    i:CARDINAL;
BEGIN
    FOR i := firstObject TO lastObject DO
        index:=i;
        getObjectName(objet(i),S1);
        UpperCase(S1);
        IF same(S,S1) THEN RETURN TRUE; END;
    END;
    RETURN FALSE;
END findCetObjet;

PROCEDURE cleanIt (VAR R : ARRAY OF CHAR );
BEGIN
    LtrimBlanks(R);
    RtrimBlanks(R);
    UpperCase(R);
END cleanIt;

(*


*)

(* in these subs, VAR S for speed, but do NOT modify S ! *)

PROCEDURE getPresentIndex (VAR S:ARRAY OF CHAR;possible:ARRAY OF CHAR) : CARDINAL;
VAR
    i : CARDINAL;
    str:str128;
BEGIN
    Str.Append(possible,delim);
    i := 0;
    LOOP
        Str.ItemS(str,possible,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.Pos(S,str) # MAX(CARDINAL) THEN RETURN (i+1); END;
        INC(i);
    END;
END getPresentIndex;

PROCEDURE present (VAR S:ARRAY OF CHAR;lower,upper:ARRAY OF CHAR):CARDINAL;
VAR
    p:CARDINAL;
    T:str128;
BEGIN
    p:=Str.Pos(S,lower);
    IF p # MAX(CARDINAL) THEN RETURN p; END;
    (* RETURN Str.Pos(S,upper); *)
    p:=Str.Pos(S,upper);
    IF p # MAX(CARDINAL) THEN RETURN p; END;
    Str.Copy(T,S);
    UpperCase(T);
    RETURN Str.Pos(T,upper);
END present;

PROCEDURE presence (VAR S : ARRAY OF CHAR;searched:ARRAY OF CHAR  ) : BOOLEAN;
BEGIN
    IF Str.Pos(S,searched) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END presence;

(* taken from COMPARER.MOD *)
(* find THE aspect between two longitudes, for "there can be only one" ! *)
(* return boolean, ndxaspect (max(cardinal) if none) and nature *)

PROCEDURE findAspect(lambda1,lambda2:LONGREAL;group1,group2, ndx1,ndx2:CARDINAL;
                     VAR ndxaspect,nature: CARDINAL;VAR diff:LONGREAL):BOOLEAN;
VAR
    k:CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect:CARDINAL;
    orbe : CARDINAL;
BEGIN
    k:=firstAspect;
    LOOP
        IF k > lastAspect THEN EXIT; END;
        ndxaspect     :=aspectindex[k];
        enabledaspect :=AspectInfo[ndxaspect].enabled;
        ecartaspect   :=AspectInfo[ndxaspect].ecart;
        nature        :=AspectInfo[ndxaspect].nature;
        IF (enabledaspect AND smallerNonZero(ndx1,ndx2,ndxaspect)) THEN (* was enabledaspect alone *)
            orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
            IF inAspect(lambda1,lambda2,ecartaspect,LONGREAL(orbe),diff) THEN
                RETURN TRUE;
            END;
        END;
        INC(k);
    END;
    ndxaspect:=MAX(CARDINAL);
    nature:=MAX(CARDINAL);
    diff:=180.0;
    RETURN FALSE;
END findAspect;

PROCEDURE findAspectBeta(lambda1,beta1,lambda2,beta2:LONGREAL;group1,group2, ndx1,ndx2:CARDINAL;
                         VAR ndxaspect,nature: CARDINAL;VAR diff:LONGREAL):BOOLEAN;
VAR
    k:CARDINAL;
    enabledaspect:BOOLEAN;
    ecartaspect:CARDINAL;
    orbe : CARDINAL;
BEGIN
    k:=firstAspect;
    LOOP
        IF k > lastAspect THEN EXIT; END;
        ndxaspect     :=aspectindex[k];
        enabledaspect :=AspectInfo[ndxaspect].enabled;
        ecartaspect   :=AspectInfo[ndxaspect].ecart;
        nature        :=AspectInfo[ndxaspect].nature;
        IF (enabledaspect AND smallerNonZero(ndx1,ndx2,ndxaspect)) THEN (* was enabledaspect alone *)
            orbe:=getOrbe(group1,group2,ndxaspect, ndx1,ndx2);
            IF inAspectBeta(lambda1,beta1,lambda2,beta2,ecartaspect,LONGREAL(orbe),diff) THEN
                RETURN TRUE;
            END;
        END;
        INC(k);
    END;
    ndxaspect:=MAX(CARDINAL);
    nature:=MAX(CARDINAL);
    diff:=180.0;
    RETURN FALSE;
END findAspectBeta;


(* ------------------------------------------------------------ *)

VAR
    hugestring : str4096; (* should be enough : longest paragraph is about 4050 chars for now *)

PROCEDURE dmpPara (S : ARRAY OF CHAR);
VAR
    continue:BOOLEAN;
    R:str128;
BEGIN
    processGender(S,(sex=woman));
    CASE LineWidth OF
    | 0 :
        dmp1(S);
    ELSE
        continue:=dmpTTX(S,LineWidth,R,TRUE);
        WHILE continue DO
            dmp1(R);
            continue:=dmpTTX(S,LineWidth,R,FALSE);
        END;
    END;
END dmpPara;

(* S2 is report section header, S is :::looked for *)
(* if S2 is "", then nada as section header : darn, I was clever ! ;-) *)

PROCEDURE dmpIt (objet1,objet2:CARDINAL;
                 offset:LONGCARD; S2,S : ARRAY OF CHAR);
CONST
    dummyecart = 360; (* cannot happen ! not used here anyway *)
VAR
    result:BOOLEAN;
    state:(normal,include,skip);
BEGIN
    IF Str.Length(S2) # 0 THEN
        Str.Prepend(S2,hilite);
        dmp1(S2);
        nl;
    END;
    IF findFileEntry(hndTextes,offset,S) THEN
        state:=normal;
        LOOP
  eyeCandy(cmdSHOW);
            IF readFileEntry(hndTextes,hugestring)=FALSE THEN EXIT; END;
            IF Str.Length(hugestring) # 0 THEN
                CASE state OF
                | normal :
                    IF evalIfCondition(dummyecart,objet1,objet2,hugestring,result) THEN
                        CASE result OF
                        | TRUE :
                            state:=include;
                        | FALSE:
                            state:=skip;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    ELSE
                        dmpPara(hugestring);
                    END;
                | include :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=skip;
                    ELSE
                        dmpPara(hugestring);
                    END;
                | skip :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=include;
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            ELSE
                IF flagKeepEmptyLine THEN nl; END;
            END;
        END;
    END;
    nl;
END dmpIt;


PROCEDURE intWarning (  );
VAR
    offset:LONGCARD;
    S:str128;
BEGIN
    IF findIndexFileOffset(sfWarning,extTXT,offset)=FALSE THEN
        Str.Concat(S,sfWarning,extTXT);
        Str.Append(S," introuvable !");
        Str.Prepend(S,hilite);
        dmp1(S);
    ELSE
        Str.Copy(S,"POST SCRIPTUM");
        dmpIt(0,0,offset,S, stIntro);
    END;
END intWarning;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)

PROCEDURE intWarningRET (  );
VAR
    offset:LONGCARD;
    S:str128;
BEGIN
    IF findIndexFileOffset(sfWarning,extDOM,offset)=FALSE THEN
        Str.Concat(S,sfWarning,extDOM);
        Str.Append(S," introuvable !");
        Str.Prepend(S,hilite);
        dmp1(S);
    ELSE
        Str.Copy(S,"POST SCRIPTUM");
        dmpIt(0,0,offset,S, stIntro);
    END;
END intWarningRET;

(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)

(* objet1 is ndxstrongest *)

PROCEDURE dmpItAspectRET (ASPECT,P1,P2:ARRAY OF CHAR;
                          objet1,objet2,nature:CARDINAL;
                          rank1,rank2:CARDINAL;
                          showTitle : BOOLEAN);
VAR
    TITRE,ABREV,FICHIER:str128;
    offset:LONGCARD;
    result:BOOLEAN;
    state:(normal,include,skip);
    val:CARDINAL;
    K,Ksymbol:str128;
BEGIN
    val := computeAspectCoeff(rank1,rank2,K,Ksymbol); (* is filtered for real and real *)

    Str.Concat(TITRE,P1," et ");
    Str.Append(TITRE,P2);
    Str.Append(TITRE," en ");
    Str.Append(TITRE,ASPECT);
    Str.Prepend(TITRE," ");
    Str.Prepend(TITRE,Ksymbol);
    Str.Prepend(TITRE," ");
    Str.Prepend(TITRE,K);

    CASE nature OF
    | natNeutral  : ABREV:=stConjonction;
    | natDissonant: ABREV:=stDissonant;
    | natHarmonic : ABREV:=stHarmonique;
    ELSE ; (* //ISO fixed silly requirement *) END;
    (* in CIEL.W51, definitions are always in the order of objects, so... *)
    IF objet1 < objet2 THEN
        Str.Copy(FICHIER,P1);
    ELSE
        Str.Copy(FICHIER,P2);
    END;

    cleanIt(FICHIER);
    ReplaceChar(FICHIER,blank,underscore);
    IF Str.Length(FICHIER) > 8 THEN FICHIER[7+1]:=CHR(0); END;

    IF findIndexFileOffset(FICHIER,extRET,offset)=FALSE THEN
        Str.Concat(TITRE,FICHIER,extRET);
        Str.Append(TITRE," introuvable !");
        Str.Prepend(TITRE,hilite);
        dmp1(TITRE);
        RETURN;
    END;
    (* okay, we may try : if showtitle is false, skip *)
    IF showTitle THEN
        IF Str.Length(TITRE) # 0 THEN
            Str.Prepend(TITRE,hilite);
            dmp1(TITRE);
            nl;
        END;
    END;

    IF findFileEntryAspect(hndTextes,offset,ABREV,P1,P2) THEN
        state:=normal;
        LOOP
  eyeCandy(cmdSHOW);
            IF readFileEntry(hndTextes,hugestring)=FALSE THEN EXIT; END;
            IF Str.Length(hugestring) # 0 THEN
                CASE state OF
                | normal :
                    IF evalIfConditionRET(objet1,objet2,hugestring,result) THEN
                        CASE result OF
                        | TRUE :
                            state:=include;
                        | FALSE:
                            state:=skip;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                    ELSE
                        dmpPara(hugestring);
                    END;
                | include :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=skip;
                    ELSE
                        dmpPara(hugestring);
                    END;
                | skip :
                    IF evalEndCondition(hugestring) THEN
                        state:=normal;
                    ELSIF evalElseCondition(hugestring) THEN
                        state:=include;
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            ELSE
                IF flagKeepEmptyLine THEN nl; END;
            END;
        END;
    END;
    nl;
END dmpItAspectRET;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE buildRscPath (VAR file:ARRAY OF CHAR);
VAR
    fullpath,u,d,n,e : str128;
BEGIN
    IF CharCount(file,backslash)=0 THEN
        Lib.ParamStr(fullpath,0);
        UpperCase(fullpath); (* useless but... *)
        Lib.SplitAllPath(fullpath,u,d,n,e); (* dot is included in extension *)
        Str.Concat(fullpath,u,d);
        Str.Append(fullpath,file);
        Str.Copy(file,fullpath);
    END;
END buildRscPath;

PROCEDURE buildIniPath (VAR fullpath:ARRAY OF CHAR);
VAR
    u,d,n,e : str128;
BEGIN
    Lib.ParamStr(fullpath,0);
    UpperCase(fullpath); (* useless but... *)
    Lib.SplitAllPath(fullpath,u,d,n,e); (* dot is included in extension *)
    Lib.MakeAllPath(fullpath,u,d,astroToolsName,extRSC);
    Str.Concat(exedir,u,d);
END buildIniPath;

PROCEDURE removeExt(VAR fullpath:ARRAY OF CHAR);
VAR
    u,d,n,e : str128;
BEGIN
    UpperCase(fullpath); (* useless but... *)
    Lib.SplitAllPath(fullpath,u,d,n,e); (* dot is included in extension *)
    Lib.MakeAllPath(fullpath,u,d,n,"");
END removeExt;

PROCEDURE chkFile (ext:ARRAY OF CHAR;VAR S:ARRAY OF CHAR  ) : BOOLEAN;
VAR
    u,d,n,e:str128;
BEGIN
    CASE CharCount(S,".") OF
    | 0 :
        Str.Append(S,ext);
    | 1 :
        (* nada *)
    ELSE
        RETURN FALSE;
    END;
    IF chkJoker(S) THEN RETURN FALSE; END;
    Lib.SplitAllPath(S,u,d,n,e);
    (* either we say ERROR or we silently truncate *)

    IF Str.Length(n) > 8 THEN RETURN FALSE; END;
    IF Str.Length(e) > (1+3) THEN RETURN FALSE; END;
(*
    IF Str.Length(n) > 8 THEN
        n[8]:=CHR(0);
    END;
    IF Str.Length(e) > (1+3) THEN
        e[1+3]:=CHR(0);
    END;
    Lib.MakeAllPath(S,u,d,n,e);
*)
    RETURN TRUE;
END chkFile;

(* ------------------------------------------------------------ *)

VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    opt       : CARDINAL;
    S         : pathtype;
    R         : pathtype;
    state     : (waiting,
                 gotTheme,gotHierarchy,gotReport);
    overwrite : BOOLEAN;
    datafile  : pathtype;
    reportfile: pathtype;
    inifile   : pathtype;
    extTEXTES,extINDEX:str128;
    forceinterpret          : BOOLEAN;
    forceinterpretTradition : BOOLEAN;
    forceinterpretMix       : BOOLEAN;
    forceWP                 : BOOLEAN;
    forcelambda             : BOOLEAN;
    forcebeta               : BOOLEAN;
    forcebygroup            : BOOLEAN;
    forcebyobject           : BOOLEAN;
    forcefile               : BOOLEAN;
    forceexhaustive  : BOOLEAN;
    forcedomification:BOOLEAN;
    forcedHouseType : LONGCARD;
    myinterfile             : str128;
    rc:CARDINAL;
    k         : LONGINT;

    firsttime : BOOLEAN;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    DEBUG := FALSE;
  PATIENCE:=FALSE;
    overwrite                := FALSE;
    forceinterpret           := FALSE;
    forceinterpretTradition  := FALSE;
    forceinterpretMix        := FALSE;
    forceWP                  := FALSE;
    forcelambda              := FALSE;
    forcebeta                := FALSE;
    forcebygroup             := FALSE;
    forcebyobject            := FALSE;
    forcefile                := FALSE;
    forceexhaustive          := FALSE;
    forcedomification        := FALSE;
    inithierarchy();
    initOrbePlus();

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,""); END;

    state:=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "DEBUG"+delim+
                                 "O"+delim+"OVERWRITE"+delim+
                                 "I"+delim+"INTERPRET"+delim+
                                 "T"+delim+"TRADITION"+delim+
                                 "M"+delim+"MIX"+delim+
                                 "W"+delim+"WP"+delim+
                                 "L"+delim+"LAMBDA"+delim+
                                 "B"+delim+"BETA"+delim+
                                 "A:"+delim+"ADD:"+delim+
                                 "F:"+delim+"FILE:"+delim+
                                 "E"+delim+"EXHAUSTIVE"+delim+
                                 "D:"+delim+"HOUSE:"+delim+
                                 "PG"+delim+"BYGROUP"+delim+
                                 "PO"+delim+"BYOBJECT"
                                 );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4 :
                DEBUG := TRUE;
            | 5,6 :
                overwrite := TRUE;
            | 7,8 :
                forceinterpret:=TRUE;
            | 9,10:
                forceinterpretTradition:=TRUE;
            | 11,12:
                forceinterpretMix:=TRUE;
            | 13,14:
                forceWP := TRUE;
            | 15,16:
                forcelambda := TRUE;
            | 17,18:
                forcebeta := TRUE;
            | 19,20:
                IF GetLongInt(S,k) = FALSE THEN abort(errBadOrbePlus,""); END;
                IF chkOrbePlusRange(k)=FALSE THEN abort(errBadOrbePlus,""); END;
                orbePlus := INTEGER(k);
            | 21,22:
                GetString(S,myinterfile);
                forcefile := TRUE;
            | 23,24:
                forceexhaustive :=TRUE;
            | 25,26:
                IF GetLongCard(S,forcedHouseType)=FALSE THEN abort(errBadDomification,"");END;
                IF chkDomificationRange(forcedHouseType)=FALSE THEN abort(errBadDomification,"");END;
                forcedomification:=TRUE;
            | 27,28:
                forcebygroup:=TRUE;
            | 29,30:
                forcebyobject:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Copy(datafile,R); (* keep uppercase *)
                state := gotTheme;
            | gotTheme :
                (* firsthierarchy, lasthierarchy, hierarchyndx *)
                rc := addToHierarchy(R); (* pass UPPERCASE string ! *)
                CASE rc OF
                | errBadPlanetZone,errRedefined:
                     abort(rc,S);
                | errNone :
                     IF hierarchyndx > lastHierarchy THEN
                         state := gotHierarchy;
                     END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            | gotHierarchy :
                Str.Copy(reportfile,R); (* keep uppercase *)
                state := gotReport;
            | gotReport :
                abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    CASE state OF
    | waiting  : abort(errMissingTheme,""); (* could be errHelp *)
    | gotTheme : abort(errBadHierarchy,"");
    ELSE ; (* //ISO fixed silly requirement *) END;
    (* gotHierarchy or gotReport ok *)

    IF (forcelambda AND forcebeta) THEN abort(errConflictInterpret,"");END;
    IF (forcebygroup AND forcebyobject) THEN abort(errConflictOrbes,"");END;

    (* now check datafile *)

    IF chkFile(extTHM,datafile)=FALSE THEN abort(errBadName,datafile); END;
    IF FIO.Exists(datafile)=FALSE THEN abort(errThemeNotFound,datafile); END;

    IF state = gotHierarchy THEN
        Str.Copy(reportfile,datafile);
        removeExt(reportfile);
    END;

    IF chkFile(extRPT,reportfile)=FALSE THEN abort(errBadName,reportfile); END;
    IF FIO.Exists(reportfile) THEN
        CASE overwrite OF
        | FALSE :
            abort(errExists,reportfile);
        | TRUE :
            IF isReadOnly(reportfile) THEN abort(errReadOnly,reportfile);END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;


  video(pleasewait,TRUE);
  eyeCandy(cmdInit);
  eyeCandy(cmdSHOW);
  PATIENCE:=TRUE;
    IF loadTheme(themenatal,datafile)=FALSE THEN abort(errThemeFormat,datafile); END;
    IF chkThemeVersion(themenatal)=FALSE THEN abort(errThemeVersion,datafile); END;

  eyeCandy(cmdSHOW);
    buildIniPath(inifile);
    IF FIO.Exists(inifile)=FALSE THEN abort(errIniNotFound,inifile); END;
    IF readIniFileEnh(inifile)=FALSE THEN abort(errIniRead,inifile); END;

  eyeCandy(cmdSHOW);
    initReportFlags();
    FreeIni(); (* we can and MUST do it NOW ! *)

  eyeCandy(cmdSHOW);
    IF chkFile(extRSC,rscfile)=FALSE THEN abort(errBadName,rscfile); END;
    buildRscPath(rscfile);
    IF FIO.Exists(rscfile)=FALSE THEN abort(errRscNotFound,rscfile); END;
    IF readIniFileEnh(rscfile)=FALSE THEN abort(errRscRead,rscfile); END;

  eyeCandy(cmdSHOW);
    initMethodFlags();
    FreeIni(); (* we can and MUST do it NOW ! *)

    (* we know it's one OR the other *)
    IF forcebeta THEN flagUseBeta := TRUE; END;
    IF forcelambda THEN flagUseBeta := FALSE; END;
    (* we know it's one OR the other *)
    IF forcebygroup THEN flagUseAltOrbesNatal := FALSE; END;
    IF forcebyobject THEN flagUseAltOrbesNatal:= TRUE;END;

    IF forceWP THEN
        flagUseTabs:=TRUE;
        LineWidth := 0;
    END;

    IF forceinterpret THEN flagInterpret:=TRUE; END;
    IF forceinterpretTradition THEN flagInterpretTradition:=TRUE; END;
    IF forceinterpretMix THEN flagInterpretMix:= TRUE; END;

    IF forceexhaustive THEN exhaustiveReport(); END;
    IF forcedomification THEN
        theFavoriteHouse:=CARDINAL(forcedHouseType);
        enableFlagForThisHouse(theFavoriteHouse);
    END;
    IF theFavoriteHouse=CARDINAL(nonsensical) THEN
        theFavoriteHouse:=CARDINAL(placidus);
        enableFlagForThisHouse(theFavoriteHouse);
    END;

    flagInterpret:=FALSE;
    flagInterpretTradition:=FALSE;
    flagInterpretMix:=FALSE;

    (* ------------------------------------------------------------ *)

    initHierarchyAndZonesIndexes();   (* set new order and user defined zones, and set flag for angularities here *)

    (* ------------------------------------------------------------ *)

    IF (flagInterpret OR flagInterpretTradition) THEN
        hndTextes:=FIO.OpenRead(textes);
        FIO.AssignBuffer(hndTextes,ioBufferTextes);
    END;

    hndOut:=FIO.Create(reportfile);
    FIO.AssignBuffer(hndOut,ioBuffer);
    headertwo(ProgBanner,nicolaBanner); (* was : header(ProgBanner) *)
    doFixSomeFlags();

  eyeCandy(cmdSHOW);
    IF themenatal.typeof=unsafenatal THEN
        header (msgUnsafeChart);
    END;

  eyeCandy(cmdSHOW);
    IF flagData                   THEN dmpData; END;
  eyeCandy(cmdSHOW);
    IF flagSynthesis              THEN
        dmpSynthesis(domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagInSign                 THEN dmpInSign; END;
  eyeCandy(cmdSHOW);
    IF flagInHouse                THEN
        dmpInHouse(domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagInTrueHouse            THEN dmpInTrueHouse; END;
  eyeCandy(cmdSHOW);
    IF flagMotion                 THEN dmpMotion; END;
  eyeCandy(cmdSHOW);
    IF flagPlacidus               THEN dmpDom(placidus); END;
  eyeCandy(cmdSHOW);
    IF flagNonsensical                THEN dmpDom(nonsensical); END;
  eyeCandy(cmdSHOW);
    IF flagKoch                   THEN dmpDom(koch); END;
  eyeCandy(cmdSHOW);
    IF flagCampanus               THEN dmpDom(campanus); END;
  eyeCandy(cmdSHOW);
    IF flagRegiomontanus          THEN dmpDom(regiomontanus); END;
  eyeCandy(cmdSHOW);
    IF flagPtolemeus              THEN dmpDom(ptolemeus); END;

  eyeCandy(cmdSHOW);
    IF flagInRETzone              THEN dmpInRETzone; END;
  eyeCandy(cmdSHOW);
    IF flagRETfamilies            THEN dmpFamilies; END;
  eyeCandy(cmdSHOW);
    IF flagRETsigns               THEN dmpRETsigns; END;

  eyeCandy(cmdSHOW);
    IF flagByAspect               THEN dmpByAspect(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByAspectWithFictitious THEN dmpByAspect(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagByObject               THEN dmpByObject(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByObjectWithFictitious THEN dmpByObject(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagByAspectWithBeta       THEN dmpByAspectWithBeta(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByAspectWithBetaWithAngles THEN dmpByAspectWithBeta(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagByObjectWithBeta       THEN dmpByObjectWithBeta(FALSE); END;
  eyeCandy(cmdSHOW);
    IF flagByObjectWithBetaWithAngles THEN dmpByObjectWithBeta(TRUE); END;
  eyeCandy(cmdSHOW);
    IF flagAngularities           THEN dmpAngularities(OrbeAngulaireAS,OrbeAngulaireMC,OrbeAngulaireDS,OrbeAngulaireFC); END;
  eyeCandy(cmdSHOW);
    IF flagCoefficients           THEN
        dmpCoefficients(FALSE,domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagCoefficientsWithFictitious THEN
        dmpCoefficients(TRUE,domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagTradition              THEN
        dmpTradition(domificationtype(theFavoriteHouse));
    END;
  eyeCandy(cmdSHOW);
    IF flagAnalysisRET            THEN dmpAnalysisRET; END;
  eyeCandy(cmdSHOW);
    IF flagGeocentric             THEN dmpGeocentric; END;
  eyeCandy(cmdSHOW);
    IF flagEquatorial             THEN dmpEquatorial; END;
  eyeCandy(cmdSHOW);
    IF flagLocal                  THEN dmpLocal; END;
  eyeCandy(cmdSHOW);
    IF flagHeliocentric           THEN dmpHeliocentric; END;
  eyeCandy(cmdSHOW);
    IF flagInterpret              THEN
    END;
  eyeCandy(cmdSHOW);
    IF flagInterpretTradition          THEN
    END;

    header(ProgBanner);

    FIO.Flush(hndOut);
    FIO.Close(hndOut);

    IF (flagInterpret OR flagInterpretTradition) THEN FIO.Close(hndTextes); END;

  eyeCandy(cmdStop);
  video(pleasewait,FALSE);
  PATIENCE:=FALSE;

    WrLn;
    WrStr(ProgBanner);
    WrLn;

    WrLn;
    WrStr("Le fichier ");
    WrStr(reportfile);
    WrStr(" contient le rapport R.E.T. !");
    WrLn;

    abort(errNone,"");
END RET.






