
(* ---------------------------------------------------------------
Title         Q&D CRLF
Author        PhG
Overview      fix CR/LF from Unix and the like...
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              trimming is best left to TRIM

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              yes, yes, we know a few int $13 calls
              could be replaced with Win32 API calls

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
              -q (note verbose mode had to be remed out)

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              crap parser does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Bugs          doFixCRLFCRLF() does not remove CRLFCRLF at start of text
Wish List     -cr and -lf to change EOF sequence ?
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 27 Nov 15 v0.9a fixed a few USELESS missing ELSEs for CASEs : damn you, ISO !
PhG 14 Nov 15 an ugly really Q&D port from CRLF v1.1n for DOS
--------------------------------------------------------------- *)

MODULE CRLF;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE fileGetFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END fileGetFileSize;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;




(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    USELESS = FALSE; (* TRUE to reenable useless FIO.EOF check *)
CONST
    ProgEXEname   = "CRLF32";
    ProgTitle     = "Q&D CRLF (Win32)";
    ProgVersion   = "v0.9a (from v1.1n for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    twirldot      = "." ; (* was CHR(249) but it's ugly with vindoze *)
    extBAK        = ".BK!";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    skippedextensions = extBAK+delim+extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extZIP+delim+extARJ+delim+extLZH;
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errMissingName  = 4;
    errTooManyFiles = 5;
    errNoMatch      = 6;
    errBadExt       = 7;
    errConflict     = 8;
    errPerform      = 9;
    errPerformZ     = 10;
    errUserAborted  = 255;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg=
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <file(s)> [option]..."+nl+
nl+
"This program performs various operations related to CR ($0d) and LF ($0a)."+nl+
nl+
"  -n     replace single character end-of-line (CR or LF) with CRLF (default)"+nl+
"  -r     remove CRLFCRLF sequences"+nl+
"  -p     pack all CRLF sequences"+nl+
"  -pp    leave only first CRLFCRLF sequence"+nl+
"  -l     filter out each empty line"+nl+
"  -ll    same as -l but leaving first CRLFCRLF sequence (first empty line)"+nl+
"  -w     replace CRCRLF sequences with CRLF"+nl+
"  -ww    replace CRCRLF sequences with CRLFCRLF"+nl+
"  -a[!]  append CRLF at end of file if sequence does not exist"+nl+
"  -aa[!] change existing single CRLF at end of file to CRLFCRLF"+nl+
"  -aaa   apply -a option then -aa option"+nl+
"  -z[!]  remove trailing Ctrl-Z ($1a)"+nl+
"  -zz    replace trailing Ctrl-Z ($1a) with CRLF"+nl+
"  -!     list files requiring a change (-a[a] and -z only)"+nl+
nl+
"a) "+skippedextensions+" files will be ignored."+nl+
"b) For user safety, each original file is kept with "+extBAK+" extension."+nl+
"   However, note -a[a[a]] and -z[z] options do not create any backup."+nl+
"c) -l[l] assumes each line is not longer than 4096 characters."+nl+
"d) CRCRLF sequences are often found in HTML files."+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOption :
        Str.Concat(S,"Unknown ",einfo);
        Str.Append(S," option !");
    | errTooManyParms :
        Str.Concat(S,"Uneeded ",einfo);
        Str.Append(S," parameter !");
    | errMissingName :
        S := "Missing file specification !";
    | errTooManyFiles :
        Str.Concat(S,'Too many files match "',einfo);
        Str.Append(S,'" specification ');
    | errNoMatch :
        Str.Concat(S,'No legal file matches "',einfo);
        Str.Append(S,'" specification !');
    | errBadExt :
        S:="File extension would prevent file(s) from being processed !";
    | errConflict:
        S:="Please specify only one processing command !";
    | errPerform:
        S:="-! option is a nonsense with -aaa option !";
    | errPerformZ:
        S:="-! option is a nonsense with -zz option !";
    | errUserAborted:
        S := "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE  e OF
    | errNone, errHelp:
        ;
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE legalextension (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN

    Str.Caps(S); (* ah, lowercase LFNs... *)

    rc:=TRUE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        IF Str.Pos(S,e3) # MAX(CARDINAL) THEN rc:=FALSE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END legalextension;

(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    (* //XDS IF Available(needed)=FALSE THEN RETURN FALSE; END; *)
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        spec:pathtype;skipext:ARRAY OF CHAR):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    includeme:BOOLEAN;
BEGIN
    count:=0;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name); (* //XDS TS field is Name with a N ! *)
        includeme := NOT( isReservedEntry(entryname) ); (* skip "." and ".." *)
        includeme := includeme AND legalextension(entryname,skipext);
        IF includeme THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN (* //XDS aD seems reserved by XDS *)
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := SHORTCARD(len);
                Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    CR = cr;
    LF = lf;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC; (* //XDS BYTE was too easy *)
VAR
    bufferIn : ioBuffer;
    bufferOut: ioBuffer;

(* ------------------------------------------------------------ *)

PROCEDURE doFixCRs (source,target:pathtype;maxSequence : CARDINAL );
VAR
    hndIn : FIO.File;
    hndOut: FIO.File;
    got   : CARDINAL;
    ch	  : CHAR;
    last  : CHAR;
    status: (waiting,wasCR);
    sequence:CARDINAL;
    fsize : LONGCARD;
BEGIN
    hndIn :=FIO.OpenRead(source);
    FIO.AssignBuffer(hndIn,bufferIn);
    hndOut:=FIO.Create(target);
    FIO.AssignBuffer(hndOut,bufferOut);
    FIO.EOF:=FALSE;
    status:=waiting;

    CASE maxSequence OF
    | 1 : sequence := 1; (* v1.1j -p fix *)
    | 2 : sequence := 0;
    ELSE
          sequence := 0;
    END;

    LOOP
        (*%T USELESS *) IF FIO.EOF=TRUE THEN EXIT; END; (*%E *)
        got:=FIO.RdBin(hndIn,ch,1);
        IF got # 1 THEN EXIT;END;
        CASE status OF
        | waiting :
            CASE ch OF
            | CR :
                status:=wasCR;
            ELSE
                FIO.WrChar(hndOut,ch);
                sequence:=0;
            END;
        | wasCR :
            CASE ch OF
            | LF :
                IF sequence < maxSequence THEN
                    FIO.WrChar(hndOut,CR);
                    FIO.WrChar(hndOut,LF);
                END;
                INC(sequence);
                status:=waiting;
            ELSE
                FIO.WrChar(hndOut,CR); (* was pending *)
                FIO.WrChar(hndOut,ch);
                sequence:=0;
                status:=waiting;
            END;
        ELSE
            ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
        END;
    END;
    CASE status OF
    | wasCR:     FIO.WrChar(hndOut,CR);
    ELSE
       ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
    END;

    FIO.Flush(hndOut);
    FIO.Close(hndOut);
    FIO.Close(hndIn);
END doFixCRs;

(* ------------------------------------------------------------ *)

PROCEDURE doFixCRLFCRLF (source,target:pathtype);
VAR
    hndIn : FIO.File;
    hndOut: FIO.File;
    got   : CARDINAL;
    ch	  : CHAR;
    status: (waiting,wasCR,wasCRLF,wasCRLFCR);
    fsize : LONGCARD;
BEGIN
    hndIn :=FIO.OpenRead(source);
    FIO.AssignBuffer(hndIn,bufferIn);
    hndOut:=FIO.Create(target);
    FIO.AssignBuffer(hndOut,bufferOut);
    FIO.EOF:=FALSE;

    status:=waiting;

    LOOP
        (*%T USELESS *) IF FIO.EOF=TRUE THEN EXIT; END; (*%E *)
        got:=FIO.RdBin(hndIn,ch,1);
        IF got # 1 THEN EXIT;END;
        CASE status OF
        | waiting :
            IF ch=CR THEN
                status:=wasCR;
            ELSE
                FIO.WrChar(hndOut,ch);
            END;
        | wasCR :
            IF ch=LF THEN
                status:=wasCRLF;
            ELSE
                FIO.WrChar(hndOut,CR);
                FIO.WrChar(hndOut,ch);
                status:=waiting;
            END;
        | wasCRLF :
            IF ch=CR THEN
                status:=wasCRLFCR;
            ELSE
                FIO.WrChar(hndOut,CR);
                FIO.WrChar(hndOut,LF);
                FIO.WrChar(hndOut,ch);
                status:=waiting;
            END;
        | wasCRLFCR :
            IF ch=LF THEN
                FIO.WrChar(hndOut,CR);
                FIO.WrChar(hndOut,LF);
                status:=waiting;
            ELSE
                FIO.WrChar(hndOut,CR);
                FIO.WrChar(hndOut,LF);
                FIO.WrChar(hndOut,CR);
                FIO.WrChar(hndOut,ch);
                status:=waiting;
            END;
        ELSE
            ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
        END;
    END;
    IF status = wasCRLFCR THEN
        FIO.WrChar(hndOut,CR);
        FIO.WrChar(hndOut,LF);
    END;

    FIO.Flush(hndOut);
    FIO.Close(hndOut);
    FIO.Close(hndIn);
END doFixCRLFCRLF;

(* ------------------------------------------------------------ *)

PROCEDURE doFixCRorLF (source,target:pathtype);
VAR
    hndIn : FIO.File;
    hndOut: FIO.File;
    got   : CARDINAL;
    ch	  : CHAR;
    wasCR : BOOLEAN;
    fsize : LONGCARD;
BEGIN

    hndIn :=FIO.OpenRead(source);
    FIO.AssignBuffer(hndIn,bufferIn);
    hndOut:=FIO.Create(target);
    FIO.AssignBuffer(hndOut,bufferOut);
    FIO.EOF:=FALSE;
    wasCR:=FALSE;
    LOOP
        (*%T USELESS *) IF FIO.EOF=TRUE THEN EXIT; END; (*%E *)
        got:=FIO.RdBin(hndIn,ch,1);
        IF got # 1 THEN EXIT;END;

        CASE ch OF
        | CR :
            IF wasCR THEN
                FIO.WrChar (hndOut,LF); (* cr LF CR *)
            ELSE
                wasCR := TRUE;
            END;
        | LF :
            IF wasCR = FALSE THEN
                FIO.WrChar (hndOut,CR); (* cr LF *)
            ELSE
                wasCR := FALSE;
            END;
        ELSE
            IF wasCR THEN
                FIO.WrChar (hndOut,LF); (* CR LF *)
                wasCR := FALSE;
            END;
        END;
        FIO.WrChar (hndOut,ch);
    END;
    IF wasCR THEN
        FIO.WrChar (hndOut,LF);
    END;
(*
    FIO.WrStr(hndOut,CR_LF); (* just in case ! *)
*)
    FIO.Flush(hndOut);
    FIO.Close(hndOut);
    FIO.Close(hndIn);
END doFixCRorLF;

(* ------------------------------------------------------------ *)

PROCEDURE doFixStrings (keepfirstcrlfcrlf:BOOLEAN;
                       source,target:pathtype);
VAR
    hndIn : FIO.File;
    hndOut: FIO.File;
    hugestr:str4096;
    wasempty:BOOLEAN;
    fsize : LONGCARD;
BEGIN
    wasempty:=FALSE;

    hndIn :=FIO.OpenRead(source);
    FIO.AssignBuffer(hndIn,bufferIn);
    hndOut:=FIO.Create(target);
    FIO.AssignBuffer(hndOut,bufferOut);
    FIO.EOF:=FALSE;

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hndIn,hugestr);
        IF Str.Length(hugestr) > 0 THEN
            FIO.WrStr (hndOut,hugestr);  FIO.WrLn(hndOut);
            wasempty:=FALSE;
        ELSE
            IF keepfirstcrlfcrlf THEN
               IF wasempty=FALSE THEN
                   FIO.WrLn(hndOut);
                   wasempty:=TRUE;
               END;
            END;
        END;
    END;

    FIO.Flush(hndOut);
    FIO.Close(hndOut);
    FIO.Close(hndIn);
END doFixStrings;

(* ------------------------------------------------------------ *)

PROCEDURE doFixCRCRLF (source,target:pathtype;count:CARDINAL);
VAR
    hndIn : FIO.File;
    hndOut: FIO.File;
    i,got   : CARDINAL;
    ch	  : CHAR;
    fsize : LONGCARD;
    status:(waiting,gotcr,gotcrcr);
BEGIN

    hndIn :=FIO.OpenRead(source);
    FIO.AssignBuffer(hndIn,bufferIn);
    hndOut:=FIO.Create(target);
    FIO.AssignBuffer(hndOut,bufferOut);
    FIO.EOF:=FALSE;
    status:=waiting;
    LOOP
        (*%T USELESS *) IF FIO.EOF THEN EXIT; END; (*%E *)
        got:=FIO.RdBin(hndIn,ch,1);
        IF got # 1 THEN EXIT;END;

        CASE status OF
        | waiting:
            IF ch=CR THEN
                status:=gotcr;
            ELSE
                FIO.WrChar (hndOut,ch);
            END;
        | gotcr:
            IF ch=CR THEN
                status:=gotcrcr;
            ELSE
                FIO.WrChar (hndOut,cr);
                FIO.WrChar (hndOut,ch);
                status:=waiting;
            END;
        | gotcrcr:
            IF ch=LF THEN
                FOR i:=1 TO count DO
                    FIO.WrStr(hndOut,nl);
                END;
            ELSE
                FIO.WrStr (hndOut,cr+cr);
                FIO.WrChar(hndOut,ch);
            END;
            status:=waiting;
        ELSE
            ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
        END;
    END;
    CASE status OF
    | waiting:
        ;
    | gotcr:
        FIO.WrChar(hndOut,cr);
        FIO.WrChar(hndOut,lf);             (* better nl than cr alone ! *)
    | gotcrcr:
                FOR i:=1 TO count DO
                    FIO.WrStr(hndOut,nl);
                END;
    ELSE
        ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
    END;

(*
    FIO.WrStr(hndOut,CR_LF); (* just in case ! *)
*)
    FIO.Flush(hndOut);
    FIO.Close(hndOut);
    FIO.Close(hndIn);
END doFixCRCRLF;

(* ------------------------------------------------------------ *)

CONST
    lencrlf = 1+1;

CONST
    opAppend         = 1; (* append CRLF at EOF if none found *)
    opForce          = 2; (* change single CRLF at EOF to CRLFCRLF *)
    opAppendAndForce = 3; (* 1 then 2 *)

PROCEDURE doFixAppend (performop:BOOLEAN;source:pathtype;op:CARDINAL);
CONST
    msgFixed   = "+++ Fixed ";
    msgInfo    = "::: ";
    msgMissing = "missing final CRLF : |";
    msgSingle  = "single final CRLF  : |";
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
    got:CARDINAL;
    CRLFatEOF,singleCRLFatEOF:BOOLEAN;
    b : str2;
    S : str1024; (* room for LFN *)
BEGIN
    fsize:= fileGetFileSize(source);
    hnd :=FIO.Open(source);
    FIO.AssignBuffer(hnd,bufferIn);

    CRLFatEOF       := FALSE;
    singleCRLFatEOF := FALSE;

    IF fsize >= lencrlf THEN (* fsize is 2 or longer *)
        FIO.Seek(hnd,fsize-lencrlf);
        got := FIO.RdBin(hnd,b,lencrlf);
        CRLFatEOF :=  ( (b[0] = cr) AND (b[1] = lf) );
        IF CRLFatEOF THEN
            IF fsize >= (lencrlf+1) THEN (* fsize is 3 or longer *)
                FIO.Seek(hnd,fsize-lencrlf-1);
                got:=FIO.RdBin(hnd,b,1);
                singleCRLFatEOF :=  (b[0] # lf); (* minimal but should do *)
            END;
        END;
    END;

    CASE op OF
    | opAppend,opAppendAndForce:
        IF CRLFatEOF = FALSE THEN
            S:=msgMissing;
            Str.Subst(S,"|",dquote+vbar+dquote);
            Str.Subst(S,"|",source);
            IF performop THEN
                Str.Prepend(S,msgFixed);
                FIO.Seek(hnd,fsize);
                FIO.WrBin(hnd,nl,lencrlf);
                FIO.Flush(hnd);
                (* update then recheck *)
                INC(fsize,lencrlf);
                CRLFatEOF := TRUE; (* useless *)
                IF fsize >= (lencrlf+1) THEN (* fsize is 3 or longer *)
                    FIO.Seek(hnd,fsize-lencrlf-1);
                    got:=FIO.RdBin(hnd,b,1);
                    singleCRLFatEOF :=  (b[0] # lf); (* minimal but should do *)
                END;
            ELSE
                S[0]:=CAP(S[0]);
                Str.Prepend(S,msgInfo);
            END;
            WrStr(S);WrLn;
        END;
    ELSE
       ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
    END;

    CASE op OF
    | opForce,opAppendAndForce:
        IF singleCRLFatEOF THEN
            S:=msgSingle;
            Str.Subst(S,"|",dquote+vbar+dquote);
            Str.Subst(S,"|",source);
            IF performop THEN
                Str.Prepend(S,msgFixed);
                FIO.Seek(hnd,fsize);
                FIO.WrBin(hnd,nl,lencrlf);
                FIO.Flush(hnd);
            ELSE
                S[0]:=CAP(S[0]);
                Str.Prepend(S,msgInfo);
            END;
            WrStr(S);WrLn;
        END;
    ELSE
        ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
    END;

    FIO.Flush(hnd);
    FIO.Close(hnd);

END doFixAppend;

(* ------------------------------------------------------------ *)

CONST
    opKill    = 1;
    opReplace = 2;

PROCEDURE doCtrlZ (performop:BOOLEAN;source:pathtype;op:CARDINAL);
CONST
    ctrlZ      = CHR(26);
    msgDeleted = "+++ Deleted ";
    msgReplaced= "+++ Replaced ";
    msgInfo    = "::: ";
    msgFound   = "final Ctrl-Z : |";
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
    got:CARDINAL;
    b : SHORTCARD; (* byte *)
    S : str1024; (* room for LFN *)
BEGIN
    fsize:= fileGetFileSize(source);
    hnd :=FIO.Open(source);
    FIO.AssignBuffer(hnd,bufferIn);

    IF fsize # 0 THEN
        FIO.Seek(hnd,fsize-1);
        got:=FIO.RdBin(hnd,b,SIZE(b));
        IF b = ORD(ctrlZ) THEN
            S:=msgFound;
            Str.Subst(S,"|",dquote+vbar+dquote);
            Str.Subst(S,"|",source);
            IF performop THEN
                FIO.Seek(hnd,fsize-1);
                CASE op OF
                | opKill:
                    FIO.Truncate(hnd);
                    Str.Prepend(S,msgDeleted);
                | opReplace:
                    FIO.WrBin(hnd,nl,lencrlf);
                    Str.Prepend(S,msgReplaced);
		ELSE
         	    ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
                END;
            ELSE
                S[0]:=CAP(S[0]);
                Str.Prepend(S,msgInfo);
            END;
            WrStr(S);WrLn;
        END;
    END;

    FIO.Flush(hnd);
    FIO.Close(hnd);

END doCtrlZ;

(* ------------------------------------------------------------ *)

PROCEDURE buildPath (VAR path:pathtype; spec:pathtype);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec, u,d,n,e);
    Str.Concat(path, u,d);
    fixDirectory(path); (* safety *)
END buildPath;

(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (doCmdDefault,
               doCRLFCRLF,doCRs1,doCRs2,
               doCRCRLF,doCRCRLFalt,
               doReadLine,doReadLineAlt,
               doAppendMissingLastCRLF,doLastCRLFtoCRLFCRLF,doAppendAndForce,
               doKillCtrlZ,doReplaceCtrlZ);

PROCEDURE newcmd (VAR cmd:cmdtype;newcmd:cmdtype ):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    rc:=TRUE;
    IF cmd=newcmd THEN RETURN rc;END;
    IF cmd=doCmdDefault THEN
        cmd:=newcmd;
    ELSE
        rc:=FALSE;
    END;
    RETURN rc;
END newcmd;

(* ------------------------------------------------------------ *)

CONST
    msgProcessing = "Processing ";
    msgNow = " : ";
    msgOK = "done !";
VAR
    cmd : cmdtype;
VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    opt       : CARDINAL;
    S,R,spec,path:pathtype;
    found     : BOOLEAN;

    anchor,ptr:pFname;
    p    : CARDINAL;
    countFile : CARDINAL;
    state  :(waiting,gotspec);
    performop,createbak,userAborted   : BOOLEAN;
BEGIN
    FIO.IOcheck := FALSE;

    WrLn;

    performop := TRUE;
    cmd       := doCmdDefault;
    state     := waiting;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "R"+delim+"REMOVE"+delim+
                                 "P"+delim+"PACK"+delim+
                                 "PP"+delim+
                                 "Q"+delim+"QUIET"+delim+
                                 "L"+delim+"STRINGMODE"+delim+
                                 "LL"+delim+
                                 "W"+delim+"WEB"+delim+
                                 "N"+delim+"DEFAULT"+delim+
                                 "WW"+delim+
                                 "A"+delim+"APPEND"+delim+
                                 "AA"+delim+
                                 "AAA"+delim+
                                 "A!"+delim+"APPEND!"+delim+
                                 "AA!"+delim+
                                 "!"+delim+"LIST"+delim+
                                 "X"+delim+"LFN"+delim+
                                 "Z"+delim+"CTRLZ"+delim+
                                 "ZZ"+delim+
                                 "Z!"+delim+"CTRLZ!"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5 :   IF newcmd(cmd,doCRLFCRLF)=FALSE THEN abort(errConflict,"");END;
            | 6,7:    IF newcmd(cmd,doCRs1)=FALSE THEN abort(errConflict,"");END;
            | 8:      IF newcmd(cmd,doCRs2)=FALSE THEN abort(errConflict,"");END;
            | 9,10:   abort(errOption,S);
            | 11,12:  IF newcmd(cmd,doReadLine)=FALSE THEN abort(errConflict,"");END;
            | 13:     IF newcmd(cmd,doReadLineAlt)=FALSE THEN abort(errConflict,"");END;
            | 14,15:  IF newcmd(cmd,doCRCRLF)=FALSE THEN abort(errConflict,"");END;
            | 16,17:  IF newcmd(cmd,doCmdDefault)=FALSE THEN abort(errConflict,"");END;
            | 18:     IF newcmd(cmd,doCRCRLFalt)=FALSE THEN abort(errConflict,"");END;

            | 19,20:  IF newcmd(cmd,doAppendMissingLastCRLF)=FALSE THEN abort(errConflict,"");END;
            | 21:     IF newcmd(cmd,doLastCRLFtoCRLFCRLF)=FALSE THEN abort(errConflict,"");END;
            | 22:     IF newcmd(cmd,doAppendAndForce)=FALSE THEN abort(errConflict,"");END;

            | 23,24:  IF newcmd(cmd,doAppendMissingLastCRLF)=FALSE THEN abort(errConflict,"");END;
                      performop := FALSE;
            | 25:     IF newcmd(cmd,doLastCRLFtoCRLFCRLF)=FALSE THEN abort(errConflict,"");END;
                      performop := FALSE;
            | 26,27:  performop := FALSE;
            | 28,29:  abort(errOption,S);
            | 30,31:  IF newcmd(cmd,doKillCtrlZ)=FALSE THEN abort(errConflict,"");END;
            | 32:     IF newcmd(cmd,doReplaceCtrlZ)=FALSE THEN abort(errConflict,"");END;
            | 33,34:  IF newcmd(cmd,doKillCtrlZ)=FALSE THEN abort(errConflict,"");END;
                      performop := FALSE;
            ELSE
                      abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(spec,S);
            | gotspec : abort(errTooManyParms,S);
	    ELSE
                ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
            END;
            INC(state);
        END;
    END;
    (* check nonsense *)

    IF state=waiting THEN abort(errMissingName,""); END;

    CASE cmd OF
    | doAppendAndForce : IF NOT(performop) THEN abort(errPerform,"");END;
    | doReplaceCtrlZ   : IF NOT(performop) THEN abort(errPerformZ,"");END;
    ELSE
        ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
    END;

    IF legalextension (spec,skippedextensions)=FALSE THEN abort(errBadExt,"");END;

    IF same(spec,".") THEN spec:="*.*"; END;
    IF Str.Match(spec,"*\") THEN Str.Append(spec,"*.*"); END;
    IF Str.Match(spec,"*\.") THEN
        i:=Str.Length(spec);
        spec[i-1]:=nullchar;
        Str.Append(spec,"*.*");
    END;

    initList(anchor);
    countFile:=buildFileList(anchor,spec,skippedextensions);
    IF countFile=MAX(CARDINAL) THEN abort(errTooManyFiles,spec);END; (* errStorage *)
    IF countFile=0 THEN abort(errNoMatch,spec); END;

    buildPath(path,  spec);

    WrStr(Banner);WrLn;
    WrLn;

    userAborted := FALSE;

    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(R,ptr);
        p := Str.RCharPos(R,dot);
        IF p # MAX(CARDINAL) THEN
            Str.Slice(S,R,0,p);
            Str.Copy(R,S);
        END;
        Str.Append(R,extBAK);
        Str.Prepend(R,path);

        getStr(S,ptr);
        Str.Prepend(S,path);

        CASE cmd OF
        | doAppendMissingLastCRLF, doLastCRLFtoCRLFCRLF, doAppendAndForce,
          doKillCtrlZ,doReplaceCtrlZ:
            createbak:=FALSE;
        ELSE
            createbak:=TRUE;
        END;

        IF createbak THEN
            IF FIO.Exists(R) THEN
                fileSetRW(R);
                FIO.Erase(R);
            END;
            FIO.Rename(S,R);
            WrStr(msgProcessing);
            WrStr(dquote);
            WrStr(S);
            WrStr(dquote);
            WrStr(msgNow);
        END;

        CASE cmd OF
        | doCmdDefault :  doFixCRorLF(R,S);         (* -n yes ! *)
        | doCRLFCRLF :    doFixCRLFCRLF(R,S);       (* -r *)
        | doCRs1 :        doFixCRs(R,S,1);          (* -p *)
        | doCRs2 :        doFixCRs(R,S,2);          (* -pp *)
        | doReadLine:     doFixStrings(FALSE,R,S);  (* -l *)
        | doReadLineAlt:  doFixStrings(TRUE,R,S);   (* -ll *)
        | doCRCRLF:       doFixCRCRLF(R,S,1);       (* -w *)
        | doCRCRLFalt:    doFixCRCRLF(R,S,2);       (* -ww *)
        | doAppendMissingLastCRLF:
                          doFixAppend(performop,S,opAppend);         (* -a *)
        | doLastCRLFtoCRLFCRLF:
                          doFixAppend(performop,S,opForce);          (* -aa *)
        | doAppendAndForce:
                          doFixAppend(performop,S,opAppendAndForce); (* -aaa *)
        | doKillCtrlZ:    doCtrlZ(performop,S,opKill);       (* -z *)
        | doReplaceCtrlZ: doCtrlZ(performop,S,opReplace);    (* -zz *)
	ELSE
	    ; (* //XDS STUPID USELESS REQUIREMENT FOR ABSOLUTELY NOTHING EXCEPT SO-CALLED ACADEMIC WHIMS ! *)
        END;
        IF createbak THEN
            WrStr(msgOK);WrLn;
        END;

        userAborted:=ChkEscape();
        IF userAborted THEN
            freeList(anchor); (* cleaner *)
            abort(errUserAborted,"");
        END;

        ptr:=ptr^.next;
    END;

    freeList(anchor);

    abort(errNone,"");
END CRLF.