(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help

Notes         adler32 is not so fast as advertised !
              but yes, it's coded in m2 for now...
              should we zero adler32 buffer out of safety ?
              don't use NEW() to allocate arrays, for it crashes ungracefully
              note win9X accepts multiple dots in filenames (q&d hack/fix)

                         flushed cache   no cache   (500 files, 50Mb)
              crc32            19s          21s
              adler32          17s          19s
              fletcher         19s          21s
              fsize             2s           2s
              chkdata          20s          23s
              chkdata -g       18s          20s

              note xlarge model is much slower than compact :-(

              compact v1.3k   0mn 2.15s     1mn 22.06s
              xlarge  v1.3l   0mn 4.51s     3mn 30.42s
              compact v1.3m   0mn 2.36s     1mn 29.70s (adler and fletcher disabled)

              funny : MD5 collisions have been discovered,
              and now many bozos say "horror ! unsecure ! obsolete !"
              they don't seem to have thought of using MORE than one method
              in order to check data (CRC32+MD5, MD5+SHA, etc.)
              finding collisions able to fool several checksums/digests
              would require at least a god ! once again, common sense...

              we use SHA-1 here

              v1.3p options -! and -b are NOT checked for noNonsense

Bugs          well, implementation quirk in fact : as we use CARDINALs,
              we won't check more than 65535-1 files even with -d option

              weird compiler bug : now we've added MD5, xlarge model
              with -v forces a random log not found error !!!

              not really a bug but when computing checksums,
              CS bargraph display is pertinent to directories,
              NOT to files !

              warning ! listModified() should be checked :
              when in quick (unsafe) mode, when using disk,
              we can flag as "##" files which have not changed
              (related to crc=0 or same size found elsewhere ?)
              (csquick displays modified files which have not changed,
              while csall works !)

              with XP crap, extremely complex and/or deep directory structures
              may force errorinf.$$$ creation and other crashes about farheap corrupted
              (who said it was foolish to expect real DOS console support from m$ ?)

              setting useINLINE to TRUE in QD_MD5 would add 12Kb !

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
	          (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

	          many functions had to be dumped because of stupid XDS limits and choices
	          remember only DOS version (both executable and source code)
	          is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -w
              -lfn
              -mem
              modifications of output when redirected is no longer handled

              a few DOS-specific limits have been increased (string length,
	      array limits -- 100 to 1000, 5000 to 16380)

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
	          the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
	          requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
	          with so many warnings, the crap compiler is not even able
	          to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

	      passim : still the ELSE crappy TERNARY BOOLEAN gag... and others...
	      ignoring overflow in project is required : else, program crashes !
	      crappy TS compatibility mode does not warn about TS directives !!!

	      XDS parser won't catch a LONGCARD being passed to a SHORTCARD !
              (seen in date/time functions where they have broken compatibility)

              tables for ASCII and OEM have not yet been fully checked
	      note entry conversion will not be perfect,
	      for many chars do not have an exact match from one set to another
	      see //V09B

Wish List     ignore path ? change unit ? (see CHKDATA)
              count number of log entries to autoset -d if more than 16380 files ?
              working() when comparing without redirection ?
              chkEscape() while comparing logs ?
              we'll need more pathtype vars
              alternate log line format : "method value path" without header ?
              (i.e. "CRC32 [$]######## u:...")
              autofind checksum type even without header ?
              yes, rebuild could be smarter using a file list and a method

              fix long paths staying if candy ON ("please wait while processing ")
              add quotes (breaking one more time CS output)
              create a lowercasealt() for win32

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG  9 Oct 16 v0.9b now defaulting to converting ASCII2OEM for cs.ini and log (-v)
              added -# not to perform any conversion
PhG 10 Sep 16 v0.9a now requiring CS32.INI instead of CS.INI
PhG 20 Jan 16 an ugly really Q&D port from CS v1.3s for DOS
--------------------------------------------------------------- *)

MODULE cs32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr, WrLn, WrLngCard;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    specialchar = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | specialchar :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;

(* assume screen width is 80 *)

PROCEDURE cooked (VAR R:pathtype;
		 quoted,shortened:BOOLEAN; wiscreen,wimsg:CARDINAL; S:pathtype);
VAR
    len:CARDINAL;
BEGIN
    Str.Copy(R,S);
    IF quoted THEN
        Str.Append(R,dquote);
	Str.Prepend(R,dquote);
    END;
    IF shortened THEN

    END;
END cooked;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //FIXME
<* PUSH *>
<* COVERFLOW = "OFF"  *>
<* IOVERFLOW = "OFF"  *>
*)

(* // QD_MD5 *)

CONST
    MD5firstDigestNdx = 0;
    MD5lastDigestNdx  = 15;
TYPE
    MD5str        = ARRAY [0..31] OF CHAR;
    MD5digestType = ARRAY [MD5firstDigestNdx..MD5lastDigestNdx] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)

TYPE
    MDstatetype = RECORD
        CASE : BOOLEAN OF
        | TRUE : a,b,c,d: LONGCARD;
        | FALSE: digest : MD5digestType;
	ELSE
	    ;
        END;
    END;
    count64type = RECORD
        lo,hi:LONGCARD;
    END;
    MDblocktype = ARRAY [0..15] OF LONGCARD; (* 0..63 BYTE *)
    MDpblock = POINTER TO MDblocktype; (* no generic POINTER TYPE ! *)
    MD5contextType = RECORD
        state : MDstatetype;   (* ABCD *)
        count : count64type; (* bits modulo 2^64, lsb first *)
    END;

(* ------------------------------------------------------------ *)

CONST
    MDioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    MDfirstioBufferByte = 1;
    MDlastioBufferByte  = MDioBufferSize;
TYPE
    MDioBufferType  = ARRAY [MDfirstioBufferByte..MDlastioBufferByte] OF SYSTEM.LOC;
VAR
    MDsourceBuffer : MDioBufferType;

CONST
    MDfirstDataByte = 0;
    MDlastDataByte  = 8*512-1; (* 4Kb + 64 *)
    MDdataBufferSize= MDlastDataByte - MDfirstDataByte + 1;
TYPE
    MDdataBufferType = ARRAY [MDfirstDataByte..MDlastDataByte+SIZE(MDblocktype)] OF SYSTEM.LOC; (* 8Kb+64 *)
VAR
    MDdataBuffer : MDdataBufferType; (* globerk *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    maphex = "0123456789abcdef"; (* already beautified for readability *)

(* 16 bytes to 32 chars *)

PROCEDURE MD5toString (VAR R:MD5str; digest:MD5digestType);
VAR
    i,v : CARDINAL;
    lo,hi:CHAR;
BEGIN
    Str.Copy(R,"");
    FOR i:=MD5firstDigestNdx TO MD5lastDigestNdx DO
        v:=CARDINAL( digest[i] );
        lo:=maphex[ v AND 0FH];
        hi:=maphex[ v >> 4 ];
        Str.Append(R,hi);
        Str.Append(R,lo);
    END;
END MD5toString;

(* assume legal 32 hex chars string has been checked to [0..9a..f] ! *)

PROCEDURE stringToMD5 (S:MD5str):MD5digestType;
VAR
    digest:MD5digestType;
    i,ndx,v,vlo,vhi:CARDINAL;
BEGIN
    Str.Lows(S); (* safety *)
    ndx:=0;
    FOR i:=MD5firstDigestNdx TO MD5lastDigestNdx DO
        vlo:=Str.CharPos(maphex,S[ndx]);    IF ndx < MD5lastDigestNdx THEN INC(ndx); END;
        vhi:=Str.CharPos(maphex,S[ndx+1]);  IF ndx < MD5lastDigestNdx THEN INC(ndx); END;
        v:=(vhi << 4 ) + vlo;
        digest[i]:=SYSTEM.LOC(v);
    END;
    RETURN digest;
END stringToMD5;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE MD5init (VAR ctx:MD5contextType;bytecount:LONGCARD);
BEGIN
    ctx.state.a := 067452301H;
    ctx.state.b := 0EFCDAB89H;
    ctx.state.c := 098BADCFEH;
    ctx.state.d := 010325476H;
    ctx.count.lo:=bytecount << 3;      (* x8 : bytes to bits *)
    ctx.count.hi:=bytecount >> (32-3); (* keep 3 upper bits *)
END MD5init;

PROCEDURE xor (v1,v2 : LONGCARD  ) : LONGCARD;
TYPE
    dBITSET = SET OF [0..31];
BEGIN
    RETURN LONGCARD( dBITSET(v1) / dBITSET(v2) );
END xor;

PROCEDURE ROTATE_LEFT( x, n: LONGCARD):LONGCARD ;
BEGIN
    RETURN  ( (x << n) OR (x >> (32-n)) );
END ROTATE_LEFT;

PROCEDURE FF (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a,  ( (b AND c) OR ((NOT (b)) AND d) )  +x+ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END FF;

PROCEDURE GG (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a, ( (b AND d) OR (c AND (NOT (d))) ) +x+ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END GG;

PROCEDURE HH (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a, xor(xor(b,c),d) +x+ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END HH;

PROCEDURE II (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a, xor(c, (b OR (NOT (d)))) +x +ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END II;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE MD5Transform (VAR state:MDstatetype; p:MDpblock);
CONST
    S11 = 7;
    S12 =12;
    S13 =17;
    S14 =22;
    S21 = 5;
    S22 = 9;
    S23 =14;
    S24 =20;
    S31 = 4;
    S32 =11;
    S33 =16;
    S34 =23;
    S41 = 6;
    S42 =10;
    S43 =15;
    S44 =21;
VAR
    a,b,c,d:LONGCARD;
BEGIN
    a:= state.a;
    b:= state.b;
    c:= state.c;
    d:= state.d;

    (* Round 1 *)
    FF (a, b, c, d, p^[ 0], S11, 0D76AA478H); (*  1 *)
    FF (d, a, b, c, p^[ 1], S12, 0E8C7B756H); (*  2 *)
    FF (c, d, a, b, p^[ 2], S13, 0242070DBH); (*  3 *)
    FF (b, c, d, a, p^[ 3], S14, 0C1BDCEEEH); (*  4 *)
    FF (a, b, c, d, p^[ 4], S11, 0F57C0FAFH); (*  5 *)
    FF (d, a, b, c, p^[ 5], S12, 04787C62AH); (*  6 *)
    FF (c, d, a, b, p^[ 6], S13, 0A8304613H); (*  7 *)
    FF (b, c, d, a, p^[ 7], S14, 0FD469501H); (*  8 *)
    FF (a, b, c, d, p^[ 8], S11, 0698098D8H); (*  9 *)
    FF (d, a, b, c, p^[ 9], S12, 08B44F7AFH); (* 10 *)
    FF (c, d, a, b, p^[10], S13, 0FFFF5BB1H); (* 11 *)
    FF (b, c, d, a, p^[11], S14, 0895CD7BEH); (* 12 *)
    FF (a, b, c, d, p^[12], S11, 06B901122H); (* 13 *)
    FF (d, a, b, c, p^[13], S12, 0FD987193H); (* 14 *)
    FF (c, d, a, b, p^[14], S13, 0A679438EH); (* 15 *)
    FF (b, c, d, a, p^[15], S14, 049B40821H); (* 16 *)

    (* Round 2 *)
    GG (a, b, c, d, p^[ 1], S21, 0F61E2562H); (* 17 *)
    GG (d, a, b, c, p^[ 6], S22, 0C040B340H); (* 18 *)
    GG (c, d, a, b, p^[11], S23, 0265E5A51H); (* 19 *)
    GG (b, c, d, a, p^[ 0], S24, 0E9B6C7AAH); (* 20 *)
    GG (a, b, c, d, p^[ 5], S21, 0D62F105DH); (* 21 *)
    GG (d, a, b, c, p^[10], S22, 002441453H); (* 22 *)
    GG (c, d, a, b, p^[15], S23, 0D8A1E681H); (* 23 *)
    GG (b, c, d, a, p^[ 4], S24, 0E7D3FBC8H); (* 24 *)
    GG (a, b, c, d, p^[ 9], S21, 021E1CDE6H); (* 25 *)
    GG (d, a, b, c, p^[14], S22, 0C33707D6H); (* 26 *)
    GG (c, d, a, b, p^[ 3], S23, 0F4D50D87H); (* 27 *)
    GG (b, c, d, a, p^[ 8], S24, 0455A14EDH); (* 28 *)
    GG (a, b, c, d, p^[13], S21, 0A9E3E905H); (* 29 *)
    GG (d, a, b, c, p^[ 2], S22, 0FCEFA3F8H); (* 30 *)
    GG (c, d, a, b, p^[ 7], S23, 0676F02D9H); (* 31 *)
    GG (b, c, d, a, p^[12], S24, 08D2A4C8AH); (* 32 *)

    (* Round 3 *)
    HH (a, b, c, d, p^[ 5], S31, 0FFFA3942H); (* 33 *)
    HH (d, a, b, c, p^[ 8], S32, 08771F681H); (* 34 *)
    HH (c, d, a, b, p^[11], S33, 06D9D6122H); (* 35 *)
    HH (b, c, d, a, p^[14], S34, 0FDE5380CH); (* 36 *)
    HH (a, b, c, d, p^[ 1], S31, 0A4BEEA44H); (* 37 *)
    HH (d, a, b, c, p^[ 4], S32, 04BDECFA9H); (* 38 *)
    HH (c, d, a, b, p^[ 7], S33, 0F6BB4B60H); (* 39 *)
    HH (b, c, d, a, p^[10], S34, 0BEBFBC70H); (* 40 *)
    HH (a, b, c, d, p^[13], S31, 0289B7EC6H); (* 41 *)
    HH (d, a, b, c, p^[ 0], S32, 0EAA127FAH); (* 42 *)
    HH (c, d, a, b, p^[ 3], S33, 0D4EF3085H); (* 43 *)
    HH (b, c, d, a, p^[ 6], S34, 004881D05H); (* 44 *)
    HH (a, b, c, d, p^[ 9], S31, 0D9D4D039H); (* 45 *)
    HH (d, a, b, c, p^[12], S32, 0E6DB99E5H); (* 46 *)
    HH (c, d, a, b, p^[15], S33, 01FA27CF8H); (* 47 *)
    HH (b, c, d, a, p^[ 2], S34, 0C4AC5665H); (* 48 *)

    (* Round 4 *)
    II (a, b, c, d, p^[ 0], S41, 0F4292244H); (* 49 *)
    II (d, a, b, c, p^[ 7], S42, 0432AFF97H); (* 50 *)
    II (c, d, a, b, p^[14], S43, 0AB9423A7H); (* 51 *)
    II (b, c, d, a, p^[ 5], S44, 0FC93A039H); (* 52 *)
    II (a, b, c, d, p^[12], S41, 0655B59C3H); (* 53 *)
    II (d, a, b, c, p^[ 3], S42, 08F0CCC92H); (* 54 *)
    II (c, d, a, b, p^[10], S43, 0FFEFF47DH); (* 55 *)
    II (b, c, d, a, p^[ 1], S44, 085845DD1H); (* 56 *)
    II (a, b, c, d, p^[ 8], S41, 06FA87E4FH); (* 57 *)
    II (d, a, b, c, p^[15], S42, 0FE2CE6E0H); (* 58 *)
    II (c, d, a, b, p^[ 6], S43, 0A3014314H); (* 59 *)
    II (b, c, d, a, p^[13], S44, 04E0811A1H); (* 60 *)
    II (a, b, c, d, p^[ 4], S41, 0F7537E82H); (* 61 *)
    II (d, a, b, c, p^[11], S42, 0BD3AF235H); (* 62 *)
    II (c, d, a, b, p^[ 2], S43, 02AD7D2BBH); (* 63 *)
    II (b, c, d, a, p^[ 9], S44, 0EB86D391H); (* 64 *)

    INC(state.a,a);
    INC(state.b,b);
    INC(state.c,c);
    INC(state.d,d);
END MD5Transform;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume file exists ! *)

PROCEDURE ComputeMD5 (VAR digest:MD5digestType;S:pathtype);
VAR
    hin:FIO.File;
    ndx:CARDINAL; (* assume less than 64Kb buffer *)
    got:CARDINAL;
    done:BOOLEAN;
    ctx:MD5contextType;
BEGIN
    hin:=FIO.OpenRead(S);
    FIO.AssignBuffer(hin,MDsourceBuffer);
    done:=FALSE;
    MD5init(ctx, FIO.Size(hin));
    REPEAT
         got:=FIO.RdBin(hin,MDdataBuffer,MDdataBufferSize);
         IF got # MDdataBufferSize THEN
             MDdataBuffer[got]:= 080H;
             INC(got);
             WHILE (got MOD 64) # 56 DO
                 MDdataBuffer[ got ] := 0;
                 INC(got);
             END;

             Lib.Move(     SYSTEM.ADR(ctx.count), SYSTEM.ADR(MDdataBuffer[got]), 8);

             INC(got,8);
             done:=TRUE;
         END;
         ndx:=0;
         REPEAT
             MD5Transform( ctx.state, SYSTEM.ADR(MDdataBuffer[ndx]) );
             INC(ndx, SIZE(MDblocktype));
         UNTIL ndx=got;
    UNTIL done;
    FIO.Close(hin);
    digest:=ctx.state.digest;
END ComputeMD5;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_SHA *)

CONST
    SHAfirstDigestNdx = 0;
    SHAlastDigestNdx  = 19;
TYPE
    SHAstr        = ARRAY [0..39] OF CHAR; (* 20 bytes = 40 hex digits *)
    SHAdigestType = ARRAY [SHAfirstDigestNdx..SHAlastDigestNdx] OF SYSTEM.LOC;


(* FIPS PUB 180-1 keeping varnames, and without any optimization *)

TYPE
    SHAstatetype = RECORD
        CASE : BOOLEAN OF
        | TRUE : H0,H1,H2,H3,H4 : LONGCARD;
        | FALSE: digest : SHAdigestType;
	ELSE
	   ;
        END;
    END;
    (*
    count64type = RECORD
        lo,hi:LONGCARD;
    END;
    *)
    SHAcontextType = RECORD
        state : SHAstatetype;   (* H0 H1 H2 H3 H4 *)
        count : count64type; (* bits modulo 2^64 *)
    END;
CONST
    firstround    = 1-1;             (* 0 *)
    lastround     = (20*4)-1;        (* 79 *)
    lastroundbyte = (20*4*4)-1;      (* 319 *)
TYPE
    SHAcombotype = RECORD
        CASE : BOOLEAN OF
        | TRUE : dw : ARRAY [firstround..lastround] OF LONGCARD;
        | FALSE: b  : ARRAY [firstround..lastroundbyte] OF SYSTEM.LOC;
	ELSE
	    ;
        END;
    END;
    SHAblocktype = RECORD
        CASE : BOOLEAN OF
        | TRUE : dw : ARRAY [0..15] OF LONGCARD;
        | FALSE: b  : ARRAY [0..63] OF SYSTEM.LOC;     (* 512 bits = 64 bytes = 16 dwords *)
	ELSE
	    ;
        END;
    END;
    ptrToSHABlockType = POINTER TO SHAblocktype; (* no generic POINTER type ! *)
CONST
    SHABLOCKSIZE = SIZE (SHAblocktype);

(* ------------------------------------------------------------ *)

VAR
    K : ARRAY [firstround..lastround] OF LONGCARD;
    W : SHAcombotype;

(* ------------------------------------------------------------ *)

CONST
    SHAioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    SHAfirstioBufferByte = 1;
    SHAlastioBufferByte  = SHAioBufferSize;
TYPE
    SHAioBufferType  = ARRAY [SHAfirstioBufferByte..SHAlastioBufferByte] OF SYSTEM.LOC;
VAR
    SHAsourceBuffer : SHAioBufferType;

CONST
    SHAfirstDataByte = 1-1; (* yes, it's 0 *)
    SHAlastDataByte  = 8*512-1; (* 4Kb *)
    SHAdataBufferSize= SHAlastDataByte - SHAfirstDataByte + 1;
TYPE
    SHAdataBufferType = ARRAY [SHAfirstDataByte..SHAlastDataByte+SHABLOCKSIZE] OF SYSTEM.LOC; (* 4Kb+64 *)
VAR
    SHAdataBuffer : SHAdataBufferType; (* globerk *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* 20 bytes to 40 chars *)

PROCEDURE SHAtoString (VAR R:SHAstr; digest:SHAdigestType);
VAR
    i,v : CARDINAL;
    lo,hi:CHAR;
BEGIN
    Str.Copy(R,"");
    FOR i:=SHAfirstDigestNdx TO SHAlastDigestNdx DO
        v:=CARDINAL( digest[i] );
        lo:=maphex[ v AND 0FH];
        hi:=maphex[ v >> 4 ];
        Str.Append(R,hi);
        Str.Append(R,lo);
    END;
END SHAtoString;

(* assume legal 40 hex chars string has been checked to [0..9a..f] ! *)

PROCEDURE stringToSHA (S:SHAstr):SHAdigestType;
VAR
    digest:SHAdigestType;
    i,ndx,v,vlo,vhi:CARDINAL;
BEGIN
    Str.Lows(S); (* safety *)
    ndx:=0;
    FOR i:=SHAfirstDigestNdx TO SHAlastDigestNdx DO
        vlo:=Str.CharPos(maphex,S[ndx]);    IF ndx < SHAlastDigestNdx THEN INC(ndx); END;
        vhi:=Str.CharPos(maphex,S[ndx+1]);  IF ndx < SHAlastDigestNdx THEN INC(ndx); END;
        v:=(vhi << 4 ) + vlo;
        digest[i]:=SYSTEM.LOC(v);
    END;
    RETURN digest;
END stringToSHA;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE SHAinit (VAR ctx:SHAcontextType;bytecount:LONGCARD);
VAR
    t,i,j : CARDINAL;
    V : LONGCARD;
BEGIN
    ctx.state.H0 := 067452301H;
    ctx.state.H1 := 0EFCDAB89H;
    ctx.state.H2 := 098BADCFEH;
    ctx.state.H3 := 010325476H;
    ctx.state.H4 := 0C3D2E1F0H;

    t:=firstround;
    FOR i:=1 TO 4 DO
        CASE i OF
        | 1 : V:=05A827999H; (*  0..19 *)
        | 2 : V:=06ED9EBA1H; (* 20..39 *)
        | 3 : V:=08F1BBCDCH; (* 40..59 *)
        | 4 : V:=0CA62C1D6H; (* 60..79 *)
	ELSE
	    ;
        END;
        FOR j:=1 TO 20 DO K[t]:=V; INC(t); END;
    END;

    ctx.count.lo:=bytecount << 3;      (* x8 : bytes to bits *)
    ctx.count.hi:=bytecount >> (32-3); (* keep 3 upper bits *)
END SHAinit;

PROCEDURE SHAflip (VAR ctx:SHAcontextType);
VAR
    t,j : CARDINAL;
    b : ARRAY [0..3] OF SYSTEM.LOC;
BEGIN
    FOR t:= SHAfirstDigestNdx TO SHAlastDigestNdx BY 4 DO
        FOR j:=0 TO 3 DO b[j]:=ctx.state.digest[t+j];END;
        ctx.state.digest[t+0] := b[3];
        ctx.state.digest[t+1] := b[2];
        ctx.state.digest[t+2] := b[1];
        ctx.state.digest[t+3] := b[0];
    END;
END SHAflip;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
PROCEDURE xor (v1,v2 : LONGCARD  ) : LONGCARD;
TYPE
    dBITSET = SET OF [0..31];
BEGIN
    RETURN LONGCARD( dBITSET(v1) / dBITSET(v2) );
END xor;

PROCEDURE ROTATE_LEFT( x, n: LONGCARD):LONGCARD ;
BEGIN
    RETURN  ( (x << n) OR (x >> (32-n)) );
END ROTATE_LEFT;
*)

PROCEDURE F00 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:= (B AND C)  OR  ((NOT (B)) AND D);
END F00;

PROCEDURE F20 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:=xor(B,C);
    v:=xor(v,D);
END F20;

PROCEDURE F40 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:= (B AND C)  OR  (B AND D)  OR  (C AND D);
END F40;

PROCEDURE F60 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:=xor(B,C);
    v:=xor(v,D);
END F60;

(* ------------------------------------------------------------ *)

(* p points to data which are to become W[0]...W[15] *)

PROCEDURE SHAtransform (VAR state:SHAstatetype; pBlock:ptrToSHABlockType);
VAR
    A,B,C,D,E : LONGCARD;
    TEMP, v : LONGCARD;
    t:CARDINAL;
BEGIN
    (* don't forget to reverse bytes of each longcard ! *)
    FOR t:= 0 TO 63 BY 4 DO
        W.b[t+0] := pBlock^.b[t+3];
        W.b[t+1] := pBlock^.b[t+2];
        W.b[t+2] := pBlock^.b[t+1];
        W.b[t+3] := pBlock^.b[t+0];
    END;

    FOR t := 16 TO 79 DO
        v       := xor ( W.dw[t-3] , W.dw[t-8]);
        v       := xor ( v         , W.dw[t-14]);
        v       := xor ( v         , W.dw[t-16]);
        W.dw[t] := ROTATE_LEFT( v, 1);
    END;

    A:= state.H0;
    B:= state.H1;
    C:= state.H2;
    D:= state.H3;
    E:= state.H4;

    FOR t := 0 TO 79 DO
        TEMP := ROTATE_LEFT(A,5);
        CASE t OF                    (* no speed gain from splitting here *)
        |  0..19 : F00( v, B,C,D);
        | 20..39 : F20( v, B,C,D);
        | 40..59 : F40( v, B,C,D);
        | 60..79 : F60( v, B,C,D);
	ELSE
	    ;
        END;
        INC( TEMP, v );
        INC( TEMP, E );
        INC( TEMP, W.dw[t] );
        INC( TEMP, K[t] );

        E    := D;
        D    := C;
        C    := ROTATE_LEFT(B,30);
        B    := A;
        A    := TEMP;

    END;

    INC(state.H0,A);
    INC(state.H1,B);
    INC(state.H2,C);
    INC(state.H3,D);
    INC(state.H4,E);
END SHAtransform;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume file exists ! *)

PROCEDURE ComputeSHA (VAR digest:SHAdigestType;S:pathtype);
VAR
    hin:FIO.File;
    ndx:CARDINAL; (* assume less than 64Kb buffer *)
    j,t,got:CARDINAL;
    done:BOOLEAN;
    b:ARRAY[0..3] OF SYSTEM.LOC;
    ctx:SHAcontextType;
BEGIN
    hin:=FIO.OpenRead(S);
    FIO.AssignBuffer(hin,SHAsourceBuffer);
    done:=FALSE;
    SHAinit(ctx, FIO.Size(hin));
    REPEAT
        got:=FIO.RdBin(hin,SHAdataBuffer,SHAdataBufferSize);
        IF got # SHAdataBufferSize THEN
            SHAdataBuffer[got]:= 080H;
            INC(got);
            WHILE (got MOD 64) # 56 DO
                SHAdataBuffer[ got ] := 0;
                INC(got);
            END;

            Lib.Move(     SYSTEM.ADR(ctx.count.hi), SYSTEM.ADR(SHAdataBuffer[got]), 4);
            Lib.Move(     SYSTEM.ADR(ctx.count.lo), SYSTEM.ADR(SHAdataBuffer[got+4]), 4);

    FOR t:= got TO got+8 BY 4 DO
        FOR j:=0 TO 3 DO b[j]:=SHAdataBuffer[t+j];END;
        SHAdataBuffer[t+0] := b[3];
        SHAdataBuffer[t+1] := b[2];
        SHAdataBuffer[t+2] := b[1];
        SHAdataBuffer[t+3] := b[0];
    END;

            INC(got,8);
            done:=TRUE;
        END;
        ndx:=0;
        REPEAT
            SHAtransform( ctx.state, SYSTEM.ADR( SHAdataBuffer[ndx] ) );
            INC(ndx, SHABLOCKSIZE);
        UNTIL ndx=got;
    UNTIL done;
    FIO.Close(hin);
    SHAflip(ctx);
    digest:=ctx.state.digest;
END ComputeSHA;

(* //FIXME
<* POP *>
*)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_CRC *)

(* ------------------------------------------------------------ *)

(* all indexes must be from 0, and end at 255 *)
(* both arrays are LONGCARD *)

CONST
    firstByteVal    = 0;         (* for CRCsigma *)
    lastByteVal     = 255;
    firstTableIndex = 0;         (* for CRC *)
    lastTableIndex  = 255;

VAR
    CRC32table : ARRAY [firstTableIndex..lastTableIndex] OF LONGCARD;
    countTable : ARRAY [firstByteVal..lastByteVal] OF LONGCARD;
    computeSigma: BOOLEAN; (* ugly global hack... *)

(* ------------------------------------------------------------ *)

PROCEDURE InitCountTable ();
VAR
    n : CARDINAL;
BEGIN
    FOR n := firstByteVal TO lastByteVal DO
        countTable[n] := 0;
    END;
END InitCountTable;

(* ------------------------------------------------------------ *)

(*

w1+w2 = OR
w1*w2 = AND
w1/w2 = XOR
{0..15} - 16 = NOT
i IN w = true if bit i set in word w
INCL(w,i) = set
EXCL(w,i) = clear

*)

TYPE
    dBITSET = SET OF [0..31];

PROCEDURE xorDWORD (v1,v2 : LONGCARD  ) : LONGCARD;
BEGIN
    RETURN LONGCARD( dBITSET(v1) / dBITSET(v2) );
END xorDWORD;

(* ------------------------------------------------------------ *)

PROCEDURE InitCRC32 ();
CONST
    polynomial      = 3988292384; (* $EDB88320 *)
VAR
    n   : CARDINAL;
    i   : CARDINAL;
    crc : LONGCARD;
BEGIN
    FOR n := firstTableIndex TO lastTableIndex DO
        crc := LONGCARD(n);
        FOR i := 1 TO 8 DO
            IF ( 0 IN dBITSET(crc) )=TRUE THEN (* crc AND 1 *)
                crc := xorDWORD( (crc >> 1) , polynomial);
            ELSE
                crc := crc >> 1;
            END;
        END;
        CRC32table[n]:=crc;
    END;
END InitCRC32;

(* ------------------------------------------------------------ *)

(*

we use a work buffer as to be MUCH faster :

       1Mb  200Kb  32Kb
no  153.35  28.23  4.67
*2   17.19   3.30  0.66
*4   17.02   3.24  0.66
*8   16.76   3.19  0.66
*16  16.26   3.13  0.66
*32  16.53   3.19  0.66

*)

CONST
    CRCioBufferSize    = (8*512) + FIO.BufferOverhead;
    CRCfirstBufferByte = 1;
    CRClastBufferByte  = CRCioBufferSize;
VAR
    CRCioBuffer  : ARRAY [CRCfirstBufferByte..CRClastBufferByte] OF SYSTEM.LOC;
    CRCTMPbuffer : ARRAY [CRCfirstBufferByte..CRClastBufferByte] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)

CONST
    seedCRC   = LONGCARD(0FFFFFFFFH);
    invertCRC = LONGCARD(0FFFFFFFFH);
    (* mask24    = LONGCARD(000FFFFFFH); *)
    mask16    = LONGCARD(00000FFFFH);
    mask8     = LONGCARD(0000000FFH);

PROCEDURE ComputeCRC32 (S : pathtype) : LONGCARD;
VAR
    hnd  : FIO.File;
    ch   : SYSTEM.LOC;
    got  : CARDINAL;
    tmp1 : LONGCARD;
    tmp2 : LONGCARD;
    i    : CARDINAL;
    crc  : LONGCARD;
    buffhere,buffsigmahere:SYSTEM.ADDRESS;
BEGIN
    InitCountTable;
    crc := seedCRC;
    hnd :=FIO.OpenRead(S);
    FIO.AssignBuffer(hnd,CRCioBuffer);
    LOOP
        got := FIO.RdBin(hnd,CRCTMPbuffer,CRCioBufferSize);
        IF got = 0 THEN EXIT; END; (* size was a multiple of iobufferSize *)
        FOR i := CRCfirstBufferByte TO got DO
            ch := CRCTMPbuffer[i];
            IF computeSigma THEN INC(countTable[CARDINAL(ch)]); END;

            (* no speed gain if these lines are packed *)
            (*
            tmp1 := (crc >> 8);
            tmp2 := crc AND mask16;
            tmp2 := xorDWORD(tmp2,LONGCARD(ch));
            tmp2 := CRC32table[CARDINAL(tmp2 AND mask8)];
            crc  := xorDWORD(tmp1,tmp2);
            *)

            (* previous is safe but possibly overcomplicated, use alternate instead *)

            tmp2 := xorDWORD(crc,LONGCARD(ch)) AND mask8;
            tmp1 := (crc >> 8); (* AND mask24; is USELESS !!! *)
            crc  := xorDWORD(tmp1,CRC32table[CARDINAL(tmp2)]);

        END;
        IF got < CRCioBufferSize THEN EXIT; END;
    END;
    FIO.Close(hnd);
    RETURN xorDWORD(crc,invertCRC);
END ComputeCRC32;

(* ------------------------------------------------------------ *)

PROCEDURE ComputeCRCval () : LONGCARD;
CONST
    first = 0;
    last = (lastByteVal-firstByteVal+1) * SIZE(LONGCARD) -1;
VAR
    p    : POINTER TO ARRAY [first..last] OF SYSTEM.LOC;
    ch   : SYSTEM.LOC;
    tmp1 : LONGCARD;
    tmp2 : LONGCARD;
    i    : CARDINAL;
    crc  : LONGCARD;
    buffhere : SYSTEM.ADDRESS;
BEGIN
    IF computeSigma=FALSE THEN RETURN 0;END;
    crc := seedCRC;
    p := SYSTEM.ADR(countTable); (* not always a far so we use ADR *)
    FOR i := first TO last DO
        ch := p^[i];
        tmp2 := xorDWORD(crc,LONGCARD(ch)) AND mask8;
        tmp1 := (crc >> 8);
        crc  := xorDWORD(tmp1,CRC32table[CARDINAL(tmp2)]);
    END;
    RETURN xorDWORD(crc,invertCRC);
END ComputeCRCval;

(* ------------------------------------------------------------ *)

PROCEDURE setSigmaUse (flag:BOOLEAN);
BEGIN
    computeSigma := flag;
END setSigmaUse;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a dated 29 Apr *)

TYPE
    chardef   = RECORD
                    Code    : SYSTEM.LOC;  (* byte *)
                    Flag    : CHAR;
                    MapChar : SYSTEM.LOC;  (* BYTE *)
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST                         (* //XDS yet another stupid syntax change ! *)
    TpcTOwin  = CharTable {
    chardef{000H, "=", 000H},
    chardef{001H, "=", 001H},
    chardef{002H, "=", 002H},
    chardef{003H, "=", 003H},
    chardef{004H, "=", 004H},
    chardef{005H, "=", 005H},
    chardef{006H, "=", 006H},
    chardef{007H, "=", 007H},
    chardef{008H, "=", 008H},
    chardef{009H, "!", 009H},
    chardef{00AH, "=", 00AH},
    chardef{00BH, "=", 00BH},
    chardef{00CH, "=", 00CH},
    chardef{00DH, "=", 00DH},
    chardef{00EH, "=", 00EH},
    chardef{00FH, "=", 00FH},
    chardef{010H, "=", 010H},
    chardef{011H, "=", 011H},
    chardef{012H, "=", 012H},
    chardef{013H, "=", 013H},
    chardef{014H, "!", 0B6H},
    chardef{015H, "!", 0A7H},
    chardef{016H, "=", 016H},
    chardef{017H, "=", 017H},
    chardef{018H, "=", 018H},
    chardef{019H, "=", 019H},
    chardef{01AH, "=", 01AH},
    chardef{01BH, "=", 01BH},
    chardef{01CH, "=", 01CH},
    chardef{01DH, "=", 01DH},
    chardef{01EH, "=", 01EH},
    chardef{01FH, "=", 01FH},
    chardef{020H, "=",  " "},
    chardef{021H, "=",  "!"},
    chardef{022H, "=",  '"'},
    chardef{023H, "=",  "#"},
    chardef{024H, "=",  "$"},
    chardef{025H, "=",  "%"},
    chardef{026H, "=",  "&"},
    chardef{027H, "=",  "'"},
    chardef{028H, "=",  "("},
    chardef{029H, "=",  ")"},
    chardef{02AH, "=",  "*"},
    chardef{02BH, "=",  "+"},
    chardef{02CH, "=",  ","},
    chardef{02DH, "=",  "-"},
    chardef{02EH, "=",  "."},
    chardef{02FH, "=",  "/"},
    chardef{030H, "=",  "0"},
    chardef{031H, "=",  "1"},
    chardef{032H, "=",  "2"},
    chardef{033H, "=",  "3"},
    chardef{034H, "=",  "4"},
    chardef{035H, "=",  "5"},
    chardef{036H, "=",  "6"},
    chardef{037H, "=",  "7"},
    chardef{038H, "=",  "8"},
    chardef{039H, "=",  "9"},
    chardef{03AH, "=",  ":"},
    chardef{03BH, "=",  ";"},
    chardef{03CH, "=",  "<"},
    chardef{03DH, "=",  "="},
    chardef{03EH, "=",  ">"},
    chardef{03FH, "=",  "?"},
    chardef{040H, "=",  "@"},
    chardef{041H, "=",  "A"},
    chardef{042H, "=",  "B"},
    chardef{043H, "=",  "C"},
    chardef{044H, "=",  "D"},
    chardef{045H, "=",  "E"},
    chardef{046H, "=",  "F"},
    chardef{047H, "=",  "G"},
    chardef{048H, "=",  "H"},
    chardef{049H, "=",  "I"},
    chardef{04AH, "=",  "J"},
    chardef{04BH, "=",  "K"},
    chardef{04CH, "=",  "L"},
    chardef{04DH, "=",  "M"},
    chardef{04EH, "=",  "N"},
    chardef{04FH, "=",  "O"},
    chardef{050H, "=",  "P"},
    chardef{051H, "=",  "Q"},
    chardef{052H, "=",  "R"},
    chardef{053H, "=",  "S"},
    chardef{054H, "=",  "T"},
    chardef{055H, "=",  "U"},
    chardef{056H, "=",  "V"},
    chardef{057H, "=",  "W"},
    chardef{058H, "=",  "X"},
    chardef{059H, "=",  "Y"},
    chardef{05AH, "=",  "Z"},
    chardef{05BH, "=",  "["},
    chardef{05CH, "=",  "\"},
    chardef{05DH, "=",  "]"},
    chardef{05EH, "=",  "^"},
    chardef{05FH, "=",  "_"},
    chardef{060H, "=",  "`"},
    chardef{061H, "=",  "a"},
    chardef{062H, "=",  "b"},
    chardef{063H, "=",  "c"},
    chardef{064H, "=",  "d"},
    chardef{065H, "=",  "e"},
    chardef{066H, "=",  "f"},
    chardef{067H, "=",  "g"},
    chardef{068H, "=",  "h"},
    chardef{069H, "=",  "i"},
    chardef{06AH, "=",  "j"},
    chardef{06BH, "=",  "k"},
    chardef{06CH, "=",  "l"},
    chardef{06DH, "=",  "m"},
    chardef{06EH, "=",  "n"},
    chardef{06FH, "=",  "o"},
    chardef{070H, "=",  "p"},
    chardef{071H, "=",  "q"},
    chardef{072H, "=",  "r"},
    chardef{073H, "=",  "s"},
    chardef{074H, "=",  "t"},
    chardef{075H, "=",  "u"},
    chardef{076H, "=",  "v"},
    chardef{077H, "=",  "w"},
    chardef{078H, "=",  "x"},
    chardef{079H, "=",  "y"},
    chardef{07AH, "=",  "z"},
    chardef{07BH, "=",  "{"},
    chardef{07CH, "=",  "|"},
    chardef{07DH, "=",  "}"},
    chardef{07EH, "=",  "~"},
    chardef{07FH, "?",  " "},
    chardef{080H, "=", 0C7H},
    chardef{081H, "=", 0FCH},
    chardef{082H, "=", 0E9H},
    chardef{083H, "=", 0E2H},
    chardef{084H, "=", 0E4H},
    chardef{085H, "=", 0E0H},
    chardef{086H, "=", 0E5H},
    chardef{087H, "=", 0E7H},
    chardef{088H, "=", 0EAH},
    chardef{089H, "=", 0EBH},
    chardef{08AH, "=", 0E8H},
    chardef{08BH, "=", 0EFH},
    chardef{08CH, "=", 0EEH},
    chardef{08DH, "=", 0ECH},
    chardef{08EH, "=", 0C4H},
    chardef{08FH, "=", 0C5H},
    chardef{090H, "=", 0C9H},
    chardef{091H, "=", 0E6H},
    chardef{092H, "=", 0C6H},
    chardef{093H, "=", 0F4H},
    chardef{094H, "=", 0F6H},
    chardef{095H, "=", 0F2H},
    chardef{096H, "=", 0FBH},
    chardef{097H, "=", 0F9H},
    chardef{098H, "=", 0FFH},
    chardef{099H, "=", 0D6H},
    chardef{09AH, "=", 0DCH},
    chardef{09BH, "=", 0A2H},
    chardef{09CH, "=", 0A3H},
    chardef{09DH, "=", 0A5H},
    chardef{09EH, "?",  " "},
    chardef{09FH, "?",  " "},
    chardef{0A0H, "=", 0E1H},
    chardef{0A1H, "=", 0EDH},
    chardef{0A2H, "=", 0F3H},
    chardef{0A3H, "=", 0FAH},
    chardef{0A4H, "=", 0F1H},
    chardef{0A5H, "=", 0D1H},
    chardef{0A6H, "=", 0AAH},
    chardef{0A7H, "=", 0BAH},
    chardef{0A8H, "=", 0BFH},
    chardef{0A9H, "?",  " "},
    chardef{0AAH, "=", 0ACH},
    chardef{0ABH, "=", 0BDH},
    chardef{0ACH, "=", 0BCH},
    chardef{0ADH, "=", 0A1H},
    chardef{0AEH, "=", 0ABH},
    chardef{0AFH, "=", 0BBH},
    chardef{0B0H, "@",  " "},
    chardef{0B1H, "@",  " "},
    chardef{0B2H, "@",  " "},
    chardef{0B3H, "@",  " "},
    chardef{0B4H, "@",  " "},
    chardef{0B5H, "@",  " "},
    chardef{0B6H, "@",  " "},
    chardef{0B7H, "@",  " "},
    chardef{0B8H, "@",  " "},
    chardef{0B9H, "@",  " "},
    chardef{0BAH, "@",  " "},
    chardef{0BBH, "@",  " "},
    chardef{0BCH, "@",  " "},
    chardef{0BDH, "@",  " "},
    chardef{0BEH, "@",  " "},
    chardef{0BFH, "@",  " "},
    chardef{0C0H, "@",  " "},
    chardef{0C1H, "@",  " "},
    chardef{0C2H, "@",  " "},
    chardef{0C3H, "@",  " "},
    chardef{0C4H, "@",  " "},
    chardef{0C5H, "@",  " "},
    chardef{0C6H, "@",  " "},
    chardef{0C7H, "@",  " "},
    chardef{0C8H, "@",  " "},
    chardef{0C9H, "@",  " "},
    chardef{0CAH, "@",  " "},
    chardef{0CBH, "@",  " "},
    chardef{0CCH, "@",  " "},
    chardef{0CDH, "@",  " "},
    chardef{0CEH, "@",  " "},
    chardef{0CFH, "@",  " "},
    chardef{0D0H, "@",  " "},
    chardef{0D1H, "@",  " "},
    chardef{0D2H, "@",  " "},
    chardef{0D3H, "@",  " "},
    chardef{0D4H, "@",  " "},
    chardef{0D5H, "@",  " "},
    chardef{0D6H, "@",  " "},
    chardef{0D7H, "@",  " "},
    chardef{0D8H, "@",  " "},
    chardef{0D9H, "@",  " "},
    chardef{0DAH, "@",  " "},
    chardef{0DBH, "@",  " "},
    chardef{0DCH, "@",  " "},
    chardef{0DDH, "@",  " "},
    chardef{0DEH, "@",  " "},
    chardef{0DFH, "@",  " "},
    chardef{0E0H, "?",  " "},
    chardef{0E1H, "=", 0DFH},
    chardef{0E2H, "?",  " "},
    chardef{0E3H, "?",  " "},
    chardef{0E4H, "?",  " "},
    chardef{0E5H, "?",  " "},
    chardef{0E6H, "=", 0B5H},
    chardef{0E7H, "?",  " "},
    chardef{0E8H, "?",  " "},
    chardef{0E9H, "?",  " "},
    chardef{0EAH, "?",  " "},
    chardef{0EBH, "?",  " "},
    chardef{0ECH, "?",  " "},
    chardef{0EDH, "=", 0D8H},
    chardef{0EEH, "?",  " "},
    chardef{0EFH, "?",  " "},
    chardef{0F0H, "?",  " "},
    chardef{0F1H, "=", 0B1H},
    chardef{0F2H, "?",  " "},
    chardef{0F3H, "?",  " "},
    chardef{0F4H, "?",  " "},
    chardef{0F5H, "?",  " "},
    chardef{0F6H, "=", 0F7H},
    chardef{0F7H, "?",  " "},
    chardef{0F8H, "=", 0B0H},
    chardef{0F9H, "?",  " "},
    chardef{0FAH, "?",  " "},
    chardef{0FBH, "?",  " "},
    chardef{0FCH, "?",  " "},
    chardef{0FDH, "=", 0B2H},
    chardef{0FEH, "?",  " "},
    chardef{0FFH, "=",  " "}  };

(* ripped and adapted from old WIN2PC v1.0a dated 29 Apr *)

CONST
    TwinTOpc  = CharTable{
    chardef{000H, "=", 000H},
    chardef{001H, "=", 001H},
    chardef{002H, "=", 002H},
    chardef{003H, "=", 003H},
    chardef{004H, "=", 004H},
    chardef{005H, "=", 005H},
    chardef{006H, "=", 006H},
    chardef{007H, "=", 007H},
    chardef{008H, "=", 008H},
    chardef{009H, "!", 009H},
    chardef{00AH, "=", 00AH},
    chardef{00BH, "=", 00BH},
    chardef{00CH, "=", 00CH},
    chardef{00DH, "=", 00DH},
    chardef{00EH, "=", 00EH},
    chardef{00FH, "=", 00FH},
    chardef{010H, "=", 010H},
    chardef{011H, "=", 011H},
    chardef{012H, "=", 012H},
    chardef{013H, "=", 013H},
    chardef{014H, "=", 014H},
    chardef{015H, "=", 015H},
    chardef{016H, "=", 016H},
    chardef{017H, "=", 017H},
    chardef{018H, "=", 018H},
    chardef{019H, "=", 019H},
    chardef{01AH, "=", 01AH},
    chardef{01BH, "=", 01BH},
    chardef{01CH, "=", 01CH},
    chardef{01DH, "=", 01DH},
    chardef{01EH, "=", 01EH},
    chardef{01FH, "=", 01FH},
    chardef{020H, "=",  " "},
    chardef{021H, "=",  "!"},
    chardef{022H, "=",  '"'},
    chardef{023H, "=",  "#"},
    chardef{024H, "=",  "$"},
    chardef{025H, "=",  "%"},
    chardef{026H, "=",  "&"},
    chardef{027H, "=",  "'"},
    chardef{028H, "=",  "("},
    chardef{029H, "=",  ")"},
    chardef{02AH, "=",  "*"},
    chardef{02BH, "=",  "+"},
    chardef{02CH, "=",  ","},
    chardef{02DH, "=",  "-"},
    chardef{02EH, "=",  "."},
    chardef{02FH, "=",  "/"},
    chardef{030H, "=",  "0"},
    chardef{031H, "=",  "1"},
    chardef{032H, "=",  "2"},
    chardef{033H, "=",  "3"},
    chardef{034H, "=",  "4"},
    chardef{035H, "=",  "5"},
    chardef{036H, "=",  "6"},
    chardef{037H, "=",  "7"},
    chardef{038H, "=",  "8"},
    chardef{039H, "=",  "9"},
    chardef{03AH, "=",  ":"},
    chardef{03BH, "=",  ";"},
    chardef{03CH, "=",  "<"},
    chardef{03DH, "=",  "="},
    chardef{03EH, "=",  ">"},
    chardef{03FH, "=",  "?"},
    chardef{040H, "=",  "@"},
    chardef{041H, "=",  "A"},
    chardef{042H, "=",  "B"},
    chardef{043H, "=",  "C"},
    chardef{044H, "=",  "D"},
    chardef{045H, "=",  "E"},
    chardef{046H, "=",  "F"},
    chardef{047H, "=",  "G"},
    chardef{048H, "=",  "H"},
    chardef{049H, "=",  "I"},
    chardef{04AH, "=",  "J"},
    chardef{04BH, "=",  "K"},
    chardef{04CH, "=",  "L"},
    chardef{04DH, "=",  "M"},
    chardef{04EH, "=",  "N"},
    chardef{04FH, "=",  "O"},
    chardef{050H, "=",  "P"},
    chardef{051H, "=",  "Q"},
    chardef{052H, "=",  "R"},
    chardef{053H, "=",  "S"},
    chardef{054H, "=",  "T"},
    chardef{055H, "=",  "U"},
    chardef{056H, "=",  "V"},
    chardef{057H, "=",  "W"},
    chardef{058H, "=",  "X"},
    chardef{059H, "=",  "Y"},
    chardef{05AH, "=",  "Z"},
    chardef{05BH, "=",  "["},
    chardef{05CH, "=",  "\"},
    chardef{05DH, "=",  "]"},
    chardef{05EH, "=",  "^"},
    chardef{05FH, "=",  "_"},
    chardef{060H, "=",  "`"},
    chardef{061H, "=",  "a"},
    chardef{062H, "=",  "b"},
    chardef{063H, "=",  "c"},
    chardef{064H, "=",  "d"},
    chardef{065H, "=",  "e"},
    chardef{066H, "=",  "f"},
    chardef{067H, "=",  "g"},
    chardef{068H, "=",  "h"},
    chardef{069H, "=",  "i"},
    chardef{06AH, "=",  "j"},
    chardef{06BH, "=",  "k"},
    chardef{06CH, "=",  "l"},
    chardef{06DH, "=",  "m"},
    chardef{06EH, "=",  "n"},
    chardef{06FH, "=",  "o"},
    chardef{070H, "=",  "p"},
    chardef{071H, "=",  "q"},
    chardef{072H, "=",  "r"},
    chardef{073H, "=",  "s"},
    chardef{074H, "=",  "t"},
    chardef{075H, "=",  "u"},
    chardef{076H, "=",  "v"},
    chardef{077H, "=",  "w"},
    chardef{078H, "=",  "x"},
    chardef{079H, "=",  "y"},
    chardef{07AH, "=",  "z"},
    chardef{07BH, "=",  "{"},
    chardef{07CH, "=",  "|"},
    chardef{07DH, "=",  "}"},
    chardef{07EH, "=",  "~"},
    chardef{07FH, "x",  " "},
    chardef{080H, "x",  " "},
    chardef{081H, "x",  " "},
    chardef{082H, "x",  " "},
    chardef{083H, "x",  " "},
    chardef{084H, "x",  " "},
    chardef{085H, "x",  " "},
    chardef{086H, "x",  " "},
    chardef{087H, "x",  " "},
    chardef{088H, "x",  " "},
    chardef{089H, "x",  " "},
    chardef{08AH, "x",  " "},
    chardef{08BH, "x",  " "},
    chardef{08CH, "x",  " "},
    chardef{08DH, "x",  " "},
    chardef{08EH, "x",  " "},
    chardef{08FH, "x",  " "},
    chardef{090H, "x",  " "},
    chardef{091H, "=",  "'"},
    chardef{092H, "=",  "'"},
    chardef{093H, "x",  " "},
    chardef{094H, "x",  " "},
    chardef{095H, "x",  " "},
    chardef{096H, "x",  " "},
    chardef{097H, "x",  " "},
    chardef{098H, "x",  " "},
    chardef{099H, "x",  " "},
    chardef{09AH, "x",  " "},
    chardef{09BH, "x",  " "},
    chardef{09CH, "x",  " "},
    chardef{09DH, "x",  " "},
    chardef{09EH, "x",  " "},
    chardef{09FH, "x",  " "},
    chardef{0A0H, "=",  " "},
    chardef{0A1H, "=",  ""},
    chardef{0A2H, "=",  ""},
    chardef{0A3H, "=",  ""},
    chardef{0A4H, "=",  ""},
    chardef{0A5H, "=",  ""},
    chardef{0A6H, "=",  "|"},
    chardef{0A7H, "!", 015H},
    chardef{0A8H, "?",  " "},
    chardef{0A9H, "!",  ""},
    chardef{0AAH, "=",  ""},
    chardef{0ABH, "=",  ""},
    chardef{0ACH, "=",  ""},
    chardef{0ADH, "=",  "-"},
    chardef{0AEH, "!",  ""},
    chardef{0AFH, "!",  "-"},
    chardef{0B0H, "=",  ""},
    chardef{0B1H, "=",  ""},
    chardef{0B2H, "=",  ""},
    chardef{0B3H, "?",  " "},
    chardef{0B4H, "?",  " "},
    chardef{0B5H, "=",  ""},
    chardef{0B6H, "!", 014H},
    chardef{0B7H, "?",  " "},
    chardef{0B8H, "?",  " "},
    chardef{0B9H, "?",  " "},
    chardef{0BAH, "=",  ""},
    chardef{0BBH, "=",  ""},
    chardef{0BCH, "=",  ""},
    chardef{0BDH, "=",  ""},
    chardef{0BEH, "?",  " "},
    chardef{0BFH, "=",  ""},
    chardef{0C0H, "=",  "A"},
    chardef{0C1H, "=",  "A"},
    chardef{0C2H, "=",  "A"},
    chardef{0C3H, "=",  "A"},
    chardef{0C4H, "=",  ""},
    chardef{0C5H, "=",  ""},
    chardef{0C6H, "=",  ""},
    chardef{0C7H, "=",  ""},
    chardef{0C8H, "=",  "E"},
    chardef{0C9H, "=",  ""},
    chardef{0CAH, "=",  "E"},
    chardef{0CBH, "=",  "E"},
    chardef{0CCH, "=",  "I"},
    chardef{0CDH, "=",  "I"},
    chardef{0CEH, "=",  "I"},
    chardef{0CFH, "=",  "I"},
    chardef{0D0H, "?",  " "},
    chardef{0D1H, "=",  ""},
    chardef{0D2H, "=",  "O"},
    chardef{0D3H, "=",  "O"},
    chardef{0D4H, "=",  "O"},
    chardef{0D5H, "=",  "O"},
    chardef{0D6H, "=",  ""},
    chardef{0D7H, "=",  "X"},
    chardef{0D8H, "=",  "O"},
    chardef{0D9H, "=",  "U"},
    chardef{0DAH, "=",  "U"},
    chardef{0DBH, "=",  "U"},
    chardef{0DCH, "=",  ""},
    chardef{0DDH, "=",  "Y"},
    chardef{0DEH, "?",  " "},
    chardef{0DFH, "=",  ""},
    chardef{0E0H, "=",  ""},
    chardef{0E1H, "=",  ""},
    chardef{0E2H, "=",  ""},
    chardef{0E3H, "=",  "a"},
    chardef{0E4H, "=",  ""},
    chardef{0E5H, "=",  ""},
    chardef{0E6H, "=",  ""},
    chardef{0E7H, "=",  ""},
    chardef{0E8H, "=",  ""},
    chardef{0E9H, "=",  ""},
    chardef{0EAH, "=",  ""},
    chardef{0EBH, "=",  ""},
    chardef{0ECH, "=",  ""},
    chardef{0EDH, "=",  ""},
    chardef{0EEH, "=",  ""},
    chardef{0EFH, "=",  ""},
    chardef{0F0H, "?",  " "},
    chardef{0F1H, "=",  ""},
    chardef{0F2H, "=",  ""},
    chardef{0F3H, "=",  ""},
    chardef{0F4H, "=",  ""},
    chardef{0F5H, "=",  "o"},
    chardef{0F6H, "=",  ""},
    chardef{0F7H, "=",  ""},
    chardef{0F8H, "=",  "o"},
    chardef{0F9H, "=",  ""},
    chardef{0FAH, "=",  ""},
    chardef{0FBH, "=",  ""},
    chardef{0FCH, "=",  ""},
    chardef{0FDH, "=",  "y"},
    chardef{0FEH, "?",  " "},
    chardef{0FFH, "=",  ""} };

(* we don't care about flag here *)

PROCEDURE remap2ascii (ch:CHAR):CHAR;
BEGIN
    RETURN TwinTOpc[ ORD(ch) ].MapChar;
END remap2ascii;

PROCEDURE remap2oem (ch:CHAR):CHAR;
BEGIN
    RETURN TpcTOwin[ ORD(ch) ].MapChar;
END remap2oem;

PROCEDURE fixentrycharset(convertme : BOOLEAN; VAR S:ARRAY OF CHAR);
CONST
    chexactmatch = "=";
    chmatch      = "!";
    chgraph      = "@"; (* no match *)
    chnomatch    = "?";
    chOEMonly    = "x";
VAR
    i,kod : CARDINAL;
    ch : CHAR;
BEGIN
    IF NOT(convertme) THEN RETURN; END;
    FOR i:= 1 TO Str.Length(S) DO
        kod := ORD( S[i-1] );
        CASE TpcTOwin[ kod ].Flag OF
        | chexactmatch,chmatch: (* [=!] *)
            ch := TpcTOwin [ kod ].MapChar;
            S[i-1] := ch;
        | chgraph,chnomatch,chOEMonly: (* [@?x] *)
            ; (* //FIXME *)
        ELSE
            ; (* //FIXME *)
        END;
    END;
END fixentrycharset;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstmethod  = 1; (* crc *)
    lastmethod   = 5; (* subdirs *)
TYPE
    cmdtype = (undefined,
               crc,md5,sha,unsafe,subdirs,
               verify,compare,rebuild);

CONST
    maxPath   = 16380;
    sMaxPath  = "16380"; (* directories *)
    maxndx    = 16380;
    sMaxNdx   = "16380"; (* files *)
CONST
    netslash    = backslash+backslash;
    seps        = blank+tabul;
    extLOG      = ".LOG";
    extTMP      = ".TMP";
    extBAK      = ".BK!";
    wifsize     = 10; (* was 9 *)
CONST
    tmprebuild  = "~DEL_ME~";     (* f8 for -r[r] *)
    tmpold      = "~OLD"+extTMP;
    tmpnew      = "~NEW"+extTMP;
    extEXE      = ".EXE";
    extINI      = ".INI";
    REMCHAR     = semicolon;
    OPENSECTION = "[";
    CLOSESECTION= "]";
    (* both lowercase *)
    sectionExclude = OPENSECTION+"exclude"+CLOSESECTION;
    sectionSelect  = OPENSECTION+"select"+CLOSESECTION;
    sectionInclude = OPENSECTION+"include"+CLOSESECTION; (* in fact, select mode *)
CONST
    msgLFN       = "Win9X LFNs        : ";
CONST
    msgOldLog    = "Older logfile     : ";
    msgNewLog    = "Newer logfile     : ";
    msgUseDisk   = "Indexes storage   : ";
CONST
    msgDefault   = "Default directory : ";
    msgBaseDir   = "Base directory    : ";
    msgSpec      = "Specification     : ";
    msgINI       = "INI file          : ";
CONST (* no spaces within strings here, for tabsep's sake ! *)
    bl2          = "  ";
    bl4          = bl2+bl2;
    bl8          = bl4+bl4;
    dash8        = "--------";

    sFiller      = "$$$$$$$$$";

    sCRC         = "CRC32    ";
    sMD5         = "MD5      "+bl8+bl8+bl8;     (* $ + 32 chars *)
    sSHA         = "SHA-1    "+bl8+bl8+bl8+bl8; (* $ + 40 chars *)
    sUNSAFE      = "Q&D      ";
    sSUBDIRS     = "<DIR>    ";
    sHeader0     =          "  ----------  ---------------";
    sHeader1     = sFiller+ "  Length      Path";
    sHeader2     = "---------"+sHeader0;
    sHeader2md5  = "-"+dash8+dash8+dash8+dash8+sHeader0; (* message digest *)
    sHeader2sha  = "-"+dash8+dash8+dash8+dash8+dash8+sHeader0; (* message digest *)
    msgMissing   = "Not found ! ";
    msgSizePb    = "Size      ! ";
    msgCpb       = "CRC32     ! ";
    msgMpb       = "MD5       ! ";
    msgSpb       = "SHA-1     ! ";
CONST
    longDeleted  = "Deleted   ! ";
    longAdded    = "Added     ! ";
    longSize     = "Size      ! ";
    longModified = "Modified  ! ";
    shortDeleted = "-- ";
    shortAdded   = "++ ";
    shortModified= "## ";
CONST
    dash10       = "----------";
    dashDeleted  = REMCHAR+" Deleted";
    dashAdded    = REMCHAR+" Added";
    dashModified = REMCHAR+" Modified";
    dashline     = REMCHAR+dash10+dash10+dash10+dash10+dash10+dash10+dash10;

    dashStarted  = REMCHAR+" Report started on ";
    dashCompleted= REMCHAR+" Report completed on ";
    dashElapsed  = REMCHAR+" Elapsed time was ";
    dasholder    = REMCHAR+" Older logfile (";
    dashnewer    = REMCHAR+" Newer logfile (";
    dashsep      = ") : ";

    dashmethod   = REMCHAR+" Method : ";
    dashinfo1    = REMCHAR+" 8ung ! Files excluded when creating logfiles CANNOT be checked here !";
    dashinfo2    = REMCHAR+" 8ung ! For obvious reasons, report is best viewed in 132 columns mode !";

    dashSummary  = REMCHAR+" Summary";
    msgDeleted   = "Entries deleted  : ";
    msgAdded     = "Entries added    : ";
    msgChanged   = "Entries modified : ";

CONST
    searchingDeleted  = "Step 1/3 : looking for deleted entries... ";
    searchingAdded    = "Step 2/3 : looking for added entries... ";
    searchingModified = "Step 3/3 : looking for modified entries... ";
CONST
    msgEverythingGoes     = "All files checked. No problem detected.";
    msgEverythingWentFine = "All files analyzed.";
    msgProcessing    = "Please wait while processing ";
    msgChecking      = "Please wait while checking...";
    msgRebuilding    = "Please wait while analyzing...";
    msgIndexing      = "Please wait while indexing "; (* name will follow *)
    msgScanningMethod= "Please wait while scanning "; (* name will follow *)
CONST
    sTMP        = "TMP";
    sTEMP       = "TEMP";
    sTMPDIR     = "TMPDIR";
    sTEMPDIR    = "TEMPDIR";
    sOLDNDX     = "~DELME1~.TMP"; (* very unlikely to exist ! *)
    sNEWNDX     = "~DELME2~.TMP";
CONST
    sSwapWin92  = "*\386spart.par";  (* lowercase *)
    sSwapWin98  = "*\win386.swp";
    sSwapWinXP  = "*\pagefile.sys";

CONST
    progEXEname   = "CS32";
    progTitle     = "Q&D CheckSum (Win32)";
    progVersion   = "v0.9b (from v1.3s for DOS)";
    progCopyright = "by PhG";
    Banner        = progTitle+" "+progVersion+" "+progCopyright;

CONST
    errNone              = 0;
    errHelp              = 1;
    errOption            = 2;
    errSyntax            = 3;
    errBadSpec           = 4;
    errTooManyDirs       = 5;
    errMethod            = 6;
    errNonsense          = 7;
    errJoker             = 8;
    errNotFound          = 9;
    errBadFormat         = 10;
    errBadLine           = 11;
    errBadLog            = 12;
    errTooManyINIentries = 13;
    errIllegalINIsection = 14;
    errMissingINIsection = 15;
    errExclusive         = 16;
    errMethods           = 17;
    errMEM               = 18;
    errOverflow          = 19;
    errMaybeWare         = 20;
    errChkMethod         = 21;
    errDiskRequiredForMD5= 22; (* obsolete *)
    errDiskRequiredForSHA= 23; (* obsolete *)

    errAbortedByUser     = 64;

    errMissingEntries    = 128;
    errDifferences       = 129;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);

    MODULE message;
    IMPORT Str;
    EXPORT msg3;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;

CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

    msghelp=
Banner+nl+
nl+
"Syntax 1 : "+progEXEname+" <file(s)> <-c|-m|-$|-z|-s> [-l-n-g-t[-x[x]|-e|-j]-u-q-w]"+nl+
"Syntax 2 : "+progEXEname+" <log["+extLOG+"]> <-v[cm$zs]> [-p-u-q-w-b]"+nl+
"Syntax 3 : "+progEXEname+" <log1["+extLOG+"]> <log2["+extLOG+"]> <-k[cm$zsd]> [-d-y-i-u-q-w]"+nl+
"Syntax 4 : "+progEXEname+" <log["+extLOG+"]> <-r[r]> [-p-u-q-w]"+nl+
nl+
"This program computes checksums (syntax 1), verifies checksums (syntax 2),"+nl+
"compares two logs (syntax 3), or rebuilds data for each log entry (syntax 4)."+nl+
nl+
"-c|m|$ compute CRC32 (default), MD5 or SHA-1 (-m and -$ force -d with syntax 3)"+nl+
"-z     quick unsafe mode (for each file, only filesize is tracked)"+nl+
"-s     do not process files but subdirectories (-x forced and -n ignored)"+nl+
"-v[?]  verify log previously created with redirected ouput (128=FNF, 129=#)"+nl+
"-k[?]  compare two logs, assuming oldest is reference (-kd = -k -d)"+nl+
"-r[r]  rebuild data from log (method header assumed, -rr keeps no backup)"+nl+
(* nl+ *)
"-!     ignore filesize check for MD5 or SHA methods"+nl+
"-b     store relative paths (default is to store canonical paths)"+nl+
"-n     do not include subdirectories (default is to include subdirectories)"+nl+
"-d     store indexes on disk instead of RAM"+nl+
"       (slower but allowing more than "+sMaxNdx+" entries, forced with -k[m$] -m|-$)"+nl+
"-g     exclude method header (default is to include method header)"+nl+
"-t     use tab as a separator"+nl+
"-x[x]  ignore entries listed in "+progEXEname+extINI+", if any (-xx = -x but still ignoring"+nl+
'       "'+sSwapWin92+'", "'+sSwapWin98+'", "'+sSwapWinXP+'")'+nl+
"-e     reverse search order for "+progEXEname+extINI+nl+
"-j     force select mode for "+progEXEname+extINI+" entries (default is exclude mode)"+nl+
"-u     paths in uppercase (default is lowercase)"+nl+
"-p     ignore path in log entries (ignored if log was created with -s)"+nl+
'-y     use "'+longDeleted+'", "'+longAdded+'" and "'+longModified+'" long prefixes'+nl+
'       (default is "'+shortDeleted+'", "'+shortAdded+'" and "'+shortModified+'" short prefixes)'+nl+
"-i     add final report"+nl+
"-#     do not convert "+progEXEname+extINI+" and log entries from ASCII to OEM"+nl+
nl+
"a) Headerless logs can be processed using -<v|k><cm$z> option variants."+nl+
"b) "+progEXEname+extINI+" may contain up to 1000 entries (syntax 1 only)"+nl+
"   specifying files to be excluded (default) or selected (with -j option) :"+nl+
"   it is first searched for in current directory, then in executable directory."+nl+
(* "   (unless -e option was specified to reverse default search order)."+nl+ *)
"c) With syntax 1, output, if redirected, should not belong to scanned domain."+nl+
"d) Syntax 3 cannot process more than "+sMaxNdx+" entries in a valid log, unless"+nl+
"   -d option is specified to create temporary files in directory specified by,"+nl+
"   in that order, "+sTMP+", "+sTEMP+", "+sTMPDIR+", "+sTEMPDIR+" environment variables"+nl+
"   (if none of these variables is defined, current directory will be used)."+nl+
"e) Program returns 255 if Escape key was used to abort syntax 1 or syntax 2 ;"+nl+
"   but for log integrity, Escape key is disabled if output is redirected."+nl+
'f) Whatever the operation, lines beginning with "'+REMCHAR+'" will be ignored.'+nl+
'g) When converting from ASCII to OEM, chars without match remain unchanged.'+nl+
"h) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
(* "   Although successful compiling required (too) many modifications in source,"+nl+ *)
"   Results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :        WrStr(msghelp);
    | errOption :      msg3(S,"Illegal ",einfo," option !");
    | errSyntax :      S:="Illegal command line, check syntax !";
    | errBadSpec :     msg3(S,"Illegal ",einfo," specification !");
    | errTooManyDirs : msg3(S,"Memory full or more than "+sMaxPath+" directories from ",einfo," !");
    | errMethod :
                       S:="-c, -m, -$, -z, -s, -v, -r[r] and -k are mutually exclusive !";
    | errNonsense:  msg3(S,einfo," option is a nonsense with specified command !","");
    | errJoker:     msg3(S,"Illegal joker(s) in ",einfo," log !");
    | errNotFound:  msg3(S,einfo," log does not exist !","");
    | errBadFormat:
                    msg3(S,"Unrecognized ",einfo," log format or unsupported method !");
    | errBadLine:   msg3(S,"Unexpected (",einfo,") line format !");
    | errBadLog:    msg3(S,"Unexpected problem (format or line) with ",einfo," log !");
    | errTooManyINIentries: msg3(S,"Too many entries in ",einfo," file !");
    | errIllegalINIsection: msg3(S,"Illegal section in ",einfo," !");
    | errMissingINIsection: msg3(S,"Sections do not exist in ",einfo," !");
    | errExclusive: S:="-x[x] and -j options are mutually exclusive !";
    | errMethods  : S:="Method mismatch between logs to compare !";
    | errMEM      : msg3(S,"Storage.ALLOCATE() failure for ",einfo," !");
    | errOverflow : msg3(S,"Too many entries in ",einfo," log !");
    | errAbortedByUser:S:="Aborted by user !";
    | errMaybeWare:S:="-m option is not yet implemented !";
    | errChkMethod :
                     S:="-vc, -vm, -v$ and -vz are mutually exclusive !";
    | errDiskRequiredForMD5:S:="-d option is required to compare MD5 logs !";
    | errDiskRequiredForSHA:S:="-d option is required to compare SHA-1 logs !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp : ;
    | errMissingEntries,errDifferences : ;
    ELSE
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE sound (freq,duration,pause:CARDINAL);
BEGIN
END sound;

PROCEDURE alarm (  );
BEGIN
    sound(55,55,100);
    sound(55,55,10);
END alarm;

PROCEDURE alert (  );
BEGIN
    sound(550,55,100);
    sound(550,55,10);
END alert;

PROCEDURE showmem(S:ARRAY OF CHAR );
VAR
    heapsize    : CARDINAL; (* in PARAGRAPHS and not in bytes ! help is wrong ! *)
    n           : LONGCARD;
BEGIN
END showmem;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize      = (8 * 512) + FIO.BufferOverhead; (* 8 is enough *)
    firstioBufferByte = 1;
    lastioBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstioBufferByte..lastioBufferByte] OF SYSTEM.LOC;
VAR
    ioInBuffer        : ioBufferType; (* buildINIentries, procLog, doIndex::called_by_compareLogs *)
    ioOld             : ioBufferType; (* compareLogs *)
    ioNew             : ioBufferType; (* compareLogs, procLog *)
    ioDskOld,ioDskNew : ioBufferType; (* doIndex::called_by_compareLogs *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstPath = 1;    (* was 0, but 1 required by Lib.QSort and by firstPath-1 of course ! *)

TYPE
    ptrToEntry = POINTER TO entrytype;
    entrytype  = RECORD
        slen : SHORTCARD;
        string:CHAR; (* variable length *)
    END;
VAR
    Path      : ARRAY[firstPath..maxPath] OF ptrToEntry;
    lastPath  : CARDINAL;

PROCEDURE getentry (i:CARDINAL; VAR R : pathtype);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(Path[i]^.slen);
    Lib.FastMove( SYSTEM.ADR(Path[i]^.string),SYSTEM.ADR(R),len);
    R[len]:=nullchar; (* REQUIRED safety ! *)
END getentry;

PROCEDURE setentry (i:CARDINAL; S : pathtype ) : BOOLEAN ;
VAR
    len,needed:CARDINAL;
BEGIN
    len    := Str.Length(S);
    needed := SIZE(entrytype)-SIZE(CHAR)+len;
        ALLOCATE(Path[i],needed);
        Path[i]^.slen := SHORTCARD(len);
        Lib.FastMove( SYSTEM.ADR(S),SYSTEM.ADR(Path[i]^.string),len);
    RETURN (Path[i] # NIL);
END setentry;

PROCEDURE freePaths (lastpath:CARDINAL);
VAR
    i,len,needed:CARDINAL ;
BEGIN
    FOR i := firstPath TO lastpath DO
        IF Path[i] # NIL THEN (* useless safety *)
            len := CARDINAL( Path[i]^.slen);
            needed := SIZE(entrytype)-SIZE(CHAR)+len;
            DEALLOCATE(Path[i],needed);
        END;
        Path[i]:=NIL;
    END;
END freePaths;

(*
(* // accents handling ? *)

PROCEDURE isLess (i,j : CARDINAL) : BOOLEAN;
VAR
    SI,SJ:pathtype;
BEGIN
    getentry(i,SI);
    getentry(j,SJ);
    IF Str.Compare(SI,SJ) < 0 THEN (* -1 is less *)
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END isLess;

PROCEDURE doSwap (i,j : CARDINAL);
VAR
    S : ptrToEntry;
BEGIN
    S:=Path[i];
    Path[i]:=Path[j];
    Path[j]:=S;
END doSwap;
*)

(* ------------------------------------------------------------ *)

PROCEDURE fixDirPath (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN
        Str.Copy(S,backslash);
    ELSE
        IF S[len-1] # backslash THEN
            Str.Append(S,backslash);
        END;
    END;
END fixDirPath;

PROCEDURE isDirEntry (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isDirEntry;

CONST
    nothingRequired = FIO.FileAttr{};

PROCEDURE doDir (root : pathtype;
                 VAR index:CARDINAL;VAR err:BOOLEAN);
VAR
    path    : pathtype;
    S       : pathtype;
    entry   : FIO.DirEntry;
    found   : BOOLEAN;
    w9Xhandle,errcode:CARDINAL;
    rc : BOOLEAN;
    full:pathtype;
    dosattr:FIO.FileAttr;
BEGIN
    IF index > maxPath THEN
        err:=TRUE;
        RETURN;
    END;
    fixDirPath(root); (* add required "\" here *)
    IF setentry(index,root)=FALSE THEN
        err:=TRUE;
        RETURN;
    END;
    Str.Copy(path,root); (* "\" already added *)
    Str.Append(path,stardotstar); (* root\*.* *)

        found := FIO.ReadFirstEntry(path,everything,entry);
    WHILE found DO
        Str.Copy(S,root);
        fixDirPath(S);

            Str.Copy(full,entry.name);
        Str.Append(S,full); (* root\f8e3 *)
        IF isDirEntry(full)=FALSE THEN (* skip . AND .. *)
                dosattr:=entry.attr;
            IF (aDD IN dosattr) THEN
                INC(index);
                doDir(S,index,err);
            END;
        END;
            found :=FIO.ReadNextEntry(entry);
    END;
END doDir;

PROCEDURE BuildPathList (recurse:BOOLEAN; rootdir : pathtype) : CARDINAL;
CONST
    msg1 = "Building list of ";
    msg2 = "Windows 9X ";
    msg3 = "directories for ";
VAR
    found    : BOOLEAN;
    i        : CARDINAL;
    prompt   : pathtype; (* we may have a long filename *)
    error    : BOOLEAN;
BEGIN
    i        := firstPath;
    error    := FALSE;
IF recurse THEN
    Str.Copy(prompt,msg1);
    Str.Append(prompt,msg2);
    Str.Append(prompt,msg3);
    Str.Append(prompt,rootdir);

    video (prompt,TRUE);

    doDir(rootdir,i,error);

    video (prompt,FALSE);
ELSE
    IF setentry(i,rootdir)=FALSE THEN error:=TRUE;END;
END;
    IF error THEN i:=MAX(CARDINAL); END;
    RETURN i;
END BuildPathList;

(* ------------------------------------------------------------ *)

(* adapted from QD_BOX.MOD dated 4 Oct 03 *)

PROCEDURE w9XisDirectory (S : pathtype) : BOOLEAN;
VAR
    w9Xhandle,errcode:CARDINAL;
    found,rc : BOOLEAN;
    dosattr:FIO.FileAttr;
    entry:FIO.DirEntry;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=backslash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    dosattr:=entry.attr;
    RETURN (aDD IN dosattr);
END w9XisDirectory;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE s2lc (VAR v : LONGCARD; base:CARDINAL;S:ARRAY OF CHAR):BOOLEAN ;
VAR
    ok:BOOLEAN;
BEGIN
    UpperCase(S);
    IF base=16 THEN
        ReplaceChar(S,dollar,"");
    END;
    v:=Str.StrToCard(S,base,ok);
    RETURN ok;
END s2lc;

PROCEDURE dotab (VAR R:ARRAY OF CHAR);
BEGIN
    LOOP
        IF Str.Pos(R,"  ")=MAX(CARDINAL) THEN EXIT;END;
        Str.Subst(R,"  "," ");
    END;
    LOOP
        IF Str.CharPos(R," ")=MAX(CARDINAL) THEN EXIT;END;
        Str.Subst(R," ",tabul);
    END;
END dotab;

PROCEDURE valToStr (base,digits:CARDINAL;prefix,pad:CHAR;v:LONGCARD):str16;
VAR
    S : str16;
    ok: BOOLEAN;
BEGIN
    Str.CardToStr(v,S,base,ok);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    Str.Prepend(S,prefix);
    IF base=16 THEN LowerCase(S); END;
    RETURN S;
END valToStr;

(* return TRUE if no dot in \f8.e3 part *)

PROCEDURE needTrailingDot (S:ARRAY OF CHAR):BOOLEAN;
VAR
    u,d,n,e,ne:pathtype; (* we may get a long filename *)
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Lib.MakeAllPath(ne,"","",n,e);
    RETURN Str.CharPos(ne,dot)=MAX(CARDINAL);
END needTrailingDot;

PROCEDURE unquote(bothquotes:BOOLEAN ; VAR S:ARRAY OF CHAR);
VAR
    len,last,i:CARDINAL;
    ch:CHAR;
    pat:str16;
BEGIN
    IF bothquotes THEN
        last:=2;
    ELSE
        last:=1;
    END;
    i:=1;
    LOOP
        CASE i OF
        | 1: ch:=doublequote;
        | 2: ch:=singlequote;
	ELSE
	    ;
        END;
        Str.Concat(pat,ch,"*");Str.Append(pat,ch);
        IF Str.Match(S,pat) THEN
            Str.Delete(S,0,1); (* first doublequote *)
            len:=Str.Length(S);
            Str.Delete(S,len-1,1);
            EXIT;
        END;
        INC(i);
        IF i > last THEN EXIT; END;
    END;
END unquote;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*

;
; in fact, this file is CHKDATA.INI
;
; files excluded by CS when computing checksums
;
; 386spart.par should ALWAYS be excluded for obvious reasons
;

[exclude]

*\386spart.par
*\pagefile.sys
*\win386.swp

?:\diskmap.*
?:\image.*
?:\treeinfo.*
?:\tmp\*
*.{*
*.$$$
*.tmp
*.bak
*.bk2
*.chk
*.ndx
*.swp
*.lnk
*.jbf
*\when.log
?:\sentry\*
?:\recycled\*
?:\hibrn8.dat
*\chkdata._?_
?:\snapshot.log
?:\snapshot.txt
?:\order.txt
c:\selectit\selit.cfg
*\index.dat
*\temp\*
*\chkfiles.all
*\netscape\*.db
*.old
*.new
?:\cs*.crc
?:\cs*.rpt
?:\cs*.log

[select]

*.exe
*.com

*)

(* hashing was tested, without any gain in speed *)

CONST
    firstINIentry = 1;
    maxINIentry   = 1000; (* at least 3 ! //XDS was 100 *)
TYPE
    INIentryArray = ARRAY [firstINIentry..maxINIentry] OF pathtype;
    ptrToINIentryArray = POINTER TO INIentryArray;
VAR
    pINIentry     : ptrToINIentryArray;
    lastINIentry : CARDINAL;

PROCEDURE includeIt (excludemode:BOOLEAN; file:ARRAY OF CHAR):BOOLEAN; (* do NOT modify them ! *)
VAR
    i : CARDINAL;
    rc,ok,nope:BOOLEAN;
BEGIN
    IF excludemode THEN
        ok  :=TRUE;
        nope:=FALSE;
    ELSE
        ok  :=FALSE;
        nope:=TRUE;
    END;

    i := firstINIentry;
    LOOP
        IF i > lastINIentry THEN rc:=ok;EXIT; END;
        IF Str.Match(file,pINIentry^[i]) THEN rc:=nope;EXIT; END;
        INC(i);
    END;
    RETURN rc;
END includeIt;

(* do not forget to convert entries to lowercase after unquoting them !!! *)

PROCEDURE buildINIentries (ignoreini,stillavoidswapfiles,excludemode,ascii2oem:BOOLEAN;
                          inifile:ARRAY OF CHAR):CARDINAL;
VAR
    state : (waiting,gotexclude,gotselect,overflow,illegal); (* // *)
    i   : CARDINAL;
    S   : pathtype;
    hnd : FIO.File;
    processme:BOOLEAN;
BEGIN
    i := firstINIentry;

    IF ignoreini THEN
        IF stillavoidswapfiles THEN
            S:=sSwapWin92;
            Str.Copy(pINIentry^[i],S);
            INC(i);
            S:=sSwapWin98;
            Str.Copy(pINIentry^[i],S);
            INC(i);
            S:=sSwapWinXP;
            Str.Copy(pINIentry^[i],S);
            INC(i);
        END;
        lastINIentry := i-1;
        RETURN errNone; (* not very bright, we should always add "386spart.par" *)
    END;

    IF FIO.Exists(inifile)=FALSE THEN
        lastINIentry := i-1;
        RETURN errNone; (* not very bright, we should always add "386spart.par" *)
    END;

    state:=waiting;

    FIO.EOF := FALSE; (* safety fix for flag seems set to true by fio.exists ! *)

    hnd:=FIO.OpenRead(inifile);
    FIO.AssignBuffer(hnd,ioInBuffer);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hnd,S);

	fixentrycharset(ascii2oem,S); (* //FIXME //V09B *)

        LtrimBlanks(S);RtrimBlanks(S);
        unquote(TRUE,S);
        LowerCase(S);
        (* IF same(S,"")=FALSE THEN *)
            CASE S[0] OF
            | nullchar,REMCHAR :
                ;
            | OPENSECTION :
                (* we could remove brackets and spaces here but... *)
                IF    same(S,sectionExclude) THEN
                    state:=gotexclude;
                ELSIF same(S,sectionSelect) THEN
                    state:=gotselect;
                ELSIF same(S,sectionInclude) THEN
                    state:=gotselect;
                ELSE
                    state:=illegal;EXIT;
                END;
            ELSE
                processme:=FALSE;
                CASE state OF
                | gotexclude:
                    processme:=excludemode;
                | gotselect:
                    processme:=NOT(excludemode);
		ELSE
		    ;
                END;
                IF processme THEN
                    (* no check is made for specification here ! *)
                    IF i > maxINIentry THEN state:=overflow;EXIT;END;
                    Str.Copy(pINIentry^[i],S);
                    INC(i);
                END;
            END;
        (* END; *)
    END;
    FIO.Close(hnd);
    CASE state OF
    | waiting:  RETURN errMissingINIsection;
    | overflow: RETURN errTooManyINIentries;
    | illegal:  RETURN errIllegalINIsection;
    ELSE
        ;
    END;

    lastINIentry := i-1;
    RETURN errNone;
END buildINIentries;

PROCEDURE doHeader (cmd:cmdtype; tabsep:BOOLEAN );
VAR
    S,R:str128;
BEGIN
    Str.Copy(S,sHeader1);
    CASE cmd OF
    | crc:       R:=sCRC;
    | md5:       R:=sMD5;
    | sha:       R:=sSHA;
    | unsafe:    R:=sUNSAFE;
    | subdirs:   R:=sSUBDIRS;
    ELSE
        ;
    END;
    Str.Subst(S,sFiller,R);
    CASE cmd OF
    | md5 :
        Str.Copy(R,sHeader2md5);
    | sha :
        Str.Copy(R,sHeader2sha);
    ELSE
        Str.Copy(R,sHeader2);
    END;
    IF tabsep THEN
        dotab(S);
        dotab(R);
    END;
    WrStr(S);WrLn;
    WrStr(R);WrLn;
END doHeader;

PROCEDURE casify(lowercase:BOOLEAN;VAR S:ARRAY OF CHAR);
BEGIN
    IF lowercase THEN
        LowerCase(S);
    ELSE
        UpperCase(S);
    END;
END casify;

PROCEDURE computeLogs (cmd:cmdtype;
                      lowercase,excludemode,
                      candy,includeBaseDir:BOOLEAN;
                      separ:ARRAY OF CHAR; R,spec,basedir:pathtype):BOOLEAN;
CONST
    wiscreen = 80; (* assume standard screen *)
VAR
    found:BOOLEAN;
    entry:FIO.DirEntry;
    S:pathtype;
    msg:pathtype;
    thispath,removeMe:pathtype;
    v,fsize:LONGCARD;
    wimsg,wi,chksum,cszero:CARDINAL;
    w9Xhandle,errcode:CARDINAL;
    rc : BOOLEAN;
    canonical,shortform:pathtype;
    MD5digest : MD5digestType;
    MD5digeststr : MD5str;
    SHAdigest : SHAdigestType;
    SHAdigeststr : SHAstr;
    cRooked:pathtype;
BEGIN

    candy := FALSE; (* //XDS made us to that *)

    wimsg:=Str.Length(msgProcessing);
IF cmd = subdirs THEN
    fsize:=0; wi:=4; v:=0;
    WrStr(valToStr(16,wi,dollar,"0",v)); WrStr(bl4);
    WrStr(separ); WrStr( valToStr(10,wifsize,""," ",fsize));WrStr(separ);
    casify(lowercase,R);
    WrStr(R);WrLn;
        IF ChkEscape() THEN
            RETURN FALSE;
        END;
    RETURN TRUE;
ELSE

    IF includeBaseDir = FALSE THEN
        Str.Copy(removeMe,basedir);
        LowerCase(removeMe);
        casify(lowercase,removeMe);
    END;

    cooked(cRooked, TRUE,TRUE,wiscreen,wimsg,R);
    Str.Concat(msg,msgProcessing,cRooked );
    IF candy THEN video(msg,TRUE); END;
    Str.Concat(thispath,R,spec);
    found := FIO.ReadFirstEntry(thispath,allfiles,entry);
    WHILE found DO
        Str.Concat(canonical, R,entry.name);
        LowerCase(canonical); (* don't assume anything about case *)
        Str.Copy(S,canonical);
        IF includeIt (excludemode, canonical) THEN
            fsize := getFileSize(S);
            CASE cmd OF
            | crc      : wi:=8; v:=ComputeCRC32(S);
            | unsafe   : wi:=4; v:=0;
            | md5      : wi:=2; ComputeMD5(MD5digest,S);
            | sha      : wi:=2; ComputeSHA(SHAdigest,S);
	    ELSE
	        ;
            END;
	    IF candy THEN video(msg,FALSE);END;
            CASE cmd OF
            | crc             : WrStr(valToStr(16,wi,dollar,"0",v));
            | unsafe          : WrStr(valToStr(16,wi,dollar,"0",v)); WrStr(bl4);
            | md5             : MD5toString(MD5digeststr, MD5digest);
                                WrStr(dollar); WrStr(MD5digeststr);
            | sha             : SHAtoString(SHAdigeststr, SHAdigest);
                                WrStr(dollar); WrStr(SHAdigeststr);
	    ELSE
	        ;
            END;
            (* yes, we know digests already take size into account *)
            WrStr(separ); WrStr( valToStr (10,wifsize,""," ",fsize) );
            WrStr(separ);
            casify(lowercase,canonical);
            IF includeBaseDir = FALSE THEN
                Str.Subst(canonical,removeMe,"");
            END;
            WrStr(canonical);WrLn;
	    IF candy THEN video(msg,TRUE);END;
        END;
        found :=FIO.ReadNextEntry(entry);
        IF ChkEscape() THEN
            IF candy THEN video(msg,FALSE);END;
            RETURN FALSE;
        END;
    END;
    IF candy THEN video(msg,FALSE);END;
    RETURN TRUE;
END;
END computeLogs;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* match our ugly but historic CHKDATA display -- ah, the 80s... *)

PROCEDURE warnUser (crbefore,audiowarn:BOOLEAN; missing,mismatches:LONGCARD);
CONST
    msgborder   ="********************************************";
    msgempty    ="*                                          *";
    msgModified ="* FATAL WARNING ! Modified file(s) : $$$$$ *";
    msgMissing  ="* WARNING ! Missing file(s) :        $$$$$ *";
    placeholder ="$$$$$";
VAR
    Z : ARRAY [1..3] OF str80;
    i : CARDINAL;
BEGIN
    IF audiowarn THEN alarm; END;
    Z[1]:=msgborder;
    (* Z[2]:=msgempty;
    Z[4]:=msgempty; *)
    Z[3]:=msgborder;
    IF mismatches # 0 THEN
        Z[2]:=msgModified;
        Str.Subst(Z[2],placeholder, valToStr(10,5,""," ",mismatches) );
    END;
    IF missing # 0 THEN
        Z[2]:=msgMissing;
        Str.Subst(Z[2],placeholder, valToStr(10,5,""," ",missing) );
    END;
    IF crbefore THEN WrLn;END;
    FOR i:=1 TO 3 DO WrStr( Z[i] ); WrLn; END;
END warnUser;

PROCEDURE chkAnyDigestString (VAR sval:ARRAY OF CHAR;what:cmdtype):BOOLEAN;
CONST
    MD5expectedlen = 16;
    SHAexpectedlen = 20;
VAR
    expectedlen : CARDINAL;
BEGIN
    CASE what OF
    | md5 : expectedlen := MD5expectedlen;
    | sha : expectedlen := SHAexpectedlen;
    ELSE
       ;
    END;
    expectedlen := (expectedlen << 1); (* *2 because hex digit is 2 chars *)

    LowerCase(sval);
    IF sval[0] # dollar THEN RETURN FALSE; END;
    Str.Delete(sval,0,1);
    IF Str.Length(sval) # expectedlen THEN RETURN FALSE; END;
    RETURN verifyString(sval,maphex);
END chkAnyDigestString;

(*
    verifyLog() took about 2.4 K code
    renamed to procLog() because it can also rebuild data
    missing files entries are rewritten as they were

    it's overkill safety, but rebuild keeps previous version as a backup
    we're too lazy to rebuild from a list of canonical entries "-r[r] -method" :
    some hand editing using dummy values required !
    computers don't have to do all the work, eh eh...
    rebuild is just a CHKDATA-like hack for check at startup
*)

PROCEDURE procLog (lowercase,usepath,audiowarn,
                  candy,redir,killprev,performFsizeChk,ascii2oem:BOOLEAN;
                  cmd,forcedmethod:cmdtype;logfile:ARRAY OF CHAR;
                  VAR einfo:ARRAY OF CHAR ):CARDINAL;

VAR
    R,sval,ssize,message,msg,msgDone:str128;
    udne,u,d,n,e,f8e3 : pathtype;
    hin,hout:FIO.File;
    S,S2,orgS : str1024; (* better safe than sorry *)
    i : CARDINAL;
    mismatches,missing,fsize0,v0,fsize,v:LONGCARD;
    readstate : (gotnada,gotmethod,gotdashes,aborted);
    EOFstate, pb, ok, fsizemismatch:BOOLEAN;
    chksum,cszero:CARDINAL;
    canonical : pathtype;
    errcode:CARDINAL;
    MD5digest:MD5digestType;
    MD5digeststr:MD5str;
    SHAdigest:SHAdigestType;
    SHAdigeststr:SHAstr;
    tabsep,recreate,pollEsc:BOOLEAN;
    baklogfile,tmplogfile,logfilesmall:str128; (* should do for good old DOS pathname *)
    wi:CARDINAL;
    separ : str16;
BEGIN
    (* v1.3n IF useLFN THEN usepath:=TRUE; END; (* we cannot get F8E3 from a partial LFN *) *)

    recreate := (cmd=rebuild);

    qdSplitAllPath(logfile,u,d,n,e);
    Lib.MakeAllPath(logfilesmall,"","",n,e); (* not used anyway ! *)
    IF recreate THEN
        msg:=msgRebuilding;
        msgDone:=msgEverythingWentFine;
        pollEsc := FALSE;                (* safety for log integrity *)

        Lib.MakeAllPath(baklogfile,u,d,n,extBAK);
        Lib.MakeAllPath(tmplogfile,u,d,tmprebuild,extTMP);

        (* IF isReadOnly(baklogfile) THEN setReadWrite(baklogfile);END; (* who knows etc. *) *)

        hout:=FIO.Create(baklogfile);
        FIO.AssignBuffer(hout,ioNew ); (* safe : see usage supra *)
    ELSE
        msg:=msgChecking;
        msgDone:=msgEverythingGoes;
        pollEsc := (redir = FALSE);
    END;

    hin:=FIO.OpenRead(logfile);
    FIO.AssignBuffer(hin,ioInBuffer);

    pb:=FALSE; (* format problem *)
    mismatches:=0;
    missing   :=0;
    IF forcedmethod = undefined THEN
        readstate:=gotnada;   (* we need to check header *)
    ELSE
        cmd:=forcedmethod;
        readstate:=gotdashes; (* assume no header, cannot happen with rebuild *)
    END;

    (* Flushkey; *)

    IF candy THEN video(msg,TRUE); END;
    LOOP
        FIO.RdStr(hin,orgS);
        IF FIO.EOF THEN EXIT; END;
        Str.Copy(S,orgS);

	fixentrycharset(ascii2oem,S); (* //FIXME //V09B *)

        LtrimBlanks(S);RtrimBlanks(S);
        CASE S[0] OF
        | nullchar:
            IF recreate THEN FIO.WrLn(hout);END;
        | REMCHAR:
            IF recreate THEN FIO.WrStr(hout,orgS);FIO.WrLn(hout);END;
        ELSE
            CASE readstate OF
            | gotnada:
                casify(lowercase,S);
                i:=firstmethod;
                LOOP
                    CASE i OF
                    | 1: cmd:=crc;      R:=sCRC;
                    | 2: cmd:=unsafe;   R:=sUNSAFE;
                    | 3: cmd:=md5;      R:=sMD5;
                    | 4: cmd:=sha;      R:=sSHA;
                    | 5: cmd:=subdirs;  R:=sSUBDIRS;
		    ELSE
		        ;
                    END;
                    ReplaceChar(R,blank,"");
                    LtrimBlanks(R); (* should be useless ! *)
                    RtrimBlanks(R);
                    casify(lowercase,R);
                    IF Str.Pos(S,R) # MAX(CARDINAL) THEN EXIT; END;
                    INC(i);
                    IF i > lastmethod THEN cmd:=undefined;EXIT; END;
                END;
                IF cmd # undefined THEN
                    INC(readstate);
                    IF recreate THEN FIO.WrStr(hout,orgS);FIO.WrLn(hout);END;
                END;
                IF cmd = subdirs THEN usepath := TRUE; END; (* the once and future safety : ignore -p *)
            | gotmethod:
                R:=sHeader2; (* will do whatever the method *)
                i:=Str.CharPos(R,blank);
                R[i]:=nullchar;
                IF Str.Pos(S,R) # MAX(CARDINAL) THEN
                    INC(readstate);
                    IF recreate THEN FIO.WrStr(hout,orgS);FIO.WrLn(hout);END;
                END;
            | gotdashes:
                tabsep:= ( Str.CharPos(S,tabul) # MAX(CARDINAL) );
                IF tabsep THEN
                    separ:=tabul;
                ELSE
                    separ:=bl2;
                END;

                Str.ItemS(sval,  S, seps, 0);
                Str.ItemS(ssize, S, seps, 1);

                (* Str.ItemS(udne,  S, seps, 2); fix for inner blanks *)
                Str.Copy(S2,S);
                Str.Subst(S2,sval,"");Str.Subst(S2,ssize,"");
                LtrimBlanks(S2);RtrimBlanks(S2);
                Str.Copy(udne,S2); (* this is original trailing path *)

                CASE cmd OF
                | md5:
                    IF chkAnyDigestString(sval,cmd)=FALSE THEN pb:=TRUE; EXIT; END;
                | sha:
                    IF chkAnyDigestString(sval,cmd)=FALSE THEN pb:=TRUE; EXIT; END;
                ELSE
                    IF s2lc(v0    ,16,sval )=FALSE THEN pb:=TRUE;  EXIT; END;
                END;
                IF s2lc(fsize0,10,ssize)=FALSE THEN pb:=TRUE;  EXIT; END;

                Str.Copy(canonical, udne);
		    (* //FIXME useLFN
                    (*
                    v1.3o fix : if we don't use original path,
                    we must find DOS path using filename alone here
                    *)
                    IF NOT (usepath) THEN
                        qdSplitAllPath(canonical,u,d,n,e);
                        Lib.MakeAllPath(canonical,"","",n,e);
                    END;
                    ok:=w9XlongToShort (canonical, errcode,udne);
		    *)
                    ok:=TRUE;
                Str.Copy(S,udne);
                casify(lowercase,S);

                IF usepath THEN
                    qdSplitAllPath(S,u,d,n,e);
                    Lib.MakeAllPath(f8e3,"","",n,e);
                ELSE
                    qdSplitAllPath(S,u,d,n,e);
                    Lib.MakeAllPath(S,"","",n,e); (* we'll check S as filename alone *)
                    Str.Copy(f8e3,S);
                END;

                IF cmd = subdirs THEN
                    unfixDirectory(S); (* yes, we could test "u:\*\." but... *)
                ELSE
                    IF needTrailingDot(f8e3) THEN (* JPI does not keep trailing dot *)
                        Str.Append(S,dot);
                        Str.Append(f8e3,dot);
                    END;
                END;
                IF recreate THEN (* rebuild log *)
                    IF ok THEN ok:=FIO.Exists(S); END;
                    IF ok THEN
                        message:=""; (* fake ok for everything *)
                        IF cmd = subdirs THEN
                            fsize := 0;
                        ELSE
                            fsize := getFileSize(S);
                        END;
                        EOFstate:=FIO.EOF; (* very important ! *)
                        CASE cmd OF
                        | crc      : wi:=8; v:=ComputeCRC32( pathtype(S) );
                        | unsafe   : wi:=4; v:=0;
                        | md5      : wi:=2; ComputeMD5(MD5digest, pathtype(S) );
                        | sha      : wi:=2; ComputeSHA(SHAdigest, pathtype(S) );
                        | subdirs  : wi:=4; v:=0; (* see computeLog *)
			ELSE
			    ;
                        END;
                        FIO.EOF:=EOFstate; (* very important ! *)
                        CASE cmd OF
                        | crc             : Str.Copy(S,valToStr(16,wi,dollar,"0",v));
                        | unsafe          : Str.Concat(S,valToStr(16,wi,dollar,"0",v),bl4);
                        | md5             : MD5toString(MD5digeststr, MD5digest);
                                            Str.Concat(S,dollar,MD5digeststr);
                        | sha             : SHAtoString(SHAdigeststr, SHAdigest);
                                            Str.Concat(S,dollar,SHAdigeststr);
                        | subdirs         : Str.Concat(S,valToStr(16,wi,dollar,"0",v),bl4);
			ELSE
			    ;
                        END;
                        Str.Append(S,separ);Str.Append(S,valToStr(10,wifsize,""," ",fsize));
                        Str.Append(S,separ);Str.Append(S,canonical); (* rewrite original entry path *)
                    ELSE
                        message := msgMissing; INC(missing); (* tell user about problem *)
                        Str.Copy(S,orgS); (* not found : rewrite original *)
                    END;
                    FIO.WrStr(hout,S);FIO.WrLn(hout);

                ELSE (* verify log *)

                    IF ok THEN ok:=FIO.Exists(S); END;
                    IF ok THEN
                        message:="";
                        IF cmd = subdirs THEN
                            fsize := 0;
                            fsize0:= 0; (* safety : anyway, this should be so ! *)
                        ELSE
                            fsize := getFileSize(S);
                        END;
                        EOFstate:=FIO.EOF; (* very important ! *)

                        (* if fsize changed, useless to check anything else *)
                        CASE cmd OF
                        | md5,sha:
                            IF performFsizeChk THEN
                                fsizemismatch := ( fsize # fsize0 );
                            ELSE
                                fsizemismatch := FALSE; (* ignore fsize here, and force file verify *)
                            END;
                        ELSE
                            fsizemismatch := ( fsize # fsize0 );
                        END;
                        IF fsizemismatch THEN
                            message:=msgSizePb;
                        ELSE
                            EOFstate:=FIO.EOF; (* very important ! *)
                            CASE cmd OF
                            | crc      : v:=ComputeCRC32( pathtype(S) );
                                         IF v # v0 THEN message:=msgCpb;END;
                            | unsafe   : ; (* size already checked *)
                            | md5      : ComputeMD5(MD5digest, pathtype(S) );
                                         MD5toString(MD5digeststr, MD5digest);
                                         IF same(MD5digeststr,sval)=FALSE THEN (* both lowercased and without "$" *)
                                              message:=msgMpb;
                                         END;
                            | sha      : ComputeSHA(SHAdigest, pathtype(S) );
                                         SHAtoString(SHAdigeststr, SHAdigest);
                                         IF same(SHAdigeststr,sval)=FALSE THEN (* both lowercased and without "$" *)
                                             message:=msgSpb;
                                         END;
                            | subdirs  : ; (* do nothing *)
			    ELSE
			        ;
                            END;
                            FIO.EOF:=EOFstate;
                        END;
                        IF same(message,"")=FALSE THEN INC(mismatches);END;
                    ELSE
                        message:=msgMissing; INC(missing);
                        IF cmd = subdirs THEN fixDirectory(S);END;
                    END;
                END;

                IF same(message,"")=FALSE THEN
                    IF candy THEN video(msg,FALSE); END;
                    WrStr(message);
                    IF NOT(usepath) THEN (* verifying ignoring path *)
                        WrStr("(");  WrStr(f8e3);  WrStr(") ");
                    END;
                    WrStr(canonical); WrLn;
                    IF candy THEN video(msg,TRUE); END;
                END;
            ELSE
	        ;
            END;
        END;
        IF FIO.EOF THEN EXIT;END;
        IF pollEsc THEN
            IF ChkEscape() THEN readstate:=aborted;EXIT;END;
        END;
    END;
    FIO.Close(hin);
    IF recreate THEN
        FIO.Close(hout);

        (* IF isReadOnly(tmplogfile) THEN setReadWrite(tmplogfile);END; (* who knows etc. *) *)
        IF FIO.Exists(tmplogfile) THEN FIO.Erase(tmplogfile);END;

        (* IF isReadOnly(logfile) THEN setReadWrite(logfile);END; (* who knows etc. *) *)

        (* use full paths here *)
        FIO.Rename(logfile,tmplogfile);
        FIO.Rename(baklogfile,logfile);
        IF killprev THEN
            FIO.Erase(tmplogfile);
        ELSE
            FIO.Rename(tmplogfile,baklogfile);
        END;
    END;
    IF candy THEN video(msg,FALSE); END;

    Str.Copy(einfo,""); (* who knows etc. *)
    CASE readstate OF
    | gotnada,gotmethod :
        i:=errBadFormat; Str.Copy(einfo,logfile);
    | aborted :
        i:=errAbortedByUser;
    | gotdashes :
        IF pb THEN
            i:=errBadLine;Str.Copy(einfo,S);
        ELSE
            IF recreate THEN
                IF missing = 0 THEN
                    i:=errNone;
                    WrStr(msgDone);WrLn;
                ELSE
                    i:=errMissingEntries;
                    warnUser(TRUE, audiowarn, missing,0);
                END;
            ELSE
                IF mismatches=0 THEN
                    IF missing = 0 THEN
                        i:=errNone;
                        WrStr(msgDone);WrLn;
                    ELSE
                        i:=errMissingEntries;
                        warnUser(TRUE, audiowarn, missing,0);
                    END;
                ELSE
                    i:=errDifferences;
                    IF missing = 0 THEN
                        warnUser(TRUE, audiowarn, 0,mismatches);
                    ELSE
                        warnUser(TRUE, audiowarn, 0,mismatches);
                        warnUser(FALSE,FALSE    , missing,0);
                    END;
                END;
            END;
        END;
    ELSE
        ;
    END;
    RETURN i;
END procLog;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str80;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str80;
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

PROCEDURE fmtDate (d,m,y: CARDINAL) : str80;
CONST
    dash = "-";
    separator = dash;
    pad="0";
    baseyear = 0; (* //XDS was 1900 but XDS has changed that *)
    tmonths2="Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec ???";
VAR
    R : str80;
BEGIN
    IF ((m < 1) OR (m > 12)) THEN m := 13; END;
    Str.ItemS(R,tmonths2," ",m-1);
    Str.Prepend(R,separator);
    Str.Prepend(R,using(d,2,pad));
    Str.Append(R,separator);
    Str.Append(R,using(baseyear+y,4,pad));
    RETURN R;
END fmtDate;

PROCEDURE fmtTime (h,m,s:CARDINAL) : str80;
CONST
    separator = colon;
    pad="0";
VAR
    R : str80;
BEGIN
    R := using(h,2,pad);
    Str.Append(R,separator);
    Str.Append(R,using(m,2,pad));
    Str.Append(R,separator);
    Str.Append(R,using(s,2,pad));
    RETURN R;
END fmtTime;

PROCEDURE fmtVal (v:CARDINAL) : str16;
VAR
    S : str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(LONGCARD(v),S,10,ok);
    RETURN S;
END fmtVal;

PROCEDURE dtf (S, sep: ARRAY OF CHAR) : str256;
VAR
    hnd      : FIO.File;
    stamp    : FIO.FileStamp;
    ok       : BOOLEAN;
    R        : str256;
    y,m,d,hh,mm,ss:CARDINAL; (* //XDS JPI uses SHORTCARDs here !!! *)
BEGIN
    hnd:=FIO.OpenRead(S);
    ok:=FIO.GetFileStamp(hnd,stamp);
    FIO.Close(hnd);

    (* //XDS how clever from you NOT to emulate JPI TS M2 names here ! *)
    y  := stamp.year ;
    m  := stamp.month;
    d  := stamp.day  ;
    hh := stamp.hour ;
    mm := stamp.minute  ;
    ss := stamp.second ;

    Str.Copy  (R, fmtDate(d,m,y) );
    Str.Append(R,", ");
    Str.Append(R,fmtTime( hh,mm,ss) );
    Str.Append(R,sep);
    Str.Append(R,S);
    RETURN R;
END dtf;

TYPE
    chronoType = RECORD
        Year,Month,Day : CARDINAL;
        DayOfWeek      : Lib.DayType;
        H,M,S,ss       : CARDINAL; (* ss = (worthless) hundredths of second *)
    END;

VAR (* kolossal kludge *)
    globalchronostart : chronoType;
    globalchronostop  : chronoType;

PROCEDURE fmtDateTimeUS (VAR chrono:chronoType):str80;
TYPE
    tDays   = ARRAY [1..7] OF str16;
    tMonths = ARRAY [1..12] OF str16;
CONST
    strFmtDT    = "~, ~ ~ ~ at ~h ~mn ~s";
    placeholder = "~";
CONST
    tJours = tDays {"Sunday","Monday","Tuesday","Wednesday",
                   "Thursday","Friday","Saturday"
                  };
    tMois = tMonths {"January","February","March","April",
                    "May","June","July","August",
                    "September","October","November","December"
                   };
VAR
    R : str80;
BEGIN
    (* yes, we know it's not very american a date/time format... so what ? *)
WITH chrono DO
    Lib.GetDate (Year,Month,Day,DayOfWeek);
    Lib.GetTime (H,M,S,ss);

    R:=strFmtDT;
    Str.Subst(R,placeholder,tJours[ORD(DayOfWeek)+1]);
    Str.Subst(R,placeholder,fmtVal(Day));
    Str.Subst(R,placeholder,tMois[Month]);
    Str.Subst(R,placeholder,fmtVal(Year));
    Str.Subst(R,placeholder,fmtVal(H));
    Str.Subst(R,placeholder,fmtVal(M));
    Str.Subst(R,placeholder,fmtVal(S));
END;
    RETURN R;
END fmtDateTimeUS;

(*
    gregorian calendar rule : leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100
    1900 is common, 2000 is leap
*)

PROCEDURE getDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END getDaysInFebruary;

(* assume month and year are correct *)

PROCEDURE getDaysInMonth (mois,annee:CARDINAL):CARDINAL;
TYPE
    daysinmonthtype = ARRAY [1..12] OF CARDINAL;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype { 31, 0,31,30,31,30,31,31,30,31,30,31 };
VAR
    m : CARDINAL;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=getDaysInFebruary(annee);END;
    RETURN m;
END getDaysInMonth;

(* jan 1 = 1, etc. *)

PROCEDURE getCountOfDays (jour,mois,annee:CARDINAL):CARDINAL;
VAR
    n,i : CARDINAL;
BEGIN
    n:=jour;
    FOR i:= 1 TO (mois-1) DO
        INC(n, getDaysInMonth(mois,annee) );
    END;
    RETURN n;
END getCountOfDays;

(* out of lazyness, reasonably assume process won't take more than 24 hours ! *)

PROCEDURE fmtDeltaDT (started,ended:chronoType):str80;
CONST
    strFmtTime  = "~h ~mn ~s";
    placeholder = "~";
CONST
    minutesPerHour   = 60;
    secondsPerMinute = 60;
    hundred          = 100;
    midnight         = 24*minutesPerHour*secondsPerMinute*hundred;
    baseyear         = 1980; (* historic ! *)
VAR
    R : str80;
    n,hmsStart,hmsEnd,jmaStart,jmaEnd : LONGCARD; (* in hundredths of seconds *)
    delta : chronoType;
    i,v:CARDINAL;
BEGIN
    n := LONGCARD(started.H) * minutesPerHour + LONGCARD(started.M);
    n := n * secondsPerMinute + LONGCARD(started.S);
    n := n * hundred + LONGCARD(started.ss);
    hmsStart := n;

    n := LONGCARD(ended.H)   * minutesPerHour + LONGCARD(ended.M);
    n := n * secondsPerMinute + LONGCARD(ended.S);
    n := n * hundred + LONGCARD(ended.ss);
    hmsEnd := n;

    n:=LONGCARD ( getCountOfDays(started.Day,started.Month,started.Year) );
    v:=started.Year-1;
    FOR i:= baseyear TO v DO
         INC (n, LONGCARD ( getCountOfDays(31,12,i) ) );
    END;
    jmaStart:=n;

    n:=LONGCARD ( getCountOfDays(ended.Day,ended.Month,ended.Year) );
    v:=ended.Year-1;
    FOR i:= baseyear TO v DO
         INC (n, LONGCARD ( getCountOfDays(31,12,i) ) );
    END;
    jmaEnd:=n;

    IF jmaEnd # jmaStart THEN (* assume no more than one day ! *)
        hmsEnd := hmsEnd + midnight;
    END;
    n := hmsEnd-hmsStart; (* always >= 0 *)
    delta.H   :=CARDINAL (n DIV (minutesPerHour*secondsPerMinute*hundred) );
    delta.M   :=CARDINAL((n DIV (               secondsPerMinute*hundred) ) MOD 60 );
    delta.S   :=CARDINAL((n DIV (                                hundred) ) MOD 60 );
    delta.ss  :=CARDINAL (n MOD hundred);

    R:=strFmtTime;
    Str.Subst(R,placeholder, fmtVal(delta.H));
    Str.Subst(R,placeholder, fmtVal(delta.M));
    Str.Subst(R,placeholder, fmtVal(delta.S));

    RETURN R;
END fmtDeltaDT;

(* ------------------------------------------------------------ *)

PROCEDURE getTMPdir (default:ARRAY OF CHAR; VAR tmpdir:ARRAY OF CHAR);
VAR
    i:CARDINAL;
    D:str128;
BEGIN
    i:=1;
    LOOP
        CASE i OF
        | 1: D:=sTMP;
        | 2: D:=sTEMP;
        | 3: D:=sTMPDIR;
        | 4: D:=sTEMPDIR;
	ELSE
	    ;
        END;
        Lib.EnvironmentFind(D,tmpdir);
        IF same(tmpdir,"")=FALSE THEN EXIT; END;
        INC(i);
        IF i > 4 THEN Str.Copy(tmpdir,default); EXIT; END; (* tmpdir will be empty *)
    END;
    UpperCase(tmpdir); (* probably useless *)
    fixDirectory(tmpdir);
END getTMPdir;

(* ------------------------------------------------------------ *)

(* ugly but this way, we'll stay under the 64 Kb limit *)

CONST
    MAXHASH       = MAX(CARDINAL)-1;
    firstndx      = 1;
    (* maxndx        = 16380; // defined earlier now *)
    (* maxdsklastndx = MAX(CARDINAL)-1; (* yes, we know, 65535-1 may be too small *) *)
    oldndx        = 1;
    newndx        = 2;
TYPE
    cardArrayType      = ARRAY [firstndx..maxndx] OF CARDINAL;
    longcardArrayType  = ARRAY [firstndx..maxndx] OF LONGCARD;
    ptrToCardArray     = POINTER TO cardArrayType;
    ptrToLongCardArray = POINTER TO longcardArrayType;
VAR
    hashIDold              : ptrToCardArray;
    hashIDnew              : ptrToCardArray;
    fposold,flenold,CRCold : ptrToLongCardArray;
    fposnew,flennew,CRCnew : ptrToLongCardArray;

TYPE
    hackdigestype = RECORD
        CASE : BOOLEAN OF
        | TRUE : md5dig : MD5digestType; (* required for MD5 / SHA *)
        | FALSE: shadig : SHAdigestType; (* required for SHA *)
	ELSE
	    ;
        END;
    END;
    fileentrytype = RECORD
        hashID : CARDINAL;
        fpos   : LONGCARD;
        flen   : LONGCARD;
        CRC    : LONGCARD;
        digest : hackdigestype;
    END;

PROCEDURE doIndex (VAR overflowed:BOOLEAN;
                  VAR cmd:cmdtype; VAR lastndx:CARDINAL;
                  VAR dsklastndx:LONGCARD; VAR dskhnd:FIO.File;
                  VAR dsk:ARRAY OF CHAR;
                  forcedmethod:cmdtype;
                  usedisk:BOOLEAN; which:CARDINAL; logfile,tmpdir:ARRAY OF CHAR):BOOLEAN;
VAR
    hin:FIO.File;
    S,S2:str1024; (* better safe than sorry *)
    R,sval,ssize,msg:str128;
    udne:pathtype;
    here,v0,fsize0:LONGCARD;
    readstate : (gotnada,gotmethod,gotdashes);
    i,hash : CARDINAL;
    pb:BOOLEAN;
    fileentry:fileentrytype;
BEGIN
    Str.Concat(msg,msgIndexing,logfile);
    hin:=FIO.OpenRead(logfile);
    FIO.AssignBuffer(hin,ioInBuffer);

    IF usedisk THEN
        CASE which OF
        | oldndx: S:=tmpold;
        | newndx: S:=tmpnew;
	ELSE
	    ;
        END;
        Str.Prepend(S,tmpdir);
        dskhnd:=FIO.Create(S);
        Str.Copy(dsk,S);
        CASE which OF
        | oldndx : FIO.AssignBuffer(dskhnd,ioDskOld);
        | newndx : FIO.AssignBuffer(dskhnd,ioDskNew);
	ELSE
	    ;
        END;
        dsklastndx:=firstndx-1;
    ELSE
        lastndx:=firstndx-1;
    END;

    pb:=FALSE;
    overflowed:=FALSE;

    IF forcedmethod = undefined THEN
        readstate:=gotnada;   (* we need to check header *)
    ELSE
        cmd:=forcedmethod;
        readstate:=gotdashes; (* assume no header, cannot happen with rebuild *)
    END;

    video(msg,TRUE);
    LOOP
        here:=FIO.GetPos(hin);
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;
        LtrimBlanks(S);RtrimBlanks(S);
        CASE S[0] OF
        | nullchar,REMCHAR :
            ;
        ELSE
            CASE readstate OF
            | gotnada:
                casify(TRUE ,S);
                i:=firstmethod;
                LOOP
                    CASE i OF
                    | 1: cmd:=crc;      R:=sCRC;
                    | 2: cmd:=unsafe;   R:=sUNSAFE;
                    | 3: cmd:=md5;      R:=sMD5;
                    | 4: cmd:=sha;      R:=sSHA;
                    | 5: cmd:=subdirs;  R:=sSUBDIRS;
		    ELSE
		        ;
                    END;
                    ReplaceChar(R,blank,"");
                    LtrimBlanks(R); (* should be useless ! *)
                    RtrimBlanks(R);
                    casify(TRUE,R);
                    IF Str.Pos(S,R) # MAX(CARDINAL) THEN EXIT; END;
                    INC(i);
                    IF i > lastmethod THEN cmd:=undefined;EXIT; END;
                END;
                IF cmd # undefined THEN INC(readstate); END;
            | gotmethod:
                R:=sHeader2; (* will do whatever the method *)
                i:=Str.CharPos(R,blank);
                R[i]:=nullchar;
                IF Str.Pos(S,R) # MAX(CARDINAL) THEN INC(readstate);END;
            | gotdashes:
                Str.ItemS(sval,  S, seps, 0);
                Str.ItemS(ssize, S, seps, 1);

                (* Str.ItemS(udne,  S, seps, 2); *)
                Str.Copy(S2,S);
                Str.Subst(S2,sval,"");Str.Subst(S2,ssize,"");
                LtrimBlanks(S2);RtrimBlanks(S2);
                Str.Copy(udne,S2);

                CASE cmd OF
                | md5:
                    IF chkAnyDigestString(sval,cmd)=FALSE THEN pb:=TRUE; EXIT; END;
                | sha:
                    IF chkAnyDigestString(sval,cmd)=FALSE THEN pb:=TRUE; EXIT; END;
                ELSE
                    IF s2lc(v0    ,16,sval )=FALSE THEN pb:=TRUE;  EXIT; END;
                END;
                IF s2lc(fsize0,10,ssize)=FALSE THEN pb:=TRUE;  EXIT; END;

                (*
                i:=Str.CharPos(udne,colon);
                IF i # MAX(CARDINAL) THEN Str.Delete(udne,0,i+1);END; (* remove u: *)
                *)
                IF cmd # subdirs THEN
                    IF needTrailingDot(udne) THEN (* JPI does not keep trailing dot *)
                        Str.Append(udne,dot);
                    END;
                END;
                casify(TRUE,udne);
                hash:=Lib.HashString(udne,MAXHASH); (* hash same case *)

                IF usedisk THEN
                    INC(dsklastndx);
                    (* IF dsklastndx > maxdsklastndx THEN overflowed:=TRUE; EXIT;END; *)
                    fileentry.hashID := hash;
                    fileentry.fpos   := here;
                    fileentry.flen   := fsize0;
                    fileentry.CRC    := v0;
                    fileentry.digest.md5dig := stringToMD5( MD5str(sval) );
                    fileentry.digest.shadig := stringToSHA( SHAstr(sval) );
                    FIO.WrBin(dskhnd, fileentry, SIZE(fileentry));
                ELSE
                    INC(lastndx);
                    IF lastndx > maxndx THEN overflowed:=TRUE; EXIT; END;
                    CASE which OF
                    | oldndx:
                        hashIDold^ [lastndx]:=hash;
                        fposold^   [lastndx]:=here;
                        flenold^   [lastndx]:=fsize0;
                        CRCold^    [lastndx]:=v0;
                    | newndx:
                        hashIDnew^ [lastndx]:=hash;
                        fposnew^   [lastndx]:=here;
                        flennew^   [lastndx]:=fsize0;
                        CRCnew^    [lastndx]:=v0;
		    ELSE
		        ;
                    END;
                END;
	    ELSE
	        ;
            END;
        END;
        IF FIO.EOF THEN EXIT;END;
    END;
    FIO.Close(hin);

    video(msg,FALSE);
    IF pb THEN RETURN FALSE; END;
    IF readstate # gotdashes THEN RETURN FALSE; END;
    IF cmd = undefined THEN RETURN FALSE; END;
    IF overflowed THEN RETURN FALSE; END;
    RETURN TRUE;
END doIndex;

(* assume S in legal form and udne not empty ! *)

PROCEDURE getStrDisk (lowercase:BOOLEAN;fpos:LONGCARD;hnd:FIO.File;
                     VAR udne:pathtype);
VAR
    S:str1024; (* better safe than sorry *)
    len:CARDINAL;
    sval,ssize:str128;
BEGIN
    FIO.Seek(hnd,fpos);
    FIO.RdStr(hnd,S);

    (* Str.ItemS(udne,  S, seps, 2); *)
    Str.ItemS(sval ,  S, seps, 0);
    Str.ItemS(ssize,  S, seps, 1);
    Str.Subst(S,sval,"");Str.Subst(S,ssize,"");
    LtrimBlanks(S);RtrimBlanks(S);
    Str.Copy(udne,S);

    len:=Str.Length(udne);
    IF len > 0 THEN
        IF udne[len-1] # backslash THEN (* no trailing "\", this is not a directory but a file *)
            IF needTrailingDot(udne) THEN (* JPI does not keep trailing dot *)
                Str.Append(udne,dot); (* everywhere ! *)
            END;
        END;
    END;
    casify(lowercase,udne); (* required ! *)
END getStrDisk;

PROCEDURE doSection (S:ARRAY OF CHAR);
BEGIN
    WrStr(dashline);WrLn;
    WrStr(S);WrLn;
    WrStr(dashline);WrLn;
    WrLn;
END doSection;

PROCEDURE doSectionHeader (cmd:cmdtype;older,newer:ARRAY OF CHAR);
VAR
    R:str128;
    S:str2048; (* oversized for safety *)
BEGIN
    CASE cmd OF
    | crc:       R:=sCRC;
    | md5:       R:=sMD5;
    | sha:       R:=sSHA;
    | unsafe:    R:=sUNSAFE;
    | subdirs:   R:=sSUBDIRS;
    ELSE
        ;
    END;
    Str.Concat(S,REMCHAR,nl);
    Str.Append(S,REMCHAR+blank+Banner+nl);
    Str.Append(S,REMCHAR+nl);

  IF cmd # subdirs THEN
    Str.Append(S,dashStarted);Str.Append(S,fmtDateTimeUS(globalchronostart));Str.Append(S,nl);
    Str.Append(S,REMCHAR+nl);
  END;

    Str.Append(S,dasholder); Str.Append(S,dtf(older,dashsep)); Str.Append(S,nl);
    Str.Append(S,dashnewer); Str.Append(S,dtf(newer,dashsep)); Str.Append(S,nl);
    Str.Append(S,REMCHAR+nl);
    Str.Append(S,dashmethod);Str.Append(S,R); Str.Append(S,nl);
    Str.Append(S,REMCHAR+nl);
    IF cmd # subdirs THEN
        Str.Append(S,dashinfo1+nl);
        Str.Append(S,dashinfo2+nl);
        Str.Append(S,REMCHAR+nl);
    END;
    WrStr(S);WrLn;
END doSectionHeader;

PROCEDURE doSectionTrailer (cmd:cmdtype;ndeleted,nadded,nmodified:LONGCARD);
BEGIN
    doSection(dashSummary);
    WrStr(msgDeleted); WrStr( valToStr(10,6,""," ",ndeleted));WrLn;
    WrStr(msgAdded);   WrStr( valToStr(10,6,""," ",nadded  ));WrLn;
    IF cmd # subdirs THEN
        WrStr(msgChanged); WrStr( valToStr(10,6,""," ",nmodified));WrLn;
    END;
    WrLn;
END doSectionTrailer;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* created from doIndex() *)

PROCEDURE getLogMethod (VAR cmd:cmdtype;
                       maxscannedlines:CARDINAL; logfile:ARRAY OF CHAR):BOOLEAN;
VAR
    hin:FIO.File;
    R,msg:str128;
    i,currline:CARDINAL;
    S:str1024; (* better safe than sorry *)
BEGIN
    Str.Concat(msg,msgScanningMethod,logfile);
    hin:=FIO.OpenRead(logfile);
    FIO.AssignBuffer(hin,ioInBuffer);

    currline:=0;
    cmd:=undefined;
    video(msg,TRUE);
    LOOP
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;
        LtrimBlanks(S);RtrimBlanks(S);
        CASE S[0] OF
        | nullchar,REMCHAR :
            ;
        ELSE
            INC(currline);
            IF currline > maxscannedlines THEN EXIT; END;
                casify(TRUE ,S);
                i:=firstmethod;
                LOOP
                    CASE i OF
                    | 1: cmd:=crc;      R:=sCRC;
                    | 2: cmd:=unsafe;   R:=sUNSAFE;
                    | 3: cmd:=md5;      R:=sMD5;
                    | 4: cmd:=sha;      R:=sSHA;
                    | 5: cmd:=subdirs;  R:=sSUBDIRS;
		    ELSE
		        ;
                    END;
                    ReplaceChar(R,blank,"");
                    LtrimBlanks(R); (* should be useless ! *)
                    RtrimBlanks(R);
                    casify(TRUE,R);
                    IF Str.Pos(S,R) # MAX(CARDINAL) THEN EXIT; END;
                    INC(i);
                    IF i > lastmethod THEN cmd:=undefined;EXIT; END;
                END;
                IF cmd # undefined THEN EXIT;END;

        END;
        IF FIO.EOF THEN EXIT;END;
    END;
    FIO.Close(hin);
    video(msg,FALSE);

    RETURN (cmd # undefined);
END getLogMethod;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE listDeleted  (VAR ndeleted:LONGCARD;
                       lowercase,candy,usedisk:BOOLEAN;
                       lastold,lastnew:CARDINAL;dsklastold,dsklastnew:LONGCARD;
                       hndold,hndnew,dskhndold,dskhndnew:FIO.File;
                       sDeleted:ARRAY OF CHAR);
VAR
    msg:str128;
    ii,jj:LONGCARD;
    got:CARDINAL;
    fileentry:fileentrytype;
    hashold,hashnew:CARDINAL;
    hereold,herenew:LONGCARD;
    i,j:CARDINAL;
    sOLD,sNEW : pathtype;
    found: BOOLEAN;
BEGIN

    (* deleted files : found in old, not found in new *)

    doSection(dashDeleted);

    Str.Copy(msg,searchingDeleted);
    IF candy THEN video(msg,TRUE); END;
    ii:=firstndx-1;
    IF usedisk THEN
        FIO.Seek(dskhndold,0);
    ELSE
        dsklastold:=LONGCARD(lastold);
    END;
    LOOP
        INC(ii);
        IF ii > dsklastold THEN EXIT; END;
        IF usedisk THEN
            got:=FIO.RdBin(dskhndold,fileentry,SIZE(fileentry));
            hashold  :=fileentry.hashID;
            hereold  :=fileentry.fpos;
        ELSE
            i:=CARDINAL(ii);
            hashold  :=hashIDold^[i];
            hereold  :=fposold^[i];
        END;
        getStrDisk(lowercase,hereold,hndold,sOLD);

        found:=FALSE;
        jj:=firstndx-1;
        IF usedisk THEN
            FIO.Seek(dskhndnew,0);
        ELSE
            dsklastnew:=LONGCARD(lastnew);
        END;
        LOOP
            INC(jj);
            IF jj > dsklastnew THEN EXIT; END;
            IF usedisk THEN
                got:=FIO.RdBin(dskhndnew,fileentry,SIZE(fileentry));
                hashnew  :=fileentry.hashID;
                herenew  :=fileentry.fpos;
            ELSE
                j:=CARDINAL(jj);
                hashnew  :=hashIDnew^[j];
                herenew  :=fposnew^[j];
            END;
            IF hashnew=hashold THEN (* same hashes, check same strings *)
                getStrDisk(lowercase,herenew,hndnew,sNEW);
                IF same(sOLD,sNEW) THEN found:=TRUE; EXIT; END;
            END;
        END;
        IF found=FALSE THEN
            IF candy THEN video(msg,FALSE); END;
            casify(lowercase,sOLD);
            WrStr(sDeleted);WrStr(sOLD);WrLn;
            IF candy THEN video(msg,TRUE); END;
            INC(ndeleted);
        END;
    END;
    IF candy THEN video(msg,FALSE); END;
    IF ndeleted # 0 THEN WrLn;END;
END listDeleted;

PROCEDURE listAdded    (VAR nadded:LONGCARD;
                       lowercase,candy,usedisk:BOOLEAN;
                       lastold,lastnew:CARDINAL;dsklastold,dsklastnew:LONGCARD;
                       hndold,hndnew,dskhndold,dskhndnew:FIO.File;
                       sAdded:ARRAY OF CHAR);
VAR
    msg:str128;
    ii,jj:LONGCARD;
    got:CARDINAL;
    fileentry:fileentrytype;
    hashold,hashnew:CARDINAL;
    hereold,herenew:LONGCARD;
    i,j:CARDINAL;
    sOLD,sNEW : pathtype;
    found: BOOLEAN;
BEGIN

    (* added files : found in new, not found in old *);

    doSection(dashAdded);

    Str.Copy(msg,searchingAdded);
    IF candy THEN video(msg,TRUE); END;
    ii:=firstndx-1;
    IF usedisk THEN
        FIO.Seek(dskhndnew,0);
    ELSE
        dsklastnew:=LONGCARD(lastnew);
    END;
    LOOP
        INC(ii);
        IF ii > dsklastnew THEN EXIT;END;
        IF usedisk THEN
            got:=FIO.RdBin(dskhndnew,fileentry,SIZE(fileentry));
            hashnew  :=fileentry.hashID;
            herenew  :=fileentry.fpos;
        ELSE
            i:=CARDINAL(ii);
            hashnew  :=hashIDnew^[i];
            herenew  :=fposnew^[i];
        END;
        getStrDisk(lowercase,herenew,hndnew,sNEW);

        found:=FALSE;
        jj:=firstndx-1;
        IF usedisk THEN
            FIO.Seek(dskhndold,0);
        ELSE
            dsklastold:=LONGCARD(lastold);
        END;
        LOOP
            INC(jj);
            IF jj > dsklastold THEN EXIT; END;
            IF usedisk THEN
                got:=FIO.RdBin(dskhndold,fileentry,SIZE(fileentry));
                hashold  :=fileentry.hashID;
                hereold  :=fileentry.fpos;
            ELSE
                j:=CARDINAL(jj);
                hashold  :=hashIDold^[j];
                hereold  :=fposold^[j];
            END;
            IF hashold=hashnew THEN (* same hashes, check same strings *)
                getStrDisk(lowercase,hereold,hndold,sOLD);
                IF same(sOLD,sNEW) THEN found:=TRUE; EXIT; END;
            END;
        END;
        IF found=FALSE THEN
            IF candy THEN video(msg,FALSE); END;
            casify(lowercase,sNEW);
            WrStr(sAdded);WrStr(sNEW);WrLn;
            IF candy THEN video(msg,TRUE); END;
            INC(nadded);
        END;
    END;
    IF candy THEN video(msg,FALSE); END;
    IF nadded # 0 THEN WrLn;END;
END listAdded;


PROCEDURE listModified (VAR nmodified:LONGCARD;
                       lowercase,candy,usedisk,useMD5digest,useSHAdigest:BOOLEAN;
                       lastold,lastnew:CARDINAL;dsklastold,dsklastnew:LONGCARD;
                       hndold,hndnew,dskhndold,dskhndnew:FIO.File;
                       sModified:ARRAY OF CHAR);
VAR
    msg:str128;
    ii,jj:LONGCARD;
    got:CARDINAL;
    fileentry:fileentrytype;
    hashold,hashnew:CARDINAL;
    hereold,herenew:LONGCARD;
    i,j:CARDINAL;
    sOLD,sNEW : pathtype;
    found,different:BOOLEAN;
    valdiff: CARDINAL;
    fsizeold,csold:LONGCARD;
    fsizenew,csnew:LONGCARD;
    MD5digestold,MD5digestnew:MD5digestType;
    SHAdigestold,SHAdigestnew:SHAdigestType;
BEGIN

    (* modified files : found in old, found in new, but length or CRC mismatch *)

    doSection(dashModified);

    Str.Copy(msg,searchingModified);
    IF candy THEN video(msg,TRUE); END;
    ii:=firstndx-1;
    IF usedisk THEN
        FIO.Seek(dskhndold,0);
    ELSE
        dsklastold:=LONGCARD(lastold);
    END;
    LOOP
        INC(ii);
        IF ii > dsklastold THEN EXIT;END;
        IF usedisk THEN
            got:=FIO.RdBin(dskhndold,fileentry,SIZE(fileentry));
            hashold  :=fileentry.hashID;
            hereold  :=fileentry.fpos;
            fsizeold :=fileentry.flen;
            csold    :=fileentry.CRC;
            MD5digestold:=fileentry.digest.md5dig;
            SHAdigestold:=fileentry.digest.shadig;
        ELSE
            i:=CARDINAL(ii);
            hashold  :=hashIDold^[i];
            hereold  :=fposold^[i];
            fsizeold :=flenold^[i];
            csold    :=CRCold^[i];
        END;
        getStrDisk(lowercase,hereold,hndold,sOLD);

        found:=FALSE;
        jj:=firstndx-1;
        IF usedisk THEN
            FIO.Seek(dskhndnew,0);
        ELSE
            dsklastnew:=LONGCARD(lastnew);
        END;
        LOOP
            INC(jj);
            IF jj > dsklastnew THEN EXIT; END;
            IF usedisk THEN
                got:=FIO.RdBin(dskhndnew,fileentry,SIZE(fileentry));
                hashnew  :=fileentry.hashID;
                herenew  :=fileentry.fpos;
                fsizenew :=fileentry.flen;
                csnew    :=fileentry.CRC;
                MD5digestnew:=fileentry.digest.md5dig;
                SHAdigestnew:=fileentry.digest.shadig;
            ELSE
                j:=CARDINAL(jj);
                hashnew  :=hashIDnew^[j];
                herenew  :=fposnew^[j];
                fsizenew :=flennew^[j];
                csnew    :=CRCnew^[j];
            END;
            IF hashnew=hashold THEN (* same hashes, check same strings *)
                getStrDisk(lowercase,herenew,hndnew,sNEW);
                IF same(sOLD,sNEW) THEN found:=TRUE; EXIT; END;
            END;
        END;
        IF found THEN
            different := ((fsizeold # fsizenew) OR (csold # csnew));
            IF useMD5digest THEN
	        (* //XDS crappy compiler won't allow us to compare these types directly ! *)
	    	valdiff:= Lib.Compare(SYSTEM.ADR(MD5digestold),SYSTEM.ADR(MD5digestnew),SIZE(MD5digestold));
                different:=(different OR (valdiff # SIZE(MD5digestold)) );
            ELSIF useSHAdigest THEN
	    	valdiff:= Lib.Compare(SYSTEM.ADR(SHAdigestold),SYSTEM.ADR(SHAdigestnew),SIZE(SHAdigestold));
                different:=(different OR (valdiff # SIZE(SHAdigestold)) );
            END;
            IF different THEN
                IF candy THEN video(msg,FALSE); END;
                casify(lowercase,sOLD);
                WrStr(sModified);WrStr(sOLD);WrLn;
                IF candy THEN video(msg,TRUE); END;
                INC(nmodified);
            END;
        END;
    END;
    IF candy THEN video(msg,FALSE); END;
END listModified;

(*
    scanning for deleted/added/modified entries is no longer inline (well... infunction)
    avoiding modified subdirs forced a very cryptic isl:342 error !
*)

PROCEDURE compareLogs (lowercase,plainprefix,summary,
                      audiowarn,candy,usedisk:BOOLEAN;
                      forcedmethod : cmdtype;
                      oldlog,newlog,tmpdir:ARRAY OF CHAR;
                      VAR einfo:ARRAY OF CHAR ) : CARDINAL;
CONST
    maxscannedlines = 1; (* should always be first line ! *)
VAR
    cmdold,cmdnew:cmdtype;
    lastold,lastnew:CARDINAL;
    dskhndold,dskhndnew:FIO.File;
    dsklastold,dsklastnew:LONGCARD; (* allow more than 65536 files after all *)
    dskold,dsknew:str128;
    sAdded,sDeleted,sModified:str16;
    ndeleted,nadded,nmodified:LONGCARD;
    hndold,hndnew:FIO.File;
    overflowed,useMD5digest,useSHAdigest:BOOLEAN;
BEGIN
    (* //v1.3r fixes *)
    CASE forcedmethod OF
    | md5,sha:
        usedisk:=TRUE;
    | undefined:
        Str.Copy(einfo,oldlog);
        IF getLogMethod(cmdold,maxscannedlines,oldlog)=FALSE THEN RETURN errBadLog;END;
        Str.Copy(einfo,newlog);
        IF getLogMethod(cmdnew,maxscannedlines,newlog)=FALSE THEN RETURN errBadLog;END;
        IF cmdold # cmdnew THEN RETURN errMethods; END;
        CASE cmdnew OF
        | md5 :
            (* IF usedisk=FALSE THEN RETURN errDiskRequiredForMD5; END; *)
            usedisk := TRUE; (* help user even if he had forgotten TOO LATE ! *)
        | sha :
            (* IF usedisk=FALSE THEN RETURN errDiskRequiredForSHA; END; *)
            usedisk := TRUE; (* help user even if he had forgotten TOO LATE ! *)
	ELSE
	    ;
        END;
    ELSE
        ;
    END;

    IF doIndex (overflowed,cmdold,lastold, dsklastold,dskhndold,dskold,
               forcedmethod, usedisk,oldndx,oldlog,tmpdir) = FALSE THEN
        Str.Copy(einfo,oldlog);
        IF overflowed THEN
            RETURN errOverflow;
        ELSE
            RETURN errBadLog;
        END;
    END;
    IF doIndex (overflowed,cmdnew,lastnew, dsklastnew,dskhndnew,dsknew,
               forcedmethod, usedisk,newndx,newlog,tmpdir) = FALSE THEN
        Str.Copy(einfo,newlog);
        IF overflowed THEN
            RETURN errOverflow;
        ELSE
            RETURN errBadLog;
        END;
    END;

    IF cmdold # cmdnew THEN RETURN errMethods; END; (* useless safety here *)

    useMD5digest := (cmdnew=md5);
    useSHAdigest := (cmdnew=sha);

    IF plainprefix THEN
        sAdded   :=longAdded;
        sDeleted :=longDeleted;
        sModified:=longModified;
    ELSE
        sAdded   :=shortAdded;
        sDeleted :=shortDeleted;
        sModified:=shortModified;
    END;

    ndeleted  :=0;
    nadded    :=0;
    nmodified :=0;

    hndold:=FIO.OpenRead(oldlog);
    FIO.AssignBuffer(hndold,ioOld);
    hndnew:=FIO.OpenRead(newlog);
    FIO.AssignBuffer(hndnew,ioNew);

    doSectionHeader(cmdold,oldlog,newlog);

    (* deleted files : found in old, not found in new *)

    listDeleted      (ndeleted,
                     lowercase,candy,usedisk,
                     lastold,lastnew, dsklastold,dsklastnew,
                     hndold,hndnew, dskhndold,dskhndnew,
                     sDeleted);

    (* added files : found in new, not found in old *)

    listAdded        (nadded,
                     lowercase,candy,usedisk,
                     lastold,lastnew, dsklastold,dsklastnew,
                     hndold,hndnew, dskhndold,dskhndnew,
                     sAdded);

    (* modified files : found in old, found in new, but length or CRC mismatch *)

    IF (cmdold # subdirs) THEN
        listModified (nmodified,
                     lowercase,candy,usedisk,useMD5digest,useSHAdigest,
                     lastold,lastnew, dsklastold,dsklastnew,
                     hndold,hndnew, dskhndold,dskhndnew,
                     sModified);
    END;

    FIO.Close(hndnew);
    FIO.Close(hndold);

    IF usedisk THEN
        FIO.Close(dskhndnew);
        FIO.Close(dskhndold);
        FIO.Erase(dsknew);
        FIO.Erase(dskold);
    END;

    (* always show completion date/time *)

    IF nmodified # 0 THEN WrLn;END;
    WrStr(REMCHAR+nl);
    WrStr(dashCompleted);WrStr(fmtDateTimeUS(globalchronostop));WrLn;
    WrStr(REMCHAR+nl);
  IF cmdold # subdirs THEN
    WrStr(dashElapsed);WrStr(fmtDeltaDT(globalchronostart,globalchronostop));WrLn;
    WrStr(REMCHAR+nl);
  END;
    WrLn;

    IF summary THEN
        doSectionTrailer(cmdold,ndeleted,nadded,nmodified);
    END;

    IF audiowarn THEN alarm; END;

    RETURN errNone;
END compareLogs;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkSpec (defaultdir:ARRAY OF CHAR;
                  VAR basedir,spec:pathtype):BOOLEAN;
VAR
    u,d,n,e:pathtype; (* "u:" "\*\" "" "" *)
BEGIN
    IF Str.Pos(spec,netslash) # MAX(CARDINAL) THEN RETURN FALSE; END;
    IF same(spec,dot) THEN Str.Copy(spec,stardotstar);END;
    IF Str.Match(spec,"*\") THEN Str.Append(spec,stardotstar);END;
    CASE CharCount(spec,colon) OF
    | 0 : ;
    | 1 : IF Str.CharPos(spec,colon) # 1 THEN RETURN FALSE; END; (* only "?:*" allowed *)
    ELSE
        RETURN FALSE;
    END;

    IF Str.Match(spec,"?:\*") THEN
        ;
    ELSIF Str.Match(spec,"?:*") THEN
        RETURN FALSE;
    ELSIF Str.Match(spec,"\*") THEN
        Str.Prepend(spec,colon);
        Str.Prepend(spec,defaultdir[0]);
    ELSE
        Str.Prepend(spec,defaultdir);
    END;

    IF chkJoker(spec)=FALSE THEN
            IF isDirectory(spec) THEN Str.Append(spec,backslash+stardotstar);END;
    END;

    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(basedir,u,d,"","");
    Lib.MakeAllPath(spec,"","",n,e);
    RETURN TRUE;
END chkSpec;

PROCEDURE getStamp (S : ARRAY OF CHAR) : LONGREAL;
CONST
    k10e4 =   10000;
    k10e2 =     100;
    k10e6 = 1000000.0;
VAR
    hnd      : FIO.File;
    stamp    : FIO.FileStamp;
    ok       : BOOLEAN;
    yyyymmdd : LONGCARD;
    hhmmss   : LONGCARD;
    n        : LONGREAL;
BEGIN
    hnd:=FIO.OpenRead(S);
    ok:=FIO.GetFileStamp(hnd,stamp);
    FIO.Close(hnd);
    yyyymmdd:=k10e4*LONGCARD(stamp.year)+k10e2*LONGCARD(stamp.month)+LONGCARD(stamp.day);
    hhmmss  :=k10e4*LONGCARD(stamp.hour)+k10e2*LONGCARD(stamp.minute)+LONGCARD(stamp.second);
    RETURN LONGREAL(yyyymmdd)+(LONGREAL(hhmmss)/k10e6);
END getStamp;

PROCEDURE selectIni (VAR inifile:ARRAY OF CHAR;
                    reverseinisearchorder:BOOLEAN;inidir:ARRAY OF CHAR);
VAR
    u,d,n,e,R,f8e3:str128; (* oversized just in case *)
BEGIN
    Lib.ParamStr(inifile,0);
    UpperCase(inifile); (* we must be sure we're uppercased here *)
    Str.Subst(inifile,extEXE,extINI);

    qdSplitAllPath(inifile, u,d,n,e);
    Lib.MakeAllPath(f8e3,"","",n,e);

    Str.Copy(R,inidir);
    UpperCase(R); (* safety *)
    fixDirectory(R);
    Str.Append(R,f8e3);

    (* inifile = executable directory, R = current directory *)

    IF reverseinisearchorder THEN (* executable then current *)
        IF FIO.Exists(inifile)=FALSE THEN Str.Copy(inifile,R);END; (* favor executable *)
    ELSE (* default : current then executable *)
        IF FIO.Exists(R) THEN Str.Copy(inifile,R);END; (* favor local *)
    END;
END selectIni;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showLFN (VAR R:ARRAY OF CHAR;  availableLFN,disableLFN:BOOLEAN);
BEGIN
    Str.Copy(R,msgLFN);
    IF availableLFN THEN
        IF disableLFN THEN
            Str.Append(R,"disabled");
        ELSE
            Str.Append(R,"enabled");
        END;
    ELSE
        Str.Append(R,"not available");
    END;
END showLFN;

PROCEDURE newcmd (VAR cmd:cmdtype; specified:cmdtype);
BEGIN
    IF ( (cmd=undefined) OR (cmd=specified) ) THEN
        cmd:=specified;
    ELSE
        abort(errMethod,"");
    END;
END newcmd;

PROCEDURE newmethod (VAR cmd:cmdtype; specified:cmdtype);
BEGIN
    IF ( (cmd=undefined) OR (cmd=specified) ) THEN
        cmd:=specified;
    ELSE
        abort(errChkMethod,"");
    END;
END newmethod;

(* help us spare less than 50 bytes ! *)

PROCEDURE noNonsense (shouldnotbetrue:BOOLEAN;S:ARRAY OF CHAR);
BEGIN
    IF shouldnotbetrue THEN abort(errNonsense,S);END;
END noNonsense;

(* ------------------------------------------------------------ *)

VAR
    S,R:pathtype; (* was str128 *)
    parmcount,opt,i:CARDINAL;
    state:(waiting,gotparm1,gotparm2);
    cmd,forcedmethod:cmdtype;
VAR
    uppercase,lowercase,usepath,recurse,showheader,killprev:BOOLEAN;
    tabsep,ignoreini,reverseinisearchorder,stillavoidswapfiles:BOOLEAN;
    excludemode,unpacked,summary, performFsizeChk,includeBaseDir,ascii2oem:BOOLEAN;
    usedisk:BOOLEAN;
    needed:CARDINAL;
    DEBUG,rc,candy:BOOLEAN;
    currdrive:SHORTCARD;
    currdir,logfile,tmpdir,inifile,parm2,inidir:pathtype;
    oldlog,newlog:pathtype;
    basedir : pathtype;
    parm1,spec,fullpath,defaultdir : pathtype;
VAR
    separ:str16;
BEGIN

    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    setSigmaUse(FALSE); (* safety : we won't use crcsigma *)

    cmd       := undefined;
    recurse   := TRUE;
    showheader:= TRUE;
    tabsep    := FALSE;
    uppercase := FALSE;
    usepath   := TRUE;
    ignoreini := FALSE;
    reverseinisearchorder:=FALSE;
    excludemode:=TRUE;
    unpacked  := FALSE;
    summary   := FALSE;
    usedisk   := FALSE;
    killprev  := FALSE;
    candy     := TRUE;
    performFsizeChk:=TRUE;
    includeBaseDir :=TRUE;
    ascii2oem := TRUE;
    DEBUG     := FALSE;
    forcedmethod := undefined; (* must be default for -v, -k and -r[r] *)
    stillavoidswapfiles:=FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,""); END;

    state:=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,""); (* yes, we could clean R instead *)
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
(* available: "bo" *)
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "C"+delim+"CRC"+delim+"CRC32"+delim+
                                   "a"+delim+"adler"+delim+"adler32"+delim+
                                   "f"+delim+"fletcher"+delim+"fletcher16"+delim+
                                   "G"+delim+"METHOD"+delim+
                                   "T"+delim+"TAB"+delim+
                                   "N"+delim+"NORECURSE"+delim+
                                   "U"+delim+"UPPERCASE"+delim+
                                   "V"+delim+"VERIFY"+delim+
                                   "P"+delim+"PATH"+delim+
                                   "K"+delim+"COMPARE"+delim+
                                   "Z"+delim+"SIZE"+delim+
                                   "M"+delim+"MD5"+delim+"DIGEST"+delim+
                                   "X"+delim+"IGNORE"+delim+
                                   "J"+delim+"ONLY"+delim+"INCL"+delim+"INCLUDE"+delim+
                                   "Y"+delim+"PREFIX"+delim+
                                   "I"+delim+"REPORT"+delim+
                                   "w"+delim+"audio"+delim+"warn"+delim+
                                   "Q"+delim+"QUIET"+delim+
                                   "D"+delim+"DISK"+delim+
                                   "KD"+delim+
                                   "S"+delim+"DIRECTORIES"+delim+
                                   "L"+delim+"LFN"+delim+"F8E3"+delim+ (* left for compatibility *)
                                   "VC"+delim+
                                   "VM"+delim+
                                   "VA"+delim+
                                   "VF"+delim+
                                   "VZ"+delim+
                                   "E"+delim+"EXE"+delim+
                                   "XX"+delim+
                                   "$"+delim+"SHA"+delim+
                                   "V$"+delim+
                                   "R"+delim+"REBUILD"+delim+"REFRESH"+delim+
                                   "RR"+delim+

                                   "KC"+delim+
                                   "KM"+delim+
                                   "K$"+delim+
                                   "KZ"+delim+
                                   "KA"+delim+
                                   "KF"+delim+

                                   "!"+delim+"FSIZECHECK"+delim+
                                   "B"+delim+"USEBASE"+delim+
                                   "DEBUG"+delim+
				   "#"+delim+"NOCONVERSION"+delim+"ASSUMEOEM"
                               );
            CASE opt OF
            | 1,2,3     : abort(errHelp,"");
            | 4,5,6     : newcmd (cmd,crc);
            | 7,8,9     :
                          abort(errOption,S);
            | 10,11,12  :
                          abort(errOption,S);
            | 13,14     : showheader:=FALSE;
            | 15,16     : tabsep:=TRUE;
            | 17,18     : recurse:=FALSE;
            | 19,20     : uppercase:=TRUE;
            | 21,22     : newcmd (cmd,verify);
            | 23,24     : usepath:=FALSE;
            | 25,26     : newcmd (cmd,compare);
            | 27,28     : newcmd (cmd,unsafe);
            | 29,30,31  : newcmd (cmd,md5);
            | 32,33     : ignoreini:=TRUE;
            | 34,35,36,37:excludemode:=FALSE;
            | 38,39     : unpacked:=TRUE;
            | 40,41     : summary:=TRUE;
            | 42,43,44  : ;
            | 45,46     : candy := FALSE;
	    | 47,48     : usedisk:=TRUE;
            | 49        : newcmd (cmd,compare);
                          usedisk:=TRUE;
            | 50,51     : newcmd (cmd,subdirs);
            | 52,53,54  : ; (* lfn do nothing *)
            | 55        : newcmd(cmd,verify); newmethod(forcedmethod,crc);
            | 56        : newcmd(cmd,verify); newmethod(forcedmethod,md5);
            | 57        :
                          abort(errOption,S);
            | 58        :
                          abort(errOption,S);
            | 59        : newcmd(cmd,verify); newmethod(forcedmethod,unsafe);
            | 60,61     : reverseinisearchorder:=TRUE;
            | 62        : ignoreini:=TRUE; stillavoidswapfiles:=TRUE;
            | 63,64     : newcmd (cmd,sha);
            | 65        : newcmd(cmd,verify); newmethod(forcedmethod,sha);
            | 66,67,68  : newcmd (cmd,rebuild);
            | 69        : newcmd (cmd,rebuild); killprev:=TRUE;

            | 70        : newcmd(cmd,compare); newmethod(forcedmethod,crc);
            | 71        : newcmd(cmd,compare); newmethod(forcedmethod,md5);
            | 72        : newcmd(cmd,compare); newmethod(forcedmethod,sha);
            | 73        : newcmd(cmd,compare); newmethod(forcedmethod,unsafe);
            | 74        :
                          abort(errOption,S);
            | 75        :
                          abort(errOption,S);

            | 76,77     : performFsizeChk:=FALSE;
            | 78,79     : includeBaseDir:=FALSE;
            | 80        : DEBUG:=TRUE;
	    | 81,82,83  : ascii2oem := FALSE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting:
                Str.Copy(parm1,R);
            | gotparm1:
                Str.Copy(parm2,R);
            ELSE
                abort(errSyntax,S);
            END;
            INC(state);
        END;
    END;


    InitCRC32; (* init table then forget it ! *)
    setSigmaUse(FALSE);

    currdrive := FIO.GetDrive(); (* 1=A, etc. *)
    FIO.GetDir(currdrive,currdir); (* we could use 0 for default drive *)
    (* we have unit letter and "\xxx" directory now *)

    Str.Copy(defaultdir,CHR(ORD("A")-1+currdrive));
    Str.Append(defaultdir,colon);
    Str.Append(defaultdir,currdir);
    Str.Copy(inidir,defaultdir); (* for possible later use *)
    fixDirectory(defaultdir);      (* add required trailing "\" *)

    CASE cmd OF
    | undefined :
        cmd:=crc;
    | subdirs : (* safety : ignore INI, force recurse *)
        ignoreini := TRUE; (* force -x *)
        recurse   := TRUE; (* ignore -n *)
    ELSE
        ;
    END;

    CASE state OF
    | waiting : abort(errHelp,"");
    | gotparm1:
        CASE cmd OF
        | compare :
            abort(errSyntax,"");
        | verify:
            Str.Copy(spec,parm1);
        ELSE
            Str.Copy(spec,parm1);
            IF chkSpec(defaultdir, basedir,spec)=FALSE THEN abort(errBadSpec,R);END;
        END;
    | gotparm2:
        CASE cmd OF
        | compare:
            Str.Copy(S,parm1);
            IF needTrailingDot(S) THEN Str.Append(S,extLOG);END;
            IF chkJoker(S) THEN abort(errJoker,S);END;
            IF FIO.Exists(S)=FALSE THEN abort(errNotFound,S);END;
            Str.Copy(oldlog,S);

            Str.Copy(S,parm2);
            IF needTrailingDot(S) THEN Str.Append(S,extLOG);END;
            IF chkJoker(S) THEN abort(errJoker,S);END;
            IF FIO.Exists(S)=FALSE THEN abort(errNotFound,S);END;
            Str.Copy(newlog,S);

            IF getStamp(newlog) < getStamp(oldlog) THEN (* silently swap names *)
                Str.Copy(S,newlog);
                Str.Copy(newlog,oldlog);
                Str.Copy(oldlog,S);
            END;
        ELSE
            abort(errSyntax,"");
        END;
    ELSE
        ;
    END;

    lowercase:=NOT(uppercase);

    CASE cmd OF
    | compare:
        noNonsense( (recurse=FALSE)       ,"-n");
        noNonsense( (showheader=FALSE)    ,"-g");
        noNonsense( tabsep                ,"-t");
        noNonsense( ignoreini             ,"-x[x]");
        noNonsense( reverseinisearchorder ,"-e");
        noNonsense( (excludemode=FALSE)   ,"-j");
        noNonsense( (usepath=FALSE)       ,"-p");

        getTMPdir(defaultdir, tmpdir);
        IF DEBUG THEN
            WrStr(S);WrLn;
            WrStr(msgOldLog);WrStr(oldlog);WrLn;
            WrStr(msgNewLog);WrStr(newlog);WrLn;
            WrStr(msgUseDisk);
            IF usedisk THEN
                Str.Concat(S,"Disk (",tmpdir);Str.Append(S,")");
            ELSE
                S:="RAM";
            END;
            WrStr(S);WrLn;
            WrLn;
        END;

        IF NOT(usedisk) THEN

            IF DEBUG THEN showmem("prior to first allocate");END;
            (* NEW(hashIDold); *)
            needed := SIZE(hashIDold^);
            ALLOCATE(hashIDold,needed);
            IF DEBUG THEN showmem("1 ok");END;

            needed := SIZE(fposold^);
            ALLOCATE(fposold,needed);
            IF DEBUG THEN showmem("2 ok");END;

            needed := SIZE(flenold^);
            ALLOCATE(flenold,needed);
            IF DEBUG THEN showmem("3 ok");END;

            needed := SIZE(CRCold^);
            ALLOCATE(CRCold,needed);
            IF DEBUG THEN showmem("4 ok");END;

            needed := SIZE(hashIDnew^);
            ALLOCATE(hashIDnew,needed);
            IF DEBUG THEN showmem("5 ok");END;

            needed := SIZE(fposnew^);
            ALLOCATE(fposnew,needed);
            IF DEBUG THEN showmem("6 ok");END;

            needed := SIZE(flennew^);
            ALLOCATE(flennew,needed);
            IF DEBUG THEN showmem("7 ok");END;

            needed := SIZE(CRCnew^);
            ALLOCATE(CRCnew,needed);
            IF DEBUG THEN showmem("after last allocate");END;

        END;

        IF DEBUG THEN showmem("prior to comparing");END;

        i:=compareLogs (lowercase,unpacked,
                       summary,FALSE,candy,usedisk,
                       forcedmethod,
                       oldlog,newlog,tmpdir,  R);

        IF DEBUG THEN showmem("after comparing");END;

        IF i # errNone THEN abort(i,R); END;

    | verify,rebuild:
        noNonsense( (recurse=FALSE)       ,"-n");
        noNonsense( (showheader=FALSE)    ,"-g");
        noNonsense( tabsep                ,"-t");
        noNonsense( ignoreini             ,"-x[x]");
        noNonsense( reverseinisearchorder ,"-e");
        noNonsense( (excludemode=FALSE)   ,"-j");
        noNonsense( unpacked              ,"-y");
        noNonsense( summary               ,"-i");
        noNonsense( usedisk               ,"-d");

        Str.Concat(logfile,basedir,spec);

        IF needTrailingDot(logfile) THEN Str.Append(logfile,extLOG);END;
        IF chkJoker(logfile) THEN abort(errJoker,logfile);END;
        IF FIO.Exists(logfile)=FALSE THEN abort(errNotFound,logfile);END;

        IF DEBUG THEN
            IF cmd=verify THEN
                S:="verifying";
            ELSE
                S:="rebuilding";
            END;
            Str.Prepend(S,"prior to ");
            showmem(S);
        END;

        i:=procLog (lowercase,usepath,FALSE,
                   candy,FALSE,killprev,performFsizeChk,ascii2oem,
                   cmd,forcedmethod,logfile,  R);

        IF DEBUG THEN
            IF cmd=verify THEN
                S:="verifying";
            ELSE
                S:="rebuilding";
            END;
            Str.Prepend(S,"after ");
            showmem(S);
        END;

        IF i # errNone THEN abort(i,R); END;

    ELSE
        noNonsense( (usepath=FALSE)   ,"-p");
        noNonsense( unpacked          ,"-y");
        noNonsense( summary           ,"-i");
        noNonsense( usedisk           ,"-d");

        IF (ignoreini AND (excludemode=FALSE)) THEN abort(errExclusive,"");END;

        IF DEBUG THEN showmem("before INI allocate");END;
        (* NEW(pINIentry); *)
        needed := SIZE(pINIentry^);
        ALLOCATE(pINIentry,needed);
        IF DEBUG THEN showmem("after INI allocate");END;

        lastPath := BuildPathList (recurse, basedir);
        IF lastPath=MAX(CARDINAL) THEN abort(errTooManyDirs,basedir);END;

        selectIni(inifile,reverseinisearchorder,inidir);

        i:=buildINIentries(ignoreini,stillavoidswapfiles,excludemode,ascii2oem,inifile);
        IF i # errNone THEN abort(i,inifile);END;

        IF DEBUG THEN
            WrStr(S);WrLn;
            WrStr(msgDefault); WrStr(defaultdir);WrLn;
            WrStr(msgBaseDir); WrStr(basedir);WrLn;
            WrStr(msgSpec);    WrStr(spec);WrLn;
            WrStr(msgINI);     WrStr(inifile);WrLn;
            WrLn;
            FOR i:=firstINIentry TO lastINIentry DO
                IO.WrCard(i,3);WrStr(" : ");WrStr(pINIentry^[i]);WrLn;
            END;
            WrLn;
            FOR i:=firstPath TO lastPath DO
                getentry(i,fullpath);
                IO.WrCard(i,3);WrStr(" : ");WrStr(fullpath);WrLn;
            END;
            WrLn;
        END;

        (* IF redir THEN verbose:=TRUE; END; *)

        IF showheader THEN doHeader(cmd,tabsep); END;

        IF tabsep THEN
            separ:=tabul;
        ELSE
            separ:=bl2;
        END;

        (* Flushkey; *)

        IF DEBUG THEN showmem("prior to computing");END;

        FOR i:=firstPath TO lastPath DO
            getentry(i,fullpath);
            rc:=computeLogs (cmd,
                            lowercase,excludemode,
                            candy,includeBaseDir,
                            separ,fullpath,spec,basedir);
            IF rc=FALSE THEN
                freePaths (lastPath);
                abort(errAbortedByUser,"");
            END;
        END;

        IF DEBUG THEN showmem("after computing");END;

        freePaths (lastPath);

        needed := SIZE(pINIentry^);
        DEALLOCATE(pINIentry,needed);

        IF DEBUG THEN showmem("final");END;

    END;

    abort(errNone,"");
END cs32.
