(* ---------------------------------------------------------------
Title         Q&D Date & Time
Author        PhG
Overview      see help
Notes         test with
              dt -f:"$d $m $yy $0d $0m $yyyy $dd $mm h m s 0h 0m 0s !d !0d"

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
	          (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

	          many functions had to be dumped because of stupid XDS limits and choices
	          remember only DOS version (both executable and source code)
	          is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -i:#
              -p:#
              -b
              -y:#
              -fr
              -us
              -n:$ (stamp retrieved by XDS is nonsensical)

              support for French has been removed because of the joys of character sets
              among others, DOS ASCII "" looks funny when dumped to screen,
              and, when converted to Win OEM "", gives yet another funny char on screen !
              welcome to a world of mixed character sets !!!

              this option has been added for lack of QD_Text support :
              -w:#

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
	          the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
	          requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
	          with so many warnings, the crap compiler is not even able
	          to warn that a variable has never been defined ! (adventure in EditLand !)
              only ONE backup !

              ah, when there's one "END;" too many, friendly compiler warns us
              about "function procedure without RETURN statement" !!!
              the crappy parser is as good as PowerBASIC's one !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

              while I'm at it : thanks again, XDS, for alt-F, X
              which does not prompt user to save edited source !
              (and no, autosave is not a substitute for user-friendliness and safety)


Bugs          not really : implementation quirk
              as we do a global find/replace, we cannot handle "\\"...
              and we do not care about it ! ;-)
              even though we're not proud of it either...
Wish List     a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 27 Nov 15 v0.9a fixed missing USELESS ELSEs for CASEs : damn you, ISO !
PhG 16 Oct 15 Yet Another Ugly Really Q&D Port to Win32 from DT v1.1a for DOS
--------------------------------------------------------------- *)

MODULE DT32;


IMPORT SYSTEM;
IMPORT Lib;
IMPORT Str;
IMPORT IO;
IMPORT FIO;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* DOS $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Eris *)

CONST
    ErisFmtDefault = 0;
    ErisFmtTerse   = 1;
    ErisFmtAlt     = 2;

TYPE
    discordianType = RECORD
        DinS            : CARDINAL;
        season          : CARDINAL;
        YOLD            : CARDINAL;
        DofW            : CARDINAL;
        isExtraDay      : BOOLEAN;
        rndnum          : CARDINAL;

        (* yes, oversized *)
        strDinS         : str16;
        strDinSordinal  : str16;
        strSeason       : str80;
        strshortSeason  : str16;
        strYOLD         : str16;
        strDofW         : str80;
        strshortDofW    : str16;

        strExtraDay     : str80;
        strshortExtraDay: str16;

        isHolyday       : BOOLEAN;

        strHolyDay      : str80;
        strshortHolyDay : str16;

        strSlogan       : str80; (* depends upon rndnum whatever it is *)
    END;


(*
    gregorian calendar rule according to Jean Meeus :
    leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100 :
    1900 is common, 2000 is leap

    Note DDATE Erisian program is WRONG here !
    I thought of supporting their bug too
    (in addition to the RIGHT algorithm coming from Jean Meeus)
    but on second thought, I decided that no : no silly legacy code !

    note those master unixians should be ashamed of themselves !
    this was STUPID, especially considering the number of programmers
    who "revised" or ported the ugly original C code !
    now, talk about "Open Source" for anyone to "fix" other's code !
    besides, they could easily forge a reason so Discordian calendar
    matches ALL rules of Gregorian calendar, especially since,
    according to kikipedia, Discordian is really SUPPOSED
    to match Gregorian -- as show by its very structure.
    they don't even check wrong dates such as 29 2 1903 = 1 3 1903 !
    they use (annee-1900+3066)=(annee-1166) THEN check (result MOD 4) = 2 !

    it's funny for one of the DDATE programmers to play the smart guy
    about missing days in 1752 and year 0 when he forgets
    a) most Western countries changed for Gregorian calendar in 1582 ;
    b) he was not able to apply *all* gregorian rules for leap years,
    thus allowing errors, wrong input and wrong output (and they
    don't even respect their own language's rules for cardinal formation !)

    ok, ok, DDATE is not vital to anyone,
    but who is to trust people who don't even have their small programs ok,
    and for years ? the one who does not care about details
    should not be trusted either for the big picture.

    should anyone find an error here... well, *I* never said
    I was a "hacker extraordinaire" and I'm no longer an unixian, eh eh... ;-)

*)

PROCEDURE erisGetDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END erisGetDaysInFebruary;

PROCEDURE erisGetDaysInMonth (mois,annee:INTEGER ):INTEGER;
TYPE
    daysinmonthtype = ARRAY [1..12] OF INTEGER;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype{31, 0,31,30,31,30,31,31,30,31,30,31 } ;
VAR
    m : INTEGER;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=erisGetDaysInFebruary(annee);END;
    RETURN m;
END erisGetDaysInMonth;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str16;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str16;     (* was str80 *)
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    IF pad="" THEN RETURN S; END;
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

PROCEDURE substring (S1,S2:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    Str.Caps(S2);
    IF Str.Pos(S1,S2) # MAX(CARDINAL) THEN RETURN TRUE; END;
    Str.Lows(S2);
    IF Str.Pos(S1,S2) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END substring;

PROCEDURE newstring (VAR R:ARRAY OF CHAR; old,new:ARRAY OF CHAR);
BEGIN
    Str.Caps(old);
    IF Str.Pos(R,old) # MAX(CARDINAL) THEN
        Str.Subst(R,old,new);
    ELSE
        Str.Lows(old);
        IF Str.Pos(R,old) = MAX(CARDINAL) THEN RETURN; END;
        Str.Subst(R,old,new);
    END;
END newstring;

PROCEDURE oldnew (sOld,sNew:ARRAY OF CHAR;VAR R:ARRAY OF CHAR);
BEGIN
    LOOP
        IF substring(R,sOld)=FALSE THEN EXIT;END;
        newstring(R,sOld,sNew);
    END;
END oldnew;

(* ------------------------------------------------------------ *)

PROCEDURE buildOrdinalEnding (DiS : CARDINAL ):str16;
VAR
    X:str16;
    i:CARDINAL;
BEGIN
    X:="?"; (* error ! *)
        i:=DiS;
        CASE i OF
        | 0:       X:="th";
        | 1:       X:="st";
        | 2:       X:="nd";
        | 3:       X:="rd";
        | 4..9:    X:="th";
        | 10..19:  X:="th";
        ELSE
            i:=(i MOD 10);
            CASE i OF
            | 0:    X:="th";
            | 1:    X:="st";
            | 2:    X:="nd";
            | 3:    X:="rd";
            | 4..9: X:="th";
            ELSE
                ; (* //XDS SILLY USELESS REQUIREMENT *)
            END;
        END;
    RETURN X;
END buildOrdinalEnding;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*

DinS        1..73      ( note 365 = 73 * 5 )
season      1..5
YOLD        year+1166
DofW        1..5
DinYOLD     1..365 or 1..366
isExtraDay  Saint Tib's day

*)

PROCEDURE gregorianToDiscordian (VAR DinS,season,YOLD,DofW,DinYOLD:CARDINAL;
                                 VAR isExtraDay:BOOLEAN;
                                 jour,mois,annee:CARDINAL);
CONST
    janmonth            = 1;
    febmonth            = 2;
    febcountforleapyear = 29;
CONST
    YOLDoffset    = 1166;
    daysPerSeason = 73;
    daysPerWeek   = 5;
VAR
    hasanextraday : BOOLEAN;
    extradaypos   : CARDINAL; (* 59+1 *)
    i,total: CARDINAL;
BEGIN
    YOLD   := annee + YOLDoffset;

    hasanextraday := ( erisGetDaysInMonth(febmonth, annee) = febcountforleapyear );

    (* see page 34 ! *)

    extradaypos := erisGetDaysInMonth(janmonth,annee);
    INC(extradaypos, erisGetDaysInMonth(febmonth,annee) );

    DinYOLD:=0;
    FOR i := janmonth TO mois-1 DO
        INC(DinYOLD, erisGetDaysInMonth (i,annee) );
    END;
    INC(DinYOLD,jour);

    IF hasanextraday THEN
        IF DinYOLD > extradaypos THEN
            total:=DinYOLD-1;
        ELSE
            total:=DinYOLD;
        END;
    ELSE
        total := DinYOLD;
    END;
    DEC(total); (* 0-based now *)

    season := total DIV daysPerSeason; INC(season);
    DofW   := total MOD daysPerWeek;   INC(DofW);
    DinS   := total MOD daysPerSeason; INC(DinS);

    isExtraDay := ( hasanextraday AND (DinYOLD = extradaypos) );
END gregorianToDiscordian;

PROCEDURE discordianToType (VAR d :discordianType;
                           DinS,season,YOLD,DofW:CARDINAL;
                           isExtraDay:BOOLEAN);
BEGIN
    d.DinS      := DinS;
    d.season    := season;
    d.YOLD      := YOLD;
    d.DofW      := DofW;
    d.isExtraDay:= isExtraDay;
END discordianToType;

(*
    assume "d" infos are ok
    note Feb 29 tokens strings are nonsensical :
    program should check for isExtraDay i.e. Saint Tib's day
    and process strings accordingly
    now, if Discordians had not decided this was an *extra* day
    without day/season/dayofweek... :-( & ;-)

*)

PROCEDURE buildDiscordianTokens (VAR d:discordianType;
                                 rndnum:CARDINAL);
CONST
    usSeasons       = "Chaos,Discord,Confusion,Bureaucracy,The Aftermath";

    usSeasonsAbrev  = "Chs,Dsc,Cfn,Bcy,Afm";

    usDoWs          = "Sweetmorn,Boomtime,Pungenday,Prickle-Prickle,Setting Orange";

    usDoWsAbrev     = "SM,BT,PD,PP,SO";

    usExtraDay      = "Saint Tib's day";

    usExtraDayAbrev = "St Tib";

    (* use "/" separator here for we need "," *)

    us5             = "Mungday to honor Hung Mung the Apostle/"+
                      "Mojoday to honor Doctor Van Van Mojo the Apostle/"+
                      "Syaday to honor Sri Syadasti the Apostle/"+ (* guliday saint gulik ??? *)
                      "Zaraday to honor Zarathud the Apostle/"+
                      "Maladay to honor Malaclypse the Elder";

    us5abrev        = "Mungday/Mojoday/Syaday/Zaraday/Maladay";

    us50            = "Chaoflux/Discoflux/Confuflux/Bureflux/Afflux";

    us50abrev       = us50;

    lstSlogans      = "Hail Eris !/"+
                      "All Hail Discordia !/"+
                      "Kallisti !/"+
                      "Fnord./"+
                      "Or Not./"+
                      "Wibble./"+
                      "Pzat !/"+
                      "P'tang !/"+
                      "Frink !/"+
                      "Slack !/"+
                      'Praise "Bob" !/'+
                      "Or kill me./"+
                      "Grudnuk demand sustenance !/"+
                      "Keep the Lasagna flying !/"+
                      "Umlaut Zebra uber alles !/"+  (* no way to get a "" on screen ! *)
                      "Bozozo !/"+
                      "GAFIA !/"+
                      "FUWI !";

CONST
    TIBWARNVALUE  = 0;
    TIBWARNSTRING = "0";
    TIBWARNING    = "?";

VAR
    lstSeasons,lstSeasonsAbrev  : str128;
    lstDoWs,lstDoWsAbrev        : str128;
    extraday                    : str80;
    extradayAbrev               : str16;
    lst5                        : str256;
    lst5abrev                   : str128;
    lst50,lst50abrev            : str128;
    i                           : CARDINAL;
BEGIN
        lstSeasons      := usSeasons;
        lstSeasonsAbrev := usSeasonsAbrev;
        lstDoWs         := usDoWs;
        lstDoWsAbrev    := usDoWsAbrev;
        extraday        := usExtraDay;
        extradayAbrev   := usExtraDayAbrev;
        lst5            := us5;
        lst5abrev       := us5abrev;
        lst50           := us50;
        lst50abrev      := us50abrev;

    Str.Copy   (d.strDinS,        using(d.DinS,1,""));
    Str.Concat (d.strDinSordinal, d.strDinS,buildOrdinalEnding(d.DinS));

    isoleItemS (d.strSeason,      lstSeasons,     comma,d.season-1);
    isoleItemS (d.strshortSeason, lstSeasonsAbrev,comma,d.season-1);

    Str.Copy   (d.strYOLD,        using(d.YOLD,1,""));

    isoleItemS (d.strDofW,        lstDoWs,        comma,d.DofW-1);
    isoleItemS (d.strshortDofW,   lstDoWsAbrev,   comma,d.DofW-1);

    CASE d.DinS OF
    | 5:
        isoleItemS(d.strHolyDay,        lst5,       slash, d.season-1);
        isoleItemS(d.strshortHolyDay,   lst5abrev,  slash, d.season-1);
    | 50:
        isoleItemS(d.strHolyDay,        lst50,      slash, d.season-1);
        isoleItemS(d.strshortHolyDay,   lst50abrev, slash, d.season-1);
    ELSE (* applies to Saint Tib's day too seen as 60 *)
        d.strHolyDay      :="";
        d.strshortHolyDay :="";
    END;
    d.isHolyday := NOT (same(d.strHolyDay,"") );

    i:=CharCount(lstSlogans,slash);
    INC(i); (* make sure we get the right count and never 0 *)
    isoleItemS(d.strSlogan, lstSlogans,slash, (rndnum MOD i) );

    (* now we can process this damn EXTRA day without numbering ! *)

    IF d.isExtraDay THEN
        Str.Copy   (d.strExtraDay,    extraday);
        Str.Copy   (d.strshortExtraDay,extradayAbrev);
        (* //FIXME should be some UNDEFINED token as to prevent nonsensical display *)
        (* we've decided on warnings with impossible values *)
        d.DinS             :=TIBWARNVALUE;
        d.season           :=TIBWARNVALUE;
        d.DofW             :=TIBWARNVALUE;

        d.strDinS          :=TIBWARNSTRING; (* or "59+1" ? *)
        d.strDinSordinal   :=TIBWARNSTRING; (* +"th" ? ah ah only serious ! *);
        d.strSeason        :=TIBWARNING;
        d.strshortSeason   :=TIBWARNING;

        d.strDofW          :=TIBWARNING;
        d.strshortDofW     :=TIBWARNING;

        (* strHolyDay and strshortHolyDay are "" because DinS seems 59+1 i.e. 60 *)

    ELSE
        d.strExtraDay      :="";
        d.strshortExtraDay :="";
    END;

END buildDiscordianTokens;

(* assume *all* "d" infos are ok *)

PROCEDURE buildDiscordianStrings (VAR strDate,strHolyday,strSlogan:ARRAY OF CHAR;
                                  d:discordianType;erispat:CARDINAL);
CONST
    (*
        as we allow user to set date, we have removed such strings :
        "Today", "Nous sommes"
        and while we were at it :
        "It's", "C'est"

        "~" = ordinal
        "#" = cardinal
        "@" = season
        "|" = year
        "%" = dofw
        "*" = holyday (other than saint Tib's day)
        "&" = short form holyday

        "+" = "Apostle" or "Season" // special case : ALT only and LOCAL !

    *)

    usDateFmt        = "%, the ~ day of @ in the YOLD |.";    (* Year of Our Lady Of Discord *)

    usDateFmtAbrev   = "%, @ #, | YOLD";    (* Year of Our Lady Of Discord *)

    usDateExtra      = "Saint Tib's day in the Year | of Our Lady of Discord."; (* between Chaos 59 and Chaos 60 *)

    usDateExtraAbrev = "Saint Tib's day, | YOLD"; (* between Chaos 59 and Chaos 60 *)

    usDateFmtAlt     = "Today is %, day # in the season of @, |.";
    usDateExtraAlt   = "Today is Saint Tib's Day, day between 59 and 60"+
                       " in the season of Chaos, |."; (* "@" would force "?" *)

CONST
    usCeleb          = "Celebrate *.";

    usCelebAbrev     = "&";

    usCelebNIL       = "No celebration this day.";

    usCelebNILabrev  = "No celebration.";

    usCelebAlt       = "It is the sacred + Holyday of &."; (* "+" is a special case *)

    usCelebNILalt    = "No celebration.";

    (* hack to handle alt format *)

    usApostle        = "Apostle";
    usSeason         = "Season";
VAR
    patDate,patCelebrate,S:str128;
    kindOfHolyDay : str16;
    i:CARDINAL;
BEGIN
    kindOfHolyDay := "";
        CASE erispat OF
        | ErisFmtTerse:
            IF d.isExtraDay THEN
            patDate           := usDateExtraAbrev;
            ELSE
            patDate           := usDateFmtAbrev;
            END;
            IF d.isHolyday THEN
            patCelebrate      := usCelebAbrev;
            ELSE
            patCelebrate      := usCelebNILabrev;
            END;
        | ErisFmtDefault:
            IF d.isExtraDay THEN
            patDate           := usDateExtra;
            ELSE
            patDate           := usDateFmt;
            END;
            IF d.isHolyday THEN
            patCelebrate      := usCeleb;
            ELSE
            patCelebrate      := usCelebNIL;
            END;
        | ErisFmtAlt:
            IF d.isExtraDay THEN
            patDate           := usDateExtraAlt;
            ELSE
            patDate           := usDateFmtAlt;
            END;
            IF d.isHolyday THEN
            patCelebrate      := usCelebAlt;
                CASE d.DinS OF
                | 5:  kindOfHolyDay := usApostle;
                | 50: kindOfHolyDay := usSeason;
                ELSE
                    ; (* //XDS DAMN YOU STUPID ISO ! *)
                END;
            ELSE
            patCelebrate      := usCelebNILalt;
            END;
        ELSE
            ; (* //XDS SILLY USELESS REQUIREMENT *)
        END;

    FOR i:=1 TO 2 DO
        CASE i OF
        | 1 : Str.Copy(S, patDate);
        | 2 : Str.Copy(S, patCelebrate);
        ELSE
            ; (* //XDS SILLY USER REQUIREMENT *)
        END;
        oldnew ( "~" , d.strDinSordinal , S );
        oldnew ( "#" , d.strDinS        , S );
        oldnew ( "@" , d.strSeason      , S );
        oldnew ( "|" , d.strYOLD        , S );
        oldnew ( "%" , d.strDofW        , S );
        oldnew ( "*" , d.strHolyDay     , S );
        oldnew ( "&" , d.strshortHolyDay, S );
        oldnew ( "+" , kindOfHolyDay    , S );
        CASE i OF
        | 1 : Str.Copy (strDate    ,S);
        | 2 : Str.Copy (strHolyday ,S);
        ELSE
            ; (* //XDS SILLY USER REQUIREMENT *)
        END;
    END;

    Str.Copy(strSlogan, d.strSlogan);
END buildDiscordianStrings;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    escch   = "\";
    chDT    = "h"; (* lower case required for pretty display in help *)
    chCRLF  = "n";
    chTAB   = "t";
    chPERCENT="p";

    ChDT    = "H";
    ChCRLF  = "N";
    ChTAB   = "T";
    ChPERCENT="P";

    fmtDT     = escch+chDT;    (* almost C-like ! berk... *)
    fmtCRLF   = escch+chCRLF;    (* C-like ! berk... *)
    fmtTAB    = escch+chTAB;    (* ditto ! *)
    fmtPERCENT= escch+chPERCENT;
    (*
    nl      = CHR(13) + CHR(10);
    tab     = CHR(9);
    *)


    defaultFmtUS           = "$dd, $mm $d, $yyyy at 0h:0m:0s";
    defaultFmtUSfilestamp  = "$mm $d, $yyyy at 0h:0m:0s";
    undeterminedDayUS      = "<undetermined>";

    defaultErisFmt         = "#d\n\n#h\n\n#s";
    defaultErisFmtShort    = "#e\n\n#i\n\n#s";
    defaultErisFmtAlt      = "#f\n\n#j";

CONST
    mintabwidth   = 1;
    maxtabwidth   = 16;
CONST
    ProgEXEname   = "DT32";
    ProgTitle     = "Q&D Date & Time (Win32)";
    ProgVersion   = "v0.9a (from v1.1a for DOS)";
    ProgCopyright = "by PhG";
CONST
    errNone         = 0;
    errHelp         = 1;
    errUnknownOpt   = 2;
    errTooManyParms = 3;
    errBadNumber    = 4;
    errInkRange     = 5;
    errPaperRange   = 6;
    errHtabRange    = 7;
    errVtabRange    = 8;
    errCenterHTAB   = 9;
    errLanguage     = 10;
    errNotFound     = 11;
    errJoker        = 12;
    errMoreHelp     = 13;
    errDateSource   = 14;
    errUserDate     = 15;
    errUserYear     = 16;
    errBadRecursiveToken = 17;
    errTooManyLines = 18;
    errEvenMoreHelp = 19;
    errTabWidthRange= 20;
    errEitherOr     = 21;
    errWidthRange   = 22;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 .........1.........2.........3.........4.........5.........6.........7.........8
 12345678901234567890123456789012345678901234567890123456789012345678901234567890
*)
CONST
    placeholder = "|";
    helpmsg = nl+
    ProgTitle+" "+ProgVersion+" "+ProgCopyright+nl+
nl+
"Syntax : "+ProgEXEname+" [string] [option]..."+nl+
nl+
"This program prints current or filename date and time."+nl+
"Date format can be user-specified. Discordian calendar is supported."+nl+
nl+
'-f:$     format string (tokens listed in -?? help screen)'+nl+  (* "$[0]<d|m>", "$dd", "$mm", "$yy", "$yyyy", "[0]<h|m|s>" *)
'         English default is "'+defaultFmtUS+'"'+nl+
'         Discordian default is "'+defaultErisFmt+'"'+nl+
'         Discordian short default is "'+defaultErisFmtShort+'"'+nl+
'         Discordian alternate default is "'+defaultErisFmtAlt+'"'+nl+
"-w:#     set screen width, default is 79"+nl+
"-t:#     tab width (default is 4)"+nl+
"-n[n]    dump a cr+lf newline (-n = after output, -nn = before & after output)"+nl+
"-![!]    beautified output (-!! = -! -c)"+nl+
"-c       centered output (one-liner only or beautified output)"+nl+
"-x:#     horizontal position i.e. htab (one-liner only)"+nl+
"-jma:$   use date specified as jj/mm/aaaa or jj-MMM-aaaa (default is sysdate)"+nl+
"-mdy:$   use date specified as mm/dd/yyyy or MMMdd,aaaa (default is sysdate)"+nl+
"-e[e[e]] display Discordian date (-eris = -yold = -kallisti = -ddate = -e)"+nl+
"-hail:#  dump the whole Discordian year (check 1900, 2000, 1960, 1963, etc.)"+nl+
"-??[?]   more help (to be read at least once !)"+nl+
nl+
"a) String, if specified, should be delimited with double quotes."+nl+
"b) Default program behavior is to append date and time to string,"+nl+
"   unless string contains "+doublequote+fmtDT+doublequote+", which stands for date and time."+nl+
'   Other special substrings are "'+fmtPERCENT+'" for "%", "'+fmtCRLF+'" for CRLF, and "'+fmtTAB+'" for TAB.'+nl+
'   Note mixing any of "'+fmtTAB+'", -c, -! and -x:# may have unexpected results.'+nl+

(* about c) : yes, we know we should support day of week but we're fed up now *)

"c) With any of -n:$, -jma:$ and -mdy:$ options,"+nl+
'   default format strings will not include "$dd" token ;'+nl+
'   forced "$dd" token will be either "'+undeterminedDayUS+'".'+nl+
"d) Year is [1583..3000] : change from julian to gregorian was on Oct 15, 1582"+nl+
"   in the Western world, although a few countries waited until Sep 14, 1752."+nl+
"e) -jma:$ and -mdy:$ options modify date display but time is still system time."+nl+
"f) For obvious reasons, Discordian calendar defaults to English. ;-)"+nl+
"g) By design, Discordian date and holyday formats cannot be modified."+nl+
"   Alternate formats are available with -ee and -eee options."+nl+
"h) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

CONST
    morehelpmsg =
"i) Note DDATE Unix utility does not compute leap years correctly,"+nl+
"   while "+ProgEXEname+" does : 1900, for example, is common, not leap."+nl+
'   Hail Eris ! Kallisti ! Hail Discordia ! Praise "Bob" ! Fnord ! ;-)'+nl+
nl+
"Examples : "+ProgEXEname+nl+
"           "+ProgEXEname+" "+doublequote+"Date et heure actuelles : "+doublequote+nl+
"           "+ProgEXEname+" ***"+fmtCRLF+fmtTAB+fmtDT+fmtCRLF+"***"+nl+
"           "+ProgEXEname+' -f:"'+"!d.$m.$yyyy"+'"'+nl+
"           "+ProgEXEname+' -f:"'+"$0d-$0m-$yyyy"+'"'+nl+
"           "+ProgEXEname+' -f:"'+"Roman date : $!"+'"'+nl+
"           "+ProgEXEname+' -f:"$d $m $yy $0d $0m $yyyy $dd $mm h m s 0h 0m 0s !d !0d"'+nl+
"           "+ProgEXEname+' -n:C:\WINDOWS\USER.DAT "Previous USER.DAT access was "'+nl+
"           "+ProgEXEname+" -e!! -jma:1/2/1963"+nl+
"           "+ProgEXEname+" -mdy:2/1/1963 -! -t:12"+nl+
"           "+"  "+       ' -f:"Gregorian\t$0d-$0m-$yyyy\nDiscordian\t#d\n\t#h\n\n\t#s"'+nl+
nl+
"Tokens allowed in format string are :"+nl+
nl+
"$dd     monday..sunday"+nl+
"$d      1..31 (ordinal)"+nl+
"$0d     01..31"+nl+
"$mm     january..december"+nl+
"$m      1..12"+nl+
"$0m     01..12"+nl+
"$yyyy   ####"+nl+
"$yy     00..99"+nl+
"!d      1er..31 (cardinal)"+nl+
"!0d     1er..31"+nl+
"h      0..23"+nl+
"0h     00..23"+nl+
"m      0..59"+nl+
"0m     00..59"+nl+
"s      0..59"+nl+
"0s     00..59"+nl+
nl+
"$!      Latin date"+nl;

CONST
    evenmorehelpmsg = nl+
"#d      default Discordian date"+nl+
"#h      default Discordian holyday"+nl+
"#e      terse Discordian date"+nl+
"#i      terse Discordian holyday"+nl+
"#f      alternate Discordian date"+nl+
"#j      alternate Discordian holyday"+nl+
"#s      Discordian slogan"+nl+
nl+
"#o      1st..73rd or 1er..73e Discordian ordinal (0=St Tib)"+nl+
"#c      1..73 Discordian cardinal (0=St Tib)"+nl+
'#z      Discordian season ("?"=St Tib)'+nl+
"#y      #### Discordian year"+nl+
'#w      Discordian day of week ("?"=St Tib)'+nl+
'#a      terse Discordian season ("?"=St Tib)'+nl+
'#x      terse Discordian day of week ("?"=St Tib)'+nl+
nl+
"Gregorian calendar    Discordian calendar   Holyday"+nl+
"====================  ====================  ===================="+nl+
"January 5             Chaos 5               Mungday"+nl+
"February 19           Chaos 50              Chaoflux"+nl+
"February 29           Saint Tib's Day       Saint Tib's Day"+nl+
"March 19              Discord 5             Mojoday"+nl+
"May 3                 Discord 50            Discoflux"+nl+
"May 31                Confusion 5           Syaday"+nl+
"July 15               Confusion 50          Confuflux"+nl+
"August 12             Bureaucracy 5         Zaraday"+nl+
"September 26          Bureaucracy 50        Bureflux"+nl+
"October 24            The Aftermath 5       Maladay"+nl+
"December 8            The Aftermath 50      Afflux"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp,errEvenMoreHelp :
        WrStr(helpmsg);
        IF e # errHelp THEN WrStr(morehelpmsg); END;
        IF e = errEvenMoreHelp THEN WrStr(evenmorehelpmsg);END;
        e:=errHelp;
    | errUnknownOpt :
        S := "Illegal "+placeholder+" option !";
        Str.Subst(S,placeholder,einfo);
    | errTooManyParms :
        (* Str.Concat(S,einfo," is just one parameter too many !"); *)
        S := "Enclose string with double quotes !";
    | errBadNumber:
        S := "Illegal value in "+placeholder+" option !";
        Str.Subst(S,placeholder,einfo);
    | errInkRange:
        S := "Ink range is [0..15] !";
    | errPaperRange:
        S := "Paper range is [0..15] !";
    | errHtabRange:
        S := "Horizontal position (htab) is not in legal range !";
    | errVtabRange:
        S := "Vertical position (vtab) is not in legal range !";
    | errCenterHTAB :
        S := "-c and -x:# options are mutually exclusive !";
    | errLanguage:
        S := "-french and -english options are mutually exclusive !";
    | errNotFound:
        S := "Specified "+placeholder+" file does not exist !";
        Str.Subst(S,placeholder,einfo);
    | errJoker:
        S := "At least one illegal joker in "+placeholder+" option !";
        Str.Subst(S,placeholder,einfo);
    | errDateSource:
        S := "-n:$, -jma:$ and -mdy:$ options are mutually exclusive !";
    | errUserDate:
        S := 'Illegal or out of legal [1583..3000] range "'+placeholder+'" user date !';
        Str.Subst(S,placeholder,einfo);
    | errUserYear:
        S := "Illegal year or year out of legal [1583..3000] range !";
    | errBadRecursiveToken:
        (*
        S :='Illegal "'+fmtDT+'" token in "'+placeholder+'" format string !';
        Str.Subst(S,placeholder,einfo);
        *)
        S := '"'+fmtDT+'" can be used in message only and not in format string !';
    | errTooManyLines:
        S := "Too many lines to output !";
    | errTabWidthRange:
        S := "Tab width is [1..16] range !";
    | errEitherOr:
        S := placeholder+" options are mutually exclusive !";
        Str.Subst(S,placeholder,einfo);
    | errWidthRange:
        S := "Illegal line width !";
    ELSE
        S := "This is illogical, Captain !!!";
    END;
    CASE  e OF
    | errNone, errHelp : ;
    ELSE
        WrLn;
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e));    *)
    HALT (e); (* ah ah, feel like in PowerBASIC now... *)
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    datetype = RECORD
        day   : CARDINAL;
        month : CARDINAL;
        year  : CARDINAL;
        dayOfWeek  : Lib.DayType; (* but there's no undefinedDayOfWeek *)
        validDayOfWeek : BOOLEAN; (* //XDS made us add that one *)
    END;
    timetype = RECORD
        hours   : CARDINAL;
        minutes : CARDINAL;
        seconds : CARDINAL;
    END;

PROCEDURE getDateNow (VAR d : datetype);
VAR
    dayOfWeek : Lib.DayType;
BEGIN
    Lib.GetDate(d.year,d.month,d.day,d.dayOfWeek);
    d.validDayOfWeek:=TRUE;
END getDateNow;

PROCEDURE getTimeNow (VAR t : timetype);
VAR
    hundredth : CARDINAL;
BEGIN
    Lib.GetTime(t.hours,t.minutes,t.seconds,hundredth);
END getTimeNow;

CONST
    joursUS = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday "+
               undeterminedDayUS;
    moisUS  = "January February March April May June "+
              "July August September October November December";

(* ------------------------------------------------------------ *)

TYPE
    dttype = RECORD
        CASE : BOOLEAN OF
        | TRUE  :
            t : CARDINAL; (* hms is low  *)
            d : CARDINAL; (* ymd is high *)
        | FALSE :
            dt : LONGCARD;
        (* //XDS : do we need another silly ISO ELSE, eh ??? *)
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

(*
Year stored relative to 1980 (ex. 1988 stores as 8)
    year      month    day   

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number

Seconds are 0 to 29 -- DOS stores nearest even / 2
  hours    minutes   seconds 

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    DOSbaseyear  = 1980;
CONST
    yyMask=BITSET{9..15};    yyShft=9;
    moMask=BITSET{5..8};     moShft=5;
    ddMask=BITSET{0..4};     ddShft=0;
CONST
    hhMask=BITSET{11..15};   hhShft=11;
    miMask=BITSET{5..10};    miShft=5;
    ssMask=BITSET{0..4};     ssShft=0;

PROCEDURE unpackDate (ymd:CARDINAL;VAR y,m,d:CARDINAL);
BEGIN
    y :=  CARDINAL(BITSET(ymd) * yyMask) >> yyShft ;
    m :=  CARDINAL(BITSET(ymd) * moMask) >> moShft ;
    d :=  CARDINAL(BITSET(ymd) * ddMask) >> ddShft ;
    INC(y,DOSbaseyear);
END unpackDate;

PROCEDURE unpackTime (hms:CARDINAL;VAR h,m,s:CARDINAL);
BEGIN
    h :=  CARDINAL(BITSET(hms) * hhMask) >> hhShft ;
    m :=  CARDINAL(BITSET(hms) * miMask) >> miShft ;
    s :=  CARDINAL(BITSET(hms) * ssMask) >> ssShft ;
    s := s << 1; (* yes, yes, "* 2" works too... *)
END unpackTime;

PROCEDURE getfilestamp (VAR dmy:datetype; VAR hms:timetype;
                       S:ARRAY OF CHAR);
VAR
    hnd:FIO.File;
    rc:BOOLEAN;
    stamp:dttype;
BEGIN
    hnd:=FIO.OpenRead(S);
    (* //XDS does not want us to check this !
    IF hnd = MAX(CARDINAL) THEN (* not trapped by fileGetFileStamp() *)
        rc:=FALSE;
    ELSE
    *)
        stamp.dt:=FIO.GetFileDate(hnd);
        rc:=TRUE;
    (* END; *)
    FIO.Close(hnd);

    unpackDate(stamp.d , dmy.year  ,dmy.month  ,dmy.day );
    (* we should compute dayOfWeek but we're fed up *)
    dmy.dayOfWeek := Lib.DayType(Lib.Saturday);
    (* dmy.INC( dmy.dayOfWeek); (* force undetermined day *) fascist //XDS forces an error *)
    dmy.validDayOfWeek:=FALSE;

    unpackTime(stamp.t , hms.hours ,hms.minutes,hms.seconds );
END getfilestamp;

(* ------------------------------------------------------------ *)

(*
    gregorian calendar rule : leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100
    1900 is common, 2000 is leap
*)

PROCEDURE getDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END getDaysInFebruary;

PROCEDURE getDaysInMonth (mois,annee:INTEGER):INTEGER;
TYPE
    daysinmonthtype = ARRAY [1..12] OF INTEGER;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype{31, 0,31,30,31,30,31,31,30,31,30,31};
VAR
    m : INTEGER;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=getDaysInFebruary(annee);END;
    RETURN m;
END getDaysInMonth;

PROCEDURE latinDate (jour,mois,annee:CARDINAL):str80;
CONST
    calendes = 1;
    nones    = 5;
    ides     = 13;
    veille   = "PRID.";
    sKAL     = "KAL.";
    sNON     = "NON.";
    sID      = "ID.";
CONST
    (* 31-13=18 so go to 20 for safety *)
    countLAT= veille+" III IV V VI VII VIII IX "+
              "X XI XII XIII XIV XV XVI XVII XVIII XIX XX";
    moisLAT = "IAN. FEB. MART. APR. MAI. IUN. "+
              "IUL. AUG. SEPT. OCT. NOV. DEC.";
VAR
    j,m,R:str80;
    v:CARDINAL;
BEGIN
    v:=mois-1;
    Str.ItemS(m,moisLAT," ",v);

    CASE jour OF
    | calendes :
        j:=sKAL;
    | calendes+1..nones-1:
        Str.Prepend(m,sNON);
        v:=(nones-jour)-1;
        Str.ItemS(j,countLAT," ",v);
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
    | nones :
        j:=sNON;
    | nones+1..ides-1 :
        Str.Prepend(m,sID);
        v:=(ides-jour)-1;
        Str.ItemS(j,countLAT," ",v);
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
    | ides :
        j:=sID;
    ELSE
        v:=getDaysInMonth(mois,annee);
        IF v < jour THEN
            j:="???";
        ELSE
            v:=((v+1)-jour)-1;
            Str.ItemS(j,countLAT," ",v);
        END;
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
        INC(mois);
        IF mois > 12 THEN mois := 1; END;
        v:=mois-1;
        Str.ItemS(m,moisLAT," ",v);
        Str.Prepend(m,sKAL);
    END;
    IF j[Str.Length(j)-1] # "." THEN Str.Append(j," ");END;
    Str.Concat(R,j,m);
    RETURN R;
END latinDate;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getnum(VAR n:CARDINAL; ndx,mini,maxi:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    v:LONGCARD;
    ok:BOOLEAN;
    R:str16;
BEGIN
    isoleItemS(R,  S,dash,ndx-1);
    v:=Str.StrToCard(R,10,ok);
    IF NOT(ok) THEN RETURN FALSE;END;
    IF v > MAX(CARDINAL) THEN RETURN FALSE;END;
    n:=CARDINAL(v);
    RETURN  NOT ( (n < mini) OR (n > maxi) );
END getnum;

(*
    separator is "-" or "/"
    we handle :
    jma : jj/mm/aaaa   jj/MMM/aaaa   jjMMMaaaa
    dmy : mm/jj/aaaa   MMM/jj/aaaa   MMMjj,aaaa   MMM/jj,aaaa

    yes, we know it's BFL (Brute Force and Lazyness)
    YES, we know we should compute day of week, etc.
*)

CONST
    modeJMA = 0;
    modeMJA = 1;

PROCEDURE parseUserDate (VAR jj,mm,aa:CARDINAL;
                        dateparsemode:CARDINAL;S:ARRAY OF CHAR   ):BOOLEAN;
CONST
    abrevMMus   = "jan feb mar apr may jun jul aug sep oct nov dec";
    abrevMMnum  = "1 2 3 4 5 6 7 8 9 10 11 12";
    febmonth    = 2;
CONST
    minday      = 1;
    maxday      = 31;
    minmonth    = 1;
    maxmonth    = 12;
    minyear     = 1583; (* Oct 15, 1582 for most Western countries ; september 1752 for a few others *)
    maxyear     = 3000; (* we should ALL be dead *)
VAR
    i,j:CARDINAL;
    plain,number:str16;
BEGIN
    ReplaceChar(S, antislash, dash);
    ReplaceChar(S, slash    , dash);
    ReplaceChar(S, comma    , dash);
    ReplaceChar(S, dot      , dash);
    LowerCase(S); (* ignore accents *)
    FOR i:=1 TO 12 DO
            isoleItemS(plain,   abrevMMus  ,blank,i-1);
            isoleItemS(number,  abrevMMnum ,blank,i-1);
            Str.Prepend(number,dash);Str.Append(number,dash);
            Str.Subst(S, plain, number);
    END;
    oldnew (dash+dash, dash, S);
    IF S[0]=dash THEN Str.Delete(S,0,1);END;
    IF CharCount(S,dash) # 2 THEN RETURN FALSE;END;
    (* WrStr(S);WrLn; *)
    CASE dateparsemode OF
    | modeJMA:
        IF getnum(jj,   1,  minday,maxday,    S)=FALSE THEN RETURN FALSE;END;
        IF getnum(mm,   2,  minmonth,maxmonth,S)=FALSE THEN RETURN FALSE;END;
    | modeMJA:
        IF getnum(jj,   2,  minday,maxday,    S)=FALSE THEN RETURN FALSE;END;
        IF getnum(mm,   1,  minmonth,maxmonth,S)=FALSE THEN RETURN FALSE;END;
    ELSE
        RETURN FALSE; (* should never happen for now ! *)
    END;
        IF getnum(aa,   3,  minyear,maxyear,  S)=FALSE THEN RETURN FALSE;END;

    (* don't limit ourself to febmonth here *)
    IF jj > CARDINAL( erisGetDaysInMonth(mm,aa) ) THEN RETURN FALSE; END;

    RETURN TRUE;
END parseUserDate;

TYPE
    datesourceType = (nodatesourceyet,sysdate,filestampdate,
                     userdatejma,userdatemdy);

PROCEDURE newDateSource (VAR datesource:datesourceType;
                        wanted:datesourceType):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    IF ( (datesource = nodatesourceyet) OR (datesource = wanted) ) THEN
        datesource:=wanted;
        ok:=TRUE;
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newDateSource;

PROCEDURE getuserdate (VAR dmy:datetype;
                      dateparsemode:CARDINAL;S:ARRAY OF CHAR);
CONST
    lastweekday = Lib.Saturday;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=parseUserDate (dmy.day,dmy.month,dmy.year,
                      dateparsemode,S);

    (* we should compute dayOfWeek but we're fed up *)
    dmy.dayOfWeek := Lib.DayType(lastweekday);
    (* INC( dmy.dayOfWeek); (* force undetermined day -- how clever... *) fascist //XDS forces an error *)
    dmy.validDayOfWeek:=FALSE;
END getuserdate;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE getDateAndTime (VAR dmy:datetype; VAR hms:timetype;
                         datesource:datesourceType;
                         refpath,sUser:ARRAY OF CHAR);
VAR
    dmyCHK:datetype;
BEGIN
    CASE datesource OF
    | filestampdate:   getfilestamp (dmy,hms,refpath);
    | sysdate:         getDateNow(dmy);
    | userdatejma:     getuserdate(dmy, modeJMA,sUser);
    | userdatemdy:     getuserdate(dmy, modeMJA,sUser);
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    IF datesource # filestampdate THEN
        getTimeNow(hms);
        (* check midnight crossing *)
        getDateNow(dmyCHK);
        (*
            //XDS GAG : both dmy and dmyCHK are datetype type
            yet compiler won't let us test for equality because... "incompatible types" !!!
            we're fed up with XDS and ISO quirks !
        *)
        getTimeNow(hms); (* was IF NOT(dmy = dmyTMP) THEN getTimeNow(hms); END; *)
    END;
END getDateAndTime;

(*

    order DOES matter !!!

    $dd     monday..sunday
    $d      1..31 (ordinal)
    $0d     01..31
    $mm     january..december
    $m      1..12
    $0m     01..12

    $yyyy   ####
    $yy     00..99

    !d      1er..31 (cardinal)
    !0d     1er..31

    h      0..23
    0h     00..23
    m      0..59
    0m     00..59
    s      0..59
    0s     00..59

    $!      Latin date

    #d      Discordian date
    #h      Discordian holyday
    #s      Discordian slogan
    #e      terse Discordian date
    #i      terse Discordian holyday
    #f      alternate Discordian date
    #j      alternate Discordian holyday

    #o      1st..73rd or 1er..73e Discordian ordinal (0=St Tib)
    #c      1..73 Discordian cardinal (0=St Tib)
    #z      Discordian season ("?"=St Tib)
    #y      #### Discordian year
    #w      Discordian day of week ("?"=St Tib)
    #a      terse Discordian season ("?"=St Tib)
    #x      terse Discordian day of week ("?"=St Tib)
*)

PROCEDURE processDateTimeTokens ( VAR R : ARRAY OF CHAR ;
                                datesource:datesourceType;
                                refpath,sUser,strFormat:ARRAY OF CHAR);
VAR
    dmy    : datetype;
    hms    : timetype;
    S,T    : str16;
    pad    : CHAR;
    v      : CARDINAL;
    celebrate:BOOLEAN;
    DinS,season,YOLD,DofW,DinYOLD:CARDINAL;
    eng,isExtraDay:BOOLEAN;
    d:discordianType;
    rndnum:CARDINAL;
    strDate,strHolyday,strSlogan:str256; (* better safe than sorry *)
    strDateAlt,strHolydayAlt:str256;     (* better safe than sorry too *)
    strDateTerse,strHolydayTerse:str128; (* should do *)
BEGIN
    getDateAndTime(dmy,hms,  datesource,refpath,sUser);

    Str.Copy(R,strFormat);

    IF dmy.validDayOfWeek THEN
        v := ORD(dmy.dayOfWeek);
        Str.ItemS(T,joursUS," ",v);
    ELSE
        T:="";
    END;
    (*
    IF usefilestamp THEN
        oldnew("$dd","",R);
    ELSE
    *)
        oldnew("$dd",T,R);
    (*
    END;
    *)

    v:=dmy.day;
    pad := "";   oldnew("$d",    using(v,2,pad), R);
    pad := "0";  oldnew("$0d",   using(v,2,pad), R);

    IF v=1 THEN
    pad := "";   oldnew("!d",    "1er"         , R);
    pad := "0";  oldnew("!0d",   "1er"         , R);
    ELSE
    pad := "";   oldnew("!d",    using(v,2,pad), R);
    pad := "0";  oldnew("!0d",   using(v,2,pad), R);
    END;

    v := dmy.month-1;
    Str.ItemS(T,moisUS," ",v);
    oldnew("$mm",T,R);

    v := dmy.month;
    pad := "";  oldnew("$m",    using(v,2,pad), R);
    pad := "0"; oldnew("$0m",   using(v,2,pad), R);

    v := dmy.year;
    pad := "";  oldnew("$yyyy", using(v,4,pad), R);
    pad := "0";
    v:=(v MOD 100);
                oldnew("$yy",   using(v,2,pad), R);

    (* getTimeNow() was here *)

    v := hms.hours;
    pad := "";   oldnew("h",    using(v,2,pad), R);
    pad := "0";  oldnew("0h",   using(v,2,pad), R);

    v := hms.minutes;
    pad := "";   oldnew("m",    using(v,2,pad), R);
    pad := "0";  oldnew("0m",   using(v,2,pad), R);

    v := hms.seconds;
    pad := "";   oldnew("s",    using(v,2,pad), R);
    pad := "0";  oldnew("0s",   using(v,2,pad), R);

    (* we could handle some escaped chars here, such as "\n", "\t", "\p" *)

    oldnew ("$!", latinDate(dmy.day,dmy.month,dmy.year), R);

    (* discordian stuff now *)

    rndnum:=GetRndCardRange (0,99); (* will be reduced by modulo *)

    gregorianToDiscordian (DinS,season,YOLD,DofW,DinYOLD, isExtraDay,
                           dmy.day, dmy.month, dmy.year);
    discordianToType (d,   DinS,season,YOLD,DofW,isExtraDay);
    buildDiscordianTokens (d,  rndnum );

    buildDiscordianStrings (strDate,strHolyday,strSlogan,          d,ErisFmtDefault);
    buildDiscordianStrings (strDateTerse,strHolydayTerse,strSlogan,d,ErisFmtTerse  );
    buildDiscordianStrings (strDateAlt,strHolydayAlt,strSlogan,    d,ErisFmtAlt);

    oldnew( "#e",  strDateTerse,      R);
    oldnew( "#i",  strHolydayTerse,   R);
    oldnew( "#f",  strDateAlt,        R);
    oldnew( "#j",  strHolydayAlt,     R);
    oldnew( "#d",  strDate,           R);
    oldnew( "#h",  strHolyday,        R);
    oldnew( "#s",  strSlogan,         R);

    (* irrelevant values for Saint Tib's day are shown as "0" or "?" *)

    oldnew( "#o",  d.strDinSordinal,  R);
    oldnew( "#c",  d.strDinS,         R);
    oldnew( "#z",  d.strSeason,       R);
    oldnew( "#y",  d.strYOLD,         R);
    oldnew( "#w",  d.strDofW,         R);

    oldnew( "#a",  d.strshortSeason,       R);
    oldnew( "#x",  d.strshortDofW,         R);

END processDateTimeTokens;

PROCEDURE processFormattingTokens (VAR R:ARRAY OF CHAR;
                                   msg,sDate:ARRAY OF CHAR):BOOLEAN;
VAR
    dtwashere:BOOLEAN;
    i,len:CARDINAL;
    ch:CHAR;
    getting:(grab,gotesc);
BEGIN
    dtwashere:=FALSE;
    getting:=grab;
    Str.Copy(R,"");

    len := Str.Length(msg);
    i:=0;
    WHILE i < len DO
        ch := msg[i];
        CASE getting OF
        | grab :
            IF ch = escch THEN
                getting:=gotesc;
            ELSE
                Str.Append(R,ch);
            END;
        | gotesc:
            CASE ch OF
            | chDT,ChDT     : Str.Append(R,sDate); dtwashere:=TRUE;
            | chCRLF,ChCRLF : Str.Append(R,nl);
            | chTAB,ChTAB   :
                Str.Append(R,tabul);
            | escch         : Str.Append(R,escch); (* \\ becomes \ *)
            | chPERCENT,ChPERCENT:
                Str.Append(R,percent);
            ELSE
                Str.Append(R,escch); Str.Append(R,ch);
            END;
            getting := grab;
        ELSE
            ; (* ok, //XDS, I've covered all cases, so WHY DO I NEED TO ADD THIS USELESS ELSE ??? *)
        END;
        INC(i);
    END;
    RETURN dtwashere;
END processFormattingTokens;

(* ------------------------------------------------------------ *)

PROCEDURE expandTabs (VAR S:ARRAY OF CHAR;tabwidth:CARDINAL );
VAR
    R:str256; (* same as dumpline[] *)
    i,j,add:CARDINAL;
    c:CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c:= S[i-1];
        IF c = tabul THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
    Str.Copy(S,R);
END expandTabs;

VAR
    LineWidth : CARDINAL; (* yet another forced globerk because we can no longer use QD_Text *)
CONST
    mincolumns       = 0;
    maxcolumns       = 132-1;
CONST
    minHtab = 0;
    maxHtab = 80-1; (* //FIXME possibly even -2 *)
    defaultLineWidth = maxHtab; (* // -w:# *)

PROCEDURE getMinHtab () : CARDINAL;
BEGIN
    RETURN minHtab;
END getMinHtab;

PROCEDURE getMaxHtab () : CARDINAL;
BEGIN
    RETURN LineWidth;
    (* RETURN maxHtab; *)
END getMaxHtab;

PROCEDURE getHtab () : CARDINAL;
BEGIN
    RETURN minHtab;
END getHtab;

PROCEDURE computeHtab (len:CARDINAL ):CARDINAL ;
VAR
    mini,maxi,wi,value : CARDINAL;
BEGIN
    mini := getMinHtab(); (* 0.. *)
    maxi := getMaxHtab();
    wi := maxi-mini+1;
    IF wi > len THEN
        value:=(wi-len) DIV 2;
    ELSE
        value := 0;
    END;
    RETURN (mini+value);
END computeHtab;

CONST
    minline = 1;
    maxline = 25; (* a normal 25x80 screen : should be overkill *)
VAR
    dmpline : ARRAY [minline..maxline] OF str256; (* should do *)

(* we'll use global error codes *)

PROCEDURE getMaxVtab():CARDINAL;
BEGIN
    RETURN maxline-1;
END getMaxVtab;

PROCEDURE prepareDmp (VAR lastline:CARDINAL;
                     tabwidth,htab:CARDINAL;
                     cooked:BOOLEAN; Z:str1024 ):CARDINAL;
VAR
    i,p,rc,len,maxlen,maxvtab:CARDINAL;
    S:str256; (* same as dmpline[] *)
BEGIN
    maxvtab  := getMaxVtab();
    rc       := errNone;
    maxlen   := 0;
    lastline := minline-1;

    IF cooked THEN Str.Prepend(Z,nl);Str.Append(Z,nl+nl);END; (* 2 nl before the last will be seen as empty line *)

    LOOP
        IF same(Z,"") THEN EXIT; END;

        p:=Str.Pos(Z,nl);
        IF p = MAX(CARDINAL) THEN
            Str.Copy(S,Z);
            Str.Copy(Z,"");
        ELSE
            Str.Slice(S, Z,0,p);
            Str.Delete(Z,0,p+2);   (* +2 because it's crlf length *)
        END;
        INC(lastline);
        IF lastline > maxline THEN rc:=errTooManyLines; EXIT; END;
        IF cooked THEN Str.Prepend(S,blank);Str.Append(S,blank); END;
        expandTabs(S,tabwidth);
        len:=Str.Length(S);
        IF len > maxlen THEN maxlen := len; END;
        Str.Copy( dmpline[lastline], S);
    END;
    IF rc # errNone THEN RETURN rc; END;
    IF cooked THEN
        FOR i:=minline TO lastline DO
            FOR len:=Str.Length(dmpline[i])+1 TO maxlen DO
                Str.Append(dmpline[i],blank);
            END;
        END;
    END;
    RETURN rc;
END prepareDmp;

PROCEDURE fakeGotoX(htab:CARDINAL);
VAR
    i:CARDINAL;
BEGIN
    FOR i:=1 TO htab DO WrStr(" ");END;
END fakeGotoX;

CONST
    nlnone   = 0;
    nlbefore = 1;
    nlafter  = 2;
    nlboth   = 3;

PROCEDURE dmpAll (lastline,htab,nlmode:CARDINAL;centered,cooked:BOOLEAN);
VAR
    S:str256; (* same as dmpline[] *)
    i,len:CARDINAL;
BEGIN
    CASE nlmode OF
    | nlbefore,nlboth :
        WrLn;
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    FOR i:=minline TO lastline DO
        S:=dmpline[i];
        len:=Str.Length(S);
        IF centered THEN htab:=computeHtab(len);END;
        fakeGotoX(htab); (* was gotoXY(htab,vtab) *)
        WrStr(S);
        IF i < lastline THEN WrLn; END;
    END;

    CASE nlmode OF
    | nlafter,nlboth:
        WrLn;
    ELSE
       ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
END dmpAll;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dbg (S1,S2:ARRAY OF CHAR);
CONST
    wi = 20;
VAR
    i:CARDINAL;
BEGIN
    WrStr("// ");WrStr(S1);
    FOR i:=Str.Length(S1)+1 TO wi DO WrStr(space);END;
    WrStr(" = ");WrStr(S2);WrLn;
END dbg;

PROCEDURE dbgC (S1:ARRAY OF CHAR;v:CARDINAL );
BEGIN
    dbg(S1,using(v,1,""));
END dbgC;

PROCEDURE dbgB (S1:ARRAY OF CHAR;tf:BOOLEAN);
BEGIN
    IF tf THEN
        dbg(S1,"TRUE");
    ELSE
        dbg(S1,"FALSE");
    END;
END dbgB;

PROCEDURE showDiscordianYear (year,erispat:CARDINAL;DEBUG:BOOLEAN);
CONST
    blanks5 = "     ";
    blanks20= blanks5+blanks5+blanks5+blanks5;
VAR
    day,month,rndnum,p:CARDINAL;
    DinS,season,YOLD,DofW,DinYOLD:CARDINAL;
    isExtraDay:BOOLEAN;
    d:discordianType;
    strDate,strHolyday,strSlogan:str256;
    strDateAlt,strHolydayAlt    :str256;
    strDateTerse,strHolydayTerse:str128;
    S:str256;
    indent:str16;
BEGIN
    WrLn;
    rndnum:=0; (* we won't need it *)
    FOR month:=1 TO 12 DO
        FOR day :=1 TO CARDINAL ( erisGetDaysInMonth(month,year) ) DO  (* //XDS forces us to cast ! *)
            gregorianToDiscordian (DinS,season,YOLD,DofW,DinYOLD, isExtraDay,
                                   day,month,year);
            discordianToType (d,   DinS,season,YOLD,DofW,isExtraDay);
            buildDiscordianTokens (d,  rndnum );

            buildDiscordianStrings (strDate,strHolyday,strSlogan,          d,ErisFmtDefault);
            buildDiscordianStrings (strDateTerse,strHolydayTerse,strSlogan,d,ErisFmtTerse);
            buildDiscordianStrings (strDateAlt,strHolydayAlt,strSlogan,    d,ErisFmtAlt);

            IF DEBUG THEN
                dbgC ("DinS",d.DinS);
                dbgC ("season",d.season);
                dbgC ("YOLD",d.YOLD);
                dbgC ("DofW",d.DofW);
                dbgB ("isExtraDay",d.isExtraDay);
                dbg  ("strDinS",d.strDinS);
                dbg  ("strDinSordinal",d.strDinSordinal);
                dbg  ("strSeason",d.strSeason);
                dbg  ("strshortSeason",d.strshortSeason);
                dbg  ("strYOLD",d.strYOLD);
                dbg  ("strDofW",d.strDofW);
                dbg  ("strshortDofW",d.strshortDofW);
                dbg  ("strExtraDay",d.strExtraDay);
                dbg  ("strshortExtraDay",d.strshortExtraDay);
                dbgB ("isHolyday",d.isHolyday);
                dbg  ("strHolyDay",d.strHolyDay);
                dbg  ("strshortHolyDay",d.strshortHolyDay);
            END;

            CASE erispat OF
            | ErisFmtTerse:
                Str.Copy(strDate,   strDateTerse);
                Str.Copy(strHolyday,strHolydayTerse);
            | ErisFmtAlt:
                Str.Copy(strDate,   strDateAlt);
                Str.Copy(strHolyday,strHolydayAlt);
            ELSE
                ; (* ok, //XDS, erispat has only TWO possibilities... WHY THIS DAMN ELSE ??? *)
            END;

            S:="~-~-~ : ~";
            Str.Subst(S,"~",using(day,2,"0"));
            Str.Subst(S,"~",using(month,2,"0"));
            Str.Subst(S,"~",using(year,4,"0"));
            Str.Subst(S,"~",strDate);
            WrStr(S);WrLn;
            IF d.isHolyday THEN
                p:=Str.CharPos(S,":");
                Str.Slice(indent,blanks20,0,p+2);
                WrStr(indent);WrStr(strHolyday);WrLn;
            END;

        END;
        WrLn;
    END;
    WrLn;
END showDiscordianYear;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt : CARDINAL;
    S,R       : str128;
    state     : (waiting,gotstring);

    centered,cooked  : BOOLEAN;
    nlmode,tabwidth,htab : CARDINAL;

    refpath             : str128;
    strMsg,strFormat    : str128;
    lookfor,replacewith : str128;

    len,lastline,rc  : CARDINAL;
    v         : LONGCARD;
    DEBUG     : BOOLEAN;
    datesource: datesourceType;
    sYear,sUser     : str80; (* oversized for "jj/MMM/aaaa" *)
    jj,mm,aa : CARDINAL;
    dmy:datetype;
    hms:timetype;
    erisshortform,dtwashere,hailEris,marvin:BOOLEAN;
    SSS,RRR,Z : str1024; (* (comanche maximum) overkill in the unlikely case output would be very long *)
    ErisFormat : CARDINAL;
BEGIN
    FIO.IOcheck := FALSE;
    (* WrLn; *)

    centered     := FALSE;
    nlmode       := nlnone;
    cooked       := FALSE;
    erisshortform:= FALSE;
    htab         := MAX(CARDINAL); (* remember it starts at 0 ! *)
    tabwidth     := 4;
    LineWidth    := defaultLineWidth;

    Str.Copy(strMsg,"");
    Str.Copy(refpath,"");
    Str.Copy(strFormat,"");
    state        := waiting;
    datesource   := nodatesourceyet;

    Str.Copy(sYear,""); (* useless *)
    hailEris     := FALSE;
    ErisFormat   := ErisFmtDefault;
    marvin       := FALSE; (* the paranoid android *)

    DEBUG   := FALSE;

    parmcount := Lib.ParamCount();
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        cleanCLI(R); ReplaceChar(R,dquote,"");
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "F:"+delim+"FORMAT:"+delim+
                                   "C"+delim+"CENTER"+delim+
                                   "X:"+delim+"HTAB:"+delim+
                                   "JMA:"+delim+"DMY:"+delim+
                                   "MJA:"+delim+"MDY:"+delim+
                                   "??"+delim+"HH"+delim+"MOREHELP"+delim+
                                   "N"+delim+"NL"+delim+"CRLF"+delim+
                                   "!"+delim+"COOKED"+delim+"BEAUTIFIED"+delim+
                                   "???"+delim+"HHH"+delim+"EVENMOREHELP"+delim+

                                   "E"+delim+"ERIS"+delim+"YOLD"+delim+"KALLISTI"+delim+
                                   "E!"+delim+"ERIS!"+delim+"YOLD!"+delim+"KALLISTI!"+delim+
                                   "HAIL:"+delim+
                                   "DDATE"+delim+
                                   "T:"+delim+"TAB:"+delim+"TABWIDTH:"+delim+

                                   "EE"+delim+
                                   "EE!"+delim+
                                   "!!"+delim+
                                   "E!!"+delim+
                                   "EE!!"+delim+
                                   "NN"+delim+
                                   "EEE"+delim+
                                   "EEE!"+delim+
                                   "EEE!!"+delim+
                                   "W:"+delim+"WIDTH:"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5:
                GetString(S,strFormat); (* keep case *)

                (* // XDS quirk forced us to this hack *)
                oldnew ("","",strFormat);

            | 6,7:
                centered:=TRUE;
            | 8,9:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF v >= MAX(CARDINAL) THEN abort(errHtabRange,"");END;
                len := CARDINAL(v);
                (*
                we use maxcolumns instead of getMaxHtab() in case
                new -w:# option -- see infra -- has not yet been set i.e. before -x:#
                for safety, we'll retest after parsing
                *)
                (* IF ( (len < getMinHtab()) OR (len > getMaxHtab()) ) THEN abort(errHtabRange,"");END; *)
                IF ( (len < getMinHtab()) OR (len > maxcolumns ) ) THEN abort(errHtabRange,"");END;
                htab:=len;
            | 10,11:
                GetString(S,sUser);
                IF newDateSource(datesource,userdatejma)=FALSE THEN abort(errDateSource,S);END;
            | 12,13:
                GetString(S,sUser);
                IF newDateSource(datesource,userdatemdy)=FALSE THEN abort(errDateSource,S);END;
            | 14,15,16:
                abort(errMoreHelp,"");
            | 17,18,19:
                nlmode:=nlafter;
            | 20,21,22:
                cooked:= TRUE;
            | 23,24,25:
                abort(errEvenMoreHelp,"");

            | 26,27,28,29:
                hailEris := TRUE;
            | 30,31,32,33:
                hailEris := TRUE; cooked := TRUE;
            | 34:
                GetString(S,sYear);
                Str.Prepend(sYear,"1/1/"); (* ok with jma and mja *)
                IF parseUserDate(jj,mm,aa,modeJMA,sYear)=FALSE THEN abort(errUserYear,"");END;
                marvin := TRUE;
            | 35:
                hailEris := TRUE;
            | 36,37,38:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF v >= MAX(CARDINAL) THEN abort(errTabWidthRange,"");END;
                len := CARDINAL(v);
                IF ( (len < mintabwidth) OR (len > maxtabwidth) ) THEN abort(errTabWidthRange,"");END;
                tabwidth := len;

            | 39:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtTerse;              (* -ee *)
            | 40:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtTerse;cooked:=TRUE; (* -ee! *)

            | 41:
                cooked:=TRUE; centered:=TRUE;             (* -!! *)
            | 42:
                hailEris    := TRUE;                      (* -e!! *)
                cooked:=TRUE; centered:=TRUE;
            | 43:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtTerse;              (* -ee!! *)
                cooked:=TRUE; centered:=TRUE;
            | 44:
                nlmode:=nlboth;
            | 45:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtAlt;                (* -eee *)
            | 46:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtAlt;  cooked:=TRUE; (* -eee! *)
            | 47:
                hailEris    := TRUE;
                ErisFormat  := ErisFmtAlt;                (* -eee!! *)
                cooked:=TRUE; centered:=TRUE;
            | 48,49:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolumns) OR (v > LONGCARD(maxcolumns)) ) THEN abort(errWidthRange,"");END;
                LineWidth:=CARDINAL(v);
            | 50:
                DEBUG := TRUE;
            ELSE
                abort(errUnknownOpt,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Copy(strMsg,S);
            ELSE
                abort(errTooManyParms,S);
            END;
            INC(state);
        END;
    END;
    IF htab # MAX(CARDINAL) THEN
        IF ( (htab < getMinHtab()) OR (htab > getMaxHtab()) ) THEN abort(errHtabRange,"");END;
    END;

    IF (centered AND (htab # MAX(CARDINAL)) ) THEN abort(errCenterHTAB,"");END;

    IF (hailEris AND marvin) THEN abort(errEitherOr,"-hail:# and -e[e[e]]");END;

    (* now we can parse *)
    CASE datesource OF
    | nodatesourceyet :
        datesource:=sysdate;
    | userdatejma :
        IF parseUserDate(jj,mm,aa,modeJMA,sUser)=FALSE THEN abort(errUserDate,S);END;
    | userdatemdy :
        IF parseUserDate(jj,mm,aa,modeMJA,sUser)=FALSE THEN abort(errUserDate,S);END;
    ELSE
        ; (* //XDS that's official now : I hate your syntax *)
    END;

    InitRnd();

    IF same(strFormat,"") THEN
        CASE datesource OF
        | filestampdate,userdatejma,userdatemdy: (* no day of week here *)
            Str.Copy(strFormat,defaultFmtUSfilestamp);
        | sysdate:
            Str.Copy(strFormat,defaultFmtUS);
        ELSE
            ; (* //XDS SILLY USELESS REQUIREMENT *)
        END;
    END;

    (* //FIXME handle hailEris and marvin *)

    (* ------------------------------------------------------------ *)

    IF marvin THEN
        (*
        1900 is common contrarily to what DDATE says
        2000 is leap
        1960 is leap
        1963 is common
        *)
        (* recompute jj,mm,aa *)
        IF parseUserDate(jj,mm,aa,modeJMA,sYear)=FALSE THEN abort(errUserYear,"");END;
        showDiscordianYear(aa,ErisFmtDefault,DEBUG );
        showDiscordianYear(aa,ErisFmtTerse,  DEBUG );
        showDiscordianYear(aa,ErisFmtAlt,    DEBUG );
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF hailEris THEN
        CASE ErisFormat OF
        | ErisFmtDefault:
            Str.Copy(strFormat,defaultErisFmt);
        | ErisFmtTerse:
            Str.Copy(strFormat,defaultErisFmtShort);
        | ErisFmtAlt:
            Str.Copy(strFormat,defaultErisFmtAlt);
        ELSE
            ; (* //XDS SILLY USELESS REQUIREMENT *)
        END;
        Str.Copy(strMsg,""); (* we don't want any user message here ! *)
    END;

    IF DEBUG THEN
        WrStr("user message : ");WrStr(doublequote);WrStr(strMsg);WrStr(doublequote);WrLn;
        WrStr("date format  : ");WrStr(strFormat);WrLn;
        WrStr("file source  : ");WrStr(refpath);WrLn;
        WrStr("user date    : ");WrStr(doublequote);WrStr(sUser);WrStr(doublequote);WrLn;
    END;

    processDateTimeTokens(SSS,  datesource,refpath,sUser,strFormat);

    dtwashere:=processFormattingTokens(RRR, SSS,"");
    IF dtwashere THEN abort(errBadRecursiveToken,strFormat);END;

    dtwashere:=processFormattingTokens(Z, strMsg,RRR);
    IF NOT(dtwashere) THEN Str.Append(Z,RRR);END;

    IF htab=MAX(CARDINAL) THEN htab := getHtab();END;

    rc:=prepareDmp (lastline,tabwidth,htab,
                   cooked,Z);
    IF rc # errNone THEN abort(rc,"");END;

    dmpAll(lastline,htab,nlmode,centered,cooked);

    abort(errNone,"");
END DT32.







