(* ---------------------------------------------------------------
Title         Q&D Binary File Compare
Overview      try and correct DR6/ND7 buggy COMP utility
Usage         see help
Notes         check all batches using FCOMP before v1.3
              scan for FIXME and CHKME


              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
	          (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

	          many functions had to be dumped because of stupid XDS limits and choices
	          remember only DOS version (both executable and source code)
	          is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              yes, yes, we know a few int $13 calls
              could be replaced with Win32 API calls

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
              -mem
              -v
              modifications of output when redirected is no longer handled

              a few DOS-specific limits have been increased (string length)

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
	          the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
	          requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
	          with so many warnings, the crap compiler is not even able
	          to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              batch output does not use DOS ASCII charset (seen in letters with accents) :
              running batch from console will require XLAT conversion
              and even sometimes filtering
              (DEBUG shows they were retrieved "as is" from operating system !)
              all english/american filenames don't seem to share this problem

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

              damn compiler unable to spot its own requirements about
              mandatory ELSE for CASE even if all cases have been handled !!!

              note this program uses UpperCase*() and LowerCase*() functions for DOS


Bugs          - we're lucky doGetDir() found in PCOPY and MAKEPATH prepends u:
                which is not ALWAYS returned by shortToLong (at least at root)
              - yet another M$ one (will they ever stop ?) :
                vindoze (any version) does NOT like
                frequent calls to BIOS chkEscape() !
              - well, side-effect : when comparing with subdirs,
                duplicate filenames can be flagged as different files
              - pattern matching should take both patterns into account
                ($.* against $.* would try every match for * !)


              WIN32 : accents in filenames, "; " not added when redirecting
              (but no detection !), results very different from DOS version

Wish List     include DCOMP functions
              some day (but why ?), use a more clever entries storage method
              (dir entries is really ugly for now)
              (more) clever match for jokers ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !



Who When      What
--- --------- ----------------------------------------------------
PhG 19 Mar 21 v0.9c possible fix for crash with heap size at 8000000 in project
PhG  9 Oct 16 v0.9b remed out XDS Str.Caps and Str.Lows, for too many filenames contain accents
	      implemented uppercase() and lowercase() using DOS tables, not OEM tables
PhG 25 Nov 15 v0.9a we had missed a few CASEs requiring a USELESS ELSE
              while all cases were yet handled !!! SILLY ISO REQUIREMENT !!!
PhG 13 Oct 15 an ugly really Q&D port from FCOMP v1.3j for DOS
--------------------------------------------------------------- *)

MODULE fComp32;

FROM IO IMPORT WrStr, WrLn;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT IO;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

(* bad idea : accents are a problem here with XDS *)

(*

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

*)

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
(* OEM tables from WCOUNT32.MOD *)

CONST

    (* darn, we forgot non-French codes... but we don't care *)
    (* note all these tables are DOS ASCII ! *)

    ignoreme = " ";

    Tupper = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "CUEAAAACEEEIIIAAEOOOUUYOU     "+ (* use "ae" *)
             "AIOUNN                          "+
             "                                "+
             "                               ";

    Tlower = "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "ueaaaaeeeiiiaaeooouuyou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    TupperA= "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "AAEEEIIIOOUUY     "+
             "AIOU                          "+
             "                                "+
             "                                ";

    TlowerA= "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "Ҵı     "+
             "                          "+
             "                                "+
             "                               ";

    (*
    //FIXME : French table has not been fully checked yet
    we just try and fix annoying filenames
    *)

    TupperFR="                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "UAAAEEEIIIAOOOUUYOU     "+
             "AIOUNN                          "+
             "                                "+
             "                                ";

    TlowerFR="                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "uҴaiaooou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    Taz    = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "CueaaaaeeeiiiAAEooouuyOU     "+ (* yes we keep lower case "" *)
             "aiounN               AAA        "+
             "      aA          EEE III     I "+
             "O OOoO   UUUyY                 ";

(*
    Tasc   = "                                "+
             ' !"'+
                "#$%&'()*+,-./0123456789:;<=>?"+
             "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_"+
             "`abcdefghijklmnopqrstuvwxyz{|}~"+
             "Ҵ"+
             "ѳ"+
             ""+
             "";
*)

*)

(* DOS tables from GEMATRIA32.MOD *)


CONST

    (* darn, we forgot non-French codes... but we don't care *)

    ignoreme = " ";

    Tupper = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "CUEAAAACEEEIIIAAEOOOUUYOU     "+ (* use "ae" *)
             "AIOUNN                          "+
             "                                "+
             "                               ";

    Tlower = "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "ueaaaaeeeiiiaaeooouuyou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    TupperA= "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "AAEEEIIIOOUUY     "+
             "AIOU                          "+
             "                                "+
             "                                ";

    TlowerA= "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "     "+
             "                          "+
             "                                "+
             "                               ";

    (*
    //FIXME : French table has not been fully checked yet
    we just try and fix annoying filenames
    *)

    TupperFR="                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "UAAAEEEIIIAOOOUUYOU     "+
             "AIOUNN                          "+
             "                                "+
             "                                ";

    TlowerFR="                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "uaiaooou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    Taz    = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "CueaaaaeeeiiiAAEooouuyOU     "+ (* yes we keep lower case "" *)
             "aiounN               AAA        "+
             "      aA          EEE III     I "+
             "O OOoO   UUUyY                 ";

(*
    Tasc   = "                                "+
             ' !"'+
                "#$%&'()*+,-./0123456789:;<=>?"+
             "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_"+
             "`abcdefghijklmnopqrstuvwxyz{|}~"+
             ""+
             ""+
             ""+
             "";
*)



(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tupper);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tlower);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END LowerCase;

PROCEDURE UpperCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperA);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END UpperCaseAlt;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerA);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END LowerCaseAlt;

PROCEDURE UpperCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperFR);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END UpperCaseFR;

PROCEDURE LowerCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerFR);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END LowerCaseFR;

PROCEDURE ASCIIonly (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Taz);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END ASCIIonly;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    sTMP          = "TMP";
    sTEMP         = "TEMP";
    sTMPDIR       = "TMPDIR";
    sTEMPDIR      = "TEMPDIR";
    sNDX1         = "~DELME1~.TMP"; (* very unlikely to exist ! *)
    sNDX2         = "~DELME2~.TMP";
CONST
    extBAT        = ".BAT";
    extSYS        = ".SYS"; (* alas, there's config.sys stupid name ! *)

    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    sSkippedExtensions = extCOM+delim+extEXE+delim+
                         extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                         extZIP+delim+extARJ+delim+extLZH;
CONST
    sREMarkChar   = ";";
    sRemark       = "rem";
    sEcho         = "ECHO";
    sThem         = "THEM"+extBAT; (* will be prefixed with del/copy *)
    sDELcmd       = "DEL";
    sCOPYcmd      = "COPY";
    sUSERcmd      = "PROC";
CONST
    sDOSDELcli    = "DEL"; (* won't like hidden files *)
    sDOSCOPYcli   = "COPY";
    sDDdelCli     = "DD -k -y -r"; (* really delete including RO *)
    sPCOPYcli     = "PCOPY -p -o"; (* don't recreate path and overwrite RO target *)
CONST
    msgINFO       = "::: ";
    msgOK         = "+++ ";
    msgPB         = "--- ";
    msgDIFF       = "### ";
    msgNADA       = "    ";
    msgWARN       = "*** ";
    msgDEBUG      = "/// ";
CONST
    CHKEVERY      = 256; (* let's call chkEscape every CHKEVERY loop *)
VAR
    DEBUG : BOOLEAN; (* globerk for ease of use *)

(* ------------------------------------------------------------ *)

CONST
    progEXEname   = "FCOMP32";
    progTitle     = "Q&D Binary/Text File Compare (Win32)";
    progVersion   = "v0.9c (from v1.3j for DOS)";
    progCopyright = "by PhG";
    Banner        = progTitle+" "+progVersion+" "+progCopyright;

CONST
    errNone           = 0;
    errHelp           = 1;
    errOption         = 2;
    errParmOverflow   = 3;
    errExpecting      = 4;
    errColon          = 5;
    errInnerParent    = 6;
    errNoParent       = 7;
    errDirJoker       = 8;
    errNetSlash       = 9;
    errBadUnit        = 10;
    errPhantomUnit    = 11;
    errSameSpecs      = 12;
    errStorage        = 13;
    errBadValue       = 14;
    errListMode       = 15;
    errNonsenseBin    = 16;
    errNonsenseText   = 17;
    errNonsenseList   = 18;
    errSpecFileForm   = 19;
    errAborted        = 20;
    errNonsenseTest   = 21;
    errMacLeod        = 22;
    errNotFound       = 23;
    errListOnly       = 24;
    errOpcode         = 25;
    errOpcodeList     = 26;
    errBatchPrefix    = 27;
    errNonsenseRedirection=28;
    errUserCmd        = 29;
    errListJoker      = 30;
    errListNotFound   = 31;
    errOnlyDelOpcode  = 32;

    errCheckPB        = 64;
    errCheckOK        = 96;

    errMismatch       = 128;
    errBothFilesMatch = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);

    PROCEDURE msg3 (VAR S:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR );
    BEGIN
        Str.Concat(S, S1,S2); Str.Append(S, S3);
    END msg3;

CONST
(*
"12345678901234567890123456789012345678901234567890123456789012345678901234567890"
*)
    helpmsg = Banner+nl+
nl+
"Syntax 1 : "+progEXEname+" <spec1> <spec2> [option]..."+nl+
"Syntax 2 : "+progEXEname+" <-c[c]> <list>"+nl+
nl+
"-c[c]   check <list> created with DUPLINES (-cc = create "+sDELcmd+sThem+")"+nl+
"-m:#    maximum mismatch count (0=unlimited, default is 10)"+nl+
"-z      force comparison (shorter size is taken as reference)"+nl+
"-i      return error code 255 if two existing files are identical"+nl+
"-t      force text lines comparison instead of default binary (-v forced)"+nl+
"-k      case-sensitive (-t required)"+nl+
"-w      take tabs and spaces into account (-t required)"+nl+
"-l[a|l] list <spec1> files with identical matching <spec2> files (-ll = -l -a)"+nl+
"-d[a|d] list <spec1> files with different matching <spec2> files (-dd = -d -a)"+nl+
"-a      list all matching files in both <spec1> and <spec2> (-l or -d required)"+nl+
'-del    prefix files with "'+sDOSDELcli+'" (-cc, -l[l] or -d[d] required)'+nl+
'-copy   prefix files with "'+sDOSCOPYcli+'" (-l[l] or -d[d] required)'+nl+
'-kill   prefix files with "'+sDDdelCli+'" (-cc, -l[l] or -d[d] required)'+nl+
'-pcopy  prefix files with "'+sPCOPYcli+'" (-l[l] or -d[d] required)'+nl+
'-u:$    prefix files with user command (-l[l] or -d[d] required)'+nl+
"-bat    create batch file based on prefix operation (-db[a|b], -kb[a|b])"+nl+
"-s      process subdirectories"+nl+
"-v      verbose (slower display, forced with -t)"+nl+
"-n      alternate display (names without paths)"+nl+
nl+
"a) If specification contains any joker, program assumes it applies to files."+nl+
'   Directory specification should have a trailing "\".'+nl+
'   <spec2> file part must match one of "$.$", "*.*", "$.*" or "*.$" forms.'+nl+
'b) Each <list> entry is a line matching "<#|;>< ><digest>< ><path>" format.'+nl+
"c) About -t option (Windows OEM) : older file is taken as reference ;"+nl+
"   temporary files are created in directory specified by, in that order,"+nl+
"   "+sTMP+", "+sTEMP+", "+sTMPDIR+", "+sTEMPDIR+" environment variables"+nl+
"   (if none of these variables is defined, current directory will be used)."+nl+
"   "+sSkippedExtensions+" files are ignored."+nl+
"   Note default character set is Windows OEM for this Win32 binary."+nl+
"d) About -n option : in default mode, listing is terser ;"+nl+
"   in list mode (-l or -d options), path is removed from <spec1> source ;"+nl+
"   this option is ignored with -ll, -dd and -t options."+nl+
"e) A few aliases exist : -<d|k>b[a|b] = <-del|-kill> <-bat> [-all] ; -@ = -c."+nl+
"f) About -c[c] option (syntax 2) : successes are not reported ;"+nl+
'   an entry <path> can be relative but matching "?:\*" pattern is SAFER ;'+nl+
"   -c[c] returns error code 96 if groups contain identical files, else 64."+nl+
"   -ccc and -cck are shortcuts (-cc -k)."+nl+
"g) Note joker matching includes extension if extension is omitted."+nl+
"h) Note batches do *NOT* use DOS ASCII character set : should they contain"+nl+
"   letters with accents, they will have to be converted before they are run."+nl+
"i) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;


VAR
    S : str1024; (* oversized just in case we' use a LFN *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOption:
        msg3(S, 'Illegal "',einfo,'" option !');
    | errParmOverflow:
        msg3(S, '"',einfo,'" is one parameter too many !');
    | errExpecting:
        msg3(S, "Expecting ",einfo," !");
    | errColon:
        msg3(S, 'Unexpected ":" in "',einfo,'" specification !');
    | errInnerParent:
        msg3(S, 'Illegal ".." in "',einfo,'" specification !');
    | errNoParent:
        msg3(S, 'Unresolvable ".." in "',einfo,'" specification !');
    | errDirJoker:
        msg3(S, 'Illegal "',einfo,'" directory joker(s) !');
    | errNetSlash:
        msg3(S, 'Illegal server "\\" in "',einfo,'" specification !');
    | errBadUnit:
        msg3(S, 'Illegal unit in "',einfo,'" specification !');
    | errPhantomUnit:
        msg3(S, 'Unavailable unit in "',einfo,'" specification !');
    | errSameSpecs:
        S:= "Specifying identical <spec1> and <spec2> is a nonsense !";
    | errStorage:
        msg3(S, 'Storage.ALLOCATE() failure while processing "',einfo,'" specification !');
    | errBadValue:
        msg3(S, 'Illegal "',einfo,'" value !');
    | errListMode:
        S:="-l[l], -d[d] and -c[c] options are mutually exclusive !"; (* //V13F *)
    | errNonsenseBin:
        msg3(S,einfo," option is a nonsense without -t option"," !");
    | errNonsenseText:
        msg3(S,einfo," option is a nonsense with -t option"," !");
    | errNonsenseList:
        msg3(S,"-l[l] and -d[d] options are not compatible with ",einfo," option !");
    | errSpecFileForm:
        msg3(S,einfo,' file form must be "$.$", "*.*", "*.$" or "$.*"', " !");
    | errAborted:
        S:="Aborted by user !";
    | errNonsenseTest:
        msg3(S,einfo," option is a nonsense with -i option"," !");
    | errMacLeod: (* "There can be only one !" *)
        msg3(S,einfo," must match exactly one existing file with -i option"," !");
    | errNotFound:
        msg3(S,'No file matches "',einfo,'" specification !');
    | errListOnly:
        msg3(S,einfo," option requires -l[l] or -d[d] options"," !");
    | errOpcode:
        S:="All prefix command options are mutually exclusive !";
    | errOpcodeList:
        S:="All prefix command options require -l[l] or -d[d] options !";
    | errBatchPrefix:
        S:="-bat option requires a prefix command option !";
    | errNonsenseRedirection:
        S:="-bat option is a nonsense with redirected output !";
    | errUserCmd:
        S:="User command specified with -u:$ option cannot be an empty string !";
    | errListJoker:
        msg3(S,'"',einfo,'" should not contain any joker !');
    | errListNotFound:
        msg3(S,'"',einfo,'" does not exist !');
    | errOnlyDelOpcode:
        S:="-cc option supports one of -del or -kill options only !";

    | errCheckPB:
        S:="At least one difference found in entries groups !"; (* never displayed *)
    | errCheckOK:
        S:="No difference found in entries groups !"; (* never displayed *)

    | errMismatch:
        S:="Files do not match !"; (* never displayed *)
    | errBothFilesMatch:
        S:="Both files match !"; (* never displayed *)

    ELSE
        S := "How did you get here ?"; (* or legal error not taken into account ;-) *)
    END;
    CASE e OF
    | errNone, errHelp, errMismatch,errBothFilesMatch,errCheckPB,errCheckOK:
        ;
    ELSE
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT; (* XDS ah ah, HALT(errcode) almost undocumented extension... *)
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* as usual, buffers must be outside procedure, else program bombs ! *)

CONST
    IObufferSize      = (16 * 512) + FIO.BufferOverhead;
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
TYPE
    ioBufferType      = ARRAY [firstIObufferByte..lastIObufferByte] OF SYSTEM.LOC; (* XDS BYTE was too short, eh ? *)
VAR
    ioBuffer1,ioBuffer2 : ioBufferType;
VAR
    ioBufferNdxOld,ioBufferNdxNew:ioBufferType; (* out of proc in order to avoid crash *)

CONST
    dataBufferSize    = (16 * 512) ;
    firstBufferChar   = 1;
    lastBufferChar    = dataBufferSize;
VAR
    sourceBuffer,targetBuffer : ARRAY [firstBufferChar..lastBufferChar] OF CHAR;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO CARDINAL( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmt (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmt;

PROCEDURE fmtchar (enclose:BOOLEAN;c : SYSTEM.LOC) : str16; (* XDS BYTE *)
VAR
    S : str16;
    enclosechar:CHAR;
    cval:CARDINAL;
BEGIN
    cval := CARDINAL( c );
    CASE ORD(c) OF
    | 0..ORD(blank)-1 : S:=".";
    | 255 :             S:=".";
    ELSE
                        Str.Copy(S,CHR(cval));
    END;
    IF enclose THEN
        CASE cval OF
        | ORD(dquote) :
            enclosechar := singlequote;
        ELSE
            enclosechar := dquote;
        END;
        Str.Prepend(S,enclosechar);Str.Append(S,enclosechar);
    END;
    RETURN S;
END fmtchar;

PROCEDURE smaller (a,b:CARDINAL):CARDINAL;
BEGIN
    IF a < b THEN
        RETURN a;
    ELSE
        RETURN b;
    END;
END smaller;

PROCEDURE smallerlc (a,b:LONGCARD):LONGCARD;
BEGIN
    IF a < b THEN
        RETURN a;
    ELSE
        RETURN b;
    END;
END smallerlc;

PROCEDURE nice (S:pathtype):pathtype;
VAR
    R:pathtype;
BEGIN
        Str.Concat(R,dquote,S);
        Str.Append(R,dquote);
    RETURN R;
END nice;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* current is "\" or "\*\" *)

PROCEDURE buildParent (VAR parent:pathtype; current:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(current,"\") THEN RETURN FALSE; END;
    unfixDirectory(current);
    p:=Str.RCharPos(current,"\");
    Str.Slice(parent,current,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END buildParent;

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(*
    remember dirs can have an extension, and LFNs can have inner dots
    we handle (whether u: or not) :

    .        current
    ..       parent
    .\xxx    current\xxx       F/D
    ..\xxx   parent\xxx        F/D

    xxx\     current\xxx\
    xxx\.    current\xxx\
    xxx      current\xxx       F/D

    \xxx\    \xxx\
    \xxx     \xxx              F/D
*)

PROCEDURE chkfixSpec (VAR base,spec:pathtype;
                     orgS:pathtype;HDletters:ARRAY OF CHAR):CARDINAL;
VAR
    p,len,rc:CARDINAL;
    drive:SHORTCARD;
    u:CHAR;
    unit:str2;
    current,parent,S:pathtype;
    ok:BOOLEAN;
BEGIN
    Str.Copy(S,orgS);
    IF Str.Pos(S,"\\") # MAX(CARDINAL) THEN RETURN errNetSlash;END;

    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
        rc:=errNone;
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                IF verifyString(u,HDletters) THEN
                    drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                    Str.Delete(S,0,2); (* remove u: *)
                    rc:=errNone;
                ELSE
                    rc:=errPhantomUnit;
                END;
            ELSE
                rc:=errBadUnit;
            END;
        ELSE
            rc:=errColon;
        END;
    ELSE
        rc:=errColon;
    END;
    IF rc # errNone THEN RETURN rc; END;

    (* note S no longer has u: *)

    doGetCurrent(drive, unit,current); (* "u:" and "\" or "\*\" *)
    ok:=buildParent(parent, current);

    IF same(S,".") THEN Str.Copy(S,current);END;
    IF same(S,"..") THEN
        IF ok THEN Str.Copy(S,parent) ELSE RETURN errNoParent; END;
    END;
    IF Str.Match(S,".\*") THEN Str.Subst(S,".\",current); END;
    IF Str.Match(S,"..\*") THEN
        IF ok THEN Str.Subst(S,"..\",parent) ELSE RETURN errNoParent;END;
    END;
    IF Str.Match(S,"\*")=FALSE THEN Str.Prepend(S,current);END;
    IF Str.Match(S,"*\.") THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    IF Str.Match(S,"*\") THEN
        Str.Concat(base,unit,S);
        Str.Copy(spec,"*.*");
    ELSE
        Str.Prepend(S,unit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,"\");
        Str.Slice(base,S,0,p+1);
        Str.Slice(spec,S,p+1,len-p);
        IF chkJoker(spec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF isDirectory(S) THEN
                Str.Copy(base,S);
                fixDirectory(base); (* safety *)
                Str.Copy(spec,"*.*");
            END;
        END;
    END;
    IF chkJoker(base) THEN RETURN errDirJoker; END;
    RETURN errNone;
END chkfixSpec;

(* minimalist *)

PROCEDURE chkBothSpecs (b1,s1,b2,s2:pathtype ):BOOLEAN;
VAR
    p1,p2:pathtype;
BEGIN
    Str.Concat(p1,b1,s1);
    Str.Concat(p2,b2,s2);
    UpperCase(p1); (* XDS ignore accents *)
    UpperCase(p2);
    RETURN NOT( same(p1,p2) );
END chkBothSpecs;

PROCEDURE splitFileExt (VAR f,e:pathtype;S:pathtype):BOOLEAN;
VAR
   p:CARDINAL;
BEGIN
    p:=Str.RCharPos(S,".");
    CASE p OF
    | 0 :
        RETURN FALSE; (* nonsense : extension without file ! *)
    | MAX(CARDINAL) :
        Str.Copy(f,S);
        Str.Copy(e,"");
    ELSE
        Str.Slice(f,S,0,p);
        Str.Copy(e,S);
        Str.Delete(e,0,p+1);
    END;
    RETURN TRUE;
END splitFileExt;

(* we only support "$.$", "*.*", "*.$" and "$.*" for now *)

TYPE
    patType = (patUnsupported,patExtAlone,
              patStarStar,patStarExt,patFileStar,patFileExt);
              (*    "*.*"      "*.$"       "$.*"      "$.$" *)

PROCEDURE getPattern (S:pathtype):patType;
VAR
    f,e:pathtype;
BEGIN
    IF Str.CharPos(S,"?") # MAX(CARDINAL) THEN RETURN patUnsupported; END;
    IF Str.CharPos(S,"*") = MAX(CARDINAL) THEN RETURN patFileExt; END;
    IF same(S,"*.*") THEN RETURN patStarStar; END;
    IF splitFileExt(f,e, S)= FALSE THEN RETURN patExtAlone; END; (* extension without file ! *)
    IF same(f,"*") THEN
        IF Str.CharPos(e,"*") = MAX(CARDINAL) THEN
            RETURN patStarExt;
        ELSE
            RETURN patUnsupported;
        END;
    END;
    IF same(e,"*") THEN
        IF Str.CharPos(f,"*") = MAX(CARDINAL) THEN
            RETURN patFileStar;
        ELSE
            RETURN patUnsupported;
        END;
    END;
    IF Str.CharPos(f,"*") # MAX(CARDINAL) THEN RETURN patUnsupported; END;
    IF Str.CharPos(e,"*") # MAX(CARDINAL) THEN RETURN patUnsupported; END;
    RETURN patFileExt;
END getPattern;

TYPE
    listmodeType = (lstDefault,lstIdentical,lstDifferent,lstCheck);

PROCEDURE chkList (VAR listmode:listmodeType;wanted:listmodeType ):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    CASE listmode OF
    | lstDefault :
        listmode := wanted;
    ELSE
        IF listmode # wanted THEN ok:=FALSE; END;
    END;
    RETURN ok;
END chkList;

(* we don't check for TMP validity *)

PROCEDURE buildWorkDir (forcecurrent:BOOLEAN; VAR workdir:pathtype);
CONST
    numvars = 4;
VAR
    i:CARDINAL;
    D:str128;
    drive:SHORTCARD;
    unit:str2;
    current:pathtype;
BEGIN
    IF forcecurrent THEN
        i:=numvars+1;
    ELSE
        i:=1;
        LOOP
            CASE i OF
            | 1: D:=sTMP;
            | 2: D:=sTEMP;
            | 3: D:=sTMPDIR;
            | 4: D:=sTEMPDIR;
            ELSE
                ; (* //XDS SILLY USELESS REQUIREMENT *)
            END;
            Lib.EnvironmentFind(D,workdir);
            IF same(workdir,"")=FALSE THEN EXIT; END;
            INC(i);
            IF i > numvars THEN EXIT; END;
        END;
    END;
    IF i > numvars THEN
        drive := FIO.GetDrive();
        doGetCurrent(drive, unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(workdir,unit,current);
    END;
    fixDirectory(workdir);
END buildWorkDir;

TYPE
    opcodeType = (opDefault,opDosDel,opCopy,opDDdel,opPCOPY,opUser);

PROCEDURE chkOp (VAR opcode:opcodeType;wanted:opcodeType ):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    CASE opcode OF
    | opDefault :
        opcode := wanted;
    ELSE
        IF opcode # wanted THEN ok:=FALSE; END;
    END;
    RETURN ok;
END chkOp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* dir/file list assume :
   a) dirs are stored first
   b) dircont won't be more than 65535
   c) list will contain at least two dirs
*)

CONST
    firstindex = 1;
    FULLPATH   = firstindex-1; (* 0 = dir *)
TYPE
    pEntry = POINTER TO entryType;
    entryType = RECORD
        next      : pEntry;
        specindex : SHORTCARD; (* 1=spec1, 2=spec2 *)
        ID        : LONGCARD;  (* entry unique ID *)
        baseindex : CARDINAL;  (* FULLPATH for dirs, [1.. is ID of base dir for files *)
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pEntry );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pEntry);
VAR
    needed : CARDINAL;
    p      : pEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(entryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(entryType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* ------------------------------------------------------------ *)

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

PROCEDURE findMatchID (VAR p : pEntry;
                      anchor:pEntry;wanted:CARDINAL;IDwanted:LONGCARD):BOOLEAN;
BEGIN
    p:=anchor;
    WHILE anchor # NIL DO
        IF p^.specindex = SHORTCARD(wanted) THEN
            IF p^.ID = IDwanted THEN RETURN TRUE; END;
        END;
        p:=anchor^.next;
        anchor:=p;
    END;
    p:=NIL; (* added safety *)
    RETURN FALSE;
END findMatchID;

(* pathtypes have been UpperCase-ed : d+f+e = source *)
(* we don't use hash because we have stored paths/files as they were *)
(* //XDS note we no longer take accents into account here, out of lazyness *)
(* //FIXME *)

PROCEDURE findMatchName (VAR p:pEntry; VAR e2 : pathtype;
                        anchor,rootanchor:pEntry;wanted:CARDINAL;patform:patType;
                        fpat,epat,d,f,e:pathtype):BOOLEAN;
VAR
    ok,idnames:BOOLEAN;
    pdir:pEntry;
    file,d2,f2:pathtype;
BEGIN
    p:=anchor;
    WHILE anchor # NIL DO
        ok:=(p^.baseindex # FULLPATH);
        ok:=(ok AND (p^.specindex = SHORTCARD(wanted) ) );
        IF ok THEN
            getStr(file,p);
            ok:=splitFileExt(f2,e2, file);
            UpperCase(f2); (* XDS we'll ignore accents *)
            UpperCase(e2);
            idnames:= same(f,f2) AND same(e,e2);
IF DEBUG THEN
WrStr(msgDEBUG+"f2+e2     : ");WrStr(nice(f2));WrStr(" + ");
WrStr(nice(e2));WrLn;
END;
            ok:=FALSE;
            CASE patform OF
            | patStarStar: ok:= idnames; (* don't waste time with meaningless comparisons *)
            | patFileStar: ok:= same(fpat,f2) AND same(e,e2);
            | patStarExt:  ok:= same(f   ,f2) AND same(epat,e2); (* hopefully //FIXED with AND ext condition now *)
            | patFileExt:  ok:= TRUE;    (* we specified a unique filename *)
            ELSE
                ; (* //XDS SILLY USELESS REQUIREMENT *)
            END;
IF DEBUG THEN
WrStr(msgDEBUG+"pattern and file ");
IF NOT(ok) THEN
WrStr("DO NOT ");
END;
WrStr("match");WrLn;
END;
            IF ok THEN
                IF idnames THEN (* same filenames, check directories *)
                    ok:=findMatchID(pdir, rootanchor,wanted,LONGCARD(p^.baseindex) ); (* assume always TRUE *)
                    getStr(d2,pdir);
                    UpperCase(d2); (* XDS we'll ignore accents *)

                    ok:=NOT( same(d,d2) ); (* avoid comparing a file with itself ! *)
                END;
            END;
            IF ok THEN RETURN ok; END; (* TRUE ! *)
            (* try another entry *)
        END;
        p:=anchor^.next;
        anchor:=p;
    END;
    p:=NIL; (* added safety *)
    RETURN FALSE;
END findMatchName;

(* ------------------------------------------------------------ *)

PROCEDURE dmpList (anchor:pEntry;wanted:CARDINAL;showdirs:BOOLEAN);
VAR
    p,pdir,rootanchor : pEntry;
    S,base,R: pathtype;
    len,baseindex:CARDINAL;
    found,ok:BOOLEAN;
BEGIN
    WrStr("<spec> baseindex        ID");WrLn;
    rootanchor:=anchor;
    p:=anchor;
    WHILE anchor # NIL DO
        ok:=(p^.baseindex # FULLPATH);
        IF showdirs THEN ok:=NOT(ok);END;
        ok:=(ok AND (p^.specindex = SHORTCARD(wanted) ) );
        IF ok THEN
            getStr(S,p);
            IF p^.baseindex = FULLPATH THEN
                Str.Copy(R,S);
            ELSE
                found:=findMatchID(pdir, rootanchor,wanted,LONGCARD(p^.baseindex) ); (* assume always TRUE *)
                getStr(base,pdir);
                Str.Concat(R,base,S);
            END;
            IO.WrShtCard(p^.specindex,6);
            IO.WrCard(p^.baseindex,10);
            IO.WrLngCard(p^.ID,10);
            WrStr("  ");
            WrStr(nice(R));
            WrLn;
        END;
        p:=anchor^.next;
        anchor:=p;
    END;
END dmpList;

(* ------------------------------------------------------------ *)

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildDirList (VAR currID:LONGCARD; VAR count:LONGCARD;VAR anchor:pEntry;
                       recurse:BOOLEAN;
                       whatspec:CARDINAL;base:pathtype):CARDINAL;
VAR
    p: pEntry;
    len : CARDINAL;
    root,rootspec,entryname,newroot : pathtype;
    entry : FIO.DirEntry;
    found : BOOLEAN;
    dosattr:FIO.FileAttr;
    errcode:CARDINAL;
    rc : CARDINAL;
    ok:BOOLEAN;
BEGIN
    Str.Copy(root,base);
    fixDirectory(root); (* safety *)

    (* assume base exists ! *)

    len:=Str.Length(root);
    IF buildNewPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
    INC(count);
    INC(currID);
    p^.specindex := SHORTCARD (whatspec);
    p^.ID        := currID;
    p^.baseindex := FULLPATH; (* 0 ! *)
    p^.slen      := SHORTCARD(len);
    Lib.FastMove ( SYSTEM.ADR(root),SYSTEM.ADR(p^.str),len );

    IF NOT(recurse) THEN RETURN errNone; END;

    Str.Concat(rootspec,root,"*.*");
    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name); (* XDS chose name while JPI has Name *)
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;
            IF (aDD IN dosattr) THEN
                Str.Concat(newroot,root,entryname); (* u:\xx\ + xxx *)
                fixDirectory(newroot);
                rc:= buildDirList (currID,count,anchor,
                                  recurse,whatspec,newroot);
                IF rc # errNone THEN
                    RETURN rc;
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END buildDirList;

PROCEDURE buildFileList (VAR currID:LONGCARD; VAR count:LONGCARD;
                        anchor:pEntry;
                        wanted:CARDINAL;spec:pathtype):CARDINAL;
VAR
    pdir,pp:pEntry;
    base,rootspec, entryname:pathtype;
    len : CARDINAL;
    ok,found:BOOLEAN;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
BEGIN
    count:=0;
    pdir:=anchor;
    WHILE anchor # NIL DO
        ok:=(pdir^.baseindex=FULLPATH);
        ok:=(ok AND ( pdir^.specindex = SHORTCARD(wanted) ) );
        IF ok THEN
            getStr(base,pdir);
            Str.Concat(rootspec,base,spec);
            found := FIO.ReadFirstEntry(rootspec,everything,entry);
            WHILE found DO
                Str.Copy(entryname,entry.name);
                IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
                    dosattr:=entry.attr;
                    IF NOT (aDD IN dosattr) THEN
                        (* if file has no extension, add it as a marker *)
                        IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                            Str.Append(entryname,".");
                        END;
                        len:=Str.Length(entryname);
                        IF buildNewPtr(anchor,pp,len)=FALSE THEN
                            RETURN errStorage;
                        END;
                        INC(count);
                        INC(currID);
                        pp^.specindex := SHORTCARD (wanted);
                        pp^.ID        := currID;
                        pp^.baseindex := CARDINAL(pdir^.ID);
                        pp^.slen      := SHORTCARD(len);
                        Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
                    END;
                END;
                found :=FIO.ReadNextEntry(entry);
            END;
        END;
        pdir:=anchor^.next;
        anchor:=pdir;
    END;
    RETURN errNone;
END buildFileList;

(* ------------------------------------------------------------ *)

PROCEDURE nopath (VAR R:pathtype);
VAR
    p:CARDINAL;
BEGIN
    p:=Str.RCharPos(R,"\");
    IF p # MAX(CARDINAL) THEN Str.Delete(R,0,p+1); END;
END nopath;

TYPE
    cmpType = (binfile,textfile);

PROCEDURE headerComp (cmp:cmpType;source,target:pathtype);
VAR
    S:str1024; (* two LFNs can be very long *)
BEGIN
    CASE cmp OF
    | binfile:  Str.Copy(S,msgINFO+"Binary");
    | textfile: Str.Copy(S,msgINFO+"Line");
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    Str.Append(S," differences between ");
    Str.Append(S, nice(source) );
    Str.Append(S," and ");
    Str.Append(S, nice(target) );
    WrStr(S);WrLn;
END headerComp;

TYPE
    resultType = (rcSame,rcSameForced,rcSize,rcMismatch,rcAborted);

PROCEDURE showDiff (addr : LONGCARD;ref,now : SYSTEM.LOC);
VAR
    S:str128;
BEGIN
    Str.Concat(S, fmtlc(addr,16,8,"0","$"), "  :  " );
    Str.Append(S, fmt(CARDINAL(ref),16,2,"0","$"));
    Str.Append(S," --> ");
    Str.Append(S, fmt(CARDINAL(now),16,2,"0","$"));
    Str.Append(S,"  :  ");
    Str.Append(S,fmtchar(TRUE,ref));
    Str.Append(S," --> ");
    Str.Append(S,fmtchar(TRUE,now));
    Str.Append(S,"  :  ");
    Str.Append(S, fmt(CARDINAL(ref),10,3," ",""));
    Str.Append(S," --> ");
    Str.Append(S, fmt(CARDINAL(now),10,3," ",""));
    WrStr(msgNADA);WrStr(S);WrLn;
END showDiff;

(* assume src and target exist *)

PROCEDURE doBinCompare (verbose,ignorefsize:BOOLEAN;
                       maxmismatches:LONGCARD;
                       source,target:pathtype):resultType;
CONST
    msgWorking = "Processing... ";
VAR
    hnd1,hnd2:FIO.File;
    fsize1,fsize2,fpos,mismatches:LONGCARD;
    i,got1,got2,got:CARDINAL;
    alcatraz,done,samesize:BOOLEAN;
    ref,now:SYSTEM.LOC;
    S:str128;
    result:resultType;
    lastfpos:LONGCARD;
    chkrounds:CARDINAL;
BEGIN
    hnd1:= FIO.OpenRead (source);
    FIO.AssignBuffer(hnd1,ioBuffer1);
    hnd2:= FIO.OpenRead ( target);
    FIO.AssignBuffer(hnd2,ioBuffer2);

    fsize1:=FIO.Size(hnd1);
    fsize2:=FIO.Size(hnd2);
    samesize := (fsize1 = fsize2);
    IF NOT (samesize) THEN
        IF NOT(ignorefsize) THEN
            FIO.Close(hnd2);
            FIO.Close(hnd1);
            RETURN rcSize;
        END;
    END;
    lastfpos   :=smallerlc(fsize1,fsize2);
    fpos       :=0;
    mismatches :=0;
    done       :=FALSE;
    alcatraz   :=FALSE;
    chkrounds  :=0;

    LOOP
        got1:=FIO.RdBin(hnd1,sourceBuffer, dataBufferSize );
        got2:=FIO.RdBin(hnd2,targetBuffer, dataBufferSize );
        got := smaller(got1,got2);
        IF got = 0 THEN EXIT; END; (* size was a multiple of dataBufferSize *)

        i:=firstBufferChar-1; (* 1-1=0 *)
        LOOP
            INC(i); IF i > got THEN EXIT; END;
            ref := sourceBuffer[i];
            now := targetBuffer[i];
            IF ref # now THEN
                INC(mismatches);
                done:=( mismatches > maxmismatches ); IF done THEN EXIT; END;
                IF verbose THEN
                    IF mismatches=1 THEN WrLn; END;
                    showDiff(fpos+LONGCARD(i-firstBufferChar),ref,now);
                END;
            END;
            INC(chkrounds);
            IF (chkrounds MOD CHKEVERY) = 0 THEN alcatraz:=ChkEscape(); END;
            IF alcatraz THEN EXIT; END;
        END;
        IF done THEN EXIT; END;
        IF got # dataBufferSize THEN EXIT; END; (* < *)
        IF alcatraz THEN EXIT; END;
        INC(fpos, LONGCARD(got));
    END;
    FIO.Close(hnd2);
    FIO.Close(hnd1);

    IF alcatraz THEN RETURN rcAborted;END;

    IF mismatches=0 THEN
        IF samesize THEN
            result:=rcSame;
        ELSE
            result:=rcSameForced;
        END;
    ELSE
        IF verbose THEN
            IF done THEN
                Str.Concat(S,"More than ", fmtlc(maxmismatches,10,0,"","") );
                DEC(mismatches); (* we were already at +1 *)
            ELSE
                Str.Copy(S, fmtlc(mismatches,10,0,"","") );
            END;
            Str.Append(S," mismatch");
            IF mismatches > 1 THEN Str.Append(S,"es"); END;
            Str.Append(S," found.");
            WrLn;
            WrStr(msgDIFF);WrStr(S);WrLn;
        END;
        result:=rcMismatch;
    END;
    RETURN result;
END doBinCompare;

(* ------------------------------------------------------------ *)

(*
   buildFileList() takes care of adding a trailing dot to file without extension
   e1 and e2 are already UpperCase-ed but they don't have dot
   //XDS darn, we no longer take accents into account
*)

PROCEDURE validExtensions (skipem:ARRAY OF CHAR;e,e2:pathtype):BOOLEAN;
VAR
    ext:str16; (* oversized *)
    n,pb:CARDINAL;
BEGIN
    pb:=0;
    n:=0;
    LOOP
        isoleItemS(ext, skipem,delim,n);
        Str.Subst(ext,".",""); (* remove leading dot *)
        IF same(ext,"") THEN EXIT; END;
        IF same(ext,e ) THEN INC(pb);END;
        IF same(ext,e2) THEN INC(pb);END;
        INC(n);
    END;
    RETURN (pb=0);
END validExtensions;

PROCEDURE getStamp (S:pathtype):LONGREAL;
VAR
    hnd:FIO.File;
    stamp:FIO.FileStamp;
    ok:BOOLEAN;
    y,m,d,hh,mm,ss:CARDINAL; (* //XDS was SHORTCARD but would often crash *)
    seconds,days:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    ok:=FIO.GetFileStamp(hnd,stamp);
    FIO.Close(hnd);
    (* //XDS how clever from you NOT to emulate JPI TS M2 names here ! *)
    y  := stamp.year ;
    m  := stamp.month;
    d  := stamp.day  ;
    hh := stamp.hour ;
    mm := stamp.minute  ;
    ss := stamp.second ;

    (* seconds ok, days approximate : months of 32 days, years of 367 days *)

    seconds := LONGCARD(ss) + 60*LONGCARD(mm) + 60*60*LONGCARD(hh); (*  90060 *)
    days    := LONGCARD(d ) + 32*LONGCARD(m ) + 367  *LONGCARD(y ); (* 7xxxxx *)

    RETURN LONGREAL(days) + LONGREAL(seconds) / 100000.0;
END getStamp;

PROCEDURE olderNewer (VAR source,target:pathtype);
VAR
    tmp:pathtype;
BEGIN
    IF getStamp(target) < getStamp(source) THEN
        Str.Copy(tmp,source);
        Str.Copy(source,target);
        Str.Copy(target,tmp);
    END;
END olderNewer;

CONST
    MAXHASH = MAX(CARDINAL)-1;

PROCEDURE doTxtCompare (verbose,keepcase,keepblanks:BOOLEAN;
                       source,target:pathtype):resultType;
TYPE
    lineType = RECORD
        linenum : LONGCARD;
        fpos    : LONGCARD;
        hashID  : CARDINAL;
    END;
CONST
    msgIndexing  = "Please wait while indexing ";
    msgWorking   = "Processing... ";
    tagDeleted   = " -- ";
    tagAdded     = " ++ ";
    tagCommon    = " == "; (* never used *)
    tagInfo      = msgINFO;
    winum        = 6;
VAR
    result:resultType;
    F,FNDX,workdir:pathtype;
    msg:str1024;
    hin,hndx,hndxold,hndxnew,hold,hnew:FIO.File;
    wanted,got,i : CARDINAL;
    mismatches,matches,currline,fpos:LONGCARD;
    S,SS:str4096;
    entry,oldentry,newentry:lineType;
    alcatraz:BOOLEAN;
    lastfpos:LONGCARD;
    chkrounds:CARDINAL;
BEGIN
    buildWorkDir(FALSE,workdir);

    FOR i:=1 TO 2 DO
        CASE i OF
        | 1: Str.Copy(F,source); Str.Copy(FNDX,sNDX1);
        | 2: Str.Copy(F,target); Str.Copy(FNDX,sNDX2);
        ELSE
            ; (* //XDS SILLY USELESS REQUIREMENT *)
        END;
        Str.Concat(msg,msgIndexing,F);

        Str.Prepend(FNDX,workdir);
        IF FIO.Exists(FNDX) THEN
            IF fileIsRO(FNDX) THEN fileSetRW(FNDX);END;
        END;

        hin:=FIO.OpenRead(F);
        FIO.AssignBuffer(hin,ioBuffer1);
        hndx:=FIO.Create(FNDX);           (* CHKME LFN function here *)
        FIO.AssignBuffer(hndx,ioBuffer2);

        currline:=0;
        LOOP
            INC(currline);
            fpos:=FIO.GetPos(hin);
            FIO.RdStr(hin,S);
            IF FIO.EOF THEN EXIT; END;
            IF NOT(keepcase) THEN LowerCase(S);END; (* //XDS we no longer keep accents *)
            IF NOT(keepblanks) THEN
                ReplaceChar(S,blank,"");
                ReplaceChar(S,tabul,"");
            END;
            IF S[0] # CHR(0) THEN
                entry.linenum := currline;
                entry.fpos    := fpos;
                entry.hashID  := Lib.HashString(S,MAXHASH);
                FIO.WrBin(hndx,entry,SIZE(entry));
            END;
        END;

        FIO.Close(hndx);
        FIO.Close(hin);
    END;

    (* if hash1=hash2, we have to retrieve and compare both strings *)

    (* list lines deleted from source : hashold without match in newndx -- yes, it's not exactly the same *)

    WrStr(tagInfo+"Line(s) deleted from ");WrStr(source);WrLn;
    WrLn;

    Str.Concat(FNDX,workdir,sNDX1);
    hndxold:=FIO.OpenRead(FNDX);
    FIO.AssignBuffer(hndxold,ioBufferNdxOld);

    Str.Concat(FNDX,workdir,sNDX2);
    hndxnew:=FIO.OpenRead(FNDX);
    FIO.AssignBuffer(hndxnew,ioBufferNdxNew);

    hold:=FIO.OpenRead(source);
    FIO.AssignBuffer(hold,ioBuffer1);
    hnew:=FIO.OpenRead(target);
    FIO.AssignBuffer(hnew,ioBuffer2);

    mismatches:=0;
    alcatraz:=FALSE;
    chkrounds:=0;
    wanted:=SIZE(lineType);

    lastfpos:=FIO.Size(hndxold);
    LOOP
        IF alcatraz THEN EXIT; END;
        got:=FIO.RdBin(hndxold,oldentry,wanted);
        IF got # wanted THEN EXIT; END;
        FIO.Seek(hndxnew,0);
        matches:=0;
        LOOP
            got:=FIO.RdBin(hndxnew,newentry,wanted);
            IF got # wanted THEN EXIT; END;
            IF oldentry.hashID = newentry.hashID THEN
                FIO.Seek(hold,oldentry.fpos);
                FIO.RdStr(hold,S);
                FIO.Seek(hnew,newentry.fpos);
                FIO.RdStr(hnew,SS);

                IF NOT(keepcase) THEN LowerCase(S);END;
                IF NOT(keepblanks) THEN
                    ReplaceChar(S,blank,"");
                    ReplaceChar(S,tabul,"");
                END;

                IF NOT(keepcase) THEN LowerCase(SS);END;
                IF NOT(keepblanks) THEN
                    ReplaceChar(SS,blank,"");
                    ReplaceChar(SS,tabul,"");
                END;

                IF same(S,SS) THEN INC(matches);END;
            END;
        END;
        IF matches=0 THEN
            INC(mismatches);
            FIO.Seek(hold,oldentry.fpos);
            FIO.RdStr(hold,S);
            WrStr( fmtlc(oldentry.linenum,10,winum," ","") );
            WrStr( tagDeleted );
            WrStr(S);WrLn;
        END;

        INC(chkrounds);
        IF (chkrounds MOD CHKEVERY) = 0 THEN alcatraz:=ChkEscape(); END;
        IF alcatraz THEN EXIT; END;
    END;

    (* list lines added to source : hashnew without match in oldndx -- yes, it's not exactly the same *)

    WrLn;
    WrStr(tagInfo+"Line(s) added to ");WrStr(target);WrLn;
    WrLn;

    FIO.Seek(hndxnew,0);
    (* don't reinit alcatraz *)

    lastfpos:=FIO.Size(hndxnew);
    LOOP
        IF alcatraz THEN EXIT; END;
        got:=FIO.RdBin(hndxnew,newentry,wanted);
        IF got # wanted THEN EXIT; END;
        FIO.Seek(hndxold,0);
        matches:=0;
        LOOP
            got:=FIO.RdBin(hndxold,oldentry,wanted);
            IF got # wanted THEN EXIT; END;
            IF newentry.hashID = oldentry.hashID THEN
                FIO.Seek(hnew,newentry.fpos);
                FIO.RdStr(hnew,S);
                FIO.Seek(hold,oldentry.fpos);
                FIO.RdStr(hold,SS);

                IF NOT(keepcase) THEN LowerCase(S);END;
                IF NOT(keepblanks) THEN
                    ReplaceChar(S,blank,"");
                    ReplaceChar(S,tabul,"");
                END;

                IF NOT(keepcase) THEN LowerCase(SS);END;
                IF NOT(keepblanks) THEN
                    ReplaceChar(SS,blank,"");
                    ReplaceChar(SS,tabul,"");
                END;

                IF same(S,SS) THEN INC(matches);END;
            END;
        END;
        IF matches=0 THEN
            INC(mismatches);
            FIO.Seek(hnew,newentry.fpos);
            FIO.RdStr(hnew,S);
            WrStr( fmtlc(newentry.linenum,10,winum," ","") );
            WrStr( tagAdded );
            WrStr(S);WrLn;
        END;

        INC(chkrounds);
        IF (chkrounds MOD CHKEVERY) = 0 THEN alcatraz:=ChkEscape(); END;
        IF alcatraz THEN EXIT; END;
    END;

    FIO.Close(hnew);
    FIO.Close(hold);
    FIO.Close(hndxnew);
    FIO.Close(hndxold);

    Str.Concat(FNDX,workdir,sNDX2);
    FIO.Erase(FNDX);
    Str.Concat(FNDX,workdir,sNDX1);
    FIO.Erase(FNDX);

    IF alcatraz THEN RETURN rcAborted; END;
    IF mismatches = 0 THEN
        result:=rcSame;
    ELSE
        IF verbose THEN
            Str.Copy(S, fmtlc(mismatches,10,0,"","") );
            Str.Append(S," line mismatch");
            IF mismatches > 1 THEN Str.Append(S,"es"); END;
            Str.Append(S," found.");
            WrLn;
            WrStr(msgDIFF);WrStr(S);WrLn;
        END;
        result:=rcMismatch;
    END;
    RETURN result;
END doTxtCompare;

(* ------------------------------------------------------------ *)

CONST
    msgSAME       = msgOK+  "Files match."+nl;
    msgSAMEFORCED = msgOK+  "Files match (comparison limited to smaller filesize)."+nl;
    msgSIZE       = msgPB+  "Sizes are not identical."+nl;
    msgNOTHINGTODO= msgWARN+"Nothing to do."+nl;           (* was msgINFO *)
    msgSAMELINES  = msgOK+  "Lines match."+nl;
    msgNOMATCH    = msgPB+  "No match for ";               (* was msgINFO *)
    msgNOTID      = msgPB+  "Mismatch(es) found."+nl;

PROCEDURE procComp (anchor:pEntry; cmp:cmpType;
                   altdisplay,keepcase,keepblanks,
                   ignorefsize,testsame:BOOLEAN;
                   maxmismatches:LONGCARD; wanted,icomp:CARDINAL;
                   patref,patcomp:pathtype):CARDINAL;
VAR
    patform:patType;
    i:CARDINAL;
    matched,found,ok:BOOLEAN;
    rootanchor,p,pdir,pmatch:pEntry;
    file,d,source,target,f,e,fpat,epat,base:pathtype;
    mismatch,nothingtodo:BOOLEAN;
    rcode:resultType;
    rc:CARDINAL;
    e2:pathtype; (* target ext uppercase-ed *)
    S:str1024; (* oversized because of LFN *)
    Ssrc,Stgt:pathtype;
    verbose:BOOLEAN;
BEGIN
    mismatch:=FALSE;
    nothingtodo:=TRUE;

    patform:=getPattern(patcomp); (* already checked for errors *)
    ok:=splitFileExt(fpat,epat, patcomp);
    UpperCase(fpat); (* //XDS accents are no longer taken into account *)
    UpperCase(epat);
IF DEBUG THEN
WrStr(msgDEBUG+"patform   : ");
CASE patform OF
| patStarStar: WrStr("*.*");
| patFileExt : WrStr("$.$");
| patFileStar: WrStr("$.*");
| patStarExt : WrStr("*.$");
ELSE
               WrStr("???"); (* cannot happen *)
END;
WrLn;
WrStr(msgDEBUG+"fpat+epat : ");WrStr(nice(fpat));WrStr(" + ");
WrStr(nice(epat));WrLn;
END;
    rootanchor:=anchor;
    p:=anchor;
    WHILE anchor # NIL DO
        ok:=(p^.baseindex # FULLPATH);
        ok:=(ok AND (p^.specindex = SHORTCARD(wanted) ) );
        IF ok THEN
            getStr(file,p);
            ok:=findMatchID(pdir, rootanchor,wanted,LONGCARD(p^.baseindex) ); (* assume always TRUE *)
            getStr(d,pdir);
            Str.Concat(source,d,file);

            ok:=splitFileExt(f,e, file);
            UpperCase(d);
            UpperCase(f);
            UpperCase(e);
IF DEBUG THEN
WrStr(msgDEBUG+"d+f+e     : ");WrStr(nice(d));WrStr(" + ");
WrStr(nice(f));WrStr(" + ");
WrStr(nice(e));WrLn;
END;
            found:=findMatchName (pmatch, e2,
                                 rootanchor,rootanchor,icomp,patform,
                                 fpat,epat,d,f,e);
            matched:=found;
            WHILE found DO
                getStr(file,pmatch);
                ok:=findMatchID(pdir, rootanchor,icomp,LONGCARD(pmatch^.baseindex) ); (* assume always TRUE *)
                getStr(base,pdir);
                Str.Concat(target,base,file);

                CASE cmp OF
                | binfile:
                    IF NOT(altdisplay) THEN
                        headerComp( binfile,source,target);
                    END;
                    IF testsame THEN
                        verbose:=FALSE; (* whatever display *)
                    ELSE
                        verbose:=NOT(altdisplay);
                    END;
                    rcode:=doBinCompare (verbose,
                                        ignorefsize,maxmismatches,
                                        source,target);
                    CASE rcode OF
                    | rcSize:       mismatch:=TRUE; (* well... *)
                    | rcMismatch:   mismatch:=TRUE;
                    | rcAborted:    RETURN errAborted;
                    ELSE
                        ; (* //XDS SILLY USELESS REQUIREMENT *)
                    END;

                    (* nl included *)
                    IF altdisplay THEN
                        (* don't use nopath here *)
                        Str.Copy(Ssrc,nice(source));
                        Str.Copy(Stgt,nice(target));

                        CASE rcode OF
                        | rcSame:       Str.Concat(S,msgOK+" | and |",nl);
                                        Str.Subst(S,"|",Ssrc);
                                        Str.Subst(S,"|",Stgt);
                                        WrStr(S);
                        | rcSameForced: Str.Concat(S,msgWARN+" | and |",nl);
                                        Str.Subst(S,"|",Ssrc);
                                        Str.Subst(S,"|",Stgt);
                                        WrStr(S);
                        | rcSize:       Str.Concat(S,msgPB+"Size mismatch between | and |",nl);
                                        Str.Subst(S,"|",Ssrc);
                                        Str.Subst(S,"|",Stgt);
                                        WrStr(S);
                        | rcMismatch:   Str.Concat(S,msgPB+"Mismatch(es) between | and |",nl);
                                        Str.Subst(S,"|",Ssrc);
                                        Str.Subst(S,"|",Stgt);
                                        WrStr(S);
                        ELSE
                            ; (* //XDS YASIR ! *)
                        END;
                    ELSE
                        CASE rcode OF
                        | rcSame:       WrStr(msgSAME);
                        | rcSameForced: WrStr(msgSAMEFORCED);
                        | rcSize:       WrStr(msgSIZE);
                        | rcMismatch:   IF testsame THEN
                                            WrStr(msgNOTID);
                                        END; (* else, already done while comparing *)
                        ELSE
                            ; (* //XDS YASIR ! *)
                        END;
                    END;

                    nothingtodo:=FALSE;
                | textfile:
                    (* we skip forbidden binary extensions the m$ way : without telling user about it *)
                    IF validExtensions(sSkippedExtensions,e,e2) THEN
                        olderNewer(source,target);

                        headerComp( textfile,source,target);
                        rcode:=doTxtCompare ( TRUE ,keepcase,keepblanks,
                                            source,target);

                        CASE rcode OF
                        | rcSame:     WrStr(msgSAMELINES);
                        | rcMismatch: mismatch:=TRUE;
                        | rcAborted:  RETURN errAborted;
                        ELSE
                            ; (* //XDS YASIR ! *)
                        END;
                        nothingtodo:=FALSE;
                    END;
                ELSE
                    ; (* //XDS SILLY USELESS REQUIREMENT *)
                END;
                found:=findMatchName (pmatch, e2,
                                     pmatch^.next,rootanchor,icomp,patform,
                                     fpat,epat,d,f,e);
            END;
            IF NOT (matched) THEN
                Str.Concat(S, nice (source) , nl);
                Str.Prepend(S, msgNOMATCH);
                WrStr(S);
            END;
        END;
        p:=anchor^.next;
        anchor:=p;
    END;
    IF mismatch THEN
        rc:=errMismatch;
    ELSE
        IF nothingtodo THEN WrStr(msgNOTHINGTODO); END;
        rc:=errNone;
    END;
    RETURN rc;
END procComp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE initBatch ( opcode:opcodeType);
VAR
    batchfile:pathtype;
    hout:FIO.File;
BEGIN
    CASE opcode OF
    | opDosDel,opDDdel : Str.Concat(batchfile,sDELcmd ,sThem);
    | opCopy,opPCOPY   : Str.Concat(batchfile,sCOPYcmd,sThem);
    | opUser           : Str.Concat(batchfile,sUSERcmd,sThem);
    ELSE
        RETURN; (* should never happen *)
    END;
    IF FIO.Exists(batchfile) THEN
        IF fileIsRO(batchfile) THEN fileSetRW(batchfile);END;
    END;
    hout:=FIO.Create(batchfile);
    FIO.WrStr(hout,"@"+sEcho+blank+"ON");
    FIO.Close(hout);
END initBatch;

PROCEDURE show (VAR sourceshown:BOOLEAN;
               altdisplay,showallmatches,bat:BOOLEAN;hout:FIO.File;
               op:ARRAY OF CHAR;source,target:pathtype);
VAR
    S:str1024;
BEGIN
    IF NOT(showallmatches) THEN
        IF altdisplay THEN nopath(source);END;
    END;
    IF sourceshown = FALSE THEN
        Str.Concat(S, nice(source), nl);
        (* WrStr(op); *)
        WrStr(S);
        IF bat THEN FIO.WrStr(hout,op);FIO.WrStr(hout,S);END;
        sourceshown:=TRUE;
    END;
    IF showallmatches THEN
        Str.Concat(S, nice(target), nl);
        (* WrStr(op); *)
        WrStr(S);
        IF bat THEN FIO.WrStr(hout,op);FIO.WrStr(hout,S);END;
    END;
END show;

PROCEDURE shownomatch (altdisplay,bat:BOOLEAN;hout:FIO.File;
                      source:pathtype);
VAR
    S:str1024;
BEGIN
    IF altdisplay THEN nopath(source);END;
    Str.Concat(S, nice (source), nl);
    Str.Prepend(S,msgNOMATCH);
    (* IF redirected THEN WrStr(sRemark+blank);END; *)
    WrStr(S);
    IF bat THEN FIO.WrStr(hout,sRemark+blank);FIO.WrStr(hout,S);END;
END shownomatch;

(* modified procComp *)

PROCEDURE procList (anchor:pEntry; lst:listmodeType; opcode:opcodeType;
                   altdisplay,showallmatches,makebatch:BOOLEAN;
                   iref,icomp:CARDINAL;
                   patref,patcomp:pathtype;
                   usercli:ARRAY OF CHAR):CARDINAL;
VAR
    patform:patType;
    i:CARDINAL;
    matched,found,ok,sourceshown:BOOLEAN;
    rootanchor,p,pdir,pmatch:pEntry;
    file,d,source,target,f,e,fpat,epat,base:pathtype;
    rcode:resultType;
    rc:CARDINAL;
    e2:pathtype; (* target ext uppercase-ed *)
    S,S2:str128;
    pass:CARDINAL;
    op:str16;
    hout:FIO.File;
    batchfile:pathtype;
    bat:BOOLEAN;
BEGIN
    (* say we don't report files without match name *)
    CASE lst OF
    | lstIdentical: S:=msgINFO+"List of matching identical files"+nl;
    | lstDifferent: S:=msgINFO+"List of matching different files"+nl;
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    CASE opcode OF
    | opDefault: op:="";
    | opDosDel:  op:=sDOSDELcli+blank;  Str.Concat(batchfile,sDELcmd,sThem);
    | opCopy:    op:=sDOSCOPYcli+blank; Str.Concat(batchfile,sCOPYcmd,sThem);
    | opDDdel:   op:=sDDdelCli+blank;   Str.Concat(batchfile,sDELcmd,sThem);
    | opPCOPY:   op:=sPCOPYcli+blank;   Str.Concat(batchfile,sCOPYcmd,sThem);
    | opUser:                           Str.Concat(batchfile,sUSERcmd,sThem);
                 Str.Concat(op,usercli,blank);
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    bat:=makebatch AND (opcode # opDefault);
    IF bat THEN
        Str.Concat(S2,sEcho+blank,S); (* "@ECHO ON"+nl was removed *)
    ELSE
        Str.Copy(S2,S);
    END;
    IF bat THEN
        IF FIO.Exists(batchfile) THEN
            IF fileIsRO(batchfile) THEN fileSetRW(batchfile);END;
        END;
        hout:=FIO.Create(batchfile);
    ELSE
        hout:=FIO.StandardOutput; (* safety *)
    END;
    WrStr(S);
    IF bat THEN FIO.WrStr(hout,S2);END;

    (* done with damn header, let's go now ! *)

    patform:=getPattern(patcomp); (* already checked for errors *)
    ok:=splitFileExt(fpat,epat, patcomp);
    UpperCase(fpat);
    UpperCase(epat);

    rootanchor:=anchor;
    p:=anchor;
    WHILE anchor # NIL DO
        ok:=(p^.baseindex # FULLPATH);
        ok:=(ok AND (p^.specindex = SHORTCARD(iref) ) );
        IF ok THEN
            getStr(file,p);
            ok:=findMatchID(pdir, rootanchor,iref,LONGCARD(p^.baseindex) ); (* assume always TRUE *)
            getStr(d,pdir);
            Str.Concat(source,d,file);

            ok:=splitFileExt(f,e, file);
            UpperCase(d);
            UpperCase(f);
            UpperCase(e);

            sourceshown:=FALSE; (* we haven't shown source file yet *)

            found:=findMatchName (pmatch, e2,
                                 rootanchor,rootanchor,icomp,patform,
                                 fpat,epat,d,f,e);
            matched:=found;
            WHILE found DO
                getStr(file,pmatch);
                ok:=findMatchID(pdir, rootanchor,icomp,LONGCARD(pmatch^.baseindex) ); (* assume always TRUE *)
                getStr(base,pdir);
                Str.Concat(target,base,file);

                (* verbose FALSE, ignorefsize FALSE, maxmismatches 1 *)

                rcode:=doBinCompare (FALSE, FALSE,1,
                                    source,target);

                CASE rcode OF
                | rcSame,rcSameForced:
                    IF lst=lstIdentical THEN
                        show (sourceshown,
                             altdisplay,showallmatches,
                             bat,hout,op,
                             source,target);
                    END;
                | rcSize:
                    IF lst=lstDifferent THEN
                        show (sourceshown,
                             altdisplay,showallmatches,
                             bat,hout,op,
                             source,target);
                    END;
                | rcMismatch:
                    IF lst=lstDifferent THEN
                        show (sourceshown,
                             altdisplay,showallmatches,
                             bat,hout,op,
                             source,target);
                    END;
                | rcAborted:
                    IF bat THEN FIO.Close(hout);END;
                    RETURN errAborted;
                ELSE
                    ; (* //XDS SILLY USELESS REQUIREMENT *)
                END;

                found:=findMatchName (pmatch, e2,
                                     pmatch^.next,rootanchor,icomp,patform,
                                     fpat,epat,d,f,e);
            END;
            IF NOT(matched) THEN
                IF lst = lstDifferent THEN
                    shownomatch(altdisplay,bat,hout,source);
                END;
            END;
        END;
        p:=anchor^.next;
        anchor:=p;
    END;
    IF bat THEN
        FIO.Close(hout);
        Str.Concat(S,msgINFO,batchfile);Str.Append(S," has been created.");
        WrStr(S);WrLn;
    END;
    rc:=errNone;
    RETURN rc;
END procList;

PROCEDURE fixStorageError (VAR rc, ignoredstoragepb:CARDINAL;
                          fakeokstorage:BOOLEAN);
BEGIN
    IF rc=errStorage THEN
        IF fakeokstorage THEN
           rc:=errNone;
           INC(ignoredstoragepb);
        END;
    END;
END fixStorageError;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume trimmed string, handle "[<?> <digest>] <["]file["]>" *)

PROCEDURE fakeDuplinesFormat (posingroup:CARDINAL; VAR S:ARRAY OF CHAR );
VAR
    ch:CHAR;
BEGIN
    IF same(S,"") THEN RETURN; END;
    IF Str.Match(S,'? ?* "?*"') THEN RETURN; END; (* not bullet-proof *)
    IF Str.Match(S,'? ?* ?*') THEN RETURN; END;
    (* assume '["]?*["]' here *)
    Str.Prepend(S," 0 ");
    IF posingroup = 0 THEN
        ch:=pound;
    ELSE
        ch:=semicolon;
    END;
    Str.Prepend(S,ch);
END fakeDuplinesFormat;

(* assume trimmed non-empty string, expect "<?> <digest> <["]file["]>" format *)

PROCEDURE isolepath (VAR R:pathtype;S:ARRAY OF CHAR);
VAR
    p:CARDINAL;
BEGIN
    Str.Copy(R,"");

    p:=Str.CharPos(S,blank);
    IF p = MAX(CARDINAL) THEN RETURN; END;
    Str.Delete(S,0,p+1);
    LtrimBlanks(S);

    p:=Str.CharPos(S,blank);
    IF p = MAX(CARDINAL) THEN RETURN; END;
    Str.Delete(S,0,p+1);
    LtrimBlanks(S);

    IF S[0]="*" THEN Str.Delete(S,0,1);END;
    ReplaceChar(S,dquote,"");
    Str.Copy(R,S);
END isolepath;

CONST
    opDosDelme  = 0;
    opDDdelme   = 1;
    opremme     = 2;
    opflagme    = 3; (* FNF *)

PROCEDURE dmpname (makebatch:BOOLEAN;whatop:CARDINAL;h:FIO.File;F:pathtype);
VAR
    S:str1024;
BEGIN
    IF NOT (makebatch) THEN RETURN; END;
    CASE whatop OF
    | opDosDelme : S:=sDOSDELcli;
    | opDDdelme  : S:=sDDdelCli;
    | opremme    : S:=sRemark;
    | opflagme   : S:=msgPB+"File not found !";
    ELSE
        ; (* //XDS yes, yes, programmer is too stupid to know he has handled all cases ! *)
    END;
    Str.Append(S,' "|"');
    Str.Subst(S,"|",F);
    FIO.WrStr(h,S);FIO.WrLn(h);
    IF whatop=opflagme THEN WrStr(S);WrLn;END;
END dmpname;

PROCEDURE chkFileEntry (VAR pbnotfound:CARDINAL;
                       makebat,allowNotCanonical:BOOLEAN;
                       hout:FIO.File;F:pathtype):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    IF allowNotCanonical THEN
        ok := TRUE;
    ELSE
        IF F[0]="\" THEN
            ok:=TRUE;
        ELSE
            ok:= Str.Match(F,"?:\*");
        END;
    END;
    IF ok THEN
        ok:= FIO.Exists(F);
        IF NOT(ok) THEN dmpname(makebat,opflagme,hout,F); INC(pbnotfound);END;
    END;
    RETURN ok;
END chkFileEntry;

(* #=ref, ;=dup, skip <digest> -- opcode has been filtered BY caller *)

PROCEDURE doCheckList ( DEBUG,makebat:BOOLEAN;opcode:opcodeType;
                        rcOK,rcPB:CARDINAL;F:pathtype):CARDINAL;
CONST
    msgPBAT         = msgPB+"Problem at line ";
    msgGOODchk      = msgOK+"No problem found while checking list.";
    msgBAD          = msgPB+"Problem to solve before program is runned again on specified list :"+nl+
                      msgPB+"~ file(s) not found, ~ filesize mismatch(es),"+nl+
                      msgPB+"~ data mismatch(es), ~ other error(s).";
CONST
    AllowRELATIVE      = TRUE;
    AllowFSIZEmismatch = FALSE;
    maxMISMATCHES      = 1;
VAR
    okref,okcurr,ciaobye:BOOLEAN;
    pbmisc,pbfsize,pbnotfound,pbmismatch:CARDINAL;
    currline:LONGCARD;
    rc:CARDINAL;
    hin,hout:FIO.File;
    refentry,currentry,batchfile:pathtype;
    S:str1024;
    Z:str80;
    state:(waiting,gotref,ingroup);
    result:resultType;
    verbose,keepEOF:BOOLEAN;
    posingroup : CARDINAL;
    opdodelme:CARDINAL;
BEGIN
    CASE opcode OF
    | opDosDel  : opdodelme := opDosDelme;
    | opDDdel   : opdodelme := opDDdelme;
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    verbose:=FALSE; (* don't show address and byte values *)
    IF makebat THEN
        batchfile:=sDELcmd+sThem;
        IF FIO.Exists(batchfile) THEN
            IF fileIsRO(batchfile) THEN fileSetRW(batchfile);END;
        END;
        hout:=FIO.Create(batchfile);
        S:="@ECHO ON"+nl+"PAUSE"+nl;
        FIO.WrStr(hout,S);
    END;

    pbnotfound:=0;
    pbmismatch:=0;
    pbfsize   :=0;
    pbmisc    :=0;

    currline:=0;
    ciaobye:=FALSE;
    posingroup:=0;
    hin:=FIO.OpenRead(F);

    FIO.EOF:=FALSE;
    state:=waiting;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S); INC(currline);
        LtrimBlanks(S);
        RtrimBlanks(S);
        ReplaceChar(S,tabul,blank);
        (* // IO.WrLngCard(currline,-8);IO.WrCard(posingroup,-8);WrStr(S);WrLn; *)

        fakeDuplinesFormat(posingroup,S);

        CASE S[0] OF
        | nullchar:
            posingroup:=0;
            IF FIO.EOF THEN EXIT; END;
        | pound :
            posingroup:=1;
            CASE state OF
            | waiting: ;
            | gotref:    INC(pbmisc); ciaobye:=TRUE; (* # then # again *)
            | ingroup: ;
            ELSE
                ; (* //XDS YASIR ! *)
            END;
            isolepath(refentry,S);
            state:=gotref;
            IF makebat THEN FIO.WrLn(hout);END;
            dmpname(makebat,opremme,hout,refentry);

            okref:= chkFileEntry(pbnotfound, makebat,AllowRELATIVE,hout,refentry);
            IF NOT(okref) THEN ciaobye:=TRUE; END; (* //V13G *)
        | semicolon :
            INC(posingroup);
            CASE state OF
            | waiting:   INC(pbmisc); ciaobye:=TRUE; (* first entry is not ref *)
            | gotref:  ;
            | ingroup: ;
            ELSE
                ; (* //XDS YASIR ! *)
            END;

            IF NOT(ciaobye) THEN
                isolepath(currentry,S);
                okcurr:=chkFileEntry(pbnotfound, makebat,AllowRELATIVE,hout,currentry);
                IF NOT(okcurr) THEN ciaobye:=TRUE; END; (* //V13G *)
            END;

            IF NOT(ciaobye) THEN
                state:=ingroup;
                keepEOF:=FIO.EOF; (* required because of silly TS design ! *)
                (* headerComp (binfile,refentry,currentry); *)

                IF DEBUG THEN (* both exist *)
                    WrStr("//");WrStr(refentry);WrLn;
                    WrStr("\\");WrStr(currentry);WrLn;
                END;
                result:=doBinCompare ( verbose,
                                      AllowFSIZEmismatch,maxMISMATCHES,
                                      refentry,currentry);
                FIO.EOF:=keepEOF; (* restore *)

                CASE result OF
                | rcSame :

                    dmpname(makebat,opdodelme,hout,currentry);
                | rcAborted:
                    INC(pbmisc);
                    ciaobye:=TRUE;
                    S:=msgINFO+"Aborted by user !";
                ELSE
                    CASE result OF
                    | rcSize :      INC(pbfsize);    Z:=msgSIZE;
                    | rcMismatch:   INC(pbmismatch); Z:=msgNOTID;
                    | rcSameForced: INC(pbmisc);     Z:=msgSAMEFORCED; (* should NEVER happen *)
                    ELSE
                        ; (* //XDS YASIR ! *)
                    END;
                    dmpname(makebat,opremme,hout,currentry);
                    headerComp (binfile,refentry,currentry);
                    WrStr(Z);
                END;
            END;
        ELSE
            INC(posingroup);
            ciaobye:=TRUE; (* unexpected entry *)
            Str.Prepend(S,msgPB);
        END;
        IF ciaobye THEN
            WrStr(msgPBAT);WrStr( fmtlc(currline,10,1,"",""));WrLn;
            EXIT;
        END;
    END;
    FIO.Close(hin);
    IF makebat THEN FIO.Close(hout); END;

    CASE state OF
    | waiting: ;
    | gotref:  IF NOT(ciaobye) THEN  (* # without ; *)
                   INC(pbmisc); WrStr(msgPBAT);WrStr( fmtlc(currline,10,1,"",""));WrLn;
               END;
    | ingroup: ;
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;

    IF ( (pbnotfound=0) AND (pbfsize=0) ) AND ( (pbmismatch=0) AND (pbmisc=0) ) THEN
        rc:=rcOK;
        S:=msgGOODchk;
    ELSE
        rc:=rcPB; S:=msgBAD;
        Str.Subst(S,"~", fmt(pbnotfound,10,1,"","") );
        Str.Subst(S,"~", fmt(pbfsize   ,10,1,"","") );
        Str.Subst(S,"~", fmt(pbmismatch,10,1,"","") );
        Str.Subst(S,"~", fmt(pbmisc    ,10,1,"","") );
    END;
    WrStr(S);WrLn;

    IF makebat THEN
        WrStr(msgOK);WrStr(batchfile);WrStr(" has been created.");WrLn;
    END;

    RETURN rc;
END doCheckList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstparm  = 1;
    maxparm    = 2;
    ndxref     = firstparm;
    ndxcomp    = firstparm+1; (* darn, 1+1=2 ! <g> *)
VAR
    S,R:pathtype;
    lastparm,i,parmcount,opt:CARDINAL;
    parm : ARRAY[firstparm..maxparm] OF pathtype;
    sLegalUnits:str80;
    anchor : pEntry;
    currID:LONGCARD;
    rc:CARDINAL;
    base     : ARRAY [ndxref..ndxcomp] OF pathtype;
    spec     : ARRAY [ndxref..ndxcomp] OF pathtype;
    dircount : ARRAY [ndxref..ndxcomp] OF LONGCARD;
    filecount: ARRAY [ndxref..ndxcomp] OF LONGCARD;
    fcount:LONGCARD;
    recurse,ignorefsize:BOOLEAN;
    altdisplay,keepcase,keepblanks,testsame:BOOLEAN;
    showallmatches,makebatch: BOOLEAN;
    maxmismatches : LONGCARD;
    cmpmode       : cmpType;
    listmode      : listmodeType;
    opcode        : opcodeType;
    usercli       : str128; (* should DO ! *)
    FAKEOKSTORAGE : BOOLEAN;
    IGNOREDSTORAGEPB:CARDINAL;
BEGIN
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)

    WrLn;

    recurse       := FALSE;
    maxmismatches := 0;         (* not yet redefined *)
    cmpmode       := binfile;
    keepcase      := FALSE;
    keepblanks    := FALSE;
    ignorefsize   := FALSE;
    testsame      := FALSE;
    listmode      := lstDefault;
    opcode        := opDefault;
    makebatch     := FALSE;
    showallmatches:= FALSE;
    altdisplay    := FALSE;
    FAKEOKSTORAGE := FALSE;
    IGNOREDSTORAGEPB:=0;
    DEBUG         := FALSE;

    parmcount:=Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,""); END;

    lastparm:=firstparm-1;
    FOR i:=1 TO parmcount DO
        Lib.ParamStr(R,i); cleanCLI(R); ReplaceChar(R,dquote,"");
        Str.Copy(S,R);
        UpperCase(S);
        IF isOption(S) THEN
            opt := GetOptIndex (S, "?"+delim+"H"+delim+"HELP"+delim+
                                   "S"+delim+"SUB"+delim+
                                   "M:"+delim+"MAX:"+delim+
                                   "T"+delim+"TEXT"+delim+"TXT"+delim+"LINES"+delim+
                                   "K"+delim+"KEEPCASE"+delim+
                                   "W"+delim+"KEEPBLANKS"+delim+
                                   "Z"+delim+"SIZE"+delim+
                                   "L"+delim+"IDENTICAL"+delim+
                                   "D"+delim+"DIFFERENT"+delim+
                                   "I"+delim+"IDENTICAL"+delim+

                                   "LL"+delim+"LA"+delim+
                                   "DD"+delim+"DA"+delim+
                                   "BAT"+delim+"BATCH"+delim+
                                   "N"+delim+"ALTERNATE"+delim+"NAMES"+delim+
                                   "DB"+delim+
                                   "DBB"+delim+"DBA"+delim+
                                   "A"+delim+"ALL"+delim+"ALLMATCHES"+delim+

                                   "DEL"+delim+
                                   "COPY"+delim+
                                   "KILL"+delim+
                                   "PCOPY"+delim+
                                   "KB"+delim+
                                   "KBB"+delim+"KBA"+delim+
                                   "U:"+delim+"USER:"+delim+"CMD:"+delim+
                                   "SDB"+delim+"DBS"+delim+
                                   "C"+delim+"CHECK"+delim+"@"+delim+
                                   "CC"+delim+"CHECKDEL"+delim+"@@"+delim+
                                   "CCC"+delim+"CCK"+delim+
                                   (* "SDBB"+delim+"DBBS"+delim+ *)
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3: abort(errHelp,"");

            | 4,5  : recurse:= TRUE;
            | 6,7  : IF GetLongCard(S,maxmismatches)=FALSE THEN
                         abort(errBadValue,R);
                     END;
                     IF maxmismatches=0 THEN maxmismatches:=MAX(LONGCARD);END;
            | 8,9,10,11: cmpmode:= textfile;
            | 12,13: keepcase:=TRUE;
            | 14,15: keepblanks:=TRUE;
            | 16,17: ignorefsize:=TRUE;
            | 18,19: IF chkList(listmode,lstIdentical)=FALSE THEN abort(errListMode,"");END;
            | 20,21: IF chkList(listmode,lstDifferent)=FALSE THEN abort(errListMode,"");END;
            | 22,23: testsame:=TRUE;

            | 24,25: IF chkList(listmode,lstIdentical)=FALSE THEN abort(errListMode,"");END;
                     showallmatches:=TRUE;
            | 26,27: IF chkList(listmode,lstDifferent)=FALSE THEN abort(errListMode,"");END;
                     showallmatches:=TRUE;
            | 28,29: makebatch:=TRUE;

            | 30,31,32: altdisplay:=TRUE;
            | 33   : IF chkOp(opcode,opDosDel)=FALSE THEN abort(errOpcode,"");END;
                     makebatch:=TRUE;
            | 34,35: IF chkOp(opcode,opDosDel)=FALSE THEN abort(errOpcode,"");END;
                     makebatch:=TRUE;
                     showallmatches:=TRUE;
            | 36,37,38:showallmatches:=TRUE;

            | 39   : IF chkOp(opcode,opDosDel)=FALSE THEN abort(errOpcode,"");END;
            | 40   : IF chkOp(opcode,opCopy)  =FALSE THEN abort(errOpcode,"");END;
            | 41   : IF chkOp(opcode,opDDdel) =FALSE THEN abort(errOpcode,"");END;
            | 42   : IF chkOp(opcode,opPCOPY) =FALSE THEN abort(errOpcode,"");END;
            | 43   : IF chkOp(opcode,opDDdel) =FALSE THEN abort(errOpcode,"");END;
                     makebatch:=TRUE;
            | 44,45: IF chkOp(opcode,opDDdel)=FALSE THEN abort(errOpcode,"");END;
                     makebatch:=TRUE;
                     showallmatches:=TRUE;
            | 46,47,48: GetString(R,usercli);
                     IF same(usercli,"") THEN abort(errUserCmd,"");END;
                     IF chkOp(opcode,opUser)=FALSE THEN abort(errOpcode,"");END;
            | 49,50: IF chkOp(opcode,opDosDel)=FALSE THEN abort(errOpcode,"");END;
                     makebatch:=TRUE;
                     recurse:=TRUE;


            | 51,52,53: IF chkList(listmode,lstCheck) =FALSE THEN abort(errListMode,"");END;
            | 54,55,56: IF chkList(listmode,lstCheck) =FALSE THEN abort(errListMode,"");END;
                     makebatch:=TRUE;
            | 57,58: IF chkOp(opcode,opDDdel) =FALSE THEN abort(errOpcode,"");END;
                     IF chkList(listmode,lstCheck) =FALSE THEN abort(errListMode,"");END;
                     makebatch:=TRUE;
            (*
            | sdbb handler : removed because too dangerous for user
                     IF chkOp(opcode,opDosDel)=FALSE THEN abort(errOpcode,"");END;
                     makebatch:=TRUE;
                     showallmatches:=TRUE;
                     recurse:=TRUE;
            *)
            | 59    : DEBUG:=TRUE;
            ELSE
                abort(errOption,R);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,R);END;
            parm[lastparm]:=R;
        END;
    END;

    (* getAllLegalUnits(TRUE,TRUE,TRUE,sLegalUnits); (* floppy,hd,CDROM *) //FIXME // XDS remed out for now *)
    sLegalUnits := lettersUpp; (* //FIXME temporary hack *)

    CASE listmode OF
    | lstCheck:
        CASE lastparm OF
        | 0: abort(errExpecting,"<list>");
        | 1: ;
        ELSE
             abort(errExpecting,"only <list>");
        END;
    ELSE
        CASE lastparm OF
        | 0: abort(errExpecting,"<spec1> <spec2>");
        | 1: abort(errExpecting,        "<spec2>");
        ELSE
            ; (* //XDS YASIR ! *)
        END;
    END;

    CASE listmode OF
    | lstDefault:
        IF showallmatches            THEN abort(errListOnly,"-a");END;
        IF makebatch                 THEN abort(errListOnly,"-bat");END;
        CASE cmpmode OF
        | binfile:
            IF keepcase              THEN abort(errNonsenseBin,"-k");END;
            IF keepblanks            THEN abort(errNonsenseBin,"-w");END;
        | textfile:
            IF ignorefsize           THEN abort(errNonsenseText,"-z");END;
            IF maxmismatches # 0     THEN abort(errNonsenseText,"-m:#");END;
        ELSE
            ; (* //XDS SILLY USELESS REQUIREMENT *)
        END;
        IF testsame THEN
            IF recurse               THEN abort(errNonsenseTest,"-s");END;
            IF ignorefsize           THEN abort(errNonsenseTest,"-z");END;
            IF maxmismatches # 0     THEN abort(errNonsenseTest,"-m:#");END;
        END;
        IF opcode # opDefault        THEN abort(errOpcodeList,""); END;
    | lstIdentical,lstDifferent:
        (* better safe than sorry with text files *)
        IF cmpmode = textfile    THEN abort(errNonsenseList,"-t");END;
        (* this test now makes it useless to check for dircount later *)
        (* CHKME IF recurse               THEN abort(errNonsenseList,"-s");END; *)
        IF testsame              THEN abort(errNonsenseList,"-i");END;
        (* reason dictates these options are a nonsense with list modes *)
        IF keepcase              THEN abort(errNonsenseList,"-k");END;
        IF keepblanks            THEN abort(errNonsenseList,"-w");END;
        IF ignorefsize           THEN abort(errNonsenseList,"-z");END;
        IF maxmismatches # 0     THEN abort(errNonsenseList,"-m:#");END;
        IF makebatch THEN
            IF opcode=opDefault  THEN abort(errBatchPrefix,"");END;
        END;
    | lstCheck :

        CASE opcode OF
        | opDefault :
            opcode := opDosDel;
        | opDosDel, opDDdel :
            ;
        ELSE
            abort(errOnlyDelOpcode,"");
        END;

        S:=parm[lastparm];
        IF chkJoker(S) THEN abort(errListJoker,S);END;
        IF FIO.Exists(S)=FALSE THEN abort(errListNotFound,S);END;
        rc:=doCheckList (DEBUG,makebatch, opcode,
                         errCheckOK, errCheckPB, S);
        abort(rc,""); (* // stop here *)
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;

    FOR i:=ndxref TO ndxcomp DO
        rc:= chkfixSpec( base[i],spec[i], parm[i],sLegalUnits );
        IF rc # errNone THEN abort(rc,parm[i]);END;
IF DEBUG THEN
WrStr(msgDEBUG+"command line <spec> : ");WrStr(parm[i]);WrLn;
WrStr(msgDEBUG+"base                : ");WrStr(base[i]);WrLn;
WrStr(msgDEBUG+"spec                : ");WrStr(spec[i]);WrLn;
END;
    END;
    CASE getPattern(spec[ndxcomp]) OF
    | patUnsupported : abort(errSpecFileForm,"<spec2>");
    | patExtAlone    : abort(errSpecFileForm,"<spec2>");
    ELSE
       ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    IF chkBothSpecs(base[ndxref],spec[ndxref],base[ndxcomp],spec[ndxcomp])=FALSE THEN
        abort(errSameSpecs,"");
    END;

    CASE listmode OF
    | lstDefault:
        IF testsame THEN (* there can be only one... well, one+one ;-) *)
            IF getPattern(spec[ndxref])  # patFileExt THEN abort(errMacLeod,"<spec1>");END;
            IF getPattern(spec[ndxcomp]) # patFileExt THEN abort(errMacLeod,"<spec2>");END;
        END;
    ELSE
       ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;

    (* step 1 : let's build lists *)

    initList(anchor);
    currID := FULLPATH; (* i.e. firstindex-1 i.e. 0 *)

    FOR i:=ndxref TO ndxcomp DO
        dircount[i]:=0; (* we can't init count in recursive buildDirList() *)
        rc:= buildDirList (currID,dircount[i],anchor,
                          recurse,i,base[i]);

        fixStorageError (rc,IGNOREDSTORAGEPB,  FAKEOKSTORAGE);

        IF rc # errNone THEN abort(rc, parm[i] ); END;
IF DEBUG THEN dmpList(anchor,i,TRUE); END;
    END;

    (* from now on, currID will change for files *)

    FOR i:=ndxref TO ndxcomp DO
        rc:= buildFileList (currID,filecount[i],
                           anchor,
                           i,spec[i]);

        fixStorageError (rc,IGNOREDSTORAGEPB,  FAKEOKSTORAGE);

        IF rc # errNone THEN abort(rc, parm[i] ); END;
IF DEBUG THEN dmpList (anchor,i,FALSE);END;
    END;

IF DEBUG THEN
WrStr(msgDEBUG+"dircount <spec1>  : ");IO.WrLngCard(dircount[ndxref],10);WrLn;
WrStr(msgDEBUG+"dircount <spec2>  : ");IO.WrLngCard(dircount[ndxcomp],10);WrLn;
WrStr(msgDEBUG+"filecount <spec1> : ");IO.WrLngCard(filecount[ndxref],10);WrLn;
WrStr(msgDEBUG+"filecount <spec2> : ");IO.WrLngCard(filecount[ndxcomp],10);WrLn;
END;

    IF makebatch THEN initBatch(opcode); END; (* for compatibility with v1.2, always create a dummy empty batch *)

    IF testsame THEN (* there can be only one... well, one+one ;-) *)
        fcount:=filecount[ndxref];
        IF fcount # 1 THEN
            IF fcount=0 THEN
                abort(errNotFound,spec[ndxref]);
            ELSE
                abort(errMacLeod,"<spec1>");
            END;
        END;
        fcount:=filecount[ndxcomp];
        IF fcount # 1 THEN
            IF fcount=0 THEN
                abort(errNotFound,spec[ndxcomp]);
            ELSE
                abort(errMacLeod,"<spec2>");
            END;
        END;
    END;

    (* step 2 : let's compare *)

    (*
    WrStr(Banner);WrLn;
    WrLn;
    *)

    IF maxmismatches = 0 THEN maxmismatches := 10; END; (* default *)
    IF testsame          THEN maxmismatches := 1;  END;

    rc:=errNone;
    CASE listmode OF
    | lstDefault :
        IF filecount[ndxref ] = 0 THEN abort(errNotFound,parm[ndxref]);END;
        IF filecount[ndxcomp] = 0 THEN abort(errNotFound,parm[ndxcomp]);END;

        rc:=procComp (anchor, cmpmode,
                     altdisplay, keepcase,keepblanks,
                     ignorefsize,testsame,
                     maxmismatches,
                     ndxref,ndxcomp, spec[ndxref],spec[ndxcomp]);

    | lstIdentical,lstDifferent:
        (* here we don't test filecount *)

        rc:=procList (anchor, listmode, opcode,
                     altdisplay, showallmatches, makebatch,
                     ndxref,ndxcomp, spec[ndxref],spec[ndxcomp],usercli);
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;

    freeList(anchor);

    IF testsame THEN
        IF rc=errNone THEN rc:=errBothFilesMatch;END; (* not an error, in fact ! *)
    END;
    abort(rc,"");
END fComp32.



