(* ---------------------------------------------------------------
Title         Q&D fix PE executable
Overview      see help
Usage         see help
Notes         A few months ago, while checking a few PE docs
              so I could enhance DLLFIND,
              I had the idea to patch by hand certain "interesting" PE fields
              so patched programs (games, screensavers, utilities...)
              would run on older Vindoze OSes such as Win98SE
              (possibly with the excellent KernelEx libraries) or WinXP.
              Patching versions often did the job, and patching CPU flags
              would sometimes allow a program to run on a newer multicore PC,
              provided patch executable requires a single procesor.

              While I dared think this was rather original an idea,
              I happened to find recently an IMAGECFG.EXE tool
              (seemingly from a M$ Win32 SDK) performing similar tasks. :-(

              I still find my own FIXPE (although more limited in scope)
              is much more user friendly. ;-)

              note KernelEx libraries may be more useful than this program...
              except for single processor setting

              -a display is compatible with DLLFIND /fff display



              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
              -r

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

	      ah, playing with LONGCARD, CARD32 and the like is *such* a joy...

	      note redirected files may differ with FIXPE for DOS
	      because of accentuated characters and the like !

Bugs

Wish List     patch "PE plus" Win64 binaries ?
              as I've decided to stop this OS "upgrade" madness with WinXP... ;-)

              list only files matching a version OR a minimum version ?
              bah, just grep log !
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 12 Dec 16 v0.9a now allowing CPU [0..31] instead of [0..7]
PhG  7 Dec 16 an ugly really Q&D port from FIXPE v1.0 for DOS
--------------------------------------------------------------- *)

MODULE fixPE32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

FROM SYSTEM IMPORT CARD8, CARD16, CARD32;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    SHOWCULPRIT   = TRUE;
CONST
    progEXEname   = "FIXPE32";
    progTitle     = "Q&D fix PE executable (Win32)";
    progVersion   = "v0.9a (from v1.0 for DOS)";
    progCopyright = "by Philippe Guiochon";
    banner        = progTitle+" "+progVersion+" "+progCopyright;

CONST
    extCOM        = ".COM";
    sINFO         = "::: ";
    sERR          = "--- ";
    sOK           = "+++ ";
    sPrefix       = "    ";
    sINFOVER      = "=== ";
    sGOODNEWS     = ":+: ";
    sBADNEWS      = ":-: ";
    sNOTABENE     = ":!: ";
CONST
    extLOG        = ".LOG";
    extCD         = ".CD";   (* .RO was better a choice but well, now... *)
    LOGFILE       = progEXEname+extLOG;
    LOGFIXFILE    = progEXEname+extCD;
    specSWP       = "*.SWP";
    specPAR       = "*.PAR";
    specPAGEFILE  = "*\PAGEFILE.SYS"; (* was "?:\PAGEFILE.SYS" *)
    TOOMANY       = MAX(CARDINAL);
CONST
    sBit14on      = "$4000";
    sBit14off     = "$BFFF";
    bit14on       =  04000H; (* 0100000000000000 IN characteristics flag *)
    bit14off      =  0BFFFH; (* 1011111111111111 IN characteristics flag *)
    anyCPU        =  00000H; (* 0000000000000000 IN affinity mask *)



CONST
    errNone            = 0;
    errHelp            = 1;
    errUnknownOption   = 2;
    errTooManyParms    = 3;
    errMissingSpec     = 4;
    errNotFound        = 5;
    errNotFile         = 6;
    errJoker           = 7;
    errCmd             = 8;
    errJokerPath       = 9;
    errTooMany         = 10;
    errMajMin          = 11;
    errRedefined       = 12;
    errCardVal         = 13;
    errMask            = 14;

    errROtarget        = 32;
    errNoWeCant        = 64;
    errBadPEinfos      = 128;
    errUnsupported     = 192;
    errEscape          = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg = banner+nl+
nl+
"Syntax : "+progEXEname+" <file> [option]..."+nl+
nl+
'This program shows a few "interesting" values in a PE 32-bits executable.'+nl+
"It can also modify them so patched binary *MAY* run on older Win OSes :"+nl+
"Win98SE (sometimes with the excellent KernelEx libraries) or WinXP."+nl+
'Beware ! Running a patched "newer" binary on an "older" O.S. may *NOT* work.'+nl+

(*
"Just ask your local guru about KernelEX, Unicode, libraries with alternate functions and the like, eh eh... ;-)"
*)

nl+
"  -v          view <file> interesting values (default)"+nl+
"  -c:#        set characteristics flag"+nl+
'  -s          set "single CPU required" ("OR '+sBit14on+'" in characteristics flag)'+nl+
'  -m          set "multiple CPUs allowed" ("AND '+sBit14off+'" in characteristics flag)'+nl+
"  -m:#        set processor affinity mask"+nl+
"  -p:#[,#]... allow specified processor(s) (CPU range is [0..31], *=all)"+nl+
"  -<n|o>:#.#  set NT OS version"+nl+
"  -<w|s>:#.#  set Win32 subsystem version"+nl+
"  -<a|i>:#.#  set application image version"+nl+
"  -v:#        set Win32 version value"+nl+
nl+
"  -a          alternate display (similar to DLLFIND -fff display)"+nl+
"  -n          keep CRLFs to a minimum"+nl+
"  -c          create a new "+LOGFILE+" instead of appending to existing one"+nl+
"  -l          prevent operations from being reported to "+LOGFILE+" log"+nl+
"  -d          update <file> date/time stamp (default is not to update it) "+nl+
nl+
"a) When patching, filename jokers are not supported : this is by design."+nl+
"b) PE+ Win64 executables are not supported : this is by lack of interest."+nl+
'c) Please note "affinity mask" field is not always defined : this is NOT a bug.'+nl+
'd) ".0" is appended to version if specified without ".#" part.'+nl+
'e) Number parsing handles "$#", "0x#", "H#" and "#H" forms for hexadecimal,'+nl+
'   "B#" and "#B" for binary.'+nl+
"f) Modifications are written to "+LOGFILE+" log in current directory :"+nl+
"   this allows easy undoing of any change."+nl+
"   Note -l option can be forced if "+LOGFIXFILE+" exists in executable directory."+nl+
"g) Please note creating a backup of original file is *STRONGLY* advised."+nl+
"h) For obvious reasons, program will not try and analyze files matching"+nl+
"   "+specSWP+", "+specPAR+" and "+specPAGEFILE+" specifications."+nl+
"i) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" calc.exe -single -p:0"+nl+
"           "+progEXEname+" ribbons.scr -n:4.0"+nl+
"           "+progEXEname+" c:\windows\system\*.* /a"+nl;



VAR
    S  : str1024; (* we may get a LFN *)
BEGIN
    CASE e OF
    | errHelp :         WrStr(errmsg);
    | errUnknownOption: S := 'Unknown "|" option !';
    | errTooManyParms:  S := '"|" is one parameter too many !';
    | errMissingSpec:   S := "Missing <file> specification !";
    | errNotFound:      S := '"|" does not exist !';
    | errNotFile:       S := '"|" looks like a directory !';
    | errJoker:         S := 'Jokers are not allowed when patching a file !';
    | errCmd:           S := '"|" option conflicts with an already set command !';
    | errJokerPath:     S := "Jokers are not allowed in path !";
    | errTooMany:       S := "Storage.ALLOCATE() failure !"; (* or 65535 matches ! *)
                        S := "Too many files !";
    | errMajMin:        S := 'Bad "|" version number !';
    | errRedefined:     S := 'Field specified with "|" has already been redefined !';
    | errCardVal:       S := 'Illegal "|" value !';
    | errMask:          S := 'Illegal "|" mask !';

    | errROtarget:      S := "";
    | errNoWeCant:      S := "";
    | errBadPEinfos:    S := "";
    | errUnsupported:   S := "";
    | errEscape:        S := "Aborted by user !";
    ELSE
                        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    | errUnsupported,errBadPEinfos,errNoWeCant,errROtarget : (* already displayed *)
        ;
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    firstioBufferByte = 1;
    lastioBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstioBufferByte..lastioBufferByte] OF SYSTEM.LOC;
VAR
    ioBufferList,ioBufferIn : ioBufferType; (* iobufferlist used for ini and list *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE initRptLog (SKIPLOG,NEWLOG:BOOLEAN;F:ARRAY OF CHAR);
BEGIN
    IF SKIPLOG THEN RETURN; END;
    IF FIO.Exists(LOGFILE) THEN
        (* IF isReadOnly(LOGFILE) THEN setReadWrite(LOGFILE); END; (* safety *) *)
        IF NEWLOG THEN FIO.Erase(LOGFILE); END;
    END;
END initRptLog;

PROCEDURE flushRptLog (SKIPLOG:BOOLEAN;F:ARRAY OF CHAR);
BEGIN
END flushRptLog;

PROCEDURE rptwr (SKIPLOG:BOOLEAN;F, prefix,S:ARRAY OF CHAR);
VAR
    hnd:FIO.File;
BEGIN
    WrStr(prefix);
    WrStr(S);
    WrLn;
    IF SKIPLOG THEN RETURN;END;
    IF FIO.Exists(F) THEN
        hnd:=FIO.Append(F);
    ELSE
        hnd:=FIO.Create(F);
    END;
    FIO.WrStr(hnd,prefix);
    FIO.WrStr(hnd,S);
    FIO.WrLn(hnd);
    FIO.Close(hnd);
END rptwr;

PROCEDURE foundFixFile(ext:ARRAY OF CHAR):BOOLEAN; (* ".???" uppercase *)
VAR
    S:str128;
    p:CARDINAL;
BEGIN
    Lib.ParamStr(S,0); (* retrieve executable location so LOGFILE is EXE.LOG *)
    p:=Str.RCharPos(S,dot); (* always found ! *)
    S[p]:=charnull;
    Str.Append(S,ext);
    RETURN FIO.Exists(S);
END foundFixFile;

(* ------------------------------------------------------------ *)

PROCEDURE chkJokerPath (spec:pathtype  ):BOOLEAN;
VAR
    S,u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(S,u,d,"","");
    RETURN chkJoker(S);
END chkJokerPath;

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S:ARRAY OF CHAR):BOOLEAN;
BEGIN
    IF Str.Match(S,specSWP) THEN RETURN TRUE; END;
    IF Str.Match(S,specPAR) THEN RETURN TRUE; END;
    RETURN Str.Match(S,specPAGEFILE);
END isReservedPattern;

PROCEDURE isReservedEntry (S : ARRAY OF CHAR) : BOOLEAN; (* assume uppercase *)
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    IF same(S,dotdot) THEN RETURN TRUE; END;
    RETURN isReservedPattern(S);
END isReservedEntry;

(* ------------------------------------------------------------ *)

CONST
    firstEntry = 1; (* 1..count *)
TYPE
    ptrToEntry = POINTER TO entryType;
    entryType = RECORD
        next   : ptrToEntry;
        slen   : CARDINAL; (* a SHORTCARD would do fine in almost all cases  *)
        string : CHAR;      (* here, after other data, because variable length *)
    END;

PROCEDURE store (VAR newInList,anchor:ptrToEntry; VAR lastEntry:CARDINAL;
                S:pathtype):BOOLEAN ;
VAR
    len,needed:CARDINAL;
    rc:BOOLEAN;
BEGIN
    INC(lastEntry);
    IF lastEntry=TOOMANY THEN RETURN FALSE;END; (* too many files but fake storage ALLOCATE failure here *)

    len:=Str.Length(S);
    needed:=SIZE(entryType)-SIZE(CHAR)+len;
    rc:= TRUE;
    IF rc THEN
        CASE lastEntry OF
        | firstEntry :
            ALLOCATE( anchor,needed);
            newInList := anchor;
        ELSE
            ALLOCATE(newInList^.next,needed);
            newInList :=newInList^.next;
        END;
        Lib.FastMove( SYSTEM.ADR(S),SYSTEM.ADR(newInList^.string),len);
        newInList^.slen := len;
        newInList^.next := NIL;
    END;
    RETURN rc;
END store;

PROCEDURE buildMatchList (VAR anchor:ptrToEntry;
                          spec:pathtype):CARDINAL;
VAR
    S,u,d,n,e,dirbase,filespec:pathtype; (* some are oversized but safety first ! *)
    newInList : ptrToEntry;
    lastEntry: CARDINAL;
    errcode:CARDINAL;
    DOSentry     : FIO.DirEntry;
    rc,found:BOOLEAN;
    dosattr:FIO.FileAttr;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(dirbase,u,d,"","");
    fixDirectory(dirbase);
    Lib.MakeAllPath(filespec,"","",n,e);

    lastEntry:=firstEntry-1;
    anchor:=NIL;

    found := FIO.ReadFirstEntry(spec,everything,DOSentry);
    WHILE found DO
        Str.Copy(S,DOSentry.name);
        IF isReservedEntry(S) THEN (* skip "." ".." "*.SWP" "*.PAR" *)
            ; (* silently ignore this spec *)
        ELSE
            dosattr:=DOSentry.attr;
            IF NOT (aDD IN dosattr) THEN
                Str.Prepend(S,dirbase);
                IF store(newInList,anchor,lastEntry,S)=FALSE THEN
                    RETURN TOOMANY; (* storage ALLOCATE failure or too many files *)
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(DOSentry);
    END;
    RETURN lastEntry;
END buildMatchList;

PROCEDURE freeMatchList (anchor:ptrToEntry);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrToEntry;
BEGIN
    firstInList := anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
        len         := CARDINAL(newInList^.slen);
        needed      := SIZE(entryType)-SIZE(CHAR)+len;
        firstInList := firstInList^.next;
        DEALLOCATE (newInList,needed);
        newInList := firstInList;
    END
END freeMatchList;

PROCEDURE getMatchEntry (VAR R:pathtype;
                         n:CARDINAL; anchor:ptrToEntry);
VAR
    i,len:CARDINAL;
    newInList:ptrToEntry;
    S:pathtype;
BEGIN
    newInList := anchor;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:=firstEntry TO n DO
         newInList := newInList^.next;
    END;
    len         := newInList^.slen;
    Lib.FastMove( SYSTEM.ADR(newInList^.string),SYSTEM.ADR(S),len);
    S[len]      := nullchar; (* REQUIRED safety ! *)
    Str.Copy(R,S); (* yep, compiler won't let us fill R directly *)
END getMatchEntry;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    dttype = RECORD
        CASE : BOOLEAN OF
        | TRUE  :
            t : CARDINAL; (* hms is low  *)
            d : CARDINAL; (* ymd is high *)
        | FALSE :
            dt : LONGCARD;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

PROCEDURE getfilestamp (VAR h:dttype  ; S:pathtype):BOOLEAN;
VAR
    hnd:FIO.File;
    rc:BOOLEAN;
BEGIN
    hnd:=FIO.OpenRead(S);
        h.dt := FIO.GetFileDate(hnd);
        rc:=TRUE;
    FIO.Close(hnd);
    RETURN rc;
END getfilestamp;

PROCEDURE setFileStamp (h:dttype;S:pathtype):BOOLEAN;
VAR
    hnd:FIO.File;
    rc:BOOLEAN;
BEGIN
    hnd:=FIO.Open(S);
        FIO.SetFileDate(hnd,h.dt);
        rc:=TRUE;
    FIO.Close(hnd);
    RETURN rc;
END setFileStamp;

PROCEDURE enquote (S:pathtype):pathtype;
VAR
    R: pathtype;
BEGIN
    Str.Concat(R,dquote,S);
    Str.Append(R,dquote);
    RETURN R;
END enquote;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtbignum (v:LONGCARD; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr( v, S, base,ok);
    FOR i:=Str.Length(S)+1 TO CARDINAL ( ABS(wi) ) DO
         IF wi < 0 THEN
             Str.Append(S,pad);
         ELSE
             Str.Prepend(S,pad);
         END;
    END;
    IF base=16 THEN Str.Lows(S);END;
    RETURN S;
END fmtbignum;

PROCEDURE fmtnum ( v:CARDINAL; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
BEGIN
    RETURN fmtbignum( LONGCARD(v),base,wi,pad);
END fmtnum;

(* ------------------------------------------------------------ *)

TYPE
    byteArrayType = ARRAY [0..7] OF CARD8; (* 8 bytes should DO FOR now *)

PROCEDURE fmtnummem ( v:CARD16):str16;
VAR
    R:str16;
    b:byteArrayType;
    i,n:CARDINAL;
BEGIN
    n:=SIZE(v);
    Lib.Move( SYSTEM.ADR(v), SYSTEM.ADR(b), n );
    R:="";
    FOR i:=1 TO n DO
        Str.Append(R,fmtnum( CARDINAL(b[i-1]),16,2,"0"));
        IF i < n THEN Str.Append(R," "); END;
    END;
    RETURN R;
END fmtnummem;

PROCEDURE fmtbignummem ( v:CARD32):str16;
VAR
    R:str16;
    b:byteArrayType;
    i,n:CARDINAL;
BEGIN
    n:=SIZE(v);
    Lib.Move( SYSTEM.ADR(v), SYSTEM.ADR(b), n );
    R:="";
    FOR i:=1 TO n DO
        Str.Append(R,fmtnum( CARDINAL(b[i-1]),16,2,"0"));
        IF i < n THEN Str.Append(R," "); END;
    END;
    RETURN R;
END fmtbignummem;

(* ------------------------------------------------------------ *)

PROCEDURE fmtval ( base:CARDINAL; v:LONGCARD;S:ARRAY OF CHAR  ):str128;
VAR
    R:str128;
BEGIN
    IF base=16 THEN
        Str.Concat(R,"$", fmtbignum(v,base,8,"0") );
    ELSE
        Str.Concat(R,"",fmtbignum(v,base,1,"") );
    END;
    RETURN R;
END fmtval;

PROCEDURE fmtaddr ( base:CARDINAL;h:FIO.File; S:ARRAY OF CHAR ):str128;
VAR
    addr:LONGCARD;
BEGIN
    addr:=FIO.GetPos(h);
    RETURN fmtval(base,addr,S);
END fmtaddr;

PROCEDURE fmtver ( major,minor:CARDINAL):str16;
VAR
    R:str16;
BEGIN
    R:="~.~";
    Str.Subst(R,"~",fmtbignum(LONGCARD(major),10,1,""));
    Str.Subst(R,"~",fmtbignum(LONGCARD(minor),10,1,""));
    RETURN R;
END fmtver;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE readStringZ (hin:FIO.File;pos:CARD32;VAR R:ARRAY OF CHAR);
VAR
    wanted,got : CARDINAL;
    ch  : CHAR;
BEGIN
    wanted:=SIZE(ch);
    FIO.Seek(hin,pos);
    Str.Copy(R,"");
    LOOP
        got:=FIO.RdBin(hin,ch,wanted);
        IF got # wanted THEN ch:=nullchar;END; (* hide error *)
        Str.Append(R,ch);
        IF ch=nullchar THEN EXIT; END;
    END;
END readStringZ;

PROCEDURE readStringZU (hin:FIO.File;pos:CARD32;VAR R:ARRAY OF CHAR);
VAR
    wanted,got : CARDINAL;
    ch  : CHAR;
BEGIN
    wanted:=SIZE(ch);
    FIO.Seek(hin,pos);
    Str.Copy(R,"");
    LOOP
        got:=FIO.RdBin(hin,ch,wanted);
        IF got # wanted THEN ch:=nullchar;END; (* hide error *)
        Str.Append(R,ch);
        IF ch=nullchar THEN EXIT; END;
        got:=FIO.RdBin(hin,ch,wanted); (* $00 *)
        IF got # wanted THEN EXIT;END;
    END;
END readStringZU;

PROCEDURE readString (hin:FIO.File;pos:CARD32;len:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    got : CARDINAL;
BEGIN
    FIO.Seek(hin,pos);
    got:=FIO.RdBin(hin,R,len);
    IF got = len THEN
        R[got]:=nullchar; (* brutal ! *)
    ELSE
        Str.Copy(R,""); (* error *)
    END;
END readString;

PROCEDURE readByte (hin:FIO.File; pos:CARD32):CARD8;
VAR
    b:CARD8;
    wanted,got:CARDINAL;
BEGIN
    wanted:=SIZE(b);
    FIO.Seek(hin,pos);
    got:=FIO.RdBin(hin,b,wanted);
    IF got # wanted THEN b:=0;END; (* ignore errors *)
    RETURN b;
END readByte;

PROCEDURE readWord (hin:FIO.File; pos:CARD32):CARD16;
VAR
    w:CARD16;
    wanted,got:CARDINAL;
BEGIN
    wanted:=SIZE(w);
    FIO.Seek(hin,pos);
    got:=FIO.RdBin(hin,w,wanted);
    IF got # wanted THEN w:=0;END; (* ignore errors *)
    RETURN w;
END readWord;

PROCEDURE readDword (hin:FIO.File; pos:CARD32):CARD32;
VAR
    d:CARD32;
    wanted,got:CARDINAL;
BEGIN
    wanted:=SIZE(d);
    FIO.Seek(hin,pos);
    got:=FIO.RdBin(hin,d,wanted);
    IF got # wanted THEN d:=0;END; (* ignore errors *)
    RETURN d;
END readDword;

(* ------------------------------------------------------------ *)

PROCEDURE readCurrStringZU (hin:FIO.File;DEBUG:BOOLEAN; VAR R:ARRAY OF CHAR);
VAR
    wanted,got : CARDINAL;
    ch,unicrap  : CHAR;
BEGIN
IF DEBUG THEN WrStr( fmtval( 16,FIO.GetPos(hin),"readstrZU") );WrLn;END;
    wanted:=SIZE(ch);
    Str.Copy(R,"");
    LOOP
        got:=FIO.RdBin(hin,ch,wanted);
        IF got # wanted THEN ch:=nullchar;END; (* hide error *)
        Str.Append(R,ch);
        got:=FIO.RdBin(hin,unicrap,wanted); (* $00 *)
        IF got # wanted THEN EXIT;END;
        IF ch=nullchar THEN EXIT; END;
    END;
END readCurrStringZU;

PROCEDURE readCurrStringU (hin:FIO.File;DEBUG:BOOLEAN; len:CARDINAL; VAR R:ARRAY OF CHAR);
VAR
    i,wanted,got : CARDINAL;
    ch,unicrap  : CHAR;
BEGIN
IF DEBUG THEN WrStr( fmtval(  16,FIO.GetPos(hin),"readstrU start") );WrLn;END;
    wanted:=SIZE(ch);
    Str.Copy(R,"");
    FOR i:= 1 TO len DO
        got:=FIO.RdBin(hin,ch,wanted);
        IF got # wanted THEN ch:=nullchar;END; (* hide error *)
        Str.Append(R,ch);
        got:=FIO.RdBin(hin,unicrap,wanted); (* $00 *)
        IF got # wanted THEN RETURN;END;
        IF ch=nullchar THEN RETURN; END;
    END;
IF DEBUG THEN WrStr( fmtval(  16,FIO.GetPos(hin),"readstrU end") );WrLn;END;
END readCurrStringU;

PROCEDURE readCurrWord (hin:FIO.File;DEBUG:BOOLEAN):CARD16;
VAR
    w:CARD16;
    wanted,got:CARDINAL;
BEGIN
IF DEBUG THEN WrStr( fmtval(  16,FIO.GetPos(hin),"readcurrword") );WrLn;END;
    wanted:=SIZE(w);
    got:=FIO.RdBin(hin,w,wanted);
    IF got # wanted THEN w:=0;END; (* ignore errors *)
    RETURN w;
END readCurrWord;

PROCEDURE readCurrByte (hin:FIO.File):CARD8;
VAR
    b:CARD8;
    wanted,got:CARDINAL;
BEGIN
    wanted:=SIZE(b);
    got:=FIO.RdBin(hin,b,wanted);
    IF got # wanted THEN b:=0;END; (* ignore errors *)
    RETURN b;
END readCurrByte;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    PEfileHeaderType = RECORD
        signature            : CARD32; (* 50 45 00 00 at $40 *)
        Machine              : CARD16;
        NumberOfSections     : CARD16; (* useful  *)
        TimeDateStamp        : CARD32;
        PointerToSymbolTable : CARD32;
        NumberOfSymbols      : CARD32;
        SizeOfOptionalHeader : CARD16;
        CharacteristicsFlag  : CARD16; (* bit 14 = UP_SYSTEM_ONLY = ONE CPU *)
    END;

TYPE
    PEoptionalHeaderType = RECORD
        Magic                       : CARD16;  (* +0 PE is $010B, PE+ is $020B *)
        MajorLinkerVersion          : CARD8;
        MinorLinkerVersion          : CARD8;
        SizeOfCode                  : CARD32;  (* +4 *)
        SizeOfInitializedData       : CARD32;
        SizeOfUninitializedData     : CARD32;
        AddressOfEntryPoint         : CARD32;  (* +16 *)
        BaseOfCode                  : CARD32;
        BaseOfData                  : CARD32;
        ImageBase                   : CARD32;
        SectionAlignment            : CARD32;  (* +32 *)
        FileAlignment               : CARD32;
        MajorOperatingSystemVersion : CARD16;  (* +40 *)
        MinorOperatingSystemVersion : CARD16;
        MajorImageVersion           : CARD16;  (* +44 *)
        MinorImageVersion           : CARD16;
        MajorSubsystemVersion       : CARD16;  (* +48 *)
        MinorSubsystemVersion       : CARD16;
        Win32VersionValue           : CARD32;  (* +52 *)
        SizeOfImage                 : CARD32;
        SizeOfHeaders               : CARD32;
        CheckSum                    : CARD32;  (* //FIXME algo ? *)
        SubsystemFlag               : CARD16;  (* +68 *)
        DllCharacteristics          : CARD16;
        SizeOfStackReserve          : CARD32;
        SizeOfStackCommit           : CARD32;
        SizeOfHeapReserve           : CARD32;
        SizeOfHeapCommit            : CARD32;
        LoaderFlags                 : CARD32;
        NumberOfRvaAndSizes         : CARD32;
    END;
TYPE
    PEimageDirectoryType = RECORD
        strucaddr : CARD32;
        strucsize : CARD32;
    END;


TYPE
    PEsectionHeaderType = RECORD
        Name                 : ARRAY [0..7] OF CHAR; (* 0 terminated or 8 chars *)
        VirtualSize          : CARD32;
        VirtualAddress       : CARD32;
        SizeOfRawData        : CARD32;
        PointerToRawData     : CARD32; (* file offset *)
        PointerToRelocations : CARD32;
        PointerToLinenumbers : CARD32;
        NumberOfRelocations  : CARD16;
        NumberOfLinenumbers  : CARD16;
        Characteristics      : CARD32;
    END;

TYPE
    PEimageImportDescriptorType = RECORD
        OriginalFirstThunk : CARD32;
        TimeDateStamp      : CARD32;
        ForwarderChain     : CARD32;
        Name               : CARD32; (* // ASCIIZ *)
        FirstThunk         : CARD32;
    END;

(*
//FIXME search doc about this !
tiny C compiler WINNT.H file
discrepancies with digitalmars C compiler WINNT.H and PEFILE.PY code !
we should try AND locate a reliable source FOR this damn PE format !
*)

TYPE
    PEloadConfig32type = RECORD
        Size                          :  CARD32; (* +0 *)
        TimeDateStamp                 :  CARD32;
        MajorVersion                  :  CARD16; (* +8 *)
        MinorVersion                  :  CARD16;
        GlobalFlagsClear              :  CARD32; (* +12 *)
        GlobalFlagsSet                :  CARD32;
        CriticalSectionDefaultTimeout :  CARD32;
        DeCommitFreeBlockThreshold    :  CARD32;
        DeCommitTotalFreeThreshold    :  CARD32;
        LockPrefixTable               :  CARD32;
        MaximumAllocationSize         :  CARD32;
        VirtualMemoryThreshold        :  CARD32; (* +40 *)
        ProcessHeapFlags              :  CARD32;
        ProcessAffinityMask           :  CARD32; (* +48 //FIXME check *)
        CSDVersion                    :  CARD16;
        Reserved1                     :  CARD16;
        EditList                      :  CARD32;
        SecurityCookie                :  CARD32;
        SEHandlerTable                :  CARD32;
        SEHandlerCount                :  CARD32;
        (* here PEFILE.PY *)
        GuardCFCheckFunctionPointer   : CARD32;
        Reserved2                     : CARD32;
        GuardCFFunctionTable          : CARD32;
        GuardCFFunctionCoun           : CARD32;
        GuardFlags                    : CARD32;
    END;

TYPE
    valueType = RECORD
        CASE : BOOLEAN OF
        | TRUE : hilo  : CARD32;
        | FALSE: lo,hi : CARD16;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;





CONST
    (* from WIN32 API headers *)
    IMAGE_DIRECTORY_ENTRY_EXPORT       =  0;   (* Export Directory *)
    IMAGE_DIRECTORY_ENTRY_IMPORT       =  1;   (* Import Directory // *)
    IMAGE_DIRECTORY_ENTRY_RESOURCE     =  2;   (* Resource Directory // *)
    IMAGE_DIRECTORY_ENTRY_EXCEPTION    =  3;   (* Exception Directory *)
    IMAGE_DIRECTORY_ENTRY_SECURITY     =  4;   (* Security Directory *)
    IMAGE_DIRECTORY_ENTRY_BASERELOC    =  5;   (* Base Relocation Table *)
    IMAGE_DIRECTORY_ENTRY_DEBUG        =  6;   (* Debug Directory *)
    IMAGE_DIRECTORY_ENTRY_COPYRIGHT    =  7;   (* Description String *)
    IMAGE_DIRECTORY_ENTRY_GLOBALPTR    =  8;   (* Machine Value (MIPS GP) *)
    IMAGE_DIRECTORY_ENTRY_TLS          =  9;   (* TLS Directory *)
    IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG  = 10;   (* Load Configuration Directory // *)
    IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11;   (* Bound Import Directory in headers *)
    IMAGE_DIRECTORY_ENTRY_IAT          = 12;   (* Import Address Table *)
    IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT   = 13; (* Delay Load Import Descriptors *)
    IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR = 14; (* COM Runtime descriptor *)

CONST
    (* image directory entries *)
    firstdirindex   = 0;
    lastdirindex    = 15; (* not 14 ! *)
    IMPORTindex     = IMAGE_DIRECTORY_ENTRY_IMPORT;
    RESOURCEindex   = IMAGE_DIRECTORY_ENTRY_RESOURCE;
    LOADCONFIGindex = IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG;
TYPE
    PEdataDirectoriesType = ARRAY [firstdirindex..lastdirindex] OF PEimageDirectoryType;


(* ------------------------------------------------------------ *)

(* TS kludge as not to use additions of SIZE() *)

CONST  (* PEfileHeaderType *)
    ofsCharacteristicsFlag         = 22; (* bit 14 UP_SYSTEM_ONLY ONE CPU *)
CONST  (* PEoptionalHeaderType *)
    ofsMajorOperatingSystemVersion = 40;
    ofsMajorImageVersion           = 44;
    ofsMajorSubsystemVersion       = 48;
    ofsWin32VersionValue           = 52;
    ofsSubsystemFlag               = 68;
CONST  (* PEloadConfig32type *)
    ofsProcessorAffinityMask       = 48;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    idNotEXE          = 1; (* possibly COM format *)
    idNotPackedDOSexe = 2; (* almost certainly a DOS executable *)
    idUnknownWinEXE   = 3; (* almost certainly a packed DOS executable *)
    idNE              = 4;
    idLE              = 5;
    idW3              = 6;
    idW4              = 7;
    idPE              = 8;   (* supported *)
    idCOM             = 9;
    idLZ090           = 10;
    idLZ091           = 11;
    idPKLITE          = 12;
    idLHASFX          = 13;
    idTScrunch        = 14;
    idUPXdos          = 15;
    idUPXwin32        = 16;  (* supported *)
    idPEplus          = 17;
    idDIET            = 18;
    idGloups          = 19;

PROCEDURE getdesc (id:CARDINAL; VAR R:ARRAY OF CHAR);
VAR
    S:str128;
BEGIN
    CASE id OF
    | idNotEXE :         S:="Not an executable";
    | idNotPackedDOSexe: S:="DOS executable (probably not packed)";
    | idUnknownWinEXE:   S:="DOS executable (probably packed)";
    | idNE:              S:="NE Win16 executable";
    | idLE:              S:="LE Win16 VxD";
    | idW3:              S:="W3 Win16 collection of VxDs";
    | idW4:              S:="W4 Win9x VxD";
    | idPE:              S:="PE Win32 executable";
    | idCOM:             S:="DOS program (COM format)"; (* assumption based upon file extension ! *)
    | idLZ090:           S:="DOS executable (packed with LZEXE 0.90)";
    | idLZ091:           S:="DOS executable (packed with LZEXE 0.91)";
    | idPKLITE:          S:="DOS executable (packed with PKLITE)";
    | idLHASFX:          S:="DOS executable (LHA 2.x self-extracting archive)";
    | idTScrunch:        S:="DOS executable (packed with TopSpeed CRUNCH)";
    | idUPXdos:          S:="DOS executable (packed with UPX)";
    | idUPXwin32:        S:="PE Win32 executable (packed with UPX)";
    | idPEplus:          S:="PE+ Win64 executable";
    | idDIET:            S:="DOS executable (packed with DIET)";
    ELSE
                         S:="Unknown";
    END;
    Str.Copy(R,S);
END getdesc;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
values for IMAGE_FILE_HEADER.Machine field according to M$ PE/COFF dox :

UNKNOWN      0x0        applicable to any machine type
AM33         0x1d3      Matsushita AM33
AMD64        0x8664     x64                                     ///
ARM          0x1c0      ARM little endian
EBC          0xebc      EFI byte code
I386         0x14c      Intel 386 or later                      ///
IA64         0x200      Intel Itanium processor family          /// ???
M32R         0x9041     Mitsubishi M32R little endian
MIPS16       0x266      MIPS16
MIPSFPU      0x366      MIPS with FPU
MIPSFPU16    0x466      MIPS16 with FPU
POWERPC      0x1f0      Power PC little endian
POWERPCFP    0x1f1      Power PC with floating point support
R4000        0x166      MIPS little endian
SH3          0x1a2      Hitachi SH3
SH3DSP       0x1a3      Hitachi SH3 DSP
SH4          0x1a6      Hitachi SH4
SH5          0x1a8      Hitachi SH5
THUMB        0x1c2      Thumb
WCEMIPSV2    0x169      MIPS little-endian WCE v2

values for "PE architecture" i.e. Magic field :
UNKNOWN      0x0000
ANYCPU       0x0001
X86          0x010B
x64          0x020B
*)

PROCEDURE chkUPXwin32 (VAR seems64bits:BOOLEAN;
                       hin:FIO.File;winheaderpos:LONGCARD;DEBUG:BOOLEAN):BOOLEAN;
CONST
    strUPX          = "UPX"; (* normally, UPX0, UPX1, UPX2 *)
CONST
    magicUnknown    = 0000H;
    magicAnyCPU     = 0001H;
    magic32         = 010BH;
    magic64         = 020BH;
CONST
    machineX86      = 014CH;
    machineX64      = 8664H;
    machineI64      = 0200H;
VAR
    rc:BOOLEAN;
    pefileheader     : PEfileHeaderType;
    peoptionalheader : PEoptionalHeaderType; (* required "optional" : go figure ! *)
    pedirindex       : PEdataDirectoriesType;
    pesectionheader  : PEsectionHeaderType;
    i,got,wanted,sectioncount:CARDINAL;
    filealignment,sectionalignment,importaddr : LONGCARD;
    sectionheadername : str16; (* oversized *)
    chk64a,chk64b:BOOLEAN;
BEGIN
    seems64bits := FALSE; (* assume 32 bits PE *)
    rc:=FALSE; (* assume NOT an UPX Win32 *)

    FIO.Seek(hin,winheaderpos);

    wanted:=SIZE(pefileheader);
    got := FIO.RdBin(hin,pefileheader,wanted);
    IF got # wanted THEN RETURN rc; END;
    sectioncount:=pefileheader.NumberOfSections;
    IF sectioncount=0 THEN RETURN rc; END;

IF DEBUG THEN WrStr(fmtval( 16,LONGCARD( pefileheader.Machine) ,"machine"));WrLn;END;

    CASE pefileheader.Machine OF
    | machineX86 : chk64a := FALSE;
    | machineX64 : chk64a := TRUE;
    | machineI64 : chk64a := TRUE;
    ELSE
                   chk64a := FALSE;
    END;

    wanted:=SIZE(peoptionalheader);
    got := FIO.RdBin(hin,peoptionalheader,wanted);
    IF got # wanted THEN RETURN rc; END;

IF DEBUG THEN WrStr(fmtval( 16,LONGCARD( peoptionalheader.Magic) ,"magic"));WrLn;END;

    CASE peoptionalheader.Magic OF
    | magic32 : chk64b := FALSE;
    | magic64 : chk64b := TRUE;
    ELSE
                chk64b := FALSE;
    END;

    seems64bits := (chk64a AND chk64b); (* better safe than sorry *)

    filealignment := peoptionalheader.FileAlignment;
    sectionalignment:=peoptionalheader.SectionAlignment;

    wanted:=SIZE(pedirindex);
    got := FIO.RdBin(hin,pedirindex,wanted);
    IF got # wanted THEN RETURN rc; END;

    importaddr:=pedirindex[IMPORTindex].strucaddr;

    i:=0;
    LOOP
        IF i >= sectioncount THEN EXIT; END; (* = is enough but... *)
        wanted:=SIZE(pesectionheader);
        got := FIO.RdBin(hin,pesectionheader,wanted);
        IF got # wanted THEN RETURN rc; END; (* file image problem ! abort ! *)

        (* kludge *)
        Str.Copy(sectionheadername, pesectionheader.Name);
        IF Str.Pos(sectionheadername,strUPX) = 0 THEN rc:=TRUE; EXIT; END; (* assume "UPX#" *)

        IF pesectionheader.VirtualAddress<=importaddr THEN
            IF importaddr < (pesectionheader.VirtualAddress+pesectionheader.SizeOfRawData) THEN
                EXIT;
            END;
        END;
        INC(i);
    END;
    RETURN rc; (* true only if one strUPX was found in section header name *)
END chkUPXwin32;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getIDfileType (VAR winheaderpos : LONGCARD ;
                        hin:FIO.File;DEBUG:BOOLEAN;zefile:pathtype):CARDINAL;
CONST
    sigMZ = ( ORD("M") + (ORD("Z") << 8) );
    sigZM = ( ORD("Z") + (ORD("M") << 8) );
    sigNE = ( ORD("N") + (ORD("E") << 8) );
    sigLE = ( ORD("L") + (ORD("E") << 8) );
    sigW3 = ( ORD("W") + (ORD("3") << 8) );
    sigW4 = ( ORD("W") + (ORD("4") << 8) );
    sigPE = ( ORD("P") + (ORD("E") << 8) );
CONST
    jpimagic1 = 0001H;
    jpimagic2 = 018AH;
    jpimagic3 = 1565H;
VAR
    tsmagic:ARRAY[1..3] OF CARDINAL;
    id,magic,addr:CARDINAL;
    R:str16;
    seems64bits:BOOLEAN;
BEGIN

    magic:=readWord(hin,000H);
    CASE magic OF
    | sigMZ,sigZM:
        addr:=readWord(hin,018H); (* //FIXHARD *)
        IF addr < 040H THEN       (* //FIXHARD *)
            readString (hin, 01CH, 4, R);                 (* //FIXHARD *)
            IF same(R,"LZ09") THEN RETURN idLZ090; END;
            IF same(R,"LZ91") THEN RETURN idLZ091; END;
            IF same(R,"diet") THEN RETURN idDIET;END;   (* assume lowercase signature *)
            readString(hin, 01EH, 6, R);                  (* //FIXHARD *)
            IF same(R,"PKLITE") THEN RETURN idPKLITE; END;
            readString(hin, 024H, 10, R); Str.Caps(R);    (* //FIXHARD *)
            IF same(R,"LHA'S SFX ") THEN RETURN idLHASFX; END;
            readString(hin, 055H,  3, R);                 (* //FIXHARD *)
            IF same(R,"UPX") THEN RETURN idUPXdos; END;

            id:=idNotPackedDOSexe; (* default *)

            tsmagic[1]:=readWord(hin, 01CH);               (* //FIXHARD *)
            tsmagic[2]:=readWord(hin, 01EH);               (* //FIXHARD *)
            tsmagic[3]:=readWord(hin, 020H);               (* //FIXHARD *)
            IF tsmagic[1] = jpimagic1 THEN
                IF tsmagic[2] = jpimagic2 THEN
                    IF tsmagic[3] = jpimagic3 THEN id:=idTScrunch; END;
                END;
            END;
        ELSE
            winheaderpos:=readDword(hin,03CH); (* //FIXHARD *)
            IF winheaderpos = 0 THEN (* unlikely *)
                id:=idNotPackedDOSexe;
            ELSE
                magic:=readWord(hin,winheaderpos);
                CASE magic OF
                | sigNE: id:=idNE; (* NE Windows or OS/2 1.x segmented ("new") executable *)
                | sigLE: id:=idLE; (* LE Windows virtual device driver (VxD) linear executable *)
                | sigW3: id:=idW3; (* W3 Windows WIN386.EXE file; a collection of LE files *)
                | sigW4: id:=idW4; (* W4 Windows95 VMM32.VXD file *)
                | sigPE:
                         IF chkUPXwin32(seems64bits, hin,winheaderpos,DEBUG) THEN
                             id:=idUPXwin32;
                         ELSE
                             IF seems64bits THEN
                                 id:=idPEplus;
                             ELSE
                                 id:=idPE; (* PE Win32 (Windows NT and Win32s) portable executable based on Unix COFF *)
                             END;
                         END;
                ELSE
                    (* a few DOS packers can have addr >= 40H, so we must test them here too *)
                    readString(hin, 01EH, 6, R);   (* //FIXHARD *)
                    IF same(R,"PKLITE") THEN RETURN idPKLITE; END;
                    (* check upx just in case *)
                    readString(hin, 055H,  3, R);  (* //FIXHARD *)
                    IF same(R,"UPX") THEN RETURN idUPXdos; END;
                    id:=idUnknownWinEXE; (* default *)
                    tsmagic[1]:=readWord(hin, 01CH);    (* //FIXHARD *)
                    tsmagic[2]:=readWord(hin, 01EH);    (* //FIXHARD *)
                    tsmagic[3]:=readWord(hin, 020H);    (* //FIXHARD *)
                    IF tsmagic[1] = jpimagic1 THEN
                        IF tsmagic[2] = jpimagic2 THEN
                            IF tsmagic[3] = jpimagic3 THEN id:=idTScrunch; END;
                        END;
                    END;
                END;
            END;
        END;
    ELSE
        id:=idNotEXE;

    END;

    IF id = idNotEXE THEN (* further check needed *)
        (* assume file extension is correct ! we could check first byte is a JMP too *)
        IF Str.Match(zefile,star+extCOM) THEN (* case-insensitive *)
            id:=idCOM;
        END;
    END;

    RETURN id;
END getIDfileType;

PROCEDURE getFileType (VAR winheaderpos : LONGCARD ;
                       DEBUG:BOOLEAN;zefile:pathtype):CARDINAL;
VAR
    hin:FIO.File;
    id:CARDINAL;
BEGIN
    hin:=FIO.OpenRead(zefile);
    FIO.AssignBuffer(hin,ioBufferIn);

    id:=getIDfileType (winheaderpos,  hin,DEBUG,zefile) ;

    FIO.Close(hin);
    RETURN id;
END getFileType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    aboutType = (isWORD,isDWORD,isMajMin);
    idType = (idCharacteristicsFlag,
              idProcessorAffinityMask,
              idMajorOperatingSystemVersion,
              idMajorSubsystemVersion,
              idMajorImageVersion,
              idWin32VersionValue);
CONST
    firstPEinfo = ORD(idCharacteristicsFlag);
    lastPEinfo  = ORD(idWin32VersionValue);

CONST
    idString = "characteristics flag,"+
               "processor affinity mask,"+
               "NT OS version,"+
               "Win32 subsystem version,"+
               "application image version,"+
               "Win32 version value";


TYPE PEinfoType = RECORD
     fpos              : LONGCARD;
     value             : valueType;
     isOptional        : BOOLEAN;
     isPresent         : BOOLEAN;    (* isDefined : affinity mask may NOT exist *)
     about             : aboutType;
     idstr             : str80; (* should do FOR name *)
END;

TYPE
    PEinfostruc = ARRAY[firstPEinfo..lastPEinfo] OF PEinfoType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
     MISSINGDIRENTRY       = CARD32(0);
     HIDDENAFFINITYPROBLEM = CARD32(0FFFFFFFFH);
     UNDEFINED             = MAX(CARD32);

PROCEDURE zeroPEinfos ( defined:BOOLEAN; VAR PEinfo : PEinfostruc );
VAR
    i:CARDINAL;
    S:str80;
BEGIN
    FOR i:=firstPEinfo TO lastPEinfo DO (* default safety *)
        PEinfo[i].fpos              := UNDEFINED;
        PEinfo[i].value.hilo        := UNDEFINED;
        IF i = ORD(idProcessorAffinityMask) THEN
            PEinfo[i].isOptional        := TRUE;
        ELSE
            PEinfo[i].isOptional        := FALSE;
        END;
        PEinfo[i].isPresent         := defined; (* may be FALSE FOR affinitymask *)
        CASE i OF
        | ORD(idCharacteristicsFlag) :
            PEinfo[i].about             := isWORD;
        | ORD(idProcessorAffinityMask), ORD(idWin32VersionValue):
            PEinfo[i].about             := isDWORD;
        ELSE
            PEinfo[i].about             := isMajMin;
        END;
        isoleItemS(S, idString,coma,i); (* 0.. *)
        PEinfo[i].idstr             :=S;
    END;
END zeroPEinfos;


PROCEDURE grabPEdata (VAR PEinfo:PEinfostruc ;
                      winheaderpos:CARD32;hin:FIO.File; DEBUG:BOOLEAN):BOOLEAN;
VAR
    i,got,wanted     : CARDINAL;
    sectioncount     : CARDINAL;
    pefileheader     : PEfileHeaderType;
    peoptionalheader : PEoptionalHeaderType; (* required "optional" : go figure ! *)
    pedirindex       : PEdataDirectoriesType;
    pesectionheader  : PEsectionHeaderType;
    peloadconfig     : PEloadConfig32type;
    posloadconfig,sizeloadconfig,importaddr,posheader : LONGCARD;
    rc,missing       : BOOLEAN;
BEGIN
    rc:=FALSE;

    FIO.Seek(hin,winheaderpos);

    wanted:=SIZE(pefileheader);
    got := FIO.RdBin(hin,pefileheader,wanted);
    IF got # wanted THEN RETURN rc; END;
    sectioncount:=pefileheader.NumberOfSections;
    IF sectioncount=0 THEN RETURN rc; END;

    posheader:=FIO.GetPos(hin);

    wanted:=SIZE(peoptionalheader);
    got := FIO.RdBin(hin,peoptionalheader,wanted);
    IF got # wanted THEN RETURN rc; END;

    wanted:=SIZE(pedirindex);
    got := FIO.RdBin(hin,pedirindex,wanted);
    IF got # wanted THEN RETURN rc; END;

    (* may be 0 i.e. undefined !!! *)
    importaddr    := pedirindex[IMPORTindex].strucaddr;
    posloadconfig := pedirindex[LOADCONFIGindex].strucaddr; (* seems optional ! *)
    sizeloadconfig:= pedirindex[LOADCONFIGindex].strucsize;

    i:=0;
    LOOP
        IF i >= sectioncount THEN EXIT; END; (* = is enough but... *)
        wanted:=SIZE(pesectionheader);
        got := FIO.RdBin(hin,pesectionheader,wanted);
        IF got # wanted THEN RETURN rc; END; (* file image problem ! abort ! *)
        IF pesectionheader.VirtualAddress<=importaddr THEN
            IF importaddr < (pesectionheader.VirtualAddress+pesectionheader.SizeOfRawData) THEN
                (* WrStr(".rdata ! TAKE ME !");WrLn; *)
                EXIT;
            END;
        END;
        INC(i);
    END;
    IF i >= sectioncount THEN RETURN rc; END; (* abort because problem ! *)

    (* both 0 means this entry does NOT exist *)
    missing := ( (posloadconfig = MISSINGDIRENTRY) AND (sizeloadconfig = MISSINGDIRENTRY) );
    IF missing THEN
        peloadconfig.ProcessAffinityMask := HIDDENAFFINITYPROBLEM;
    ELSE
        INC(posloadconfig,pesectionheader.PointerToRawData);
        DEC(posloadconfig,pesectionheader.VirtualAddress);
        FIO.Seek(hin,posloadconfig);
        wanted:=SIZE(peloadconfig);
        got := FIO.RdBin(hin,peloadconfig,wanted);
        IF got # wanted THEN RETURN rc;END;
    END;

    zeroPEinfos(TRUE, PEinfo);

    i:=firstPEinfo;
    PEinfo[i].fpos              := winheaderpos+ofsCharacteristicsFlag; (* //FIXME hardcoded *)
    PEinfo[i].value.lo          := pefileheader.CharacteristicsFlag;
    PEinfo[i].value.hi          := 0;

    INC(i);
    IF peloadconfig.ProcessAffinityMask = HIDDENAFFINITYPROBLEM THEN
        PEinfo[i].fpos              := UNDEFINED;
        PEinfo[i].value.hilo        := UNDEFINED;
        PEinfo[i].isPresent         := FALSE;
    ELSE
        PEinfo[i].fpos              := posloadconfig+ofsProcessorAffinityMask; (* //FIXME hardcoded *)
        PEinfo[i].value.hilo        := peloadconfig.ProcessAffinityMask;
        PEinfo[i].isPresent         := TRUE; (* useless *)
    END;

    INC(i);
    PEinfo[i].fpos              := posheader+ofsMajorOperatingSystemVersion; (* //FIXME hardcoded *)
    PEinfo[i].value.hi          := peoptionalheader.MajorOperatingSystemVersion;
    PEinfo[i].value.lo          := peoptionalheader.MinorOperatingSystemVersion;

    INC(i);
    PEinfo[i].fpos              := posheader+ofsMajorSubsystemVersion; (* //FIXME hardcoded *)
    PEinfo[i].value.hi          := peoptionalheader.MajorSubsystemVersion;
    PEinfo[i].value.lo          := peoptionalheader.MinorSubsystemVersion;

    INC(i);
    PEinfo[i].fpos              := posheader+ofsMajorImageVersion; (* //FIXME hardcoded *)
    PEinfo[i].value.hi          := peoptionalheader.MajorImageVersion;
    PEinfo[i].value.lo          := peoptionalheader.MinorImageVersion;

    INC(i);
    PEinfo[i].fpos              := posheader+ofsWin32VersionValue; (* //FIXME hardcoded *)
    PEinfo[i].value.hilo        := peoptionalheader.Win32VersionValue;

    RETURN TRUE; (* ok *)
END grabPEdata;

PROCEDURE grabPEinfos (VAR PEinfo : PEinfostruc;
                       winheaderpos : CARD32 ;
                       DEBUG:BOOLEAN;zefile:pathtype):BOOLEAN;
VAR
    hin:FIO.File;
    rc:BOOLEAN;
BEGIN
    hin:=FIO.OpenRead(zefile);
    FIO.AssignBuffer(hin,ioBufferIn);

    rc:=grabPEdata(PEinfo,  winheaderpos,hin,DEBUG) ;

    FIO.Close(hin);
    RETURN rc;
END grabPEinfos;

(* ------------------------------------------------------------ *)

PROCEDURE dmpPEinfos (SKIPLOG,altdisplay:BOOLEAN;PEinfo:PEinfostruc  );
CONST
    sPadWord            = "     "; (* "?? ??" *)
    sW                  = "@ : ~ "+sPadWord+" = $# (!)";
    sDW                 = "@ : ~ = $# (!)";
    sVer                = "@ : ~ ~ = # (!)";
    sCharacteristicsAlt = "@ : ~ "+sPadWord+" = $# (! - |)";
CONST
    sSepar   = ", ";
    lenSepar = 2;
CONST
    sMultipleCPUsOKalt      = "multiple CPUs OK";
    sSingleCPUrequiredAlt   = "single CPU required";
    sMultipleCPUsOK         = "Multiple CPUs are supported.";
    sSingleCPUrequired      = "A single CPU is required.";
    sUndefinedAffinityMask  = "Affinity mask is undefined.";
    sAnyCPU                 = "All core CPUs are supported.";
    sCPUlistSingular        = "Supported core CPU is ";
    sCPUlistPlural          = "Supported core CPUs are ";
VAR
    i,count,lo,hi:CARDINAL;
    mask,fpos,hilo:LONGCARD;
    about:aboutType;
    undefinedAffinityMask,isPresent,isOptional:BOOLEAN;
    S:str128;
    Z,idstr:str80;
    processorAffinityMask : LONGCARD;
    characteristicsFlag   : CARDINAL;
BEGIN
    FOR i:= firstPEinfo TO lastPEinfo DO
        fpos              := PEinfo[i].fpos;
        hi                := PEinfo[i].value.hi;
        lo                := PEinfo[i].value.lo;
        hilo              := PEinfo[i].value.hilo;
        about             := PEinfo[i].about;
        idstr             := PEinfo[i].idstr;
        isPresent         := PEinfo[i].isPresent;
        isOptional        := PEinfo[i].isOptional;

        CASE i OF
        | ORD(idCharacteristicsFlag)   :
            characteristicsFlag  :=lo;
        | ORD(idProcessorAffinityMask) :
            processorAffinityMask:=hilo;
            undefinedAffinityMask:=NOT(isPresent);
            IF undefinedAffinityMask THEN
                S:=sDW;
                Str.Subst(S,"@","????????");
                Str.Subst(S,"~","?? ?? ?? ??");
                Str.Subst(S,"#","????????");
                Str.Subst(S,"!","undefined !"); (* trick *)
                Str.Subst(S,"!",idstr);
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;

        IF isPresent THEN
            CASE about OF
            | isWORD:
                S:=sW;
                Str.Subst(S,"@",fmtbignum(fpos,16,8,"0"));
                Str.Subst(S,"~",fmtnummem(lo));
                Str.Subst(S,"#",fmtnum(lo,16,4,"0"));
            | isDWORD:
                S:=sDW;
                Str.Subst(S,"@",fmtbignum(fpos,16,8,"0"));
                Str.Subst(S,"~",fmtbignummem(hilo));
                Str.Subst(S,"#",fmtbignum(hilo,16,8,"0"));
            | isMajMin:
                S:=sVer;
                Str.Subst(S,"@",fmtbignum(fpos,16,8,"0"));
                Str.Subst(S,"~",fmtnummem(hi)); (* reversed here : major first *)
                Str.Subst(S,"~",fmtnummem(lo));
                Str.Subst(S,"#",fmtver(hi,lo));
            ELSE ; (* //ISO fixed silly requirement *) END;
            Str.Subst(S,"!",idstr);

            IF altdisplay THEN
                IF i = ORD(idCharacteristicsFlag) THEN
                    S:=sCharacteristicsAlt;
                    Str.Subst(S,"@",fmtbignum(fpos,16,8,"0"));
                    Str.Subst(S,"~",fmtnummem(lo));
                    Str.Subst(S,"#",fmtnum(lo,16,4,"0"));
                    Str.Subst(S,"!",idstr);
                    IF ( characteristicsFlag AND bit14on ) = bit14on THEN
                        Str.Subst(S,"|",sSingleCPUrequiredAlt);
                    ELSE
                        Str.Subst(S,"|",sMultipleCPUsOKalt);
                    END;
                END;
            END;
        END;
        rptwr(SKIPLOG,LOGFILE,sINFOVER,S);
    END;

    IF altdisplay THEN RETURN; END;

    (* about characteristics bit 14 *)

    IF (characteristicsFlag AND bit14on) = bit14on THEN
        Z:=sNOTABENE; S:=sSingleCPUrequired;
    ELSE
        Z:=sGOODNEWS; S:=sMultipleCPUsOK;
    END;
    rptwr(SKIPLOG,LOGFILE, Z,S);


    (* about core CPUs *)

    IF undefinedAffinityMask THEN
        Z:=sBADNEWS; S:=sUndefinedAffinityMask;
    ELSE
        IF processorAffinityMask = anyCPU THEN
            Z:=sGOODNEWS; S:=sAnyCPU;
        ELSE
            count:=0;
            mask:=01H;
            FOR i:=0 TO 15 DO
                IF (processorAffinityMask AND mask)=mask THEN INC(count);END;
                mask:=(mask << 1);
            END;
            CASE count OF
            | 0 : Z:=sGOODNEWS; S:=sAnyCPU;
            | 1 : Z:=sNOTABENE; S:=sCPUlistSingular;
            ELSE
                  Z:=sNOTABENE; S:=sCPUlistPlural;
            END;
            mask:=01H;
            FOR i:=0 TO 15 DO
                IF (processorAffinityMask AND mask)=mask THEN
                    Str.Append(S,fmtnum(i,10,1,""));Str.Append(S,sSepar);
                END;
                mask:=(mask << 1);
            END;
            IF count # 0 THEN
                i:=Str.Length(sSepar);
                Str.Delete(S,Str.Length(S)-i,i);
                Str.Append(S,dot);
                i:=Str.RCharPos(S,coma);
                IF i # MAX(CARDINAL) THEN
                    Str.Delete(S,i,1);
                    Str.Insert(S," and",i);
                END;
            END;
        END;
    END;
    rptwr(SKIPLOG,LOGFILE,Z,S);
END dmpPEinfos;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    flagVALUE = CARD16(0);
    flagOR    = CARD16( MAX(CARD16) );
    flagAND   = CARD16( MAX(CARD16)-1 );

PROCEDURE createPatch (VAR newPEinfo:PEinfostruc;
                      refPEinfo:PEinfostruc  ):BOOLEAN;
VAR
    i:CARDINAL;
    v:CARD16;
BEGIN
    i:=ORD(idProcessorAffinityMask);
    IF newPEinfo[i].isPresent THEN
        IF NOT(refPEinfo[i].isPresent) THEN RETURN FALSE;END;
    END;

    FOR i:=firstPEinfo TO lastPEinfo DO
        IF newPEinfo[i].isPresent THEN (* modified *)
            CASE i OF (* could use .about too *)
            | ORD(idCharacteristicsFlag) :
                CASE CARDINAL(newPEinfo[i].value.hi) OF
                | flagVALUE : v:= newPEinfo[i].value.lo;
                | flagOR    : v:= (refPEinfo[i].value.lo OR bit14on );
                | flagAND   : v:= (refPEinfo[i].value.lo AND bit14off);
                ELSE ; (* //ISO fixed silly requirement *) END;
                refPEinfo[i].value.lo := v;
            | ORD(idProcessorAffinityMask), ORD(idWin32VersionValue):
                refPEinfo[i].value.hilo:=newPEinfo[i].value.hilo;
            ELSE
                refPEinfo[i].value.hi:=newPEinfo[i].value.hi;
                refPEinfo[i].value.lo:=newPEinfo[i].value.lo;
            END;
        END;
    END;
    (* we could also check for no change i.e. useless patch but well, who cares ? *)
    newPEinfo := refPEinfo;
    RETURN TRUE;
END createPatch;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume F is rw *)

PROCEDURE doPatch (updateStamp:BOOLEAN;F:pathtype;PEinfo:PEinfostruc );
VAR
    i : CARDINAL;
    hnd:FIO.File;
    hilo:CARD32;
    lo,hi,count:CARD16;
    b : byteArrayType;
BEGIN
    hnd:=FIO.Open(F);
    FIO.AssignBuffer(hnd,ioBufferIn);

    FOR i:=firstPEinfo TO lastPEinfo DO
        IF PEinfo[i].isPresent THEN (* should do for optional affinity flag *)
            CASE i OF
            | ORD(idCharacteristicsFlag) :
                lo:=PEinfo[i].value.lo;
                count:=SIZE(lo);
                Lib.Move(SYSTEM.ADR(lo),SYSTEM.ADR(b),count);
            | ORD(idWin32VersionValue) :
                hilo:=PEinfo[i].value.hilo;
                count:=SIZE(hilo);
                Lib.Move(SYSTEM.ADR(hilo),SYSTEM.ADR(b),count);
            | ORD(idProcessorAffinityMask) :
                hilo:=PEinfo[i].value.hilo;
                count:=SIZE(hilo);
                Lib.Move(SYSTEM.ADR(hilo),SYSTEM.ADR(b),count);
            ELSE
                hi:=PEinfo[i].value.hi; (* major first *)
                count:=SIZE(hi);
                Lib.Move(SYSTEM.ADR(hi),SYSTEM.ADR(b),count);
                lo:=PEinfo[i].value.lo;
                count:=SIZE(lo);
                Lib.Move(SYSTEM.ADR(lo),SYSTEM.ADR(b[SIZE(lo)]),count);
                count:=SIZE(hi)+SIZE(lo);
            END;
            FIO.Seek(hnd,PEinfo[i].fpos);
            FIO.WrBin(hnd,b,count);
        END;
    END;
    FIO.Close(hnd);
END doPatch;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE viewMatches (VAR errcode:CARDINAL; VAR PEinfo : PEinfostruc;
                      addNL,SKIPLOG,altdisplay,DEBUG:BOOLEAN;
                      lastfile:CARDINAL;anchor:ptrToEntry):BOOLEAN;
CONST
    sPEheader = "Missing or unsupported PE headers.";
VAR
    zefile:pathtype;
    flagAbort:BOOLEAN;
    i:CARDINAL;
    winheaderpos:CARD32;
    R:str128;
    id:CARDINAL;
BEGIN
    errcode:=errNone;
    flagAbort:=FALSE;
    i:=firstEntry-1;
    LOOP
        INC(i);
        IF i > lastfile THEN EXIT; END;
        getMatchEntry(zefile, i,anchor);


        id:=getFileType (winheaderpos,  DEBUG,zefile) ; (* must be done first *)
        getdesc(id,R);

        rptwr(SKIPLOG, LOGFILE,sOK,enquote(zefile));
        rptwr(SKIPLOG, LOGFILE,sINFO,R);
        CASE id OF
        | idPE,idUPXwin32 :
            IF grabPEinfos(PEinfo, winheaderpos,DEBUG,zefile) THEN
                dmpPEinfos(SKIPLOG,altdisplay, PEinfo);   (* show values current state *)
            ELSE
                IF NOT(altdisplay) THEN
                    rptwr(SKIPLOG, LOGFILE,sERR,sPEheader);
                END;
                errcode:=errBadPEinfos;
                (* abort(errBadPEinfos,""); *)
            END;
        ELSE
            IF NOT(altdisplay) THEN
                rptwr(SKIPLOG, LOGFILE,sERR,"This file does not look like a supported PE 32-bits executable.");
            END;
            errcode:=errUnsupported;
            (* abort(errUnsupported,""); *)
        END;


        IF addNL THEN
            IF i # lastfile THEN WrLn; END;
        END;

        flagAbort:=ChkEscape();
        IF flagAbort THEN EXIT; END;
    END;
    RETURN flagAbort;
END viewMatches;

PROCEDURE paranoDump (SKIPLOG,altdisplay:BOOLEAN;F:pathtype);
VAR
    id:CARDINAL;
    winheaderpos : LONGCARD;
    ok:BOOLEAN;
    PEinfo:PEinfostruc;
BEGIN
    id:=getFileType (winheaderpos,  FALSE,F) ; (* must be done first *)
    ok:= grabPEinfos(PEinfo, winheaderpos,FALSE,F);
    dmpPEinfos(SKIPLOG,altdisplay, PEinfo);
END paranoDump;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (cmdnone,cmdview,cmdpatch);

PROCEDURE newcmd (VAR cmd:cmdtype; wanted:cmdtype  ):BOOLEAN ;
VAR
    rc:BOOLEAN;
BEGIN
    rc:=TRUE;
    IF    cmd = cmdnone THEN
        cmd:=wanted;
    ELSIF cmd = wanted  THEN
        cmd:=wanted; (* useless, eh ! *)
    ELSE
        rc:=FALSE;
    END;
    RETURN rc;
END newcmd;

(* #.# *)

PROCEDURE getmajmin(VAR major,minor:CARDINAL; R:ARRAY OF CHAR):BOOLEAN ;
VAR
    S:str128;
    Z:str16;
    p:CARDINAL;
    v:LONGCARD;
    ok:BOOLEAN;
BEGIN
    GetString(R,S);
    p:=Str.CharPos(S,dot);
    IF p = MAX(CARDINAL) THEN
        Str.Append(S,dot+"0");
        p:=Str.CharPos(S,dot);
    END;
    Str.Slice(Z,S,0,p);
    v:=Str.StrToCard(Z,10,ok);
    IF NOT(ok) THEN RETURN FALSE;END;
    IF v > MAX(CARDINAL) THEN RETURN FALSE;END;
    major:=CARDINAL(v);

    Str.Delete(S,0,p+1);
    v:=Str.StrToCard(S,10,ok);
    IF NOT(ok) THEN RETURN FALSE;END;
    IF v > MAX(CARDINAL) THEN RETURN FALSE;END;
    minor:=CARDINAL(v);
    RETURN TRUE;
END getmajmin;

PROCEDURE newmajmin (VAR PEinfo:PEinfostruc;
                    major,minor,i:CARDINAL):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    IF PEinfo[i].isPresent THEN
        rc:=FALSE;
    ELSE
        PEinfo[i].isPresent := TRUE;
        PEinfo[i].value.lo  := minor;
        PEinfo[i].value.hi  := major;
        rc:=TRUE;
    END;
    RETURN rc;
END newmajmin;

(* #, $#, 0x#, [H]#[H], [B]#[B] *)

PROCEDURE str2lc (VAR lc:LONGCARD;S:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    base:CARDINAL;
BEGIN
    IF Str.Match(S,"$*") THEN
        base:=16;  Str.Delete(S,0,1);
    ELSIF Str.Match(S,"0X*") THEN (* FOR our C f(r)iends... *)
        base:=16;  Str.Delete(S,0,2);
    ELSIF Str.Match(S,"H*") THEN
        base:=16;  Str.Delete(S,0,1);
    ELSIF Str.Match(S,"B*") THEN
        base:=2;   Str.Delete(S,0,1);
    ELSIF Str.Match(S,"*H") THEN
        base:=16;  Str.Delete(S, Str.Length(S)-1,1); (* or brutal charnull *)
    ELSIF Str.Match(S,"*B") THEN
        base:=2;   Str.Delete(S, Str.Length(S)-1,1);
    ELSE
        base:=10;
    END;
    lc:=Str.StrToCard(S,base,ok);
    RETURN ok;
END str2lc;

PROCEDURE getcard (VAR n:CARDINAL;R:ARRAY OF CHAR):BOOLEAN;
VAR
    S:str128;
    lc:LONGCARD;
BEGIN
    GetString(R, S);
    IF str2lc(lc,S)=FALSE THEN RETURN FALSE;END;
    IF lc > MAX(CARDINAL) THEN RETURN FALSE;END;
    n:=CARDINAL(lc);
    RETURN TRUE;
END getcard;

PROCEDURE newcard (VAR PEinfo:PEinfostruc;
                   n,flag:CARD16;i:CARDINAL):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    IF PEinfo[i].isPresent THEN
        rc:=FALSE;
    ELSE
        PEinfo[i].isPresent := TRUE;
        PEinfo[i].value.hi  := flag;
        PEinfo[i].value.lo  := n;
        rc:=TRUE;
    END;
    RETURN rc;
END newcard;

PROCEDURE getlongcard (VAR n:LONGCARD;R:ARRAY OF CHAR):BOOLEAN;
VAR
    S:str128;
BEGIN
    GetString(R, S);
    RETURN str2lc(n,S);
END getlongcard;

PROCEDURE newlongcard (VAR PEinfo:PEinfostruc;
                      n : CARD32; i:CARDINAL):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    IF PEinfo[i].isPresent THEN
        rc:=FALSE;
    ELSE
        PEinfo[i].isPresent := TRUE;
        PEinfo[i].value.hilo:= n;
        rc:=TRUE;
    END;
    RETURN rc;
END newlongcard;

PROCEDURE getmask (VAR lc:LONGCARD; R:ARRAY OF CHAR  ):BOOLEAN;
CONST
    minCPU = 0;
    maxCPU = 31; (* //V09A increased after seeing a Win10 capture about affinity setting *)
VAR
    S:str128;
    Z:str16;
    i,j,pb:CARDINAL;
    cpu,bitmask:LONGCARD;
BEGIN
    GetString(R, S);
    IF same(S,"*") THEN
        lc:=anyCPU;
        RETURN TRUE;
    END;
    ReplaceChar(S,dot,coma);
    Str.Append(S,coma); (* trick *)
    lc:=0;
    pb:=0;
    FOR i := 1 TO CharCount(S,coma) DO
         isoleItemS(Z,  S,coma,i-1);
         IF str2lc(cpu,Z) THEN
             IF cpu > maxCPU THEN
                 INC(pb);
             ELSE
                 bitmask := 01H;
                 FOR j:=1 TO CARDINAL(cpu) DO bitmask := (bitmask << 1); END;
                 lc:=(lc OR bitmask);
             END;
         ELSE
             INC(pb);
         END;
    END;
    RETURN (pb=0);
END getmask;

PROCEDURE newmask (VAR PEinfo:PEinfostruc;
                  n : CARD32; i:CARDINAL) : BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    IF PEinfo[i].isPresent THEN
        rc:=FALSE;
    ELSE
        PEinfo[i].isPresent := TRUE;
        PEinfo[i].value.hilo:= n;
        rc:=TRUE;
    END;
    RETURN rc;
END newmask;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    sNoAffinityMask = "Missing affinity mask cannot be changed.";
    sReadOnly       = "Read-Only file cannot be patched.";
    sUpdated        = "File has been updated.";
    sVerified	    = "File has been verified.";
CONST
    firstparm = 1;
    maxparm   = 1;
VAR
    ndx,major,minor,charac,errcode,lastfile,parmcount,i,opt,lastparm:CARDINAL;
    S,R,zefile:pathtype;
    alcatraz,addNL,DEBUG:BOOLEAN;
    parm:ARRAY [firstparm..maxparm] OF pathtype;
    cmd:cmdtype;
    anchor:ptrToEntry;
    altdisplay,SKIPLOG,NEWLOG,updateStamp:BOOLEAN;
    lc:LONGCARD;
    ok:BOOLEAN;
    orgstamp:dttype;
VAR
    refPEinfo , newPEinfo : PEinfostruc;
BEGIN
    FIO.IOcheck := FALSE; (* don't let topspeed handle problems *)

    WrLn;   (* beautify display *)

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    lastparm    := firstparm-1;
    cmd         := cmdnone;
    addNL       := TRUE;

    SKIPLOG     := FALSE;
    NEWLOG      := FALSE;
    updateStamp := FALSE;
    altdisplay  := FALSE;

    zeroPEinfos (FALSE, newPEinfo); (* SET all data TO NOT present *)

    DEBUG       := FALSE;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "x"+delim+"lfn"+delim+
                                  "V"+delim+"VIEW"+delim+
                                  "N"+delim+"NL"+delim+
                                  "DEBUG"+delim+

                                  "r"+delim+"readonly"+delim+
                                  "L"+delim+"LOG"+delim+
                                  "C"+delim+"CREATE"+delim+
                                  "D"+delim+"DATETIME"+delim+
                                  "A"+delim+"ALTERNATE"+delim+

                                  "N:"+delim+"O:"+delim+"NT:"+delim+"OS:"+delim+
                                  "W:"+delim+"S:"+delim+"WIN:"+delim+"SUB:"+delim+
                                  "A:"+delim+"I:"+delim+"APP:"+delim+"IMG:"+delim+

                                  "C:"+delim+"CHARACTERISTICS:"+delim+
                                  "M"+delim+"MULTIPLE"+delim+"BIT14OFF"+delim+
                                            "MULTI"+delim+
                                  "S"+delim+"SINGLE"+delim+"BIT14ON"+delim+

                                  "V:"+delim+"VERSION:"+delim+

                                  "P:"+delim+"CPU:"+delim+"PROCESSOR:"+delim+
                                  "M:"+delim+"MASK:"+delim+"AFFINITY:"


                              );
            CASE opt OF
            | 1,2,3 :    abort(errHelp,"");
            | 4,5:       ;
            | 6,7:       IF newcmd(cmd,cmdview)=FALSE THEN abort(errCmd,S);END;
            | 8,9:       addNL        := FALSE;
            | 10:        DEBUG        := TRUE;

            | 11,12:     ;
            | 13,14:     SKIPLOG      := TRUE;
            | 15,16:     NEWLOG       := TRUE;
            | 17,18:     updateStamp  := TRUE;
            | 19,20:     altdisplay   := TRUE;

            |21,22,23,24:IF getmajmin(major,minor, R)=FALSE THEN abort(errMajMin,S); END;
                         ndx:=ORD(idMajorOperatingSystemVersion);
                         IF newmajmin(newPEinfo,  major,minor,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;
            |25,26,27,28:IF getmajmin(major,minor, R)=FALSE THEN abort(errMajMin,S); END;
                         ndx:=ORD(idMajorSubsystemVersion);
                         IF newmajmin(newPEinfo,  major,minor,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;
            |29,30,31,32:IF getmajmin(major,minor, R)=FALSE THEN abort(errMajMin,S); END;
                         ndx:=ORD(idMajorImageVersion);
                         IF newmajmin(newPEinfo,  major,minor,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;

            |33,34:      IF getcard(charac, R)=FALSE THEN abort(errCardVal,S);END;
                         ndx:=ORD(idCharacteristicsFlag);
                         IF newcard(newPEinfo, charac,flagVALUE,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;
            |35,36,37,38:ndx:=ORD(idCharacteristicsFlag);
                         IF newcard(newPEinfo, bit14off,flagAND,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;
            |39,40,41:   ndx:=ORD(idCharacteristicsFlag);
                         IF newcard(newPEinfo, bit14on,flagOR,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;

            |42,43:      IF getlongcard(lc, R)=FALSE THEN abort(errCardVal,S);END;
                         ndx:=ORD(idWin32VersionValue);
                         IF newlongcard(newPEinfo, lc,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;

            |44,45,46:   IF getmask(lc, R)=FALSE THEN abort(errMask,S);END;
                         ndx:=ORD(idProcessorAffinityMask);
                         IF newmask(newPEinfo, lc,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;
            |47,48,49:   IF getlongcard(lc, R)=FALSE THEN abort(errCardVal,S);END;
                         ndx:=ORD(idProcessorAffinityMask);
                         IF newlongcard(newPEinfo, lc,ndx)=FALSE THEN
                             abort(errRedefined,S);
                         END;
                         IF newcmd(cmd,cmdpatch)=FALSE THEN abort(errCmd,S);END;

            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;
    IF lastparm < firstparm THEN abort(errMissingSpec,"");END;

    IF cmd = cmdnone THEN cmd:=cmdview;END;

    Str.Copy(zefile,parm[firstparm]);
    CASE cmd OF
    | cmdview:
        IF same(zefile,dot) THEN Str.Copy(zefile,stardotstar);END;
        IF chkJokerPath(zefile) THEN abort(errJokerPath,zefile);END;
    ELSE
        IF chkJoker(zefile) THEN abort(errJoker,zefile);END;
        IF isDirectory(zefile) THEN abort(errNotFile,zefile);END;
        IF FIO.Exists(zefile)=FALSE THEN abort(errNotFound,zefile);END;

        IF foundFixFile(extCD) THEN SKIPLOG:=TRUE;END; (* .cd found hence force -l *)
        initRptLog(SKIPLOG,NEWLOG,LOGFILE);
    END;

    lastfile:=buildMatchList (anchor, zefile);
    CASE lastfile OF
    | firstEntry-1:
        abort(errNotFound,zefile);
    | TOOMANY:
        abort(errTooMany,zefile);
    ELSE
        IF NOT(SKIPLOG) THEN
            SKIPLOG := ( cmd = cmdview ); (* log only if patching ONE file *)
        END;
        alcatraz:=viewMatches (errcode,refPEinfo,
                              addNL,SKIPLOG,altdisplay,DEBUG,
                              lastfile,anchor);
        getMatchEntry(zefile, firstEntry,anchor); (* here for later patch use *)
        freeMatchList(anchor);
        IF alcatraz THEN abort(errEscape,"");END;
        IF cmd = cmdview THEN abort(errNone,"");END;
    END;

    (* patch : first, let's check that yes, we can do it *)

    CASE errcode OF
    | errBadPEinfos:  abort(errBadPEinfos,"");
    | errUnsupported: abort(errUnsupported,"");
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF fileIsRO(zefile) THEN
            rptwr(SKIPLOG, LOGFILE,sERR,sReadOnly);
            abort(errROtarget,"");
    END;

    ok:=getfilestamp(orgstamp, zefile);

    IF createPatch(newPEinfo, refPEinfo) THEN
        rptwr(SKIPLOG, LOGFILE,"","");

        doPatch(updateStamp,zefile,newPEinfo);
        IF NOT(updateStamp) THEN ok:=setFileStamp(orgstamp,zefile);END;

        dmpPEinfos(SKIPLOG,altdisplay, newPEinfo); (* we could reread data too *)
        rptwr(SKIPLOG, LOGFILE,"","");
        rptwr(SKIPLOG, LOGFILE,sINFO,sUpdated);
        rptwr(SKIPLOG, LOGFILE,"","");
        IF DEBUG THEN
	    paranoDump(SKIPLOG,altdisplay,zefile);
            rptwr(SKIPLOG, LOGFILE,"","");
            rptwr(SKIPLOG, LOGFILE,sINFO,sVerified);
            rptwr(SKIPLOG, LOGFILE,"","");
	END;

        i:=errNone;
        S:="";
    ELSE
        rptwr(SKIPLOG, LOGFILE,sERR,sNoAffinityMask);

        i:=errNoWeCant;
        Str.Copy(S,zefile);
    END;

    flushRptLog(SKIPLOG,LOGFILE);

    abort(i,S);
END fixPE32.





