(* ---------------------------------------------------------------
Title         Q&D free space on hard disk(s)
Author        PhG
Overview
Notes         minimal error messages and checking, etc.
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          even with HUGECARDs, formula does not work with > 4 Gb disks !
              we don't care about CD-ROM and removeable units

	      won't give valid results from Win98
	      we could waste time trying to use Win32 extended functions but why ?
	      DOS version is ok from Win98, this one is ok from WinXP...
	      and we don't care about so-called "better" ulterior vindoze versions ;-)
              anyway, it's really time wasted for nothing

Wish List

              Mb and Gb would benefit from 3 digits after comma

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 17 Mar 16 an ugly really Q&D port from HDFREE v1.0l for DOS
--------------------------------------------------------------- *)

MODULE HDfree32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;

IMPORT WinBase;
(* IMPORT WinNT; *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    HUGECARD = LONGREAL;
CONST
    HUGEZERO = LONGREAL(0.0);
    HUGEONE  = LONGREAL(1.0);
CONST
    CONSOLE = FALSE; (* if FALSE, do not use QD_Text library *)


PROCEDURE vidinit ( useBios:BOOLEAN );
BEGIN
END vidinit;

PROCEDURE print (S : ARRAY OF CHAR  );
BEGIN
    IO.WrStr(S);
END print;

PROCEDURE newline (  );
BEGIN
    IO.WrLn;
END newline;

PROCEDURE colorheader ();
BEGIN
END colorheader;

PROCEDURE colorhelp ();
BEGIN
END colorhelp;

PROCEDURE colortext ();
BEGIN
END colortext;

PROCEDURE colorwarning ();
BEGIN
END colorwarning;



(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "HDFREE32";
    ProgTitle     = "Q&D free space on hard disk(s) (Win32)";
    ProgVersion   = "v0.9 (from v1.0l for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    extEXE        = ".EXE";
    extINI        = ".INI";
    chUsed        = CHR(176);  chUsedTxt = "+";
    chFree        = CHR(219);  chFreeTxt = "-";
    sigma         = CHR(228);
    graphdash     = CHR(196);
    graphbar      = CHR(205);
    msgWarning    = "Remember results include lost clusters and DELWATCHed files !";
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errBadUnitSpec      = 3;
    errTooManyUnits     = 4;
    errAlreadySpecified = 5;
    errNotFound         = 6;
    errNoUnitSpecified  = 7;
    errPoorDOSsupportHere=8;
    errOSversion	= 9;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msgHelp =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <u[u]...>:... [option]..."+nl+
nl+
"This program shows free space left on specified hard disk(s)."+nl+
nl+
"-q    quiet mode (no percentage bar graph)"+nl+
"-s    do not show sum of all disks"+nl+
"-a[a] do not use graphics separator lines (-aa = -a -t)"+nl+
"-t    do not use graphics characters in bar graph"+nl+
"-u    show used space instead of free space"+nl+
"-k[k] show rounded kilobytes (-kk = -rk = mathematical kilobytes)"+nl+
"-m[m] show rounded megabytes (-mm = -rm = mathematical megabytes)"+nl+
"-g[g] show rounded gigabytes (-gg = -rg = mathematical gigabytes)"+nl+
"-e    english group and decimal separators (default is french separators)"+nl+
nl+
"a) If program is run without any parameter, command line will be read from"+nl+
"   "+ProgEXEname+extINI+", if such a file exists in "+ProgEXEname+extEXE+" directory."+nl+
"b) Warning : results may not be significant for CD-ROM and network drives."+nl+
"c) Win95 and Win98 are not supported."+nl+
"d) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;


VAR
    S : str1024;
BEGIN
    colorhelp;
    CASE e OF
    | errHelp :
        newline;
        print(msgHelp);
    | errOption :
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errBadUnitSpec:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," unit specification !");
    | errTooManyUnits:
        Str.Concat(S,"Overflow with ",einfo);Str.Append(S," unit specification !");
    | errAlreadySpecified:
        Str.Concat(S,"Duplicate ",einfo);Str.Append(S," unit specification !");
    | errNotFound:
        Str.Concat(S,"File ",einfo);Str.Append(S," does not exist !");
    | errNoUnitSpecified:
        S := "No unit specified !";
    | errPoorDOSsupportHere:
        S := "required DOS functions are no longer supported with WinXP ! :-(";
    | errOSversion:
        S := 'This program DOES require WinXP !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        newline;
        print(ProgEXEname+" : "); print(S);
        newline;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

PROCEDURE dbg(DEBUG:BOOLEAN;S1,S2:ARRAY OF CHAR);
CONST
    wi = 20;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrStr(S1);
    	FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
	WrStr(S2);WrLn;
    END;
END dbg;
(* ------------------------------------------------------------ *)

PROCEDURE str (v:LONGCARD;wi:CARDINAL   ) : str16;
VAR
    S:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr( v,S,10,ok);
    WHILE Str.Length(S) < wi DO
        Str.Prepend(S," ");
    END;
    RETURN S;
END str;

(* ------------------------------------------------------------ *)

(* u should be UPPERCASE but we handle it anyway *)

PROCEDURE getUnitFreeTotal (DEBUG:BOOLEAN; u:CHAR;
                           VAR freebytes,totalbytes:HUGECARD):BOOLEAN;
CONST
    wiinfo = 9; (* was 5 for P233 2Gb drive, but with P4 15Gb... *)
VAR
    sectorsPerCluster, freeClusters, bytesPerSector, totalClusters,v : LONGCARD; (* DWORD *)
    ok:BOOLEAN;
    ustr : str16;
    (*
    winFreeBytesAvailableToCaller,winTotalNumberOfBytes,winTotalNumberOfFreeBytes:WinNT.ULARGE_INTEGER;
    *)
BEGIN
    u:=CAP(u);
    Str.Concat(ustr,u,colon+antislash);

    freebytes  :=HUGEZERO;
    totalbytes :=HUGEZERO; (* should NEVER happen ! *)

    ok:=WinBase.GetDiskFreeSpace (ustr,
    				 sectorsPerCluster,bytesPerSector,
				 freeClusters,totalClusters);

    freebytes  := HUGECARD(sectorsPerCluster) * HUGECARD(bytesPerSector);
    totalbytes := HUGECARD(sectorsPerCluster) * HUGECARD(bytesPerSector);
    freebytes  := freebytes  * HUGECARD(freeClusters);
    totalbytes := totalbytes * HUGECARD(totalClusters);

    (*
    nice try, hot shot !
    ok:=WinBase.GetDiskFreeSpaceEx (ustr,
                           winFreeBytesAvailableToCaller,winTotalNumberOfBytes,winTotalNumberOfFreeBytes);
    freebytes:=HUGECARD(winTotalNumberOfFreeBytes);
    totalbytes:= HUGECARD(winTotalNumberOfBytes);
    *)

    RETURN ok;
END getUnitFreeTotal;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getsepgroup (fr:BOOLEAN ):CHAR;
BEGIN
    IF fr THEN RETURN dot; END;
    RETURN comma;
END getsepgroup;

PROCEDURE getsepdec (fr:BOOLEAN ):CHAR;
BEGIN
    IF fr THEN RETURN comma; END;
    RETURN dot;
END getsepdec;

(* ------------------------------------------------------------ *)

PROCEDURE fmtstring (S:ARRAY OF CHAR; pad:CHAR; n:INTEGER ) : str80;
VAR
    R : str80;
BEGIN
    Str.Copy(R,S);
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(n) THEN EXIT; END;
        IF n < 0 THEN
            Str.Append(R,pad); (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtstring;

PROCEDURE fmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtlc;

PROCEDURE fmtpercent (v:LONGREAL;pad:CHAR;sep:CHAR;field:INTEGER;digits:CARDINAL):str80;
VAR
    R : str80;
    ok: BOOLEAN;
BEGIN
    Str.FixRealToStr(v,digits,R,ok);
    Str.Subst(R,dot,sep);
    RETURN fmtstring(R,pad,field);
END fmtpercent;

PROCEDURE fmtbar (percentused:LONGREAL;used,free:CHAR;field:CARDINAL):str80;
VAR
    R : str80;
    p,i : CARDINAL;
BEGIN
    percentused := (percentused / 100.0 ) * LONGREAL(field);
    p := CARDINAL(percentused + 0.5 ); (* round ! *)
    R := "";
    FOR i := 1 TO field DO
        IF i <= p THEN
           Str.Append(R,used);
        ELSE
           Str.Append(R,free);
        END;
    END;
    RETURN R;
END fmtbar;

PROCEDURE HUGEINC (VAR r:HUGECARD;n:HUGECARD );
BEGIN
    r := r + n;
END HUGEINC;

PROCEDURE fmthc (v : HUGECARD; pad:CHAR; sepgroup:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.FixRealToStr( LONGREAL(v), 0 ,S,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sepgroup);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmthc;

PROCEDURE fmthcdec (v : HUGECARD; pad:CHAR; sepgroup:CHAR; field:INTEGER; zedigits:CARDINAL) : str80;
VAR
    S,R   : str80;
    len,i,p,zelen,wi : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
    isfr:BOOLEAN;
    sepdec : CHAR;
    Z:str16;
BEGIN
    Str.FixRealToStr( LONGREAL(v), zedigits ,S,ok);
    len:=Str.Length(S);
    R := "";
    wi:=CARDINAL ( ABS(field) );

    p:=Str.CharPos(S,dot);
    IF p # MAX(CARDINAL ) THEN
        zelen := p;
        DEC(wi, 1+zedigits ); (* sepdec and digits after *)
    ELSE
        zelen := len;
    END;

    FOR i := 1 TO zelen DO
        Str.Prepend(R,S[zelen-i]);
        IF i < zelen THEN               (* len instead of zelen ! silly typo ! *)
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sepgroup);
            END;
        END;
    END;
    LOOP
        IF Str.Length(R) >= wi THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    IF p # MAX(CARDINAL) THEN
        isfr := (sepgroup = getsepgroup(TRUE) );
        sepdec:=getsepdec(isfr);
        Str.Append(R,sepdec);
        Str.Slice( Z, S,p+1,len-p);
        Str.Append(R,Z);
    END;
    RETURN R;
END fmthcdec;

CONST
    kKB       = HUGECARD (1024);
    kMB       = HUGECARD (kKB * kKB);
    kGB       = HUGECARD (kMB * kKB);
    krealKB   = HUGECARD (1000);
    krealMB   = HUGECARD (krealKB * krealKB);
    krealGB   = HUGECARD (krealMB * krealKB);
TYPE
    showAsType = (bytes, kilobytes, megabytes, gigabytes,
                 realkilobytes, realmegabytes, realgigabytes);

PROCEDURE fmthcAs (v : HUGECARD; pad:CHAR; sep:CHAR; field:INTEGER;
                  as : showAsType) : str80;
VAR
    R : str80;
    z : str16;
    ugly : INTEGER;
    di: HUGECARD;
BEGIN
    CASE as OF
    | bytes :         z:=""   ; di := HUGECARD(1);
    | kilobytes :     z:=" Kb"; di := kKB;
    | megabytes :     z:=" Mb"; di := kMB;
    | gigabytes :     z:=" Gb"; di := kGB;
    | realkilobytes : z:=" kB"; di := krealKB;
    | realmegabytes : z:=" mB"; di := krealMB;
    | realgigabytes : z:=" gB"; di := krealGB;
    ELSE ; (* //ISO fixed silly requirement *) END;
    ugly := Str.Length(z);
    v:= v / di;
    CASE as OF
    | bytes,kilobytes,realkilobytes:
        Str.Concat(R, fmthc   (v,pad,sep,field-ugly), z); (* yes, suffix here is a really ugly hack *)
    ELSE
        Str.Concat(R, fmthcdec(v,pad,sep,field-ugly,1), z); (* yes, suffix here is a really ugly hack *)
    END;
    RETURN R;
END fmthcAs;

(* ------------------------------------------------------------ *)

CONST
    allletters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

(* assume S is already in uppercase *)

PROCEDURE isUnitSpec ( S : ARRAY OF CHAR ) : BOOLEAN;
BEGIN
    IF Str.Length(S) # 2 THEN RETURN FALSE; END; (* not xx *)
    IF S[1] # colon THEN RETURN FALSE; END;      (* not x: *)
    RETURN Str.CharPos(allletters, CAP(S[0]) ) # MAX(CARDINAL);
END isUnitSpec;

PROCEDURE isConcatenatedUnits (S:ARRAY OF CHAR   ):CARDINAL ;
VAR
    i,len,rc : CARDINAL;
BEGIN
    rc:=MAX(CARDINAL);
    len:=Str.Length(S);
    IF len < 2 THEN RETURN rc; END; (* "?:" or more required *)
    IF S[len-1] # colon THEN RETURN rc; END;
    FOR i:=1 TO len-1 DO
        IF Str.CharPos(allletters, CAP(S[i-1]) ) = MAX(CARDINAL) THEN RETURN rc;END;
    END;
    RETURN (len-1);
END isConcatenatedUnits;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* Win98se = 4.10, WinXPsp3 = 5.1 *)

PROCEDURE chkOSversion(DEBUG:BOOLEAN) : BOOLEAN;
CONST
    win95or98major = 4;
    winXPmajor     = 5;
VAR
    ok:BOOLEAN;
    v:LONGCARD; (* DWORD *)
    major,minor:LONGCARD;
BEGIN
    v:=WinBase.GetVersion();
    dbg(DEBUG,"GetVersion()", fmtlc(v,"","",1) );

    major := (v AND 0FFH);
    minor := (v AND 0FF00H) >> 8;

    dbg(DEBUG,"major",fmtlc(major,"","",1) );
    dbg(DEBUG,"minor",fmtlc(minor,"","",1) );

    ok := (major > win95or98major); (* don't care about NT *)
    RETURN ok;
END chkOSversion;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    (*
                "u:    #,###,###,###,###  #,###,###,###,###  ###,#  ###,#  "
                "----  -----------------  -----------------  -----  -----  --------------------"
    *)
    sHeader1a = "Unit               Free              Total  %Used  %Free";
    sHeader1b =                                                         "  Used=$        Free=$";
    sHeader2a = "----  -----------------  -----------------  -----  -----";
    sHeader2b =                                                         "  --------------------";
    sInvalid  =       "                                                    ** INVALID DRIVE! **";
    chsymbol  = "$";
    chdash    = "-";
    sFree     = "Free"; (* same as sHeader1a *)
    sUsed     = "Used"; (* same length as sFree *)
    wihuge    = 13+4;   (* digits and inner commas , was 12+3 *)
    wipercent = 3+1+1;
    wibar     = 20;
    zedigits  = 1;
CONST
    firstUnit = 1;
    maxUnit   = 26; (* A..Z at most *)
VAR
    unit      : ARRAY [firstUnit..maxUnit] OF CHAR;
    lastUnit  : CARDINAL;
    sUnits    : str80;
VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    S         : str128;
    R         : str128;
    opt       : CARDINAL;
    useCLI    : BOOLEAN;
    cli       : str256; (* false cli, oversized just in case *)
    hnd       : FIO.File;
    freespace,usedspace,totalspace: HUGECARD;
    sumfree,sumused,sumtotal:HUGECARD;
    percentused,percentfree:LONGREAL;
    warn,verbose:BOOLEAN;
    showsum,graphchars,semigraphics,showfree:BOOLEAN;
    DEBUG : BOOLEAN;
    charUsed,charFree:CHAR;
    showAs : showAsType;
    lastletter,zeletter:CARDINAL;
    U:str2;
    sepgroup,sepdec:CHAR;
BEGIN
    FIO.IOcheck := FALSE;

    parmcount := Lib.ParamCount();
    useCLI    := TRUE;

    IF parmcount = 0 THEN
        Lib.ParamStr(S,0); (* argh ! no longer okay when qd_text is used ! *)
        UpperCase(S); (* useless ! *)
        Str.Subst(S,extEXE,extINI);
        IF FIO.Exists(S)=FALSE THEN
            (* abort(errNotFound,S); *)
            abort(errHelp,"");
        END;
        hnd:=FIO.OpenRead(S);
        FIO.RdStr(hnd,cli);
        FIO.Close(hnd);
        LtrimBlanks(cli);
        RtrimBlanks(cli);
        parmcount := argc(cli,FALSE); (* FALSE because already trimed *)
        useCLI := FALSE;
    END;

    lastUnit     := firstUnit-1;
    sUnits       := "";
    warn         := FALSE;
    verbose      := TRUE;
    showsum      := TRUE;
    sumfree      := HUGEZERO;
    sumtotal     := HUGEZERO;
    graphchars   := TRUE;
    semigraphics := TRUE;
    showfree     := TRUE;
    showAs       := bytes;
    sepgroup     :=getsepgroup(TRUE);
    sepdec       :=getsepdec(TRUE);
    DEBUG        := FALSE;

    FOR i := 1 TO parmcount DO
        IF useCLI THEN
            Lib.ParamStr(S,i);
        ELSE
            argv(S,cli,i,FALSE); (* FALSE because already trimed *)
        END;
        cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "Q"+delim+"QUIET"+delim+
                                  "S"+delim+"SUM"+delim+
                                  "A"+delim+"ASCII"+delim+
                                  "U"+delim+"USED"+delim+
                                  "T"+delim+"TEXT"+delim+
                                  "K"+delim+"KB"+delim+
                                  "RK"+delim+"KK"+delim+
                                  "M"+delim+"MB"+delim+
                                  "RM"+delim+"MM"+delim+
                                  "G"+delim+"GB"+delim+
                                  "RG"+delim+"GG"+delim+
                                  "DEBUG"+delim+
                                  "E"+delim+"US"+delim+"UK"+delim+
                                  "AA"
                              );
            CASE opt OF
            | 1,2,3 :  abort(errHelp,"");
            | 4,5   :  verbose:=FALSE;
            | 6,7   :  showsum:=FALSE;
            | 8,9   :  graphchars:=FALSE;
            | 10,11 :  showfree := FALSE;
            | 12,13 :  semigraphics:=FALSE;
            | 14,15 : showAs :=     kilobytes;
            | 16,17 : showAs := realkilobytes;
            | 18,19 : showAs :=     megabytes;
            | 20,21 : showAs := realmegabytes;
            | 22,23 : showAs :=     gigabytes;
            | 24,25 : showAs := realgigabytes;
            | 26    : DEBUG := TRUE;
            | 27,28,29: sepgroup:=getsepgroup(FALSE);
                        sepdec  :=getsepdec(FALSE);
            | 30    :  graphchars:=FALSE; semigraphics:=FALSE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            lastletter:=isConcatenatedUnits(R); (* ?[?...]: *)
            IF lastletter = MAX(CARDINAL) THEN abort(errBadUnitSpec,S);END;
            FOR zeletter := 1 TO lastletter DO
                Str.Concat(U, R[zeletter-1], colon);
                IF isUnitSpec(U) = FALSE THEN abort(errBadUnitSpec,S); END;
                IF Str.CharPos(sUnits,U[0]) # MAX(CARDINAL) THEN
                    ;(* abort(errAlreadySpecified,S); (* we could just ignore it, but... *) *)
                ELSE
                    INC(lastUnit);
                    IF lastUnit > maxUnit THEN abort(errTooManyUnits,S); END; (* extremely unlikely and even impossible ! *)
                    unit[lastUnit] := U[0]; (* keep uppercase *)
                    Str.Append(sUnits,U[0]);
                END;
            END;
        END;
    END;

    IF chkOSversion(DEBUG)=FALSE THEN abort(errOSversion,"");END;

    IF lastUnit < firstUnit THEN abort(errNoUnitSpecified,""); END;

    IF lastUnit = firstUnit THEN showsum := FALSE; END;

    newline; (* here for pretty output *)

    (*
    print(Banner);
    newline;
    newline;
    *)

    S := sHeader1a; IF verbose THEN Str.Append(S,sHeader1b);END;
    R := sHeader2a; IF verbose THEN Str.Append(R,sHeader2b);END;

    IF semigraphics THEN
        charUsed:=chUsed;     charFree:=chFree;
    ELSE
        charUsed:=chUsedTxt;  charFree:=chFreeTxt;
    END;
    Str.Subst(S,chsymbol,charUsed);
    Str.Subst(S,chsymbol,charFree);

    IF graphchars THEN ReplaceChar(R,chdash,graphdash); END;

    IF NOT (showfree) THEN Str.Subst(S,sFree,sUsed);END;

    colorheader;

    print(S);newline;
    print(R);newline;

    colortext;

    FOR i := firstUnit TO lastUnit DO
        Str.Concat(S,unit[i],colon);
        Str.Copy(S,fmtstring(S,blank,2+2));
        Str.Append(S,"  ");
        IF getUnitFreeTotal(DEBUG,unit[i],freespace,totalspace) THEN
            HUGEINC(sumtotal,totalspace);
            HUGEINC(sumfree,freespace);
            usedspace := totalspace-freespace;
            HUGEINC(sumused,usedspace);

            IF showfree THEN
                Str.Append(S,fmthcAs(freespace,blank,sepgroup,wihuge,showAs));
            ELSE
                Str.Append(S,fmthcAs(usedspace,blank,sepgroup,wihuge,showAs));
            END;
            Str.Append(S,"  ");
            Str.Append(S,fmthcAs(totalspace,blank,sepgroup,wihuge,showAs));
            Str.Append(S,"  ");
            percentfree := (LONGREAL(freespace) / LONGREAL(totalspace) ) * 100.0;
            percentused := 100.0 - percentfree;
            Str.Append(S,fmtpercent(percentused,blank,sepdec,wipercent,zedigits));
            (* Str.Append(S,"%"); *)
            Str.Append(S,"  ");
            Str.Append(S,fmtpercent(percentfree,blank,sepdec,wipercent,zedigits));
            (* Str.Append(S,"%"); *)
            IF verbose THEN
                Str.Append(S,"  ");
                Str.Append(S,fmtbar(percentused,charUsed,charFree,wibar));
            END;
        ELSE
            Str.Append(S,sInvalid);
        END;
        print(S);
        newline;
    END;

    colorheader;

    IF showsum THEN
        IF lastUnit > firstUnit THEN
            IF graphchars THEN
                ReplaceChar(R,graphdash,graphbar);
            ELSE
                ReplaceChar(R,"-","=");
            END;
            print(R);newline; (* we did not change R separator ! *)
            freespace := sumfree;
            totalspace:= sumtotal;
            usedspace := sumused;
            Str.Concat(S,"all",colon);
            Str.Copy(S,fmtstring(S,blank,2+2));
            Str.Append(S,"  ");
            IF showfree THEN
                Str.Append(S,fmthcAs(freespace,blank,sepgroup,wihuge,showAs));
            ELSE
                Str.Append(S,fmthcAs(usedspace,blank,sepgroup,wihuge,showAs));
            END;
            Str.Append(S,"  ");
            Str.Append(S,fmthcAs(totalspace,blank,sepgroup,wihuge,showAs));
            Str.Append(S,"  ");
            percentfree := (LONGREAL(freespace) / LONGREAL(totalspace) ) * 100.0;
            percentused := 100.0 - percentfree;
            Str.Append(S,fmtpercent(percentused,blank,sepdec,wipercent,zedigits));
            (* Str.Append(S,"%"); *)
            Str.Append(S,"  ");
            Str.Append(S,fmtpercent(percentfree,blank,sepdec,wipercent,zedigits));
            (* Str.Append(S,"%"); *)
            IF verbose THEN
                Str.Append(S,"  ");
                Str.Append(S,fmtbar(percentused,charUsed,charFree,wibar));
            END;
            print(S);
            newline;
        END;
    END;

    colorwarning;

    IF warn THEN
        newline;
        print(msgWarning);newline;
    END;

    abort(errNone,"");
END HDfree32.

