(* ---------------------------------------------------------------
Title         Q&D Line Count
Overview      count lines in a text file
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              assume legal (and rational !) comments for Modula-2 and Basic
              no handling of "(*" and "*)" in strings
              no handling of complex imbricated commments in M2 and C
              here are legal patterns :
              (* *)
              (*
              *)
              we don't care about M2 pragmas

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -v

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Bugs
Wish List     accept string or val instead of char for -s option ?
              LFN support ? bah...
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 28 Jun 20 relunctantly keeping in sync with v1.1f for DOS
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 17 Mar 16 an ugly really Q&D port from LCOUNT v1.1e for DOS
--------------------------------------------------------------- *)

MODULE LCount32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn, WrLngCard, WrCard;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ProgEXEname     = "LCOUNT32";
    ProgTitle       = "Q&D Line Counter (Win32)";
    ProgVersion     = "v0.9a (from v1.1f for DOS)";

    ProgCopyright   = "by PhG";
    Banner          = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extBAK        = ".BK!";
    basicrem0     = "REM";
    basicrem1     = "'";
    modularemopen = "(*";
    modularemclose= "*)";
    crem          = "//";
    cremopen      = "/*";
    cremclose     = "*/";
    asmcomment    = ";";
CONST
    extCOM      = ".COM";
    extEXE      = ".EXE";
    extDLL      = ".DLL";
    extOVR      = ".OVR";
    extOVL      = ".OVL";
    extDRV      = ".DRV";
    extVXD      = ".VXD";
    extBIN      = ".BIN";
    extZIP      = ".ZIP";
    extARJ      = ".ARJ";
    extLZH      = ".LZH";
    skippedextensions = extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extVXD+delim+extBIN+delim+
                        extZIP+delim+extARJ+delim+extLZH;
CONST
    sINFO         = "::: ";
    msgProcessing = sINFO+" Processing |";

CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errMissingSpec  = 4;
    errTooMany      = 5;
    errNoMatch      = 6;
    errNonsense     = 7;
    errSilly        = 8;
    errComment      = 9;
    errRidiculous   = 10;
    errThereCanBeOnlyOne    = 11;
    errVerySilly            = 12;
    errBadRange             = 13;
    errThereCanBeOnlyOneHere= 14;
    errNonsenseWithSort     = 15;
    errBadSpec              = 16;
    errNonsenseFinding      = 17;
    errAborted              = 18;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" <file(s)> [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <-f> [-v] <file(s)"+nl+
nl+
"This program counts lines in a text file (syntax 1)"+nl+
"or it finds the longest line (syntax 2), assuming at most 4096 characters."+nl+
nl+
'-m     ignore Modula-2 comments between "'+modularemopen+'" and "'+modularemclose+'"'+nl+
'-b     ignore BASIC comments beginning with "'+basicrem0+'" or "'+basicrem1+'"'+nl+
'-c     ignore C comments beginning with "'+crem+'" or between "'+cremopen+'" and "'+cremclose+'"'+nl+
'-a     ignore Assembler comments beginning with "'+asmcomment+'"'+nl+
"-k     display count of comments instead of count of lines"+nl+
"-e     count empty or blanks lines too"+nl+
"-s[:#] count sorted lines according to character at column specified with -c:#"+nl+
"       (-s:# = -s -c:#)"+nl+
"-c:#   character column (-s required, default is 1)"+nl+
"-g[g]  show bar graph (-s required, -bb = no semigraphics)"+nl+
"-w:#   bar graph width (default is 25 characters)"+nl+
"-f:#   number field width (default is 9)"+nl+
"-d     dump lines or comments verbatim to screen"+nl+
"-f[f]  find the longest line (-ff = show rough lines average length too)"+nl+
nl+
"a) Language comments support is minimal... and will remain so. ;-)"+nl+
"b) With -f[f] option, any option other than -v will be silently ignored."+nl+
"   Empty lines are not considered when computing rough lines average length."+nl+
"c) Program will not process files with any of these extensions :"+nl+
"   "+skippedextensions+" for safety."+nl+
"d) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024; (* was str256 but in case we get a LFN... *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errOption:
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errTooManyParms:
        Str.Concat(S,einfo," parameter is one too many !");
    | errMissingSpec:
        S := "Missing file specification !";
    | errTooMany:
        Str.Concat(S,'Too many files match "',einfo);Str.Append(S,'" specification !');
    | errNoMatch:
        Str.Concat(S,'No file matches "',einfo);Str.Append(S,'" specification !');
    | errNonsense:
        S := "-m, -b, -c and -a options are mutually exclusive !";
    | errSilly:
        S := "-v, d- and -debug options are mutually exclusive !";
    | errComment:
        S := "-k option requires -m, -b, -c or -a option !";
    | errRidiculous:
        S := "-e option is a nonsense with any of -m, -b, -c or -a options !";
    | errThereCanBeOnlyOne:
        S := "-d option should be used for one file at a time !";
    | errVerySilly:
        S := "-d option is a nonsense without one of -m, -b, -c or -a options !";
    | errBadRange:
        Str.Concat(S,"Out of range ",einfo);Str.Append(S," value !");
    | errThereCanBeOnlyOneHere:
        S := "-s option should be used for one file at a time !";
    | errNonsenseWithSort:
        S := "-s option should be used alone !";
    | errBadSpec:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" specification !');
    | errNonsenseFinding:
        S := "-g[g] option is a nonsense with -f option !";
    | errAborted:
        S := "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;     (* variable length *)
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        DEBUG :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        excludeme2 := isReservedPattern (entryname,skippedextensions );
        IF NOT(excludeme1 OR excludeme2) THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr("Included : ");WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

PROCEDURE WrQuoted (S:ARRAY OF CHAR);
BEGIN
    WrStr(dquote);  WrStr(S);  WrStr(dquote);
END WrQuoted;

PROCEDURE WrFname (useLFN:BOOLEAN;S:pathtype );
BEGIN
    IF useLFN THEN
        WrQuoted(S);
    ELSE
        WrStr(S);
    END;
END WrFname;

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE tally (substring,S:ARRAY OF CHAR) : CARDINAL;
VAR
    n,len,p:CARDINAL ;
BEGIN
    len := Str.Length(S);
    n:=0;
    p:=Str.Pos(S,substring);
    IF p # MAX(CARDINAL) THEN
        LOOP
            INC(n);
            INC(p);
            IF p >= len THEN EXIT;END;
            p := Str.NextPos(S,substring,p);
            IF p = MAX(CARDINAL) THEN EXIT;END;
        END;
    END;
    RETURN n;
END tally;

(* assume S is already fully trimed *)
PROCEDURE atstart (substring,S : ARRAY OF CHAR   ) : BOOLEAN ;
VAR
    S2 : str128;
BEGIN
    IF S[0] # substring[0] THEN RETURN FALSE; END; (* quick test *)

    IF same(S,substring) THEN RETURN TRUE; END;

    IF Str.Pos(S,substring)=0 THEN RETURN TRUE;END; (* //V11F *)

    Str.Concat(S2,substring,blank);
    IF Str.Pos(S,S2)=0 THEN RETURN TRUE; END;

    Str.Concat(S2,substring,tabul);
    IF Str.Pos(S,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END atstart;

PROCEDURE atend (substring,S : ARRAY OF CHAR   ) : BOOLEAN ;
VAR
    S2 : str128;
    len,lensub:CARDINAL;
BEGIN
    lensub:=Str.Length(substring);
    len:=Str.Length(S);
    IF len < lensub THEN RETURN FALSE; END;
    IF S[len-lensub] # substring[0] THEN RETURN FALSE; END; (* quick test *)

    IF same(S,substring) THEN RETURN TRUE; END;

    Str.Slice(S2,S,len-lensub,lensub);
    IF same(S2,substring) THEN RETURN TRUE;END; (* //V11F *)

    INC(lensub); (* we'll add a blank *)
    IF len < lensub THEN RETURN FALSE; END;

    Str.Concat(S2,blank,substring);
    IF Str.Pos(S,S2)=(len-lensub) THEN RETURN TRUE; END;

    Str.Concat(S2,tabul,substring);
    IF Str.Pos(S,S2)=(len-lensub) THEN RETURN TRUE; END;
    RETURN FALSE;
END atend;

PROCEDURE atstartandend (sub1,sub2,S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    len,sublen : CARDINAL;
    R : str128;
BEGIN
    (*
    IF atstart(sub1,S) THEN
        len:=Str.Length(S);
        sublen:=Str.Length(sub2);
        IF len >= sublen THEN
            Str.Slice(R, S, len-sublen, sublen);
            RETURN same(R,sub2);
        END;
    END;
    RETURN FALSE;
    *)
    RETURN ( atstart(sub1,S) AND atend(sub2,S) );
END atstartandend;

PROCEDURE herebutnotalone ( sub1,sub2,S:ARRAY OF CHAR  ):BOOLEAN ;
BEGIN
    IF Str.Pos(S,sub1)=MAX(CARDINAL) THEN RETURN FALSE; END;
    IF Str.Pos(S,sub2)=MAX(CARDINAL) THEN RETURN FALSE; END;
    (* ok, we've got both : now check if commenting code *)
    IF atstart(sub1,S) THEN
        IF atend(sub2,S) THEN
            RETURN FALSE;
        ELSE
            RETURN TRUE;
        END;
    ELSE
        IF atend(sub2,S) THEN
            RETURN TRUE;
        ELSE
            RETURN TRUE;
        END;
    END;
END herebutnotalone;

(* ------------------------------------------------------------ *)

TYPE
    languagetype = (none,modula,basic,c,assembler);

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
VAR
    bufferIn  : ioBuffer;

(* ------------------------------------------------------------ *)

VAR
    SSS : ARRAY [0..24576-1] OF CHAR; (* //OUT moved out of getLongest() *)

PROCEDURE getLongest (VAR maxlen:CARDINAL;VAR whatline, totallines,totalchars:LONGCARD;
                      f : pathtype);
VAR
    msg : str256;
    hin : FIO.File;
    len:CARDINAL;
    currline:LONGCARD; (* take care of possible very long text file *)
BEGIN
    msg:=msgProcessing;
    Str.Subst(msg,hbar,f);
    video(msg,TRUE);

    whatline:=0;
    maxlen:=0;

    totallines:=0;
    totalchars:=0;

    currline:=0;

    hin := FIO.OpenRead(f);
    FIO.AssignBuffer(hin,bufferIn);
    FIO.EOF := FALSE;
    LOOP
        FIO.RdStr(hin,SSS);
        IF ((SSS[0]=0C) AND FIO.EOF) THEN EXIT; END;
        INC(currline);
        len:=Str.Length(SSS);
        IF len > maxlen THEN maxlen:=len; whatline:=currline; END;
        IF len # 0 THEN
            INC(totallines);
            INC(totalchars, LONGCARD(len));
        END;
    END;
    FIO.Close(hin);
    video(msg,FALSE);
END getLongest;

(* ------------------------------------------------------------ *)

PROCEDURE dbg (n:LONGCARD;S,S2:ARRAY OF CHAR   );
BEGIN
    WrLngCard(n,6);
    WrStr(" ");
    WrStr(S2);
    WrStr(" ");
    WrStr(S);WrLn; (* ###### should do ! *)
END dbg;

PROCEDURE countLines (debug,countcomments,countempty,dump:BOOLEAN;
                     language:languagetype; f : pathtype) : LONGCARD;
VAR
    msg : str256;
    hin : FIO.File;
    count,comments,currline: LONGCARD;
    S,SORG : str4096;
    levels:CARDINAL;
    wasREMark:BOOLEAN;
    isopenclose:BOOLEAN;
BEGIN
    msg:=msgProcessing;
    Str.Subst(msg,hbar,dquote+hbar+dquote);
    Str.Subst(msg,hbar,f);

IF dump=FALSE THEN
    IF debug THEN
        WrStr(msg);WrLn;
        WrLn;
    ELSE
        video(msg,TRUE);
    END;
END;
    currline :=0;
    levels := 0;

    count := 0;
    comments := 0;

    hin := FIO.OpenRead(f);
    FIO.AssignBuffer(hin,bufferIn);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        wasREMark:=TRUE; (* it's easier to set this variable to false ! *)
        FIO.RdStr(hin,S);
        IF ((S[0]=0C) AND FIO.EOF) THEN EXIT; END;
        INC(currline);
        IF dump THEN
            Str.Copy(SORG,S);
        END;
        RtrimBlanks(S);
        LtrimBlanks(S);
        IF Str.Length(S) = 0 THEN
            IF countempty THEN INC(count);END;
            wasREMark:=FALSE;
        ELSE
            CASE language OF
            | none :
                INC(count);
            | modula :
                isopenclose:=FALSE;
                (* ugly, unable to parse complex cases but who cares ? *)
                isopenclose:= atstartandend(modularemopen,modularemclose,S); (* "( *...* )" *)
                IF isopenclose THEN
                    INC(comments);
                    IF debug THEN dbg(currline,S,"--");END;
                ELSIF same(S,modularemopen) THEN (* "( *" alone *)
                    INC(levels);
                    INC(comments);
                    IF debug THEN dbg(currline,S,"--");END;
                ELSIF same(S,modularemclose) THEN (* "* )" alone *)
                    IF levels > 0 THEN DEC(levels);END; (* yes, this test should not be necessary *)
                    INC(comments);
                    IF debug THEN dbg(currline,S,"--");END;
                ELSIF herebutnotalone(modularemopen,modularemclose,S) THEN
                    IF levels = 0 THEN
                        (* we don't incremend comments here : we process lines ! *)
                        INC(count);
                        INC(comments); (* //V11F *)
                        wasREMark:=FALSE;
                        IF debug THEN dbg(currline,S,"++");END; (* show it but let know it's not counted *)
                    ELSE
                        INC(comments);
                        IF debug THEN dbg(currline,S,"--");END;
                    END;
                ELSIF atstart(modularemopen,S) THEN (* "( *..." *)
                    IF NOT(isopenclose ) THEN INC(levels);INC(comments);END;
                    IF debug THEN dbg(currline,S,"--");END;
                ELSIF atend(modularemclose,S) THEN (* "...* )" *)
                    IF NOT(isopenclose) THEN
                        IF levels > 0 THEN DEC(levels); END; (* yes, this test should not be necessary *)
                        INC(comments);
                    END;
                    IF debug THEN dbg(currline,S,"--");END;

                ELSE
                    IF levels = 0 THEN
                        INC(count);
                        wasREMark:=FALSE;
                    ELSE
                        INC(comments);
                        IF debug THEN dbg(currline,S,"--");END;
                    END;
                END;
            | c :
                (* pretty... basic but anyway, I don't like C *)
                IF atstart(crem,S) THEN (* // *)
                    INC(comments);
                    IF debug THEN dbg(currline,S,"--");END;
                ELSE
                    isopenclose:= atstartandend(cremopen,cremclose,S);
                    IF isopenclose THEN
                        INC(comments);
                        IF debug THEN dbg(currline,S,"--");END;
                    ELSIF ( same(S,cremopen) OR atstart(cremopen,S) ) THEN
                        IF NOT(isopenclose) THEN INC(levels); INC(comments);END;
                        IF debug THEN dbg(currline,S,"--");END;
                    ELSIF (same(S,cremclose) OR atend (cremclose,S) ) THEN
                        IF NOT(isopenclose) THEN
                            IF levels > 0 THEN DEC(levels);END;INC(comments);
                        END;
                        IF debug THEN dbg(currline,S,"--");END;
                    ELSE
                        IF levels = 0 THEN
                            INC(count);
                            wasREMark:=FALSE;
                        ELSE
                            INC(comments);
                            IF debug THEN dbg(currline,S,"--");END;
                        END;
                    END;
                END;
            | basic :
                IF S[0] # basicrem1 THEN (* first char is not a single quote *)
                    Str.Caps(S);
                    IF atstart(basicrem0,S) THEN (* REM *)
                        INC(comments);
                        IF debug THEN dbg(currline,S,"--");END;
                    ELSE
                        INC(count);
                        wasREMark:=FALSE;
                    END;
                ELSE
                    INC(comments);
                    IF debug THEN dbg(currline,S,"--");END;
                END;
            | assembler:
                IF S[0] # asmcomment THEN (* first char is not ";" *)
                    INC(count);
                    wasREMark:=FALSE;
                ELSE
                    INC(comments);
                    IF debug THEN dbg(currline,S,"--");END;
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
        IF dump THEN
            IF countcomments THEN
                IF wasREMark THEN WrStr(SORG);WrLn;END;
            ELSE
                IF wasREMark=FALSE THEN WrStr(SORG);WrLn;END;
            END;
        END;
    END;
    FIO.Close(hin);
IF dump=FALSE THEN
    IF debug THEN
        WrLn;
    ELSE
        video(msg,FALSE);
    END;
END;
    IF countcomments THEN
        RETURN comments;
    ELSE
        RETURN count;
    END;
END countLines;

(* ------------------------------------------------------------ *)

PROCEDURE fmtbar (percentused:LONGREAL;used,free:CHAR;field:CARDINAL):str80;
VAR
    R : str80;
    p,i : CARDINAL;
BEGIN
    percentused := (percentused / 100.0 ) * LONGREAL(field);
    p := CARDINAL(percentused + 0.5); (* round ! *)
    R := "";
    FOR i := 1 TO field DO
        IF i <= p THEN
           Str.Append(R,used);
        ELSE
           Str.Append(R,free);
        END;
    END;
    RETURN R;
END fmtbar;

PROCEDURE showbargraph (semigraphics:BOOLEAN;wi:CARDINAL;count,maxcount:LONGCARD  );
CONST
    chUsed = CHR(219);  chUsedTxt = "+";
    chFree = CHR(176);  chFreeTxt = "-";
VAR
    v      : LONGREAL;
    charUsed,charFree:CHAR;
BEGIN
    IF semigraphics THEN
        charUsed := chUsed ;     charFree := chFree;
    ELSE
        charUsed := chUsedTxt ;  charFree := chFreeTxt;
    END;
    v := ( LONGREAL(count) / LONGREAL(maxcount) ) * 100.0;
    WrStr(fmtbar(v,charUsed,charFree,wi));
END showbargraph;

(* ------------------------------------------------------------ *)

(* dump,debug: not used here *)

PROCEDURE showbychar (charcol,wi,barwi:CARDINAL;
                     dump,showbar,semigraphics,debug:BOOLEAN;
                     f:pathtype);
CONST
    (*        "____'?'" *)
    sep     = "    ";
VAR
    hin : FIO.File;
    total,count : LONGCARD;
    S : str4096;
    oldch,newch:CHAR;
    pass,lastpass,len:CARDINAL;
    R:str16;
BEGIN
    DEC(charcol); (* 1.. to 0.. *)

    total := 0;

    IF showbar THEN
        lastpass:=2;
    ELSE
        lastpass:=1;
    END;

    FOR pass:=1 TO lastpass DO
        count := 0;
        oldch := '';

        hin := FIO.OpenRead(f);
        FIO.AssignBuffer(hin,bufferIn);
        FIO.EOF := FALSE;
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hin,S);
            IF ((S[0]=0C) AND FIO.EOF) THEN EXIT; END;
            len:=Str.Length(S);
            IF len > 0 THEN
                DEC(len);
                IF charcol <= len THEN
                    newch:=S[charcol];
                    IF newch=oldch THEN
                        INC(count);
                    ELSE
                        IF count > 0 THEN
                            IF pass=1 THEN INC(total,count); END;
                            IF pass=lastpass THEN
                                WrLngCard(count,wi);
                                Str.Concat(R,sep+'"',oldch); Str.Append(R,'"');
                                WrStr(R);
                                IF pass=2 THEN
                                    WrStr("  ");
                                    showbargraph (semigraphics,barwi,count,total);
                                END;
                                WrLn;
                            END;
                        END;
                        count:=1;
                        oldch:=newch;
                    END;
                END;
            END;
        END;
        FIO.Close(hin);
        (* handle pending *)
                        IF count > 0 THEN
                            IF pass=1 THEN INC(total,count); END;
                            IF pass=lastpass THEN
                                WrLngCard(count,wi);
                                Str.Concat(R,sep+'"',oldch); Str.Append(R,'"');
                                WrStr(R);
                                IF pass=2 THEN
                                    WrStr("  ");
                                    showbargraph (semigraphics,barwi,count,total);
                                END;
                                WrLn;
                            END;
                        END;
        IF pass=lastpass THEN
            FOR len:=1 TO wi DO WrStr("=");END;WrLn;
            WrLngCard(total,wi);WrLn;
        END;
    END;

END showbychar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getcard (VAR v:CARDINAL;lower,upper:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    rc:BOOLEAN;
    lc:LONGCARD;
BEGIN
    rc:=GetLongCard(S,lc);
    IF rc THEN
        rc:=(lc <= MAX(CARDINAL) );
        IF rc THEN
            v:=CARDINAL(lc);
            rc:=( (v >= lower) AND (v <= upper) );
        END;
    END;
    RETURN rc;
END getcard;

(* yes, we know rounding is faulty but we don't care here *)

PROCEDURE fmtratio (totallines,totalchars:LONGCARD;wi:CARDINAL;fracsep:CHAR):str16;
VAR
    R,RR:str16;
    avg,frac:LONGCARD;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    IF totallines = 0 THEN totallines:=1; END;
    avg:= totalchars DIV totallines;
    Str.CardToStr(avg,R,10,ok);
    frac:=( totalchars - avg*totallines )*100;
    frac:=( frac DIV totallines );
    Str.CardToStr(frac,RR,10,ok);
    IF frac = 0 THEN
        Str.Concat(RR,fracsep,"00");
    ELSE
        FOR i:=Str.Length(RR)+1 TO 2 DO Str.Prepend(RR,"0");END;
        Str.Prepend(RR,fracsep);
    END;
    Str.Append(R,RR);
    FOR i:=Str.Length(R)+1 TO (wi+1+2) DO Str.Prepend(R," ");END;
    RETURN R;
END fmtratio;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    defaultBarWidth    = 25;
    minBarWidth        = 1;
    maxBarWidth        = 100;
    defaultFieldWidth  = 9;
CONST
    msgLines    = " line(s) in ";
    msgComments = " comment(s) in ";
    (*            "######### line(s) in ????????.???" *)
    msgDashes   = "==========================================";
    msgFiles    = " files";
VAR
    parmcount,i,opt : CARDINAL;
    S,R,filespec    : pathtype; (* was str128 *)
    NFO             : str128;
    LNG             : str16;
    state           : (waiting,gotparm1);
VAR
    countFile       : CARDINAL;
    file,basedir    : pathtype;
    ptr,anchor      : pFname;
VAR
    debug,countcomments,countempty,dump,findaverage : BOOLEAN;
    language : languagetype;
    total,nlines,whatline,totallines,totalchars: LONGCARD;
    bychar,showbar ,semigraphics: BOOLEAN;
    charcol,wi,maxlen,barwi:CARDINAL;
    poll,currpoll:CARDINAL;
    redirected:BOOLEAN;
    cmd:(countlines,findlongestline);
BEGIN
    WrLn;
    FIO.ShareMode := FIO.ShareDenyNone;

    debug :=FALSE;

    countcomments :=FALSE;
    countempty := FALSE;
    language := none;
    dump     := FALSE;
    showbar  := FALSE;
    semigraphics:=TRUE;
    barwi    := defaultBarWidth;
    wi       := defaultFieldWidth;
    bychar   := FALSE; (* another mode *)
    charcol  := 1;
    findaverage:=FALSE;
    cmd      := countlines;

    state   := waiting;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleanCLI(R); ReplaceChar(R,dquote,"");
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "v"+delim+"verbose"+delim+
                                   "M"+delim+"MODULA"+delim+
                                   "B"+delim+"BASIC"+delim+
                                   "C"+delim+
                                   "DEBUG"+delim+
                                   "K"+delim+"COMMENTS"+delim+
                                   "E"+delim+"EMPTY"+delim+
                                   "A"+delim+"ASM"+delim+
                                   "D"+delim+"DUMP"+delim+
                                   "S"+delim+"BYCHAR"+delim+
                                   "C:"+delim+"COLUMN:"+delim+
                                   "F:"+delim+"FIELD:"+delim+
                                   "F"+delim+"FIND"+delim+"LONGEST"+delim+
                                   "x"+delim+"lfn"+delim+
                                   "S:"+delim+
                                   "G"+delim+"BARGRAPH"+delim+
                                   "GG"+delim+
                                   "W:"+delim+"WIDTH:"+delim+
                                   "FF"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : ;
            | 6,7   : CASE language OF
                      | none,modula: language := modula;
                      ELSE abort(errNonsense,"");
                      END;
            | 8,9   : CASE language OF
                      | none,basic : language := basic;
                      ELSE abort(errNonsense,"");
                      END;
            | 10    : CASE language OF
                      | none,c : language := c;
                      ELSE abort(errNonsense,"");
                      END;
            | 11    : debug := TRUE;
            | 12,13 : countcomments:=TRUE;
            | 14,15 : countempty := TRUE;
            | 16,17 : CASE language OF
                      | none,assembler : language := assembler;
                      ELSE abort(errNonsense,"");
                      END;
            | 18,19:  dump:=TRUE;
            | 20,21:  bychar:=TRUE;
            | 22,23:  IF getcard(charcol,1,127,R)=FALSE THEN abort(errBadRange,S);END;
            | 24,25:  IF getcard(wi,1,12,R)=FALSE THEN abort(errBadRange,S);END;
            | 26,27,28:cmd:=findlongestline;
            | 29,30:  ;
            | 31:     bychar:=TRUE;
                      IF getcard(charcol,1,127,R)=FALSE THEN abort(errBadRange,S);END;
            | 32,33:  showbar        := TRUE;
            | 34:     showbar        := TRUE; semigraphics:=FALSE;
            | 35,36:  IF getcard(barwi,minBarWidth,maxBarWidth,R)=FALSE THEN abort(errBadRange,S);END;
            | 37:     cmd:=findlongestline;
                      findaverage:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(filespec,S);
            | gotparm1: abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    (* check nonsense *)
    IF state=waiting THEN abort(errMissingSpec,"");END;

    CASE cmd OF
    | findlongestline:
        IF (debug AND dump) THEN abort(errSilly,"");END;
        IF (dump AND (language=none)) THEN abort(errVerySilly,"");END;

        IF ( countcomments AND (language=none) ) THEN abort(errComment,"");END;

        IF ( countempty AND (language # none) ) THEN abort(errRidiculous,"");END;

        IF ( bychar AND (language # none) ) THEN abort(errNonsenseWithSort,"");END;

        IF showbar THEN abort(errNonsenseFinding,"");END;

    ELSE ; (* //ISO fixed silly requirement *) END;

    (* a few q&d sanity checks *)

    IF chkUD(filespec)=FALSE THEN abort(errBadSpec,filespec);END;
    IF same(filespec,dot) THEN Str.Copy(filespec,stardotstar); END;
    IF same(filespec,star) THEN Str.Copy(filespec,stardotstar); END;
    IF Str.Match(filespec,"*"+antislash) THEN Str.Append(filespec,stardotstar); END;
    IF chkJoker(filespec)=FALSE THEN
        IF isDirectory ( filespec) THEN
            fixDirectory(filespec);
            Str.Append(filespec,stardotstar);
        END;
    END;
    makebase(filespec,basedir);

    initList(anchor);
    countFile := buildFileList(anchor,debug,filespec);

IF debug THEN
    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(filespec,ptr);
        Str.Concat(file,basedir,filespec);
        WrFname(TRUE,file);WrLn;
        ptr:=ptr^.next;
    END;
END;
    CASE countFile OF
    | 0 :            abort(errNoMatch,filespec);
    | 1 : ;
    | MAX(CARDINAL): abort(errTooMany,filespec);
    ELSE
        IF dump THEN abort(errThereCanBeOnlyOne,filespec); END;
    END;

    IF bychar THEN
        IF countFile # 1 THEN abort(errThereCanBeOnlyOneHere,filespec);END;
    END;

    CASE cmd OF
    | countlines:
        IF dump=FALSE THEN
                WrStr(Banner);WrLn;
                WrLn;

            IF countcomments THEN
                Str.Copy(NFO,msgComments); (* " comments IN " *)
                CASE language OF
                | modula   : LNG:="Modula-2";
                | basic    : LNG:="BASIC";
                | c        : LNG:="C";
                | assembler: LNG:="Assembler";
                ELSE
                             LNG:="";
                END;
                IF same(LNG,"")=FALSE THEN
                    WrStr(sINFO+"Counting ");WrStr(LNG);WrStr(" comments."+nl+nl);
                END;
            ELSE
                Str.Copy(NFO,msgLines); (* " lines IN " *)
                CASE language OF
                | modula   : LNG:="Modula-2";
                | basic    : LNG:="BASIC";
                | c        : LNG:="C";
                | assembler: LNG:="Assembler";
                ELSE
                             LNG:="";
                END;
                IF same(LNG,"")=FALSE THEN
                    WrStr(sINFO);WrStr(LNG);WrStr(" comments will be ignored."+nl+nl);
                END;
            END;
            IF countempty THEN
                WrStr(sINFO+"Counting empty or blank lines too.");WrLn;WrLn;
            END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    poll := 50; (* vindoze does not like frequent calls TO chkEscape() *)
    currpoll:=0;

    total := 0;
    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(filespec,ptr);
        Str.Concat(file,basedir,filespec);

IF debug THEN WrFname(TRUE,file);WrLn;END;

        CASE cmd OF
        | findlongestline:
            getLongest(maxlen,whatline, totallines,totalchars,file);
            WrStr("Maximum length = ");WrCard( maxlen,wi);
            WrStr("   "+" (line ");
            WrLngCard( whatline,wi); (* 9 digits should do ! *)
            WrStr(") in ");WrFname(TRUE,file);WrLn;
            IF findaverage THEN
                WrStr("Total chars    = ");WrLngCard(totalchars,wi);WrLn;
                WrStr("Total lines    = ");WrLngCard(totallines,wi);WrLn;
                WrStr("Average length = ");
                WrStr( fmtratio(totallines,totalchars,wi,coma) );WrLn;
                IF (ptr^.next # NIL) THEN WrLn; END;
            END;
        | countlines:
            IF bychar THEN
                showbychar (charcol,wi,barwi,
                           dump,showbar,semigraphics,debug,file);
            ELSE
                nlines:=countLines (debug,countcomments,countempty,dump,
                                   language,file);
                INC(total,nlines);
                IF dump=FALSE THEN
                    WrLngCard(nlines,wi);
                    WrStr(NFO);
                    WrFname(TRUE,file);WrLn;
                END;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;

        INC(currpoll);
        IF (currpoll MOD poll) = 0 THEN
            IF ChkEscape() THEN
                freeList(anchor);
                abort(errAborted,"");
            END;
            currpoll:=0;
        END;

        ptr:=ptr^.next;
    END;
    freeList(anchor);


    CASE cmd OF
    | countlines:
        IF dump=FALSE THEN
            IF countFile > 1 THEN
                WrStr(msgDashes);WrLn;
                WrLngCard(total,wi);
                WrStr(NFO);WrStr("all ");
                WrCard(countFile,0);
                WrStr(msgFiles);WrLn;
            END;
       END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    abort(errNone,"");
END LCount32.


