(* --------------------------------------------------------------
Title         Q&D O'Clock
Author        PhG
Overview      tsk tsk...
Usage         see help
Notes         Graph library adds about 14 Kb, even if not called !
              flicker but TopSpeed won't let us use two pages on VGA,
              and EGA is ugly... maybe with a BGI VESA driver ?
              argh, there seems to have no way to flip pages...
              model must be LARGE or "better" for BGI

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -t audio
              -k stopmouse
              -c alternaterefresh

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs

Wish List     various radii could be relative to outer cicle ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 19 Mar 16 an ugly really Q&D port from OCLOCK v1.0c for DOS
--------------------------------------------------------------- *)

MODULE Oclock32;

IMPORT Lib;
IMPORT Str;
IMPORT SYSTEM;
IMPORT BiosIO;
IMPORT IO;
IMPORT MATHLIB;

IMPORT Graph;

FROM IO IMPORT WrStr,WrLn;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)


PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



CONST
    ProgEXEname   = "OCLOCK32";
    ProgTitle     = "Q&D O'Clock (Win32)";
    ProgVersion   = "v0.9a (from v1.0c for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    errNone      = 0;
    errHelp      = 1;
    errOpt       = 2;
    errParm      = 3;
    errRange     = 4;
    errVGA       = 5;
    errCannotSet = 6;

PROCEDURE mak2 (VAR R : ARRAY OF CHAR;S1,S2:ARRAY OF CHAR);
BEGIN
    Str.Concat(R,S1,S2);
END mak2;

PROCEDURE mak3 (VAR R : ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
BEGIN
    Str.Concat(R,S1,S2); Str.Append(R,S3);
END mak3;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
00000000011111111112222222222333333333344444444445555555555666666666677777777778
1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [option]..."+nl+
nl+
"    -i?:# color of Hours/Minutes/Seconds hand"+nl+
"    -ia:# color of marks"+nl+
"    -p:#  color of paper"+nl+
"    -r:#  outer radius of clock (top of marks)"+nl+
"    -r?:# length of Hours/Minutes/Seconds hand"+nl+
"    -la:# length of marks"+nl+
"    -s:#  shape of hands"+nl+
"    -m:#  shape of marks"+nl+
"    -wh:# width of hands"+nl+
"    -wm:# width of marks"+nl+
"    -nb   no borders"+nl+
"    -ib:# border color"+nl+
"    -f    integer minutes hand"+nl+
"    -u    draw seconds, then minutes, then hours"+nl+
"    -e    emphasis on hours angles (0h, 3h, 6h and 9h)"+nl+
"    -s    skeleton (only borders)"+nl+
nl+
"Color [0..15], length [0..239], shape [0..2] (rectangle,diamond,triangle)"+nl+
nl+
"Once program is running, hit any key to exit clock window."+nl;
VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOpt   : mak3(S,"Unknown ",einfo," option !");
    | errParm  : mak3(S,"Useless ",einfo," parameter !");
    | errRange : mak3(S,"Illegal value in ",einfo," option !");
    | errVGA   :    S:="VGA card required !";
    | errCannotSet: S:="Cannot set required 640x480x16 mode !";

    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        (* nada *)
    ELSE
        WrStr(ProgEXEname+" : ");
        WrStr(S);
        WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    origin       = LONGREAL(90);
VAR
    PI      : LONGREAL;
    deg2rad : LONGREAL;

PROCEDURE inittrigo (  );
BEGIN
    PI      := 4.0 * MATHLIB.ATan(1.0);
    deg2rad := PI / 180.0;
END inittrigo;

PROCEDURE DegreesToRadians ( alphadeg : LONGREAL ) : LONGREAL ;
BEGIN
    RETURN (alphadeg * deg2rad);
END DegreesToRadians;

PROCEDURE RadiansToDegrees( alpha : LONGREAL ) : LONGREAL ;
BEGIN
    RETURN (alpha / deg2rad);
END RadiansToDegrees;

PROCEDURE PolarToRectangular (alphadeg:LONGREAL;radius:CARDINAL;cx,cy:CARDINAL;
			     VAR x,y : CARDINAL);
VAR
    alpha,dx,dy,co,si : LONGREAL;
BEGIN
    alpha := alphadeg;   (* +origin *)
    alpha := DegreesToRadians(alpha);
    co    := MATHLIB.Cos(alpha);
    si    := MATHLIB.Sin(alpha);
    (* dx and dy can be negative *)
    dx    := LONGREAL(radius) * co;
    dy    := LONGREAL(radius) * si;
    (* x and y always > 0 *) (* //XDS we need integers here *)
    x     := VAL(CARDINAL,(INTEGER(cx)+VAL(INTEGER,dx)));
    y     := VAL(CARDINAL,(INTEGER(cy)-VAL(INTEGER,dy)));
END PolarToRectangular;

(* x and y may be < 0 *)

PROCEDURE RectangularToPolar (x,y:INTEGER;VAR radius:CARDINAL;VAR alphadeg:LONGREAL);
VAR
    xx,yy,numerator,divisor:LONGREAL;
    si,co,r,alpha:LONGREAL;
BEGIN
    xx:=LONGREAL(x);
    yy:=LONGREAL(y);
    numerator := xx;
    divisor   := yy;
    alpha     := MATHLIB.ATan2(numerator,divisor);
    r         := MATHLIB.Sqrt (xx * xx + yy * yy);
    radius    := CARDINAL(r);
    alphadeg  := RadiansToDegrees(alpha);
END RectangularToPolar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minshape = 0;
    maxshape = 3;

CONST
    maxsides = 4;
VAR
    pAlpha : ARRAY [0..maxsides-1] OF LONGREAL;
    pR     : ARRAY [0..maxsides-1] OF CARDINAL;
    px     : ARRAY[0..maxsides-1] OF CARDINAL;
    py     : ARRAY[0..maxsides-1] OF CARDINAL;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    xmin         = 0;
    ymin         = 0;
    minrad       = 0;

(* TopSpeed
CONST
    cBLACK	       =0;
    cPALEBLUE 	   =1;
    cPALEGREEN     =2;
    cPALECYAN      =3;
    cPALERED       =4;
    cPALEMAGENTA   =5;
    cBROWN         =6;
    cPALEWHITE     =7; (* was WHITE *)
    cGRAY          =8;
    cBLUE          =9;
    cGREEN         =10;
    cCYAN          =11;
    cRED           =12;
    cMAGENTA       =13;
    cYELLOW        =14;
    cWHITE         =15; (* was BRIGHTWHITE *)

    minink         = cBLACK;
    maxink         = cWHITE; (* was BRIGHTWHITE *)
*)

(* //XDS has it wrong !!! *)
CONST
    cBLACK	   =Graph._clrBLACK;
    cPALEBLUE 	   =Graph._clrLIGHTBLUE;
    cPALEGREEN     =Graph._clrLIGHTYELLOW;
  cPALECYAN      =Graph._clrLIGHTCYAN;
    cPALERED       =Graph._clrLIGHTMAGENTA;
  cPALEMAGENTA   =Graph._clrLIGHTRED;
    cBROWN         =Graph._clrCYAN;
    cPALEWHITE     =Graph._clrWHITE;
    cGRAY          =Graph._clrGRAY;
    cBLUE          =Graph._clrRED;
    cGREEN         =Graph._clrGREEN;
    cCYAN          =Graph._clrBROWN;
    cRED           =Graph._clrBLUE;
    cMAGENTA       =Graph._clrMAGENTA;
    cYELLOW        =Graph._clrBRIGHTWHITE;
    cWHITE         =Graph._clrLIGHTGREEN;

    minink         = 0; (* cBLACK *)
    maxink         = 15; (* cWHITE *)


TYPE
    palette16=ARRAY[0..15] OF CARDINAL; (* //XDS should have put RGB LONGCARDs here *)
CONST
    pal16=palette16{
    cBLACK, cPALEBLUE, cPALEGREEN, cPALECYAN,
    cPALERED, cPALEMAGENTA, cBROWN, cPALEWHITE,
    cGRAY,cBLUE, cGREEN,cCYAN,
    cRED,cMAGENTA,cYELLOW ,cWHITE };

PROCEDURE WaitVGAretrace ();
BEGIN
END WaitVGAretrace;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST                                           (* fastest handling ! *)
    tmode        = Graph._DEFAULTMODE;
    gmode        = Graph._VRES16COLOR;
    screenwidth  = 640;
    screenheight = 480;
    xmax         = screenwidth-1;
    ymax         = screenheight-1;
    cx           = xmax DIV 2;
    cy           = ymax DIV 2;
    maxrad       = cy;

PROCEDURE pset (x,y,ink:CARDINAL  );
BEGIN
    Graph.Plot(x,y,ink);
END pset;

PROCEDURE HiresOn (VAR infovideo:Graph.VideoConfig) : BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=Graph.SetVideoMode(gmode);
    IF ok THEN
        Graph.GetVideoConfig(infovideo);
    END;
    RETURN ok;
END HiresOn;

PROCEDURE TextOn (  ) : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(tmode);
END TextOn;

PROCEDURE GrLine (x1,y1,x2,y2:INTEGER;ink,pattern:CARDINAL);
BEGIN
    Graph.SetLinestyle(pattern);
    Graph.Line(x1,y1,x2,y2,ink);
END GrLine;

PROCEDURE GrCircle (cx,cy,r,ink:CARDINAL);
BEGIN
    Graph.Circle(cx,cy,r,ink);
END GrCircle;

PROCEDURE GrClearScreen();
BEGIN
    Graph.ClearScreen(Graph._GWINDOW);
END GrClearScreen;

PROCEDURE GrPolygon (sides:CARDINAL;px,py:ARRAY OF CARDINAL;ink:CARDINAL;
                     filled:BOOLEAN);
VAR
    i,x,y,lastx,lasty:CARDINAL;
BEGIN
    IF filled THEN
        Graph.Polygon(sides,px,py,ink, TRUE); (* //XDS final boolean is yet another stupid extension ! *)
    ELSE
        i:=1;
        lastx:=px[i-1];lasty:=py[i-1];
        LOOP
            x:=px[i];y:=py[i];
            Graph.Line(lastx,lasty,x,y,ink);
            lastx:=x;lasty:=y;
            INC(i);
            IF i = sides THEN EXIT;END;
        END;
        x:=px[0];y:=py[0];
        Graph.Line(lastx,lasty,x,y,ink);
    END;
END GrPolygon;

PROCEDURE GrSetBkColor (color : LONGCARD) : LONGCARD;
BEGIN
    RETURN Graph.SetBkColor(color);
END GrSetBkColor;

PROCEDURE VGAhere (VAR infovideo:Graph.VideoConfig  ) : BOOLEAN;
BEGIN
    Graph.GetVideoConfig(infovideo);
(*     IF infovideo.adapter # Graph._VGA THEN RETURN FALSE; END; //XDS *)
    RETURN TRUE;
END VGAhere;

(* dummy procedures *)

PROCEDURE initHGR ();
BEGIN
END initHGR;

PROCEDURE setviewwork (view,work:INTEGER);
BEGIN
END setviewwork;

PROCEDURE flipviewwork ();
BEGIN
END flipviewwork;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR (* globerks... too many of them... *)
    DEBUG : BOOLEAN;
    hink,mink,sink,aink,paper          : CARDINAL;
    border                   : BOOLEAN;
    fixedmm,smh,emphasis,skel    : BOOLEAN;
    alternaterefresh                   : BOOLEAN;
    radius,hlen,mlen,slen,marklen      : CARDINAL;
    handshape,markshape                : CARDINAL;
    wmark,whand                        : CARDINAL;
    bink                               : CARDINAL;

PROCEDURE defaults (  );
BEGIN
    hink     := pal16[cBLUE];
    mink     := pal16[cBLUE];
    sink     := pal16[cPALECYAN];

    aink     := pal16[cPALECYAN];
    paper    := pal16[cBLACK];

    radius   := (maxrad * 9) DIV 10; (* //XDS prettier because of a window, not a screen *)
    marklen  := radius DIV 10;       (* // more logical to use radius here ! *)
    hlen     := marklen * 6;
    mlen     := marklen * 8;
    slen     := marklen * 9;

    handshape:= 2;
    markshape:= 0;

    wmark    := marklen DIV 2;
    whand    := marklen DIV 2;

    border   := TRUE;
    bink     := pal16[cYELLOW];

    fixedmm  := FALSE;
    smh      := FALSE;
    emphasis := FALSE;
    skel     := FALSE;

    alternaterefresh := FALSE; (* force it //XDS needs FALSE ! *)
END defaults;

CONST
    oldtime = 1;
    newtime = 2;
TYPE
    hmsType = RECORD
        hh,mm,ss,hss,minutes,seconds:CARDINAL;
    END;

(* ------------------------------------------------------------ *)


(*
    each shape is defined this way :

    y
    :
    :   P4      P1
    0...........x  (x is xref)
        P3      P2

    etc.

*)

PROCEDURE buildshape (whatshape,xref,longueur,largeur:CARDINAL;hand:BOOLEAN):CARDINAL;
VAR
    i:CARDINAL;
    ix,ih,iw:INTEGER;
    x,y:INTEGER;
BEGIN
    IF hand THEN INC(whatshape,maxshape+1);END;

    ix :=INTEGER(xref);
    ih :=INTEGER(longueur);
    iw :=INTEGER(largeur);

    (* order of definition is VERY important for it traces contours !!! *)

    i := 0;
    CASE whatshape OF
    (* marks *)
    | 0: (* rectangle *)
        x := ix;    y :=  (iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix;    y := -(iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-ih; y := -(iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-ih; y :=  (iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    | 1: (* diamond *)
        x := ix;            y :=  0;         RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-(ih DIV 2); y := -(iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-ih;         y := 0;          RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-(ih DIV 2); y := (iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    | 2: (* decreasing triangle *)
        x := ix;     y := 0;           RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-ih;  y := -(iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-ih;  y :=  (iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    | 3: (* increasing triangle *)
        x := ix;     y := -(iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix;     y :=  (iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix-ih;  y := 0;           RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);

    (* hands *)
    | 4: (* rectangle *)
        x := ix;    y :=  (iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix;    y := -(iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x :=   -ih; y := -(iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x :=   -ih; y :=  (iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    | 5: (* diamond *)
        x := ix;            y :=  0;         RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := 0            ; y := -(iw DIV 2);RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x :=   -ih;         y := 0;          RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := 0            ; y := (iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    | 6: (* decreasing triangle *)
        x := ix;   y := 0;           RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := -ih;  y := -(iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := -ih;  y :=  (iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    | 7: (* increasing triangle *)
        x := ix;     y := -(iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := ix;     y :=  (iw DIV 2); RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
        x := -ih;    y := 0;           RectangularToPolar (x,y,  pR[i], pAlpha[i]);INC(i);
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN i;
END buildshape;

PROCEDURE rotateshape (sides,cx,cy:CARDINAL;angle:LONGREAL );
VAR
    i  : CARDINAL;
    radius,x,y: CARDINAL;
    alphadeg:LONGREAL;
BEGIN
    FOR i := 1 TO sides DO
        alphadeg := pAlpha[i-1] - angle + origin;
        radius   := pR[i-1];
        PolarToRectangular (alphadeg,radius,cx,cy, x,y);
        px[i-1]:=x; py[i-1]:=y;
    END;
END rotateshape;

PROCEDURE showmarks (cx,cy:CARDINAL );
VAR
    sides,angle : CARDINAL;
    alphadeg    : LONGREAL;
    rayon,longueur,largeur : CARDINAL;
BEGIN
(*
FOR angle := 0 TO 359 BY 6 DO
    alphadeg:=LONGREAL(angle);
    rotateshape(sides,cx,cy, alphadeg);
    GrPolygon(sides,px,py,cGREEN,TRUE);
END;
*)
    FOR angle := 0 TO 330 BY 30 DO
        rayon    := radius;
        longueur := marklen;
        largeur  := wmark;
        IF emphasis THEN
            CASE angle OF
            | 0,90,180,270 :
            ELSE
                rayon    := radius- marklen DIV 4;
                longueur := marklen-marklen DIV 2;
                largeur  := wmark-wmark DIV 2;
            END;
        END;
        sides:=buildshape(markshape, rayon,longueur,largeur,FALSE);
        alphadeg:=LONGREAL(angle);
        rotateshape(sides,cx,cy, alphadeg);
        IF NOT(skel) THEN GrPolygon(sides,px,py,aink,TRUE); END;
        IF border THEN
            GrPolygon(sides,px,py,bink,FALSE);
        END;
    END;
END showmarks;

PROCEDURE showhand (draw,usefrac:BOOLEAN;
                    cx,cy,len,ink,count,divisions,
                    units,circonf:CARDINAL);
VAR
    sides,portion,basealpha:CARDINAL;
    n,fraction,alphadeg:LONGREAL;
BEGIN
    sides:=buildshape(handshape,len,marklen,whand,TRUE);

    portion   := 360 DIV divisions;
    basealpha := portion * count;
    IF usefrac THEN (* hours only *)
        fraction  := LONGREAL(units) / LONGREAL(circonf);
    ELSE
        fraction := 0.0; (* for minutes and seconds, else they would be always 1 more ! *)
    END;

    alphadeg :=  LONGREAL (basealpha)+fraction*LONGREAL(portion);

    rotateshape(sides,cx,cy, alphadeg);
    IF NOT(draw) THEN ink:=paper;END;
    IF NOT(skel) THEN GrPolygon(sides,px,py,ink,TRUE); END;
    IF border THEN
        IF draw THEN
            ink := bink;
        ELSE
            ink := paper;
        END;
        GrPolygon(sides,px,py,ink,FALSE);
    END;
END showhand;

PROCEDURE showhands (cx,cy:CARDINAL;hms:hmsType;draw:BOOLEAN);
VAR
    ink:CARDINAL;
BEGIN
    IF smh THEN
        showhand(draw,FALSE        ,cx,cy,slen,sink, hms.ss,60, 0,0);
        showhand(draw,NOT(fixedmm) ,cx,cy,mlen,mink, hms.mm,60, hms.ss,60);
        showhand(draw,TRUE         ,cx,cy,hlen,hink, hms.hh,12, hms.mm,60);
    ELSE
        showhand(draw,TRUE         ,cx,cy,hlen,hink, hms.hh,12, hms.mm,60);
        showhand(draw,NOT(fixedmm) ,cx,cy,mlen,mink, hms.mm,60, hms.ss,60);
        showhand(draw,FALSE        ,cx,cy,slen,sink, hms.ss,60, 0,0);
    END;
END showhands;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE now (VAR hms:hmsType);
CONST
    noon = 12;
VAR
    hh,mm,ss,hss:CARDINAL;
BEGIN
    Lib.GetTime(hh,mm,ss,hss);
    IF hh > noon THEN DEC(hh,noon); END;
    hms.hh       := hh;
    hms.mm       := mm;
    hms.ss       := ss;
    hms.hss      := hss;
    hms.minutes  := hh * 60 + mm;
    hms.seconds  := hms.minutes * 60 + ss;
END now;

PROCEDURE value (S:ARRAY OF CHAR;min,max:CARDINAL;VAR r:CARDINAL):BOOLEAN;
VAR
    v : LONGCARD;
BEGIN
    IF GetLongCard(S,v)=FALSE THEN RETURN FALSE; END;
    IF v < LONGCARD(min) THEN RETURN FALSE; END;
    IF v > LONGCARD(max) THEN RETURN FALSE; END;
    r := CARDINAL(v);
    RETURN TRUE;
END value;

PROCEDURE getKeyboardCode (VAR keycode:CARDINAL):BOOLEAN;
VAR
    c1,c2:CHAR;
BEGIN
    IF BiosIO.KeyPressed()=FALSE THEN RETURN FALSE; END;
    c1 := BiosIO.RdKey();
    IF c1 = CHR(0) THEN
        c2 := BiosIO.RdKey();
    ELSE
        c2 := CHR(0);
    END;
    keycode := (ORD(c1) << 8) + ORD(c2);
    RETURN TRUE;
END getKeyboardCode;

PROCEDURE flushKeyboard (  );
VAR
    c : CHAR;
BEGIN
    LOOP
        IF BiosIO.KeyPressed()=FALSE THEN EXIT; END;
        c := BiosIO.RdKey();
        IF c = CHR(0) THEN c := BiosIO.RdKey(); END;
    END;
END flushKeyboard;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    keyEscape  = 01B00H;
    keyCR      = 00D00H;

VAR
    i,opt,parmcount  : CARDINAL;
    S,R              : str128;

    chk              : BOOLEAN;
    keycode          : CARDINAL;
    bgr              : LONGCARD;
    mytime           : ARRAY [oldtime..newtime] OF hmsType;
    infovideo        : Graph.VideoConfig;
BEGIN
    WrLn;                       (* must be here for pretty ulterior display ! *)

    initHGR;  (* must come first for BGI ! important variables defined here *)
    defaults;
    DEBUG := FALSE;

    parmcount := Lib.ParamCount();

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R)=TRUE THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "IH:"+delim+
                                   "IM:"+delim+
                                   "IS:"+delim+
                                   "IA:"+delim+
                                   "P:"+delim+
                                    "k"+delim+
                                   "R:"+delim+
                                   "RH:"+delim+
                                   "RM:"+delim+
                                   "RS:"+delim+
                                   "LA:"+delim+
                                   "S:"+delim+
                                   "M:"+delim+
                                   "WH:"+delim+
                                   "WM:"+delim+
                                   "NB"+delim+
                                   "IB:"+delim+
                                   "F"+delim+
                                    "t"+delim+
                                   "U"+delim+
                                   "E"+delim+
                                   "S"+delim+
                                   "c"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4 : IF value(R,minink,maxink,hink)=FALSE THEN abort(errRange,R);END;
            | 5 : IF value(R,minink,maxink,mink)=FALSE THEN abort(errRange,R);END;
            | 6 : IF value(R,minink,maxink,sink)=FALSE THEN abort(errRange,R);END;
            | 7 : IF value(R,minink,maxink,aink)=FALSE THEN abort(errRange,R);END;
            | 8 : IF value(R,minink,maxink,paper)=FALSE THEN abort(errRange,R);END;
            | 9 : ;
            | 10: IF value(R,minrad,maxrad,radius)=FALSE THEN abort(errRange,R);END;
            | 11: IF value(R,minrad,maxrad,hlen)=FALSE THEN abort(errRange,R);END;
            | 12: IF value(R,minrad,maxrad,mlen)=FALSE THEN abort(errRange,R);END;
            | 13: IF value(R,minrad,maxrad,slen)=FALSE THEN abort(errRange,R);END;
            | 14: IF value(R,minrad,maxrad,marklen)=FALSE THEN abort(errRange,R);END;
            | 15: IF value(R,minshape,maxshape-1,handshape)=FALSE THEN abort(errRange,R);END;
            | 16: IF value(R,minshape,maxshape  ,markshape)=FALSE THEN abort(errRange,R);END;
            | 17: IF value(R,minrad,maxrad,whand)=FALSE THEN abort(errRange,R);END;
            | 18: IF value(R,minrad,maxrad,wmark)=FALSE THEN abort(errRange,R);END;
            | 19: border := FALSE;
            | 20: IF value(R,minink,maxink,bink)=FALSE THEN abort(errRange,R);END;
            | 21: fixedmm:=TRUE;
            | 22: ;
            | 23: smh:=TRUE;
            | 24: emphasis:=TRUE;
            | 25: skel:=TRUE;
            | 26: ;
            | 27: DEBUG := TRUE;
            ELSE
                abort(errOpt,S);
            END;
        ELSE
            abort(errParm,S);
        END;
    END;

    IF alternaterefresh THEN
        i  := radius-marklen;
        opt:= 0;
        IF hlen >= i THEN INC(opt); END;
        IF mlen >= i THEN INC(opt); END;
        IF slen >= i THEN INC(opt); END;
        IF opt # 0 THEN alternaterefresh := FALSE; END;
    END;

    IF skel THEN border:=TRUE; END;

    initHGR;

    IF VGAhere(infovideo)=FALSE THEN abort(errVGA,"");END; (* //XDS *)
    IF HiresOn(infovideo)=FALSE THEN
        chk := TextOn();
        abort(errCannotSet,"");
    END;
    Graph.InitStdPalette(); (* //XDS *)
    (* setviewwork(0,1); *)

    bgr:=GrSetBkColor ( pal16[paper] );
    GrClearScreen;
    Graph.SetGraphWindowTitle(ProgTitle+" "+ProgVersion);

    inittrigo();

    showmarks(cx,cy);
    i:=oldtime;
    now( mytime[i] );
    showhands(cx,cy,mytime[i], TRUE );

    (* flipviewwork; *)

    LOOP
        i := newtime;
        now( mytime[i] );
        IF mytime[i].ss # mytime[oldtime].ss THEN
            WaitVGAretrace; (* more and/or elsewhere increases flicker ! *)
            IF alternaterefresh THEN
                showhands(cx,cy,mytime[oldtime], FALSE );
            ELSE
                GrClearScreen;
            END;
IF DEBUG THEN
GrLine(0,cy,xmax,cy,cWHITE,0FFFFH);GrLine(cx,0,cx,ymax,cWHITE,0FFFFH);
GrCircle(cx,cy,cy,cWHITE);         GrCircle(cx,cy,cy-marklen,cWHITE);
END;
            showmarks(cx,cy);
            showhands(cx,cy,mytime[i], TRUE );
            (* no longer a tick *)
            mytime[oldtime]:=mytime[i];
        END;
        chk:=getKeyboardCode(keycode);
        IF chk THEN
            CASE keycode OF
            | keyEscape     : EXIT;
            | keyCR         : EXIT;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;

    chk:=TextOn();
    flushKeyboard();
    abort(errNone,"");
END Oclock32.


