(* ---------------------------------------------------------------
Title         Q&D remark processor for TS M2 source code
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone)
              see wish list anyway ! ;-)

Bugs
Wish List     allow removal/edition of lines through line number ?
              crossref constants, variables, procedures ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 26 Nov 23 v0.9b bugfix : code after inner comments would disappear
              as seen IN ISOCASEd fixed src "ELSE ; (* xxx *) END;"
              see //V10N FOR uninitialized variable !
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 17 Nov 16 v0.9a bugfix : fixed mismatch between options string and id numbers
PhG 18 Mar 16 an ugly really Q&D port from REMMOD v1.0j for DOS
--------------------------------------------------------------- *)

MODULE remMOD;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    winum          = 5; (* ##### = 99999... should DO ! *)
    sTagOnlyCode   = "??";
    sTagCodeHere   = "::"; (* code AND remark *)
    sTagREM        = "++"; (* only remark or remark open/close alone *)
    sTagINrem      = "!!"; (* between remark open/close *)
    taglen         = 2;    (* both tags are 2 chars long *)
CONST
    exe            = "REMMOD32";
    extBAK         = ".ORG";
    extMOD         = ".MOD";
    title          = "Q&D M2 remarks and strings processor (Win32)";
    version        = "v0.9b (from v1.0j for DOS)";
    culprit        = "by PhG";
    Banner         = title+" "+version+" "+culprit;
    sMaxFileCount  = "200"; (* should do ! *)
    maxFileCount   = 200;
    qui            = "who";
    quand          = "when";
    quoi           = "what";
    patWWW         = "*"+qui+"*"+quand+"*"+quoi+"*"; (* trick not to be parsed *)
    patREMclose    = "----------*---------- ?)"; (* beware of internal comments ! *)
    patLibStart    = "IMPLEMENTATION*MODULE*"+semicolon;
    patProgStart   = "MODULE*"+semicolon;
    patProgEnd     = "END*"+dot;
    arobase        = "@";
    dumpsepline    = '(* =========::: "$" *)'; (* $ is file *)
CONST
    extCOM      = ".COM";
    extEXE      = ".EXE";
    extDLL      = ".DLL";
    extOVR      = ".OVR";
    extOVL      = ".OVL";
    extDRV      = ".DRV";
    extVXD      = ".VXD";
    extBIN      = ".BIN";
    extZIP      = ".ZIP";
    extARJ      = ".ARJ";
    extLZH      = ".LZH";
    skippedextensions = extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extVXD+delim+extBIN+delim+
                        extZIP+delim+extARJ+delim+extLZH;

CONST
    help=
Banner+nl+
nl+
"Syntax 1 : "+exe+" <m2_source["+extMOD+"]> [-q]"+nl+
"Syntax 2 : "+exe+" <m2_source["+extMOD+"]> <remarks_file>"+nl+
"Syntax 3 : "+exe+" <m2_source["+extMOD+"]> <"+arobase+"|-w>"+nl+
"Syntax 4 : "+exe+" <m2_source["+extMOD+"]> <"+exclam+"|-f>"+nl+
"Syntax 5 : "+exe+" <m2_source["+extMOD+"]> <"+dollar+"|-c>"+nl+
"Syntax 6 : "+exe+" <m2_source["+extMOD+"]> <"+pound+"|-x[x]> [-k]"+nl+
"Syntax 7 : "+exe+" <m2_source["+extMOD+"]> <"+ampersand+"|-s[s]> [-t] [-n]"+nl+
nl+
"    This program processes Modula-2 *"+extMOD+" files."+nl+
nl+
"    It dumps all remarks enclosed or not (-q) with double quotes (syntax 1) ;"+nl+
"    replaces lines using edited remarks enclosed with double quotes (syntax 2)"+nl+
"    provided lines have been dumped using syntax 1 first ;"+nl+
'    dumps code removing "Who When What" history header (syntax 3) ;'+nl+
'    removes "Who When What" history header from source (syntax 4) ;'+nl+
"    warns about any data left after end of program code (syntax 5) ;"+nl+
"    remove all remarks from source (syntax 6),"+nl+
"    possibly keeping separation lines (-k) ;"+nl+
"    dumps all lines containing strings whether double- or single- quoted"+nl+
"    (syntax 7), possibly trimming lines (-t) or keeping only strings (-n)."+nl+
nl+
"a) Source code is assumed to be correct (its compilation should be a success)."+nl+
"b) Syntax 1 flags each dumped line with a marker in this priority order :"+nl+
'   "'+sTagCodeHere+'" = code+remark ; "'+sTagREM+'" = remark ; "'+sTagINrem+'" = between remarks'+nl+
"c) Syntax 2 requires edited remarks to keep their line number and marker ;"+nl+
"   only text between outer double quotes may be changed (this is by design)."+nl+
"d) All syntaxes (except syntax 2) can process up to "+sMaxFileCount+" files."+nl+
"e) Syntax 4 keeps each original file with "+extBAK+" extension :"+nl+
"   other syntaxes (except syntax 2) dump processed source files to screen."+nl+
"   Should more than one source file be processed, this separator is inserted :"+nl+
nl+
"   "+dumpsepline+nl+
nl+
"   where $ is source filename."+nl+
'f) Syntax 6 can preserve separation lines remarks made only of "'+dash+'" or "'+equal+'".'+nl+
"g) Syntax 7 dumps any remark containing a string, including Modula-2 comments."+nl+
"h) Here are skipped extensions :"+nl+
"   "+skippedextensions+nl+
"i) Redirection, DIRBAT, WITH, and USERBRAIN utilities should help. ;-)"+nl+
"j) This program was written for TopSpeed J.P.I. Modula-2 source code,"+nl+
"   but it should be useful for newer Modula-2 compilers."+nl+
"k) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

PROCEDURE abort (S:ARRAY OF CHAR);
VAR
    rc:CARDINAL;
BEGIN
    IF same(S,"") THEN
        rc:=0;
    ELSE
        WrStr(exe+" : ");WrStr(S);WrLn;
        rc:=1;
    END;
    (* Lib.SetReturnCode(SHORTCARD(rc)); *)
    HALT (rc);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType    = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
VAR
    ioBufferIn  : ioBufferType;
    ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE num2str (num,fix:CARDINAL;padchar:CHAR   ):str16;
VAR
    R:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr( LONGCARD(num),R,10,ok);
    WHILE Str.Length(R) < fix DO
        Str.Prepend(R,padchar);
    END;
    RETURN R;
END num2str;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    modularemopen   = "(*";
    modularemclose  = "*)";

(* assume S is already fully trimed *)

PROCEDURE atstart (substring,S : ARRAY OF CHAR   ) : BOOLEAN ;
VAR
    S2 : str128;
BEGIN
    IF S[0] # substring[0] THEN RETURN FALSE; END; (* quick test *)
    IF same(S,substring) THEN RETURN TRUE; END;
    Str.Concat(S2,substring,blank);
    IF Str.Pos(S,S2)=0 THEN RETURN TRUE; END;
    Str.Concat(S2,substring,tabul);
    IF Str.Pos(S,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END atstart;

PROCEDURE atend (substring,S : ARRAY OF CHAR   ) : BOOLEAN ;
VAR
    S2 : str128;
    len,lensub:CARDINAL;
BEGIN
    lensub:=Str.Length(substring);
    len:=Str.Length(S);
    IF len < lensub THEN RETURN FALSE; END;
    IF S[len-lensub] # substring[0] THEN RETURN FALSE; END; (* quick test *)
    IF same(S,substring) THEN RETURN TRUE; END;

    INC(lensub); (* we'll add a blank *)
    IF len < lensub THEN RETURN FALSE; END;
    Str.Concat(S2,blank,substring);
    IF Str.Pos(S,S2)=(len-lensub) THEN RETURN TRUE; END;
    Str.Concat(S2,tabul,substring);
    IF Str.Pos(S,S2)=(len-lensub) THEN RETURN TRUE; END;
    RETURN FALSE;
END atend;

PROCEDURE atstartandend (sub1,sub2,S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    len,sublen : CARDINAL;
    R : str128;
BEGIN
    (*
    IF atstart(sub1,S) THEN
        len:=Str.Length(S);
        sublen:=Str.Length(sub2);
        IF len >= sublen THEN
            Str.Slice(R, S, len-sublen, sublen);
            RETURN same(R,sub2);
        END;
    END;
    RETURN FALSE;
    *)
    RETURN ( atstart(sub1,S) AND atend(sub2,S) );
END atstartandend;

PROCEDURE herebutnotalone ( sub1,sub2,S:ARRAY OF CHAR  ):BOOLEAN ;
BEGIN
    IF Str.Pos(S,sub1)=MAX(CARDINAL) THEN RETURN FALSE; END;
    IF Str.Pos(S,sub2)=MAX(CARDINAL) THEN RETURN FALSE; END;
    (* ok, we've got both : now check if commenting code *)
    IF atstart(sub1,S) THEN
        IF atend(sub2,S) THEN
            RETURN FALSE;
        ELSE
            RETURN TRUE;
        END;
    ELSE
        IF atend(sub2,S) THEN
            RETURN TRUE;
        ELSE
            RETURN TRUE;
        END;
    END;
END herebutnotalone;

PROCEDURE isSeparationLine (S:ARRAY OF CHAR   ):BOOLEAN;
CONST
    allowed  = "(*)"+blank+tabul+dash+equal;
    openrem  = "(*";
    closerem = "*)";
    lenrem   = 2;
VAR
    group:str2;
    len:CARDINAL;
    ok:BOOLEAN;
BEGIN
    ok:=FALSE;
    IF verifyString(S,allowed)=FALSE THEN RETURN ok;END;
    LtrimBlanks(S);
    RtrimBlanks(S);
    Str.Slice(group,S,0,lenrem);
    IF same(group,openrem)=FALSE THEN RETURN ok;END;
    Str.Delete(S,0,lenrem);
    len:=Str.Length(S);
    IF len < lenrem THEN RETURN ok;END;
    Str.Slice(group,S,len-lenrem,lenrem);
    IF same(group,closerem)=FALSE THEN RETURN ok;END;
    S[len-lenrem]:=charnull;

    ReplaceChar(S,blank,"");
    ReplaceChar(S,tabul,"");

    IF verifyString(S,dash) THEN RETURN TRUE; END;
    RETURN verifyString(S,equal);
END isSeparationLine;

(* ------------------------------------------------------------ *)

(*
    this line contains both code and remarks possibly in succession or nested
    handle "!* *!" and "!* !* *! *!" and "!* *! !* *!"
    adapted from procline() in MOD2THM v1.0
*)

PROCEDURE dmpmecooked (S:ARRAY OF CHAR   );
CONST
    delimiters            = "(*)";
    openrem               = "(*";
    closerem              = "*)";
    lenrem                = 2;
VAR
    dmped,cpos,i,len,remdepth:CARDINAL;
    ch,stringdelimiter:CHAR;
    group:str2;
    parsingstate : (waitingdata,instring,inremark);
BEGIN
    remdepth:=0; (* //V10N *)
    dmped:=0;
    len:=Str.Length(S);
    cpos:=1-1;
    parsingstate:=waitingdata;
    LOOP
        IF cpos >= len THEN EXIT; END;
        ch:=S[cpos];
        CASE parsingstate OF
        | waitingdata:
            CASE ch OF
            | "(":
                Str.Slice(group,S,cpos,lenrem);
                IF same(group,openrem) THEN
                    INC(remdepth);
                    INC(cpos); (* pass "*" *)
                    parsingstate:=inremark;
                ELSE
                    WrStr(ch);INC(dmped);
                END;
            | singlequote,doublequote:
                stringdelimiter:=ch;
                parsingstate:=instring;
                WrStr(ch); INC(dmped);
            ELSE
                WrStr(ch); INC(dmped);
            END;

        | instring:
            WrStr(ch); INC(dmped);
            IF ch=stringdelimiter THEN parsingstate:=waitingdata; END;

        | inremark:
            CASE ch OF
            | "(" :
                Str.Slice(group,S,cpos,lenrem);
                IF same(group,openrem) THEN
                    INC(remdepth);
                    INC(cpos);
                END;
            | "*" :
                Str.Slice(group,S,cpos,lenrem);
                IF same(group,closerem) THEN
                    INC(cpos); (* pass ")" *)
                    IF remdepth # 0 THEN (* should always be here *)
                        DEC(remdepth);
                        IF remdepth = 0 THEN parsingstate:=waitingdata;END;
                    END;
                ELSE
                    (* WrStr(ch); //V10N *) (* INC(dmped); *)
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cpos);
    END;
    IF dmped # 0 THEN WrLn; END;
END dmpmecooked;

(* ------------------------------------------------------------ *)

TYPE
    tagremtype = (tagonlycode,tagcodehere,tagrem,tagINrem,tagsepline);

PROCEDURE dmpme (okdmp,enclosed,unrem:BOOLEAN;
                n:LONGCARD;tag:tagremtype;S:ARRAY OF CHAR   );
VAR
    R:str16;
    stag:str2;
BEGIN
    IF unrem THEN
        CASE tag OF
        | tagcodehere:  dmpmecooked(S);
        | tagonlycode:  WrStr(S);WrLn;
        | tagsepline :  WrStr(S);WrLn;
        ELSE ; (* //ISO fixed silly requirement *) END;
    ELSE
        IF okdmp THEN
            CASE tag OF
            | tagcodehere : stag:=sTagCodeHere;
            | tagrem      : stag:=sTagREM;
            | tagINrem    : stag:=sTagINrem;
            | tagonlycode : stag:=sTagOnlyCode; (* should never happen here *)
            ELSE ; (* //ISO fixed silly requirement *) END;
            R:="~ ~ ";
            Str.Subst(R,"~",num2str( CARDINAL(n),winum," "));
            Str.Subst(R,"~",stag);
            WrStr(R);
            IF enclosed THEN WrStr(doublequote); END;
            WrStr(S);
            IF enclosed THEN WrStr(doublequote); END;
            WrLn;
        END;
    END;
END dmpme;

(* adapted from LCOUNT.MOD v1.0f countLines() *)

PROCEDURE dodump (enclosed,unrem,keepseplines:BOOLEAN;f : pathtype);
VAR
    hin : FIO.File;
    comments,currline: LONGCARD;
    S,SORG : str4096;
    levels:CARDINAL;
    wasREMark:BOOLEAN;
    okdmp:BOOLEAN;
BEGIN
    okdmp:=TRUE;

    currline :=0;
    levels := 0;

    comments := 0;

    hin := FIO.OpenRead(f);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        wasREMark:=TRUE; (* it's easier to set this variable to false ! *)
        FIO.RdStr(hin,S);
        IF ((S[0]=charnull) AND FIO.EOF) THEN EXIT; END;
        INC(currline);
        Str.Copy(SORG,S);
        LtrimBlanks(S); RtrimBlanks(S);
        IF Str.Length(S) = 0 THEN
            wasREMark:=FALSE;
            dmpme(NOT(okdmp),enclosed,unrem,currline,tagonlycode,SORG);
        ELSE
            (* ugly, unable to parse complex cases but who cares ? *)
            IF same(S,modularemopen) THEN (* "( *" alone *)
                INC(levels);
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
            ELSIF same(S,modularemclose) THEN (* "* )" alone *)
                IF levels > 0 THEN DEC(levels);END; (* yes, this test should not be necessary *)
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
            ELSIF atstartandend(modularemopen,modularemclose,S) THEN (* "( *...* )" *)
                (* //FIXME : separation line *)
                IF unrem THEN
                    IF isSeparationLine(S) THEN
                        IF keepseplines THEN
                            dmpme(okdmp,enclosed,unrem,currline,tagsepline,SORG);
                        END;
                    ELSE
                        dmpme(okdmp,enclosed,unrem,currline,tagcodehere,SORG);
                    END;
                ELSE
                    INC(comments);
                    dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
                END;

            ELSIF herebutnotalone(modularemopen,modularemclose,S) THEN
                IF levels = 0 THEN
                    wasREMark:=FALSE;
                    dmpme(okdmp,enclosed,unrem,currline,tagcodehere,SORG); (* show it but let know it's counted *)
                ELSE
                    INC(comments);
                    dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
                END;
            ELSIF atstart(modularemopen,S) THEN (* "( *..." *)
                INC(levels);
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);
            ELSIF atend(modularemclose,S) THEN (* "...* )" *)
                IF levels > 0 THEN DEC(levels); END; (* yes, this test should not be necessary *)
                INC(comments);
                dmpme(okdmp,enclosed,unrem,currline,tagrem,SORG);

            ELSE
                IF levels = 0 THEN
                    wasREMark:=FALSE;
                    dmpme(NOT(okdmp),enclosed,unrem,currline,tagonlycode,SORG);
                ELSE
                    INC(comments);
                    dmpme(okdmp,enclosed,unrem,currline,tagINrem,SORG);
                END;
            END;

        END;
    END;
    FIO.Close(hin);
END dodump;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ugly hack *)

PROCEDURE dofilter (tofile:BOOLEAN; src:pathtype;onMatch,offString:ARRAY OF CHAR   );
CONST
    (* extremely unlikely to already exists ! *)
    tmpf8 = "~TMP~M2~";
    tmpe3 = ".TMP";
VAR
    S:str4096;
    state:(waiting,inheader,done);
    hin,hout:FIO.File;
    u,d,n,e,target,tmpcanonical:pathtype;
BEGIN
    qdSplitAllPath(src, u,d,n,e);
    Lib.MakeAllPath(target,u,d,n,extBAK);
    Lib.MakeAllPath(tmpcanonical,u,d,tmpf8,tmpe3);

    IF tofile THEN
        hout:=FIO.Create(target);
        FIO.AssignBuffer(hout,ioBufferOut);
    END;

    hin := FIO.OpenRead(src);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    state:=waiting;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        IF ((S[0]=0C) AND FIO.EOF) THEN EXIT; END;
        CASE state OF
        | waiting:
            IF Str.Match(S,onMatch) THEN
                state:=inheader;
            ELSE
                IF tofile THEN
                    FIO.WrStr(hout,S);FIO.WrLn(hout);
                ELSE
                    WrStr(S);WrLn;
                END;
            END;
        | inheader:
            IF Str.Match(S,offString) THEN
                IF tofile THEN
                    FIO.WrStr(hout,S);FIO.WrLn(hout);
                ELSE
                    WrStr(S);WrLn;
                END;
                state:=done;
            END;
        | done:
            IF tofile THEN
                FIO.WrStr(hout,S);FIO.WrLn(hout);
            ELSE
                WrStr(S);WrLn;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;

    END;
    FIO.Close(hin);
    IF tofile THEN
        FIO.Close(hout);
        IF FIO.Exists(tmpcanonical) THEN
            fileSetRW(tmpcanonical);
            FIO.Erase(tmpcanonical);
        END;
        FIO.Rename(src,tmpcanonical);        (* .MOD becomes .tmp *)
        FIO.Rename(target,src);              (* .org becomes .MOD *)
        FIO.Rename(tmpcanonical,target);     (* .tmp becomes .org *)
        WrStr("+++ Created  : ");WrStr(src);WrLn;
        WrStr("::: Original : ");WrStr(target);WrLn;
    END;
END dofilter;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we won't warn about illegal code : we assume it's ok *)

PROCEDURE doChkPastEnd (src:pathtype;patlibstart,patstart,patend:ARRAY OF CHAR);
VAR
    hin:FIO.File;
    state:(waiting,gotname,gotend,datapastend);
    S:str4096;
    modulename,maybe:str128;
BEGIN
    hin := FIO.OpenRead(src);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    state:=waiting;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        IF ((S[0]=0C) AND FIO.EOF) THEN EXIT; END;
        CASE state OF
        | waiting:
            IF Str.Match(S,patstart) THEN
                argv(modulename, S,2,FALSE);
                ReplaceChar(modulename,semicolon,"");
                state:=gotname;
            ELSIF Str.Match(S,patlibstart) THEN
                argv(modulename, S,3,FALSE);
                ReplaceChar(modulename,semicolon,"");
                state:=gotname;
            END;
        | gotname:
            IF Str.Match(S,patend) THEN
                argv(maybe,  S,2,FALSE);
                ReplaceChar(maybe,dot,"");
                IF same(modulename,maybe) THEN state:=gotend; END;
            END;
        | gotend:
            IF same(S,"")=FALSE THEN state:=datapastend; EXIT;END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    FIO.Close(hin);
    IF state=datapastend THEN
        WrStr("::: Data past end of program : ");WrStr(src);WrLn;
    END;
END doChkPastEnd;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    remIDtype = (remcodehere,remrem,remINrem);

CONST
    firstEntry = 1; (* 1..count *)
TYPE
    ptrToEntry = POINTER TO entryType;
    entryType = RECORD
        next   : ptrToEntry;
        linenum: CARDINAL;
        remID  : remIDtype;
        slen   : CARDINAL;
        string : CHAR;      (* here, after other data, because variable length *)
    END;

PROCEDURE getfileentry (VAR R:ARRAY OF CHAR; VAR remID:remIDtype; VAR linenum:CARDINAL;
                        getall:BOOLEAN; n:CARDINAL; firstInList:ptrToEntry);
VAR
    i,len:CARDINAL;
    newInList:ptrToEntry;
    S:str4096; (* what about LFN, eh ? ;-) *)
BEGIN
    newInList := firstInList;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:=firstEntry TO n DO
         newInList := newInList^.next;
    END;
    IF getall THEN
        len         := newInList^.slen;
        Lib.FastMove( SYSTEM.ADR(newInList^.string),SYSTEM.ADR(S),len);
        S[len]      := 0C; (* REQUIRED safety ! *)
        Str.Copy(R,S); (* yep, we cannot fill R directly *)
        remID       := newInList^.remID;
    END;
    linenum     := newInList^.linenum;
END getfileentry;

PROCEDURE freeList (anchor:ptrToEntry);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrToEntry;
BEGIN
    firstInList := anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
         len         := CARDINAL(newInList^.slen);
         needed      := SIZE(entryType)-SIZE(CHAR)+len;
         firstInList := firstInList^.next;
         DEALLOCATE (newInList,needed);
         newInList := firstInList;
    END
END freeList;

PROCEDURE loadRemarks (VAR anchor:ptrToEntry;
                      dbg:BOOLEAN;f:pathtype):CARDINAL;
VAR
    ok:BOOLEAN;
    CrashAndBurn:(Bangles,avoided);
    v:LONGCARD;
    lastEntry,len,needed : CARDINAL;
    newInList : ptrToEntry;
    S:str4096;
    p,linenum,count:CARDINAL;
    tag:str16;
    hin:FIO.File;
    whatline,whattag:str16;
    remID : remIDtype;
BEGIN
    hin:=FIO.OpenRead(f);
    FIO.AssignBuffer(hin,ioBufferIn);
    lastEntry := firstEntry-1;
    anchor:=NIL;
    CrashAndBurn:=avoided;
    LOOP
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;

        argv(whatline, S,1,FALSE );
        argv(whattag , S,2,FALSE );

        count:=0;
        IF same(whattag,sTagCodeHere) THEN INC(count); remID:=remcodehere; END;
        IF same(whattag,sTagREM)      THEN INC(count); remID:=remrem; END;
        IF same(whattag,sTagINrem)    THEN INC(count); remID:=remINrem; END;
        ok:=(count = 1);

        IF ok THEN
            count:=Str.Pos(S,whattag) + taglen-1 +1;
            Str.Delete(S,0,count);
            LtrimBlanks(S); RtrimBlanks(S);
            ok:=Str.Match(S,dquote+"*"+dquote);
        END;

        IF ok THEN
            v:=Str.StrToCard(whatline,10,ok); (* assume ok *)
            linenum:=CARDINAL(v);
            (* IO.WrCard( linenum,wi);WrStr(tag);WrStr(S);WrLn; *)

            S[Str.Length(S)-1] := charnull;
            Str.Delete(S,0,1);

            INC(lastEntry);
            IF lastEntry=MAX(CARDINAL) THEN CrashAndBurn:=Bangles; EXIT; END;
            len:=Str.Length(S);
            needed:=SIZE(entryType)-SIZE(CHAR)+len;
            (* IF Available(needed)=FALSE THEN CrashAndBurn:=Bangles; EXIT; END; *)
            CASE lastEntry OF
            | firstEntry :
                ALLOCATE( anchor,needed);
                newInList := anchor;
            ELSE
                ALLOCATE(newInList^.next,needed);
                newInList :=newInList^.next;
            END;
            Lib.FastMove( SYSTEM.ADR(S),SYSTEM.ADR(newInList^.string),len);
            newInList^.slen    := len;
            newInList^.remID   := remID;
            newInList^.linenum := linenum;
            newInList^.next    := NIL;
        ELSE
            IF dbg THEN
                WrStr('-- Problem ! "');
                WrStr(whatline);
                WrStr(" ");
                WrStr(whattag);
                WrStr(" ");
                WrStr(S);WrStr('"');WrLn;
            END;
        END;
    END;
    FIO.Close(hin);
    CASE CrashAndBurn OF
    | Bangles : RETURN MAX(CARDINAL);
    | avoided:  RETURN lastEntry;
    ELSE ; (* //ISO fixed silly requirement *) END;
END loadRemarks;

(* we expect (no, we require) ordered lines *)

PROCEDURE doapply (dbg:BOOLEAN; file,remfile:pathtype ):BOOLEAN;
VAR
    i,lastEntry:CARDINAL;
    anchor:ptrToEntry;
    S,S2:str4096;
    linenum:CARDINAL;
    currline:CARDINAL;
    hin:FIO.File;
    remID:remIDtype;
    stag:str16;
BEGIN
    lastEntry:=loadRemarks(anchor, dbg,remfile);
    IF lastEntry=MAX(CARDINAL) THEN RETURN FALSE; END;

    IF dbg THEN
        WrLn;
        FOR i:=firstEntry TO lastEntry DO
            getfileentry(S,remID,linenum,  TRUE,i,anchor);

            IO.WrCard( linenum,winum);
            WrStr(" ");
            CASE remID OF
            | remcodehere: stag:=sTagCodeHere;
            | remrem:      stag:=sTagREM;
            | remINrem:    stag:=sTagINrem;
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrStr(stag);
            WrStr(" ");
            WrStr(S);WrLn;
        END;
    END;

    hin:=FIO.OpenRead(file);
    FIO.AssignBuffer(hin,ioBufferIn);
    currline:=0;
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        (* was IF FIO.EOF THEN EXIT; END; *)
        IF ((S[0]=charnull) AND FIO.EOF) THEN EXIT; END;
        INC(currline);

        i:=firstEntry;
        LOOP
            IF i> lastEntry THEN EXIT; END;
            getfileentry(S2,remID,linenum,FALSE,i,anchor);
            IF currline=linenum THEN
                getfileentry(S,remID,linenum,TRUE,i,anchor);
                EXIT;
            END;
            INC(i);
        END;
        WrStr(S);WrLn;
    END;
    FIO.Close(hin);

    freeList(anchor);

    RETURN TRUE;
END doapply;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    patstring = "*~*~*";

PROCEDURE grabnextstring (VAR Z,S:ARRAY OF CHAR   ):BOOLEAN;
VAR
    p,q:CARDINAL;
    strdelim:CHAR;
    pat:str16;
BEGIN
    p:=Str.CharPos(S,doublequote);
    q:=Str.CharPos(S,singlequote);
    IF p = MAX(CARDINAL) THEN
        IF q = MAX(CARDINAL) THEN
            RETURN FALSE;           (* no quote at all *)
        ELSE
            strdelim:=singlequote;
        END;
    ELSE
        IF q = MAX(CARDINAL) THEN
            strdelim:=doublequote;
        ELSE
            IF p < q THEN
                strdelim:=doublequote;
            ELSE
                strdelim:=singlequote;
            END;
        END;
    END;
    pat:=patstring;
    ReplaceChar(pat,"~",strdelim);
    IF Str.Match(S,pat)=FALSE THEN RETURN FALSE; END; (* only one quote *)

    Str.Delete(S,0,p+1);
    p:=Str.CharPos(S,strdelim);
    IF p = MAX(CARDINAL) THEN RETURN FALSE;END; (* cannot happen here, see supra *)
    Str.Slice(Z,S,0,p);
    Str.Delete(S,0,p+1);

    Str.Append(Z,strdelim);
    Str.Prepend(Z,strdelim);

    RETURN TRUE ;
END grabnextstring;

PROCEDURE dostrings (stringsonly,dotrim:BOOLEAN; f:pathtype);
CONST
    separ  = " ::: ";
    separM = "  :: ";
VAR
    hin : FIO.File;
    currline,n: CARDINAL;
    S,SORG,Z: str4096;
    ok,okdq,oksq:BOOLEAN;
    pat:str16;
BEGIN
    currline :=0;

    hin := FIO.OpenRead(f);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        IF ((S[0]=charnull) AND FIO.EOF) THEN EXIT; END;
        INC(currline);
        IF stringsonly THEN
            Str.Copy(SORG,S);
            n:=0;
            LOOP
                IF grabnextstring(Z, S)=FALSE THEN EXIT; END;
                INC(n);
            END;
            ok:=(n # 0);
        ELSE
            (* this is very quick and dirty a test but it should do here *)
            pat:=patstring;
            ReplaceChar(pat,"~",doublequote);
            okdq := Str.Match(S,pat);
            pat:=patstring;
            ReplaceChar(pat,"~",singlequote);
            oksq := Str.Match(S,pat);
            ok:= (okdq OR oksq);
        END;
        IF ok THEN
            IF stringsonly THEN
                Str.Copy(S,SORG);
                n:=0;
                LOOP
                    IF grabnextstring(Z, S)=FALSE THEN EXIT; END;
                    INC(n);
                    IO.WrCard( currline,winum);
                    IF n = 1 THEN
                        WrStr(separ);
                    ELSE
                        WrStr(separM);
                    END;
                    WrStr(Z);WrLn;
                END;
            ELSE
                IO.WrCard( currline,winum);WrStr(separ);
                IF dotrim THEN
                    LtrimBlanks(S);
                    RtrimBlanks(S);
                END;
                WrStr(S);WrLn;
            END;
        END;
    END;
    FIO.Close(hin);

END dostrings;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

CONST
    firstFile = 1;
    maxFile   = firstFile-1+maxFileCount;
VAR
    fileentry : ARRAY [firstFile..maxFile] OF pathtype;

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (noskip:BOOLEAN;spec:pathtype):CARDINAL;
VAR
    lastentry:CARDINAL;
    ok,found:BOOLEAN;
    errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    lastentry:=firstEntry-1;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    LOOP
        IF found=FALSE THEN EXIT;END;
        Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        IF noskip THEN
            excludeme2 := FALSE;
        ELSE
            excludeme2 := isReservedPattern (entryname,skippedextensions );
        END;
        IF NOT(excludeme1 OR excludeme2) THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                INC(lastentry);
                IF lastentry > maxFile THEN lastentry:=MAX(CARDINAL);EXIT;END;
                fileentry[lastentry]:=entryname;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN lastentry;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    shortcuts = arobase+exclam+dollar+pound+ampersand;
CONST
    minparm = 1;
    maxparm = 2;
VAR
    parm : ARRAY [minparm..maxparm] OF str128;
    mfile,remfile,basedir:pathtype;
    cmd : (undefined,dump,apply,www,wwwfile,chkpastend,unrem,dumpstrings);
    S,R:str128;
    Z:str1024;
    lastparm,lastfile,i,opt:CARDINAL;
    stringsonly,keepseplines,enclosed,dotrim,DEBUG:BOOLEAN;
BEGIN
    FIO.IOcheck:=FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone;
    WrLn;

    DEBUG        := FALSE;
    enclosed     := TRUE;
    keepseplines := FALSE;
    stringsonly  := FALSE;
    dotrim       := FALSE;
    cmd          := undefined;

    lastparm := minparm-1;
    FOR i:=1 TO Lib.ParamCount() DO
        Lib.ParamStr(S,i);cleanCLI(S); ReplaceChar(S,dquote,"");
        IF isOption(S) = FALSE THEN
            IF Str.Length(S)=SIZE(CHAR) THEN
                IF Str.CharPos(shortcuts,S[0]) # MAX(CARDINAL) THEN
                    Str.Prepend(S,dash);
                END;
            END;
        END;
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   arobase+delim+"W"+delim+"WWW"+delim+
                                   exclam+delim +"F"+delim+"FILTER"+delim+
                                   dollar+delim +"C"+delim+"CHECK"+delim+
                                   pound+delim  +"X"+delim+"UNREM"+delim+"NOREM"+delim+
                                   "XX"+delim+
                                   "K"+delim+"SEPARATION"+delim+
                                   "Q"+delim+"UNQUOTE"+delim+"NOQUOTES"+delim+"RAW"+delim+
                                   ampersand+delim+"S"+delim+"STRINGS"+delim+
                                   "SS"+delim+
                                   "N"+delim+"NOCODE"+delim+
                                   "l"+delim+"lfn"+delim+
                                   "T"+delim+"TRIM"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3      : WrStr(help);
                           abort("");
            | 4,5,6      : cmd:=www;
            | 7,8,9      : cmd:=wwwfile;
            | 10,11,12   : cmd:=chkpastend;
            | 13,14,15,16: cmd:=unrem;
            | 17         : cmd:=unrem;        keepseplines:=TRUE;
            | 18,19      :                    keepseplines:=TRUE;
            | 20,21,22,23: enclosed:=FALSE;
            | 24,25,26   : cmd:=dumpstrings;
            | 27         : cmd:=dumpstrings;  stringsonly := TRUE;
            | 28,29      :                    stringsonly := TRUE;
            | 30,31      : ;
            | 32,33      : dotrim := TRUE;
            | 34         : DEBUG := TRUE;
            ELSE
                abort("Illegal option !");
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort("Too many parameters !");END;
            parm[lastparm]:=S;
        END;
    END;

    CASE lastparm OF
    | minparm-1:
        (* abort("Parameters expected !"); *)
        WrStr(help);
        abort("");
    | minparm:
        Str.Copy(mfile, parm[minparm]);
        IF cmd = undefined THEN
            cmd:=dump;
        ELSE
            IF enclosed=FALSE THEN abort("-q requires syntax 1 !");END;
        END;
    | minparm+1:
        Str.Copy(mfile, parm[minparm]);
        Str.Copy(remfile,parm[minparm+1]);
        IF cmd = undefined THEN
            cmd:=apply;
        ELSE
            abort("Unexpected command for syntax 2 !");
        END;
        IF enclosed=FALSE THEN abort("-q requires syntax 1 !");END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF chkUD(mfile)=FALSE THEN abort("Bad file specification !");END;

    IF same(mfile,dot) THEN abort('For user safety, "." is not allowed !');END;
    IF same(mfile,stardotstar) THEN abort('For user safety, "*.*" is not allowed !');END;
    IF Str.Match(mfile,"*"+antislash) THEN Str.Append(mfile,stardotstar); END;
    IF Str.RCharPos(mfile,dot)=MAX(CARDINAL) THEN Str.Append(mfile,extMOD);END;

    IF chkJoker(mfile)=FALSE THEN
        IF isDirectory ( mfile) THEN
            fixDirectory(mfile);
            Str.Append(mfile,stardotstar);
        END;
    END;
    makebase(mfile,basedir);

    CASE cmd OF
    | apply:
        IF chkJoker(mfile) THEN abort("Jokers are not allowed with syntax 2 !");END;
    ELSE
        ;
    END;

    (* let's go now ! *)

    lastfile := buildFileList(FALSE, mfile); (* FALSE is noskip *)
    CASE lastfile OF
    | firstFile-1:
         Str.Concat(S,"No match for ",mfile);Str.Append (S," !");
         abort(S);
    | MAX(CARDINAL) :
         Str.Concat(S,"Too many files match ",mfile);Str.Append(S," !");
         abort(S);
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | apply:                                             (* syntax 2 *)
        IF chkJoker(remfile) THEN
            S:="Jokers not allowed !";
            abort(S);
        END;
        IF FIO.Exists(remfile)=FALSE THEN
            Str.Concat(S,remfile," does not exist !");
            abort(S);
        END;
        IF doapply(DEBUG,mfile,remfile)=FALSE THEN
            S:="Storage.ALLOCATE() failure while reading edited remarks !";
            abort(S);
        END;
    ELSE
        FOR i:=firstFile TO lastfile DO
            Str.Concat(mfile,basedir,fileentry[i]);
            IF lastfile > firstFile THEN
                Z:=dumpsepline;
                Str.Subst(Z,dollar,mfile);
                WrLn;
                WrLn;
                WrStr(Z);WrLn;
                WrLn;
                WrLn;
            END;
            CASE cmd OF
            | dump:        dodump(enclosed,FALSE,FALSE,mfile);
            | www:         dofilter(FALSE,mfile,patWWW,patREMclose);
            | wwwfile:     dofilter(TRUE ,mfile,patWWW,patREMclose);
            | chkpastend:  doChkPastEnd(mfile,patLibStart,patProgStart,patProgEnd);
            | unrem:       dodump(enclosed,TRUE,keepseplines,mfile);
            | dumpstrings: dostrings(stringsonly,dotrim,mfile);
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    abort("");
END remMOD.


