(* ---------------------------------------------------------------
Title         Q&D Slow Sort
Overview      self-explanatory !
Notes         Yet Another "Reinvent a not so round wheel" example !

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -r

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs
Wish List     by length ? bah... sort, explode by length, rebuild
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 29 Mar 22 v0.9b added -l
PhG  9 Jul 20 v0.9a from SSORT v1.0a for DOS
PhG  8 Jul 20 an ugly really Q&D port from SSORT v1.0 for DOS
	      maxentry no longer 10000 10000*6 (will crash if more !!!)
--------------------------------------------------------------- *)

MODULE sSort32;

IMPORT IO;
IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT Storage;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;




CONST
    strmaxlen     = 4096-1;
    sMaxLen       = "4095";
    sEOL          = "*";
    sRANGE        = "[1..4095]";
CONST
    sTMP          = "TMP";
    sTEMP         = "TEMP";
    sTMPDIR       = "TMPDIR";
    sTEMPDIR      = "TEMPDIR";
CONST
    extBKBANG     = ".BK!";
    extBAK        = ".BAK";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    ext7Z         = ".7Z";

    sSkippedExtensions = extBKBANG+delim+extBAK+delim+
                         extCOM+delim+extEXE+delim+
                         extDLL+delim+
                         extZIP+delim+extARJ+delim+extLZH+delim+ext7Z;
CONST
    progEXEname   = "SSORT32";
    progTitle     = "Q&D Slow Sort (Win32)";
    progVersion   = "v0.9b (from v1.0b for DOS)";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errParmOverflow = 3;
    errExpected     = 4;
    errJoker        = 5;
    errNotFound     = 6;
    errNotFile      = 7;
    errExt          = 8;
    errStrTooLong   = 9;
    errRO           = 10;
    errBadRange     = 11;
    errRangeDefinedAlready = 12;
    errAborted      = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <file> [option]..."+nl+
nl+
"  -z       Heap sort method (default is Quick sort method)"+nl+
"  -d[d]    ignore accents and case (-dd = -d -w)"+nl+
"  -l[l]    sort by line length"+nl+
"  -w[w]    force internal conversion from Win OEM to DOS ASCII (-ww = -w -d)"+nl+
"  -r|-i    reverse sort order"+nl+
"  -o:#[,#] use only specified columns range (-c:#[,#] = -o:#[,#])"+nl+
"  -i:#[,#] ignore specified columns range"+nl+
(* //XDSTS "  -r       ignore <file> read-only attribute"+nl+ *)
"  -b       keep <file> backup (default is to overwrite <file>)"+nl+
"  -c       force temporary files to be created in current directory"+nl+
"  -v       verbose"+nl+
"  -x       disable LFN support even if available"+nl+
nl+
"This program slowly sorts <file> DOS ASCII text lines."+nl+
nl+
"a) Temporary files are created in directory specified by, in that order,"+nl+
"   "+sTMP+", "+sTEMP+", "+sTMPDIR+", "+sTEMPDIR+" environment variables"+nl+
"   (if none of these variables is defined, or if -w option is specified,"+nl+
"   current directory will be used instead)."+nl+
"b) "+sSkippedExtensions+" are ignored."+nl+
"c) A line cannot be longer than "+sMaxLen+" bytes."+nl+
"d) Note whatever the original line separator, it will become cr+lf ($0d0a)."+nl+
'e) -b option creates a backup with "'+extBKBANG+'" extension.'+nl+
"f) Range for -o:#[,#] and -i:#[,#] options is 1-based."+nl+
'   It can be specified as "column,count" or "first_column..last_column".'+nl+
'   Default count or last_column is "'+sEOL+'" for "end of line".'+nl+
"g) Please note this program does not handle any form of redirection."+nl+
"h) Safety requires free disk space to be about 3 times the size of <file>."+nl+
"i) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :        WrStr(helpmsg);
    | errOption :      S:='Illegal "~" option !';
    | errParmOverflow: S:='"~" is one parameter too many !';
    | errExpected:     S:='"~" expected !';
    | errJoker:        S:='"~" cannot contain any joker !';
    | errNotFound:     S:='"~" does not exist !';
    | errNotFile:      S:='"~" is not a file !';
    | errExt:          S:='"~" has a forbidden extension !';
    | errStrTooLong:   S:='"~" contains at least one line longer than '+sMaxLen+' characters !';
    | errRO:           S:='"~" is read-only !';
    | errBadRange:     S:='"~" is illegal or not in valid '+sRANGE+" range !";
    | errRangeDefinedAlready:
                       S:="Columns range cannot be defined more than once !";
    | errAborted:      S:="Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* //XDSTS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT(e);
END abort;

(* as usual, buffers must be outside procedure, else program bombs ! *)

CONST
    IObufferSize      = (16 * 512) + FIO.BufferOverhead;
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
TYPE
    ioBufferType      = ARRAY [firstIObufferByte..lastIObufferByte] OF SYSTEM.BYTE; (* for private M2 IO *)
VAR
    ioBufferIn, ioBufferInAlt, ioBufferOut : ioBufferType;

CONST
    firstDataByte = 0;
    lastDataByte  = 32*512-1;
    dataBufferSize= lastDataByte - firstDataByte + 1;
TYPE
    dataBufferType = ARRAY [firstDataByte..lastDataByte] OF SYSTEM.BYTE;
VAR
    dataBuffer : dataBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a *)

TYPE
    chardef   = RECORD
                    Code    : SYSTEM.BYTE;
                    Flag    : CHAR;
                    MapChar : SYSTEM.BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

(* ripped and adapted from old WIN2PC v1.0a *)

CONST
    TwinTOpc  = CharTable{
    chardef{000H, "=", 000H},
    chardef{001H, "=", 001H},
    chardef{002H, "=", 002H},
    chardef{003H, "=", 003H},
    chardef{004H, "=", 004H},
    chardef{005H, "=", 005H},
    chardef{006H, "=", 006H},
    chardef{007H, "=", 007H},
    chardef{008H, "=", 008H},
    chardef{009H, "!", 009H},
    chardef{00AH, "=", 00AH},
    chardef{00BH, "=", 00BH},
    chardef{00CH, "=", 00CH},
    chardef{00DH, "=", 00DH},
    chardef{00EH, "=", 00EH},
    chardef{00FH, "=", 00FH},
    chardef{010H, "=", 010H},
    chardef{011H, "=", 011H},
    chardef{012H, "=", 012H},
    chardef{013H, "=", 013H},
    chardef{014H, "=", 014H},
    chardef{015H, "=", 015H},
    chardef{016H, "=", 016H},
    chardef{017H, "=", 017H},
    chardef{018H, "=", 018H},
    chardef{019H, "=", 019H},
    chardef{01AH, "=", 01AH},
    chardef{01BH, "=", 01BH},
    chardef{01CH, "=", 01CH},
    chardef{01DH, "=", 01DH},
    chardef{01EH, "=", 01EH},
    chardef{01FH, "=", 01FH},
    chardef{020H, "=",  " "},
    chardef{021H, "=",  "!"},
    chardef{022H, "=",  '"'},
    chardef{023H, "=",  "#"},
    chardef{024H, "=",  "$"},
    chardef{025H, "=",  "%"},
    chardef{026H, "=",  "&"},
    chardef{027H, "=",  "'"},
    chardef{028H, "=",  "("},
    chardef{029H, "=",  ")"},
    chardef{02AH, "=",  "*"},
    chardef{02BH, "=",  "+"},
    chardef{02CH, "=",  ","},
    chardef{02DH, "=",  "-"},
    chardef{02EH, "=",  "."},
    chardef{02FH, "=",  "/"},
    chardef{030H, "=",  "0"},
    chardef{031H, "=",  "1"},
    chardef{032H, "=",  "2"},
    chardef{033H, "=",  "3"},
    chardef{034H, "=",  "4"},
    chardef{035H, "=",  "5"},
    chardef{036H, "=",  "6"},
    chardef{037H, "=",  "7"},
    chardef{038H, "=",  "8"},
    chardef{039H, "=",  "9"},
    chardef{03AH, "=",  ":"},
    chardef{03BH, "=",  ";"},
    chardef{03CH, "=",  "<"},
    chardef{03DH, "=",  "="},
    chardef{03EH, "=",  ">"},
    chardef{03FH, "=",  "?"},
    chardef{040H, "=",  "@"},
    chardef{041H, "=",  "A"},
    chardef{042H, "=",  "B"},
    chardef{043H, "=",  "C"},
    chardef{044H, "=",  "D"},
    chardef{045H, "=",  "E"},
    chardef{046H, "=",  "F"},
    chardef{047H, "=",  "G"},
    chardef{048H, "=",  "H"},
    chardef{049H, "=",  "I"},
    chardef{04AH, "=",  "J"},
    chardef{04BH, "=",  "K"},
    chardef{04CH, "=",  "L"},
    chardef{04DH, "=",  "M"},
    chardef{04EH, "=",  "N"},
    chardef{04FH, "=",  "O"},
    chardef{050H, "=",  "P"},
    chardef{051H, "=",  "Q"},
    chardef{052H, "=",  "R"},
    chardef{053H, "=",  "S"},
    chardef{054H, "=",  "T"},
    chardef{055H, "=",  "U"},
    chardef{056H, "=",  "V"},
    chardef{057H, "=",  "W"},
    chardef{058H, "=",  "X"},
    chardef{059H, "=",  "Y"},
    chardef{05AH, "=",  "Z"},
    chardef{05BH, "=",  "["},
    chardef{05CH, "=",  "\"},
    chardef{05DH, "=",  "]"},
    chardef{05EH, "=",  "^"},
    chardef{05FH, "=",  "_"},
    chardef{060H, "=",  "`"},
    chardef{061H, "=",  "a"},
    chardef{062H, "=",  "b"},
    chardef{063H, "=",  "c"},
    chardef{064H, "=",  "d"},
    chardef{065H, "=",  "e"},
    chardef{066H, "=",  "f"},
    chardef{067H, "=",  "g"},
    chardef{068H, "=",  "h"},
    chardef{069H, "=",  "i"},
    chardef{06AH, "=",  "j"},
    chardef{06BH, "=",  "k"},
    chardef{06CH, "=",  "l"},
    chardef{06DH, "=",  "m"},
    chardef{06EH, "=",  "n"},
    chardef{06FH, "=",  "o"},
    chardef{070H, "=",  "p"},
    chardef{071H, "=",  "q"},
    chardef{072H, "=",  "r"},
    chardef{073H, "=",  "s"},
    chardef{074H, "=",  "t"},
    chardef{075H, "=",  "u"},
    chardef{076H, "=",  "v"},
    chardef{077H, "=",  "w"},
    chardef{078H, "=",  "x"},
    chardef{079H, "=",  "y"},
    chardef{07AH, "=",  "z"},
    chardef{07BH, "=",  "{"},
    chardef{07CH, "=",  "|"},
    chardef{07DH, "=",  "}"},
    chardef{07EH, "=",  "~"},
    chardef{07FH, "x",  " "},
    chardef{080H, "x",  " "},
    chardef{081H, "x",  " "},
    chardef{082H, "x",  " "},
    chardef{083H, "x",  " "},
    chardef{084H, "x",  " "},
    chardef{085H, "x",  " "},
    chardef{086H, "x",  " "},
    chardef{087H, "x",  " "},
    chardef{088H, "x",  " "},
    chardef{089H, "x",  " "},
    chardef{08AH, "x",  " "},
    chardef{08BH, "x",  " "},
    chardef{08CH, "x",  " "},
    chardef{08DH, "x",  " "},
    chardef{08EH, "x",  " "},
    chardef{08FH, "x",  " "},
    chardef{090H, "x",  " "},
    chardef{091H, "=",  "'"},
    chardef{092H, "=",  "'"},
    chardef{093H, "x",  " "},
    chardef{094H, "x",  " "},
    chardef{095H, "x",  " "},
    chardef{096H, "x",  " "},
    chardef{097H, "x",  " "},
    chardef{098H, "x",  " "},
    chardef{099H, "x",  " "},
    chardef{09AH, "x",  " "},
    chardef{09BH, "x",  " "},
    chardef{09CH, "x",  " "},
    chardef{09DH, "x",  " "},
    chardef{09EH, "x",  " "},
    chardef{09FH, "x",  " "},
    chardef{0A0H, "=",  " "},
    chardef{0A1H, "=",  ""},
    chardef{0A2H, "=",  ""},
    chardef{0A3H, "=",  ""},
    chardef{0A4H, "=",  ""},
    chardef{0A5H, "=",  ""},
    chardef{0A6H, "=",  "|"},
    chardef{0A7H, "!", 015H},
    chardef{0A8H, "?",  " "},
    chardef{0A9H, "!",  ""},
    chardef{0AAH, "=",  ""},
    chardef{0ABH, "=",  ""},
    chardef{0ACH, "=",  ""},
    chardef{0ADH, "=",  "-"},
    chardef{0AEH, "!",  ""},
    chardef{0AFH, "!",  "-"},
    chardef{0B0H, "=",  ""},
    chardef{0B1H, "=",  ""},
    chardef{0B2H, "=",  ""},
    chardef{0B3H, "?",  " "},
    chardef{0B4H, "?",  " "},
    chardef{0B5H, "=",  ""},
    chardef{0B6H, "!", 014H},
    chardef{0B7H, "?",  " "},
    chardef{0B8H, "?",  " "},
    chardef{0B9H, "?",  " "},
    chardef{0BAH, "=",  ""},
    chardef{0BBH, "=",  ""},
    chardef{0BCH, "=",  ""},
    chardef{0BDH, "=",  ""},
    chardef{0BEH, "?",  " "},
    chardef{0BFH, "=",  ""},
    chardef{0C0H, "=",  "A"},
    chardef{0C1H, "=",  "A"},
    chardef{0C2H, "=",  "A"},
    chardef{0C3H, "=",  "A"},
    chardef{0C4H, "=",  ""},
    chardef{0C5H, "=",  ""},
    chardef{0C6H, "=",  ""},
    chardef{0C7H, "=",  ""},
    chardef{0C8H, "=",  "E"},
    chardef{0C9H, "=",  ""},
    chardef{0CAH, "=",  "E"},
    chardef{0CBH, "=",  "E"},
    chardef{0CCH, "=",  "I"},
    chardef{0CDH, "=",  "I"},
    chardef{0CEH, "=",  "I"},
    chardef{0CFH, "=",  "I"},
    chardef{0D0H, "?",  " "},
    chardef{0D1H, "=",  ""},
    chardef{0D2H, "=",  "O"},
    chardef{0D3H, "=",  "O"},
    chardef{0D4H, "=",  "O"},
    chardef{0D5H, "=",  "O"},
    chardef{0D6H, "=",  ""},
    chardef{0D7H, "=",  "X"},
    chardef{0D8H, "=",  "O"},
    chardef{0D9H, "=",  "U"},
    chardef{0DAH, "=",  "U"},
    chardef{0DBH, "=",  "U"},
    chardef{0DCH, "=",  ""},
    chardef{0DDH, "=",  "Y"},
    chardef{0DEH, "?",  " "},
    chardef{0DFH, "=",  ""},
    chardef{0E0H, "=",  ""},
    chardef{0E1H, "=",  ""},
    chardef{0E2H, "=",  ""},
    chardef{0E3H, "=",  "a"},
    chardef{0E4H, "=",  ""},
    chardef{0E5H, "=",  ""},
    chardef{0E6H, "=",  ""},
    chardef{0E7H, "=",  ""},
    chardef{0E8H, "=",  ""},
    chardef{0E9H, "=",  ""},
    chardef{0EAH, "=",  ""},
    chardef{0EBH, "=",  ""},
    chardef{0ECH, "=",  ""},
    chardef{0EDH, "=",  ""},
    chardef{0EEH, "=",  ""},
    chardef{0EFH, "=",  ""},
    chardef{0F0H, "?",  " "},
    chardef{0F1H, "=",  ""},
    chardef{0F2H, "=",  ""},
    chardef{0F3H, "=",  ""},
    chardef{0F4H, "=",  ""},
    chardef{0F5H, "=",  "o"},
    chardef{0F6H, "=",  ""},
    chardef{0F7H, "=",  ""},
    chardef{0F8H, "=",  "o"},
    chardef{0F9H, "=",  ""},
    chardef{0FAH, "=",  ""},
    chardef{0FBH, "=",  ""},
    chardef{0FCH, "=",  ""},
    chardef{0FDH, "=",  "y"},
    chardef{0FEH, "?",  " "},
    chardef{0FFH, "=",  ""}};

(* we don't care about flag here *)

PROCEDURE remap2ascii (ch:CHAR):CHAR;
BEGIN
    RETURN TwinTOpc[ ORD(ch) ].MapChar;
END remap2ascii;

(* ------------------------------------------------------------ *)

(*
PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;
*)

CONST
    TlowerSORT= "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "cueaaaaceeeiiiaaeooouuyou     "+ (* no "" for sort *)
             "aiounn                          "+
             "                                "+
             "                               ";

PROCEDURE LowerCaseSORT (VAR S : ARRAY OF CHAR);
CONST
    ignore   = " ";
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerSORT);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCaseSORT;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO CARDINAL(ABS(wi)) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmt (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmt;


CONST
    sINFO  = "::: ";
    wiINFO = 24;

PROCEDURE padstr (VAR R:ARRAY OF CHAR;padwi:CARDINAL  );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Str.Length(R)+1 TO padwi DO Str.Append(R," ");END;
    Str.Append(R," : ");
END padstr;

PROCEDURE dmpval ( S:ARRAY OF CHAR;v:CARDINAL  );
VAR
    R:str128;
    i:CARDINAL;
BEGIN
    Str.Concat(R,sINFO,S);
    padstr(R,wiINFO);
    Str.Append(R,fmt(v,10,1," ",""));
    WrStr(R);WrLn;
END dmpval;

PROCEDURE dmpbool (S,Y,N:ARRAY OF CHAR;v:BOOLEAN);
VAR
    R:str128;
BEGIN
    Str.Concat(R,sINFO,S);
    padstr(R,wiINFO);
    IF v THEN
        Str.Append(R,Y);
    ELSE
        Str.Append(R,N);
    END;
    WrStr(R);WrLn;
END dmpbool;

PROCEDURE dmp (S,S2:ARRAY OF CHAR);
VAR
    R:str128;
BEGIN
    Str.Concat(R,sINFO,S);
    padstr(R,wiINFO);
    Str.Append(R,S2);
    WrStr(R);WrLn;
END dmp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    MINCOLUMN = 1;
    MAXCOLUMN = strmaxlen; (* 4095 *)
    sMAXCOL   = sMaxLen; (* "4095" *)
TYPE
    rangetype = (norange,rangeignore,rangeonly);

(* legal : column,count  first..last  first-last  column *)

PROCEDURE parseRange (VAR firstcol,countcol:CARDINAL; VAR range:rangetype;
                     newrange:rangetype;R:ARRAY OF CHAR):CARDINAL;
VAR
    S2:str128;
    p:CARDINAL;
    rangesep,pattern,snum:str16;
    lc:LONGCARD;
    try : (trycount, tryrange, tryrangealt, trycolumn);
BEGIN
    IF range # norange THEN RETURN errRangeDefinedAlready;END;

    GetString(R,S2);

    firstcol  := MINCOLUMN-1;
    countcol  := MAXCOLUMN;

    try:=trycount;
    LOOP
        CASE try OF
        | trycount:    rangesep:=",";
        | tryrange:    rangesep:="..";
        | tryrangealt: rangesep:="-";
        | trycolumn:   rangesep:=",";
                       Str.Append(S2,rangesep);Str.Append(S2,sMAXCOL);
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Concat(pattern,"*",rangesep); Str.Append(pattern,"*");
        IF Str.Match(S2, pattern) THEN
            p:=Str.Pos(S2,rangesep);
            IF p > 0 THEN
                Str.Slice(snum,S2,0,p);
                Str.Delete(S2,0,p);
            ELSE
                snum:="";
            END;
            Str.Subst(S2,rangesep,"");
            Str.Prepend(snum,"="); (* ugly trick *)
            IF GetLongCard(snum,lc)=FALSE THEN RETURN errBadRange;END;
            IF ( (lc < MINCOLUMN) OR (lc > MAXCOLUMN) ) THEN RETURN errBadRange;END;
            firstcol:=CARDINAL(lc)-1; (* remember : 1-based for user, 0-based for Str library *)

            IF same(S2,sEOL) THEN S2:=sMAXCOL;END;
            Str.Concat(snum,"=",S2);
            IF GetLongCard(snum,lc)=FALSE THEN RETURN errBadRange;END;
            IF ( (lc < MINCOLUMN) OR (lc > MAXCOLUMN) ) THEN RETURN errBadRange;END;
            CASE try OF
            | trycount,trycolumn:
                countcol:=CARDINAL(lc);
            | tryrange, tryrangealt:
                IF CARDINAL(lc) < (firstcol+1) THEN RETURN errBadRange;END;
                countcol:=(CARDINAL(lc)-1) -firstcol+1;
            ELSE ; (* //ISO fixed silly requirement *) END;
            range:=newrange;
            EXIT;
        END;
        IF try=trycolumn THEN EXIT; END;
        INC(try);
    END;
    IF range # newrange THEN RETURN errBadRange;END;
    RETURN errNone;
END parseRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(* we don't check for TMP validity *)

PROCEDURE buildWorkDir (forcecurrent:BOOLEAN; VAR workdir:pathtype);
CONST
    numvars = 4;
VAR
    i:CARDINAL;
    D:str128;
    drive:SHORTCARD;
    unit:str2;
    current:pathtype;
BEGIN
    IF forcecurrent THEN
        i:=numvars+1;
    ELSE
        i:=1;
        LOOP
            CASE i OF
            | 1: D:=sTMP;
            | 2: D:=sTEMP;
            | 3: D:=sTMPDIR;
            | 4: D:=sTEMPDIR;
            ELSE ; (* //ISO fixed silly requirement *) END;
            Lib.EnvironmentFind(D,workdir);
            IF same(workdir,"")=FALSE THEN EXIT; END;
            INC(i);
            IF i > numvars THEN EXIT; END;
        END;
    END;
    IF i > numvars THEN
        drive := FIO.GetDrive();
        doGetCurrent(drive, unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(workdir,unit,current);
    END;
    fixDirectory(workdir);
END buildWorkDir;

(* ------------------------------------------------------------ *)

PROCEDURE chkExt (S,skipem:ARRAY OF CHAR ):BOOLEAN;
VAR
    p,pb,n : CARDINAL;
    ext:str16;
BEGIN
    p:=Str.RCharPos(S, "." );
    IF p=MAX(CARDINAL) THEN RETURN TRUE; END;
    Str.Delete(S, 0,p+1);
    Str.Caps(S);

    pb:=0;
    n:=0;
    LOOP
        isoleItemS(ext, skipem,delim,n);
        Str.Subst(ext, "." , "" ); (* remove leading dot *)
        IF same(ext,"") THEN EXIT; END;
        IF same(ext,S) THEN INC(pb);END;
        INC(n);
    END;
    RETURN (pb=0);
END chkExt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* 0001 to FFFF, could also be smaller range extension .001 to .FFF *)

PROCEDURE buildTarget (VAR dst:pathtype; count:CARDINAL;workdir:pathtype);
CONST
    pat="$DEL~.TMP";
BEGIN
    Str.Copy(dst,pat);
    Str.Subst(dst,"~",fmt(count,16,4,"0",""));
    Str.Prepend(dst,workdir);
END buildTarget;

TYPE
    strPtr = POINTER TO str4096;
CONST
    minentry = 1;
    maxentry = 10000*6; (* should DO *)
    indexA   = 1;
    indexB   = 2;
    strsafety= 1;
TYPE
    strarrayType = ARRAY[minentry..maxentry] OF strPtr;

VAR
    orgentry   : strarrayType; (* avoid object too big *)
    cookedentry: strarrayType;
VAR
    orgstr    : ARRAY[indexA..indexB] OF str4096; (* globerks as to avoid crash in PROC *)
    cookedstr : ARRAY[indexA..indexB] OF str4096; (* working copies of orgstr *)

CONST
    rcStrTooLong = MAX(CARDINAL);
    rcAlcatraz   = MAX(CARDINAL)-1;

(* ------------------------------------------------------------ *)

TYPE
    options      = (forceAZ,oemtoascii,reverse,altsort,bylength);
    setOfOptions = SET OF options;

VAR
    globsortmode : setOfOptions; (* ugly globerk for doLess() and isLess() *)

PROCEDURE doSwap (i,j:CARDINAL);
VAR
    tmp:strPtr;
BEGIN
    tmp:=orgentry[i];
    orgentry[i]:=orgentry[j];
    orgentry[j]:=tmp;

    tmp:=cookedentry[i];
    cookedentry[i]:=cookedentry[j];
    cookedentry[j]:=tmp;
END doSwap;

(* use globerks : work on working copies *)

PROCEDURE doLess (i,j:CARDINAL):BOOLEAN;
VAR
    ok,okx:BOOLEAN;
    leni,lenj:CARDINAL;
BEGIN
    ok :=  (Str.Compare(cookedentry[i]^,cookedentry[j]^) < 0 );
    IF (bylength IN globsortmode) THEN
        leni:=Str.Length(cookedentry[i]^);lenj:=Str.Length(cookedentry[j]^);
        IF leni # lenj THEN
            ok:=(leni < lenj);
        END;
    END;
    IF (reverse IN globsortmode) THEN ok:=NOT(ok);END;
    RETURN ok;
END doLess;

(* use globerks : work on working copies *)

PROCEDURE isLess (iA,jB:CARDINAL ):BOOLEAN;
VAR
    ok,okx:BOOLEAN;
    leni,lenj:CARDINAL;
BEGIN
    ok:= (Str.Compare(cookedstr[iA],cookedstr[jB]) < 0 );
    IF (bylength IN globsortmode) THEN
        leni:=Str.Length(cookedstr[iA]);lenj:=Str.Length(cookedstr[jB]);
        IF leni # lenj THEN
            ok:=(leni < lenj);
        END;
    END;
    IF (reverse IN globsortmode) THEN ok:=NOT(ok);END;
    RETURN ok;
END isLess;

(* ------------------------------------------------------------ *)

PROCEDURE processMe (ndx,firstcol,countcol:CARDINAL;
                    sortmode:setOfOptions;whatrange:rangetype):CARDINAL;
VAR
    i,len:CARDINAL;
    ch:CHAR;
BEGIN
    CASE whatrange OF
    | norange:
        Str.Copy(cookedstr[ndx],orgstr[ndx]);
    | rangeignore:
        Str.Copy(cookedstr[ndx],orgstr[ndx]);
        Str.Delete(cookedstr[ndx],firstcol,countcol);
    | rangeonly:
        Str.Slice(cookedstr[ndx],orgstr[ndx],firstcol,countcol);
    ELSE ; (* //ISO fixed silly requirement *) END;
    len:=Str.Length(cookedstr[ndx]);
    IF (oemtoascii IN sortmode) THEN
        FOR i:=1 TO len DO
            ch:=cookedstr[ndx][i-1];
            cookedstr[ndx][i-1]:= remap2ascii (ch);
        END;
    END;
    IF (forceAZ IN sortmode) THEN LowerCaseSORT(cookedstr[ndx]);END;
    RETURN len;
END processMe;

(* ------------------------------------------------------------ *)

PROCEDURE doPresort (sortmode:setOfOptions;whatrange:rangetype;
                    firstcol,countcol:CARDINAL;
                    src,workdir:pathtype ):CARDINAL;
CONST
    msgSorting = "Sorting ~... ";
VAR
    hin,hout:FIO.File;
    ndx,count,i,rc:CARDINAL;
    dst:pathtype;
    fsize,anchor:LONGCARD;
    dmp,done:BOOLEAN;
    msg:str80;
    len,needed,lencooked,neededcooked:CARDINAL;
BEGIN
    globsortmode:=sortmode; (* ugly but vital for doLess() ! *)
    FOR i:=minentry TO maxentry DO orgentry[i]:=NIL;END;

    hin:=FIO.Open(src);
    FIO.AssignBuffer(hin,ioBufferIn);
    fsize:=FIO.Size(hin);

    dmp:=FALSE;
    count:=1;
    ndx:=minentry-1;

    LOOP
        anchor:=FIO.GetPos(hin);
        done:=NOT ( anchor < fsize);
        IF done THEN
            dmp:=TRUE;
        ELSE
            FIO.RdStr(hin,orgstr[indexA]);
            len:=Str.Length(orgstr[indexA]);
            IF len > strmaxlen THEN rc:=rcStrTooLong;EXIT;END;

            INC(ndx);
            IF ndx > maxentry THEN
                DEC(ndx);
                FIO.Seek(hin,anchor);
                dmp:=TRUE;
            ELSE
                lencooked:=processMe(indexA,firstcol,countcol,sortmode,whatrange);
                neededcooked := lencooked+strsafety;
                (*
                    two calls seem required,
                    for checking added sizes can force a crash
                    when allocating
                *)
                needed := len+strsafety;
                (* IF Available(needed) THEN *)
		            ALLOCATE(orgentry[ndx],needed);
    		        Lib.Move(SYSTEM.ADR(orgstr[indexA]), SYSTEM.ADR(orgentry[ndx]^),needed);
                    (* IF Available(neededcooked) THEN *)
    		            ALLOCATE(cookedentry[ndx],neededcooked);
                        Lib.Move(SYSTEM.ADR(cookedstr[indexA]),SYSTEM.ADR(cookedentry[ndx]^),neededcooked);
                        dmp:=FALSE;
                    (* ELSE
                        DEALLOCATE(orgentry[ndx],needed);
                        DEC(ndx);
                        FIO.Seek(hin,anchor);
                        dmp:=TRUE;
                    END; *)
                (* ELSE
                    DEC(ndx);
                    FIO.Seek(hin,anchor);
                    dmp:=TRUE;
                END; *)
            END;
        END;
        IF dmp THEN
            Str.Copy(msg,msgSorting);
            Str.Subst(msg,"~",fmt(count,10,1," ",""));
            video(msg,TRUE);

            IF (altsort IN sortmode) THEN
            	Lib.HSort(ndx,doLess,doSwap); (* handle globsortmode *)
	    ELSE
            	Lib.QSort(ndx,doLess,doSwap); (* handle globsortmode *)
	    END;

            buildTarget(dst,count,workdir);
            hout:=FIO.Create(dst);
            FIO.AssignBuffer(hout,ioBufferOut);
            FOR i:=minentry TO ndx DO
                FIO.WrStr(hout,orgentry[i]^);FIO.WrLn(hout);

                len:=Str.Length(orgentry[i]^);
                needed:=len+strsafety;
                DEALLOCATE(orgentry[i],needed);
                lencooked:=Str.Length(cookedentry[i]^);
                needed:=lencooked+strsafety;
                DEALLOCATE(cookedentry[i],needed);
            END;
            FIO.Close(hout);
            video(msg,FALSE);
            IF done THEN rc:=count;EXIT;END;
            IF ChkEscape() THEN rc:=rcAlcatraz;EXIT;END;
            INC(count);
            ndx:=minentry-1;
        END;
    END;

    FIO.Close(hin);
    CASE rc OF
    | rcStrTooLong,rcAlcatraz:
        FOR i:=1 TO count DO
            buildTarget(dst,i,workdir);
            IF FIO.Exists(dst) THEN FIO.Erase(dst); END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN rc;
END doPresort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dbg (S1,S2:ARRAY OF CHAR  );
BEGIN
    WrStr("::: ");WrStr(S1);WrStr("  ");WrStr(S2);WrLn;
END dbg;

PROCEDURE doMerge (DEBUG:BOOLEAN;sortmode:setOfOptions;whatrange:rangetype;
                  ndxsrc,ndxsrcalt, ndxdst,firstcol,countcol:CARDINAL;
                  workdir:pathtype);
CONST
    msgMerging = "Merging ~ and ~ to ~...";
VAR
    hin,hinalt,hout:FIO.File; (* yes, yes, we could use indexed ARRAY *)
    msg:str80;
    src,srcalt,dst:pathtype;
    anchor,anchoralt:LONGCARD;
    fsize,fsizealt:LONGCARD;
    ok,done,donealt:BOOLEAN;
    state:(waiting,compare,dump,dumpalt);
    lencooked:CARDINAL;
BEGIN
    globsortmode:=sortmode; (* ugly but vital for isLess() ! *)
    Str.Copy(msg,msgMerging);
    Str.Subst(msg,"~",fmt(ndxsrc,10,1," ",""));
    Str.Subst(msg,"~",fmt(ndxsrcalt,10,1," ",""));
    Str.Subst(msg,"~",fmt(ndxdst,10,1," ",""));
    video(msg,TRUE);

    buildTarget(src,ndxsrc,workdir);
    buildTarget(srcalt,ndxsrcalt,workdir);
    buildTarget(dst,ndxdst,workdir);

    hin:=FIO.OpenRead(src);
    FIO.AssignBuffer(hin,ioBufferIn);
    hinalt:=FIO.OpenRead(srcalt);
    FIO.AssignBuffer(hinalt,ioBufferInAlt);
    hout:=FIO.Create(dst);
    FIO.AssignBuffer(hout,ioBufferOut);

    fsize:=FIO.Size(hin);
    fsizealt:=FIO.Size(hinalt);

    Str.Copy(orgstr[indexA],"");
    Str.Copy(orgstr[indexB],"");

    state:=waiting;
    LOOP
        anchor    := FIO.GetPos(hin);
        done      := NOT ( anchor < fsize);
        anchoralt := FIO.GetPos(hinalt);
        donealt   := NOT ( anchoralt < fsizealt);

        CASE state OF
        | waiting:
            IF done THEN
                IF donealt THEN EXIT;END;
                state:=dumpalt;
            ELSE
                FIO.RdStr(hin,orgstr[indexA]);
                lencooked:=processMe(indexA,firstcol,countcol,sortmode,whatrange);
                state:=compare;
            END;
        | compare:
            IF donealt THEN
                FIO.WrStr(hout,orgstr[indexA]);FIO.WrLn(hout);
                state:=dump;
            ELSE
                FIO.RdStr(hinalt,orgstr[indexB]);
                lencooked:=processMe(indexB,firstcol,countcol,sortmode,whatrange);

                ok:= isLess(indexA,indexB); (* use cookedstr, handle globsortmode *)

                IF ok THEN
                    FIO.WrStr(hout,orgstr[indexA]);FIO.WrLn(hout);
                    FIO.Seek(hinalt,anchoralt); (* ugly but NOT slower than grabalt flag *)
                    state:=waiting;
                ELSE
                    FIO.WrStr(hout,orgstr[indexB]);FIO.WrLn(hout);
                END;
            END;
        | dump:
            IF done THEN EXIT;END;
            FIO.RdStr(hin,orgstr[indexA]);
            FIO.WrStr(hout,orgstr[indexA]);FIO.WrLn(hout);
        | dumpalt:
            IF donealt THEN EXIT;END;
            FIO.RdStr(hinalt,orgstr[indexB]);
            FIO.WrStr(hout,orgstr[indexB]);FIO.WrLn(hout);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    FIO.Close(hout);
    FIO.Close(hinalt);
    FIO.Close(hin);
    video(msg,FALSE);

    IF NOT(DEBUG) THEN
        FIO.Erase(src);
        FIO.Erase(srcalt);
    END;
END doMerge;

PROCEDURE doPostSort (DEBUG:BOOLEAN;sortmode:setOfOptions;whatrange:rangetype;
                     firstcol,countcol,count:CARDINAL;
                     src,workdir:pathtype ):CARDINAL;
VAR
    i:CARDINAL;
BEGIN
    i:=1;
    LOOP
        IF i >= count THEN EXIT;END;
        INC(count);
        doMerge(DEBUG,sortmode,whatrange,i,i+1,count,firstcol,countcol,workdir);
        INC(i,2);
        IF ChkEscape() THEN i:=rcAlcatraz;EXIT;END;
    END;
    RETURN i;
END doPostSort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE copyFile (verbose:BOOLEAN;src,dst:pathtype );
CONST
    msgCopying = "Copying, please wait... ";
VAR
    hin,hout:FIO.File;
    got:CARDINAL;
BEGIN
    hin:=FIO.OpenRead(src);
    FIO.AssignBuffer(hin,ioBufferIn);
    hout:=FIO.Create(dst);
    FIO.AssignBuffer(hout,ioBufferOut);
    IF verbose THEN video(msgCopying,TRUE); END;
    LOOP
        got:=FIO.RdBin(hin,dataBuffer,dataBufferSize);
        IF got = 0 THEN EXIT; END;
        FIO.WrBin(hout,dataBuffer,got);
        IF got # dataBufferSize THEN EXIT; END;
    END;
    IF verbose THEN video(msgCopying,FALSE); END;
    FIO.Close(hout);
    FIO.Close(hin);
END copyFile;

PROCEDURE doFinal (DEBUG,keepbackup,wasRO:BOOLEAN;totalcount:CARDINAL;
                   src,workdir:pathtype );
CONST
    showmsg=TRUE;
VAR
    sorted:pathtype;
    u,d,n,e,ne:pathtype;
BEGIN
    buildTarget(sorted,totalcount,workdir); (* last tmp created *)
    fileSetRW(src);
    IF keepbackup THEN
        qdSplitAllPath(src, u,d,n,e);
        Lib.MakeAllPath(ne,u,d,n,extBKBANG); (* just NE does NOT work !!! *)
        FIO.Rename(src,ne);
    ELSE
        FIO.Erase(src);
    END;
    copyFile(showmsg,sorted,src); (* src is target *)
    IF NOT(DEBUG) THEN FIO.Erase(sorted); END;
    (* IF wasRO THEN fileSetRO(src);END; *)
END doFinal;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWorking = "Working, please wait... ";
VAR
    sortmode : setOfOptions;
VAR
    i,opt,parmcount:CARDINAL;
    S,R:pathtype;
    src,workdir:pathtype;
    state:(waiting,gotsource);
    wasRO,ignoreRO,verbose,keepbackup,forcecurrent:BOOLEAN;
    DEBUG:BOOLEAN;
    rc,count,totalcount,firstcol,countcol:CARDINAL;
    whatrange:rangetype;
BEGIN
    WrLn;
    FIO.IOcheck:=FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone;

    forcecurrent := FALSE;
    keepbackup   := FALSE;
    verbose      := FALSE;
    ignoreRO     := FALSE;
    whatrange    := norange;
    firstcol     := MINCOLUMN-1;
    countcol     := MAXCOLUMN;
    sortmode     := setOfOptions{};
    DEBUG        := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    state:=waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R,"?"+delim+"H"+delim+"HELP"+delim+
                                  "x"+delim+"lfn"+delim+
                                  "C"+delim+"CURRENT"+delim+
                                  "B"+delim+"BACKUP"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "r"+delim+"ro"+delim+"readonly"+delim+
                                  "I:"+delim+"IGNORE:"+delim+
                                  "O:"+delim+"ONLY:"+delim+
                                  "C:"+delim+"COLUMN:"+delim+
                                  "D"+delim+"DOS"+delim+"ASCII"+delim+
                                  "W"+delim+"WIN"+delim+"OEM"+delim+
                                  "I"+delim+"R"+delim+
                                  "DD"+delim+"WW"+delim+
				  "Z"+delim+"ALTSORT"+delim+"HEAP"+delim+"HEAPSORT"+delim+
				  "L"+delim+"LEN"+delim+"LENGTH"+delim+"LL"+delim+
                                  "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : ;
            | 6,7   : forcecurrent := TRUE;
            | 8,9   : keepbackup   := TRUE;
            | 10,11 : verbose      := TRUE;
            | 12,13,14: ;
            | 15,16 : rc:=parseRange (firstcol,countcol,whatrange,  rangeignore,R);
                      IF rc # errNone THEN abort(rc,S);END;
            | 17,18 : rc:=parseRange (firstcol,countcol,whatrange,  rangeonly,R);
                      IF rc # errNone THEN abort(rc,S);END;
            | 19,20 : rc:=parseRange (firstcol,countcol,whatrange,  rangeonly,R);
                      IF rc # errNone THEN abort(rc,S);END;

            | 21,22,23 : INCL (sortmode,forceAZ);
            | 24,25,26 : INCL (sortmode,oemtoascii);
            | 27,28 :    INCL (sortmode,reverse);
            | 29,30 :    INCL (sortmode,forceAZ); INCL(sortmode,oemtoascii);
            | 31,32,33,34:INCL(sortmode,altsort);
	    | 35,36,37,38:INCL(sortmode,bylength);
	    | 39  :   DEBUG        := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting:   Str.Copy(src,S);
            | gotsource: abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting:  abort(errExpected,"<file>");
    | gotsource : ;
    ELSE ; (* //ISO fixed silly requirement *) END;

    (* useLFN := ( useLFN AND fileSupportLFN() ); *)

    IF chkJoker(src) THEN abort(errJoker,src);END;
    IF FIO.Exists(src)=FALSE THEN abort(errNotFound,src);END;
    IF isDirectory(src) THEN abort(errNotFile,src);END;
    IF chkExt(src,sSkippedExtensions)=FALSE THEN abort(errExt,src);END;
    wasRO:=fileIsRO(src);
    IF wasRO THEN
        IF NOT(ignoreRO) THEN abort(errRO,src);END;
    END;

    buildWorkDir(forcecurrent,workdir);

    IF DEBUG THEN
        dmp     ("File",src);
        dmp     ("Workdir",workdir);
        dmpbool ("Local TMPdir"    , "yes"  , "no"   , forcecurrent);
        dmpbool ("Keep backup"     , "yes"  , "no"   , keepbackup);
        CASE whatrange OF
        | norange:    S:="none";
        | rangeonly:  S:="only";
        | rangeignore:S:="ignore";
        ELSE ; (* //ISO fixed silly requirement *) END;
        dmpbool ("Sort method"    ,  "Heap","Quick",altsort IN sortmode);
        dmp     ("Range mode"      , S);
        dmpval  ("First column"    , firstcol+1);
        dmpval  ("Column count"    , countcol);
        dmpbool ("Force [a..z] set", "yes" ,"no",forceAZ IN sortmode);
        dmpbool ("Win OEM to DOS ASCII"  , "yes" ,"no",oemtoascii IN sortmode);
	dmpbool ("By line length"  ,       "yes" ,"no",bylength IN sortmode);
        dmpbool ("Reverse"         , "yes" ,"no",reverse IN sortmode);
        WrLn;
    END;

    video(msgWorking,TRUE);
    count:=doPresort(sortmode,whatrange,firstcol,countcol,src,workdir);
    video(msgWorking,FALSE);
    CASE count OF
    | rcStrTooLong : abort(errStrTooLong,src);
    | rcAlcatraz   : abort(errAborted,"");
    ELSE ; (* //ISO fixed silly requirement *) END;

    video(msgWorking,TRUE);
    totalcount:=doPostSort (DEBUG,sortmode,whatrange,
                           firstcol,countcol,count,
                           src,workdir);
    video(msgWorking,FALSE);
    CASE totalcount OF
    | rcAlcatraz   : abort(errAborted,"");
    ELSE ; (* //ISO fixed silly requirement *) END;

    doFinal(DEBUG,keepbackup,wasRO,totalcount,src,workdir);

    IF DEBUG THEN
        dmpval ("Initial split count",count);
        dmpval ("Total split count",totalcount);
    END;

    abort(errNone,"");
END sSort32.



