(* ---------------------------------------------------------------
Title         Q&D Word/Token count
Overview
Usage
Notes
Bugs          not really a bug but a few files force a stack overflow
              thanks to deep recursion (discovered when parsing "roman 1..3999" output)
              solution is to run program twice, first with -o, then with -m

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -q
	      -f
	      -c

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Wish List     sort ? bah, let an external program take care of that point...
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 22 Jan 18 v0.9b bugfix : "*" would be changed to ".*" instead of "*.*"
PhG 14 Jan 17 v0.9a added -z
	      recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG  1 Apr 16 an ugly really Q&D port from WCOUNT v1.1 for DOS
--------------------------------------------------------------- *)

MODULE wCount32;

IMPORT FIO;
IMPORT Str;
IMPORT Lib;
IMPORT Storage;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;
*)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)


(*
PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;
*)


PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

CONST

    (* darn, we forgot non-French codes... but we don't care *)
    (* note all these tables are DOS ASCII ! *)

    ignore = " ";
    Tupper = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "CUEAAAACEEEIIIAAEOOOUUYOU     "+ (* use "ae" *)
             "AIOUNN                          "+
             "                                "+
             "                               ";

    Tlower = "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "ueaaaaeeeiiiaaeooouuyou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    TupperA= "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "AAEEEIIIOOUUY     "+
             "AIOU                          "+
             "                                "+
             "                                ";

    TlowerA= "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "Ҵı     "+
             "                          "+
             "                                "+
             "                               ";

    (*
    //FIXME : French table has not been fully checked yet
    we just try and fix annoying filenames
    *)

    TupperFR="                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "UAAAEEEIIIAOOOUUYOU     "+
             "AIOUNN                          "+
             "                                "+
             "                                ";

    TlowerFR="                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "uҴaiaooou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    Taz    = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "CueaaaaeeeiiiAAEooouuyOU     "+ (* yes we keep lower case "" *)
             "aiounN               AAA        "+
             "      aA          EEE III     I "+
             "O OOoO   UUUyY                 ";

(*
    Tasc   = "                                "+
             ' !"'+
                "#$%&'()*+,-./0123456789:;<=>?"+
             "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_"+
             "`abcdefghijklmnopqrstuvwxyz{|}~"+
             "Ҵ"+
             "ѳ"+
             ""+
             "";
*)


(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tupper);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tlower);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCase;

PROCEDURE UpperCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperA);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCaseAlt;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerA);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCaseAlt;

PROCEDURE UpperCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperFR);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCaseFR;

PROCEDURE LowerCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerFR);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCaseFR;

PROCEDURE ASCIIonly (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Taz);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END ASCIIonly;



(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;




(* ------------------------------------------------------------ *)

CONST
    wi               = 7; (* should do for LONGCARD width *)
    widashes         = "=======";
    modulaseparators = " (),=+-*<>/\[]^:;.";
    sBlanksSet       = "[$00..$20]";
    sModulaSet       = sBlanksSet+' + "'+modulaseparators+'" + quotes';
    sNotAZset        = "^[A..Z]";
CONST
    dotstar     = ".*";
    extRPT      = ".RPT";
    extCOM      = ".COM";
    extEXE      = ".EXE";
    extDLL      = ".DLL";
    extOVR      = ".OVR";
    extOVL      = ".OVL";
    extDRV      = ".DRV";
    extVXD      = ".VXD";
    extBIN      = ".BIN";
    extZIP      = ".ZIP";
    extARJ      = ".ARJ";
    extLZH      = ".LZH";
    skippedextensions = extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extVXD+delim+extBIN+delim+
                        extZIP+delim+extARJ+delim+extLZH+delim+extRPT;
CONST
    progEXEname   = "WCOUNT32";
    progTitle     = "Q&D Word/n-gram Counter (Win32)";
    progVersion   = "v0.9b (from v1.1a for DOS)";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone          = 0;
    errHelp          = 1;
    errOption        = 2;
    errTooManyParms  = 3;
    errMissingSpec   = 4;
    errTooManyMatches= 5;
    errNoMatch       = 6;
    errUpperLen      = 7;
    errLowerLen      = 8;
    errExactLen      = 9;
    errConflict      = 10;
    errNonsense      = 11;
    errAllocate      = 12;
    errMode          = 13;
    errJoker         = 14;
    errProblem       = 15;
    errBadSpec       = 16;
    errAborted       = 255;

PROCEDURE abort (e : CARDINAL; einfo:ARRAY OF CHAR);

    MODULE message;
    IMPORT Str;
    EXPORT msg3;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;

CONST
(*
 0        1         2         3         4         5         6         7         8
 12345678901234567890123456789012345678901234567890123456789012345678901234567890
*)
    msgHelp =
banner+nl+
nl+
"Syntax : "+progEXEname+" <file(s)> [option]..."+nl+
nl+
"This program reads tokens from specified text file(s) then builds frequencies."+nl+
'The "divide and conquer" approach is highly recommended !'+nl+
nl+
"-g    n-gram counter mode (default mode is word counter)"+nl+
"-l:#  n-gram lower length ([1..100], default is 1)"+nl+
"-u:#  n-gram upper length ([1..100], default is 2)"+nl+
"-e:#  n-gram exact length ([1..100], shortcut for -l:# -u:#)"+nl+
"-d    allow [A..Z0..9] (default is [A..Z])"+nl+
(* "-c    ignore case"+nl+ *)
"-a    ignore accents"+nl+
(* '-f    do not expand "" to "ae" nor "" to "AE"'+nl+ *)
"-b    set of token separators is "+sBlanksSet+nl+
"-k    set of token separators is "+sModulaSet+nl+
"-i    individual processing for each file (default is cumulative process)"+nl+
"-o    output raw data to video screen without storing to RAM (-q forced)"+nl+
"-m    make an analysis using sorted output file (only -t taken into account)"+nl+
"-x    do not show header"+nl+
"-l    do not show list"+nl+
"-t    do not show frequency table"+nl+
"-s    do not show summary"+nl+
"-z    include D field (D=C-N)"+nl+
nl+
"a) Please note this program processes files using DOS ASCII character set :"+nl+
"   files using Windows OEM character set are NOT supported"+nl+
"   (their conversion will be required prior to processing)."+nl+
"b) Note program may abort on a few files after creating an ERRORINF.$$$ file,"+nl+
"   for deep recursion may force a stack overflow."+nl+
"   Here is a workaround : first run program with -o option and redirect output,"+nl+
"   then run program with -m option on previously redirected sorted output."+nl+
"c) L is token length, N is occurrences count, C is ( L * N ), D is C-N."+nl+
"d) Unless -b or -k options, "+sNotAZset+" is default set of token separators."+nl+
"e) If program was aborted using Escape, return code is 255."+nl+
"f) Program will not process files with any of these extensions :"+nl+
"   "+skippedextensions+" for safety."+nl+
"g) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;


VAR
    S : str1024; (* oversized, was str256 *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(msgHelp);
    | errOption :
        msg3(S,'Unknown "',einfo,'" option !');
    | errTooManyParms:
        msg3(S,'Useless "',einfo,'" parameter !');
    | errMissingSpec:
        S := "Missing <file(s)> specification !";
    | errTooManyMatches:
        msg3(S,'Too many files match "',einfo,'" specification !');
    | errNoMatch:
        msg3(S,'No file matches "',einfo,'" filtered specification !');
    | errUpperLen:
        msg3(S,'Illegal "',einfo,'" n-gram upper length !');
    | errLowerLen:
        msg3(S,'Illegal "',einfo,'" n-gram lower length !');
    | errExactLen:
        msg3(S,'Illegal "',einfo,'" n-gram exact length !');
    | errConflict:
        S := "-e:# option is a nonsense with any of -u:# and -l:# options !";
    | errNonsense:
        Str.Concat(S,einfo," options are mutually exclusive !");
    | errAllocate:
        (* not very informative ! *)
        msg3(S,'Storage.ALLOCATE() would not store "',einfo,'" token !');
    | errMode:
        S := "-g option required with -l:#, -u:# and -e:# options !";
    | errJoker:
        S := "-m option will process one file only !";
    | errProblem:
        msg3(S,'Unexpected "',einfo,'" line !');
    | errBadSpec:
        msg3(S,'Illegal "',einfo,'" specification !');
    | errAborted:
        S := "Aborted by user !";
    ELSE
        S := "This is illogical, Captain ! ;-)";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dbg (DEBUG:BOOLEAN;S1,S2:ARRAY OF CHAR   );
CONST
    wi = 15;
    enquote=TRUE;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrStr("/// ");WrStr(S1);
        FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
        WrStr(" : ");
        IF enquote THEN WrStr(dquote);END;
        WrStr(S2);
        IF enquote THEN WrStr(dquote);END;
        WrLn;
    END;
END dbg;

(* taken almost verbatim from OLDNEW v1.1f code, out of weariness *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    (* IF Available(needed)=FALSE THEN RETURN FALSE; END; *)
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        noskip,DEBUG :BOOLEAN;
                        spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        IF noskip THEN
            excludeme2 := FALSE;
        ELSE
            excludeme2 := isReservedPattern (entryname,skippedextensions );
        END;
        IF NOT(excludeme1 OR excludeme2) THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                dbg(DEBUG,"Included",entryname);
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
            ELSE
                dbg(DEBUG,"Ignored",entryname);
            END;
        ELSE
            dbg(DEBUG,"Excluded",entryname);
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

(* ------------------------------------------------------------ *)

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

PROCEDURE WrFname (F:pathtype );
BEGIN
        WrStr(dquote);WrStr(F);WrStr(dquote);
END WrFname;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE wrQuoted (S:ARRAY OF CHAR);
BEGIN
    WrLn;WrStr(dquote);WrStr(S);WrStr(dquote);
END wrQuoted;

(* ------------------------------------------------------------ *)

PROCEDURE pad (wi:INTEGER;padchar:CHAR; VAR R:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Str.Length(R)+1 TO CARDINAL ( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Append(R,padchar);
        ELSE
            Str.Prepend(R,padchar);
        END;
    END;
END pad;

PROCEDURE lcToStr (wi:INTEGER;padchar:CHAR; n:LONGCARD):str80;
VAR
    ok:BOOLEAN;
    R:str80;
BEGIN
    Str.CardToStr ( n, R, 10, ok);
    pad (wi,padchar,R);
    RETURN R;
END lcToStr;

(* ------------------------------------------------------------ *)

CONST
    rem = ";";
    hdr = rem+" ";
VAR
    heapsizebefore : CARDINAL;


(* ------------------------------------------------------------ *)

CONST
    (* ignore = " "; *)

    Talpha = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "ueaaaaeeeiiiAAEooouuyOU     "+
             "aiounN                          "+
             "                                "+
             "                                ";
(*
PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;
*)

PROCEDURE removeAccents (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Talpha);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END removeAccents;

PROCEDURE isAlpha(ch:CHAR):BOOLEAN;
BEGIN
    RETURN map(ch,Talpha) # ignore;
END isAlpha;

PROCEDURE isOK (ch:CHAR;allowdigits:BOOLEAN) : BOOLEAN;
(*
CONST
    digits = "0123456789";
*)
BEGIN
    IF isAlpha(ch) THEN RETURN TRUE; END;
    IF allowdigits THEN
        RETURN (Str.CharPos(digits,ch) # MAX(CARDINAL));
    ELSE
        RETURN FALSE;
    END;
END isOK;

PROCEDURE isBlank(ch:CHAR):BOOLEAN;
BEGIN
    (*
    CASE ch OF
    | space,tabul,cr,lf:
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
    *)
    RETURN (ORD(ch) <= ORD(space));
END isBlank;

(*
PROCEDURE dofixae (VAR S : ARRAY OF CHAR):CARDINAL;
CONST
    LCae = ""; (* 145 *)
    UCae = ""; (* 146 *)
VAR
    i,p : CARDINAL;
    ch:CHAR;
    replace:str2;
BEGIN
    FOR i:=1 TO 2 DO
        CASE i OF
        | 1: ch:=LCae;replace:="ae";
        | 2: ch:=UCae;replace:="AE";
        ELSE ; (* //ISO fixed silly requirement *) END;
        LOOP
            p:=Str.CharPos(S,ch);
            IF p=MAX(CARDINAL) THEN EXIT; END;
            Str.Subst(S,ch,replace);
        END;
    END;
    RETURN Str.Length(S);
END dofixae;
*)

(* ------------------------------------------------------------ *)

TYPE
    pstr = POINTER TO tokendata;
    tokendata = RECORD
        total  : LONGCARD;
        len    : SHORTCARD;
        string : CHAR;
    END;
    NODE = POINTER TO tokentype; (* pointer to a wordnode structure *)
    tokentype = RECORD
        left,right : NODE;
        data       : pstr;
    END;

VAR
    gwordtree : NODE;
CONST
    mingram = 1;
    maxgram = 100;
    undefined=MAX(CARDINAL);
VAR
    (* avoid stack problems thanks to globerks *)
    gwcount,gtwcount:LONGCARD; (* unique tokens, total tokens *)
    gdump:BOOLEAN;
    gskipped,gfilesize:LONGCARD;
TYPE
    tokinfotype = RECORD
        uniques : LONGCARD;
        freq    : LONGCARD;
    END;

PROCEDURE initCounters (counts,showlist:BOOLEAN );
BEGIN
    IF counts THEN
        gwcount   :=0;
        gtwcount  :=0;
        gdump     :=showlist;
    ELSE
        gfilesize :=0;
        gskipped  :=0;
    END;
END initCounters;

PROCEDURE initTree ();
BEGIN
    gwordtree := NIL;
END initTree;

PROCEDURE killNode ( p:NODE);
VAR
    len,used:CARDINAL;
    tmp:pstr;
    pl,pr:NODE;
BEGIN
    IF p=NIL THEN RETURN;  END;
    tmp:=p^.data;
    len:=CARDINAL(tmp^.len);
    used:=SIZE(tokendata)-1+len;
    DEALLOCATE(tmp,used);
    pl:=p^.left;
    pr:=p^.right;
    DEALLOCATE(p,SIZE(tokentype));
    killNode( pl);
    killNode( pr);
END killNode;

PROCEDURE killTree ();
BEGIN
    killNode(gwordtree) ;
END killTree;

PROCEDURE strstore (VAR ok:BOOLEAN; S:ARRAY OF CHAR ): pstr;
VAR
    len,needed:CARDINAL;
    tmp:pstr;
BEGIN
    len:=Str.Length(S);
    needed:=SIZE(tokendata)-1+len;
    (*
    ok:=Storage.Available(needed);
    IF ok=FALSE THEN RETURN NIL;END;
    *)
    ALLOCATE(tmp, needed);
    tmp^.total:=1;
    tmp^.len := SHORTCARD(len);
    Lib.FastMove( SYSTEM.ADR(S),SYSTEM.ADR(tmp^.string),len);
    RETURN tmp;
END strstore;

PROCEDURE newnode (VAR p:NODE; snorm:ARRAY OF CHAR):BOOLEAN ;
VAR
    nlen,clen:CARDINAL;
    ok:BOOLEAN;
BEGIN
    (* IF Storage.Available( SIZE(tokentype) )=FALSE THEN RETURN FALSE; END; *)
    ALLOCATE (p,SIZE(tokentype));
    p^.left:=NIL;
    p^.right:=NIL;
    p^.data:=strstore(ok,snorm);
    RETURN ok;
END newnode;

PROCEDURE addnode (newptr:NODE);
VAR
    p:NODE;
    s1,s2:str128; (* oversized ! *)
    len:CARDINAL;
BEGIN
    IF gwordtree = NIL THEN
        gwordtree := newptr;
        RETURN;
    END;

	(* insert into binary tree for normal search *)

    p:=gwordtree;
    WHILE p # NIL DO
        len:=CARDINAL(p^.data^.len);
        Lib.FastMove( SYSTEM.ADR(p^.data^.string),SYSTEM.ADR(s1),len);
        s1[len]:=charnull;
        len:=CARDINAL(newptr^.data^.len);
        Lib.FastMove( SYSTEM.ADR(newptr^.data^.string),SYSTEM.ADR(s2),len);
        s2[len]:=charnull;
        IF Str.Compare(s1,s2) < 0 THEN
            IF p^.left # NIL THEN
                p := p^.left;
            ELSE
                p^.left := newptr;
                p := NIL;
            END;
        ELSE
            IF p^.right # NIL THEN
                p := p^.right;
            ELSE
                p^.right := newptr;
                p := NIL;
            END;
        END;
    END;

END addnode;

PROCEDURE findMatch (ID:ARRAY OF CHAR):NODE;
VAR
    p   : NODE;
    len : CARDINAL;
    rc  : INTEGER;

    matchID : str128; (* oversized ! *)
BEGIN
    p := gwordtree;
    WHILE p # NIL DO
        len:=CARDINAL(p^.data^.len);
        Lib.FastMove(SYSTEM.ADR(p^.data^.string)  ,SYSTEM.ADR(matchID), len);
        matchID[len]:=charnull;
        rc:=Str.Compare(matchID,ID);
        IF rc=0 THEN
            RETURN p;
        END;
        IF rc < 0 THEN
            p:=p^.left;
        ELSE
            p:=p^.right;
        END;
    END;
    RETURN NIL;
END findMatch;


PROCEDURE getFmtStr (VAR R:ARRAY OF CHAR;
          alt,withdelta:BOOLEAN   );
CONST
    sInfo        = 'L= $,  N= $,  C= $,  S= "$"';
    sInfoAlt     = 'L= $,  N= $,  C= $,  S= $';
    sInfoFull    = 'L= $,  N= $,  C= $,  D=$,  S= "$"';
    sInfoFullAlt = 'L= $,  N= $,  C= $,  D=$,  S= $';
VAR
    S:str128;
BEGIN
    IF alt THEN
        IF withdelta THEN
            S:=sInfoFullAlt;
        ELSE
            S:=sInfoAlt;
        END;
    ELSE
        IF withdelta THEN
            S:=sInfoFull;
        ELSE
            S:=sInfo;
        END;
    END;
    Str.Copy(R,S);
END getFmtStr;


PROCEDURE dumpNode (VAR errcode:CARDINAL; showdelta:BOOLEAN;p:NODE);
VAR
    len:CARDINAL;
    S:str128; (* oversized ! *)
    R:str256; (* oversized just in case ! *)
    esc:BOOLEAN;
    vN,vC:LONGCARD;
BEGIN
    IF errcode # errNone THEN RETURN; END;
    IF p=NIL THEN RETURN;  END;

    (*
    WrStr("// dumpNode() ");
    IF lnode THEN
        WrStr("LEFT");
    ELSE
        WrStr("RIGHT");
    END;
    WrLn;
    *)

    IF gdump THEN
        len:=CARDINAL(p^.data^.len);
        Lib.FastMove(SYSTEM.ADR(p^.data^.string),SYSTEM.ADR(S),len);
        S[len]:=charnull;

        getFmtStr(R, FALSE,showdelta);
        vN := p^.data^.total;
	vC := vN * LONGCARD(len);

        Str.Subst(R,"$",lcToStr(2," ", LONGCARD(len) ));
        Str.Subst(R,"$",lcToStr(wi," ",  vN   ) );
        Str.Subst(R,"$",lcToStr(wi," ",  vC   ) );
	IF showdelta THEN
	Str.Subst(R,"$",lcToStr(wi," ", vC-vN));
	END;
        Str.Subst(R,"$",S);
        WrStr(R);WrLn;
    END;

    INC(gwcount);
    INC(gtwcount,p^.data^.total);

    IF ChkEscape() THEN errcode:=errAborted; END;
    dumpNode(errcode, showdelta,p^.left  );
    dumpNode(errcode, showdelta,p^.right );
END dumpNode;

PROCEDURE dumpTree (VAR errcode:CARDINAL; showdelta:BOOLEAN);
CONST
    msg="Working...";
BEGIN
    IF NOT(gdump) THEN video(msg,TRUE);END;
    errcode:=errNone;
    dumpNode(errcode,showdelta,gwordtree ) ;
    IF NOT(gdump) THEN video(msg,FALSE);END;
END dumpTree;

(* ------------------------------------------------------------ *)

CONST
    sBytesRead   = hdr+"Bytes read              : ";
    sFilteredOut = hdr+"Characters filtered out : ";
    sTokens      = hdr+"Tokens                  : ";
    sWords       = hdr+"Unique words            : ";
    sTotalWords  = hdr+"Total words             : ";

    sPath        = hdr+"File specification      : ";
    sCase        = hdr+"Ignore case             : ";
    sAccents     = hdr+"Ignore accents          : ";
(*     sAE          = hdr+'Expand "" and ""      : '; *)
    sSeparators  = hdr+"Token separators        : ";
    sSet         = hdr+"Accept [A..Z0..9]       : ";
    sMode        = hdr+"Word counter mode       : ";
    sRange       = hdr+"n-gram range            : ";
    sCumulative  = hdr+"Cumulative results      : ";
    sRaw         = hdr+"Raw output              : ";

PROCEDURE dumpStats (showme,wordmode,outputnow:BOOLEAN   );
VAR
    S:str128;
BEGIN
    IF NOT(showme) THEN RETURN; END;
    WrLn;
    Str.Concat(S,sBytesRead     ,lcToStr(wi," ",gfilesize));WrStr(S);WrLn;
    Str.Concat(S,sFilteredOut   ,lcToStr(wi," ",gskipped));WrStr(S);WrLn;
    IF wordmode THEN
        Str.Concat(S,sTotalWords,lcToStr(wi," ",gtwcount));WrStr(S);WrLn;
      IF NOT(outputnow) THEN
        Str.Concat(S,sWords     ,lcToStr(wi," ",gwcount));WrStr(S);WrLn;
      END;
    ELSE
      IF NOT(outputnow) THEN
        Str.Concat(S,sTokens      ,lcToStr(wi," ",gwcount));WrStr(S);WrLn;
      END;
    END;
END dumpStats;

PROCEDURE dumpFlags (showme,
                    keepcase,keepaccents,modulamode,useblanks,allowdigits,
                    wordmode,cumulative,outputnow:BOOLEAN;lowerlen,upperlen:CARDINAL;
                    filespec:pathtype );
    MODULE message;
    IMPORT Str;
    FROM IO IMPORT WrStr,WrLn;
    EXPORT msgbool;

    PROCEDURE msgbool (flag:BOOLEAN;S:ARRAY OF CHAR);
    BEGIN
        WrStr(S);
        IF flag THEN
            WrStr("YES");
        ELSE
            WrStr("no");
        END;
        WrLn;
    END msgbool;

    END message;
VAR
    S : str128;
BEGIN
    IF NOT(showme) THEN RETURN;END;
    WrStr(sPath);WrFname(filespec);WrLn;

    msgbool(NOT(keepcase)    ,sCase);
    msgbool(NOT(keepaccents) ,sAccents);
(*     msgbool(NOT(keepae)      ,sAE); *)

    IF modulamode THEN
        S:=sModulaSet;
    ELSIF useblanks THEN
        S:=sBlanksSet;
    ELSE
        S:=sNotAZset;
    END;
    WrStr(sSeparators);WrStr(S);WrLn;

    msgbool(allowdigits      ,sSet);
    msgbool(wordmode         ,sMode);
    msgbool(cumulative       ,sCumulative);
    IF NOT(wordmode) THEN
        WrStr(sRange);
        Str.Concat(S,lcToStr(1," ",LONGCARD (lowerlen)),"..");
        Str.Append(S,lcToStr(1," ",LONGCARD (upperlen)));
        Str.Prepend(S,"[");Str.Append(S,"]");
        WrStr(S);WrLn;
    END;
    msgbool(outputnow        ,sRaw);
END dumpFlags;

(* ------------------------------------------------------------ *)

PROCEDURE scanNode (VAR remaining,uniques,total:LONGCARD;
                   len:SHORTCARD;p:NODE);
BEGIN
    IF p=NIL THEN RETURN;  END;

    IF len = p^.data^.len THEN
        INC(uniques);
        INC(total,p^.data^.total);
        DEC(remaining);
    END;

    scanNode(remaining,uniques,total,len,p^.left);
    scanNode(remaining,uniques,total,len,p^.right);

END scanNode;

CONST
    sfreqInfo   = hdr+"L= $,  uniques= $,  total= $";
    sfreqFinal  = hdr+"   $            $          $";

PROCEDURE dumpFreq (showme:BOOLEAN   );
VAR
    remaining,uniques,total,granduniques,grandtotal:LONGCARD;
    len:SHORTCARD;
    R:str128;
BEGIN
    IF NOT(showme) THEN RETURN; END;
    WrLn;
    granduniques:=0;
    grandtotal:=0;
    remaining:=gwcount;
    len:=1;
    WHILE remaining > 0 DO
        uniques:=0;
        total:=0;
        scanNode(remaining,uniques,total,len,gwordtree);
        INC(granduniques,uniques);
        INC(grandtotal,total);
        Str.Copy(R,sfreqInfo);
        Str.Subst(R,"$",lcToStr(2," ", LONGCARD(len) ));
        Str.Subst(R,"$",lcToStr(wi," ",  uniques ) );
        Str.Subst(R,"$",lcToStr(wi," ",  total ) );
        WrStr(R);WrLn;

        INC(len);
    END;

    Str.Copy(R,sfreqFinal);
    Str.Subst(R,"$","  " ) ;
    Str.Subst(R,"$",widashes);
    Str.Subst(R,"$",widashes);
    WrStr(R);WrLn;

    Str.Copy(R,sfreqFinal);
    Str.Subst(R,"$","  " ) ;
    Str.Subst(R,"$",lcToStr(wi," ",  granduniques ) );
    Str.Subst(R,"$",lcToStr(wi," ",  grandtotal ) );
    WrStr(R);WrLn;

END dumpFreq;

(* ------------------------------------------------------------ *)

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = IObufferSize;
VAR
    ioBuffer : ARRAY [1..IObufferSize] OF SYSTEM.LOC;

PROCEDURE getToken (modulamode,useblanks,allowdigits:BOOLEAN;hnd : FIO.File;
                   VAR len:CARDINAL; VAR token:ARRAY OF CHAR );
CONST
    m2separators = modulaseparators+dquote+quote;
VAR
    ch    : CHAR;
    state : (waiting,getting);
    got   : CARDINAL;
    ok    : BOOLEAN;
    tokmode : (onlyblanks,notAZ,m2);
BEGIN
    IF modulamode THEN
        tokmode := m2;
    ELSIF useblanks THEN
        tokmode := onlyblanks;
    ELSE
        tokmode := notAZ;
    END;
    Str.Copy(token,"");
    state := waiting;
    len   := 0;
    LOOP
        got := FIO.RdBin(hnd,ch,1);
        IF got = 0 THEN EXIT; END;
        CASE state OF
        | waiting :
            CASE tokmode OF
            | m2:         ok:=NOT(isBlank(ch) OR Belongs(m2separators,ch));
            | onlyblanks: ok:=NOT(isBlank(ch));
            | notAZ:      ok:=isOK(ch,allowdigits);
            ELSE ; (* //ISO fixed silly requirement *) END;
            IF ok THEN
                Str.Copy(token,ch);
                len:=1;
                state :=getting;
            ELSE
                INC(gskipped);
            END;
        | getting :
            CASE tokmode OF
            | m2:         ok:=NOT(isBlank(ch) OR Belongs(m2separators,ch));
            | onlyblanks: ok:=NOT(isBlank(ch));
            | notAZ:      ok:=isOK(ch,allowdigits);
            ELSE ; (* //ISO fixed silly requirement *) END;
            IF ok THEN
                Str.Append(token,ch);
                INC(len);
            ELSE
                INC(gskipped);
                EXIT;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
END getToken;

PROCEDURE buildGrams (VAR errcode:CARDINAL;VAR einfo:ARRAY OF CHAR;
                     lowerlen,upperlen:CARDINAL;
                     keepcase,keepaccents,modulamode,
                     useblanks,allowdigits,wordmode,outputnow:BOOLEAN;
                     f:pathtype);
CONST
    msgProcessing = "Processing ";
VAR
    hin:FIO.File;
    token:str128; (* should do ! *)
    i,len:CARDINAL;
    j,lim:INTEGER;
    ptr,matchptr:NODE;
    ok:BOOLEAN;
    msg:str128;
    gram:str128; (* str16 was enough but leave room for unlikely extension ! *)
    fsize:LONGCARD;
BEGIN
    errcode:=errNone;

    FIO.EOF:=FALSE; (* silly JPI quirks/bugs ! *)
    hin:=FIO.OpenRead(f);
    FIO.AssignBuffer(hin,ioBuffer);

    fsize:=FIO.Size(hin);   (* handle is ok for both DOS and LFN *)

    Str.Concat(msg,msgProcessing,f);Str.Append(msg," ");
    IF NOT(outputnow) THEN video(msg,TRUE); END;

    INC(gfilesize,fsize);

    LOOP
        IF FIO.EOF THEN EXIT; END;
        getToken(modulamode,useblanks,allowdigits,hin,len,token);
        IF len=0 THEN EXIT;END;
        (* IF NOT(keepae) THEN len:=dofixae(token);END; *)
        IF keepcase THEN
            IF keepaccents = FALSE THEN removeAccents(token); END;
        ELSE
            IF keepaccents THEN
                LowerCaseAlt(token);
            ELSE
                LowerCase(token);
            END;
        END;
        IF wordmode THEN
            IF outputnow THEN
                wrQuoted(token);
                INC(gtwcount); (* update total words is ok here *)
            ELSE
(* WrStr("// findmatch() for ");WrStr(token);WrLn; *)
                matchptr:=findMatch(token);
                IF matchptr=NIL THEN
                    IF newnode(ptr, token)=FALSE THEN
                        errcode:=errAllocate;
                        Str.Concat(einfo,token," (");Str.Append(einfo,f);Str.Append(einfo,")");
                        EXIT;
                    END;
(* WrStr("//   addnode()");WrLn; *)
                    addnode(ptr);
                ELSE
                    INC( matchptr^.data^.total );
                END;
            END;
        ELSE
            FOR i:=lowerlen TO upperlen DO
                lim:=INTEGER(len)-INTEGER(i)+1;
                j:=0;
                LOOP
                    IF j>=lim THEN EXIT; END;
                    Str.Slice(gram,token, CARDINAL(j),CARDINAL(i) );
                    IF outputnow THEN
                        wrQuoted(gram); (* update gwcount unique tokens would be a nonsense here *)
                    ELSE
                        matchptr:=findMatch(gram);
                        IF matchptr=NIL THEN
                            IF newnode(ptr, gram)=FALSE THEN
                                errcode:=errAllocate;
                                Str.Concat(einfo,token," (");Str.Append(einfo,f);Str.Append(einfo,")");
                                EXIT;
                            END;
                            addnode(ptr);
                        ELSE
                            INC( matchptr^.data^.total );
                        END;
                    END;
                    INC(j);
                END;
                IF errcode # errNone THEN EXIT;END;
            END;
        END;
        IF outputnow THEN
            IF ChkEscape() THEN errcode:=errAborted;EXIT; END;
        END;
    END;
    FIO.Close(hin);

    IF NOT(outputnow) THEN video(msg,FALSE); END;
END buildGrams;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minlen = 1; (* 0 would be a nonsense here ! and we'll need 1-1 *)
    maxlen = 128; (* should do ! *)
TYPE
    statstype = RECORD
        uniques,total:LONGCARD;
    END;
VAR
    stats : ARRAY [minlen..maxlen] OF statstype;

PROCEDURE dumpFreqRemade (showme:BOOLEAN   );
VAR
    remaining,uniques,total,granduniques,grandtotal:LONGCARD;
    R:str128;
    len,lastlen:CARDINAL;
BEGIN
    IF NOT(showme) THEN RETURN; END;

    lastlen:=maxlen;
    LOOP
        IF stats[lastlen].uniques # 0 THEN EXIT; END;
        DEC(lastlen);
        IF lastlen < minlen THEN RETURN; END;
    END;

    WrLn;
    granduniques:=0;
    grandtotal:=0;

    FOR len:=minlen TO lastlen DO
        uniques:=stats[len].uniques;
        total:=stats[len].total;
        INC(granduniques,uniques);
        INC(grandtotal,total);
        Str.Copy(R,sfreqInfo);
        Str.Subst(R,"$",lcToStr(2," ", LONGCARD(len) ));
        Str.Subst(R,"$",lcToStr(wi," ",  uniques ) );
        Str.Subst(R,"$",lcToStr(wi," ",  total ) );
        WrStr(R);WrLn;
    END;

    Str.Copy(R,sfreqFinal);
    Str.Subst(R,"$","  " ) ;
    Str.Subst(R,"$",widashes);
    Str.Subst(R,"$",widashes);
    WrStr(R);WrLn;

    Str.Copy(R,sfreqFinal);
    Str.Subst(R,"$","  " ) ;
    Str.Subst(R,"$",lcToStr(wi," ",  granduniques ) );
    Str.Subst(R,"$",lcToStr(wi," ",  grandtotal ) );
    WrStr(R);WrLn;
END dumpFreqRemade;

PROCEDURE parseLines (VAR PB:ARRAY OF CHAR; showdelta:BOOLEAN;f:pathtype):CARDINAL;
VAR
    hin:FIO.File;
    S,sPrev,R:str128;
    rc,len:CARDINAL;
    total:LONGCARD;
    what:(ignore,valid);
    vN,vC:LONGCARD;
BEGIN
    FOR len:=minlen TO maxlen DO stats[len].uniques:=0;stats[len].total:=0;END;

    sPrev:="";
    total:=0;
    len:=0;
    rc:=errNone;
    FIO.EOF:=FALSE; (* silly JPI quirks/bugs ! *)
    hin:=FIO.OpenRead(f);
    FIO.AssignBuffer(hin,ioBuffer);
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hin,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE S[0] OF
        | charnull, rem :
            what:=ignore; (* empty or remark *)
        | dquote :
            what:=valid;
            IF same(S,sPrev) THEN
                INC(total);
            ELSE
                IF len # 0 THEN
                    INC( stats[len].uniques);
                    INC( stats[len].total, total);
                    getFmtStr(R, TRUE,showdelta);
		    vN:=total;
		    vC:=total * LONGCARD(len);
                    Str.Subst(R,"$",lcToStr( 2," ", LONGCARD( len )));
                    Str.Subst(R,"$",lcToStr(wi," ", vN ) );
                    Str.Subst(R,"$",lcToStr(wi," ", vC ));
		    IF showdelta THEN
		    Str.Subst(R,"$",lcToStr(wi," ", vC-vN));
		    END;
                    Str.Subst(R,"$",sPrev);
                    WrStr(R);WrLn;
                END;
                Str.Copy(sPrev,S);
                total:=1;
                len:=Str.Length(sPrev)-2; (* no quotes ! *)
            END;
        ELSE
            Str.Copy(PB,S);
            rc:=errProblem;
            EXIT;
        END;
        IF ChkEscape() THEN
            Str.Copy(PB,"");
            rc:=errAborted;
            EXIT;
        END;
    END;
    FIO.Close(hin);

    IF rc = errNone THEN
        IF total # 0 THEN
                IF len # 0 THEN
                    INC( stats[len].uniques);
                    INC( stats[len].total, total);
                    getFmtStr(R, TRUE,showdelta);
		    vN:=total;
		    vC:=total * LONGCARD(len);
                    Str.Subst(R,"$",lcToStr( 2," ", LONGCARD( len )));
                    Str.Subst(R,"$",lcToStr(wi," ", vN ) );
                    Str.Subst(R,"$",lcToStr(wi," ", vC ) );
		    IF showdelta THEN
		    Str.Subst(R,"$",lcToStr(wi," ",vC-vN));
		    END;
                    Str.Subst(R,"$",sPrev);
                    WrStr(R);WrLn;
                END;
        END;
    END;
    RETURN rc;
END parseLines;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getCard (VAR v:CARDINAL;
                   lower,upper: CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc:LONGCARD;
    ok:BOOLEAN;
BEGIN
    IF GetLongCard(S,lc)=FALSE THEN RETURN FALSE; END;
    IF lc < LONGCARD(lower) THEN RETURN FALSE; END;
    IF lc > LONGCARD(upper) THEN RETURN FALSE; END;
    v:=CARDINAL(lc);
    RETURN TRUE;
END getCard;

(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt,lowerlen,upperlen,exactlen:CARDINAL;
    S,R,filespec,basedir,fname:pathtype;
    state : (waiting,gotspec);
    keepcase,keepaccents,useblanks,allowdigits:BOOLEAN;
    showsummary,showfreq,showflags,showlist,wordmode,cumulative:BOOLEAN;
    modulamode,outputnow,doanalysis,noskip,showdelta:BOOLEAN;
    DEBUG:BOOLEAN;
    errcode:CARDINAL;
    einfo:str128;
    ptr,anchor: pFname;
    count:CARDINAL;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn; (* yes, here now for help, errors, etc. *)

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;

    DEBUG       := FALSE;
    lowerlen    := undefined;
    upperlen    := undefined;
    exactlen    := undefined;
    keepcase    := TRUE;
    keepaccents := TRUE;
(*     keepae      := TRUE; (* was false *) *)
    useblanks   := FALSE;
    allowdigits := FALSE;
    wordmode    := TRUE;
    cumulative  := TRUE;
    showflags   := TRUE;
    showlist    := TRUE;
    showfreq    := TRUE;
    showsummary := TRUE;
    outputnow   := FALSE;
    doanalysis  := FALSE;
    modulamode  := FALSE;
    showdelta   := FALSE;

    state :=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "U:"+delim+"UPPER:"+delim+
                                  "L:"+delim+"LOWER:"+delim+
                                  "E:"+delim+"EXACT:"+delim+
                                     "c"+delim+"ignorecase"+delim+
                                  "A"+delim+"IGNOREACCENTS"+delim+
                                    "f"+delim+"nofixae"+delim+
                                  "B"+delim+"BLANKS"+delim+
                                  "D"+delim+"DIGITS"+delim+
                                    "q"+delim+"quiet"+delim+
                                  "G"+delim+"GRAM"+delim+
                                  "I"+delim+"INDIVIDUAL"+delim+
                                  "X"+delim+"NOFLAGS"+delim+
                                  "L"+delim+"NOLIST"+delim+
                                  "T"+delim+"NOTABLE"+delim+
                                  "S"+delim+"NOSUMMARY"+delim+
                                  "O"+delim+"OUTPUT"+delim+
                                  "M"+delim+"MAKE"+delim+"OO"+delim+
                                  "K"+delim+"CODE"+delim+"MODULA"+delim+
                                    "lfn"+delim+
				  "Z"+delim+"DELTA"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5:    IF exactlen # undefined THEN abort(errConflict,"");END;
                      IF getCard (upperlen, mingram,maxgram,R)=FALSE THEN
                          abort(errUpperLen,S);
                      END;
            | 6,7:    IF exactlen # undefined THEN abort(errConflict,"");END;
                      IF getCard (lowerlen, mingram,maxgram,R)=FALSE THEN
                          abort(errLowerLen,S);
                      END;
            | 8,9:    IF ((lowerlen # undefined) OR (upperlen # undefined)) THEN
                          abort(errConflict,"");
                      END;
                      IF getCard (exactlen, mingram,maxgram,R)=FALSE THEN
                          abort(errExactLen,S);
                      END;
            | 10,11:  ; (* keepcase    := FALSE; *)
            | 12,13:  keepaccents := FALSE;
            | 14,15:  ; (* keepae      := TRUE; *)
            | 16,17:  useblanks   := TRUE;
            | 18,19:  allowdigits := TRUE;
            | 20,21:  ;
            | 22,23:  wordmode    := FALSE;
            | 24,25:  cumulative  := FALSE;
            | 26,27:  showflags   := FALSE;
            | 28,29:  showlist    := FALSE;
            | 30,31:  showfreq    := FALSE;
            | 32,33:  showsummary := FALSE;
            | 34,35:  outputnow   := TRUE;
            | 36,37,38:  doanalysis  := TRUE;
            | 39,40,41:  modulamode  := TRUE;
            | 42:     ;
            | 43,44:  showdelta   := TRUE;
	    | 45:     DEBUG       := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(filespec,S);
            | gotspec : abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC (state);
        END;
    END;
    IF state=waiting THEN abort(errMissingSpec,"");END;


    dbg(DEBUG,"Filespec 1",filespec);
    IF chkUD(filespec)=FALSE THEN abort(errBadSpec,filespec);END;

    IF same(filespec,dot) THEN Str.Copy(filespec,stardotstar); END;
    IF same(filespec,star) THEN Str.Copy(filespec,stardotstar); END;
    IF Str.Match(filespec,"*"+antislash) THEN Str.Append(filespec,stardotstar); END;
    IF Str.RCharPos(filespec,dot)=MAX(CARDINAL) THEN Str.Append(filespec,dotstar);END;

    IF chkJoker(filespec)=FALSE THEN
        IF isDirectory ( filespec) THEN
            fixDirectory(filespec);
            Str.Append(filespec,stardotstar);
        END;
    END;
    dbg(DEBUG,"Filespec 2",filespec);
    makebase(filespec,basedir);
    dbg(DEBUG,"Basedir",basedir);

    noskip:=doanalysis;

    initList(anchor);
    count := buildFileList( anchor,noskip,DEBUG,filespec);
    CASE count OF
    | MAX(CARDINAL): abort(errTooManyMatches,filespec);
    | 0 :            abort(errNoMatch,filespec);
    ELSE ; (* //ISO fixed silly requirement *) END;

(* ------------------------------------------------------------ *)

    IF doanalysis THEN
        IF count # 1 THEN abort(errJoker,filespec);END;
        ptr:=anchor;
        getStr(filespec,ptr);
        Str.Concat(fname,basedir,filespec);
        dbg(DEBUG,"Fname",fname);
        i:=parseLines(R, showdelta,filespec);
        IF i # errNone THEN abort(i,R);END;
        dumpFreqRemade(showfreq);
        abort(errNone,"");
    END;

(* ------------------------------------------------------------ *)

    IF wordmode THEN
        IF lowerlen # undefined THEN abort(errMode,"");END;
        IF upperlen # undefined THEN abort(errMode,"");END;
        IF exactlen # undefined THEN abort(errMode,"");END;
    END;

    IF lowerlen = undefined THEN lowerlen := mingram; END;
    IF upperlen = undefined THEN upperlen := mingram+1; END;
    IF exactlen = undefined THEN
        IF upperlen < lowerlen THEN
            i:=lowerlen;
            lowerlen:=upperlen;
            upperlen:=i;
        END;
    ELSE
        lowerlen:=exactlen;
        upperlen:=exactlen;
    END;

    IF (useblanks AND modulamode) THEN abort(errNonsense,"-b and -k");END;

    IF (allowdigits AND useblanks) THEN abort(errNonsense,"-b and -d");END;

    dumpFlags (showflags,
              keepcase,keepaccents,modulamode,useblanks,allowdigits,
              wordmode,cumulative,outputnow,lowerlen,upperlen,filespec);


    IF cumulative THEN initTree();initCounters(FALSE  ,FALSE);END;

    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(filespec,ptr);
        Str.Concat(fname,basedir,filespec);
        dbg(DEBUG,"Fname",fname);

        IF NOT(cumulative) THEN
            WrLn;WrStr(hdr+"File : ");WrFname(fname);WrLn;
            initTree();initCounters( FALSE , FALSE);
        END;

        buildGrams (errcode,einfo,
                   lowerlen,upperlen,
                   keepcase,keepaccents,modulamode,useblanks,allowdigits,
                   wordmode,outputnow,
                   fname);
        IF errcode # errNone THEN abort(errcode,einfo);END;

        IF NOT(cumulative) THEN
            WrLn;
            IF NOT(outputnow) THEN
                initCounters(TRUE ,showlist);
                dumpTree(errcode,showdelta); IF errcode#errNone THEN abort(errAborted,"");END;
                dumpFreq(showfreq);
            END;
            dumpStats(showsummary,wordmode,outputnow);
            IF outputnow THEN
                initCounters(TRUE ,showlist);
            END;
            killTree();
        END;

        ptr:=ptr^.next;
    END;
    freeList(anchor);

    IF cumulative THEN
        WrLn;
        IF NOT(outputnow) THEN
            initCounters(TRUE ,showlist );
            dumpTree(errcode,showdelta); IF errcode#errNone THEN abort(errAborted,"");END;
            dumpFreq(showfreq);
        END;
        dumpStats(showsummary,wordmode,outputnow);
        killTree();
    END;

    abort(errNone,"");
END wCount32.



