

(* ---------------------------------------------------------------
Title         Q&D XLAT filter
Overview      Yet Another Use<full|less> Program to remap chars to chars
Usage         see help
Notes         revising 15 years old code on a whim was not so difficult after all :
              m2 is neither asm6502 nor forth, eh eh

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          wrong error message about string not being the same length
              when culprit line was a range with a mispelled ~command~
Wish List     v2.0 should be written as to allow string to string
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 14 Jan 18 v0.9a keep in sync with v1.4 for DOS
			  no longer requiring uppercase token
              added INC,DEC,xor,AND,OR using an operand
              bugfix : assign() would not set .enabled in structure to true
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 20 Jul 16 an ugly really Q&D port from XLAT v1.3b for DOS
--------------------------------------------------------------- *)

MODULE xlat32;

IMPORT Lib;
IMPORT Str;
IMPORT IO;
IMPORT FIO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;

PROCEDURE UpperCaseAlt(VAR S:ARRAY OF CHAR);
BEGIN
	Str.Caps(S); (* //FIXME *)
END UpperCaseAlt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    what        = "Q&D Xlat (Win32)";
    version     = "v0.9a (from v1.4 for DOS)";
    who         = "by PhG";
    prog        = "XLAT32";
    banner      = what+" "+version+" "+who;

CONST
    rem1        = ";";
    rem2        = "#";
CONST
    header      = prog+" : ";
    extGLO      = ".GLO";
    extLOG      = ".LOG";
    extBAK      = ".BK!";
    extTST      = ".TST";
    extXLT      = ".XLT";
    extCOM      = ".COM";
    extEXE      = ".EXE";
    extSYS      = ".SYS";
    extDLL      = ".DLL";
    extOVR      = ".OVR";
    extOVL      = ".OVL";
    extDRV      = ".DRV";
    extVXD      = ".VXD";
    extBIN      = ".BIN";
    extZIP      = ".ZIP";
    extARJ      = ".ARJ";
    extLZH      = ".LZH";
    skippedextensions = extBAK+delim+extCOM+delim+extEXE+delim+extSYS+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extVXD+delim+extBIN+delim+
                        extZIP+delim+extARJ+delim+extLZH;
CONST
    tokidem        = "~IDEM~";
    toknihil       = "~NIL~";
    tokreset       = "~RESET~";
    tokbit7off     = "~BIT7OFF~";
    tokbit7on      = "~BIT7ON~";
    tokplusOne     = "~PLUS1~";
    tokminusOne    = "~MINUS1~";
    tokdosnl       = "~NL~";
    tokdoscrlf     = "~CRLF~";
CONST
    tokplus        = "~PLUS~";
    tokminus       = "~MINUS~";
    tokinc         = "~INC~";
    tokdec         = "~DEC~";
    tokXor         = "~XOR~";
    tokand         = "~AND~";
    tokor          = "~OR~";
    (* 1..16 *)
    TokenList1  = tokidem+delim+
                  toknihil+delim+
                  tokreset+delim+
                  tokbit7off+delim+
                  tokbit7on+delim+
                  tokplusOne+delim+
                  tokminusOne+delim+
                  tokdosnl+delim+
                  tokdoscrlf;
    TokenList2  = tokplus+delim+
                  tokminus+delim+
                  tokinc+delim+
                  tokdec+delim+
                  tokXor+delim+
                  tokand+delim+
                  tokor;
    TokenList   = TokenList1+delim+TokenList2;
CONST
    sectionHead = "[_[_";
    sectionTail = "_]_]";
    sectionpattern = sectionHead+"*"+sectionTail;
CONST
    dirdotdot   = dotdot;
CONST
    errNone         = 0;
    errHelp         = 1;
    errIn           = 2;
    errOut          = 3;
    errNotFound     = 4;
    errLineTooLong  = 5;
    errMissingQuote = 6;
    errBadHexVal    = 7;
    errBadVal       = 8;
    errEmptyString  = 9;
    errMissingSecondParm = 10;
    errThirdParm    = 11;
    errMissingClose = 12;
    errCloseNotEnd  = 13;
    errNotRange     = 14;
    errBadRange     = 15;
    errRanges       = 16;
    errRedefined    = 17;
    errRangeString  = 18;
    errStringRange  = 19;
    errValueRange   = 20;
    errStrings      = 21;
    errValueString  = 22;
    errUNdefined    = 23;
    errREdefinedWarn= 24;
    errLetterRange  = 25;
    errNoMatch      = 26;
    errTooMany      = 27;
    errBadExt       = 28;
    errOpt          = 29;
    errParm         = 30;
    errSyntax       = 31;
    errNoExtInSection=32;
    errList          =33;
    errSectionNotFound=34;
    errBadSpec      = 35;
    errListGen      = 36;
    errGen          = 37;
    errCharToString = 38;
    errJokerDest    = 39;
    errDestBadExt   = 40;
    errNumRequired  = 41;
    errImpossible   = 255;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msghelp= banner+nl+
nl+
"This program transcodes characters from one set to another."+nl+
nl+
"Syntax 1: "+prog+" [-r] [-u] [-z] [-debug] <glossary> < infile > outfile"+nl+
"Syntax 2: "+prog+" [-r] [-u] [-z] [-debug] <glossary> <filespec> [destfile["+extXLT+"]]"+nl+
"Syntax 3: "+prog+" <-list|-l>"+nl+
"Syntax 4: "+prog+" <-gen|-!>"+nl+
nl+
"    -r no redefinition allowed (default is to allow redefinitions)"+nl+
"    -u no undefinition allowed (default is to allow undefinitions)"+nl+
"    -z allow character to string assignment (default is char to char)"+nl+
"    -l list available glossaries"+nl+
"    -! create "+prog+extTST+" test file in current directory"+nl+
"    -k keep original date and time stamp"+nl+
(* "  -debug  create default "+prog+extLOG+" definition file in current directory"+nl+ *)
nl+
"a) Program will not process files with any of these extensions :"+nl+
"   "+skippedextensions+" for safety."+nl+
"b) Each original file is saved with "+extBAK+" extension ([destfile] is not)."+nl+
"c) Glossaries are defined in "+prog+extGLO+" file, located in executable directory."+nl+
'   A glossary section is between "'+sectionHead+'" and "'+sectionTail+'", without blanks.'+nl+
'   Definition format is "<source> <target> [operand]",'+nl+
"   where both elements can be a string, a quoted string,"+nl+
"   a decimal number (#), a hexadecimal number ($#) or a range ([#..#])."+nl+
"   Target can also be any of the following self-explanatory tokens :"+nl+
"   "+TokenList1+"."+nl+
"   These tokens require an operand value :"+nl+
"   "+TokenList2+"."+nl+
"   Tokens are not case-sensitive."+nl+
"   If -z option was specified, target can be a string ([1..16] characters)."+nl+
"d) "+prog+extGLO+" uses DOS ASCII character set."+nl+
'e) Lines beginning with either "'+rem1+'" or "'+rem2+'" are comments :'+nl+
"   should these characters be redefined, enclose them with double quotes."+nl+
"f) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errHelp:
        WrStr(msghelp);
    | errIn :
        S:="StandardInput error !";
    | errOut :
        S:="StandardOutput error !";
    | errNotFound :
        Str.Concat(S,einfo," does not exist !");
    | errLineTooLong :
        S:="Line longer than 128 characters !";
    | errMissingQuote :
        S:="Quote not matched by another quote !";
    | errBadHexVal :
        S:="Hexadecimal number either invalid or outside the [$00..$FF] range !";
    | errBadVal :
        S:="Decimal number either invalid or outside the [0..255] range !";
    | errEmptyString :
        S:="Quoted string empty !";
    | errMissingSecondParm :
        S:="Missing translation element !";
    | errThirdParm :
        S:="More than 2 elements in line !";
    | errMissingClose :
        S:="Missing ']' in range definition !";
    | errCloseNotEnd :
        S:="']' not at the end of range definition !";
    | errNotRange :
        S:="Missing '..' in range definition !";
    | errBadRange :
        S:="Invalid range definition !";
    | errRanges :
        S:="Different lengths for source and target ranges !";
    | errRedefined :
        S:="Attempt to redefine a code !";
    | errRangeString :
        S:="Different lengths for source range and target string !";
    | errStringRange :
        S:="Different lengths for source string and target range !";
    | errValueRange :
        S:="Range assigned to a value !";
    | errStrings :
        S:="Different lengths for source and target strings !";
    | errValueString :
        S:="Single character expected as a match to a code !";
    | errUNdefined :
        S:="At least one undefined code !";
    | errREdefinedWarn :
        S:="At least one code defined more than once !";
    | errLetterRange :
        S:="Single character expected as range limit !";
    | errNoMatch :
        S:="No match (or reserved extension) for <filespec> !";
    | errTooMany :
        S:="Too many files match <filespec> !";
    | errBadExt :
        S:="Source file extension cannot be "+extBAK+" !";
    | errOpt:
        S:="Illegal option !";
    | errParm:
        S:="Useless parameter !";
    | errSyntax:
        S:="Syntax error !";
    | errNoExtInSection:
        S:="Glossaries are no longer individual external files !";
    | errList:
        S:="-list command and file processing are mutually exclusive !";
    | errSectionNotFound :
        Str.Copy(S,einfo);
    | errBadSpec:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," specification !");
    | errListGen:
        S:="-list and -gen commands are mutually exclusive !";
    | errGen:
        S:="-gen command and file processing are mutually exclusive !";
    | errCharToString:
        S:="Target string is more than 16 characters long !";
    | errJokerDest:
        S:="<filespec> cannot contain any joker if [destfile] is specified !";
    | errDestBadExt:
        S:="Reserved [destfile] extension !";
    | errNumRequired:
        S:="Operand must be a number !";
    ELSE
        S:="How did you get there ???";
    END;
    CASE e OF
    | errHelp,errNone: ;
    ELSE
        WrStr(header); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    (* IF Available(needed)=FALSE THEN RETURN FALSE; END; *)
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dirdotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        DEBUG :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        excludeme2 := isReservedPattern (entryname,skippedextensions );
        IF NOT(excludeme1 OR excludeme2) THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr("Included : ");WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

PROCEDURE WrQuoted (S:ARRAY OF CHAR);
BEGIN
    WrStr('"');  WrStr(S);  WrStr('"');
END WrQuoted;

PROCEDURE WrFname (S:pathtype );
BEGIN
    WrQuoted(S);
END WrFname;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
VAR
    bufferIn : ioBufferType;
    bufferOut: ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE LeftTrim (VAR S : ARRAY OF CHAR) : CARDINAL;
(* strip leading blanks in S, returning its new length *)
VAR
    i   : CARDINAL;
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    LOOP
        IF i = len THEN     (* a long line of blanks *)
            Str.Copy(S,"");
            len := 0;
            EXIT;
        END;
        IF ORD(S[i]) > ORD(blank) THEN
            Str.Delete(S,0,i); (* procedure handles removal of 0 char *)
            DEC(len,i);
            EXIT;
        END;
        INC(i);
    END;
    RETURN len;
END LeftTrim;

PROCEDURE TrimQuotes (VAR S : ARRAY OF CHAR);
(* from "xxx" or even "" to xxx *)
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    Str.Delete(S,len-1,1); (* remove trailing doublequote *)
    Str.Delete(S,0,1);     (* remove leading doublequote *)
END TrimQuotes;

(* ------------------------------------------------------------ *)

PROCEDURE GetArg (VAR S : ARRAY OF CHAR; VAR R : ARRAY OF CHAR);
(* read string until first non-blank to R, removing it from S,
and ltriming S for next parsing *)
VAR
    i   : CARDINAL;
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    LOOP
        IF i = len THEN             (* no blanks in S or S="" *)
            Str.Copy(R,S);
            Str.Copy(S,"");
            EXIT;
        END;
        IF ORD(S[i]) <= ORD(blank) THEN
            Str.Slice(R,S,0,i);
            Str.Delete(S,0,i);
            len := LeftTrim(S);
            EXIT;
        END;
        INC(i);
    END;
END GetArg;

PROCEDURE GetThisString (VAR S : ARRAY OF CHAR; VAR R : ARRAY OF CHAR) : BOOLEAN;
(* return first "string" without quotes, leaving S ready for next parsing
FALSE if no matching " was found for the first one *)
VAR
    i   : CARDINAL;
    len : CARDINAL;
    p   : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len < 2 THEN             (* cannot be empty, can be 1 char only *)
        RETURN FALSE;
    ELSE
        p := Str.NextPos(S,doublequote,1); (* we already know S[0] is a doublequote *)
        IF p = MAX(CARDINAL) THEN
            RETURN FALSE;
        ELSIF p = (len-1) THEN
            Str.Copy(R,S);
            Str.Copy(S,"");
            RETURN TRUE;
        ELSE
            Str.Slice(R,S,0,p+1);
            Str.Delete(S,0,p+1);
            len := LeftTrim(S);
            RETURN TRUE;
        END;
    END;
END GetThisString;

(* ------------------------------------------------------------ *)

PROCEDURE GetHexVal (S : ARRAY OF CHAR; VAR value : CARDINAL) : BOOLEAN;
VAR
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    Str.Delete(S,0,1); (* remove leading $ *)
    IF Str.Length(S)=0 THEN RETURN FALSE; END;
    Str.Caps(S); (* this routine does not like $ff and the like ! *)
    v := Str.StrToCard(S,16,ok);
    IF ok = FALSE THEN RETURN FALSE; END;
    IF v > MAX(SHORTCARD) THEN RETURN FALSE; END;
    value := CARDINAL(v);
    RETURN TRUE;
END GetHexVal;

PROCEDURE GetVal (S : ARRAY OF CHAR; VAR value : CARDINAL) : BOOLEAN;
VAR
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    v := Str.StrToCard(S,10,ok);
    IF ok = FALSE THEN RETURN FALSE; END;
    IF v > MAX(SHORTCARD) THEN RETURN FALSE; END;
    value := CARDINAL(v);
    RETURN TRUE;
END GetVal;

(* ------------------------------------------------------------ *)

CONST
    firstCode = MIN(SHORTCARD); (* yes, it's just 0 *)
    lastCode  = MAX(SHORTCARD); (* pretty complicated way of saying : $FF ! *)
    clearBit7 = 07FH; (* AND 01111111 *)
    setBit7   = 080H; (* OR  10000000 *)
CONST
    ONECHAR      = SIZE(SHORTCARD);
    MAXUSERTOKEN = 16;
    firstbincode = 1;
    maxbincode   = MAXUSERTOKEN;
TYPE
    chardeftype= RECORD
         enabled: BOOLEAN;
         defined: CARDINAL;
         count  : CARDINAL; (* yes, SHORTCARD would do too *)
         bindef : ARRAY[firstbincode..maxbincode] OF SHORTCARD; (* fake str16 *)
    END;
VAR
    newCode : ARRAY[firstCode..lastCode] OF chardeftype; (* globerk *)

(* ------------------------------------------------------------ *)

TYPE
    formattype = (nada,range,string,numvalue,nooperand);

TYPE
    argtype = RECORD
        fmt      : formattype;
        startval : CARDINAL;
        endval   : CARDINAL;
        str      : str128;
    END;

CONST
    openset = "[";
    hex     = "$";
    digit0  = "0";
    digit9  = "9";
    closeset= "]";
    rangesep= "..";

PROCEDURE ParseParm (VAR SSS : ARRAY OF CHAR; VAR arg:argtype):CARDINAL;
VAR
    p   : CARDINAL;
    N   : str128;
    fmt : formattype;
    R   : str128;
    v1,v2:CARDINAL;
BEGIN
    Str.Copy(R,""); (* silly safety but Murphy is always lurking... *)
    fmt := nada;
    v1  := 0;
    v2  := 0;
    CASE SSS[0] OF
    | openset :         (* find interval [##..##] *)
        GetArg(SSS,R);
        p := Str.CharPos(R,closeset);
        IF p = MAX(CARDINAL) THEN RETURN errMissingClose; END;
        IF p # (Str.Length(R)-1) THEN RETURN errCloseNotEnd; END;
        Str.Delete(R,p,1); (* now we have [##..## *)
        Str.Delete(R,0,1); (* now we have ##..## *)
        p := Str.Pos(R,rangesep);
        IF p = MAX(CARDINAL) THEN RETURN errNotRange; END;
        Str.Subst(R,rangesep," "); (* ## ## *)
        GetArg(R,N); (* first ## *)
        CASE N[0] OF
        | hex :
            IF GetHexVal(N,v1)=FALSE THEN RETURN errBadHexVal; END;
        | digit0..digit9 :
            IF GetVal(N,v1)=FALSE THEN RETURN errBadVal; END;
        ELSE
            IF Str.Length(N) # 1 THEN RETURN errLetterRange; END;
            v1 := ORD ( N[0] );
        END;
        GetArg(R,N); (* second ## *)
        CASE N[0] OF
        | hex :
            IF GetHexVal(N,v2)=FALSE THEN RETURN errBadHexVal; END;
        | digit0..digit9 :
            IF GetVal(N,v2)=FALSE THEN RETURN errBadVal; END;
        ELSE
            IF Str.Length(N) # 1 THEN RETURN errLetterRange; END;
            v2 := ORD ( N[0] );
        END;
        IF v1 >= v2 THEN RETURN errBadRange; END;
        fmt := range;
    | doublequote :           (* find quoted string "xxx" *)
        IF GetThisString(SSS,R) = FALSE THEN RETURN errMissingQuote; END;
        TrimQuotes(R);
        IF Str.Length(R) = 0 THEN RETURN errEmptyString; END;
        fmt := string;
    | hex :
        GetArg(SSS,R);
        IF GetHexVal(R,v1)=FALSE THEN RETURN errBadHexVal; END;
        fmt := numvalue;
    | digit0..digit9 :
        GetArg(SSS,R);
        IF GetVal(R,v1)=FALSE THEN RETURN errBadVal; END;
        fmt := numvalue;
    ELSE                (* find string xxx *)
        GetArg(SSS,R);
        fmt := string;
    END;
    arg.fmt      := fmt;
    arg.startval := v1;
    arg.endval   := v2;
    Str.Copy(arg.str,R);
    RETURN errNone;
END ParseParm;

(* ------------------------------------------------------------ *)

PROCEDURE dumpdef (code:CARDINAL; hnd:FIO.File);
VAR
    i:CARDINAL;
    c:CHAR;
BEGIN
    (*
    FOR i:= firstbincode TO newCode[code].count DO
        c := CHR ( newCode[code].bindef[i] );
        FIO.WrChar(hnd,c);
    END;
    *)
    FIO.WrBin(hnd, newCode[code].bindef, newCode[code].count );
END dumpdef;

PROCEDURE charToChar (index,code:CARDINAL);
BEGIN
    INC( newCode[index].defined );
    newCode[index].bindef[firstbincode] := SHORTCARD(code);
    newCode[index].count := ONECHAR;
END charToChar;

PROCEDURE assign (index : CARDINAL; newcode : CARDINAL);
BEGIN
    charToChar(index, newcode);
    newCode[index].enabled := TRUE; (* //V14 FIX *)
END assign;

PROCEDURE lazare (index : CARDINAL);
BEGIN
    charToChar(index, index);
    newCode[index].enabled  := TRUE;
END lazare;

PROCEDURE ignore (index : CARDINAL) ;
BEGIN
    INC(newCode[index].defined);
    newCode[index].enabled := FALSE;
END ignore;

PROCEDURE assignstring (index:CARDINAL; S:ARRAY OF CHAR);
VAR
    p,i,len,code:CARDINAL;
BEGIN
    len:=Str.Length(S);
    INC( newCode[index].defined );
    newCode[index].count := len;
    p:=firstbincode;
    FOR i:= 0 TO len-1 DO
        code:=ORD ( S[i] );
        newCode[index].bindef[p] := SHORTCARD( code);
        INC(p);
    END;
END assignstring;

PROCEDURE assignit (index : CARDINAL; value : INTEGER);
VAR
    i,newcode : CARDINAL;
BEGIN
    newcode := index;   (* default will be reset character to its value *)
    FOR i:= 1 TO CARDINAL( ABS(value) ) DO
        IF value < 0 THEN
            IF newcode > MIN(SHORTCARD) THEN
                DEC(newcode);
            ELSE
                newcode:=MAX(SHORTCARD);
            END;
        ELSE
            IF newcode < MAX(SHORTCARD) THEN
                INC(newcode);
            ELSE
                newcode:=MIN(SHORTCARD);
		    END;
		END;
	END;
    charToChar(index,newcode);
END assignit;

PROCEDURE xor (b1,b2 : CARDINAL) : CARDINAL;
BEGIN
    RETURN CARDINAL ( (BITSET (b1) / BITSET (b2)) );
END xor;

(* ------------------------------------------------------------ *)

PROCEDURE doRange (arg1,arg2,arg3:argtype):CARDINAL;
VAR
    i,err,code,ndxtok,pp : CARDINAL;
    SU:str128;
    start,fin:CARDINAL;
    SP2:str128;
    what:formattype;
    startP2,endP2:CARDINAL;
    operand:CARDINAL;
BEGIN
    start:=arg1.startval;
    fin:=arg1.endval;
    Str.Copy(SP2,arg2.str);
    what:=arg2.fmt;
    startP2:=arg2.startval;
    endP2:=arg2.endval;

    CASE what OF
    | range :
        IF (endP2-startP2+1) # (fin-start+1) THEN RETURN errRanges; END;
        FOR i := start TO fin DO
            assign(i,startP2);
            INC(startP2);
        END;
    | string :
        Str.Copy(SU,SP2);
        UpperCaseAlt(SU); (* //V14 *)
        ndxtok:= getStrIndex (delim, SU, TokenList);
        IF ndxtok = 0 THEN
            IF Str.Length(SP2) # (fin-start+1) THEN RETURN errRangeString; END;
            pp := 0;
            FOR i := start TO fin DO
                code := ORD(SP2[pp]);
                assign(i,code);
                INC(pp);
            END;
        ELSE
            operand:=arg3.startval;
            FOR i := start TO fin DO
                CASE ndxtok OF
                | 1 : assign(i,i);
                | 2 : ignore(i);
                | 3 : lazare(i);
                | 4 : assign(i, (i AND clearBit7) );
                | 5 : assign(i, (i OR setBit7) );
                | 6 : assignit(i,  1 );
                | 7 : assignit(i, -1 );
                | 8 : assignstring(i,nl);
                | 9 : assignstring(i,nl);
                |10 : assignit(i,  INTEGER(operand));
                |11 : assignit(i, -INTEGER(operand));
                |12 : assignit(i,  INTEGER(operand));
                |13 : assignit(i, -INTEGER(operand));
                |14 : assign(i, xor(i,operand) );
                |15 : assign(i, (i AND operand) );
                |16 : assign(i, (i OR operand) );
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
        END;
    | numvalue :
        FOR i := start TO fin DO
            assign(i,startP2);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN errNone;
END doRange;

(* ------------------------------------------------------------ *)

PROCEDURE doString (arg1,arg2,arg3:argtype;flagCHARtoSTRING:BOOLEAN):CARDINAL;
VAR
    err,code,codenow,fin,pp,ndxtok : CARDINAL;
    SU:str128;
    S,SP2:str128;
    what:formattype;
    startP2,endP2:CARDINAL;
    operand:CARDINAL;
BEGIN
    Str.Copy(S,arg1.str);
    Str.Copy(SP2,arg2.str);
    what:=arg2.fmt;
    startP2:=arg2.startval;
    endP2:=arg2.endval;

    fin:=Str.Length(S)-1;
    CASE what OF
    | range :
        IF (fin+1) # (endP2-startP2+1) THEN RETURN errStringRange; END;
        FOR pp := 0 TO fin DO
            code := ORD(S[pp]);
            assign(code,startP2);
            INC(startP2);
        END;
    | string :
        Str.Copy(SU,SP2);
        UpperCaseAlt(SU); (* //V14 *)
        ndxtok:= getStrIndex (delim, SU, TokenList);
        IF ndxtok = 0 THEN
            IF ( flagCHARtoSTRING AND ( (fin+1) = 1 ) ) THEN
                IF Str.Length(SP2) > MAXUSERTOKEN THEN RETURN errCharToString;END;
                code:=ORD (S[0]);
                assignstring(code, SP2);
            ELSE
                IF (fin+1) # Str.Length(SP2) THEN RETURN errStrings; END;
                FOR pp := 0 TO fin DO
                    code   :=ORD(S[pp]);
                    codenow:=ORD(SP2[pp]);
                    assign(code,codenow);
                END;
            END;
        ELSE
            operand:=arg3.startval;
            FOR pp := 0 TO fin DO
                code:=ORD(S[pp]);
                CASE ndxtok OF
                | 1 : assign(code,code);
                | 2 : ignore(code);
                | 3 : lazare(code);
                | 4 : assign(code, (code AND clearBit7) );
                | 5 : assign(code, (code OR setBit7) );
                | 6 : assignit (code,  1 );
                | 7 : assignit (code, -1 );
                | 8 : assignstring(code, nl);
                | 9 : assignstring(code, nl);
                |10 : assignit(code,  INTEGER(operand));
                |11 : assignit(code, -INTEGER(operand));
                |12 : assignit(code,  INTEGER(operand));
                |13 : assignit(code, -INTEGER(operand));
                |14 : assign(code, xor(code,operand) );
                |15 : assign(code, (code AND operand) );
                |16 : assign(code, (code OR operand) );
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
        END;
    | numvalue :
        FOR pp := 0 TO fin DO
            code := ORD(S[pp]);
            assign(code,startP2);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN errNone;
END doString;

(* ------------------------------------------------------------ *)

PROCEDURE doValue (arg1,arg2,arg3:argtype;flagCHARtoSTRING:BOOLEAN):CARDINAL;
VAR
    err,code,ndxtok : CARDINAL;
    SU : str128;
    value:CARDINAL;
    SP2:str128;
    what : formattype;
    startP2:CARDINAL;
    operand:CARDINAL;
BEGIN
    value:=arg1.startval;
    Str.Copy(SP2,arg2.str);
    what:=arg2.fmt;
    startP2:=arg2.startval;

    CASE what OF
    | range :
        RETURN errValueRange;
    | string :
        Str.Copy(SU,SP2);
        UpperCaseAlt(SU); (* //V14 *)
        ndxtok:= getStrIndex (delim, SU, TokenList);
        IF ndxtok = 0 THEN
            IF flagCHARtoSTRING THEN
                IF Str.Length(SP2) > MAXUSERTOKEN THEN RETURN errCharToString;END;
                assignstring(value,SP2);
            ELSE
                IF Str.Length(SP2) # 1 THEN RETURN errValueString; END;
                code := ORD(SP2[0]);
                assign(value,code);
            END;
        ELSE
            operand:=arg3.startval;
            CASE ndxtok OF
            | 1 : assign(value,value);
            | 2 : ignore(value);
            | 3 : lazare(value);
            | 4 : assign(value, (value AND clearBit7) );
            | 5 : assign(value, (value OR setBit7) );
            | 6 : assignit(value,  1 );
            | 7 : assignit(value, -1 );
            | 8 : assignstring(value, nl);
            | 9 : assignstring(value, nl);
            |10 : assignit(value,  INTEGER(operand));
            |11 : assignit(value, -INTEGER(operand));
            |12 : assignit(value,  INTEGER(operand));
            |13 : assignit(value, -INTEGER(operand));
            |14 : assign(value, xor(value,operand) );
            |15 : assign(value, (value AND operand) );
            |16 : assign(value, (value OR operand) );
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    | numvalue :
        assign(value,startP2);
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN errNone;
END doValue;

(* ------------------------------------------------------------ *)

PROCEDURE Parse (DEBUG,flagCHARtoSTRING:BOOLEAN;S : ARRAY OF CHAR) : CARDINAL;
VAR
    SU:str128;
    err,ndxtok : CARDINAL;
    arg1,arg2,arg3 : argtype;
BEGIN
    IF S[0] = rem1 THEN RETURN errNone; END;
    IF S[0] = rem2 THEN RETURN errNone; END;
    err := ParseParm(S,arg1);
    IF err # errNone THEN RETURN err; END;
    IF Str.Length(S)=0 THEN RETURN errMissingSecondParm; END;

    err := ParseParm(S,arg2);
    IF err # errNone THEN RETURN err; END;
    IF Str.Length(S) = 0 THEN
        arg3.fmt:=nooperand;
    ELSE
        Str.Copy(SU,arg2.str);
        UpperCaseAlt(SU); (* //V14 *)
        ndxtok:= getStrIndex (delim, SU, TokenList2);
        IF ndxtok = 0 THEN RETURN errThirdParm;END;
        err := ParseParm(S,arg3);
        IF err # errNone THEN RETURN err;END;
        IF arg3.fmt # numvalue THEN RETURN errNumRequired;END;
    END;

    CASE arg1.fmt OF
    | range :
        RETURN doRange (arg1,arg2,arg3);
    | string :
        RETURN doString(arg1,arg2,arg3,flagCHARtoSTRING);
    | numvalue :
        RETURN doValue (arg1,arg2,arg3,flagCHARtoSTRING);
    ELSE (* //ISO fixed silly requirement *)
	    RETURN errNone; (* //ISO crappy interpreter requires a return for an impossible value ! *)
	END;
END Parse;

(* ------------------------------------------------------------ *)

PROCEDURE printable (c : CHAR):CHAR;
BEGIN
    IF ORD(c) < ORD(blank) THEN
        RETURN ".";
    ELSE
        RETURN c;
    END;
END printable;

PROCEDURE num2str (n,digits,base: CARDINAL;prefix,padchar : CHAR):str16;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    R    : str16;
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,R,base,ok);
    len := Str.Length(R);
    LOOP
        IF Str.Length(R) >= digits THEN EXIT; END;
        Str.Prepend(R,padchar);
    END;
    Str.Prepend(R,prefix);
    IF base=16 THEN Str.Lows(R);END;
    RETURN R;
END num2str;

PROCEDURE Report (VAR R : ARRAY OF CHAR; index : CARDINAL);
CONST
    sep2 = "  ";
    (* we can't use subst here for obvious reasons *)
    header =
(*
"###  $##  "?"    ###  $##  "?"    Y  (###)  !!! ++ "*"
*)
"Index            Code             Status        String (if applicable)";

VAR
    code : CARDINAL;
    v : CARDINAL;
    S : str128;
    ch: CHAR;
BEGIN
    IF index = MAX(CARDINAL) THEN
        Str.Copy(R,header);
        RETURN;
    END;

    ch:=CHR(index);
    Str.Concat(S, num2str(index,3,10,"" ," "), sep2);
    Str.Append(S, num2str(index,2,16,"$","0"));
    Str.Append(S, sep2+doublequote);
    Str.Append(S, printable ( ch ));
    Str.Append(S, doublequote+sep2+sep2);

    code:=ORD(newCode[index].bindef[firstbincode]);
    ch:=CHR(code);
    Str.Append(S, num2str(code,3,10,"" ," "));
    Str.Append(S, sep2);
    Str.Append(S, num2str(code,2,16,"$","0"));
    Str.Append(S, sep2+doublequote);
    Str.Append(S, printable ( ch ) );
    Str.Append(S, doublequote+sep2+sep2);

    IF newCode[index].enabled THEN
        Str.Append(S,"Y");
    ELSE
        Str.Append(S,"n");
    END;
    Str.Append(S,sep2+"(");

    v := newCode[index].defined;
    Str.Append(S,num2str(v,3,16,"" ," "));
    Str.Append(S,")"+sep2);

    CASE v OF
    | 0 : Str.Append(S,"#-#"); (* undefined *)
    | 1 : Str.Append(S,"..."); (* defined once *)
    ELSE
          Str.Append(S,"#+#"); (* defined ### times *)
    END;

    IF newCode[index].count # ONECHAR THEN
        Str.Append(S,sep2+doublequote);
        FOR  v:=firstbincode TO newCode[index].count DO
             Str.Append(S, printable( CHR(newCode[index].bindef[v])) );
        END;
        Str.Append(S,doublequote);
    END;

    Str.Copy(R,S);
END Report;

PROCEDURE Warning (count : CARDINAL;err:CARDINAL );
VAR
    S : str128;
BEGIN
    Str.Concat(S, num2str(count,3,10,"" ," ")," code");
    IF count > 1 THEN Str.Append(S,"s"); END;
    CASE err OF
    | errUNdefined :     Str.Append(S," undefined !");
    | errREdefinedWarn : Str.Append(S," defined more than once !");
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Prepend(S,"::: Warning ! ");
    FIO.WrStr(FIO.ErrorOutput,S);
    FIO.WrLn(FIO.ErrorOutput);
END Warning;

(* ------------------------------------------------------------ *)

PROCEDURE LoadGlossary (DEBUG,REDEFINED,UNDEFINED,flagCHARtoSTRING:BOOLEAN;
                       glofile:pathtype; F : ARRAY OF CHAR):CARDINAL;
VAR
    i    : CARDINAL;
    hnd  : FIO.File;
    S    : str128;
    orgS : str128;
    len  : CARDINAL;
    err  : CARDINAL;
    count : CARDINAL;
    udne,u,d,n,e:pathtype;
    id:str128;
BEGIN
	(*
    FIO.WrStr(FIO.ErrorOutput,banner); FIO.WrLn(FIO.ErrorOutput);
    FIO.WrLn(FIO.ErrorOutput);
	*)

    FOR i := firstCode TO lastCode DO
        newCode[i].defined := 0; (* reset definition count *)
        charToChar(i, i);        (* default : keep the same *)
        newCode[i].defined := 0; (* reset definition count again which was just incremented *)
        newCode[i].enabled := TRUE;
    END;

    Str.Concat(id,sectionHead,F);Str.Append(id,sectionTail);
    Str.Caps(id); (* useless in fact ! *)

    hnd := FIO.OpenRead (glofile);
    FIO.AssignBuffer(hnd,bufferIn);

    LOOP
        IF FIO.EOF THEN FIO.Close(hnd);RETURN errSectionNotFound;END;
        FIO.RdStr(hnd,S);
        IF Str.Match(S,sectionpattern) THEN
            Str.Caps(S);
            IF same(id,S) THEN EXIT; END;
        END;
    END;

    LOOP
        IF FIO.EOF THEN
            err := errNone;
            EXIT;
        END;
        FIO.RdStr(hnd,S);

        IF Str.Match(S,sectionpattern) THEN
            err := errNone;
            EXIT;
        END;

        len := Str.Length(S);
        IF len > HIGH(S) THEN
            Str.Copy(orgS,S);
            err := errLineTooLong;
            EXIT;
        END;
        len := LeftTrim(S);
        Str.Copy(orgS,S);
        IF len # 0 THEN
            err := Parse(DEBUG,flagCHARtoSTRING,S);
            IF err # errNone THEN EXIT; END;
        END;
    END;
    FIO.Close(hnd);
    IF err # errNone THEN
        WrStr(header+"Error in this glossary line : ");WrStr(orgS);WrLn;
        RETURN err;
    END;

    (* now check for codes not defined *)

    count := 0;
    FOR i := firstCode TO lastCode DO
        IF newCode[i].defined = 0 THEN INC(count); END;
    END;

    IF count # 0 THEN
        IF UNDEFINED THEN
            Warning(count,errUNdefined);
        ELSE
            RETURN errUNdefined;
        END;
    END;

    (* now check for codes defined more than once *)

    count := 0;
    FOR i := firstCode TO lastCode DO
        IF newCode[i].defined > 1 THEN INC(count); END;
    END;

    IF count # 0 THEN
        IF REDEFINED THEN
            Warning(count,errREdefinedWarn);
        ELSE
            RETURN errREdefinedWarn;
        END;
    END;

    (* now always keep a copy of state of new codes *)

    IF DEBUG THEN
        Lib.ParamStr(S,0);
        Str.Caps(S);                    (* just in case... *)
        Str.Subst(S,extEXE,extLOG);
        qdSplitAllPath(S,u,d,n,e);
        Lib.MakeAllPath(udne,"","",n,e); (* always in current directory *)
        hnd := FIO.Create(udne);
        FIO.WrLn(hnd);
        FIO.WrStr(hnd,F); FIO.WrLn(hnd);
        FIO.WrLn(hnd);
        Report(S,MAX(CARDINAL));
        FIO.WrStr(hnd,S); FIO.WrLn(hnd);
        FIO.WrLn(hnd);

        FOR i := firstCode TO lastCode DO
            Report(S,i);
            FIO.WrStr(hnd,S); FIO.WrLn(hnd);
        END;
        FIO.Close(hnd);
    END;
    RETURN errNone;
END LoadGlossary;

PROCEDURE newExtension (VAR R:pathtype;S:pathtype;e3:ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    Str.Copy(R,S);
    p := Str.RCharPos(R,dot);
    IF p = MAX(CARDINAL) THEN
        ;
    ELSE
        R[p]:=CHR(0);
    END;
    Str.Append(R,e3);
END newExtension;

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

(* ------------------------------------------------------------ *)

CONST
    msgSkipping   = "Skipped    ";
    msgProcessing = "Processing ";
    msgCreating   = "Creating ";
    msgNow        = " ... "; (* was " : " *)
    msgOK         = "Done.";

VAR
    hin,hout  : FIO.File;
    c    : CHAR;
    S,R,filespec,destfile,glofile,backup,file,basedir,source,target : pathtype;
    i,opt    : CARDINAL;
    code : CARDINAL;
    parmcount : CARDINAL;
    p         : CARDINAL;
    got       : CARDINAL;
    state     : (waiting,gotglossary,gotspec,gotdest);
    cmd       : (oplist,opredir,opfile,opgen);
    section   : str128;
    flagREDEFINED,flagUNDEFINED,flagCHARtoSTRING,DEBUG:BOOLEAN;
    doList,doGen,doCreate,doKeepStamp:BOOLEAN;
    ptr,anchor  : pFname;
    countFile : CARDINAL;
    stamp : LONGCARD;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;

    flagREDEFINED    := TRUE; (* allow redefinition *)
    flagUNDEFINED    := TRUE; (* allow undefinition *)
    flagCHARtoSTRING := FALSE;
    DEBUG            := FALSE;
    doList           := FALSE;
    doGen            := FALSE;
    doCreate         := FALSE;
    doKeepStamp      := FALSE;

    state:=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "R"+delim+
                                   "U"+delim+
                                   "L"+delim+"LIST"+delim+
                                   "x"+delim+"lfn"+delim+
                                   "Z"+delim+
                                   "!"+delim+"GEN"+delim+
                                   "K"+delim+"STAMP"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3: abort(errHelp,"");
            | 4:     flagREDEFINED    := FALSE;
            | 5:     flagUNDEFINED    := FALSE;
            | 6,7:   doList           := TRUE;
            | 8,9:   ;
            | 10:    flagCHARtoSTRING := TRUE;
            | 11,12: doGen            := TRUE;
            | 13,14: doKeepStamp      := TRUE;
            | 15:    DEBUG            := TRUE;
            ELSE
                abort(errOpt,S);
            END;
        ELSE
            CASE state OF
            | waiting:      IF Str.CharPos(R,dot) # MAX(CARDINAL) THEN
                                 abort(errNoExtInSection,"");
                            END;
                            Str.Copy(section,R);
            | gotglossary:  Str.Copy(filespec,R);
            | gotspec:      Str.Copy(destfile,R);
            | gotdest:      abort(errParm,R);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    IF (doList AND doGen) THEN abort(errListGen,"");END;
    CASE state OF
    | waiting:
         IF doList THEN
             cmd:=oplist;
         ELSE
             IF doGen THEN
                 cmd:=opgen;
             ELSE
                 abort(errSyntax,"");
             END;
         END;
    | gotglossary:
         IF doList THEN abort(errList,"");END;
         IF doGen  THEN abort(errGen,"");END;
         cmd:=opredir;
    | gotspec:
         IF doList THEN abort(errList,"");END;
         IF doGen  THEN abort(errGen,"");END;
         cmd:=opfile;
    | gotdest:
         IF chkJoker(filespec) THEN abort(errJokerDest,"");END;
         IF Str.RCharPos(destfile,dot)=MAX(CARDINAL) THEN Str.Append(destfile,extXLT);END;
         IF isReservedPattern (destfile,skippedextensions ) THEN abort(errDestBadExt,"");END;
         doCreate:=TRUE;

         IF doList THEN abort(errList,"");END;
         IF doGen  THEN abort(errGen,"");END;
         cmd:=opfile;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | opgen :
        ; (* don't care about glossary here *)
    ELSE
        Lib.ParamStr(glofile,0);
        Str.Caps(glofile);                    (* just in case... *)
        Str.Subst(glofile,extEXE,extGLO);
        IF FIO.Exists(glofile)=FALSE THEN abort(errNotFound,glofile); END;
    END;

    CASE cmd OF
    | oplist:
        WrStr("Glossaries found in ");WrStr(glofile);WrLn;WrLn;
        hin:=FIO.OpenRead(glofile);
        FIO.AssignBuffer(hin,bufferIn);
        i:=0;
        LOOP
            IF FIO.EOF THEN EXIT;END;
            FIO.RdStr(hin,S);
            IF Str.Match(S,sectionpattern) THEN
                Str.Subst(S,sectionHead,"");
                Str.Subst(S,sectionTail,"");
                Str.Caps(S);
                WrStr(S);WrLn;
                INC(i);
            END;
        END;
        FIO.Close(hin);
        IF i=0 THEN WrStr("None !");WrLn;END;

    | opgen:
        hout:=FIO.Create(prog+extTST);
        FOR i:=0 TO 255 DO
            FIO.WrChar( hout, printable(CHR(i)) );
            IF ((i+1) MOD 16) = 0 THEN FIO.WrLn(hout); END;
        END;
        FIO.Close(hout);
        WrStr(prog+extTST+" has been created.");WrLn;
    | opredir:

        i:=LoadGlossary (DEBUG,flagREDEFINED,flagUNDEFINED,flagCHARtoSTRING,
                        glofile,section);
        CASE i OF
        | errNone:
            ;
        | errSectionNotFound:
            Str.Concat(S,section," glossary was not found in ");
            Str.Append(S,glofile);Str.Append(S," !");
            abort(i,S);
        ELSE
            abort(i,"");
        END;

        hin  := FIO.StandardInput;
        hout := FIO.StandardOutput;
        LOOP
            c := FIO.RdChar(hin);
            IF FIO.IOresult() # 0 THEN
                abort(errIn,"");
            END;
            IF FIO.EOF THEN EXIT; END;
            code := ORD(c);
            IF newCode[code].enabled THEN
                dumpdef(code,hout);
                IF FIO.IOresult() # 0 THEN abort(errOut,""); END;
            END;
        END;

    | opfile:

        i:=LoadGlossary (DEBUG,flagREDEFINED,flagUNDEFINED,flagCHARtoSTRING,
                        glofile,section);
        CASE i OF
        | errNone:
            ;
        | errSectionNotFound:
            Str.Concat(S,section," glossary was not found in ");
            Str.Append(S,glofile);Str.Append(S," !");
            abort(i,S);
        ELSE
            abort(i,"");
        END;

        (* a few q&d sanity checks *)

        IF chkUD(filespec)=FALSE THEN abort(errBadSpec,filespec);END;
        IF same(filespec,dot) THEN Str.Copy(filespec,stardotstar); END;
        IF same(filespec,star) THEN Str.Copy(filespec,stardotstar); END;
        IF Str.Match(filespec,"*"+antislash) THEN Str.Append(filespec,stardotstar); END;
        IF chkJoker(filespec)=FALSE THEN
            IF isDirectory ( filespec) THEN
                fixDirectory(filespec);
                Str.Append(filespec,stardotstar);
            END;
        END;
        makebase(filespec,basedir);

        initList(anchor);
        countFile := buildFileList(anchor,DEBUG,filespec);
        CASE countFile OF
        | MAX(CARDINAL): abort(errTooMany,filespec);
        | 0 :            abort(errNoMatch,filespec);
        ELSE ; (* //ISO fixed silly requirement *) END;

        ptr:=anchor;
        WHILE ptr # NIL DO
            getStr(filespec,ptr);
            Str.Concat(file,basedir,filespec);

            IF doCreate THEN (* "there can be only one..." here *)
                Str.Copy(source,file);
                Str.Copy(target,destfile);

                IF FIO.Exists(target) THEN FIO.Erase(target); END;

                WrStr(msgCreating); WrFname(target);WrStr(msgNow);
            ELSE
                newExtension(backup,file,extBAK);

                IF FIO.Exists(backup) THEN FIO.Erase(backup); END;
                FIO.Rename(file,backup);

                Str.Copy(source,backup);
                Str.Copy(target,file);
                WrStr(msgProcessing); WrFname(target);WrStr(msgNow);
            END;


            hin :=FIO.OpenRead(source);
            FIO.AssignBuffer(hin,bufferIn);
            IF doKeepStamp THEN
                stamp:=FIO.GetFileDate(hin);
            END;
            hout:=FIO.Create(target);
            FIO.AssignBuffer(hout,bufferOut);
            FIO.EOF:=FALSE;
            LOOP
                IF FIO.EOF THEN EXIT; END;
                got:=FIO.RdBin(hin,c,1);
                IF got # 1 THEN EXIT;END;
                code := ORD(c);
                IF newCode[code].enabled THEN dumpdef(code,hout); END;
            END;
            FIO.Flush(hout);
            FIO.Close(hout);
            FIO.Close(hin);

            (* NOW and only NOW, we may update again date and time if needed *)
            IF doKeepStamp THEN
                hout:=FIO.Open(target);
                FIO.SetFileDate(hout,stamp);
                FIO.Close(hout);
            END;

            WrStr(msgOK);WrLn;

            ptr:=ptr^.next;
        END;
        freeList(anchor);

    ELSE ; (* //ISO fixed silly requirement *) END;

    abort(errNone,"");
END xlat32.



(*

//XDS note this is verbatim ASCII DOS here

// this is XLAT.GLO companion file

;
; Please note this file uses DOS ASCII and *NOT* Win OEM !
;

; A glossary section is between "[_[_" and "_]_]", without blanks.
; Definition format is "<source> <target> [operand]",
; where both elements can be a string, a quoted string,
; a decimal number (#), a hexadecimal number ($#) or a range ([#..#]).
; Target can also be any of the following self-explanatory tokens :
; ~IDEM~,~NIL~,~RESET~,~BIT7OFF~,~BIT7ON~,~PLUS1~,~MINUS1~,~NL~,~CRLF~.
; These tokens require a value operand :
; ~PLUS~,~MINUS~,~INC~,~DEC~,~XOR~,~AND~,~OR~.
; Tokens are not case-sensitive.

[_[_PC2WIN_]_]
;
; PC to vindoze -- should be checked for uppercase with accents
;
$14     $B6
$15     $A7
$7F     
$80     $C7
$81     $FC
$82     $E9
$83     $E2
$84     $E4
$85     $E0
$86     $E5
$87     $E7
$88     $EA
$89     $EB
$8A     $E8
$8B     $EF
$8C     $EE
$8D     $EC
$8E     $C4
$8F     $C5
$90     $C9
$91     $E6
$92     $C6
$93     $F4
$94     $F6
$95     $F2
$96     $FB
$97     $F9
$98     $FF
$99     $D6
$9A     $DC
$9B     $A2
$9C     $A3
$9D     $A5
$9E     
$9F     
$A0     $E1
$A1     $ED
$A2     $F3
$A3     $FA
$A4     $F1
$A5     $D1
$A6     $AA
$A7     $BA
$A8     $BF
$A9     
$AA     $AC
$AB     $BD
$AC     $BC
$AD     $A1
$AE     $AB
$AF     $BB
; graphics
[$B0..$DF]  "                                                "
$E0     
$E1     
$E2     
$E3     
$E4     
$E5     
$E6     $B5
$E7     
$E8     
$E9     
$EA     
$EB     
$EC     
$ED     $D8
$EE     
$EF     
$F0     
$F1     $B1
$F2     
$F3     
$F4     
$F5     
$F6     $F7
$F7     
$F8     $B0
$F9     
$FA     
$FB     
$FC     
$FD     $B2
$FE     
$FF     " "



[_[_WIN2PC_]_]
;
; vindoze to PC
;
[$7F..$90]  
$91         '
$92         '
[$93..$A0]  
$A1         
$A2         
$A3         
$A4         
$A5         
$A6         |
$A7         $15
$A8         
$A9         
$AA         
$AB         
$AC         
$AD         -
$AE         
$AF         -
$B0         
$B1         
$B2         
$B3         
$B4         
$B5         
$B6         $14
$B7         
$B8         
$B9         
$BA         
$BB         
$BC         
$BD         
$BE         
$BF         
$C0         A
$C1         A
$C2         A
$C3         A
$C4         
$C5         
$C6         
$C7         
$C8         E
$C9         
$CA         E
$CB         E
$CC         I
$CD         I
$CE         I
$CF         I
$D0         
$D1         
$D2         O
$D3         O
$D4         O
$D5         O
$D6         
$D7         X
$D8         O
$D9         U
$DA         U
$DB         U
$DC         
$DD         Y
$DE         
$DF         
$E0         
$E1         
$E2         
$E3         a
$E4         
$E5         
$E6         
$E7         
$E8         
$E9         
$EA         
$EB         
$EC         
$ED         
$EE         
$EF         
$F0         
$F1         
$F2         
$F3         
$F4         
$F5         o
$F6         
$F7         
$F8         o
$F9         
$FA         
$FB         
$FC         
$FD         y
$FE         
$FF         



[_[_UPPER_]_]
;
; upper case
;
abcdefghijklmnopqrstuvwxyz  ABCDEFGHIJKLMNOPQRSTUVWXYZ
 CUEAAAACEEEIIIAAEOOOUUYOU
                      AIOUNN



[_[_LOWER_]_]
;
; lower case
;
ABCDEFGHIJKLMNOPQRSTUVWXYZ  abcdefghijklmnopqrstuvwxyz
 ueaaaaeeeiiiaaeooouuyou
                      aiounn



[_[_NOCTRL_]_]
;
; clean any control character in a textfile except cr, lf and tab
;
[0..31]     ~NIL~
$09         ~RESET~
$0A         ~RESET~
$0D         ~RESET~



[_[_NOGRAPH_]_]

""                           "+++"
""           "!!!!!+!!++++++--!-+"
""         "!!+++++-+++++++++!+++"
""                         "+-!!-"



[_[_ROT13_]_]
;
; ROT13
;
[A..M]  [N..Z]
[N..Z]  [A..M]
[a..m]  [n..z]
[n..z]  [a..m]



[_[_ASCII_]_]
;
; clean any file to let only text
;
; would be a better idea if...
; ctrl-z did not meant a nasty stop when reading a binary file !
; maybe for v1.1 ? ;-)
;
[0..255]    ~NIL~
$0A         ~RESET~
$0D         ~RESET~
$20         ~RESET~

!"#$%&'()*+,-./0123456789:;<=>?     ~RESET~
@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_    ~RESET~
`abcdefghijklmnopqrstuvwxyz{|}~     ~RESET~
                 ~RESET~
                 ueaaaeeeiiEoouu



[_[_WEIRD_]_]
;
; clean any file to let only weird characters
;
[0..255]    ~RESET~

$0A         ~NIL~
$0D         ~NIL~
$20         ~NIL~
!"#$%&'()*+,-./0123456789:;<=>?     ~NIL~
@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_    ~NIL~
`abcdefghijklmnopqrstuvwxyz{|}~     ~NIL~



[_[_NOACCENT_]_]
;
; no accents nor cedilla !
;
  Cueaaaaceeeiii
   AAEooouuyOU
          aiounN



[_[_NOACCENTCAPS_]_]
;
; no accents nor cedilla on caps !
;
               C
          AAEOU
               N



[_[_ALPHANUM_]_]
;
; leave only letters and digits
;
[0..255]    ~NIL~
$0A         ~RESET~
$0D         ~RESET~
$20         ~RESET~

"0123456789"                        ~RESET~
ABCDEFGHIJKLMNOPQRSTUVWXYZ          ~RESET~
abcdefghijklmnopqrstuvwxyz          ~RESET~
                 ~RESET~
                 ueaaaeeeiiEoouu



[_[_NODIGITS_]_]
;
; remove digits
;
[0..255]        ~RESET~
"0123456789"    ~NIL~



[_[_NODQUOTE_]_]
;
; clean any double quote (ASCII code 34) in a textfile
;
[0..255]    ~RESET~
$22         ~NIL~



[_[_MARTIAN_]_]
;
; martian
;
!"                          
"."                         ""
"?"                         ""
ABCDEFGHIJKLMNOPQRSTUVWXYZ  G׺JkmNPqR$њwxz
abcdefghijklmnopqrstuvwxyz  뉟ghKMQWXZ



[_[_PLUS1_]_]
;
; add 1
;
[0..255]    ~PLUS1~



[_[_MINUS1_]_]
;
; substract 1
;
[0..255]    ~MINUS1~



[_[_BIT7ON_]_]
;
; set bit 7
;
[$00..$7F]  ~BIT7ON~



[_[_BIT7OFF_]_]
;
; clear bit 7
;
[$80..$FF]  ~BIT7OFF~


[_[_UPPERTEXT_]_]
;
; leave only digits, uppercase letters, spaces, cr/lf/tab
;
[0..255]    ~NIL~
$0A         ~RESET~
$0D         ~RESET~
$20         ~RESET~

"0123456789"                        ~RESET~
ABCDEFGHIJKLMNOPQRSTUVWXYZ          ~RESET~

[_[_NOCTRLZ_]_]
;
; remove Ctrl-Z
;
[0..255]        ~RESET~
$1A             ~NIL~



[_[_PC2MAC_]_]
;
; DOS PC to Macintrash (unchecked)
;
$00    $00
$01    $01
$02    $02
$03    $03
$04    $04
$05    $05
$06    $06
$07    $07
$08    $08
$09    $09
$0A    ~NIL~
$0B    $0B
$0C    $0C
$0D    $0D
$0E    $0E
$0F    $0F
$10    $10
$11    $11
$12    $12
$13    $13
$14    $A6
$15    $A4
$16    $16
$17    $17
$18    $18
$19    $19
$1A    $1A
$1B    $1B
$1C    $1C
$1D    $1D
$1E    $1E
$1F    $1F
$20    " "
$21    "!"
$22    $22
$23    "#"
$24    "$"
$25    "%"
$26    "&"
$27    "'"
$28    "("
$29    ")"
$2A    "*"
$2B    "+"
$2C    ","
$2D    "-"
$2E    "."
$2F    "/"
$30    "0"
$31    "1"
$32    "2"
$33    "3"
$34    "4"
$35    "5"
$36    "6"
$37    "7"
$38    "8"
$39    "9"
$3A    ":"
$3B    ";"
$3C    "<"
$3D    "="
$3E    ">"
$3F    "?"
$40    "@"
$41    "A"
$42    "B"
$43    "C"
$44    "D"
$45    "E"
$46    "F"
$47    "G"
$48    "H"
$49    "I"
$4A    "J"
$4B    "K"
$4C    "L"
$4D    "M"
$4E    "N"
$4F    "O"
$50    "P"
$51    "Q"
$52    "R"
$53    "S"
$54    "T"
$55    "U"
$56    "V"
$57    "W"
$58    "X"
$59    "Y"
$5A    "Z"
$5B    "["
$5C    "\"
$5D    "]"
$5E    "^"
$5F    "_"
$60    "`"
$61    "a"
$62    "b"
$63    "c"
$64    "d"
$65    "e"
$66    "f"
$67    "g"
$68    "h"
$69    "i"
$6A    "j"
$6B    "k"
$6C    "l"
$6D    "m"
$6E    "n"
$6F    "o"
$70    "p"
$71    "q"
$72    "r"
$73    "s"
$74    "t"
$75    "u"
$76    "v"
$77    "w"
$78    "x"
$79    "y"
$7A    "z"
$7B    "{"
$7C    "|"
$7D    "}"
$7E    "~"
$7F    $C6
$80    $82
$81    $9F
$82    $8E
$83    $89
$84    $8A
$85    $88
$86    $8C
$87    $8D
$88    $90
$89    $91
$8A    $8F
$8B    $95
$8C    $94
$8D    $93
$8E    $80
$8F    "A"
$90    $83
$91    $BE
$92    $AE
$93    $99
$94    $9A
$95    $98
$96    $9E
$97    $9D
$98    $D8
$99    $85
$9A    $86
$9B    $A2
$9C    $A3
$9D    $B4
$9E    "."
$9F    $C4
$A0    $87
$A1    $92
$A2    $97
$A3    $9C
$A4    $96
$A5    $84
$A6    $BB
$A7    $BC
$A8    $C0
$A9    "~"
$AA    $C2
$AB    "H"
$AC    "Q"
$AD    $C1
$AE    $C7
$AF    $C8
[$B0..$BF]    "++++++++++++++++"
[$C0..$CF]    "++++++++++++++++"
[$D0..$DF]    "++++++++++++++++"
$E0    "a"
$E1    $A7
$E2    "G"
$E3    $B9
$E4    $B7
$E5    "s"
$E6    $B5
$E7    "t"
$E8    "F"
$E9    "h"
$EA    $BD
$EB    $B6
$EC    $B0
$ED    $AF
$EE    "E"
$EF    "U"
$F0    "="
$F1    $B1
$F2    $B3
$F3    $B2
$F4    "("
$F5    ")"
$F6    $D6
$F7    $C5
$F8    $A2
$F9    $13
$FA    $D7
$FB    $C3
$FC    "n"
$FD    "2"
$FE    $A5
$FF    "_"



[_[_WIN2MAC_]_]
;
; Vindoze OEM to Macintoy (unchecked))
;
$00    $00
$01    $01
$02    $02
$03    $03
$04    $04
$05    $05
$06    $06
$07    $07
$08    $08
$09    $09
$0A    ~NIL~
$0B    $0B
$0C    $0C
$0D    $0D
$0E    $0E
$0F    $0F
$10    $10
$11    $11
$12    $12
$13    $13
$14    $14
$15    $15
$16    $16
$17    $17
$18    $18
$19    $19
$1A    $1A
$1B    $1B
$1C    $1C
$1D    $1D
$1E    $1E
$1F    $1F
$20    " "
$21    "!"
$22    $22
$23    "#"
$24    "$"
$25    "%"
$26    "&"
$27    "'"
$28    "("
$29    ")"
$2A    "*"
$2B    "+"
$2C    ","
$2D    "-"
$2E    "."
$2F    "/"
$30    "0"
$31    "1"
$32    "2"
$33    "3"
$34    "4"
$35    "5"
$36    "6"
$37    "7"
$38    "8"
$39    "9"
$3A    ":"
$3B    ";"
$3C    "<"
$3D    "="
$3E    ">"
$3F    "?"
$40    "@"
$41    "A"
$42    "B"
$43    "C"
$44    "D"
$45    "E"
$46    "F"
$47    "G"
$48    "H"
$49    "I"
$4A    "J"
$4B    "K"
$4C    "L"
$4D    "M"
$4E    "N"
$4F    "O"
$50    "P"
$51    "Q"
$52    "R"
$53    "S"
$54    "T"
$55    "U"
$56    "V"
$57    "W"
$58    "X"
$59    "Y"
$5A    "Z"
$5B    "["
$5C    "\"
$5D    "]"
$5E    "^"
$5F    "_"
$60    "`"
$61    "a"
$62    "b"
$63    "c"
$64    "d"
$65    "e"
$66    "f"
$67    "g"
$68    "h"
$69    "i"
$6A    "j"
$6B    "k"
$6C    "l"
$6D    "m"
$6E    "n"
$6F    "o"
$70    "p"
$71    "q"
$72    "r"
$73    "s"
$74    "t"
$75    "u"
$76    "v"
$77    "w"
$78    "x"
$79    "y"
$7A    "z"
$7B    "{"
$7C    "|"
$7D    "}"
$7E    "~"
$7F    
[$80..$8F]    
$90    
$91    $D4
$92    $D5
[$93..$9F]    
$A0    "_"
$A1    $C1
$A2    $A2
$A3    $A3
$A4    $D7
$A5    $B4
$A6    "|"
$A7    $A4
$A8    $AC
$A9    $A9
$AA    $BB
$AB    $C7
$AC    $C2
$AD    $D0
$AE    $A8
$AF    $D1
$B0    $A1
$B1    $B1
$B2    "2"
$B3    "3"
$B4    $AB
$B5    $B5
$B6    $A6
$B7    $22
$B8    ","
$B9    "1"
$BA    $BC
$BB    $C8
$BC    "Q"
$BD    "H"
$BE    "T"
$BF    $C0
$C0    $CB
$C1    "A"
$C2    $81
$C3    $CC
$C4    $80
$C5    "A"
$C6    $AE
$C7    $82
$C8    "E"
$C9    $83
$CA    "E"
$CB    "E"
$CC    $93
$CD    $92
$CE    $94
$CF    $95
$D0    "]"
$D1    $84
$D2    "O"
$D3    "O"
$D4    "O"
$D5    $CD
$D6    $85
$D7    
$D8    $AF
$D9    "U"
$DA    "U"
$DB    "U"
$DC    $86
$DD    "Y"
$DE    "}"
$DF    $A7
$E0    $88
$E1    $87
$E2    $89
$E3    $8B
$E4    $8A
$E5    $8C
$E6    $BE
$E7    $8D
$E8    $8F
$E9    $8E
$EA    $90
$EB    $91
$EC    $93
$ED    $92
$EE    $94
$EF    $95
$F0    "&"
$F1    $96
$F2    $98
$F3    $97
$F4    $99
$F5    $9B
$F6    $9A
$F7    $D6
$F8    $BF
$F9    $9D
$FA    $9C
$FB    $9E
$FC    $9F
$FD    "y"
$FE    "$"
$FF    $D8



[_[_MAC2PC_]_]
;
; Macintrash to DOS PC (unchecked))
;
$00    $00
$01    $01
$02    $02
$03    $03
$04    $04
$05    $05
$06    $06
$07    $07
$08    $08
$09    $09
$0A    $0A
$0B    $0B
$0C    $0C
$0D    ~NL~
$0E    $0E
$0F    $0F
$10    $10
$11    "X"
$12    "/"
$13    "x"
$14    "@"
$15    $15
$16    $16
$17    $17
$18    $18
$19    $19
$1A    $1A
$1B    $1B
$1C    $1C
$1D    $1D
$1E    $1E
$1F    $1F
$20    " "
$21    "!"
$22    $22
$23    "#"
$24    "$"
$25    "%"
$26    "&"
$27    "'"
$28    "("
$29    ")"
$2A    "*"
$2B    "+"
$2C    ","
$2D    "-"
$2E    "."
$2F    "/"
$30    "0"
$31    "1"
$32    "2"
$33    "3"
$34    "4"
$35    "5"
$36    "6"
$37    "7"
$38    "8"
$39    "9"
$3A    ":"
$3B    ";"
$3C    "<"
$3D    "="
$3E    ">"
$3F    "?"
$40    "@"
$41    "A"
$42    "B"
$43    "C"
$44    "D"
$45    "E"
$46    "F"
$47    "G"
$48    "H"
$49    "I"
$4A    "J"
$4B    "K"
$4C    "L"
$4D    "M"
$4E    "N"
$4F    "O"
$50    "P"
$51    "Q"
$52    "R"
$53    "S"
$54    "T"
$55    "U"
$56    "V"
$57    "W"
$58    "X"
$59    "Y"
$5A    "Z"
$5B    "["
$5C    "\"
$5D    "]"
$5E    "^"
$5F    "_"
$60    "`"
$61    "a"
$62    "b"
$63    "c"
$64    "d"
$65    "e"
$66    "f"
$67    "g"
$68    "h"
$69    "i"
$6A    "j"
$6B    "k"
$6C    "l"
$6D    "m"
$6E    "n"
$6F    "o"
$70    "p"
$71    "q"
$72    "r"
$73    "s"
$74    "t"
$75    "u"
$76    "v"
$77    "w"
$78    "x"
$79    "y"
$7A    "z"
$7B    "{"
$7C    "|"
$7D    "}"
$7E    "~"
$7F    $C6
$80    ""
$81    "A"
$82    ""
$83    ""
$84    ""
$85    ""
$86    ""
$87    ""
$88    ""
$89    ""
$8A    ""
$8B    "a"
$8C    ""
$8D    ""
$8E    ""
$8F    ""
$90    ""
$91    ""
$92    ""
$93    ""
$94    ""
$95    ""
$96    ""
$97    ""
$98    ""
$99    ""
$9A    ""
$9B    "o"
$9C    ""
$9D    ""
$9E    ""
$9F    ""
$A0    "^"
$A1    ""
$A2    ""
$A3    ""
$A4    $15
$A5    ""
$A6    $14
$A7    ""
$A8    ""
$A9    ""
$AA    ""
$AB    "'"
$AC    ":"
$AD    "#"
$AE    ""
$AF    "O"
$B0    ""
$B1    ""
$B2    ""
$B3    ""
$B4    ""
$B5    ""
$B6    ""
$B7    ""
$B8    ""
$B9    ""
$BA    ""
$BB    ""
$BC    ""
$BD    ""
$BE    ""
$BF    "o"
$C0    ""
$C1    ""
$C2    ""
$C3    ""
$C4    ""
$C5    ""
$C6    ""
$C7    ""
$C8    ""
$C9    "."
$CA    "_"
$CB    "A"
$CC    "A"
$CD    "O"
$CE    ""
$CF    ""
$D0    "-"
$D1    "-"
$D2    $22
$D3    $22
$D4    "'"
$D5    "'"
$D6    ""
$D7    ""
$D8    ""
[$D9..$DF]    
[$E0..$EF]    
[$F0..$FF]    



[_[_MAC2WIN_]_]
;
; Macintoy to Vindoze OEM (unchecked))
;
$00    $00
$01    $01
$02    $02
$03    $03
$04    $04
$05    $05
$06    $06
$07    $07
$08    $08
$09    $09
$0A    $0A
$0B    $0B
$0C    $0C
$0D    ~NL~
$0E    $0E
$0F    $0F
$10    $10
$11    "X"
$12    "/"
$13    "x"
$14    "+"
$15    $15
$16    $16
$17    $17
$18    $18
$19    $19
$1A    $1A
$1B    $1B
$1C    $1C
$1D    $1D
$1E    $1E
$1F    $1F
$20    " "
$21    "!"
$22    $22
$23    "#"
$24    "$"
$25    "%"
$26    "&"
$27    "'"
$28    "("
$29    ")"
$2A    "*"
$2B    "+"
$2C    ","
$2D    "-"
$2E    "."
$2F    "/"
$30    "0"
$31    "1"
$32    "2"
$33    "3"
$34    "4"
$35    "5"
$36    "6"
$37    "7"
$38    "8"
$39    "9"
$3A    ":"
$3B    ";"
$3C    "<"
$3D    "="
$3E    ">"
$3F    "?"
$40    "@"
$41    "A"
$42    "B"
$43    "C"
$44    "D"
$45    "E"
$46    "F"
$47    "G"
$48    "H"
$49    "I"
$4A    "J"
$4B    "K"
$4C    "L"
$4D    "M"
$4E    "N"
$4F    "O"
$50    "P"
$51    "Q"
$52    "R"
$53    "S"
$54    "T"
$55    "U"
$56    "V"
$57    "W"
$58    "X"
$59    "Y"
$5A    "Z"
$5B    "["
$5C    "\"
$5D    "]"
$5E    "^"
$5F    "_"
$60    "`"
$61    "a"
$62    "b"
$63    "c"
$64    "d"
$65    "e"
$66    "f"
$67    "g"
$68    "h"
$69    "i"
$6A    "j"
$6B    "k"
$6C    "l"
$6D    "m"
$6E    "n"
$6F    "o"
$70    "p"
$71    "q"
$72    "r"
$73    "s"
$74    "t"
$75    "u"
$76    "v"
$77    "w"
$78    "x"
$79    "y"
$7A    "z"
$7B    "{"
$7C    "|"
$7D    "}"
$7E    "~"
$7F    $D0
$80    $C4
$81    $C2
$82    $C7
$83    $C9
$84    $D1
$85    $D6
$86    $DC
$87    $E1
$88    $E0
$89    $E2
$8A    $E4
$8B    $E3
$8C    $E5
$8D    $E7
$8E    $E9
$8F    $E8
$90    $EA
$91    $EB
$92    $ED
$93    $EC
$94    $EE
$95    $EF
$96    $F1
$97    $F3
$98    $F2
$99    $F4
$9A    $F6
$9B    $F5
$9C    $FA
$9D    $F9
$9E    $FB
$9F    $FC
$A0    "^"
$A1    $B0
$A2    $A2
$A3    $A3
$A4    $A7
$A5    $A4
$A6    $B6
$A7    $DF
$A8    $AE
$A9    $A9
$AA    "T"
$AB    $B4
$AC    $A8
$AD    "#"
$AE    $C6
$AF    $D8
$B0    "="
$B1    $B1
$B2    "<"
$B3    ">"
$B4    $A5
$B5    $B5
$B6    $F0
$B7    "S"
$B8    "P"
$B9    "p"
$BA    "{"
$BB    $AA
$BC    $BA
$BD    "O"
$BE    $E6
$BF    $F8
$C0    $BF
$C1    $A1
$C2    $AC
$C3    "V"
$C4    "f"
$C5    "~"
$C6    "D"
$C7    $AB
$C8    $BB
$C9    "."
$CA    "_"
$CB    $C0
$CC    $C3
$CD    $D5
$CE    $C6
$CF    $E6
$D0    $AD
$D1    $AF
$D2    $22
$D3    $22
$D4    $91
$D5    $92
$D6    $B1
$D7    $A4
$D8    $FF
[$D9..$DF]    
[$E0..$EF]    
[$F0..$FF]    



[_[_UNICODE_]_]
;
; should fix most unicrap characters
;
$00         ~NIL~
[$01..$ff]  ~RESET~



[_[_WEIRDEST_]_]
;
; as weird but cleaning only a..z, 0..9 and common chars
;
[0..255]    ~RESET~

$20                             ~NIL~
!'(),-.0123456789:;             ~NIL~
ABCDEFGHIJKLMNOPQRSTUVWXYZ      ~NIL~
abcdefghijklmnopqrstuvwxyz      ~NIL~
                  ~NIL~



[_[_TESTFRENCH_]_]
;
; in : ASCII DOS text file
; out : text cleaned from A..Z, a..z, control chars and signs
; why : we can assume a processed non-0 file contains accents and may be in french
;
[0..255]        ~RESET~
[0..31]         ~NIL~
$20                             ~NIL~
"0123456789"                    ~NIL~
ABCDEFGHIJKLMNOPQRSTUVWXYZ      ~NIL~
abcdefghijklmnopqrstuvwxyz      ~NIL~
!"#$%&'()*+,-./                 ~NIL~
:;<=>?@[\]^_`{|}~               ~NIL~



[_[_APPLE2_]_]
;
; from Apple ][ to PC (though we don't handle "letter $08 accent" )]
;
; darn, we no longer have any doc about good old Apple ][ now... :-(
;
[0..255]        ~RESET~

"["       ""
"{"       ""
"]"       ""
"@"       ""
"|"       ""



[_[_SILLY_]_]

[0..255]       ~RESET~

"aA"       "44"
"bB"       "88"
"cC"       "(("
"eE"       "33"
"gG"       "99"
"iI"       "!!"
"lL"       "11"
"oO"       "00"
"sS"       "55"
"tT"       "77"
"zZ"       "22"



[_[_$00_]_]

; same as UNICODE

[0..255] ~RESET~
$00     ~NIL~



[_[_SHOWWEIRD_]_]
;
; clean any file from A..Z 0..9 and a few symbols and accents
;
[0..255]    ~RESET~

" "                           ~NIL~
                ~NIL~
!"#$%&'()*+,-./:;<=>?[]       ~NIL~
"0123456789"                  ~NIL~
ABCDEFGHIJKLMNOPQRSTUVWXYZ    ~NIL~
abcdefghijklmnopqrstuvwxyz    ~NIL~



[_[_NOLETTERSNODIGITS_]_]

[0..255]        ~RESET~
"0123456789"                  ~NIL~
ABCDEFGHIJKLMNOPQRSTUVWXYZ    ~NIL~
abcdefghijklmnopqrstuvwxyz    ~NIL~



[_[_NOSYMBOLS_]_]

[0..255]                ~RESET~
!"#$%&'()*+,-./:;<=>?   ~NIL~
@[\]^_                  ~NIL~
`{|}~                   ~NIL~



[_[_VANITY_]_]

[0..255]        ~NIL~
ABCDEFGHIJKLMNOPQRSTUVWXYZ    "22233344455566677778889999"
abcdefghijklmnopqrstuvwxyz    "22233344455566677778889999"
"0123456789"                  ~RESET~



[_[_XOR255_]_]

[0..255]    ~xor~ $ff



[_[_PLUS13_]_]

[0..255]    ~inc~ 13



[_[_MINUS13_]_]

[0..255]    ~dec~ 13



[_[_AND$7F_]_]

[0..255]    ~and~ $7f



[_[_OR$80_]_]

[0..255]    ~or~ 128



[_[_FIXHTM_FOR_V20_]_]
;
; WIP ! for XLAT v2.0 : useless with anything earlier !
;

$c3b4 
$c3a0 
$c3a8 
$c3a9 
$c3aa 
$c3b9 
$c3bb 
$c3ae 
$c3a2 
$c380 
$c382 
$c3a7 
$c3af 
$c3b6 
$c3ab 
$c3a4 
$c3bc 
$c3bf 
$c39b 
$c3b1 n
; ae alt-145
$c3a6 ae
$c38b 
$c389 
$C387 
$c388 
; AE alt-146
$c386 AE
$c38a 
$c38E 
$c38f 
$c394 
$c592 OE
; power of 2
$c2b2 $fd
$c2b0 
$c2a7 
$c2ab20 $22
$20c2bb $22
$c2ab   $22
$c2bb   $22
$e2809c $22
$e2809d $22
; single quote
$e28099 $27
$e280a6 ...
$e28892 --
$c593   oe


// end of XLAT.GLO


*)



(*

// ugly batches to check nothing was broken from 1.2c to 1.3 and 1.3b to 1.4

// all.bat

@echo off
c:
cd \z
if exist xlat32.rpt del xlat32.rpt

call one PC2WIN
call one WIN2PC
call one UPPER
call one LOWER
call one NOCTRL
call one NOGRAPH
call one ROT13
call one ASCII
call one WEIRD
call one NOACCENT
call one NOACCENTCAPS
call one ALPHANUM
call one NODIGITS
call one NODQUOTE
call one MARTIAN
call one PLUS1
call one MINUS1
call one BIT7ON
call one BIT7OFF
call one UPPERTEXT
call one NOCTRLZ
call one PC2MAC
call one WIN2MAC
call one MAC2PC
call one MAC2WIN
call one UNICODE
call one WEIRDEST
call one TESTFRENCH
call one APPLE2
call one SILLY
call one $00
call one SHOWWEIRD
call one NOLETTERSNODIGITS
call one NOSYMBOLS
call one VANITY
call one XOR255
call one PLUS13
call one MINUS13
call one AND$7F
call one OR$80




// one.bat

@echo off
xlat32 -!
xlat32 %1 xlat32.tst %1.new
xlat32 -!
xlat   %1 xlat32.tst %1.old

fcomp  %1.old %1.new >> xlat32.rpt

set _f_=c:\windows\isuninst.exe

copy /b %_f_% xlat32.tst
xlat32 %1 xlat32.tst %1.new
copy /b %_f_% xlat32.tst
xlat   %1 xlat32.tst %1.old

fcomp  %1.old %1.new >> xlat32.rpt

set _f_=



*)


