(* ---------------------------------------------------------------
Title         Q&D File Data Extractor
Author        PhG
Overview      Extract and save portion of a file to another file
Usage         see help
Notes         YACWOT
              weird : without cache, M2 code is about 50% slower than BASIC
              yet, with cache, it is about 8 times FASTER !
              as for other programs (see infra), even though a LONGCARD
              can hold 4 Gb, filesize will be 0 with huge 2 Gb files
              when using win9X
              yep, we should $216c00 extended open file function,
              but we could risk weird problems thanks to ms crap
              interfering more or less willingly with TS libraries
              so, let this for now and for ever

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              yes, yes, we know a few int $13 calls
              could be replaced with Win32 API calls

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
              a few DOS-specific or Win32-unsupported options have been forced
              -q
              modifications of output when redirected is no longer handled

              a few DOS-specific limits have been increased (string length)

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          program won't process files 2.6 Gb long, thinking it's 0

Wish list     no, why ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 20 Mar 23 v0.9a added inner separators and K,M,G,KB,MB,GB suffixes (v1.0k for DOS)
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 25 Nov 15 an ugly really Q&D port from XTRACT for DOS
--------------------------------------------------------------- *)

MODULE Xtract32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
CONST
    (* stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *) *)
    (* stderr        = FIO.ErrorOutput; *)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

CONST
    minus       = "-";
    extBAK      = ".BK!";
    cosmeticseparators = coma+dot+underscore;
CONST
    ProgEXEname   = "XTRACT32";
    ProgTitle     = "Q&D File Data Extractor (Win32)";
    ProgVersion   = "v0.9a (from v1.2i for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errUnknownOption    = 2;
    errUneededParm      = 3;
    errCmd              = 4;
    errMissingSource    = 5;
    errMissingTarget    = 6;
    errMissingStart     = 7;
    errMissingEnd       = 8;
    errNotFound         = 9;
    errAlreadyExists    = 10;
    errBadHex           = 11;
    errBadDec           = 12;
    errStrToCard        = 13;
    errBeforeStart      = 14;
    errEndPastSize      = 15;
    errStartPastSize    = 16;
    errSameSourceTarget = 17;
    errNonsense         = 18;
    errRenameFailure    = 19;
    errAnotherNonsense  = 20;
    errBadOffset        = 21;
    errFileWasRO        = 22;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [option]... <source> <target> <start> <end|L[=]length|*[-#]>"+nl+
nl+
"  -o    overwrite existing <target>"+nl+
"  -t[t] create text <target> formatted for XD (-tt = -t -8)"+nl+
"  -8    output 8 hexadecimal bytes instead of 16 (-t[t])"+nl+
"  -n    do not display data in ASCII alongside data in hexadecimal (-t[t])"+nl+
"  -u    hexadecimal data in uppercase"+nl+
"  -r    rename existing <target>, if any"+nl+
'  -b    do not create backup (only if <target> was specified as "'+star+'" or "'+equal+'")'+nl+
"  -z    abort data extraction at first encountered $00 byte (C-style string)"+nl+
nl+
"a) <start> address is 0-based."+nl+
'b) <end> address can be specified as "*[-#]" for "end of file" ;'+nl+
"   optional concatenated value is relative negative offset."+nl+
'c) Hexadecimal values are prefixed with "$" ;'+nl+
'   supported inner cosmetic separators are any of "'+cosmeticseparators+'" ;'+nl+
"   supported suffixes for multiples of 1000 are K, M, G ;"+nl+
"   supported suffixes for multiples of 1024 are Kb, Mb, Gb."+nl+
'd) If <target> is specified as "'+star+'" or "'+equal+'", it will become <source>.'+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" -t c:\win31\system\user.exe guesswho $29e2c L30"+nl+
"           "+ProgEXEname+" xpsp3.nrg xpsp3.iso 307200 *-156"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errUnknownOption :
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errUneededParm :
        Str.Concat(S,"Uneeded ",einfo);Str.Append(S," parameter !");
    | errMissingSource :
        S:="Missing <source> specification !";
    | errMissingTarget :
        S:="Missing <target> specification !";
    | errMissingStart :
        S:="Missing <[$]start> specification !";
    | errMissingEnd :
        S:="Missing <[$]end|L[$]length|*> specification !";
    | errNotFound :
        Str.Concat(S,einfo," <source> does not exist !");
    | errAlreadyExists :
        Str.Concat(S,einfo," <target> already exists !");
    | errBadHex:
        Str.Concat(S,"Illegal characters in hexadecimal ",einfo);Str.Append(S," value !");
    | errBadDec:
        Str.Concat(S,"Illegal characters in decimal ",einfo);Str.Append(S," value !");
    | errStrToCard:
        Str.Concat(S,"Illegal (",einfo);Str.Append(S,") value !");
    | errBeforeStart:
        S := "End position is before start position !";
    | errEndPastSize:
        S := "End position is beyond end of <source> !";
    | errStartPastSize:
        S := "Start position is beyond end of <source> !";
    | errSameSourceTarget:
        S := "<source> and <target> must be different !";
    | errNonsense:
        S := "-o and -r are mutually exclusive !";
    | errRenameFailure:
        Str.Concat(S,"No new name could be created for ",einfo);Str.Append(S," <target> !");
    | errAnotherNonsense:
        Str.Concat(S,einfo," option is a nonsense when <target> is <source> !");
    | errBadOffset:
        Str.Concat(S,einfo," relative offset must be smaller than file size !");
    | errFileWasRO:
        Str.Concat(S,einfo," is read-only !");
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
    tmpbuffersize   = ioBufferSize * 8;
    lasttmpbuffer   = tmpbuffersize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC; (* //XDS byte *)
VAR
    bufferIn  : ioBuffer;
    bufferOut : ioBuffer;
    tmpbuffer : ARRAY [firstBufferByte..lasttmpbuffer] OF SYSTEM.LOC; (* //XDS BYTE; *)

(* ------------------------------------------------------------ *)

PROCEDURE PadHex (v : LONGCARD; digits : CARDINAL) : str16;
CONST
    padStr = "0000000000000000"; (* 16 digits *)
VAR
    S : str16;
    R : str16;
    ok : BOOLEAN;
    delta : CARDINAL;
BEGIN
    digits := digits MOD 16; (* better safe than sorry! *)
    Str.CardToStr (v,S,16,ok);
    delta := digits - Str.Length(S);
    Str.Slice (R,padStr,0,delta);
    Str.Append (R,S);
    Str.Lows(R);
    RETURN R;
END PadHex;

PROCEDURE PadDec (v : LONGCARD; digits : CARDINAL) : str16;
CONST
    padStr = "                "; (* 16 digits *)
VAR
    S : str16;
    R : str16;
    ok : BOOLEAN;
    delta : CARDINAL;
BEGIN
    digits := digits MOD 16; (* better safe than sorry! *)
    Str.CardToStr (v,S,10,ok);
    delta := digits - Str.Length(S);
    Str.Slice (R,padStr,0,delta);
    Str.Append (R,S);
    RETURN R;
END PadDec;

PROCEDURE Filter (c : CHAR) : CHAR;
BEGIN
    IF ( (ORD(c) < ORD(blank)) OR (ORD(c) = 255) ) THEN
        RETURN ".";
    ELSE
        RETURN c;
    END;
END Filter;

(* ------------------------------------------------------------ *)

PROCEDURE newname (VAR S : pathtype):BOOLEAN ;
CONST
    maxtries = 999;
    maxf8    = 8;
    max9X    = 128; (* should be more than enough *)
VAR
    u,d,n,e,newfile,fname : pathtype;
    i   : LONGCARD;
    num : str16;
    ok  : BOOLEAN;
    len,maxlen : CARDINAL;
BEGIN
    maxlen := max9X;
    qdSplitAllPath(S,u,d,n,e);
    len:=Str.Length(n);
    i:=0;
    LOOP
        Str.CardToStr(i,num,10,ok);
        WHILE (len+Str.Length(num)) > maxlen DO
            Str.Delete(n,len-1,1); (* delete last char of name *)
            DEC(len);
        END;
        Str.Concat(fname,n,num); (* build new name *)
        Lib.MakeAllPath(newfile,u,d,fname,e);
        IF FIO.Exists(newfile)=FALSE THEN
            Str.Copy(S,newfile);
            RETURN TRUE;
        END;
        INC(i);
        IF i > maxtries THEN EXIT; END;
    END;
    RETURN FALSE;
END newname;

PROCEDURE newExtension (VAR R:pathtype;S:pathtype;e3:ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    Str.Copy(R,S);
    p := Str.RCharPos(R,dot);
    IF p = MAX(CARDINAL) THEN
        Str.Append(R,e3);
    ELSE
        R[p]:=CHR(0);
        Str.Append(R,e3);
    END;
END newExtension;

(* ------------------------------------------------------------ *)

PROCEDURE verify (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verify;

(*
PROCEDURE StrToLong (S:ARRAY OF CHAR; VAR v : LONGCARD) : CARDINAL;
CONST
    digits    = "0123456789";
    hexdigits = "ABCDEF"+digits;
VAR
    ok : BOOLEAN;
    base : CARDINAL;
BEGIN
    IF S[0]=dollar THEN
        Str.Delete(S,0,1);
        IF verify(S,hexdigits)=FALSE THEN RETURN errBadHex;END;
        base := 16;
    ELSIF ( (S[0]="0") AND (S[1]="X") ) THEN
        Str.Delete(S,0,2);
        IF verify(S,hexdigits)=FALSE THEN RETURN errBadHex;END;
        base := 16;
    ELSE
        IF verify(S,digits)=FALSE THEN RETURN errBadDec;END;
        base := 10;
    END;
    v:=Str.StrToCard(S,base,ok);
    IF ok THEN
        RETURN errNone;
    ELSE
        RETURN errStrToCard;
    END;
END StrToLong;
*)

(* assume already trimmed and in uppercase -- strToLC() from FU.MOD *)

PROCEDURE StrToLong (S:ARRAY OF CHAR; VAR v:LONGCARD):CARDINAL;
CONST
    bmul  = 1;
    Kbmul = 1024;  Mbmul = Kbmul * Kbmul;  Gbmul = Kbmul * Mbmul;
    rKmul = 1000;  rMmul = rKmul * rKmul;  rGmul = rKmul * rMmul;
CONST
    sMul  = "KB KO MB MO GB GO KK K MM M GG G"; (* uppercase, longest first, us and fr *)
CONST
    cosmeticseparators = coma+dot+underscore;
VAR
    base,i,p:CARDINAL;
    ok:BOOLEAN;
    vmax,mul:LONGCARD;
    abrev:str2;
BEGIN
    IF same(S,"*") THEN v:=MAX(LONGCARD);RETURN errNone;END;
    Str.Caps(S);
    (* now for prefix *)
    base:=16;
    IF Str.Match(S,dollar+"*") THEN
        Str.Delete(S,0,1);
    ELSIF Str.Match(S,"0X*") THEN
        Str.Delete(S,0,2);
    ELSIF Str.Match(S,"*H") THEN
        p:=Str.RCharPos(S,"H");
        Str.Delete(S,p,1);
    ELSE
        base:=10;
    END;
    (* now for cosmetix *)
    FOR i:=1 TO Str.Length(cosmeticseparators) DO
        ReplaceChar(S,cosmeticseparators[i-1],"");
    END;
    (* now for suffixes *)
    mul:=bmul;
    IF base = 10 THEN
        i:=0;
        LOOP
            isoleItemS(abrev, sMul,blank,i);
            IF same(abrev,"") THEN EXIT; END;
            IF Str.Pos(S,abrev) # MAX(CARDINAL) THEN
                Str.Subst(S,abrev,"");
                CASE i OF
                | 0,1:  mul:= Kbmul;
                | 2,3:  mul:= Mbmul;
                | 4,5:  mul:= Gbmul;
                | 6,7:  mul:= rKmul;
                | 8,9:  mul:= rMmul;
                |10,11: mul:= rGmul;
                END;
               EXIT;
            END;
            INC(i);
        END;
    END;
    v:=Str.StrToCard(S,base,ok);
    IF ok THEN
        IF mul # bmul THEN
            vmax:=MAX(LONGCARD) DIV mul;
            IF v > vmax THEN
                ok:=FALSE; (* too big *)
            ELSE
                v :=v * mul;
            END;
        END;
        i:= errNone;
    ELSE
        i:= errStrToCard;
    END;
    RETURN i;
END StrToLong;

(* ------------------------------------------------------------ *)

PROCEDURE header( src,dest:pathtype;pos,lastpos,count:LONGCARD;
                  renamed : BOOLEAN; orgdest:pathtype;
                  VAR S1,S2,S3,S1BIS:ARRAY OF CHAR);
CONST
    wihex      = 8;
    widec      = 10; (* ########## *)
    performing = "Extracting data";
    performed  = "Data extracted";
CONST
    headhex    = "[ $";
    midhex     = ".. $";
    trailhex   = "], count= $";
    headdec    = "[";
    middec     = "..";
    traildec   = "], count=";
VAR
    newdest : str1024;
BEGIN
    Str.Copy(newdest,dest);
    Str.Prepend(newdest,dquote);
    Str.Append(newdest,dquote);
    IF renamed THEN
        Str.Append(newdest," (");
        Str.Append(newdest,dquote);
        Str.Append(newdest,orgdest);
        Str.Append(newdest,dquote);
        Str.Append(newdest,")");
    END;

    Str.Concat(S1,performing," from ");
    Str.Append(S1,dquote);
    Str.Append(S1,src);
    Str.Append(S1,dquote);
    Str.Append(S1," to ");
    Str.Append(S1,newdest);
    Str.Append(S1,nl);

    Str.Concat(S2,headhex,PadHex(pos,wihex));
    Str.Append(S2,midhex);
    Str.Append(S2,PadHex(lastpos,wihex));
    Str.Append(S2,trailhex);
    Str.Append(S2,PadHex(count,wihex));
    Str.Append(S2,nl);

    Str.Concat(S3,headdec,PadDec(pos,widec));
    Str.Append(S3,middec);
    Str.Append(S3,PadDec(lastpos,widec));
    Str.Append(S3,traildec);
    Str.Append(S3,PadDec(count,widec));
    Str.Append(S3,nl);

    Str.Concat(S1BIS,performed," from ");
    Str.Append(S1BIS,dquote);
    Str.Append(S1BIS,src);
    Str.Append(S1BIS,dquote);
    Str.Append(S1BIS,nl);
END header;

(* we use tmpbuffer *)

PROCEDURE dumpxd (hnd:FIO.File;offset:LONGCARD;total:CARDINAL;
                  showascii,lowercase:BOOLEAN;row:CARDINAL);
CONST
    sepaddrbeg  = " :";
    sepaddr     = sepaddrbeg+" ";
    sepasciibeg = " |"; (* for safety, must be different from sepaddr *)
    sepascii    = sepasciibeg+" ";
    sep         = "  ";
VAR
    i,j : CARDINAL;
    V : str16;
    O : str256;
    R : str128;
    c : SYSTEM.LOC; (* //XDS BYTE was too simple, eh ! *)
BEGIN
    i:=0;
    LOOP
        IF i >= total THEN EXIT; END;
        V := PadHex(offset+LONGCARD(i),8);
        Str.Concat(O,V,sepaddr);

        Str.Copy(R,"");
        FOR j := 1 TO row DO
            IF (i+j-1) < total THEN
                c := tmpbuffer[i+j];
                V := PadHex(LONGCARD(ORD(c)),2); (* $$ *)
                Str.Append(R,V);
            ELSE
                Str.Append(R,sep);
            END;
            IF j < row THEN Str.Append(R," "); END;
        END;
        Str.Append(O,R);
        IF lowercase THEN Str.Lows(O);END;
        IF showascii THEN
            Str.Copy(R,sepascii);
            FOR j := 1 TO row DO
                IF (i+j-1) < total THEN
                    c :=  Filter(   CHAR(tmpbuffer[i+j])  ) ;
                    Str.Append(R, CHAR(c) );
                END;
            END;
            Str.Append(O,R);
        END;

        Str.Append(O,nl);
        FIO.WrStr(hnd,O);
        INC(i,row);
    END;
END dumpxd;

(* ------------------------------------------------------------ *)

PROCEDURE doExtract (src,dest:pathtype; pos,lastpos,count:LONGCARD;
                     forXD,showascii,lowercase,cstring:BOOLEAN;
                     bytesPerLine:CARDINAL;
                     renamed:BOOLEAN;orgtarget:pathtype);
CONST
    msg = "Working "; (* space needed *)
VAR
    hin,hout:FIO.File;
    S1,S2,S3,S1BIS:str1024; (* were str128 but with LFNs... *)
    remaining : LONGCARD;
    wanted,got : CARDINAL;
    i,p : CARDINAL;
    cstringfound:BOOLEAN;
BEGIN
    cstringfound :=FALSE;

    hin:=FIO.OpenRead(src);
    FIO.AssignBuffer(hin,bufferIn);
    hout:=FIO.Create(dest);
    FIO.AssignBuffer(hout,bufferOut);

    header ( src,dest,pos,lastpos,count,
             renamed,orgtarget,
             S1,S2,S3,S1BIS );

    WrStr(S1);
    WrLn;
    WrStr(S2);
    WrStr(S3);

    IF forXD THEN
        FIO.WrStr(hout,semicolon+nl);
        FIO.WrStr(hout,semicolon+blank);FIO.WrStr(hout,S1BIS);
        FIO.WrStr(hout,semicolon+nl);
        FIO.WrStr(hout,semicolon+blank);FIO.WrStr(hout,S2);
        FIO.WrStr(hout,semicolon+blank);FIO.WrStr(hout,S3);
        FIO.WrStr(hout,semicolon+nl+nl);
    END;

    FIO.Seek(hin,pos);
    remaining:=count;

    LOOP
        IF remaining = 0 THEN EXIT; END;
        IF remaining > tmpbuffersize THEN
            wanted := tmpbuffersize;
            DEC(remaining,tmpbuffersize);
        ELSE
            wanted := CARDINAL(remaining);
            remaining := 0;
        END;
        got := FIO.RdBin(hin,tmpbuffer,wanted);
        IF cstring THEN
            IF got # 0 THEN (* safety ! *)
                p:=Lib.ScanR( SYSTEM.ADR(tmpbuffer), got, SYSTEM.LOC(00H) );
                IF p # got THEN (* found, truncate data and force next EXIT *)
                    got := p;
                    remaining:=0;
                    cstringfound:=TRUE;
                END;
            END;
        END;
        IF forXD THEN
            dumpxd (hout,pos+count-remaining-LONGCARD(wanted),got,showascii,lowercase,bytesPerLine);
        ELSE
            FIO.WrBin(hout,tmpbuffer,got);
        END;
    END;

    FIO.Flush(hout);
    FIO.Close(hout);
    FIO.Close(hin);

    IF (cstring AND cstringfound) THEN
        WrLn;
        WrStr("Data truncated at first encountered $00 byte.");WrLn;
    END;

END doExtract;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount : CARDINAL;
    i,opt     : CARDINAL;
    S,R       : pathtype;
    source,target : pathtype;
    sStartaddr, sEndaddr : str128;
    status    : (waiting,gotsource,gottarget,gotstartaddr,gotendaddr);

    overwrite, autorename, forXD : BOOLEAN;
    bytesPerLine:CARDINAL;
    showascii, lowercase, samename, nobackup, cstring : BOOLEAN;
    nullcount,DEBUG : BOOLEAN;

    renamed,wasRO   : BOOLEAN;
    orgtarget : pathtype;

    fsize,pos,lastpos,count,negofs : LONGCARD;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    DEBUG        := FALSE;
    overwrite    := FALSE;
    autorename   := FALSE;
    forXD        := FALSE;
    bytesPerLine := 16;
    showascii    := TRUE;
    lowercase    := TRUE;
    samename     := FALSE;
    nobackup     := FALSE;
    renamed      := FALSE;
    cstring      := FALSE;
    Str.Copy(orgtarget,"");

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    status := waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);  cleanCLI(R); ReplaceChar(R,dquote,""); (* YATB ! *)
        IF isOption(R)=TRUE THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "T"+delim+"TEXT"+delim+
                                  "8"+delim+
                                  "N"+delim+"NOASCII"+delim+
                                  "U"+delim+"UPPERCASE"+delim+
                                  "Q"+delim+"QUIET"+delim+
                                  "R"+delim+"RENAME"+delim+
                                  "B"+delim+"NOBACKUP"+delim+
                                  "Z"+delim+"ZEROTERMINATED"+delim+
                                  "LFN"+delim+"X"+delim+
                                  "TT"+delim+
                                  "DEBUG"

                              );
            CASE opt OF
            |  1,  2,  3 : abort(errHelp,"");
            |  4,  5     : overwrite    := TRUE;
            |  6,  7     : forXD        := TRUE;
            |  8         : bytesPerLine := 8;
            |  9, 10     : showascii    := FALSE;
            | 11, 12     : lowercase    := FALSE;
            | 13, 14     : ;
            | 15, 16     : autorename   := TRUE;
            | 17, 18     : nobackup     := TRUE;
            | 19, 20     : cstring      := TRUE;
            | 21, 22     : ;
            | 23         : forXD        := TRUE;
                           bytesPerLine := 8;
            | 24         : DEBUG        := TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            CASE status OF
            | waiting      : Str.Copy(source,R);
            | gotsource    : Str.Copy(target,R);
            | gottarget    : Str.Copy(sStartaddr,R);
            | gotstartaddr : Str.Copy(sEndaddr,R);
            | gotendaddr   : abort(errUneededParm,S);
            ELSE
                ; (* //XDS YASIR ! *)
            END;
            INC(status);
        END;
    END;

    CASE status OF
    | waiting      : abort(errMissingSource,"");
    | gotsource    : abort(errMissingTarget,"");
    | gottarget    : abort(errMissingStart,"");
    | gotstartaddr : abort(errMissingEnd,"");
    | gotendaddr   : ; (* ok for now *)
    ELSE
        ; (* //XDS YASIR ! *)
    END;


    IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source); END;

    IF (overwrite AND autorename) THEN abort(errNonsense,"");END;

    IF ( same(target,star) OR same(target,equal) ) THEN
        IF forXD THEN abort(errAnotherNonsense,"-t");END;
        IF autorename THEN abort(errAnotherNonsense,"-r");END;
        samename:=TRUE;
    END;

    fsize := getFileSize(source);

    IF StrToLong (sStartaddr,pos) # errNone THEN abort(errStrToCard,sStartaddr);END;
    INC(pos); (* 1-based now *)

    nullcount:=FALSE;
    CASE sEndaddr[0] OF
    | star :
        IF same(sEndaddr,star) THEN
            lastpos:=fsize;
        ELSE
            Str.Delete(sEndaddr,0,1);
            IF Str.Match(sEndaddr,minus+"*") THEN
                Str.Delete(sEndaddr,0,1);
                IF StrToLong(sEndaddr,negofs) # errNone THEN abort(errStrToCard,sEndaddr);END;
                IF negofs >= fsize THEN abort(errBadOffset,sEndaddr);END;
                lastpos:=fsize-negofs;
            ELSE
                abort(errStrToCard,sEndaddr);
            END;
        END;
    | "L": (* we kept uppercase *)
        Str.Delete(sEndaddr,0,1);
        CASE sEndaddr[0] OF
        | equal, colon :
            Str.Delete(sEndaddr,0,1); (* kludge ! *)
        ELSE
            ; (* //XDS YASIR ! *)
        END;
        IF same(sEndaddr,star) THEN
            lastpos:=fsize;
        ELSE
            IF StrToLong(sEndaddr,count) # errNone THEN abort(errStrToCard,sEndaddr);END;
            IF count=0 THEN nullcount:=TRUE;END;
            lastpos:=pos+count-1; (* at worst (0+1)+0-1=0 *)
        END;
    ELSE
        IF StrToLong(sEndaddr,lastpos) # errNone THEN abort(errStrToCard,sEndaddr);END;
        INC(lastpos);
        IF lastpos = 0 THEN abort(errEndPastSize,sEndaddr); END; (* v1.2h check rollover *)
    END;

    IF fsize = 0 THEN
        IF pos     > 1 THEN abort(errStartPastSize,sStartaddr);END;
        IF lastpos > 1 THEN abort(errEndPastSize,sEndaddr);END;
        IF NOT(nullcount) THEN abort(errEndPastSize,sEndaddr);END;
        lastpos:=pos;
        count:=0;
    ELSE
        IF pos     > fsize THEN abort(errStartPastSize,sStartaddr);END;
        IF lastpos > fsize THEN abort(errEndPastSize,sEndaddr);END;
        IF nullcount THEN
            lastpos:=pos;
            count:=0; (* done already ! for beauty ! *)
        ELSE
            IF lastpos < pos THEN abort(errBeforeStart,sEndaddr);END;
            count:=lastpos-pos+1;
        END;
    END;

    DEC(pos);
    DEC(lastpos);

    CASE samename OF
    | TRUE:
        Str.Copy(target,source);
        newExtension(source,target,extBAK);
        FIO.Rename(target,source);
        IF fileIsRO(target)=FALSE  THEN
            wasRO:=FALSE;
        ELSE
            wasRO:=TRUE;
            abort(errFileWasRO,target);
        END;
        doExtract( source,target,pos,lastpos,count,
                   forXD,showascii,lowercase,cstring,bytesPerLine,
                   renamed,orgtarget);
        IF nobackup THEN
            IF fileIsRO(source) THEN abort(errFileWasRO,source);END;
            FIO.Erase(source);
            WrLn;
            WrStr('"');WrStr(source);WrStr('" backup has been deleted !');WrLn;
        END;
    | FALSE:
        IF FIO.Exists(target) THEN
            IF same(source,target) THEN abort(errSameSourceTarget,""); END;
            IF overwrite THEN
                IF fileIsRO(target) THEN abort(errFileWasRO,target); END;
            ELSE
                IF autorename THEN
                    Str.Copy(orgtarget,target);
                    IF newname(target)=FALSE THEN
                        abort(errRenameFailure,target);
                    END;
                    renamed:=TRUE;
                ELSE
                    abort(errAlreadyExists,target);
                END;
           END;
        END;
        doExtract( source,target,pos,lastpos,count,
                   forXD,showascii,lowercase,cstring,bytesPerLine,
                   renamed,orgtarget);
    ELSE
        ; (* //XDS YASIR ! now this is RIDICULOUS ! *)
    END;

    abort(errNone,"");
END Xtract32.


