(* ---------------------------------------------------------------
Title         Q&D Try And Overwrite Deleted Entry Names
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(

              any undeleter shows very old and overwritten
              deleted filenames are still recoverable
              seems there's nothing to do against this behavior
              especially with NTFS systems
              and as it is almost impossible to program
              at bare metal level...
              defragmenting seems useless
              this was an idea for an experimental fix :
              overwriting specified directories
              with dozens of files (incremented filenames, 0 or 1 byte long)
              this trick, should had it worked, would have done nothing
              for files still visible in deleted subdirs

              another useless idea... ;-)
              recreating a deleted subdir then filling it again might work

              error checking is minimal

              v0.9 for now because very experimental and utterly useless

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs	      here, FIO.ReadFirstEntry() used by isDirectory()
              really does not like unexisting directories... go figure !
              no time nor will to investigate : just make sure directories
	      specified in dirlist *do* exist -- after all, they are supposed to !
              yes, yes, we should check handle returned by fileCreate()
	      is not MAX(CARDINAL)... in another life !
Wish List     back to the AIM-65 and Apple ][+ days...
              or a one-way travel to Finney's Verna...
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 20 Aug 23 an ugly really Q&D port from GOTOHELL v0.9 for DOS
--------------------------------------------------------------- *)

MODULE gotoHell;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn,WrCard,WrLngCard;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    (* select an executable filename ! *)
    useGOTOHELL     = TRUE;  (* go away from this entry space ! *)
    useOBLIVION     = FALSE; (* go forgotten once and for all ! *)
    useMASKEM       = FALSE; (* have a mask so you're anonymous... and cannot breathe too ! *)

    ProgEXEname     = "GOTOHELL32";
    ProgTitle       = "Q&D TryAndOverwriteDeletedEntryNames (Win32)";
    ProgVersion     = "v0.9 (from v0.9 for DOS)";
    ProgCopyright   = "by PhG";
    Banner          = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    strDefaultLFNbasename = "GoAway!GoAway!GoAway!.tmp";
    strDefaultDOSbasename = "DIE!.TMP";
    mincount            = 1;
    maxcount            = 9999;
    winum               = 4; (* #### *)
    wiDOSf8             = 8-winum;
    wiDOSe3             = 1+3; (* leading dot *)
    strCountRange       = "[1..9999]";
CONST
    sINFO           = "::: ";
    sPB             = "--- ";
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errMissingParm  = 4;
    errNotFound     = 5;
    errBadCount     = 6;
    errCountRange   = 7;
    errSyntax       = 8;
    errBadBasename  = 9;
    errBadDirList   = 10;
    errIsDir        = 11;
    errAborted      = 255;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <[@]dirlist> <count> [basename] [option]..."+nl+
nl+
"This program creates <count> files named ####basename"+nl+
"for each directory specified in <[@]dirlist>,"+nl+
"then deletes them all unless instructed no to."+nl+
"Yet Another Useless Idea. ;-)"+nl+
nl+
"    -k[e|k] keep created files instead of deleting them (-ke = -k -e)"+nl+
"    -e[k|e] create 0-byte files instead of 1-byte files (-ek = -e -k)"+nl+
(* "    -x      disable LFN support even if available"+nl+ *)
nl+
"a) Each entry in <[@]dirlist> must be a valid directory in canonical form."+nl+
"b) <count> must belong to "+strCountRange+"."+nl+
'c) Default basefilename is "'+strDefaultLFNbasename+'".'+nl+
"d) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Example : "+ProgEXEname+" list.lst 500 _tryandoverwriteme.$$$"+nl;

VAR
    S : str1024; (* was str256 but in case we get a LFN... *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errOption:       S:= 'Unknown "~" option !';
    | errTooManyParms: S:= '"~" parameter is one too many !';
    | errMissingParm:  S:= 'Missing "~" parameter !';
    | errNotFound:     S:= '"~" does not exist !';
    | errBadCount:     S:= 'Illegal "~" <count> value !';
    | errCountRange:   S:= '"~" <count> must belong to '+strCountRange+"range !";
    | errSyntax:       S:= "Please check syntax !";
    | errBadBasename:  S:= 'Illegal "~" basename !';
    | errBadDirList:   S:= 'Illegal "~" dirlist !';
    | errIsDir:        S:= '"~" looks like a directory !';
    | errAborted:      S:= "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT(e);
END abort;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.BYTE;
VAR
    ioBufferIn    : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fixTrailingDot (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = dot THEN RETURN; END;
    Str.Append(S,dot);
END fixTrailingDot;

PROCEDURE unfixTrailingDot (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # dot THEN RETURN; END;
    Str.Delete(S,len-1,1);
END unfixTrailingDot;

PROCEDURE fmtnum (v:LONGCARD;wi:CARDINAL;padchar:CHAR):str16;
VAR
    N:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(v,N,10,ok);
    IF ok THEN
        FOR i:= Str.Length(N)+1 TO wi DO
            Str.Prepend(N,padchar);
        END;
    ELSE
        N:="";
        FOR i:= 1 TO wi DO Str.Append(N,"#");END;
    END;
    RETURN N;
END fmtnum;

PROCEDURE pad (wi:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    FOR i:=Str.Length(R)+1 TO wi DO Str.Append(R," ");END;
END pad;

(* ------------------------------------------------------------ *)

CONST
               (* 12345678901234567890 *)
    msgDirList = "dirlist";
    msgBasename= "basename";
    msgCount   = "count";
    msgEmpty   = "empty files";
    msgDelete  = "delete files";
    msgUseLFN  = "LFN";
    wimsg      = 12; (* longest *)

PROCEDURE msgstr (S1,S2:ARRAY OF CHAR   );
VAR
    S:str256;
BEGIN
    Str.Copy(S,S1);
    pad(wimsg,S);
    Str.Prepend(S,sINFO);
    Str.Append(S,' : "~"');
    Str.Subst(S,"~",S2);
    WrStr(S);WrLn;
END msgstr;

PROCEDURE msgbool (S1:ARRAY OF CHAR;tf:BOOLEAN);
CONST
    strYes = "yes";
    strNo  = "no";
VAR
    S:str256;
    truth:str16;
BEGIN
    Str.Copy(S,S1);
    pad(wimsg,S);
    Str.Prepend(S,sINFO);
    Str.Append(S,' : ~');
    IF tf THEN
        truth:=strYes;
    ELSE
        truth:=strNo;
    END;
    Str.Subst(S,"~",truth);
    WrStr(S);WrLn;
END msgbool;

PROCEDURE msgcard (S1:ARRAY OF CHAR;v:CARDINAL);
VAR
    S:str256;
BEGIN
    Str.Copy(S,S1);
    pad(wimsg,S);
    Str.Prepend(S,sINFO);
    Str.Append(S,' : ~');
    Str.Subst(S,"~",fmtnum(LONGCARD(v),1," ")); (* OR winum ? *)
    WrStr(S);WrLn;
END msgcard;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isValidBasename ( useLFN:BOOLEAN;Z:pathtype):BOOLEAN;
CONST
    dotstarpat = ".*";
VAR
    S,u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    Str.Copy(S,Z);
    fixTrailingDot(S);

    pb:=0;
    qdSplitAllPath(S, u,d,n,e);
    IF Str.Length(u) > 0 THEN INC(pb);END;
    IF Str.Length(d) > 0 THEN INC(pb);END;
    IF Str.Length(n) < 1 THEN INC(pb);END;
    IF Str.Length(e) < 1 THEN INC(pb);END;
    IF Str.Match(e,dotstarpat)=FALSE THEN INC(pb);END;

    IF NOT(useLFN) THEN
        IF Str.Length(n) > wiDOSf8 THEN INC(pb);END;
        IF Str.Length(e) > wiDOSe3 THEN INC(pb);END;
    END;
    RETURN (pb=0);
END isValidBasename;

(* ------------------------------------------------------------ *)

PROCEDURE preprocessLine (useLFN:BOOLEAN; VAR S:ARRAY OF CHAR):BOOLEAN;
CONST
    quotedpat     = '"*"';
    canonicalpat  = "?:\*";
VAR
    len:CARDINAL;
    ok:BOOLEAN;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    IF Str.Match(S,quotedpat) THEN
        Str.Delete(S,0,1);
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
        LtrimBlanks(S);
        RtrimBlanks(S);
    END;
    ok:=Str.Match(S,canonicalpat);
    IF ok THEN
        ok:=isDirectory(S);
        IF ok THEN fixDirectory(S); END;
    END;
    RETURN ok;
END preprocessLine;

PROCEDURE procList (DEBUG,useLFN,createempty,keepalive:BOOLEAN;count:CARDINAL;
                   dirlist,basename:pathtype ):CARDINAL ;
CONST
    msgProcessing = sINFO+'processing "~"';
    msgSkipping   = sPB  +'skipping   "~"';
    stardotpat = "*.";
VAR
    hin,h:FIO.File;
    DIR,CREATED:pathtype;
    ok,aborted:BOOLEAN;
    i,n,poll,currpoll:CARDINAL;
    msg:str1024;
    zero:SHORTCARD;
BEGIN
    zero := 0;

    IF useLFN THEN
        poll := 50; (* vindoze does not like frequent calls TO chkEscape() *)
    ELSE
        poll := 5;
    END;
    currpoll:=0;

    aborted:=FALSE;
    FIO.EOF := FALSE;
    hin:=FIO.OpenRead(dirlist);
    FIO.AssignBuffer(hin,ioBufferIn);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,DIR);
        IF FIO.EOF THEN EXIT; END;
        ok:=preprocessLine(useLFN,DIR);
        IF ok THEN
            fixDirectory(DIR);
            msg:=msgProcessing;
        ELSE
            msg:=msgSkipping;
        END;
        Str.Subst(msg,"~",DIR);
        WrStr(msg);WrLn;

        IF ok THEN
            n:=mincount-1;
            LOOP
                INC(n);
                Str.Concat(CREATED,fmtnum(LONGCARD(n),4,"0"),basename);
                Str.Prepend(CREATED,DIR);
                IF DEBUG THEN WrStr("created ");WrStr(CREATED);WrLn;END;
                h:=FIO.Create(CREATED);
                IF NOT(createempty) THEN
                    FIO.WrBin(h,zero,SIZE(zero));
                END;
                FIO.Close(h);

                INC(currpoll);
                IF (currpoll MOD poll) = 0 THEN
                    aborted:=ChkEscape();IF aborted THEN EXIT;END;
                    currpoll:=0;
                END;

                IF n >= count THEN EXIT;END;
            END;
            IF NOT(keepalive) THEN
                FOR i:= mincount TO n DO
                    Str.Concat(CREATED,fmtnum(LONGCARD(i),4,"0"),basename);
                    Str.Prepend(CREATED,DIR);
                    IF DEBUG THEN WrStr("deleted "); WrStr(CREATED);WrLn;END;
                    FIO.Erase(CREATED);
                END;
            END;
        END;
    END;
    FIO.Close(hin);
    IF aborted THEN
        i:=errAborted;
    ELSE
        i:=errNone;
    END;
    RETURN i;
END procList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype; (* was str128 *)
    state           : (waiting,gotdirlist,gotcount,gotbasename);
    dirlist,basename:pathtype;
    createempty,keepalive : BOOLEAN;
    lc:LONGCARD;
    count:CARDINAL;
VAR
    DEBUG,useLFN:BOOLEAN;
    poll,currpoll:CARDINAL;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.ShareMode:=FIO.ShareDenyNone;

    WrLn;

    basename    := "";
    createempty := FALSE;
    keepalive   := FALSE;
    useLFN      := TRUE;
    DEBUG       := FALSE;

    state   := waiting;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "x"+delim+"lfn"+delim+
                                   "K"+delim+"KEEP"+delim+
                                   "E"+delim+"EMPTY"+delim+
                                   "KE"+delim+"KK"+delim+
                                   "EK"+delim+"EE"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : ; (* useLFN      := FALSE; *)
            | 6,7   : keepalive   := TRUE;
            | 8,9   : createempty := TRUE;
            | 10,11 : keepalive   := TRUE; createempty := TRUE;
            | 12,13 : createempty := TRUE; keepalive   := TRUE;
            | 14    : DEBUG       := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting    : Str.Copy(dirlist,S);
            | gotdirlist : Str.Prepend(R,"-N:");
                           IF GetLongCard(R,lc)=FALSE THEN abort(errBadCount,S);END;
                           IF lc > maxcount THEN abort(errCountRange,S);END;
                           IF lc < mincount THEN abort(errCountRange,S);END;
                           count:=CARDINAL(lc);
            | gotcount:    Str.Copy(basename,S);
                           IF Str.RCharPos(basename,dot)=MAX(CARDINAL) THEN
                               Str.Append(basename,dot);
                           END;
            | gotbasename: abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;

    (* useLFN := (useLFN AND fileSupportLFN() ); *)

    IF same(basename,"") THEN
        IF useLFN THEN
            basename:=strDefaultLFNbasename;
        ELSE
            basename:=strDefaultDOSbasename;
        END;
    END;

    IF DEBUG THEN
        msgstr(msgDirList,dirlist);
        msgstr(msgBasename,basename);
        msgcard(msgCount,count);
        msgbool(msgEmpty,createempty);
        msgbool(msgDelete,NOT(keepalive));
        msgbool(msgUseLFN,useLFN);
        WrLn;
    END;

    CASE state OF
    | waiting:     abort(errSyntax,"");
    | gotdirlist:  abort(errSyntax,"");
    | gotcount:    ;
    | gotbasename: IF isValidBasename(useLFN,basename) = FALSE THEN
                       abort(errBadBasename,basename);
                   END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    i:=0;
    IF same(dirlist,dot) THEN INC(i);END;
    IF chkJoker(dirlist) THEN INC(i);END;
    IF i # 0 THEN abort(errBadDirList,dirlist);END;

    IF Str.Match(dirlist,"@*") THEN Str.Delete(dirlist,0,1);END;

    unfixTrailingDot(dirlist);
    unfixTrailingDot(basename);
    IF isDirectory(dirlist) THEN abort(errIsDir,dirlist);END;
    IF FIO.Exists(dirlist)=FALSE THEN abort(errNotFound,dirlist);END;

    IF DEBUG THEN
        msgstr(msgDirList,dirlist);
        msgstr(msgBasename,basename);
        msgcard(msgCount,count);
        msgbool(msgEmpty,createempty);
        msgbool(msgDelete,NOT(keepalive));
        msgbool(msgUseLFN,useLFN);
        WrLn;
    END;

    i:=procList(DEBUG,useLFN,createempty,keepalive,count,dirlist,basename);

    abort(i,"");
END gotoHell.



(*

; c:\z\x.y
zut
"c:\z"
; c:\

*)