(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         "the CASE against M2 ISO"
              "M2 ISO considered harmful"

              should a Win32 version be created,
              redirection will probably be a problem whether with XDS or ADW
              we don't care : we merely do DOS ;-)
              ah, we're too nice : let's process source and create a backup

              in EEVAL.MOD readtoken(), program v0.9a would wrongly fix
              outer LOOP with aa useless ELSE, thus preventing compilation
              by luck, only affected by the bug : EEVAL, STORM0, MPAUSE0

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              remember only DOS version (both executable and source code)
              is considered validated by years (er... hours, here) of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs
Wish List     better check parser even if it seems OK
              (for now, label program as v0.9)
              insert CASE line number for inserted ELSE ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  1 Dec 23 keep in sync with v1.0a for DOS
PhG 15 Mar 23 v1.0 matching bugfixed v1.0 for DOS
              removed REPEAT and BEGIN, added MODULE
              better debug display
PhG 16 Jun 19 fixed typo in help screen
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 26 Feb 16 v0.9a DOS -b is now default for Win32+LFN
              added -d for DOS backup form
PhG 12 Feb 16 an ugly really Q&D port from ISOCASE v0.9 for DOS
--------------------------------------------------------------- *)

MODULE ISOCASE32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn,WrChar,WrCard;



(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)




(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    extMOD          = ".MOD";
    extINI          = ".INI";
    extBAK          = ".ORG";
CONST
    defaultInsertMEhere = "ELSE ; (* //ISO fixed silly requirement *)";
    defaultTokenset     = lettersLow+lettersUpp+underscore;
    defaultTokensetfull = defaultTokenset+digits;
    (* avoid CASE here, of course *)
    defaultKeywords     = "FOR,IF,LOOP,"+
                          "MODULE,PROCEDURE,RECORD,WHILE";
    altcrlf1 = "$_";
    altcrlf2 = "\n";
CONST
    (* no inner space, no inner tab *)
    defaultINI = nl+
"   ; verbatim strings can be delimited with double or single quotes"+nl+
"   ; 1. inserted ELSE statement with a reminder"+nl+
"   ;    - note a trailing space separator will be added if omitted here ;"+nl+
'   ;    - note "'+altcrlf1+'" and "'+altcrlf2+'" are replaced with newline.'+nl+
'   "'+defaultInsertMEhere+'"'+nl+
"   ; 2. legal characters for first character of keyword"+nl+
'   "'+defaultTokenset+'"'+nl+
"   ; 3. legal characters for inner characters of keyword"+nl+
'   "'+defaultTokensetfull+'"'+nl+
"   ; 4. comma-separated keywords requiring an END (except CASE itself)"+nl+
'   "'+defaultKeywords+'"'+nl+
nl;

CONST
    ProgEXEname     = "ISOCASE32";
    ProgTitle       = "Q&D Modula-2 ISO CASE checker (Win32)";
    ProgVersion     = "v1.0a (from v1.0a for DOS)";
    ProgCopyright   = "by PhG";
    Banner          = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errJoker        = 4;
    errNotFound     = 5;
    errParm         = 6;
    errIniProblem   = 7;
    errStack        = 8;
    errBackup       = 9;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder = vbar;
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg = nl+
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <source["+extMOD+"]> [-![!]]"+nl+
nl+
"This program scans a TopSpeed Modula-2 source,"+nl+
"inserting the ELSE required by Modula-2 ISO for each CASE (if necessary)."+nl+
"Remarks and strings contents are ignored."+nl+
nl+
"This mandatory ELSE for each CASE is useless and stupid"+nl+
"whether the real-world programmer has handled all possible cases or not."+nl+
"The (censored) Modula-2 ISO academic committee has created the ternary BOOLEAN"+nl+
"requiring an ELSE in a CASE where both TRUE and FALSE are handled !"+nl+
'"The CASE against Modula-2 ISO" or "Modula-2 ISO considered harmful". ;-)'+nl+
nl+
"-@    dump fixed source to screen instead of modifying it"+nl+
"-![!] create default "+ProgEXEname+extINI+" in current directory then terminate"+nl+
"      (-!! = overwrite existing "+ProgEXEname+extINI+", if any)"+nl+
"-d    replace original extension with "+extBAK+nl+
nl+
"a) Source code is assumed to be correct (its compilation should be a success)."+nl+
"b) If "+ProgEXEname+extINI+" exist in either current or executable directory,"+nl+
"   the program will read four strings from it. Else, it will default to :"+nl+
defaultINI+
"c) For safety, original source will be kept with appended "+extBAK+" extension."+nl+
"d) Any inserted ELSE will have this form :"+nl+
nl+
'   "'+defaultInsertMEhere+'"'+nl+
nl+
"e) By design, jokers are not supported."+nl+
"f) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :        WrStr(errmsg);
    | errOption:       S:='Unknown "'+placeholder+'" option !';
    | errTooManyParms: S:='"'+placeholder+'" parameter is one too many !';
    | errJoker:        S:='No joker allowed in "'+placeholder+'" specification !';
    | errNotFound:     S:='No valid file matches "'+placeholder+'" specification !';
    | errParm:         S:="Expecting "+placeholder+" parameter !";
    | errIniProblem:   S:="Illegal "+placeholder+" file !";
    | errStack:        S:="Keywords stack overflow or  underflow !";
    | errBackup:       S:='Illegal "'+extBAK+'" extension in "'+placeholder+'" specification !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,placeholder,einfo);
        WrLn; (* was NOT dumped at program start *)
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType    = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
VAR
    ioBufferIn        : ioBufferType;
    ioBufferOut       : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    widbg = 4; (* strings *)
    wicard= 6;

PROCEDURE card2str (v,base,wi:CARDINAL;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr ( LONGCARD(v),R,base,ok);
    FOR i:=Str.Length(R)+1 TO wi DO Str.Prepend(R,padchar);END;
    RETURN R;
END card2str;

PROCEDURE dbgme (DEBUG:BOOLEAN;currline,stackndx:CARDINAL;token:ARRAY OF CHAR );
VAR
    S:str128;
BEGIN
    IF DEBUG THEN
        S:='::: line = ~ ::: stack index = ~ ::: token = "~"';
        Str.Subst(S,"~",card2str(currline,10,wicard,blank));
        Str.Subst(S,"~",card2str(stackndx,10,wicard,blank));
        Str.Subst(S,"~",token);
        WrStr(S);WrLn;
    END;
END dbgme;

PROCEDURE dbg (DEBUG:BOOLEAN;S1,S2:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrLn; (* DO not be mixed IN code *)
        WrStr("::: "+"// "); (* avoid being kept by newline *)
        WrStr(S1);
        FOR i:= Str.Length(S1)+1 TO widbg DO WrStr(" ");END;
        WrStr(S2);WrLn;
    END;
END dbg;

PROCEDURE dbgv (DEBUG:BOOLEAN;v:CARDINAL; S1:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrLn; (* DO NOT be mixed IN code *)
        WrStr("::: "+"// ");
        WrStr(S1);
        FOR i:= Str.Length(S1)+1 TO widbg DO WrStr(" ");END;
        WrStr( card2str(v,10,wicard,blank));WrLn;
    END;
END dbgv;

(* ------------------------------------------------------------ *)

PROCEDURE unquote (VAR S:ARRAY OF CHAR);
VAR
    len:CARDINAL;
BEGIN
    len:=Str.Length(S);
    IF len < (1+1) THEN RETURN;END; (* we need at least 2 chars *)
    IF S[0] = S[len-1] THEN
        S[len-1]:=charnull;
        Str.Delete(S,0,1);
    END;
END unquote;

VAR
    sinsertMEhere,stokenset,stokensetfull:str128;  (* more than enough *)
    skeywords:str1024;                             (* just in case *)

PROCEDURE initSpecial (DEBUG, useLFN:BOOLEAN ):BOOLEAN ;
CONST
    firststr = 1;
    laststr  = 4;
VAR
    ini:pathtype;
    p,n:CARDINAL;
    fromini,ok:BOOLEAN;
    hin:FIO.File;
    S:str1024;
BEGIN
    ok:=TRUE;
    ini:=ProgEXEname+extINI;
    fromini:= FIO.Exists(ini);
    IF NOT(fromini) THEN
        Lib.ParamStr(ini,0);
        p:=Str.RCharPos(ini,dot);
        IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
        Str.Append(ini,extINI);
        fromini:=FIO.Exists(ini);
    END;
    IF fromini THEN
        dbg(DEBUG,"ini",ini);
        hin:=FIO.OpenRead(ini);
        p:=firststr;
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hin,S);
            LtrimBlanks(S);
            RtrimBlanks(S);
            CASE S[0] OF
            | semicolon, pound, charnull: (* remark or empty *)
                ;
            ELSE
                dbg(DEBUG,"S",S);
                unquote(S); (* no trimming here *)
                CASE p OF
                | firststr: Str.Copy(sinsertMEhere,S);
                | 2:        Str.Copy(stokenset,S);
                | 3:        Str.Copy(stokensetfull,S);
                | laststr:  Str.Copy(skeywords,S);
		ELSE
		    ;
                END;
                INC(p);
                IF p > laststr THEN EXIT;END;
            END;
        END;
        FIO.Close(hin);
        ok:=( p > laststr );
    ELSE
        sinsertMEhere := defaultInsertMEhere;
        stokenset     := defaultTokenset;
        stokensetfull := defaultTokensetfull;
        skeywords     := defaultKeywords;
    END;

    ReplaceChar(skeywords, space,"");
    ReplaceChar(skeywords, tabul,"");

    LOOP
        p:=0;
        IF Str.Pos(sinsertMEhere,altcrlf1)=MAX(CARDINAL) THEN
            INC(p);
        ELSE
            Str.Subst(sinsertMEhere,altcrlf1,nl);
        END;
        IF Str.Pos(sinsertMEhere,altcrlf2)=MAX(CARDINAL) THEN
            INC(p);
        ELSE
            Str.Subst(sinsertMEhere,altcrlf2,nl);
        END;
        IF p = 2 THEN EXIT; END;
    END;



    p:=Str.Length(sinsertMEhere);
    IF p # 0 THEN
        CASE sinsertMEhere[p-1] OF
        | space,tabul:
            ; (* ok, user has thought OF it *)
        ELSE
            Str.Append(sinsertMEhere,space); (* force trailing space separator for following END *)
        END;
    END;
    RETURN ok;
END initSpecial;

PROCEDURE genINI (useLFN,overwrite:BOOLEAN;ini:pathtype  );
VAR
    hout:FIO.File;
    ok:BOOLEAN;
    S:str128;
BEGIN
    IF FIO.Exists(ini) THEN
        IF overwrite THEN
            ok:=TRUE; S:="::: Overwrite existing ~";
        ELSE
            ok:=FALSE;S:="::: Skip existing ~";
        END;
    ELSE
            ok:=TRUE; S:="::: Create ~";
    END;
    Str.Subst(S,tilde,dquote+tilde+dquote);
    Str.Subst(S,tilde,ini);
    WrLn; (* was not added at program start because of redirection *)
    WrStr(S);WrLn;
    IF ok THEN
        hout:=FIO.Create(ini);
        FIO.WrStr(hout,defaultINI);
        FIO.Close(hout);
    END;
END genINI;

(* ------------------------------------------------------------ *)

CONST
    minstack = 1;
    maxstack = 16384; (* why... but why not ? should do anyway *)
VAR
    pushedtoken : ARRAY[minstack..maxstack] OF SHORTCARD;
    pushedline  : ARRAY[minstack..maxstack] OF CARDINAL;  (* for later use *)

PROCEDURE procToken (VAR stackndx:CARDINAL; VAR doinsert : BOOLEAN;
                    DEBUG:BOOLEAN;currline:CARDINAL;token:ARRAY OF CHAR):BOOLEAN;
CONST
    isCASE  = 0;
    isELSE  = 1;
    isEND   = 2;
    isIF      = 3;
    isOTHER   = 4;
    isIGNORED = 5; (* not IN list of keywords *)
VAR
    id:CARDINAL;
BEGIN
    doinsert := FALSE;
    IF same(token,"CASE") THEN
        id:=isCASE;
    ELSIF same(token,"ELSE") THEN
        id:=isELSE;
    ELSIF same(token,"END") THEN
        id:=isEND;
    ELSIF same(token,"IF") THEN
        id:=isIF;
    ELSIF getStrIndex(comma,token,skeywords) # 0 THEN
        id:=isOTHER;
    ELSE
        id:=isIGNORED;
    END;
    IF id = isIGNORED THEN RETURN TRUE;END;

    INC(stackndx); IF stackndx > maxstack THEN RETURN FALSE;END;
    (*
    dbg(DEBUG,"token",token); dbgv(DEBUG,currline,"currline");
    dbgv(DEBUG,stackndx,"stack index");
    *)
    dbgme(DEBUG,currline,stackndx,token);

    pushedline[stackndx]:=currline;
    CASE id OF
    | isCASE:
        pushedtoken[stackndx]:=isCASE;
    | isELSE:
        pushedtoken[stackndx]:=isELSE;
    | isOTHER:
        pushedtoken[stackndx]:=isOTHER;
    | isIF:
        pushedtoken[stackndx]:=isIF;
    | isEND:
        pushedtoken[stackndx]:=isEND; (* useless but for the principle *)
        DEC(stackndx); IF stackndx < minstack THEN RETURN FALSE;END;
        CASE pushedtoken[stackndx] OF
        | isOTHER:IF stackndx > minstack THEN DEC(stackndx);END;
        | isIF:   IF stackndx > minstack THEN DEC(stackndx);END;
        | isELSE: IF stackndx > minstack THEN DEC(stackndx);END;
                  CASE pushedtoken[stackndx] OF
                  | isCASE,isIF,isOTHER:
                      IF stackndx > minstack THEN DEC(stackndx);END;
		  ELSE
		      ;
                  END;
        | isCASE: IF stackndx > minstack THEN DEC(stackndx);END;
                  doinsert := TRUE;
	ELSE
	    ;
        END;
    ELSE
        ;
    END;
    RETURN TRUE;
END procToken;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE backonechar ( hin:FIO.File );
VAR
    fpos:LONGCARD ;
BEGIN
    fpos:=FIO.GetPos(hin);
    IF fpos # 0 THEN FIO.Seek(hin,fpos-1);END;
END backonechar;

PROCEDURE grabnextchar ( VAR nextch:CHAR;hin:FIO.File  );
VAR
    got,wanted:CARDINAL;
BEGIN
    wanted:=SIZE(nextch);
    got:=FIO.RdBin(hin,nextch,wanted);
    IF got # wanted THEN nextch:=charnull;END;
END grabnextchar;

PROCEDURE procSrc (DEBUG,useLFN,tofile,dosbak:BOOLEAN;src:pathtype):BOOLEAN;
CONST
    (* extremely unlikely to already exists ! *)
    tmpf8 = "~TMP~ISO~";
    tmpe3 = ".TMP";
VAR
    hin,hout:FIO.File;
    state:(waiting,instring,intoken,inremark);
    token:str128;
    stackndx,remdepth,got,wanted,currline:CARDINAL;
    ch,stringdelim:CHAR;
    doinsert,ok:BOOLEAN;
    u,d,n,e,target,tmpcanonical:pathtype;
BEGIN
    qdSplitAllPath(src, u,d,n,e);
    IF dosbak THEN
    Lib.MakeAllPath(target,u,d,n,extBAK);
    ELSE
    Str.Concat(target,src,extBAK);
    END;
    Lib.MakeAllPath(tmpcanonical,u,d,tmpf8,tmpe3);

    IF tofile THEN
        hout:=FIO.Create(target);
        FIO.AssignBuffer(hout,ioBufferOut);
    ELSE
        hout:=FIO.StandardOutput;
    END;

    currline:=1;
    ok:=TRUE;
    stackndx := minstack-1;
    remdepth := 0;

    hin := FIO.OpenRead(src);
    FIO.AssignBuffer(hin,ioBufferIn);
    wanted:=SIZE(ch);
    state:=waiting;
    LOOP
        got:=FIO.RdBin(hin,ch,wanted);
        IF got # wanted THEN EXIT;END;
        IF ch = lf THEN INC(currline);END; (* handle both DOS and "others" *)
        CASE state OF
        | waiting:
            IF Belongs(stokenset,ch) THEN
                Str.Copy(token,ch);
                state:=intoken;
            ELSE
                FIO.WrChar(hout,ch);
                CASE ch OF
                | doublequote,singlequote:
                    stringdelim:=ch;
                    state:=instring;
                | "(":
                    grabnextchar(ch,hin);
                    IF ch="*" THEN
                        FIO.WrChar(hout,ch);
                        INC(remdepth);
                        state:=inremark;
                    ELSE
                        backonechar(hin);
                    END;
                | "*":
                    grabnextchar(ch,hin);
                    IF ch = ")" THEN
                        IF remdepth # 0 THEN DEC(remdepth);END;
                        IF remdepth = 0 THEN state := waiting; END;
                        FIO.WrChar(hout,ch);
                    ELSE
                        backonechar(hin);
                    END;
		ELSE
		    ;
                END;
            END;
        | intoken:
            IF Belongs(stokensetfull,ch) THEN
                Str.Append(token,ch);
            ELSE
                ok:= procToken(stackndx,doinsert,  DEBUG,currline,token);
                IF NOT(ok) THEN EXIT;END;
                IF doinsert THEN FIO.WrStr(hout,sinsertMEhere); END;
                FIO.WrStr(hout,token);
                state:=waiting;
                backonechar(hin);
            END;
        | instring:
            FIO.WrChar(hout,ch);
            IF ch = stringdelim THEN state:=waiting; END;
        | inremark:
                FIO.WrStr(hout,ch);
                CASE ch OF
                | "(":
                     grabnextchar(ch,hin);
                     IF ch = "*" THEN
                         FIO.WrChar(hout,ch);
                         INC(remdepth);
                     ELSE
                         backonechar(hin);
                     END;
                | "*":
                     grabnextchar(ch,hin);
                     IF ch = ")" THEN
                         FIO.WrChar(hout,ch);
                         IF remdepth # 0 THEN DEC(remdepth);END;
                         IF remdepth = 0 THEN state:=waiting;END;
                     ELSE
                         backonechar(hin);
                     END;
		ELSE
		    ;
                END;
	ELSE
	    ;
        END;
    END;
    CASE state OF
    | intoken:
        ok:=procToken(stackndx,doinsert,  DEBUG,currline,token);
        IF doinsert THEN FIO.WrStr(hout,sinsertMEhere); END;
        FIO.WrStr(hout,token);
    ELSE
        ;
    END;
    FIO.Close(hin);

    IF tofile THEN
        FIO.Close(hout);
        IF FIO.Exists(tmpcanonical) THEN
            fileSetRW(tmpcanonical);
            FIO.Erase(tmpcanonical);
        END;
	FIO.Rename(src,tmpcanonical);        (* .MOD becomes .tmp *)
        FIO.Rename(target,src);              (* .org becomes .MOD *)
        FIO.Rename(tmpcanonical,target);     (* .tmp becomes .org *)

        WrLn; (* was not added at program start *)
        WrStr("+++ Created  : ");WrStr(src);WrLn;
        WrStr("::: Original : ");WrStr(target);WrLn;

    END;

    RETURN ok;
END procSrc;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minparm = 1;
    maxparm = 1;
VAR
    parm : ARRAY[minparm..maxparm] OF pathtype;
    lastparm,parmcount,i,opt : CARDINAL;
    S,R,src:pathtype;
    dosbak,tofile,useLFN,DEBUG : BOOLEAN;
BEGIN
    FIO.IOcheck := FALSE;

    (* WrLn; *)

    tofile      := TRUE;
    dosbak      := FALSE;
    useLFN      := TRUE;  (* always on Win32 *)
    DEBUG       := FALSE;

    lastparm    := minparm-1;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "DEBUG"+delim+
                                   "!"+delim+"INI"+delim+
                                   "!!"+delim+"!O"+delim+
                                   "@"+delim+
                                   "D"+delim+"DOSBAK"+delim+
                                   "x"+delim+"lfn"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4     : DEBUG:=TRUE;
            | 5,6   : genINI(useLFN,FALSE,ProgEXEname+extINI);
                      abort(errNone,"");
            | 7,8   : genINI(useLFN,TRUE,ProgEXEname+extINI);
                      abort(errNone,"");
            | 9     : tofile := FALSE;
            | 10,11 : dosbak := TRUE;
            | 12,13 : ;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S); END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;

    IF NOT(dosbak) THEN dosbak:=NOT(useLFN); END;

    CASE lastparm OF
    | minparm-1 : abort(errParm,"<file>");
    | minparm:    Str.Copy(src,parm[minparm]);
    ELSE
        ; (* handled supra *)
    END;

    IF same(src,dot) THEN Str.Copy(src,star+extMOD); END;
    IF same(src,star) THEN Str.Copy(src,star+extMOD); END;
    IF Str.Match(src,"*"+antislash) THEN Str.Append(src,star+extMOD); END;
    IF Str.RCharPos(src,dot)=MAX(CARDINAL) THEN Str.Append(src,extMOD);END;

    IF chkJoker(src) THEN abort(errJoker,src);END;

    IF Str.Match(src,"*"+extBAK) THEN abort(errBackup,src);END;

    IF FIO.Exists(src)=FALSE THEN abort(errNotFound,src);END;

    IF initSpecial(DEBUG,useLFN)=FALSE THEN abort(errIniProblem,ProgEXEname+extINI);END;

    IF procSrc(DEBUG,useLFN,tofile,dosbak,src) = FALSE THEN abort(errStack,"");END;

    abort(errNone,"");
END ISOCASE32.
