(* ---------------------------------------------------------------
Title         see help
Author        PhG
Overview      see help (bis repetita...)
Usage         see help (ter repetita...)
Notes
              possible problem when patching wininit.exe strings :
              if patched strings are smaller than original at $6b2 and $760
              what happens if executable code reads strings sequentially ?
              bah... seems there's no problem
              -m option is a bad idea but sometimes useful, so...

              no eyecandy (would be too slow)

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          XDS sometimes decides to fix a LF alone in a string, changing it to CRLF
              seems XDS has a problem with redirection (as ADW does, by the way)
              those guys hate command line !
Wish List     check string looks ASCII (DOS or OEM) with a percentage ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 25 Nov 15 an ugly really Q&D port from PASPEEK for DOS
--------------------------------------------------------------- *)

MODULE PASpeek32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn,WrChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
CONST
    (* stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *) *)
    (* stderr        = FIO.ErrorOutput; *)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    gremlin     = 250C; (* //XDS CHR(168); (* reversed question mark *) *)
    sTAB        = "<TAB>";
    sCR         = "<CR>";
    sLF         = "<LF>";
CONST
    ProgEXEname   = "PASPEEK32";
    ProgTitle     = "Q&D Pascal strings finder (Win32)";
    ProgVersion   = "v0.9 (from v1.1d for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParmOverflow     = 3;
    errExpecting        = 4;
    errReading          = 5;
    errJoker            = 6;
    errNotFound         = 7;
    errStrToCard        = 8;
    errStart            = 9;
    errEnd              = 10;
    errRange            = 11;
    errAborted          = 12;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <file> [<[$]start> <[$]end|L[=][$]length|*>] [option]..."+nl+
nl+
"This program extracts PASCAL counted strings found in <first>..<end> range."+nl+
nl+
"-u    search for Unicode strings (default is to search for ASCII strings)"+nl+
"-v[v] show string address and character count (-vv = alternate format)"+nl+
"-q    show double-quoted strings (default is to show raw strings)"+nl+
"-m    more thorough search mode"+nl+
"-b    replace $07 code (bell) with a space"+nl+
'-f[f] fix control chars (except TAB, CR and LF) and CHR(255) (-ff = alt fmt)'+nl+
nl+
'a) <start> is 0-based ; <end> can be specified as "*" for "end of file".'+nl+
"b) If only <file> parameter is specified, [0..filesize-1] range is assumed."+nl+
'c) Hexadecimal values are prefixed with "$".'+nl+
"d) Note specifying <start> <end|length> search range is HIGHLY recommended."+nl+
"e) Length is [1..255] for an ASCII string, [1..65535] for a Unicode string."+nl+
'f) -f replaces [0..31,255] codes (except 9,13,10) with "'+gremlin+'" CHR(168) ;'+nl+
'   -ff prepends 9 ($09), 13 ($0d), 10 ($0a) with "'+sTAB+'", "'+sCR+'", "'+sLF+'"'+nl+
'   (note CR and LF codes are then dumped as CR+LF sequence for display).'+nl+
"g) If both -b and -f options are specified, -b is applied first."+nl+
"h) While working, program can be aborted by pressing the Escape key."+nl+
"i) -m option, however useful in certain cases, is NOT recommended :"+nl+
"   redirected output filesize can grow very large."+nl+
'j) Note XDS may sometimes "fix" CR, LF or CRLF if output is redirected :'+nl+
"   binary compare with DOS PASPEEK output may show harmless differences,"+nl+
"   while text compare matches."+nl+
"k) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" -v -ff wininit.exe 929 2061"+nl+
"           "+ProgEXEname+" newspeak.exe $989a $bf27"+nl+
"           "+ProgEXEname+" -u vtuner.exe $4a1c0 $4b4ff"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :        WrStr(helpmsg);
    | errOption :      S:='Unknown "~" option';
    | errParmOverflow: S:='"~" is one parameter too many';
    | errExpecting :   S:="Expecting ~ parameter";
    | errReading:      S:='Unexpected problem reading "~"';
    | errJoker :       S:='"~" cannot contain any joker';
    | errNotFound :    S:='"~" does not exist';
    | errStrToCard :   S:='Illegal "~" value';
    | errStart:        S:='"~" <start> value is beyond filesize';
    | errEnd:          S:='"~" <end> value is beyond filesize';
    | errRange:        S:="<end> value is before <start> value";
    | errAborted:      S:="Aborted by user";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        IF Str.CharPos(S,"~") # MAX(CARDINAL) THEN Str.Subst(S,"~",einfo); END;
        Str.Append(S," !");
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC; (* //XDS BYTE; *)
VAR
    ioBufferIn:ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE padded (wi:INTEGER;padchar:CHAR; S:ARRAY OF CHAR):str80;
VAR
    i:CARDINAL;
    R:str80;
BEGIN
    R:="";
    FOR i:=Str.Length(S)+1 TO CARDINAL ( ABS(wi) ) DO
        Str.Append(R,padchar);
    END;
    IF wi < 0 THEN
        Str.Prepend(R,S);
    ELSE
        Str.Append(R,S);
    END;
    RETURN R;
END padded;

PROCEDURE valToStr (v:LONGCARD;base:CARDINAL):str16;
VAR
    S:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(v,S,base,ok);
    IF base=16 THEN Str.Lows(S);END;
    RETURN S;
END valToStr;

PROCEDURE dbgval (DEBUG: BOOLEAN; v:LONGCARD;S:ARRAY OF CHAR);
CONST
    wi = 20;
VAR
    N:str16;
    R:str80;
BEGIN
    IF DEBUG THEN
        R := "// ~ : ~ ($~)";
        Str.Subst(R, "~", padded(-wi,blank,S) );
        N:= valToStr(v,10);
        Str.Subst(R, "~", padded(10,blank,N) );
        N:= valToStr(v,16);
        Str.Subst(R, "~", padded(8,"0",N) );
        WrStr(R);WrLn;
    END;
END dbgval;

(* ------------------------------------------------------------ *)

PROCEDURE verify (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verify;

CONST
    pbNone   = 0;
    pbBadHex = 1;
    pbBadDec = 2;
    pbBadCard= 3;

PROCEDURE StrToLong (VAR v : LONGCARD; S:ARRAY OF CHAR) : CARDINAL;
CONST
    digits    = "0123456789";
    hexdigits = "ABCDEF"+digits;
VAR
    ok : BOOLEAN;
    rc,base : CARDINAL;
BEGIN
    Str.Caps(S);
    IF S[0]=dollar THEN
        Str.Delete(S,0,1);
        IF verify(S,hexdigits)=FALSE THEN RETURN pbBadHex;END;
        base := 16;
    ELSIF ( (S[0]="0") AND (S[1]="X") ) THEN
        Str.Delete(S,0,2);
        IF verify(S,hexdigits)=FALSE THEN RETURN pbBadHex;END;
        base := 16;
    ELSE
        IF verify(S,digits)=FALSE THEN RETURN pbBadDec;END;
        base := 10;
    END;
    v:=Str.StrToCard(S,base,ok);
    IF ok THEN
        rc:=pbNone;
    ELSE
        rc:=pbBadCard;
    END;
    RETURN rc;
END StrToLong;

PROCEDURE buildheader (searchunicrap,altformat:BOOLEAN;p:LONGCARD;n:CARDINAL):str80;
VAR
    R:str80;
    N:str16;
BEGIN
    R:="::: ~ @ ~ ($~) & L = ~ ($~) :::";
    IF searchunicrap THEN
        IF altformat THEN
            N:="Unicode";
        ELSE
            N:="U";
        END;
    ELSE
        IF altformat THEN
            N:="ASCII";
        ELSE
            N:="A";
        END;
    END;
    Str.Subst(R,"~",N);
    N:= valToStr(p,10);
    Str.Subst(R, "~", padded(10,blank,N) );
    N:= valToStr(p,16);
    Str.Subst(R, "~", padded(8,"0",N) );

    N:= valToStr(LONGCARD(n),10);
    Str.Subst(R, "~", padded(10,blank,N) );
    N:= valToStr( LONGCARD(n),16 );
    Str.Subst(R, "~", padded(8,"0",N) );
    IF altformat THEN
        Str.Append(R,nl);
    ELSE
        Str.Append(R,blank);
    END;
    RETURN R;
END buildheader;

PROCEDURE fixCtrl (VAR c : CHAR; VAR R:str16;
                  filterbell,filterctrlcodes,showplain,rigorous:BOOLEAN) : BOOLEAN ;
CONST
    bellchar = CHR(7);
VAR
    v:CARDINAL;
    showtext:BOOLEAN;
BEGIN
    showtext:=FALSE;
    R:="";

    IF filterbell THEN
       IF c = bellchar THEN c := blank; END; (* should be gremlin ? *)
    END;

    IF filterctrlcodes THEN
        v:=ORD(c);
        CASE v OF
        | ORD(space)..(255-1):
           ;
        | 255:
           v:=ORD(gremlin);
        ELSE
           IF rigorous THEN
               v:=ORD(gremlin); (* all [0..31] codes become a gremlin *)
           ELSE
               showtext:=showplain;
               CASE v OF
               | ORD(tabul): R:=sTAB+tabul;
               | ORD(cr)   : R:=sCR+nl; (* prettier display *)
               | ORD(lf)   : R:=sLF+nl; (* prettier display *)
               ELSE
                  v:=ORD(gremlin);
                  showtext:=FALSE;
               END;
           END;
        END;
    END;
    RETURN showtext;
END fixCtrl;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    pbReading = 101;
    pbEscape  = 102;

PROCEDURE  procPeek (VAR rc: CARDINAL;  searchunicrap,showinfos,
                    altformat,quoted,aggressive,
                    filterbell,filterctrlcodes,showplain,
                    DEBUG:BOOLEAN;
                    firstpos,lastpos:LONGCARD;
                    source:pathtype);
CONST
    rigorous    = FALSE; (* TRUE = all [0..31] codes become a gremlin *)
    CHKEVERY    = 1024; (* let's call chkEscape every CHKEVERY loop, 256 is NOT enough *)
TYPE
    chtype = RECORD
        ch1:CHAR;
        ch2:CHAR;
    END;
VAR
    hin:FIO.File;
    currpos,here,anchor:LONGCARD;
    status : (waiting,dumping);

    (* //XDS TS mode QUIRK : if we don't use m2base16 directive, size is 4 instead of 2 *)
    (* wlen:CARDINAL; *)
    wlen:SYSTEM.CARD16;  (* //XDS make sure variable has the right size now !!! *)
    blen:SHORTCARD;
    chkrounds,wanted,got,count:CARDINAL;
    S:str80;
    ch:chtype;
    carac:CHAR;
    strPlain:str16;
    dumpstr:BOOLEAN;
BEGIN
    chkrounds:=0;
    rc:=pbNone;
    hin:=FIO.OpenRead(source);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.Seek(hin,firstpos);
    currpos:=firstpos;
    status:=waiting;
    LOOP
        CASE status OF
        | waiting:
            IF searchunicrap THEN
                wanted:=SIZE(wlen);
                got:=FIO.RdBin(hin,wlen,wanted);
                IF got # wanted THEN rc:=pbReading; EXIT;END;
                count:=wlen;
            ELSE
                wanted:=SIZE(blen);
                got:=FIO.RdBin(hin,blen,wanted);
                IF got # wanted THEN rc:=pbReading; EXIT;END;
                count:=CARDINAL(blen);
            END;
            here:=currpos;
            INC(currpos,LONGCARD(got)); (* yes, FIO.Pos() would do too *)
            IF currpos > lastpos THEN EXIT; END;
            IF count # 0 THEN (* avoid 0-length *)
                IF showinfos THEN
                    S:=buildheader(searchunicrap,altformat,here,count);
                    WrStr(S);
                    IF quoted THEN WrStr(dquote);END;
                ELSE
                    IF quoted THEN WrStr(dquote);END;
                END;
                anchor:=currpos;
                dbgval(DEBUG,anchor,"store anchor");
                status := dumping;
            END;
        | dumping:
            got:=FIO.RdBin(hin,ch,wanted);
            IF got # wanted THEN rc:=pbReading; EXIT; END;
            IF searchunicrap THEN
                carac:=ch.ch1;
            ELSE
                carac:=ch.ch1;
            END;
            dumpstr := fixCtrl (carac,strPlain,
                               filterbell,filterctrlcodes,showplain,rigorous);
            IF dumpstr THEN
                WrStr(strPlain); (* include fixed carac *)
            ELSE
                WrStr(carac);
            END;
            DEC(count);
            IF count = 0 THEN
                IF quoted THEN WrStr(dquote);END;
                WrLn;
                IF (chkrounds MOD CHKEVERY) = 0 THEN
                    IF ChkEscape() THEN rc:=pbEscape;EXIT; END; (* //V11B ChkEscape was missing ! *)
                END;
                IF aggressive THEN (* rewind *)
                    dbgval(DEBUG,anchor,"rewind to anchor");
                    FIO.Seek(hin,anchor);
                    currpos := anchor;
                    wanted:=0; (* fix later INC() ! *)
                END;
                status:=waiting;
            END;
            INC(currpos,LONGCARD(wanted));
            IF currpos > lastpos THEN EXIT; END;
        ELSE
            ; (* //XDS YET ANOTHER SILLY ISO REQUIREMENT ! *)
        END;
        INC(chkrounds);
    END;
    FIO.Close(hin);
END procPeek;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minparm = 1;
    maxparm = 3;
VAR
    lastparm : CARDINAL;
    parm : ARRAY[minparm..maxparm] OF pathtype;
    searchascii,searchunicrap,showinfos:BOOLEAN;
    altformat,quoted,aggressive,filterctrlcodes,filterbell,showplain:BOOLEAN;
    DEBUG:BOOLEAN;
    source:pathtype;
    fsize,firstpos,lastpos,count:LONGCARD;
VAR
    parmcount,i,opt:CARDINAL;
    S,R:pathtype;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    searchunicrap      := FALSE;
    showinfos          := FALSE;
    altformat          := TRUE;
    quoted             := FALSE;
    aggressive         := FALSE;
    filterctrlcodes    := FALSE;
    filterbell         := FALSE;
    showplain          := FALSE;

    lastparm := minparm-1;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);  cleanCLI(R); ReplaceChar(R,dquote,""); (* YATB ! *)
        IF isOption(R)=TRUE THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "U"+delim+"UNICODE"+delim+
                                  "V"+delim+
                                  "VV"+delim+
                                  "Q"+delim+"QUOTED"+delim+
                                  "x"+delim+"lfn"+delim+
                                  "M"+delim+"SEARCHMODE"+delim+
                                  "F"+delim+"FILTER"+delim+
                                  "B"+delim+"BELL"+delim+
                                  "FF"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            |  1,  2,  3 : abort(errHelp,"");
            |  4,  5     : searchunicrap:= TRUE;
            |  6         : showinfos    := TRUE;
            |  7         : showinfos    := TRUE; altformat := FALSE;
            |  8,  9     : quoted       := TRUE;
            | 10, 11     : ; (* //XDS remed out *)
            | 12, 13     : aggressive   := TRUE;
            | 14, 15     : filterctrlcodes:= TRUE;
            | 16, 17     : filterbell   := TRUE;
            | 18         : filterctrlcodes:= TRUE;
                           showplain    := TRUE;
            | 19         : DEBUG        := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,S);END;
            parm[lastparm]:=S;
        END;
    END;
    CASE lastparm OF
    | minparm-1: abort(errExpecting,"<file>");
    (* | minparm:   abort(errExpecting,"<[$]start"); *)
    | minparm+1: abort(errExpecting,"<[$]end|L[=][$]lengh>");
    ELSE
        ; (* //XDS YASIR ! *)
    END;

    source := parm[minparm];
    IF chkJoker(source) THEN abort(errJoker,source); END;
    IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source); END;
    fsize := getFileSize(source);

    IF fsize = 0 THEN abort(errNone,"");END;

    CASE lastparm OF
    | minparm:
        firstpos := 0;
        lastpos  := fsize-1;
        dbgval(DEBUG,firstpos,"firstpos");
        dbgval(DEBUG,lastpos,"lastpos");
    ELSE
        S:=parm[minparm+1];
        IF StrToLong (firstpos,S) # pbNone THEN abort(errStrToCard,S);END;
        dbgval(DEBUG,firstpos,"firstpos");

        S:=parm[minparm+2];
        CASE CAP( S[0] ) OF
        | star:
            lastpos := fsize-1;
        | "L" :
            Str.Delete(S,0,1);
            CASE S[0] OF
            | equal, colon :
                Str.Delete(S,0,1);
            ELSE
                ; (* //XDS YASIR ! *)
            END;
            IF same(S,star) THEN
                lastpos:=fsize-1;
            ELSE
                IF StrToLong(count,S) # pbNone THEN abort(errStrToCard,S);END;
                lastpos:=firstpos+count-1;
            END;
        ELSE
            IF StrToLong(lastpos,S) # pbNone THEN abort(errStrToCard,S);END;
        END;
        dbgval(DEBUG,lastpos,"lastpos");
    END;

    (* check range against 0..fsize-1 *)

    IF lastpos < firstpos THEN abort(errRange,"");END;

    S:="~ ($~)";
    Str.Subst(S,"~",valToStr(firstpos,10));
    Str.Subst(S,"~",valToStr(firstpos,16));
    IF firstpos > fsize THEN abort(errStart,S);END;
    S:="~ ($~)";
    Str.Subst(S,"~",valToStr(lastpos,10));
    Str.Subst(S,"~",valToStr(lastpos,16));
    IF lastpos  > fsize THEN abort(errEnd,S);END;

    procPeek (i,searchunicrap,showinfos,
                altformat,quoted,aggressive,
                filterbell,filterctrlcodes,showplain,DEBUG,
                firstpos,lastpos,
                source);
    CASE i OF
    | pbReading:abort(errReading,source);
    | pbEscape :abort(errAborted,"");
    ELSE
        ; (* //XDS YASIR ! *)
    END;

    abort(errNone,"");
END PASpeek32.





(*

del dos.?
del win.?

set _p_=c:\z\paspeek.exe
set _t_=dos

%_p_% -u vtuner.exe $4a1c0 $4b4ff    > %_t_%.1
%_p_% newspeak.exe $989a $bf27       > %_t_%.2
%_p_% -v -ff wininit.exe 929 2061    > %_t_%.3
%_p_% -u vtuner.exe $4a1c0 $4b4ff -q > %_t_%.4
%_p_% newspeak.exe $989a $bf27    -q > %_t_%.5
%_p_% -v -ff wininit.exe 929 2061 -q > %_t_%.6
%_p_% -u vtuner.exe $4a1c0 $4b4ff -b > %_t_%.7
%_p_% newspeak.exe $989a $bf27    -b > %_t_%.8
%_p_% -v -ff wininit.exe 929 2061 -b > %_t_%.9
%_p_% -u vtuner.exe $4a1c0 $4b4ff -f > %_t_%.A
%_p_% newspeak.exe $989a $bf27    -f > %_t_%.B
%_p_% -v -ff wininit.exe 929 2061 -f > %_t_%.C


set _p_=c:\z\paspeek32.exe
set _t_=win

%_p_% -u vtuner.exe $4a1c0 $4b4ff    > %_t_%.1
%_p_% newspeak.exe $989a $bf27       > %_t_%.2
%_p_% -v -ff wininit.exe 929 2061    > %_t_%.3
%_p_% -u vtuner.exe $4a1c0 $4b4ff -q > %_t_%.4
%_p_% newspeak.exe $989a $bf27    -q > %_t_%.5
%_p_% -v -ff wininit.exe 929 2061 -q > %_t_%.6
%_p_% -u vtuner.exe $4a1c0 $4b4ff -b > %_t_%.7
%_p_% newspeak.exe $989a $bf27    -b > %_t_%.8
%_p_% -v -ff wininit.exe 929 2061 -b > %_t_%.9
%_p_% -u vtuner.exe $4a1c0 $4b4ff -f > %_t_%.A
%_p_% newspeak.exe $989a $bf27    -f > %_t_%.B
%_p_% -v -ff wininit.exe 929 2061 -f > %_t_%.C


fcomp dos.* win.*
pause
fcomp32 /t dos.* win.*

set _t_=
set _p_=


*)