(* ---------------------------------------------------------------
Title         Q&D Show Pictures Dimensions
Overview      Yet Another Completely Useless Program
Usage         see help
Notes         model cannot be small
Bugs          yes, we know JPG data should not be hardcoded
              YATB : checking in a set does not work ! seen in chkTGA()
              jpeg APP14 adobe marker may/will require special handling
              seems a few JPG, while viewable, are not standard
              seems Adobe header is not standard (missing JFIF, etc.)

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn


	      removed support for BMP and TGA : oddly, it does not work here !
	      anyway, in a world of PNGs, GIFs and JPGs... this is weird, still...


              8-ung ! in order not to bother fixing structures everywhere
	      (SYSTEM.CARD16 and the like), we just set "m2base16 on" mention in project
	      so everything is 16 bits... but then, another problem : crashes !
	      in fact, seems too many XDS functions require CARDINAL32
	      therefore we have to fix CARD16 everywhere ! great job, guys !


              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Wish List     clever external pattern database ?
              filter according to user-specified dimensions ?
              more formats (compressed JPEGs) ?
              more infos about pictures ? bah, we just need dimensions
              check //FIXME for len >= 16

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  5 Apr 22 v0.9a fixed *.* parsing bug thanks to PICDIMS v1.0y for DOS
              still not determined to have DOS and Vindoze versions match
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 17 Mar 16 an ugly really Q&D port from PICDIMS v1.3j for DOS
--------------------------------------------------------------- *)

MODULE picDimS32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tabul);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ctrlZ       = CHR(26); (* $1a *)
    specSWP     = "*.SWP";
    specPAR     = "*.PAR";
    specPAGEFILE= "*\PAGEFILE.SYS"; (* was "?:\PAGEFILE.SYS" *)
    specLST     = "*.LST";
    specRPT     = "*.RPT";
    specBAT     = "*.BAT";
    TOOMANY     = MAX(CARDINAL);
    validPicExtensions  =".GIF,.PNG,.JPG,.PCX,.DDS,.JPEG"; (* .???[,.???] *)
    supportedFormats    = "GIF, PNG, JPG, PCX and DDS";
    partialsupport      = "JPG, PCX and DDS";
CONST
    progEXEname   = "PICDIMS32";
    progTitle     = "Q&D Show Pictures Dimensions (Win32)";
    progVersion   = "v0.9a (from v1.0r for DOS)";

    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone            = 0;
    errHelp            = 1;
    errUnknownOption   = 2;
    errTooManyParms    = 3;
    errMissingSpec     = 4;
    errNotFound        = 5;
    errNotFile         = 6;
    errJokerPath       = 7;
    errAborted         = 8;
    errNoMatch         = 9;
    errTooMany         = 10;
    errFmt             = 11;
    errScreen          = 12;
    errInverseDimensions=13;
    errNonsense        = 14;
    errValue           = 15;
    errDefaultOrUser   = 16;
    errBadExtRequired  = 17;
    errFsize           = 18;
    errInverseFsize    = 19;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <pathspec> [option]..."+nl+
nl+
"This program shows "+supportedFormats+" pictures dimensions."+nl+
nl+
'  -f[f] pad "#### x ####" Width x Height dimensions using "0" instead of " "'+nl+
"        (-ff = no padding)"+nl+
"  -l    list all files, whether recognized or not"+nl+
"  -ll   list only unrecognized files"+nl+
"  -lll  list only files with extension not matching internal recognized format"+nl+
"  -t    terse listing (-tl = -lt = -l -t)"+nl+
"  -b    batch-ready listing (-lllb = -blll = -lll -b)"+nl+
"  -#    list file only if one dimension is greater than specified screen size"+nl+
"        (320x[2]00  640x[4]80  800x[6]00  1024x[7]68  1280x[9]60  1600x[1]200)"+nl+
"  -s:#  list file only if filesize is greater than #"+nl+
"  -w:#  list file only if width is greater than # (-x:# = -w:#)"+nl+
"  -h:#  list file only if height is greater than # (-y:# = -h:#)"+nl+
"  -x?y  list file according to width compared to height"+nl+
"        (g = greater than, e = equal to, s = smaller than)"+nl+
"  -i[i] invert results for filter (-i = dimensions, -ii = filesize)"+nl+
"  -s    show filesize"+nl+
"  -z    ignore extensions not matching "+validPicExtensions+nl+
"  -c[z] show DIV 8 + delta values (-cz = show only if both deltas equal 0)"+nl+
"  -k[z] show DIV 4 + delta values (-kz = show only if both deltas equal 0)"+nl+
nl+
"a) For obvious reasons, program will not try and analyze files matching"+nl+
"   "+specSWP+", "+specPAR+" and "+specPAGEFILE+" specifications."+nl+
"   Files matching "+specLST+", "+specRPT+" and "+specBAT+" will be skipped too."+nl+
"b) Dimensions formatting assumes both width and height are within [0..9999]."+nl+
"c) -b option requires -lll option and forces -t option."+nl+
"   Output should be redirected to a file with one of skipped extensions."+nl+
"d) -s:# supports multiples of 1024 (Kb and Mb) and multiples of 1000 (K and M)."+nl+
"e) "+partialsupport+" support is limited : however unlikely,"+nl+
"   unexpected results may happen (especially with Adobe-generated files)."+nl+
"f) Unfortunately, support for BMP and TGA had to be removed :"+nl+
"   should it be needed, please use PICDIMS for DOS utility."+nl+
"g) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;


VAR
    S  : str1024; (* we may get a LFN *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errUnknownOption:
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errTooManyParms:
        Str.Concat(S,einfo," is one parameter too many !");
    | errMissingSpec:
        S := "Missing <filespec> !";
    | errNotFound:
        Str.Concat(S,einfo," does not exist !");
    | errNotFile:
        Str.Concat(S,einfo," looks like a directory !");
    | errJokerPath:
        S := "Jokers are not allowed in path !";
    | errAborted:
        S := "Aborted by user !";
    | errNoMatch:
        S := "No file matches <filespec>";
    | errTooMany:
        S := "Storage.ALLOCATE() failure !"; (* or 65535 matches ! *)
        S := "Too many files !";
    | errFmt:
        S :="-f and -ff options are mutually exclusive !";
    | errScreen:
        S := "Screen dimensions defined more than once !";
    | errInverseDimensions:
        S := "-i option requires any of -#, -w:#, -x?y or -h:# options !";
    | errNonsense:
        Str.Concat(S,einfo," options are mutually exclusive !");
    | errValue:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," value !");
    | errDefaultOrUser:
        S := "-# option cannot be specified with any of -w:# or -h:# options !";
    | errBadExtRequired:
        S := "-b option is a nonsense without -lll option !";
    | errFsize:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," filesize !");
    | errInverseFsize:
        S := "-ii option requires -s:# option !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ;
    ELSE
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

PROCEDURE wrq (tf:BOOLEAN;S:ARRAY OF CHAR   );
BEGIN
    IF tf THEN WrStr(doublequote);END;
    WrStr(S);
    IF tf THEN WrStr(doublequote);END;
END wrq;

PROCEDURE fmtbignum (v:LONGCARD; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr( v, S, base,ok);
    FOR i:=Str.Length(S)+1 TO CARDINAL ( ABS(wi) ) DO
         IF wi < 0 THEN
             Str.Append(S,pad);
         ELSE
             Str.Prepend(S,pad);
         END;
    END;
    IF base=16 THEN Str.Lows(S);END;
    RETURN S;
END fmtbignum;

PROCEDURE fmtnum (v:CARDINAL; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
BEGIN
    RETURN fmtbignum (LONGCARD(v), base,wi,pad);
END fmtnum;

PROCEDURE dwflip (v:LONGCARD):LONGCARD;
TYPE
    doubleword = RECORD (* boy, this is ugly... but effective ! *)
        CASE : BOOLEAN OF
        | TRUE:  n:LONGCARD;
        | FALSE: a,b,c,d:SHORTCARD;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
VAR
    intel,motorola:doubleword;
BEGIN
    motorola.n:=v;
    intel.a := motorola.d;
    intel.b := motorola.c;
    intel.c := motorola.b;
    intel.d := motorola.a;
    RETURN intel.n;
END dwflip;

PROCEDURE wflip (v:CARDINAL):CARDINAL;
TYPE
    singleword = RECORD (* boy, this is ugly... but effective ! *)
        CASE : BOOLEAN OF
        | TRUE:  n:SYSTEM.CARD16;
        | FALSE: a,b:SHORTCARD;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
VAR
    intel,motorola:singleword;
BEGIN
    motorola.n:=v;
    intel.a := motorola.b;
    intel.b := motorola.a;
    RETURN intel.n;
END wflip;

PROCEDURE readByte (hin:FIO.File):SYSTEM.LOC;
VAR
    b:SYSTEM.LOC;
    got:CARDINAL;
BEGIN
    got:=FIO.RdBin(hin,b,SIZE(b));
    IF got # SIZE(b) THEN b:=0;END; (* ignore errors *)
    RETURN b;
END readByte;

PROCEDURE readWord (hin:FIO.File):CARDINAL;
VAR
    w:SYSTEM.CARD16;
    got:CARDINAL;
BEGIN
    got:=FIO.RdBin(hin,w,SIZE(w));
    IF got # SIZE(w) THEN w:=0;END; (* ignore errors *)
    RETURN w;
END readWord;

PROCEDURE readDword (hin:FIO.File):LONGCARD;
VAR
    d:SYSTEM.CARD32;
    got:CARDINAL;
BEGIN
    got:=FIO.RdBin(hin,d,SIZE(d));
    IF got # SIZE(d) THEN d:=0;END; (* ignore errors *)
    RETURN d;
END readDword;

(* ------------------------------------------------------------ *)

PROCEDURE chkJokerPath (spec:pathtype  ):BOOLEAN;
VAR
    S,u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(S,u,d,"","");
    RETURN chkJoker(S);
END chkJokerPath;

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S:ARRAY OF CHAR):BOOLEAN;
BEGIN
    IF Str.Match(S,specBAT) THEN RETURN TRUE; END;
    IF Str.Match(S,specLST) THEN RETURN TRUE; END;
    IF Str.Match(S,specRPT) THEN RETURN TRUE; END;
    IF Str.Match(S,specSWP) THEN RETURN TRUE; END;
    IF Str.Match(S,specPAR) THEN RETURN TRUE; END;
    RETURN Str.Match(S,specPAGEFILE);
END isReservedPattern;

PROCEDURE isReservedEntry (S : ARRAY OF CHAR) : BOOLEAN; (* assume uppercase *)
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    IF same(S,dotdot) THEN RETURN TRUE; END;
    RETURN isReservedPattern(S);
END isReservedEntry;

PROCEDURE isValidPicExt (S:ARRAY OF CHAR ):BOOLEAN;
VAR
    ext,spec:str16;
    i:CARDINAL;
BEGIN
    i:=0;
    LOOP
        isoleItemS(ext,validPicExtensions,coma,i);
        IF same(ext,"") THEN EXIT; END;
        Str.Concat(spec,star,ext);
        IF Str.Match(S,spec) THEN RETURN TRUE; END;
        INC(i);
    END;
    RETURN FALSE;
END isValidPicExt;

(* ------------------------------------------------------------ *)

CONST
    firstEntry = 1; (* 1..count *)
TYPE
    ptrToEntry = POINTER TO entryType;
    entryType = RECORD
        next   : ptrToEntry;
        slen   : CARDINAL; (* a SHORTCARD would do fine in almost all cases  *)
        string : CHAR;      (* here, after other data, because variable length *)
    END;

PROCEDURE store (VAR newInList,anchor:ptrToEntry; VAR lastEntry:CARDINAL;
                S:pathtype):BOOLEAN ;
VAR
    len,needed:CARDINAL;
    rc:BOOLEAN;
BEGIN
    INC(lastEntry);
    IF lastEntry=TOOMANY THEN RETURN FALSE;END; (* too many files but fake storage ALLOCATE failure here *)

    len:=Str.Length(S);
    needed:=SIZE(entryType)-SIZE(CHAR)+len;
    rc:= TRUE; (* //XDS Available(needed); *)
    IF rc THEN
        CASE lastEntry OF
        | firstEntry :
            ALLOCATE( anchor,needed);
            newInList := anchor;
        ELSE
            ALLOCATE(newInList^.next,needed);
            newInList :=newInList^.next;
        END;
        Lib.Move( SYSTEM.ADR(S),SYSTEM.ADR(newInList^.string),len);
        newInList^.slen := len;
        newInList^.next := NIL;
    END;
    RETURN rc;
END store;

PROCEDURE buildMatchList (VAR anchor:ptrToEntry;
                          onlypicext:BOOLEAN;spec:pathtype):CARDINAL;
VAR
    S,u,d,n,e,dirbase,filespec:pathtype; (* some are oversized but safety first ! *)
    newInList : ptrToEntry;
    lastEntry: CARDINAL;
    errcode:CARDINAL;
    DOSentry     : FIO.DirEntry;
    rc,found,skipme:BOOLEAN;
    dosattr:FIO.FileAttr;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(dirbase,u,d,"","");
    fixDirectory(dirbase);
    Lib.MakeAllPath(filespec,"","",n,e);

    lastEntry:=firstEntry-1;
    anchor:=NIL;

    found := FIO.ReadFirstEntry(spec,everything,DOSentry);
    WHILE found DO
        Str.Copy(S,DOSentry.name);
        skipme:=isReservedEntry(S); (* skip "." ".." "*.SWP" "*.PAR" *)
        IF NOT(skipme) THEN
            IF onlypicext THEN skipme:=NOT( isValidPicExt(S) ); END;
        END;
        IF NOT(skipme) THEN
            dosattr:=DOSentry.attr;
            IF NOT (aDD IN dosattr) THEN
                Str.Prepend(S,dirbase);
                IF store(newInList,anchor,lastEntry,S)=FALSE THEN
                    RETURN TOOMANY; (* storage ALLOCATE failure or too many files *)
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(DOSentry);
    END;
    RETURN lastEntry;
END buildMatchList;

PROCEDURE freeMatchList (anchor:ptrToEntry);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrToEntry;
BEGIN
    firstInList := anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
        len         := CARDINAL(newInList^.slen);
        needed      := SIZE(entryType)-SIZE(CHAR)+len;
        firstInList := firstInList^.next;
        DEALLOCATE (newInList,needed);
        newInList := firstInList;
    END
END freeMatchList;

PROCEDURE getMatchEntry (VAR R:pathtype;
                         n:CARDINAL; anchor:ptrToEntry);
VAR
    i,len:CARDINAL;
    newInList:ptrToEntry;
    S:pathtype;
BEGIN
    newInList := anchor;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:=firstEntry TO n DO
         newInList := newInList^.next;
    END;
    len         := newInList^.slen;
    Lib.Move( SYSTEM.ADR(newInList^.string),SYSTEM.ADR(S),len);
    S[len]      := nullchar; (* REQUIRED safety ! *)
    Str.Copy(R,S); (* yep, compiler won't let us fill R directly *)
END getMatchEntry;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    firstioBufferByte = 1;
    lastioBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstioBufferByte..lastioBufferByte] OF SYSTEM.LOC;
VAR
    ioBufferIn : ioBufferType;

(* ------------------------------------------------------------ *)

CONST
    idUNKNOWN = 0;
    idJPG     = 1;
    idGIF     = 2;
    idPNG     = 3;
    idPCX     = 4;
    idBMP     = 5;
    idDDS     = 6;
    idTGA     = 7;

(*
TYPE
    JPGfalseHeaderType = RECORD
        mark : CARDINAL;            (* 2 $ff $?? *)
        mlen : CARDINAL;            (* 2 motorola, including mlen itself, >= $10 *)
        id:   ARRAY [0..3] OF CHAR; (* 4 "JFIF" or "Exif" *)
    END;
*)

TYPE
    GIFheaderType = RECORD
        sig:      ARRAY[0..5] OF CHAR;   (* 6 *)
        wi:       SYSTEM.CARD16;              (* 2 *)
        he:       SYSTEM.CARD16;              (* 2 *)
    END;

TYPE
    PNGheaderType = RECORD
        sig1:     ARRAY[0..6] OF CHAR;   (* 7 *)
        filler:   ARRAY[0..4] OF SYSTEM.LOC;   (* 5 *)
        sig2:     ARRAY[0..3] OF CHAR;   (* 4 *)
        wi:       LONGCARD;              (* 4 motorola *)
        he:       LONGCARD;              (* 4 motorola *)
    END;

TYPE
    PCXrgbType = RECORD
        red,green,blue:SYSTEM.LOC;
    END;
    (* (almost) useless fields are indented again *)

    PCXheaderType = RECORD
     manufacturer    : SYSTEM.LOC; (* constant 10=$0A=ZSoft *)
     version         : SYSTEM.LOC; (* constant 5=PC Paintbrush v3.0+ *)
     encoding        : SYSTEM.LOC; (* constant 1=RLE *)
    bitsPerPixel     : SYSTEM.LOC; (* 1, 2, 4 or 8, i.e. mono, 4, 16 OR 256 colors  *)
	                  (* window, i.e. image dimensions : xmin, ymin, xmax, ymax *)
    leftmargin       : SYSTEM.CARD16;
    uppermargin      : SYSTEM.CARD16;
    rightmargin      : SYSTEM.CARD16; (* do not use xmax-xmin ! *)
    lowermargin      : SYSTEM.CARD16;
     hDPIresolution  : SYSTEM.CARD16; (* put 300 for instance *)
     vDPIresolution  : SYSTEM.CARD16; (* idem *)
    colormap         : ARRAY[0..15] OF PCXrgbType;
     reserved1       : SYSTEM.LOC; (* must be 0 *)
    NCP              : SYSTEM.LOC; (* number of color planes, 1 or 4 *)
    NBS              : SYSTEM.CARD16; (* number of bytes per scanline, always even *)
                            (* from here, fields may contain rubbish *)
     paletteInfo     : SYSTEM.CARD16; (* 1=color or BW, 2=grayscale *)
     hscreensize     : SYSTEM.CARD16;
     vscreensize     : SYSTEM.CARD16;
     reserved2       : ARRAY[0..53] OF SYSTEM.LOC; (* must be 0 *)
    END;

TYPE
    BMPFileHeader = RECORD
	bfType	     : ARRAY[0..1] OF CHAR; (* "BM" string *)
        bfSize 	     : LONGCARD;            (* file size in bytes *)
        bfReserved1  : SYSTEM.CARD16;            (* must be set to 0 *)
        bfReserved2  : SYSTEM.CARD16;            (* idem *)
        bfOffBits    : LONGCARD;            (* offset from this structure to the actual bitmap data in file *)
    END;
    BMPInfoHeader = RECORD
        biSize 	      : LONGCARD; (* size of this structure *)
        biWidth       : SYSTEM.INT32;  (* # of pixels *)
        biHeight      : SYSTEM.INT32;  (* # of pixels *)
        biPlanes      : SYSTEM.CARD16; (* must be 1   *)
        biBitCount    : SYSTEM.CARD16; (* bits per pixel (1=mono, 4=16 colors) *)
        biCompression : LONGCARD; (* 0=not compressed, 1=RLE8, 2=RLE4 *)
        (* from here, 0=default *)
        biSizeImage 	: LONGCARD; (* # of bytes in image (can be 0 if no compression) *)
        biXpelsPerMeter : SYSTEM.INT32;  (* could be 0 *)
        biYpelsPerMeter : SYSTEM.INT32;
        biClrUsed 	: LONGCARD; (* set to 0 to force use of all pallette *)
        biClrImportant 	: LONGCARD; (* 0=all colors are important *)
    END;
    BMPtotalHeaderType = RECORD (* assume following subheaders *)
       FILE:BMPFileHeader;
       INFO:BMPInfoHeader;
    END;

    TGAheaderType = RECORD
        info        : SYSTEM.LOC;
        colortyp    : SYSTEM.LOC;         (* 0,1 *)
        imagetyp    : SYSTEM.LOC;         (* 1,2,9,10 *)
        origin      : SYSTEM.CARD16;
        colnumber   : SYSTEM.CARD16;
        entrybits   : SYSTEM.LOC;         (* 16,24,32 *)
        xvalue      : SYSTEM.CARD16;  (* lower left *)
        yvalue      : SYSTEM.CARD16;  (* lower left *)
        width       : SYSTEM.CARD16;
        height      : SYSTEM.CARD16;
        pixelsize   : SYSTEM.LOC;         (* 8,16 or 16,24,32 *)
        descriptor  : SYSTEM.LOC;
    END;

    TYPE DDSheaderType = RECORD
        sig      : ARRAY[0..3] OF CHAR; (* "DDS " i.e. $44445320 *)
        (* now just enough of DDSURFACEDESC2 fields as to retrieve picdims *)
        dwSize   : LONGCARD; (* size of structure : always $7c (124) *)
        dwFlags  : LONGCARD;
        dwHeight : LONGCARD;
        dwWidth  : LONGCARD;
        (* we don't care of the rest *)
    END;

(* ------------------------------------------------------------ *)

CONST
    databufferlen = SIZE(PCXheaderType); (* longest header for now *)
VAR
    databuffer : ARRAY[0..databufferlen-1] OF SYSTEM.LOC;

(* see jpeglib.h *)

CONST
    markJPEG  = 0FFH;
    markSOI   = 0D8H;
    markEOI   = 0D9H;
    markDQT   = 0DBH; (* adobe ? *)
    markSOF0  = 0C0H;
    markSOF1  = 0C1H;
    markSOF2  = 0C2H;
    markSOF3  = 0C3H;
    markCOM   = 0FEH;
    markAPP0  = 0E0H;
    markAPP1  = 0E1H;
    markAPP2  = 0E2H;
    markAPP13 = 0EDH; (* adobe ? *)

PROCEDURE friendlymarker ( b:SYSTEM.LOC  ):str16;
VAR
    R:str16;
BEGIN
    CASE CARDINAL(b) OF
    | markEOI    :R:="EOI";
    | markDQT    :R:="DQT";
    | markSOF0   :R:="SOF0";
    | markSOF1   :R:="SOF1";
    | markSOF2   :R:="SOF2";
    | markSOF3   :R:="SOF3";
    | markCOM    :R:="COM";
    | markAPP0   :R:="APP0";
    | markAPP1   :R:="APP1";
    | markAPP2   :R:="APP2";
    | markAPP13  :R:="APP13";
    ELSE
                  R:="???";
    END;
    RETURN R;
END friendlymarker;

(* far from perfect but we're fed up with this crappy header *)

PROCEDURE chkJPG (VAR x,y:LONGCARD; hin:FIO.File; DEBUG:BOOLEAN):BOOLEAN;
CONST
    maxretries = 10; (* maximum loop iteration : 10 should do *)
VAR
    retries,skiplen:CARDINAL;
    n:SYSTEM.CARD16;   (* //XDS as we'll flip it, we must force it a TopSpeed cardinal *)
    fsize,p:LONGCARD;
    b:SYSTEM.LOC;
    ok:BOOLEAN;
BEGIN
    fsize:=FIO.Size(hin);
    FIO.Seek(hin,0);
    b:=readByte(hin);
    IF CARDINAL(b) # markJPEG THEN RETURN FALSE;END;
    b:=readByte(hin);
    IF CARDINAL(b) # markSOI THEN RETURN FALSE;END;

    ok:=FALSE;
    retries:=0; (* safety *)
    LOOP
        INC(retries);
        IF retries > maxretries THEN EXIT; END;

        p:=FIO.GetPos(hin);
        b:=readByte(hin);
        IF CARDINAL(b) # markJPEG THEN EXIT; END;

        b:=readByte(hin);
IF DEBUG THEN
    WrStr("//    fpos    = $"); WrStr( fmtbignum(p+SIZE(b),16,8,"0"));
    WrStr("      marker  = $"); WrStr( fmtbignum ( LONGCARD(b), 16, 2, "0") );WrLn;
END;
        CASE CARDINAL(b) OF
        | markSOI  : (* $ffd8 should never happen here ! *)
            ;
        | markAPP0,markAPP1 : (* $ffe0 $ffe1 *)
            ; (* "JFIF" or "exif" *)
        | markAPP2 : (* $ffe2 *)
            ;
        | markAPP13: (* $ffed *)
            ;
        | markDQT  : (* $ffdb *)
            ;
        | markEOI: (* end of image *)
            EXIT;
        | markSOF0,markSOF1,markSOF2,markSOF3: (* start of frame *)
            n:=readWord(hin);
            b:=readByte(hin);
            n:=readWord(hin);
            y:=SYSTEM.CARD32(wflip(n));
            n:=readWord(hin);
            x:=SYSTEM.CARD32(wflip(n));
            ok:=TRUE;
            EXIT;
        | markCOM: (* comment *)
            ;
        ELSE
            ;
        END;
        n:=readWord(hin);
        skiplen:=wflip(n);
        INC(p, SIZE(n) );
        INC(p, SYSTEM.CARD32(skiplen) );
IF DEBUG THEN
    WrStr("//    fpos    = $"); WrStr( fmtbignum(p,16,8,"0"));
    WrStr("      skiplen = $"); WrStr( fmtbignum ( LONGCARD(skiplen), 16, 2, "0") );WrLn;
END;
        IF p >= fsize THEN EXIT; END;
        FIO.Seek(hin,p);
    END;
    RETURN ok;
END chkJPG;

PROCEDURE chkGIF (VAR x,y:LONGCARD):BOOLEAN; (* ok *)
VAR
    h:GIFheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.Move( SYSTEM.ADR(databuffer), SYSTEM.ADR(h), SIZE(h));
    ok:=FALSE;
    IF (same(h.sig,"GIF87a") OR same(h.sig,"GIF89a") ) THEN
        x:=LONGCARD (h.wi);
        y:=LONGCARD (h.he);
        ok:=TRUE;
    END;
    RETURN ok;
END chkGIF;

PROCEDURE chkPNG (VAR x,y:LONGCARD):BOOLEAN; (* ok *)
VAR
    h:PNGheaderType;
    ok:BOOLEAN;
    S:str16;
BEGIN
    Str.Concat(S,CHR(89H),"PNG"+nl);Str.Append(S,ctrlZ); (* //XDS stupid syntax ! *)
    Lib.Move( SYSTEM.ADR(databuffer), SYSTEM.ADR(h), SIZE(h) );
    ok:=FALSE;
    IF same(h.sig1,S) THEN
        IF same(h.sig2,"IHDR") THEN
            x:=dwflip(h.wi);
            y:=dwflip(h.he);
            ok:=TRUE;
        END;
    END;
    RETURN ok;
END chkPNG;

PROCEDURE chkPCX (VAR x,y:LONGCARD ):BOOLEAN;
CONST
    kTen = SYSTEM.LOC(0AH);
    kOne = SYSTEM.LOC(1);
    kZero= SYSTEM.LOC(0);
VAR
    h:PCXheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.Move( SYSTEM.ADR(databuffer), SYSTEM.ADR(h), SIZE(h) );
    ok:=FALSE;
    IF h.manufacturer = kTen THEN
        IF h.encoding = kOne THEN
            IF h.reserved1 = kZero THEN
                x:= LONGCARD(h.rightmargin-h.leftmargin)+1;
                y:= LONGCARD(h.lowermargin-h.uppermargin)+1;
                ok:=TRUE;
            END;
        END;
    END;
    RETURN ok;
END chkPCX;

PROCEDURE chkBMP (VAR x,y:LONGCARD ):BOOLEAN;
VAR
    h:BMPtotalHeaderType;
    ok:BOOLEAN;
i:CARDINAL;
BEGIN
(* FOR i:=0 TO 15 DO IO.WrHex( CARDINAL(databuffer[i]),3);END; *)
    Lib.Move( SYSTEM.ADR(databuffer), SYSTEM.ADR(h), SIZE(h) );
    ok:=FALSE;
    IF same(h.FILE.bfType,"BM") THEN
        IF CARDINAL( h.FILE.bfReserved1 ) = 0 THEN (* //XDS madness : buffer is ok, data is offset by 2 here ! *)
            IF CARDINAL ( h.FILE.bfReserved2 ) = 0 THEN
                x:=LONGCARD( h.INFO.biWidth );
                y:=LONGCARD( h.INFO.biHeight );
                ok:=TRUE;
            END;
        END;
    END;
    ok:=FALSE; (* //XDS hack because oddly enough, detection won't work from Win32 ! *)
    RETURN ok;
END chkBMP;

(* mere probability without guarantee *)

PROCEDURE chkTGA (VAR x,y:LONGCARD ):BOOLEAN;
VAR
    h:TGAheaderType;
    ok:BOOLEAN;
    n:CARDINAL;
BEGIN
    Lib.Move( SYSTEM.ADR(databuffer), SYSTEM.ADR(h), SIZE(h) );
    n:=0;
    CASE CARDINAL( h.colortyp  ) OF
    | 0,1 : INC(n);
    ELSE ; (* //ISO fixed silly requirement *) END;
    CASE CARDINAL( h.imagetyp  ) OF
    | 1,2,9,10: INC(n);
    ELSE ; (* //ISO fixed silly requirement *) END;
    CASE CARDINAL( h.entrybits ) OF
    | 0,16,24,32 : INC(n);
    ELSE ; (* //ISO fixed silly requirement *) END;
    CASE CARDINAL( h.pixelsize ) OF (* checking 8,16,24,32 set would not work ! *)
    | 8, 16, 24, 32 : INC(n);
    ELSE ; (* //ISO fixed silly requirement *) END;
    ok:= (n = 4);
    IF ok THEN
        x:= LONGCARD(h.width);
        y:= LONGCARD(h.height);
    END;
    ok:=FALSE; (* //XDS hack because oddly enough, detection won't work from Win32 ! *)
    RETURN ok;
END chkTGA;

PROCEDURE chkDDS (VAR x,y:LONGCARD ):BOOLEAN;
CONST
    kStructSize = 124; (* $7c *)
VAR
    h:DDSheaderType;
    ok:BOOLEAN;
BEGIN
    Lib.Move( SYSTEM.ADR(databuffer), SYSTEM.ADR(h), SIZE(h) );
    ok:=FALSE;
    IF (same(h.sig,"DDS ")) THEN
        IF h.dwSize = kStructSize THEN
            x:=h.dwHeight;
            y:=h.dwWidth;
            ok:=TRUE;
        END;
    END;
    RETURN ok;
END chkDDS;

(* ------------------------------------------------------------ *)

PROCEDURE fmtnewext (VAR S:pathtype;realext:str80);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(S, u,d,n,e);
    Lib.MakeAllPath(S, "","",n,realext);
END fmtnewext;

CONST
    unsupportedextstr = "..."; (* was "???" *)

PROCEDURE idToExt (VAR Z:str80; id:CARDINAL );
BEGIN
    CASE id OF
    | idJPG: Z:="jpg";
    | idGIF: Z:="gif";
    | idPNG: Z:="png";
    | idPCX: Z:="pcx";
    | idBMP: Z:="bmp";
    | idDDS: Z:="dds";
    | idTGA: Z:="tga";
    ELSE     Z:=unsupportedextstr;
    END;
END idToExt;

PROCEDURE chkIDext (VAR Z:str80;
                   id:CARDINAL;S:ARRAY OF CHAR ):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    i:CARDINAL;
    rc:BOOLEAN;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Str.Caps(e);

    idToExt(Z, id);
    Str.Caps(Z);

    IF same(Z,unsupportedextstr) THEN RETURN FALSE;END;

    Str.Prepend(Z,dot);

    rc:=same(Z,e);
    IF NOT(rc) THEN
        IF id=idJPG THEN rc:=same(".JPEG",e); END;
    END;
    RETURN rc;
END chkIDext;

PROCEDURE handleExactModulo (clipmode,bothmodulo:BOOLEAN;
                            x,y,moduloclip:LONGCARD):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    IF clipmode THEN
        IF bothmodulo THEN
            ok:=( ( ( x MOD moduloclip)=0 ) AND ( ( y MOD moduloclip)= 0) );
        END;
    END;
    RETURN ok;
END handleExactModulo;

PROCEDURE fmtXY (VAR R:ARRAY OF CHAR;
                padchar:CHAR;padwi,moduloclip,id:CARDINAL;x,y,fsize:LONGCARD;
                clipmode,showfsize:BOOLEAN);
CONST
    winormal = 2 + 4 + 3 + 4; (* "  #### x ####" *)
    wiclip   = winormal+2+2;  (* "  ####+# x ####+#" *)
    wifsize  = 10; (* #+###+###+### *)
VAR
    S : str128;
    Z : str80;
    wi,i:CARDINAL;
    xx,yy,dx,dy:LONGCARD;
BEGIN
    IF clipmode THEN
        dx:= x MOD LONGCARD(moduloclip); xx:=x - dx;
        dy:= y MOD LONGCARD(moduloclip); yy:=y - dy;
        wi:=wiclip;
    ELSE
        wi:=winormal;
    END;
    idToExt(Z, id);
    IF showfsize THEN
        Str.Prepend(Z,blank+blank);
        Str.Prepend(Z,fmtbignum(fsize,10,wifsize," "));
    END;
    IF id = idUNKNOWN THEN
        Str.Prepend(Z,"--- ");
        S:="";
    ELSE
        Str.Prepend(Z,"+++ ");
        IF clipmode THEN
            S:="~+! x ~+!";
            Str.Subst(S,"~",fmtbignum(xx,10,padwi,padchar));
            Str.Subst(S,"~",fmtbignum(yy,10,padwi,padchar));
            IF dx = 0 THEN
                Str.Subst(S,"+!","  ");  (* "+!" *)
            ELSE
                Str.Subst(S,"!",fmtbignum(dx,10,1,""));
            END;
            IF dy = 0 THEN
                Str.Subst(S,"+!","  ");  (* "+!" *)
            ELSE
                Str.Subst(S,"!",fmtbignum(dy,10,1,""));
            END;
        ELSE
            S:="~ x ~";
            Str.Subst(S,"~",fmtbignum(x,10,padwi,padchar));
            Str.Subst(S,"~",fmtbignum(y,10,padwi,padchar));
        END;
    END;

    FOR i:=Str.Length(S)+1 TO wi DO
        Str.Prepend(S,blank);
    END;
    Str.Prepend(S,Z);
    Str.Append(S,blank+blank);
    Str.Copy(R,S);
END fmtXY;

CONST
   FZERO = 0; (* fsize flag *)
TYPE
    cmdType = (undefined,listpix,listall,listallbutpix,listbadext);
TYPE
    compType= (compNone,
              xGREATERthanVAL,yGREATERthanVAL,
              XorYgreater,
              xGREATERthanY,xEQUALtoY,xSMALLERthanY);

PROCEDURE showit (cmd:cmdType;compmode:compType;
                 inversedimensions,inversefsize,terse,
                 clipmode,bothmodulo,batchmode,showfsize,DEBUG:BOOLEAN;
                 padchar:CHAR;padwi,moduloclip,minW,minH:CARDINAL;
                 minfsize:LONGCARD;S:pathtype ):BOOLEAN;
CONST
    wanted = databufferlen;
VAR
    hin:FIO.File;
    got:CARDINAL;
    x,y:LONGCARD;
    id:CARDINAL;
    R:str128;
    goodext,okdim,oksize,okpic,showme:BOOLEAN;
    fsize,minX,minY:LONGCARD;
    realext : str80; (* really oversized *)
BEGIN
IF DEBUG THEN
    WrStr("// ");WrStr(S);WrLn;
END;
    minX:=LONGCARD(minW);
    minY:=LONGCARD(minH);

    showme := TRUE;

    hin:=FIO.OpenRead(S);
    fsize:=FIO.Size(hin);
    Lib.Fill( SYSTEM.ADR(databuffer), databufferlen, 00H); (* reset state *)
    got:=FIO.RdBin(hin,databuffer,wanted);

    IF chkJPG(x,y,hin,DEBUG) THEN (* should not be hard coded *)
        id:=idJPG;
    ELSIF chkGIF(x,y) THEN
        id:=idGIF;
    ELSIF chkPNG(x,y) THEN
        id:=idPNG;
    ELSIF chkPCX(x,y) THEN
        id:=idPCX;
    ELSIF chkBMP(x,y) THEN
        id:=idBMP;
    ELSIF chkDDS(x,y) THEN
        id:=idDDS;
    ELSIF chkTGA(x,y) THEN
        id:=idTGA;
    ELSE
        id:=idUNKNOWN;
        x:=MAX(LONGCARD); (* force display *)
        y:=MAX(LONGCARD);
    END;
    FIO.Close(hin);

    CASE compmode OF
    | compNone        : okdim:=TRUE;
    | xGREATERthanVAL : okdim:=(x > minX);
    | yGREATERthanVAL : okdim:=(y > minY);
    | XorYgreater     : okdim:=(x > minX) OR (y > minY);
    | xGREATERthanY   : okdim:=(x > y);
    | xEQUALtoY       : okdim:=(x = y);
    | xSMALLERthanY   : okdim:=(x < y);
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF inversedimensions THEN okdim:=NOT(okdim);END;

    IF minfsize = FZERO THEN
        oksize := TRUE;
    ELSE
        oksize := (fsize > minfsize);
    END;
    IF inversefsize THEN oksize:=NOT(oksize);END;

    okpic := ( okdim AND oksize );

    CASE cmd OF
    | listpix:       showme := (id # idUNKNOWN); showme:=(showme AND okpic);
    | listall:       showme := okpic;
    | listallbutpix: showme := (id = idUNKNOWN);
    | listbadext:    goodext:=chkIDext(realext, id,S);
                     showme := (id # idUNKNOWN); showme:=(showme AND (NOT(goodext)) );
    ELSE ; (* //ISO fixed silly requirement *) END;

    showme := ( showme AND handleExactModulo(clipmode,bothmodulo,x,y,LONGCARD(moduloclip) ) );

    IF showme THEN
        fmtXY(R,padchar,padwi,moduloclip,id,x,y,fsize,clipmode,showfsize);
        IF NOT (terse) THEN WrStr(R); END;
        IF cmd = listbadext THEN
            IF batchmode THEN
                WrStr("ren ");
                wrq(TRUE,S);
                WrStr(" ");
                fmtnewext(S,realext);
                wrq(TRUE,S);
            ELSE
                wrq(TRUE,S);
            END;
        ELSE
            wrq(TRUE,S);
        END;
        WrLn;
    END;
    RETURN showme;
END showit;

PROCEDURE showXY (VAR fcount:LONGCARD;
                 cmd:cmdType;compmode:compType;
                 inversedimensions,inversefsize,terse,
                 clipmode,bothmodulo,batchmode,showfsize,DEBUG:BOOLEAN;
                 padchar:CHAR;padwi,moduloclip,lastfile,minW,minH:CARDINAL;
                 minfsize:LONGCARD; anchor:ptrToEntry):BOOLEAN;
VAR
    S:pathtype;
    ismatch,flagAbort:BOOLEAN;
    i:CARDINAL;
BEGIN
    fcount:=0;
    flagAbort:=FALSE;
    i:=firstEntry-1;
    LOOP
        INC(i);
        IF i > lastfile THEN EXIT; END;
        getMatchEntry(S, i,anchor);
        ismatch:=showit (cmd,compmode,
                        inversedimensions,inversefsize,terse,
                        clipmode,bothmodulo,batchmode,showfsize,DEBUG,
                        padchar,padwi,moduloclip,minW,minH,minfsize,S);
        IF ismatch THEN INC(fcount);END;
        flagAbort:=ChkEscape();
        IF flagAbort THEN EXIT; END;
    END;
    RETURN flagAbort;
END showXY;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getfsize (VAR v:LONGCARD;S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    ok:BOOLEAN;
    kmul:LONGCARD;
    i:CARDINAL;
    suffix:str16;
BEGIN
    i:=1-1;
    LOOP
        INC(i);
        IF i > 4 THEN kmul:=1; EXIT; END;
        CASE i OF
        | 1: suffix:="K"; kmul:=1000;
        | 2: suffix:="M"; kmul:=1000*1000;
        | 3: suffix:="KB";kmul:=1024;
        | 4: suffix:="MB";kmul:=1024*1024;
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Prepend(suffix,"*");
        IF Str.Match(S,suffix) THEN
            i:=Str.Length(suffix);
            Str.Delete(S,Str.Length(S)-i+1,i);
            EXIT;
        END;
    END;
    ok:=GetLongCard(S,v);
    IF ok THEN v:=v*kmul; END;
    RETURN ok;
END getfsize;

PROCEDURE getcard (VAR v:CARDINAL; S:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    lc:LONGCARD;
BEGIN
    ok:= GetLongCard(S,lc);
    IF ok THEN
        ok:= ( lc <= MAX(CARDINAL) );
        IF ok THEN v:=CARDINAL(lc); END;
    END;
    RETURN ok;
END getcard;

PROCEDURE newcmd (VAR cmd:cmdType;wanted:cmdType ):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    rc:= ( (cmd = undefined) OR (cmd = wanted) );
    IF rc THEN cmd:=wanted;END;
    RETURN rc;
END newcmd;

PROCEDURE dmpme (terse,addnl:BOOLEAN;S:ARRAY OF CHAR   );
BEGIN
    IF NOT(terse) THEN
        WrStr(S);WrLn;
        IF addnl THEN WrLn;END;
    END;
END dmpme;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgListMode         = "::: List mode         : ~";
    msgDimensionsFilter = "::: Dimensions filter : ~";
    msgFilesizeFilter   = "::: Filesize filter   : ~";
    msgMatchesFound     = "::: Matches found     : ~";
CONST
    firstparm = 1;
    maxparm   = 1;
VAR
    parmcount,i,opt,lastparm:CARDINAL;
    S,R,spec:pathtype;
    showfsize,terse,inversedimensions,inversefsize:BOOLEAN;
    onlypicext,clipmode,bothmodulo,batchmode:BOOLEAN;
    DEBUG:BOOLEAN;
    parm:ARRAY [firstparm..maxparm] OF pathtype;
    anchor:ptrToEntry;
    alcatraz:BOOLEAN;
    lastfile:CARDINAL;
    fmtxy:(unset,rawxy,useblank,usezero);
    moduloclip,padwi:CARDINAL;
    padchar:CHAR;
    redef,redefusr, minW , minH : CARDINAL;
    XY:str16;
    fcount:LONGCARD; (* a CARDINAL would probably do, eh eh *)
    msgN,msgI:str128;
    cmd:cmdType;
    minfsize:LONGCARD;
    compmode:compType;
BEGIN
    FIO.IOcheck := FALSE; (* don't let topspeed handle problems *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    lastparm    := firstparm-1;
    fmtxy       := unset;
    compmode    := compNone;
    minW        := 0;
    minH        := 0;
    inversedimensions := FALSE;
    inversefsize:= FALSE;
    onlypicext  := FALSE;
    terse       := FALSE;
    redef       := 0;
    redefusr    := 0;
    clipmode    := FALSE;
    bothmodulo  := FALSE;
    batchmode   := FALSE;
    cmd         := undefined;
    minfsize    := FZERO;
    showfsize   := FALSE;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "x"+delim+"lfn"+delim+
                                  "L"+delim+"LIST"+delim+"ALL"+delim+
                                  "F"+delim+"BLANK"+delim+
                                  "FF"+delim+"ZERO"+delim+
                                  "I"+delim+"INVERSE"+delim+
                                  "2"+delim+"320X200"+delim+"320*200"+delim+"200"+delim+
                                  "4"+delim+"640X480"+delim+"640*480"+delim+"480"+delim+
                                  "6"+delim+"800X600"+delim+"800*600"+delim+"600"+delim+
                                  "7"+delim+"1024X768"+delim+"1024*768"+delim+"768"+delim+
                                  "9"+delim+"1280X960"+delim+"1280*960"+delim+"960"+delim+
                                  "1"+delim+"1600X1200"+delim+"1600*1200"+delim+"1200"+delim+
                                  "LL"+delim+
                                  "Z"+delim+"PICTURES"+delim+
                                  "T"+delim+"TERSE"+delim+
                                  "LT"+delim+"TL"+delim+
                                  "W:"+delim+"X:"+delim+
                                  "H:"+delim+"Y:"+delim+
                                  "LLL"+delim+"BADEXT"+delim+
                                  "C"+delim+"CLIP8"+delim+
                                  "B"+delim+"BATCH"+delim+
                                  "LLLB"+delim+"BLLL"+delim+
                                  "S:"+delim+"SIZE:"+delim+"FILESIZE:"+delim+
                                  "S"+delim+"SHOWSIZE"+delim+
                                  "II"+delim+"IS"+delim+
                                  "CZ"+delim+
                                  "K"+delim+"KLIP4"+delim+
                                  "KZ"+delim+
                                  "XGY"+delim+"WGH"+delim+"ITALIAN"+delim+
                                  "XEY"+delim+"WEH"+delim+"SQUARE"+delim+
                                  "XSY"+delim+"WSH"+delim+"PORTRAIT"+delim+
                                  "DEBUG"
                              );

            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5:    abort(errHelp,"");
            | 6,7,8:  IF newcmd(cmd,listall)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
            | 9,10:   CASE fmtxy OF
                      | unset,usezero: fmtxy:=usezero;
                      ELSE            abort(errFmt,"");
                      END;
            |11,12:   CASE fmtxy OF
                      | unset,rawxy:  fmtxy:=rawxy;
                      ELSE            abort(errFmt,"");
                      END;
            |13,14  : inversedimensions:=TRUE;
            |15..18 : minW:=320;  minH:=200;  compmode:=XorYgreater;INC(redef);
            |19..22 : minW:=640;  minH:=480;  compmode:=XorYgreater;INC(redef);
            |23..26 : minW:=800;  minH:=600;  compmode:=XorYgreater;INC(redef);
            |27..30 : minW:=1024; minH:=768;  compmode:=XorYgreater;INC(redef);
            |31..34 : minW:=1280; minH:=960;  compmode:=XorYgreater;INC(redef);
            |35..38 : minW:=1600; minH:=1200; compmode:=XorYgreater;INC(redef);
            |39:      IF newcmd(cmd,listallbutpix)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
            |40,41:   onlypicext     := TRUE;
            |42,43:   terse          := TRUE;
            |44,45:   IF newcmd(cmd,listall)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
                      terse          := TRUE;
            |46,47:   IF getcard(minW,R)=FALSE THEN abort(errValue,S);END;
                      compmode       := xGREATERthanVAL; INC(redefusr);
            |48,49:   IF getcard(minH,R)=FALSE THEN abort(errValue,S);END;
                      compmode       := yGREATERthanVAL; INC(redefusr);
            |50,51:   IF newcmd(cmd,listbadext)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
            |52,53:   clipmode       := TRUE; moduloclip:=8;
            |54,55:   batchmode      := TRUE;
            |56,57:   IF newcmd(cmd,listbadext)=FALSE THEN
                          abort(errNonsense,"-l, -ll and -lll");
                      END;
                      batchmode      := TRUE;
            |58,59,60:IF getfsize(minfsize,R)=FALSE THEN abort(errFsize,S);END;
                      INC(redefusr);
            |61,62:   showfsize:=TRUE;
            |63,64:   inversefsize:=TRUE;
            |65:      clipmode       := TRUE; moduloclip:=8;
                      bothmodulo     := TRUE;
            |66,67:   clipmode       := TRUE; moduloclip:=4;
            |68:      clipmode       := TRUE; moduloclip:=4;
                      bothmodulo     := TRUE;
            |69,70,71:compmode       := xGREATERthanY;   INC(redefusr);
            |72,73,74:compmode       := xEQUALtoY;       INC(redefusr);
            |75,76,77:compmode       := xSMALLERthanY;   INC(redefusr);
            |78:      DEBUG          := TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;
    IF lastparm < firstparm THEN abort(errMissingSpec,"");END;

    IF ( (redef # 0) AND (redefusr # 0) ) THEN abort(errDefaultOrUser,"");END;

    IF cmd = undefined THEN cmd:=listpix;END;

    CASE cmd OF
    | listpix,listall : ;
    | listallbutpix,listbadext:
        IF inversedimensions      THEN abort(errNonsense,"-ll[l] and -i");END;
        IF inversefsize           THEN abort(errNonsense,"-ll[l] and -ii");END;
        IF redef # 0              THEN abort(errNonsense,"-ll[l] and -#");END;
        IF redefusr # 0           THEN abort(errNonsense,"-ll[l] and any of -w:#, -h:#, x?y:# or -s:#");END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | listbadext:
        IF batchmode THEN terse:=TRUE;END;
    ELSE
        IF batchmode THEN abort(errBadExtRequired,"");END;
    END;

    CASE redef OF
    | 0 : ; (* no -# *)
    | 1 : ; (* one -# *)
    ELSE
        abort(errScreen,"");
    END;

    IF inversedimensions THEN
        IF ( (redef = 0) AND (redefusr = 0) ) THEN abort(errInverseDimensions,"");END;
    END;

    IF inversefsize THEN
        IF ( (redef = 0) AND (redefusr = 0) ) THEN abort(errInverseFsize,"");END;
    END;

    Str.Copy(spec,parm[firstparm]);

    IF same(spec,dot) THEN Str.Copy(spec,stardotstar);END;
    IF same(spec,stardotstar)=FALSE THEN
        IF isDirectory(spec) THEN
            fixDirectory(spec);
            Str.Append(spec,stardotstar);
        END;
    END;
    IF chkJokerPath (spec) THEN abort(errJokerPath,spec);END;

    lastfile:=buildMatchList (anchor, onlypicext,spec);
    CASE lastfile OF
    | firstEntry-1: freeMatchList(anchor); abort(errNoMatch,S);
    | TOOMANY:      freeMatchList(anchor); abort(errTooMany,S);
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF fmtxy = unset THEN fmtxy:=useblank;END;
    CASE fmtxy OF
    | rawxy    : padwi:=1; padchar:="";
    | useblank : padwi:=4; padchar:=" ";
    | usezero  : padwi:=4; padchar:="0";
    ELSE ; (* //ISO fixed silly requirement *) END;

    S:=msgListMode;
    CASE cmd OF
    | listpix:       R:="recognized files";
    | listall:       R:="all files";
    | listallbutpix: R:="unrecognized files";
    | listbadext:    R:="files with extension not matching internal format";
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF onlypicext THEN Str.Append(R," (valid picture extensions only)");END;
    Str.Subst(S,"~",R);
    dmpme(terse,FALSE,S);

    XY:="";
    CASE compmode OF
    | compNone        : XY:="no";
    | xGREATERthanVAL : XY:="~";
                        msgN:="width greater than ";
                        msgI:="width smaller or equal to ";
    | yGREATERthanVAL : XY:="|";
                        msgN:="height greater than ";
                        msgI:="height smaller or equal to ";
    | XorYgreater     : XY:="~x|";
                        msgN:="one dimension greater than ";
                        msgI:="dimensions smaller or equal to ";
    | xGREATERthanY   : msgN:="width greater than height";
                        msgI:="width smaller than, or equal to, height";
    | xEQUALtoY       : msgN:="width equal to height";
                        msgI:="width different from height";
    | xSMALLERthanY   : msgN:="width smaller than height";
                        msgI:="width equal to, or greater than, height";
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Subst( XY,"~",fmtnum(minW,10,1,"") );
    Str.Subst( XY,"|",fmtnum(minH,10,1,"") );

    S:=msgDimensionsFilter;
    CASE cmd OF
    | listallbutpix,listbadext:
        R:="not applicable";
    ELSE
        CASE compmode OF
        | compNone:
            R:="no";
        ELSE
            IF inversedimensions THEN
                Str.Concat(R,msgI,XY);
            ELSE
                Str.Concat(R,msgN,XY);
            END;
        END;
    END;
    Str.Subst(S,"~",R);
    dmpme(terse,FALSE,S);

    IF minfsize = FZERO THEN
        XY:="no";
    ELSE
        XY:="|";
        msgN:="filesize greater than ";
        msgI:="filesize smaller or equal to ";
    END;
    Str.Subst( XY,"|",fmtbignum(minfsize,10,1,"") );

    S:=msgFilesizeFilter;
    CASE cmd OF
    | listallbutpix,listbadext:
        R:="not applicable";
    ELSE
        IF minfsize = FZERO THEN
            R:="no";
        ELSE
            IF inversefsize THEN
                Str.Concat(R,msgI,XY);
            ELSE
                Str.Concat(R,msgN,XY);
            END;
        END;
    END;
    Str.Subst(S,"~",R);
    dmpme(terse,TRUE,S);

    (* //FIXME possibly insert here message about clipmode and modulo *)

    alcatraz:=showXY (fcount,cmd,compmode,
                     inversedimensions,inversefsize,terse,
                     clipmode,bothmodulo,batchmode,showfsize,DEBUG,
                     padchar,padwi,moduloclip,lastfile,minW,minH,minfsize,anchor);
    freeMatchList(anchor);

    IF alcatraz THEN abort(errAborted,"");END;

    S:=msgMatchesFound;
    Str.Subst(S,"~",fmtbignum(fcount,10,1,""));
    IF NOT(terse) THEN
        IF fcount # 0 THEN WrLn;END;
    END;
    dmpme(terse,FALSE,S);

    abort(errNone,"");
END picDimS32.

