
(* very very old code, slightly revised for QDTOOLS *)

(*
for Win32 version :
- BiosIO calls were replaced with IO
- Lib.Delay() calls were removed
- no retrace, of course...
- colors in GRAPH.DEF are WRONG ! see infra
- graphics glitches, compiler unable to retrieve a record member... bravo !
*)

MODULE YingYang32;

IMPORT Graph,IO,MATHLIB,SYSTEM;
IMPORT Lib,Str;
FROM IO IMPORT WrStr,WrLn;

(* ------------------------------------------------------------ *)

PROCEDURE doDelay(n:CARDINAL);
CONST
    jmax=1000;
    kmax=1000;
VAR
    i,j,k,v:CARDINAL;
BEGIN
    FOR i:=1 TO n DO
        FOR j:=1 TO jmax DO
	    FOR k:=1 TO kmax DO
	        v:=19630201;
	    END;
	END;
    END;
END doDelay;

PROCEDURE line (delay:CARDINAL;  x1,y1,x2,y2:LONGREAL; ink:CARDINAL );
VAR
    xx1,yy1,xx2,yy2:CARDINAL;
BEGIN
    xx1:=VAL(CARDINAL,x1);
    yy1:=VAL(CARDINAL,y1);
    xx2:=VAL(CARDINAL,x2);
    yy2:=VAL(CARDINAL,y2);
    Graph.Line( xx1,yy1,xx2,yy2, ink );
    IF delay # 0 THEN doDelay(delay); END;
END line;

PROCEDURE plot (x,y:LONGREAL; ink:CARDINAL );
VAR
    xx,yy:CARDINAL;
BEGIN
    xx:=VAL(CARDINAL,x);
    yy:=VAL(CARDINAL,y);
    Graph.Plot( xx,yy, ink );
END plot;

PROCEDURE disc (fast:BOOLEAN; x,y,r:LONGREAL;ink,delay:CARDINAL  );
VAR
    i,xx,yy,rr:CARDINAL;
BEGIN
    xx:=VAL(CARDINAL,x);
    yy:=VAL(CARDINAL,y);
    rr:=VAL(CARDINAL,r);
    IF fast THEN
        Graph.Disc(xx,yy,rr,ink);
    ELSE
        FOR i := 1 TO rr DO
	    Graph.Circle(xx,yy,i,ink);
            IF delay # 0 THEN doDelay(delay); END;
	END;
    END;
END disc;

(* ------------------------------------------------------------ *)

CONST
    progTitle = "Q&D Ying-Yang (Win32) v0.9 (from v1.0a for DOS) by PhG";

CONST
    gmode        = Graph._VRES16COLOR;
    tmode        = Graph._DEFAULTMODE;
CONST
    bkcolor=Graph._clrLIGHTMAGENTA; (* RED !!! *)
    white = Graph._clrLIGHTGREEN;   (* BRIGHT WHITE !!! *)
    black = Graph._clrBLACK;        (* YES, THIS ONE MATCHES ITS NAME !!! *)
    defaultpaper = bkcolor;
(*
du grand n'importe quoi : les couleurs sont fausses !

  _clrBLACK         =  0;  noir
  _clrBLUE          =  1;  rouge fonc
  _clrGREEN         =  2;  vert fonc
  _clrCYAN          =  3;  jaune fonc (marron)
  _clrRED           =  4;  bleu nuit
  _clrMAGENTA       =  5;  violet fonc
  _clrBROWN         =  6;  cyan fonc
  _clrWHITE         =  7;  gris clair
  _clrGRAY          =  8;  vert clair
  _clrLIGHTBLUE     =  9;  bleu clair
  _clrLIGHTGREEN    =  10; blanc
  _clrLIGHTCYAN     =  11; gris fonc
  _clrLIGHTRED      =  12; gris presque noir
  _clrLIGHTMAGENTA  =  13; rouge
  _clrLIGHTYELLOW   =  14; vert
  _clrBRIGHTWHITE   =  15; jaune
*)

CONST
    mindelay=0;
    maxdelay=20;
    defaultdelay = 2;
    maxpause = 10000;
CONST
    bigradius   = 120;
    smallradius = LONGREAL(bigradius DIV 8);
CONST
    firstangle = LONGREAL(90.0);
    halfcircle = LONGREAL(180.0);
    increment  = LONGREAL(0.5);   (* smaller means less gaps in teardrops *)
VAR
    rc: BOOLEAN;
    oldbk:LONGCARD;
    V  : Graph.VideoConfig;
    i,paper,xmin,xmax,ymin,ymax:CARDINAL;
    cx,cy:LONGREAL;
    ch:CHAR;
    halfradius,PI,s,c,deg2rad,alphadeg,e,radius,dx,dy,lastdx,lastdy:LONGREAL;
    zlastdx,zlastdy:LONGREAL;
    x1,y1,x2,y2,x0,y0:LONGREAL;
    S:ARRAY[0..15] OF CHAR;
    v:LONGCARD;
    delay,pause:CARDINAL;
BEGIN
    delay:=defaultdelay;
    paper:=defaultpaper;
    FOR i:=1 TO Lib.ParamCount() DO
        Lib.ParamStr(S,i);
        CASE S[0] OF
        | "-","/","?":
            WrLn;
            WrStr(progTitle);WrLn;
            WrLn;
            WrStr("Syntax : YINGYANG32 [pause] [paper]");WrLn;
            WrLn;
            WrStr('"pause" waits [0..20] units when drawing a line, default is 2.');WrLn;
            WrStr('"paper" is [A..P], default is A.');WrLn;
            WrLn;
            WrStr("In order to close window, either hit a key or wait for a few seconds.");WrLn;
            (* Lib.SetReturnCode(0); *)
            HALT (0);
        | "A".."P", "a".."p" :
            S[0]:=CAP(S[0]);
            paper:=ORD(S[0])-ORD("A");
        ELSE
            v:=Str.StrToCard(S,10,rc);
            IF rc THEN
                IF ( (v >= LONGCARD(mindelay)) AND (v <= LONGCARD(maxdelay)) ) THEN
                    delay:=CARDINAL(v);
                END;
            END;
        END;
    END;

    rc:=Graph.SetVideoMode(gmode);
    Graph.InitStdPalette(); (* //XDS *)
    Graph.GetVideoConfig(V);
    xmin:=0; xmax:=V.numxpixels-1;
    ymin:=0; ymax:=V.numypixels-1;
    cx:=LONGREAL(V.numxpixels DIV 2);
    cy:=LONGREAL(V.numypixels DIV 2);
    oldbk:=Graph.SetBkColor(paper);    (* //XDS ah ah, not the expected RGB value ! *)
    Graph.ClearScreen(Graph._GWINDOW);
    Graph.SetGraphWindowTitle(progTitle);

    PI := 4.0 * MATHLIB.ATan(1.0);
    deg2rad := PI / halfcircle;

    e        := LONGREAL(1.0); (* ellipse *)
    radius   := VAL(LONGREAL,bigradius);

    alphadeg := firstangle;
    lastdx := radius * MATHLIB.Cos( alphadeg * deg2rad) * e;
    lastdy := radius * MATHLIB.Sin( alphadeg * deg2rad);
    halfradius := radius / 2.0;
    zlastdx:=lastdx;
    zlastdy:=lastdy;

    LOOP
        alphadeg:=alphadeg + increment;
        IF alphadeg > (firstangle+halfcircle) THEN EXIT; END; (* clockwise, bottom to top *)
        c := MATHLIB.Cos( alphadeg * deg2rad);
        s := MATHLIB.Sin( alphadeg * deg2rad);

        dx := c * radius * e;
        dy := s * radius;

        x1 := cx+lastdx;
        y1 := cy+lastdy;
        x2 := cx+dx;
        y2 := cy+dy;
        line (delay,x1,y1,x2,y2, white); (* left half-circle *)
        x0 := cx-lastdx; (* symetric *)
        y0 := cy-lastdy;
        lastdx := dx;
        lastdy := dy;

        dx := c * halfradius;
        dy := s * halfradius;
        x1 := cx + dx;
        y1 := cy + dy + halfradius;
        x2 := cx + dx;
        y2 := cy - dy + halfradius;
        line(delay,x1,y1,x2,y2,white); (* left half-disk *)

        x1 := x0;
        y1 := y0;
        x2 := cx - dx;
        y2 := cy - dy - halfradius;

        line (delay,x1,y1,x2,y2,white); (* right teardrop *)

        (* uneeded but just to check *)

        dx := c * radius * e;
        dy := s * radius;

        x1 := cx-zlastdx;
        y1 := cy-zlastdy;
        x2 := cx-dx;
        y2 := cy-dy;
        line (delay,x1,y1,x2,y2, black); (* right half-circle *)
        x0 := cx+zlastdx; (* symetric *)
        y0 := cy+zlastdy;
        zlastdx := dx;
        zlastdy := dy;

        dx := c * halfradius;
        dy := s * halfradius;
        x1 := cx - dx;
        y1 := cy - dy - halfradius;
        x2 := cx - dx;
        y2 := cy + dy - halfradius;
        line(delay,x1,y1,x2,y2,black); (* right half-disk *)

        x1 := x0;
        y1 := y0;
        x2 := cx + dx;
        y2 := cy + dy + halfradius;

        line (delay,x1,y1,x2,y2,black); (* left teardrop *)
        (* //XDS ??? Graph.Update(); *)
    END;

    x1 := cx;
    y1 := cy - halfradius;
    disc(FALSE,x1,y1, smallradius, white,delay);

    x1 := cx;
    y1 := cy + halfradius;
    disc(FALSE,x1,y1, smallradius, black,delay);

    WHILE IO.KeyPressed() DO
        ch:=IO.RdKey();IF ch=CHR(0) THEN ch:=IO.RdKey();END;
    END;

    pause:=0;
    LOOP
        (* retrace(); *)
	doDelay(1);
        IF IO.KeyPressed() THEN
            ch:=IO.RdKey();IF ch=CHR(0) THEN ch:=IO.RdKey();END;
            EXIT;
        END;
        INC(pause);
        IF pause >= maxpause THEN EXIT; END;
    END;
    rc:=Graph.SetVideoMode(tmode);
    (* Lib.SetReturnCode(0); *)
    HALT (0);
END YingYang32.

