(* ---------------------------------------------------------------
Title         Q&D Theme
Author        PhG
Overview      calc essential data
Usage         see help
Notes         very, very, very quick & dirty... :-(
Bugs
Wish List

--------------------------------------------------------------- *)

MODULE Theme;

IMPORT FIO;
IMPORT Str;
IMPORT Lib;

FROM QD_Box IMPORT str80, str2, str16, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, chkJoker,
isOption, GetOptIndex, GetLongCard, GetString, CharCount, same, cleantabs,
aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
cmdSHOW, str1024, Elapsed, getStrIndex,pathtype;

FROM QD_Sky IMPORT int, frac, mod, DateToJD, JDtoDate, JDtoJD0H,
JDtoWeekday, JDtoT, isDigit, MatchFormat, getLastCard, stripCard,
getCard, parseDate, parseTime, parseLongitude, DateTimeToJD,
CalcBornes, chkZoneFR, ToggleSign, parseLatitude, parseDeltaTU,
DateToStr, TimeToStr, themeFile, themeID, themetype, displayfmt,
AngleToStr, isDirect, loadTheme, saveTheme,
clearThemeData,rangeWarning,minYear,maxYear,
real2str, card2str;

FROM QD_Make IMPORT MAJOR, MINOR;

FROM QD_Calc IMPORT Calc, InitCalc, calcmode, objet, cuspide, sens,
domificationtype, solarsystemtype,housetype,skypos, InitCalcLocal,
CalcDomification, CalcTrueHouse, CalcAzimutAltitude, enginetype,
CALCENGINE, firstDomSystem, lastDomSystem, firstCusp, lastCusp;

FROM QD_Names IMPORT getObjectAbrev, ProgCopyright, sPGMAGIC;

IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)


CONST
    ProgEXEname   = "THEME";
    ProgTitle     = "Q&D Thme (Win32)";
    ProgVersion   = "v0.9 (v1.2e DOS)";
    ProgBanner    = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extEXE        = ".EXE"; (* upper case *)
    extTHM        = ".TM";
    RELOCATE      = "RELOC.BAT";
    (* next two cannot be in command line, at least not before eventual infos *)
    placeholderPhi   = "?";
    placeholderLambda= "*";
CONST
    errNone              = 0;
    errHelp              = 1;
    errOption            = 2;
    errMissingDate       = 3; (* cannot happen ! *)
    errMissingTime       = 4;
    errMissingDeltaTU    = 5;
    errMissingLatitude   = 6;
    errMissingLongitude  = 7;
    errMissingDatafile   = 8;
    errDateFmt           = 9;
    errTimeFmt           = 10;
    errDeltaTUFmt        = 11;
    errLatitudeFmt       = 12;
    errLongitudeFmt      = 13;
    errBadName           = 14;
    errExists            = 15;
    errReadOnly          = 16;
    errParmOverflow      = 17;
    errRenseignements    = 18;
    errEitherOorR        = 19;
    errRenameFailure     = 20; (* extremely unlikely... *)
    errPullenBadName     = 21;
    errPullenNotFound    = 22;
    errPullenFormat      = 23;
    errPullenData        = 24;
    errBadIncrement      = 25;
    errRelocateNonsense  = 26;
    errOneOrTheOther     = 27;

    errAborted       = 253;

VAR
    DEBUG         : BOOLEAN;
CONST
    nullchar    = CHR(0);
    semicolon   = ";";
    pound       = "#";
    openbracket = "[";
    closebracket= "]";
    quote       = "'";
    doublequote = '"';
    blank       = " ";
    tab         = CHR(9);
    coma        = ",";
    dash        = "-";
    slash       = "/";
    bar         = "|";
    underbar    = "_";
    dollar      = "$";
    antislash   = "\";
    dquote      = doublequote; (* for argc() and argv() which should be in QD_Box ! *)
    ansimarker  = 033C+ 135C; (* //XDS CHR(27)+"["; *)
CONST
    codeParis      = "P";
    codeLocal      = "L";
    msgWarn        = "Attention ! Par prcaution, recommencez en indiquant aussi la longitude !";
    smalldelay     = LONGREAL(0.25); (* 6 hours in days for motion calc *)
    pleasewait     = "Patience, calculs en cours... Temps coul : ";
    pleasewaitReloc= "Patience, gnration du fichier "+RELOCATE+" en cours... Temps coul : ";

(* ------------------------------------------------------------ *)

PROCEDURE eyeCandy(cmd:CARDINAL);
BEGIN
    Elapsed(cmd);
END eyeCandy;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    nl     = 015C + 012C; (* //XDS CHR(13)+CHR(10); *)
VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        (*
               00000000011111111112222222222333333333344444444445555555555666666666677777777778
               1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
        *)
        WrLn;
        WrStr("Titre   : "+ProgBanner+nl);
        WrLn;
        WrStr("Syntaxe : "+ProgEXEname+" <date> <heure lgale> <correction horaire>"+nl);
        WrStr("          <latitude> <longitude> <fichier["+extTHM+"]> [renseignements] [option]..."+nl);
        WrLn;
        WrStr("Utilit : calcul des positions plantaires et domifications"+nl);
        CASE CALCENGINE OF
        | vsop87 :
        WrStr("          (thorie Bretagnon et Francou, VSOP87)"+nl);
        | flandern:
        WrStr("          (thorie Van Flandern et Pulkkinen, 1979)"+nl);
        | de404:
        WrStr("          (thorie DE404 du Jet Propulsion Laboratory, 1995)"+nl);
        ELSE ; (* //ISO fixed silly requirement *) END;
        WrLn;
        WrStr("Options : /o pour remplacer l'ventuel fichier existant"+nl);
        WrStr("          /r pour renommer automatiquement le fichier s'il existe dj"+nl);
        WrStr("          /u pour ignorer la restriction  l'intervalle [1600..2200]"+nl);
        WrStr("          /i:$ pour importer les positions plantaires calcules par Astrolog"+nl);
        WrStr("          /f:$ pour utiliser les positions plantaires calcules par Astrolog"+nl);
        WrStr("          /la:# pour spcifier l'intervalle de relocalisation en latitude"+nl);
        WrStr("          /lo:# pour spcifier l'intervalle de relocalisation en longitude"+nl);
        WrLn;
        WrStr("Note 1  : L = correction locale (longitude), P = correction pour Paris."+nl);
        WrStr("Note 2  : Les renseignements (ville,pays,nom,genre,remarque) sont regroups"+nl);
        WrStr("          dans une chane. Le sparateur doit appartenir  l'ensemble ["+coma+semicolon+underbar+slash+dollar+antislash+"]."+nl);
        WrStr("          Les ventuels prnoms doivent prcder le nom de famille."+nl);
        WrStr("Note 3  : L'option /i:$ importe les donnes d'Astrolog au terme des calculs,"+nl);
        WrStr("          quand l'option /f:$ les utilise partiellement pendant les calculs."+nl);
        WrStr("          Les thmes crs avec ces options sont destins au seul affichage !"+nl);
        WrStr("          Le fichier contenant les donnes  importer aura t gnr ainsi :"+nl);
        WrStr('          par "File/Save Chart Text Output..." (Astrolog 5.40 pour Windows),'+nl);
        WrStr('          par "File/Save Chart Positions..." (Astrolog 5.40 pour Windows), ou'+nl);
        WrStr('          par "ASTROLOG /i data > results" (Astrolog 5.40 pour DOS).'+nl);
        WrStr("Note 4  : Les options /la:# et /lo:# gnrent, en plus du fichier "+extTHM+","+nl);
        WrStr("          un fichier "+RELOCATE+" qui permet de crer les thmes relocaliss."+nl);
        WrStr("          Au moins un intervalle de relocalisation doit tre diffrent de 0."+nl);
        WrStr("          L'usage du Temps Universel est fortement recommand."+nl);
        WrStr("          Un ventuel fichier "+RELOCATE+" existant sera remplac."+nl);
        WrLn;
        WrStr("Exemple : "+ProgEXEname+" 20/9/16 7h -1H 45n26 0h17M35e PB "+doublequote+"42,F,PB,H,Philosophe"+doublequote+nl);
    | errOption :
        Str.Concat(S,"L'option ",einfo);
        Str.Append(S," est illgale !");
    | errMissingDate :
        Str.Concat(S,"Les date, heure lgale, correction, latitude, longitude et fichier",nl); (* horaire was too long ! *)
        Str.Append(S,"sont indispensables !");
    | errMissingTime :
        Str.Concat(S,"Les heure lgale, correction horaire, latitude, longitude et fichier",nl);
        Str.Append(S,"sont indispensables !");
    | errMissingDeltaTU:
        Str.Concat(S,"Les correction horaire, latitude, longitude et fichier",nl);
        Str.Append(S,"sont indispensables !");
    | errMissingLatitude :
        S := "Les latitude, longitude et fichier sont indispensables !";
    | errMissingLongitude :
        S := "Les longitude et fichier sont indispensables !";
    | errMissingDatafile  :
        S := "Le fichier est indispensable !";
    | errDateFmt        :
        S := "La date est incorrecte !";
    | errTimeFmt        :
        S := "L'heure est incorrecte !";
    | errDeltaTUFmt     :
        S := "La correction horaire est incorrecte !";
    | errLatitudeFmt    :
        S := "La latitude est incorrecte !";
    | errLongitudeFmt   :
        S := "La longitude est incorrecte !";
    | errBadName :
        Str.Concat(S,"Le nom de fichier (",einfo);
        Str.Append(S,") est incorrect !");
    | errExists :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") existe dj !");
    | errReadOnly :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") est protg contre l'criture !");
    | errParmOverflow :
        Str.Concat(S,"Le paramtre ",einfo);
        Str.Append(S," est de trop !");
    | errRenseignements :
        S :="Les renseignements ne semblent pas au format attendu !";
    | errEitherOorR:
        S :="Les options /o et /r sont mutuellement exclusives !";
    | errRenameFailure:
        S:="Impossible de trouver un nouveau nom pour le fichier !";
    | errPullenBadName :
        Str.Concat(S,"Le nom de fichier (",einfo);
        Str.Append(S,") est incorrect !");
    | errPullenNotFound :
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") n'existe pas !");
    | errPullenFormat:
        Str.Concat(S,"Le fichier (",einfo);
        Str.Append(S,") ne semble pas avoir t cr par Astrolog !");
    | errPullenData:
        Str.Concat(S,"Les donnes du fichier (",einfo);
        Str.Append(S,") semblent incompltes !");
    | errBadIncrement:
        Str.Concat(S,"La valeur de l'intervalle (",einfo);
        Str.Append(S,") est illgale !");
    | errRelocateNonsense:
        S := "Au moins un intervalle de relocalisation doit tre diffrent de 0 !";
    | errOneOrTheOther:
        S := "L'importation et la relocalisation sont mutuellement exclusives !";

    | errAborted :
        S := "Interruption du programme ! Sage dcision avec Windows ! ;-)";


    ELSE
        S := "This is illogical, Captain !";
    END;
    IF (e <> errNone) AND (e <> errHelp) THEN
        WrLn;
        WrStr(ProgEXEname+" : ");
        WrStr(S);
        WrLn;
    END;


    (* //XDS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we use VAR as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    char     : CHAR;
    code     : CARDINAL;
    arg      : str128;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        char := cli[cliPos-1];
        code := ORD(char);
        CASE state OF
        | empty :
            IF code = ORD(dquote) THEN
                state := instring;        (* begin new string *)
                Str.Copy(arg,char);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* dquote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,char);
                INC(argCount);
            END;
        | intoken :
            IF code = ORD(dquote) THEN     (* dquote in token *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,char);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,char);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = ORD(dquote) THEN
                Str.Append(arg,char);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,char);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    char     : CHAR;
    code     : CARDINAL;
    arg      : str128;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        char := cli[cliPos-1];
        code := ORD(char);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF code = ORD(dquote) THEN
                state := instring;        (* begin new string *)
                Str.Copy(arg,char);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* dquote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,char);
                INC(argCount);
            END;
        | intoken :
            IF code = ORD(dquote) THEN     (* dquote in token *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,char);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,char);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = ORD(dquote) THEN
                Str.Append(arg,char);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,char);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType    = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBuffer        : ioBufferType;

(* ------------------------------------------------------------ *)

(*

theme 21/12/31 17h00 0h 48n50 2e20 /i:debord.win win
theme 21/12/31 17h00 0h 48n50 2e20 /i:debord.dos dos
theme 21/12/31 17h00 0h 48n50 2e20 /i:debord.oem oem

*)

(*

((( samples edited to keep only what we need )))

gag : the Windows version is buggy : signs for betas are wrong !


((( Astrolog 5.50 for DOS : ASTROLOG /i datafile > results )))

Astrolog 5.40 chart for Guy Debord
Mon Dec 28, 1931  5:00pm (ST +0:00 GMT) Paris   2:20E 48:50N
Body  Locat. Ret. Lati.
Sun :  6Cap00   + 0:00'
Moon: 22Leo41   + 3:03'
Merc: 20Sag50 R + 3:07'
Venu:  3Aqu35   - 1:43'
Mars: 14Cap12   - 0:58'
Jupi: 22Leo03 R + 0:52'
Satu: 23Cap22   - 0:05'
Uran: 15Ari27   - 0:39'
Nept:  7Vir54 R + 0:46'
Plut: 21Can23 R + 0:31'
0         1         2
01234567890123456789012
===   --===--   x-- --

((( Astrolog 5.40 for Windows : File/Save Chart Text Output... )))
((( escape was converted TO "[" here )))

[[1;37mAstrolog 5.40 chart for Guy Debord
Mon 28-12-1931 17:00 (ST +0:00 GMT) Paris   220E 4850N
[[1;30mBody  Locat. Ret. Lati. Rul.      House  Rul. Veloc.    Placidus Houses.
[[1;31mSun : [[1;33m 6Cap00[[0m   + 000'
[[1;34mMoon: [[1;31m22Leo41[[0m   + 303'
[[1;32mMerc: [[1;31m20Sag50[[0m R + 307'
[[1;32mVenu: [[1;32m 3Aqu35[[0m   - 143'
[[1;31mMars: [[1;33m14Cap12[[0m   - 058'
[[1;31mJupi: [[1;31m22Leo03[[0m R + 052'
[[1;33mSatu: [[1;33m23Cap22[[0m   - 005'
[[1;32mUran: [[1;31m15Ari27[[0m   - 039'
[[1;34mNept: [[1;33m 7Vir54[[0m R + 046'
[[1;34mPlut: [[1;34m21Can23[[0m R + 031'
0         1         2         3         4
01234567890123456789012345678901234567890
       ===          --===--       x-- --

((( Astrolog 5.40 for Windows : File/Save Chart Positions... : bugged ! )))

@0203  ; Astrolog chart positions.
/zi "Guy Debord" "Paris"
/YF Sun:  6 Cap  0.349410904,   0  0.000000000,
/YF Moo: 22 Leo 41.435997867,   3  2.757318231,
/YF Mer: 20 Sag 49.810197397,   3  6.518028903,
/YF Ven:  3 Aqu 35.004158937,  -1 42.772929389,
/YF Mar: 14 Cap 12.363503467,   0 57.659776146,
/YF Jup: 22 Leo  3.010838608,   0 51.712890978,
/YF Sat: 23 Cap 22.426582241,   0  4.725574919,
/YF Ura: 15 Ari 26.548243343,   0 38.544788755,
/YF Nep:  7 Vir 54.078103005,   0 46.145273637,
/YF Plu: 21 Can 23.037783010,   0 30.743749773,
 1   2    3  4        5         6       7

*)

(* minimalist ! *)

TYPE
    pullenfmttype = (dosfmt,ansifmt,winfmt,unknownfmt);

PROCEDURE chkPullenFormat (F:ARRAY OF CHAR):pullenfmttype;
CONST
    (* always remember trailing star ! *)
    patternANSI = ansimarker+"*ASTROLOG*CHART*FOR*";  (* text output, with ansi sequences *)
    patternWIN  = "@*;*ASTROLOG*CHART*";              (* positions, bugged *)
    patternDOS  = "ASTROLOG*CHART*FOR*";              (* raw DOS *)
VAR
    hnd  : FIO.File;
    S    : str128;
BEGIN
    hnd:=FIO.OpenRead(F);
    FIO.RdStr(hnd,S);
    FIO.Close(hnd);
    UpperCase(S);
    IF Str.Match(S,patternANSI) THEN
        RETURN ansifmt;
    END;
    IF Str.Match(S,patternWIN) THEN
        RETURN winfmt;
    END;
    IF Str.Match(S,patternDOS) THEN
        RETURN dosfmt;
    END;
    RETURN unknownfmt;
END chkPullenFormat;

TYPE
    pullenskypos = RECORD (* longreals as in skypos, check QD_CALC.DEF *)
        lambda : LONGREAL;
        beta   : LONGREAL;
        gotem  : BOOLEAN;
    END;
VAR
    pullensolarsystem : ARRAY [ORD(soleil)..ORD(pluton)] OF pullenskypos;

PROCEDURE readPullenData (pullenfmt:pullenfmttype; F:ARRAY OF CHAR):BOOLEAN;
CONST
    (* build from DATA.C *)
    sBodies="SUN,MOO,MER,VEN,MAR,JUP,SAT,URA,NEP,PLU"; (* objet in QD_Calc *)
    sSigns ="ARI,TAU,GEM,CAN,LEO,VIR,LIB,SCO,SAG,CAP,AQU,PIS"; (* signtype in QD_Names *)
VAR
    hnd : FIO.File;
    S   : str128;
    i,j,ndxp,ndxs : CARDINAL;
    body,sign,sdd,smm:str16;
    dd,mm:LONGREAL;
    ok,negative:BOOLEAN;
BEGIN
    FOR i:=ORD(soleil) TO ORD(pluton) DO
        pullensolarsystem[i].gotem:=FALSE;
    END;
    hnd:=FIO.OpenRead(F);
    FIO.AssignBuffer(hnd,ioBuffer);
    CASE pullenfmt OF
    | dosfmt : j:=3;
    | ansifmt: j:=3;
    | winfmt : j:=2;
    ELSE ; (* //ISO fixed silly requirement *) END;
    FOR i:=1 TO j DO
        FIO.RdStr(hnd,S); (* skip header *)
    END;
    FOR i:=ORD(soleil) TO ORD(pluton) DO
        FIO.RdStr(hnd,S);
        UpperCase(S);
        CASE pullenfmt OF
        | dosfmt:
            Str.Slice(body, S, 0,3);
            Str.Slice(sign, S, 8,3);
        | ansifmt:
            Str.Slice(body, S, 7,3);
            Str.Slice(sign, S,22,3);
        | winfmt:
            argv(body,  S, 2, TRUE); ReplaceChar(body,":",""); (* or body[3]=CHR(0) *)
            argv(sign,  S, 4, TRUE);
        ELSE ; (* //ISO fixed silly requirement *) END;
        ndxp:=getStrIndex (","  , body, sBodies);
        ndxs:=getStrIndex (","  , sign, sSigns );
        IF ( (ndxp > 0) AND (ndxs > 0) ) THEN
            ndxp:=ORD(soleil)+ndxp-1;
            CASE pullenfmt OF
            | dosfmt:
                Str.Slice(sdd, S, 6,2); ReplaceChar(sdd," " , "");
                Str.Slice(smm, S,11,2); ReplaceChar(smm," " , "");
            | ansifmt:
                Str.Slice(sdd, S,20,2); ReplaceChar(sdd," " , "");
                Str.Slice(smm, S,25,2); ReplaceChar(smm," " , "");
            | winfmt:
                argv(sdd , S, 3, TRUE);
                argv(smm , S, 5, TRUE); ReplaceChar(smm,"," , "");
            ELSE ; (* //ISO fixed silly requirement *) END;
            dd:=Str.StrToReal(sdd,ok);
            mm:=Str.StrToReal(smm,ok);
            j :=(ndxs-1) * 30;
            pullensolarsystem[ndxp].lambda := LONGREAL(j)+dd+(mm/60.0);

            CASE pullenfmt OF
            | dosfmt:
                Str.Slice(sdd, S,17,2); ReplaceChar(sdd," " , "");
                Str.Slice(smm, S,20,2); ReplaceChar(smm," " , "");
                (* keeping sign of "- 0" was, well..., er... <g> *)
                IF S[16]="-" THEN
                    negative:=TRUE;
                ELSE
                    negative:=FALSE; (* assume "+" or " " *)
                END;
            | ansifmt:
                Str.Slice(sdd, S,35,2); ReplaceChar(sdd," " , "");
                Str.Slice(smm, S,38,2); ReplaceChar(smm," " , "");
                (* keeping sign of "- 0" was, well..., er... <g> *)
                IF S[34]="-" THEN
                    negative:=TRUE;
                ELSE
                    negative:=FALSE; (* assume "+" or " " *)
                END;
            | winfmt:
                argv(sdd , S, 6, TRUE);
                argv(smm , S, 7, TRUE); ReplaceChar(smm,",","");
                IF Str.CharPos(sdd,"-") # MAX(CARDINAL) THEN
                    ReplaceChar(sdd,"-" , "");
                    ReplaceChar(sdd," " , ""); (* eh... *)
                    negative:=TRUE;
                ELSE
                    negative:=FALSE;
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;
            dd:=Str.StrToReal(sdd,ok);
            mm:=Str.StrToReal(smm,ok);
            IF negative THEN
                pullensolarsystem[ndxp].beta:=-( dd +(mm/60.0));
            ELSE
                pullensolarsystem[ndxp].beta:=   dd +(mm/60.0) ;
            END;
            pullensolarsystem[ndxp].gotem:=TRUE;
        END;
    END;
    FIO.Close(hnd);

    FOR i:=ORD(soleil) TO ORD(pluton) DO
        IF pullensolarsystem[i].gotem=FALSE THEN RETURN FALSE; END;
    END;
    RETURN TRUE;
END readPullenData;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE newname (VAR S : ARRAY OF CHAR):BOOLEAN ;
CONST
    maxtries = 999;
    maxf8    = 8;
VAR
    u,d,n,e  : str128;
    newfile  : str128;
    i        : LONGCARD;
    num,f8   : str16;
    ok       : BOOLEAN;
    len      : CARDINAL;
BEGIN
    Lib.SplitAllPath(S,u,d,n,e);
    len:=Str.Length(n);
    i:=0;
    LOOP
        Str.CardToStr(i,num,10,ok);
        WHILE (len+Str.Length(num)) > maxf8 DO
            Str.Delete(n,len-1,1); (* delete last char of name *)
            DEC(len);
        END;
        Str.Concat(f8,n,num); (* build new name *)
        Lib.MakeAllPath(newfile,u,d,f8,e);
        IF FIO.Exists(newfile)=FALSE THEN
            Str.Copy(S,newfile);
            RETURN TRUE;
        END;
        INC(i);
        IF i > maxtries THEN EXIT; END;
    END;
    RETURN FALSE;
END newname;

(* ------------------------------------------------------------ *)

PROCEDURE chkFile (ext:ARRAY OF CHAR;VAR S:ARRAY OF CHAR  ) : BOOLEAN;
VAR
    u,d,n,e:str128;
BEGIN
    CASE CharCount(S,".") OF
    | 0 :
        Str.Append(S,ext);
    | 1 :
        (* nada *)
    ELSE
        RETURN FALSE;
    END;
    IF chkJoker(S) THEN RETURN FALSE; END;
    Lib.SplitAllPath(S,u,d,n,e);
    (* either we say ERROR or we silently truncate *)

    IF Str.Length(n) > 8 THEN RETURN FALSE; END;
    IF Str.Length(e) > (1+3) THEN RETURN FALSE; END;
(*
    IF Str.Length(n) > 8 THEN
        n[8]:=CHR(0);
    END;
    IF Str.Length(e) > (1+3) THEN
        e[1+3]:=CHR(0);
    END;
    Lib.MakeAllPath(S,u,d,n,e);
*)
    RETURN TRUE;
END chkFile;

(*
    eh eh... y'a quand mme des manires plus lgantes de faire
    cette esquisse d'amorce de commencement de dbut de prolgomnes 
    une vrification sommaire ! ;-)
*)

PROCEDURE chkInfos (unsafe,pullendata,relocate:BOOLEAN;
                    VAR S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    Ltrim(S,doublequote);
    Rtrim(S,doublequote);
    LtrimBlanks(S);
    LtrimBlanks(S);
    IF (CharCount(S,coma) # 4) AND
       (CharCount(S,semicolon) # 4) AND
       (CharCount(S,underbar) # 4) AND
       (CharCount(S,slash) # 4) AND
       (CharCount(S,dollar) # 4) AND
       (CharCount(S,antislash) # 4) THEN
       RETURN FALSE;
    END;
    (* yes, we already have unsafenatal for that ! *)
    IF unsafe THEN
       Str.Append(S," (UNSAFE !)"); (* avoid ",;_/$\" set *)
    END;
    IF pullendata THEN
       Str.Append(S," (8-ung !)");
    END;
    IF relocate THEN
       Str.Append(S," (++ !)");
    END;
    RETURN TRUE;
END chkInfos;

(* ------------------------------------------------------------ *)

PROCEDURE getRelocIncrement (minval,maxval:CARDINAL;S:ARRAY OF CHAR;
                        VAR i:CARDINAL) : BOOLEAN;
VAR
    ok:BOOLEAN;
    lc:LONGCARD;
BEGIN
    IF GetLongCard(S,lc)=FALSE THEN RETURN FALSE; END;
    IF lc < LONGCARD(minval) THEN RETURN FALSE; END;
    IF lc > LONGCARD(maxval) THEN RETURN FALSE; END;
    i:=CARDINAL(lc);
    RETURN TRUE;
END getRelocIncrement;

PROCEDURE dmpnl (hndout:FIO.File; S:ARRAY OF CHAR);
BEGIN
    FIO.WrStr(hndout,S);FIO.WrLn(hndout);
END dmpnl;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    opt       : CARDINAL;
    S,R       : pathtype; (* useless to try and enlarge this 128 chars command line : DOS rules ! :-( *)
    state     : (waiting,
                 gotDate,gotTime,gotDeltaTU,gotLatitude,gotLongitude,
                 gotDatafile,gotInfos);
    date      : str128;
    time      : str128;
    deltaTU   : str128;
    latitude  : str128;
    longitude : str128;
    datafile  : pathtype;
    pullenfile: pathtype;
    pullenfmt : pullenfmttype;
    justimport: BOOLEAN;

    relocate  : BOOLEAN;
    iphi      : CARDINAL;
    ilambda   : CARDINAL;
    phireloc  : str16;
    lambdareloc:str16;
    plusphi,pluslambda:str16;
    vdeg      : LONGREAL;
    x,y       : CARDINAL;
    suffix    : CHAR;

    renseignements : str1024; (* to allow later patch of these infos by an external program *)
    day,month,year : CARDINAL;
    hh,mm          : CARDINAL;
    phiDeg         : LONGREAL;
    phiSec         : LONGINT;
    lambdaDeg      : LONGREAL;
    lambdaSec      : LONGINT;
    overwrite      : BOOLEAN;
    autorename     : BOOLEAN;
    pullendata     : BOOLEAN;
    deltaDays      : LONGREAL;
    useLocal       : BOOLEAN;
    jd             : LONGREAL;

    themenatal     : themeFile;

    flagIgnoreRangeLimits:BOOLEAN;

    before,after   : skypos;
    motion         : sens;
    hnd            : FIO.File;
    hashedserialnum: CARDINAL;

    firsttime : BOOLEAN;

BEGIN
    (* //XDS Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    DEBUG := FALSE;

    renseignements := "?,?,?,?,?"; (* ville,pays,nom,genre,info : unknown ! *)
    overwrite  := FALSE;
    autorename := FALSE;
    pullendata := FALSE; (* must be initialized ! *)
    flagIgnoreRangeLimits:=FALSE;
    relocate   := FALSE;
    iphi       := 0;
    ilambda    := 0;

    hashedserialnum:=0FFFFH; (* default when no serial number enabled *)

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,""); END;

    state:=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF (isOption(R)=TRUE) AND (state#gotTime) THEN (* (R[0] # dash) THEN (* hey ! keep minus sign ! *) *)
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "DEBUG"+delim+
                                 "O"+delim+"OVERWRITE"+delim+
                                 "R"+delim+"RENAME"+delim+
                                 "U"+delim+"UNSAFE"+delim+
                                 "F:"+delim+"FILE:"+delim+
                                 "I:"+delim+"IMPORT:"+delim+
                                 "LA:"+delim+"PHI:"+delim+
                                 "LO:"+delim+"LAMBDA:"
                                 );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4 :
                DEBUG := TRUE;
            | 5,6 :
                overwrite := TRUE;
            | 7,8 :
                autorename:= TRUE;
            | 9,10:
                flagIgnoreRangeLimits:=TRUE;
            | 11,12:
                GetString(S,pullenfile);
                pullendata:=TRUE;
                justimport:=FALSE; (* we'll use imported lambda/beta while computing ! *)
            | 13,14:
                GetString(S,pullenfile);
                pullendata:=TRUE;
                justimport:=TRUE;  (* after computations, we'll replace our values with Pullen's ones : safest ! *)
            | 15,16:
                IF getRelocIncrement(0,45,R,iphi)=FALSE THEN abort(errBadIncrement,S);END;
                relocate := TRUE;
            | 17,18:
                IF getRelocIncrement(0,45,R,ilambda)=FALSE THEN abort(errBadIncrement,S);END;
                relocate := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Copy(date,S);      (* state := gotDate; *)
            | gotDate :
                Str.Copy(time,S);      (* state := gotTime; *)
            | gotTime :
                Str.Copy(deltaTU,S);   (* state := gotDeltaTU; *)
            | gotDeltaTU :
                Str.Copy(latitude,S);  (* state := gotLatitude; *)
            | gotLatitude :
                Str.Copy(longitude,S); (* state := gotLongitude; *)
            | gotLongitude :
                Str.Copy(datafile,R); (* keep uppercase *) (* state := gotDatafile; *)
            | gotDatafile : (* optional *)
                Str.Copy(renseignements,S); (* state := gotInfos; *)
            | gotInfos :
                abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting :
        abort(errMissingDate,""); (* could be errHelp *)
    | gotDate :
        abort(errMissingTime,""); (* could be errHelp *)
    | gotTime :
        abort(errMissingDeltaTU,""); (* could be errHelp *)
    | gotDeltaTU :
        abort(errMissingLatitude,""); (* could be errHelp *)
    | gotLatitude :
        abort(errMissingLongitude,""); (* could be errHelp *)
    | gotLongitude :
        abort(errMissingDatafile,""); (* could be errHelp *)
    ELSE ; (* //ISO fixed silly requirement *) END;
    (* gotDataFile or gotInfos ok *)
    IF overwrite AND autorename THEN abort(errEitherOorR,"");END;

    IF parseDate(flagIgnoreRangeLimits,date,day,month,year)=FALSE THEN abort(errDateFmt,""); END;
    IF parseTime(time,hh,mm)=FALSE THEN abort(errTimeFmt,""); END;
    IF parseDeltaTU(deltaTU,deltaDays,useLocal)=FALSE THEN abort(errDeltaTUFmt,""); END;
    IF parseLatitude(latitude,phiDeg,phiSec)=FALSE THEN abort(errLatitudeFmt,""); END;
    IF parseLongitude(longitude,lambdaDeg,lambdaSec)=FALSE THEN abort(errLongitudeFmt,""); END;
    (* now we can use useLocal with a checked longitude *)
    IF useLocal THEN deltaDays:=lambdaDeg / 360.0; END;

    (* now check datafile *)
    IF chkFile(extTHM,datafile)=FALSE THEN abort(errBadName,datafile); END;
    IF FIO.Exists(datafile) THEN
        CASE overwrite OF
        | FALSE :
            IF autorename THEN
                IF newname(datafile)=FALSE THEN
                    abort(errRenameFailure,datafile);
                END;
            ELSE
                abort(errExists,datafile);
            END;
        | TRUE :
            IF isReadOnly(datafile) THEN abort(errReadOnly,datafile);END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    (* at last... *)
    IF chkInfos(flagIgnoreRangeLimits,pullendata,relocate,renseignements)=FALSE THEN
        abort(errRenseignements,"");
    END;

    IF pullendata THEN
        IF relocate THEN abort(errOneOrTheOther,"");END;

        IF chkFile("",pullenfile)=FALSE THEN abort(errPullenBadName,pullenfile);END;
        IF FIO.Exists(pullenfile)=FALSE THEN abort(errPullenNotFound,pullenfile);END;
        pullenfmt := chkPullenFormat(pullenfile);
        IF pullenfmt=unknownfmt THEN abort(errPullenFormat,pullenfile);END;
        IF readPullenData(pullenfmt,pullenfile)=FALSE THEN abort(errPullenData,pullenfile);END;
    END;

    IF relocate THEN
        IF pullendata THEN abort(errOneOrTheOther,"");END;
        IF ((iphi=0) AND (ilambda=0)) THEN abort(errRelocateNonsense,"");END;
    END;

    rangeWarning(flagIgnoreRangeLimits,1,0);

    WrLn;
    WrStr(ProgBanner);
    WrLn;


  video(pleasewait,TRUE);
  eyeCandy(cmdInit);
  eyeCandy(cmdSHOW);

    (* ------------------------------------------------------------ *)

    clearThemeData(themenatal);

    jd:=DateTimeToJD(day,month,year,hh,mm)+deltaDays;

    InitCalc(jd,full); (* first of all ! soleil IS computed here for later needs *)
    FOR i := ORD(soleil) TO ORD(pluton) DO
  eyeCandy(cmdSHOW);
        Calc(VAL(objet,i), themenatal.planete[i], full); (* full for possible later use *)
    END;

IF (pullendata AND (justimport=FALSE)) THEN
    FOR i := ORD(soleil) TO ORD(pluton) DO
  eyeCandy(cmdSHOW);
        themenatal.planete[i].lambda:=pullensolarsystem[i].lambda;
        themenatal.planete[i].beta  :=pullensolarsystem[i].beta;
    END;
END;

    (* then compute fictitious sillies just in case *)

    FOR i := ORD(lilith) TO ORD(blacksun) DO
  eyeCandy(cmdSHOW);
        Calc(VAL(objet,i), themenatal.planete[i], partial); (* full would be a nonsense here *)
    END;

    (* now calc TSL, required for as mc ds fc domification true house azimut hauteur *)

    themenatal.tsl := InitCalcLocal(jd,phiDeg,lambdaDeg);

    (* now TSL is okay, compute AS MC and DS FC *)

    FOR i := ORD(as) TO ORD(fc) DO
  eyeCandy(cmdSHOW);
        Calc(VAL(objet,i), themenatal.planete[i], full); (* yes,  full to store data about alpha *)
        CalcAzimutAltitude(themenatal.planete[i]); (* required for CARTE local display *)
        themenatal.planete[i].motion := direct; (* motion for angles is always direct *)
    END;

    (* compute domifications *)
  eyeCandy(cmdSHOW);
    FOR i := firstDomSystem TO lastDomSystem DO
        themenatal.domificationFlag[i] := CalcDomification(domificationtype(i),themenatal.maisonData[i]);
    END;

    (* now compute true house, azimut and hauteur assuming previous FULL mode *)

    FOR i := ORD(soleil) TO ORD(pluton) DO
  eyeCandy(cmdSHOW);
        CalcTrueHouse(themenatal.planete[i]);
        CalcAzimutAltitude(themenatal.planete[i]);
    END;

    (* last to be done : compute motion and remember InitCalc changes data ! *)

    FOR i := ORD(soleil) TO ORD(pluton) DO
  eyeCandy(cmdSHOW);
        InitCalc(jd-smalldelay,partial);
        Calc(VAL(objet,i), before, partial);
        InitCalc(jd+smalldelay,partial);     (* one hour after *)
        Calc(VAL(objet,i), after, partial);

        CASE isDirect(before.lambda,themenatal.planete[i].lambda) OF
        | TRUE :
            CASE isDirect(themenatal.planete[i].lambda,after.lambda) OF
            | TRUE  :motion := direct;
            | FALSE :motion := stationretrograde;
            ELSE ; (* //ISO fixed silly requirement *) END;
        | FALSE :
            CASE isDirect(themenatal.planete[i].lambda,after.lambda) OF
            | TRUE  :motion := stationdirect;
            | FALSE :motion := retrograde;
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        themenatal.planete[i].motion := motion;
    END;

    (* well, stupid but... *)

    FOR i := ORD(lilith) TO ORD(blacksun) DO
  eyeCandy(cmdSHOW);
        InitCalc(jd-smalldelay,partial);
        Calc(VAL(objet,i), before, partial);
        InitCalc(jd+smalldelay,partial);     (* one hour after *)
        Calc(VAL(objet,i), after, partial);

        CASE isDirect(before.lambda,themenatal.planete[i].lambda) OF
        | TRUE :
            CASE isDirect(themenatal.planete[i].lambda,after.lambda) OF
            | TRUE  :motion := direct;
            | FALSE :motion := stationretrograde;
            ELSE ; (* //ISO fixed silly requirement *) END;
        | FALSE :
            CASE isDirect(themenatal.planete[i].lambda,after.lambda) OF
            | TRUE  :motion := stationdirect;
            | FALSE :motion := retrograde;
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        themenatal.planete[i].motion := motion;
    END;

IF (pullendata AND justimport) THEN
    FOR i := ORD(soleil) TO ORD(pluton) DO
  eyeCandy(cmdSHOW);
        themenatal.planete[i].lambda:=pullensolarsystem[i].lambda;
        themenatal.planete[i].beta  :=pullensolarsystem[i].beta;
    END;
END;

    (* ------------------------------------------------------------ *)

    (* date$             time$   deltaTU$   latitude$ longitude$ *)
    (* day% month% year% hh% mm% deltaDays# phiDeg#   lambdaDeg# *)
    (* datafile$ renseignements$ *)

    Str.Copy(themenatal.ID,themeID);
    themenatal.major := MAJOR;
    themenatal.minor := MINOR;
    themenatal.serialnumhash:=hashedserialnum;
    Str.Copy(themenatal.odate,date);
    Str.Copy(themenatal.otime,time);
    Str.Copy(themenatal.odeltaTU,deltaTU);
    Str.Copy(themenatal.olatitude,latitude);
    Str.Copy(themenatal.olongitude,longitude);
    Str.Copy(themenatal.orenseignements,renseignements);

IF flagIgnoreRangeLimits THEN
  IF ( (year < minYear) OR (year > maxYear) ) THEN
    themenatal.typeof        := unsafenatal; (* out of legal range ! as we'll never add VSOP87... *)
  ELSE
    themenatal.typeof        := natal;
  END;
ELSE
    themenatal.typeof        := natal;
END;

IF pullendata THEN
    themenatal.typeof        := unsafenatal; (* force it ! *)
END;

    themenatal.deltaDays     := deltaDays;
    themenatal.latitude      := phiDeg;
    themenatal.longitude     := lambdaDeg;
    themenatal.jd            := jd;

    themenatal.reservedUseA := 0;
    themenatal.reservedUseB := 0;

    themenatal.engine := CALCENGINE;

    Str.Copy(themenatal.IDEOF,sPGMAGIC); (* //XDS does not like cast !!! *)
    (*
    themenatal.IDEOF[0] := sPGMAGIC[0];
    themenatal.IDEOF[1] := sPGMAGIC[1];
    *)

    saveTheme(themenatal,datafile);

  eyeCandy(cmdStop);
  video(pleasewait,FALSE);

    WrLn;
    WrStr("Le fichier ");
    WrStr(datafile);
    WrStr(" contient le rsultat des calculs !"); WrLn;

    IF DEBUG THEN

        WrStr(date);WrLn;
        WrStr(time);WrLn;
        WrStr(deltaTU);WrLn;
        WrStr(latitude);WrLn;
        WrStr(longitude);WrLn;
        WrStr(datafile);WrLn;
        WrStr(renseignements);WrLn;
        WrLn;

        DateToStr(day,month,year,S);WrStr(S);WrLn;
        TimeToStr(hh,mm,S);WrStr(S);WrLn;

        AngleToStr(deltaDays*360.0,latDDMM,S);WrStr(S);WrLn;
        AngleToStr(phiDeg,latDDMM,S);WrStr(S);WrLn;
        AngleToStr(lambdaDeg,latDDMM,S);WrStr(S);WrLn;
        AngleToStr(themenatal.tsl,HHMMSS,S);WrStr(S);WrLn;

        FOR i :=ORD(soleil) TO ORD(blacksun) DO
            getObjectAbrev(objet(i),S);
            IF i = ORD(as) THEN WrLn; END;
            IF i = ORD(lilith) THEN WrLn; END;
            WrStr(S);
            WrStr(" alpha ");
            AngleToStr( themenatal.planete[i].alpha, HHMMSS, S);
            WrStr(S);WrStr(" ");

            AngleToStr( themenatal.planete[i].delta, latDDdd, S);
            WrStr(S);WrStr(" ");

            WrStr("l ");
            AngleToStr( themenatal.planete[i].l, DDDdd, S);
            WrStr(S);WrStr(" ");

            AngleToStr( themenatal.planete[i].b, latDDdd, S);
            WrStr(S);WrStr(" ");

            AngleToStr( themenatal.planete[i].r, DDddddd, S);
            WrStr(S);WrStr(" ");

            WrStr("vm ");
            AngleToStr( LONGREAL(themenatal.planete[i].truehouse), DDd, S);
            WrStr(S); WrStr(" ");

            CASE themenatal.planete[i].motion OF
            | direct : S := "-->";
            | retrograde : S := "<--";
            | stationdirect : S := "*>";
            | stationretrograde : S := "<*";
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrStr(S);

            WrLn;
        END;
        WrLn;
        (* only placidus here : after all, TOOLSKY now handles debug exam ! *)
        FOR i := firstCusp TO lastCusp DO
            AngleToStr( themenatal.maisonData[ORD(placidus)][i], DDDMM, S);
            WrStr(S);WrStr("  ");

            AngleToStr( themenatal.maisonData[ORD(placidus)][i], DDDdd, S);
            WrStr(S);WrStr("  ");

            AngleToStr( themenatal.maisonData[ORD(placidus)][i], HHMMSS, S);
            WrStr(S);WrLn;

        END;
        WrLn;
        FOR i :=ORD(soleil) TO ORD(blacksun) DO
            getObjectAbrev(objet(i),S);
            IF i = ORD(as) THEN WrLn; END;
            IF i = ORD(lilith) THEN WrLn; END;
            WrStr(S);
            WrStr(" lambda ");
            AngleToStr( themenatal.planete[i].lambda, DDDMM, S);
            WrStr(S);WrStr(" ");

            AngleToStr( themenatal.planete[i].beta, latDDMM, S);
            WrStr(S);WrStr(" ");

            WrStr("A ");
            AngleToStr( themenatal.planete[i].azimut, DDDMM, S);
            WrStr(S);WrStr(" ");

            AngleToStr( themenatal.planete[i].altitude, latDDMM, S);
            WrStr(S);WrStr(" ");

            WrLn;
        END;
        WrLn;
        FOR i :=ORD(soleil) TO ORD(pluton) DO
            getObjectAbrev(objet(i),S);
            WrStr(S);
            WrStr(" domitude ");
            AngleToStr( themenatal.planete[i].domitude, DDDMM, S);
            WrStr(S);WrStr(" ");

            WrStr("planetary hour ");
            AngleToStr( themenatal.planete[i].planetaryhour, HHMMSS, S);
            WrStr(S);WrStr(" ");

            WrLn;
        END;
        WrLn;

    END;


IF relocate THEN
  video(pleasewaitReloc,TRUE);
  eyeCandy(cmdInit);
  eyeCandy(cmdShow);

    hnd:=FIO.Create(RELOCATE); (* ignore any existing batch *)
    FIO.AssignBuffer(hnd,ioBuffer);

    dmpnl(hnd,"@ECHO OFF");
    dmpnl(hnd,"ECHO.");
    dmpnl(hnd,"ECHO ::: Q&D .THM relocator");
    dmpnl(hnd,"ECHO.");

    plusphi    :=card2str(iphi,2);
    pluslambda :=card2str(ilambda,2);

    Str.Concat(S,"ECHO ::: Chart (automagically renamed)  : ",datafile);
    dmpnl(hnd,S);
    Str.Concat(S,"ECHO ::: Increment applied to latitude  : ",plusphi);Str.Append(S,"");
    dmpnl(hnd,S);
    Str.Concat(S,"ECHO ::: Increment applied to longitude : ",pluslambda);Str.Append(S,"");
    dmpnl(hnd,S);
    dmpnl(hnd,"ECHO.");

    dmpnl(hnd,"ECHO ::: Here is your last chance to hit Ctrl-C or Ctrl-Break ! ;-)");
    dmpnl(hnd,"ECHO.");
    dmpnl(hnd,"PAUSE");

    dmpnl(hnd,"");

    Str.Concat(S,ProgEXEname," -r"); LowerCase(S); (* this option was a GOOD thing ! *)
    IF flagIgnoreRangeLimits THEN Str.Append(S," -u"); END;
    Str.Append(S," "); Str.Append(S,date);
    Str.Append(S," "); Str.Append(S,time);
    Str.Append(S," "); Str.Append(S,deltaTU);
    Str.Append(S," "+placeholderPhi);
    Str.Append(S," "+placeholderLambda);
    Str.Append(S," "); Str.Append(S,datafile);
    IF same(renseignements,"")=FALSE THEN (* chkInfos makes this always false *)
        Str.Append(S," "+doublequote);
        Str.Append(S,renseignements);
        Str.Append(S,doublequote);
    END;
    (*
    phiDeg         : LONGREAL;
    lambdaDeg      : LONGREAL;
    vdeg
    real2str 3,2 N S   E W
    *)

    IF iphi    = 0 THEN iphi    :=180; END; (* -90..+90 *)
    IF ilambda = 0 THEN ilambda :=360; END; (* -180..+180 *)

    y:=0;
    LOOP
  eyeCandy(cmdShow);
        plusphi:=card2str(y,3);
        x:=0;
        LOOP
  eyeCandy(cmdShow);
            pluslambda:=card2str(x,3);

            Str.Copy(R,"REM ");
            Str.Append(R,"phi + "); Str.Append(R,plusphi);Str.Append(R,"");
            Str.Append(R," -- ");
            Str.Append(R,"lambda + "); Str.Append(R,pluslambda);Str.Append(R,"");
            (* dmpnl(hnd,R); *)

            Str.Copy(R,S);

            (* -90..90, -45..135, 0..180, 45..225, 90..270 *)

            vdeg:=phiDeg+LONGREAL(y);
            IF vdeg > 90.0 THEN vdeg:=vdeg-180.0; END;
            IF vdeg < 0.0 THEN
                vdeg:=ABS(vdeg);
                suffix:="s";
            ELSE
                suffix:="n";
            END;
            phireloc    := real2str(vdeg,2,2); Str.Append(phireloc,suffix);
            Str.Subst(R,placeholderPhi,phireloc);

            (* -180..180, -90..270, 0..360, 90..450, 180..540 *)

            vdeg:=lambdaDeg+LONGREAL(x);
            IF vdeg > 180.0 THEN vdeg:=vdeg-360.0; END;
            IF vdeg < 0.0 THEN
                vdeg:=ABS(vdeg);
                suffix:="e";
            ELSE
                suffix:="w";
            END;
            lambdareloc := real2str(vdeg,3,2); Str.Append(lambdareloc,suffix);
            Str.Subst(R,placeholderLambda,lambdareloc);

            dmpnl(hnd,R);

            INC(x,ilambda);
            IF x >= 360 THEN EXIT; END;
        END;
        dmpnl(hnd,"");

        INC(y,iphi);
        IF y >= 180 THEN EXIT; END;
    END;

    dmpnl(hnd,"ECHO.");

    FIO.Flush(hnd);
    FIO.Close(hnd);

  eyeCandy(cmdStop);
  video(pleasewaitReloc,FALSE);

    WrLn;
    WrStr("Le fichier "+RELOCATE);
    WrStr(" permet de gnrer les thmes relocaliss !"); WrLn;

END;

    abort(errNone,"");
END Theme.



(*

set ila=30
set ilo=30

set la=48n50
set lo=0h9m21e

theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat org



set ila=30
set ilo=0

set lo=0h9m21e

set la=90s00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %la%

set la=45s00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %la%

set la=00n00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %la%

set la=45n00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %la%

set la=90n00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %la%



set ila=0
set ilo=30

set la=48n50

set lo=180e00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %lo%

set lo=90e00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %lo%

set lo=00e00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %lo%

set lo=90w00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %lo%

set lo=180w00
theme -o /la:%ila% /lo:%ilo% 28/12/31 17:00 0h %la% %lo% ged "Paris,France,Guy-Ernest Debord,H,subversif officiel"
ren reloc.bat %lo%

set la=
set lo=
set ila=
set ilo=

*)