(* ---------------------------------------------------------------
Title         Q&D Day Month
Author        PhG
Overview
Notes         minimal error messages and checking, etc.
              shamelessly ripped public domain databases found everywhere
              (CDs, Internet, etc.)
              to fix collisions between QD_ASCII and QD_TEXT,
              a few QD_ASCII chars have been remed out
              (they're identical, of course)
              remember isoleItemS() grabs token strings verbatim

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -ni:#
              -np:#
              -hi:#
              -hp:#
              -b
              -k does not force an error but has no effect
              -w[w] does not force an error but has no effect

              see XDS, //XDSTS and //FIXME

              note searching a name containing accents will NOT work in this port :
              anyway, I don't feel like adding character sets conversion here

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs
Wish List     are you kidding ? but well, isn't it already a joke to
              write such a little DOS (f)utility nowadays ? :-(
              find date from event (i.e. name)

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 25 Apr 19 v0.9a try and keep in sync with DOS v1.1l
PhG 24 Dec 17 an ugly really Q&D port from DAYMONTH v1.1j for DOS
--------------------------------------------------------------- *)

MODULE DayMonth32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn,WrChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    str160 = ARRAY [0..160-1] OF CHAR;
CONST
    ProgEXEname   = "DAYMONTH32";
    ProgTitle     = "Q&D Day Month (Win32)";
    ProgVersion   = "v0.9a (from v1.1l for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    DATheader     = "DAYM_"; (* header for data files *)
    sEGO          = "EGO";
    sCAL          = "CAL";   (* pagan *)
    sSAINT        = "KTO";   (* saints such as Martine, eh eh... *)
    extEXE        = ".EXE";
    extDM         = ".DM";   (* normal data *)
    extDMX        = ".DMX";  (* huge data, was ".DM_" *)
    todaymarker   = "*";
    msgWait       = "Hit any key to continue... ";
    kbdmsg        = "Hit any key to continue or Escape to abort... ";
CONST
    newlinemarker    = "\n"; (* tss... *)
    newlinemarkerlen = 2;
    femalemarker     = "!";
    epicenemarker    = equal;
    eventmarker      = "@";
    alsomarker       = dollar;
    comment          = ";";
    rem              = "*";
CONST
    exclamation   = "!";
CONST
    initpagingcounter = 1; (* account for message *)

(* ------------------------------------------------------------ *)

CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParameter        = 3;
    errBadNumber        = 4;
    errInkRange         = 5;
    errPaperRange       = 6;
    errBadDMY           = 7;
    errMissingDate      = 8;
    errMissingFile      = 9;
    errWidthRange       = 10;
    errConflict         = 11;
    errOnlyOneSearch    = 12;
    errEmptySearch      = 13;
    errBadSearch        = 14;
    errAborted          = 64;
    errMoreHelp         = 128;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msgHelp =
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" <"+todaymarker+"|date> [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <-z[z]:$> [-x]"+nl+
nl+
"This program displays any birthday or event which occurred on specified date."+nl+
"The data files should be considered public domain, for they were gathered from"+nl+
"many contradictory and unchecked sources, filled with duplicates and errors."+nl+
nl+
"-n      add a newline (CR+LF) in order to beautify display (useful with PEXEC)"+nl+
"-fr     display date and program texts in French"+nl+
"-s      sort output by year"+nl+
"-nb     ignore birthdays"+nl+
"-nd     ignore deaths"+nl+
"-ne     ignore events"+nl+
"-a      use all entries found (including "+'"b", "d" and "s" prefixes)'+nl+
"-e      personal data only ("+DATheader+sEGO+" required)"+nl+
"-p[p]   pagan calendar ("+DATheader+sCAL+" required, -k ignored)"+nl+
"-m[m]   saints calendar ("+DATheader+sSAINT+" required, -fr forced unless -mm)"+nl+
'-d:$    alternate daily calendar (default extension is "'+extDM+'")'+nl+
"-z[z]:$ show date matching specified string, then terminate ("+DATheader+sSAINT+" required)"+nl+
"-l      add Latin date (-p option only, -pp = -p -l)"+nl+
'-x      use extra huge "'+extDMX+'" files instead of normal "'+extDM+'" files'+nl+
"-f:#    frame type (0=none, 1=single, 2=double, 3=raw), default is 2"+nl+
"-w:#    set line width, default is 79"+nl+ (* //80 *)
"-v      do not force a newline (CR+LF) if line length equals screen width"+nl+
"-??     verbose help, including data file format"+nl+
nl+
"a) Date may be specified as "+dquote+todaymarker+dquote+" for today (system date), or"+nl+
'   as "day-month", "day/month" or "day month", the month being either a number'+nl+
"   in the [1..12] range or the first three letters of its name."+nl+
'b) All "*'+extDM+'" and/or "*'+extDMX+'" files must be located in '+ProgEXEname+extEXE+" directory:"+nl+
"   "+DATheader+"<???|##>"+" for the 12 months, "+DATheader+sEGO+" for personal data (optional), and"+nl+
"   "+DATheader+sCAL+" for pagan data (optional). LFNs are not supported."+nl+
"c) Options irrelevant to selected display will be ignored."+nl+
"d) Note -fr option is not very useful with datafiles in English. ;-)"+nl+
"e) These options were added for Martine : -m[m] (hence the name !) and -z[z]:$."+nl+
"   This is why their display defaults to French for her (-m[m]x = -m[m] -x)."+nl+
"f) -z[z]:$ option ignores any option except -x option (-z[z]x:$ = -z[z]:$ -x)."+nl+
'   Only letters and M2 jokers ("?"=any single char, "*"=sequence) are checked.'+nl+
"   Specified string may be delimited with double quotes."+nl+
"g) For obvious reasons, -x option is a nonsense with -p and -e options."+nl+
"h) Though disabled, -k and -w[w] options of DOS original do not force an error."+nl+
"i) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

    msgMoreHelp=nl+
"(* "+DATheader+"??? and "+DATheader+sEGO+" file format *)"+nl+
nl+
'Lines beginning with ";" are treated as remarks and ignored.'+nl+
'Date format is specified using either "*ddmmyyyy" or "*mmddyyyy".'+nl+
'First character is a code : "B" (birth), "S" (event) or "D" (death).'+nl+
"-a option forces lines beginning with a lower case code to be displayed."+nl+
nl+
"    Example :"+nl+
nl+
"    *mmddyyyy"+nl+
"    S1231     Last day of the year"+nl+
"    *ddmmyyyy"+nl+
"    B19 31928 Patrick McGoohan, acteur"+nl+
nl+
"(* "+DATheader+sCAL+" and -d:$ file format *)"+nl+
nl+
'Lines beginning with ";" are treated as remarks and ignored.'+nl+
'Each line is in "ddmm:text" format (ddmm must be unique).'+nl+
'If dd < 10, a leading "0" is required. "'+newlinemarker+'" stands for a newline.'+nl+
nl+
"    Example :"+nl+
nl+
"    0101:Kalends of January, New Year's Day\n\nNew year's day."+nl+
nl+
"(* "+DATheader+sSAINT+" file format *)"+nl+
nl+
'Lines beginning with ";" are treated as remarks and ignored.'+nl+
'Each line is in "ddmm:<nom>[<,|;> nom]..." format (ddmm must be unique).'+nl+
'If dd < 10, a leading "0" is required. "'+newlinemarker+'" stands for a newline.'+nl+
'Each "nom" may have a prefix or a suffix for these special cases :'+nl+
'"'+femalemarker+'" stands for a female saint, "'+eventmarker+'" for an event,'+nl+
'"'+epicenemarker+'" for an epicene name, '+alsomarker+'" for a celebrated first name.'+nl+
nl+
"    Examples :"+nl+
nl+
"    0101 : @Jour de l'An"+nl+
"    2607 : Anne*=, Joachim"+nl+
"    2903 : Gwladys*, Gladys$"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp :
        WrStr(msgHelp);
        IF e=errMoreHelp THEN
            WrStr(msgMoreHelp);
            e:=errHelp;
        END;
    | errOption :
        Str.Concat(S,"Unknown "+dquote,einfo);Str.Append(S,dquote+" option !");
    | errParameter :
        Str.Concat(S,dquote,einfo);Str.Append(S,dquote+" is just one parameter too many !");
    | errBadNumber:
        Str.Concat(S,"Illegal value in "+dquote,einfo);Str.Append(S,dquote+" option !");
    | errInkRange:
        S := "Ink range is [0..15] !";
    | errPaperRange:
        S := "Paper range is [0..15] !";
    | errBadDMY:
        Str.Concat(S,"Illegal "+dquote,einfo);Str.Append(S,dquote+" date format !");
    | errMissingDate:
        S := "Missing required date parameter !";
    | errMissingFile:
        Str.Concat(S,"Missing "+dquote,einfo);Str.Append(S,dquote+" data file !");
    | errWidthRange:
        S := "Illegal line width !";
    | errConflict:
        Str.Concat(S,einfo," options are mutually exclusive !");
    | errOnlyOneSearch:
        S := "-z[z]:$ option must be unique !";
    | errEmptySearch:
        S := "Specified string for -z[z]:$ option is empty !";
    | errBadSearch:
        S := "Specified string for -z[z]:$ option contains reserved characters !";
    | errAborted:
        S := "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp : ;
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

PROCEDURE dbg (DEBUG:BOOLEAN;S0,S1,S2:ARRAY OF CHAR);
CONST
    DBGHEADER = "// ";
    wiproc = 15;
    wiid   = 20;
VAR
    i:CARDINAL;
    Z:str1024; (* oversized *)
BEGIN
    IF DEBUG THEN
        Str.Concat(Z,DBGHEADER,S0);
        FOR i:=Str.Length(S0)+1 TO wiproc DO Str.Append(Z," ");END;
        Str.Append(Z," : ");
        Str.Append(Z,S1);
        FOR i:=Str.Length(S1)+1 TO wiid   DO Str.Append(Z," ");END;
        Str.Append(Z," = ");
        Str.Append(Z,S2);
        WrStr(Z);WrLn;
    END;
END dbg;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    gregorian calendar rule : leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100
    1900 is common, 2000 is leap
*)

PROCEDURE getDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END getDaysInFebruary;

PROCEDURE getDaysInMonth (mois,annee:INTEGER):INTEGER;
TYPE
    daysinmonthtype = ARRAY [1..12] OF INTEGER;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype{31, 0,31,30,31,30,31,31,30,31,30,31};
VAR
    m : INTEGER;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=getDaysInFebruary(annee);END;
    RETURN m;
END getDaysInMonth;

PROCEDURE latinDate (jour,mois,annee:CARDINAL):str80;
CONST
    calendes = 1;
    nones    = 5;
    ides     = 13;
    veille   = "PRID.";
    sKAL     = "KAL.";
    sNON     = "NON.";
    sID      = "ID.";
CONST
    (* 31-13=18 so go to 20 for safety *)
    countLAT= veille+" III IV V VI VII VIII IX "+
              "X XI XII XIII XIV XV XVI XVII XVIII XIX XX";
    moisLAT = "IAN. FEB. MART. APR. MAI. IUN. "+
              "IUL. AUG. SEPT. OCT. NOV. DEC.";
VAR
    j,m,R:str80;
    v:CARDINAL;
BEGIN
    v:=mois-1;
    Str.ItemS(m,moisLAT," ",v);

    CASE jour OF
    | calendes :
        j:=sKAL;
    | calendes+1..nones-1:
        Str.Prepend(m,sNON);
        v:=(nones-jour)-1;
        Str.ItemS(j,countLAT," ",v);
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
    | nones :
        j:=sNON;
    | nones+1..ides-1 :
        Str.Prepend(m,sID);
        v:=(ides-jour)-1;
        Str.ItemS(j,countLAT," ",v);
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
    | ides :
        j:=sID;
    ELSE
        v:=getDaysInMonth(mois,annee);
        IF v < jour THEN
            j:="???";
        ELSE
            v:=((v+1)-jour)-1;
            Str.ItemS(j,countLAT," ",v);
        END;
        IF same(j,veille)=FALSE THEN Str.Prepend(j,"A.D."); END;
        INC(mois);
        IF mois > 12 THEN mois := 1; END;
        v:=mois-1;
        Str.ItemS(m,moisLAT," ",v);
        Str.Prepend(m,sKAL);
    END;
    IF j[Str.Length(j)-1] # "." THEN Str.Append(j," ");END;
    Str.Concat(R,j,m);
    RETURN R;
END latinDate;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    languagetype = (french,english);
    datetype = RECORD
        day   : CARDINAL;
        month : CARDINAL;
        year  : CARDINAL;
        dayOfWeek  : Lib.DayType;
    END;
    timetype = RECORD
        hours   : CARDINAL;
        minutes : CARDINAL;
        seconds : CARDINAL;
    END;

PROCEDURE getDateNow (VAR d : datetype);
VAR
    dayOfWeek : Lib.DayType;
BEGIN
    Lib.GetDate(d.year,d.month,d.day,d.dayOfWeek);
END getDateNow;

PROCEDURE getTimeNow (VAR t : timetype);
VAR
    hundredth : CARDINAL;
BEGIN
    Lib.GetTime(t.hours,t.minutes,t.seconds,hundredth);
END getTimeNow;

CONST
    Sjours =   "Dimanche Lundi Mardi Mercredi Jeudi Vendredi Samedi";
    Smois  =   "janvier fvrier mars avril mai juin "+
               "juillet aot septembre octobre novembre dcembre";
    SjoursUS = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday";
    SmoisUS  = "January February March April May June "+
               "July August September October November December";

CONST
    alphabet = lettersUpp;
    zero     = "0";

PROCEDURE parseDate (S : ARRAY OF CHAR;
                     VAR date : datetype) : BOOLEAN;
CONST
    century  = 1900; (* should it be really 2000 now ? ;-) *)
CONST
    separator=dash;
    legaldateset = digits+separator+alphabet;
    mindd=1;
    maxdd=31;
    minmm=1;
    maxmm=12;
    minyy=1600; (* in case a very old event ! *)
    maxyy=2399; (* ah ah ! *)
VAR
    i : CARDINAL;
    R : str80;
    v : LONGCARD;
    ok: BOOLEAN;
BEGIN
    UpperCase(S); (* in case months would be letters *)

    ReplaceChar(S,slash,separator);
    IF CharCount(S,separator)=1 THEN (* "dd/mm", not "dd/mm/yy" *)
        (* bugfix : force current year, not our unfortunate birth year *)
        getDateNow(date);
        Str.CardToStr( LONGCARD(date.year), R, 10, ok);
        Str.Append(S,separator);
        Str.Append(S,R);         (* force current year, not our unfortunate birth year *)
    END;

    FOR i := 0 TO (Str.Length(S)-1) DO
        IF Str.CharPos(legaldateset,S[i])=MAX(CARDINAL) THEN RETURN FALSE; END;
    END;
    IF CharCount(S,separator) # 2 THEN RETURN FALSE; END;

    Str.ItemS(R,S,separator,0);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN RETURN FALSE; END;
    IF (v < mindd) OR (v > maxdd) THEN RETURN FALSE; END;
    date.day := CARDINAL(v);

    Str.ItemS(R,S,separator,1);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN
        R[3]:=CHR(0); (* ignore after first three letters if any *)
        Str.Prepend(R,dash); (* fake command line parameter ! *)
        i := GetOptIndex(R,"JAN"+delim+"JAN"+delim+
                           "FEB"+delim+"FEV"+delim+
                           "MAR"+delim+"MAR"+delim+
                           "APR"+delim+"AVR"+delim+
                           "MAY"+delim+"MAI"+delim+
                           "JUN"+delim+"JUN"+delim+
                           "JUL"+delim+"JUI"+delim+
                           "AUG"+delim+"AOU"+delim+
                           "SEP"+delim+"SEP"+delim+
                           "OCT"+delim+"OCT"+delim+
                           "NOV"+delim+"NOV"+delim+
                           "DEC"+delim+"DEC");
        CASE i OF
        | 1..24 :
            v := LONGCARD(i+1) DIV 2;
        ELSE
            RETURN FALSE;
        END;
    END;
    IF (v < minmm) OR (v > maxmm) THEN RETURN FALSE; END;
    date.month := CARDINAL(v);

    Str.ItemS(R,S,separator,2);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN RETURN FALSE; END;
    IF v < 100 THEN INC(v,century); END;
    IF (v < minyy) OR (v > maxyy) THEN RETURN FALSE; END;
    date.year := CARDINAL(v);
    RETURN TRUE;
END parseDate;

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str80;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str80;
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    IF pad="" THEN RETURN S; END;
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

PROCEDURE substring (S1,S2:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    Str.Caps(S2);
    IF Str.Pos(S1,S2) # MAX(CARDINAL) THEN RETURN TRUE; END;
    Str.Lows(S2);
    IF Str.Pos(S1,S2) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END substring;

PROCEDURE newstring (VAR R:ARRAY OF CHAR; old,new:ARRAY OF CHAR);
BEGIN
    Str.Caps(old);
    IF Str.Pos(R,old) # MAX(CARDINAL) THEN
        Str.Subst(R,old,new);
    ELSE
        Str.Lows(old);
        IF Str.Pos(R,old) = MAX(CARDINAL) THEN RETURN; END;
        Str.Subst(R,old,new);
    END;
END newstring;

PROCEDURE oldnew (sOld,sNew:ARRAY OF CHAR;VAR R:ARRAY OF CHAR);
BEGIN
    LOOP
        IF substring(R,sOld)=FALSE THEN EXIT;END;
        newstring(R,sOld,sNew);
    END;
END oldnew;

(*
    $dd     lundi..dimanche / monday..sunday
    $d      1..31 (ordinal)
    $0d     01..31
    $mm     janvier..dcembre / january..december
    $m      1..12
    $0m     01..12

    $yyyy   ####
    $yy     00..99

    !d      1er..31 (cardinal)
    !0d     1er..31

    $!      Latin date

*)

PROCEDURE formatDate(format:ARRAY OF CHAR;language:languagetype;
                     dmy:datetype;
                     VAR R : ARRAY OF CHAR  );
VAR
    S,T    : str16;
    pad    : CHAR;
    v      : CARDINAL;
BEGIN
    Str.Copy(R,format);

    v := ORD(dmy.dayOfWeek);
    CASE language OF
    | french:   Str.ItemS(T,Sjours," ",v);
    | english:  Str.ItemS(T,SjoursUS," ",v);
    ELSE ; (* //ISO fixed silly requirement *) END;
    oldnew("$dd",T,R);

    v:=dmy.day;
    pad := "";   oldnew("$d",    using(v,2,pad), R);
    pad := "0";  oldnew("$0d",   using(v,2,pad), R);

    IF v=1 THEN
    pad := "";   oldnew("!d",    "1er"         , R);
    pad := "0";  oldnew("!0d",   "1er"         , R);
    ELSE
    pad := "";   oldnew("!d",    using(v,2,pad), R);
    pad := "0";  oldnew("!0d",   using(v,2,pad), R);
    END;

    v := dmy.month-1;
    CASE language OF
    | french:   Str.ItemS(T,Smois," ",v);
    | english:  Str.ItemS(T,SmoisUS," ",v);
    ELSE ; (* //ISO fixed silly requirement *) END;
    oldnew("$mm",T,R);

    v := dmy.month;
    pad := "";  oldnew("$m",    using(v,2,pad), R);
    pad := "0"; oldnew("$0m",   using(v,2,pad), R);

    v := dmy.year;
    pad := "";  oldnew("$yyyy", using(v,4,pad), R);
    pad := "0";
    IF v >= 1900 THEN (* always here *)
        v  := dmy.year - 1900;IF v > 100 THEN DEC(v,100);END;
    END;
                oldnew("$yy",   using(v,2,pad), R);

    oldnew ("$!", latinDate(dmy.day,dmy.month,dmy.year), R);

END formatDate;

(*
    h      0..23
    0h     00..23
    m      0..59
    0m     00..59
    s      0..59
    0s     00..59
*)

PROCEDURE formatTime (format:ARRAY OF CHAR;language:languagetype;
                      hms:timetype;
                      VAR R : ARRAY OF CHAR  );
VAR
    S,T    : str16;
    pad    : CHAR;
    v      : CARDINAL;
BEGIN

    v := hms.hours;
    pad := "";   oldnew("h",    using(v,2,pad), R);
    pad := "0";  oldnew("0h",   using(v,2,pad), R);

    v := hms.minutes;
    pad := "";   oldnew("m",    using(v,2,pad), R);
    pad := "0";  oldnew("0m",   using(v,2,pad), R);

    v := hms.seconds;
    pad := "";   oldnew("s",    using(v,2,pad), R);
    pad := "0";  oldnew("0s",   using(v,2,pad), R);

END formatTime;

PROCEDURE formatNowFormat (format:ARRAY OF CHAR;language:languagetype;
                           dmy:datetype;
                           VAR R : ARRAY OF CHAR);
VAR
    hms:timetype;
BEGIN
    formatDate(format,language,dmy,R);
    getTimeNow(hms); (* let's hope we don't cross midnight ! ;-) maybe we should reread date ! *)
    formatTime(format,language,hms,R);
END formatNowFormat;

PROCEDURE fmtHeader (language:languagetype;dmy:datetype;
                     usebirths,useevents:BOOLEAN ):str80;
CONST
    pad = "0";
    defaultFmtFR  = "!d $mm";
    defaultFmtUS  = "$mm $d";
    frBorn        = "Qui est n le ";
    frWhat        = "Qu'est-il arriv le ";
    usBorn        = "Who was born on ";
    usWhat        = "What happened on ";
VAR
    R : str80;
BEGIN
    Str.Copy(R,"");
    CASE language OF
    | french:
        formatDate(defaultFmtFR,french,dmy,R);
        IF usebirths AND NOT(useevents) THEN
            Str.Prepend(R,frBorn);
        ELSE
            Str.Prepend(R,frWhat);
        END;
    | english:
        formatDate(defaultFmtUS,english,dmy,R);
        IF usebirths AND NOT(useevents) THEN
            Str.Prepend(R,usBorn);
        ELSE
            Str.Prepend(R,usWhat);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Append(R," ?");
    RETURN R;
END fmtHeader;

(* ------------------------------------------------------------ *)

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead;
VAR
    IObuffer : ARRAY [1..IObufferSize] OF SYSTEM.LOC;

TYPE
    str8   = ARRAY [0..7] OF CHAR;
    linetype = RECORD (* almost oversized strings anyway ! *)
        s1 : str8;
        s2 : str8;
        s3 : str160; (* was str80 but we allow long data now, str256 was too much *)
    END;
CONST
    firstEntry = 1;
    maxEntry   = 350; (* was 100, then 240 : pointers needed now ! *)
VAR
    line : ARRAY [firstEntry..maxEntry] OF linetype;

PROCEDURE less (i,j:CARDINAL):BOOLEAN ;
BEGIN
    RETURN (Str.Compare(line[i].s2,line[j].s2) < 0);
END less;

PROCEDURE swap (i,j:CARDINAL);
VAR
    tmp : linetype;
BEGIN
    tmp := line[i];
    line[i]:=line[j];
    line[j]:=tmp;
END swap;

(*
PROCEDURE waitAndSee (VAR rowcount:CARDINAL; lastRow:CARDINAL):BOOLEAN;
CONST
    funckey = CHR(0);
    echapkey= CHR(27);
VAR
    c1,c2:CHAR;
BEGIN
    INC(rowcount);
    IF rowcount >= lastRow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
        rowcount := initpagingcounter;
        video(kbdmsg,TRUE);
        Flushkey;
        BiosWaitkey(c1,c2);
        video(kbdmsg,FALSE);
        IF c1 = echapkey THEN
            RETURN FALSE;
        END;
    END;
    RETURN TRUE;
END waitAndSee;
*)

(* ------------------------------------------------------------ *)

PROCEDURE dmpData ( DEBUG, sort,fullbase,
                    usebirths,usedeaths,useevents,egotist,redirection:BOOLEAN;
                    datafile,privatefile:ARRAY OF CHAR;dmy:datetype;
                    language:languagetype;LineWidth : CARDINAL):BOOLEAN;
CONST
    procme = "dmpData()";
CONST (* lucky english is sometimes so compact ! *)
    usformat     = rem+"MMDDYYYY";
    frformat     = rem+"DDMMYYYY";
    sDiedUS      = "Died ";
    sBornUS      = "Born ";
    sInUS        = "  In ";
    sDiedFR      = "Mort ";
    sBornFR      = "++++ "; (* n(e) ou naissance won't fit 4 chars ! *)
    sInFR        = "  En ";
    sPadContinue = "     ";
    sYYYYempty   = "    ";
    sYYYYunknown = "????";

    sThisUS      = "It's ";
    sThisFR      = "  De ";
    sIsUS        = "also";
    sIsFR        = "plus";

    sRienFR      = "Rien  afficher !"; (* "Rien." was royal but did not fit birthdays ! *)
    sRienUS      = "No data to display !";
VAR
    md   : str16;
    mmdd,yyyy : str16;
    s1,s2 : str8; (* enough room for "born " and "yyyy "*)
    s3,S,R  : str256; (* we may need a long original string *)
    hnd  : FIO.File;
    firsttime,include,glue,overflow,done,rc:BOOLEAN;
    i,p,lastentry,dumped : CARDINAL;
    dateformat : (mmddyyyy,ddmmyyyy);
    msgBorn,msgDied,msgIn,msgThis,msgIs:str8;
    msgRien:str80;
BEGIN

    CASE language OF
    | english:
        msgBorn :=sBornUS;
        msgDied :=sDiedUS;
        msgIn   :=sInUS;
        msgThis :=sThisUS;
        msgIs   :=sIsUS;
        msgRien :=sRienUS;
    | french:
        msgBorn :=sBornFR;
        msgDied :=sDiedFR;
        msgIn   :=sInFR;
        msgThis :=sThisFR;
        msgIs   :=sIsFR;
        msgRien :=sRienFR;
    ELSE ; (* //ISO fixed silly requirement *) END;

    Str.Concat(md,using(dmy.month,2,zero),using(dmy.day,2,zero));

    IF sort THEN
        lastentry := firstEntry - 1;
        overflow  := FALSE;
    END;

    dumped := 0;

    firsttime := TRUE;

                    IF firsttime THEN
                        Str.Copy(s3,fmtHeader(language,dmy,usebirths,useevents));
                        WrStr(s3);
                        WrLn;
                        WrLn;

                        firsttime:=FALSE;
                    END;

    IF egotist THEN
        i:=2; (* directly start with personal data file *)
    ELSE
        i:=1;
    END;

    dbg(DEBUG,procme,"datafile",datafile);
    dbg(DEBUG,procme,"privatefile",privatefile);

    LOOP
        IF i > 2 THEN EXIT; END;
        CASE i OF
        | 1 : Str.Copy(S,datafile);
        | 2 : IF FIO.Exists(privatefile)=FALSE THEN EXIT; END;
              Str.Copy(S,privatefile);
        ELSE ; (* //ISO fixed silly requirement *) END;
        dateformat := mmddyyyy; (* default is obviously US *)
        hnd := FIO.OpenRead(S);
        FIO.AssignBuffer(hnd,IObuffer);
        FIO.EOF := FALSE;
        LOOP
            IF FIO.EOF THEN EXIT;END;
            FIO.RdStr(hnd,S); (* "?mmddyyyy ..." *)
            LtrimBlanks(S);
            RtrimBlanks(S);
            CASE S[0] OF
            | CHR(0) : ;(* nada *)
            | comment : ;(* nada either *)
            | rem :
                Str.Caps(S);
                IF Str.Pos(S,usformat)=0 THEN
                    dateformat := mmddyyyy;
                ELSIF Str.Pos(S,frformat)=0 THEN
                    dateformat := ddmmyyyy;
                END;
            ELSE
                IF dateformat = mmddyyyy THEN
                    Str.Slice(mmdd,S,1,4);
                ELSIF dateformat = ddmmyyyy THEN
                    Str.Slice(s1,S,3,2);
                    Str.Slice(s2,S,1,2);
                    Str.Concat(mmdd,s1,s2);
                END;
                ReplaceChar(mmdd,blank,zero); (* just in case... *)
                Str.Slice(yyyy,S,5,4);
                ReplaceChar(yyyy,dash,question); (* just in case... *)
                IF same(mmdd,md) THEN
                    (* we no longer remain silent when no data is available !
                    IF firsttime THEN
                        color(hiink,hipaper);
                        Str.Copy(s3,fmtHeader(language,dmy,usebirths,useevents));
                        WrStr(s3);
                        color(ink,paper);
                        WrLn;
                        rc:=waitAndSee(rowcount,lastRow);
                        IF rc=FALSE THEN RETURN FALSE;END;
                        WrLn;
                        rc:=waitAndSee(rowcount,lastRow);
                        IF rc=FALSE THEN RETURN FALSE;END;

                        firsttime:=FALSE;
                    END;
                    *)
                    include:=TRUE;
                    glue   :=FALSE;
                    CASE S[9] OF
                    | "C" :          (* continue *)
                        s1 := sPadContinue;
                        s2 := sYYYYempty;
                        glue := TRUE;
                        (* avoid glueing to previous entry : check 15 June ! *)
                        CASE S[0] OF
                        | "B","b" : IF NOT(usebirths)  THEN include:=FALSE;END;
                        | "D","d" : IF NOT(usedeaths)  THEN include:=FALSE;END;
                        | "S","s" : IF NOT(useevents)  THEN include:=FALSE;END;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        IF NOT(fullbase) THEN
                            CASE S[0] OF
                            | "b","d","s": include:=FALSE;
                            ELSE ; (* //ISO fixed silly requirement *) END;
                        END;
                    | " " :          (* new entry *)
                        Str.Copy(s2,yyyy);
                        CASE S[0] OF
                        | "B","b" :
                            s1 := msgBorn;
                            IF same(yyyy,sYYYYempty) THEN s2:=sYYYYunknown;END;
                            IF NOT(usebirths) THEN include:=FALSE;END;
                        | "D","d" :
                            s1 := msgDied;
                            IF same(yyyy,sYYYYempty) THEN s2:=sYYYYunknown;END;
                            IF NOT(usedeaths) THEN include:=FALSE;END;
                        | "S","s" :
                            s1 := msgIn;
                            IF same(yyyy,sYYYYempty) THEN s1:=msgThis;s2:=msgIs;END;
                            IF NOT(useevents) THEN include:=FALSE;END;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        IF NOT(fullbase) THEN
                            CASE S[0] OF
                            | "b","d","s": include:=FALSE;
                            ELSE ; (* //ISO fixed silly requirement *) END;
                        END;
                    ELSE             (* ignore day -- 6=friday, etc. *)
                        include:=FALSE;
                    END;
                    IF include THEN
                        Str.Delete(S,0,10);
                        LtrimBlanks(S); (* just in case *)
                        RtrimBlanks(S);
                        IF sort THEN
                            IF lastentry < maxEntry THEN
                                IF glue THEN
                                    Str.Append(line[lastentry].s3,newlinemarker);
                                    Str.Append(line[lastentry].s3,S);
                                ELSE
                                    INC(lastentry);
                                    Str.Copy(line[lastentry].s1,s1);
                                    Str.Copy(line[lastentry].s2,s2);
                                    Str.Copy(line[lastentry].s3,S);
                                END;
                            ELSE
                                overflow:=TRUE;
                            END;
                        ELSE
                            WrStr(s1);
                            WrStr(s2);
                            WrStr(" ");
                            WrStr(S);

                            IF redirection THEN
                                WrLn;
                            ELSE
                                Str.Concat(R,s1,s2);Str.Append(R,S);
                                (* R+space vs screen, # and not < *)
                                IF (Str.Length(R)+1) # LineWidth THEN WrLn; END;
                            END;
                        END;
                        INC(dumped); (* whether stored or sent to screen *)
                        IF NOT(sort) THEN
                        END;
                    END;
                END;
            END;
        END;
        FIO.Close(hnd);
        INC(i);
    END;
    IF (sort AND (lastentry >= firstEntry)) THEN (* //V11F FIX *)
        IF overflow=FALSE THEN Lib.QSort(lastentry,less,swap); END;
        FOR i := firstEntry TO lastentry DO
             (* too bad if original data contained \n ! ;-) *)
             Str.Copy(s1,line[i].s1);
             Str.Copy(s2,line[i].s2);
             Str.Copy(S ,line[i].s3);
             REPEAT
                 p:=Str.Pos(S,newlinemarker);
                 IF p = MAX(CARDINAL) THEN
                     done:=TRUE;
                     Str.Copy(s3,S);
                 ELSE
                     done:=FALSE;
                     Str.Slice(s3,S,0,p);
                     Str.Delete(S,0,p+newlinemarkerlen);
                 END;

                 WrStr(s1);
                 WrStr(s2);
                 WrStr(" "); WrStr(s3);

                 IF redirection THEN
                     WrLn;
                 ELSE
                     Str.Concat(R,s1,s2);Str.Append(R,S);
                     (* R+space vs screen, # and not < *)
                     IF (Str.Length(R)+1) # LineWidth THEN WrLn; END;
                 END;


                 Str.Copy(s1,sPadContinue);
                 Str.Copy(s2,sYYYYempty);
             UNTIL done;
        END;
        IF overflow THEN
             WrLn;WrStr("Warning ! There was not enough room for all data !");WrLn;
        END;
    END;
    IF dumped = 0 THEN
        WrStr(msgRien);WrLn;
    END;
    RETURN TRUE;
END dmpData;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE pack (VAR S : ARRAY OF CHAR;older,newer:ARRAY OF CHAR);
BEGIN
    LOOP
        IF Str.Pos(S,older)=MAX(CARDINAL) THEN EXIT; END;
        Str.Subst(S,older,newer);
    END;
END pack;

(*
    almost useless, for data was already verified,
    but as our dmpTTX proc does not check punctuation marks...
*)

PROCEDURE cleanstring (VAR S : ARRAY OF CHAR);
BEGIN
    pack(S,space+space      ,space);
    pack(S,space+semicolon  ,semicolon);
    pack(S,space+exclamation,exclamation);
    pack(S,space+question   ,question);
    pack(S,space+comma      ,comma);
END cleanstring;

CONST
    mincolumns  = 1+1+1+1+1;
    frameNone   = 0;
    frameSingle = 1;
    frameDouble = 2;
    frameRaw    = 3;
    minframe    = frameNone;
    maxframe    = frameRaw;
    (*            012345     *)
    sSingle    = "ڳ";
    sDouble    = "ɺͼ";
    sNone      = "      ";
    wiHORIZ    = 4; (* bar, space, ... , space, bar *)
    wiHORIZalt = 2; (* space, ... , space *)
CONST
    firstline = firstEntry;
    maxline   = maxEntry;

PROCEDURE formatSentence (LineWidth,doFrame:CARDINAL;
                          VAR lastline,longest:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    tmplen            : CARDINAL;
    tmp               : str256;   (* could be str128 but... *)
    splitagain        : BOOLEAN;
    p                 : CARDINAL;
    Z                 : str2048;  (* just in case *)
BEGIN
    cleanstring(S);

    CASE doFrame OF
    | frameRaw :
        ;
    | frameNone:
        DEC(LineWidth,wiHORIZalt);  (* string + 2 spaces *)
    ELSE
        DEC(LineWidth,wiHORIZ);     (* string + 2 spaces + 2 bars *)
    END;

    lastline  := firstline-1;
    longest   := 0;

    LOOP
        p:=Str.Pos(S,newlinemarker);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Slice(Z,S,0,p);
        Str.Delete(S,0,p+1+1); (* "\n" CRLF marker takes two characters *)

        splitagain:=dmpTTX(Z,LineWidth,tmp,TRUE);
        WHILE splitagain DO
            Str.Copy(line[firstline+lastline].s3,tmp);
            tmplen:=Str.Length(tmp);
            IF tmplen > longest THEN longest := tmplen; END;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
            splitagain:=dmpTTX(Z,LineWidth,tmp,FALSE);
        END;
        IF Str.Pos(S,newlinemarker)=0 THEN
            Str.Copy(line[firstline+lastline].s3, "");
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
        END;
    END;

        splitagain:=dmpTTX(S,LineWidth,tmp,TRUE);
        WHILE splitagain DO
            Str.Copy(line[firstline+lastline].s3,tmp);
            tmplen:=Str.Length(tmp);
            IF tmplen > longest THEN longest := tmplen; END;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
            splitagain:=dmpTTX(S,LineWidth,tmp,FALSE);
        END;

    RETURN TRUE;
END formatSentence;

PROCEDURE dmpSentence (redirection:BOOLEAN;
                       doFrame,screenwidth,LineWidth,lastline,longest:CARDINAL);
VAR
    plus,len,i,j,k    : CARDINAL;
    frameChars   : str16;
    S            : str128;
    neednl       : BOOLEAN;
BEGIN

    len := longest;

    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE doFrame OF
    | frameRaw :
        (* WrLn; *)
        FOR j:=firstline TO lastline DO
            IF j=firstline THEN ; END;
            WrStr(line[j].s3);
            IF j=firstline THEN ;END;
            neednl :=( Str.Length(line[j].s3) < LineWidth );
            neednl :=(neednl OR redirection);
            neednl :=(neednl OR (LineWidth # screenwidth) ); (* < *)
            IF neednl THEN WrLn; END;
        END;
    ELSE
        neednl := ((1+len+plus+1) < LineWidth );
        neednl := (neednl OR redirection);
        neednl := (neednl OR (LineWidth # screenwidth) ); (* < *)

        (* WrLn; *)
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrStr(frameChars[2]);
        IF neednl THEN WrLn; END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrStr(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;
        FOR j:=firstline TO lastline DO
            WrStr(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            IF j=firstline THEN ; END;
            WrStr(line[j].s3);
            IF j=firstline THEN ; END;
            FOR k:=Str.Length(line[j].s3)+1 TO len DO
                WrStr(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        IF doFrame # frameNone THEN
            WrStr(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrStr(space); END;
            WrStr(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        WrStr(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrStr(frameChars[4]); END;
        WrStr(frameChars[5]);
        IF neednl THEN WrLn; END;
    END;
END dmpSentence;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dmpPagan ( DEBUG,doLatin,redirection,shortday,doDay:BOOLEAN;
                     datafile : ARRAY OF CHAR;dmy:datetype;
                     screenwidth,LineWidth,doFrame:CARDINAL;
                     language:languagetype):BOOLEAN;
CONST
    defaultFmtFR  = "$dd !d $mm $yyyy  0hh 0mmn 0ss";
    defaultShortFR= "Calendrier paen pour le !d $mm";
    defaultFmtUS  = "$dd, $mm $d, $yyyy at 0h:0m:0s";
    defaultShortUS= "Pagan calendar for $mm $d";
    defaultNadaFR = "Aucun rite  observer, aucune remarque  formuler.";
    defaultNadaUS = "No observance today.";
    defaultNadaFRalt= "Rien  signaler.";
    defaultNadaUSalt= "Nothing to report.";
    errmsgFR      = "ERREUR !";
    errmsgUS      = "ERROR WHILE PROCESSING DATA !";
VAR
    dm,ddmm : str16;
    S : str1024; (* max length is about 730 chars, so... *)
    dt : str128;
    found:BOOLEAN;
    hnd:FIO.File;
    format:str80;
    lastline,longest,p:CARDINAL;
BEGIN
    Str.Concat(dm,using(dmy.day,2,zero),using(dmy.month,2,zero));
    found:=FALSE;
    hnd := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hnd,S); (* "ddmm:..." *)
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE S[0] OF
        | nullchar: ; (* nada *)
        | comment : ; (* nada either *)
        ELSE
            Str.Slice(ddmm,S,0,4); (* //V11H assume leading "0" *)
            ReplaceChar(ddmm,blank,zero); (* just in case... *)
            IF same(ddmm,dm) THEN
                found:=TRUE;
                EXIT;
            END;
        END;
    END;
    FIO.Close(hnd);
    IF found THEN
        (* we could directly remove "####:" header but just to be sure... *)
        Str.Delete(S,0,4); (* first, we remove "ddmm" *)
        p:=Str.CharPos(S,":"); (* should always be 0 ! *)
        IF p # MAX(CARDINAL) THEN
            Str.Delete(S,0,p+1);
        END;
        LtrimBlanks(S);
    ELSE
        IF doDay THEN
           CASE language OF
           | french : Str.Copy(S,defaultNadaFRalt);
           | english: Str.Copy(S,defaultNadaUSalt);
           ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE
           CASE language OF
           | french : Str.Copy(S,defaultNadaFR);
           | english: Str.Copy(S,defaultNadaUS);
           ELSE ; (* //ISO fixed silly requirement *) END;
	END;
    END;
    CASE language OF
    | french  :
        IF shortday THEN
            Str.Copy(format,defaultShortFR);
        ELSE
            Str.Copy(format,defaultFmtFR);
        END;
    | english :
        IF shortday THEN
            Str.Copy(format,defaultShortUS);
        ELSE
            Str.Copy(format,defaultFmtUS);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF doLatin THEN Str.Append(format," ($!)");END;
    formatNowFormat(format,language,dmy,dt);
    Str.Prepend(S,newlinemarker+newlinemarker);
    Str.Prepend(S,dt);
    IF formatSentence (LineWidth,doFrame,  lastline,longest,S)=FALSE THEN
        Str.Concat(S,dt,newlinemarker+newlinemarker);
        CASE language OF
        | french:  Str.Append(S,errmsgFR);
        | english: Str.Append(S,errmsgUS);
        ELSE ; (* //ISO fixed silly requirement *) END;
        (* assume always ok here ! *)
        found:=formatSentence(LineWidth,doFrame,  lastline,longest,S);
    END;
    dmpSentence (redirection,doFrame,screenwidth,LineWidth,lastline,longest);
    RETURN TRUE;
END dmpPagan;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doCookEntry (VAR isFemale,isEvent,isEpicene,isAlsoCelebrated:BOOLEAN;
                       VAR R : ARRAY OF CHAR);
BEGIN
    (* "!"=female  "@"=event  "="=epicne  "$"=also celebrated *)
    isFemale         := ( Str.CharPos(R,femalemarker)  # MAX(CARDINAL) );
    isEvent          := ( Str.CharPos(R,eventmarker)   # MAX(CARDINAL) );
    isEpicene        := ( Str.CharPos(R,epicenemarker) # MAX(CARDINAL) );
    isAlsoCelebrated := ( Str.CharPos(R,alsomarker)    # MAX(CARDINAL) );
    ReplaceChar(R,femalemarker,"");
    ReplaceChar(R,eventmarker,"");
    ReplaceChar(R,epicenemarker,"");
    ReplaceChar(R,alsomarker,"");
END doCookEntry;

PROCEDURE getzeStr (VAR dst:ARRAY OF CHAR;
                 language:languagetype;fr,us:ARRAY OF CHAR);
BEGIN
    CASE language OF
    | french:  Str.Copy(dst,fr);
    | english: Str.Copy(dst,us);
    ELSE ; (* //ISO fixed silly requirement *) END;
END getzeStr;


PROCEDURE dmpSaints ( DEBUG,redirection,today:BOOLEAN;
                     datafile : ARRAY OF CHAR;dmy:datetype;
                     screenwidth,LineWidth,doFrame:CARDINAL;
                     language:languagetype):BOOLEAN;
CONST
    procme          = "dmpSaints()";
    pldefaultTodayFR  = "Ftes  clbrer en ce !d $mm";
    pldefaultFR       = "Ftes  clbrer le !d $mm";
    pldefaultTodayUS  = "Events to celebrate today $mm $d";
    pldefaultUS       = "Events to celebrate on $mm $d";
    sgdefaultTodayFR  = "Fte  clbrer en ce !d $mm";
    sgdefaultFR       = "Fte  clbrer le !d $mm";
    sgdefaultTodayUS  = "Event to celebrate today $mm $d";
    sgdefaultUS       = "Event to celebrate on $mm $d";
    defaultNadaFR   = "Aucune fte ( en croire la base de donnes).";
    defaultNadaUS   = "No event (according to database).";
    errmsgFR        = "ERREUR !";
    errmsgUS        = "ERROR WHILE PROCESSING DATA !";
    frSaintMale     = "Saint ";  (* trailing space *)
    frSaintFemale   = "Sainte ";
    usSaintMale     = "Saint ";
    usSaintFemale   = "Saint ";
    frEpicene       = " (prnom picne)";
    usEpicene       = " (epicene)";
    frAlso          = "C'est aussi la fte des ";
    usAlso          = "Also celebrated : ";
VAR
    dm,ddmm:str16;
    prefix,suffix : str80;
    S,Z,ALSO : str1024; (* max length is about 730 chars, so... *)
    R,dt : str128;
    found:BOOLEAN;
    hnd:FIO.File;
    format:str80;
    lastline,longest,p,n:CARDINAL;
    isFemale,isEvent,isEpicene,isAlsoCelebrated:BOOLEAN;
BEGIN
    Str.Concat(dm,using(dmy.day,2,zero),using(dmy.month,2,zero));
dbg(DEBUG,procme,"dm",dm);
    found:=FALSE;
    hnd := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hnd,S); (* "ddmm:..." *)
        LtrimBlanks(S);
        RtrimBlanks(S);
dbg(DEBUG,procme,"S",S);
        CASE S[0] OF
        | nullchar: ; (* nada *)
        | comment : ; (* nada either *)
        ELSE
            Str.Slice(ddmm,S,0,4); (* //V11H assume leading "0" *)
            ReplaceChar(ddmm,blank,zero); (* just in case... *)
dbg(DEBUG,procme,"ddmm",ddmm);
            IF same(ddmm,dm) THEN
                found:=TRUE;
                EXIT;
            END;
        END;
    END;
    FIO.Close(hnd);
    IF found THEN
        (* we could directly remove "####:" header but just to be sure... *)
        Str.Delete(S,0,4); (* first, we remove "ddmm" *)
        p:=Str.CharPos(S,":"); (* should always be 0 ! *)
        IF p # MAX(CARDINAL) THEN
            Str.Delete(S,0,p+1);
        END;
        LtrimBlanks(S);
    ELSE
        getzeStr(S, language,defaultNadaFR,defaultNadaUS);
    END;

    ReplaceChar(S,semicolon,comma);
    IF found THEN
        Z:=S;
        S:="";
    ELSE
        Z:="";
        Str.Prepend(S,newlinemarker); (* beautify *)
    END;

    ALSO:="";
    n:=0;
    LOOP
        isoleItemS(R, Z,comma,n); LtrimBlanks(R); RtrimBlanks(R);
dbg(DEBUG,procme,"R",R);
        IF same(R,"") THEN EXIT; END;
        doCookEntry(isFemale,isEvent,isEpicene,isAlsoCelebrated,R);
        IF isAlsoCelebrated=FALSE THEN Str.Append(S,newlinemarker); END;

        prefix:="";
        suffix:="";
        IF isEvent THEN
            ;
        ELSIF isAlsoCelebrated THEN
            ;
        ELSIF isFemale THEN
            getzeStr(prefix, language, frSaintFemale,usSaintFemale);
        ELSE
            getzeStr(prefix, language, frSaintMale,usSaintMale);
        END;
        IF isEpicene THEN
            getzeStr(suffix, language, frEpicene,usEpicene);
        END;
        IF isAlsoCelebrated THEN
            IF same(ALSO,"")=FALSE THEN Str.Append(ALSO,", ");END;
            Str.Append(ALSO,R);
dbg(DEBUG,procme,"ALSO",ALSO);
        ELSE
            Str.Append(S,prefix);
            Str.Append(S,R);
            Str.Append(S,suffix);
            Str.Append(S,newlinemarker);
dbg(DEBUG,procme,"S",S);
        END;
        INC(n);
    END;

    (* take count into account FOR header //V11L *)

    CASE language OF
    | french  :
        IF today THEN
            IF n < 2 THEN
                Str.Copy(format,sgdefaultTodayFR);
            ELSE
                Str.Copy(format,pldefaultTodayFR);
            END;
        ELSE
            IF n < 2 THEN
                Str.Copy(format,sgdefaultFR);
            ELSE
                Str.Copy(format,pldefaultFR);
            END;
        END;
    | english :
        IF today THEN
            IF n < 2 THEN
                Str.Copy(format,sgdefaultTodayUS);
            ELSE
                Str.Copy(format,pldefaultTodayUS);
            END;
        ELSE
            IF n < 2 THEN
                Str.Copy(format,sgdefaultUS);
            ELSE
                Str.Copy(format,pldefaultUS);
            END;
        END;
    ELSE
        ; (* silly ISO ! *)
    END;
    formatNowFormat(format,language,dmy,dt);

    (* resume S building S *)

    Str.Prepend(S,newlinemarker); (* one nl here, NOT two *)
    Str.Prepend(S,dt);
    IF same(ALSO,"") = FALSE THEN
        getzeStr(R, language, frAlso, usAlso);
        Str.Append(S,newlinemarker);
        Str.Append(S,R);
        Str.Append(S,ALSO);
        Str.Append(S,".");
    END;

    IF formatSentence (LineWidth,doFrame,  lastline,longest,S)=FALSE THEN
        Str.Concat(S,dt,newlinemarker+newlinemarker);
        CASE language OF
        | french:  Str.Append(S,errmsgFR);
        | english: Str.Append(S,errmsgUS);
        ELSE ; (* //ISO fixed silly requirement *) END;
        (* assume always ok here ! *)
        found:=formatSentence(LineWidth,doFrame,  lastline,longest,S);
    END;
    dmpSentence (redirection,doFrame,screenwidth,LineWidth,lastline,longest);
    RETURN TRUE;
END dmpSaints;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJokerMode (S:ARRAY OF CHAR   ):BOOLEAN;
BEGIN
    IF Str.CharPos(S,"?") # MAX (CARDINAL) THEN RETURN TRUE; END;
    RETURN ( Str.CharPos(S,"*") # MAX(CARDINAL) );
END chkJokerMode;

PROCEDURE cookForComp (VAR R:ARRAY OF CHAR;isPattern:BOOLEAN  );
VAR
    S:str128;
    i:CARDINAL;
    ch:CHAR;
    jokermode:BOOLEAN;
    legal : str256;
BEGIN
    IF isPattern THEN
        jokermode:=chkJokerMode(R);
    ELSE
        jokermode:=FALSE;
    END;
    legal:=lettersLow;
    IF jokermode THEN Str.Append(legal,"?*");END;
    LowerCase(R); (* don't keep accents *)
    S:="";
    FOR i:=1 TO Str.Length(R) DO
        ch := R[i-1];
        IF Str.CharPos(legal,ch) # MAX (CARDINAL) THEN Str.Append(S,ch);END;
    END;
    Str.Copy(R,S);
END cookForComp;

PROCEDURE doShowMatches (DEBUG:BOOLEAN;language:languagetype;
                        wanted,datafile:ARRAY OF CHAR);
CONST
    procme      = "doShowMatches()";
    placeholder = vbar;
    frDB        = '::: Base de donnes : "|"';
    usDB        = '::: Database      : "|"';
    frToFind    = '::: Texte recherch : "|"';
    usToFind    = '::: Searched text : "|"';
    frMatch     = '+++ "|" (|), le $d $mm';
    usMatch     = '+++ "|" (|), on $mm, $d';
    frNomatch   = "--- Aucune correspondance !";
    usNomatch   = "--- No match !";
    frEvent     = "jour de fte";
    usEvent     = "day of celebration";
    frAlso      = "fte  souhaiter";
    usAlso      = "celebration day";
    frSaintFemale="sainte";
    usSaintFemale="saint";
    frSaintMale = "saint";
    usSaintMale = "saint";
VAR
    S:str1024;
    msg:str256;
    shortmsg,org,cooked:str128;
    hnd:FIO.File;
    p,matches:CARDINAL;
    ddmm:str16;
    isFemale,isEvent,isEpicene,isAlsoCelebrated:BOOLEAN;
    dmy:datetype;
    showme,jokermode,ok:BOOLEAN;
BEGIN
    jokermode:=chkJokerMode(wanted);
    getzeStr(msg, language,frDB,usDB);
    Str.Subst(msg,placeholder,datafile);
    WrStr(msg);WrLn;

    LtrimBlanks(wanted);
    RtrimBlanks(wanted);
    getzeStr(msg, language,frToFind,usToFind);
    Str.Subst(msg,placeholder,wanted);
    WrStr(msg);WrLn;
    (* WrLn; *)

    cookForComp(wanted, TRUE);

    matches:=0;
    hnd := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hnd,S); (* "ddmm:..." *)
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE S[0] OF
        | nullchar: ; (* nada *)
        | comment : ; (* nada either *)
        ELSE
dbg(DEBUG,procme,"S",S);
            (* we could directly remove "####:" header but just to be sure... *)
            Str.Slice(ddmm,S,0,4);
            ReplaceChar(ddmm,blank,zero); (* just in case... *)

            Str.Delete(S,0,4); (* first, we remove "ddmm" *)
            p:=Str.CharPos(S,":"); (* should always be 0 ! *)
            IF p # MAX(CARDINAL) THEN
                Str.Delete(S,0,p+1);
            END;
            LtrimBlanks(S);

            Str.Insert(ddmm,dash,2); (* from "ddmm" to "dd-mm" *)
            ok:=parseDate(ddmm,dmy); (* assume ok *)

            p:=0;
            LOOP
                isoleItemS(org, S,comma,p); LtrimBlanks(org);RtrimBlanks(org);
                IF same(org,"") THEN EXIT; END;
dbg(DEBUG,procme,"org",org);
                doCookEntry(isFemale,isEvent,isEpicene,isAlsoCelebrated,org);
                Str.Copy(cooked,org);
                cookForComp(cooked, FALSE);
dbg(DEBUG,procme,"cooked",cooked);
                IF jokermode THEN
dbg(DEBUG,procme,"wanted",wanted);
                    showme:=Str.Match(cooked,wanted);
                ELSE
                    showme:=same(wanted,cooked);
                END;
                IF showme THEN

dbg(DEBUG,procme,"ddmm",ddmm);
dbg(DEBUG,procme,"dmy.day",using(dmy.day,1,""));
dbg(DEBUG,procme,"dmy.month",using(dmy.month,1,""));

                    getzeStr(shortmsg,language,frMatch,usMatch);
dbg(DEBUG,procme,"shortmsg",shortmsg);
                    formatDate(shortmsg,language,dmy,msg);
dbg(DEBUG,procme,"msg",msg);
                    Str.Subst(msg,placeholder,org);

                    (* care about event, saint, sainte, also celebrated *)

                    IF isEvent THEN
                        getzeStr(cooked,language,frEvent,usEvent);
                    ELSIF isAlsoCelebrated THEN
                        getzeStr(cooked,language,frAlso,usAlso);
                    ELSIF isFemale THEN
                        getzeStr(cooked,language,frSaintFemale,usSaintFemale);
                    ELSE
                        getzeStr(cooked,language,frSaintMale,usSaintMale);
                    END;
                    Str.Subst(msg,placeholder,cooked);
                    WrStr(msg);WrLn;
                    INC(matches);
                END;
                INC(p);
            END;
        END;
    END;
    FIO.Close(hnd);
    IF matches = 0 THEN
        getzeStr(msg,language,frNomatch,usNomatch);
        WrStr(msg);WrLn;
    END;
END doShowMatches;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE buildDataFilePath (VAR datafile,dataaltfile,privatefile,
			    paganfile,saintsfile,dayfile: ARRAY OF CHAR;
                             n : CARDINAL;hugedata:BOOLEAN);
CONST
    moisUS =     "JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC";
    datmisc=     sEGO+" "+sCAL+" "+sSAINT; (* upper CASE *)
    moisNN =     "01 02 03 04 05 06 07 08 09 10 11 12";
VAR
    exe,u,d,f8,e3:str128;
    extDAT,S : str16;
    pb:CARDINAL;
BEGIN
    IF hugedata THEN
        extDAT:=extDMX;
    ELSE
        extDAT:=extDM;
    END;

    Lib.ParamStr(exe,0);
    UpperCase(exe); (* useless but... *)
    qdSplitAllPath(exe,u,d,f8,e3);
    (* well, some genius might have renamed our executable : let's hard code name ! :-( *)
    Str.Copy(f8,DATheader);

    Str.ItemS(S,moisUS," ",n-1);
    Str.Prepend(S,f8);
    Lib.MakeAllPath(datafile,u,d,S,extDAT);

    Str.ItemS(S,moisNN," ",n-1);
    Str.Prepend(S,f8);
    Lib.MakeAllPath(dataaltfile,u,d,S,extDAT);

    Str.ItemS(S,datmisc," ",1-1);
    Str.Prepend(S,f8);
    Lib.MakeAllPath(privatefile,u,d,S,extDAT);

    Str.ItemS(S,datmisc," ",2-1);
    Str.Prepend(S,f8);
    Lib.MakeAllPath(paganfile,u,d,S,extDAT);

    Str.ItemS(S,datmisc," ",3-1);
    Str.Prepend(S,f8);
    Lib.MakeAllPath(saintsfile,u,d,S,extDAT);

    Lib.MakeAllPath(saintsfile,u,d,S,extDAT);

    IF NOT ( same(dayfile,"") ) THEN
        IF Str.RCharPos(dayfile,dot)=MAX(CARDINAL) THEN Str.Append(dayfile,extDM);END;
        pb:=0;
        IF Str.CharPos(dayfile,colon) # MAX(CARDINAL) THEN INC(pb);END;
        IF Str.CharPos(dayfile,slash) # MAX(CARDINAL) THEN INC(pb);END;
        IF Str.CharPos(dayfile,antislash) # MAX(CARDINAL) THEN INC(pb);END;
        IF pb=0 THEN
            Str.Prepend(dayfile,d);
            Str.Prepend(dayfile,u);
        END;
    END;

END buildDataFilePath;

PROCEDURE chkwhat (S:ARRAY OF CHAR   ):CARDINAL;
VAR
    isFemale,isEvent,isEpicene,isAlsoCelebrated:BOOLEAN;
    i:CARDINAL;
BEGIN
    IF same(S,"") THEN RETURN errEmptySearch;END;
    doCookEntry(isFemale,isEvent,isEpicene,isAlsoCelebrated,S);
    i:=0;
    IF isFemale         THEN INC(i); END;
    IF isEvent          THEN INC(i); END;
    IF isEpicene        THEN INC(i); END;
    IF isAlsoCelebrated THEN INC(i); END;
    IF i # 0 THEN RETURN errBadSearch;END;
    RETURN errNone;
END chkwhat;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    opt       : CARDINAL;
    S         : pathtype;
    R         : pathtype;

    doBeautify: BOOLEAN;
    doSort    : BOOLEAN;
    doFull    : BOOLEAN;
    doBirths,doDeaths,doEvents,doEgotist: BOOLEAN;
    doPagan,doLatin,doSaints,doDay : BOOLEAN;
    doFrame,LineWidth,maxcolumns,screenwidth:CARDINAL;
    dmy       : datetype;
    language  : languagetype;
    DEBUG,shortday,today,hugedata,redirection  : BOOLEAN;
    datafile, dataaltfile, privatefile, paganfile, saintsfile, dayfile: pathtype;
    whatsaint,parm1,parm2:str128;

    state     : (waiting,gotparm1,gotmonth);
    v         : LONGCARD;
    c1,c2     : CHAR;
    rc        : BOOLEAN;
    errcode   : CARDINAL;
BEGIN
    FIO.IOcheck:=FALSE;

    WrLn; (* here to beautify display *)

    DEBUG        := FALSE;
    redirection  := TRUE; (* should be FALSE but this way we force a CR at LineWidth *)
    screenwidth  := 80-1;     (* //ugly hard coded *)
    LineWidth    := screenwidth;
    maxcolumns   := screenwidth;

    doBeautify      := FALSE;
    doSort          := FALSE;
    doFull          := FALSE;
    doBirths        := TRUE;
    doDeaths        := TRUE;
    doEvents        := TRUE;
    doPagan         := FALSE;
    doSaints        := FALSE;
    doDay           := FALSE;
    doFrame         := frameDouble;
    doEgotist       := FALSE;
    doLatin         := FALSE;

    language        := english;
    hugedata        := FALSE;
    whatsaint       := "";

    dayfile         := ""; (* undefined *)

    state     := waiting;
    parmcount := Lib.ParamCount();

    IF parmcount = 0 THEN abort(errHelp,""); END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        RtrimBlanks(S); (* thank you, TopSpeed runtime library ! *)
        Str.Copy(R,S);
        UpperCase(R); cleanCLI(R); ReplaceChar(R,dquote,"");
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+

                                 "W"+delim+"WAIT"+delim+

                                 "N"+delim+"NEWLINE"+delim+"CR"+delim+"CRLF"+delim+

                                 "ni:"+delim+"ink1:"+delim+
                                 "np:"+delim+"paper1:"+delim+
                                 "hi:"+delim+"ink2:"+delim+
                                 "hp:"+delim+"paper2:"+delim+
                                 "b"+delim+"bios"+delim+

                                 "FR"+delim+"FRENCH"+delim+
                                 "S"+delim+"SORT"+delim+
                                 "A"+delim+"ALL"+delim+
                                 "NB"+delim+"NOBIRTHS"+delim+
                                 "NE"+delim+"NOEVENTS"+delim+
                                 "P"+delim+"PAGAN"+delim+
                                 "F:"+delim+"FRAME:"+delim+
                                 "W:"+delim+"WIDTH:"+delim+
                                 "X"+delim+"EXTRA"+delim+"XL"+delim+"XXL"+delim+
                                 "ND"+delim+"NODEATHS"+delim+
                                 "E"+delim+"EGO"+delim+
                                 "L"+delim+"LATIN"+delim+
                                 "PP"+delim+"PL"+delim+

                                 "K"+delim+"PAGING"+delim+
                                 "WW"+delim+"WK"+delim+"KW"+delim+"KK"+delim+

                                 "M"+delim+"MARTINE"+delim+"SAINTS"+delim+
                                 "MM"+delim+
                                 "MX"+delim+
                                 "MMX"+delim+
                                 "Z:"+delim+"FIND:"+delim+
                                 "ZZ:"+delim+
                                 "ZX:"+delim+
                                 "ZZX:"+delim+
                                 "DEBUG"+delim+
                                 "??"+delim+
                                 "V"+delim+"NOTREDIRECTED"+delim+
				 "D:"+delim+"DAY:"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5 :
            | 6,7,8,9:doBeautify  := TRUE;
            | 10,11:
            | 12,13:
            | 14,15:
            | 16,17:
            | 18,19:
            | 20,21:  language := french;
            | 22,23:  doSort := TRUE;
            | 24,25:  doFull := TRUE;
            | 26,27:  doBirths := FALSE;
            | 28,29:  doEvents := FALSE;
            | 30,31:  doPagan := TRUE;
            | 32,33:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minframe) OR (v > maxframe) ) THEN abort(errBadNumber,S); END;
                doFrame:=CARDINAL(v);
            | 34,35:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolumns) OR (v > LONGCARD(maxcolumns)) ) THEN abort(errWidthRange,"");END;
                LineWidth:=CARDINAL(v);
            | 36,37,38,39: hugedata:=TRUE;
            | 40,41: doDeaths:=FALSE;
            | 42,43: doEgotist:=TRUE;
            | 44,45: doLatin := TRUE;
            | 46,47: doPagan := TRUE; doLatin:=TRUE;
            | 48,49:
            | 50,51,52,53:
            | 54,55,56:    doSaints := TRUE; language:=french;
            | 57:          doSaints := TRUE; language:=english;
            | 58:          doSaints := TRUE; language:=french; hugedata:=TRUE;
            | 59:          doSaints := TRUE; language:=english;hugedata:=TRUE;

            | 60,61: IF same(whatsaint,"")=FALSE THEN abort(errOnlyOneSearch,S);END;
                     GetString(S, whatsaint);
                     errcode:= chkwhat(whatsaint);
                     IF errcode # errNone THEN abort(errcode,"");END;
                     language:=french;
            | 62:    IF same(whatsaint,"")=FALSE THEN abort(errOnlyOneSearch,S);END;
                     GetString(S, whatsaint);
                     errcode:= chkwhat(whatsaint);
                     IF errcode # errNone THEN abort(errcode,"");END;
                     language:=english;

            | 63:    IF same(whatsaint,"")=FALSE THEN abort(errOnlyOneSearch,S);END;
                     GetString(S, whatsaint);
                     errcode:= chkwhat(whatsaint);
                     IF errcode # errNone THEN abort(errcode,"");END;
                     language:=french;
                     hugedata:=TRUE;
            | 64:    IF same(whatsaint,"")=FALSE THEN abort(errOnlyOneSearch,S);END;
                     GetString(S, whatsaint);
                     errcode:= chkwhat(whatsaint);
                     IF errcode # errNone THEN abort(errcode,"");END;
                     language:=english;
                     hugedata:=TRUE;

            | 65:    DEBUG:=TRUE;
            | 66:    abort(errMoreHelp,"");
            | 67,68: redirection := FALSE;
            | 69,70: doDay:=TRUE;
	             GetString(S,dayfile);
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Copy(parm1,R);
            | gotparm1:
                Str.Copy(parm2,R);
            | gotmonth :
                abort(errParameter,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting :
        IF same(whatsaint,"") THEN abort(errMissingDate,"");END;

        getDateNow(dmy);
        buildDataFilePath (datafile,dataaltfile,privatefile,
	                  paganfile,saintsfile,dayfile,dmy.month,hugedata);
        IF FIO.Exists(saintsfile)=FALSE THEN abort(errMissingFile,saintsfile);END;
        doShowMatches (DEBUG,language,whatsaint,saintsfile);
        abort(errNone,"");

    | gotparm1:
        IF same(parm1,"?") THEN abort(errHelp,""); END;
        IF same(parm1,todaymarker) THEN
            getDateNow(dmy);
        ELSE
            IF parseDate(parm1,dmy)=FALSE THEN abort(errBadDMY,parm1);END;
        END;
    | gotmonth:
        Str.Append(parm1,dash);
        Str.Append(parm1,parm2);
        IF parseDate(parm1,dmy)=FALSE THEN abort(errBadDMY,parm1);END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    (* yes, yes, Mr Code Policeman, we do know a set or an enumeration would be better here *)
    i:=0;
    IF doBirths=FALSE THEN INC(i);END;
    IF doDeaths=FALSE THEN INC(i);END;
    IF doEvents=FALSE THEN INC(i);END;
    IF i = 3 THEN abort(errConflict,"-nb, -nd and -ne");END;

    IF doPagan THEN
        IF doSaints     THEN abort(errConflict,"-p and -m[m]");END;
        IF doEgotist    THEN abort(errConflict,"-p and -e");END;
        IF doDay        THEN abort(errConflict,"-p and -d:$");END;
    END;
    IF doSaints THEN
        IF doEgotist    THEN abort(errConflict,"-m[m] and -e");END;
        IF doDay        THEN abort(errConflict,"-m[m] and -d:$");END;
    END;
    IF doEgotist THEN
        IF doDay        THEN abort(errConflict,"-e and -d:$");END;
    END;


    IF hugedata THEN
        IF (doPagan OR doEgotist OR doDay) THEN abort(errConflict,"-p, -e, -d:$ and -x");END;
    END;


    buildDataFilePath (datafile,dataaltfile,privatefile,paganfile,saintsfile,dayfile,
    			dmy.month,hugedata);
    IF doPagan THEN
        shortday := (state=gotmonth);
        IF FIO.Exists(paganfile)=FALSE THEN abort(errMissingFile,paganfile);END;
        rc:=dmpPagan( DEBUG, doLatin,redirection,shortday, doDay,paganfile,
		      dmy, screenwidth,LineWidth,doFrame, language);
    ELSIF doSaints THEN
        today := (state # gotmonth);
        IF FIO.Exists(saintsfile)=FALSE THEN abort(errMissingFile,saintsfile);END;
        rc:=dmpSaints( DEBUG,redirection,today,saintsfile,dmy,
                       screenwidth,LineWidth,doFrame, language);

    ELSIF doDay THEN
        shortday := (state=gotmonth);
        IF FIO.Exists(dayfile)=FALSE THEN abort(errMissingFile,dayfile);END;
        rc:=dmpPagan( DEBUG, doLatin,redirection,shortday,doDay, dayfile, dmy,
                      screenwidth,LineWidth,doFrame, language);
    ELSE
        IF doEgotist THEN
            ; (* dmpData() will care about optional private file not existing *)
        ELSE
            IF FIO.Exists(datafile)=FALSE THEN (* first "???" form... *)
                Str.Copy(datafile,dataaltfile);    (* ... then "##" form *)
                IF FIO.Exists(datafile)=FALSE THEN abort(errMissingFile,datafile);END;
            END;
        END;
        rc:=dmpData( DEBUG, doSort,doFull,
                     doBirths,doDeaths,doEvents,doEgotist,redirection,
                     datafile,privatefile,dmy,language,LineWidth);
    END;
    IF rc=FALSE THEN abort(errAborted,"");END;

    IF doBeautify THEN WrLn; END;

    abort(errNone,"");
END DayMonth32.



(*

@echo off
if "%1" == "" goto god
set _p_=daymonth32
goto ok
:god
set _p_=daymonth
:ok

%_p_%      *          >%_p_%.rpt
%_p_%      1 2        >>%_p_%.rpt
%_p_% /s     *        >>%_p_%.rpt
%_p_% /s     1 2      >>%_p_%.rpt
%_p_% /a   *          >>%_p_%.rpt
%_p_% /a   1 2        >>%_p_%.rpt
%_p_% /s /a   *       >>%_p_%.rpt
%_p_% /S /a   1 2     >>%_p_%.rpt
%_p_% /x   1 2        >>%_p_%.rpt
%_p_% /p   1 2        >>%_p_%.rpt
%_p_% /pp  1 2        >>%_p_%.rpt

%_p_% /fr      *       >>%_p_%.rpt
%_p_% /fr      1 2     >>%_p_%.rpt
%_p_% /fr /s     *     >>%_p_%.rpt
%_p_% /fr /s     1 2   >>%_p_%.rpt
%_p_% /fr /a   *       >>%_p_%.rpt
%_p_% /fr /A   1 2     >>%_p_%.rpt
%_p_% /fr /s /a   *    >>%_p_%.rpt
%_p_% /fr /s /A   1 2  >>%_p_%.rpt
%_p_% /fr /x   1 2     >>%_p_%.rpt
%_p_% /fr /p   1 2     >>%_p_%.rpt
%_p_% /fr /pp  1 2     >>%_p_%.rpt

%_p_% /m   2 11        >>%_p_%.rpt
%_p_% /m   1 1         >>%_p_%.rpt
%_p_% /m   *           >>%_p_%.rpt
%_p_% /m   26 7        >>%_p_%.rpt
%_p_% /m   29 3        >>%_p_%.rpt
%_p_% /m   30 1        >>%_p_%.rpt

%_p_% /mx   2 11       >>%_p_%.rpt
%_p_% /mx   1 1        >>%_p_%.rpt
%_p_% /mx   *          >>%_p_%.rpt
%_p_% /mx   26 7       >>%_p_%.rpt
%_p_% /mx   29 3       >>%_p_%.rpt
%_p_% /mx   30 1       >>%_p_%.rpt

%_p_% /mm   2 11       >>%_p_%.rpt
%_p_% /mm   1 1        >>%_p_%.rpt
%_p_% /mm   *          >>%_p_%.rpt
%_p_% /mm   26 7       >>%_p_%.rpt
%_p_% /mm   29 3       >>%_p_%.rpt
%_p_% /mm   30 1       >>%_p_%.rpt

%_p_% /mmx  2 11       >>%_p_%.rpt
%_p_% /mmx  1 1        >>%_p_%.rpt
%_p_% /mmx  *          >>%_p_%.rpt
%_p_% /mmx  26 7       >>%_p_%.rpt
%_p_% /mmx  29 3       >>%_p_%.rpt
%_p_% /mmx  30 1       >>%_p_%.rpt

%_p_% /z:andre           >>%_p_%.rpt
%_p_% /z:aNdR           >>%_p_%.rpt
%_p_% /z:ANDRE           >>%_p_%.rpt
%_p_% /z:"jean baptiste" >>%_p_%.rpt
%_p_% /z:"Jean-Baptiste" >>%_p_%.rpt
%_p_% /z:serge           >>%_p_%.rpt
%_p_% /zx:serge          >>%_p_%.rpt
%_p_% /z:"martine"       >>%_p_%.rpt
%_p_% /zx:hilarion       >>%_p_%.rpt

*)


