(* ---------------------------------------------------------------
Title         Q&D Expression Evaluator
Overview
Notes         this is how software publishers should work :
              do not provide useless examples or snippets
              but real world code !
              yes, the whole thing should have been REWRITTEN,
              NOT just ENHANCED... but who cares ?
              now, it *is* useful at last

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Bugs          negative numbers are not directly supported :
              "-#" is a nono but "(0-#)" Kolossal Kludge is ok
Wish List     a complete rewrite of the parser so it handles text operators
              and other bases (at least hex and binary)
              check logic FOR <0 and >1 (see //FIXME)
              interactive (grab cli, compute, functions, save to log ?)

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 15 Mar 23 an ugly really Q&D port from EEVAL v1.0e for DOS
--------------------------------------------------------------- *)

MODULE eEval32;

IMPORT Lib;
IMPORT Str;
IMPORT Storage;
IMPORT MATHLIB;
IMPORT IO;
IMPORT FIO;

FROM IO IMPORT WrStr,WrLn;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "EEVAL32";
    ProgTitle     = "Q&D Expression Evaluator (Win32)";
    ProgVersion   = "v0.9 (from 1.0e for DOS)";
    ProgCopyright = "enhanced by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    ctrlZ         = CHR(26);
CONST
    suffixLocal   = "F";
    suffixKollabo = "E"; (* say NO to Yet Another Evil Empire : John Walker is righ here too ! *)

CONST
    (*
    yes, we know there are more clever ways of dealing with these numbers
    we'll use them when we rewrite the whole crap, eh eh...
    see //FIXME
    *)
    REALZERO      = LONGREAL(0.0);
    REALONE       = LONGREAL(1.0);

(* ------------------------------------------------------------ *)

CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errParse        = 3;
    errReadToken    = 4;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [option]... <expression>"+nl+
nl+
"a) Valid tokens in <expression> are :"+nl+
nl+
'   [0..9]             digits (only base 10 numbers are supported)'+nl+
'   "." ","            decimal separator'+nl+
'   " " "(" ")"'+nl+
'   "+" "-" "*" "/"'+nl+
'   "\"                integer division'+nl+
'   "%"                modulo'+nl+
'   "^"                power (from WinXP console please use "~" instead)'+nl+
nl+
"b) Legal suffixes for currency operations are :"+nl+
nl+
'   "'+suffixLocal  +'"                francs (default)'+nl+
'   "'+suffixKollabo+'"                EU occupation AMGOT-like currency'+nl+
nl+
"   John Walker was right about EU : it *is* Yet Another Evil Empire."+nl+
nl+
"c) Options can appear anywhere in line. They are :"+nl+
nl+
'   "="                format result as currency'+nl+
'   "!"                force American decimal format (default is French)'+nl+
'   "@"                do not beautify results'+nl+
'   "#[#[#[#]]]"       force fix 0, 4, 6 or 8 (default is fix 2)'+nl+
nl+
"d) Note this program is merely one of JPI TS M2 examples with many enhancements"+nl+
"   so it is now a small real-world tool (a command line calculator)"+nl+
"   instead of a useless small piece of source code :"+nl+
"   as such, it may still contain quirks from the original average parser"+nl+
"   which was designed for positive numbers handling and basic operations"+nl+
'   (negative numbers can still be handled if specified as "(0-number)").'+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" 1963*10000+2*100+1"+nl+
"           "+ProgEXEname+" = ! 1000f+2e"+nl+
"           "+ProgEXEname+" (0-4)*4+16"+nl+
"           "+ProgEXEname+" ### 355/113"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :       WrStr(helpmsg);
    | errOption :     Str.Concat(S,"Illegal ",einfo);Str.Append(S," option !");
    | errParse:       Str.Concat(S,einfo," !");
    | errReadToken:   Str.Concat(S,einfo," !");
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    kfrancs = LONGREAL (1.0);
    kdollaros=LONGREAL (6.55957);
    kdefault =kfrancs; (* kdollaros would lead to nonsense : 10e*2= 65*13 ! *)
VAR
    what : (mult,
            suffix,
            localsuffix,
            singular,
            plural,
            localsingular,
            localplural);
CONST
    firstndx = ORD(mult);
    lastndx  = ORD(localplural);
CONST
    defaultstringsFR=
"6.55957"+delim+
"E"+delim+
"F"+delim+
"unit en monnaie d'occupation"+delim+
"units en monnaie d'occupation"+delim+
"franc"+delim+
"francs";
    defaultstringsUS=
"6.55957"+delim+
"E"+delim+
"F"+delim+
"EU occupation currency unit"+delim+
"EU occupation currency units"+delim+
"French franc"+delim+
"French francs";

(* ------------------------------------------------------------ *)

PROCEDURE fmtreal (v:LONGREAL;fix:CARDINAL;fr,beautify:BOOLEAN;
                   VAR RR:ARRAY OF CHAR);
CONST
    decimalfr = comma;
    sepfr     = dot; (* or space *)
    decimalus = dot;
    sepus     = comma;
VAR
    S,R : str128;
    ok:BOOLEAN;
    i,len:CARDINAL;
BEGIN
    Str.FixRealToStr( ABS(v),fix,S,ok);
    IF ok THEN
        (* default is FR *)
        ReplaceChar(S,decimalus,decimalfr); (* replace dot with comma or... dot ! *)
        (* "*,##" *)
        len:=Str.CharPos(S,decimalfr); (* trick ! *)
        IF len=MAX(CARDINAL) THEN len:=Str.Length(S);END; (* fix 0 ok *)
        R := "";
        FOR i := 1 TO len DO
            Str.Prepend(R,S[len-i]);
            IF i < len THEN
                IF (i MOD 3) = 0 THEN Str.Prepend(R,sepfr); END;
            END;
        END;
        Str.Delete(S,0,len);  (* ",##" *)
        Str.Prepend(S,R);     (* "###.###"+",##" *)
        IF NOT(beautify) THEN ReplaceChar(S,sepfr,"");END;
        IF NOT(fr) THEN
            Str.Subst(S,decimalfr,"|"); (* the mcleod law : there can be only one *)
            ReplaceChar(S,sepfr,sepus); (* all of them *)
            Str.Subst(S,"|",decimalus);
        END;
        IF v < REALZERO THEN Str.Prepend(S,"-");END; (* //FIXME *)
    ELSE
        S := "???";
    END;
    Str.Copy(RR,S);
END fmtreal;

PROCEDURE align (pad:CHAR;VAR S1,S2:ARRAY OF CHAR);
VAR
    l1,l2,wi,i:CARDINAL;
BEGIN
    l1:=Str.Length(S1);
    l2:=Str.Length(S2);
    IF l1 < l2 THEN
        wi:=l2;
    ELSE
        wi:=l1;
    END;
    (* ugly but functional ! *)
    FOR i:=1 TO wi DO
        IF Str.Length(S1) < wi THEN Str.Prepend(S1,pad);END;
        IF Str.Length(S2) < wi THEN Str.Prepend(S2,pad);END;
    END;
END align;

PROCEDURE fmthowmuch (v:LONGREAL;sing,plur:ARRAY OF CHAR; VAR R:ARRAY OF CHAR);
BEGIN
    IF v > REALONE THEN (* //FIXME *)
        Str.Copy(R,plur);
    ELSE
        Str.Copy(R,sing);
    END;
END fmthowmuch;

(*
PROCEDURE getCli (VAR S : ARRAY OF CHAR);
CONST
    nullchar = CHR(0);
VAR
    i : CARDINAL;
BEGIN
    i := 0;
    LOOP
        S[i] := Lib.CommandLine^[i];         (* //XDS does not exist ! *)
        IF S[i] = nullchar THEN EXIT; END;
        INC(i);
    END;
    (* now, clean string *)
    cleantabs(S);
    LtrimBlanks(S);
    RtrimBlanks(S);
END getCli;
*)

PROCEDURE getCli (VAR S : ARRAY OF CHAR);
CONST
    nullchar = CHR(0);
VAR
    i,lastparm : CARDINAL;
    R : str128;
BEGIN
    Str.Copy(S,"");
    lastparm := Lib.ParamCount();
    FOR i := 1 TO lastparm DO
        Lib.ParamStr(R,i);
	Str.Append(S,R);
	IF i < lastparm THEN Str.Append(S,blank); END;
    END;
    (* now, clean string *)
    cleantabs(S);
    LtrimBlanks(S);
    RtrimBlanks(S);
END getCli;

(* ------------------------------------------------------------ *)

TYPE
    tokenType = (number,
                 add, sub, mul, divi, intdivi, power, modulo,
                 leftParen, rightParen,
                 done);
    setoftokensType = SET OF tokenType;

    treeType = POINTER TO treeRecordType;
    treeRecordType = RECORD
        CASE kind:tokenType OF
        | number :
            numberValue : LONGREAL;
        | add,sub,mul,divi,intdivi,power,modulo :
            left  : treeType;
            right : treeType;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    syntacticType = (init, expr, term, factor);

CONST
    exprTokens = setoftokensType { add,sub };
    termTokens = setoftokensType { mul,divi,intdivi,power,modulo };

(*
yes, yes, awful globerks ...
but we're merely enhancing TS code the Q&D way !
we don't care about writing a new parser...
and we admit we're not proud of it
besides, recursion almost forces this solution
*)

VAR
    cli,clicaps : str128;
    globndx : CARDINAL;
    globc : CHAR;
    token:tokenType;
    tokenNumberValue:LONGREAL;

PROCEDURE getchar (  ):CHAR ;
BEGIN
    INC(globndx);
    RETURN cli[globndx-1];
END getchar;

PROCEDURE readtoken;
VAR
    S:str128;
    i:CARDINAL;
    ok:BOOLEAN;
    oldc:CHAR;
    kmul : LONGREAL;
BEGIN
    kmul := kdefault;
    LOOP
        oldc := globc;
        globc := getchar();
        CASE oldc OF
        | ' ', tabul : ;
        | '+' : token := add; EXIT;
        | '-' : token := sub; EXIT; (* //FIXME what about negative numbers ? *)
        | '*' : token := mul; EXIT;
        | '/' : token := divi; EXIT;
        | '\' : token := intdivi; EXIT;
        | '~','^' : token := power;EXIT; (* //V10D "^" is eaten by WinXP console ! *)
        | '%' : token := modulo; EXIT;
        | '(' : token := leftParen; EXIT;
        | ')' : token := rightParen; EXIT;
        | charnull, cr, lf, ctrlZ : token := done; EXIT;
        | '0'..'9' : (* read a real number *)
            i := 1;
            S[0] := oldc;
            WHILE (globc >= '0') AND (globc <= '9') DO
                S[i] := globc;
                INC(i);
                globc := getchar();
            END;
            CASE CAP(globc) OF
            | dot, comma :
                globc:= dot; (* decimal point *)
                REPEAT (* read fraction part *)
                    S[i] := globc;
                    INC(i);
                    globc := getchar();
                UNTIL (globc < '0') OR (globc > '9');
                CASE CAP(globc) OF
                | suffixLocal:    globc:=getchar();kmul:=kfrancs;
                | suffixKollabo:  globc:=getchar();kmul:=kdollaros;
                ELSE ; (* //ISO fixed silly requirement *) END;
            | suffixLocal:        globc:=getchar();kmul:=kfrancs;   S[i]:=dot;INC(i);
            | suffixKollabo:      globc:=getchar();kmul:=kdollaros; S[i]:=dot;INC(i);
            ELSE
                S[i] := dot;
                INC(i);
            END;
            S[i] := CHR(0);
            tokenNumberValue := Str.StrToReal(S, ok);
            IF NOT ok THEN abort(errReadToken,"Bad number"); END;
            tokenNumberValue := tokenNumberValue * kmul;
            token := number;
            EXIT;
        ELSE
            abort(errReadToken,"Bad character");
        END;
    END;
END readtoken;

PROCEDURE parse(what:syntacticType):treeType;
VAR
    t,t1:treeType;
BEGIN
    CASE what OF
    | factor :
        IF token = leftParen THEN
            readtoken;
            t := parse(expr);
            IF token = rightParen THEN
                readtoken;
            ELSE
                abort(errParse,'Missing ")"');
            END;
        ELSIF token = number THEN
            Storage.ALLOCATE(t, SIZE(t^));
            t^.kind := number;
            t^.numberValue := tokenNumberValue;
            readtoken;
        ELSE
            abort(errParse,"Missing number");
        END;
    | term:
        t := parse(factor);
        WHILE ( token IN (termTokens) ) DO
            t1 := t;
            Storage.ALLOCATE(t, SIZE(t^));
            t^.kind := token;
            readtoken;
            t^.left := t1;
            t^.right := parse(factor);
        END;
    | expr:
        t := parse(term);
        WHILE ( token IN (exprTokens) ) DO
            t1 := t;
            Storage.ALLOCATE(t, SIZE(t^));
            t^.kind := token;
            readtoken;
            t^.left := t1;
            t^.right := parse(term);
        END;
    | init:
        globndx := 0;
        globc := getchar();
        readtoken;
        t := parse(expr);
        IF (token # done) THEN
            abort(errParse,"Missing operator");
        END;
     ELSE ; (* //ISO fixed silly requirement *) END;
     RETURN t;
END parse;

PROCEDURE eval(t:treeType):LONGREAL;
VAR
    vl,vr,v:LONGREAL;
BEGIN
    IF t^.kind = number THEN RETURN t^.numberValue; END;
    (* now we can eval *)
    vl:=eval(t^.left);
    vr:=eval(t^.right);
    CASE t^.kind OF
    | add :   v:= vl + vr;
    | sub :   v:= vl - vr;
    | mul :   v:= vl * vr;
    | divi:   v:= vl / vr;
    |intdivi: v:= ( vl - MATHLIB.Mod ( vl,vr ) ) / vr;
    |power  : v:= MATHLIB.Pow ( ABS(vl),vr );
              (* handle MATHLIB quirk *)
              IF vl < REALZERO THEN v:=-v;END; (* //FIXME *)
    | modulo: v:= MATHLIB.Mod ( vl,vr ); (* seems ok *)
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN v;
END eval;

(* ------------------------------------------------------------ *)

VAR
    msg : ARRAY [firstndx..lastndx] OF str128;
    i,p : CARDINAL;
    S,R,S1,S2:str128;
VAR
    t : treeType;
    result,valfrancs,valdollaros : LONGREAL;
    DEBUG,fr,fmtcurrency,beautify:BOOLEAN;
    fixval : CARDINAL;
BEGIN
    WrLn;
    DEBUG       := FALSE;
    beautify    := TRUE;
    fmtcurrency := FALSE;
    fr          := TRUE;
    fixval      := 2;

    getCli(cli);
    IF same(cli,"") THEN abort(errHelp,"");END;

    Str.Copy(clicaps,cli);
    UpperCase(clicaps);

    (* kludgy but we're not creating a program of ours here, after all ! *)
    FOR i:=1 TO 11 DO
        CASE i OF
        | 1 : S := "/?";
        | 2 : S := "-?";
        | 3 : S := "?";
        | 4 : S := "=";
        | 5 : S := "!";
        | 6 : S := "####"; (* longest first *)
        | 7 : S := "###";
        | 8 : S := "##";
	| 9 : S := "#";
        | 10: S := "@";
        | 11: S := "/DEBUG";
        | 12: S := "-DEBUG";
        ELSE ; (* //ISO fixed silly requirement *) END;
        p:=Str.Pos(clicaps,S);     (* yes, Code Police officer, this is ugly *)
        IF p # MAX(CARDINAL) THEN
            CASE i OF
            | 1,2,3 : abort(errHelp,"");
            | 4     : fmtcurrency := TRUE;
            | 5     : fr          := FALSE;
            | 6     : fixval      := 8;
            | 7     : fixval      := 6;
            | 8     : fixval      := 4;
	    | 9     : fixval      := 0;
            | 10    : beautify    := FALSE;
            | 11,12 : DEBUG       := TRUE;
            ELSE ; (* //ISO fixed silly requirement *) END;
            Str.Delete(clicaps,p,Str.Length(S)); (* brutal and kludgy *)
            Str.Delete(cli    ,p,Str.Length(S)); (* brutal and kludgy *)
        END;
    END;

    (* init strings *)
    IF fr THEN
        S:=defaultstringsFR;
    ELSE
        S:=defaultstringsUS;
    END;
    FOR i:=firstndx TO lastndx DO
        Str.ItemS ( msg[i], S, delim, i);
    END;

    t := parse(init);
    result := eval(t);

    IF fmtcurrency THEN
        valfrancs  := result;
        valdollaros:= result / kdollaros;

        fmtreal(valfrancs  ,fixval,fr,beautify, S);
        fmtreal(valdollaros,fixval,fr,beautify, R);
        align(blank,S,R);

        (* we could hide occasional apparent plural quirk with "Units : #" too ! *)

        fmthowmuch(valfrancs  , msg[ORD(localsingular)] , msg[ORD(localplural)] , S1);
        fmthowmuch(valdollaros, msg[ORD(singular)]      , msg[ORD(plural)]      , S2);

        WrStr(R);WrStr(" ");WrStr(S2);WrLn;
        WrStr(S);WrStr(" ");WrStr(S1);WrLn;
    ELSE
        fmtreal(result     ,fixval,fr,beautify, S);
        WrStr(S);WrLn;
    END;
    abort(errNone,"");
END eEval32.





(*

// useless original is here (PROG8.MOD) as a reminder :

MODULE prog8;
(* This program implements a simple interactive calculator *)
IMPORT IO,Str,Storage;

TYPE
  TokenType = (number, add, sub, mul, div, LeftParen,
                RightParen, end);
  SyntacticType = (main, exp, term, factor);
  TreeType = POINTER TO TreeRecordType;

  TreeRecordType = RECORD
    CASE kind:TokenType OF
    | number :
      NumberValue : LONGREAL;
    | add,sub,mul,div :
      left : TreeType;
      right : TreeType;
    END;
  END;

VAR
  c:CHAR;
  token:TokenType;
  TokenNumberValue:LONGREAL;

PROCEDURE error(s:ARRAY OF CHAR);
BEGIN
  IO.WrStr(s);
  IO.WrLn;
  HALT;
END error;

PROCEDURE readtoken;
VAR
  s:ARRAY[0..99] OF CHAR;
  i:[0..99];
  done:BOOLEAN;
  oldc:CHAR;
BEGIN
  LOOP
    oldc := c;
    c := IO.RdChar();
    CASE oldc OF
    | ' ' :
    | '+' : token := add; EXIT;
    | '-' : token := sub; EXIT;
    | '*' : token := mul; EXIT;
    | '/' : token := div; EXIT;
    | '(' : token := LeftParen; EXIT;
    | ')' : token := RightParen; EXIT;
    | CHAR(10),CHAR(13),CHAR(26) : token := end; EXIT;

    | '0'..'9' : (* read a real number *)
      i := 1; s[0] := oldc;
      WHILE (c >= '0') AND (c <= '9') DO
        s[i] := c;
        INC(i);
        c := IO.RdChar();
      END;
      IF c<>'.' THEN (* add decimal point if none in input *)
        s[i] := '.';
        INC(i);
      ELSE
        REPEAT (* read fraction part *)
          s[i] := c;
          INC(i);
          c := IO.RdChar();
        UNTIL (c < '0') OR (c > '9');
      END;
      s[i] := CHAR(0);
      TokenNumberValue := Str.StrToReal(s, done);
      IF NOT done THEN
        error('Bad number?');
      END;
      token := number;
      EXIT;
    ELSE
      error('Bad character');
    END;
  END;
END readtoken;

PROCEDURE read(what:SyntacticType):TreeType;
VAR t,t1:TreeType;
BEGIN
  CASE what OF
  | factor :
    IF token = LeftParen THEN
      readtoken;
      t := read(exp);
      IF token = RightParen THEN
        readtoken;
      ELSE
        error("Missing ')'");
      END;
    ELSIF token = number THEN
      Storage.ALLOCATE(t, SIZE(t^));
      t^.kind := number;
      t^.NumberValue := TokenNumberValue;
      readtoken;
    ELSE
      error('Missing number?');
    END;
  | term:
    t := read(factor);
    WHILE (token = mul) OR (token = div) DO
      t1 := t;
      Storage.ALLOCATE(t, SIZE(t^));
      t^.kind := token;
      readtoken;
      t^.left := t1;
      t^.right := read(factor);
    END;
  | exp:
    t := read(term);
    WHILE (token = add) OR (token = sub) DO
      t1 := t;
      Storage.ALLOCATE(t, SIZE(t^));
      t^.kind := token;
      readtoken;
      t^.left := t1;
      t^.right := read(term);
    END;
  | main :
    c := IO.RdChar();
    readtoken;
    t := read(exp);
    IF (token <> end) THEN
      error('Missing operator?');
    END;
  END;
  RETURN t;
END read;

PROCEDURE eval(t:TreeType):LONGREAL;
BEGIN
  CASE t^.kind OF
  | number : RETURN t^.NumberValue;
  | add : RETURN eval(t^.left) + eval(t^.right);
  | sub : RETURN eval(t^.left) - eval(t^.right);
  | mul : RETURN eval(t^.left) * eval(t^.right);
  | div : RETURN eval(t^.left) / eval(t^.right);
  END;
END eval;

VAR
  t:TreeType;
  result:LONGREAL;
BEGIN
  LOOP
    IO.WrStr('Enter expression : ');
    t := read(main);
    result := eval(t);
    IO.WrStr(' = ');
    IO.WrLngReal(result, 4, 0);
    IO.WrLn;
  END;
END prog8.

*)

