(* ---------------------------------------------------------------
Title         Q&D Every N
Overview      more general an EVENODD
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              original header size was variable,
              but a fixed-length header might sometimes be better an idea

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -r

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          in XDS JPI TopSpeed support libraries :-(
Wish List     are you kidding ?
              -i should show org date/time
              encrypted header ?
              headerless data ? (just use XTRACT)

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 25 Apr 19 an ugly really Q&D port from EVERYN v1.0 for DOS
--------------------------------------------------------------- *)

MODULE EveryN32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;


FROM IO IMPORT WrStr, WrLn;
FROM SYSTEM IMPORT BYTE,CARD16;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    progEXEname     = "EVERYN32";
    progTitle       = "Q&D Every N (Win32)";
    progVersion     = "v0.9 (from v1.0 for DOS)";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;
CONST
    extBang         = ".!"; (* .!02  ..  .!99 *)
    firstcount      = 1;
    mincount        = 2;
    maxcount        = 99;
    sRange          = "[2..99]";
    smincount       = "01";
    vMajor          = 1;
    vMinor          = 0;
    sDataAddress    = "$0114 (276)"; (* see splitheaderType *)
CONST
    placeholder = dquote+vbar+dquote;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParmOverflow     = 3;
    errSyntax           = 4;
    errExclusive        = 5;
    errJoker            = 6;
    errBadNum           = 7;
    errRange            = 8;
    errUselessExt       = 9;
    errNotFound         = 10;
    errOverwrite        = 11;
    errAlready          = 12;
    errReadOnly         = 13;
    errSplits           = 14;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
CONST
errmsg =
banner+nl+
nl+
"Syntax 1 : "+progEXEname+" [-s] <count> <source> [option]..."+nl+
"Syntax 2 : "+progEXEname+" [-c] <basename> [option]..."+nl+
"Syntax 3 : "+progEXEname+" <-f> <basename> <target> [option]..."+nl+
"Syntax 4 : "+progEXEname+" <-i> <file>"+nl+
nl+
"    -s[s] split (-ss = -s -o)"+nl+
"    -c[c] create (-cc = -c -o)"+nl+
"    -f[f] create (-ff = -f -o)"+nl+
"    -i    show split file header infos"+nl+
nl+
"    -o    overwrite"+nl+
"    -n    do not restore original date/time stamp (-c and -f only)"+nl+
nl+
"This program saves <source> content to <count> split files (syntax 1),"+nl+
"rebuilds source from split files (syntax 2 and syntax 3),"+nl+
"or shows split file header infos if any (syntax 4)."+nl+
nl+
"a) Split files extension is "+extBang+"## where ## goes from "+smincount+" to <count>."+nl+
"b) <basename> is filename of split files without extension."+nl+
"   target name comes from either header (syntax 2) or command line (syntax 3)."+nl+
"c) By design, split files and target are created in current directory."+nl+
"d) This program is best used to process compressed and/or encrypted files."+nl+
"e) Should raw data be necessary, it starts at this address : "+sDataAddress+"."+nl+
"f) Please note rebuilding source from split files is slow a process."+nl+
"g) The same executable run to split files must be used in order to rebuilt it !"+nl+
"h) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" 16 c:\z\foo.bin"+nl+
"           "+progEXEname+" foo"+nl+
"           "+progEXEname+" -i foo"+extBang+"00"+nl;
VAR
    S : str1024; (* in case we get a LFN *)
BEGIN
    CASE e OF
    | errHelp :        WrStr(errmsg);
    | errOption:       S := "Unknown "+placeholder+" option !";
    | errParmOverflow: S := placeholder+" is one parameter too many !";
    | errSyntax :      S := "Illegal syntax, please check help screen !";
    | errExclusive:    S := "-s[s], -c[c], -f[f] and -i options are mutually exclusive !";
    | errJoker:        S := placeholder+" should not contain any joker !";
    | errBadNum:       S := "Illegal "+placeholder+" value !";
    | errRange:        S := placeholder+" is out of "+sRange+" valid range !";
    | errUselessExt:   S := placeholder+" should not have an extension !";
    | errNotFound:     S := placeholder+" does not exist !";
    | errOverwrite:    S := "-o option seems required in order to create "+dquote+vbar+extBang+"##"+dquote+" !";
    | errAlready:      S := placeholder+" already exists !";
    | errReadOnly:     S := placeholder+" is read-only !";
    | errSplits:       S := 'Invalid "'+vbar+extBang+'##" set of files !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,vbar,einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (96 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBufferIn  : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
    ioBufferOut : ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
CONST
    dataBufferSize      = MAX(CARD16)-256-32; (* avoid pos+255 overflow beyond 65535 ! *)
    firstDataBufferByte = 0;
    maxDataBufferByte   = dataBufferSize-1;
VAR
    databuffer  : ARRAY [firstDataBufferByte..maxDataBufferByte] OF BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE strToCardnum (VAR n:CARDINAL; S:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    v:LONGCARD;
BEGIN
    v:=Str.StrToCard(S,10,ok);
    IF ok THEN
        ok := (v <= MAX(CARDINAL) );
        IF ok THEN n:=CARDINAL(v);END;
    END;
    RETURN ok;
END strToCardnum;

PROCEDURE numToStr (n,base:CARDINAL;wi:INTEGER;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr( LONGCARD(n),R,base,ok);
    IF ok THEN
        FOR i := (Str.Length(R)+1) TO CARDINAL(ABS(wi)) DO
            IF wi < 0 THEN
                Str.Append(R,padchar);
            ELSE
                Str.Prepend(R,padchar);
            END;
        END;
    ELSE
        R:="*** ERROR ! ***"; (* should never happen ! *)
    END;
    RETURN R;
END numToStr;

PROCEDURE wrq (S:ARRAY OF CHAR);
BEGIN
    WrStr(dquote);WrStr(S);WrStr(dquote);
END wrq;

CONST
    sepcolon = " : ";

PROCEDURE dmpstr (enquote:BOOLEAN;S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1); WrStr(sepcolon);
    IF enquote THEN
        wrq(S2);
    ELSE
        WrStr(S2);
    END;
    WrLn;
END dmpstr;

PROCEDURE dmplc(v:LONGCARD;S:ARRAY OF CHAR);
BEGIN
    WrStr(S);WrStr(sepcolon);
    IO.WrLngCard(v,0);WrLn;
END dmplc;

(* //FIXME well, write me ! *)

PROCEDURE LowerCaseAlt (S:ARRAY OF CHAR);
BEGIN
END LowerCaseAlt;

PROCEDURE zesame (S1,S2:ARRAY OF CHAR ):BOOLEAN;
BEGIN
    LowerCaseAlt(S1);
    LowerCaseAlt(S2);
    RETURN same(S1,S2);
END zesame;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ctrlz         = 032C; (* CHR(26) //XDS ! *)
    zemark        = ".##"+ctrlz;
    chDOS         = "D";
    chWin32       = "w";
    chExpectedOS  = chWin32; (* //WARNING ! chWin32 for unlikely XDS version ! *)
TYPE
    splitheaderType = RECORD
        magicmark : ARRAY[0..3] OF CHAR; (* end with ctrl-Z *)
        os        : CHAR;      (* "D" = DOS, "w" = Win32 *)
        version   : SHORTCARD;
        orgdt     : LONGCARD;
        orgfsize  : LONGCARD;
        totalcount: SHORTCARD; (* plain view ! *)
        thiscount : SHORTCARD; (* plain view ! *)
        orgfname  : pathtype;
    END;
    (* original source filename follows this structure *)

PROCEDURE buildHeader (VAR H:splitheaderType;
                       total,current:CARDINAL;hnd:FIO.File;fname:pathtype);
VAR
    i:CARDINAL;
BEGIN
    H.magicmark:= zemark;
    H.os       := chExpectedOS;
    H.version  := SHORTCARD(vMajor << 4 + vMinor);
    H.orgdt    := FIO.GetFileDate(hnd);
    H.orgfsize := FIO.Size(hnd);
    H.totalcount:=SHORTCARD(total);
    H.thiscount:= SHORTCARD(current);
    (* Lib.Fill( ADR(H.orgfname),SIZE(H.orgfname)," "); *)
    FOR i := 1 TO SIZE(H.orgfname) DO H.orgfname[i-1]:=" ";END;
    Str.Copy(H.orgfname,fname);
END buildHeader;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* don't bother with exact error code here : let's assume user has a brain ! *)

PROCEDURE ChkTargets (DEBUG,OVERWRITE,IGNORERO:BOOLEAN;
                     count:CARDINAL;base:pathtype  ):BOOLEAN;
VAR
    pb,i:CARDINAL;
    F:pathtype;
    hin:FIO.File;
BEGIN
    pb:=0;
    FOR i:=firstcount TO count DO
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));
        IF DEBUG THEN dmpstr(TRUE,"/// ChkTargets()",F);END;
        IF FIO.Exists(F) THEN
            IF OVERWRITE THEN
                IF fileIsRO(F) THEN
                    IF IGNORERO THEN
                        fileSetRW(F);
                    ELSE
                        INC(pb);
                    END;
                END;
            ELSE
                INC(pb);
            END;
        END;
    END;
    RETURN (pb=0);
END ChkTargets;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE procSplit (DEBUG,OVERWRITE,IGNORERO:BOOLEAN;
                    count:CARDINAL;source,base,ext:pathtype  );
VAR
    H:splitheaderType;
    hin,hout:FIO.File;
    p,j,i,got,wanted:CARDINAL;
    SRC,F:pathtype;
    S:str256;
    ok:BOOLEAN;
BEGIN
    IF DEBUG THEN
        dmpstr(TRUE, "Source",source);
        dmpstr(TRUE, "Base  ",base);
        dmpstr(FALSE,"Count ",numToStr(count,10,2,""));
    END;

    IF same(ext,"") THEN ext:=dot;END; (* cosmetic *)
    Str.Concat(SRC,base,ext);
    wanted:=(dataBufferSize DIV count) * count; (* multiple of count *)

    hin:=FIO.OpenRead(source);
    FIO.AssignBuffer(hin,ioBufferIn);

    FOR i:=firstcount TO count DO
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));

        hout:=FIO.Create(F);
        FIO.AssignBuffer(hout,ioBufferOut);
        buildHeader(H, count,i,hin,SRC); (* hin ! *)
        FIO.WrBin(hout,H,SIZE(H));
        S:="+++ Creating "+placeholder;
        Str.Subst(S,vbar,F);
        video(S,TRUE);

        FIO.Seek(hin,0); (* source from beginning *)
        LOOP
            got:=FIO.RdBin(hin,databuffer,wanted);
            IF got = 0 THEN EXIT; END;
            p:=i-1; (* every Nth *)
            LOOP
                FIO.WrBin(hout,databuffer[p],1);
                INC(p,count); (* p+count should never overflow buffer size ! *)
                IF p >= got THEN EXIT; END;
            END;
            IF got < wanted THEN EXIT;END;
        END;
        FIO.Close(hout);
        video(S,FALSE);
    END;

    FIO.Close(hin);

    S:="::: Processed "+placeholder;
    Str.Subst(S,vbar,source);
    WrStr(S);WrLn;
END procSplit;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE grabHeader (VAR H:splitheaderType;
                     source:pathtype):CARDINAL;
VAR
    got,pb:CARDINAL;
    hin:FIO.File;
BEGIN
    H.magicmark := "";
    H.os        := "?";
    H.totalcount:= 0;
    H.thiscount := 0;
    Str.Copy(H.orgfname,"");

    pb:=0;
    hin:=FIO.OpenRead(source);
    got:=FIO.RdBin(hin,H,SIZE(H));
    IF got # SIZE(H) THEN INC(pb);RETURN pb; END;

    IF same(H.magicmark,zemark)=FALSE THEN INC(pb);END;
    IF H.os # chExpectedOS THEN INC(pb);END; (* //WARNING *)

    FIO.Close(hin);
    RETURN pb;
END grabHeader;

PROCEDURE procAbout (DEBUG:BOOLEAN;source:pathtype  );
VAR
    H : splitheaderType;
    S : str256;
    pb:CARDINAL;
BEGIN
    pb:=grabHeader(H, source);

    IF pb # 0 THEN
        dmpstr(TRUE,"--- No valid header in ",source); (* DOS # Win32, among other problems *)
    ELSE
        CASE H.os OF
        | chDOS:   S:="DOS";
        | chWin32: S:="Win32";
        ELSE ; (* //ISO fixed silly requirement *) END;
        dmpstr            (TRUE, "::: O.S.           ",S);
        WrLn;
        dmpstr            (TRUE, "::: File name      ",source);
        S:="~ out of ~";
        Str.Subst(S,"~",numToStr( CARDINAL(H.thiscount), 10,1,""));
        Str.Subst(S,"~",numToStr( CARDINAL(H.totalcount),10,1,""));
        dmpstr            (FALSE,"::: File content   ",S);
        WrLn;
        dmpstr            (TRUE, "::: Target name    ",H.orgfname);
        dmplc  (H.orgfsize,      "::: Target filesize");
        (* //FIXME dump decoded H.orgdt LONGCARD *)
    END;
END procAbout;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* don't bother with exact error code here : let's assume user has a brain ! *)

PROCEDURE ChkSplits (VAR H:splitheaderType;
                    DEBUG,OVERWRITE,IGNORERO:BOOLEAN;base:pathtype):BOOLEAN;
VAR
    pb,i:CARDINAL;
    F:pathtype;
    hin:FIO.File;
    HH:splitheaderType;
    pbhere:BOOLEAN;
BEGIN
    Str.Concat(F,base,extBang);
    Str.Append(F,numToStr(firstcount,10,2,"0"));
    IF DEBUG THEN dmpstr(TRUE,"/// ChkSplits()",F);END;
    IF FIO.Exists(F)=FALSE THEN RETURN FALSE;END; (* *.!01 does not exist *)
    IF grabHeader (H, F) # 0 THEN RETURN FALSE;END; (* no valid *.!01 *)

    pb:=0;
    FOR i:=firstcount+1 TO CARDINAL(H.totalcount) DO (* 1 already checked *)
        pbhere:=TRUE;
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));
        IF DEBUG THEN dmpstr(TRUE,"/// ChkSplits()",F);END;
        IF FIO.Exists(F) THEN
            IF grabHeader(HH, F) = 0 THEN
                IF H.orgfsize = HH.orgfsize THEN
                    IF H.orgdt = HH.orgdt THEN
                        IF zesame(H.orgfname,HH.orgfname) THEN pbhere:=FALSE;END;
                    END;
                END;
            END;
        END;
        IF pbhere THEN INC(pb);END;
    END;
    RETURN (pb=0);
END ChkSplits;

PROCEDURE procRebuild (DEBUG,OVERWRITE,IGNORERO,ORGDT:BOOLEAN;
                      H:splitheaderType;target,base:pathtype);
VAR
    hout,hin:FIO.File;
    i,j,got,wanted,count:CARDINAL;
    fpos:LONGCARD;
    Htmp:splitheaderType;
    F:pathtype;
    S:str256;
BEGIN
    count:=CARDINAL(H.totalcount);

    hout:=FIO.Create(target);
    FIO.AssignBuffer(hout,ioBufferOut);

    FOR i:=firstcount TO count DO
        Str.Concat(F,base,extBang);
        Str.Append(F,numToStr(i,10,2,"0"));

        S:="+++ Processing "+placeholder;
        Str.Subst(S,vbar,F);
        video(S,TRUE);

        hin:=FIO.OpenRead(F);
        FIO.AssignBuffer(hin,ioBufferIn);

        got:=FIO.RdBin(hin,Htmp,SIZE(Htmp));

        fpos:=LONGCARD(i-1);
        wanted:=dataBufferSize;
        LOOP
            got:=FIO.RdBin(hin,databuffer,wanted);
            FOR j:=1 TO got DO
                FIO.Seek(hout,fpos); (* ugly but rebuilding a buffer is NOT faster *)
                FIO.WrBin(hout,databuffer[j-1],1);
                INC(fpos, LONGCARD(count));
            END;
            IF got # wanted THEN EXIT; END;
        END;
        FIO.Close(hin);
        video(S,FALSE);
    END;
    FIO.Close(hout);

    IF ORGDT THEN
        hout := FIO.Open(target);
        FIO.SetFileDate(hout,H.orgdt);
        FIO.Close(hout);
    END;

    S:="::: Rebuilt "+placeholder;
    Str.Subst(S,vbar,target);
    WrStr(S);WrLn;

END procRebuild;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (cmdnone, cmdsplit, cmdrebuild, cmdrebuilduser,cmdabout);

PROCEDURE newcmd (VAR cmd:cmdtype;wanted:cmdtype):BOOLEAN;
BEGIN
    IF cmd = wanted  THEN RETURN TRUE; END;
    IF cmd # cmdnone THEN RETURN FALSE;END;
    cmd:=wanted;
    RETURN TRUE;
END newcmd;

(* ------------------------------------------------------------ *)

CONST
    minparm = 1;
    maxparm = 2;
VAR
    lastparm,parmcount,i,opt : CARDINAL;
    S,R                : pathtype;
    target,source,base,uu,dd,nn,ee:pathtype; (* uu is so overdimensionned it's a shame *)
    count:CARDINAL;
    parm : ARRAY [minparm..maxparm] OF pathtype;
    cmd                : cmdtype;
    DEBUG,OVERWRITE,IGNORERO,ORGDT:BOOLEAN;
    baseheader : splitheaderType;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;

    WrLn;

    DEBUG     := FALSE;
    OVERWRITE := FALSE;
    IGNORERO  := FALSE;
    ORGDT     := TRUE;

    cmd       := cmdnone;

    lastparm := minparm-1;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S); cleantabs(R);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "r"+delim+"readonly"+delim+
                                   "OO"+delim+
                                   "x"+delim+"lfn"+delim+
                                   "DEBUG"+delim+

                                   "I"+delim+"INFO"+delim+"ABOUT"+delim+
                                   "S"+delim+"SPLIT"+delim+
                                   "SS"+delim+
                                   "sss"+delim+
                                   "C"+delim+"CREATE"+delim+"REBUILD"+delim+
                                   "CC"+delim+
                                   "ccc"+delim+
                                   "F"+delim+"TARGET"+delim+
                                   "FF"+delim+
                                   "fff"+delim+
                                   "N"+delim+"NOUPDATE"
                               );
            CASE opt OF
            | 1,2,3 :    abort(errHelp,"");
            | 4,5:       OVERWRITE := TRUE;
            | 6,7:       ; (* IGNORERO  := TRUE; *)
            | 8:         OVERWRITE := TRUE;
                         (* IGNORERO  := TRUE; *)
            | 9,10:      ; (* useLFN    := FALSE; *)
            | 11:        DEBUG     := TRUE;

            | 12,13,14:  IF newcmd(cmd,cmdabout)=FALSE THEN abort(errExclusive,"");END;
            | 15,16   :  IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
            | 17      :  IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
            | 18      :  IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
                         (* IGNORERO  := TRUE; *)
            | 19,20,21:  IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
            | 22      :  IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
            | 23      :  IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
                         (* IGNORERO  := TRUE; *)
            | 24,25   :  IF newcmd(cmd,cmdrebuilduser)=FALSE THEN abort(errExclusive,"");END;
            | 26      :  IF newcmd(cmd,cmdrebuilduser)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
            | 27      :  IF newcmd(cmd,cmdrebuilduser)=FALSE THEN abort(errExclusive,"");END;
                         OVERWRITE := TRUE;
                         (* IGNORERO  := TRUE; *)
            | 28,29   :  ORGDT     := FALSE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,S);END;
            parm[lastparm]:=S;
        END;
    END;

    CASE lastparm OF
    | minparm-1:
        abort(errSyntax,"");
    | minparm:
        CASE cmd OF
        | cmdabout : ;
        ELSE
            IF newcmd(cmd,cmdrebuild)=FALSE THEN abort(errExclusive,"");END;
        END;
    | minparm+1:
        CASE cmd OF
        | cmdrebuilduser: ;
        ELSE
            IF newcmd(cmd,cmdsplit)=FALSE THEN abort(errExclusive,"");END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | cmdnone :
        abort(errSyntax,""); (* should never happen *)
    | cmdsplit:
        S:=parm[minparm];
        source:=parm[minparm+1];
        IF strToCardnum(count,S)=FALSE THEN abort(errBadNum,S);END;
        IF ( (count < mincount) OR (count > maxcount) ) THEN abort(errRange,S);END;
        IF chkJoker(source) THEN abort(errJoker,source);END;
        IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source);END;
        qdSplitAllPath(source, uu,dd,nn,ee);
        IF ChkTargets(DEBUG,OVERWRITE,IGNORERO,count,nn)=FALSE THEN
            abort(errOverwrite,nn);
        END;
        procSplit(DEBUG,OVERWRITE,IGNORERO,count,source,nn,ee);
    | cmdrebuild,cmdrebuilduser:
        source:=parm[minparm];
        IF chkJoker(source) THEN abort(errJoker,source);END;
        qdSplitAllPath(source, uu,dd,nn,ee);
        IF same(ee,"")=FALSE THEN abort(errUselessExt,source);END;
        Lib.MakeAllPath(base,uu,dd,nn,"");
        IF ChkSplits(baseheader, DEBUG,OVERWRITE,IGNORERO,base)=FALSE THEN
            abort(errSplits,base);
        END;
        IF cmd=cmdrebuilduser THEN
            target:=parm[minparm+1];
            IF chkJoker(target) THEN abort(errJoker,target);END;
        ELSE
            target:=baseheader.orgfname;
        END;
        IF FIO.Exists(target) THEN
            IF OVERWRITE THEN
                IF fileIsRO(target) THEN
                    IF IGNORERO THEN
                        fileSetRW(target);
                    ELSE
                        abort(errReadOnly,target);
                    END;
                END;
            ELSE
                abort(errAlready,target);
            END;
        END;
        procRebuild(DEBUG,OVERWRITE,IGNORERO,ORGDT,baseheader,target,base);
    | cmdabout:
        source:=parm[minparm];
        IF chkJoker(source) THEN abort(errJoker,source);END;
        IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source);END;
        procAbout(DEBUG,source);
    ELSE ; (* //ISO fixed silly requirement *) END;

    abort(errNone,"");
END EveryN32.


