(* ---------------------------------------------------------------
Title         Q&D total32
Author        PhG
Overview      size of files in a directory
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              how silly, to duplicate TREE functionality...
              we handle floppy/hd/CDROM

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
			  -l
			  -w
			  -k
			  -r
			
              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Bugs          -w does not like 2Gb+ units and FAT32
Wish List     better ?:\ check/trap
              accept @filelist containing dirs ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 11 Feb 22 v0.9b bugfix dirs were limited to 16000 entries as in DOS version :-(
PhG 26 Oct 21 v0.9a removed useless -u option
PhG  2 Mar 18 an ugly really Q&D port from TOTAL v1.0t for DOS
--------------------------------------------------------------- *)

MODULE total32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

PROCEDURE UpperCaseAlt(VAR S:ARRAY OF CHAR); (* //FIXME *)
BEGIN
	UpperCase(S);
END UpperCaseAlt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;



(* ------------------------------------------------------------ *)

TYPE
    HUGECARD = LONGREAL;
CONST
    HUGEZERO = 0.0;
    HUGEONE  = 1.0;

(* ------------------------------------------------------------ *)

PROCEDURE vidinit ( useBios:BOOLEAN );
BEGIN
END vidinit;

PROCEDURE print (S : ARRAY OF CHAR  );
BEGIN
    IO.WrStr(S);
END print;

PROCEDURE newline (  );
BEGIN
    IO.WrLn;
END newline;

PROCEDURE colorheader ();
BEGIN
END colorheader;

PROCEDURE colorhelp ();
BEGIN
END colorhelp;

PROCEDURE colortext ();
BEGIN
END colortext;

PROCEDURE colorwarning ();
BEGIN
END colorwarning;

PROCEDURE getRows (  ):CARDINAL ;
CONST
	vrows = 25-1; (* //XDS *)
(*
VAR
    vrows  [00040H:0084H] : SHORTCARD; (* add 1 *)
*)	
BEGIN
    RETURN ( CARDINAL(vrows) +1 ); (* 25, 43, 50, etc. *)
END getRows;

PROCEDURE getColumns (  ):CARDINAL ;
CONST
	vcolumns = 80; (* //XDS *)
(*	
VAR
    vcolumns [00040H:004AH] : CARDINAL; (* a word : 40, 80, 132 *)
*)
BEGIN
    RETURN ( CARDINAL(vcolumns) );
END getColumns;

(* ------------------------------------------------------------ *)

CONST
    upper      = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lower      = "abcdefghijklmnopqrstuvwxyz";

    filenameset= "&~#{-_}$!";

    legalset   = upper+lower+digits+filenameset+colon+backslash+dot;

    netslash   = backslash+backslash;

TYPE
    scanmodetype = (normalandspecial,normalscan,specialscan);

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "TOTAL32";
    ProgTitle     = "Q&D Total (Win32)";
    ProgVersion   = "v0.9b (from v1.0t for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errUnknownOption    = 2;
    errParmOverflow     = 3;
    errMissingDirSpec   = 4;
    errJokerDir         = 5;
    errBadNameDir       = 6;
    errBadPath          = 7;
    errBadDir           = 8;
    errTooManyDirs      = 9;
    errNonsense         = 10;
    errRootOnly         = 11;
    errInvalid          = 12;
    errNonsensical      = 13;
    errPhantomUnit      = 14;
    errExclusive        = 15;
    errCmdEmpty         = 16;

    errEmptyDirHere     = 128;
    errNoEmptyDir       = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <directory> [option]..."+nl+
nl+
"  -d    list cumulative results for each subdirectory from <directory>"+nl+
"  -x    exclude subdirectories, analyzing only current directory"+nl+
"  -n    list only normal files (H and S excluded, default is -n -z)"+nl+
"  -z    list only special files (H or S required, default is -n -z)"+nl+
"  -e    list only empty subdirectories"+nl+
"  -p    sort by path"+nl+
"  -i    sort by LFN path"+nl+
"  -a    do not use graphics characters in separator lines"+nl+
"  -c    shorten paths according to columns count"+nl+
"  -t[t] terse mode showing total only (-tt = alternate terser display)"+nl+
"  -f    english group separator (default is french group separator)"+nl+
nl+
"a) Because of lazy design, directory count cannot exceed 65530 entries."+nl+
"b) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024;
BEGIN
    colorhelp;
    CASE e OF
    | errHelp :
        print(helpmsg);
    | errUnknownOption :
        Str.Concat(S,"Unknown ",einfo); Str.Append(S," option !");
    | errParmOverflow :
        Str.Concat(S,einfo," parameter is just one too many !");
    | errMissingDirSpec:
        S:="Missing directory specification !";
    | errJokerDir :
        S := "Jokers not allowed in directory specification !";
    | errBadNameDir :
        S := "Illegal characters in directory specification !";
    | errBadPath :
        Str.Concat(S,"Illegal ",einfo); Str.Append(S," directory specification !");
    | errBadDir :
        Str.Concat(S,einfo," directory does not exist !");
    | errTooManyDirs:
        Str.Concat(S,"Too many subdirectories in ",einfo);
        Str.Append(S," !");
    | errNonsense:
        Str.Concat(S,einfo," option is a nonsense with -w option !");
    | errRootOnly:
        Str.Concat(S,einfo," is not the root directory required with -w option !");
    | errInvalid:
        Str.Concat(S,"Invalid ",einfo); Str.Append(S," drive !");
    | errNonsensical:
        Str.Concat(S,einfo," option is a nonsense with -d option !");
    | errPhantomUnit:
        Str.Concat(S,einfo,": unit does not exist !");
    | errExclusive:
        S := "-n and -z options are mutually exclusive !";
    | errCmdEmpty:
        Str.Concat(S,einfo," option is a nonsense with -e, -k or -r options !");

    | errEmptyDirHere :
        S := "At least one empty directory found !";
    | errNoEmptyDir :
        S := "No empty directory found !";

    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    | errEmptyDirHere, errNoEmptyDir :
        ;
    ELSE
        print(ProgEXEname+" : "); print(S); newline;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

PROCEDURE getCurrentPath (VAR R : ARRAY OF CHAR);
VAR
    drive : SHORTCARD;
    unit  : CHAR;
BEGIN
    drive := FIO.GetDrive();
    unit  := CHR(drive + ORD("A") -1 );
    FIO.GetDir(drive,R); (* \path without trailing slash nor leading u: *)
    Str.Prepend(R,colon);
    Str.Prepend(R,unit); (* u:\path *)
    fixDirectory(R);     (* u:\path\ *)
END getCurrentPath;

(*
    assume path is in UPPERCASE ! legal variations upon u:\...\...

    .       use current path
      \xxx  prepend current unit
       xxx  prepend current path
    .\xxx   prepend current path

    u:\xxx  ok
    u:xxx   insert current path for u:
    u:.     use current path for u:
    u:      use current path for u: too even though it's ugly because no directory explicitely specified
    u:.\xxx insert current path for u:

*)

PROCEDURE buildCanonicalPath (base:ARRAY OF CHAR; VAR R : ARRAY OF CHAR):BOOLEAN;
VAR
    p         : CARDINAL;
    drive     : SHORTCARD;
    unit      : CHAR;
    S         : pathtype;
BEGIN
    p := Str.CharPos(R,colon);
    CASE p OF
    | 1 :                               (* unit specified *)
        IF CharCount(R,colon) # 1 THEN RETURN FALSE; END; (* more than one ":" *)

        IF R[0]=base[0] THEN
            Str.Copy(S,base);           (* current path of current unit again *)
        ELSE
            drive := SHORTCARD( ORD(R[0])-ORD("A")+1 );
            unit  := CHR(drive + ORD("A") -1 );
            FIO.GetDir(drive,S);
            Str.Prepend(S,colon);
            Str.Prepend(S,unit);
            fixDirectory(S);            (* u:\path\ *)
        END;

        CASE R[2] OF
        | dot :
            IF Str.Length(R)=3 THEN                      (* "U:." *)
                Str.Copy(R,S);
                RETURN TRUE;
            END;
            IF R[3] # backslash THEN RETURN FALSE; END;
            Str.Delete(R,0,4);                           (* "U:.\XXX" *)
            Str.Prepend(R,S);
        | backslash :                                    (* "U:\XXX" *)
            (* do nothing ! *)
        ELSE                                             (* "U:XXX" or "U:" *)
            Str.Delete(R,0,2);
            Str.Prepend(R,S);
        END;
    | MAX(CARDINAL):                    (* no unit specified *)
        CASE R[0] OF
        | dot :
            IF Str.Length(R)=1 THEN                      (* "." *)
                Str.Copy(R,base);
                RETURN TRUE;
            END;
            IF R[1] # backslash THEN RETURN FALSE; END;
            Str.Delete(R,0,2);                           (* ".\XXX" *)
            Str.Prepend(R,base);
        | backslash :                                    (* "\XXX" *)
            Str.Prepend(R,colon);
            Str.Prepend(R,base[0]);
        ELSE
            Str.Prepend(R,base);                         (* "XXX" *)
        END;
    ELSE
        RETURN FALSE;                   (* illegal, for ":" is either absent or at 1 *)
    END;
    IF Str.Pos(R,netslash) # MAX(CARDINAL) THEN RETURN FALSE;END;
    fixDirectory(R);                    (* just in case *)
    RETURN TRUE;
END buildCanonicalPath;

(* ah, we should have found a better name for QD_Box chkJoker ! ;-) *)

PROCEDURE chkJokersHere (S:ARRAY OF CHAR ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJokersHere;

PROCEDURE chkValidName (S:ARRAY OF CHAR ) : BOOLEAN;
VAR
    i : CARDINAL;
BEGIN
    IF Str.Pos(S,dotdot) # MAX(CARDINAL) THEN RETURN FALSE; END;
    IF Str.Pos(S,netslash) # MAX(CARDINAL) THEN RETURN FALSE; END;

    (* we no longer check other characters, for win95fr uses weirdoes ! *)
    (*
    FOR i := 0 TO (Str.Length(S)-1) DO
        IF Str.CharPos(legalset,S[i])=MAX(CARDINAL) THEN RETURN FALSE; END;
    END;
    *)
    RETURN TRUE;
END chkValidName;

PROCEDURE fixUnit (wasted:BOOLEAN;VAR S:ARRAY OF CHAR);
BEGIN
    IF wasted THEN
        IF Str.Match(S,"?:") THEN
            Str.Append(S,backslash); (* force "u:" to becomes "u:\" *)
        END;
    END;
END fixUnit;

(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtlc;

PROCEDURE fmtc (v : CARDINAL; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
BEGIN
    RETURN fmtlc (LONGCARD(v),pad,sep,field);
END fmtc;

PROCEDURE fmtstring (S:ARRAY OF CHAR; pad:CHAR; n:INTEGER ) : str80;
VAR
    R : str80;
BEGIN
    Str.Copy(R,S);
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(n) THEN EXIT; END;
        IF n < 0 THEN
            Str.Append(R,pad); (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtstring;

PROCEDURE fmtpercent (v:LONGREAL;pad:CHAR;sep:CHAR;field:INTEGER):str80;
CONST
    digits = 1; (* after dot/coma *)
VAR
    R : str80;
    ok: BOOLEAN;
BEGIN
    Str.FixRealToStr(v,digits,R,ok);
    Str.Subst(R,dot,sep);
    RETURN fmtstring(R,pad,field);
END fmtpercent;

PROCEDURE HUGEINC (VAR r:HUGECARD;n:HUGECARD );
BEGIN
    r := r + n;
END HUGEINC;

PROCEDURE fmthc (v : HUGECARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.FixRealToStr( LONGREAL(v),0,S,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmthc;

(* ------------------------------------------------------------ *)

CONST
    firstPath = 1;     (* was 0, but 1 required by Lib.QSort and by firstPath-1 of course ! *)
    maxPath   = 65530; (* was 16000 ; should do even with obscene win9X systems *)

TYPE
    ptrToEntry = POINTER TO entrytype;
    entrytype  = RECORD
        slen : SHORTCARD;
        string:CHAR; (* variable length *)
    END;
VAR
    Path : ARRAY[firstPath..maxPath] OF ptrToEntry; (* yes, we could use an index in entrytype too... *)

(* ------------------------------------------------------------ *)

PROCEDURE getentry (i:CARDINAL; VAR R : ARRAY OF CHAR);
CONST
    nullchar=CHR(0);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(Path[i]^.slen);
    Lib.FastMove( SYSTEM.ADR(Path[i]^.string),SYSTEM.ADR(R),len);
    R[len]:=nullchar; (* REQUIRED safety ! *)
END getentry;

PROCEDURE setentry ( i:CARDINAL; S : ARRAY OF CHAR  ) : BOOLEAN ;
VAR
    len,needed:CARDINAL;
BEGIN
    len    := Str.Length(S);
    needed := SIZE(entrytype)-SIZE(CHAR)+len;
        ALLOCATE(Path[i],needed);
        Path[i]^.slen := SHORTCARD(len);
        Lib.FastMove( SYSTEM.ADR(S),SYSTEM.ADR(Path[i]^.string),len);
    RETURN (Path[i] # NIL);
END setentry;

(* ------------------------------------------------------------ *)

VAR
    gForceLFNsort:BOOLEAN; (* globerk *)

PROCEDURE isLessAlpha (i,j : CARDINAL) : BOOLEAN;
VAR
    SI,SJ:pathtype; (* str128 *)
    shortform,longform:pathtype;
    errcode:CARDINAL;
BEGIN
    getentry(i,SI);
    getentry(j,SJ);

    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);
    IF Str.Compare(SI,SJ) < 0 THEN (* -1 is less *)
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END isLessAlpha;

PROCEDURE doSwap (i,j : CARDINAL);
VAR
    P : ptrToEntry;
BEGIN
    P:=Path[i];
    Path[i]:=Path[j];
    Path[j]:=P;
END doSwap;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirPath (VAR S : ARRAY OF CHAR);
BEGIN
    IF Str.Length(S)=0 THEN Str.Copy(S,backslash); END;
    fixDirectory(S);
END fixDirPath;

PROCEDURE isDirEntry (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isDirEntry;

(* ------------------------------------------------------------ *)

PROCEDURE doDir (DEBUG:BOOLEAN; root : ARRAY OF CHAR;
                 VAR index:CARDINAL;VAR err:BOOLEAN);
VAR
    path    : pathtype;
    S       : pathtype;
    entry   : FIO.DirEntry;
    found   : BOOLEAN;
BEGIN
    IF err THEN RETURN; END;
    IF index > maxPath THEN
        err:=TRUE;
        RETURN;
    END;
    (*
    Str.Copy(Path[index],root);
    fixDirPath(Path[index]); (* add required \ because it will be REQUIRED *)
    *)
    fixDirPath(root); (* add required \ because it will be REQUIRED *)
    IF DEBUG THEN print(root);newline;END;
    IF setentry(index,root)=FALSE THEN
        err:=TRUE;
        RETURN;
    END;

    Str.Copy(path,root);
    fixDirPath(path); (* add required \ *)
    Str.Append(path,stardotstar); (* root\*.* *)

    found := FIO.ReadFirstEntry(path,everything,entry);
    WHILE found DO
        Str.Copy(S,root);
        fixDirPath(S);
        Str.Append(S,entry.name); (* root\f8e3 *)
        IF isDirEntry(entry.name)=FALSE THEN (* skip . and .. *)
            IF aDD IN entry.attr THEN
                INC(index);
                doDir(DEBUG,S,index,err);
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
END doDir;

PROCEDURE buildPathList (rootdir : ARRAY OF CHAR;
                         flagRecurse,DEBUG : BOOLEAN;
                         VAR lastpath:CARDINAL) : BOOLEAN;
VAR
    i        : CARDINAL;
    error,rc : BOOLEAN;
BEGIN
    error := FALSE;
    i     := firstPath;
    IF flagRecurse THEN
        doDir(DEBUG,rootdir,i,error);
    ELSE
        fixDirPath(rootdir); (* just in case ! but should not be necessary here *)
        (* Str.Copy(Path[i],rootdir); *)
        IF DEBUG THEN print(rootdir);newline;END;
        IF setentry(i,rootdir)=FALSE THEN RETURN FALSE;END;
    END;
    lastpath := i;
    rc := NOT ( error ); (* reverse flag and return true if no error *)
    RETURN rc;
END buildPathList;

(* ------------------------------------------------------------ *)

PROCEDURE isRoot (S:ARRAY OF CHAR):BOOLEAN ;
BEGIN
    RETURN Str.Match(S,"?"+colon+backslash);
END isRoot;

(* ------------------------------------------------------------ *)

(*
333333333333333333333333333
111111111111111122222222222222
*)

CONST
    ENCLOSEME = TRUE;
    NOENCLOSE = FALSE;
    FORCENL   = TRUE;
    NONL      = FALSE;
    NOTSHORTENED=FALSE;

(*
we brutally start with "..." but we could perform an inner cut too
addNL is NONL when showing final stats with subdirs, else is FORCENL i.e. TRUE
0123456789
c:\z\x      ok
c:\z\xxxx   ok
c:\z\xxxxx  shorten or leave as is without newline ?
c:\z\xxxxxx shorten
*)

PROCEDURE dmppath (addNL,shortenpaths,enclose:BOOLEAN;wi:CARDINAL;S:ARRAY OF CHAR);
CONST
    prefix    = "...";
    prefixlen = 3;
VAR
    le,colcount:CARDINAL;
    R:str1024;
BEGIN
    Str.Copy(R,S);
    IF shortenpaths THEN
        colcount:=getColumns();
        le:=Str.Length(R);
        IF enclose THEN INC(le,2);END;
        IF (wi+le) >= colcount THEN
            Str.Delete(R,0,wi+le-colcount+1);
            Str.Delete(R,0,prefixlen);
            Str.Prepend(R,prefix);
        END;
    END;
    IF enclose THEN print(dquote);END;
    print(R);
    IF enclose THEN print(dquote);END;
    IF addNL THEN newline; END;
END dmppath;

PROCEDURE dumpDirStats (lowercase,useLFN,addNL,shortenpaths:BOOLEAN; sepgroup:CHAR;
                        wisize,wicount,wdir:CARDINAL;
                        dirsize:HUGECARD;nfiles:LONGCARD;ndirs:CARDINAL;
                        sep,sDir:ARRAY OF CHAR    );
VAR
    valstr:str80;
    shortform,longform:pathtype;
    errcode:CARDINAL;
    wi,seplen:CARDINAL;
BEGIN
    seplen:=Str.Length(sep);
    wi:=0;
    valstr:=fmthc(dirsize,blank,sepgroup,wisize);  print(valstr);print(sep);
    IF shortenpaths THEN INC(wi, Str.Length(valstr));INC(wi,seplen);END;
    valstr:=fmtlc(nfiles,blank,sepgroup,wicount);  print(valstr);print(sep);
    IF shortenpaths THEN INC(wi, Str.Length(valstr));INC(wi,seplen);END;
    valstr:=fmtc(ndirs,blank,sepgroup,wdir);       print(valstr);print(sep);
    IF shortenpaths THEN INC(wi, Str.Length(valstr));INC(wi,seplen);END;
            dmppath(addNL,shortenpaths,ENCLOSEME,wi,sDir);
END dumpDirStats;

PROCEDURE dumpEntry (lowercase,useLFN,addNL,shortenpaths,onlyempty:BOOLEAN; sepgroup:CHAR;
                     wisize,wicount:CARDINAL;
                     vsize:HUGECARD;count:LONGCARD;
                     sep,sDir:ARRAY OF CHAR  );
VAR
    valstr:str80;
    shortform,longform:pathtype;
    errcode,wi,seplen:CARDINAL;
BEGIN
    seplen:=Str.Length(sep);
    wi:=0;
    IF NOT(onlyempty) THEN
        valstr:=fmthc(vsize,blank,sepgroup,wisize);  print(valstr);print(sep);
        IF shortenpaths THEN INC(wi, Str.Length(valstr));INC(wi,seplen);END;
        valstr:=fmtlc(count,blank,sepgroup,wicount); print(valstr);print(sep);
        IF shortenpaths THEN INC(wi, Str.Length(valstr));INC(wi,seplen);END;
    END;
            dmppath(addNL,shortenpaths,ENCLOSEME,wi,sDir);
END dumpEntry;

(* ------------------------------------------------------------ *)

PROCEDURE fmtAboutSubdirs (VAR R:ARRAY OF CHAR;
                          showcount:BOOLEAN;sepgroup:CHAR;count:CARDINAL);
CONST
    widircount=1;
VAR
    valstr:str80;
BEGIN
    IF NOT(showcount) THEN
        (* Str.Copy(R," and subdirectories (if any)"); *)
        Str.Copy(R," and subdirs");
    ELSE
        (*
        IF count < 2 THEN
            Str.Copy(R, " and ~ subdirectory");
        ELSE
            Str.Copy(R, " and ~ subdirectories");
        END;
        *)
        IF count < 2 THEN
            Str.Copy(R, " and ~ subdir");
        ELSE
            Str.Copy(R, " and ~ subdirs");
        END;

        valstr:=fmtc(count,blank,sepgroup,widircount);
        Str.Subst(R,"~",valstr);
    END;
END fmtAboutSubdirs;

PROCEDURE fmtplural (VAR R:ARRAY OF CHAR; morethan1:BOOLEAN;S1,S2:ARRAY OF CHAR);
VAR
    S:str128;
BEGIN
    Str.Copy(R,S1);
    IF morethan1 THEN Str.Append(R,S2);END;
END fmtplural;

(* ------------------------------------------------------------ *)

CONST
    filler          = "$";
    sepa            = "  ";
    graphdash       = CHR(196);  txtdash  = "-";
    graphbar        = CHR(205);  txtbar   = "=";
CONST
    fsizefiller     = "$$$,$$$,$$$,$$$";
    filecountfiller =         "$$$,$$$";
    dircountfiller  =          "$$,$$$";
    pathfiller      = "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$"; (* 40 *)
CONST
    fsizeheader     = "           Size";
    filecountheader =         "  Files";
    dircountheader  =          "  Dirs";
    pathheader      = "Path";
    msgHSincluded   = " (HSRA)";
    msgHSexcluded   = " (RA)";
    msgHSonly       = " (HS)";

(* ------------------------------------------------------------ *)

PROCEDURE showStats (VAR rcode:CARDINAL;
                    lastpath:CARDINAL;scanmode:scanmodetype;sepgroup,sepdec:CHAR;
                    graphline,lowercase,useLFN,shortenpaths,verbose,terser:BOOLEAN;
                    onlyempty,sparebase,DEBUG :BOOLEAN;
                    freebytes,usedbytes,totalbytes:HUGECARD );
CONST
    header1 = fsizeheader+sepa+filecountheader+sepa+pathheader;
    header2 = fsizefiller+sepa+filecountfiller+sepa+pathfiller;
    placeholder="|";
VAR
    i        : CARDINAL;
    base     : pathtype;
    S,spec   : pathtype;  (* if VERY long a path *)
    R,bartop,barbot,sdyn: pathtype;
    found    : BOOLEAN;
    entry    : FIO.DirEntry;
    filecount,entrycount: LONGCARD;
    dirsize  : HUGECARD;
    totalcount:LONGCARD;
    totalsize :HUGECARD;
    ch,ch2    : CHAR;
    valstr    : str80;
    delta     : HUGECARD;
    percentwasted:LONGREAL;
    wifsize,wifilecount,widircount,errcode:CARDINAL;
    ok:BOOLEAN;
    countdirempty,countdirkilled:CARDINAL;
    Z:str1024; (* oversized but who knows ? *)
    shortform,longform:pathtype;
BEGIN
    countdirempty  := 0;
    countdirkilled := 0;

    wifsize    :=Str.Length(fsizefiller);
    wifilecount:=Str.Length(filecountfiller);
    widircount :=Str.Length(dircountfiller);
    IF graphline THEN
        ch := graphdash; ch2 := graphbar;
    ELSE
        ch := txtdash;   ch2 := txtbar;
    END;
    Str.Copy(bartop,header2);
    Str.Copy(barbot,header2);
    ReplaceChar(bartop,filler,ch);
    ReplaceChar(bartop,comma,ch);
    ReplaceChar(barbot,filler,ch2);
    ReplaceChar(barbot,comma,ch2);

    colorheader;

    ok:=( NOT(onlyempty) AND NOT(terser) );
    IF ok THEN
            print(header1);
            CASE scanmode OF
            | normalscan:       print(msgHSexcluded);
            | normalandspecial: print(msgHSincluded);
            | specialscan:      print(msgHSonly);
            ELSE ; (* //ISO fixed silly requirement *) END;
            newline;

        IF verbose THEN
            IF lastpath > firstPath THEN
                print(bartop);
            ELSE
                print(barbot);
            END;
            newline;
        END;
    END;

    colortext;

    FIO.EOF := FALSE; (* safety *)

    totalcount := 0;
    totalsize  := HUGEZERO;
    i := firstPath;
    IF (onlyempty AND sparebase) THEN INC(i);END; (* we won't show empty base directory *)
    LOOP
        IF i > lastpath THEN EXIT; END;
        (* Str.Copy(base,Path[i]); *)
        getentry(i,base);
        Str.Concat(spec,base,stardotstar);                  (* assume u:\xxx\ *)
        entrycount:= 0;
        filecount := 0;
        dirsize   := HUGEZERO;

        found := FIO.ReadFirstEntry(spec,everything,entry);   (* H S R A D *)
        WHILE found DO
            IF (aDD IN entry.attr) THEN
                IF isDirEntry(entry.name)=FALSE THEN (* skip . and .. *)
                    INC(entrycount); (* it's a directory *)
                END;
            ELSE
                CASE scanmode OF
                | specialscan: ok:=((aH IN entry.attr) OR (aS IN entry.attr));
                | normalscan : ok:=NOT ((aH IN entry.attr) OR (aS IN entry.attr));
                | normalandspecial:ok:=TRUE ;
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF ok THEN
                    Str.Concat(S,base,entry.name); (* uppercase *)
                    INC(filecount);
                    HUGEINC(dirsize, HUGECARD(entry.sizeL) ); (* //XDS *)
                END;
                INC(entrycount);
            END;
            found:=FIO.ReadNextEntry(entry);
        END;

        IF verbose THEN
            IF onlyempty THEN
                IF entrycount = 0 THEN (* dirsize may be 0 with empty files *)
                    INC(countdirempty);
                    dumpEntry (lowercase,useLFN,FORCENL,shortenpaths,onlyempty,sepgroup,wifsize,wifilecount,
                              dirsize,filecount,sepa,base);
                END;
            ELSE
                    dumpEntry (lowercase,useLFN,FORCENL,shortenpaths,onlyempty, sepgroup,wifsize,wifilecount,
                              dirsize,filecount,sepa,base);
            END;
        END;
        INC(totalcount,filecount);
        HUGEINC(totalsize,dirsize);

        INC(i);
    END;
    ok:=( NOT(onlyempty) AND NOT(terser) );
    IF ok THEN
            colorheader;

            IF verbose THEN
                IF lastpath > firstPath THEN
                    print(barbot);newline;

                    (* pre v1.0n
                    valstr:=fmthc(totalsize,blank,sepgroup,wifsize);
                    print(valstr);
                    print(sepa);
                    valstr:=fmtlc(totalcount,blank,sepgroup,wifilecount);
                    print(valstr);
                    *)

                    getentry(firstPath,sdyn);
                    dumpEntry (lowercase,useLFN,NONL,NOTSHORTENED,onlyempty, sepgroup,wifsize,wifilecount,
                              totalsize,totalcount,sepa,sdyn);
                    fmtAboutSubdirs(R,TRUE,sepgroup,lastpath-firstPath);
                    print(R);

                    newline;
                END;
            ELSE
                print(barbot);newline;
                getentry(firstPath,sdyn);

                colortext;

                dumpEntry (lowercase,useLFN,NONL,NOTSHORTENED,onlyempty, sepgroup,wifsize,wifilecount,
                          totalsize,totalcount,sepa,sdyn);
                IF lastpath > firstPath THEN
                    fmtAboutSubdirs(R,TRUE,sepgroup,lastpath-firstPath);
                    print(R);
                END;
                newline;
            END;
    END;

    colortext;

    ok:=( onlyempty AND NOT(terser) );
    IF ok THEN
        IF countdirempty = 0 THEN
            rcode:=errNoEmptyDir;
            print ("No empty directory found !");newline;  (* show something *)

            IF DEBUG THEN print ("::: rc = 255");newline; END;
        ELSE
            rcode:=errEmptyDirHere;

            IF DEBUG THEN print ("::: rc = 128");newline; END;
        END;
    ELSE
        IF terser THEN
            Z:='o=|  f=|  r=|  |  "|"'; (* fr *)
            Z:='b=|  f=|  d=|  |  "|"';

            valstr:=fmthc(totalsize,blank,sepgroup,wifsize);
            Str.Subst(Z,placeholder,valstr);

            valstr:=fmtlc(totalcount,blank,sepgroup,wifilecount);
            Str.Subst(Z,placeholder,valstr);

            valstr:=fmtc(lastpath-firstPath,blank,sepgroup,widircount);
            Str.Subst(Z,placeholder,valstr);

            CASE scanmode OF
            |normalscan :     valstr:="..RA";
            |normalandspecial:valstr:="HSRA";
            |specialscan:     valstr:="HS..";
            ELSE ; (* //ISO fixed silly requirement *) END;
            Str.Subst(Z,placeholder,valstr);

            getentry(firstPath,sdyn);
                    Str.Subst(Z,placeholder,sdyn);
            print(Z);newline;
        END;
        rcode:=errNone; (* for all *)
    END;

END showStats;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume trailing "\" *)

PROCEDURE getDirStats (scanmode:scanmodetype; S:ARRAY OF CHAR;
                      VAR totalsize:HUGECARD;
                      VAR nfiles:LONGCARD; VAR ndirs:CARDINAL );
VAR
    entry    : FIO.DirEntry;
    spec     : pathtype; (* safety *)
    found,ok : BOOLEAN;
BEGIN
    totalsize :=HUGEZERO;
    nfiles    :=0;
    ndirs     :=0;

    Str.Concat(spec,S,stardotstar);
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        IF (aDD IN entry.attr) THEN
            ok:=same(entry.name,dot);
            ok:=ok OR (same(entry.name,dotdot));
            IF NOT(ok) THEN INC(ndirs);END;
        ELSE
            CASE scanmode OF
            | specialscan: ok:=((aH IN entry.attr) OR (aS IN entry.attr));
            | normalscan : ok:=NOT ((aH IN entry.attr) OR (aS IN entry.attr));
            | normalandspecial:ok:=TRUE ;
            ELSE ; (* //ISO fixed silly requirement *) END;
            IF ok THEN
                HUGEINC(totalsize, HUGECARD(entry.sizeL) ); (* //FIXME *)
                INC(nfiles);
            END;
        END;
        found:=FIO.ReadNextEntry(entry);
    END;
END getDirStats;

PROCEDURE showCumul (VAR rcode:CARDINAL;
                    lastpath:CARDINAL;scanmode:scanmodetype;sepgroup:CHAR;
                    graphline,lowercase,useLFN,shortenpaths:BOOLEAN;
                    dirspec:ARRAY OF CHAR);
CONST
    header1 = fsizeheader+sepa+filecountheader+sepa+dircountheader+sepa+pathheader;
    header2 = fsizefiller+sepa+filecountfiller+sepa+dircountfiller+sepa+pathfiller;
VAR
    bartop,barbot : str128;
    ch,ch2   : CHAR;
    R,S,S0,base : pathtype;
    totalsize:HUGECARD;
    totalfiles,nfiles,znfiles:LONGCARD;
    totaldirs,ndirs,zndirs:CARDINAL;
    dirsize:HUGECARD;
    zdirsize:HUGECARD;
    refslashes,slashes:CARDINAL;
    i,j:CARDINAL;
    wifsize,wifilecount,widircount:CARDINAL;
BEGIN
    wifsize:=Str.Length(fsizefiller);
    wifilecount:=Str.Length(filecountfiller);
    widircount:=Str.Length(dircountfiller);
    IF graphline THEN
        ch := graphdash; ch2 := graphbar;
    ELSE
        ch := txtdash;   ch2 := txtbar;
    END;
    Str.Copy(bartop,header2);
    Str.Copy(barbot,header2);
    ReplaceChar(bartop,filler,ch);
    ReplaceChar(bartop,comma,ch);
    ReplaceChar(barbot,filler,ch2);
    ReplaceChar(barbot,comma,ch2);

    colorheader;

    print(header1);
    CASE scanmode OF
    |normalscan:       print(msgHSexcluded);
    |normalandspecial: print(msgHSincluded);
    |specialscan:      print(msgHSonly);
    ELSE ; (* //ISO fixed silly requirement *) END;
    newline;

    IF lastpath > firstPath THEN
        print(bartop);
    ELSE
        print(barbot);
    END;
    newline;

    colortext;

    Str.Copy(base,dirspec);
    fixDirectory(base);
    refslashes:=CharCount(base,backslash) +1;    (* "base\"+"*\" *)

    totalsize  :=HUGEZERO;
    totalfiles :=0;
    totaldirs  :=0;

    FOR i:=firstPath TO lastpath DO
        getentry(i,S);
        slashes:=CharCount(S,backslash);
        IF slashes < refslashes THEN    (* base *)
            getDirStats(scanmode,S,  dirsize,nfiles,ndirs);
            dumpDirStats (lowercase,useLFN,FORCENL,shortenpaths, sepgroup,wifsize,wifilecount,widircount,
                         dirsize,nfiles,ndirs,sepa,S);
        ELSIF slashes = refslashes THEN (* dir in base *)
            getDirStats(scanmode,S,  dirsize,nfiles,ndirs);
            FOR j:=firstPath TO lastpath DO
                getentry(j,S0);
                slashes:=CharCount(S0,backslash);
                IF ( (slashes > refslashes) AND (Str.Pos(S0,S)=0) ) THEN
                    getDirStats(scanmode,S0,  zdirsize,znfiles,zndirs);
                    HUGEINC(dirsize,zdirsize);
                    INC(nfiles,znfiles);
                    INC(ndirs,zndirs);
                END;
            END;
            dumpDirStats (lowercase,useLFN,FORCENL,shortenpaths, sepgroup,wifsize,wifilecount,widircount,
                         dirsize,nfiles,ndirs,sepa,S);
        ELSE                            (* subdir in dir in base *)
            dirsize:=HUGEZERO;
            nfiles :=0;
            ndirs  :=0;
        END;
        HUGEINC(totalsize,dirsize);
        INC(totalfiles,nfiles);
        INC(totaldirs,ndirs);
    END;

    colorheader;

    IF lastpath > firstPath THEN
        print(barbot);newline;
        dumpDirStats (FALSE, useLFN,NONL,NOTSHORTENED,sepgroup,wifsize,wifilecount,widircount,
                     totalsize,totalfiles,totaldirs,sepa,base);
        IF lastpath > firstPath THEN
            fmtAboutSubdirs(R,FALSE,sepgroup,lastpath-firstPath);
            print(R);
        END;
        newline;
    END;

    colortext;

    rcode:=errNone;
END showCumul;

PROCEDURE getsepgroup ( fr:BOOLEAN  ):CHAR ;
BEGIN
    IF fr THEN RETURN dot; END;
    RETURN comma;
END getsepgroup;

PROCEDURE getsepdec ( fr:BOOLEAN  ):CHAR ;
BEGIN
    IF fr THEN RETURN comma; END;
    RETURN dot;
END getsepdec;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWait = "Working, please wait... ";
VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype;
    state           : (waiting,gotdir);
    recurse,onlynormal,graphline,lowercase,shortenpaths,verbose,terser:BOOLEAN;
    useLFN          : BOOLEAN;
    quiet,grandtotal,alphasort,onlyempty,sparebase : BOOLEAN;
    DEBUG           : BOOLEAN;
    dirspec,base    : pathtype;
    lastdirndx      : CARDINAL;
    filecount       : CARDINAL;
    totalsize       : LONGCARD;
    freebytes,totalbytes,usedbytes : HUGECARD;
    shortform,orgdirspec:pathtype;
    errcode:CARDINAL;
    scanmode : scanmodetype;
    sepgroup,sepdec : CHAR;
BEGIN
    FIO.IOcheck := FALSE;

    newline; (* here for pretty output *)
    colortext;

    recurse   := TRUE;
    graphline := TRUE;
    lowercase := TRUE;
    verbose   := TRUE;
    terser    := FALSE;
    grandtotal:= FALSE;
    alphasort := FALSE;
    scanmode  := normalandspecial;
    useLFN    := TRUE;
    onlyempty := FALSE;
    sparebase := FALSE;
    quiet     := FALSE;
    sepgroup  := getsepgroup(TRUE);
    sepdec    := getsepdec(TRUE);
    gForceLFNsort:=FALSE;
    shortenpaths := FALSE;
    DEBUG     := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,""); END;

    state := waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "X"+delim+"EXCLUDE"+delim+
                                 "N"+delim+"NORMAL"+delim+
                                 "A"+delim+"ASCII"+delim+
                                 "u"+delim+"uppercase"+delim+
                                 "T"+delim+"TERSE"+delim+
                                 "w"+delim+"wasted"+delim+
                                 "D"+delim+"DD"+delim+
                                 "P"+delim+"PATH"+delim+
                                 "l"+delim+"lfn"+delim+
                                 "E"+delim+"EMPTY"+delim+
                                 "k"+delim+"kill"+delim+"del"+delim+
                                 "r"+delim+"killsubdirs"+delim+
                                 "DEBUG"+delim+
                                 "Q"+delim+"QUIET"+delim+
                                 "F"+delim+"US"+delim+"UK"+delim+
                                 "Z"+delim+"SPECIAL"+delim+
                                 "I"+delim+"LFNPATH"+delim+"PP"+delim+
                                 "C"+delim+"COLUMNS"+delim+
                                 "TT"
                              );
            CASE opt OF
            | 1,2,3 :   abort(errHelp,"");
            | 4,5:      recurse    := FALSE;
            | 6,7:      CASE scanmode OF
                        | normalandspecial,normalscan:
                            scanmode:=normalscan;
                        ELSE
                            abort(errExclusive,"");
                        END;
            | 8,9:      graphline  := FALSE;
            | 10,11:    lowercase  := FALSE;
            | 12,13:    verbose    := FALSE;
            | 14,15:    ;
            | 16,17:    grandtotal := TRUE;
            | 18,19:    alphasort  := TRUE;
            | 20,21:    ;
            | 22,23:    onlyempty  := TRUE;
            | 24,25,26: ;
            | 27,28:    ;
            | 29:       DEBUG      := TRUE;
            | 30,31:    quiet      := TRUE;
            | 32,33,34: sepgroup   := getsepgroup(FALSE);
                        sepdec     := getsepdec(FALSE);
            | 35,36:    CASE scanmode OF
                        | normalandspecial,specialscan:
                            scanmode:=specialscan;
                        ELSE
                            abort(errExclusive,"");
                        END;
            | 37,38,39: alphasort  := TRUE; gForceLFNsort:=TRUE;
            | 40,41:    shortenpaths := TRUE;
            | 42:       verbose :=FALSE; terser:=TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            CASE state OF
            | waiting   : Str.Copy(orgdirspec,S);
            | gotdir    : abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    IF state = waiting THEN abort(errMissingDirSpec,"");END;


    getCurrentPath(base); (* "u:\path\" *)
    IF same(orgdirspec,dot) THEN Str.Copy(orgdirspec,base);END;

    IF chkJokersHere(orgdirspec) THEN abort(errJokerDir,""); END;
    IF chkValidName(orgdirspec)=FALSE THEN abort(errBadNameDir,"");END;
            Str.Copy(dirspec,orgdirspec); (* we'll force an error *)
    UpperCaseAlt(dirspec); (* //V10Q fix : was UpperCase *)
    IF buildCanonicalPath(base,dirspec)=FALSE THEN abort(errBadPath,dirspec);END;
    IF isDirectory(dirspec)=FALSE THEN abort(errBadDir,dirspec);END;


    totalbytes := HUGEZERO; (* safety *)
    usedbytes  := HUGEZERO; (* safety *)
    freebytes  := HUGEZERO; (* safety *)
    IF grandtotal THEN
        IF NOT(recurse) THEN abort(errNonsensical,"-x");END;
        IF NOT(verbose) THEN abort(errNonsensical,"-t[t]");END;
        IF onlyempty    THEN abort(errNonsensical,"-e");END;
    END;
    IF onlyempty THEN
        IF NOT(verbose) THEN abort(errCmdEmpty,"-t[t]");END;
        IF grandtotal   THEN abort(errCmdEmpty,"-d");END;
        CASE scanmode OF
        | normalscan:        abort(errCmdEmpty,"-n");
        | specialscan:       abort(errCmdEmpty,"-z");
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    IF NOT(quiet) THEN video(msgWait,TRUE); END;
    IF buildPathList(dirspec,recurse,DEBUG,lastdirndx)=FALSE THEN
        abort(errTooManyDirs,dirspec);
    END;
        IF alphasort THEN Lib.QSort(lastdirndx,isLessAlpha,doSwap); END;
    IF NOT(quiet) THEN video(msgWait,FALSE); END;

    IF grandtotal THEN
        showCumul (errcode,
                  lastdirndx,scanmode,sepgroup,
                  graphline,lowercase,useLFN,shortenpaths,
                  dirspec);
    ELSE
        showStats (errcode,
                  lastdirndx,scanmode,sepgroup,sepdec,
                  graphline,lowercase,useLFN,shortenpaths,verbose,terser,
                  onlyempty,sparebase,DEBUG,
                  freebytes,usedbytes,totalbytes);
    END;

    abort(errcode,"");
END total32.



