(* ---------------------------------------------------------------
Title         Q&D Text Reformatter
Notes
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          ignore tags must have both before and after CRLFCRLF !
Wish List
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 29 Aug 23 v1.0 keep in sync with TXTFMT v1.2b for DOS
PhG 29 Oct 21 an ugly really Q&D port from TXTFMT v1.2a for DOS
--------------------------------------------------------------- *)

MODULE TxtFmt32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;
FROM SYSTEM IMPORT BYTE,ADR;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "TXTFMT32";
    ProgTitle     = "Q&D Text Reformatter (Win32)";
    ProgVersion   = "v1.0 (from v1.2b for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    CR         = CHR(13); (* 0D *)
    LF         = CHR(10); (* 0A *)
    Tab        = CHR(09); (* 09 *)
    Espace     = CHR(32); (* 20 *)
    FormFeed   = CHR(12); (* 0C *)
    CtrlZ      = CHR(26); (* 1A *)
    NL         = nl;
    dashdash   = dash+dash;
    DEFTAG1       = "$";
    DEFTAG2       = "*";
    DEFTAG3       = "!";
    DEFIGNORETAG  = DEFTAG1+DEFTAG2+DEFTAG3; (* chars must be different ! *)
    TAGLEN        = 3;
CONST
    msgWait         = " ..."; (* yep, leading space *)
    defaulttmpfile  = "~DEL_ME~.TMP";
    msgFilespec     = "Filespec         : "; (* see padded() *)
    msgBasedir      = "Basedir          : ";
    msgIncluded     = "Included         : ";
CONST
    extBAK          = ".BK!";
    extCOM          = ".COM";
    extEXE          = ".EXE";
    extDLL          = ".DLL";
    extOVR          = ".OVR";
    extOVL          = ".OVL";
    extDRV          = ".DRV";
    extZIP          = ".ZIP";
    extARJ          = ".ARJ";
    extLZH          = ".LZH";
    ext7Z           = ".7Z";
    skippedextensions = extBAK+delim+extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extZIP+delim+extARJ+delim+extLZH+delim+ext7Z;
CONST
    errNone          = 0;
    errHelp          = 1;
    errTooMany       = 2;
    errNoMatch       = 3;
    errAbort         = 4;
    errBadNumber     = 5;
    errDuplicate     = 6;
    errOption        = 7;
    errTooManyParms  = 8;
    errMissingSpec   = 9;
    errNonsense      = 10;
    errPageLength    = 11;
    errBadTag        = 12;
    errBadSpec       = 13;

PROCEDURE abort (e : CARDINAL;einfo:ARRAY OF CHAR);
CONST
(*
 0        1         2         3         4         5         6         7         8
 12345678901234567890123456789012345678901234567890123456789012345678901234567890
*)
    msgHelp=
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" <file(s)> [-t:#] [-t] [-g:$] [-s] [-q] [-z]"+nl+
"Syntax 2 : "+ProgEXEname+" <file(s)> <-w:#> [-t] [-g:$] [-s] [-q]"+nl+
"Syntax 3 : "+ProgEXEname+" <file(s)> <-p:#> [-c:#] [-i] [-c] [-s] [-q]"+nl+
"Syntax 4 : "+ProgEXEname+" <file(s)> <-u[:#]> [-s] [-q]"+nl+
"Syntax 5 : "+ProgEXEname+" <file(s)> <-f[f]> [-a] [-s] [-q]"+nl+
nl+
"This program reads an ASCII file then builds paragraphs from lines (syntax 1),"+nl+
"breaks paragraphs into lines (syntax 2), skips lines/columns (syntax 3),"+nl+
"expands tabs (syntax 4), or processes a fortune file (syntax 5)."+nl+
nl+
"  -z     force a new paragraph if line begins with a space or a tabulation"+nl+
"  -w:#   break paragraphs into lines counting at most # characters"+nl+
"  -p:#   page length (lines to keep together)"+nl+
"  -u[:#] expand tabs (default tab width is 8 unless specified with -u:#)"+nl+
"  -f[f]  process fortune file (-ff = start each paragraph with a tabulation)"+nl+
"  -t:#   tab width (default is 8)"+nl+
"  -t     syntax 1 and 2 : reformat text even between marker strings"+nl+
"         (marker string is a toggle and it must be on its own single line)"+nl+
'  -g:$   redefine marker string (3 symbols required, default is "'+DEFIGNORETAG+'")'+nl+
"  -c:#   count of lines to skip after page length (default is 1)"+nl+
"  -c     process columns instead of lines"+nl+
'  -a     start a paragraph for author (line beginning with "'+dash+'" or "'+dashdash+'")'+nl+
"  -i     inverse selection written to file"+nl+
"  -s     send output to screen instead of file (test mode)"+nl+
"  -q     quiet processing"+nl+
nl+
"a) Files with any of these extensions will not be processed :"+nl+
"   "+skippedextensions+nl+
"b) Each original file will be backuped with "+extBAK+" extension."+nl+
"c) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(msgHelp);
    | errTooMany :
        Str.Concat(S,"Too many files match ",einfo);Str.Append(S," specification !");
    | errNoMatch :
        Str.Concat(S,"No valid file matches ",einfo);Str.Append(S," specification !");
    | errBadNumber:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," number !");
    | errDuplicate:
        Str.Concat(S,einfo," has already been specified !");
    | errOption:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," option !");
    | errTooManyParms:
        Str.Concat(S,einfo," is one file specification too many !");
    | errMissingSpec:
        S := "No file was specified !";
    | errNonsense:
        S:="At least one option irrelevant to specified command !";
    | errPageLength:
        S := "-p:# was not specified !";
    | errBadTag:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" tag !');
    | errBadSpec:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," specification !");
    ELSE
        S := "How did you get HERE ?";
    END;
    CASE  e OF
    | errNone, errHelp, errAbort: ;
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT(e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    (* IF Available(needed)=FALSE THEN RETURN FALSE; END; //XDS *)
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        DEBUG :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
        found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
            Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        excludeme2 := isReservedPattern (entryname,skippedextensions );
        IF NOT(excludeme1 OR excludeme2) THEN
                dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr(msgIncluded);WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
            found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

(* ------------------------------------------------------------ *)

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

PROCEDURE WrQuoted (S:ARRAY OF CHAR);
BEGIN
    WrStr('"');
    WrStr(S);
    WrStr('"');
END WrQuoted;

PROCEDURE WrFname (S:pathtype );
BEGIN
        WrQuoted(S);
END WrFname;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = IObufferSize;
VAR
    IObufferIn : ARRAY [1..IObufferSize] OF BYTE;
    IObufferOut: ARRAY [1..IObufferSize] OF BYTE;

PROCEDURE donewname (source,cible:pathtype);
VAR
    tmpfile : pathtype;
BEGIN
    Str.Copy(tmpfile,defaulttmpfile);
    FIO.Rename (cible,tmpfile);
    FIO.Rename (source,cible);
    FIO.Rename (tmpfile,source);
END donewname;

(* ------------------------------------------------------------ *)

PROCEDURE BuildParagraphs (source,cible:pathtype;IGNORETAG : ARRAY OF CHAR;
                          tabwidth:CARDINAL;
                          restartatindent,usetag,verbose,sendtoscreen:BOOLEAN );
CONST
    MaxNL    = 3;
VAR
    wasCR       : BOOLEAN;
    wasLF       : BOOLEAN;
    wasNL       : BOOLEAN;
    nlnl        : CARDINAL;
    c,precedent : CHAR;
    got         : CARDINAL;
    htab,n      : LONGCARD; (* we may have very, very long paragraphs ! ;-) *)
    i           : CARDINAL;
    reformat    : BOOLEAN;
    tagcount    : CARDINAL;
    TAG1,TAG2,TAG3:CHAR;
    hndin    : FIO.File;
    hndout   : FIO.File;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
    steps    : CARDINAL;
    forcepara,wrtofile : BOOLEAN;
BEGIN
    IF sendtoscreen THEN
        verbose:=FALSE;
        wrtofile:=FALSE;
    ELSE
        wrtofile:=TRUE;
    END;

    IF wrtofile THEN WrStr("Reformatting ");WrFname(source); END;

    hndin:=FIO.OpenRead(source);
    FIO.AssignBuffer(hndin,IObufferIn);
    IF wrtofile THEN
        hndout := FIO.Create(cible);
        FIO.AssignBuffer(hndout,IObufferOut);
    ELSE
        hndout:=FIO.StandardOutput;
    END;

    TAG1:=IGNORETAG[0];
    TAG2:=IGNORETAG[1];
    TAG3:=IGNORETAG[2];

    wasCR :=TRUE;
    wasLF :=TRUE;
    wasNL :=TRUE;
    nlnl := 1;
    precedent := "";
    htab      := 0;

    reformat  := TRUE;
    tagcount  := 0;

    (* Work(cmdInit); *)
    addr:=0;
    steps := 10;
    fsize := FIO.Size(hndin); (* source *)
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);
    IF verbose THEN
        (* animInit(steps, " ", "", CHR(249), "", "\/" ); *)
    ELSE
        IF wrtofile THEN video(msgWait,TRUE);END;
    END;

    FIO.EOF := FALSE;

    LOOP
        IF FIO.EOF=TRUE THEN EXIT; END; (* pb at pass after first one! *)
        (* Work(cmdShow); *)
        IF verbose THEN
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                lastportion:=currportion;
            END;
        END;

        got := FIO.RdBin(hndin,c,1);
        IF got = 0 THEN EXIT; END;
        INC(addr);
        CASE c OF
        | CR :
          IF reformat=FALSE THEN
            FIO.WrBin(hndout,c,1);
          ELSE
            IF wasCR THEN
                wasNL := TRUE;
                nlnl := nlnl + 1;
                IF nlnl < MaxNL THEN FIO.WrBin (hndout, NL,2); htab:=0; END;
            END;
            IF wasLF THEN wasNL := TRUE; END;
            IF wasNL THEN
                nlnl := nlnl + 1;
                IF nlnl < MaxNL THEN FIO.WrBin(hndout,NL,2); htab:=0; END;
            END;
          END;
            wasCR := TRUE;
            wasLF := FALSE;
        | LF :
          IF reformat=FALSE THEN
            FIO.WrBin(hndout,c,1);
          ELSE
            IF wasLF THEN
                wasNL := TRUE;
                nlnl := nlnl + 1;
                IF nlnl < MaxNL THEN FIO.WrBin(hndout,NL,2); htab:=0; END;
            END;
            IF wasNL THEN
                nlnl := nlnl + 1;
                IF nlnl < MaxNL THEN FIO.WrBin(hndout,NL,2); htab:=0; END;
            END;
          END;
            wasLF := TRUE;
            wasCR := FALSE;

        | Espace :
          IF reformat=FALSE THEN
            FIO.WrBin(hndout,c,1);
          ELSE
            forcepara := restartatindent AND (wasCR OR wasLF); (* //V12A *)
            IF forcepara THEN

                FIO.WrBin(hndout,CR,1);
                FIO.WrBin(hndout,LF,1);

                htab:=0;
                FOR i:= 0 TO tabwidth DO (* //V12B *)
                    FIO.WrBin(hndout,Espace,1);INC(htab);
                END;
                wasCR:=FALSE;
                wasLF:=FALSE;
                wasNL:=TRUE;
            ELSE
                IF ((wasCR = FALSE) AND (wasLF = FALSE)) THEN
                    IF precedent <> Espace THEN
                        FIO.WrBin(hndout,Espace,1); INC(htab);
                    END;
                END;
            END;
          END;
        | Tab :
          IF reformat=FALSE THEN
            FIO.WrBin(hndout,c,1);
          ELSE
            forcepara := restartatindent AND (wasCR OR wasLF); (* //V12A *)
            IF forcepara THEN

                FIO.WrBin(hndout,CR,1);
                FIO.WrBin(hndout,LF,1);

                htab:=0;
                FOR i:= 0 TO tabwidth DO (* //V12B *)
                    FIO.WrBin(hndout,Espace,1);INC(htab);
                END;
                wasCR:=FALSE;
                wasLF:=FALSE;
                wasNL:=TRUE;
            ELSE
                IF tabwidth = 0 THEN
                    c := Espace;
                    IF ((wasCR = FALSE) AND (wasLF = FALSE)) THEN
                        IF precedent <> Espace THEN
                            FIO.WrBin(hndout,Espace,1); INC(htab);
                        END;
                    END;
                ELSE
                    n := ( ( htab DIV LONGCARD(tabwidth) ) + 1 ) * LONGCARD(tabwidth);
                    DEC(n,htab);
                    FOR i := 1 TO CARDINAL(n) DO
                        FIO.WrBin(hndout,Espace,1); INC(htab);
                    END;
                END;
            END;
          END;

        | FormFeed :
          IF reformat=FALSE THEN
            FIO.WrBin(hndout,c,1);
          END ;
        | CtrlZ :
          IF reformat=FALSE THEN
            FIO.WrBin(hndout,c,1);
          END;
        ELSE
            IF usetag THEN
                IF c = TAG1 THEN
                    tagcount:=1;
                ELSIF c = TAG2 THEN
                    IF precedent = TAG1 THEN INC(tagcount);END;
                ELSIF c = TAG3 THEN
                    IF precedent = TAG2 THEN INC(tagcount);END;
                    IF tagcount=TAGLEN THEN
                        reformat := NOT(reformat);
                        tagcount:=0;
                    END;
                END;
            END;
            IF reformat THEN
                IF wasNL = FALSE THEN
                    IF (wasCR OR wasLF ) THEN
                        FIO.WrBin(hndout,Espace,1); INC(htab);
                    END;
                END;
            END;
            (* remember here char is anything but already filtered ones ! *)
            FIO.WrBin(hndout,c,1);INC(htab);
            wasCR := FALSE;
            wasLF := FALSE;
            wasNL := FALSE;
            nlnl := 0;
        END;
        precedent := c;
    END;
    (* Work(cmdStop); *)
    IF verbose THEN
    ELSE
        IF wrtofile THEN video(msgWait,FALSE);END;
    END;

    FIO.Close(hndin);
    FIO.WrBin (hndout,NL,2);
    IF wrtofile THEN
        FIO.Flush(hndout);
        FIO.Close(hndout);
        donewname(source,cible);
        WrLn;
    END;
END BuildParagraphs;

(* ------------------------------------------------------------ *)

CONST
    hugestrsize = 0C000H; (* is 49152, was 24576, should be more than enough *)
VAR
    hugestr : ARRAY [0..hugestrsize-1] OF CHAR;
(*
    basePos : CARDINAL;
    baseLen : CARDINAL;
*)

PROCEDURE dmpTTXfile (VAR paragraph:ARRAY OF CHAR;width:CARDINAL;
                      VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTXfile;

PROCEDURE BreakLines (source,cible:pathtype;IGNORETAG : ARRAY OF CHAR;
                     count:CARDINAL;
                     usetag,verbose,sendtoscreen:BOOLEAN );
VAR
    S : str256; (* oversized ! *)
    continue,reformat : BOOLEAN;
    wrtofile : BOOLEAN;
    hndin    : FIO.File;
    hndout   : FIO.File;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
    steps    : CARDINAL;
BEGIN
    IF sendtoscreen THEN
        verbose:=FALSE;
        wrtofile:=FALSE;
    ELSE
        wrtofile:=TRUE;
    END;

    IF wrtofile THEN WrStr("Breaking ");WrFname(source); END;

    hndin := FIO.OpenRead(source);
    FIO.AssignBuffer(hndin,IObufferIn);
    IF wrtofile THEN
        hndout := FIO.Create(cible);
        FIO.AssignBuffer(hndout,IObufferOut);
    ELSE
        hndout:=FIO.StandardOutput;
    END;

    reformat := TRUE;

    (* Work(cmdInit); *)
    addr:=0;
    steps := 10;
    fsize := FIO.Size(hndin); (* source *)
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);
    IF verbose THEN
        (* animInit(steps, " ", "", CHR(249), "", "\/" ); *)
    ELSE
        IF wrtofile THEN video(msgWait,TRUE);END;
    END;

    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        (* Work(cmdShow); *)
        IF verbose THEN
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                lastportion:=currportion;
            END;
        END;

        FIO.RdStr(hndin,hugestr);
        INC(addr, LONGCARD(Str.Length(hugestr)) );
        IF hugestr[0] = CHR(0) THEN
            FIO.WrLn(hndout);
        ELSE
            IF usetag THEN
                IF same(IGNORETAG,hugestr) THEN
                    reformat := NOT(reformat); (* if toggled to TRUE, will autohandle dump of IGNORETAG *)
                END;
            END;
            IF reformat THEN
                continue:=dmpTTXfile(hugestr,count,S,TRUE);
                WHILE continue DO
                    FIO.WrStr(hndout,S);
                    FIO.WrLn(hndout);
                    continue:=dmpTTXfile(hugestr,count,S,FALSE);
                END;
            ELSE
                FIO.WrStr(hndout,hugestr);
                FIO.WrLn(hndout);
            END;
        END;
    END;
    (* Work(cmdStop); *)
    IF verbose THEN
    ELSE
        IF wrtofile THEN video(msgWait,FALSE);END;
    END;

    FIO.Close(hndin);
    IF wrtofile THEN
        FIO.Flush(hndout);
        FIO.Close(hndout);
        donewname(source,cible);
        WrLn;
    END;
END BreakLines;

(* ------------------------------------------------------------ *)

PROCEDURE SkipLines (source,cible : pathtype;
                     pagelength,count:CARDINAL;
                     inverse,verbose,sendtoscreen:BOOLEAN );
VAR
    i,j:CARDINAL;
    state : (keeping,skipping);
    wrtofile : BOOLEAN;
    hndin    : FIO.File;
    hndout   : FIO.File;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
    steps    : CARDINAL;
BEGIN
    IF sendtoscreen THEN
        verbose:=FALSE;
        wrtofile:=FALSE;
    ELSE
        wrtofile:=TRUE;
    END;

    IF wrtofile THEN WrStr("Cleaning ");WrFname(source); END;

    hndin := FIO.OpenRead(source);
    FIO.AssignBuffer(hndin,IObufferIn);
    IF wrtofile THEN
        hndout := FIO.Create(cible);
        FIO.AssignBuffer(hndout,IObufferOut);
    ELSE
        hndout := FIO.StandardOutput; (* DOS standard output will do here *)
    END;

    state := keeping;
    i:=0;

    (* Work(cmdInit); *)
    addr:=0;
    steps := 10;
    fsize := FIO.Size(hndin); (* source *)
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);
    IF verbose THEN
        (* animInit(steps, " ", "", CHR(249), "", "\/" ); *)
    ELSE
        IF wrtofile THEN video(msgWait,TRUE);END;
    END;

    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        (* Work(cmdShow); *)
        IF verbose THEN
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                lastportion:=currportion;
            END;
        END;

        FIO.RdStr(hndin,hugestr);
        INC(addr, LONGCARD(Str.Length(hugestr)) );
        IF (hugestr[0]=CHR(0)) AND FIO.EOF THEN EXIT; END;
        CASE state OF
        | keeping:
            INC(i);
            IF i > pagelength THEN
                IF inverse THEN
                    FIO.WrStr(hndout,hugestr);
                    FIO.WrLn(hndout);
                END;
                state:=skipping;
                j:=0;
                INC(j); (* eh, we just skipped our first line ! *)
            ELSE
                IF NOT (inverse) THEN
                    FIO.WrStr(hndout,hugestr);
                    FIO.WrLn(hndout);
                END;
            END;
        | skipping:
            INC(j);
            IF j > count THEN
                IF NOT (inverse) THEN
                    FIO.WrStr(hndout,hugestr);
                    FIO.WrLn(hndout);
                END;
                state:=keeping;
                i := 0;
                INC(i); (* eh, we just kept our first line ! *)
            ELSE
                IF inverse THEN
                    FIO.WrStr(hndout,hugestr);
                    FIO.WrLn(hndout);
                END;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    (* Work(cmdStop); *)
    IF verbose THEN
    ELSE
        IF wrtofile THEN video(msgWait,FALSE);END;
    END;

    FIO.Close(hndin);
    IF wrtofile THEN
        FIO.Flush(hndout);
        FIO.Close(hndout);
        donewname(source,cible);
        WrLn;
    END;
END SkipLines;

(* ------------------------------------------------------------ *)

PROCEDURE SkipColumns (source,cible :pathtype;
                       collength,count:CARDINAL;
                       inverse,verbose,sendtoscreen:BOOLEAN );
VAR
    i,j,p,len:CARDINAL;
    state : (keeping,skipping);
    ch:CHAR;
    wrtofile : BOOLEAN;
    hndin    : FIO.File;
    hndout   : FIO.File;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
    steps    : CARDINAL;
BEGIN
    IF sendtoscreen THEN
        verbose:=FALSE;
        wrtofile:=FALSE;
    ELSE
        wrtofile:=TRUE;
    END;

    IF wrtofile THEN WrStr("Cleaning ");WrFname(source); END;

    hndin := FIO.OpenRead(source);
    FIO.AssignBuffer(hndin,IObufferIn);
    IF wrtofile THEN
        hndout := FIO.Create(cible);
        FIO.AssignBuffer(hndout,IObufferOut);
    ELSE
        hndout := FIO.StandardOutput;
    END;

    (* Work(cmdInit); *)
    addr:=0;
    steps := 10;
    fsize := FIO.Size(hndin); (* source *)
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);
    IF verbose THEN
        (* animInit(steps, " ", "", CHR(249), "", "\/" ); *)
    ELSE
        IF wrtofile THEN video(msgWait,TRUE);END;
    END;

    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        (* Work(cmdShow); *)
        IF verbose THEN
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                lastportion:=currportion;
            END;
        END;

        FIO.RdStr(hndin,hugestr);
        len := Str.Length(hugestr);
        INC(addr, LONGCARD( len ) );
        IF (hugestr[0]=CHR(0)) AND FIO.EOF THEN EXIT; END;
        p:=0;
        i:=0;
        state := keeping;
        LOOP
            IF p=len THEN EXIT; END;
            ch:=hugestr[p];
            CASE state OF
            | keeping:
                INC(i);
                IF i > collength THEN
                    IF inverse THEN FIO.WrChar(hndout,ch); END;
                    state:=skipping;
                    j:=0;
                    INC(j); (* eh, we just skipped our first char ! *)
                ELSE
                    IF NOT (inverse) THEN FIO.WrChar(hndout,ch); END;
                END;
            | skipping:
                INC(j);
                IF j > count THEN
                    IF NOT (inverse) THEN FIO.WrChar(hndout,ch); END;
                    state:=keeping;
                    i := 0;
                    INC(i); (* eh, we just kept our first char ! *)
                ELSE
                    IF inverse THEN FIO.WrChar(hndout,ch); END;
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(p);
        END;
        FIO.WrLn(hndout);
    END;
    (* Work(cmdStop); *)
    IF verbose THEN
    ELSE
        IF wrtofile THEN video(msgWait,FALSE);END;
    END;

    FIO.Close(hndin);
    IF wrtofile THEN
        FIO.Flush(hndout);
        FIO.Close(hndout);
        donewname(source,cible);
        WrLn;
    END;
END SkipColumns;

(* ------------------------------------------------------------ *)

PROCEDURE procFortune (source,cible : pathtype;
                      paratab,author,verbose,sendtoscreen:BOOLEAN );
TYPE
    skindtype = (sep,para,str,empty);
VAR
    separator : CHAR;
    S,S2:str4096; (* well, we could use hugestr *)
    skindold:skindtype;
    hndin    : FIO.File;
    hndout   : FIO.File;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
    steps    : CARDINAL;
    wrtofile : BOOLEAN;
BEGIN
    hndin := FIO.OpenRead(source);
    FIO.AssignBuffer(hndin,IObufferIn);

    FIO.RdStr(hndin,S);
    Str.Copy(S2,S);
    LtrimBlanks(S2); RtrimBlanks(S2);
    IF Str.Length(S2) # 1 THEN
        FIO.Close(hndin);
        WrStr("Skipping ");WrFname(source);WrStr(" : probably not a fortune file !");WrLn;
        RETURN;
    END;
    separator:=S2[0]; (* assume it's ok *)

    IF sendtoscreen THEN
        verbose:=FALSE;
        wrtofile:=FALSE;
    ELSE
        wrtofile:=TRUE;
    END;

    IF wrtofile THEN
        hndout := FIO.Create(cible);
        FIO.AssignBuffer(hndout,IObufferOut);
    ELSE
        hndout:=FIO.StandardOutput;
    END;

    IF wrtofile THEN WrStr("Reformatting ");WrFname(source);WrStr(" fortune file"); END;

    steps := 10;
    fsize := FIO.Size(hndin); (* source *)
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);

    IF verbose THEN
        (* animInit(steps, " ", "", CHR(249), "", "\/" ); *)
    ELSE
        IF wrtofile THEN video(msgWait,TRUE);END;
    END;

    FIO.WrStr(hndout,separator);FIO.WrLn(hndout);

    skindold:=sep;
    LOOP
        addr := FIO.GetPos(hndin);
        IF addr >= fsize THEN EXIT;END;

        (* Work(cmdShow); *)
        IF verbose THEN
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                lastportion:=currportion;
            END;
        END;

        FIO.RdStr(hndin,S); RtrimBlanks(S); (* always remove trailing blanks *)
        Str.Copy(S2,S);
        LtrimBlanks(S2);

        IF author THEN
            (* assume authorship if line begins verbatim with a dash or a double dash *)
            IF ( (Str.Match(S2,dashdash+"*")) OR (Str.Match(S2,dash+"*")) ) THEN (* redundant ! *)
                (* force a fake paragraph so that S # S2 now *)
                IF same(S,S2) THEN Str.Prepend(S2,Tab);END;
            END;
        END;

        IF    same(S2,separator) THEN
            CASE skindold OF
            | sep,empty:
                FIO.WrStr(hndout,S);FIO.WrLn(hndout);
            | para,str:
                FIO.WrLn(hndout);
                FIO.WrStr(hndout,S);FIO.WrLn(hndout);
            ELSE ; (* //ISO fixed silly requirement *) END;
            skindold:=sep;
        ELSIF same(S2,"") THEN
            CASE skindold OF
            | sep:
                skindold:=sep;
            | para,str:
                skindold:=empty;
            | empty:
                ;
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSIF same(S2,S) THEN
            CASE skindold OF
            | sep:
                FIO.WrStr(hndout,S);
            | para,str:
                FIO.WrStr(hndout," ");FIO.WrStr(hndout,S);
            | empty:
                FIO.WrLn(hndout);
                FIO.WrLn(hndout);
                FIO.WrStr(hndout,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            skindold:=str;
        ELSE
            IF paratab THEN Str.Concat(S,Tab,S2);END;
            CASE skindold OF
            | sep:
                FIO.WrStr(hndout,S);
            | para,str:
                FIO.WrLn(hndout);
                FIO.WrStr(hndout,S);
            | empty:
                FIO.WrLn(hndout);
                FIO.WrLn(hndout);
                FIO.WrStr(hndout,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            skindold:=para;
        END;

    END;
    (* we could add a trailing separator *)
    CASE skindold OF
    | sep: ;
    | para,str: FIO.WrLn(hndout);
    | empty: ;
    ELSE ; (* //ISO fixed silly requirement *) END;

    (* Work(cmdStop); *)
    IF verbose THEN
    ELSE
        IF wrtofile THEN video(msgWait,FALSE);END;
    END;

    FIO.Close(hndin);
    IF wrtofile THEN
        FIO.Flush(hndout);
        FIO.Close(hndout);
        donewname(source,cible);
        WrLn;
    END;
END procFortune;

(* ------------------------------------------------------------ *)

PROCEDURE detabit (tabwidth:CARDINAL;S:ARRAY OF CHAR; VAR R : ARRAY OF CHAR  );
CONST
    tabchar = Tab;
    space   = Espace;
VAR
    i,j,add: CARDINAL;
    c : CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c := S[i-1];
        IF c = tabchar THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
END detabit;

PROCEDURE expTabs (source,cible : pathtype;tabwi:CARDINAL;
                  verbose,sendtoscreen:BOOLEAN);
VAR
    S,S2:str4096; (* well, we could use hugestr *)
    hndin    : FIO.File;
    hndout   : FIO.File;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
    steps    : CARDINAL;
    wrtofile : BOOLEAN;
    len:CARDINAL;
BEGIN
    IF sendtoscreen THEN
        verbose:=FALSE;
        wrtofile:=FALSE;
    ELSE
        wrtofile:=TRUE;
    END;

    IF wrtofile THEN WrStr("Expanding ");WrFname(source); END;

    hndin := FIO.OpenRead(source);
    FIO.AssignBuffer(hndin,IObufferIn);
    IF wrtofile THEN
        hndout := FIO.Create(cible);
        FIO.AssignBuffer(hndout,IObufferOut);
    ELSE
        hndout := FIO.StandardOutput;
    END;

    (* Work(cmdInit); *)
    addr:=0;
    steps := 10;
    fsize := FIO.Size(hndin); (* source *)
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);
    IF verbose THEN
        (* animInit(steps, " ", "", CHR(249), "", "\/" ); *)
    ELSE
        IF wrtofile THEN video(msgWait,TRUE);END;
    END;

    FIO.EOF := FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        (* Work(cmdShow); *)
        IF verbose THEN
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                lastportion:=currportion;
            END;
        END;

        FIO.RdStr(hndin,S);
        len := Str.Length(S);
        INC(addr, LONGCARD( len ) );
        IF (S[0]=CHR(0)) AND FIO.EOF THEN EXIT; END;

        detabit(tabwi,S, S2);

        FIO.WrStr(hndout,S2);
        FIO.WrLn(hndout);
    END;
    (* Work(cmdStop); *)
    IF verbose THEN
    ELSE
        IF wrtofile THEN video(msgWait,FALSE);END;
    END;

    FIO.Close(hndin);
    IF wrtofile THEN
        FIO.Flush(hndout);
        FIO.Close(hndout);
        donewname(source,cible);
        WrLn;
    END;

END expTabs;

(* ------------------------------------------------------------ *)

PROCEDURE newExtension (VAR R:pathtype;S:pathtype;e3:ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    Str.Copy(R,S);
    p := Str.RCharPos(R,dot);
    IF p = MAX(CARDINAL) THEN
        ;
    ELSE
        R[p]:=CHR(0);
    END;
    Str.Append(R,e3);
END newExtension;

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

(* ------------------------------------------------------------ *)

PROCEDURE padded ( S:ARRAY OF CHAR   ):str80;
CONST
    wi=15;
VAR
    R:str80;
    i:CARDINAL;
BEGIN
    Str.Copy(R,S);
    FOR i:=Str.Length(S) TO wi DO Str.Append(R," ");END;
    Str.Append(R," : ");
    RETURN R;
END padded;


PROCEDURE msg2 (S1,S2:ARRAY OF CHAR );
BEGIN
    WrStr( padded(S1));WrStr(S2);WrLn;
END msg2;

PROCEDURE msgb (S:ARRAY OF CHAR;tf:BOOLEAN);
BEGIN
    WrStr( padded(S));IO.WrBool(tf,8);WrLn;
END msgb;

PROCEDURE msgc (S:ARRAY OF CHAR;v:CARDINAL );
BEGIN
    WrStr(padded (S));IO.WrCard(v,8);WrLn;
END msgc;

(* tag is already uppercased because we except symbols *)

PROCEDURE validTag (S:ARRAY OF CHAR):BOOLEAN;
VAR
    i,pb,len:CARDINAL;
BEGIN
    len:=Str.Length(S);
    IF len # TAGLEN THEN RETURN FALSE; END;
    pb:=0;
    FOR i:=1 TO len DO
        CASE S[i-1] OF
        | "A".."Z" : INC(pb);
        | "0".."9" : INC(pb);
        | '"'      : INC(pb);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN (pb=0);
END validTag;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minwidth    = 1;
    maxwidth    = 132;
    YesStr      = "Y";
    NoStr       = "N";
    mintab      = 1;
    maxtab      = 64; (* was 16 *)
    mininterval = 1;
    maxinterval = 1024; (* really oversized ! *)
    mincount    = 1;
    maxcount    = 1024; (* same *)
    unspecified = MAX(CARDINAL);
    defaulttabwidth   = 8;
    defaultdetabwidth = 8;
VAR
    countFile   : CARDINAL;
    key         : str2;
VAR
    parmcount   : CARDINAL;
    i           : CARDINAL;
    opt         : CARDINAL;
    v           : LONGCARD;
VAR
    overwrite   : BOOLEAN;
    cmd         : (glue,break,skip,cookie,detab);
    linewidth, tabwidth,interval,count,detabwidth : CARDINAL;
    usetag,inverse,verbose,columns,sendtoscreen:BOOLEAN;
    tabpara,author,restartatindent : BOOLEAN;
    DEBUG       : BOOLEAN;
    S,R,filespec,basedir    : pathtype; (* S and R get parms, and are reused as source/target *)
    IGNORETAG   : str16;
    ptr,anchor  : pFname;
    state : (waiting,gotspec);
    skipit:BOOLEAN;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    DEBUG         := FALSE;
    overwrite     := TRUE; (* was FALSE *)
    cmd           := glue; (* default *)
    usetag        := TRUE;
    tabwidth      := unspecified; (* was 0 *)
    interval      := unspecified;
    count         := unspecified; (* should be 1 or mincount *)
    detabwidth    := unspecified;
    inverse       := FALSE;
    verbose       := TRUE;
    columns       := FALSE;
    sendtoscreen  := FALSE;
    tabpara       := FALSE;
    author        := FALSE;
    restartatindent:=FALSE;
    Str.Copy(IGNORETAG,DEFIGNORETAG);
    state := waiting;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R); (* YATB ! *)
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "A"+delim+"AUTHOR"+delim+
                                 "T"+delim+"TAGS"+delim+
                                 "W:"+delim+"WIDTH:"+delim+
                                 "T:"+delim+"TAB:"+delim+
                                 "P:"+delim+"PAGE:"+delim+
                                 "C:"+delim+"COUNT:"+delim+
                                 "I"+delim+"INVERSE"+delim+
                                 "Q"+delim+"QUIET"+delim+
                                 "C"+delim+"COLUMNS"+delim+
                                 "S"+delim+"SCREEN"+delim+
                                 "F"+delim+"FORTUNE"+delim+
                                 "FF"+delim+
                                 "G:"+delim+"TAG:"+delim+
                                 "U"+delim+"DETAB"+delim+
                                 "U:"+delim+"DETAB:"+delim+
                                 "l"+delim+"lfn"+delim+
                                 "Z"+delim+"INDENT"+delim+
                                 "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5 :
                author:=TRUE;
            | 6,7:
                usetag:=FALSE;
            | 8,9:
                CASE cmd OF
                | glue: ;
                | break : IF linewidth # unspecified THEN  abort(errDuplicate,"Line width"); END;
                | skip:   abort(errNonsense,"");
                | detab:  abort(errNonsense,"");
                | cookie: abort(errNonsense,"");
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minwidth) OR (v > maxwidth) ) THEN abort(errBadNumber,S); END;
                linewidth :=CARDINAL(v);
                cmd := break;
            | 10,11:
                CASE cmd OF
                | glue: IF tabwidth # unspecified THEN abort(errDuplicate,"Tab width"); END;
                | break:  abort(errNonsense,"");
                | skip:   abort(errNonsense,"");
                | detab:  abort(errNonsense,"");
                | cookie: abort(errNonsense,"");
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mintab) OR (v > maxtab) ) THEN abort(errBadNumber,S); END;
                tabwidth :=CARDINAL(v);
            | 12,13:
                CASE cmd OF
                | glue: ;
                | break : abort(errNonsense,"");
                | skip : IF interval # unspecified THEN abort(errDuplicate,"Page length"); END;
                | detab:  abort(errNonsense,"");
                | cookie: abort(errNonsense,"");
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mininterval) OR (v > maxinterval) ) THEN abort(errBadNumber,S); END;
                interval :=CARDINAL(v);
                cmd := skip;
            | 14,15:
                CASE cmd OF
                | glue: ;
                | break:  abort(errNonsense,"");
                | skip: IF count # unspecified THEN abort(errDuplicate,"Count");END;
                | detab:  abort(errNonsense,"");
                | cookie: abort(errNonsense,"");
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincount) OR (v > maxcount) ) THEN abort(errBadNumber,S); END;
                count :=CARDINAL(v);
                cmd := skip;
            | 16,17:
                inverse := TRUE;
            | 18,19:
                verbose:=FALSE;
            | 20,21:
                columns := TRUE;
            | 22,23:
                sendtoscreen:=TRUE;
            | 24,25:
                CASE cmd OF
                | glue: ; (* remember it's default command after all ! *)
                | break : abort(errNonsense,"");
                | skip:   abort(errNonsense,"");
                | detab:  abort(errNonsense,"");
                | cookie : ;
                ELSE ; (* //ISO fixed silly requirement *) END;
                cmd:=cookie;
                tabpara:=FALSE;
            | 26:
                CASE cmd OF
                | glue: ; (* remember it's default command after all ! *)
                | break : abort(errNonsense,"");
                | skip:   abort(errNonsense,"");
                | detab:  abort(errNonsense,"");
                | cookie : ;
                ELSE ; (* //ISO fixed silly requirement *) END;
                cmd:=cookie;
                tabpara:=TRUE;
            | 27,28:
                GetString(R,IGNORETAG); (* use uppercased tag *)
                IF validTag(IGNORETAG)=FALSE THEN abort(errBadTag,IGNORETAG);END;
            | 29,30:
                CASE cmd OF
                | glue: ;
                | break:  abort(errNonsense,"");
                | skip:   abort(errNonsense,"");
                | detab:  IF detabwidth # unspecified THEN abort(errDuplicate,"Expand tab width"); END;
                | cookie: abort(errNonsense,"");
                ELSE ; (* //ISO fixed silly requirement *) END;
                cmd:=detab;
                detabwidth:=defaultdetabwidth;
            | 31,32:
                CASE cmd OF
                | glue: ;
                | break:  abort(errNonsense,"");
                | skip:   abort(errNonsense,"");
                | detab:  IF detabwidth # unspecified THEN abort(errDuplicate,"Expand tab width"); END;
                | cookie: abort(errNonsense,"");
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mintab) OR (v > maxtab) ) THEN abort(errBadNumber,S); END;
                detabwidth :=CARDINAL(v);
                cmd:=detab;
            | 33,34:
                ;
            | 35,36:
                restartatindent:=TRUE;
            | 37 :
                DEBUG := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(filespec,S); (* org case *)
            | gotspec : abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    (* check nonsense *)
    IF state=waiting THEN abort(errMissingSpec,""); END;


    CASE cmd OF
    | glue: (* sendtoscreen *)
        IF (inverse OR columns) THEN abort(errNonsense,"");END;
        IF tabwidth = unspecified THEN tabwidth:=defaulttabwidth-1; END;
        IF author THEN abort(errNonsense,"");END;
        IF DEBUG THEN
            msg2("cmd","glue");
            msgb("restartatindent",restartatindent);
            msgb("usetag",usetag);
            msg2("tag",IGNORETAG);
            msgc("tabwidth",tabwidth);
        END;
    | break:
        IF (inverse OR columns) THEN abort(errNonsense,"");END;
        IF tabwidth # unspecified THEN abort(errNonsense,"");END;
        IF author THEN abort(errNonsense,"");END;
        IF restartatindent THEN abort(errNonsense,"");END;
        IF DEBUG THEN
            msg2("cmd","break");
            msgb("usetag",usetag);
            msg2("tag",IGNORETAG);
            msgc("linewidth",linewidth);
            msgb("sendtoscreen",sendtoscreen);
        END;
    | skip:
        IF tabwidth # unspecified THEN abort(errNonsense,"");END;
        IF interval = unspecified THEN abort(errPageLength,"");END;
        IF count    = unspecified THEN count := 1;  END;
        IF usetag=FALSE THEN abort(errNonsense,"");END;
        IF author THEN abort(errNonsense,"");END;
        IF restartatindent THEN abort(errNonsense,"");END;
        IF DEBUG THEN
            msg2("cmd","skip");
            msgc("page length",interval);
            msgc("count",count);
            msgb("inverse",inverse);
            msgb("columns",columns);
            msgb("sendtoscreen",sendtoscreen);
        END;
    | cookie: (* sendtoscreen *)
        IF (inverse OR columns) THEN abort(errNonsense,"");END;
        IF tabwidth # unspecified THEN abort(errNonsense,"");END;
        IF restartatindent THEN abort(errNonsense,"");END;
        IF DEBUG THEN
            msg2("cmd","cookie");
            msgb("tab",usetag);
            msgb("author",author);
            msgb("sendtoscreen",sendtoscreen);
        END;
    | detab:
        IF (inverse OR columns) THEN abort(errNonsense,"");END;
        IF tabwidth # unspecified THEN abort(errNonsense,"");END;
        IF interval # unspecified THEN abort(errNonsense,"");END;
        IF count    # unspecified THEN abort(errNonsense,"");END;
        IF author THEN abort(errNonsense,"");END;
        IF DEBUG THEN
            msg2("cmd","detab");
            msgc("detabwidth",detabwidth);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

        (* a few q&d sanity checks *)

        IF DEBUG THEN WrStr(msgFilespec);WrFname(filespec);WrLn;END;
        IF chkUD(filespec)=FALSE THEN abort(errBadSpec,filespec);END;
        IF same(filespec,dot) THEN Str.Copy(filespec,stardotstar); END;
        IF same(filespec,star) THEN Str.Copy(filespec,stardotstar); END;
        IF Str.Match(filespec,"*"+antislash) THEN Str.Append(filespec,stardotstar); END;
        IF chkJoker(filespec)=FALSE THEN
            IF isDirectory (filespec) THEN
                fixDirectory(filespec);
                Str.Append(filespec,stardotstar);
            END;
        END;
        IF DEBUG THEN WrStr(msgFilespec);WrFname(filespec);WrLn;END;
        makebase(filespec,basedir);
        IF DEBUG THEN WrStr(msgBasedir);WrFname(basedir);WrLn;END;


    initList(anchor);
    countFile := buildFileList(anchor,DEBUG,filespec);
    CASE countFile OF
    | MAX(CARDINAL): abort(errTooMany,filespec);
    | 0 :            abort(errNoMatch,filespec);
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF DEBUG THEN abort(errNone,"");END; (* LFN check, nothing more *)

    WrStr(Banner);WrLn;
    WrLn;

    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(filespec,ptr);
        Str.Concat(S,basedir,filespec);

        newExtension(R,S,extBAK); (* S=source,R=backup *)

        skipit := FALSE;
        IF FIO.Exists(R) THEN
            IF overwrite THEN
		        FIO.Erase(R);
		        (*
		        WrStr("Existing ");WrStr(R);
		        WrStr(" has just been deleted");WrLn;
		        WrLn;
		        *)
            ELSE
                IF fileIsRO(R) THEN
                    WrStr("Read-only b");
                ELSE
                    WrStr("B");
                END;
                WrStr("ackup file ");WrFname(R);
                WrStr(" already exists !");WrLn;
                WrLn;
                WrStr("Hit '"+YesStr+"' to erase it, '"+NoStr+"' to skip it, or any other key to abort : ");
		        Flushkey;
		        key :=Waitkey();
		        UpperCase(key);
		        IF same(key,YesStr) THEN
		            WrStr("Yes");WrLn;
		            WrLn;
		            fileSetRW(R); (* how ungraceful just to avoid YAB Yet Another Boolean *)
		            FIO.Erase(R);
		        ELSIF same(key,NoStr) THEN
		            WrStr("Skipped !");WrLn;
		            WrLn;
		            skipit := TRUE;
		        ELSE
		            WrStr("Exit !");WrLn;
		            abort(errAbort,"");
		        END;
            END;
        END;
        IF NOT(skipit) THEN
            (* the cut/paste/adapt syndrom strikes again *)
            CASE cmd OF
            | glue:  BuildParagraphs(S,R,IGNORETAG,tabwidth,restartatindent,usetag,verbose,sendtoscreen);
            | break: BreakLines(S,R,IGNORETAG,linewidth,usetag,verbose,sendtoscreen);
            | skip:  IF columns THEN
                         SkipColumns(S,R,interval,count,inverse,verbose,sendtoscreen);
                     ELSE
                         SkipLines(S,R,interval,count,inverse,verbose,sendtoscreen);
                     END;
            | cookie: procFortune(S,R, tabpara,author,verbose,sendtoscreen);
            | detab: expTabs(S,R,detabwidth,verbose,sendtoscreen);
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrLn;
        END;

        ptr:=ptr^.next;
    END;
    freeList(anchor);

    abort(errNone,"");
END TxtFmt32.