(* ---------------------------------------------------------------
Title         Q&D Byte Processor
Author        PhG
Overview      see help
Usage         see help
Notes         existing f8e3 target with matching LFN lets LFN alive
Bugs
Wish List     allow user-specified operation with pseudo assembler ?
              allow XOR with a string ?

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn -a -x -q

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 05 Nov 21 an ugly really Q&D port from BYTEPROC v1.1d for DOS
--------------------------------------------------------------- *)

MODULE ByteProc32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

FROM SYSTEM IMPORT ADR,BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;




(* ------------------------------------------------------------ *)

CONST
    hexadigits  =           "ABCDEF";

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "BYTEPROC32";
    ProgTitle     = "Q&D Byte Processor (Win32)";
    ProgVersion   = "v0.9 (from v1.1d for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    byterange     = "*";
    fposmodulo    = "!";
    extNEW        = ".NEW";

CONST
    errNone             = 0;
    errHelp             = 1;
    errUnknownOption    = 2;
    errTooManyParms     = 3;
    errNotEnough        = 4;
    errIllegal          = 5;
    errBadValue         = 6;
    errByteTooBig       = 7;
    errTooManyMatches   = 8;
    errNoMatch          = 9;
    errAborted          = 10;
    errBadValueRangeL   = 11;
    errByteTooBigRangeL = 12;
    errBadValueRangeU   = 13;
    errByteTooBigRangeU = 14;
    errBadRange         = 15;
    errBadRangeForOp    = 16;
    errXORonly          = 17;
    errRange            = 18;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);

    MODULE message;
    IMPORT Str;
    EXPORT msg2,msg3;

    PROCEDURE msg2 (VAR R:ARRAY OF CHAR;S1,S2:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);
    END msg2;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;

CONST
    nl = cr+lf;
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [option]... <operation> <value|range|"+byterange+"|"+fposmodulo+"> <filespec>"+nl+
nl+
"-p:#<,|..># specify start,count or start..end file positions range"+nl+
"-n          exclude CR and LF from operation"+nl+
"-c          exclude CR from operation"+nl+
"-f          exclude LF from operation"+nl+
"-k          exclude all control characters ([0..31]) from operation"+nl+
nl+
"a) Note any existing target will be overwritten without warning."+nl+
"b) Operation to perform may be XOR, INC, DEC, INCR, DECR, PLUS or MINUS."+nl+
"c) Value to use for operation is a byte in the [0..255] or [1..128] range."+nl+
"d) "+'"'+byterange+'" means [$00..$FF] processing for XOR, else it means [$01..$80].'+nl+
"e) "+'"'+fposmodulo+'" means value is XORed with file position modulo 256 (XOR required).'+nl+
'f) New files are created with ".$##" (hexadecimal value) extension :'+nl+
"   therefore, files with such an extension will not be processed."+nl+
"g) Range can be specified in either decimal or hexadecimal ("+dquote+dollar+dquote+" prefix)."+nl+
nl+
"Examples : "+ProgEXEname+" x 0..$10 *.bin"+nl+
"           "+ProgEXEname+" i "+byterange+" mystery.dat"+nl+
"           "+ProgEXEname+" x $ff selectit.cfg"+nl+
"           "+ProgEXEname+" x "+fposmodulo+" install.inf"+nl
(*%F FIXEDLIBS  *)
+nl+
"Unfortunately, thanks (!) to a fatal bug in TopSpeed Modula-2 FIO library,"+nl+
"paths are limited to 65 characters (longer ones will NOT be found). :-("+nl
(*%E *)
    ;
VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errUnknownOption :
        msg3(S,"Unknown ",einfo," option !");
    | errTooManyParms :
        msg2(S,einfo," is just one parameter too far !");
    | errNotEnough:
        S:="Not enough parameters in command line !";
    | errIllegal:
        msg3(S,"Illegal ",einfo," parameter !");
    | errBadValue :
        msg2(S,einfo," would not convert to a number !");
    | errByteTooBig :
        msg2(S,einfo," is not a valid byte value !");
    | errTooManyMatches:
        msg3(S,"Too many files match ",einfo," specification !");
    | errNoMatch :
        msg3(S,"No match for ",einfo," specification !");
    | errAborted:
        S := "Aborted by user !";
    | errBadValueRangeL :
        msg3(S,"Lower value of ",einfo," range would not convert to a number !");
    | errByteTooBigRangeL :
        msg3(S,"Lower value of ",einfo," range is not a valid byte value !");
    | errBadValueRangeU :
        msg3(S,"Upper value of ",einfo," range would not convert to a number !");
    | errByteTooBigRangeU :
        msg3(S,"Upper value of ",einfo," range is not a valid byte value !");
    | errBadRange:
        msg3(S,"Illogical ",einfo," range !");
    | errBadRangeForOp :
        msg3(S,"Illegal ",einfo," range for operation specified !");
    | errXORonly:
        S:='XOR operation is required with "'+fposmodulo+'" command !';
    | errRange:
        msg3(S,"Illegal ",einfo," file positions range !");
    ELSE
        S:="This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT (e) ;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE hasReservedExtension ( S:ARRAY OF CHAR ):BOOLEAN;
CONST
    hexnums   = "ABCDEFabcdef"; (* should be already upper but... *)
    hexdigits = digits+hexnums;
VAR
    p : CARDINAL;
BEGIN
    (* we only care about ".$##" *)
    p := Str.RCharPos(S,dot);
    IF p = MAX(CARDINAL) THEN RETURN FALSE; END;
    Str.Delete(S,0,p+1);
    IF Str.Length(S) # 3 THEN RETURN FALSE; END;
    p:=0;
    IF S[0]                    = "$" THEN INC(p);END;
    IF verifyString (S[1],hexdigits) THEN INC(p);END;
    IF verifyString (S[2],hexdigits) THEN INC(p);END;
    (* we could also check for .new here *)
    RETURN (p=3);
END hasReservedExtension;

(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    includeme:BOOLEAN;
BEGIN
    count:=0;
        found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
            Str.Copy(entryname,entry.name);
        includeme := NOT( isReservedEntry(entryname) ); (* skip "." and ".." *)
        includeme := includeme AND (hasReservedExtension(entryname)=FALSE);
        IF includeme THEN
                dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := SHORTCARD(len);
                Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
            END;
        END;
            found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

PROCEDURE buildPath (VAR path:pathtype; spec:pathtype);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec, u,d,n,e);
    Str.Concat(path, u,d);
    fixDirectory(path); (* safety *)
END buildPath;

PROCEDURE wrQ (S:ARRAY OF CHAR   );
BEGIN
    WrStr(dquote);
    WrStr(S);
    WrStr(dquote);
END wrQ;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn  : ioBuffer;
    bufferOut : ioBuffer;

CONST
    dataBufferSize      = 1024;
    firstDataBufferByte = 1-1;
    lastDataBufferByte  = dataBufferSize-1;
VAR
    databuffer : ARRAY [firstDataBufferByte..lastDataBufferByte] OF BYTE;

(* ------------------------------------------------------------ *)

PROCEDURE getlc (VAR v:LONGCARD;S:ARRAY OF CHAR):BOOLEAN;
VAR
    base:CARDINAL;
    ok:BOOLEAN;
BEGIN
    IF S[0]=dollar THEN
        Str.Delete(S,0,1);
        base := 16;
    ELSE
        base := 10;
    END;
    v:=Str.StrToCard(S,base,ok);
    RETURN ok;
END getlc;

PROCEDURE parserange (VAR startpos,endpos:LONGCARD;S:ARRAY OF CHAR ):BOOLEAN;
VAR
    ok,iscount:BOOLEAN;
    p,l:CARDINAL;
    Z:str16;
BEGIN
    Str.Caps(S); (* [$]#<,|..>[$]# *)
    ok:=verifyString(S,digits+hexadigits+dot+coma+dollar);
    IF NOT(ok) THEN RETURN ok;END;

    ok:=FALSE;
    IF CharCount(S,coma)=1 THEN
        p:=Str.CharPos(S,coma); l:=1;    iscount:=TRUE;
    ELSIF Str.Pos(S,dotdot) # MAX(CARDINAL) THEN
        p:=Str.Pos(S,dotdot);   l:=2;    iscount:=FALSE;
    ELSE
        RETURN ok;
    END;
    Str.Slice(Z,S,0,p);
    Str.Delete(S,0,p+l);
(* WrStr(Z);WrLn; *)
    ok:=getlc(startpos,Z);
    IF NOT(ok) THEN RETURN ok;END;

(* WrStr(S);WrLn; *)
    ok:=getlc(endpos,S);
    IF NOT(ok) THEN RETURN ok;END;

    IF iscount THEN INC(endpos,startpos);DEC(endpos,1); END;

(* IO.WrLngCard(startpos,1);WrStr("  ..  ");IO.WrLngCard(endpos,1);WrLn; *)

    ok:=(startpos <= endpos);
    RETURN ok;
END parserange;

PROCEDURE inrange (startpos,endpos,fpos:LONGCARD;index:CARDINAL   ):BOOLEAN;
BEGIN
    INC(fpos, LONGCARD(index) ); (* index is 0-based *)
    IF fpos < startpos THEN RETURN FALSE;END;
    IF fpos > endpos   THEN RETURN FALSE;END;
    RETURN TRUE;
END inrange;

PROCEDURE vtostr (v:LONGCARD;base:CARDINAL):str16;
VAR
    R:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr(v,R,base,ok);
    IF base=16 THEN Str.Lows(R);END;
    RETURN R;
END vtostr;


PROCEDURE XOR (b1,b2 : CARDINAL) : CARDINAL;
BEGIN
    RETURN CARDINAL ( (BITSET (b1) / BITSET (b2)) );
END XOR;

(* ------------------------------------------------------------ *)

CONST
    firstcode    = 0;
    lastcontrol  = ORD(" ")-1; (* i.e. 31 *)
    lastcode     = 255;
VAR
    doop : ARRAY [firstcode..lastcode] OF BOOLEAN;

(* ------------------------------------------------------------ *)

CONST
    chFiller = "."; (* handle nasty vindoze OEM charset ! *)
CONST
    (* //XDS forces a scalar error when told to create a MIN() or MAX() constant ! *)
    MINBYTE = 0;
    MAXBYTE = 255;
    opmodulo  = MAXBYTE+1; (* //XDS MAX(SHORTCARD)+1 *)
    verbose = TRUE;
VAR
    parmcount : CARDINAL;
    state     : (waiting,gotop,gotvalue,gotspec);
    S,R,T,spec,path : pathtype;
    i,opt,n   : CARDINAL;
    operation : (doxor,doinc,dodec,domodulo);
    firstopvalue,lastopvalue  : CARDINAL;
    source,target,targetbase : pathtype;
    index     : CARDINAL;
    valeur    : CARDINAL;
    DEBUG,ok        : BOOLEAN;
    anchor,ptr:pFname;
    countFile:CARDINAL;
    procmode : (xor, plus, minus);
    b0,b1:CARDINAL;
    v:LONGCARD;
VAR
    fpos,addr,fsize: LONGCARD;
    startpos,endpos:LONGCARD;
    steps    : CARDINAL;
    hndIn      : FIO.File;
    hndOut     : FIO.File;
    got        : CARDINAL;
    e3         : str16; (* oversized *)
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    FOR i:=firstcode TO lastcode DO doop[i]:=TRUE; END;
    DEBUG     := FALSE;
    startpos  := 0;
    endpos    := MAX(LONGCARD);
    state     := waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "a"+delim+"audio"+delim+
                                  "q"+delim+"quiet"+delim+
                                  "x"+delim+"lfn"+delim+
                                  "N"+delim+"NL"+delim+
                                  "C"+delim+"CR"+delim+
                                  "F"+delim+"LF"+delim+
                                  "K"+delim+"CTRL"+delim+
                                  "DEBUG"+delim+
                                  "P:"+delim+"POS:"
                              );
            CASE opt OF
            |  1,  2,  3: abort(errHelp,"");
            |  4,  5    : ;
            |  6,  7    : ;
            |  8,  9    : ;
            | 10, 11    : doop[ ORD(cr) ] := FALSE;
                          doop[ ORD(lf) ] := FALSE;
            | 12, 13    : doop[ ORD(cr) ] := FALSE;
            | 14, 15    : doop[ ORD(lf) ] := FALSE;
            | 16, 17    : FOR n:= firstcode TO lastcontrol DO doop[n]:=FALSE; END;
            | 18        : DEBUG:=FALSE;
            | 19,20     : GetString(S,T);
                          IF parserange(startpos,endpos,T)=FALSE THEN abort(errRange,S);END;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                n := getStrIndex(delim,R, "XOR"+delim+"X"+delim+
                                          "INC"+delim+"INCR"+delim+"I"+delim+"PLUS"+delim+
                                          "DEC"+delim+"DECR"+delim+"D"+delim+"MINUS"
                                );
                CASE n OF
                | 1,2   :    operation := doxor; procmode := xor;
                | 3,4,5,6 :  operation := doinc; procmode := plus;
                | 7,8,9,10 : operation := dodec; procmode := minus;
                ELSE abort(errIllegal,"<operation>");
                END;
            | gotop   :
                IF same(R,byterange) THEN
                    IF operation=doxor THEN
                        firstopvalue := MINBYTE;
                        lastopvalue  := MAXBYTE;
                    ELSE
                        firstopvalue := MINBYTE+1;
                        lastopvalue  := 128;
                    END;
                ELSIF same(R,fposmodulo) THEN
                    IF operation=doxor THEN        (* fake 256..256 *)
                        firstopvalue := opmodulo;
                        lastopvalue  := opmodulo;
                    ELSE
                        abort(errXORonly,"");
                    END;
                ELSE
                    n := Str.Pos(R,dotdot);
                    CASE n OF
                    | 0, MAX(CARDINAL):     (* if "..", force an error *)
                        ok:=getlc(v,R);
                        IF ok =FALSE THEN abort(errBadValue,S); END;
                        IF v > MAXBYTE THEN abort(errByteTooBig,S);END;
                        firstopvalue := CARDINAL(v);
                        lastopvalue := firstopvalue;
                    ELSE
                        Str.Slice(T,R,0,n); (* n-1+1 *)
                        ok:=getlc(v,T);
                        IF ok =FALSE THEN abort(errBadValueRangeL,S); END;
                        IF v > MAXBYTE THEN abort(errByteTooBigRangeL,S);END;
                        firstopvalue := CARDINAL(v);
                        Str.Delete(R,0,n);
                        Str.Subst(R,dotdot,"");
                        Str.Copy(T,R);
                        ok:=getlc(v,T);
                        IF ok =FALSE THEN abort(errBadValueRangeU,S); END;
                        IF v > MAXBYTE THEN abort(errByteTooBigRangeU,S);END;
                        lastopvalue := CARDINAL(v);
                        IF lastopvalue < firstopvalue THEN abort(errBadRange,S);END;
                        IF operation=doxor THEN
                            IF NOT ( (firstopvalue >= MINBYTE) AND (lastopvalue <= MAXBYTE) ) THEN
                                abort(errBadRangeForOp,S);
                            END;
                        ELSE
                            IF NOT ( (firstopvalue >= (MINBYTE+1)) AND (lastopvalue <= 128) ) THEN
                                abort(errBadRangeForOp,S);
                            END;
                        END;
                    END;
                END;
            | gotvalue:
                Str.Copy(spec,S);
            | gotspec : abort(errTooManyParms,R);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    IF state # gotspec THEN abort(errNotEnough,"");END;


    IF same(spec,".") THEN
        spec:=stardotstar;
    ELSIF Str.Match(spec,"*\") THEN
        Str.Append(spec,stardotstar);
    ELSIF Str.Match(spec,"*\.") THEN
        i:=Str.Length(spec);
        spec[i-1]:=nullchar;
        Str.Append(spec,stardotstar);
    ELSIF same(spec,stardotstar) THEN
        ;
    ELSIF same(spec,"*.") THEN (* ugly *)
        ;
    ELSE
        IF isDirectory(spec) THEN
            fixDirectory(spec);
            Str.Append(spec,stardotstar);
        END;
    END;

    initList(anchor);
    countFile:=buildFileList(anchor,spec);
    IF countFile=MAX(CARDINAL) THEN abort(errTooManyMatches,spec);END; (* errStorage *)
    IF countFile=0 THEN abort(errNoMatch,spec); END;

    buildPath(path,  spec);

    WrStr(Banner);WrLn;
    WrLn;
    IF ( (startpos = 0) AND (endpos = MAX(LONGCARD)) ) THEN
        ;
    ELSE
        S:="::: Decimal operating range     : ~..~";
        Str.Subst(S,"~",vtostr(startpos,10));
        Str.Subst(S,"~",vtostr(endpos,10));
        WrStr(S);WrLn;
        S:="::: Hexadecimal operating range : $~..$~";
        Str.Subst(S,"~",vtostr(startpos,16));
        Str.Subst(S,"~",vtostr(endpos,16));
        WrStr(S);WrLn;
        WrLn;
    END;

    IF firstopvalue=opmodulo THEN operation:=domodulo;END;

    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(R,ptr);
        i := Str.RCharPos(R,dot);
        IF i # MAX(CARDINAL) THEN
            Str.Slice(S,R,0,i);
            Str.Copy(R,S);
        END;
        Str.Concat(targetbase,path,R);
        Str.Append(targetbase,dot);

        getStr(source,ptr);
        Str.Prepend(source,path);

        WrStr("+++ ");wrQ(source);

        FOR n := firstopvalue TO lastopvalue DO
            IF operation=domodulo THEN
                Str.Copy(e3,"!");
            ELSE
                Str.CardToStr(LONGCARD(n),e3,16,ok);
                UpperCase(e3);
                IF n < 16 THEN Str.Prepend(e3,"0"); END;
            END;

            Str.Prepend(e3,"$");
            Str.Concat(target,targetbase,e3);

            Str.Concat(S,blank,e3);Str.Append(S,blank);
            IF verbose THEN video(S,TRUE); END;

            fsize := getFileSize(source);
	    addr:=0;

            hndIn :=FIO.OpenRead(source);
            FIO.AssignBuffer(hndIn,bufferIn);
            hndOut :=FIO.Create(target);
            FIO.AssignBuffer(hndOut,bufferOut);
            FIO.EOF:=FALSE; (* useless safety *)

            LOOP
                got:=FIO.RdBin(hndIn,databuffer,dataBufferSize);
                IF got = 0 THEN EXIT; END;
                fpos:=addr; (* for domodulo() *)
                INC(addr, LONGCARD(got) );

                FOR index:= firstDataBufferByte TO (got-1) DO

                    IF doop[ CARDINAL(databuffer[index]) ] THEN
                        IF operation=domodulo THEN
                            v := (fpos+LONGCARD(index)) MOD 256;
                            valeur:=CARDINAL(v);
                        ELSE
                            valeur:=n;
                        END;
                        IF inrange(startpos,endpos,fpos,index) THEN
			    b1:=CARDINAL(databuffer[index]);
			    CASE procmode OF
			    | xor:   b0:=XOR(b1,valeur);
			    | plus:  b0:=b1+valeur;
			    | minus: IF b1 < valeur THEN
			                 b0:=b1+MAXBYTE+1-valeur;
			             ELSE
			                 b0:=b1-valeur;
				     END;
			    ELSE ; (* //ISO GROTESQUE REQUIREMENT ! *) END;
                            databuffer[index] := BYTE(b0);
                        END;
                    END;
                END;

                FIO.WrBin(hndOut,databuffer,got);
                IF got # dataBufferSize THEN EXIT; END;
            END;
            FIO.Flush(hndOut);
            FIO.Close(hndOut);
            FIO.Close(hndIn);

            IF verbose THEN video(S,FALSE); END;

            IF ChkEscape() THEN
                WrLn;
                WrLn;
                abort(errAborted,"");
            END;
        END;

        WrLn;

        ptr:=ptr^.next;

    END;

    freeList(anchor);


    abort(errNone,"");
END ByteProc32.




(*

dd c:\z\*.$* /sky /n

set p=byteproc32
set x=32

md xor%x%
md inc%x%
md dec%x%
md partx%x%
md parti%x%
md partd%x%

%p% x * *.exe
move *.$* xor%x%
%p% i * *.exe
move *.$* inc%x%
%p% d * *.exe
move *.$* dec%x%
%p% x * *.exe -p:16,32
move *.$*  partx%x%
%p% i * *.exe -p:16,32
move *.$*  parti%x%
%p% d * *.exe -p:16,32
move *.$*  partd%x%


set p=byteproc
set x=16

md xor%x%
md inc%x%
md dec%x%
md partx%x%
md parti%x%
md partd%x%

%p% x * *.exe
move *.$* xor%x%
%p% i * *.exe
move *.$* inc%x%
%p% d * *.exe
move *.$* dec%x%
%p% x * *.exe -p:16,32
move *.$*  partx%x%
%p% i * *.exe -p:16,32
move *.$*  parti%x%
%p% d * *.exe -p:16,32
move *.$*  partd%x%




call listid xor16 xor32 /dbb
call delthem
call listid inc16 inc32 /dbb
call delthem
call listid dec16 dec32 /dbb
call delthem
call listid partx16 partx32 /dbb
call delthem
call listid parti16 parti32 /dbb
call delthem
call listid partd16 partd32 /dbb
call delthem

del delthem.bat


*)


