(* ---------------------------------------------------------------
Title         Q&D Check File Readability
Overview
Usage         see help
Notes
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      	  -w
	      	  -u

              see XDS, //XDSTS and //FIXME

			  file list should be in Win32 charset
			  errcode other than 0 seems to always be max(longcard)
			  "no match" can mean file is used by another process

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs          no critical error handler
Wish List     rewrite each file to a tmp file
              before rename THEN del if everything went fine ?

              better report ?
              show percentage OF operations ?
              add companion file for exclusions ?
              handle delta in .RSM

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  4 Mar 21 v0.9c keep in sync with v1.0c for DOS
PhG  8 Oct 20 v0.9b keep in sync with v1.0b for DOS
PhG 30 Aug 20 v0.9a keep in sync with v1.0a for DOS
PhG 30 Oct 19 an ugly really Q&D port from CHKFREAD v1.0 for DOS
--------------------------------------------------------------- *)

MODULE chkFread32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;
FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE IsDirectorySpec (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    RETURN isDirectory(S);
END IsDirectorySpec;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)

CONST
    progEXEname      = "CHKFREAD32";
    progTitle        = "Q&D Check File Readability (Win32)";
    progVersion      = "v0.9c (from v1.0c for DOS)";
    progCopyright    = "by PhG";
    progBanner       = progTitle+" "+progVersion+" "+progCopyright;
CONST
    extLST           = ".LST";
    extRSM           = ".RSM";
    msgJoker         = "::: Joker(s) : ";
    msgNotFile       = "::: Not file : ";
    msgNotFound      = "::: No match : "; (* //XDS or locked by another process *)
    msgReadOK        = "+++ Success  : ";
    msgReadError     = "--- Failure  : "; (* //XDS don't care about Win32 errcode *)
CONST
    msgSkipped       = "::: Skipped  : ";
    msgFailed        = "::: Failed   : ";
    msgProcessed     = "::: Verified : ";
    msgElapsed       = "::: Elapsed time was ";
    wilc             = 10;
    msgRESUME        = '::: "~" resume file has been created.';
    msgLASTPROCESSED = '::: Last processed file was "~"';
CONST
    errNone            = 0;
    errHelp            = 1;
    errExpecting       = 2;
    errOption          = 3;
    errTooManyParms    = 4;
    errNoMatch         = 5;
    errJoker           = 6;
    errDir             = 7;
    errCaseRedefined   = 8;
    errCorrupt         = 9;
    errBadOS           = 10;
    errReserved        = 11;
    errAborted         = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
msgHelp =
progBanner+nl+
nl+
"Syntax : "+progEXEname+" <list["+extLST+"]> [option]..."+nl+
nl+
"This program verifies each file entry in <list> is readable."+nl+
"Possible usefulness should be self-explanatory."+nl+
nl+
"    -r  resume from last file entry read"+nl+
"    -v  verbose mode (do not report only failures but successes too)"+nl+
"    -q  do not show list completion percentage"+nl+
(*
"    -u  display file entries in uppercase"+nl+
"    -w  display file entries in lowercase"+nl+
"    -x  disable LFN support even if available"+nl+
*)
nl+
"a) Each file entry in <list> is expected to be an OEM ASCII valid one."+nl+ (* //XDS *)
"   Jokers are not supported."+nl+
"b) <list> should be filtered for entries locked by operating system,"+nl+
'   to prevent them from being reported as files not found.'+nl+
(* "c) A critical error handler TSR might be useful."+nl+ *)
'c) Should program be aborted with ESCape key,'+nl+
'   a resume file with "'+extRSM+'" will be created in current directory'+nl+
"   so program can resume from last file entry read thanks to -r option."+nl+
"d) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
"e) Note even with -r option, elapsed time applies to current program run only."+nl;


VAR
    S : str1024; (* oversized for possible LFN *)
BEGIN
    CASE e OF
    | errHelp :          WrStr(msgHelp);
    | errExpecting:      S := "Expecting <list> !";
    | errOption:         S := 'Unknown "~" option !';
    | errTooManyParms:   S := '"~" is one parameter too many !';
    | errNoMatch:        S := '"~" does not exist !';
    | errJoker:          S := '"~" should not contain any joker !';
    | errDir:            S := '"~" seems to be a directory !';
    | errCaseRedefined:  S := "-u and -w options are mutually exclusive !";
    | errCorrupt:        S := '"~" seems damaged !';
    | errBadOS:          S := '"~" requires another O.S. !';
    | errReserved:       S := '"~" should not have reserved "'+extRSM+'" extension !';
    | errAborted  :      S := "Aborted by user !";
    ELSE
                         S := "This is illogical, Captain !";
    END;

    CASE e OF
    | errNone,errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    (* //XDS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (16 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferLst,ioBufferIn : ioBufferType;

CONST
    dataBufferSize      = (16 * 512);
    firstDataBuffer     = 1-1;
    lastDataBuffer      = dataBufferSize-1;
VAR
    dataBuffer : ARRAY [firstDataBuffer..lastDataBuffer] OF BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    CHKEVERY9X = 64; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 4;  (* safety *)

PROCEDURE pollEscape (VAR chkrounds:CARDINAL; useLFN,ignoreESC:BOOLEAN):BOOLEAN;
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomly hangs till a keypress
    Flushkey() does NOT help
    *)
    (*
    IF useLFN THEN
        hit:=FALSE;
    ELSE
        hit:=ChkEscape();
    END;
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    IF useLFN THEN
        every:=CHKEVERY9X;
    ELSE
        every:=CHKEVERYDOS;
    END;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEscape;

PROCEDURE preprocessLine (VAR S:pathtype);
VAR
    len:CARDINAL;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    (* we could use Str.Match(S,dquote+"*"+dquote) but... *)
    len:=Str.Length(S);
    IF len < 2 THEN RETURN; END; (* at least 1+1 for possible dquote+dquote *)
    IF S[len-1] # dquote THEN RETURN; END;
    IF S[0] # dquote THEN RETURN; END;
    S[len-1]:=charnull;
    Str.Delete(S,0,1);
    (* just in case *)
    LtrimBlanks(S);
    RtrimBlanks(S);
END preprocessLine;

PROCEDURE dmp (enquote:BOOLEAN;S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);
    IF enquote THEN WrStr(dquote);END;
    WrStr(S2);
    IF enquote THEN WrStr(dquote);END;
    WrLn;
END dmp;

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str16;
VAR
    R : str16;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= CARDINAL(Str.Length(R)+1) TO CARDINAL(ABS(wi)) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmtc (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str16;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmtc;

PROCEDURE buildResumeFilename (VAR R:pathtype; ext,S:pathtype);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Str.Concat(R,n,ext);
END buildResumeFilename;

(* ------------------------------------------------------------ *)

TYPE
    DTtype = RECORD
        Year      : CARDINAL;
        Month     : CARDINAL;
        Day       : CARDINAL;
        Hours     : CARDINAL;
        Minutes   : CARDINAL;
        Seconds   : CARDINAL;
        Hundredths: CARDINAL;
        DayOfWeek : Lib.DayType;
    END;

PROCEDURE GetDateTimeNow (VAR dt : DTtype);
BEGIN
    Lib.GetDate(dt.Year,dt.Month,dt.Day,dt.DayOfWeek);
    Lib.GetTime(dt.Hours,dt.Minutes,dt.Seconds,dt.Hundredths);
END GetDateTimeNow;

(*
    gregorian calendar rule : leap 366 years if divisible by 4
    but centurial years NOT divisible by 4 are common
    Leap years are divisible by 400, or by 4 and not by 100
    1900 is common, 2000 is leap
*)

PROCEDURE getDaysInFebruary (annee:CARDINAL):CARDINAL;
CONST
    common = 28;
    leap   = 29;
BEGIN
    IF (annee MOD 400) = 0 THEN RETURN leap; END;
    IF (((annee MOD 4) = 0) AND ((annee MOD 100) # 0)) THEN RETURN leap; END;
    RETURN common;
END getDaysInFebruary;

(* assume month and year are correct *)

PROCEDURE getDaysInMonth (mois,annee:CARDINAL):CARDINAL;
TYPE
    daysinmonthtype = ARRAY [1..12] OF CARDINAL;
CONST
    (*                    JanFevMarAprMayJunJulAugSepOctNovDec *)
    (*                     1  2  3  4  5  6  7  8  9 10 11 12  *)
    dpm = daysinmonthtype{31, 0,31,30,31,30,31,31,30,31,30,31};
VAR
    m : CARDINAL;
BEGIN
    m:= dpm[mois];
    IF m=0 THEN m:=getDaysInFebruary(annee);END;
    RETURN m;
END getDaysInMonth;

(* jan 1 = 1, etc. *)

PROCEDURE getCountOfDays (jour,mois,annee:CARDINAL):CARDINAL;
VAR
    n,i : CARDINAL;
BEGIN
    n:=jour;
    FOR i:= 1 TO (mois-1) DO
        INC(n, getDaysInMonth(mois,annee) );
    END;
    RETURN n;
END getCountOfDays;

(* out of lazyness, reasonably assume process won't take more than 24 hours ! *)

CONST
    strFmtTime    = "~h ~mn ~s";

PROCEDURE fmtDelta (started,ended:DTtype):str80;
CONST
    minutesPerHour   = 60;
    secondsPerMinute = 60;
    hundred          = 100;
    midnight         = 24*minutesPerHour*secondsPerMinute*hundred;
    baseyear         = 1980; (* historic ! *)
VAR
    R : str80;
    n,hmsStart,hmsEnd,jmaStart,jmaEnd : LONGCARD; (* in hundredths of seconds *)
    delta : DTtype;
    i,v:CARDINAL;
BEGIN
    n := LONGCARD(started.Hours) * minutesPerHour + LONGCARD(started.Minutes);
    n := n * secondsPerMinute + LONGCARD(started.Seconds);
    n := n * hundred + LONGCARD(started.Hundredths);
    hmsStart := n;

    n := LONGCARD(ended.Hours)   * minutesPerHour + LONGCARD(ended.Minutes);
    n := n * secondsPerMinute + LONGCARD(ended.Seconds);
    n := n * hundred + LONGCARD(ended.Hundredths);
    hmsEnd := n;

    n:=LONGCARD ( getCountOfDays(started.Day,started.Month,started.Year) );
    v:=started.Year-1;
    FOR i:= baseyear TO v DO
         INC (n, LONGCARD ( getCountOfDays(31,12,i) ) );
    END;
    jmaStart:=n;

    n:=LONGCARD ( getCountOfDays(ended.Day,ended.Month,ended.Year) );
    v:=ended.Year-1;
    FOR i:= baseyear TO v DO
         INC (n, LONGCARD ( getCountOfDays(31,12,i) ) );
    END;
    jmaEnd:=n;

    IF jmaEnd # jmaStart THEN (* assume no more than one day ! *)
        hmsEnd := hmsEnd + midnight;
    END;
    n := hmsEnd-hmsStart; (* always >= 0 *)
    delta.Hours     :=CARDINAL (n DIV (minutesPerHour*secondsPerMinute*hundred) );
    delta.Minutes   :=CARDINAL((n DIV (               secondsPerMinute*hundred) ) MOD 60 );
    delta.Seconds   :=CARDINAL((n DIV (                                hundred) ) MOD 60 );
    delta.Hundredths:=CARDINAL (n MOD hundred);

    R:=strFmtTime;
    Str.Subst(R,tilde, fmtc(delta.Hours,  10,2,"0",""));
    Str.Subst(R,tilde, fmtc(delta.Minutes,10,2,"0",""));
    Str.Subst(R,tilde, fmtc(delta.Seconds,10,2,"0",""));

    RETURN R;
END fmtDelta;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE procFile (VAR errcode:CARDINAL;
                   useLFN,showpercentage:BOOLEAN;
                   total,current:LONGCARD;S:pathtype):BOOLEAN;
CONST
    tersemsg        = "::: Reading, please wait... ";
    informativemsg  = "::: Reading ~ out of ~, please wait... ";
    DOSNOERROR = 0; (* let's hope it's ok here *)
VAR
    pb1,pb2,rc,keep:BOOLEAN;
    hin:FIO.File;
    got:CARDINAL;
    msg:str128;
BEGIN
    IF showpercentage THEN
        Str.Copy(msg,informativemsg);
        Str.Subst(msg,"~", fmtlc (current,10,1,"",""));
        Str.Subst(msg,"~", fmtlc (total,  10,1,"",""));
    ELSE
        Str.Copy(msg,tersemsg);
    END;

    keep:=FIO.EOF;
    video(msg,TRUE);
    rc:=TRUE;

    hin :=FIO.OpenRead(S);
    (* we check handle now //V10A *)
    pb1:= FALSE; (* //XDS we can't test for MAX(CARDINAL) here *);
    errcode:=FIO.IOresult();
    pb2:=( errcode # DOSNOERROR);
    IF ( pb1 OR pb2 ) THEN
        rc:=FALSE;
    ELSE
    	FIO.AssignBuffer(hin,ioBufferIn);
    	LOOP
            got := FIO.RdBin(hin,dataBuffer,dataBufferSize);
            errcode:= FIO.IOresult();
            IF errcode # 0 THEN rc:=FALSE;EXIT;END;
            IF got = 0 THEN EXIT; END;
            IF got # dataBufferSize THEN EXIT;END;
        END;
        FIO.Close(hin);
    END;
    video(msg,FALSE);
    FIO.EOF := keep;
    RETURN rc;
END procFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE countLines ( useLFN:BOOLEAN;list:pathtype ):LONGCARD ;
CONST
    msg="::: Counting lines, please wait... ";
VAR
    hlst:FIO.File;
    S:pathtype;
    n:LONGCARD;
BEGIN
    video(msg,TRUE);
    n:=0;
    hlst:=FIO.OpenRead(list);
    FIO.AssignBuffer(hlst,ioBufferLst);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hlst,S);
        IF FIO.EOF THEN EXIT; END;
        INC(n);
    END;
    FIO.Close(hlst);
    video(msg,FALSE);
    RETURN n;
END countLines;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    idDOS   = "DOS!";
    idWin32 = "WIN!";
    idNOW   = idWin32;
TYPE
    statstype = RECORD (* include list filename too ? *)
        id        : ARRAY[0..3] OF CHAR;
        currfpos  : LONGCARD;
        skipped   : LONGCARD;
        failed    : LONGCARD;
        processed : LONGCARD;
	(* //V10B *)
        linecount : LONGCARD;
        currline  : LONGCARD;
      	dtStart   : DTtype;
        dtEnd     : DTtype;
    END;
VAR
    i,opt,parmcount : CARDINAL;
    Z,S,R,list:pathtype;
    useLFN,verbose,resume : BOOLEAN;
    state:(waiting,gotlist);
    casemode:(defcase,uppercased,lowercased);
    hlst:FIO.File;
    errcode,chkrounds:CARDINAL;
    ok,alcatraz,showpercentage:BOOLEAN;
    stats : statstype;
    RESUMEFILE:pathtype;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    useLFN    := TRUE;
    verbose   := FALSE;
    casemode  := defcase;
    resume    := FALSE;
    chkrounds := 0;
    showpercentage:=TRUE;
    state     := waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "R"+delim+"RESTART"+delim+"!"+delim+
                                  "x"+delim+"lfn"+delim+"l"+delim+
                                  "u"+delim+"uppercase"+delim+
                                  "w"+delim+"lowercase"+delim+
				  "Q"+delim+"QUIET"
                              );
            CASE opt OF
            | 1,2,3   : abort(errHelp,"");
            | 4,5     : verbose := TRUE;
            | 6,7,8   : resume  := TRUE;
            | 9,10,11 : (* useLFN  := FALSE; *)
            | 12,13:    CASE casemode OF
                        | defcase,uppercased : casemode:=uppercased;
                        ELSE
                            abort(errCaseRedefined,"");
                        END;
            | 14,15:    CASE casemode OF
                        | defcase,lowercased : casemode:=lowercased;
                        ELSE
                            abort(errCaseRedefined,"");
                        END;
	    | 16,17:    showpercentage:=FALSE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting : Str.Copy(list,S);
            | gotlist:  abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting: abort(errExpecting,"<list>");
    | gotlist: ;
    ELSE ; (* //ISO fixed silly requirement *) END;



    IF chkJoker(list) THEN abort(errJoker,list);END;
    IF Str.Match(list,"*"+extRSM) THEN abort(errReserved,list);END;
	IF IsDirectorySpec(list) THEN abort(errDir,list);END;
    IF Str.RCharPos(list,dot) = MAX(CARDINAL) THEN Str.Append(list,extLST);END;
    IF FIO.Exists(list)=FALSE THEN abort(errNoMatch,list);END;

    buildResumeFilename(RESUMEFILE, extRSM,list);
    IF resume THEN
        IF FIO.Exists(RESUMEFILE)=FALSE THEN abort(errNoMatch,RESUMEFILE);END;
        hlst:=FIO.OpenRead(RESUMEFILE);
        i:=FIO.RdBin(hlst,stats,SIZE(stats));
        FIO.Close(hlst);
        IF Str.Compare(stats.id,idNOW) # 0 THEN abort(errBadOS,RESUMEFILE);END;
        IF i # SIZE(stats) THEN abort(errCorrupt,RESUMEFILE);END;
    ELSE
        Str.Copy(stats.id,idNOW);
        stats.currfpos  := 0;
        stats.processed := 0;
        stats.failed    := 0;
        stats.skipped   := 0;
        stats.linecount := countLines(TRUE,list);
        stats.currline  := 0;
    END;

    GetDateTimeNow(stats.dtStart);

    FIO.EOF := FALSE; (* should not be necessary ! *)
    hlst:=FIO.OpenRead(list);
    FIO.AssignBuffer(hlst,ioBufferLst);

    FIO.Seek(hlst,stats.currfpos);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hlst,S);
        IF FIO.EOF THEN EXIT; END;
	INC(stats.currline);
        preprocessLine(S);
        CASE S[0] OF
        | charnull,semicolon,pound: ;
        ELSE
            Str.Copy(Z,S);
	    (*
            CASE casemode OF
            | defcase:    ;
            | uppercased: UpperCaseAlt(Z);
            | lowercased: LowerCaseAlt(Z);
            ELSE ; (* //ISO fixed silly requirement *) END;
	    *)
            IF chkJoker(S) THEN
                dmp(TRUE,msgJoker,Z);
                INC(stats.skipped);
            ELSE
                IF IsDirectorySpec(S) THEN
                    dmp(TRUE, msgNotFile,Z);
                    INC(stats.skipped);
                ELSE
                    IF FIO.Exists(S) THEN
                        IF procFile (errcode,
				    useLFN,showpercentage,
				    stats.linecount,stats.currline,S) THEN
                            IF verbose THEN dmp(TRUE,msgReadOK,Z); END;
                            INC(stats.processed);
                        ELSE
                            R:=msgReadError;
                            (* //XDS Str.Subst(R,"#",fmtc(errcode,10,3," ","")); *)
                            dmp(TRUE,R,Z);
                            INC(stats.failed);
                        END;
                    ELSE
                        dmp(TRUE,msgNotFound,Z);
                        INC(stats.skipped);
                    END;
                END;
            END;
        END;
        alcatraz := pollEscape (chkrounds, useLFN,FALSE);
        IF alcatraz THEN EXIT; END;
    END;
    stats.currfpos:=FIO.GetPos(hlst);
    FIO.Close(hlst);

    GetDateTimeNow(stats.dtEnd);

	WrLn;
    dmp(FALSE,msgSkipped  ,fmtlc(stats.skipped,  10,wilc," ",""));
    dmp(FALSE,msgFailed   ,fmtlc(stats.failed   ,10,wilc," ",""));
    dmp(FALSE,msgProcessed,fmtlc(stats.processed,10,wilc," ",""));
	WrLn;
    Str.Copy(R,fmtDelta(stats.dtStart,stats.dtEnd) );
    dmp(FALSE,msgElapsed  ,R);

    IF alcatraz THEN
        IF FIO.Exists(RESUMEFILE) THEN
            FIO.Erase(RESUMEFILE);
        END;
        hlst:=FIO.Create(RESUMEFILE);
        FIO.WrBin(hlst,stats,SIZE(stats));
        FIO.Close(hlst);
        WrLn;
        R:=msgLASTPROCESSED;
        Str.Subst(R,"~",S);
        WrStr(R);WrLn;
        WrLn;
        S:=msgRESUME;
        Str.Subst(S,"~",RESUMEFILE);
        WrStr(S);WrLn;
        WrLn;
        abort(errAborted,"");
    END;

    abort(errNone,"");
END chkFread32.

