(* ---------------------------------------------------------------
Title         Q&D Reveal "hidden" words
Overview
Usage         see help
Notes         no checks for processor, ram etc.
              LastEntry const is currently 5000 (8000 max, 3000 okay)
              yes, syntax could have been more clever
              but who cares ? and it's NOT essential software !

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -lim
	      -a

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          vindoze does not like "frequent" calls to ChkEscape() !
Wish List     XMS support using pragma for stacksize at least 256 bytes
              (M2 default stack size is 16 Kb anyway!). But maybe XMS
              is overkill for such a thing... ;-)
              escape key to abort, audio beep when one name found ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  8 Aug 17 an ugly really Q&D port from FINDHIDN v1.0d for DOS
--------------------------------------------------------------- *)

MODULE findHIDN32;

IMPORT IO;
IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCaseXDS (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCaseXDS;

PROCEDURE LowerCaseXDS (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCaseXDS;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* start annoyances to be fixed later //FIXME *)

CONST
    cmdInit = 0;
    cmdShow = 0;
    cmdSHOW = 0;
    cmdStop = 0;

PROCEDURE Work (foo:CARDINAL);
BEGIN
    ;
END Work;

PROCEDURE FixAE (VAR S : ARRAY OF CHAR);
CONST
    ae = CHR(145); (* ascii "ae" code *)
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,ae);
        IF p=MAX(CARDINAL) THEN EXIT; END;
        Str.Subst(S,ae,"ae");
    END;
END FixAE;

PROCEDURE isReadOnly(S:pathtype):BOOLEAN;
BEGIN
    RETURN FALSE;
END isReadOnly;

PROCEDURE setReadWrite(S:pathtype);
BEGIN
    ;
END setReadWrite;

(* end annoyances to be fixed later //FIXME *)


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* DOS tables from GEMATRIA32.MOD : DOS ASCII charset, *not* Vindoze OEM !!! *)

CONST

    (* darn, we forgot non-French codes... but we don't care *)

    ignoreme = " ";

    Tupper = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "CUEAAAACEEEIIIAAEOOOUUYOU     "+ (* use "ae" *)
             "AIOUNN                          "+
             "                                "+
             "                               ";

    Tlower = "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "ueaaaaeeeiiiaaeooouuyou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    TupperA= "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "AAEEEIIIOOUUY     "+
             "AIOU                          "+
             "                                "+
             "                                ";

    TlowerA= "                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "     "+
             "                          "+
             "                                "+
             "                               ";

    (*
    //FIXME : French table has not been fully checked yet
    we just try and fix annoying filenames
    *)

    TupperFR="                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             "UAAAEEEIIIAOOOUUYOU     "+
             "AIOUNN                          "+
             "                                "+
             "                                ";

    TlowerFR="                                "+
             "                                "+
             " abcdefghijklmnopqrstuvwxyz     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "uaiaooou     "+
             "aiounn                          "+
             "                                "+
             "                               ";

    Taz    = "                                "+
             "                                "+
             " ABCDEFGHIJKLMNOPQRSTUVWXYZ     "+
             " abcdefghijklmnopqrstuvwxyz     "+
             "CueaaaaeeeiiiAAEooouuyOU     "+ (* yes we keep lower case "" *)
             "aiounN               AAA        "+
             "      aA          EEE III     I "+
             "O OOoO   UUUyY                 ";


(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tupper);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tlower);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END LowerCase;

PROCEDURE UpperCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperA);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END UpperCaseAlt;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerA);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END LowerCaseAlt;

PROCEDURE UpperCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperFR);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END UpperCaseFR;

PROCEDURE LowerCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerFR);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END LowerCaseFR;

PROCEDURE ASCIIonly (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Taz);
        IF ch # ignoreme THEN S[i] := ch; END;
    END;
END ASCIIonly;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)




(* ------------------------------------------------------------ *)

CONST
    progPREPROC   = "PREPHIDN32";
    progREVEAL    = "FINDHIDN32";
    progSHOW      = "SHOWHIDN32";
CONST
    ProgEXEname   = progREVEAL;
    ProgTitle     = 'Q&D Search "hidden" words (Win32)';
    ProgVersion   = "v0.9a (from v1.0d for DOS)";
    ProgCopyright = "by PhG";

CONST
    errNone             = 0;
    errHelp             = 1;
    errUnknown          = 2;
    errTooMany          = 3;
    errNotFound         = 4;
    errConversion       = 5;
    errNeeded           = 6;
    errMinCount         = 7;
    errMaxCount         = 8;
    errTooLong          = 9;
    errTooShort         = 10;
    errNeedRoom         = 11;
    errNeverWare        = 12;
    errParmOverflow     = 13;
    errAborted          = 255;

PROCEDURE abort (e : CARDINAL;einfo:ARRAY OF CHAR );
CONST
    hlp =ProgTitle+" "+ProgVersion+" "+ProgCopyright+nl+
nl+
"Syntax : "+ProgEXEname+" <textfile> <-w:word> [-l:#] [-u:#] [-r]"+nl+
nl+
'This program *slowly* searches "hidden" words in a DOS ASCII text file,'+nl+
"provided file has *already* been processed with "+progPREPROC+" (un)utility,"+nl+
"another "+progREVEAL+" companion (un)utility with "+progSHOW+"."+nl+
"The three programs have been written in order to confirm"+nl+
'the nonsense of "hidden" words in the Bible or in any long text.'+nl+
nl+
"    -w:$ word to find"+nl+
"    -l:# lower count of characters to skip (default is 1)"+nl+   (* see infra *)
"    -u:# upper count of characters to skip (default is 50)"+nl+
"    -lim use EMS/LIM memory if present"+nl+
(* "    -a   audio warning for each entry found"+nl+ *)
"    -v   verbose eyecandy"+nl+
"    -z   show position as 0-based (default is 1-based)"+nl+
"    -sa  do not sort filenames alphabetically"+nl+
nl+
"a) Please remember <textfile> *must* have been preprocessed with "+progPREPROC+" !"+nl+
"b) Please remember this program is *slow*."+nl+
"c) Note position of any match found in text file is 1-based"+nl+
"   unless -z option has been specified."+nl+
"d) Note word is first searched verbatim then reversed."+nl+
"e) EMS/LIM is about five times SLOWER than conventional memory"+nl+
"   (at least with a true DOS). It SHOULD be safer anyway."+nl+
"   Besides, this option gives a sorted output."+nl+
"f) Using conventional memory, output will have to be sorted later."+nl+
"   Moreover, buffer overflow is likely to happen for big intervals."+nl+
"   Use the divide and conquer approach by searching small intervals."+nl+
"g) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" *.t -w:PHIL -u:666"+nl+
"           "+ProgEXEname+" test -w:HELL"+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(hlp);
    | errUnknown :
        S := "Unknown ~ option !";
    | errTooMany :
        S := "Too many files match ~ specification !";
    | errNotFound :
        S := "No file matches ~ specification !";
    | errConversion :
        S := "~ parameter is not a LONGCARD !";
    | errNeeded :
        S := "Word needed !";
    | errMinCount :
        S := "~ lower count to skip cannot be 0 !";
    | errMaxCount :
        S := "~ upper count to skip cannot be less than lower count !";
    | errTooLong :
        S := "~ word length cannot be more than 256 characters !";
    | errTooShort :
        S := "~ word length cannot be more less than 1 character !";
    | errNeedRoom :
        S := "Pending positions array overflow : please retry with a smaller interval !";
    | errNeverWare :
        S := "This MaybeWare is NeverWare : XMS will NOT be implemented !";
    | errParmOverflow:
        S := "~ is one parameter too many !";
    | errAborted :
        S := "Search aborted by user !";
    ELSE
        S := "How did you get THERE ?";
    END;
    CASE e OF
    | errNone,errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT (e);
END abort;

PROCEDURE alert (  );
BEGIN
    ;
END alert;

PROCEDURE candy (verbose:BOOLEAN;cmd:CARDINAL   );
BEGIN
    ;
END candy;

(* prevent freeze from Win9X hating fast kbd polling ! *)
CONST
    CHKEVERY = 64; (* 16 seems okay but let's play it safe *)
VAR
    globpollval  : CARDINAL; (* fix Win9X weird problem *)

PROCEDURE pollEscape (  ):BOOLEAN ;
VAR
    hit : BOOLEAN;
BEGIN
    hit := FALSE;
    INC(globpollval);
    IF (globpollval MOD CHKEVERY) = 0 THEN
        globpollval := 0;
        hit:=ChkEscape();
    END;
    RETURN hit;
END pollEscape;

(* ------------------------------------------------------------ *)

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead; (* 64 i.e. 32Kb was STUPID ! *)
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
VAR
    IObufferIn : ARRAY [firstIObufferByte..lastIObufferByte] OF SYSTEM.LOC; (* for private M2 IO *)

(* ------------------------------------------------------------ *)

CONST
    sizePage            = 16384; (* for LIM *)
    wordsPerPage        = 8192; (* for lib.wordmove *)
    firstInPage         = 1;
    lastInPage          = sizePage;
    firstpage           = 0; (* 0..pages-1 *)
    firstPhysicalPage   = 0; (* 0..3 *)
VAR
    pages : CARDINAL; (* global for LIM pages *)
    available : LONGCARD; (* global *)
    LIMhandle : CARDINAL;

(* ------------------------------------------------------------ *)


PROCEDURE dmpFound (VAR matchesfound:LONGCARD;
                   fpos:LONGCARD;interval:CARDINAL;
                   flagShowZeroBased,warn,flagReverse:BOOLEAN);
BEGIN
    IF flagShowZeroBased THEN DEC(fpos);END;
    IO.WrLngCard(fpos,9);
    WrStr(tabul);
    WrStr("(");
    IO.WrCard(interval,5);
    WrStr(")");
    IF flagReverse THEN WrStr(" R");END;
    WrLn;
    INC(matchesfound);
    IF warn THEN alert;END;
END dmpFound;

(* ------------------------------------------------------------ *)

(* buffers must be outside procedure, else bomb! *)

CONST
    bufferSize = 64 * 512 ; (* is AT LEAST 16 Kb, and here 32 Kb *)
    firstBufferChar = 1;
    lastBufferChar = bufferSize;
VAR
    Buffer : ARRAY [firstBufferChar..lastBufferChar] OF CHAR;

(* berk... should use linked list but... *)

CONST
    firstEntry = 1;
    lastEntry = 10000; (* maximum practical is 8000 here, 3000 seems enough *)
    freeEntry = 0; (* flag as interval 0 is a nonsense *)
TYPE
    entry = RECORD
                addr : LONGCARD;
                interval : CARDINAL;
                matchcount : SHORTCARD;
            END;
VAR
    pending : ARRAY [firstEntry..lastEntry] OF entry;

(* ------------------------------------------------------------ *)

(* yes, yes, we should have returned an error code instead of aborting inproc *)

PROCEDURE doSearchMain (VAR matchesfound:LONGCARD;
                       source : ARRAY OF CHAR;
                       wantedword : str128;
                       mincount,maxcount : CARDINAL;
                       flagReverse,warn,verbose,flagShowZeroBased : BOOLEAN);
VAR
    wordlen : CARDINAL;
    filesize : LONGCARD;
    posinfile : LONGCARD;
    got      : CARDINAL;
    ibuffer : CARDINAL;
    interval : CARDINAL;
    iword : CARDINAL;
    p : LONGCARD;
    i : CARDINAL;
    pbase,here : LONGCARD;
    offset : CARDINAL;
    liminf,limsup : LONGCARD;
    IOhndIn:FIO.File;
BEGIN
    FOR i := firstEntry TO lastEntry DO
        pending[i].interval := freeEntry ; (* used as a flag for free or not *)
    END;
  candy(verbose,cmdInit);
    wordlen := Str.Length(wantedword);
    IOhndIn:=FIO.OpenRead(source);
    FIO.AssignBuffer(IOhndIn,IObufferIn);
    filesize := FIO.Size(IOhndIn);
    posinfile := 0;
    LOOP
        got := FIO.RdBin(IOhndIn,Buffer,bufferSize);
        IF got = 0 THEN EXIT; END; (* filesize was a multiple of buffersize *)
        (* scan pending positions just in case *)
        liminf := posinfile + firstBufferChar; (* position of current start of buffer *)
        limsup := liminf + LONGCARD(got);
        FOR i := firstEntry TO lastEntry DO
  candy(verbose,cmdShow);
            IF pending[i].interval <> freeEntry THEN
                pbase := pending[i].addr;
                interval := pending[i].interval;
                iword := CARDINAL( pending[i].matchcount );
                (* here check and keep if necessary or show then clear *)
                LOOP
                    p := pbase + LONGCARD(interval) * LONGCARD(iword);
                    IF p >= limsup THEN (* past last byte of file *)
                        EXIT;
                    END;
                    IF p >= liminf  THEN (* p < limsup *)
                        offset := CARDINAL(p-liminf)+firstBufferChar;
                        IF wantedword[iword] # Buffer[offset] THEN
                            pending[i].interval:=freeEntry; (* clear ! *)
                            EXIT; (* no match so we can abort search here *)
                        END;
                        INC(iword); (* advance *)
                        IF iword = wordlen THEN
  candy(verbose,cmdStop);
                            here:=pbase;
                            dmpFound (matchesfound,
                                     here,interval,flagShowZeroBased,warn,flagReverse);
  candy(verbose,cmdInit);
                            pending[i].interval:=freeEntry; (* clear ! *)
                            EXIT; (* abort now, for iword is here >= wordlen *)
                        END;
                        INC(pending[i].matchcount);
                    END;
                END;
            END;
        END;

        (* scan normally *)
        FOR ibuffer := firstBufferChar TO got DO
  candy(verbose,cmdShow);
            FOR interval := mincount TO maxcount DO
                iword := 0;
                LOOP
                    (* first iword is always 0 *)
                    p := LONGCARD(ibuffer) + LONGCARD(iword) * LONGCARD(interval);
                    IF p > LONGCARD(got) THEN
                        IF got = lastBufferChar THEN (* past buffer so keep info for later *)
                            i := firstEntry;
                            LOOP
                                IF pending[i].interval = freeEntry THEN
                                    pending[i].addr := posinfile+LONGCARD(ibuffer);
                                    pending[i].interval := interval;
                                    pending[i].matchcount := SHORTCARD(iword);
                                    EXIT;
                                END;
                                INC(i);
                                IF i > lastEntry THEN
  candy(verbose,cmdStop);
                                    abort(errNeedRoom,"");
                                END;
                            END;
                        END;
                        EXIT; (* exit in all case : past buffer or past filesize ! *)
                    END;
                    IF wantedword[iword] # Buffer[CARDINAL(p)] THEN
                        EXIT; (* no match so we can abort search here *)
                    END;
                    INC(iword); (* advance *)
                    IF iword = wordlen THEN (* match for all chars of wantedword *)
  candy(verbose,cmdStop);
                        here:=posinfile+LONGCARD(ibuffer);
                        dmpFound (matchesfound,
                                 here,interval,flagShowZeroBased,warn,flagReverse);
  candy(verbose,cmdInit);
                        EXIT; (* abort now, for iword is here >= wordlen *)
                    END;
                END;
                (* check for escape key *)
                IF pollEscape () = TRUE THEN
                   FIO.Close(IOhndIn);
  candy(verbose,cmdStop);
                   abort(errAborted,"");
                END;
            END;
        END;
        INC (posinfile, LONGCARD (got) );
        IF got < bufferSize THEN EXIT; END;
    END;
    FIO.Close(IOhndIn);
  candy(verbose,cmdStop);
END doSearchMain;

(* ------------------------------------------------------------ *)

PROCEDURE doReverse (VAR S : str128);
VAR
    i,p : CARDINAL;
    N : str128;
BEGIN
    Str.Copy(N,S);
    p:=Str.Length(S);
    FOR i := 1 TO Str.Length(S) DO
        S[i-1] := N[p-1];
	DEC(p);
    END;
END doReverse;

(* ------------------------------------------------------------ *)

TYPE
    f8e3 = pathtype;
CONST
    firstFile = 1;
    lastFile  = 10000;
    maxFile   = lastFile-firstFile+1;
VAR
    fileArray : ARRAY [firstFile..lastFile] OF f8e3;

PROCEDURE buildList (VAR basepath:ARRAY OF CHAR;
                    spec:ARRAY OF CHAR):CARDINAL;
VAR
    countFile : CARDINAL;
    found     : BOOLEAN;
    entry     : FIO.DirEntry;
    u,path,f8,e3    : pathtype; (* oversized just in case *)
BEGIN
    qdSplitAllPath(spec,u,path,f8,e3);
    Str.Concat(basepath,u,path);

    countFile := 0;
    found := FIO.ReadFirstEntry(spec,allfiles,entry);
    WHILE found DO
        IF countFile = maxFile THEN RETURN MAX(CARDINAL); END;
        fileArray[firstFile+countFile]:=f8e3(entry.name);
        Str.Caps(fileArray[firstFile+countFile]); (* useless ! *)
        INC (countFile);
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN countFile;
END buildList;

PROCEDURE isLessByName (i,j:CARDINAL):BOOLEAN;
VAR
    si,sj:f8e3;
BEGIN
    si:=fileArray[i];
    sj:=fileArray[j];
    RETURN ( Str.Compare(si,sj) < 0 );
END isLessByName;

PROCEDURE doSwapNames (i,j:CARDINAL);
VAR
    si,sj,tmp:f8e3;
BEGIN
    si:=fileArray[i];
    sj:=fileArray[j];
    tmp:=si;
    si:=sj;
    sj:=tmp;
    fileArray[i]:=si;
    fileArray[j]:=sj;
END doSwapNames;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minLen = 2; (* trick because 1 char gives all intervals... and I'm too lazy to put limit test at the beginning! :-) *)
    maxLen = 48; (* should be enough! *)
VAR
    mincount : LONGCARD; (* 1.. *)
    maxcount : LONGCARD;
    matchesfound   : LONGCARD;
    DEBUG,flagReverse,flagShowZeroBased,audiowarn,verbose,alphasort : BOOLEAN;
    wantedword,reversedwantedword,wanted : str128;

    flagMemType : CARDINAL;

    parms : CARDINAL;
    i : CARDINAL;
    S : pathtype;
    opt : CARDINAL;
    memtype : CARDINAL;

    source,basepath:pathtype;
    filecount:CARDINAL;
    state:(waiting,gotspec);
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    audiowarn       := FALSE;
    mincount        := 1;
    maxcount        := 50;
    wantedword      := "";
    alphasort       := TRUE;
    verbose         := FALSE;
    flagShowZeroBased  := FALSE;
    DEBUG           := FALSE;

    state           := waiting;

    parms := Lib.ParamCount();
    IF parms = 0 THEN abort (errHelp,""); END;
    FOR i := 1 TO parms DO
        Lib.ParamStr(S,i);cleanCLI(S); ReplaceChar(S,dquote,"");
        IF isOption(S)=TRUE THEN
            UpperCaseXDS (S);
            opt := GetOptIndex (S,"W:"+delim+"WORD:"+delim+
                                  "L:"+delim+"LOWER:"+delim+
                                  "U:"+delim+"UPPER:"+delim+
                                  "Z"+delim+"ZEROBASED"+delim+
                                  "lim"+delim+"ems"+delim+
                                  "a"+delim+"audiowarn"+delim+
                                  "?"+delim+"H"+delim+"HELP"+delim+
                                  "SA"+delim+"NOALPHASORT"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "DEBUG"
                                );

            CASE opt OF
            | 1,2 :
                 GetString(S,wantedword);
                 LowerCase(wantedword);
                 FixAE(wantedword); (* unlikely but... *)
                 ReplaceChar(wantedword,"","c"); (* french safety *)
            | 3,4 :
                 IF GetLongCard(S,mincount)=FALSE THEN abort(errConversion,S);END;
            | 5,6 :
                 IF GetLongCard(S,maxcount)=FALSE THEN abort(errConversion,S);END;
            | 7,8:
                flagShowZeroBased:=TRUE;

            | 9,10 :
                 ;
            | 11,12:
                 audiowarn := TRUE;
            | 13,14,15 :
                abort(errHelp,"");
            | 16,17:
                alphasort:=FALSE;
            | 18,19:
                verbose:=TRUE;
            | 20:
                DEBUG := TRUE;
            ELSE
                abort(errUnknown,S);
            END;
        ELSE
            CASE state OF
            | waiting: (* UpperCase (S); *) source:=S;
            | gotspec: abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;

    IF state = waiting THEN abort(errHelp,"");END;

    IF same(wantedword,"") THEN abort(errNeeded,""); END;

    IF mincount < 1 THEN abort (errMinCount,"-l:#"); END;
    IF maxcount < mincount THEN abort (errMaxCount,"-u:#"); END;
    IF Str.Length(wantedword) > maxLen THEN abort(errTooLong,wantedword); END;
    IF Str.Length(wantedword) < minLen THEN abort(errTooShort,wantedword); END;



    IF same(source,dot) THEN source:=stardotstar;END;

    filecount := buildList(basepath, source);
    CASE filecount OF
    | 0 : abort(errNotFound,source);
    | MAX(CARDINAL): abort(errTooMany,source);
    ELSE
        IF alphasort THEN Lib.QSort(filecount,isLessByName,doSwapNames);END;
    END;

    (*
    WrStr(ProgTitle+" "+ProgVersion+" "+ProgCopyright);
    WrLn;
    *)

    WrLn;

         WrStr("Using conventional memory");  WrLn;

    WrLn;

    reversedwantedword:=wantedword;
    doReverse(reversedwantedword);

    FOR i := 1 TO filecount DO
        Str.Concat(source,basepath,fileArray[firstFile+i-1]);

        (* no longer in do*search as TO avoid isl342 ! *)

        WrStr("Text file        : "); WrStr(source);WrLn;
        WrStr('Searched string  : "');WrStr(wantedword);WrStr('"');WrLn;
        WrStr('Reversed string  : "');WrStr(reversedwantedword);WrStr('"');WrLn;
        WrStr("Minimum interval : ");IO.WrLngCard(mincount,1);WrLn;
        WrStr("Maximum interval : ");IO.WrLngCard(maxcount,1);WrLn;
        WrStr("Position mode    : ");
        IF flagShowZeroBased THEN
            WrStr("0");
        ELSE
            WrStr("1");
        END;
        WrStr("-based");WrLn;
        WrLn;

        globpollval := 0; (* init Win9X fix *)

        matchesfound := 0;

        FOR opt := 1 TO 2 DO
            CASE opt OF
            | 1: flagReverse := FALSE; wanted:=wantedword;
            | 2: flagReverse := TRUE;  wanted:=reversedwantedword;
            ELSE ; (* //ISO fixed silly requirement *) END;
                doSearchMain ( matchesfound,
                               source, wanted,
                               CARDINAL(mincount),CARDINAL(maxcount),
                               flagReverse,audiowarn,verbose,flagShowZeroBased);
        END;

        IF matchesfound # 0 THEN WrLn;END;
        WrStr("Entries found    : ");
        IO.WrLngCard(matchesfound,1);WrLn;
        WrLn;
    END;

    abort(errNone,"");
END findHIDN32.


(*
24 bytes of test file : convert it to LOWERCASE ! ;-)
WHELLHHEELXLHHXEHELLXLYZ
2,1
6,2
17,1
13,3
*)
