(* ---------------------------------------------------------------
Title         see help !
Author        who cares ?
Overview      see help !
Usage         see help !
Notes         grep-like syntax : text then file !
              Str.Match is case-insensitive : it's useless to enable -e with
              delete/keep/viewmatch/viewgrep in joker mode !
              (check if -vv is always -v -z)

              beware of adding features
              (or "to be done" / "not finished yet" portions of code !)
              just because they MIGHT be used someday :
              this is the way quirks & bugs happen
              always add features which are needed in real world situations
              and code everything at once
              (here, without any REAL need or demand,
              we had thought of parsing #..# too
              yet without adding full support code for it :
              fortunately, we had thought of limiting check for #,# alone !)

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          with -uu, last line should be empty in order to avoid a wrong duplicate
              rarely used -z is sometimes wrong, need to recheck code (see //FIXME)
Wish List     use jokers in replace mode ? bah...
              allow removal of substrings delimited by chars, or path ?
              "keep first" command ? even though it's delete first + baseline ?
              process case before Str.Match ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !
              add a warning about tabs not expanded with /u ?
	
Who When      What
--- --------- ----------------------------------------------------
PhG 14 Apr 22 v0.9d try and keep in sync with NEWLINE v1.1s for DOS
PhG  9 Feb 22 v0.9c hopefully fixed escaped sequences
PhG 24 Oct 21 v0.9b keep in sync with NEWLINE v1.1r for DOS
PhG 25 Apr 19 v0.9a fixed help screen
PhG 15 May 18 an ugly really Q&D port from NEWLINE v1.1o for DOS
--------------------------------------------------------------- *)

MODULE NewLine32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn, WrLngCard, WrCard;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)
CONST
    escChVisual	  = "";
    escSetVisual  = escChVisual+"-/'%";
    escCh         = 0260C; 	
    escSet        = escCh+"-/'%";

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)


PROCEDURE LowerCaseAlt(VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S); (* //FIXME *)
END LowerCaseAlt;

PROCEDURE UpperCaseAlt(VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S); (* //FIXME *)
END UpperCaseAlt;



PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDir (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDir;

PROCEDURE isDirectorySpec ( S:pathtype ):BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDir(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectorySpec;


PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(*
shame on you not to have thought of more than one value at a time !
shame on you for relying on an external library to parse a mere hex value !
really gone is your Apple ][ genius... :-(
bah, old age is coming faster than end of the world...
*)

(* assume : digits already filtered and uppercased, base = 10 or 16, hex=## *)

PROCEDURE charvalToStr (VAR R:ARRAY OF CHAR; base:CARDINAL; digits:ARRAY OF CHAR):BOOLEAN;

    MODULE hxhelper;

    EXPORT hx;

    PROCEDURE hx (ch:CHAR):CARDINAL;
    CONST
        val0 = ORD("0");
        valA = ORD("A");
    VAR
        v:CARDINAL;
    BEGIN
        v:=ORD(ch);
        IF v < valA THEN
            DEC(v, val0 );
        ELSE
            DEC(v, valA );
            INC(v, 10);
        END;
        RETURN v;
    END hx;

    END hxhelper;

CONST
    maxcharval = MAX(SHORTCARD);
VAR
    rc : BOOLEAN;
    i,len,v: CARDINAL;

BEGIN
    rc := TRUE;
    len:= Str.Length(digits);
    Str.Copy(R,"");
    CASE base OF
    | 10: (* filtered for 0..9 *)
        v:=0;
        i:=1;
        LOOP
            IF i > len THEN EXIT;END;
            v := (v * 10);
            INC( v , ( ORD( digits[i-1] ) - ORD("0") ) );
            rc := ( v <= maxcharval ); IF NOT(rc) THEN EXIT; END;
            INC(i);
        END;
        IF rc THEN rc := (v # 0); END;
        IF rc THEN Str.Copy( R, CHR(v) );END;
    | 16: (* filtered for 0..9 A..F *)
        (* IF len < 2 THEN Str.Prepend(digits,"0"); INC(len);END; done by caller *)
        IF ODD(len) THEN
            rc:=FALSE;
        ELSE
            i:=1;
            LOOP
                IF i > len THEN EXIT; END;
                v:=  ( hx(digits[i-1]) << 4 );
                INC(i);
                INC(v, hx(digits[i-1]) );
                INC(i);
                rc := (v # 0);
                IF NOT(rc) THEN EXIT; END;
                Str.Append(R, CHR(v) );
            END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN rc;
END charvalToStr;

(*

n  p  q  -  /  '  

###    $##    x##

*)


PROCEDURE metaproc (VAR S : ARRAY OF CHAR):BOOLEAN;
VAR
    ch:CHAR;
    c2:str80; (* really oversized for safety *)
    len,i,base:CARDINAL;
    R,orgS:str128;
    str:str128; (* in case we overflow ! *)
    state : (waiting,gotesc,grabhex,grabdec);
    rc:BOOLEAN;
BEGIN
    Str.Copy(orgS,S); (* in case of an error, return original unmodified string *)
    len := Str.Length(S);
    R   := "";
    i   := 1;
    rc  := TRUE;
    state := waiting;
    LOOP
        IF i > len THEN EXIT; END;
        ch := S[i-1];
        CASE state OF
        | waiting:
            CASE ch OF
            | escCh :
                state := gotesc;
            ELSE
                Str.Append(R,ch);
            END;
        | gotesc:
            CASE ch OF
            | "x","X","$":Str.Copy(str,"");         state:=grabhex; base:=16;
            | "0".."9" :  Str.Copy(str,ch);         state:=grabdec; base:=10;
            | "n","N" :   Str.Append(R,nl);         state:=waiting;
            | "p","P" :   Str.Append(R,percent);    state:=waiting;
            | "q","Q" :   Str.Append(R,doublequote);state:=waiting;
            | "b","B" :   Str.Append(R,vbar);       state:=waiting;
            ELSE
                IF Str.CharPos(escSet,ch) = MAX(CARDINAL) THEN
                    DEC(i); (* esc+verbatim : go back to make verbatim the next *)
                ELSE
                    Str.Append(R,ch); (* esc+reserved char *)
                END;
                state:=waiting;
            END;
        | grabhex:
            CASE ch OF
            | "0".."9", "A".."F", "a".."f" :
                Str.Append(str, CAP(ch) ); (* uppercase ! *)
            | escCh:
                IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                state:=waiting; (* //FIX was gotesc *)
            ELSE
                IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                DEC(i); (* go back one char now to make it next *)
                state:=waiting;
            END;
        | grabdec:
            CASE ch OF
            | "0".."9" :
                Str.Append(str,ch);
            | escCh:
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                state:=waiting; (* //FIX was gotesc *)
            ELSE
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                DEC(i); (* go back one char now to make it next *)
                state:=waiting;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(i);
    END;
    CASE state OF
    | grabhex:
        IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
        rc:=charvalToStr(c2,base,str);
        IF rc THEN Str.Append(R,c2); END;
    | grabdec:
        rc:=charvalToStr(c2,base,str);
        IF rc THEN Str.Append(R,c2); END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF rc THEN
        Str.Copy(S,R);
    ELSE
        Str.Copy(S,orgS); (* restore original *)
    END;
    RETURN rc;
END metaproc;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)




(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    DEFAULT       = MAX(CARDINAL);
    COLUMNEOL     = MAX(CARDINAL)-1;
    sEOL          = "*";
    MAXPROCESSEDLINES=MAX(LONGCARD) DIV 2;
    sALLLINES     = "*"; (* sEOL *)
    sMAXRANGE     = "4096"; (* max line length = until last char *)
    msgProcessing = " ";
    msgWait       = "Please wait...";
    emudupfirst   = nl+"# ";
    emudup        = "; ";
    seplinenum    = " : ";
CONST
    extBAK        = ".BK!";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    skippedextensions    = extBAK+delim+extCOM+delim+extEXE+delim+
                           extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                           extZIP+delim+extARJ+delim+extLZH;
CONST
    ProgEXEname   = "NEWLINE32";
    ProgTitle     = "Q&D textfile line modifier/viewer (Win32)";
    ProgVersion   = "v0.9d (from v1.1r for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errConflict         = 2;
    errUnknownOption    = 3;
    errParmOverflow     = 4;
    errExpected         = 5;
    errTooMany          = 6;
    errNoMatch          = 7;
    errNonsense         = 8;
    errBadColumn        = 9;
    errBadCount         = 10;
    errBadRange         = 11;
    errBadMeta          = 12;
    errRangeDefinedAlready=13;
    errBadBaseLine      = 14;
    errJoker            = 15;
    errNonsenseMatch    = 16;
    errBadNumSuffix     = 17;
    errBadFieldWidth    = 18;
    errBadIncrement     = 19;
    errBadExt           = 20;

    errStorage          = 21;
    errNetSlash         = 22;
    errPhantomUnit      = 23;
    errBadUnit          = 24;
    errColon            = 25;
    errNoParent         = 26;
    errInnerParent      = 27;
    errDirJoker         = 28;
    errBadTabWidth      = 29;
    errEntryIsFile      = 30;
    errEntryNotFound    = 31;

    errHelper           = 128;

    errUserAborted      = 255;


PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder = "~";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
ProgEXEname+" utility may be called with the following options (-?? = more help) :"+nl+
nl+
"Syntax 1  : <-a|-append> [-t] [-f] [-n:#] [-f:#] [-k:#] <text> <file(s)>"+nl+
"Syntax 2  : <-p|-prepend> [-t] [-f] [-n:#] [-f:#] [-k:#] <text> <file(s)>"+nl+
"Syntax 3  : <-i|-insert> [-f] <-c:#> <text> <file(s)>"+nl+
"Syntax 4  : <-c|-change> [-e] [-c:#] <oldtext> <newtext> <file(s)>"+nl+
"Syntax 5  : <-r|-remove> [-e] [-c:#] <text> <file(s)>"+nl+
"Syntax 6  : <-d|-delete> [-e] [-c:#] [-j] <text> <file(s)>"+nl+
"Syntax 7  : <-k|-keep> [-e] [-c:#] [-j] [-b] <text> <file(s)>"+nl+
"Syntax 8  : <-v[v]> [-e] [-c:#] [-l] [-t] [-z[z][c]] [-j] [--] <text> <file(s)>"+nl+
"Syntax 9  : <-df|-dl|-vf|-vl> [-l] [-baseline:#] <count> <file(s)>"+nl+
"Syntax 10 : <-u|-unique> [-ignore:#,#] [-only:#,#] [-e] [-y] [--[-]] <file(s)>"+nl+
"Syntax 11 : <-m|-merge> [-c:#] [-t] [-tab] <datafile> <file(s)>"+nl+
"Syntax 12 : <-n|-reinject> <datafile> <file>"+nl+
"Syntax 13 : <-g[:#]|-untab[:#]> <file(s)>"+nl+
nl+
"The following options apply to all syntaxes :"+nl+
nl+
"  -s   allow processing of subdirectories"+nl+
"  -!   filter files using operating system jokers (read note infra)"+nl+
"  -w   disable ESCape polling (may be necessary with Win9X/WinXP)"+nl+
nl+
"a) For each processed file, original version is kept with "+extBAK+" extension."+nl+
"b) Complex <text> specification should be delimited by double quotes ;"+nl+
"   note command line parsing prevents double quotes from being used in <text>."+nl+

(* replace escCh with "" because we're fed up with ISO octal ! *)

'c) "'+escChVisual+'n" = $0d0a, "'+escChVisual+'p" = "%", "'+
escChVisual+'q" = double quote, "'+escChVisual+'b" = vertical bar ($7c),' +nl+
'   "'+escChVisual+'['+escSetVisual+']" = symbol, '+
'"'+escChVisual+'[$|x]#['+escChVisual+']" = (hexa)decimal value ($00 not allowed).'+nl+
"d) Tabs are NOT expanded and line length should be less than 4096 characters."+nl+
'e) Jokers may be "?" (any character) or "*" (any sequence, empty or not) :'+nl+
'   specify -SoL and/or -EoL not to automagically prepend/append "*" to <text>.'+nl+
"   -jj stands for -j -SoL -EoL, and [j[j]] can be appended to -d, -k or -v."+nl+
"f) -quiet option suppresses final report. Hit ESC to abort when viewing data."+nl+
'g) Without -! option, "?" and "*" jokers do NOT work the DOS or Win9X way :'+nl+
'   "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"h) "+skippedextensions+" files are not processed."+nl+
"i) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Syntax 1 or 2 : prepend or append exact <text> to each line."+nl+
" -force allows command to apply to empty or blank lines."+nl+
" -trim performs left or right triming preprocessing."+nl+
" -n:# specifies auto-incremented number prepended or appended to <text>."+nl+
" -f:# specifies auto-incremented number field width ([1..12], default is 4)."+nl+
" -k:# specifies auto-incremented number increment ([1..100], default is 1)."+nl;

verbosehelpmsg =
"Syntax 3 : insert <text> at specified <column> in each line."+nl+
" -force allows command to apply to empty or blank lines."+nl+
" -column:# (from 1 upwards) specifies column to insert <text> at."+nl+
"Syntax 4 : replace <oldtext> with <newtext> in each line."+nl+
(* '  Optional column may be specified as "'+sEOL+'" for EOL.'+nl+ *)
" -exact forces case-sensitive operation."+nl+
' -column:# (from 1 upwards, "'+sEOL+'"=EOL) removes only one occurrence of <oldtext>.'+nl+
"Syntax 5 : remove <text> from each line."+nl+
" -exact forces case-sensitive operation."+nl+
" -column:# (from 1 upwards) removes only one occurrence of <text>."+nl+
"Syntax 6 or 7 : filter out or keep each line containing <text>."+nl+
" -exact forces case-sensitive operation."+nl+
" -column:# (from 1 upwards) requires <text> to be at specified column."+nl+
" -joker specifies <text> to be a pattern searched for (read note supra)."+nl+
" -b preserves empty lines (-keep only)."+nl+
"Syntax 8 : show each line containing <text>."+nl+
" -exact forces case-sensitive operation."+nl+
" -column:# (from 1 upwards) scans for <text> from specified column."+nl+
" -vv forces a display loosely similar to Borland GREP.COM utility."+nl+
" -line shows line number."+nl+
" -z prevents files with 0 match from being listed."+nl+
" -zz acts as -z option, also preventing matching lines from being displayed."+nl+
" -zc, -zzc, -cc and -ccc force display of matching lines count."+nl+
" -joker specifies <text> to be a pattern searched for (read note supra)."+nl+
" -- reverses match condition, showing each line NOT containing <text>."+nl+
"Syntax 9 : delete or show <count> first or last lines, or from specified line."+nl+
' If specified as "'+sALLLINES+'", <count> is maximum number of lines.'+nl+
" -line shows line number."+nl+
" -baseline:# (from 1 upwards) specifies line to begin from."+nl+
"Syntax 10 : filter out duplicate lines, keeping the first occurrence (default)."+nl+
" File(s) to process MUST be already sorted."+nl+
' Optional columns range is either "column,count" or "first..last" ("'+sEOL+'"=EOL).'+nl+
' -ignore:#,# ignores specified columns range.'+nl+
' -only:#,# uses only specified columns range.'+nl+
" -exact forces case-sensitive operation."+nl+
" -o prepends count of duplicates"+nl+
" -strict|-y removes duplicate lines, including the first occurrence."+nl+
" --[-] reverses process, filtering out single lines (--- = DUPLINES format)."+nl+
" -uu is a shortcut for -unique -strict|-y."+nl+
"Syntax 11 : append lines from <datafile> to lines from <file>."+nl+
" -column:# (from 1 upwards) pads each line to specified column, if needed."+nl+
" -trim performs left and right triming preprocessing to each line."+nl+
" -tab uses a tab as separator (default is a space)."+nl+
"Syntax 12 : replace <file> lines with numbered <datafile> lines."+nl+
" <datafile> must have been dumped with -line option, <file> must be unique."+nl+
"Syntax 13 : expand tabs (default tab width is 8 unless specified with -g:#)."+nl;
VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp,errHelper :
        WrStr(helpmsg);
        IF e=errHelper THEN
            WrStr(verbosehelpmsg);
            e := errHelp;
        END;
    | errConflict :
        S := "Commands are mutually exclusive !";
    | errUnknownOption :
        S := "Unknown ~ option !";Str.Subst(S,placeholder,einfo);
    | errParmOverflow :
        S := "Unexpected ~ parameter !";Str.Subst(S,placeholder,einfo);
    | errExpected:
        S := "~ expected !";Str.Subst(S,placeholder,einfo);
    | errTooMany:
        S := 'Too many files match "~" specification !';Str.Subst(S,placeholder,einfo);
    | errNoMatch:
        S := 'No legal match for "~" specification !';Str.Subst(S,placeholder,einfo);
    | errNonsense:
        S := "~ option is a nonsense with specified command !";Str.Subst(S,placeholder,einfo);
    | errBadColumn:
        S := "Illegal ~ column value !";Str.Subst(S,placeholder,einfo);
    | errBadCount:
        S := "Illegal ~ count value !";Str.Subst(S,placeholder,einfo);
    | errBadRange:
        S := "Illegal ~ range !";Str.Subst(S,placeholder,einfo);
    | errUserAborted:
        S := "Aborted by user !";
    | errBadMeta:
        S := "Illegal escape sequence (~) !";Str.Subst(S,placeholder,einfo);
    | errRangeDefinedAlready:
        S := "-unique command accepts only one -i: or -o: range !";
        (* "Columns range for -unique option has already been defined !" *)
    | errBadBaseLine:
        S := "Illegal ~ line value !";Str.Subst(S,placeholder,einfo);
    | errJoker:
        S := "~ cannot contain any joker !";Str.Subst(S,placeholder,einfo);
    | errNonsenseMatch:
        S := "~ option is a nonsense with -joker option !";Str.Subst(S,placeholder,einfo);
    | errBadNumSuffix:
        S := "Illegal ~ number suffix value !";Str.Subst(S,placeholder,einfo);
    | errBadFieldWidth:
        S := "Illegal ~ field width value !";Str.Subst(S,placeholder,einfo);
    | errBadIncrement:
        S := "Illegal ~ increment value !";Str.Subst(S,placeholder,einfo);
    | errBadExt :
        S := "File extension would prevent file(s) from being processed !";
    | errStorage :
        S:='Storage.ALLOCATE() failure while processing "~" specification !';
        Str.Subst(S,placeholder,einfo);
    | errNetSlash :
        S:='Illegal server "\\" in "~" specification !';Str.Subst(S,placeholder,einfo);
    | errPhantomUnit :
        S:='Unavailable unit in "~" specification !';Str.Subst(S,placeholder,einfo);
    | errBadUnit :
        S:='Illegal unit in "~" specification !';Str.Subst(S,placeholder,einfo);
    | errColon :
        S:='Unexpected ":" in "~" specification !';Str.Subst(S,placeholder,einfo);
    | errNoParent :
        S:='Unresolvable ".." in "~" specification !';Str.Subst(S,placeholder,einfo);
    | errInnerParent :
        S:='Illegal ".." in "~" specification !';Str.Subst(S,placeholder,einfo);
    | errDirJoker :
        S:='Illegal "~" directory joker(s) !';Str.Subst(S,placeholder,einfo);
    | errBadTabWidth:
        S := "Illegal ~ tab width !";Str.Subst(S,placeholder,einfo);
    | errEntryIsFile:   (* never displayed *)
        S := '"~" specification is not a directory !';
    | errEntryNotFound: (* never displayed *)
        S := '"~" specification does not exist !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //FIXME *)

CONST
    CHKEVERY9X = 64; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 4;  (* safety *)

PROCEDURE pollEscape (VAR chkrounds:CARDINAL; useLFN,ignoreESC:BOOLEAN):BOOLEAN;
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomely hangs till a keypress
    Flushkey() does NOT help
    *)
    (*
    IF useLFN THEN
        hit:=FALSE;
    ELSE
        hit:=ChkEscape();
    END;
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    IF useLFN THEN
        every:=CHKEVERY9X;
    ELSE
        every:=CHKEVERYDOS;
    END;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEscape;

(* ------------------------------------------------------------ *)

PROCEDURE padnum (lc:LONGCARD;wi:CARDINAL;padchar:CHAR   ):str80;
VAR
    R:str80;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(lc,R,10,ok);
    FOR i:=Str.Length(R)+1 TO wi DO
        Str.Prepend(R,padchar);
    END;
    RETURN R;
END padnum;

(* fix : we assumed exactly 3 chars extensions : .ex would match .exe, .ex$, etc. *)

PROCEDURE legalextension (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n,p,len:CARDINAL;
    rc:BOOLEAN;
BEGIN

    Str.Caps(S); (* ah, lowercase LFNs... *)

    rc:=TRUE;
    n:=0;
    len:=Str.Length(S);
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        p:=Str.Pos(S,e3);
        IF p # MAX(CARDINAL) THEN
            IF (len-p) = Str.Length(e3) THEN rc:=FALSE; EXIT; END;
        END;
        INC(n);
    END;
    RETURN rc;
END legalextension;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doGetDir (useLFN:BOOLEAN;currdrive:SHORTCARD;
                   VAR currdir: pathtype);
VAR
    longform:pathtype;
    rc:CARDINAL;
BEGIN
    FIO.GetDir(currdrive,currdir); (* we could use 0 for default drive *)
END doGetDir;

(* u, "\*\", "u:\*\" *)

PROCEDURE getAnchor (useLFN:BOOLEAN;
                     VAR currdrive:SHORTCARD;
                     VAR currdir,currpath:pathtype);
VAR
    driveletter:CHAR;
BEGIN
    currdrive := FIO.GetDrive(); (* 1=A, etc. *)
    doGetDir(useLFN,currdrive, currdir);
    fixDirectory(currdir);
    driveletter := CHAR (currdrive+ORD("A")-1);
    Str.Concat(currpath, driveletter,colon);
    Str.Append(currpath, currdir);
END getAnchor;

(* code adapted from FCOMP v1.3c *)

(* minimalist *)

PROCEDURE buildParent (VAR parent:pathtype; current:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(current,"\") THEN RETURN FALSE; END;
    unfixDirectory(current);
    p:=Str.RCharPos(current,"\");
    Str.Slice(parent,current,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END buildParent;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(*
    remember dirs can have an extension, and LFNs can have inner dots !
    we handle (whether u: or not) :

    .        current
    ..       parent
    .\xxx    current\xxx       F/D
    ..\xxx   parent\xxx        F/D

    xxx\     current\xxx\
    xxx\.    current\xxx\
    xxx      current\xxx       F/D

    \xxx\    \xxx\
    \xxx     \xxx              F/D
*)

PROCEDURE chkfixSpec (VAR base,spec:pathtype;
                     useLFN:BOOLEAN;orgS:pathtype;HDletters:ARRAY OF CHAR):CARDINAL;
VAR
    p,len,rc:CARDINAL;
    drive:SHORTCARD;
    u:CHAR;
    unit:str2;
    current,parent,S:pathtype;
    ok:BOOLEAN;
BEGIN
    Str.Copy(S,orgS);
    IF Str.Pos(S,"\\") # MAX(CARDINAL) THEN RETURN errNetSlash;END;

    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
        rc:=errNone;
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                IF verifyString(u,HDletters) THEN
                    drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                    Str.Delete(S,0,2); (* remove u: *)
                    rc:=errNone;
                ELSE
                    rc:=errPhantomUnit;
                END;
            ELSE
                rc:=errBadUnit;
            END;
        ELSE
            rc:=errColon;
        END;
    ELSE
        rc:=errColon;
    END;
    IF rc # errNone THEN RETURN rc; END;

    (* note S no longer has u: *)

    doGetCurrent(useLFN,drive, unit,current); (* "u:" and "\" or "\*\" *)
    ok:=buildParent(parent, current);

    IF same(S,".") THEN Str.Copy(S,current);END;
    IF same(S,"..") THEN
        IF ok THEN Str.Copy(S,parent) ELSE RETURN errNoParent; END;
    END;
    IF Str.Match(S,".\*") THEN Str.Subst(S,".\",current); END;
    IF Str.Match(S,"..\*") THEN
        IF ok THEN Str.Subst(S,"..\",parent) ELSE RETURN errNoParent;END;
    END;
    IF Str.Match(S,"\*")=FALSE THEN Str.Prepend(S,current);END;
    IF Str.Match(S,"*\.") THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    IF Str.Match(S,"*\") THEN
        Str.Concat(base,unit,S);
        Str.Copy(spec,"*.*");
    ELSE
        Str.Prepend(S,unit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,"\");
        Str.Slice(base,S,0,p+1);
        Str.Slice(spec,S,p+1,len-p);
        IF chkJoker(spec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF isDirectorySpec(S) THEN
                Str.Copy(base,S);
                fixDirectory(base); (* safety *)
                Str.Copy(spec,"*.*");
            ELSE
                (* //FIXED hopefully : either entry not found, or found a file *)
                IF FIO.Exists(S) THEN
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,"."); (* file extension *)
                    END;
                    RETURN errEntryIsFile;
                ELSE
(* T FIXCHKFIXSPEC *)
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,".*");
                        Str.Append(S   ,".*");
                    END;
                    IF FIO.Exists(S) THEN
                        RETURN errEntryIsFile;
                    ELSE
                        RETURN errEntryNotFound;
                    END;
(* E  *)
(* F FIXCHKFIXSPEC
                    RETURN errEntryNotFound;
   E  *)
                END;
            END;
        END;
    END;
    IF chkJoker(base) THEN RETURN errDirJoker; END;
    (* //FIXED hopefully *)
    IF Str.Length(base) > 3 THEN (* "u:\" is assumed to always exist *)
        unfixDirectory(base);
        IF FIO.Exists(base)=FALSE THEN RETURN errEntryNotFound;END;
        fixDirectory(base);
    END;
    RETURN errNone;
END chkfixSpec;


(* ------------------------------------------------------------ *)

CONST
    firstindex = 1; (* because we'll need 1-1 *)
TYPE
    pEntry = POINTER TO entryType;
    entryType = RECORD
        next      : pEntry;
        index     : CARDINAL;  (* [1.. is ID of base dir for files *)
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pEntry );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pEntry);
VAR
    needed : CARDINAL;
    p      : pEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(entryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(entryType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* ------------------------------------------------------------ *)

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

PROCEDURE findByIndex(wanted:CARDINAL;anchor:pEntry) : pEntry;
VAR
    p:pEntry;
BEGIN
    p := anchor;
    LOOP
        IF p = NIL THEN EXIT;END; (* gloups ! should NEVER happen ! *)
        IF p^.index = wanted THEN EXIT; END;
        p := p^.next;
    END;
    RETURN p;
END findByIndex;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildDirList (VAR lastdir:CARDINAL; VAR anchor:pEntry;
                       useLFN,recurse:BOOLEAN;base:pathtype):CARDINAL;
VAR
    p: pEntry;
    len : CARDINAL;
    root,rootspec,entryname,newroot : pathtype;
    entry : FIO.DirEntry;
    found : BOOLEAN;
    dosattr:FIO.FileAttr;
    errcode:CARDINAL;
    rc : CARDINAL;
    ok:BOOLEAN;
BEGIN
    Str.Copy(root,base);
    fixDirectory(root); (* safety *)

    (* assume base exists ! *)

    len:=Str.Length(root);
    IF buildNewPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
    INC(lastdir);
    p^.index     := lastdir;
    p^.slen      := SHORTCARD(len);
    Lib.FastMove ( SYSTEM.ADR(root),SYSTEM.ADR(p^.str),len );

    IF NOT(recurse) THEN RETURN errNone; END;

    Str.Concat(rootspec,root,"*.*");
    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;
            IF (aDD IN dosattr) THEN
                Str.Concat(newroot,root,entryname); (* u:\xx\ + xxx *)
                fixDirectory(newroot);
                rc:= buildDirList (lastdir,anchor,
                                  useLFN,recurse,newroot);
                IF rc # errNone THEN
                    RETURN rc;
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END buildDirList;

PROCEDURE dmpDirs (anchor:pEntry;useLFN:BOOLEAN);
CONST
    sInfo = 'DIR  index= ~  "~"'; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=anchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);  Str.Subst(S,"~",padnum(LONGCARD(p^.index),5,"0"));
        Str.Subst(S,"~", R);
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpDirs;

PROCEDURE dmpFiles (fileanchor,diranchor:pEntry;dirindex:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = 'File index= ~  "~"'; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    base,R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=findByIndex(dirindex,diranchor);
    getStr(base,p);

    p:=fileanchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);
        Str.Subst(S,"~",padnum(LONGCARD(p^.index),5,"0"));
        Str.Prepend(R,base);
        Str.Subst(S,"~", R);
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpFiles;

(* modified DD v1.0h sub *)

PROCEDURE storeFiles (VAR globallastfile:LONGCARD; VAR lastfile:CARDINAL;
                     VAR fileanchor : pEntry;
                     useLFN,osjokers:BOOLEAN; base,spec:pathtype;
                     skipext:ARRAY OF CHAR):CARDINAL;
VAR
    matchspec,rootspec,entryname : pathtype;
    dosattr:FIO.FileAttr;
    errcode:CARDINAL;
    entry : FIO.DirEntry;
    ok,keepit,found : BOOLEAN;
    len:CARDINAL;
    pp:pEntry;
BEGIN
    lastfile     := firstindex-1; (* 0 *)
    initList(fileanchor);

    IF osjokers THEN
        Str.Concat(rootspec,base,spec);
        Str.Copy(matchspec,"*");         (* match everything *)
    ELSE
        Str.Concat(rootspec,base,"*.*"); (* was spec before osjoker option *)
        Str.Copy(matchspec,spec);
    END;

    (* allfiles is a better choice than everything here *)
    found := FIO.ReadFirstEntry(rootspec,allfiles,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;

            ok := NOT (aDD IN dosattr); (* was valid when we used everything attribute *)

            IF ok THEN
                ok := legalextension(entryname,skipext);
            END;

            IF ok THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                ok:=Str.Match(entryname,matchspec); (* was spec *)
                IF ok THEN
                    len:=Str.Length(entryname);
                    IF buildNewPtr(fileanchor,pp,len)=FALSE THEN
                        RETURN errStorage;
                    END;
                    INC(lastfile);
                    INC(globallastfile);
                    pp^.index     := lastfile;
                    pp^.slen      := SHORTCARD(len);
                    Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END storeFiles;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkRange (VAR lc:LONGCARD;lower,upper:LONGCARD):BOOLEAN ;
BEGIN
    IF lc < lower THEN RETURN FALSE;END;
    IF lc > upper THEN RETURN FALSE;END;
    RETURN TRUE;
END chkRange;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.BYTE;
VAR
    bufferIn,bufferOut,bufferInData : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE isMatch (jokermode,exact:BOOLEAN;column:CARDINAL;
                  hugestring,text,textCAPS:ARRAY OF CHAR):BOOLEAN;
VAR
    colpos,p : CARDINAL;
    hugetrimed:str4096; (* same as main *)
    found:BOOLEAN;
BEGIN
    IF jokermode THEN
        Str.Copy(hugetrimed,hugestring);
        (* useless because of str.match design !
        IF exact THEN
            IF Str.Match(hugetrimed,text) THEN
                p:=0;
            ELSE
                p:=MAX(CARDINAL);
            END;
        ELSE
        *)
            UpperCase(hugetrimed);
            IF Str.Match(hugetrimed,textCAPS) THEN
                p:=0;
            ELSE
                p:=MAX(CARDINAL);
            END;
    ELSE
        IF column = DEFAULT THEN
            colpos:=0;
        ELSE
            colpos:=column-1;
        END;
        IF exact THEN
            p:=Str.NextPos(hugestring,text,colpos);
        ELSE
            Str.Copy(hugetrimed,hugestring);
            UpperCase(hugetrimed);
            p:=Str.NextPos(hugetrimed,textCAPS,colpos);
        END;
    END;

    found := (p # MAX(CARDINAL)) AND (p < Str.Length(hugestring));
    IF found THEN
        IF column # DEFAULT THEN found:= (p=(column-1));END;
    END;
    RETURN found;
END isMatch;

(* ------------------------------------------------------------ *)

PROCEDURE showmem(debug:BOOLEAN; S:ARRAY OF CHAR );
VAR
    heapsize    : CARDINAL; (* in PARAGRAPHS and not in bytes ! help is wrong ! *)
    n           : LONGCARD;
BEGIN
END showmem;

PROCEDURE whatline ( showline, prefix:BOOLEAN; total:LONGCARD);
BEGIN
    IF showline THEN
        IF prefix THEN
            WrLngCard(total, 6 );
            WrStr(seplinenum);
        END;
        WrStr(doublequote);
    END;
END whatline;

(* ------------------------------------------------------------ *)

PROCEDURE untabme (VAR R : ARRAY OF CHAR; tabwidth:CARDINAL;S:ARRAY OF CHAR);
VAR
    i,j,add: CARDINAL;
    c : CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c := S[i-1];
        IF c = tabchar THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
END untabme;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    ptrLine = POINTER TO lineType;
    lineType = RECORD
        next      : ptrLine;
        thisline  : LONGCARD;
        slen      : CARDINAL; (* account for possible long line *)
        str       : CHAR; (* variable *)
    END;

PROCEDURE initReinject (VAR anchor:ptrLine);
BEGIN
    anchor:=NIL;
END initReinject;

PROCEDURE grabReinject (VAR anchor:ptrLine;
                       debug,useLFN:BOOLEAN;datafile:pathtype ):BOOLEAN;
CONST
    linepat = "*"+seplinenum+doublequote+"*"+doublequote;
VAR
    hindata:FIO.File;
    S:str4096;
    p,len,needed:CARDINAL;
    N:str16;
    thisline:LONGCARD;
    ok,everythinggoes:BOOLEAN;
    newInList:ptrLine;
BEGIN
    everythinggoes:=TRUE;
    hindata :=FIO.OpenRead(datafile);
    FIO.AssignBuffer(hindata,bufferInData);
    LOOP
        FIO.RdStr(hindata,S);
        IF FIO.EOF THEN EXIT; END;
        LtrimBlanks(S);
        RtrimBlanks(S);
        (*         !                               *)
        (* ''###### : "*"'' seplinenum+doublequote *)
        IF Str.Match(S,linepat) THEN
            p:=Str.Pos(S,seplinenum+doublequote); (* always found *)
            Str.Slice(N,S,0,p);
            LtrimBlanks(N);
            RtrimBlanks(N);
            thisline:=Str.StrToCard(N,10,ok);
            IF ok THEN
                p:=Str.CharPos(S,doublequote);    (* always found *)
                Str.Delete(S,0,p+1);
                p:=Str.RCharPos(S,doublequote);   (* always found *)
                S[p]:=nullchar;                   (* brutal ! *)
                IF debug THEN
                    WrStr(N);WrStr(seplinenum+doublequote);
                    WrStr(S);WrStr(doublequote);WrLn;
                END;
                len:=Str.Length(S);
                needed:=SIZE(lineType)-SIZE(anchor^.str)+len;
                IF anchor=NIL THEN
                    ALLOCATE(anchor,needed);
                    newInList:=anchor;
                ELSE
                    ALLOCATE(newInList^.next,needed);
                    newInList:=newInList^.next;
                END;
                Lib.FastMove( SYSTEM.ADR(S), SYSTEM.ADR(newInList^.str),len);
                newInList^.slen     := len;
                newInList^.thisline := thisline;
                newInList^.next     := NIL;
            END;
        END;
    END;
    FIO.Close(hindata);
    RETURN everythinggoes;
END grabReinject;

PROCEDURE releaseReinject (anchor : ptrLine);
VAR
    needed : CARDINAL;
    p      : ptrLine;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(lineType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END releaseReinject;

(* change S only IF wanted found *)

PROCEDURE procReinjectMe (anchor:ptrLine;wanted:LONGCARD;VAR S:str4096 ):BOOLEAN;
VAR
    p:ptrLine;
    found:BOOLEAN;
    R:str4096;
    len:CARDINAL;
BEGIN
    found:=FALSE;
    LOOP
        IF anchor=NIL THEN EXIT;END;
        IF anchor^.thisline = wanted THEN
            len:=anchor^.slen;
            Lib.FastMove( SYSTEM.ADR(anchor^.str), SYSTEM.ADR(R), len);
            R[len]:=nullchar; (* required safety *)
            Str.Copy(S,R);
            found:=TRUE;
            EXIT;
        END;
        p:=anchor^.next;
        anchor:=p;
    END;
    RETURN found;
END procReinjectMe;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //FIX V11I moved here to avoid dynamic pool too complex *)

(* handle "-c -c:*" *)

PROCEDURE procReplaceAtEOL (VAR hugestring:ARRAY OF CHAR;
                           exact:BOOLEAN;text : ARRAY OF CHAR   ):BOOLEAN ;
VAR
    S,pat:str128;
    len,p:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    len:=Str.Length(text);
    Str.Concat(pat,"*",text);
    IF Str.Match(hugestring,pat) THEN (* not CASE sensitive *)
        p:=Str.Length(hugestring)-len;
        Str.Slice(S,hugestring,p,len);
        IF NOT(exact) THEN
            UpperCase(S);
            UpperCase(text);
        END;
        IF same(S,text) THEN Str.Delete(hugestring,p,len);rc:=TRUE;END;
    END;
    RETURN rc;
END procReplaceAtEOL;

PROCEDURE newE3 (VAR backup:ARRAY OF CHAR;  file,ext:ARRAY OF CHAR   );
VAR
    p:CARDINAL;
BEGIN
    p := Str.RCharPos(file,dot);
    IF p = MAX(CARDINAL) THEN
        Str.Concat(backup,file,ext);
    ELSE
        Str.Slice(backup,file,0,p);
        Str.Append(backup,ext);
    END;
END newE3;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    rangetype = (norange,rangeignore,rangeonly);

(* legal : column,count  first..last  first-last *)

PROCEDURE parseRange (VAR firstcol,countcol:CARDINAL; VAR range:rangetype;
                     newrange:rangetype;R:ARRAY OF CHAR):CARDINAL;
VAR
    S2:str128;
    p:CARDINAL;
    rangesep,pattern,snum:str16;
    lc:LONGCARD;
    try : (trycount, tryrange, tryrangealt);
BEGIN
    IF range # norange THEN RETURN errRangeDefinedAlready;END;

    GetString(R,S2);

    firstcol  := DEFAULT;
    countcol  := DEFAULT;

    try:=trycount;
    LOOP
        CASE try OF
        | trycount:    rangesep:=",";
        | tryrange:    rangesep:="..";
        | tryrangealt: rangesep:="-";
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Concat(pattern,"*",rangesep); Str.Append(pattern,"*");
        IF Str.Match(S2, pattern) THEN
            p:=Str.Pos(S2,rangesep);
            IF p > 0 THEN
                Str.Slice(snum,S2,0,p);
                Str.Delete(S2,0,p);
            ELSE
                snum:="";
            END;
            Str.Subst(S2,rangesep,"");
            Str.Prepend(snum,"="); (* ugly trick *)
            IF GetLongCard(snum,lc)=FALSE THEN RETURN errBadRange;END;
            IF ( (lc < 1) OR (lc > SIZE(str4096)) ) THEN RETURN errBadRange;END;
            firstcol:=CARDINAL(lc)-1; (* remember : 1-based for user, 0-based for Str library *)

            IF same(S2,sEOL) THEN S2:=sMAXRANGE;END;
            Str.Concat(snum,"=",S2);
            IF GetLongCard(snum,lc)=FALSE THEN RETURN errBadRange;END;
            IF ( (lc < 1) OR (lc > SIZE(str4096)) ) THEN RETURN errBadRange;END;
            CASE try OF
            | trycount:
                countcol:=CARDINAL(lc);
            | tryrange, tryrangealt:
                IF CARDINAL(lc) < (firstcol+1) THEN RETURN errBadRange;END;
                countcol:=(CARDINAL(lc)-1) -firstcol+1;
            ELSE ; (* //ISO fixed silly requirement *) END;
            range:=newrange;
            EXIT;
        END;
        IF try=tryrangealt THEN EXIT; END;
        INC(try);
    END;
    IF range # newrange THEN RETURN errBadRange;END;
    RETURN errNone;
END parseRange;

TYPE
    cmdtype = (nothing,
              append,prepend,remove,delete,keep,
              delfirst,dellast,viewfirst,viewlast,
              viewmatch,viewgrep,uniq,
              insert,replace,
              delrange,viewrange,
              merge,
              untab,reinject);

PROCEDURE newcmd (VAR cmd:cmdtype;wantedcmd:cmdtype);
BEGIN
    IF cmd = wantedcmd THEN RETURN; END;
    IF cmd # nothing THEN abort(errConflict,"");END;
    cmd:=wantedcmd;
END newcmd;

(* //FIX V11I moved here to avoid "dynamic pool too complex" *)

PROCEDURE finalreport (processed,total:LONGCARD;
                      cmd:cmdtype;inverse,useLFN:BOOLEAN;file:pathtype);
VAR
    S:str128;
BEGIN
    WrLngCard(processed,5);
    CASE cmd OF
    | uniq :
        IF inverse THEN
            WrStr(" duplicate");
        ELSE
            WrStr(" unique");
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    WrStr(" line(s)"); (* IF processed > 1 THEN WrStr("s");END; *)
    WrStr(" out of ");
    WrLngCard(total,5);

    WrStr(" ");
    CASE cmd OF
    | append,prepend,insert,replace,remove,merge : S:="modified";
    | delete,delfirst,dellast,delrange           : S:="deleted";
    | keep,uniq                                  : S:="kept";
    | viewmatch,viewgrep                         : S:="matched";
    | viewfirst,viewlast,viewrange               : S:="viewed";
    | untab                                      : S:="expanded";
    | reinject                                   : S:="reinjected";
    ELSE ; (* //ISO fixed silly requirement *) END;
    WrStr(S);
    CASE cmd OF
    | delfirst,viewfirst: WrStr(" from start");
    | dellast,viewlast:   WrStr(" from end");
    ELSE ; (* //ISO fixed silly requirement *) END;
    WrStr(" in ");
    IF useLFN THEN WrStr(doublequote);END;
    WrStr(file);
    IF useLFN THEN WrStr(doublequote);END;
    WrLn;
END finalreport;

(* ------------------------------------------------------------ *)

PROCEDURE doshow (count:LONGCARD;hnd:FIO.File);
CONST
    msg = "[~] ::: ";
VAR
    S:str128;
BEGIN
    S:=msg;
    Str.Subst(S,"~",padnum(count,9," "));
    FIO.WrStr(hnd,S);
END doshow;

(* ------------------------------------------------------------ *)

CONST
    DEFAUTONUM    = MAX(LONGCARD); (* i.e. no renumbering suffix *)
    MINAUTONUM    = 1;
    MINFIELD      = 1;
    MAXFIELD      = 12;
    DEFFIELD      = 4;
    MINLINENUM    = 0;
    MAXLINENUM    = MAX(LONGCARD) DIV 2; (* //V11N bad idea anyway even though VAR is LONGCARD *)
    MINDELTA      = 1;
    MAXDELTA      = 100;
    DEFDELTA      = 1;
    MINTABWIDTH   = 1;
    MAXTABWIDTH   = 64;
    DEFTABWIDTH   = 8;
CONST
    strFile       = "::: File "; (* grep uses "File $:" *)
CONST
    firstparm = 1;
    maxparm   = 3;
VAR
    lastparm  : CARDINAL;
    parm      : ARRAY [firstparm..maxparm] OF pathtype; (* was str128 *)
VAR
    parmcount, i, opt,len : CARDINAL; (* //ISOGAG ii loop index no longer here ! *)
    S,R   : pathtype;
    orgspec,currdir,currpath,specbase,spec:pathtype;
    file,backup,datafile,rootspec,basepath:pathtype;
    pf,diranchor,pdir,fileanchor:pEntry;
    (* sLegalUnits : str80; *)
    fileindex,lastfile,rc,lastdir:CARDINAL;
    globallastfile:LONGCARD;
    quiet,trim,all,exact,onlyshow,nameshown,showline:BOOLEAN;
    keepemptylines,osjokers,skipempty,showmatchline,dmp,strict,tabsep:BOOLEAN;
    forceshowcount,inverse,emuDuplines:BOOLEAN;
    jokermode,jokerprepend,jokerappend:BOOLEAN;
    range : rangetype;
    userAborted : BOOLEAN;
    debug             : BOOLEAN;
    text,textcli,newtextcli,newtext : str128;
    textCAPS,newtextCAPS:str128;
    cmd:cmdtype;
    hin, hout,hindata : FIO.File;
    p                 : CARDINAL;
    processed,total,bigtotal : LONGCARD;  (* just in case ! *)
    linecount,bigcount,orgbigcount,baseline,lastbaseline : LONGCARD;  (* just in case ! *)
    hugestring        : str4096;
    hugetrimed        : str4096;
    oldhuge,oldhugeorg,newhuge,tmphuge   : str4096;
    stateuniq         : (norefyet,refnow);
    dupcount          : LONGCARD; (* was CARDINAL *)
    column,colpos     : CARDINAL;
    lc                : LONGCARD;
    count,firstcol,countcol : CARDINAL;
    strcol,snum : str16;
    autonum,autodelta:LONGCARD;
    autofieldwidth : CARDINAL;
    steps:CARDINAL;
    fsize,portion,currportion,lastportion:LONGCARD;
    showme,ignoreEsc,recurse,useLFN,keepEOF,found:BOOLEAN;
    dirindex,countFile,chkrounds:CARDINAL;
    currdrive:SHORTCARD;
    tabwi:CARDINAL;
    anchorReinject:ptrLine;
    showdupcount,showfilename:BOOLEAN;
    matchinglines,notmatchinglines: LONGCARD;

(* //V11S we use globerks supra *)

PROCEDURE procFile();
VAR
    ii:CARDINAL; (* //ISOGAG loop index must be local to procedure ! yet another ISO silly decision ! *)
BEGIN
            IF onlyshow THEN
                hin :=FIO.OpenRead(file);
                FIO.AssignBuffer(hin,bufferIn);
            ELSE
                IF FIO.Exists(backup) THEN fileSetRW(backup);FIO.Erase(backup); END;
                FIO.Rename(file,backup);

                video(file,TRUE);
                video(msgProcessing,TRUE);

                (* Work(cmdInit); *)

                steps := 10;
                fsize := getFileSize(backup);
                portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
                lastportion := LONGCARD(steps+1);


                hin :=FIO.OpenRead(backup);
                FIO.AssignBuffer(hin,bufferIn);
                hout:=FIO.Create(file);
                FIO.AssignBuffer(hout,bufferOut);
                IF cmd=merge THEN
                    hindata :=FIO.OpenRead(datafile);
                    FIO.AssignBuffer(hindata,bufferInData);
                END;
            END;
            CASE cmd OF
            | dellast,viewlast:
                FIO.EOF:=FALSE;
                bigtotal:=0;
                LOOP
                    IF FIO.EOF THEN EXIT; END;
                    FIO.RdStr(hin,hugestring);
                    IF FIO.EOF THEN EXIT; END;
                    INC(bigtotal);
                END;
                FIO.Seek(hin,0); (* reset *)
                IF bigtotal < bigcount THEN
                    orgbigcount := bigtotal;
                    bigcount    := 0;
                ELSE
                    orgbigcount := bigcount;
                    bigcount    := bigtotal-bigcount;
                END;
            | uniq:
                oldhuge   :="";
                oldhugeorg:="";
            ELSE ; (* //ISO fixed silly requirement *) END;

            userAborted := FALSE;

            FIO.EOF:=FALSE;

            total     := 0;
            processed := 0;
            matchinglines:=0;
            notmatchinglines:=0;

            LOOP
                IF FIO.EOF THEN EXIT; END;
                FIO.RdStr(hin,hugestring);
                IF FIO.EOF THEN EXIT; END;

                INC(total);

                IF onlyshow=FALSE THEN
                    (* Work(cmdShow); *)

                    currportion:=FIO.GetPos(hin) DIV portion;
                    IF currportion # lastportion THEN
                        lastportion:=currportion;
                    END;
                END;
                CASE cmd OF
                | append,prepend:
                    Str.Copy(hugetrimed,hugestring);
                    LtrimBlanks(hugetrimed);
                    RtrimBlanks(hugetrimed);
                    IF (all OR (hugetrimed[0] # CHR(0))) THEN
                        CASE cmd OF
                        | append:
                            IF trim THEN RtrimBlanks(hugestring);END;
                            Str.Append(hugestring,text);
                            IF autonum # DEFAUTONUM THEN
                                Str.Append(hugestring, padnum(autonum,autofieldwidth,"0"));
                                INC(autonum,autodelta);
                            END;
                        | prepend:
                            IF trim THEN LtrimBlanks(hugestring);END;
                            Str.Prepend(hugestring,text);
                            IF autonum # DEFAUTONUM THEN
                                Str.Prepend(hugestring, padnum(autonum,autofieldwidth,"0"));
                                INC(autonum,autodelta);
                            END;
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        INC(processed);
                    END;
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                | remove:
                    IF column = DEFAULT THEN
                        colpos:=0;
                    ELSE
                        colpos:=column-1;
                    END;
                    count:=0;
                    LOOP
                        IF exact THEN
                            p:=Str.NextPos(hugestring,text,colpos);
                        ELSE
                            Str.Copy(hugetrimed,hugestring);
                            UpperCase(hugetrimed);
                            p:=Str.NextPos(hugetrimed,textCAPS,colpos);
                        END;
                        IF p = MAX(CARDINAL) THEN EXIT;END;
                        IF column # DEFAULT THEN
                            IF p # (column-1) THEN EXIT; END;
                            Str.Delete(hugestring,p,Str.Length(text));
                            INC(count);
                            EXIT; (* there can be only one... removal ! *)
                        ELSE
                            Str.Delete(hugestring,p,Str.Length(text));
                            INC(count);
                        END;
                    END;
                    IF count # 0 THEN INC(processed);END; (* lines, not replacements *)
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                | delete,keep:
                    found:= isMatch (jokermode,exact,column,hugestring,text,textCAPS);
                    CASE cmd OF
                    | delete:
                        IF found THEN
                            INC(processed);
                        ELSE
                            FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                        END;
                    | keep:
                        IF found THEN
                            FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                            INC(processed);
                        ELSE
                            IF keepemptylines THEN
                                IF Str.Length(hugestring)=0 THEN
                                    FIO.WrLn(hout);
                                END;
                            END;
                        END;
                    ELSE ; (* //ISO fixed silly requirement *) END;
                | viewmatch,viewgrep:
                    found:= isMatch (jokermode,exact,column,hugestring,text,textCAPS);
                    IF found THEN
                        INC(matchinglines);
                    ELSE
                        INC(notmatchinglines);
                    END;
                    IF inverse THEN
                        showme:=NOT(found);
                    ELSE
                        showme:=found;
                    END;
                    IF showme THEN (* was using found boolean *)
                        IF nameshown=FALSE THEN

                            (* fix (logical) quirk "-v -zz --" *)
                            showfilename:=TRUE;
                            IF inverse THEN
                                IF NOT(showmatchline) THEN
                                    showfilename:= FALSE;
                                END;
                            END;

                            IF showfilename THEN
                                WrStr(strFile);WrStr(file);WrLn;
                                nameshown:=TRUE;
                            END;
                        END;
                        IF showmatchline THEN
                            whatline(showline, TRUE ,total);
                            IF trim THEN
                                Str.Copy(hugetrimed,hugestring);
                                LtrimBlanks(hugetrimed);
                                RtrimBlanks(hugetrimed);
                                WrStr(hugetrimed);
                            ELSE
                                WrStr(hugestring);
                            END;
                            whatline(showline, FALSE,total);
                            WrLn;
                        END;
                        INC(processed);
                    END;
                    userAborted:=pollEscape(chkrounds,useLFN,ignoreEsc);
                | delfirst:
                    IF total > bigcount THEN
                        FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                    ELSE
                        INC(processed);
                    END;
                | viewfirst:
                    IF total > bigcount THEN
                        ; (* EXIT would be prettier but we would not have grand total of lines *)
                    ELSE
                        IF nameshown=FALSE THEN
                            WrStr(strFile);WrStr(file);WrLn;
                            nameshown:=TRUE;
                        END;
                        whatline(showline, TRUE ,total);
                        WrStr(hugestring);
                        whatline(showline, FALSE,total);
                        WrLn;
                        INC(processed);
                    END;
                    userAborted:=pollEscape(chkrounds,useLFN,ignoreEsc);
                | dellast:
                    IF total > bigcount THEN
                        EXIT;
                    ELSE
                        FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                    END;
                | viewlast:
                    IF total > bigcount THEN
                        IF nameshown=FALSE THEN
                            WrStr(strFile);WrStr(file);WrLn;
                            nameshown:=TRUE;
                        END;
                        whatline(showline, TRUE ,total);
                        WrStr(hugestring);
                        whatline(showline, FALSE,total);
                        WrLn;
                        (* INC(processed); *)
                    END;
                    userAborted:=pollEscape(chkrounds,useLFN,ignoreEsc);
                | delrange:
                    IF ((total < baseline) OR (total > lastbaseline)) THEN
                        FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                    ELSE
                        INC(processed);
                    END;

                | viewrange:
                    IF ((total >= baseline) AND (total <= lastbaseline)) THEN
                        IF nameshown=FALSE THEN
                            WrStr(strFile);WrStr(file);WrLn;
                            nameshown:=TRUE;
                        END;
                        whatline(showline, TRUE ,total);
                        WrStr(hugestring);
                        whatline(showline, FALSE,total);
                        WrLn;
                        INC(processed);
                    END;
                    userAborted:=pollEscape(chkrounds,useLFN,ignoreEsc);
                | uniq:
                    Str.Copy(newhuge,hugestring);
                    CASE range OF
                    | rangeignore : Str.Delete(newhuge,firstcol,countcol);
                    | rangeonly   : Str.Slice(tmphuge, newhuge, firstcol,countcol);
                                    Str.Copy(newhuge,tmphuge);
                    ELSE ; (* //ISO fixed silly requirement *) END;
                    IF NOT(exact) THEN UpperCase(newhuge);END;
                    CASE stateuniq OF
                    | norefyet:
                        Str.Copy(oldhuge,newhuge);
                        Str.Copy(oldhugeorg,hugestring);
                        stateuniq:=refnow;
                        dupcount:=0;
                    | refnow:
                        IF same(newhuge,oldhuge) THEN
                            INC(dupcount);
                            IF inverse THEN
                                IF emuDuplines THEN
                                    IF dupcount = 1 THEN
                                        FIO.WrStr(hout,emudupfirst);
                                    ELSE
                                        FIO.WrStr(hout,emudup);
                                    END;
                                END;
                                FIO.WrStr(hout,oldhugeorg); FIO.WrLn(hout);
                                INC(processed);
                                Str.Copy(oldhuge,newhuge);
                                Str.Copy(oldhugeorg,hugestring);
                            END;
                            IF debug THEN WrStr("--- ");WrStr(newhuge);WrLn;END;
                        ELSE
                            IF inverse THEN
                                showme:=  (dupcount # 0) ;
                            ELSE
                                showme:= ((dupcount = 0) OR (strict=FALSE));
                            END;
                            IF showme THEN
			        IF NOT(inverse) THEN
				    IF showdupcount THEN doshow(dupcount+1,hout);END;
				END;
                                IF emuDuplines THEN FIO.WrStr(hout,emudup);END;
                                FIO.WrStr(hout,oldhugeorg); FIO.WrLn(hout);
                                INC(processed);
                            END;
                            Str.Copy(oldhuge,newhuge);
                            Str.Copy(oldhugeorg,hugestring);
                            dupcount:=0;
                        END;
                    ELSE ; (* //ISO fixed silly requirement *) END;
                | insert : (* all *)
                    Str.Copy(hugetrimed,hugestring);
                    LtrimBlanks(hugetrimed);
                    RtrimBlanks(hugetrimed);
                    IF ( all OR (hugetrimed[0] # CHR(0)) ) THEN
                        len:=Str.Length(hugestring);
                        IF len < column THEN
                            LOOP
                                INC(len);
                                IF NOT(len < column) THEN EXIT; END;
                                Str.Append(hugestring," ");
                            END;
                        END;
                        Str.Insert(hugestring,text,column-1);
                        INC(processed);
                    END;
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                | replace: (* column exact *)
                    len:=Str.Length(text);
                    count:=0;

                    CASE column OF
                    | DEFAULT:
                        colpos:=0;
                    | COLUMNEOL : (* //FIX V11I *)
                        IF procReplaceAtEOL(hugestring,exact,text) THEN
                            Str.Append(hugestring,newtext);
                            INC(count);
                        END;
                    ELSE
                        colpos:=column-1;
                    END;
                    LOOP
                        IF column = COLUMNEOL THEN EXIT; END; (* //FIX V11I *)
                        IF exact THEN
                            p:=Str.NextPos(hugestring,text,colpos);
                        ELSE
                            Str.Copy(hugetrimed,hugestring);
                            UpperCase(hugetrimed);
                            p:=Str.NextPos(hugetrimed,textCAPS,colpos);
                        END;
                        IF p = MAX(CARDINAL) THEN EXIT;END;
                        IF column # DEFAULT THEN
                            IF p # (column-1) THEN EXIT; END;
                            Str.Delete(hugestring,p,len);
                            Str.Insert(hugestring,newtext,p);
                            INC(count);
                            EXIT; (* there can be only one... removal ! *)
                        ELSE
                            Str.Delete(hugestring,p,len);
                            Str.Insert(hugestring,newtext,p);
                            INC(colpos,len);
                            INC(count);
                        END;
                    END;
                    IF count # 0 THEN INC(processed);END; (* lines, not replacements *)
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                | merge:
                    keepEOF:=FIO.EOF;
                    FIO.RdStr(hindata,hugetrimed);
                    FIO.EOF:=keepEOF;
                    IF trim THEN
                        LtrimBlanks(hugestring);
                        RtrimBlanks(hugestring);
                        LtrimBlanks(hugetrimed);
                        RtrimBlanks(hugetrimed);
                    END;
                    IF column # DEFAULT THEN
                        len:= Str.Length(hugestring);
                        IF len < column THEN
                            FOR ii:=(len+1+1) TO column DO
                                Str.Append(hugestring,space);
                            END;
                        END;
                    END;
                    IF tabsep THEN
                        Str.Append(hugestring,tabchar);
                    ELSE
                        Str.Append(hugestring,space);
                    END;
                    Str.Append(hugestring,hugetrimed);
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                    INC(processed);
                | untab:
                    Str.Copy(hugetrimed,hugestring);
                    untabme(hugestring,tabwi,hugetrimed);
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                    INC(processed);
                | reinject:
                    IF procReinjectMe(anchorReinject,total,hugestring) THEN
                        INC(processed);
                    END;
                    FIO.WrStr(hout,hugestring); FIO.WrLn(hout);
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF userAborted THEN EXIT; END;
            END;

            CASE cmd OF
            | viewmatch,viewgrep: (* adapted inner loop code *)
                IF nameshown=FALSE THEN

                    (* fix (logical) quirk "-v -zz --" *)
                    showfilename:=FALSE;
                    IF inverse THEN
                        IF NOT(showmatchline) THEN
                            showfilename:= (matchinglines=0);
                        END;
                    END;

                    IF showfilename THEN
                        WrStr(strFile);WrStr(file);WrLn;
                        nameshown:=TRUE;
                    END;
                END;
            | uniq: (* mere copy/paste of inner loop code *)
                    Str.Copy(newhuge,hugestring);
                    CASE range OF
                    | rangeignore : Str.Delete(newhuge,firstcol,countcol);
                    | rangeonly   : Str.Slice(tmphuge, newhuge, firstcol,countcol);
                                    Str.Copy(newhuge,tmphuge);
                    ELSE ; (* //ISO fixed silly requirement *) END;
                    IF NOT(exact) THEN UpperCase(newhuge);END;
                    CASE stateuniq OF
                    | norefyet:
                        Str.Copy(oldhuge,newhuge);
                        Str.Copy(oldhugeorg,hugestring);
                        stateuniq:=refnow;
                        dupcount:=0;
                    | refnow:
                        IF same(newhuge,oldhuge) THEN
                            INC(dupcount);
                            IF inverse THEN
                                IF emuDuplines THEN
                                    IF dupcount = 1 THEN
                                        FIO.WrStr(hout,emudupfirst);
                                    ELSE
                                        FIO.WrStr(hout,emudup);
                                    END;
                                END;
                                FIO.WrStr(hout,oldhugeorg);FIO.WrLn(hout);
                                INC(processed);
                                Str.Copy(oldhuge,newhuge);
                                Str.Copy(oldhugeorg,hugestring);
                            END;
                            IF debug THEN WrStr("--- ");WrStr(newhuge);WrLn;END;
                        ELSE
                            IF inverse THEN
                                showme:=  (dupcount # 0) ;
                            ELSE
                                showme:= ((dupcount = 0) OR (strict=FALSE));
                            END;
                            IF showme THEN
			        IF NOT(inverse) THEN
				    IF showdupcount THEN doshow(dupcount+1,hout);END;
				END;
                                IF emuDuplines THEN FIO.WrStr(hout,emudup);END;
                                FIO.WrStr(hout,oldhugeorg); FIO.WrLn(hout);
                                INC(processed);
                            END;
                            Str.Copy(oldhuge,newhuge);
                            Str.Copy(oldhugeorg,hugestring);
                            dupcount:=0;
                        END;
                    ELSE ; (* //ISO fixed silly requirement *) END;

            ELSE ; (* //ISO fixed silly requirement *) END;

            IF onlyshow THEN
                FIO.Close(hin);
            ELSE
                FIO.Flush(hout);
                FIO.Close(hout);
                FIO.Close(hin);
                IF cmd=merge THEN FIO.Close(hindata); END;

                (* Work(cmdStop); *)
                video(msgProcessing,FALSE);
                video(file,FALSE);
            END;
END procFile;


BEGIN
    FIO.IOcheck := FALSE;

    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    useLFN:=TRUE;

    lastparm  := firstparm - 1;
    cmd       := nothing;
    trim      := FALSE;
    all       := FALSE;
    exact     := FALSE;
    quiet     := FALSE;
    showline  := FALSE;
    column    := DEFAULT;        (* none *)
    range     := norange;
    skipempty := FALSE;
    showmatchline:=TRUE;
    strict    := FALSE;
    tabsep    := FALSE;
    jokermode := FALSE;
    jokerprepend:=TRUE;
    jokerappend :=TRUE;
    recurse   := FALSE;
    keepemptylines := FALSE;
    forceshowcount := FALSE;
    (*
    osjokers  := FALSE; (* //V11K fix *)
    osjokers  := TRUE;  (* //V11L fix *)
    *)
    osjokers  := FALSE; (* //V11M fix this looks like a joke now ! *)

    ignoreEsc := FALSE;
    baseline  := 0;
    inverse   := FALSE;
    emuDuplines:=FALSE;
    debug     := FALSE;
    stateuniq := norefyet;
    dupcount  := 0;
    chkrounds := 0;
    autonum        := DEFAUTONUM; (* i.e. no renum *)
    autofieldwidth := DEFFIELD;
    autodelta      := DEFDELTA;
    tabwi          := DEFTABWIDTH;
    showdupcount   := FALSE;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "A"+delim+"APPEND"+delim+
                                 "P"+delim+"PREPEND"+delim+
                                 "T"+delim+"TRIM"+delim+
                                 "F"+delim+"FORCE"+delim+
                                 "D"+delim+"DELETE"+delim+
                                 "E"+delim+"EXACT"+delim+
                                 "R"+delim+"REMOVE"+delim+
                                 "C:"+delim+"COLUMN:"+delim+
                                 "K"+delim+"KEEP"+delim+
                                 "DF"+delim+"DELETEFIRST"+delim+
                                 "DL"+delim+"DELETELAST"+delim+
                                 "VF"+delim+"VIEWFIRST"+delim+
                                 "VL"+delim+"VIEWLAST"+delim+
                                 "V"+delim+"VIEW"+delim+"SHOW"+delim+
                                 "Q"+delim+"QUIET"+delim+
                                 "VV"+delim+"VIEWGREP"+delim+"GREP"+delim+
                                 "L"+delim+"LINE"+delim+
                                 "U"+delim+"UNIQUE"+delim+
                                 "I:"+delim+"IGNORE:"+delim+
                                 "Z"+delim+
                                 "Y"+delim+"STRICT"+delim+
                                 "UU"+delim+
                                 "I"+delim+"INSERT"+delim+
                                 "C"+delim+"CHANGE"+delim+"REPLACE"+delim+
                                 "O:"+delim+"ONLY:"+delim+
                                 "B:"+delim+"BASELINE:"+delim+
                                 "M"+delim+"MERGE"+delim+
                                 "TAB"+delim+
                                 "??"+delim+

                                 "J"+delim+"JOKER"+delim+
                                 "JS"+delim+"SOL"+delim+"STARTOFLINE"+delim+
                                 "JE"+delim+"EOL"+delim+"ENDOFLINE"+delim+
                                 "JJ"+delim+
                                 "ZZ"+delim+
                                 "KJ"+delim+
                                 "DJ"+delim+
                                 "VJ"+delim+
                                 "KJJ"+delim+
                                 "DJJ"+delim+
                                 "VJJ"+delim+
                                 "N:"+delim+"AUTONUM:"+delim+
                                 "F:"+delim+"FIELD:"+delim+
                                 "K:"+delim+"DELTA:"+delim+
                                 "x"+delim+"lfn"+delim+
                                 "S"+delim+"RECURSE"+delim+"SUBDIRS"+delim+"SUB"+delim+
                                 "!"+delim+"JOKERS"+delim+"OS"+delim+
                                 "W"+delim+"ESC"+delim+"WINQUIRK"+delim+

                                 "-"+delim+"INVERSE"+delim+
                                 "--"+delim+"DUPLINES"+delim+

                                 "U-"+delim+
                                 "U--"+delim+
                                 "UU-"+delim+
                                 "UU--"+delim+

                                 "N"+delim+"REINJECT"+delim+
                                 "G"+delim+"UNTAB"+delim+"EXPAND"+delim+
                                 "G:"+delim+"UNTAB:"+delim+"EXPAND:"+delim+
                                 "B"+delim+"KEEPEMPTY"+delim+
                                 "DEBUG"+delim+
                                 "ZC"+delim+"CC"+delim+
                                 "ZZC"+delim+"CCC"+delim+
				 "O"+delim+"DUPCOUNT"
                                 (*
                                   "V-"+delim+"VIEW-"+delim+"SHOW-"+delim+
                                   "VV-"+delim+"VIEWGREP-"+delim+"GREP-"+delim+
                                   "VJ-"+delim+
                                   "VJJ-"+delim+
                                 *)
                              );
            CASE opt OF
            | 1,2,3 :   abort(errHelp,"");
            | 4,5 :     newcmd(cmd,append);
            | 6,7 :     newcmd(cmd,prepend);
            | 8,9 :     trim := TRUE;
            | 10,11:    all := TRUE;
            | 12,13:    newcmd(cmd,delete);
            | 14,15:    exact := TRUE;
            | 16,17:    newcmd(cmd,remove);
            | 18,19:    GetString(R,strcol);
                        IF same(strcol,sEOL) THEN
                            column:=COLUMNEOL;
                        ELSE
                            IF GetLongCard(R,lc)=FALSE THEN abort(errBadColumn,S);END;
                            IF ( (lc < 1) OR (lc > SIZE(str4096)) ) THEN abort(errBadColumn,S);END;
                            column:=CARDINAL(lc);
                        END;
            | 20,21:    newcmd(cmd,keep);
            | 22,23:    newcmd(cmd,delfirst);
            | 24,25:    newcmd(cmd,dellast);
            | 26,27:    newcmd(cmd,viewfirst);
            | 28,29:    newcmd(cmd,viewlast);
            | 30,31,32: newcmd(cmd,viewmatch);
            | 33,34:    quiet:=TRUE;
            | 35,36,37: newcmd(cmd,viewgrep);
            | 38,39:    showline:=TRUE;
            | 40,41:    newcmd(cmd,uniq);
            | 42,43:    rc:=parseRange (firstcol,countcol,range,  rangeignore,R);
                        IF rc # errNone THEN abort(rc,S);END;
            | 44:       skipempty:=TRUE;
            | 45,46:    strict:=TRUE;
            | 47:       newcmd(cmd,uniq);
                        strict:=TRUE;
            | 48,49:    newcmd(cmd,insert);
            | 50,51,52: newcmd(cmd,replace);
            | 53,54:    rc:=parseRange (firstcol,countcol,range,  rangeonly,R);
                        IF rc # errNone THEN abort(rc,S);END;
            | 55,56:    IF GetLongCard(R,lc)=FALSE THEN abort(errBadBaseLine,S);END;
                        IF ( (lc < 1) OR (lc > MAX(LONGCARD) )) THEN abort(errBadBaseLine,S);END;
                        baseline:=lc;
            | 57,58:    newcmd(cmd,merge);
            | 59:       tabsep := TRUE;
            | 60:       abort(errHelper,"");

            | 61,62:    jokermode:=TRUE;
            | 63,64,65: jokerprepend:=FALSE;
            | 66,67,68: jokerappend :=FALSE;
            | 69:       jokermode:=TRUE; jokerprepend:=FALSE; jokerappend :=FALSE;
            | 70:       skipempty:=TRUE; (* same as -z *)
                        showmatchline:=FALSE;
            | 71:       newcmd(cmd,keep);
                        jokermode:=TRUE;
            | 72:       newcmd(cmd,delete);
                        jokermode:=TRUE;
            | 73:       newcmd(cmd,viewmatch);
                        jokermode:=TRUE;
            | 74:       newcmd(cmd,keep);
                        jokermode:=TRUE; jokerprepend:=FALSE; jokerappend :=FALSE;
            | 75:       newcmd(cmd,delete);
                        jokermode:=TRUE; jokerprepend:=FALSE; jokerappend :=FALSE;
            | 76:       newcmd(cmd,viewmatch);
                        jokermode:=TRUE; jokerprepend:=FALSE; jokerappend :=FALSE;
            | 77,78:    IF GetLongCard(R,lc)=FALSE THEN abort(errBadNumSuffix,S);END;
                        IF chkRange(lc,MINLINENUM,MAXLINENUM)=FALSE THEN abort(errBadRange,S);END;
                        autonum:=lc;
            | 79,80:    IF GetLongCard(R,lc)=FALSE THEN abort(errBadFieldWidth,S);END;
                        IF chkRange(lc,MINFIELD,MAXFIELD)=FALSE THEN abort(errBadRange,S);END;
                        autofieldwidth:=CARDINAL(lc);
            | 81,82:    IF GetLongCard(R,lc)=FALSE THEN abort(errBadIncrement,S);END;
                        IF chkRange(lc,MINDELTA,MAXDELTA)=FALSE THEN abort(errBadRange,S);END;
                        autodelta:=lc;
            | 83,84:    (* useLFN:=FALSE; *) ;
            | 85,86,87,88: recurse:=TRUE;
            | 89,90,91: osjokers:=TRUE;
            | 92,93,94: ignoreEsc:=TRUE;

            | 95,96:    inverse:=TRUE;
            | 97,98:    inverse:=TRUE;  emuDuplines:=TRUE;

            | 99:       newcmd(cmd,uniq);
                        inverse:=TRUE;
            |100:       newcmd(cmd,uniq);
                        inverse:=TRUE;  emuDuplines:=TRUE;
            |101:       newcmd(cmd,uniq);
                        strict:=TRUE;
                        inverse:=TRUE;
            |102:       newcmd(cmd,uniq);
                        strict:=TRUE;
                        inverse:=TRUE;  emuDuplines:=TRUE;

            |103,104:   newcmd(cmd,reinject);
            |105,106,107: newcmd(cmd,untab);
            |108,109,110: newcmd(cmd,untab);
                        IF GetLongCard(R,lc)=FALSE THEN abort(errBadTabWidth,S);END;
                        IF ( (lc < MINTABWIDTH) OR (lc > MAXTABWIDTH) ) THEN abort(errBadTabWidth,S);END;
                        tabwi:=CARDINAL(lc);
            |111,112:   keepemptylines:=TRUE;
            |113:       debug:=TRUE;
            |114,115:   skipempty      := TRUE; (* -z *)
                        forceshowcount := TRUE;
            |116,117:   skipempty      := TRUE;
                        showmatchline  := FALSE;
                        forceshowcount := TRUE;
            |118,119:   showdupcount   := TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            (* 1=text,2=filespec or 1=text,2=newtext,3=filespec or 1=filespec *)
            INC(lastparm); IF lastparm > maxparm THEN abort(errParmOverflow,S);END;
            Str.Copy(parm[lastparm],S);
        END;
    END;
    IF cmd=nothing THEN abort(errExpected,"command");END;

    CASE lastparm OF
    | firstparm-1 : (* complicated way to specify 0 i.e. no parms ! *)
        CASE cmd OF
        | uniq,untab:                          S:="<file(s)>";
        | merge,reinject:                      S:="<datafile>";
        | delfirst,dellast,viewfirst,viewlast: S:="<count>";
        | replace:                             S:="<oldtext>";
        ELSE
                                               S:="<text>";
        END;
        abort(errExpected,S);
    | firstparm :   (* one parm *)
        CASE cmd OF
        | uniq,untab :          Str.Copy(orgspec,parm[firstparm]);
        | replace:              abort(errExpected,"<newtext>");
        | reinject:             abort(errExpected,"<file>");
        ELSE
                                abort(errExpected,"<file(s)>");
        END;
    | firstparm+1 : (* two parms *)
        CASE cmd OF
        | uniq,untab:           abort(errParmOverflow,parm[firstparm+1]);
        | replace :             abort(errExpected,"<file(s)>");
        | merge,reinject:
                                Str.Copy(datafile ,parm[firstparm]);
                                Str.Copy(orgspec  ,parm[firstparm+1]);
        ELSE
                                Str.Copy(text     ,parm[firstparm]);
                                Str.Copy(orgspec  ,parm[firstparm+1]);
        END;
    | firstparm+2 : (* three parms *)
        CASE cmd OF
        | replace :
                                Str.Copy(text     ,parm[firstparm]);
                                Str.Copy(newtext  ,parm[firstparm+1]);
                                Str.Copy(orgspec  ,parm[firstparm+2]);
        ELSE
                                abort(errParmOverflow,parm[firstparm+2]);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    (* very, very important ! keep accents too ! *)

    UpperCaseAlt(orgspec);
    UpperCaseAlt(datafile);

    CASE cmd OF
    | replace : ;
    ELSE
        IF column=COLUMNEOL THEN abort(errBadColumn,"-c:"+sEOL);END;
    END;

    CASE cmd OF
    | viewmatch,viewgrep,viewfirst,viewlast:
        ;
    ELSE
        IF showline THEN abort(errNonsense,"-line");END;
    END;

    CASE cmd OF
    | viewmatch,viewgrep :
        ;
    ELSE
        IF NOT(showmatchline) THEN abort(errNonsense,"-zz");END;
        IF skipempty THEN abort(errNonsense,"-z");END;
    END;

    CASE cmd OF
    | uniq:
        ;
    ELSE
        IF strict THEN abort(errNonsense,"-strict|-y");END;
    END;

    CASE cmd OF
    | delete,keep,viewmatch,viewgrep:
        IF jokermode THEN
            IF exact THEN abort(errNonsenseMatch,"-exact");END; (* Str.Match is case-insensitive ! *)
            IF column # DEFAULT THEN abort(errNonsenseMatch,"-column:#");END;
            IF jokerprepend THEN Str.Prepend(text,"*");END;
            IF jokerappend  THEN Str.Append (text,"*");END;
        END;
    ELSE
        IF jokermode THEN abort(errNonsense,"-joker");END;
    END;

    CASE cmd OF
    | append,prepend:
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF exact THEN abort(errNonsense,"-exact");END;
        IF column # DEFAULT THEN abort(errNonsense,"-column:#");END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF inverse THEN abort(errNonsense,"-inverse");END;
    | remove,delete,keep,replace:
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF trim THEN abort(errNonsense,"-trim");END;
        IF all THEN abort(errNonsense,"-force");END;
        IF NOT(exact) THEN UpperCase(text);END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
        IF inverse THEN abort(errNonsense,"-inverse");END;
    | viewmatch,viewgrep:
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF all THEN abort(errNonsense,"-force");END;
        IF NOT(exact) THEN UpperCase(text);END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
    | delfirst,dellast,viewfirst,viewlast:
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF exact THEN abort(errNonsense,"-exact");END;
        IF trim THEN abort(errNonsense,"-trim");END;
        IF all THEN abort(errNonsense,"-force");END;
        IF column # DEFAULT THEN abort(errNonsense,"-column:#");END;
        IF same(text,sALLLINES) THEN
            lc:=MAXPROCESSEDLINES; (* was max(cardinal) thus preventing huge processing *)
        ELSE
            IF GetLongCard(text,lc)=FALSE THEN abort(errBadCount,text);END;
        END;
        IF ( (lc < 1) OR (lc > MAXPROCESSEDLINES) ) THEN abort(errBadCount,text);END;
        linecount:=lc;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
        IF inverse THEN abort(errNonsense,"-inverse");END;
    | uniq:
        IF column # DEFAULT THEN abort(errNonsense,"-column:#");END;
        IF trim THEN abort(errNonsense,"-trim");END;
        IF all THEN abort(errNonsense,"-force");END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
        (* IF inverse THEN abort(errNonsense,"-inverse");END; *)
    | insert:
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF exact THEN abort(errNonsense,"-exact");END;
        IF trim THEN abort(errNonsense,"-trim");END;
        IF column = DEFAULT THEN abort(errExpected,"<-column:#>");END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
        IF inverse THEN abort(errNonsense,"-inverse");END;
    | merge:
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF exact THEN abort(errNonsense,"-exact");END;
        IF all THEN abort(errNonsense,"-force");END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
        IF inverse THEN abort(errNonsense,"-inverse");END;
    | untab,reinject: (* any option is a nonsense here *)
        IF range # norange THEN abort(errNonsense,"-ignore:#,#");END;
        IF exact THEN abort(errNonsense,"-exact");END;
        IF column # DEFAULT THEN abort(errNonsense,"-column:#");END;
        IF baseline # 0 THEN abort(errNonsense,"-line:#");END;
        IF tabsep THEN abort(errNonsense,"-tab");END;
        IF autonum # DEFAUTONUM THEN abort(errNonsense,"-n:#");END;
        IF inverse THEN abort(errNonsense,"-inverse");END;
        IF trim THEN abort(errNonsense,"-trim");END;
        IF all THEN abort(errNonsense,"-force");END;
        IF recurse THEN
            IF cmd=reinject THEN abort(errNonsense,"-recurse");END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | viewlast,dellast:
        IF baseline # 0 THEN abort(errNonsense,"-b:#");END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    (* setup *)

    CASE cmd OF
    | viewfirst,viewlast,viewmatch,viewgrep:
        onlyshow:=TRUE;
    ELSE
        onlyshow:=FALSE;
    END;

    CASE cmd OF
    | delfirst,dellast,viewfirst,viewlast:
        ;
    | uniq:
        IF debug THEN
            (* 1-based for user *)
            WrStr("First column : ");WrCard(firstcol+1,5);WrLn;
            WrStr("Last column  : ");WrCard( (firstcol+countcol-1)+1,5);WrLn;
            WrStr("Count        : ");WrCard(countcol,5);WrLn;
        END;
    | replace :
        Str.Copy(textcli,text);
        IF metaproc(text)=FALSE THEN abort(errBadMeta,text);END;
        Str.Copy(newtextcli,newtext);
        IF metaproc(newtext)=FALSE THEN abort(errBadMeta,newtext);END;
        IF debug THEN
            WrStr("Raw old text    : ");WrStr(textcli);WrLn;
            WrStr("Cooked old text : ");WrStr(text);WrLn;
            WrStr("Raw new text    : ");WrStr(newtextcli);WrLn;
            WrStr("Cooked new text : ");WrStr(text);WrLn;
            WrLn;
        END;
        Str.Copy(textCAPS,text);
        UpperCase(textCAPS);
        Str.Copy(newtextCAPS,newtext);
        UpperCase(newtextCAPS);
    | merge,reinject:
        IF chkJoker(datafile) THEN abort(errJoker,datafile);END;
        IF legalextension(datafile,skippedextensions)=FALSE THEN abort(errNoMatch,datafile);END;
        IF FIO.Exists(datafile)=FALSE THEN abort(errNoMatch,datafile);END;
        IF cmd=reinject THEN
            IF chkJoker(orgspec) THEN abort(errJoker,orgspec);END;
        END;
    | untab:
        IF debug THEN
            WrStr("Tab width       : ");WrCard(tabwi,5);WrLn;
        END;
    ELSE
        Str.Copy(textcli,text);
        IF metaproc(text)=FALSE THEN abort(errBadMeta,text);END;
        IF debug THEN
            IF jokermode THEN
                WrStr("Pattern search mode is enabled.");WrLn;
                WrLn;
            END;
            WrStr("Raw text    : ");WrStr(textcli);WrLn;
            WrStr("Cooked text : ");WrStr(text);WrLn;
            WrLn;
        END;
        Str.Copy(textCAPS,text);
        UpperCase(textCAPS);
    END;

    CASE cmd OF
    | delfirst,dellast:
        IF baseline # 0 THEN cmd:=delrange; lastbaseline:=baseline+linecount-1;END;
    | viewfirst,viewlast:
        IF baseline # 0 THEN cmd:=viewrange;lastbaseline:=baseline+linecount-1;END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    (* let's work now *)


    getAnchor(useLFN, currdrive,currdir, currpath); (* u, "\*\", "u:\*\" *)
    (* getAllLegalUnits(TRUE,TRUE,TRUE,sLegalUnits); (* floppy,hd,CDROM *) *)

    rc:= chkfixSpec( specbase,spec, useLFN,orgspec,lettersUpp ); (* was sLegalUnits *)
    CASE rc OF
    | errNone,errEntryIsFile,errEntryNotFound : (* ok or later use *)
        ;
    ELSE
        abort(rc,orgspec);
    END;
    IF legalextension (spec,skippedextensions)=FALSE THEN abort(errBadExt,"");END;

    showmem(debug,"step 1");

    initList(diranchor); (* global *)
    lastdir            := firstindex-1; (* we can't init count in recursive buildDirList() *)
    globallastfile     := firstindex-1;

    video(msgWait,TRUE);
    rc:= buildDirList (lastdir, diranchor,  useLFN,recurse, specbase);
    video(msgWait,FALSE);
    IF rc # errNone THEN abort(rc, orgspec); END;
    IF debug THEN dmpDirs(diranchor,useLFN); END;
    (* first minimalist "no match" check *)
    IF lastdir < firstindex THEN abort(errNoMatch,orgspec);END;

    showmem(debug,"step 2");

    initReinject(anchorReinject);
    IF cmd=reinject THEN
        IF grabReinject(anchorReinject,debug,useLFN,datafile)=FALSE THEN abort(errStorage,datafile);END;
    END;

    showmem(debug,"step 3");

    pdir:=findByIndex(firstindex,diranchor); (* we know we've got at least one dir now *)
    getStr(rootspec,pdir);


    (* here, we're at the limit OF "too complex PROCEDURE" ! *)

    dirindex:=firstindex;
    LOOP
        IF dirindex > lastdir THEN EXIT; END;
        pdir:=findByIndex(dirindex,diranchor);
        getStr(basepath,pdir);

        rc:= storeFiles (globallastfile,lastfile, fileanchor,
                        useLFN,osjokers, basepath,spec, skippedextensions);
        IF rc # errNone THEN abort(rc, orgspec); END;

        IF debug THEN dmpFiles(fileanchor,diranchor,dirindex,useLFN); END;

        fileindex:=firstindex;
        LOOP
            IF fileindex > lastfile THEN EXIT; END;
            pf := findByIndex(fileindex,fileanchor);

            getStr(file,pf);
            Str.Prepend(file,basepath);

            newE3(backup, file,extBAK);

            nameshown:=FALSE; (* default for all *)
            bigcount:=linecount;

            procFile(); (* //V11S we use globerks supra *)

            IF userAborted THEN
                freeList(fileanchor);
                freeList(diranchor);
                abort(errUserAborted,"");
            END;

            CASE cmd OF
            | dellast,viewlast:
                processed := orgbigcount;
                total     := bigtotal;
            ELSE ; (* //ISO fixed silly requirement *) END;

            CASE cmd OF
            | viewgrep:
                dmp:=FALSE;
            | viewmatch:
                (* dmp:=NOT(skipempty); *)
                (* //FIXME *)
                IF skipempty THEN (* -z or -zz *)
                    (* dmp:=showmatchline; (* was NOT() which was stupid ! *) *)
                    dmp:=FALSE; (* should fix problem *)
                ELSE
                    dmp:=TRUE;
                END;
            ELSE
                dmp:=TRUE;
            END;

            IF ( dmp AND NOT(quiet) ) OR forceshowcount THEN
                finalreport(processed,total,cmd,inverse,useLFN,file);
            END;

            INC(fileindex);
        END;

        freeList(fileanchor);
        INC(dirindex);
    END;
    freeList(diranchor);
    IF cmd=reinject THEN releaseReinject(anchorReinject);END;

    showmem(debug,"step 4");

    IF globallastfile=MAX(CARDINAL) THEN abort(errTooMany,orgspec);END; (* errStorage *)
    IF globallastfile < firstindex THEN abort(errNoMatch,orgspec); END;


    abort(errNone,"");
END NewLine32.



