(* ---------------------------------------------------------------
Title         Q&D NewName
Author        PhG
Overview      remove/replace character(s) in filename(s)
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.
              fix chkValid()
              available options : g i k q u w
              -y has not yet been fully tested

	      removed : -l -lfn -lcc -ucc -lcf -ucf -lcfr -ucfr -az -shorten

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          Win9X would sometimes not casify as asked to !
              Win9X would sometimes not retrieve all weird chars from filename !

              damn OEM and DOS mix from Win32... don't feel like fixing this...

Wish List     still to do in order to match older newname0 : count
              recursion ?
              allow at least "?" joker
              process all 0..9 digits at once ?

              lowercase only if all uppercase (AND vice versa)

              alternate recursive doSubst()
              (as to avoid building a string supposed to be deleted)

              remap accents from XP to 98 ?

              yes, -sss, -ppp and -iii:# are kludgy... but useful !

              we too often use UpperCase() ignoring accents

              mid$(), preserve # first or last chars when renaming ?

              yes, yes, space IS supported by DOS but it should NOT be !

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  8 Jun 22 v0.9b added -i
PhG  9 Feb 22 v0.9a hopefully fixed escaped sequences
PhG 26 Oct 21 an ugly really Q&D port from NEWNAME v1.3g for DOS
--------------------------------------------------------------- *)

MODULE NewName32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;
FROM SYSTEM IMPORT BYTE,ADR;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
    escape        = CHR(27);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)
CONST
    escChVisual	  = "";
    escSetVisual  = escChVisual+"-/'%";
    escCh         = 0260C; 	
    escSet        = escCh+"-/'%";

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(*
shame on you not to have thought of more than one value at a time !
shame on you for relying on an external library to parse a mere hex value !
really gone is your Apple ][ genius... :-(
bah, old age is coming faster than end of the world...
*)

(* assume : digits already filtered and uppercased, base = 10 or 16, hex=## *)

PROCEDURE charvalToStr (VAR R:ARRAY OF CHAR; base:CARDINAL; digits:ARRAY OF CHAR):BOOLEAN;

    MODULE hxhelper;

    EXPORT hx;

    PROCEDURE hx (ch:CHAR):CARDINAL;
    CONST
        val0 = ORD("0");
        valA = ORD("A");
    VAR
        v:CARDINAL;
    BEGIN
        v:=ORD(ch);
        IF v < valA THEN
            DEC(v, val0 );
        ELSE
            DEC(v, valA );
            INC(v, 10);
        END;
        RETURN v;
    END hx;

    END hxhelper;

CONST
    maxcharval = MAX(SHORTCARD);
VAR
    rc : BOOLEAN;
    i,len,v: CARDINAL;
BEGIN
    rc := TRUE;
    len:= Str.Length(digits);
    Str.Copy(R,"");
    CASE base OF
    | 10: (* filtered for 0..9 *)
        v:=0;
        i:=1;
        LOOP
            IF i > len THEN EXIT;END;
            v := (v * 10);
            INC( v , ( ORD( digits[i-1] ) - ORD("0") ) );
            rc := ( v <= maxcharval ); IF NOT(rc) THEN EXIT; END;
            INC(i);
        END;
        IF rc THEN rc := (v # 0); END;
        IF rc THEN Str.Copy( R, CHR(v) );END;
    | 16: (* filtered for 0..9 A..F *)
        (* IF len < 2 THEN Str.Prepend(digits,"0"); INC(len);END; done by caller *)
        IF ODD(len) THEN
            rc:=FALSE;
        ELSE
            i:=1;
            LOOP
                IF i > len THEN EXIT; END;
                v:=  ( hx(digits[i-1]) << 4 );
                INC(i);
                INC(v, hx(digits[i-1]) );
                INC(i);
                rc := (v # 0);
                IF NOT(rc) THEN EXIT; END;
                Str.Append(R, CHR(v) );
            END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN rc;
END charvalToStr;

(*

n  p  q  -  /  '  

###    $##    x##

*)

PROCEDURE metaproc (VAR S : ARRAY OF CHAR):BOOLEAN;
VAR
    ch:CHAR;
    c2:str80; (* really oversized for safety *)
    len,i,base:CARDINAL;
    R,orgS:str128;
    str:str128; (* in case we overflow ! *)
    state : (waiting,gotesc,grabhex,grabdec);
    rc:BOOLEAN;
BEGIN
    Str.Copy(orgS,S); (* in case of an error, return original unmodified string *)
    len := Str.Length(S);
    R   := "";
    i   := 1;
    rc  := TRUE;
    state := waiting;
    LOOP
        IF i > len THEN EXIT; END;
        ch := S[i-1];
        CASE state OF
        | waiting:
            CASE ch OF
            | escCh :
                state := gotesc;
            ELSE
                Str.Append(R,ch);
            END;
        | gotesc:
            CASE ch OF
            | "x","X","$":Str.Copy(str,"");         state:=grabhex; base:=16;
            | "0".."9" :  Str.Copy(str,ch);         state:=grabdec; base:=10;
            | "n","N" :   Str.Append(R,nl);         state:=waiting;
            | "p","P" :   Str.Append(R,percent);    state:=waiting;
            | "q","Q" :   Str.Append(R,doublequote);state:=waiting;
            | "b","B" :   Str.Append(R,vbar);       state:=waiting;
            ELSE
                IF Str.CharPos(escSet,ch) = MAX(CARDINAL) THEN
                    DEC(i); (* esc+verbatim : go back to make verbatim the next *)
                ELSE
                    Str.Append(R,ch); (* esc+reserved char *)
                END;
                state:=waiting;
            END;
        | grabhex:
            CASE ch OF
            | "0".."9", "A".."F", "a".."f" :
                Str.Append(str, CAP(ch) ); (* uppercase ! *)
            | escCh:
                IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                state:=waiting; (* //FIX was gotesc *)
            ELSE
                IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                DEC(i); (* go back one char now to make it next *)
                state:=waiting;
            END;
        | grabdec:
            CASE ch OF
            | "0".."9" :
                Str.Append(str,ch);
            | escCh:
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                state:=waiting; (* //FIX was gotesc *)
            ELSE
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                DEC(i); (* go back one char now to make it next *)
                state:=waiting;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(i);
    END;
    CASE state OF
    | grabhex:
        IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
        rc:=charvalToStr(c2,base,str);
        IF rc THEN Str.Append(R,c2); END;
    | grabdec:
        rc:=charvalToStr(c2,base,str);
        IF rc THEN Str.Append(R,c2); END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF rc THEN
        Str.Copy(S,R);
    ELSE
        Str.Copy(S,orgS); (* restore original *)
    END;
    RETURN rc;
END metaproc;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    vowels        = "aeiouy";
    alphaset      = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; (* uppercase *)
    symbols       = "_-$!(){}~#&@[]";
    legalLFN      = ",;'.+%="+blank;
    DOScharset    = alphaset+digits+symbols; (* uppercase *)
    LFNcharset    = DOScharset+legalLFN;
    UNDOBATCH     = "ROLLBACK.BAT";
    ignoredrenumprefix  = "*"; (* ignore prefix when renumbering *)
    autonumsep          = "_";
    autonummarker       = "*";
CONST
    MINFIELD      = 1;
    MAXFIELD      = 12;
    DEFFIELD      = 4;
    MINDELTA      = 1;
    MAXDELTA      = 100;
    DEFDELTA      = 1;
CONST
    ProgEXEname   = "NEWNAME32";
    ProgTitle     = "Q&D Filename Modifier (Win32)";
    ProgVersion   = "v0.9b (from v1.3h for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone         = 0;
    errHelp         = 1;
    errUnknownOption= 2;
    errParmOverflow = 3;
    errStorage      = 4;
    errCmdConflict  = 5;
    errSyntax       = 6;
    errBadPrefix    = 7;
    errBadSuffix    = 8;
    errBadSpec      = 9;
    errNoMatch      = 10;
    errBadChar      = 11;
    errBadRemap     = 12;
    errRemapNonsense= 13;
    errBadVal       = 14;
    errBadInfix     = 15;
    errNonsense     = 16;
    errRange        = 17;
    errSortConflict = 18;
    errFieldWidth   = 19;
    errWontProcess  = 20;
    errBadSubstring = 21;
    errBadMeta      = 22;
    errLFNonly      = 23;
    errDirectory    = 24;
    (* will become errHelp *)
    errMoreHelp     = 32;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
     helpmsg=Banner+nl+
nl+
"Syntax 1  : "+ProgEXEname+" [-f] <string> <file(s)> [option]..."+nl+
"Syntax 2  : "+ProgEXEname+" [-m] <oldstring> <newstring> <file(s)> [option]..."+nl+
"Syntax 3  : "+ProgEXEname+" <-p[p[p]> <prefix|"+autonummarker+"> <file(s)> [option]..."+nl+
"Syntax 4  : "+ProgEXEname+" <-s[s[s]> <suffix|"+autonummarker+"> <file(s)> [option]..."+nl+
"Syntax 5  : "+ProgEXEname+" <-i[i[i]]:#> <insertion> <file(s)> [option]..."+nl+
"Syntax 6  : "+ProgEXEname+" <-z> <substring> <file(s)> [option]..."+nl+
"Syntax 7  : "+ProgEXEname+" <-c> <oldsubstring> <newsubstring> <file(s)> [option]..."+nl+
"Syntax 8  : "+ProgEXEname+" <-lc|-uc> <file(s)> [option]..."+nl+
"Syntax 9  : "+ProgEXEname+" <-n[n]> <prefix|"+ignoredrenumprefix+"> <first> <file(s)> [option]..."+nl+
"Syntax 10 : "+ProgEXEname+" <-b|-j> <file(s)> [option]..."+nl+
"Syntax 11 : "+ProgEXEname+" <-trim|-blanks> <file(s)> [option]..."+nl+
nl+
"This program filters out characters from <string> (syntax 1) ;"+nl+
"remaps character(s) from <oldstring> using <newstring> (syntax 2) ;"+nl+
"processes prefixes (syntax 3), suffixes (syntax 4) and insertions (syntax 5) ;"+nl+
"removes substrings (syntax 6) ; changes <oldstring> to <newstring> (syntax 7) ;"+nl+
"changes LFN filenames case to lower or upper (syntax 8) ;"+nl+
"renumbers filenames (syntax 9) ;"+nl+
"prefixes or suffixes LFN filenames with YMD_HMS datetime stamp (syntax 10) ;"+nl+
"trims spaces at right and left of filenames (syntax 11)."+nl+
nl+
"-f         filter out mode (default if two parameters were specified)"+nl+
"-m         remap mode (default if three parameters were specified)"+nl+
"-p[p[p]]   prefix mode (-pp = -d -p, -ppp = -pp deleting length of <prefix>)"+nl+
"-s[s[s]]   suffix mode (-ss = -d -s, -sss = -ss deleting length of <suffix>)"+nl+
"-i[i[i]]:# insert at specified 0-based column mode (-ii:# = -d -i:#)"+nl+
"-z         remove first substring (operation not recursive)"+nl+
"-c         change first oldsubstring to newsubstring (operation not recursive)"+nl+
"-<lc|uc>   convert to lowercase or uppercase mode"+nl+
'-n[n]      renumber mode (-nn = "-n '+ignoredrenumprefix+'" syntax = do not use <prefix>)'+nl+
"-<b|j>     prefix or suffix file datetime stamp to filename"+nl+
"-trim      trim spaces at right and left"+nl+
nl+
"-r[r]      do rename file(s) (-rr = create undo "+UNDOBATCH+")"+nl+
"-??        more help (to be read at least once !)"+nl;

       morehelpmsg =
"-d[?]      delete prefix or suffix (-ds = -s -d, -dp = -p -d)"+nl+
"-a         take hidden and system files into account"+nl+
"-o         rename even if new name already exists (previous content lost)"+nl+
"-i         allow rename to same name"+nl+
"-e         process extension (only when removing, remapping or converting)"+nl+ (* chars *)
"-f:#       number field width ([1..12], default is 4)"+nl+
"-k:#       renumbering increment ([1..100], default is 1)"+nl+
"-s<?>[-]   sort when renumbering (n = name, e = extension, z = size, d = date)"+nl+
"-x         prepend renumbered value and <prefix> to <filename> (-n[n] only)"+nl+
"-<y|u>     try and make sure new filename is unique (-t[#] only)"+nl+
"-v         ignore character set validity check"+nl+
nl+
'Valid set (DOS) : "'+DOScharset+'"'+nl+
'Valid set (LFN) : "'+LFNcharset+'"'+nl+
nl+
"a) By design, this program requires <file(s)> not to be a directory alone."+nl+
"b) Any option irrelevant to specified mode command will be silently ignored."+nl+
"c) Program will handle up to 65530 files. "+UNDOBATCH+" name is reserved."+nl+
"d) Note collisions cannot be previewed : use -r only when sure of results !"+nl+
'e) Auto-numbering "-s *" and "-p *" syntaxes use "'+autonumsep+'" as a separator.'+nl+
"f) -ppp, -sss and -iii:# options delete # first, last or middle characters,"+nl+
"   where # is length of specified <prefix>, <suffix> or <insertion>."+nl+
"g) -t1 truncates characters from end of filename ;"+nl+
'   -t2 is -t1 but removes all characters preceding first "-" character if any ;'+nl+
"   -t3 is -t2 but keeps first char of filename ;"+nl+
"   -t4 is -t1 but does not try and preserve trailing digits"+nl+
"   (note -t1, -t2 and -t3 try and preserve trailing digits) ;"+nl+
"   -t4, -t5 and -t6 are identical to -t1, -t2 and -t3"+nl+
"   but they preprocess filenames by removing vowels."+nl+
"   With all -t[#] options, file extension is just truncated to fit DOS format :"+nl+
"   -e option is therefore ignored."+nl+
"   Note all -t[#] options ignore filenames already fitting DOS format."+nl+
'h) Support for escape sequences is minimalist : "'+escChVisual + '[' + escSetVisual + ']" inserts symbol,' + nl +
'   while "' + escChVisual + "[$|x]#[" + escChVisual + ']" inserts (hexa)decimal character value.'+nl+
"i) Note this program does not support any string joker."+nl+
"j) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"EXamples : "+ProgEXEname+" -t2 f:\data\pictures\*.*"+nl+
"           "+ProgEXEname+" -n pic 1 -f:2 *.jpg"+nl+
"           "+ProgEXEname+" -c iso pim *.mod"+nl+
"           "+ProgEXEname+" -p m2_ src\*.mod"+nl+
"           "+ProgEXEname+" -b *.obj"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp :
        WrStr(helpmsg);
        IF e = errMoreHelp THEN
            WrStr(morehelpmsg);
            e:=errHelp;
        END;
    | errUnknownOption :
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errParmOverflow :
        Str.Concat(S,"Uneeded ",einfo);Str.Append(S," parameter !");
    | errStorage :
        S := "Storage ALLOCATE() failure !";
    | errCmdConflict:
        S := "Mutually exclusive commands !";
    | errSyntax :
        S := "Syntax error !";
    | errBadPrefix:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" prefix !');
    | errBadSuffix:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" suffix !');
    | errBadSpec:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" specification !');
    | errNoMatch:
        Str.Concat(S,'No match for "',einfo);Str.Append(S,'" specification !');
    | errBadChar:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" string !');
    | errBadRemap:
        S:="<oldstring> and <newstring> must have the same length !";
    | errRemapNonsense:
        S:="Remapping a character to itself is a nonsense !";
    | errBadVal:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," value !");
    | errBadInfix:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" insertion !');
    | errNonsense:
        Str.Concat(S,einfo," option is a nonsense with specified command !");
    | errRange:
        Str.Concat(S,einfo," is not in expected range !");
    | errSortConflict:
        S := "Mutually exclusive sort methods !";
    | errFieldWidth:
        S := "Field width is too small for total number of files to process !";
    | errWontProcess:
        (* S := "-rr option prevents processing of existing "+UNDOBATCH+" !"; *)
        S := "As "+UNDOBATCH+" was found, -rr will not process any file !";
    | errBadSubstring:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" substring !');
    | errBadMeta:
        Str.Concat(S,'Illegal escape sequence ("',einfo);Str.Append(S,'") !');
    | errLFNonly:
        S := "LFN support is required with this command !"; (* keep it short *)
    | errDirectory:
        Str.Concat(S,'Expecting <file(s)> in "',einfo);Str.Append(S,'" directory specification !');
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT (e);
END abort;

PROCEDURE dbgstr (DEBUG:BOOLEAN;S1,S2:ARRAY OF CHAR   );
CONST
    wi = 20;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrStr("// ");WrStr(S1);
        FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
        WrStr(S2); WrLn;
    END;
END dbgstr;

PROCEDURE dbgv (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:CARDINAL   );
CONST
    wi = 20;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrStr("// ");WrStr(S1);
        FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
        IO.WrCard(v,1); WrLn;
    END;
END dbgv;

PROCEDURE WrHexStr (hex:BOOLEAN;S:pathtype);
CONST
    shx     = "0123456789abcdef";
    gremlin = CHR(168);
VAR
    len,i,c,v:CARDINAL;
BEGIN
    len:=Str.Length(S);
    FOR i:=1 TO len DO
        c:=ORD( S[i-1] );
        IF hex THEN
            v:=(c AND 0F0H);
            v:=(v >> 4);
            WrStr(shx[v]);
            v:=(c AND 00FH);
            WrStr(shx[v]);
        ELSE
            WrStr(" ");
            IF c < ORD(blank) THEN
                WrStr(gremlin);
            ELSE
                WrStr(CHR(c));
            END;
        END;
        IF i < len THEN WrStr(" ");END;
    END;
END WrHexStr;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstEntry = 1; (* 1..count *)
TYPE
    ptrToEntry = POINTER TO entryType;
    entryType = RECORD
        next   : ptrToEntry;
        index  : CARDINAL; (* for possible later sort *)
        fsize  : LONGCARD;
        fdate  : CARDINAL;
        ftime  : CARDINAL;
        slen   : CARDINAL; (* a SHORTCARD would DO fine IN almost all cases  *)
        string : CHAR;     (* here, after other data, because variable length *)
    END;

VAR
    anchorSpec  : ptrToEntry; (* globerk *)

PROCEDURE getAnchor (  ):ptrToEntry;
BEGIN
    RETURN anchorSpec;
END getAnchor;

PROCEDURE initList (VAR anchor:ptrToEntry; VAR count:CARDINAL);
BEGIN
    count := firstEntry-1; (* complicated way to mean 0 *)
    anchor:= NIL;
END initList;

PROCEDURE isReservedEntry (S : ARRAY OF CHAR) : BOOLEAN; (* assume uppercase *)
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildMatchList (VAR anchor:ptrToEntry;
                          hiddensystem : BOOLEAN;spec:pathtype):CARDINAL;
VAR
    S:pathtype; (* some are oversized but safety first ! *)
    newInList : ptrToEntry;
    len,needed,count : CARDINAL;
    w9Xhandle,errcode:CARDINAL;
    DOSentry     : FIO.DirEntry;
    rc,found:BOOLEAN;
    dosattr:FIO.FileAttr;
    fsize:LONGCARD;
    fdate,ftime:CARDINAL;
BEGIN
    IF hiddensystem THEN
        dosattr:=allfiles;
    ELSE
        dosattr := FIO.FileAttr{aR,aA};
    END;

    count:=0;

        found := FIO.ReadFirstEntry(spec,dosattr,DOSentry);
    WHILE found DO
            Str.Copy(S,DOSentry.name);
            fsize := DOSentry.sizeL;     (* thanks, JPI, for using a reserved word here ! *)
            fdate := DOSentry.datePkd;
            ftime := DOSentry.timePkd;
        IF isReservedEntry(S) THEN (* skip "." ".." *)
            ; (* silently ignore this spec *)
        ELSE
                dosattr:=DOSentry.attr;
            IF NOT (aDD IN dosattr) THEN
                IF count=MAX(CARDINAL) THEN
                    RETURN MAX(CARDINAL);
                END; (* too many files but let's fake ALLOCATE failure *)
                len:=Str.Length(S);
                needed:=SIZE(entryType)-SIZE(CHAR)+len;
		(*
                IF Available(needed)=FALSE THEN
                    RETURN MAX(CARDINAL);
                END; (* storage ALLOCATE failure *)
		*)
                IF anchor=NIL THEN
                    ALLOCATE( anchor,needed);
                    newInList := anchor;
                ELSE
                    ALLOCATE(newInList^.next,needed);
                    newInList :=newInList^.next;
                END;
                Lib.FastMove( ADR(S),ADR(newInList^.string),len);
                newInList^.slen := len;
                newInList^.fsize:= fsize;
                newInList^.fdate:= fdate;
                newInList^.ftime:= ftime;
                newInList^.next := NIL;
                newInList^.index:= 0; (* filled later *)
                INC(count);
            END;
        END;
            found :=FIO.ReadNextEntry(DOSentry);
    END;
    RETURN count;
END buildMatchList;

PROCEDURE freeMatchList (anchor:ptrToEntry);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrToEntry;
BEGIN
    firstInList := anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
        len         := CARDINAL(newInList^.slen);
        needed      := SIZE(entryType)-SIZE(CHAR)+len;
        firstInList := firstInList^.next;
        DEALLOCATE (newInList,needed);
        newInList := firstInList;
    END
END freeMatchList;

PROCEDURE findEntry (n:CARDINAL;  anchor:ptrToEntry  ):ptrToEntry;
VAR
    newInList:ptrToEntry;
BEGIN
    newInList := anchor;
    LOOP
        IF newInList = NIL THEN EXIT;END; (* gloups! *)
        IF newInList^.index = n THEN EXIT; END;
        newInList := newInList^.next;
    END;
    RETURN newInList;
END findEntry;

PROCEDURE getEntry (VAR R:pathtype;
                   n:CARDINAL; anchor:ptrToEntry);
VAR
    len:CARDINAL;
    newInList:ptrToEntry;
    S:pathtype;
BEGIN
    newInList := findEntry(n,anchor);
    IF newInList = NIL THEN Str.Copy(R,"???"); RETURN;END;
    len         := newInList^.slen;
    Lib.FastMove( ADR(newInList^.string),ADR(S),len);
    S[len]      := charnull; (* REQUIRED safety ! *)
    Str.Copy(R,S); (* yep, compiler won't let us fill R directly *)
END getEntry;

PROCEDURE getFsizeEntry (VAR R:LONGCARD;
                        n:CARDINAL; anchor:ptrToEntry);
VAR
    newInList:ptrToEntry;
BEGIN
    newInList := findEntry(n,anchor);
    IF newInList = NIL THEN R:=MAX(LONGCARD); RETURN;END;
    R := newInList^.fsize;
END getFsizeEntry;

PROCEDURE getStampEntry (VAR D,T:CARDINAL;n:CARDINAL;anchor:ptrToEntry);
VAR
    newInList:ptrToEntry;
BEGIN
    newInList := findEntry(n,anchor);
    IF newInList = NIL THEN D:=0; T:=0; RETURN ; END;
    D := newInList^.fdate;
    T := newInList^.ftime;
END getStampEntry;

PROCEDURE initIndexes (anchor:ptrToEntry );
VAR
    newInList:ptrToEntry;
    i : CARDINAL;
BEGIN
    i := firstEntry;
    newInList:=anchor;
    LOOP
        IF newInList = NIL THEN EXIT; END;
        newInList^.index := i;
        INC(i);
        newInList := newInList^.next;
    END;
END initIndexes;

(* ------------------------------------------------------------ *)

PROCEDURE doswap (i,j:CARDINAL);
VAR
    anchor,pi,pj:ptrToEntry;
    tmp:CARDINAL;
BEGIN
    anchor:=getAnchor();
    pi:=findEntry(i,anchor);
    pj:=findEntry(j,anchor);
    tmp:=pi^.index;
    pi^.index:=pj^.index;
    pj^.index:=tmp;
END doswap;

PROCEDURE dolessname (i,j:CARDINAL ):BOOLEAN ;
VAR
    SI,SJ: pathtype ;
    anchor:ptrToEntry;
BEGIN
    anchor:=getAnchor();
    getEntry(SI,i, anchor);
    getEntry(SJ,j, anchor);
    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);
    IF Str.Compare(SI,SJ) < 0 THEN (* -1 is less *)
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END dolessname;

PROCEDURE dolessext ( i,j:CARDINAL  ):BOOLEAN ;
VAR
    e1,e2:pathtype;
    p : CARDINAL;
    anchor:ptrToEntry;
BEGIN
    anchor:=getAnchor();
    getEntry(e1,i,anchor);
    getEntry(e2,j,anchor);
    LowerCase(e1); (* ignore accents when sorting *)
    LowerCase(e2);

    p := Str.RCharPos(e1,dot);
    IF p = MAX(CARDINAL) THEN
        e1:="";
    ELSE
        Str.Delete(e1,0,p+1);
    END;
    p := Str.RCharPos(e2,dot);
    IF p = MAX(CARDINAL) THEN
        e2:="";
    ELSE
        Str.Delete(e2,0,p+1);
    END;
    CASE Str.Compare(e1,e2) OF
    | -1 : RETURN TRUE;
    |  0 : RETURN dolessname(i,j);
    |  1 : RETURN FALSE;
    ELSE ; (* //ISO fixed silly requirement *) END;
END dolessext;

PROCEDURE dolesssize (i,j:CARDINAL ):BOOLEAN ;
VAR
    anchor:ptrToEntry;
    fsizeI,fsizeJ:LONGCARD;
BEGIN
    anchor:=getAnchor();
    getFsizeEntry(fsizeI,i, anchor);
    getFsizeEntry(fsizeJ,j, anchor);
    IF (fsizeI = fsizeJ) THEN
        RETURN dolessname(i,j);
    ELSE
        RETURN (fsizeI < fsizeJ);
    END;
END dolesssize;

PROCEDURE dolessstamp (i,j:CARDINAL):BOOLEAN;
VAR
    anchor:ptrToEntry;
    fdateI,ftimeI,fdateJ,ftimeJ:CARDINAL;
BEGIN
    anchor:=getAnchor();
    getStampEntry(fdateI,ftimeI,i,anchor);
    getStampEntry(fdateJ,ftimeJ,j,anchor);
    IF fdateI < fdateJ THEN RETURN TRUE; END;
    IF fdateI > fdateJ THEN RETURN FALSE; END;
    RETURN (ftimeI < ftimeJ);
END dolessstamp;

PROCEDURE dolessnameINV (i,j:CARDINAL ):BOOLEAN ;
BEGIN
    RETURN NOT (dolessname(i,j));
END dolessnameINV;

PROCEDURE dolessextINV ( i,j:CARDINAL  ):BOOLEAN ;
BEGIN
    RETURN NOT(dolessext(i,j));
END dolessextINV;

PROCEDURE dolesssizeINV (i,j:CARDINAL ):BOOLEAN ;
BEGIN
    RETURN NOT(dolesssize(i,j));
END dolesssizeINV;

PROCEDURE dolessstampINV (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN NOT(dolessstamp(i,j));
END dolessstampINV;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE WrQ (S:ARRAY OF CHAR);
BEGIN
    WrStr(dquote);WrStr(S);WrStr(dquote);
END WrQ;

(* only handle "-" alone *)

PROCEDURE isOptionForReal (S:ARRAY OF CHAR  ):BOOLEAN ;
BEGIN
    IF same(S,dash) THEN RETURN FALSE; END; (* don't be fooled by a dash alone *)
    RETURN isOption(S);
END isOptionForReal;

PROCEDURE killfile (killRO:BOOLEAN;S:pathtype);
BEGIN
    (* //V13G *)
    IF fileIsRO(S) THEN
        IF killRO THEN fileSetRW(S); END;
    END;
    FIO.Erase(S);
END killfile;

PROCEDURE padnum (lc:LONGCARD;wi:CARDINAL   ):str80;
VAR
    R:str80;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(lc,R,10,ok);
    FOR i:=Str.Length(R)+1 TO wi DO
        Str.Prepend(R,"0");
    END;
    RETURN R;
END padnum;

(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (nada,
              prefix,suffix,infix,
              prefixkill,suffixkill,infixkill,
              lenprefixkill,lensuffixkill,leninfixkill,
              remove,remap,renum,substringkill,
              substringreplace,
              strlowercase,struppercase,
              suffixautonum,prefixautonum,
              prefixstamp,suffixstamp,
              trimname);

PROCEDURE chkcmd (VAR cmd:cmdtype; wanted:cmdtype ):BOOLEAN;
BEGIN
    IF ( (cmd = nada) OR (cmd=wanted) ) THEN
        cmd:=wanted;
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END chkcmd;

TYPE
    sorttype = (nosort,
               bysize,byname,byextension,bystamp,
               bysizeINV,bynameINV,byextensionINV,bystampINV); (* bydatetime is neverware *)

PROCEDURE chksort (VAR sort:sorttype; wanted:sorttype ):BOOLEAN;
BEGIN
    IF ( (sort= nosort) OR (sort=wanted) ) THEN
        sort:=wanted;
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END chksort;

PROCEDURE chkChars (allowdot:BOOLEAN;S:ARRAY OF CHAR):BOOLEAN;
VAR
    R,allowed:pathtype;
BEGIN
        Str.Copy(allowed,LFNcharset);
        allowdot:=TRUE;
    IF allowdot THEN
        Str.Append(allowed,dot); (* for DOS *)
    ELSE
        Str.Subst(allowed,dot,"");
    END;
    Str.Copy(R,S);
    UpperCase(R);
    RETURN verifyString (R,allowed);
END chkChars;

PROCEDURE chkValid (isSpec,chkvalidchar:BOOLEAN;S:ARRAY OF CHAR;
                   VAR base:ARRAY OF CHAR):BOOLEAN;
VAR
    R,u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    IF isSpec THEN
        Lib.MakeAllPath(base,u,d,"","");
        IF same(base,"")=FALSE THEN fixDirectory(base);END;
    ELSE
        IF chkJoker(S) THEN RETURN FALSE; END;
        Lib.MakeAllPath(R,"","",n,e);
        IF same(S,R)=FALSE THEN RETURN FALSE;END; (* a path is not a valid fix *)
        IF chkvalidchar THEN RETURN chkChars(TRUE,R); END;
    END;
    RETURN TRUE;
END chkValid;

PROCEDURE chkRange (VAR v:CARDINAL;
                   lc:LONGCARD;lower,upper:CARDINAL):BOOLEAN ;
BEGIN
    IF lc > MAX(CARDINAL) THEN RETURN FALSE;END;
    v:=CARDINAL(lc); (* don't bother to check against filename len *)
    IF v < lower THEN RETURN FALSE;END;
    IF v > upper THEN RETURN FALSE;END;
    RETURN TRUE;
END chkRange;

(* ------------------------------------------------------------ *)

CONST
    placeholder    = "|"; (* does not belong to DOS or LFN charsets *)
    msgTooShort    = "--- Renamed "+placeholder+" would be empty !";
    msgTooLong     = "--- Renamed "+placeholder+" would be too long !";
    msgTooLongExt  = "--- Renamed "+placeholder+" extension would be too long !";
 (* msgAlready     = "--- Renamed "+placeholder+" already exists !"; *)
    msgAlready     = "--- "+placeholder+" would become existing "+placeholder+" !";
    msgWouldBe     = "::: "+placeholder+" would become "+placeholder;
    msgIsNow       = "+++ "+placeholder+" is now "+placeholder;
    msgFileExists  = " (file exists)";
    msgFileExisted = " (file existed)";

PROCEDURE msg (doCR:BOOLEAN;S,F:ARRAY OF CHAR   );
VAR
    R:str1024; (* oversized *)
BEGIN
    Str.Copy(R,S);
    Str.Subst(R,placeholder,dquote+placeholder+dquote);
    Str.Subst(R,placeholder,F);
    WrStr(R);IF doCR THEN WrLn; END;
END msg;

PROCEDURE msg2 (doCR:BOOLEAN;S,F1,F2:ARRAY OF CHAR   );
VAR
    R:str1024; (* oversized *)
BEGIN
    Str.Copy(R,S);
    Str.Subst(R,placeholder,dquote+placeholder+dquote);
    Str.Subst(R,placeholder,F1);
    Str.Subst(R,placeholder,dquote+placeholder+dquote);
    Str.Subst(R,placeholder,F2);
    WrStr(R);IF doCR THEN WrLn; END;
END msg2;

CONST
    MINF8   = 1;        MAXF8   = 8;
    MINE3   = 0;        MAXE3   = 3+1;
    (* //V12o fix : note empty extension is still a dot here ! *)
    MINLFN  = 1;        MAXLFN  = SIZE(pathtype);
    MINLFNE = 0;        MAXLFNE = SIZE(pathtype); (* ouais... *)

PROCEDURE chknewlen (VAR messages:CARDINAL;
                    procext,DEBUG:BOOLEAN;oldname,n,e:pathtype):BOOLEAN;
VAR
    wecandoit:BOOLEAN;
    action,mini,maxi,pass,lastpass,len : CARDINAL;
    ch:CHAR;
BEGIN
    IF procext THEN
        lastpass:=1;
    ELSE
        lastpass:=2;
    END;
    (*
    IF DEBUG THEN
        WrStr("/// n : ");WrStr(n);WrLn;
        WrStr("/// e : ");WrStr(e);WrLn;
    END;
    *)
    action:=0;
    FOR pass := 1 TO lastpass DO
        CASE pass OF
        | 1: len:=Str.Length(n);
             ch:="n";
                 mini:=MINLFN;  maxi:=MAXLFN;
             IF len < mini THEN
                 msg(TRUE, msgTooShort,oldname); INC(action);
             ELSIF len > maxi THEN
                 msg(TRUE,msgTooLong,oldname);   INC(action);
             END;
        | 2: len:=Str.Length(e);
             ch:="e";
                 mini:=MINLFNE; maxi:=MAXLFNE;
             IF DEBUG THEN
                ;
             END;
             IF len > maxi THEN
                 msg(TRUE,msgTooLongExt,oldname);  INC(action);
             END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        (*
        IF DEBUG THEN
             WrStr("/// part,mini,maxi,len,action : ");WrStr(ch);
             IO.WrCard(mini,4);IO.WrCard(maxi,4);
             IO.WrCard(len,4);IO.WrCard(action,4);WrLn;
        END;
        *)
    END;
    IF action # 0 THEN INC(messages);END;
    RETURN (action = 0);
END chknewlen;

PROCEDURE doClean (VAR n,e:pathtype; procext:BOOLEAN;str:ARRAY OF CHAR):BOOLEAN ;
VAR
    filename,extension,delme:pathtype;
    action,p,i,pass,lastpass : CARDINAL;
    ch:CHAR;
BEGIN
    IF procext THEN
       lastpass:=2
    ELSE
       lastpass:=1;
    END;

    Str.Copy(filename,n);
    Str.Copy(extension,e);
    Str.Copy(delme,str);
    UpperCase(filename);
    UpperCase(extension);
    UpperCase(delme);

    action := 0;
    FOR pass:=1 TO lastpass DO
        FOR i:=1 TO Str.Length(delme) DO
            ch:=delme[i-1];
            LOOP
                CASE pass OF
                | 1 : p:=Str.CharPos(filename,ch);
                      IF p # MAX(CARDINAL) THEN
                          Str.Delete(filename,p,1);
                          Str.Delete(n,p,1);
                          INC(action);
                      END;
                | 2 : p:=Str.CharPos(extension,ch);
                      IF p # MAX(CARDINAL) THEN
                          Str.Delete(extension,p,1);
                          Str.Delete(e,p,1);
                          INC(action);
                      END;
                ELSE ; (* //ISO fixed silly requirement *) END;
                IF p = MAX(CARDINAL) THEN EXIT; END;
            END;
        END;
    END;
    RETURN (action # 0);
END doClean;

PROCEDURE doRemap (VAR n,e:pathtype; procext:BOOLEAN;str,mapstr:ARRAY OF CHAR):BOOLEAN ;
VAR
    filename,extension,mapme:pathtype;
    action,p,i,pass,lastpass,len : CARDINAL;
    ch:CHAR;
BEGIN
    IF procext THEN
       lastpass:=2
    ELSE
       lastpass:=1;
    END;

    Str.Copy(filename,n);
    Str.Copy(extension,e);
    Str.Copy(mapme,str);
    UpperCase(filename);
    UpperCase(extension);
    UpperCase(mapme);

    action:=0;
    FOR pass:=1 TO lastpass DO
        CASE pass OF
        | 1 : len:=Str.Length(filename);
        | 2 : len:=Str.Length(extension);
        ELSE ; (* //ISO fixed silly requirement *) END;
        FOR i:=1 TO len DO
            CASE pass OF
            | 1 : p:=Str.CharPos(mapme,filename[i-1]);
                  IF p # MAX(CARDINAL) THEN
                      n[i-1]:=mapstr[p];
                      INC(action);
                  END;
            | 2 : p:=Str.CharPos(mapme,extension[i-1]);
                  IF p # MAX(CARDINAL) THEN
                      e[i-1]:=mapstr[p];
                      INC(action);
                  END;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    RETURN (action # 0);
END doRemap;

PROCEDURE doCasify (VAR n,e:pathtype; op:cmdtype;procext:BOOLEAN ):BOOLEAN;
VAR
    ok:BOOLEAN;
    orgn,orge:pathtype;
BEGIN
    Str.Copy(orgn,n);
    Str.Copy(orge,e);
        CASE op OF
        | strlowercase: LowerCase(n);
        | struppercase: UpperCase(n);
        ELSE ; (* //ISO fixed silly requirement *) END;
        ok:=NOT ( same (orgn,n) );
    IF procext THEN
        CASE op OF
        | strlowercase: LowerCase(e);
        | struppercase:UpperCase(e);
        ELSE ; (* //ISO fixed silly requirement *) END;
        ok:= ( ok OR ( NOT (same(orge,e) ) ) );  (* //V13A NOT AND here ! *)
    END;
    RETURN ok;
END doCasify;

PROCEDURE doTrimName (VAR n,e:pathtype; procext:BOOLEAN ):BOOLEAN;
VAR
    ok:BOOLEAN;
    orgn,orge:pathtype;
BEGIN
    Str.Copy(orgn,n);
    Str.Copy(orge,e);
    LtrimBlanks(n);
    RtrimBlanks(n);
    ok:=NOT ( same (orgn,n) );
    IF procext THEN
        LtrimBlanks(e);
        RtrimBlanks(e);
        ok:= ( ok OR ( NOT (same(orge,e) ) ) );  (* //V13A NOT AND here ! *)
    END;
    RETURN ok;
END doTrimName;

(* ------------------------------------------------------------ *)

PROCEDURE doSubst (VAR n,e:pathtype; procext:BOOLEAN;oldstr,newstr:ARRAY OF CHAR):BOOLEAN ;
VAR
    filename,extension,ancien,nouveau,newn,newe,tmp:pathtype;
    action,p,i,pass,lastpass,len : CARDINAL;
BEGIN
    IF procext THEN
       lastpass:=2
    ELSE
       lastpass:=1;
    END;

    Str.Copy(filename,n);
    Str.Copy(extension,e);
    Str.Copy(ancien,oldstr);
    Str.Copy(nouveau,newstr);
    UpperCase(filename);
    UpperCase(extension);
    UpperCase(ancien);
    UpperCase(nouveau);

    newn:="";
    newe:="";
    len:=Str.Length(ancien);
    action := 0;
    FOR pass:=1 TO lastpass DO
        LOOP
            CASE pass OF
            | 1 : p:=Str.Pos(filename,ancien);
                  IF p # MAX(CARDINAL) THEN
                      Str.Delete(filename,0,p+len);
                      Str.Slice(tmp,n,0,p);
                      Str.Delete(n,0,p+len);
                      Str.Append(newn,tmp);
                      Str.Append(newn,newstr);
                      INC(action);
                  END;
            | 2 : p:=Str.Pos(extension,ancien);
                  IF p # MAX(CARDINAL) THEN
                      Str.Delete(extension,0,p+len);
                      Str.Slice(tmp,e,0,p);
                      Str.Delete(e,0,p+len);
                      Str.Append(newe,tmp);
                      Str.Append(newe,newstr);
                      INC(action);
                  END;
            ELSE ; (* //ISO fixed silly requirement *) END;
            IF p = MAX(CARDINAL) THEN EXIT; END;
        END;
    END;
    IF same(newn,"")=FALSE THEN Str.Prepend(n,newn);END;
    IF same(newe,"")=FALSE THEN Str.Prepend(e,newe);END;

    RETURN (action # 0);
END doSubst;

CONST
    shortennormal       = 01H; (* 00000001 *)
    shortendash         = 02H; (* 00000010 *)
    shorteninitial      = 04H; (* 00000100 *)
    shortenvowel        = 08H; (* 00001000 *)
    shortentruncate     = 10H; (* 00010000 *)
    shortenmachete      = 20H; (* 00100000 *)

PROCEDURE bitarmed (mask,wanted:CARDINAL):BOOLEAN;
BEGIN
    RETURN ( (mask AND wanted) = wanted);
END bitarmed;

PROCEDURE adjustlen (VAR S:pathtype; DEBUG,machete:BOOLEAN;mini,maxi:CARDINAL );
VAR
    i:CARDINAL;
BEGIN
    i:=Str.Length(S);
    IF machete THEN
        IF i # 0 THEN Str.Delete(S,i-1,1); END;
    ELSE
        LOOP
            IF i <= mini THEN EXIT;END;
            IF i <= maxi THEN EXIT;END;
            Str.Delete(S,i-1,1);
            DEC(i);
        END;
    END;
END adjustlen;

PROCEDURE novowels (VAR S:pathtype;DEBUG:BOOLEAN );
VAR
    R:pathtype;
    i:CARDINAL;
    ch:CHAR;
BEGIN
    R:="";
    FOR i:=1 TO Str.Length(S) DO
        ch:=S[i-1];
        LowerCase(ch);
        IF Belongs(vowels,ch)= FALSE THEN Str.Append(R,ch);END;
    END;
    Str.Copy(S,R);
END novowels;

PROCEDURE splitstr(VAR S,R:pathtype;DEBUG:BOOLEAN);
VAR
    i:CARDINAL;
    ch:CHAR;
BEGIN
    Str.Copy(R,"");
    i:=Str.Length(S);
    LOOP
        IF i < 1 THEN EXIT; END;
        ch:=S[i-1];
        IF Belongs(digits,ch)=FALSE THEN EXIT; END;
        Str.Prepend(R,ch);
        Str.Delete(S,i-1,1);
        DEC(i);
    END;
END splitstr;

(* [mini..maxi] *)

PROCEDURE chknamelen (mini,maxi:CARDINAL;S:pathtype):BOOLEAN;
VAR
    pb,len:CARDINAL;
BEGIN
    pb:=0;
    len:=Str.Length(S);
    IF len > maxi THEN INC(pb);END;
    IF len < mini THEN INC(pb);END;
    RETURN (pb=0);
END chknamelen;


(* //FIXME only way in program to set machete on *)

(* ------------------------------------------------------------ *)

(* ripped from DT v1.1d *)

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str16;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str16;     (* was str80 *)
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    IF pad="" THEN RETURN S; END;
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

TYPE
    datetype = RECORD
        day   : CARDINAL;
        month : CARDINAL;
        year  : CARDINAL;
        dayOfWeek  : Lib.DayType;
        validDayOfWeek : BOOLEAN; (* cleaner but useless *)
    END;
    timetype = RECORD
        hours   : CARDINAL;
        minutes : CARDINAL;
        seconds : CARDINAL;
    END;


TYPE
    dttype = RECORD
        CASE : BOOLEAN OF
        | TRUE  :
            t : CARDINAL; (* hms is low  *)
            d : CARDINAL; (* ymd is high *)
        | FALSE :
            dt : LONGCARD;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

(*
Year stored relative to 1980 (ex. 1988 stores as 8)
    year      month    day   

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number

Seconds are 0 to 29 -- DOS stores nearest even / 2
  hours    minutes   seconds 

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    DOSbaseyear  = 1980;
CONST
    yyMask=BITSET{9..15};    yyShft=9;
    moMask=BITSET{5..8};     moShft=5;
    ddMask=BITSET{0..4};     ddShft=0;
CONST
    hhMask=BITSET{11..15};   hhShft=11;
    miMask=BITSET{5..10};    miShft=5;
    ssMask=BITSET{0..4};     ssShft=0;

PROCEDURE unpackDate (ymd:CARDINAL;VAR y,m,d:CARDINAL);
BEGIN
    y :=  CARDINAL(BITSET(ymd) * yyMask) >> yyShft ;
    m :=  CARDINAL(BITSET(ymd) * moMask) >> moShft ;
    d :=  CARDINAL(BITSET(ymd) * ddMask) >> ddShft ;
    INC(y,DOSbaseyear);
END unpackDate;

PROCEDURE unpackTime (hms:CARDINAL;VAR h,m,s:CARDINAL);
BEGIN
    h :=  CARDINAL(BITSET(hms) * hhMask) >> hhShft ;
    m :=  CARDINAL(BITSET(hms) * miMask) >> miShft ;
    s :=  CARDINAL(BITSET(hms) * ssMask) >> ssShft ;
    s := s << 1; (* yes, yes, "* 2" works too... *)
END unpackTime;

PROCEDURE getfilestamp (VAR dmy:datetype; VAR hms:timetype;
                        refpath:pathtype);
VAR
    hnd:FIO.File;
    rc:BOOLEAN;     (* should be trapped but eh, we don't care *)
    stamp:dttype;
BEGIN
    hnd:=FIO.OpenRead(refpath);
    (*
    IF hnd = MAX(CARDINAL16) THEN (* not trapped by fileGetFileStamp() *)
        rc:=FALSE;
    ELSE
    *)
        stamp.dt:=FIO.GetFileDate(hnd);
        rc:=TRUE;
    (* END; *)
    FIO.Close(hnd);

    unpackDate(stamp.d , dmy.year  ,dmy.month  ,dmy.day );
    unpackTime(stamp.t , hms.hours ,hms.minutes,hms.seconds );
END getfilestamp;

PROCEDURE doProcStamp (VAR n:pathtype;
                       opPrefix:BOOLEAN;oldname:pathtype);
VAR
    stamp:LONGCARD;
    dmy:datetype;
    hms:timetype;
    Z:str16;  (* "yyyymmdd_hhmmss_" *)
BEGIN
    getfilestamp(dmy,hms,oldname);

    Z:="~~~_~~~";
    Str.Subst(Z,"~",using(dmy.year   ,4,"0"));
    Str.Subst(Z,"~",using(dmy.month  ,2,"0"));
    Str.Subst(Z,"~",using(dmy.day    ,2,"0"));
    Str.Subst(Z,"~",using(hms.hours  ,2,"0"));
    Str.Subst(Z,"~",using(hms.minutes,2,"0"));
    Str.Subst(Z,"~",using(hms.seconds,2,"0"));

    IF opPrefix THEN
        Str.Prepend(n,"_"); Str.Prepend(n,Z);
    ELSE
        Str.Append(n,"_");  Str.Append(n,Z);
    END;
END doProcStamp;

(* ------------------------------------------------------------ *)

PROCEDURE doFix (VAR messages:CARDINAL; VAR newname:pathtype;
                 oldname,base:pathtype;
                 procext,safetybatch,prefixrenum,
                 overwrite,finduniquetarget,chkvalidchar,DEBUG : BOOLEAN;
                 op:cmdtype;colpos,shortenmode:CARDINAL;
                 str,str2:pathtype):BOOLEAN;
VAR
    u,d,n,e,S1,S2,newn,tmpn:pathtype;
    p,len,count:CARDINAL;
    wecandoit:BOOLEAN;
BEGIN
    IF DEBUG THEN
        WrStr("; OLD : ");WrHexStr(TRUE ,oldname);WrLn;
        WrStr("; OLD : ");WrHexStr(FALSE,oldname);WrLn;
    END;
    IF DEBUG THEN WrStr("; old : ");WrQ(oldname);WrLn; END;
    qdSplitAllPath(oldname,u,d,n,e);

    wecandoit:=TRUE; (* let's be optimistic *)

    CASE op OF
    | prefix,prefixautonum :
        Str.Prepend(n,str);
    | suffix,suffixautonum :
        Str.Append(n,str);
    | prefixkill:
        count:=Str.Length(str);
        Str.Slice(S1,n,0,count);
        Str.Copy(S2,str);
        UpperCase(S1);
        UpperCase(S2);
        IF same(S1,S2) THEN
            Str.Delete(n,0,count);
        ELSE
            wecandoit:=FALSE;
        END;
    | suffixkill:
        count:=Str.Length(str);
        len  :=Str.Length(n);
        IF len < count THEN
            wecandoit:=FALSE;
        ELSE
            Str.Slice(S1,n,len-count,count);
            Str.Copy(S2,str);
            UpperCase(S1);
            UpperCase(S2);
            wecandoit:= same(S1,S2);
            IF wecandoit THEN
                Str.Delete(n,len-count,count);
            END;
        END;
    | remove :
        wecandoit:=doClean(n,e, procext,str);
    | remap :
        wecandoit:=doRemap(n,e, procext,str,str2);
    | infix:
        Str.Insert(n,str,colpos); (* don't bother to check *)
    | infixkill:
        count:=Str.Length(str);
        Str.Slice(S1,n,colpos,count);
        Str.Copy(S2,str);
        UpperCase(S1);
        UpperCase(S2);
        wecandoit:=same(S1,S2);
        IF wecandoit THEN
            Str.Delete(n,colpos,count);
        END;
    | renum:
        IF prefixrenum THEN
            Str.Prepend(n,str);
        ELSE
            Str.Copy(n,str); (* str is renumbered name *)
        END;
    | strlowercase, struppercase:
        wecandoit:=doCasify( n,e, op,procext);
    | trimname:
        wecandoit:=doTrimName(n,e, procext);
    | substringkill:
        wecandoit:=doSubst(n,e, procext,str,"");
    | substringreplace:
        wecandoit:=doSubst(n,e, procext,str,str2);
    | prefixstamp:
        doProcStamp(n,  TRUE, oldname); (* useLFN is TRUE here *)
    | suffixstamp:
        doProcStamp(n,  FALSE,oldname); (* useLFN is TRUE here *)
    | lenprefixkill:
        count:=Str.Length(str);
        Str.Delete(n,0,count);
    | lensuffixkill:
        count:=Str.Length(str);
        len  :=Str.Length(n);
        IF len < count THEN
            wecandoit:=FALSE;
        ELSE
            Str.Delete(n,len-count,count);
        END;
    | leninfixkill:
        count:=Str.Length(str);
        Str.Delete(n,colpos,count);
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF wecandoit THEN
        wecandoit:=chknewlen(messages,procext,DEBUG, oldname,n,e);
    END;

    IF same(e,"") THEN Str.Copy(e,dot);END; (* //V12o fix *)

    Lib.MakeAllPath(newname,"","",n,e);

    IF safetybatch THEN
        Str.Copy(S1,newname);
        UpperCase(S1);
        IF same(S1,UNDOBATCH) THEN wecandoit:=FALSE;END;
    END;
    IF DEBUG THEN WrStr("; new : ");WrQ(newname);WrLn; END;
    RETURN wecandoit;
END doFix;

PROCEDURE buildUndo (VAR R:ARRAY OF CHAR;
                    base,oldname,newname:pathtype );
CONST
    cliren = "REN "+placeholder+" "+placeholder;
VAR
    S:str1024; (* oversized *)
    u,d,n,e,id:pathtype;
BEGIN
    Str.Copy(S,cliren);

    qdSplitAllPath(newname,u,d,n,e);
    Lib.MakeAllPath(id,"","",n,e);
    Str.Prepend(id,base);
    Str.Subst(S,placeholder,dquote+placeholder+dquote);
    Str.Subst(S,placeholder,id);

    qdSplitAllPath(oldname,u,d,n,e);
    Lib.MakeAllPath(id,"","",n,e);
    Str.Subst(S,placeholder,dquote+placeholder+dquote);
    Str.Subst(S,placeholder,id);
    Str.Copy(R,S);
END buildUndo;

PROCEDURE isCmdCasify (op:cmdtype):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    CASE op OF
    | strlowercase,struppercase:
        rc:=TRUE;
    ELSE
        rc:=FALSE;
    END;
    RETURN rc;
END isCmdCasify;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWaitSort = "Sorting data, please wait...";
CONST
    firstparm = 1;
    maxparm   = 3;
VAR
    parm : ARRAY [firstparm..maxparm] OF pathtype;
VAR
    testmode,overwrite,kill:BOOLEAN;
    processAll,procext,safetybatch,chkvalidchar:BOOLEAN;
    userenumprefix,prefixrenum,finduniquetarget,allowRenToSame:BOOLEAN;
    shortenmode:CARDINAL;
    cmd:cmdtype;
    sort:sorttype;
VAR
    parmcount,i,opt:CARDINAL;
    S,R,spec,base,str,mapstr,oldname,newname, oldstr,newstr:pathtype;
    lastparm,lastEntry,messages,colpos,fieldwidth,v:CARDINAL;
    DEBUG,allowed,existed,wecandoit:BOOLEAN;
    lc,currnum,rendelta:LONGCARD;
    hout:FIO.File;
    hugestr:str1024; (* oversized for LFNs *)
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    Str.Copy(mapstr,"");   (* default safety *)
    colpos:=MAX(CARDINAL); (* suffix *)

    cmd               := nada;
    sort              := nosort;
    fieldwidth        := DEFFIELD;
    rendelta          := DEFDELTA;
    currnum           := 1; (* default for "-s *" and "-p *" syntaxes *)
    testmode          := TRUE;
    safetybatch       := FALSE;
    kill              := FALSE;
    overwrite         := FALSE;
    processAll        := FALSE;
    procext           := FALSE;
    userenumprefix    := TRUE;
    prefixrenum       :=FALSE;
    chkvalidchar      := TRUE;
    shortenmode       := shortennormal;
    finduniquetarget  := FALSE;
    allowRenToSame    := FALSE;
    DEBUG             := FALSE;
    lastparm          := firstparm-1;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOptionForReal(R) THEN (* only handle "-" alone *)
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "P"+delim+"PREFIX"+delim+
                                   "S"+delim+"SUFFIX"+delim+
                                   "D"+delim+"DELETE"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "R"+delim+"RENAME"+delim+
                                   "l"+delim+"lfn"+delim+
                                   "PP"+delim+
                                   "SS"+delim+
                                   "A"+delim+"ALL"+delim+
                                   "E"+delim+"EXTENSION"+delim+
                                   "I:"+delim+"INFIX:"+delim+
                                   "II:"+delim+
                                   "N"+delim+"RENUM"+delim+
                                   "F:"+delim+"FIELD:"+delim+
                                   "SN"+delim+
                                   "SE"+delim+
                                   "RR"+delim+
                                   "K:"+delim+
                                   "DP"+delim+
                                   "DS"+delim+
                                   "Z"+delim+"ZAP"+delim+
                                   "C"+delim+"CHANGE"+delim+"REPLACE"+delim+
                                   "LC"+delim+"LOWERCASE"+delim+"LOWS"+delim+
                                   "UC"+delim+"UPPERCASE"+delim+"CAPS"+delim+
                                   "F"+delim+"FILTER"+delim+
                                   "M"+delim+"REMAP"+delim+
                                   "lcc"+delim+
                                   "ucc"+delim+
                                   "SZ"+delim+
                                   "NN"+delim+
                                   "X"+delim+"PREFIXRENUM"+delim+
                                   "SD"+delim+
                                   "V"+delim+"VALIDITY"+delim+
                                   "lcf"+delim+"lcfr"+delim+
                                   "ucf"+delim+"ucfg"+delim+
                                   "az"+delim+"asciionly"+delim+
                                   "??"+delim+
                                   "DEBUG"+delim+

                                   "t1"+delim+"t"+delim+"truncate"+delim+
                                   "t2"+delim+"tt"+delim+
                                   "t3"+delim+"ttt"+delim+

                                   "t5"+delim+"ttttt"+delim+
                                   "t6"+delim+"tttttt"+delim+
                                   "t7"+delim+"ttttttt"+delim+

                                   "B"+delim+"PREFIXSTAMP"+delim+
                                   "J"+delim+"SUFFIXSTAMP"+delim+

                                   "t4"+delim+"tttt"+delim+
                                   "t8"+delim+"tttttttt"+delim+
                                   "Y"+delim+"FINDUNIQUETARGET"+delim+"U"+delim+"UNIQUE"+delim+
                                   "PPP"+delim+
                                   "SSS"+delim+
                                   "III:"+delim+

                                   "SN-"+delim+
                                   "SE-"+delim+
                                   "SZ-"+delim+
                                   "SD-"+delim+
                                   "TRIM"+delim+"BLANKS"+delim+
				   "I"+delim+"IDEM"+delim+"RENTOSAME"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5   : IF chkcmd(cmd,prefix)=FALSE THEN abort(errCmdConflict,"");END;
            | 6,7   : IF chkcmd(cmd,suffix)=FALSE THEN abort(errCmdConflict,"");END;
            | 8,9   : kill:=TRUE;
            | 10,11 : overwrite:=TRUE;
            | 12,13 : testmode:=FALSE;
            | 14,15 : ;
            | 16    : IF chkcmd(cmd,prefixkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 17    : IF chkcmd(cmd,suffixkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 18,19 : processAll:=TRUE;
            | 20,21 : procext:=TRUE;
            | 22,23 : IF chkcmd(cmd,infix)=FALSE THEN abort(errCmdConflict,"");END;
                      IF GetLongCard(R,lc)=FALSE THEN abort(errBadVal,S);END;
                      IF chkRange(colpos,lc,0,MAX(CARDINAL))=FALSE THEN abort(errRange,S);END;
            | 24    : IF chkcmd(cmd,infixkill)=FALSE THEN abort(errCmdConflict,"");END;
                      IF GetLongCard(R,lc)=FALSE THEN abort(errBadVal,S);END;
                      IF chkRange(colpos,lc,0,MAX(CARDINAL))=FALSE THEN abort(errRange,S);END;
            | 25,26 : IF chkcmd(cmd,renum)=FALSE THEN abort(errCmdConflict,"");END;
            | 27,28 : IF GetLongCard(R,lc)=FALSE THEN abort(errBadVal,S);END;
                      IF chkRange(fieldwidth,lc,MINFIELD,MAXFIELD)=FALSE THEN abort(errRange,S);END;
            | 29    : IF chksort(sort,byname)=FALSE THEN abort(errSortConflict,"");END;
            | 30    : IF chksort(sort,byextension)=FALSE THEN abort(errSortConflict,"");END;
            | 31    : testmode:=FALSE; safetybatch:=TRUE;
            | 32    : IF GetLongCard(R,rendelta)=FALSE THEN abort(errBadVal,S);END;
                      IF chkRange(v,rendelta,MINDELTA,MAXDELTA)=FALSE THEN abort(errRange,S);END;
            | 33    : IF chkcmd(cmd,prefixkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 34    : IF chkcmd(cmd,suffixkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 35,36 : IF chkcmd(cmd,substringkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 37,38,39: IF chkcmd(cmd,substringreplace)=FALSE THEN abort(errCmdConflict,"");END;
            | 40,41,42: IF chkcmd(cmd,strlowercase)=FALSE THEN abort(errCmdConflict,"");END;
            | 43,44,45: IF chkcmd(cmd,struppercase)=FALSE THEN abort(errCmdConflict,"");END;
            | 46,47 : IF chkcmd(cmd,remove)=FALSE THEN abort(errCmdConflict,"");END;
            | 48,49 : IF chkcmd(cmd,remap)=FALSE THEN abort(errCmdConflict,"");END;
            | 50    : ;
            | 51    : ;
            | 52    : IF chksort(sort,bysize)=FALSE THEN abort(errSortConflict,"");END;
            | 53    : IF chkcmd(cmd,renum)=FALSE THEN abort(errCmdConflict,"");END;
                      userenumprefix := FALSE;
            | 54,55 : prefixrenum := TRUE;
            | 56    : IF chksort(sort,bystamp)=FALSE THEN abort(errSortConflict,"");END;
            | 57,58 : chkvalidchar := FALSE;
            | 59,60 : ;
            | 61,62 : ;
            | 63,64 : ;
            | 65    : abort(errMoreHelp,"");
            | 66    : DEBUG := TRUE;

            | 67,68,69 : ;
            | 70,71 : ;
            | 72,73 :  ;

            | 74,75 : ;
            | 76,77 : ;
            | 78,79 : ;

            | 80,81 : IF chkcmd(cmd,prefixstamp)=FALSE THEN abort(errCmdConflict,"");END;
            | 82,83 : IF chkcmd(cmd,suffixstamp)=FALSE THEN abort(errCmdConflict,"");END;

            | 84,85 : ;
            | 86,87 : ;
            | 88,89,90,91 : finduniquetarget:=TRUE;
            | 92    : IF chkcmd(cmd,lenprefixkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 93    : IF chkcmd(cmd,lensuffixkill)=FALSE THEN abort(errCmdConflict,"");END;
            | 94    : IF chkcmd(cmd,leninfixkill)=FALSE THEN abort(errCmdConflict,"");END;
                      IF GetLongCard(R,lc)=FALSE THEN abort(errBadVal,S);END;
                      IF chkRange(colpos,lc,0,MAX(CARDINAL))=FALSE THEN abort(errRange,S);END;

            | 95    : IF chksort(sort,bynameINV)=FALSE THEN abort(errSortConflict,"");END;
            | 96    : IF chksort(sort,byextensionINV)=FALSE THEN abort(errSortConflict,"");END;
            | 97    : IF chksort(sort,bysizeINV)=FALSE THEN abort(errSortConflict,"");END;
            | 98    : IF chksort(sort,bystampINV)=FALSE THEN abort(errSortConflict,"");END;
            | 99,100: IF chkcmd(cmd,trimname)=FALSE THEN abort(errCmdConflict,"");END;
	    |101,102,103:allowRenToSame:=TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,S); END;
	        Str.Copy(parm[lastparm],S); (* keep original case *)
        END;
    END;

    (* useLFN:=( useLFN AND w9XsupportLFN() ); *)

    IF kill THEN
        CASE cmd OF
        | prefix: cmd:=prefixkill;
        | suffix: cmd:=suffixkill;
        | infix : cmd:=infixkill;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    (* we don't try too hard to protect user from himself ! ;-) *)
    (* //12M allow procext for substringreplace , substringkill , remove *)

    CASE lastparm OF
    | 0 : abort(errSyntax,"");
    | 1 : CASE cmd OF
          | strlowercase,struppercase,
            prefixstamp,suffixstamp,trimname :
              (* IF NOT(useLFN) THEN abort(errLFNonly,"");END; *)
              IF kill THEN abort(errNonsense,"-d");END;
          ELSE
              abort(errSyntax,"");
          END;
    | 2 : CASE cmd OF
          | prefix,suffix,infix,
            prefixkill,suffixkill,infixkill,
            lenprefixkill,lensuffixkill,leninfixkill:
              IF procext THEN abort(errNonsense,"-e");END;
          | substringkill: ;
          | nada,remove:
              cmd:=remove;
          ELSE
              abort(errSyntax,""); (* strlowercase struppercase remap renum substringreplace *)
          END;
    | 3 : CASE cmd OF
          | renum:
              IF kill THEN abort(errNonsense,"-d");END;
              IF procext THEN abort(errNonsense,"-e");END;
          | nada, remap:
              IF kill THEN abort(errNonsense,"-d");END;
              cmd:=remap;
          | substringreplace:
              IF kill THEN abort(errNonsense,"-d");END;
          ELSE
              abort(errSyntax,"");
          END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | prefix,prefixkill,lenprefixkill:
        Str.Copy(str    ,parm[firstparm]);
        Str.Copy(spec   ,parm[firstparm+1]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF same(str,autonummarker) THEN
            CASE cmd OF
            | prefixkill    : abort(errNonsense,"-pp");
            | lenprefixkill : abort(errNonsense,"-ppp"); (* could be allowed *)
            ELSE ; (* //ISO fixed silly requirement *) END;
            cmd:=prefixautonum;
        ELSE
            IF chkValid(FALSE,chkvalidchar,str,base)=FALSE THEN abort(errBadPrefix,str);END;
        END;
    | suffix,suffixkill,lensuffixkill:
        Str.Copy(str    ,parm[firstparm]);
        Str.Copy(spec   ,parm[firstparm+1]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF same(str,autonummarker) THEN
            CASE cmd OF
            | suffixkill    : abort(errNonsense,"-ss");
            | lensuffixkill : abort(errNonsense,"-sss"); (* could be allowed *)
            ELSE ; (* //ISO fixed silly requirement *) END;
            cmd:=suffixautonum;
        ELSE
            IF chkValid(FALSE,chkvalidchar,str,base)=FALSE THEN abort(errBadSuffix,str);END;
        END;
    | remove:
        Str.Copy(str    ,parm[firstparm]);
        Str.Copy(spec   ,parm[firstparm+1]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF chkChars(TRUE,str)=FALSE THEN abort(errBadChar,str);END;
    | remap:
        Str.Copy(str    ,parm[firstparm]);
        Str.Copy(mapstr ,parm[firstparm+1]);
        Str.Copy(spec   ,parm[firstparm+2]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF metaproc(mapstr)=FALSE THEN abort(errBadMeta,mapstr);END;
        IF Str.Length(str) # Str.Length(mapstr) THEN abort(errBadRemap,"");END;
        IF chkChars(FALSE,str)=FALSE THEN abort(errBadChar,str);END;
        IF chkChars(FALSE,mapstr)=FALSE THEN abort(errBadChar,mapstr);END;
        Str.Copy(S,str);
        Str.Copy(R,mapstr);
        UpperCase(S);
        UpperCase(R);
        FOR i:=1 TO Str.Length(S) DO
            IF str[i-1] = mapstr[i-1] THEN abort(errRemapNonsense,"");END;
        END;
    | infix,infixkill,leninfixkill:
        Str.Copy(str    ,parm[firstparm]);
        Str.Copy(spec   ,parm[firstparm+1]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF chkValid(FALSE,chkvalidchar,str,base)=FALSE THEN abort(errBadInfix,str);END; (* could be allowed FOR leninfixkill *)
    | renum:
        Str.Copy(mapstr ,parm[firstparm]);   (* prefix *)
        Str.Copy(S      ,parm[firstparm+1]); (* first number *)
        Str.Copy(spec   ,parm[firstparm+2]);
        IF userenumprefix THEN
            IF same(mapstr,ignoredrenumprefix) THEN
                userenumprefix:=FALSE;
            ELSE
                IF metaproc(mapstr)=FALSE THEN abort(errBadMeta,mapstr);END;
                IF chkChars(FALSE,mapstr)=FALSE THEN abort(errBadChar,mapstr);END;
            END;
        END;
        IF NOT(userenumprefix) THEN mapstr:="";END;
        Str.Concat(R,"-FIX:",S); (* fake option *)
        IF GetLongCard(R,currnum)=FALSE THEN abort(errBadVal,S);END;
    | substringkill:
        Str.Copy(str    ,parm[firstparm]);
        Str.Copy(spec   ,parm[firstparm+1]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF chkValid(FALSE,chkvalidchar,str,base)=FALSE THEN abort(errBadSubstring,str);END;
    | strlowercase,struppercase,
      prefixstamp, suffixstamp, trimname:
        Str.Copy(spec   ,parm[firstparm]);
    | substringreplace :
        Str.Copy(str    ,parm[firstparm]);    (* oldsubstring *)
        Str.Copy(mapstr ,parm[firstparm+1]);  (* newsubstring *)
        Str.Copy(spec   ,parm[firstparm+2]);
        IF metaproc(str)=FALSE THEN abort(errBadMeta,str);END;
        IF metaproc(mapstr)=FALSE THEN abort(errBadMeta,mapstr);END;
        IF chkValid(FALSE,chkvalidchar,str,base)=FALSE THEN abort(errBadSubstring,str);END;
        IF chkValid(FALSE,chkvalidchar,mapstr,base)=FALSE THEN abort(errBadSubstring,mapstr);END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF same(spec,dot) THEN spec:=stardotstar;END;
    IF chkValid(TRUE ,chkvalidchar,spec,base)=FALSE THEN abort(errBadSpec,spec);END;
dbgstr(DEBUG,"spec",spec);
    IF chkJoker(spec)=FALSE THEN
        IF isDirectory(spec) THEN abort(errDirectory,spec);END;
    END;

    initList(anchorSpec,lastEntry);
    i:= buildMatchList(anchorSpec,processAll,spec);
    IF i=MAX(CARDINAL) THEN abort(errStorage,""); END;
    INC(lastEntry,i);
    IF lastEntry < firstEntry THEN abort(errNoMatch,spec);END;
    initIndexes(anchorSpec);

    IF safetybatch THEN
        FOR i:=firstEntry TO lastEntry DO
            getEntry(S,i,anchorSpec);
            UpperCase(S);
            IF same(S,UNDOBATCH) THEN abort(errWontProcess,"");END;
        END;
        hout:=FIO.Create(UNDOBATCH);
        FIO.AssignBuffer(hout,ioBufferOut);
        FIO.WrStr(hout,"@ECHO ON");FIO.WrLn(hout);
        FIO.WrStr(hout,"PAUSE Hit Ctrl-C or Ctrl-Break to abort !");FIO.WrLn(hout);
    END;

    CASE cmd OF
    | renum, suffixautonum,prefixautonum:
        Str.Copy(S,padnum(currnum,fieldwidth)); (* currnum defaults to 1 at start *)
        lc:=currnum+rendelta*LONGCARD(lastEntry-1);
        Str.Copy(R,padnum(lc,fieldwidth));
        IF Str.Length(S) # Str.Length(R) THEN abort(errFieldWidth,"");END;

        IF sort # nosort THEN video(msgWaitSort,TRUE);END;
        CASE sort OF
        | byname      : Lib.QSort(lastEntry,dolessname, doswap);
        | byextension : Lib.QSort(lastEntry,dolessext , doswap);
        | bysize      : Lib.QSort(lastEntry,dolesssize, doswap);
        | bystamp     : Lib.QSort(lastEntry,dolessstamp,doswap);
        | bynameINV   : Lib.QSort(lastEntry,dolessnameINV, doswap);
        | byextensionINV: Lib.QSort(lastEntry,dolessextINV , doswap);
        | bysizeINV   : Lib.QSort(lastEntry,dolesssizeINV, doswap);
        | bystampINV  : Lib.QSort(lastEntry,dolessstampINV,doswap);
        ELSE
            ;
        END;
        IF sort # nosort THEN video(msgWaitSort,FALSE);END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    (*
    WrStr(Banner);WrLn;
    WrLn;
    *)

    messages:=0;
    FOR i := firstEntry TO lastEntry DO
        getEntry(S,i,anchorSpec);
        Str.Concat(oldname,base,S);
        Str.Copy(newname,S);
        CASE cmd OF
        | renum :
            IF prefixrenum THEN
                Str.Concat(str,padnum(currnum,fieldwidth),mapstr);
            ELSE
                Str.Concat(str,mapstr,padnum(currnum,fieldwidth));
            END;
            INC(currnum,rendelta);
        | suffixautonum:
            Str.Concat(str,autonumsep,padnum(currnum,fieldwidth));
            INC(currnum,rendelta);
        | prefixautonum:
            Str.Concat(str,padnum(currnum,fieldwidth),autonumsep);
            INC(currnum,rendelta);
        ELSE ; (* //ISO fixed silly requirement *) END;
        wecandoit := doFix (messages,newname, oldname,base,
                           procext,safetybatch,prefixrenum,
                           overwrite,finduniquetarget,chkvalidchar,DEBUG,
                           cmd,colpos,shortenmode,str,mapstr);
        IF wecandoit THEN
            Str.Prepend(newname,base);
            allowed:=TRUE;
            existed:=FALSE;
            IF FIO.Exists(newname) THEN
                IF overwrite THEN
                    IF testmode=FALSE THEN
                        (* prior TO //V13D
                        IF isCmdCasify(cmd)=FALSE THEN
                            fileSetRW(oldname); (* safety *)
                        ELSE
                            killfile(overwrite,oldname); (* erase readonly too *)
                            existed:=TRUE;
                        END;
                        *)
                        IF isCmdCasify(cmd)=FALSE THEN
                            killfile(overwrite,oldname); (* erase readonly too *)
                        ELSE
                            fileSetRW(oldname); (* safety *)
                        END;
                        existed:=TRUE;
                    END;
                ELSE
                    IF isCmdCasify(cmd)=FALSE THEN (* LFN agrees to rename changing case *)
		        IF NOT(allowRenToSame) THEN
                            msg2(TRUE,msgAlready,oldname,newname);
                            allowed:=FALSE;
                            INC(messages);
			END;
                    END;
                END;
            END;
            IF allowed THEN
                IF testmode THEN
                    msg2(FALSE,msgWouldBe,oldname,newname);
                    IF existed THEN WrStr(msgFileExists);END;
                    WrLn;
                    INC(messages);
                ELSE
                    IF NOT (same (oldname, newname)) THEN
                        FIO.Rename(oldname,newname);
                    END;
                    msg2(FALSE,msgIsNow,oldname,newname);
                    IF existed THEN WrStr(msgFileExisted);END;
                    WrLn;
                    INC(messages);

                    IF safetybatch THEN
                        buildUndo(hugestr,base,oldname,newname);
                        FIO.WrStr(hout,hugestr);FIO.WrLn(hout);
                    END;
                END;
            END;
        END;
    END;
    IF messages=0 THEN WrStr("::: Nothing to do !");WrLn; END;

    IF safetybatch THEN
        FIO.Close(hout);
        WrLn;WrStr("::: "+UNDOBATCH+" has been created.");WrLn;
    END;

    freeMatchList(anchorSpec);

    abort(errNone,"");
END NewName32.


