(* ---------------------------------------------------------------
Title         Q&D Test ISAAC
Overview      see help
Usage         see help
Notes         an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !


              see XDS, //XDSTS and //FIXME

	      //IMPORTANT : make sure -coverflow and -ioverflow are in project file !!!

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

              a port of READABLE.C by Bob Jenkins
              with a bugfix and a few enhancements for testing this PRNG

              CCOUNT can help checking binary data

              never had this (not very informative) error before :
              "make error : more than one source for filename"
              in fact, it happens if compiler directory contains
              a file matching exe with .a extension !
              (probably temporary files)
Bugs
Wish List     find a clever method to scale down to range [0..255]
              without losing randomness
              bresenham mapping ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 25 Nov 19 an ugly really Q&D port from TSTISAAC v0.9 for DOS
--------------------------------------------------------------- *)

MODULE tstIsaac;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM SYSTEM IMPORT BYTE, CARD16, CARD32; (* oh, joy... *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    methodABCD           = 1;
    methodDCBA           = 2;
    methodMOD255         = 3;
    methodMOD256         = 4;
    methodDIV1000000H    = 5;
    methodSHIFT24        = 6;
    methodDIVMAXLC256    = 7;
    methodDIVRANGE256    = 8;
    methodDIVMAXLC255    = 9;
    method32TO8          = 10;
CONST
    minMethod         = methodABCD;
    maxMethod         = method32TO8;
CONST
    roundsize         = 256*SIZE(LONGCARD); (* ISAACSTATESIZE*4 *)
CONST
    FMAXLC            = LONGREAL(MAX(LONGCARD));
    FMAXLCPLUS1       = LONGREAL(MAX(LONGCARD))+1.0;
    FMAXB             = LONGREAL(255); (* //XDS MAX(BYTE)); *)
    FMAXBPLUS1        = LONGREAL(256); (* //XDS MAX(BYTE))+1.0; *)
    DIV32TO8          = MAX(LONGCARD) DIV MAX(SHORTCARD);
CONST
    progEXEname      = "TSTISAAC32";
    progTitle        = "Q&D Test Bob Jenkins' I.S.A.A.C. (Win32)";
    progVersion      = "v0.9 (from v0.9 for DOS)";
    progCopyright    = "by PhG";
    progBanner       = progTitle+" "+progVersion+" "+progCopyright;

CONST
    errNone            = 0;
    errHelp            = 1;
    errOption          = 2;
    errTooManyParms    = 3;
    errBadCount        = 4;
    errJoker           = 5;
    errBase            = 6;
    errAdjusted        = 7;
    errExpecting       = 8;
    errSpecifiedPP     = 9;
    errPadNotApplicable= 10;
    errAborted         = 32;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
msgHelp =
progBanner+nl+
nl+
"Syntax 1 : "+progEXEname+nl+
"Syntax 2 : "+progEXEname+" <count> <basename> [passphrase] [option]..."+nl+
nl+
"This program is a slightly enhanced port of READABLE.C source code"+nl+
'created Bob "I.S.A.A.C." Jenkins who generously made his PRNG public domain.'+nl+
"Syntax 1 should output the same data as RANDVECT.TXT and Rosetta Stone example."+nl+
'Syntax 2 creates target files filled with <count> random values'+nl+
"(either LONGCARDs or BYTEs) so they can be compared using randomness tests"+nl+
"(each file is created with a different export method)."+nl+
nl+
"  -s do not seed generator from pool"+nl+
"  -p pad seed pool with repeated passphrase (default is to pad with $00 value)"+nl+
"  -x init seed pool with an array of LONGCARDs instead of a string"+nl+
"  -t create text files (default is to create binary files)"+nl+
"  -d show dice results"+nl+
"  -m show missing byte values"+nl+
nl+
"a) Syntax 1 ignores all options."+nl+
"b) With syntax 2, program can be aborted by pressing almost any key."+nl+
"   Note <count> will be adjusted to the nearest multiple of 1024."+nl+
"   Existing target files will be overwritten. <basename> cannot be a LFN."+nl+
"   Passphrase, if not specified, is a random string created by program ;"+nl+
"   -x option creates an array of LONGCARDs instead of a string."+nl+
"c) Here are syntax 2 experimental methods (here, abcd is 32 bit ISAAC random) :"+nl+
"     A = abcd"+nl+
"     B = dcba"+nl+
"     C = abcd MOD 255"+nl+
"     D = abcd MOD 256"+nl+
"     E = abcd DIV $1000000"+nl+
"     F = abcd right-shifted by 24"+nl+
"     G = LONGREAL(abcd) / LONGREAL(MAX(LONGCARD))*256"+nl+
"     H = LONGREAL(abcd) / LONGREAL(MAX(LONGCARD)+1)*256"+nl+
"     I = LONGREAL(abcd) / LONGREAL(MAX(LONGCARD))*255"+nl+
"     J = abcd DIV (MAX(LONGCARD) DIV MAX(SHORTCARD))"+nl+
"   Most methods are bad (C, I, J) and/or give same results (E=F=G=H, I=J)."+nl+
"   Check "+progEXEname+".MOD source code for more details."+nl+
"d) Note CCOUNT utility can be of some help analyzing binary data."+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errHelp :          WrStr(msgHelp);
    | errOption:         S := 'Unknown "~" option !';
    | errTooManyParms:   S := '"~" is one parameter too many !';
    | errBadCount:       S := 'Illegal "~" <count> !';
    | errJoker:          S := '"~" should not contain any joker !';
    | errBase:           S := '"~" should not contain an extension !';
    | errAdjusted:       S := 'Ajusted "~" <count> would become 0 !';
    | errExpecting:      S := "Expecting ~ !";
    | errSpecifiedPP:    S := "Passphrase and -x option are mutually exclusive !";
    | errPadNotApplicable:S:= "-p option is a nonsense with -x option !";
    | errAborted:        S := "Aborted by user !";
    ELSE
                         S := "This is illogical, Captain !";
    END;

    CASE e OF
    | errNone,errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    (* //XDS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE lcXOR (b1,b2 : CARD32) : CARD32;
TYPE
    lcBITSET = SET OF [0..31];
BEGIN
    RETURN CARD32 ( (lcBITSET (b1) / lcBITSET (b2)) );
END lcXOR;

PROCEDURE wXOR (b1,b2 : CARD16) : CARD16;
TYPE
    wBITSET = SET OF [0..15];
BEGIN
    RETURN CARD16 ( (wBITSET (b1) / wBITSET (b2)) );
END wXOR;

PROCEDURE fmtlc (v:LONGCARD;base,wi:CARDINAL;pad:CHAR;upper:BOOLEAN  ):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:=Str.Length(R)+1 TO wi DO Str.Prepend(R,pad);END;
    IF NOT(upper) THEN Str.Lows(R);END;
    RETURN R;
END fmtlc;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

MODULE isaac;

IMPORT lcXOR;
IMPORT Str;
IMPORT CARD32;
(* IMPORT fmtlc,WrStr; *)

EXPORT minisaacstate,maxisaacstate,
       initisaac,updateisaac,initisaacseedstr,initisaacseedval,
       getLCisaacrnd,getisaacpool,procisaacstate,
       DOzeroPOOL,DONOTzeroPOOL;

CONST
    ISAACSTATESIZE = 256;
    minisaacstate  = 0;
    maxisaacstate  = ISAACSTATESIZE-1;

TYPE
    isaacCTX = RECORD
         (* internal state *)
         isaacmem     : ARRAY [minisaacstate..maxisaacstate] OF CARD32;
         isaacAA,isaacBB,isaacCC:CARD32;
         (* external *)
         isaacpool    : ARRAY [minisaacstate..maxisaacstate] OF CARD32; (* ub4 in readable.c *)
         isaacpoolndx : CARDINAL; (* an index, in fact *)
    END;
VAR
    (* local globerks ! *)
    ctx        : isaacCTX;
    ctxbak     : isaacCTX;
    isaacsaved : BOOLEAN;

(* ------------------------------------------------------------ *)

PROCEDURE updateisaac();
VAR
    i,ndx:CARDINAL;
    x,y:CARD32;
BEGIN
    INC(ctx.isaacCC);        (* isaacCC just gets incremented once per 256 results *)
    INC(ctx.isaacBB,ctx.isaacCC);     (* then combined with isaacBB *)

    FOR i:=minisaacstate TO maxisaacstate DO
        x := ctx.isaacmem[i];
        CASE (i MOD 4) OF
        | 0: ctx.isaacAA := lcXOR(ctx.isaacAA, (ctx.isaacAA << 13) );
        | 1: ctx.isaacAA := lcXOR(ctx.isaacAA, (ctx.isaacAA >>  6) );
        | 2: ctx.isaacAA := lcXOR(ctx.isaacAA, (ctx.isaacAA <<  2) );
        | 3: ctx.isaacAA := lcXOR(ctx.isaacAA, (ctx.isaacAA >> 16) );
        ELSE ; (* //ISO fixed silly requirement *) END;
        ndx         := (i + 128) MOD ISAACSTATESIZE;
        ctx.isaacAA      := ctx.isaacmem[ ndx] + ctx.isaacAA;

        ndx         := CARDINAL ( (x >> 2) MOD ISAACSTATESIZE) ;
        y           := ctx.isaacmem[ ndx] + ctx.isaacAA + ctx.isaacBB;
        ctx.isaacmem[i]   := y;

        ndx         := CARDINAL ( (y >> 10) MOD ISAACSTATESIZE) ;
        ctx.isaacBB      := ctx.isaacmem[ ndx ] + x;
        ctx.isaacpool[i]  := ctx.isaacBB;
    END;
    ctx.isaacpoolndx := minisaacstate; (* reset index *)
END updateisaac;

(* ------------------------------------------------------------ *)

CONST
    DOzeroPOOL = TRUE;
    DONOTzeroPOOL= FALSE;

PROCEDURE initisaac(isaacseedfrompool,zeropool:BOOLEAN);
CONST
    magic = CARD32(9E3779B9H); (* the golden ratio *)
VAR
    i:CARDINAL;
    a,b,c,d,e,f,g,h:CARD32;
BEGIN
    ctx.isaacAA:=0;
    ctx.isaacBB:=0;
    ctx.isaacCC:=0;
    FOR i:=minisaacstate TO maxisaacstate DO
        ctx.isaacmem[i]  := 0;
        IF zeropool THEN (* DOzeroPOOL *)
            ctx.isaacpool[i]:=0;
        END;
    END;

    a:=magic;
    b:=magic;
    c:=magic;
    d:=magic;
    e:=magic;
    f:=magic;
    g:=magic;
    h:=magic;

    FOR i:=0 TO 3 DO (* scramble it *)
	(* mix *)
        a:=lcXOR(a,b<<11);   INC(d,a);   INC(b,c);
        b:=lcXOR(b,c>> 2);   INC(e,b);   INC(c,d);
        c:=lcXOR(c,d<< 8);   INC(f,c);   INC(d,e);
        d:=lcXOR(d,e>>16);   INC(g,d);   INC(e,f);
        e:=lcXOR(e,f<<10);   INC(h,e);   INC(f,g);
        f:=lcXOR(f,g>> 4);   INC(a,f);   INC(g,h);
        g:=lcXOR(g,h<< 8);   INC(b,g);   INC(h,a);
        h:=lcXOR(h,a>> 9);   INC(c,h);   INC(a,b);
    END;

    FOR i:=minisaacstate TO maxisaacstate BY 8 DO (* fill in isaacmem[] with messy stuff *)
        IF isaacseedfrompool THEN (* use all the information in the seed *)
            INC(a,ctx.isaacpool[i  ]);
            INC(b,ctx.isaacpool[i+1]);
            INC(c,ctx.isaacpool[i+2]);
            INC(d,ctx.isaacpool[i+3]);
            INC(e,ctx.isaacpool[i+4]);
            INC(f,ctx.isaacpool[i+5]);
            INC(g,ctx.isaacpool[i+6]);
            INC(h,ctx.isaacpool[i+7]);
        END;
        (* mix *)
        a:=lcXOR(a,b<<11);   INC(d,a);   INC(b,c);
        b:=lcXOR(b,c>> 2);   INC(e,b);   INC(c,d);
        c:=lcXOR(c,d<< 8);   INC(f,c);   INC(d,e);
        d:=lcXOR(d,e>>16);   INC(g,d);   INC(e,f);
        e:=lcXOR(e,f<<10);   INC(h,e);   INC(f,g);
        f:=lcXOR(f,g>> 4);   INC(a,f);   INC(g,h);
        g:=lcXOR(g,h<< 8);   INC(b,g);   INC(h,a);
        h:=lcXOR(h,a>> 9);   INC(c,h);   INC(a,b);

        ctx.isaacmem[i  ]:=a;
        ctx.isaacmem[i+1]:=b;
        ctx.isaacmem[i+2]:=c;
        ctx.isaacmem[i+3]:=d;
        ctx.isaacmem[i+4]:=e;
        ctx.isaacmem[i+5]:=f;
        ctx.isaacmem[i+6]:=g;
        ctx.isaacmem[i+7]:=h;
    END;

    IF isaacseedfrompool THEN
        (* do a second pass to make all of the seed affect all of isaacmem *)
        FOR i:=minisaacstate TO maxisaacstate BY 8 DO
            INC(a,ctx.isaacmem[i  ]);
            INC(b,ctx.isaacmem[i+1]);
            INC(c,ctx.isaacmem[i+2]);
            INC(d,ctx.isaacmem[i+3]);
            INC(e,ctx.isaacmem[i+4]);
            INC(f,ctx.isaacmem[i+5]);
            INC(g,ctx.isaacmem[i+6]);
            INC(h,ctx.isaacmem[i+7]);

            (* mix *)
            a:=lcXOR(a,b<<11);   INC(d,a);   INC(b,c);
            b:=lcXOR(b,c>> 2);   INC(e,b);   INC(c,d);
            c:=lcXOR(c,d<< 8);   INC(f,c);   INC(d,e);
            d:=lcXOR(d,e>>16);   INC(g,d);   INC(e,f);
            e:=lcXOR(e,f<<10);   INC(h,e);   INC(f,g);
            f:=lcXOR(f,g>> 4);   INC(a,f);   INC(g,h);
            g:=lcXOR(g,h<< 8);   INC(b,g);   INC(h,a);
            h:=lcXOR(h,a>> 9);   INC(c,h);   INC(a,b);

            ctx.isaacmem[i  ]:=a;
            ctx.isaacmem[i+1]:=b;
            ctx.isaacmem[i+2]:=c;
            ctx.isaacmem[i+3]:=d;
            ctx.isaacmem[i+4]:=e;
            ctx.isaacmem[i+5]:=f;
            ctx.isaacmem[i+6]:=g;
            ctx.isaacmem[i+7]:=h;
        END;
    END;

    updateisaac(); (* isaacpoolndx autohandled *)
END initisaac;

PROCEDURE getLCisaacrnd():CARD32;
VAR
    v:LONGCARD;
BEGIN
    v:= ctx.isaacpool[ctx.isaacpoolndx];
    INC(ctx.isaacpoolndx);
    IF ctx.isaacpoolndx > maxisaacstate THEN updateisaac(); END; (* isaacpoolndx autohandled *)
    RETURN v;
END getLCisaacrnd;

PROCEDURE getisaacpool (i:CARDINAL):CARD32;
BEGIN
    RETURN ctx.isaacpool[i];
END getisaacpool;

PROCEDURE initisaacseedstr (isaacseedfrompool,padwithPP:BOOLEAN; PP:ARRAY OF CHAR);
VAR
    i,p,len:CARDINAL;
    v:CARD32;
BEGIN
    initisaac(isaacseedfrompool,DOzeroPOOL);

    (* we could pack string 4 chars BY 4 chars too faking 32 bit values *)

    len:=Str.Length(PP);
    p:=minisaacstate;
    i:=1-1;
    LOOP
        IF i < len THEN
            v:=CARD32( ORD(PP[i]) );
            INC(i);
        ELSE
            IF padwithPP THEN
                i:=1-1;
                v:=CARD32( ORD(PP[i] ) );
                INC(i);
            ELSE
                v:=0; (* Rosetta code does so *)
            END;
        END;
        ctx.isaacpool[p]:=v;
        (* WrStr(fmtlc(v,16,8,"0",FALSE)); *)
        INC(p);
        IF p > maxisaacstate THEN EXIT; END;
    END;

    initisaac(isaacseedfrompool,DONOTzeroPOOL);
END initisaacseedstr;

PROCEDURE initisaacseedval (isaacseedfrompool:BOOLEAN; PP:ARRAY OF CARD32);
VAR
    i,p,len:CARDINAL;
    v:CARD32;
BEGIN
    initisaac(isaacseedfrompool,DOzeroPOOL);

    (* we could pack string 4 chars BY 4 chars too faking 32 bit values *)

    FOR i:= minisaacstate TO maxisaacstate DO
        v:=PP[i];
        ctx.isaacpool[p]:=v;
        (* WrStr(fmtlc(v,16,8,"0",FALSE)); *)
    END;

    initisaac(isaacseedfrompool,DONOTzeroPOOL);
END initisaacseedval;

PROCEDURE procisaacstate ( saveit:BOOLEAN  );
BEGIN
    IF saveit THEN
        ctxbak := ctx;
        isaacsaved := TRUE;
    ELSE
        IF isaacsaved THEN ctx := ctxbak; END;
    END;
END procisaacstate;

BEGIN
     isaacsaved:=FALSE;
END isaac;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fwrLC (h:FIO.File;binexport:BOOLEAN;v:LONGCARD );
CONST
    wilc = 10;
BEGIN
    IF binexport THEN
        FIO.WrBin(h,v,SIZE(LONGCARD));
    ELSE
        FIO.WrLngCard(h,v,wilc);FIO.WrLn(h);
        (* FIO.WrLngHex(h,v,wilc);FIO.WrLn(h); *)
    END;
END fwrLC;

PROCEDURE fwrB (h:FIO.File;binexport:BOOLEAN;v:LONGCARD );
CONST
    wib = 3;
BEGIN
    IF binexport THEN
        FIO.WrBin(h,SHORTCARD(v),SIZE(SHORTCARD));
    ELSE
        FIO.WrShtCard(h,SHORTCARD(v),wib);FIO.WrLn(h);
        (* FIO.WrShtHex(h,SHORTCARD(v),wib);FIO.WrLn(h); *)
    END;
END fwrB;

PROCEDURE getrandchar():CARDINAL;
BEGIN
    RETURN CARDINAL( getLCisaacrnd() MOD 95 + ORD(" ") ); (* from space TO underscore *)
END getrandchar;

PROCEDURE vernam(VAR R:ARRAY OF CHAR;S:ARRAY OF CHAR);
VAR
    i,code,v: CARDINAL;
BEGIN
    Str.Copy(R,"");
    FOR i := 1 TO Str.Length(S) DO
        code:=ORD(S[i-1]);
        v:=wXOR(code,getrandchar());
        Str.Append(R,CHR(v));
    END;
END vernam;

PROCEDURE dmphex (S:ARRAY OF CHAR );
VAR
    i,v:CARDINAL ;
BEGIN
    FOR i:=1 TO Str.Length(S) DO
        v:=ORD(S[i-1]);
        WrStr( fmtlc (LONGCARD(v),16,2,"0",FALSE));
    END;
END dmphex;

PROCEDURE wr (quoted:BOOLEAN; S:ARRAY OF CHAR);
BEGIN
    IF quoted THEN WrStr(dquote);END;
    WrStr(S);
    IF quoted THEN WrStr(dquote);END;
END wr;

PROCEDURE chkdmp (DEBUG:BOOLEAN;lines:CARDINAL):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    IF DEBUG THEN
        rc:=TRUE;
    ELSE
        CASE lines OF
        | 1,2   : rc:=TRUE; (* 2*256 entries, 8 entries per line *)
        | 63,64 : rc:=TRUE; (* 512 DIV 8 = 64 *)
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN rc;
END chkdmp;

PROCEDURE dmpbool (tf:BOOLEAN;S,strYes,strNo:ARRAY OF CHAR);
BEGIN
    WrStr(S);
    IF tf THEN
        WrStr(strYes);
    ELSE
        WrStr(strNo);
    END;
    WrLn;
END dmpbool;

PROCEDURE dmpcard (v:LONGCARD;S:ARRAY OF CHAR );
BEGIN
    WrStr(S);WrStr(fmtlc(v,10,10," ",FALSE));WrLn;
END dmpcard;

(* ------------------------------------------------------------ *)

PROCEDURE genPP (VAR S : str256 );
VAR
    i: CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    Str.Copy(S,"");
    FOR i:=minisaacstate TO maxisaacstate DO
        (* avoid chr(0) : 1+ [0..254] i= [1..255] *)
        Str.Append(S,CHR( 1+Lib.RANDOM(255-1) ) );
    END;
END genPP;

PROCEDURE genPPLC (VAR PP : ARRAY OF LONGCARD);
VAR
    i,lo,hi: CARDINAL;
    v:LONGCARD;
BEGIN
    Lib.RANDOMIZE;
    FOR i:=minisaacstate TO maxisaacstate DO
        lo := Lib.RANDOM(MAX(CARDINAL) );
        hi := Lib.RANDOM(MAX(CARDINAL) );
        v:=LONGCARD(hi) << 16 + LONGCARD(lo);
        PP[i]:=v;
    END;
END genPPLC;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    sizevalue = 256;
    minvalue  = 0;
    maxvalue  = sizevalue-1;
VAR
    value : ARRAY[minvalue..maxvalue] OF LONGCARD;
    valuetotal :LONGCARD;
    valueoverflow : BOOLEAN;

PROCEDURE initvalues (  );
VAR
    i:CARDINAL ;
BEGIN
    FOR i:=minvalue TO maxvalue DO value[i]:=0;END;
    valueoverflow:=FALSE;
END initvalues;

PROCEDURE updatevalue ( v:LONGCARD);
VAR
    ndx:CARDINAL;
BEGIN
    ndx:= CARDINAL(v MOD sizevalue);
    INC(value[ndx]);
    IF valuetotal = MAX(LONGCARD) THEN
        valueoverflow:=TRUE;
        (* valuetotal := 0; *) (* let value as is for division *)
    ELSE
        INC(valuetotal);
    END;
END updatevalue;

PROCEDURE showmissing ( );
CONST
    wib = 3;
VAR
    i : CARDINAL;
BEGIN
    IF valueoverflow THEN
        (* WrStr("::: More than MAX(LONGCARD) values !");WrLn; *)
        RETURN;
    END;
    FOR i:=minvalue TO maxvalue DO
        IF value[i] = 0 THEN
            WrStr("         Missing value  : ");
            IO.WrCard(i,wib);WrLn;
        END;
    END;
END showmissing;

(* ------------------------------------------------------------ *)

CONST
    sizedice = 6;
    mindice  = 0;
    maxdice  = sizedice-1;
VAR
    dice : ARRAY[mindice..maxdice] OF LONGCARD; (* yes, yes, LONGREALs would do too *)
    dicetotal : LONGCARD;
    diceoverflow : BOOLEAN;

PROCEDURE initdice();
VAR
    i : CARDINAL;
BEGIN
    FOR i:=mindice TO maxdice DO dice[i]:=0;END;
    dicetotal := 0;
    diceoverflow := FALSE;
END initdice;

PROCEDURE updatedice(v:LONGCARD);
VAR
    ndx:CARDINAL;
BEGIN
    ndx:= CARDINAL(v MOD sizedice);
    INC(dice[ndx]);
    IF dicetotal = MAX(LONGCARD) THEN
        diceoverflow:=TRUE;
        (* dicetotal := 0; *) (* let value as is for division *)
    ELSE
        INC(dicetotal);
    END;
END updatedice;

PROCEDURE showdice ( );
CONST
    wilc = 10;
VAR
    i,j,p : CARDINAL;
    fl,sum: LONGREAL;
    S:str128;
    ok:BOOLEAN;
BEGIN
    IF diceoverflow THEN
        (* WrStr("::: More than MAX(LONGCARD) dices !");WrLn; *)
        RETURN;
    END;
    sum:=0.0;
    FOR i:=mindice TO maxdice DO
        WrStr("         Side ");
        IO.WrCard(i+1,1);WrStr(" of dice : ");IO.WrLngCard(dice[i],wilc);
        fl:=LONGREAL(dice[i]) / LONGREAL(dicetotal) * 100.0;
        sum:=sum+fl; (* utterly useless ! *)
        Str.FixRealToStr(fl,6,S,ok);
        p:=Str.CharPos(S,dot);
        IF p # MAX(CARDINAL) THEN
            INC(p);
            FOR j:=p TO 3 DO Str.Prepend(S," ");END;
        END;
        WrStr(" (");WrStr(S);WrStr("%)");WrLn;
    END;

    WrStr("         Total          : ");
    IO.WrLngCard(dicetotal,wilc);
    Str.FixRealToStr(sum,6,S,ok);
    WrStr(" (");WrStr(S);WrStr("%)");WrLn;
END showdice;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    rosettamsg = "a Top Secret secret";
    rosettakey = "this is my secret key";
    expectedhex= "1c0636190b1260233b35125f1e1d0e2f4c5422";
    expectedvect="f650e4c8e448e96d98db2fb4f5fad54f433f1afbedec154ad837048746ca4f9a"+nl+
                 "5de3743e88381097f1d444eb823cedb66a83e1e04a5f6355c744243325890e2e"+nl+
                 "..."+nl+
                 "94d401258aba3ffbd32be0608c17eff021e2547e07cffad905340e15f3310c92"+nl+
                 "9d8d190886ba527ff943f672ef73fbf046d95ca5c54cd95b9d855e894bb5af29";
    msgWait = "Working, please wait... ";
VAR
    opt,parmcount:CARDINAL;
    i,j,k,lines:CARDINAL;
    S,R:pathtype;
    state:(waiting,gotcount,gotbase,gotpassphrase);
    hout:FIO.File;
    flagmissing,PPstring,padwithPP,flagdice,binexport,isaacseedfrompool : BOOLEAN;
    DEBUG,alcatraz,dmpme:BOOLEAN;
    x,abcd:CARD32;
    count,localcount:LONGCARD;
    basename:pathtype;
    fl:LONGREAL;
    PP : str256;
    vlc : ARRAY[minisaacstate..maxisaacstate] OF CARD32;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    basename          := progEXEname; (* useless *)
    isaacseedfrompool := TRUE;
    binexport         := TRUE;
    flagdice          := FALSE;
    padwithPP         := FALSE;
    PPstring          := TRUE;
    flagmissing       := FALSE;
    DEBUG             := FALSE;
    Str.Copy(PP,"");

    parmcount := Lib.ParamCount();
    state     := waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "S"+delim+"STRONGER"+delim+"F"+delim+"FLAG"+delim+
                                  "T"+delim+"TEXT"+delim+"A"+delim+"ASCII"+delim+
                                  "D"+delim+"DICE"+delim+
                                  "P"+delim+"PAD"+delim+
                                  "X"+delim+"LONGCARD"+delim+
                                  "M"+delim+"MISSING"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            | 1,2,3   :   abort(errHelp,"");
            | 4,5,6,7 :   isaacseedfrompool := FALSE;
            | 8,9,10,11 : binexport         := FALSE;
            | 12,13:      flagdice          := TRUE;
            | 14,15:      padwithPP         := TRUE;
            | 16,17:      PPstring          := FALSE;
            | 18,19 :     flagmissing       := TRUE;
            | 20:         DEBUG             := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                ReplaceChar(R,dot,"");
                ReplaceChar(R,coma,"");
                Str.Prepend(R,"-?:");
                IF GetLongCard(R,count)=FALSE THEN abort(errBadCount,S);END;
                IF count=0 THEN abort(errAdjusted,S);END;
                IF ( count - (count MOD roundsize) ) = 0 THEN abort(errAdjusted,S);END;
            | gotcount :
                IF chkJoker(S) THEN abort(errJoker,S);END;
                IF Str.CharPos(S,dot) # MAX(CARDINAL) THEN abort(errBase,S);END;
                Str.Copy(basename,S);
            | gotbase  :
                Str.Copy(PP,S);
            | gotpassphrase:
                abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting:
        IF NOT(DEBUG) THEN
            WrStr("::: Computed first and last lines :");WrLn;
        END;

        isaacseedfrompool := TRUE;  (* forced *)
        padwithPP         := FALSE; (* forced *)

        lines:=1;

        initisaac(isaacseedfrompool,DOzeroPOOL);

        FOR i:=1 TO 2 DO (* //1 *)
            updateisaac();
            FOR j:=minisaacstate TO maxisaacstate DO
                dmpme:=chkdmp(DEBUG,lines);
                IF dmpme THEN WrStr(fmtlc(getisaacpool(j),16,8,"0",FALSE)); END;
                CASE (j AND 7) OF
                | 0..6 :
                    ; (* WrStr(" "); *)
                | 7 :
                    IF dmpme THEN WrLn; END;
                    INC(lines);
                    IF (NOT(DEBUG) AND (lines=3)) THEN WrStr("...");WrLn;END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
        END;
        WrLn;

        WrStr("::: Expected first and last lines from RANDVECT.TXT :");WrLn;
        WrStr(expectedvect);WrLn;
        WrLn;
        WrStr("::: message  : ");wr(TRUE,rosettamsg);WrLn;
        WrStr("::: key      : ");wr(TRUE,rosettakey);WrLn;

        initisaacseedstr (isaacseedfrompool,padwithPP,rosettakey);
        vernam(R, rosettamsg);

        WrStr("::: encoded  : ");dmphex(R);WrLn;
        WrStr("::: expected : ");WrStr(expectedhex);WrLn;

        initisaacseedstr (isaacseedfrompool,padwithPP,rosettakey);
        vernam(S, R);

        WrStr("::: decoded  : ");wr(TRUE,S);WrLn;
    | gotcount:
        abort(errExpecting,"<basename> [passphrase]");
    | gotbase,gotpassphrase:
        IF same(PP,"") THEN (* state if gotbase *)
            IF PPstring THEN
                genPP(PP);
                initisaacseedstr (isaacseedfrompool,padwithPP,PP);
            ELSE
                IF padwithPP THEN abort(errPadNotApplicable,"");END;
                genPPLC(vlc);
                initisaacseedval(isaacseedfrompool,vlc);
            END;
        ELSE
            IF PPstring=FALSE THEN abort(errSpecifiedPP,"");END;
            initisaacseedstr (isaacseedfrompool,padwithPP,PP);
        END;

        (* initisaac(isaacseedfrompool,DOzeroPOOL); (* gives same sequence as in test *) *)
        procisaacstate(TRUE);

        dmpcard(count,            "Specified count : ");
        count := count - (count MOD roundsize);
        dmpcard(count,            "Adjusted count  : ");
        WrStr("Base name       : ");wr(TRUE,basename);WrLn;
        dmpbool(binexport,        "Export format   : ","binary","text");
        dmpbool(isaacseedfrompool,"Seed from pool  : ","yes","no");
        dmpbool(padwithPP,        "Pool padding    : ","repeated passphrase","$00");
        dmpbool(PPstring,         "Auto-passphrase : ","string","array of LONGCARDs");

        i:=minMethod;
        LOOP
            localcount := count;

            procisaacstate(FALSE);
            initdice();
            initvalues();

            video(msgWait,TRUE);
            Str.Concat(R,basename,dot);Str.Append(R,CHR(ORD("A")+i-1));
            (* IF FIO.Exists(R) THEN FIO.Erase(R);END; *)
            hout:=FIO.Create(R);
            FIO.AssignBuffer(hout,ioBufferOut);

            alcatraz := FALSE;
            LOOP
                IF localcount = 0 THEN EXIT;END;
                updateisaac();
                FOR j:=minisaacstate TO maxisaacstate DO
                     abcd:=getisaacpool(j);
                     CASE i OF
                     | methodABCD:
                         x:=abcd;
                         fwrLC(hout,binexport,x);
                         updatedice(x); (* one 32-bit value *)
                         FOR k:=1 TO 4 DO
                             CASE k OF
                             | 4: x:=(abcd AND 0FF000000H) >> 24;
                             | 3: x:=(abcd AND 0FF0000H  ) >> 16;
                             | 2: x:=(abcd AND 0FF00H    ) >> 8;
                             | 1: x:=(abcd AND 0FFH      );
                             ELSE ; (* //ISO fixed silly requirement *) END;
                             updatevalue(x);
                         END;
                     | methodDCBA:
                         FOR k:=1 TO 4 DO
                             CASE k OF
                             | 1: x:=(abcd AND 0FF000000H) >> 24;
                             | 2: x:=(abcd AND 0FF0000H  ) >> 16;
                             | 3: x:=(abcd AND 0FF00H    ) >> 8;
                             | 4: x:=(abcd AND 0FFH      );
                             ELSE ; (* //ISO fixed silly requirement *) END;
                             fwrB(hout,binexport,x);
                             (* updatedice(x); four 8-bit values *)
                             updatevalue(x);
                         END;
                         updatedice(x); (* one 32-bit value *)
                     | methodMOD255:
                         x := abcd MOD 0FFH;
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | methodMOD256:
                         x := abcd MOD 100H;
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | methodDIV1000000H:
                         x := abcd DIV 1000000H;
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | methodSHIFT24:
                         x := abcd >> 24;
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | methodDIVMAXLC256:
                         fl:=LONGREAL(abcd) / FMAXLC;
                         fl:=fl*FMAXBPLUS1;
                         x:=LONGCARD(fl);
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | methodDIVRANGE256:
                         fl:=LONGREAL(abcd) / FMAXLCPLUS1;
                         fl:=fl*FMAXBPLUS1;
                         x:=LONGCARD(fl);
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | methodDIVMAXLC255:
                         fl:=LONGREAL(abcd) / FMAXLC;
                         fl:=fl*FMAXB;
                         x:=LONGCARD(fl);
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     | method32TO8:
                         x := abcd DIV DIV32TO8;
                         fwrB(hout,binexport, x);
                         updatedice(x);
                         updatevalue(x);
                     ELSE ; (* //ISO fixed silly requirement *) END;
                     DEC(localcount);
                END;
                alcatraz:=IO.KeyPressed();
                IF alcatraz THEN EXIT;END;
            END;
            FIO.Close(hout);
            video(msgWait,FALSE);
            WrStr("Created         : ");wr(TRUE,R);WrLn;
            IF alcatraz THEN EXIT; END;
            IF flagdice THEN
                showdice();
                IF i < maxMethod THEN
                    IF NOT(flagmissing) THEN WrLn;END;
                END;
            END;
            IF flagmissing THEN
                showmissing();
            END;
            INC(i);
            IF i > maxMethod THEN EXIT; END;
        END;
        IF alcatraz THEN abort(errAborted,"");END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    abort(errNone,"");
END tstIsaac.

