
(* ---------------------------------------------------------------
Title         Q&D DD
Author        who cares ?
Overview      see help
Usage         see help
Notes         beware of names containing "$" and fsize > 4Gb
              probably the highest number of options to parse

              too much code : compact is no longer enough...

              we use SHA-1 here

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              compiling memory limits were doubled in order compilation not to abort

              see XDS, //XDSTS and //FIXME
              all color, audio, readonly support was removed
              with this port, no option applies to readonly processing :-(
              default dirmask is set for LFN
              directory removal (-e) had to be... removed because it won't work
              (illogical "sharing violation" when calling FIO.RmDir() procedure)

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          under XP, crash when recursively allocating subdirs
              (with /lfn, farheapdeallocate error)
              oddly enough, no problem with 9x while processing
              approximately the same number of dirs
              seems it has to do with mad XP tree depth :
              seemingly fixed by increasing stack size from 24576 to 32767

              yet another TS one : 254C does not give CHR(254) !

              dd /ad+ /f:$u$d does not show dirnames !
              $d should always include $f for directories !
              C:\Z\foo.bar   DIR
              C:\Z\foobar.   DIR
              C:\Z\test.     FILE

              deleting (directly or from list) still lets sFake header : fix it !
              (killfile, doDel)

              another XDS gag : we have to manually force FIO.EOF to FALSE
              before opening filelist to be read !
              not only they have changed a few names, a few structures,
              not only they have kept a few TS bugs...
              but they can't even correctly emulate JPI libraries !

Wish List
              more formats ? alignments ?
              execute format as a command the WITH way ? nope, rewrite WITH instead
              try and build enhanced WITH with appropriate compilation directives ?

              what about deleting R+ directories ?
              (interactive) gotodir in filefind mode ? best left to C utility
              include ATTRIB function ?

              a cleaner buildDirList() ?
              (storing indexes of each parent dir as to waste less RAM)

              add free space to final report ? eh, what if different units ? or worse : XP !
              look into archives ? best left to DIRBAT

              we know where and how to fix for filefind parsing fix "cdef:foobar"
              but for now we're too busy... ahem, lazy to do it
              partially done but we should not restore an arbo already in memory
              in another life perhaps ?

              a multiline compact display ? in yet another non-life perhaps...

              should /fd default to /adx ?
              (last mask would win, instead of flagging conflicts)

              fix $u$d problem for directories...
              (should be $u$f if directory)

              list files by type IN order TO have a listing such as :
              .EXE  foo    bar
                    baz
              .INI  xlat   dllfind

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  7 May 23 v0.9f bugfix parseFileSizeRange() would fail on very special cases
PhG 19 Mar 21 v0.9e possible fix for crash with heap size at 8000000 in project
PhG 25 Nov 19 v0.9d parseDateRange() now handles *:$ and $:*
PhG 23 Feb 18 v0.9c bugfix doDir() would no longer take showentries flag into account (done while porting the thing)
PhG  7 Feb 18 v0.9b would not read a filelist because XDS TSCK does not correctly emulate JPI !
              (we have here to reset FIO.EOF to FALSE before opening filelist for reading !)
PhG 29 Jan 18 v0.9a parseFileSizeRange() now handles *:#  #:* and cosmetic separators
PhG 16 Jan 18 un ugly really Q&D port from DD v1.2 for DOS
--------------------------------------------------------------- *)

MODULE DD32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn,WrChar;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



TYPE
    pathtype = FIO.FileName;



(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;

PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //FIXME
<* PUSH *>
<* COVERFLOW = "OFF"  *>
<* IOVERFLOW = "OFF"  *>
*)

(* // QD_MD5 *)

CONST
    MD5firstDigestNdx = 0;
    MD5lastDigestNdx  = 15;
TYPE
    MD5str        = ARRAY [0..31] OF CHAR;
    MD5digestType = ARRAY [MD5firstDigestNdx..MD5lastDigestNdx] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)

TYPE
    MDstatetype = RECORD
        CASE : BOOLEAN OF
        | TRUE : a,b,c,d: LONGCARD;
        | FALSE: digest : MD5digestType;
	ELSE
	    ;
        END;
    END;
    count64type = RECORD
        lo,hi:LONGCARD;
    END;
    MDblocktype = ARRAY [0..15] OF LONGCARD; (* 0..63 BYTE *)
    MDpblock = POINTER TO MDblocktype; (* no generic POINTER TYPE ! *)
    MD5contextType = RECORD
        state : MDstatetype;   (* ABCD *)
        count : count64type; (* bits modulo 2^64, lsb first *)
    END;

(* ------------------------------------------------------------ *)

CONST
    MDioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    MDfirstioBufferByte = 1;
    MDlastioBufferByte  = MDioBufferSize;
TYPE
    MDioBufferType  = ARRAY [MDfirstioBufferByte..MDlastioBufferByte] OF SYSTEM.LOC;
VAR
    MDsourceBuffer : MDioBufferType;

CONST
    MDfirstDataByte = 0;
    MDlastDataByte  = 8*512-1; (* 4Kb + 64 *)
    MDdataBufferSize= MDlastDataByte - MDfirstDataByte + 1;
TYPE
    MDdataBufferType = ARRAY [MDfirstDataByte..MDlastDataByte+SIZE(MDblocktype)] OF SYSTEM.LOC; (* 8Kb+64 *)
VAR
    MDdataBuffer : MDdataBufferType; (* globerk *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    maphex = "0123456789abcdef"; (* already beautified for readability *)

(* 16 bytes to 32 chars *)

PROCEDURE MD5toString (VAR R:MD5str; digest:MD5digestType);
VAR
    i,v : CARDINAL;
    lo,hi:CHAR;
BEGIN
    Str.Copy(R,"");
    FOR i:=MD5firstDigestNdx TO MD5lastDigestNdx DO
        v:=CARDINAL( digest[i] );
        lo:=maphex[ v AND 0FH];
        hi:=maphex[ v >> 4 ];
        Str.Append(R,hi);
        Str.Append(R,lo);
    END;
END MD5toString;

(* assume legal 32 hex chars string has been checked to [0..9a..f] ! *)

PROCEDURE stringToMD5 (S:MD5str):MD5digestType;
VAR
    digest:MD5digestType;
    i,ndx,v,vlo,vhi:CARDINAL;
BEGIN
    Str.Lows(S); (* safety *)
    ndx:=0;
    FOR i:=MD5firstDigestNdx TO MD5lastDigestNdx DO
        vlo:=Str.CharPos(maphex,S[ndx]);    IF ndx < MD5lastDigestNdx THEN INC(ndx); END;
        vhi:=Str.CharPos(maphex,S[ndx+1]);  IF ndx < MD5lastDigestNdx THEN INC(ndx); END;
        v:=(vhi << 4 ) + vlo;
        digest[i]:=SYSTEM.LOC(v);
    END;
    RETURN digest;
END stringToMD5;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE MD5init (VAR ctx:MD5contextType;bytecount:LONGCARD);
BEGIN
    ctx.state.a := 067452301H;
    ctx.state.b := 0EFCDAB89H;
    ctx.state.c := 098BADCFEH;
    ctx.state.d := 010325476H;
    ctx.count.lo:=bytecount << 3;      (* x8 : bytes to bits *)
    ctx.count.hi:=bytecount >> (32-3); (* keep 3 upper bits *)
END MD5init;

PROCEDURE xor (v1,v2 : LONGCARD  ) : LONGCARD;
TYPE
    dBITSET = SET OF [0..31];
BEGIN
    RETURN LONGCARD( dBITSET(v1) / dBITSET(v2) );
END xor;

PROCEDURE ROTATE_LEFT( x, n: LONGCARD):LONGCARD ;
BEGIN
    RETURN  ( (x << n) OR (x >> (32-n)) );
END ROTATE_LEFT;

PROCEDURE FF (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a,  ( (b AND c) OR ((NOT (b)) AND d) )  +x+ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END FF;

PROCEDURE GG (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a, ( (b AND d) OR (c AND (NOT (d))) ) +x+ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END GG;

PROCEDURE HH (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a, xor(xor(b,c),d) +x+ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END HH;

PROCEDURE II (VAR a: LONGCARD; b,c,d,x,s,ac:LONGCARD);
BEGIN
    INC(a, xor(c, (b OR (NOT (d)))) +x +ac);
    a:=ROTATE_LEFT (a,s);
    INC(a,b);
END II;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE MD5Transform (VAR state:MDstatetype; p:MDpblock);
CONST
    S11 = 7;
    S12 =12;
    S13 =17;
    S14 =22;
    S21 = 5;
    S22 = 9;
    S23 =14;
    S24 =20;
    S31 = 4;
    S32 =11;
    S33 =16;
    S34 =23;
    S41 = 6;
    S42 =10;
    S43 =15;
    S44 =21;
VAR
    a,b,c,d:LONGCARD;
BEGIN
    a:= state.a;
    b:= state.b;
    c:= state.c;
    d:= state.d;

    (* Round 1 *)
    FF (a, b, c, d, p^[ 0], S11, 0D76AA478H); (*  1 *)
    FF (d, a, b, c, p^[ 1], S12, 0E8C7B756H); (*  2 *)
    FF (c, d, a, b, p^[ 2], S13, 0242070DBH); (*  3 *)
    FF (b, c, d, a, p^[ 3], S14, 0C1BDCEEEH); (*  4 *)
    FF (a, b, c, d, p^[ 4], S11, 0F57C0FAFH); (*  5 *)
    FF (d, a, b, c, p^[ 5], S12, 04787C62AH); (*  6 *)
    FF (c, d, a, b, p^[ 6], S13, 0A8304613H); (*  7 *)
    FF (b, c, d, a, p^[ 7], S14, 0FD469501H); (*  8 *)
    FF (a, b, c, d, p^[ 8], S11, 0698098D8H); (*  9 *)
    FF (d, a, b, c, p^[ 9], S12, 08B44F7AFH); (* 10 *)
    FF (c, d, a, b, p^[10], S13, 0FFFF5BB1H); (* 11 *)
    FF (b, c, d, a, p^[11], S14, 0895CD7BEH); (* 12 *)
    FF (a, b, c, d, p^[12], S11, 06B901122H); (* 13 *)
    FF (d, a, b, c, p^[13], S12, 0FD987193H); (* 14 *)
    FF (c, d, a, b, p^[14], S13, 0A679438EH); (* 15 *)
    FF (b, c, d, a, p^[15], S14, 049B40821H); (* 16 *)

    (* Round 2 *)
    GG (a, b, c, d, p^[ 1], S21, 0F61E2562H); (* 17 *)
    GG (d, a, b, c, p^[ 6], S22, 0C040B340H); (* 18 *)
    GG (c, d, a, b, p^[11], S23, 0265E5A51H); (* 19 *)
    GG (b, c, d, a, p^[ 0], S24, 0E9B6C7AAH); (* 20 *)
    GG (a, b, c, d, p^[ 5], S21, 0D62F105DH); (* 21 *)
    GG (d, a, b, c, p^[10], S22, 002441453H); (* 22 *)
    GG (c, d, a, b, p^[15], S23, 0D8A1E681H); (* 23 *)
    GG (b, c, d, a, p^[ 4], S24, 0E7D3FBC8H); (* 24 *)
    GG (a, b, c, d, p^[ 9], S21, 021E1CDE6H); (* 25 *)
    GG (d, a, b, c, p^[14], S22, 0C33707D6H); (* 26 *)
    GG (c, d, a, b, p^[ 3], S23, 0F4D50D87H); (* 27 *)
    GG (b, c, d, a, p^[ 8], S24, 0455A14EDH); (* 28 *)
    GG (a, b, c, d, p^[13], S21, 0A9E3E905H); (* 29 *)
    GG (d, a, b, c, p^[ 2], S22, 0FCEFA3F8H); (* 30 *)
    GG (c, d, a, b, p^[ 7], S23, 0676F02D9H); (* 31 *)
    GG (b, c, d, a, p^[12], S24, 08D2A4C8AH); (* 32 *)

    (* Round 3 *)
    HH (a, b, c, d, p^[ 5], S31, 0FFFA3942H); (* 33 *)
    HH (d, a, b, c, p^[ 8], S32, 08771F681H); (* 34 *)
    HH (c, d, a, b, p^[11], S33, 06D9D6122H); (* 35 *)
    HH (b, c, d, a, p^[14], S34, 0FDE5380CH); (* 36 *)
    HH (a, b, c, d, p^[ 1], S31, 0A4BEEA44H); (* 37 *)
    HH (d, a, b, c, p^[ 4], S32, 04BDECFA9H); (* 38 *)
    HH (c, d, a, b, p^[ 7], S33, 0F6BB4B60H); (* 39 *)
    HH (b, c, d, a, p^[10], S34, 0BEBFBC70H); (* 40 *)
    HH (a, b, c, d, p^[13], S31, 0289B7EC6H); (* 41 *)
    HH (d, a, b, c, p^[ 0], S32, 0EAA127FAH); (* 42 *)
    HH (c, d, a, b, p^[ 3], S33, 0D4EF3085H); (* 43 *)
    HH (b, c, d, a, p^[ 6], S34, 004881D05H); (* 44 *)
    HH (a, b, c, d, p^[ 9], S31, 0D9D4D039H); (* 45 *)
    HH (d, a, b, c, p^[12], S32, 0E6DB99E5H); (* 46 *)
    HH (c, d, a, b, p^[15], S33, 01FA27CF8H); (* 47 *)
    HH (b, c, d, a, p^[ 2], S34, 0C4AC5665H); (* 48 *)

    (* Round 4 *)
    II (a, b, c, d, p^[ 0], S41, 0F4292244H); (* 49 *)
    II (d, a, b, c, p^[ 7], S42, 0432AFF97H); (* 50 *)
    II (c, d, a, b, p^[14], S43, 0AB9423A7H); (* 51 *)
    II (b, c, d, a, p^[ 5], S44, 0FC93A039H); (* 52 *)
    II (a, b, c, d, p^[12], S41, 0655B59C3H); (* 53 *)
    II (d, a, b, c, p^[ 3], S42, 08F0CCC92H); (* 54 *)
    II (c, d, a, b, p^[10], S43, 0FFEFF47DH); (* 55 *)
    II (b, c, d, a, p^[ 1], S44, 085845DD1H); (* 56 *)
    II (a, b, c, d, p^[ 8], S41, 06FA87E4FH); (* 57 *)
    II (d, a, b, c, p^[15], S42, 0FE2CE6E0H); (* 58 *)
    II (c, d, a, b, p^[ 6], S43, 0A3014314H); (* 59 *)
    II (b, c, d, a, p^[13], S44, 04E0811A1H); (* 60 *)
    II (a, b, c, d, p^[ 4], S41, 0F7537E82H); (* 61 *)
    II (d, a, b, c, p^[11], S42, 0BD3AF235H); (* 62 *)
    II (c, d, a, b, p^[ 2], S43, 02AD7D2BBH); (* 63 *)
    II (b, c, d, a, p^[ 9], S44, 0EB86D391H); (* 64 *)

    INC(state.a,a);
    INC(state.b,b);
    INC(state.c,c);
    INC(state.d,d);
END MD5Transform;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume file exists ! *)

PROCEDURE ComputeMD5 (VAR digest:MD5digestType;S:pathtype);
VAR
    hin:FIO.File;
    ndx:CARDINAL; (* assume less than 64Kb buffer *)
    got:CARDINAL;
    done:BOOLEAN;
    ctx:MD5contextType;
BEGIN
    hin:=FIO.OpenRead(S);
    FIO.AssignBuffer(hin,MDsourceBuffer);
    done:=FALSE;
    MD5init(ctx, FIO.Size(hin));
    REPEAT
         got:=FIO.RdBin(hin,MDdataBuffer,MDdataBufferSize);
         IF got # MDdataBufferSize THEN
             MDdataBuffer[got]:= 080H;
             INC(got);
             WHILE (got MOD 64) # 56 DO
                 MDdataBuffer[ got ] := 0;
                 INC(got);
             END;

             Lib.Move(     SYSTEM.ADR(ctx.count), SYSTEM.ADR(MDdataBuffer[got]), 8);

             INC(got,8);
             done:=TRUE;
         END;
         ndx:=0;
         REPEAT
             MD5Transform( ctx.state, SYSTEM.ADR(MDdataBuffer[ndx]) );
             INC(ndx, SIZE(MDblocktype));
         UNTIL ndx=got;
    UNTIL done;
    FIO.Close(hin);
    digest:=ctx.state.digest;
END ComputeMD5;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_SHA *)

CONST
    SHAfirstDigestNdx = 0;
    SHAlastDigestNdx  = 19;
TYPE
    SHAstr        = ARRAY [0..39] OF CHAR; (* 20 bytes = 40 hex digits *)
    SHAdigestType = ARRAY [SHAfirstDigestNdx..SHAlastDigestNdx] OF SYSTEM.LOC;


(* FIPS PUB 180-1 keeping varnames, and without any optimization *)

TYPE
    SHAstatetype = RECORD
        CASE : BOOLEAN OF
        | TRUE : H0,H1,H2,H3,H4 : LONGCARD;
        | FALSE: digest : SHAdigestType;
	ELSE
	   ;
        END;
    END;
    (*
    count64type = RECORD
        lo,hi:LONGCARD;
    END;
    *)
    SHAcontextType = RECORD
        state : SHAstatetype;   (* H0 H1 H2 H3 H4 *)
        count : count64type; (* bits modulo 2^64 *)
    END;
CONST
    firstround    = 1-1;             (* 0 *)
    lastround     = (20*4)-1;        (* 79 *)
    lastroundbyte = (20*4*4)-1;      (* 319 *)
TYPE
    SHAcombotype = RECORD
        CASE : BOOLEAN OF
        | TRUE : dw : ARRAY [firstround..lastround] OF LONGCARD;
        | FALSE: b  : ARRAY [firstround..lastroundbyte] OF SYSTEM.LOC;
	ELSE
	    ;
        END;
    END;
    SHAblocktype = RECORD
        CASE : BOOLEAN OF
        | TRUE : dw : ARRAY [0..15] OF LONGCARD;
        | FALSE: b  : ARRAY [0..63] OF SYSTEM.LOC;     (* 512 bits = 64 bytes = 16 dwords *)
	ELSE
	    ;
        END;
    END;
    ptrToSHABlockType = POINTER TO SHAblocktype; (* no generic POINTER type ! *)
CONST
    SHABLOCKSIZE = SIZE (SHAblocktype);

(* ------------------------------------------------------------ *)

VAR
    K : ARRAY [firstround..lastround] OF LONGCARD;
    W : SHAcombotype;

(* ------------------------------------------------------------ *)

CONST
    SHAioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    SHAfirstioBufferByte = 1;
    SHAlastioBufferByte  = SHAioBufferSize;
TYPE
    SHAioBufferType  = ARRAY [SHAfirstioBufferByte..SHAlastioBufferByte] OF SYSTEM.LOC;
VAR
    SHAsourceBuffer : SHAioBufferType;

CONST
    SHAfirstDataByte = 1-1; (* yes, it's 0 *)
    SHAlastDataByte  = 8*512-1; (* 4Kb *)
    SHAdataBufferSize= SHAlastDataByte - SHAfirstDataByte + 1;
TYPE
    SHAdataBufferType = ARRAY [SHAfirstDataByte..SHAlastDataByte+SHABLOCKSIZE] OF SYSTEM.LOC; (* 4Kb+64 *)
VAR
    SHAdataBuffer : SHAdataBufferType; (* globerk *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* 20 bytes to 40 chars *)

PROCEDURE SHAtoString (VAR R:SHAstr; digest:SHAdigestType);
VAR
    i,v : CARDINAL;
    lo,hi:CHAR;
BEGIN
    Str.Copy(R,"");
    FOR i:=SHAfirstDigestNdx TO SHAlastDigestNdx DO
        v:=CARDINAL( digest[i] );
        lo:=maphex[ v AND 0FH];
        hi:=maphex[ v >> 4 ];
        Str.Append(R,hi);
        Str.Append(R,lo);
    END;
END SHAtoString;

(* assume legal 40 hex chars string has been checked to [0..9a..f] ! *)

PROCEDURE stringToSHA (S:SHAstr):SHAdigestType;
VAR
    digest:SHAdigestType;
    i,ndx,v,vlo,vhi:CARDINAL;
BEGIN
    Str.Lows(S); (* safety *)
    ndx:=0;
    FOR i:=SHAfirstDigestNdx TO SHAlastDigestNdx DO
        vlo:=Str.CharPos(maphex,S[ndx]);    IF ndx < SHAlastDigestNdx THEN INC(ndx); END;
        vhi:=Str.CharPos(maphex,S[ndx+1]);  IF ndx < SHAlastDigestNdx THEN INC(ndx); END;
        v:=(vhi << 4 ) + vlo;
        digest[i]:=SYSTEM.LOC(v);
    END;
    RETURN digest;
END stringToSHA;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE SHAinit (VAR ctx:SHAcontextType;bytecount:LONGCARD);
VAR
    t,i,j : CARDINAL;
    V : LONGCARD;
BEGIN
    ctx.state.H0 := 067452301H;
    ctx.state.H1 := 0EFCDAB89H;
    ctx.state.H2 := 098BADCFEH;
    ctx.state.H3 := 010325476H;
    ctx.state.H4 := 0C3D2E1F0H;

    t:=firstround;
    FOR i:=1 TO 4 DO
        CASE i OF
        | 1 : V:=05A827999H; (*  0..19 *)
        | 2 : V:=06ED9EBA1H; (* 20..39 *)
        | 3 : V:=08F1BBCDCH; (* 40..59 *)
        | 4 : V:=0CA62C1D6H; (* 60..79 *)
	ELSE
	    ;
        END;
        FOR j:=1 TO 20 DO K[t]:=V; INC(t); END;
    END;

    ctx.count.lo:=bytecount << 3;      (* x8 : bytes to bits *)
    ctx.count.hi:=bytecount >> (32-3); (* keep 3 upper bits *)
END SHAinit;

PROCEDURE SHAflip (VAR ctx:SHAcontextType);
VAR
    t,j : CARDINAL;
    b : ARRAY [0..3] OF SYSTEM.LOC;
BEGIN
    FOR t:= SHAfirstDigestNdx TO SHAlastDigestNdx BY 4 DO
        FOR j:=0 TO 3 DO b[j]:=ctx.state.digest[t+j];END;
        ctx.state.digest[t+0] := b[3];
        ctx.state.digest[t+1] := b[2];
        ctx.state.digest[t+2] := b[1];
        ctx.state.digest[t+3] := b[0];
    END;
END SHAflip;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
PROCEDURE xor (v1,v2 : LONGCARD  ) : LONGCARD;
TYPE
    dBITSET = SET OF [0..31];
BEGIN
    RETURN LONGCARD( dBITSET(v1) / dBITSET(v2) );
END xor;

PROCEDURE ROTATE_LEFT( x, n: LONGCARD):LONGCARD ;
BEGIN
    RETURN  ( (x << n) OR (x >> (32-n)) );
END ROTATE_LEFT;
*)

PROCEDURE F00 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:= (B AND C)  OR  ((NOT (B)) AND D);
END F00;

PROCEDURE F20 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:=xor(B,C);
    v:=xor(v,D);
END F20;

PROCEDURE F40 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:= (B AND C)  OR  (B AND D)  OR  (C AND D);
END F40;

PROCEDURE F60 (VAR v:LONGCARD; B,C,D:LONGCARD);
BEGIN
    v:=xor(B,C);
    v:=xor(v,D);
END F60;

(* ------------------------------------------------------------ *)

(* p points to data which are to become W[0]...W[15] *)

PROCEDURE SHAtransform (VAR state:SHAstatetype; pBlock:ptrToSHABlockType);
VAR
    A,B,C,D,E : LONGCARD;
    TEMP, v : LONGCARD;
    t:CARDINAL;
BEGIN
    (* don't forget to reverse bytes of each longcard ! *)
    FOR t:= 0 TO 63 BY 4 DO
        W.b[t+0] := pBlock^.b[t+3];
        W.b[t+1] := pBlock^.b[t+2];
        W.b[t+2] := pBlock^.b[t+1];
        W.b[t+3] := pBlock^.b[t+0];
    END;

    FOR t := 16 TO 79 DO
        v       := xor ( W.dw[t-3] , W.dw[t-8]);
        v       := xor ( v         , W.dw[t-14]);
        v       := xor ( v         , W.dw[t-16]);
        W.dw[t] := ROTATE_LEFT( v, 1);
    END;

    A:= state.H0;
    B:= state.H1;
    C:= state.H2;
    D:= state.H3;
    E:= state.H4;

    FOR t := 0 TO 79 DO
        TEMP := ROTATE_LEFT(A,5);
        CASE t OF                    (* no speed gain from splitting here *)
        |  0..19 : F00( v, B,C,D);
        | 20..39 : F20( v, B,C,D);
        | 40..59 : F40( v, B,C,D);
        | 60..79 : F60( v, B,C,D);
	    ELSE
	    ;
        END;
        INC( TEMP, v );
        INC( TEMP, E );
        INC( TEMP, W.dw[t] );
        INC( TEMP, K[t] );

        E    := D;
        D    := C;
        C    := ROTATE_LEFT(B,30);
        B    := A;
        A    := TEMP;

    END;

    INC(state.H0,A);
    INC(state.H1,B);
    INC(state.H2,C);
    INC(state.H3,D);
    INC(state.H4,E);
END SHAtransform;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume file exists ! *)

PROCEDURE ComputeSHA (VAR digest:SHAdigestType;S:pathtype);
VAR
    hin:FIO.File;
    ndx:CARDINAL; (* assume less than 64Kb buffer *)
    j,t,got:CARDINAL;
    done:BOOLEAN;
    b:ARRAY[0..3] OF SYSTEM.LOC;
    ctx:SHAcontextType;
BEGIN
    hin:=FIO.OpenRead(S);
    FIO.AssignBuffer(hin,SHAsourceBuffer);
    done:=FALSE;
    SHAinit(ctx, FIO.Size(hin));
    REPEAT
        got:=FIO.RdBin(hin,SHAdataBuffer,SHAdataBufferSize);
        IF got # SHAdataBufferSize THEN
            SHAdataBuffer[got]:= 080H;
            INC(got);
            WHILE (got MOD 64) # 56 DO
                SHAdataBuffer[ got ] := 0;
                INC(got);
            END;

            Lib.Move(     SYSTEM.ADR(ctx.count.hi), SYSTEM.ADR(SHAdataBuffer[got]), 4);
            Lib.Move(     SYSTEM.ADR(ctx.count.lo), SYSTEM.ADR(SHAdataBuffer[got+4]), 4);

    FOR t:= got TO got+8 BY 4 DO
        FOR j:=0 TO 3 DO b[j]:=SHAdataBuffer[t+j];END;
        SHAdataBuffer[t+0] := b[3];
        SHAdataBuffer[t+1] := b[2];
        SHAdataBuffer[t+2] := b[1];
        SHAdataBuffer[t+3] := b[0];
    END;

            INC(got,8);
            done:=TRUE;
        END;
        ndx:=0;
        REPEAT
            SHAtransform( ctx.state, SYSTEM.ADR( SHAdataBuffer[ndx] ) );
            INC(ndx, SHABLOCKSIZE);
        UNTIL ndx=got;
    UNTIL done;
    FIO.Close(hin);
    SHAflip(ctx);
    digest:=ctx.state.digest;
END ComputeSHA;

(* //FIXME
<* POP *>
*)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_CRC *)

(* ------------------------------------------------------------ *)

(* all indexes must be from 0, and end at 255 *)
(* both arrays are LONGCARD *)

CONST
    firstByteVal    = 0;         (* for CRCsigma *)
    lastByteVal     = 255;
    firstTableIndex = 0;         (* for CRC *)
    lastTableIndex  = 255;

VAR
    CRC32table : ARRAY [firstTableIndex..lastTableIndex] OF LONGCARD;
    countTable : ARRAY [firstByteVal..lastByteVal] OF LONGCARD;
    computeSigma: BOOLEAN; (* ugly global hack... *)

(* ------------------------------------------------------------ *)

PROCEDURE InitCountTable ();
VAR
    n : CARDINAL;
BEGIN
    FOR n := firstByteVal TO lastByteVal DO
        countTable[n] := 0;
    END;
END InitCountTable;

(* ------------------------------------------------------------ *)

(*

w1+w2 = OR
w1*w2 = AND
w1/w2 = XOR
{0..15} - 16 = NOT
i IN w = true if bit i set in word w
INCL(w,i) = set
EXCL(w,i) = clear

*)

TYPE
    dBITSET = SET OF [0..31];

PROCEDURE xorDWORD (v1,v2 : LONGCARD  ) : LONGCARD;
BEGIN
    RETURN LONGCARD( dBITSET(v1) / dBITSET(v2) );
END xorDWORD;

(* ------------------------------------------------------------ *)

PROCEDURE InitCRC32 ();
CONST
    polynomial      = 3988292384; (* $EDB88320 *)
VAR
    n   : CARDINAL;
    i   : CARDINAL;
    crc : LONGCARD;
BEGIN
    FOR n := firstTableIndex TO lastTableIndex DO
        crc := LONGCARD(n);
        FOR i := 1 TO 8 DO
            IF ( 0 IN dBITSET(crc) )=TRUE THEN (* crc AND 1 *)
                crc := xorDWORD( (crc >> 1) , polynomial);
            ELSE
                crc := crc >> 1;
            END;
        END;
        CRC32table[n]:=crc;
    END;
END InitCRC32;

(* ------------------------------------------------------------ *)

CONST
    CRCioBufferSize    = (8*512) + FIO.BufferOverhead;
    CRCfirstBufferByte = 1;
    CRClastBufferByte  = CRCioBufferSize;
VAR
    CRCioBuffer  : ARRAY [CRCfirstBufferByte..CRClastBufferByte] OF SYSTEM.LOC;
    CRCTMPbuffer : ARRAY [CRCfirstBufferByte..CRClastBufferByte] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)

CONST
    seedCRC   = LONGCARD(0FFFFFFFFH);
    invertCRC = LONGCARD(0FFFFFFFFH);
    (* mask24    = LONGCARD(000FFFFFFH); *)
    mask16    = LONGCARD(00000FFFFH);
    mask8     = LONGCARD(0000000FFH);

PROCEDURE ComputeCRC32 (S : pathtype) : LONGCARD;
VAR
    hnd  : FIO.File;
    ch   : SYSTEM.LOC;
    got  : CARDINAL;
    tmp1 : LONGCARD;
    tmp2 : LONGCARD;
    i    : CARDINAL;
    crc  : LONGCARD;
    buffhere,buffsigmahere:SYSTEM.ADDRESS;
BEGIN
    InitCountTable;
    crc := seedCRC;
    hnd :=FIO.OpenRead(S);
    FIO.AssignBuffer(hnd,CRCioBuffer);
    LOOP
        got := FIO.RdBin(hnd,CRCTMPbuffer,CRCioBufferSize);
        IF got = 0 THEN EXIT; END; (* size was a multiple of iobufferSize *)
        FOR i := CRCfirstBufferByte TO got DO
            ch := CRCTMPbuffer[i];
            IF computeSigma THEN INC(countTable[CARDINAL(ch)]); END;

            (* no speed gain if these lines are packed *)
            (*
            tmp1 := (crc >> 8);
            tmp2 := crc AND mask16;
            tmp2 := xorDWORD(tmp2,LONGCARD(ch));
            tmp2 := CRC32table[CARDINAL(tmp2 AND mask8)];
            crc  := xorDWORD(tmp1,tmp2);
            *)

            (* previous is safe but possibly overcomplicated, use alternate instead *)
            tmp2 := xorDWORD(crc,LONGCARD(ch)) AND mask8;
            tmp1 := (crc >> 8); (* AND mask24; is USELESS !!! *)
            crc  := xorDWORD(tmp1,CRC32table[CARDINAL(tmp2)]);
        END;
        IF got < CRCioBufferSize THEN EXIT; END;
    END;
    FIO.Close(hnd);
    RETURN xorDWORD(crc,invertCRC);
END ComputeCRC32;

(* ------------------------------------------------------------ *)

PROCEDURE ComputeCRCval () : LONGCARD;
CONST
    first = 0;
    last = (lastByteVal-firstByteVal+1) * SIZE(LONGCARD) -1;
VAR
    p    : POINTER TO ARRAY [first..last] OF SYSTEM.LOC;
    ch   : SYSTEM.LOC;
    tmp1 : LONGCARD;
    tmp2 : LONGCARD;
    i    : CARDINAL;
    crc  : LONGCARD;
    buffhere : SYSTEM.ADDRESS;
BEGIN
    IF computeSigma=FALSE THEN RETURN 0;END;
    crc := seedCRC;
    p := SYSTEM.ADR(countTable); (* not always a far so we use ADR *)
    FOR i := first TO last DO
        ch := p^[i];
        tmp2 := xorDWORD(crc,LONGCARD(ch)) AND mask8;
        tmp1 := (crc >> 8);
        crc  := xorDWORD(tmp1,CRC32table[CARDINAL(tmp2)]);
    END;
    RETURN xorDWORD(crc,invertCRC);
END ComputeCRCval;

(* ------------------------------------------------------------ *)

PROCEDURE setSigmaUse (flag:BOOLEAN);
BEGIN
    computeSigma := flag;
END setSigmaUse;







(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    str4     = ARRAY[0..3] OF CHAR;

PROCEDURE getWindowHeight (  ):CARDINAL;
VAR
    (* vrows [00040H:0084H] : SYSTEM.CARD8; (* add 1 *) *)
    vrows : CARDINAL;
BEGIN
    vrows := 25; (* //FIXME *)
    RETURN CARDINAL(vrows)+1; (* 25, 43, 50, etc. *)
END getWindowHeight;

PROCEDURE getWindowWidth (  ):CARDINAL;
VAR
    (* vcolumns [00040H:004AH] : CARDINAL; (* a word : 40, 80, 132 *) *)
    vcolumns : CARDINAL;
BEGIN
    vcolumns := 80; (* //FIXME *)
    RETURN CARDINAL(vcolumns);
END getWindowWidth;


(* take care of "\" or "u:\" *)

PROCEDURE unfixDir (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDir;

PROCEDURE isDirectorySpec ( S:pathtype ):BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDir(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectorySpec;

PROCEDURE LowerCaseAlt(VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S); (* //FIXME *)
END LowerCaseAlt;

PROCEDURE UpperCaseAlt(VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S); (* //FIXME *)
END UpperCaseAlt;

(* ------------------------------------------------------------ *)


CONST
    (* must be lowercasealt *)
    fSwapWin92    = "386spart.par";
    fSwapWin98    = "win386.swp";
    fSwapWinXP    = "pagefile.sys";
    patSwapWin92  = "*\"+fSwapWin92;
    patSwapWin98  = "*\"+fSwapWin98;
    patSwapWinXP  = "*\"+fSwapWinXP;
CONST
    comaFR        = dot;
    comaUS        = coma;
    exclamation   = "!";
    echap         = CHR(27);
CONST
    sectionProtected   = openbracket+"ProtectedFromDelete"+closebracket;
    sectionNotProtected= openbracket+"NotProtectedFromDelete"+closebracket;
    sectionIgnored     = openbracket+"IgnoredByDirAndDel"+closebracket;
    dataProtection     = 0;
    dataIgnored        = 1;
CONST
    extEXE        = ".EXE";
    extINI        = ".INI";
    extLST        = ".LST";
    sFake         = ";-) ";        (* prefix *)
    strSUBDIR     = "<DIR>";
    strSUBDIRECTORY = "<DIRECTORY>";

    strRptlookingfor="::: Scanning ~: for ~ ...";
    strRptmatches   = "::: ~ matching file(s) found, taking ~ byte(s).";
    strRptnomatch   = "::: No match found.";
    strRptfiles     = "::: ~ file(s) found, taking ~ byte(s).";
    strRptdirsToo   = "::: ~ file(s) and ~ dir(s) found, taking ~ byte(s).";
    strRptdirsOnly  = "::: ~ dir(s) found.";

    strRptdel     = "::: ~ file(s) processed, ~ file(s) deleted, ~ byte(s) freed.";
    strRpttree    = "::: ~ file(s) processed, ~ file(s) deleted, ~ byte(s) freed.";

CONST
                  (* "123456789012345" *)
    sDelRO         = "+++ Deleted RO ";
    sSkipRO        = "::: Skipped RO ";
    sDel           = "+++ Deleted rw ";
    sIgnored       = "::: Ignored    ";
    sNotFound      = "--- Not found  ";
    sKeptRO        = "::: Kept RO    ";
    sKeptRW        = "::: Kept rw    ";
    sProtectedDir  = "::: PROTECTED "; (* uppercase for dirs *)
    sProtectedFile = "::: Protected ";
    sIgnoredDir    = "::: IGNORED ";
    sIgnoredFile   = "::: Ignored ";

CONST
    (* sEmptiedDir = "+++ Emptied   "+strSUBDIR+" "; was misleading if files were left *)
    sSkippedDir    = "::: <DIR> skipped   ";
    sProcessedDir  = "+++ <DIR> processed ";
    sRemovedDir    = "+++ <DIR> removed   ";
    sLeftDir       = "--- <DIR> PROBLEM ! "; (* failure to perform requested op *)
    sNotDir        = "--- <DIR> is a file "; (* deltree *)
    sDNF           = "--- <DIR> not found "; (* deltree *)
    sDIRheader     = "::: <DIR> ";
CONST
    msgProcessing        = "Processing ~ ..."; (* was scanning but as it may be a filespec... *)
    msgProcessingRecurse = "Recursively processing ~ ..."; (* was scanning but as it may be a filespec... *)
    msgWorking     = "Working, please wait...";
    msgSortingDirs = "Sorting, please wait...";
    msgSortingFiles= "Sorting, please wait...";
    msgNoRemrootHere="::: -zz was changed to -z for user safety.";
CONST
    (* sDefaultPat   = "$z $a $t $l $c"; *)                   (* never /ff !  *)

    sDefaultPat     = "$z  $a  $t  $l  $c";
    sDirPat         = "$i  $j  $v  $f";   (* /fd : /g /j /q *)
    sTersePat       = "$i  $w  $l  $c";              (* /ft *)

    sSumPat         = "$$$k  $i  $j  $f";       (* /fc : /g /q *)
    sMD5digestPat   = "$$$m  $f";                     (* /fm : /g /q *)
    sSHAdigestPat   = "$$$s  $f";                     (* /fs : /g /q *)

    sListPat        = "$c";                                   (* /fl *)
    sFilesPat       = "$f";                                   (* /fv : /q *)
CONST
    minProtected    = 1;
    maxProtected    = 64;    (* at least 3 ! *)
    strMaxProtected = "64";
    minIgnored      = 1;
    maxIgnored      = 16;
    strMaxIgnored   = "16";
CONST
    (* no more letters available ! *)
    cZ        = "z";
    cI        = "i";
    cA        = "a";
    cH        = "h";
    cT        = "t";
    cJ        = "j";
    cU        = "u";
    cD        = "d";
    cB        = "b";
    cN        = "n";
    cE        = "e";
    cF        = "f";
    cC        = "c";
    cQ        = "q";
    cX        = "x";
    cY        = "y";
    cS        = "s";
    cG        = "g";
    cM        = "m";
    cK        = "k";
    cO        = "o";
    cR        = "r";
    cW        = "w";
    cV        = "v";
    cL        = "l";
    cPERCENT  = "p";
    cCRLF     = underscore;
    cDOLLAR   = dollar;
    cPOUND    = pound;
    cQUESTION = question;
    cEXCLAM   = exclamation;
CONST
    escch       = dollar;
    fmtZ        = escch+cZ;
    fmtI        = escch+cI;
    fmtA        = escch+cA;
    fmtH        = escch+cH;
    fmtT        = escch+cT;
    fmtJ        = escch+cJ;
    fmtU        = escch+cU;
    fmtD        = escch+cD;
    fmtB        = escch+cB;
    fmtN        = escch+cN;
    fmtE        = escch+cE;
    fmtF        = escch+cF;
    fmtC        = escch+cC;
    fmtQ        = escch+cQ;
    fmtX        = escch+cX;
    fmtY        = escch+cY;
    fmtS        = escch+cS;
    fmtG        = escch+cG;
    fmtM        = escch+cM;
    fmtK        = escch+cK;
    fmtO        = escch+cO;
    fmtR        = escch+cR;
    fmtW        = escch+cW;
    fmtV        = escch+cV;
    fmtL        = escch+cL;
    fmtCRLF     = escch+cCRLF;
    fmtPERCENT  = escch+cPERCENT;
    fmtDOLLAR   = escch+cDOLLAR;
    fmtPOUND    = escch+cPOUND;
    fmtQUESTION = escch+cQUESTION;
    fmtEXCLAM   = escch+cEXCLAM;
CONST
    initpagingcounter = 1; (* account for message *)
    kbdmsg = "Hit (almost) any key to continue or Escape to abort listing : ";
    strY   = "yes";
    strN   = "no";
TYPE
    casifyType = (orgcase,uppercase,lowercase);
    attrstatetype = (dontcare,required,unwanted);
    masktype = RECORD (* D R H S A *)
        stateD,stateR,stateH,stateS,stateA : attrstatetype;
    END;
CONST
    firstattr      = 1;
    lastattr       = 5;
    allowedAttr    = "DRHSA"; (* 1..5 *)
CONST
    fakeoption     = "QD=";
    showdirstoo    = fakeoption+"D?";
    showdirsonly   = fakeoption+"D+";
    showfilesonly  = fakeoption+"D-";

(* ------------------------------------------------------------ *)

CONST
    progEXEname   = "DD32";
    progTitle     = "Q&D xDir xDel (Win32)";
    progVersion   = "v0.9f (from v1.2a for DOS)";

    (* +"-";         (* show it's not memory hungry version, eh eh... *) *)
    progCopyright = "by PhG";
    Banner        = progTitle+" "+progVersion+" "+progCopyright;
    sDDfmtEnv     = progEXEname+"FMT"; (* uppercase *)
    sDDenv        = progEXEname;    (* should match progEXEname defined infra *)

CONST
    errNone                = 0;
    errHelp                = 1;
    errOption              = 2;
    errParameter           = 3;
    errMode                = 4;
    errNetSlash            = 5;
    errPhantomUnit         = 6;
    errBadUnit             = 7;
    errColon               = 8;
    errNoParent            = 9;
    errInnerParent         = 10;
    errDirJoker            = 11;
    errStorage             = 12;
    errMissingSpec         = 13;
    errListSyntax          = 14;
    errListJoker           = 15;
    errListNotFile         = 16;
    errListNotFound        = 17;
    errJokerEntry          = 18;
    errKillThemAll         = 19;
    errNonsenseCmd         = 20;
    errNonsenseListMode    = 21;
    errNonsenseDelMode     = 22;
    errNonsenseDeltreeMode = 23;
    errNonsenseDirMode     = 24;
    errMoreHelp            = 25;
    errSection             = 26;
    errCasify              = 27;
    errBadEnv              = 28;
    errSizeRange           = 29;
    errDateRange           = 30;
    errMask                = 31;
    errEntryNotFound       = 32;
    errEntryIsFile         = 33;
    errOptionRedefined     = 34;
    errMaskSetting         = 35;
    errMaskOne             = 36;
    errFF                  = 37;
    errSort                = 38;
    errFormatRedefined     = 39;
    errEvenMoreHelp        = 40;
    errDotdot              = 41;
    errTooManyProtectedEntries      = 42;
    errTooManyColors       = 43;
    errBadColorDef         = 44;
    errInkPaper            = 45;
    errInkEsc              = 46;
    errPaperEsc            = 47;
    errColorEsc            = 48;
    errColorCode           = 49;
    errParameterFF         = 50;
    errGhostEntry          = 51;
    errJokerGhost          = 52;
    errTooManyIgnoredEntries=53;
    errEvenMoreAndMoreHelp = 54;


    errUnexpectedWhatData  = 64;  (* cannot happen *)

    errNoFileMatchFound    = 128; (* not an error *)

    errAborted             = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);

    MODULE message;
    IMPORT Str;
    EXPORT msg3;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;

CONST
    placeholder = "~";
    hbar        = "|";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msghelp=
Banner+nl+
nl+
"Syntax 1 : "+progEXEname+" [[-d]|<-f>] <filespec>... [option]..."+nl+
"Syntax 2 : "+progEXEname+" <-k|-z[z]> <filespec>... [option]..."+nl+
"Syntax 3 : "+progEXEname+" <-@> <[@]filelist["+extLST+"]> [option]..."+nl+
nl+
"-d[?][?]  list entries (default, -dd = -d -m:D!, -ddd = -dds = -d -m:D! -s)"+nl+
"-f[f]     list matching files (-s -c forced, <[u:]filename> format required)"+nl+
"-k[y]     delete files (-ky = -k -y)"+nl+
"-@        assume parameter is a list of files to be deleted (-k forced)"+nl+
"-s        recurse subdirectories (forced with -z[z])"+nl+
'-f<:$|?>  format (def="'+sDefaultPat+'") or predefined ([dtcmslv])'+nl+
"-i        inverse selection (-s not recommended, one <filespec> recommended)"+nl+
"-n        do not prompt before deleting each file or directory"+nl+
"-y        really delete files and subdirectories (default is preview/test mode)"+nl+
"-t|-y-    reset preview/test mode"+nl+
"-c[c]     show final statistics (-cc = do not list files)"+nl+
"-v[v]     show parameters (-vv = show parameters and terminate)"+nl+
"-p[p][-]  paging (-d only, -p- = disable paging,"+nl+
"          -pp[-] = -p[-] but dividing screen count of rows by 2)"+nl+
"-x        ignore existing "+progEXEname+extINI+" (protection section)"+nl+
"-xp       ignore entries specified in "+progEXEname+extINI+" (-i ignored)"+nl+
"-swaps    do not default to swapfiles protection"+nl+
'          ("'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'")'+nl+
"-w        warn about files without match instead of silently ignoring them (-d)"+nl+
"-s<?>[-]  sort listing (-sn = name, -sz = size, -sd = date, -se = extension)"+nl+
"-j|-u     force lower (-j) or upper (-u) case (-d only)"+nl+
'-&        use "'+comaUS+'" coma as number separator (default is "'+comaFR+'" dot)'+nl+
"-g[g]     directory header (-gg = display even without any <filespec>... match)"+nl+
'-d:$      filter according to specified "lower[:|..]upper" date range'+nl+
'          ("*"=today, "$"=same date, "[*]:$"=before or on, "$:[*]"=on or after)'+nl+
'-z:$      filter according to specified "lower[-|:|..]upper" size range'+nl+
'          ("#"=same, "[*]:#"=smaller or equal, "#:[*]"=greater or equal)'+nl+
"-m:$      filter according to specified attributes (<"+allowedAttr+">[-|+|?|!|x]...)"+nl+
"-a<?>[?]  set individual attribute filter (<"+allowedAttr+">[-|+|?|!|x])"+nl+
"-xdir[s]  shortcut for -d -c -m:D! [-s]"+nl+
"-xdel[s]  shortcut for -k -n -c [-s]"+nl+
"-!        filter files using operating system jokers (see infra)"+nl+
"-q        force LFN enclosing with double quotes for $d, $b, $n, $e, $f, $y"+nl+
"-$        disable ESCape polling (may be necessary with Win9X/WinXP)"+nl+
"-??[?[?]] (even) more (and more) help (to be read at least once !)"+nl;

    msgmorehelp = nl+
(*
"Examples : "+progEXEname+' c:\*.* /s /m:H+S+D? /f:"LFN : $c$_DOS : $x"'+nl+
"           "+progEXEname+" c:\tmp /z /r /y"+nl+
"           "+progEXEname+" c:\*.c c:\*.cpp /s /r /k /y"+nl+  (* I love that one ;-) *)
"           "+progEXEname+' c:\ d:\ e:\ f:\ /s /d:* /f:"copy $c g:\z" > g:\z\today.bat'+nl+
nl+
*)
'a) When in preview mode, each operation has "'+sFake+'" prefix as a reminder.'+nl+
'b) -y option can be set as default with '+sDDenv+'=Y environment variable ;'+nl+
"   preview mode can still be reset from command line with -t or -y- options."+nl+
'c) Without -! option, "?" and "*" jokers do NOT work the DOS or Win9X way :'+nl+
'   "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"d) Note joker matching includes extension if extension is omitted."+nl+
"e) Jokers are not allowed in directory part of <filespec>, nor in a list."+nl+
"f) Up to "+strMaxProtected+" entries (M2 jokers supported) may be protected against deletion,"+nl+
"   if they are specified in "+progEXEname+extINI+" file located in executable directory."+nl+
"   If such a file does not exist, these entries are protected by default :"+nl+
'   "'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'".'+nl+
"   Note protection is supported by -k and -z[z] options ONLY :"+nl+
"   files deleted from a list (-@ option) are NOT protected by this feature."+nl+
"g) Up to "+strMaxIgnored+" entries (M2 jokers supported) may be ignored"+nl+
"   if they are specified in "+progEXEname+extINI+" file located in executable directory."+nl+
"   This option may be necessary with WinXP."+nl+
"h) String -f:$ format may be predefined using "+sDDfmtEnv+'="$" environment variable.'+nl+
'i) For safety, -m:$ option should be defined for each of "'+allowedAttr+'" attributes.'+nl+
"   [-]=off, [][+]=on, [?][!][x]=on or off. -f, -k and -z[z] options force D-."+nl+
'k) With -f[f] option, each "[u:]filename" <filespec> becomes "[u:]\filename",'+nl+
'   and ".*" is appended to any legal <filespec> without an extension (128=FNF).'+nl+
(* "   Return code is 128 if no matching file was found."+nl+ *)
"j) Case-insensitive sort is global for directories but local for files."+nl+
"k) Undocumented -- option forces a terser display while processing files."+nl+
"l) -z:# supports multiples of 1024 (Kb, Mb, Gb) and of 1000 (K, M, G)."+nl+
"   Lower and upper range values will be swapped if necessary."+nl+
"m) "+placeholder+nl+
"   "+placeholder+nl+
"n) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

    msgevenmorehelp = nl+
"Tokens allowed in list mode format are :"+nl+
nl+
fmtI+hbar+fmtZ               +'        raw or formatted filesize, or "'+strSUBDIRECTORY+'"'+nl+
fmtA                      +"           file attributes"+nl+
fmtT+hbar+fmtJ+hbar+fmtW        +"     file date (dd-MMM-yyyy, dd-mm-yyyy or yyyy-mm-dd)"+nl+
fmtH+hbar+fmtO+hbar+fmtL+hbar+fmtV +'  file time (hh:mm:ss or hh:mm, hh being padded with "'+blank+'" or "0")'+nl+
fmtU                      +"           unit"+nl+
fmtD+hbar+fmtB               +'        directory with or without trailing "\"'+nl+
fmtN                      +"           file"+nl+
fmtE                      +"           extension"+nl+
fmtF                      +"           file.extension"+nl+
fmtR+hbar+fmtG               +"        right-aligned or left-aligned file.extension forced to DOS format"+nl+
fmtC                      +"           shortcut for "+fmtU+fmtD+fmtF+" (enclosed with double quotes if LFN)"+nl+
fmtX                      +"           shortcut for "+fmtU+fmtD+fmtF+" (forced to DOS format)"+nl+
fmtY                      +"           shortcut for "+fmtU+fmtD+" (files)"+" or "+fmtU+fmtD+fmtF+" (directories)"+nl+
fmtPOUND                  +"           auto-incremented ##### decimal number starting from 00001"+nl+
fmtQUESTION               +'           auto-incremented ???? string starting from "AAAA"'+nl+
fmtM+hbar+fmtS+hbar+fmtK        +"     MD5/SHA-1/CRC32 (Win<92|98|XP> swapfiles automagically skipped)"+nl+
"("+fmtQ+" = double quote, "+fmtCRLF+" = newline, "+
    fmtPERCENT+" = percent, "+fmtDOLLAR+" = dollar, "+fmtEXCLAM+" = tabulation)"+nl+
nl+
"Use of $q token is highly recommended in order to avoid unexpected side effects"+nl+
"(only $c token automagically encloses LFN with double quotes ;"+nl+
"-q option is required to force this behavior for $d|$b|$n|$e|$f|$y tokens)."+nl;

   msgevenmoreandmorehelp = nl+
"Here is an example of "+progEXEname+extINI+" file :"+nl+
nl+
sectionProtected+nl+
nl+
"; These entries will be protected against /k and /z[z] but NOT against /@."+nl+
"; M2 jokers are allowed :"+nl+
'; "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"; Entries may be enclosed with double quotes if necessary."+nl+
(* nl+ *)
'; Swap files should always be protected against "delete" commands :'+nl+
"; the One and Golden Rule of Indifference should always rule."+nl+
nl+
patSwapWin92+nl+
patSwapWin98+nl+
patSwapWinXP+nl+
nl+
"?:\"+nl+
"c:\dos\*"+nl+
'"c:\windows\*"'+nl+
'"*\index.dat"'+nl+
"*\desktop.ini"+nl+
'"?:\program files\*"'+nl+
nl+
sectionNotProtected+nl+
nl+
"; These entries will NOT be protected whatever in "+sectionProtected+"."+nl+
nl+
"c:\windows\temp\*"+nl+
"*.c"+nl+
"*.cpp"+nl+
nl+
sectionIgnored+nl+
nl+
"; These entries will be ignored if -xp option is specified."+nl+
nl+
"c:\recycled\*"+nl+
"*\assembly\*"+nl+
"?:\system volume information\*"+nl;

VAR
    S : str1024;
    SS: str4096; (* should DO *)
    p:CARDINAL;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp,errEvenMoreHelp,errEvenMoreAndMoreHelp :
        WrStr(msghelp);
        IF e # errHelp THEN
            Str.Copy(SS,msgmorehelp);

            (* now tell user about DD.INI *)

            Lib.ParamStr(S,0); (* retrieve executable location : yes, we assume it ! *)
            p:=Str.RCharPos(S,dot);
            IF p # MAX(CARDINAL) THEN S[p]:=charnull;END;
            Str.Append(S,extINI);

            IF FIO.Exists(S) THEN
                S:=progEXEname+extINI+" was found in executable directory :";
                Str.Subst(SS,placeholder,S);
                S:="protection against deletion is available for its entries (unless -x).";
            ELSE
                S:=progEXEname+extINI+" was NOT found in executable directory :";
                Str.Subst(SS,placeholder,S);
                S:="protection against deletion is limited to swapfiles (unless -swaps).";
            END;
            Str.Subst(SS,placeholder,S);
            WrStr(SS);

            CASE e OF
            | errEvenMoreHelp :
                WrStr(msgevenmorehelp);
            | errEvenMoreAndMoreHelp :
                WrStr(msgevenmorehelp);
                WrStr(msgevenmoreandmorehelp);
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
        e:=errHelp;
    | errOption :     msg3(S, "Illegal ",einfo," option !");
    | errParameter :  msg3(S, einfo," is one parameter too many"," !");
    | errMode :       S:="-d, -k and -z[z] commands are mutually exclusive !";
    | errNetSlash:    msg3(S, 'Illegal server "\\" in "',einfo,'" specification !');
    | errPhantomUnit: msg3(S, 'Unavailable unit in "',einfo,'" specification !');
    | errBadUnit:     msg3(S, 'Illegal unit in "',einfo,'" specification !');
    | errColon:       msg3(S, 'Unexpected ":" in "',einfo,'" specification !');
    | errNoParent:    msg3(S, 'Unresolvable ".." in "',einfo,'" specification !');
    | errInnerParent: msg3(S, 'Illegal ".." in "',einfo,'" specification !');
    | errDirJoker:    msg3(S, 'Illegal "',einfo,'" directory joker(s) !');
    | errStorage:     msg3(S, 'Storage.ALLOCATE() failure while processing "',einfo,'" specification !');
    | errMissingSpec: S:="No filespec was specified !";
    | errListSyntax:  S:="-@ option or @filespec format will not handle more than one list !";
    | errListJoker:   S:="-@ option or @filespec format will not handle jokers !";
    | errListNotFile: S:="-@ option or @filespec format will not handle a directory !";
    | errListNotFound:msg3(S, '"',einfo,'" list does not exist !');
    | errJokerEntry:  S:="Specified list contains at least one illegal entry !";
    | errKillThemAll: msg3(S, '-z[z] option expects "*.*" in "',einfo,'" specification !');
    | errNonsenseCmd: S:="-@, -z[z] and -d options are mutually exclusive !";
    | errNonsenseListMode:   msg3(S,einfo," option is a nonsense with -@ option"," !");
    | errNonsenseDelMode :   msg3(S,einfo," option is a nonsense with -k option"," !");
    | errNonsenseDeltreeMode:msg3(S,einfo," option is a nonsense with -z[z] option"," !");
    | errNonsenseDirMode:    msg3(S,einfo," option is a nonsense with -d option"," !");
    | errSection:     S:=progEXEname+extINI+" contains an illegal or unsupported section !";
    | errCasify:      S:="-j and -u options are mutually exclusive !";
    | errBadEnv:      msg3(S,'Illegal value in "',einfo,'" environment variable !');
    | errSizeRange  : msg3(S,"Illegal ",einfo," size range !");
    | errDateRange  : msg3(S,"Illegal ",einfo," date range !");
    | errMask  :      msg3(S,"Illegal or illogical ",einfo," attributes !");
    | errEntryNotFound: msg3(S, '"',einfo,'" specification does not exist !');
    | errEntryIsFile: msg3(S, '"',einfo,'" specification is not a directory !');
    | errOptionRedefined:msg3(S,"Illegal attempt to define ",einfo," option more than once !");
    | errMaskSetting: S:="-m:$ and -a<?>[?] options are mutually exclusive !";
    | errMaskOne  :   msg3(S,"Illegal or illogical ",einfo," individual attributes !");
    | errFF       :   msg3(S, '"',einfo,'" format is illegal with -f[f] option !');
    | errSort     :   S:="-sn?, -sz?, -sd? and -se? options are mutually exclusive !";
    | errFormatRedefined:S:="-f:$ and -f? options are mutually exclusive !";
    | errDotdot :     S:='For user safety, -z[z] option will not process ".." specification !';
    | errNoFileMatchFound: S:="No match was found !"; (* never shown *)
    | errTooManyProtectedEntries:  S:=progEXEname+extINI+" contains too many "+sectionProtected+" entries !";
    | errTooManyColors:   S:=progEXEname+extINI+" contains too many color definitions !";
    | errBadColorDef,errInkPaper,errInkEsc,
      errPaperEsc,errColorEsc,errColorCode:
                          S:=progEXEname+extINI+" contains an illegal color definition !";
    | errParameterFF :  msg3(S, "Unpacked -f[f] ",einfo," makes one parameter too many !");
    | errGhostEntry  :  S:='Specified list contains at least one "not found" entry !';
    | errJokerGhost  :  S:='Specified list contains at least one illegal or "not found" entry !';
    | errTooManyIgnoredEntries:  S:=progEXEname+extINI+" contains too many "+sectionIgnored+" entries !";

    | errUnexpectedWhatData:S:="Unexpected whatdata passed to initIniData() !"; (* cannot happen *)

    | errAborted:     S:="Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp, errNoFileMatchFound : ;
    | errJokerEntry,errGhostEntry,errJokerGhost,errAborted:
        WrLn; (* uselessly beautify display *)
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    ELSE
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;

    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    firstioBufferByte = 1;
    lastioBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstioBufferByte..lastioBufferByte] OF SYSTEM.BYTE;
VAR
    lstBuffer : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    HUGECARD = LONGREAL;
CONST
    HUGEZERO = 0.0;

PROCEDURE HUGEINC (VAR r:HUGECARD;n:HUGECARD );
BEGIN
    r := r + n;
END HUGEINC;

PROCEDURE nicefmthc (v : HUGECARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.FixRealToStr( LONGREAL(v),0,S,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END nicefmthc;

PROCEDURE nicefmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END nicefmtlc;

(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO CARDINAL( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmt (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmt;

(* adapted from FCOMP v1.3c *)

PROCEDURE nice (useLFN:BOOLEAN;S:pathtype):pathtype;
VAR
    R:pathtype;
BEGIN
    IF useLFN THEN
        Str.Concat(R,dquote,S);
        Str.Append(R,dquote);
    ELSE
        Str.Copy(R,S);
    END;
    RETURN R;
END nice;

PROCEDURE showmem(S:ARRAY OF CHAR );
BEGIN
    ;
END showmem;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //FIXME *)

CONST
    CHKEVERY9X = 128; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 8;  (* safety *)

PROCEDURE pollEscape (VAR chkrounds:CARDINAL; useLFN,ignoreESC:BOOLEAN):BOOLEAN;
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomely hangs till a keypress
    Flushkey() does NOT help
    *)
    (*
    IF useLFN THEN
        hit:=FALSE;
    ELSE
        hit:=ChkEscape();
    END;
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    IF useLFN THEN
        every:=CHKEVERY9X;
    ELSE
        every:=CHKEVERYDOS;
    END;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEscape;

(* ------------------------------------------------------------ *)

CONST (* reverse storage logic ! *)
    keyEscape  = 01B00H;
    keySpace   = 02000H;
    keyCR      = 00D00H;

(* note we use IO as QD_Box Waitkey *)

PROCEDURE getKeyboardCode (VAR keycode:CARDINAL):BOOLEAN;
VAR
    c1,c2:CHAR;
BEGIN
    IF IO.KeyPressed()=FALSE THEN RETURN FALSE; END;
    c1 := IO.RdKey();
    IF c1 = CHR(0) THEN
        c2 := IO.RdKey();
    ELSE
        c2 := CHR(0);
    END;
    keycode := (ORD(c1) << 8) + ORD(c2);
    RETURN TRUE;
END getKeyboardCode;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* trim and remove double quotes *)

PROCEDURE preprocessLine (VAR S:ARRAY OF CHAR); (* was pathtype *)
VAR
    len:CARDINAL;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    (* we could use Str.Match(S,dquote+"*"+dquote) but... *)
    len:=Str.Length(S);
    IF len < 2 THEN RETURN; END; (* at least 1+1 for possible dquote+dquote *)
    IF S[len-1] # dquote THEN RETURN; END;
    IF S[0] # dquote THEN RETURN; END;
    S[len-1]:=charnull;
    Str.Delete(S,0,1);
    (* just in case *)
    LtrimBlanks(S);
    RtrimBlanks(S);
END preprocessLine;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* clever is not always faster : dynamic string allocation is much slower here -- and yes, we've tried it *)

VAR
    entryFlagProtected : ARRAY [minProtected..maxProtected] OF BOOLEAN;
    entryprotected     : ARRAY [minProtected..maxProtected] OF pathtype;
    lastEntryProtected : CARDINAL; (* globerk *)
    entryignored       : ARRAY [minIgnored..maxIgnored] OF pathtype;
    lastIgnored        : CARDINAL;

PROCEDURE initIniSafety (  );
BEGIN
    lastEntryProtected := minProtected-1;
    lastIgnored        := minIgnored-1;
END initIniSafety;

(*
    returns true if we can store it because it's either allowed or not protected
    note SBASE should be an empty string if S is not a file
*)

PROCEDURE chkNoProtection (verbose,isdir:BOOLEAN;SBASE,S:pathtype):BOOLEAN;
VAR
    last,i,pass:CARDINAL;
    result,wantedflag,showme:BOOLEAN;
    msg:str16;
BEGIN
    last:=lastEntryProtected;
    IF last < minProtected THEN RETURN TRUE; END;

    Str.Prepend(S,SBASE); (* //V12 *)
    LowerCaseAlt(S);

    FOR pass:=1 TO 2 DO
        CASE pass OF
        | 1 : wantedflag:=FALSE; result:=TRUE;   (* first, check allowed *)
              showme:=FALSE; (* no message if merely allowed exception *)
        | 2 : wantedflag:=TRUE;  result:=FALSE;  (* then check protected *)
              IF isdir THEN
                  msg:=sProtectedDir;
              ELSE
                  msg:=sProtectedFile;
              END;
              showme:=verbose;
        ELSE ; (* //ISO fixed silly requirement *) END;

        i:=minProtected-1;
        LOOP
            INC(i);
            IF i > last THEN EXIT; END;
            IF entryFlagProtected[i]=wantedflag THEN
                IF Str.Match(S,entryprotected[i]) THEN
                    IF showme THEN WrStr(msg); WrStr(S); WrLn; END;
                    RETURN result;
                END;
            END;
        END;
    END;
    RETURN TRUE;
END chkNoProtection;

(*
    returns true if entry is to be ignored -- verbose could be debug
    note SBASE should be an empty string if S is not a file
*)

PROCEDURE chkIgnoreMe (verbose,isdir:BOOLEAN;SBASE,S:pathtype):BOOLEAN;
VAR
    last,i:CARDINAL;
    showme:BOOLEAN;
    msg:str16;
BEGIN
    verbose:=FALSE; (* after all, we do not want to see ignored entries ! *)

    last:=lastIgnored;
    IF last < minIgnored THEN RETURN FALSE; END;

    Str.Prepend(S,SBASE); (* //V12 *)
    LowerCaseAlt(S);

    IF isdir THEN
        msg:=sIgnoredDir;
    ELSE
        msg:=sIgnoredFile;
    END;
    showme:=verbose;

    i:=minProtected-1;
    LOOP
        INC(i);
        IF i > last THEN EXIT; END;
        IF Str.Match(S,entryignored[i]) THEN
            IF showme THEN WrStr(msg); WrStr(S); WrLn; END;
            RETURN TRUE;
        END;
    END;
    RETURN FALSE;
END chkIgnoreMe;

(*
             ignoreini    forceswapfilesprotection
default      FALSE        TRUE
-swap        ?            FALSE
-x           TRUE         ?

if ini exists, its content override default protection unless -x was specified
if no ini, swapfiles protected unless -swaps
*)

PROCEDURE swapfilesprotectionFIX (forceswapfilesprotection,inihere,ignoreini:BOOLEAN):BOOLEAN;
BEGIN
    IF inihere THEN
        IF NOT(ignoreini) THEN
            forceswapfilesprotection:=FALSE; (* override possible default : user is responsible for ini entries *)
        END;
    END;
    RETURN forceswapfilesprotection;
END swapfilesprotectionFIX;

(* ------------------------------------------------------------ *)

PROCEDURE initIniData (VAR lastentry,lastignoredpat:CARDINAL;
                      whatdata:CARDINAL;
                      ignoreini,forceswapfilesprotection,
                      useLFN,DEBUG:BOOLEAN):CARDINAL;
VAR
    ini,udne : pathtype;
    hin:FIO.File;
    i,p,whatproblem:CARDINAL;
    S,Z:str1024; (* str80 was enough for colors but now we also get pathtype *)
    inihere,flagProtected:BOOLEAN;
    R:str128;
    here,inkhere,paperhere:BOOLEAN;
    escch,ch:CHAR;
    state : (waiting,grabProtected,grabNotProtected,grabIgnored);
BEGIN
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=FIO.Exists(ini);

    CASE whatdata OF
    | dataProtection:
         forceswapfilesprotection:=swapfilesprotectionFIX(forceswapfilesprotection, inihere,ignoreini);
         lastentry := minProtected-1;
         IF forceswapfilesprotection THEN
             FOR i:= 1 TO 3 DO
                 CASE i OF
                 | 1: S:=patSwapWin92;
                 | 2: S:=patSwapWin98;
                 | 3: S:=patSwapWinXP;
                 ELSE ; (* //ISO fixed silly requirement *) END;
                 INC(lastentry);
                 Str.Copy(entryprotected[lastentry],S);
                 entryFlagProtected[lastentry]:=TRUE;
             END;
        END;
        IF ignoreini THEN RETURN errNone; END;
        IF NOT(inihere) THEN RETURN errNone; END;
    | dataIgnored:
        lastignoredpat:=minIgnored-1;
        IF NOT(inihere) THEN RETURN errNone; END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    state:=waiting;

    hin:=FIO.OpenRead(ini);
    FIO.AssignBuffer(hin,lstBuffer);

    whatproblem:=errNone;

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;

        preprocessLine (S);

        CASE S[0] OF
        | CHR(0), semicolon,pound :
            ;
        | openbracket:
            i:=getStrIndex(delim, S, sectionProtected+delim+
                                     sectionNotProtected+delim+
                                     sectionIgnored);
            CASE i OF
            | 1: IF whatdata=dataProtection THEN
                     state:=grabProtected;    flagProtected:=TRUE;
                 ELSE
                     state:=waiting;
                 END;
            | 2: IF whatdata=dataProtection THEN
                     state:=grabNotProtected; flagProtected:=FALSE;
                 ELSE
                     state:=waiting;
                 END;
            | 3: IF whatdata=dataIgnored THEN
                     state:=grabIgnored;
                 ELSE
                     state:=waiting;
                 END;
            ELSE
                (* //V11O was too rigorous after all
                whatproblem:=errSection;
                EXIT;
                *)
                state:=waiting;
            END;
        ELSE
            CASE state OF
            | waiting: ;
            | grabProtected,grabNotProtected: (* S is udne *)
                LowerCaseAlt(S); (* keep accents *)
                INC(lastentry);
                IF lastentry > maxProtected THEN
                    whatproblem:=errTooManyProtectedEntries;
                    EXIT;
                END;
                Str.Copy(entryprotected[lastentry],S);
                entryFlagProtected[lastentry]:=flagProtected;
                IF DEBUG THEN
                    IF flagProtected THEN
                        Z:="~ ~ (protected) : ~";
                    ELSE
                        Z:="~ ~ (allowed)   : ~";
                    END;
                    Str.Subst(Z,"~","Entry");
                    i:=lastentry;
                    Str.Subst(Z,"~",fmt(i,10,2," ",""));
                    Str.Subst(Z,"~",nice(useLFN, pathtype(S) ));
                    WrStr(Z);WrLn;
                END;
            | grabIgnored: (* S is mask *)
                LowerCaseAlt(S); (* keep accents *)
                INC(lastignoredpat);
                IF lastignoredpat > maxIgnored THEN
                    whatproblem:=errTooManyIgnoredEntries;
                    EXIT;
                END;
                Str.Copy(entryignored[lastignoredpat],S);
                IF DEBUG THEN
                    Z:="Ignored entry ~ : ~";
                    i:=lastignoredpat;
                    Str.Subst(Z,"~",fmt(i,10,2," ",""));
                    Str.Subst(Z,"~",nice(useLFN, pathtype(S) ));
                    WrStr(Z);WrLn;
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    FIO.Close(hin);
    RETURN whatproblem;
END initIniData;

(* ------------------------------------------------------------ *)

PROCEDURE dmpProtected (useLFN,cr:BOOLEAN;lastentry:CARDINAL );
VAR
    last,i:CARDINAL;
    R:str80;
    S:pathtype;
    flagProtected:BOOLEAN;
BEGIN
    IF lastentry < minProtected THEN RETURN; END;
    IF cr THEN WrLn;END;
        last:=lastentry;
        i:=minProtected;
        LOOP
            IF i > last THEN EXIT; END;
            S:=entryprotected[i];
            flagProtected:=entryFlagProtected[i];
            IF flagProtected THEN
                R:="Entry ~ (protected) : ";
            ELSE
                R:="Entry ~ (allowed)   : ";
            END;
            Str.Subst(R,"~",fmt(i,10,2," ","") );
            WrStr(R);
            WrStr( nice(useLFN,S));WrLn;
            INC(i);
        END;
END dmpProtected;

PROCEDURE dmpIgnored (useLFN,cr:BOOLEAN;lastentry:CARDINAL   );
VAR
    last,i:CARDINAL;
    R:str80;
    S:pathtype;
BEGIN
    IF lastentry < minIgnored THEN RETURN; END;
    IF cr THEN WrLn;END;
        last:=lastentry;
        i:=minIgnored;
        LOOP
            IF i > last THEN EXIT; END;
            S:=entryignored[i];
            R:="Ignored entry ~ : ";
            Str.Subst(R,"~",fmt(i,10,2," ","") );
            WrStr(R);
            WrStr( nice(useLFN,S));WrLn;
            INC(i);
        END;
END dmpIgnored;

(* uses globerks *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* current is "\" or "\*\" *)

PROCEDURE buildParent (VAR parent:pathtype; current:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(current,"\") THEN RETURN FALSE; END;
    unfixDirectory(current);
    p:=Str.RCharPos(current,"\");
    Str.Slice(parent,current,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END buildParent;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(*
    remember dirs can have an extension, and LFNs can have inner dots !

    we handle (whether u: or not) :

    .        current
    ..       parent
    .\xxx    current\xxx       F/D
    ..\xxx   parent\xxx        F/D

    xxx\     current\xxx\
    xxx\.    current\xxx\
    xxx      current\xxx       F/D

    \xxx\    \xxx\
    \xxx     \xxx              F/D
*)

PROCEDURE chkfixSpec (VAR base,spec:pathtype;
                     useLFN:BOOLEAN;orgS:pathtype):CARDINAL;
VAR
    p,len,rc:CARDINAL;
    drive:SHORTCARD;
    u:CHAR;
    unit:str2;
    current,parent,S:pathtype;
    ok:BOOLEAN;
BEGIN
    Str.Copy(S,orgS);
    IF Str.Pos(S,"\\") # MAX(CARDINAL) THEN RETURN errNetSlash;END;

    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
        rc:=errNone;
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                (*
                IF verifyString(u,HDletters) THEN
                *)
                    drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                    Str.Delete(S,0,2); (* remove u: *)
                    rc:=errNone;
                (*
                ELSE
                    rc:=errPhantomUnit;
                END;
                *)
            ELSE
                rc:=errBadUnit;
            END;
        ELSE
            rc:=errColon;
        END;
    ELSE
        rc:=errColon;
    END;
    IF rc # errNone THEN RETURN rc; END;

    (* note S no longer has u: *)

    doGetCurrent(useLFN,drive, unit,current); (* "u:" and "\" or "\*\" *)
    ok:=buildParent(parent, current);

    IF same(S,".") THEN Str.Copy(S,current);END;
    IF same(S,"..") THEN
        IF ok THEN Str.Copy(S,parent) ELSE RETURN errNoParent; END;
    END;
    IF Str.Match(S,".\*") THEN Str.Subst(S,".\",current); END;
    IF Str.Match(S,"..\*") THEN
        IF ok THEN Str.Subst(S,"..\",parent) ELSE RETURN errNoParent;END;
    END;
    IF Str.Match(S,"\*")=FALSE THEN Str.Prepend(S,current);END;
    IF Str.Match(S,"*\.") THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    IF Str.Match(S,"*\") THEN
        Str.Concat(base,unit,S);
        Str.Copy(spec,"*.*");
    ELSE
        Str.Prepend(S,unit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,"\");
        Str.Slice(base,S,0,p+1);
        Str.Slice(spec,S,p+1,len-p);
        IF chkJoker(spec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF isDirectorySpec(S) THEN
                Str.Copy(base,S);
                fixDirectory(base); (* safety *)
                Str.Copy(spec,"*.*");
            ELSE
                (* //FIXED hopefully : either entry not found, or found a file *)
                IF FIO.Exists(S) THEN
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,"."); (* file extension *)
                    END;
                    RETURN errEntryIsFile;
                ELSE
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,".*");
                        Str.Append(S   ,".*");
                    END;
                    IF FIO.Exists(S) THEN
                        RETURN errEntryIsFile;
                    ELSE
                        RETURN errEntryNotFound;
                    END;
                END;
            END;
        END;
    END;
    IF chkJoker(base) THEN RETURN errDirJoker; END;
    (* //FIXED hopefully *)
    IF Str.Length(base) > 3 THEN (* "u:\" is assumed to always exist *)
        unfixDirectory(base);
        IF FIO.Exists(base)=FALSE THEN RETURN errEntryNotFound;END;
        fixDirectory(base);
    END;
    RETURN errNone;
END chkfixSpec;

PROCEDURE splitFileExt (VAR f,e:pathtype;S:pathtype):BOOLEAN;
VAR
   p:CARDINAL;
BEGIN
    p:=Str.RCharPos(S,".");
    CASE p OF
    | 0 :
        RETURN FALSE; (* nonsense : extension without file ! *)
    | MAX(CARDINAL) :
        Str.Copy(f,S);
        Str.Copy(e,"");
    ELSE
        Str.Slice(f,S,0,p);
        Str.Copy(e,S);
        Str.Delete(e,0,p+1);
    END;
    RETURN TRUE;
END splitFileExt;

(* ------------------------------------------------------------ *)

CONST
    firstEntry = 1; (* 1..count *)
    INDEXROOT  = 0; (* flag for root *)
    DIRDONE    = MAX(SHORTCARD); (* 20 parameters *)

TYPE
    pDirEntry = POINTER TO direntryType;
    direntryType = RECORD
        next      : pDirEntry;
        specindex : SHORTCARD; (* 1=spec1, 2=spec2, etc., DIRDONE=processed *)
        dirndxflag: CARDINAL;  (* 0=root any madman with more than 65535 dirs ? *)
        index     : CARDINAL;  (* 1.. for sort *)
        slen      : SHORTCARD;
        str       : CHAR;
        (*
        yes, a mere bit would do for rootflag, etc.
        WE DONT CARE ! asm days are DEAD ! even Apple ][ is DEAD ! :-(
        besides, in a Vindoze world, why care about speed and efficiency ?
        *)
    END;

PROCEDURE initDirList (VAR anchor : pDirEntry );
BEGIN
    anchor := NIL;
END initDirList;

PROCEDURE freeDirList (anchor : pDirEntry);
VAR
    needed : CARDINAL;
    p      : pDirEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(direntryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeDirList;

PROCEDURE buildNewDirPtr (VAR anchor,p:pDirEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(direntryType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewDirPtr;

(* assume p is valid *)

PROCEDURE getDirStr (VAR S : pathtype; p:pDirEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getDirStr;

PROCEDURE findMatchID (VAR p : pDirEntry;
                      anchor:pDirEntry;wanted:CARDINAL;IDwanted:LONGCARD):BOOLEAN;
BEGIN
    p:=anchor;
    WHILE anchor # NIL DO
        IF p^.specindex = SHORTCARD(wanted) THEN RETURN TRUE; END;
        p:=anchor^.next;
        anchor:=p;
    END;
    p:=NIL; (* added safety *)
    RETURN FALSE;
END findMatchID;

(* ------------------------------------------------------------ *)

TYPE
    pFileEntry = POINTER TO fileentryType;
    fileentryType = RECORD
        next      : pFileEntry;
        fsize     : LONGCARD;
        fattr     : FIO.FileAttr;
        fdate     : CARDINAL;
        ftime     : CARDINAL;
        index     : CARDINAL;  (* 1.. for sort *)
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initFileList (VAR anchor : pFileEntry );
BEGIN
    anchor := NIL;
END initFileList;

PROCEDURE freeFileList (anchor : pFileEntry);
VAR
    needed : CARDINAL;
    p      : pFileEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fileentryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeFileList;

PROCEDURE buildNewFilePtr (VAR anchor,p:pFileEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fileentryType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewFilePtr;

(* assume p is valid *)

PROCEDURE getFileStr (VAR S : pathtype; p:pFileEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getFileStr;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    diranchor:pDirEntry;    (* globerk from v1.0d *)
    fileanchor:pFileEntry;

PROCEDURE findDirByIndex(n:CARDINAL):pDirEntry;
VAR
    p:pDirEntry;
BEGIN
    p := diranchor;
    LOOP
        IF p = NIL THEN EXIT;END; (* gloups ! should NEVER happen ! *)
        IF p^.index = n THEN EXIT; END;
        p := p^.next;
    END;
    RETURN p;
END findDirByIndex;

PROCEDURE findFileByIndex(n:CARDINAL):pFileEntry;
VAR
    p:pFileEntry;
BEGIN
    p := fileanchor;
    LOOP
        IF p = NIL THEN EXIT;END; (* gloups ! should NEVER happen ! *)
        IF p^.index = n THEN EXIT; END;
        p := p^.next;
    END;
    RETURN p;
END findFileByIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    globalPrivateDirListMsg : pathtype; (* shame on you ! *)

PROCEDURE setCosmeticHackForPossibleProtection (S:pathtype);
BEGIN
    Str.Copy(globalPrivateDirListMsg, S);
END setCosmeticHackForPossibleProtection;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildDirList (VAR anchor:pDirEntry; VAR dirndxflag,lastdir: CARDINAL;
                       useLFN,recurse,dumpedmsg:BOOLEAN;
                       whatspec:CARDINAL;base:pathtype):CARDINAL;
VAR
    p: pDirEntry;
    len : CARDINAL;
    root,rootspec,entryname,newroot : pathtype;
    entry : FIO.DirEntry;
    found : BOOLEAN;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    rc : CARDINAL;
    ok:BOOLEAN;
BEGIN
    Str.Copy(root,base);
    fixDirectory(root); (* safety *)

    (* assume base exists ! *)

    IF dumpedmsg THEN video(globalPrivateDirListMsg,FALSE); END;
    ok:=chkNoProtection(TRUE,TRUE,"",root); (* show,isdir   empty base *)
    IF chkIgnoreMe(TRUE,TRUE,"",root) THEN ok:=FALSE;END; (* empty base *)
    IF dumpedmsg THEN video(globalPrivateDirListMsg,TRUE);  END;

    IF ok THEN
        len:=Str.Length(root);
        IF buildNewDirPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
        p^.specindex := SHORTCARD (whatspec);
        p^.dirndxflag:= dirndxflag;
        INC(lastdir);
        p^.index     := lastdir;
        p^.slen      := SHORTCARD(len);
        Lib.FastMove ( SYSTEM.ADR(root),SYSTEM.ADR(p^.str),len );
    END;

    IF NOT(recurse) THEN RETURN errNone; END;

    IF ok THEN INC(dirndxflag); END;

    Str.Concat(rootspec,root,"*.*");
    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;
            IF (aDD IN dosattr) THEN
                Str.Concat(newroot,root,entryname); (* u:\xx\ + xxx *)
                fixDirectory(newroot);
                rc:= buildDirList (anchor,dirndxflag,lastdir, useLFN,recurse,dumpedmsg,whatspec,newroot);
                IF rc # errNone THEN
                    RETURN rc;
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END buildDirList;

(* ------------------------------------------------------------ *)

(*
    attrstatetype = (dontcare,required,unwanted);
    masktype = RECORD (* D R H S A *)
        stateD,stateR,stateH,stateS,stateA : attrstatetype;
    END;
*)

PROCEDURE matchMask (attr:FIO.FileAttr ; m:masktype):BOOLEAN ;
VAR
    i,pb:CARDINAL;
    here:BOOLEAN;
    status:attrstatetype;
BEGIN
    pb:=0;
    FOR i:=firstattr TO lastattr DO
        CASE i OF
        | 1 : here:=( aDD IN attr ); status := m.stateD;
        | 2 : here:=( aR IN attr ); status := m.stateR;
        | 3 : here:=( aH IN attr ); status := m.stateH;
        | 4 : here:=( aS IN attr ); status := m.stateS;
        | 5 : here:=( aA IN attr ); status := m.stateA;
        ELSE ; (* //ISO fixed silly requirement *) END;
        CASE status OF
        | dontcare: ;
        | required: IF NOT(here) THEN INC(pb); END;
        | unwanted: IF here      THEN INC(pb); END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN (pb=0);
END matchMask;

PROCEDURE storeFiles (VAR lastfile:CARDINAL; VAR fileanchor : pFileEntry;
                     pdir:pDirEntry;
                     useLFN,inverse,sizerange,daterange,osjokers:BOOLEAN;
                     losize,hisize:LONGCARD; lodate,hidate:CARDINAL;
                     maskfilter : masktype;
                     whatspec:CARDINAL;spec:pathtype):CARDINAL;
VAR
    matchspec,base,rootspec,entryname : pathtype;
    dosattr:FIO.FileAttr;
    entry : FIO.DirEntry;
    ok,keepit,found : BOOLEAN;
    len:CARDINAL;
    pp:pFileEntry;
    fsize:LONGCARD;
    stampdate,stamptime:CARDINAL;
BEGIN
    lastfile := firstEntry-1; (* 0 as fcount *)

    getDirStr(base,pdir);

    IF osjokers THEN
        Str.Concat(rootspec,base,spec);
        Str.Copy(matchspec,"*");         (* match everything *)
    ELSE
        Str.Concat(rootspec,base,"*.*"); (* was spec before osjoker option *)
        Str.Copy(matchspec,spec);
    END;

    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;
            fsize     := entry.sizeL;
            stampdate := entry.datePkd;

            (* some time, be more clever here -- er... let's try to be, at least *)

            ok:=matchMask(dosattr,maskfilter);

            IF sizerange THEN (* nonsense with dirs *)
                keepit:=NOT ( (fsize < losize) OR (fsize > hisize) );
                ok := (ok AND keepit);
            END;
            IF daterange THEN
                keepit:=NOT ( (stampdate < lodate) OR (stampdate > hidate) );
                ok := (ok AND keepit);
            END;

            IF ok THEN
                (* if file has no extension, add it as a marker : valid for LFN and DOS *)
                (* //FIXME : what about directories ? *)
                IF Str.RCharPos(entryname,dot)=MAX(CARDINAL) THEN
                    Str.Append(entryname,dot);
                END;
                ok:=Str.Match(entryname,matchspec); (* was spec *)
                IF inverse THEN ok:=NOT(ok); END;

                ok:=(ok AND chkNoProtection(TRUE,FALSE,base,entryname) ); (* show,isdir *)
                IF chkIgnoreMe(TRUE,FALSE,base,entryname) THEN ok:=FALSE;END;

                IF ok THEN
                    len:=Str.Length(entryname);
                    IF buildNewFilePtr(fileanchor,pp,len)=FALSE THEN
                        RETURN errStorage;
                    END;
                    (* fsize and stampdate filled earlier now *)
                    stamptime := entry.timePkd;

                    pp^.fsize     := fsize;
                    pp^.fattr     := dosattr;
                    pp^.fdate     := stampdate;
                    pp^.ftime     := stamptime;
                    INC(lastfile);
                    pp^.index     := lastfile;
                    pp^.slen      := SHORTCARD(len);
                    Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END storeFiles;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dmpDirs (anchor:pDirEntry;wanted:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = "&&& spec= ~  dirndx= ~  index= ~  ~"; (* file must always be last with this placeholder *)
VAR
    p : pDirEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=anchor;
    WHILE p # NIL DO
        ok:= (p^.specindex = SHORTCARD(wanted) );
        IF ok THEN
            Str.Copy(S, sInfo);
            Str.Subst(S,"~",fmt( CARDINAL(p^.specindex),10,2," ",""));
            Str.Subst(S,"~",fmt(p^.dirndxflag,10,5," ",""));
            Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
            getDirStr(R,p);
            Str.Subst(S,"~", nice(useLFN,R) );
            WrStr(S);WrLn;
        END;
        p:=p^.next;
    END;
END dmpDirs;

PROCEDURE dmpDirsAlt (anchor:pDirEntry;lastdir:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = "&&& SPEC= ~  DIRNDX= ~  INDEX= ~  ~"; (* uppercase to remind it's alt proc *)
VAR
    p : pDirEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
    i:CARDINAL;
BEGIN
    FOR i:=firstEntry TO lastdir DO
        p:=findDirByIndex(i);
            Str.Copy(S, sInfo);
            Str.Subst(S,"~",fmt( CARDINAL(p^.specindex),10,2," ",""));
            Str.Subst(S,"~",fmt(p^.dirndxflag,10,5," ",""));
            Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
            getDirStr(R,p);
            Str.Subst(S,"~", nice(useLFN,R) );
            WrStr(S);WrLn;
    END;
END dmpDirsAlt;

PROCEDURE dmpFiles (VAR bytecount:HUGECARD;VAR filecount,dircount:LONGCARD;
                   anchor:pFileEntry;pdir:pDirEntry;wanted:CARDINAL;useLFN:BOOLEAN);
CONST
     sInfo    = "&&& spec= ~  ";
     sInfoFile= "&&& index= ~    ";
VAR
    p : pFileEntry;
    base,R: pathtype;
    S:str128;
BEGIN
    Str.Copy(S,sInfo);
    Str.Subst(S,"~",fmt ( wanted,10, 2," ","") );
    WrStr(S);
    getDirStr(base,pdir);
    WrStr(nice(useLFN,base));WrLn;

    p:=anchor;
    WHILE p # NIL DO

        IF (aDD IN p^.fattr) THEN
            INC(dircount);
        ELSE
            INC(filecount);
            HUGEINC(bytecount, HUGECARD(p^.fsize));
        END;

        Str.Copy(S,sInfoFile);
        Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
        WrStr(S);
        getFileStr(R,p);
        Str.Prepend(R,base);
        WrStr(nice(useLFN,R));WrLn;
        p:=p^.next;
    END;
END dmpFiles;

PROCEDURE dmpFilesAlt (VAR bytecount:HUGECARD;VAR filecount,dircount:LONGCARD;
                   anchor:pFileEntry;pdir:pDirEntry;lastfile:CARDINAL;useLFN:BOOLEAN);
CONST
     sInfo    = "&&& ";
     sInfoFile= "&&& index= ~    ";
VAR
    p : pFileEntry;
    base,R: pathtype;
    S:str128;
    i:CARDINAL;
BEGIN
    Str.Copy(S,sInfo);
    WrStr(S);
    getDirStr(base,pdir);
    WrStr(nice(useLFN,base));WrLn;

    FOR i:=firstEntry TO lastfile DO
        p:=findFileByIndex(i);

        IF (aDD IN p^.fattr) THEN
            INC(dircount);
        ELSE
            INC(filecount);
            HUGEINC(bytecount, HUGECARD(p^.fsize));
        END;

        Str.Copy(S,sInfoFile);
        Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
        WrStr(S);
        getFileStr(R,p);
        Str.Prepend(R,base);
        WrStr(nice(useLFN,R));WrLn;
    END;
END dmpFilesAlt;

PROCEDURE getEnvVar (VAR R:ARRAY OF CHAR; envvar:ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    Lib.EnvironmentFind(envvar, R);
    RtrimBlanks(R);
    LtrimBlanks(R);
    IF same(R,"") THEN RETURN; END;
    IF Str.Match(R, dquote+"*"+dquote) THEN
        Str.Delete(R,0,1);
        p:=Str.RCharPos(R,dquote);
        Str.Delete(R,p,1);
    END;
END getEnvVar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE padded (field:INTEGER;S:ARRAY OF CHAR):str80;
CONST
    pad = " ";
VAR
    R:str80;
    len:CARDINAL;
BEGIN
    Str.Copy(R,S);
    len:=Str.Length(R);
    WHILE (INTEGER(len) < ABS(field) ) DO
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
        INC(len);
    END;
    RETURN R;
END padded;

(*
Year stored relative to 1980 (ex. 1988 stores as 8)
    year      month    day   

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    yyMask=BITSET{9..15};
    yyShft=9;
    mmMask=BITSET{5..8};
    mmShft=5;
    ddMask=BITSET{0..4};
    ddShft=0;
    mindd=1;
    maxdd=31;
    minmm=1;
    maxmm=12;
    minyy=1980; (* base year for messdos *)
    maxyy=minyy+127; (* was 2099 *)
    baseyear=minyy;  (* 1980 *)

PROCEDURE PackDMY (d,m,y : CARDINAL  ) : CARDINAL;
BEGIN
    IF y < baseyear THEN
        y:=baseyear;
    END;
    DEC(y,baseyear);
    IF y > 127 THEN y:=127; END; (* %1111111 i.e. $7f max *)
    y := y << yyShft;
    m := m << mmShft;
    RETURN (y + m + d);
END PackDMY;

PROCEDURE UnpackDMY (dmy:CARDINAL;VAR d,m,y:CARDINAL);
BEGIN
    y := CARDINAL(BITSET(dmy) * yyMask) >> yyShft;
    m := CARDINAL(BITSET(dmy) * mmMask) >> mmShft;
    d := CARDINAL(BITSET(dmy) * ddMask) >> ddShft;
    INC(y,baseyear);
END UnpackDMY;

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str80;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str80;
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

CONST
    dateplain = 0; (* dd-MMM-yyyy *)
    datestd   = 1; (* dd-mm-yyyy *)
    daterev   = 2; (* yyyy-mm-dd *)

PROCEDURE fmtDate (dmy:CARDINAL;datefmt:CARDINAL) : str16;
CONST
    tokday    = "~";
    tokmonth  = "@";
    tokmois   = "$";
    tokyear   = "!";
    separator = dash;
    pad       = "0";
    baseyear  = 1900;
    tmonths   = "Jan Fv Mar Avr Mai Jun Jui Ao Sep Oct Nov Dc ???";
    tmonths2  = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec ???";
VAR
    R,S: str16;
    d,m,y:CARDINAL;
BEGIN
    UnpackDMY(dmy,d,m,y);
    IF ((m < minmm) OR (m > maxmm)) THEN m := 13; END;
    S:="";
    CASE datefmt OF
    | dateplain: R:=tokday +separator+tokmois +separator+tokyear;
                 Str.ItemS(S,tmonths2," ",m-1);
    | datestd:   R:=tokday +separator+tokmonth+separator+tokyear;
    | daterev:   R:=tokyear+separator+tokmonth+separator+tokday;
    ELSE
                 R:="??"+separator+"???"+separator+"????";
    END;
    Str.Subst(R,tokday   ,   using(d,2,pad));
    Str.Subst(R,tokmonth ,   using(m,2,pad));
    Str.Subst(R,tokyear  ,   using(y,4,pad));
    Str.Subst(R,tokmois  ,   S);

    RETURN R;
END fmtDate;

(*
Seconds are 0 to 29 -- DOS stores nearest even / 2
  hours    minutes   seconds 

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    timelong     = 0;
    timestd      = 1;
    timelongzero = 2;
    timestdzero  = 3;

PROCEDURE fmtTime (timedata:CARDINAL;timefmt:CARDINAL) : str16;
CONST
    hhMask=BITSET{11..15};
    hhShft=11;
    mmMask=BITSET{5..10};
    mmShft=5;
    ssMask=BITSET{0..4};
    ssShft=0;
CONST
    tokhh     = "~";
    tokmm     = "@";
    tokss     = "$";
    tokHZ     = "!";
    separator = colon;
    padhours  = blank;
    pad       = "0";
VAR
    h,m,s : CARDINAL;
    R : str16;
BEGIN
    h := CARDINAL(BITSET(timedata) * hhMask) >> hhShft;
    m := CARDINAL(BITSET(timedata) * mmMask) >> mmShft;
    s := CARDINAL(BITSET(timedata) * ssMask) >> ssShft;
    s := s << 1; (* FIXED ! yes, yes, "* 2" works too... *)

    CASE timefmt OF
    | timelong    : R:=tokhh+separator+tokmm+separator+tokss;
    | timestd     : R:=tokhh+separator+tokmm;
    | timelongzero: R:=tokHZ+separator+tokmm+separator+tokss;
    | timestdzero : R:=tokHZ+separator+tokmm;
    ELSE
                 R:="??"+separator+"??"+separator+"??";
    END;

    Str.Subst(R, tokhh, using(h,2,padhours) );
    Str.Subst(R, tokmm, using(m,2,pad));
    Str.Subst(R, tokss, using(s,2,pad));
    Str.Subst(R, tokHZ, using(h,2,pad) );

    RETURN R;
END fmtTime;

PROCEDURE fmtSize (v:LONGCARD;pad,sep:CHAR;isdir:BOOLEAN):str16;
CONST
    field = 10+3; (* "#,###,###,###" *) (* what if file is one giga+, eh ? *)
VAR
    S,R   : str16;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    IF isdir THEN
        S   := strSUBDIRECTORY;
        sep := "";
    ELSE
        Str.CardToStr(v,S,10,ok);
    END;
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtSize;

PROCEDURE sbool (tf:BOOLEAN;sT,sF:ARRAY OF CHAR):str16;
VAR
    R:str16;
BEGIN
    IF tf THEN
        Str.Copy(R,sT);
    ELSE
        Str.Copy(R,sF);
    END;
    RETURN R;
END sbool;

PROCEDURE fmtAttr (attr:FIO.FileAttr) : str16;
VAR
    S : str16;
BEGIN
    Str.Copy  (S, sbool( (aDD IN attr),"d","-") );
    Str.Append(S, sbool( (aR IN attr),"r","-") );
    Str.Append(S, sbool( (aH IN attr),"h","-") );
    Str.Append(S, sbool( (aS IN attr),"s","-") );
    Str.Append(S, sbool( (aA IN attr),"a","-") );
    RETURN S;
END fmtAttr;

(* ------------------------------------------------------------ *)

PROCEDURE waitAndSee (VAR rowcount:CARDINAL; lastRow:CARDINAL):BOOLEAN;
VAR
    key:str2;
BEGIN
    INC(rowcount);
    IF rowcount >= lastRow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
        rowcount := initpagingcounter;
        video(kbdmsg,TRUE);
        Flushkey;
        key:=Waitkey();
        video(kbdmsg,FALSE);
        IF same(key,echap) THEN RETURN FALSE; END;
    END;
    RETURN TRUE;
END waitAndSee;

(* ------------------------------------------------------------ *)


CONST
    doMD5     = 0;
    doSHA     = 1;
    doCRC32   = 2;
CONST

(* md5/crc32 require an existing shortform, while ne may be a LFN *)

PROCEDURE calcsum (isdir:BOOLEAN;method:CARDINAL; shortform,ne:pathtype):str80; (* oversized *)
CONST
    msgWait      = "Computing, please wait...";
    nope         = "--------";  (* 8 chars *)
    msgSkipMD5   = nope+nope+nope+nope;      (* match strMD = 32 chars for speed *)
    msgSkipSHA   = nope+nope+nope+nope+nope; (* match SHA = 40 chars for speed *)
    msgSkipCRC32 = nope;                     (* match CRC32 =  8 chars for speed *)
VAR
    valMD : MD5digestType;
    strMD : MD5str;
    valSHA: SHAdigestType;
    strSHA: SHAstr;
    crc   : LONGCARD;
    R     : str80;
    ok    : BOOLEAN;
    i : CARDINAL;
BEGIN
    (*
    useless here : protection is not initialized by directory mode
    ok:=chkNoProtection (FALSE,FALSE,ne); (* show,isdir *)
    IF chkIgnoreMe(FALSE,FALSE,ne) THEN ok:=FALSE; END;
    IF ok THEN (* not protected : try swapfiles and do it fast *)
    *)

    IF isdir THEN
        ok:=FALSE;
    ELSE
                        ok:=Str.Match(ne, fSwapWin92);
        IF NOT(ok) THEN ok:=Str.Match(ne, fSwapWin98);END;
        IF NOT(ok) THEN ok:=Str.Match(ne, fSwapWinXP);END;
        ok:=NOT(ok);
    END;
    IF ok THEN
        video(msgWait,TRUE);
        CASE method OF
        | doMD5 :
            ComputeMD5(valMD,shortform);
            MD5toString(strMD,valMD);
            Str.Copy(R, strMD);
        | doSHA :
            ComputeSHA(valSHA,shortform);
            SHAtoString(strSHA,valSHA);
            Str.Copy(R, strSHA);
        | doCRC32:
            crc:=ComputeCRC32(shortform);
            Str.Copy(R, fmtlc(crc,16,8,"0",""));
        ELSE ; (* //ISO fixed silly requirement *) END;
        video(msgWait,FALSE);
    ELSE
        CASE method OF
        | doMD5 :  R:=msgSkipMD5;
        | doSHA:   R:=msgSkipSHA;
        | doCRC32: R:=msgSkipCRC32;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN R;
END calcsum;


(* ------------------------------------------------------------ *)

CONST
    orgautonum      = 1-1;
    orgautonumalpha = "AAAA";
    autonumwi       = 4;

PROCEDURE incnumalpha (VAR S:str16);
VAR
    i,code:CARDINAL;
    carry:BOOLEAN;
BEGIN
    i:=Str.Length(S);
    IF i # autonumwi THEN RETURN; END; (* should never happen but... *)
    LOOP
        DEC(i);
        code:=ORD(S[i]);
        INC(code);
        IF code > ORD("Z") THEN
            IF i=0 THEN
                code:=ORD("_"); (* safety *)
            ELSE
                code:=ORD("A");
            END;
            carry:=TRUE;
        ELSE
            carry:=FALSE;
        END;
        S[i]:=CHR(code);
        IF carry=FALSE THEN EXIT; END;
        IF i=0 THEN EXIT; END;
    END;
END incnumalpha;

PROCEDURE dospad (padright:BOOLEAN;f8,e3:str16 ; ip:str4):str80;
CONST
    widosf8 = 8;
    widose3 = 1+3; (* include dot *)
VAR
    R : str80; (* result may contain color codes *)
    wif8,wie3 : INTEGER;
BEGIN
    (* extension will always be ".x[x[x]]] *)
    IF padright THEN
        wif8 := widosf8;
        wie3 :=-widose3;
    ELSE
        wif8 :=-widosf8;
        wie3 :=-widose3;
    END;
    Str.Copy(R,padded( wif8,f8));
    Str.Append(R,padded (wie3,e3));
    RETURN R;
END dospad;

(* ------------------------------------------------------------ *)

PROCEDURE doDir (VAR bytecount:HUGECARD; VAR filecount,dircount:LONGCARD;
                VAR rowcount:CARDINAL;   VAR singlestep:BOOLEAN;
                VAR autonum:CARDINAL;    VAR autonumalpha:str16;
                lastfile:CARDINAL; pdir:pDirEntry;
                useLFN,stats,showentries,paging,allowpause,
                dirheader,dirheaderalways,forceLFNquotes,divscreenrowcount:BOOLEAN;
                casify:casifyType; comaUSER:CHAR; pat:ARRAY OF CHAR):BOOLEAN;
VAR
    base:pathtype;
    p:pFileEntry;
    shortform,orgshortform,longform:pathtype;
    udne,u,d,dd,n,e,ext,ne,orgne:pathtype; (* was str128 *)
    R:str2048; (* really oversized ! *)
    ch,lowch:CHAR;
    getting:(grab,gotesc);
    j,i,len,rc,tmplen: CARDINAL;
    isdir,showdirheader:BOOLEAN;
    lastRow:CARDINAL;

    udos,ndos,edos:str16;
    ddos:str128;

    qfix,keychk:BOOLEAN;
    keycode:CARDINAL;
    snum:str16;
    ip:str4;
    numNotChanged,numalphaNotChanged:BOOLEAN;
BEGIN
    lastRow  := getWindowHeight();
    IF divscreenrowcount THEN lastRow:=(lastRow DIV 2); END;

    getDirStr(base,pdir);

    showdirheader:=dirheader; (* default *)
    IF showdirheader THEN
        IF NOT(dirheaderalways) THEN
            showdirheader := NOT (lastfile < firstEntry);
        END;
    END;

    IF showdirheader THEN
        FOR i:= 1 TO 3 DO
            CASE i OF
            | 1 : R:="";
            | 2 : Str.Concat(R,sDIRheader, nice(useLFN,base) );
            | 3 : R:="";
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrStr(R);WrLn;
            IF paging THEN (* code pasted from infra *)
                IF waitAndSee (rowcount,  lastRow)=FALSE THEN RETURN FALSE; END;
            END;
        END;
    END;

    FOR j:=firstEntry TO lastfile DO
        p:=findFileByIndex(j);

        isdir := (aDD IN p^.fattr);

        IF stats THEN
            IF isdir THEN
                INC(dircount);
            ELSE
                INC(filecount);
                HUGEINC(bytecount, HUGECARD(p^.fsize));
            END;
        END;

        getFileStr(udne,p);
        Str.Prepend(udne,base);

        Str.Copy(shortform,udne);
        Str.Copy(orgshortform,shortform); (* for file operation *)

        CASE casify OF (* keep accents *)
        | lowercase:
            LowerCaseAlt(udne);
            LowerCaseAlt(shortform);
        | uppercase:
            UpperCaseAlt(udne);
            UpperCaseAlt(shortform);
        ELSE ; (* //ISO fixed silly requirement *) END;
        qdSplitAllPath(udne,u,d,n,e); (* "u:" "\*\" "f" ".e" *) (* handles multiple dots *)
        qdSplitAllPath(shortform,udos,ddos,ndos,edos);
        Lib.MakeAllPath(ne,"","",n,e);
        Str.Copy(orgne,ne); (* for file operation *)

        IF same(edos,"") THEN
            edos:=dot; (* beautify for $r and $g tokens *)
            Str.Append(shortform,dot); (* $x token *)
        END;

        Str.Copy(dd,d);
        unfixDirectory(dd);
        Str.Copy(ext,e); Str.Subst(ext,dot,""); (* never used anyway ! *)

        ip:=""; (* safety *)

        R           := "";
        getting     := grab;
        len         := Str.Length(pat);
        i           := 0;

        numNotChanged      := TRUE;
        numalphaNotChanged := TRUE;

        WHILE i < len DO
            ch := pat[i];
            CASE getting OF
            | grab :
                IF ch = escch THEN
                    getting:=gotesc;
                ELSE
                    Str.Append(R,ch);
                END;
            | gotesc:
                lowch:=ch; Str.Lows(ch);
                CASE lowch OF
                | cZ:        Str.Append(R, fmtSize (p^.fsize,blank,comaUSER,isdir) );
                | cI:        Str.Append(R, fmtSize (p^.fsize,blank,""    ,isdir) );
                | cA:        Str.Append(R, fmtAttr (p^.fattr ) );
                | cH:        Str.Append(R, fmtTime (p^.ftime, timelong  ) );
                | cO:        Str.Append(R, fmtTime (p^.ftime, timestd   ) );
                | cV:        Str.Append(R, fmtTime (p^.ftime, timestdzero  ) );
                | cL:        Str.Append(R, fmtTime (p^.ftime, timelongzero  ) );
                | cT:        Str.Append(R, fmtDate (p^.fdate, dateplain ) );
                | cJ:        Str.Append(R, fmtDate (p^.fdate, datestd   ) );
                | cW:        Str.Append(R, fmtDate (p^.fdate, daterev   ) );
                | cU:        Str.Append(R,u);
                | cD:        Str.Append(R, nice(forceLFNquotes,d)); (* //FIXME *)
                | cB:        Str.Append(R, nice(forceLFNquotes,dd)); (* //FIXME *)
                | cN:        Str.Append(R, nice(forceLFNquotes,n));
                | cE:        Str.Append(R, nice(forceLFNquotes,e));
                | cF:        Str.Append(R, nice(forceLFNquotes,ne));
                | cR:        Str.Append(R, dospad (TRUE ,ndos,edos, ip));
                | cG:        Str.Append(R, dospad (FALSE,ndos,edos, ip));
                | cC:        IF useLFN THEN Str.Append(R,dquote);END;
                             Str.Append(R,u);
                             Str.Append(R,d);
                             Str.Append(R,n);Str.Append(R,e);
                             IF useLFN THEN Str.Append(R,dquote);END;
                | cX:        Str.Append(R,shortform);
                | cY:        IF forceLFNquotes THEN Str.Append(R,dquote);END;
                             Str.Append(R,u);
                             Str.Append(R,d);
                             IF isdir THEN (* //FIXME *)
                                 Str.Append(R,ne);
                                 tmplen:=Str.Length(R)-1;
                                 IF Str.RCharPos(R,dot)=tmplen THEN R[tmplen]:=CHR(0);END;
                                 fixDirectory(R);
                             END;
                             IF forceLFNquotes THEN Str.Append(R,dquote);END;

                | cM:        Str.Append(R,calcsum(isdir,doMD5,  orgshortform,orgne));
                | cS:        Str.Append(R,calcsum(isdir,doSHA,  orgshortform,orgne));
                | cK:        Str.Append(R,calcsum(isdir,doCRC32,orgshortform,orgne));

                | cQ:        Str.Append(R,dquote);
                | cCRLF:     Str.Append(R,nl);
                | cPERCENT:  Str.Append(R,percent);
                | cDOLLAR:   Str.Append(R,dollar);
                | cEXCLAM:   Str.Append(R,tabchar);
                | cPOUND:    IF numNotChanged THEN
                                 INC(autonum);
                                 numNotChanged:=FALSE;
                             END;
                             Str.Copy(snum, fmt (autonum,10,5,"0",""));
                             Str.Append(R,snum);
                | cQUESTION: IF numalphaNotChanged THEN
                                 incnumalpha(autonumalpha);
                                 numalphaNotChanged:=FALSE;
                             END;
                             Str.Append(R,autonumalpha);
                ELSE
                    Str.Append(R,escch); Str.Append(R,ch);
                END;
                getting := grab;
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(i);
        END;

        IF showentries THEN WrStr(R);WrLn; END; (* //V09C *)

        IF paging THEN
            IF waitAndSee (rowcount,  lastRow)=FALSE THEN RETURN FALSE; END;
        ELSE
            IF allowpause THEN (* no paging, no redirection *)
                IF singlestep THEN
                    WHILE getKeyboardCode(keycode)=FALSE DO
                    END;
                    keychk:=(keycode # keySpace);
                    singlestep:=NOT(keychk);
                ELSE
                    keychk:=getKeyboardCode(keycode);
                END;
                IF keychk THEN
                    CASE keycode OF
                    | keySpace      : singlestep:=NOT (singlestep);
                    | keyEscape     : RETURN FALSE;
                    ELSE ; (* //ISO fixed silly requirement *) END;
                END;
            END;
        END;
    END;
    RETURN TRUE;
END doDir;

(* ------------------------------------------------------------ *)

PROCEDURE killfile (silently,doit,useLFN,prompuser,preview,protected:BOOLEAN;
                   S:pathtype):BOOLEAN;
VAR
    msg : str16;
    rc  : BOOLEAN;
BEGIN
    rc:=FALSE;
    IF doit THEN
        IF protected THEN
            msg:=sSkipRO;
        ELSE
            IF preview=FALSE THEN
                FIO.Erase(S);
            END;
            msg:=sDel;          rc:=TRUE;
        END;
    ELSE
        IF protected THEN
            msg:=sKeptRO;
        ELSE
            msg:=sKeptRW;
        END;
    END;
    IF NOT(silently) THEN
        IF preview THEN WrStr(sFake);END;
        WrStr(msg);WrStr( nice(useLFN,S));WrLn;
    END;
    RETURN rc;
END killfile;

CONST
    kYes       = "Y"; sYes       = "Yes";
    kNo        = "N"; sNo        = "No";
    kYesAll    = "A"; sYesAll    = "Yes to all";
    kQuit      = "Q"; sQuit      = "Quit"; (* "Aborted by user !"+nl+nl *)
    kEsc       = CHR(27);
    kOui       = "O";
    kOuiTous   = "T";
    strPrompt  = "Delete ? [Y|O]-yes  [N]-no  [A|T]-yes to all  [Q|Esc]-quit : ";

PROCEDURE queryUser(VAR promptuser,continue,doit:BOOLEAN;
                        useLFN,protected,preview:BOOLEAN;udne:pathtype);
VAR
    key : str2;
    msg:str16;
    askagain:BOOLEAN;
BEGIN

    doit:=FALSE;

    Str.Copy(msg,sbool(protected,"RO","rw"));
    WrLn;
    WrStr(msg);WrStr(" file : "); WrStr(nice(useLFN,udne)); WrLn;

    IF preview THEN WrStr(sFake);END;
    WrStr(strPrompt);
    LOOP
        askagain:=FALSE;
        Flushkey;  key := Waitkey();  UpperCase(key);
        IF same(key,kYes) THEN        msg:=sYes; doit:=TRUE;
        ELSIF same(key,kYesAll) THEN  msg:=sYesAll; doit:=TRUE;promptuser:=FALSE;
        ELSIF same(key,kQuit) THEN    msg:=sQuit; continue:=FALSE;
        ELSIF same(key,kEsc) THEN     msg:=sQuit; continue:=FALSE;
        ELSIF same(key,kOui) THEN     msg:=sYes; doit:=TRUE;
        ELSIF same(key,kOuiTous) THEN msg:=sYesAll; doit:=TRUE;promptuser:=FALSE;
        ELSIF same(key,kNo) THEN      msg:=sNo;
        ELSE                          askagain:=TRUE;
        END;
        IF NOT(askagain) THEN EXIT; END;
    END;
    WrStr(msg);WrLn;
END queryUser;

PROCEDURE doDel (VAR bytecount:HUGECARD;
                VAR filecount,dircount,fileskilled:LONGCARD;
                VAR promptuser,continue:BOOLEAN;
                fileanchor:pFileEntry; pdir:pDirEntry;
                useLFN,stats,preview:BOOLEAN);
VAR
    base:pathtype;
    p:pFileEntry;
    udne:pathtype;
    ROprotected:BOOLEAN;
    doit,silently:BOOLEAN;
BEGIN
    getDirStr(base,pdir);

    silently:=FALSE;
    continue:=TRUE;

    p:=fileanchor;
    WHILE p # NIL DO

        IF stats THEN
            IF (aDD IN p^.fattr) THEN
                INC(dircount);
            ELSE
                INC(filecount);
                HUGEINC(bytecount, HUGECARD(p^.fsize));
            END;
        END;

        getFileStr(udne,p);
        Str.Prepend(udne,base);

        ROprotected:=(aR IN p^.fattr);

        IF promptuser THEN
            queryUser (promptuser,continue,doit,
                      useLFN,ROprotected,preview, udne);
            IF continue=FALSE THEN RETURN; END;
        ELSE
            doit:=TRUE;
        END;
        IF killfile(silently,doit,useLFN,promptuser,preview,ROprotected,udne) THEN
           INC(fileskilled);
        END;

        p:=p^.next;
    END;
END doDel;

PROCEDURE queryUserDir(VAR promptuser,continue,doit:BOOLEAN;
                        useLFN,preview:BOOLEAN;base:pathtype);
VAR
    key : str2;
    msg:str16;
    canon:pathtype;
    askagain:BOOLEAN;
BEGIN
    Str.Concat(canon,base,"*.*");
    doit:=FALSE;

    WrLn;
    WrStr(strSUBDIR+" : "); WrStr(nice(useLFN,canon)); WrLn;

    IF preview THEN WrStr(sFake);END;
    WrStr(strPrompt);
    LOOP
        askagain:=FALSE;
        Flushkey;  key := Waitkey();  UpperCase(key);
        IF same(key,kYes) THEN        msg:=sYes; doit:=TRUE;
        ELSIF same(key,kYesAll) THEN  msg:=sYesAll; doit:=TRUE;promptuser:=FALSE;
        ELSIF same(key,kQuit) THEN    msg:=sQuit; continue:=FALSE;
        ELSIF same(key,kEsc) THEN     msg:=sQuit; continue:=FALSE;
        ELSIF same(key,kOui) THEN     msg:=sYes; doit:=TRUE;
        ELSIF same(key,kOuiTous) THEN msg:=sYesAll; doit:=TRUE;promptuser:=FALSE;
        ELSIF same(key,kNo) THEN      msg:=sNo;
        ELSE                          askagain:=TRUE;
        END;
        IF NOT(askagain) THEN EXIT; END;
    END;
    WrStr(msg);WrLn;
END queryUserDir;

PROCEDURE doDelTree (VAR bytecount:HUGECARD;
                    VAR filecount,dircount,fileskilled:LONGCARD;
                    VAR promptuser,continue:BOOLEAN;
                    fileanchor:pFileEntry; pdir:pDirEntry;
                    useLFN,stats,preview:BOOLEAN);
VAR
    base:pathtype;
    p:pFileEntry;
    udne:pathtype;
    protected:BOOLEAN;
    doit,query,silently:BOOLEAN;
BEGIN
    getDirStr(base,pdir);

    silently:=TRUE;
    continue:=TRUE;

    IF promptuser THEN
        queryUserDir(promptuser,continue,doit, useLFN,preview, base);
        IF continue=FALSE THEN RETURN; END;
    ELSE
        doit:=TRUE;
    END;
    IF doit=FALSE THEN
        IF preview THEN WrStr(sFake);END;
        WrStr(sSkippedDir);WrStr( nice(useLFN,base));WrLn;
        RETURN;
    END;

    query:=FALSE;

    p:=fileanchor;
    WHILE p # NIL DO

        IF stats THEN
            IF (aDD IN p^.fattr) THEN
                INC(dircount);
            ELSE
                INC(filecount);
                HUGEINC(bytecount, HUGECARD(p^.fsize));
            END;
        END;

        getFileStr(udne,p);
        Str.Prepend(udne,base);

        protected:=(aR IN p^.fattr);

        IF killfile(silently,doit,useLFN,query,preview,protected,udne) THEN
            INC (fileskilled);
        END;

        p:=p^.next;
    END;
    IF preview THEN WrStr(sFake);END;
    WrStr(sProcessedDir);WrStr( nice(useLFN,base));WrLn; (* not necessarily emptied *)
END doDelTree;

(* ------------------------------------------------------------ *)

PROCEDURE countEntries(useLFN:BOOLEAN;base:pathtype):CARDINAL;
VAR
    entries:CARDINAL;
    rootspec,entryname:pathtype;
    ok,found:BOOLEAN;
    entry : FIO.DirEntry;
BEGIN
    entries:=0;

    Str.Concat(rootspec,base,"*.*"); (* was spec *)
    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            INC(entries);
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN entries;
END countEntries;

PROCEDURE doRemDir (useLFN,preview:BOOLEAN;dir:pathtype):BOOLEAN;
VAR
    rc:CARDINAL;
    base,S:pathtype;
    ok:BOOLEAN;
    msg:str80;
BEGIN
    Str.Copy(base,dir);
    unfixDirectory(base); (* FIO.RmDir does not like trailing "\" ! *)
    IF preview THEN
        ok:=TRUE;
    ELSE
        FIO.RmDir(base); (* DOS path *)
        ok:= (FIO.IOresult()=0); (* DOSErr.NO_ERROR); (* true if directory found *) *)
    END;
    IF ok THEN
        msg:=sRemovedDir;
    ELSE
        msg:=sLeftDir;
    END;
    IF preview THEN WrStr(sFake);END;
    WrStr(msg);
    WrStr( nice(useLFN,dir));WrLn;
    RETURN ok; (* true if directory deleted *)
END doRemDir;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doDelFromList (VAR promptuser:BOOLEAN; VAR fileskilled:LONGCARD;
                    useLFN,preview,ignoreESC:BOOLEAN;
                    listfile:pathtype):CARDINAL;
VAR
    hin:FIO.File;
    udne:pathtype;
    pb,chkrounds,missing,rc:CARDINAL;
    protected,continue,doit,silently:BOOLEAN;
BEGIN
    chkrounds:=0;


	FIO.EOF := FALSE; (* //XDS //09B required for this code to work using XDS Win32 ! *)

	hin:=FIO.OpenRead(listfile);
    FIO.AssignBuffer(hin,lstBuffer);

    pb:=0;
    missing:=0;
    silently:=FALSE;
    continue:=TRUE;

    (* yes, we could read each entry to memory then filter and process them all *)

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,udne);
        (* IF FIO.EOF THEN EXIT; END; //XDS quirk ! *)
        preprocessLine (udne);

        CASE udne[0] OF
        | CHR(0), semicolon,pound :
            ;
        ELSE
            IF chkJoker(udne) THEN
                INC(pb);
                IF preview THEN WrStr(sFake);END;
                WrStr(sIgnored);WrStr( nice(useLFN,udne));WrLn;
            ELSE
                IF FIO.Exists(udne) THEN
                    protected := fileIsRO(udne);
                    IF promptuser THEN
                        queryUser (promptuser,continue,doit,
                                  useLFN,protected,preview, udne);
                        IF continue=FALSE THEN EXIT;END;
                    ELSE
                        doit:=TRUE;
                    END;
                    IF killfile(silently,doit,useLFN,promptuser,preview,protected,udne) THEN
                        INC(fileskilled);
                    END;
                ELSE
                    INC(missing);
                    IF preview THEN WrStr(sFake);END;
                    WrStr(sNotFound);WrStr( nice(useLFN,udne));WrLn;
                END;
            END;
        END;
        IF pollEscape(chkrounds,useLFN,ignoreESC) THEN continue:=FALSE;EXIT; END;
    END;
    FIO.Close(hin);
    IF continue=FALSE THEN RETURN errAborted;END;

    IF pb = 0 THEN
        IF missing = 0 THEN
            rc:=errNone;
        ELSE
            rc:=errGhostEntry;
        END;
    ELSE
        IF missing = 0 THEN
            rc:=errJokerEntry;
        ELSE
            rc:=errJokerGhost;
        END;
    END;
    RETURN rc;
END doDelFromList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getwidbg (  ):INTEGER ;
BEGIN
    RETURN -(28-1); (* Win<92|98|XP> forced us to use 31 *)
END getwidbg;

PROCEDURE getsepdbg (  ):str16;
BEGIN
    RETURN str16(" : ");
END getsepdbg;

PROCEDURE msgbool (flag:BOOLEAN;S,ST,SF:ARRAY OF CHAR);
VAR
    R:str80;
BEGIN
    Str.Copy(R,S);
    WrStr( padded ( getwidbg(),R) );
    WrStr( getsepdbg());
    IF flag THEN
        WrStr(ST);
    ELSE
        WrStr(SF);
    END;
    WrLn;
END msgbool;

(* don't change variable unless necessary *)

PROCEDURE chkEnvVar (VAR preview:BOOLEAN; whatvar : ARRAY OF CHAR):BOOLEAN ;
CONST
    sAllowed = "Y"+delim+"YES"+delim+"REALLY";
VAR
    R:str16;
    rc:BOOLEAN;
    i : CARDINAL;
BEGIN
    rc:=TRUE;
    Lib.EnvironmentFind(whatvar , R);
    LtrimBlanks(R);
    RtrimBlanks(R);
    IF same(R,"") THEN RETURN rc; END;
    CASE R[0] OF
    | "-" , "/" :
        ;
    ELSE
        Str.Prepend(R,"-");
    END;
    UpperCase(R);
    i := GetOptIndex(R, sAllowed);
    CASE i OF
    | 1..3 :
        preview:=FALSE;
    ELSE
        rc:=FALSE;
    END;
    RETURN rc;
END chkEnvVar;

(* ------------------------------------------------------------ *)

(* see GetLongCard() in QD_Box *)

PROCEDURE removeOption (VAR R:ARRAY OF CHAR);
VAR
    p:CARDINAL;
BEGIN
    Str.Subst(R,equal,colon); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(R,colon);
    IF p # MAX(CARDINAL) THEN Str.Delete(R,0,p+1); END;
END removeOption;

PROCEDURE parseDate (S : ARRAY OF CHAR;
                     VAR dmy : CARDINAL) : BOOLEAN;
CONST
    century = 1900;
CONST
    digits   = "0123456789";
    alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
CONST
    separator=dash;
    legaldateset = digits+separator+alphabet;
VAR
    i,day,month,year : CARDINAL;
    R : str80;
    v : LONGCARD;
    ok: BOOLEAN;
BEGIN
    UpperCase(S); (* in case months would be letters *)
    ReplaceChar(S,slash,separator);
    FOR i := 0 TO (Str.Length(S)-1) DO
        IF Str.CharPos(legaldateset,S[i])=MAX(CARDINAL) THEN RETURN FALSE; END;
    END;
    IF CharCount(S,separator) # 2 THEN RETURN FALSE; END;

    Str.ItemS(R,S,separator,0);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN RETURN FALSE; END;
    IF (v < mindd) OR (v > maxdd) THEN RETURN FALSE; END;
    day := CARDINAL(v);

    Str.ItemS(R,S,separator,1);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN
        Str.Prepend(R,dash); (* fake command line parameter ! *)
        i := GetOptIndex(R,"JAN"+delim+"JAN"+delim+
                           "FEB"+delim+"FEV"+delim+
                           "MAR"+delim+"MAR"+delim+
                           "APR"+delim+"AVR"+delim+
                           "MAY"+delim+"MAI"+delim+
                           "JUN"+delim+"JUN"+delim+
                           "JUL"+delim+"JUI"+delim+
                           "AUG"+delim+"AOU"+delim+
                           "SEP"+delim+"SEP"+delim+
                           "OCT"+delim+"OCT"+delim+
                           "NOV"+delim+"NOV"+delim+
                           "DEC"+delim+"DEC");
        CASE i OF
        | 1..24 :
            v := LONGCARD(i+1) DIV 2;
        ELSE
            RETURN FALSE;
        END;
    END;
    IF (v < minmm) OR (v > maxmm) THEN RETURN FALSE; END;
    month := CARDINAL(v);

    Str.ItemS(R,S,separator,2);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN RETURN FALSE; END;
    IF v < 100 THEN INC(v,century); END;
    IF (v < minyy) OR (v > maxyy) THEN RETURN FALSE; END;
    year := CARDINAL(v);
    dmy:=PackDMY (day,month,year);
    RETURN TRUE;
END parseDate;

PROCEDURE parseDateRange (S:ARRAY OF CHAR;VAR lodate,hidate:CARDINAL):BOOLEAN;
VAR
    rc:BOOLEAN;
    p:CARDINAL;
    S1,S2:str128;
    d,m,y:CARDINAL;
    dow:Lib.DayType;
BEGIN
    removeOption(S); (* we had gotten an option "$:*" *)
    rc:=FALSE;

    (* not here, because dash can be a date separator ! *)
    (* ReplaceChar(S,dash, colon); (* change possible "*-*" range TO "*:*" *) *)

    Str.Subst(S,dotdot,colon);  (* change possible "*..*" range to "*:*" *)
    p:=Str.CharPos(S,colon);

    IF p=MAX(CARDINAL) THEN
        IF same(S,"*") THEN                      (* today *)
            Lib.GetDate(y,m,d,dow);
            lodate:=PackDMY(d,m,y);
            rc:=TRUE;
        ELSE
            rc:=parseDate(S,lodate);
        END;
        hidate:=lodate;                          (* "$" means same *)
    ELSE
        Str.Slice(S1,S,0,p);
        Str.Delete(S,0,p+1); Str.Copy(S2,S);

	IF (same(S1,"") OR same(S1,"*")) THEN    (* ":$" means before/on *)
            lodate:=PackDMY(1,1,0000);
            rc:=parseDate(S2,hidate);
	ELSIF (same(S2,"") OR same(S2,"*"))THEN  (* "$:" means on/after *)
            hidate:=PackDMY(31,12,9999);
            rc:=parseDate(S1,lodate);
        ELSE
            rc:=parseDate(S1,lodate);
            IF rc THEN rc:=parseDate(S2,hidate); END;
        END;
    END;
    IF rc THEN
        rc:=(lodate <= hidate); (* safety check *)
    END;
    RETURN rc;
END parseDateRange;

PROCEDURE parsefsize (VAR v:LONGCARD;S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    ok:BOOLEAN;
    kmul:LONGCARD;
    i:CARDINAL;
    suffix:str16;
BEGIN
    i:=1-1;
    LOOP
        INC(i);
        IF i > 6 THEN kmul:=1; EXIT; END;
        CASE i OF
        | 1: suffix:="K"; kmul:=1000;
        | 2: suffix:="M"; kmul:=1000*1000;
        | 3: suffix:="G"; kmul:=1000*1000*1000;
        | 4: suffix:="KB";kmul:=1024;
        | 5: suffix:="MB";kmul:=1024*1024;
        | 6: suffix:="GB";kmul:=1024*1024*1024;
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Prepend(suffix,"*");
        IF Str.Match(S,suffix) THEN
            i:=Str.Length(suffix);
            Str.Delete(S,Str.Length(S)-i+1,i);
            EXIT;
        END;
    END;
    ok:=GetLongCard(S,v);
    IF ok THEN v:=v*kmul; END;
    RETURN ok;
END parsefsize;

PROCEDURE parseFileSizeRange (S:ARRAY OF CHAR;VAR losize,hisize:LONGCARD ):BOOLEAN ;
VAR
    rc:BOOLEAN;
    p:CARDINAL;
    S1,S2:str128;
    tmplc:LONGCARD;
    isjokerlo,isjokerhi:BOOLEAN;
BEGIN
    removeOption(S); (* we had gotten an option "$:*" *)
    rc:=FALSE;
    ReplaceChar(S,dash, colon); (* change possible "*-*" range to "*:*" *)
    Str.Subst(S,dotdot,colon);  (* change possible "*..*" range TO "*:*" *)

    (* handle cosmetic separators now *)
    ReplaceChar(S,coma,"");
    ReplaceChar(S,dot,"");

    p:=Str.CharPos(S,colon);
    IF p=MAX(CARDINAL) THEN    (* "$" "*" "" *)
        rc:=parsefsize(losize,S);
        hisize:=losize;                          (* "$" means exact size *)
    ELSE
        Str.Slice(S1,S,0,p);
        Str.Delete(S,0,p+1); Str.Copy(S2,S);

        isjokerlo:=( same(S1,"") OR same(S1,star) );
        isjokerhi:=( same(S2,"") OR same(S2,star) );

        IF isjokerlo THEN
            IF isjokerhi THEN           (* "*:*" *)
                losize:=MIN(LONGCARD);
                hisize:=MAX(LONGCARD);
                rc:=TRUE;
            ELSE                        (* "*:$" *)
                losize:=MIN(LONGCARD); (* complicated ways to mean 0 ! *)
                rc:=parsefsize(hisize,S2);
            END;
        ELSIF isjokerhi THEN            (* "$:*" *)
            hisize:=MAX(LONGCARD);
            rc:=parsefsize(losize,S1);
        ELSE                            (* "$:$" *)
            rc:=parsefsize(losize,S1);
            IF rc THEN rc:=parsefsize(hisize,S2);END;
        END;
    END;
    IF rc THEN
        (* rc:=(losize <= hisize); (* safety check *) *)
        IF losize > hisize THEN
            tmplc:=losize;
            losize:=hisize;
            hisize:=tmplc;
        END;
    END;
    RETURN rc;
END parseFileSizeRange;

PROCEDURE parseMask (S:ARRAY OF CHAR; VAR m:masktype):BOOLEAN;
VAR
    included,excluded,indifferent:str16;
    i,len:CARDINAL;
    ch,keepch:CHAR;
    state:(wait,grab);
    rc:BOOLEAN;
    attrstate:attrstatetype;
BEGIN
    removeOption(S);

    (* accept ?+, ?-, ?x, ? (assuming ?+) : exemple A+R-H+ *)

    len:=Str.Length(S);
    FOR i:= 1 TO len DO
        ch:=S[i-1];
        IF Belongs(allowedAttr,ch) THEN
            IF CharCount(S,ch) > 1 THEN RETURN FALSE; END; (* avoid repeated or contradictory *)
        END;
    END;
    included := "";
    excluded := "";
    indifferent:="";
    i:=1;
    rc:=FALSE;
    state:=wait;
    LOOP
        IF i > len THEN rc:=TRUE; EXIT; END;
        ch:=S[i-1];
        CASE state OF
        | wait:
            CASE ch OF
            | "D","R","H","S","A" : keepch:=ch;
                IF (i+1) > len THEN Str.Append(included,keepch);END;
            ELSE
                EXIT;
            END;
            state:=grab;
        | grab:
            CASE ch OF
            | "+"         : Str.Append(included,keepch);
            | "-"         : Str.Append(excluded,keepch);
            | "?","!","X" : Str.Append(indifferent,keepch);
            | "D","R","H","S","A": Str.Append(included,keepch); (* fake "+" for previous flag *)
                DEC(i); (* but cancel next advance *)
            ELSE
                EXIT;
            END;
            state:=wait;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(i);
    END;
    (* included and excluded don't share any attribute *)
    FOR i:=firstattr TO lastattr DO
        ch:=allowedAttr[i-1];
        IF Belongs(included,ch) THEN
            attrstate:=required;
        ELSIF Belongs(excluded,ch) THEN
            attrstate:=unwanted;
        ELSIF Belongs(indifferent,ch) THEN
            attrstate:=dontcare;
        ELSE
            attrstate:=dontcare;
        END;
        CASE ch OF
        | "D" : m.stateD := attrstate;
        | "R" : m.stateR := attrstate;
        | "H" : m.stateH := attrstate;
        | "S" : m.stateS := attrstate;
        | "A" : m.stateA := attrstate;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN rc;
END parseMask;

PROCEDURE fmtSizeRange (losize,hisize:LONGCARD):str80;
VAR
    R : str80;
BEGIN
    IF losize = hisize THEN
        Str.Copy(R,      fmtSize(losize,blank,"",FALSE ) );
    ELSE
        R:="[~..~]";
        Str.Subst(R,"~", fmtSize(losize,blank,"",FALSE ) );
        Str.Subst(R,"~", fmtSize(hisize,blank,"",FALSE ) );
    END;
    ReplaceChar(R,blank,"");
    RETURN R;
END fmtSizeRange;

PROCEDURE fmtDateRange (lodate,hidate:CARDINAL):str80;
VAR
    R:str80;
BEGIN
    IF lodate = hidate THEN
        Str.Copy(R, fmtDate(lodate,dateplain ) );
    ELSE
        R:="[~..~]";
        Str.Subst(R,"~", fmtDate(lodate,dateplain ) );
        Str.Subst(R,"~", fmtDate(hidate,dateplain ) );
    END;
    RETURN R;
END fmtDateRange;

PROCEDURE fmtMask (m:masktype):str80;
VAR
    R:str80;
    i:CARDINAL;
    ch:CHAR;
    attrstate:attrstatetype;
BEGIN
    R:="";
    FOR i:=firstattr TO lastattr DO
        ch:=allowedAttr[i-1];
        CASE ch OF
        | "D" : attrstate:=m.stateD;
        | "R" : attrstate:=m.stateR;
        | "H" : attrstate:=m.stateH;
        | "S" : attrstate:=m.stateS;
        | "A" : attrstate:=m.stateA;
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Append(R,ch);
        CASE attrstate OF
        | dontcare: ch:="?";
        | required: ch:="+";
        | unwanted: ch:="-";
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Append(R,ch);
        Str.Append(R," ");
    END;
    Rtrim(R," ");
    (* Str.Lows(R); *)
    RETURN R;
END fmtMask;

PROCEDURE preprocessFileFind (VAR S:pathtype):BOOLEAN;
VAR
    rc:BOOLEAN;
BEGIN
    (* handle nonsense *)

    IF same(S,".") THEN RETURN FALSE; END;
    IF same(S,"..") THEN RETURN FALSE; END;

    (* each "[u:]filename" becomes "[u:]\filename" *)
    (* "[u:]\filename" is obviously legal *)
    (* add ".*" if no extension *)

    rc:=TRUE;

    (* \$ *)

    IF S[0] = "\" THEN
        IF Str.RCharPos(S,".") = MAX(CARDINAL) THEN Str.Append(S,".*");END;
        RETURN rc;
    END;

    (* $:\$ *)

    IF Str.Pos(S,":\") # MAX(CARDINAL) THEN
        IF Str.RCharPos(S,".") = MAX(CARDINAL) THEN Str.Append(S,".*");END;
        RETURN rc;
    END;

    IF Str.CharPos(S,"\") # MAX(CARDINAL) THEN RETURN FALSE; END; (* $\$ *)

    IF Str.CharPos(S,":") # MAX(CARDINAL) THEN (* $:$ *)
        Str.Subst(S,":",":\");
    ELSE
        Str.Prepend(S,"\"); (* $ because \$ was filtered earlier *)
    END;
    IF Str.RCharPos(S,".") = MAX(CARDINAL) THEN Str.Append(S,".*");END;
    RETURN rc;
END preprocessFileFind;

(*

PROCEDURE preprocessDir (useLFN:BOOLEAN;VAR S:pathtype);
VAR
    u,d,n,e,ne:pathtype;
BEGIN
    IF isDirectory(S) THEN RETURN; END;

    qdSplitAllPath(S, u,d,n,e);
    Lib.MakeAllPath(ne,"","",n,e);
    IF same(ne,"")=FALSE THEN
        IF Str.CharPos(ne,".") = MAX(CARDINAL) THEN Str.Append(S,".*"); END;
    END;
END preprocessDir;

*)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dodirswap (i,j:CARDINAL);
VAR
    pi,pj:pDirEntry;
    tmp:CARDINAL;
BEGIN
    pi:=findDirByIndex(i);
    pj:=findDirByIndex(j);
    tmp:=pi^.index;
    pi^.index:=pj^.index;
    pj^.index:=tmp;
END dodirswap;

PROCEDURE dofileswap (i,j:CARDINAL);
VAR
    pi,pj:pFileEntry;
    tmp:CARDINAL;
BEGIN
    pi:=findFileByIndex(i);
    pj:=findFileByIndex(j);
    tmp:=pi^.index;
    pi^.index:=pj^.index;
    pj^.index:=tmp;
END dofileswap;

PROCEDURE dolessdirname (i,j:CARDINAL):BOOLEAN;
VAR
    pi,pj:pDirEntry;
    SI,SJ: pathtype ;
BEGIN
    pi:=findDirByIndex(i);
    pj:=findDirByIndex(j);

    getDirStr(SI,pi);
    getDirStr(SJ,pj);

    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);
    RETURN ( Str.Compare(SI,SJ) < 0 ); (* -1 is less *)
END dolessdirname;

PROCEDURE dolessfilename (i,j:CARDINAL):BOOLEAN;
VAR
    pi,pj:pFileEntry;
    SI,SJ: pathtype ;
BEGIN
    pi:=findFileByIndex(i);
    pj:=findFileByIndex(j);

    getFileStr(SI,pi);
    getFileStr(SJ,pj);

    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);
    RETURN ( Str.Compare(SI,SJ) < 0 ); (* -1 is less *)
END dolessfilename;

PROCEDURE dolessfilesize (i,j:CARDINAL):BOOLEAN;
VAR
    pi,pj:pFileEntry;
BEGIN
    pi:=findFileByIndex(i);
    pj:=findFileByIndex(j);
    RETURN (pi^.fsize < pj^.fsize);
END dolessfilesize;

PROCEDURE dolessfileext (i,j:CARDINAL):BOOLEAN;
VAR
    pi,pj:pFileEntry;
    SI,SJ,u,d,n,ei,ej: pathtype ;
BEGIN
    pi:=findFileByIndex(i);
    pj:=findFileByIndex(j);

    getFileStr(SI,pi);
    getFileStr(SJ,pj);

    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);

    qdSplitAllPath(SI,u,d,n,ei); (* "u:" "\*\" "f" ".e" *) (* handles multiple dots *)
    qdSplitAllPath(SJ,u,d,n,ej); (* "u:" "\*\" "f" ".e" *) (* handles multiple dots *)

    CASE Str.Compare(ei,ej) OF
    | -1 : RETURN TRUE;
    |  0 : RETURN ( Str.Compare(SI,SJ) < 0 ); (* -1 is less *)
    |  1 : RETURN FALSE;
    ELSE ; (* //ISO fixed silly requirement *) END;
END dolessfileext;

PROCEDURE dolessfiledate (i,j:CARDINAL):BOOLEAN;
VAR
    pi,pj:pFileEntry;
    d,t,dti,dtj:LONGCARD;
BEGIN
    pi:=findFileByIndex(i);
    pj:=findFileByIndex(j);

    d:= LONGCARD (pi^.fdate);
    t:= LONGCARD (pi^.ftime);
    dti := (d << 16) + t;

    d:= LONGCARD (pj^.fdate);
    t:= LONGCARD (pj^.ftime);
    dtj := (d << 16) + t;

    RETURN (dti < dtj);
END dolessfiledate;

PROCEDURE dolessdirnamerev (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN NOT ( dolessdirname(i,j) );
END dolessdirnamerev;

PROCEDURE dolessfilenamerev (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN NOT ( dolessfilename(i,j) );
END dolessfilenamerev;

PROCEDURE dolessfiledaterev (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN NOT ( dolessfiledate(i,j) );
END dolessfiledaterev;

PROCEDURE dolessfilesizerev (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN NOT ( dolessfilesize(i,j) );
END dolessfilesizerev;

PROCEDURE dolessfileextrev (i,j:CARDINAL):BOOLEAN;
BEGIN
    RETURN NOT ( dolessfileext(i,j) );
END dolessfileextrev;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (undefinedcmd,dirmode,delmode);
    sorttype= (nosort,byname,bysize,bydate,byext,
              bynamerev,bysizerev,bydaterev,byextrev);

PROCEDURE newcmd (VAR what:cmdtype; specified:cmdtype):BOOLEAN;
BEGIN
    IF ( (what=undefinedcmd) OR (what=specified) ) THEN
        what:=specified;
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END newcmd;

PROCEDURE newsort (VAR what:sorttype; specified:sorttype):BOOLEAN;
BEGIN
    IF ( (what=nosort) OR (what=specified) ) THEN
        what:=specified;
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END newsort;

PROCEDURE newcase (VAR what:casifyType; specified:casifyType):BOOLEAN;
BEGIN
    IF ( (what=orgcase) OR (what=specified) ) THEN
        what:=specified;
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END newcase;

PROCEDURE procSort (sortmethod:sorttype;lastfile:CARDINAL);
BEGIN
    IF sortmethod # nosort THEN video(msgSortingFiles,TRUE); END;
    CASE sortmethod OF
    | nosort: ;
    | byname   : Lib.QSort(lastfile,dolessfilename   ,dofileswap);
    | bysize   : Lib.QSort(lastfile,dolessfilesize   ,dofileswap);
    | bydate   : Lib.QSort(lastfile,dolessfiledate   ,dofileswap);
    | byext    : Lib.QSort(lastfile,dolessfileext    ,dofileswap);
    | bynamerev: Lib.QSort(lastfile,dolessfilenamerev,dofileswap);
    | bysizerev: Lib.QSort(lastfile,dolessfilesizerev,dofileswap);
    | bydaterev: Lib.QSort(lastfile,dolessfiledaterev,dofileswap);
    | byextrev : Lib.QSort(lastfile,dolessfileextrev ,dofileswap);
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF sortmethod # nosort THEN video(msgSortingFiles,FALSE); END;
END procSort;

PROCEDURE showParmsDelList (usingfilelist,useLFN,preview,promptuser:BOOLEAN);
BEGIN
    msgbool(usingfilelist  ,"Delete from list"       ,strY,strN);

    msgbool(preview        ,"Preview mode"           ,strY,strN);
    msgbool(promptuser     ,"Confirmation by user"   ,strY,strN);
END showParmsDelList;

PROCEDURE showParmsDel (cmd:cmdtype;
                       recurse,inverse,stats,useLFN,osjokers,
                       daterange,sizerange,preview,promptuser,
                       remroot,flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                       flagIGNOREENTRIES:BOOLEAN;
                       maskfilter:masktype;
                       lodate,hidate:CARDINAL;losize,hisize:LONGCARD);
VAR
    ini:pathtype;
    inihere,actualswapfilesprotection:BOOLEAN;
    p:CARDINAL;
BEGIN
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=FIO.Exists(ini);
    actualswapfilesprotection:=swapfilesprotectionFIX (flagFORCESWAPFILESPROTECTION,inihere,flagIGNOREINI);

    msgbool(recurse       ,"Recursion"              ,strY,strN);
    msgbool(inverse       ,"Invert specification"   ,strY,strN);
    msgbool(stats         ,"Show stats"             ,strY,strN);
  CASE cmd OF
  | delmode :
    msgbool(osjokers ,"Operating system jokers",strY,strN);
    msgbool(TRUE     ,"Attribute filter" , fmtMask(maskfilter),strN);
    msgbool(daterange,"Date range filter", fmtDateRange(lodate,hidate),strN);
    msgbool(sizerange,"Size range filter", fmtSizeRange(losize,hisize),strN);
  ELSE ; (* //ISO fixed silly requirement *) END;
    msgbool(preview       ,"Preview mode"           ,strY,strN);
    msgbool(promptuser    ,"Confirmation by user"   ,strY,strN);


    msgbool(flagIGNOREINI,"Ignore "+progEXEname+extINI+" (cli)",strY,strN);
    msgbool(flagFORCESWAPFILESPROTECTION,"Protect Win swapfiles (cli)",strY,strN);
    msgbool(inihere,progEXEname+extINI+" found",strY,strN);
    msgbool(flagIGNOREENTRIES,"Ignore entries",strY,strN);
    msgbool(actualswapfilesprotection,"Autoprotect Win swapfiles",strY,strN);

    dmpIgnored(useLFN,TRUE,lastIgnored);

    dmpProtected(useLFN,TRUE,lastEntryProtected );
END showParmsDel;

PROCEDURE showParmsDir (cmd:cmdtype;
                       recurse,inverse,showentries,stats,filefind,
                       useLFN,osjokers,daterange,sizerange,paging,
                       forceLFNquotes,flagIGNOREENTRIES:BOOLEAN;
                       maskfilter:masktype;
                       lodate,hidate:CARDINAL;losize,hisize:LONGCARD;
                       casify:casifyType;sortmethod:sorttype;
                       pat:ARRAY OF CHAR);
VAR
    rpt:str128;
    tmppat,ini:pathtype;
    inihere:BOOLEAN;
    p:CARDINAL;
BEGIN
    Str.Copy(tmppat,pat);
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=FIO.Exists(ini);

    msgbool(recurse       ,"Recursion"              ,strY,strN);
    msgbool(inverse       ,"Invert specification"   ,strY,strN);
    msgbool(showentries   ,"Show files"             ,strY,strN);
    msgbool(stats         ,"Show statistics"        ,strY,strN);
    msgbool(filefind      ,"Filefind mode"          ,strY,strN);
    msgbool(osjokers      ,"Operating system jokers",strY,strN);
    msgbool(TRUE          ,"Attribute filter" , fmtMask(maskfilter),strN);
    msgbool(daterange     ,"Date range filter", fmtDateRange(lodate,hidate),strN);
    msgbool(sizerange     ,"Size range filter", fmtSizeRange(losize,hisize),strN);
    msgbool(forceLFNquotes,"Force $dbnefy LFN enclosing",strY,strN);
    msgbool(TRUE          ,"Dir format (raw)"       ,nice(TRUE,tmppat),"");

    msgbool(paging             ,"Paging"                 ,strY,strN);

    WrStr( padded( getwidbg(),"Pathnames case" ) );
    WrStr( getsepdbg());
    CASE casify OF
    | orgcase:   rpt:="unchanged";
    | lowercase: rpt:="forced to lower case";
    | uppercase: rpt:="forced to upper case";
    ELSE ; (* //ISO fixed silly requirement *) END;
    WrStr(rpt);WrLn;

    WrStr( padded( getwidbg(),"Sort" ) );
    WrStr( getsepdbg());
    CASE sortmethod OF
    | nosort   : rpt := "none";
    | byname   : rpt := "by name";
    | bysize   : rpt := "by size";
    | bydate   : rpt := "by date";
    | byext    : rpt := "by extension";
    | bynamerev: rpt := "by name (reversed)";
    | bysizerev: rpt := "by size (reversed)";
    | bydaterev: rpt := "by date (reversed)";
    | byextrev : rpt := "by extension (reversed)";
    ELSE ; (* //ISO fixed silly requirement *) END;
    WrStr(rpt);WrLn;

    msgbool(inihere,progEXEname+extINI+" found",strY,strN);
    msgbool(flagIGNOREENTRIES,"Ignore entries",strY,strN);

    dmpIgnored(useLFN,TRUE,lastIgnored); (* here to use current colors *)

END showParmsDir;

PROCEDURE abortOnDefaultChanged (flag:BOOLEAN;errcode:CARDINAL;info:ARRAY OF CHAR);
BEGIN
    IF flag THEN abort(errcode,info);END;
END abortOnDefaultChanged;

(* if true, R1 = "u:*" RX = "uu...:*" *)

PROCEDURE isMultiUnits (VAR R1,RX:pathtype; S:pathtype):BOOLEAN;
VAR
    rc:BOOLEAN;
    p:CARDINAL;
BEGIN
    p:=Str.CharPos(S,colon);
    CASE p OF
    | 0,1,MAX(CARDINAL) :
        rc:=FALSE; (* illegal, one unit, no unit *)
    ELSE
        Str.Copy(R1,S); Str.Delete(R1,1,p-1); (* "abc:" becomes "a:" *)
        Str.Copy(RX,S); Str.Delete(RX,0,1);   (* "abc:" becomes "bc:" *)
        rc:=TRUE;
    END;
    RETURN rc;
END isMultiUnits;

(* ------------------------------------------------------------ *)

PROCEDURE getColumns (  ):CARDINAL ;
BEGIN
    RETURN getWindowWidth();
END getColumns;

PROCEDURE adjustMsgToScreenWidth (VAR S:ARRAY OF CHAR;
                                 useLFN,recurse,tersest,shortenpath:BOOLEAN;
                                 F:pathtype);
CONST
    prefix    = "...";
    prefixlen = 3;
VAR
    le,lenice,lemsg,delta,colcount : CARDINAL;
    Fnice : pathtype;
BEGIN
    IF recurse THEN
        Str.Copy(S,msgProcessingRecurse);
    ELSE
        Str.Copy(S,msgProcessing);
    END;

    IF tersest THEN
        Str.Subst(S,"~ ", ""); (* placeholder+space *)
    ELSE
        IF shortenpath THEN
            colcount:=getColumns(); (* use QD_TEXT, not BIOS *)
            lemsg:=Str.Length(S)-1; (* ignore placeholder *)
            le:=Str.Length(F);
            Str.Copy(Fnice, nice(useLFN,F));
            lenice:=Str.Length( Fnice);
            IF lenice > le THEN
                delta:=lenice-le; (* normally : 2 for dquotes *)
            ELSE
                delta:=0;
            END;
            INC(delta,lemsg);
            INC(delta,le);
            IF delta >= colcount THEN
                Str.Delete(F,0,delta-colcount+1);
                Str.Delete(F,0,prefixlen);
                Str.Prepend(F,prefix);
            END;
        END;
        Str.Subst(S,"~", nice(useLFN,F));
    END;
END adjustMsgToScreenWidth;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //V11O moved out of main() IN order TO avoid nasty "dynamic pool exceeds isl.args" *)

PROCEDURE getoptindex(R:ARRAY OF CHAR):CARDINAL;
VAR
    opt:CARDINAL;
BEGIN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "??"+delim+
                                  "b"+delim+"bios"+delim+
                                  "l"+delim+"lfn"+delim+
                                  "S"+delim+"RECURSE"+delim+
                                  "D"+delim+"DIR"+delim+"LIST"+delim+
                                  "K"+delim+"KILL"+delim+"DEL"+delim+
                                            "DELETE"+delim+"ERASE"+delim+
(* 19 *)
                                  "z"+delim+"zap"+delim+
                                  "zz"+delim+"deltreeroot"+delim+
                                  "F:"+delim+"FMT:"+delim+
                                  "D:"+delim+"BYDATE:"+delim+
                                  "Z:"+delim+"BYSIZE:"+delim+
                                  "M:"+delim+"BYMASK:"+delim+
(* 31 *)
                                  "r"+delim+"o"+delim+"readonly"+delim+
                                  "N"+delim+"NOPROMPT"+delim+
                                            "NOQUERY"+delim+"DONTASK"+delim+
                                  "@"+delim+"LISTMODE"+delim+
                                  "Y"+delim+"YES"+delim+"REALLY"+delim+
                                  "C"+delim+"COUNT"+delim+"STATS"+delim+
(* 46 *)
                                  "I"+delim+"INVERSE"+delim+
                                  "P"+delim+"PAGING"+delim+
                                  "X"+delim+"IGNOREINI"+delim+
                                  "T"+delim+"TEST"+delim+"Y-"+delim+"PREVIEW"+delim+
                                  "V"+delim+"SHOWPARMS"+delim+
                                  "VV"+delim+"SHOWPARMSQUIT"+delim+
                                  "J"+delim+"LOWERCASE"+delim+"LC"+delim+
                                  "U"+delim+"UPPERCASE"+delim+"UC"+delim+
(* 66 *)
                                  "KY"+delim+
                                  "zy"+delim+
                                  "zzy"+delim+
                                  "XDIR"+delim+
                                  "XDIRS"+delim+
                                  "XDEL"+delim+
                                  "XDELS"+delim+
                                  "deltree"+delim+
                                  "DD"+delim+
                                  "DDD"+delim+"DDS"+delim+
                                  "$"+delim+"ESC"+delim+
(* 79 *)
                                  "AD-"+delim+
                                  "AD"+delim+"AD+"+delim+
                                  "AD!"+delim+"AD?"+delim+"ADX"+delim+

                                  "AR-"+delim+
                                  "AR"+delim+"AR+"+delim+
                                  "AR!"+delim+"AR?"+delim+"ARX"+delim+

                                  "AH-"+delim+
                                  "AH"+delim+"AH+"+delim+
                                  "AH!"+delim+"AH?"+delim+"AHX"+delim+

                                  "AS-"+delim+
                                  "AS"+delim+"AS+"+delim+
                                  "AS!"+delim+"AS?"+delim+"ASX"+delim+

                                  "AA-"+delim+
                                  "AA"+delim+"AA+"+delim+
                                  "AA!"+delim+"AA?"+delim+"AAX"+delim+
(* 109 *)
                                  "???"+delim+
                                  "W"+delim+"WARN"+delim+"SHOWNOTFOUND"+delim+
                                  "F"+delim+"FIND"+delim+"FF"+delim+"FILEFIND"+delim+
                                  "SZ"+delim+"BYSIZE"+delim+"SS"+delim+
                                  "SN"+delim+"BYNAME"+delim+
                                  "SD"+delim+"BYDATE"+delim+
                                  "SE"+delim+"BYEXTENSION"+delim+
(* 126 *)
                                  "SZ-"+delim+"BYSIZE-"+delim+"SS-"+delim+
                                  "SN-"+delim+"BYNAME-"+delim+
                                  "SD-"+delim+"BYDATE-"+delim+
                                  "SE-"+delim+"BYEXTENSION-"+delim+
                                  "!"+delim+"JOKERS"+delim+"OS"+delim+
                                  "G"+delim+"DIRHEADER"+delim+

                                  (* dir terse crc32 md5 *)
                                  "FD"+delim+
                                  "FT"+delim+
                                  "FC"+delim+
                                  "FM"+delim+

                                  "CC"+delim+
                                  "e"+delim+"empty"+delim+
                                  "ze"+delim+
                                  "zey"+delim+
                                  "zze"+delim+
                                  "zzey"+delim+
(* 151 *)
                                  "FL"+delim+
                                  "FV"+delim+
                                  "a"+delim+"ignoredat"+delim+
                                  "XX"+delim+ (* -xx is a mere alias for -x *)
                                  "Q"+delim+"QUOTES"+delim+
                                  "FS"+delim+
                                  "m"+delim+"beep"+delim+"quiet"+delim+
                                  "SF"+delim+"SWAPS"+delim+"SWAPFILES"+delim+
                                  "P-"+delim+"PAGING-"+delim+
                                  "GG"+delim+
                                  "PP"+delim+
                                  "PP-"+delim+
(* 170 *)
                                  "&"+delim+"US"+delim+
                                  "mem"+delim+"fake"+delim+
                                  "SKY"+delim+"KYS"+delim+
                                  "-"+delim+"TERSE"+delim+
                                  "XP"+delim+"IGNORED"+delim+
                                  "SKYR"+delim+"KRYS"+delim+
                                  "????"+delim+
                                  "DEBUG"
                              );
    RETURN opt;
END getoptindex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstParm  = 1;
    maxParm    = 20; (* now, call that oversized ! *)
VAR
    parm     : ARRAY [firstParm..maxParm] OF pathtype;
    base     : ARRAY [firstParm..maxParm] OF pathtype;
    spec     : ARRAY [firstParm..maxParm] OF pathtype;
    status   : ARRAY [firstParm..maxParm] OF CARDINAL;
    matches  : ARRAY [firstParm..maxParm] OF LONGCARD;
VAR
    useLFN,recurse,promptuser:BOOLEAN;
    usingfilelist,preview,stats,inverse,verbose,verbosebye:BOOLEAN;
    dirheader,dirheaderalways:BOOLEAN;
    showentries,remroot,paging,allowpause,forceLFNquotes:BOOLEAN;
    flagIGNOREINI,flagFORCESWAPFILESPROTECTION:BOOLEAN;
    flagIGNOREENTRIES:BOOLEAN;
    divscreenrowcount,ignoreESC,killemptyonly:BOOLEAN;
    osjokers,filefind,showfnf,daterange,sizerange,usemask, singlestep: BOOLEAN;
    DEBUG : BOOLEAN;
    lastparm:CARDINAL;
    S,R,listfile:pathtype;
    parmcount,i,opt:CARDINAL;
    anchor,pdir:pDirEntry;
    cmd : cmdtype;
    ok,continue:BOOLEAN;
    (* sLegalUnits : str80; (* A..Z *) *)
    rc,dirndxflag:CARDINAL;
    pat,rpt:str128;
    bytecount:HUGECARD;
    filecount,dircount,fileskilled:LONGCARD; (* let's hope it's oversized ! ;-) *)
    chkrounds,rowcount,lastRow,deep:CARDINAL;
    casify:casifyType;
    lodate,hidate:CARDINAL;
    losize,hisize:LONGCARD;
    shuge : str1024; (* could be useful *)
    maskfilter:masktype;
    strmask:str80; (* in case user would be... well... absent-minded ? *)
    j,lastfile,lastdir:CARDINAL;
    sortmethod:sorttype;
    autonum:CARDINAL;
    autonumalpha:str16;
    comaUSER:CHAR;
    tersest : BOOLEAN;  (* worse than curiouser *)
BEGIN
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)

    InitCRC32(); (* was done by library but as we have to include everything in source thanks to XDS... *)
    setSigmaUse (FALSE);

    WrLn;               (* ok here *)

    cmd            := undefinedcmd;
    useLFN         := TRUE;
    recurse        := FALSE;
    pat            := "";
    promptuser     := TRUE;
    usingfilelist  := FALSE;
    preview        := TRUE;
    stats          := FALSE;
    inverse        := FALSE;
    remroot        := FALSE; (* change by -zz only *)
    paging         := FALSE;
    osjokers       := FALSE;
    flagIGNOREINI  := FALSE;  (* -x will force existing ini to be ignored -- protection *)
    flagIGNOREENTRIES:=FALSE; (* -xp *)
    flagFORCESWAPFILESPROTECTION := TRUE; (* default is to ignore swapfiles *)
    casify         := orgcase;
    filefind       := FALSE;
    verbose        := FALSE;
    verbosebye     := FALSE;
    showfnf        := FALSE;
    dirheader      := FALSE;
    dirheaderalways:= FALSE;
    showentries    := TRUE;
    forceLFNquotes := FALSE;
    ignoreESC      := FALSE;
    daterange      := FALSE;
    sizerange      := FALSE;
    usemask        := FALSE;
    ok:=parseMask(showfilesonly,maskfilter);
    strmask        := "";
    sortmethod     := nosort;
    divscreenrowcount := FALSE;
    comaUSER       := comaFR;
    tersest        := FALSE;
    DEBUG          := FALSE;


    lastparm       := firstParm-1;

    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,""); END;

    IF chkEnvVar(preview,sDDenv) = FALSE THEN abort(errBadEnv,sDDenv);END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);UpperCase(R);
        IF isOption(R) THEN
            opt:=getoptindex(R);
            CASE opt OF
            | 1..3   : abort(errHelp,"");
            | 4      : abort(errMoreHelp,"");
            | 5,6    : ;
            | 7,8    : ;
            | 9,10   : recurse   := TRUE;
            | 11..13 : IF newcmd(cmd,dirmode    )=FALSE THEN abort(errMode,"");END;
            | 14..18 : IF newcmd(cmd,delmode    )=FALSE THEN abort(errMode,"");END;
            | 19,20  : ;
            | 21,22  : ;
            | 23,24  : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                       GetString(S,pat); (* keep case *)
            | 25,26  : ok:=parseDateRange(R,lodate,hidate);
                       IF ok=FALSE THEN abort(errDateRange,S);END;
                       daterange := TRUE;
            | 27,28  : ok:=parseFileSizeRange(R,losize,hisize);
                       IF ok=FALSE THEN abort(errSizeRange,S);END;
                       sizerange := TRUE;
            | 29,30  : IF usemask THEN abort(errOptionRedefined,"-m:$");END;
                       ok:=parseMask(R,maskfilter);
                       IF ok=FALSE THEN abort(errMask,S);END;
                       usemask   := TRUE;
            | 31..33 : ;
            | 34..37 : promptuser:= FALSE;
            | 38,39  : usingfilelist   := TRUE;
            | 40..42 : preview   := FALSE;
            | 43..45 : stats     := TRUE;
            | 46,47  : inverse   := TRUE;
            | 48,49  : paging    := TRUE;
            | 50,51 : flagIGNOREINI:= TRUE;
            | 52..55 : preview   := TRUE;
            | 56,57  : verbose   := TRUE;
            | 58,59  : verbose   := TRUE; verbosebye:=TRUE;
            | 60..62 : IF newcase(casify,lowercase)=FALSE THEN abort(errCasify,"");END;
            | 63..65 : IF newcase(casify,uppercase)=FALSE THEN abort(errCasify,"");END;
            | 66     : IF newcmd(cmd,delmode    )=FALSE THEN abort(errMode,"");END;
                       preview   :=FALSE; (* -ky = -k -y *)
            | 67     : ; (* -zy = -z -y *)
            | 68     : ; (* -zzy = -zz -y *)
            | 69     : IF newcmd(cmd,dirmode    )=FALSE THEN abort(errMode,"");END;
                       ok:=parseMask(showdirstoo,maskfilter);
                       stats     := TRUE; (* -xdir = -d -m:D! -c *)
            | 70     : IF newcmd(cmd,dirmode    )=FALSE THEN abort(errMode,"");END;
                       ok:=parseMask(showdirstoo,maskfilter);
                       stats     := TRUE;
                       recurse   := TRUE; (* -xdirs = -d -m:D! -c -s *)
            | 71     : IF newcmd(cmd,delmode    )=FALSE THEN abort(errMode,"");END;
                       promptuser:= FALSE;
                       stats     := TRUE; (* -xdel = -k -n -r -c *)
            | 72     : IF newcmd(cmd,delmode    )=FALSE THEN abort(errMode,"");END;
                       promptuser:= FALSE;
                       stats     := TRUE;
                       recurse   := TRUE; (* -xdels = -k -n -r -c -s *)
            | 73     : ; (* -deltree = -z -n -r -c *)
            | 74     : IF newcmd(cmd,dirmode    )=FALSE THEN abort(errMode,"");END;
                       ok:=parseMask(showdirstoo,maskfilter); (* -dd = -d -m:D! *)
            | 75,76  : IF newcmd(cmd,dirmode    )=FALSE THEN abort(errMode,"");END;
                       ok:=parseMask(showdirstoo,maskfilter);
                       recurse   := TRUE; (* -ddd = -d -m:D! -s *)
            | 77,78  : ignoreESC := TRUE;

            | 79       : Str.Append(strmask,"D-");
            | 80,81    : Str.Append(strmask,"D+");
            | 82..84   : Str.Append(strmask,"D?");
            | 85       : Str.Append(strmask,"R-");
            | 86,87    : Str.Append(strmask,"R+");
            | 88..90   : Str.Append(strmask,"R?");
            | 91       : Str.Append(strmask,"H-");
            | 92,93    : Str.Append(strmask,"H+");
            | 94..96   : Str.Append(strmask,"H?");
            | 97       : Str.Append(strmask,"S-");
            | 98,99    : Str.Append(strmask,"S+");
            | 100..102 : Str.Append(strmask,"S?");
            | 103      : Str.Append(strmask,"A-");
            | 104,105  : Str.Append(strmask,"A+");
            | 106..108 : Str.Append(strmask,"A?");

            | 109      : abort(errEvenMoreHelp,"");
            | 110..112 : showfnf      := TRUE;
            | 113..116 : IF newcmd(cmd,dirmode    )=FALSE THEN abort(errMode,"");END;
                         recurse      := TRUE;
                         stats        := TRUE;
                         filefind     := TRUE;  (* only changed here *)
            | 117..119 : IF newsort(sortmethod,bysize)=FALSE THEN abort(errSort,"");END;
            | 120,121  : IF newsort(sortmethod,byname)=FALSE THEN abort(errSort,"");END;
            | 122,123  : IF newsort(sortmethod,bydate)=FALSE THEN abort(errSort,"");END;
            | 124,125  : IF newsort(sortmethod,byext )=FALSE THEN abort(errSort,"");END;
            | 126..128 : IF newsort(sortmethod,bysizerev)=FALSE THEN abort(errSort,"");END;
            | 129,130  : IF newsort(sortmethod,bynamerev)=FALSE THEN abort(errSort,"");END;
            | 131,132  : IF newsort(sortmethod,bydaterev)=FALSE THEN abort(errSort,"");END;
            | 133,134  : IF newsort(sortmethod,byextrev )=FALSE THEN abort(errSort,"");END;
            | 135..137 : osjokers := TRUE;
            | 138,139  : dirheader := TRUE;

            | 140      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         IF newcase(casify,lowercase)=FALSE THEN abort(errCasify,"");END;
                         pat           := sDirPat;
                         dirheader     := TRUE;
                         stats         := TRUE;
                         forceLFNquotes:=TRUE;
            | 141      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         pat           := sTersePat;
            | 142      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         pat           := sSumPat;
                         dirheader     := TRUE;
                         forceLFNquotes:=TRUE;
            | 143      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         pat           := sMD5digestPat;
                         dirheader     := TRUE;
                         forceLFNquotes:=TRUE;

            | 144      : stats:=TRUE;
                         showentries:= FALSE;
                         (* paging     := FALSE; *)
            | 145,146  : ;
            | 147      : ;    (* -ze *)
            | 148      : ;   (* -zy = -z -y *)
                         ;    (* -zey *)
            | 149      : ;    (* -zze *)
            | 150      : ;   (* -zzy = -zz -y *)
                         ;   (* -zzey *)

            | 151      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         pat           := sListPat;
            | 152      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         pat           := sFilesPat;
                         forceLFNquotes:= TRUE;

            | 153,154  : ;
            | 155      : flagIGNOREINI:=TRUE; (* -xx is a mere alias for -x *)
            | 156,157  : forceLFNquotes:=TRUE;
            | 158      : IF same(pat,"")=FALSE THEN abort(errFormatRedefined,"");END;
                         pat           := sSHAdigestPat;
                         dirheader     := TRUE;
                         forceLFNquotes:=TRUE;
            | 159..161 : ;
            | 162..164 : flagFORCESWAPFILESPROTECTION:=FALSE;
            | 165,166  : paging    := FALSE;
            | 167      : dirheader := TRUE;
                         dirheaderalways := TRUE;
            | 168      : paging    :=TRUE;  divscreenrowcount:=TRUE;
            | 169      : paging    :=FALSE; divscreenrowcount:=TRUE;
            | 170,171  : comaUSER  := comaUS;
            | 172,173  : ;
            | 174,175  : IF newcmd(cmd,delmode    )=FALSE THEN abort(errMode,"");END;
                         preview   :=FALSE; (* -ky = -k -y *)
                         recurse   :=TRUE;  (* -sky = -kys = -k -y -s *)
            | 176,177  : tersest := TRUE;
            | 178,179  : flagIGNOREENTRIES:=TRUE;
            | 180,181  : IF newcmd(cmd,delmode    )=FALSE THEN abort(errMode,"");END;
                         preview   :=FALSE; (* -ky = -k -y *)
                         recurse   :=TRUE;  (* -sky = -kys = -k -y -s *)
            | 182      : abort(errEvenMoreAndMoreHelp,"");
            | 183      : DEBUG := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxParm THEN abort(errParameter,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;

    useLFN := TRUE;

    CASE lastparm OF
    | firstParm-1 :
        IF NOT (verbosebye) THEN abort(errMissingSpec,""); END;
    ELSE
        Str.Copy(listfile, parm[firstParm]); (* let's assume listmode *)
        IF listfile[0] = "@" THEN
            Str.Delete( listfile,0,1);
            usingfilelist:=TRUE;
        END;
    END;

    (* no use to check remroot and filefind, trapped with /zz AND /f *)

    IF usingfilelist THEN
        CASE cmd OF
        | dirmode: abort(errNonsenseCmd,"");
        ELSE ; (* //ISO fixed silly requirement *) END;

        IF same(pat,"")=FALSE THEN abort(errNonsenseListMode,"-f:$");END;
        abortOnDefaultChanged(killemptyonly,errNonsenseListMode,"-e");
        (* abortOnDefaultChanged(stats        ,errNonsenseListMode,"-c"); *)
        abortOnDefaultChanged(recurse      ,errNonsenseListMode,"-s");
        abortOnDefaultChanged(inverse      ,errNonsenseListMode,"-i");
        abortOnDefaultChanged(paging       ,errNonsenseListMode,"-p");
        abortOnDefaultChanged(osjokers     ,errNonsenseListMode,"-!");
        abortOnDefaultChanged(dirheader    ,errNonsenseListMode,"-g[g]");
        abortOnDefaultChanged( NOT(showentries),errNonsenseListMode,"-cc");
        abortOnDefaultChanged(forceLFNquotes,errNonsenseListMode,"-q");
        abortOnDefaultChanged(flagIGNOREINI,errNonsenseListMode,"-x");
        abortOnDefaultChanged(daterange    ,errNonsenseListMode,"-d:$");
        abortOnDefaultChanged(sizerange    ,errNonsenseListMode,"-z:$");
        abortOnDefaultChanged(usemask      ,errNonsenseListMode,"-m:$");
        IF same(strmask,"")=FALSE THEN abort(errNonsenseListMode,"-a<?>[?]");END;
        IF casify # orgcase THEN abort(errNonsenseListMode,"Any casify");END;
        IF sortmethod # nosort THEN abort(errNonsenseListMode,"Any sort");END;

        IF lastparm > firstParm THEN abort(errListSyntax,"");END;
        IF chkJoker(listfile) THEN abort(errListJoker,"");END;
        IF Str.CharPos(listfile,dot)=MAX(CARDINAL) THEN Str.Append(listfile,extLST);END;
      IF NOT(verbosebye) THEN
        IF isDirectorySpec(listfile) THEN abort(errListNotFile,"");END;
        IF FIO.Exists(listfile)=FALSE THEN abort(errListNotFound,listfile);END;
      END;
        IF verbose THEN
            showParmsDelList (usingfilelist,useLFN,preview,promptuser);
            IF verbosebye THEN abort(errNone,"");END;
            WrLn;
        END;

        fileskilled:=0;
        i:=doDelFromList (promptuser,fileskilled,
                         useLFN,preview,ignoreESC,listfile);
        CASE i OF
        | errJokerEntry: abort(errJokerEntry,"");
        | errGhostEntry: abort(errGhostEntry,"");
        | errJokerGhost: abort(errJokerGhost,"");
        | errAborted:    abort(errAborted,"");
        ELSE
            rpt:=strRptdel;
            Str.Subst(rpt, "~", nicefmtlc(filecount," ",comaUSER,1));
            Str.Subst(rpt, "~", nicefmtlc(fileskilled," ",comaUSER,1));
            IF stats THEN
                WrLn;
                WrStr(rpt);WrLn;
            END;
            abort(errNone,"");
        END;
    END;


    (* dir, del or deltree now *)


    IF cmd = undefinedcmd THEN ok:=newcmd(cmd,dirmode); END;

    CASE cmd OF
    | dirmode:
        IF same(pat,"") THEN (* not redefined using cli *)
            getEnvVar(pat,sDDfmtEnv);
            IF same(pat,"") THEN pat:=sDefaultPat; END; (* not redefined using env var *)
        END;
        abortOnDefaultChanged(killemptyonly      ,errNonsenseDirMode,"-e");
        abortOnDefaultChanged((promptuser=FALSE) ,errNonsenseDirMode,"-n");
        (* IF preview=FALSE THEN abort(errNonsenseDirMode,"-y");END; don't trigger env var ! *)
        (* abortOnDefaultChanged(flagIGNOREINI      ,errNonsenseDirMode,"-x"); *)
        IF same(strmask,"")=FALSE THEN
            IF usemask THEN abort(errMaskSetting,"");END;
            Str.Concat(R,fakeoption,strmask);
            usemask:= parseMask(R,maskfilter);
            IF usemask=FALSE THEN abort(errMaskOne,strmask);END;
        END;
        (*
        CASE maskfilter.stateD OF
        | dontcare,required : daterange:=FALSE; sizerange:=FALSE;
        END;
        *)
        IF filefind THEN
            maskfilter.stateD := unwanted; (* forced just in CASE *)
            (*
            here, we could split "uu...:*" filefind patterns
            updating lastparm and parm[], knowing real check is infra
            in fact, from "cdef:foo", we just fake manual "c:foo" "d:foo" etc.
            *)
            i:=firstParm;
            LOOP
                IF i > lastparm THEN EXIT; END;
                IF isMultiUnits(S,R,  parm[i]) THEN (* "ab...:" *)
                    INC(lastparm);
                    IF lastparm > maxParm THEN abort(errParameterFF,parm[i]);END;
                    Str.Copy(parm[i],S);        (* "a:*" *)
                    Str.Copy(parm[lastparm],R); (* "b...:*" *)
                END;
                INC(i);
            END;
        END;
        allowpause := NOT(paging);
        singlestep     := FALSE; (* must persist with successive calls to doDir() *)

        rowcount := initpagingcounter; (* global *)

    | delmode:
        abortOnDefaultChanged(killemptyonly      ,errNonsenseDelMode,"-e");
        IF same(pat,"")=FALSE THEN abort(errNonsenseDelMode,"-f:$");END;
        abortOnDefaultChanged(paging             ,errNonsenseDelMode,"-p");
        abortOnDefaultChanged(dirheader          ,errNonsenseDelMode,"-g[g]");
        abortOnDefaultChanged( NOT(showentries)  ,errNonsenseDelMode,"-cc");
        abortOnDefaultChanged(forceLFNquotes     ,errNonsenseDelMode,"-q");
        IF casify # orgcase   THEN abort(errNonsenseDelMode,"Any casify");END;
        IF sortmethod # nosort THEN abort(errNonsenseDelMode,"Any sort");END;
        IF same(strmask,"")=FALSE THEN
            IF usemask THEN abort(errMaskSetting,"");END;
            Str.Concat(R,fakeoption,strmask);
            usemask:= parseMask(R,maskfilter);
            IF usemask=FALSE THEN abort(errMaskOne,strmask);END;
        END;
        (*
        CASE maskfilter.stateD OF
        | dontcare,required :      abort(errNonsenseDelMode,"-m:D<+|?>");
        END;
        *)
        maskfilter.stateD := unwanted; (* forced just in case *)
    ELSE ; (* //ISO fixed silly requirement *) END;

    (* check, check ! *)

    (* getAllLegalUnits(TRUE,TRUE,TRUE,sLegalUnits); (* floppy,hd,CDROM *)
    IF DEBUG THEN WrStr("legal units : ");WrStr(sLegalUnits);WrLn;END; *)
    FOR i:=firstParm TO lastparm DO
        IF DEBUG THEN WrStr("parm : ");WrStr(parm[i]);WrLn; END;
        CASE cmd OF
        | dirmode :
            IF filefind THEN
                IF preprocessFileFind( parm[i])=FALSE THEN abort(errFF,parm[i]); END;
(*
            ELSE
                preprocessDir(useLFN,  parm[i]);
*)
            END;
            IF DEBUG THEN
                (* IF filefind THEN WrStr("PARM : ");WrStr( parm[i] );WrLn; END; *)
                WrStr("PARM : ");WrStr( parm[i] );WrLn;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        rc:= chkfixSpec( base[i],spec[i], useLFN,parm[i]); (* //XDS *)
        IF DEBUG THEN
            WrStr("base : ");WrStr( base[i] );WrLn;
            WrStr("spec : ");WrStr( spec[i] );WrLn;
        END;
        status[i]:=rc; (* later use : errNone,errEntryIsFile,errEntryNotFound *)
        CASE rc OF
        | errNone:
            ;
        | errEntryIsFile, errEntryNotFound:
            ;
        ELSE
            abort(rc,parm[i]);
        END;
    END;

    initIniSafety();

    IF flagIGNOREENTRIES THEN
        opt:=dataIgnored;
        i:=initIniData (lastEntryProtected,lastIgnored,  opt,
                        flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                        useLFN,DEBUG);
        IF i # errNone THEN abort(i,""); END;
    END;

    CASE cmd OF
    | delmode :
        opt:=dataProtection;
        i:=initIniData (lastEntryProtected,lastIgnored,  opt,
                        flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                        useLFN,DEBUG);
        IF i # errNone THEN abort(i,""); END;

        IF verbose THEN
            showParmsDel(cmd, recurse,inverse,stats,useLFN,osjokers,
                              daterange,sizerange,preview,promptuser,
                              remroot,flagIGNOREINI,
                              flagFORCESWAPFILESPROTECTION,flagIGNOREENTRIES,
                              maskfilter,lodate,hidate,losize,hisize);
            IF verbosebye THEN abort(errNone,"");END;
            WrLn;
        END;
    | dirmode:
        (*
        i:=initIniData (lastEntryProtected,lastIgnored,  opt,
                        flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                        useLFN,DEBUG);
        IF i # errNone THEN abort(i,""); END;
        *)

        IF verbose THEN (* waste of time ! *)
            showParmsDir(cmd, recurse,inverse,showentries,stats,filefind,
                              useLFN,osjokers,daterange,sizerange,
                              paging,forceLFNquotes,flagIGNOREENTRIES,
                              maskfilter,lodate,hidate,losize,hisize,
                              casify,sortmethod,pat);
            IF verbosebye THEN abort(errNone,"");END;
            WrLn;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    chkrounds:=0; (* try and fix nasty Win9X behavior about ChkEscape *)

    (* step 1 : let's store directories *)

    IF DEBUG THEN showmem("before step 1 : initDirList");END;

    initDirList(diranchor);

    lastdir   :=firstEntry-1; (* global for all specs : must be here *)

    FOR i:=firstParm TO lastparm DO
        matches[i]:=0;
        (* remind we're in filefind mode *)
        IF cmd=dirmode THEN (* useless safety but cleaner  *)
            IF filefind THEN (* dirmode only *)
                rpt:=strRptlookingfor;
                Str.Subst(rpt,"~", base[i][0]);
                Str.Subst(rpt,"~", nice(useLFN,spec[i]));
                WrStr(rpt);WrLn;
            END;
        END;

        CASE status[i] OF
        | errNone:          ok := TRUE;
        | errEntryIsFile:   CASE cmd OF
                            | dirmode, delmode:
                                ok:=TRUE ;
                            ELSE ; (* //ISO fixed silly requirement *) END;
        | errEntryNotFound: CASE cmd OF
                            | dirmode:
                                (*
                                IF showfnf THEN
                                    ok:=recurse; rpt:=sNotFound; (* v1.0j fix *)
                                ELSE
                                    ok:=TRUE;  (* silently hide it *)
                                END;
                                *)
                                ok:=TRUE; (* v1.0j fix : silently hide it for later *)
                            | delmode:
                                (*
                                ok:=recurse;     rpt:=sNotFound; (* v1.0j fix *)
                                *)
                                ok:=TRUE; (* v1.0j fix : silently hide it for later *)
                            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        IF ok THEN
            adjustMsgToScreenWidth(S, useLFN,recurse,tersest,TRUE,parm[i]);

            setCosmeticHackForPossibleProtection(S); (* ugly ! *)
            video(S,TRUE);

            dirndxflag:=INDEXROOT; (* local : we can't init this value in recursive proc() *)
            rc:= buildDirList (diranchor,dirndxflag,lastdir, useLFN,recurse,TRUE,i,base[i]);

            video(S,FALSE);

            IF rc # errNone THEN abort(rc, parm[i] ); END;
            IF DEBUG THEN dmpDirs(diranchor,i,useLFN);WrLn;END;
        ELSE
            WrStr(rpt); WrStr( nice(useLFN, parm[i]) ); WrLn;
        END;
    END;

    IF DEBUG THEN showmem("after step 1 : buildDirList");END;

    IF cmd = dirmode THEN
        IF sortmethod # nosort THEN video(msgSortingDirs,TRUE); END;
        CASE sortmethod OF
        | byname   : Lib.QSort(lastdir,dolessdirname   ,dodirswap);
        | bynamerev: Lib.QSort(lastdir,dolessdirnamerev,dodirswap);
        ELSE
            ;
        END;
        IF sortmethod # nosort THEN video(msgSortingDirs,FALSE); END;
        IF DEBUG THEN dmpDirsAlt(diranchor,lastdir,useLFN);END;
    END;

    (* step 2 : let's list/delete files *)

    bytecount    := HUGEZERO; (* actualized even if not displayed *)
    filecount    := 0;
    dircount     := 0;
    fileskilled  := 0;

    autonum      := orgautonum; (* just in case we would need it *)
    autonumalpha := orgautonumalpha;

    IF DEBUG THEN showmem("before step 2 : storeFiles");END;

    FOR j:=firstEntry TO lastdir DO
        pdir:=findDirByIndex(j);

        FOR i:=firstParm TO lastparm DO
    (* before v1.0d
    FOR i:=firstParm TO lastparm DO
        FOR j:=firstEntry TO lastdir DO
            pdir:=findDirByIndex(j);
    *)
            ok:=( pdir^.specindex = SHORTCARD(i) );
            IF ok THEN
                initFileList(fileanchor);
                rc:=storeFiles (lastfile,fileanchor,
                               pdir,useLFN,inverse,sizerange,daterange,osjokers,
                               losize,hisize,lodate,hidate,maskfilter,
                               i,spec[i]);

                IF rc # errNone THEN abort(rc, parm[i] ); END;
                INC( matches[i], LONGCARD ( lastfile) );

                IF cmd = dirmode THEN
                        procSort(sortmethod,lastfile);
                END;

                IF DEBUG THEN
                    dmpFiles(bytecount,filecount,dircount, fileanchor,pdir,i,useLFN);
                    WrLn;
                    IF sortmethod # nosort THEN
                    dmpFiles(bytecount,filecount,dircount, fileanchor,pdir,lastfile,useLFN);
                    END;
                ELSE
                    CASE cmd OF
                    | dirmode:
                        IF doDir (bytecount,filecount,dircount,rowcount,
                                 singlestep, autonum,autonumalpha,
                                 lastfile,pdir,
                                 useLFN,stats,showentries,paging,allowpause,
                                 dirheader,dirheaderalways,forceLFNquotes,divscreenrowcount,
                                 casify,comaUSER,pat) = FALSE THEN
                            freeFileList(fileanchor);
                            freeDirList(diranchor);
                            abort(errAborted,"");
                        END;

                    | delmode:
                        doDel (bytecount,filecount,dircount,fileskilled,promptuser,continue,
                               fileanchor,pdir,useLFN,stats,preview);
                        IF NOT(continue) THEN
                            freeFileList(fileanchor);
                            freeDirList(diranchor);
                            abort(errAborted,"");
                        END;
                    ELSE ; (* //ISO fixed silly requirement *) END;
                END;

                freeFileList(fileanchor);
            END;
            IF pollEscape(chkrounds,useLFN,ignoreESC) THEN
                freeDirList(diranchor);
                abort(errAborted,"");
            END;
        END;
    END;

    IF DEBUG THEN showmem("after step 2 : storeFiles");END;

    (* v1.0j step 3 *)

    IF showfnf THEN
        CASE cmd OF
        | dirmode,delmode:
            FOR i:=firstParm TO lastparm DO
                IF matches[i]=0 THEN
                    WrStr(sNotFound); WrStr( nice(useLFN, spec[i]) ); WrLn;
                END;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    (* step 4 *)

    CASE cmd OF
    | dirmode:
        IF stats THEN
            CASE maskfilter.stateD OF
            | required :
                rpt := strRptdirsOnly;
                Str.Subst(rpt, "~", nicefmtlc(dircount ," ",comaUSER,1));
            | dontcare :
                rpt := strRptdirsToo;
                Str.Subst(rpt, "~", nicefmtlc(filecount," ",comaUSER,1));
                Str.Subst(rpt, "~", nicefmtlc(dircount ," ",comaUSER,1));
                Str.Subst(rpt, "~", nicefmthc(bytecount," ",comaUSER,1));
            | unwanted:
                IF filefind THEN
                    IF filecount = 0 THEN
                        rpt:=strRptnomatch;
                    ELSE
                        rpt:=strRptmatches;
                    END;
                ELSE
                    rpt := strRptfiles;
                END;
                Str.Subst(rpt, "~", nicefmtlc(filecount," ",comaUSER,1));
                Str.Subst(rpt, "~", nicefmthc(bytecount," ",comaUSER,1));
            ELSE ; (* //ISO fixed silly requirement *) END;

            IF paging THEN
                lastRow:= getWindowHeight();
                FOR i:= 1 TO 2 DO
                    CASE i OF
                    | 1: pat:="";
                    | 2: pat:=rpt;
                    ELSE ; (* //ISO fixed silly requirement *) END;
                    WrStr(pat);WrLn;
                    IF waitAndSee (rowcount,  lastRow)=FALSE THEN abort(errAborted,"");END;
                END;
            ELSE
                WrLn;
                WrStr(rpt);WrLn;
            END;
        END;
        (* here in case someday we disable stats *)
        IF filefind THEN
            IF filecount=0 THEN abort(errNoFileMatchFound,"");END; (* all specs tried *)
        END;

    | delmode:
        IF stats THEN
            rpt:=strRptdel;
            Str.Subst(rpt, "~", nicefmtlc(filecount," ",comaUSER,1));
            Str.Subst(rpt, "~", nicefmtlc(fileskilled," ",comaUSER,1));
            Str.Subst(rpt, "~", nicefmthc(bytecount," ",comaUSER,1));
            WrLn;
            WrStr(rpt);WrLn;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF DEBUG THEN showmem("almost done");END;

    freeDirList(diranchor);

    IF DEBUG THEN showmem("final");END;

    abort(errNone,"");
END DD32.

