(* ---------------------------------------------------------------
Title         Q&D Modula-2 Cipher Saber
Overview
Usage
Notes         a mere "proof of concept"
              -t hex mode was not implemented : use XD utility instead

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -r

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs
Wish List     support for automatic filenames (.CS, .CS2)
              alternate header (possibly faking container data)
              wipe source file
              check passphrase for mini and maxi lengths, entropy, chars...
              allow escape chars in passphrase or hex string ($00 ?)
              handle redirection
              armored hex input and output
              select alternate rng and cipher
              generate password (TESTGEN-like)

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  4 Dec 19 fixed a typo in help screen
PhG 14 Oct 19 fixed help screen for obsolete DOS option
PhG 26 Apr 19 an ugly really Q&D port from MSABER v1.0 for DOS
--------------------------------------------------------------- *)

MODULE mSaber;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    quotedpat     = '"*"';
    remark1       = semicolon;
    remark2       = pound;
    addrsep       = colon;
CONST
    zerocard      = MAX(CARDINAL);
    zeroshort     = MAX(SHORTCARD);
CONST
    SALTCS1       = 10; PASSESCS1 = 1;
    SALTCS2       = 10; PASSESCS2 = 20;
CONST
    (* MINPPLEN      = 0; MAXPPLEN   = 256; *)  sMAXPPLEN     = "256";
    MINSALTLEN    = 0; MAXSALTLEN = 128-1; sSALTLENrange = "[0..127]";
    MINPASSES     = 1; MAXPASSES  = 4096;  sPASSESrange  = "[1..4096]";
    DEFSALTLEN    = SALTCS2;
    DEFPASSES     = PASSESCS2;
CONST
    strDEFSALT    = "10";
    strDEFPASSES  = "20";
CONST
    progEXEname   = "MSABER32";
    progTitle     = "Modula-2 Cipher Saber (Win32)";
    progVersion   = "v0.9 (from v1.0 for DOS)";
    progCopyright = "by PhG";
    progBanner    = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone            = 0;
    errHelp            = 1;
    errExclusive       = 2;
    errUnknownOption   = 3;
    errTooManyParms    = 4;
    errExpecting       = 5;
    errNoMatch         = 6;
    errMissingCommand  = 7;
    errSALT            = 8;
    errPASSES          = 9;
    errJoker           = 10;
    errTargetPath      = 11;
    errTargetHere      = 12;
    errTargetRO        = 13;
    errIsDir           = 14;
    errMissingPPfilespec=15;
    errPPmismatch      = 16;
    errNoPPhere        = 17;
    errIllogicalInput  = 18;
    errEmptyPP         = 19;
    errPPSALTLEN       = 20;
    errBadSALTLEN      = 21;

PROCEDURE abort(e:CARDINAL;einfo:ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
progBanner+nl+
nl+
"Syntax 1 : "+progEXEname+" -e <original> <ciphered> [passphrase] [option]..."+nl+
"Syntax 2 : "+progEXEname+" -d <ciphered> <original> [passphrase] [option]..."+nl+
nl+
"-e[?] encrypt (-ee = -e -@)"+nl+
"-d[?] decrypt (-dd = -d -@)"+nl+
"-cs2  newer CipherSaber-2 method (default, same as -p:20 -i:10)"+nl+
"-cs1  older CipherSaber-1 method (legacy, same as -p:1 -i:10)"+nl+
"-i:#  size of initialization vector ("+sSALTLENrange+", default is "+strDEFSALT+")"+nl+
"-p:#  setup passes ("+sPASSESrange+", default is "+strDEFPASSES+")"+nl+
"-@|-f assume passphrase is plain text in specified passphrase file (see infra)"+nl+
"-s    secure entry of passphrase (do not betray length of passphrase)"+nl+
"-u    unwise (display passphrase)"+nl+
"-o    overwrite existing target file"+nl+
"-y    do not copy source date/time stamp to target"+nl+
(* "-t    hexadecimal text mode (default is binary)"+nl+ *)
(* "-x    disable LFN support even if available"+nl+ *)
nl+
"This program implements Cipher Saber as designed by Arnold G. Reinhold."+nl+
"Note Cipher Saber, though clever in a few ways, is not clever in all ways. ;-)"+nl+
nl+
"a) If omitted from command line, passphrase will be asked from keyboard."+nl+
"b) Should spaces be needed, enclose passphrase with double quotes."+nl+
"c) Passphrase *is* case-sensitive. It should be created with extreme care."+nl+
"   The longer the better. Use at least one character of each group :"+nl+
"   lowercase letters, uppercase letters, digits and symbols."+nl+
"   A DiceWare passphrase may be a good idea. TEXTGEN program can help too."+nl+
"d) Compression prior to encryption is recommended."+nl+
"e) Encrypted and decrypted files are created in current directory,"+nl+
"   whatever their source location (this behavior is by design)."+nl+
"f) Any file decrypted with an invalid passphrase will contain garbage."+nl+
"g) With -@ option, actual passphrase is read from specified passphrase file :"+nl+
"   it will be first non-empty line found after left and right trimming"+nl+
"   (note it cannot be more than 256 bytes long)."+nl+
"   Should passphrase match _"+quotedpat+"_ pattern and thus be double quotes delimited,"+nl+
"   both outer _"+dquote+"_ will be removed."+nl+
(*
'h) -t hexadecimal processing ignores comments preceded by "'+remark1+'" or "'+remark2+'".'+nl+
'   It also ignore anything preceding "'+addrsep+'".'+nl+
*)
"h) Hexadecimal mode was not thought necessary : use XD utility instead."+nl+
"i) Both sender and receiver are required to agree on these parameters :"+nl+
"   -p:#, -i:#, passphrase and original filename."+nl+
"j) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" -d -cs1 -o diploma1.cs1 diploma1.gif ThomasJefferson"+nl+
"           "+progEXEname+" -d -p:63 -i:19 diploma3.csx diploma3.gif Eris_1963"+nl+
"           "+progEXEname+" -d -cs2 diploma4.csx diploma4.gif -f testpp.asc"+nl;

VAR
    S : str1024; (* oversized for possible LFN *)
BEGIN
    CASE e OF
    | errHelp :            WrStr(errmsg);
    | errExclusive:        S := "-encrypt and -decrypt are mutually exclusive !";
    | errUnknownOption:    S := 'Unknown "~" option !';
    | errTooManyParms:     S := 'Useless "~"  parameter !';
    | errExpecting:        S := 'Missing "~" !';
    | errNoMatch:          S := 'No file matches "~" specification !';
    | errMissingCommand:   S := "Missing -encrypt or -decrypt command !";
    | errSALT:             S := 'Illegal -i:# value or out of "~" range !';
    | errPASSES:           S := 'Illegal -p:# value or out of "~" range !';
    | errJoker:            S := '"~" should not contain any joker !';
    | errTargetPath:       S := '"~" should not contain a path !';
    | errTargetHere:       S := '"~" target already exists !';
    | errTargetRO:         S := '"~" target is read-only !';
    | errIsDir:            S := '"~" cannot be a directory !';
    | errMissingPPfilespec:S :="Missing passphrase file parameter !";
    | errPPmismatch:       S :="First and second entries of passphrase do not match !";
    | errNoPPhere:         S :='No passphrase found in "~" file !';
    | errIllogicalInput:   S :="-s and -u options are mutually exclusive !";
    | errEmptyPP:          S :="No passphrase specified !";
    | errPPSALTLEN:        S :="Passphrase length plus -i:# value is greater than "+sMAXPPLEN+" !";
    | errBadSALTLEN:       S :='No initialization vector header in "~" !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE XOR (b1,b2 : CARDINAL) : CARDINAL;
BEGIN
    RETURN CARDINAL ( (BITSET (b1) / BITSET (b2)) );
END XOR;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (16 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn  : ioBufferType;
    ioBufferOut : ioBufferType;

CONST
    dataBufferSize      = 256;
    firstDataBufferByte = 0;
    maxDataBufferByte   = dataBufferSize-1;
VAR
    databuffer : ARRAY [firstDataBufferByte..maxDataBufferByte] OF BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* rough input : only RETURN, DELETE/LEFT ARROW, ESCAPE *)

PROCEDURE input (VAR R : ARRAY OF CHAR;
                plain,secure:BOOLEAN; prompt:ARRAY OF CHAR);
CONST
    escape    = 33C; (* //XDS CHR(27); *)
    erasechar = 10C+40C+10C; (* //XDS bs+space+bs; *)
VAR
    i     : CARDINAL;
    c1,c2 : CHAR;
    hidechar : CHAR;
BEGIN
    IF secure THEN
        hidechar := space;
    ELSE
        hidechar := star;
    END;
    WrStr(prompt);
    Str.Copy(R,"");
    i:=0;
    LOOP
        c1 := IO.RdKey();
        CASE c1 OF
        | cr:
            EXIT;
        | bs: (* del key *)
            ;
        | escape: (* escape key *)
            WHILE i > 0 DO
                WrStr(erasechar);
                DEC(i);
                R[i]:=CHR(0);
            END;
            EXIT;
        | CHR(0):
            c2 := IO.RdKey();
            CASE c2 OF
            | CHR(75): (* left arrow *)
                c1 := bs;
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        IF c1 = bs THEN
            IF i > 0 THEN
                WrStr(erasechar);
                DEC(i);
                R[i]:=CHR(0); (* force character delete *)
            END;
        ELSIF ORD(c1) >= ORD(space) THEN
            IF plain THEN
                WrStr(c1);
            ELSE
                IF hidechar # space THEN WrStr(hidechar); END; (* else, cursor would betray ! *)
            END;
            Str.Append(R,c1);
            INC(i);
        END;
    END;
    WrLn;
END input;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    TSrng     = 1;
    QDrng     = 2;

PROCEDURE getRndVal ( whatrng:CARDINAL;lowerlimit,upperlimit:CARDINAL):CARDINAL;
VAR
    v:CARDINAL;
BEGIN
    CASE whatrng OF
    | TSrng  : v:= lowerlimit+Lib.RANDOM(upperlimit-lowerlimit+1);
    | QDrng  : v:= GetRndCardRange(lowerlimit,upperlimit);
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN v;
END getRndVal;

PROCEDURE initRNG ( whatrng:CARDINAL );
CONST
    warmup = 1024;
VAR
    i,k : CARDINAL;
BEGIN
    CASE whatrng OF
    | TSrng  : Lib.RANDOMIZE();
    | QDrng  : InitRnd;
    ELSE ; (* //ISO fixed silly requirement *) END;
    FOR i:=1 TO warmup DO
        k:=getRndVal(whatrng,MIN(CARDINAL),MAX(CARDINAL));
    END;
END initRNG;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* MODULE arcfour;

EXPORT MINPPLEN,MAXPPLEN,pptype,initRC4,getRC4; *)

CONST
    MINPPLEN      = 0; MAXPPLEN   = 256;
TYPE
    pptype = RECORD
        len : CARDINAL;
        dat : ARRAY[MINPPLEN..MAXPPLEN-1] OF CARDINAL; (* 0-based *)
    END;
CONST
    MINSTATE = MIN(SHORTCARD);
    MAXSTATE = MAX(SHORTCARD);
    MODSTATE = MAXSTATE+1;
VAR
    state    : ARRAY[MINSTATE..MAXSTATE] OF CARDINAL; (* bytes *)
    irc4,jrc4      : CARDINAL; (* global for inner module *)

PROCEDURE swap (VAR a,b:CARDINAL);
VAR
    tmp:CARDINAL;
BEGIN
    tmp:=a;
    a:=b;
    b:=tmp;
END swap;

PROCEDURE initRC4 (warmloop:CARDINAL;userkey:pptype);
VAR
	i,j:CARDINAL;
BEGIN
    FOR i := MINSTATE TO MAXSTATE DO state[i] := i; END;
    j := 0;
    LOOP
        IF warmloop = 0 THEN EXIT;END;
        FOR i:= MINSTATE TO MAXSTATE DO
            j := (j + state[i] + userkey.dat[i MOD userkey.len]) MOD MODSTATE;
            swap (state[i],state[j]);
        END;
        DEC(warmloop);
    END;
    irc4 := 0;
    jrc4 := 0;
END initRC4;

PROCEDURE getRC4 (  ):CARDINAL;
VAR
	i,j:CARDINAL;
BEGIN
	i:=irc4;
	j:=jrc4;
    i := (i + 1) MOD MODSTATE;
    j := (j + state[i]) MOD MODSTATE;
irc4:=i;
jrc4:=j;
    swap (state[i],state[j]);
    RETURN state[ (state[i] + state[j]) MOD MODSTATE ];
END getRC4;

(* END arcfour; *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE preprocessLine (VAR S:ARRAY OF CHAR);
VAR
    len:CARDINAL;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    IF Str.Match(S,quotedpat) THEN
        Str.Delete(S,0,1);
        len:=Str.Length(S);
        S[len-1]:=charnull;
    END;
END preprocessLine;

(* passphrase enters as filename and exits as... passphrase *)

PROCEDURE grabPP (VAR pp:pptype;F:pathtype):BOOLEAN;
CONST
    maxtries = 100;
    msg = "Working, please wait... ";
VAR
    S:str1024; (* almost pathtype *)
    hin:FIO.File;
    ok:BOOLEAN;
    i,tries:CARDINAL;
BEGIN
    video(msg,TRUE);

    tries:=1-1;
    ok:=FALSE;
    FIO.EOF:=FALSE;
    hin:=FIO.OpenRead(F);
    FIO.AssignBuffer(hin,ioBufferIn);
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;
        preprocessLine(S);
        IF same(S,"") = FALSE THEN
            pp.len:=Str.Length(S);
            FOR i:=1 TO pp.len DO pp.dat[i-1]:=ORD(S[i-1]); END;
            ok:=TRUE;
            EXIT;
        END;
        INC(tries);
        IF tries >= maxtries THEN ok:=FALSE; EXIT; END;
    END;
    FIO.Close(hin);
    video(msg,FALSE);
    RETURN ok;
END grabPP;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    methodrc4 = 0;

PROCEDURE initCipher (whatcipher,warmloop:CARDINAL;userkey:pptype);
BEGIN
    CASE whatcipher OF
    | methodrc4: initRC4(warmloop,userkey);
    ELSE ; (* //ISO fixed silly requirement *) END;
END initCipher;

(* uses global databuffer *)

PROCEDURE doCipher (whatcipher,got:CARDINAL);
VAR
    i,b,v:CARDINAL;
BEGIN
    FOR i:= firstDataBufferByte TO (got-1) DO
        b:=CARDINAL(databuffer[i]);
        CASE whatcipher OF
        | methodrc4: v:=getRC4();
        ELSE ; (* //ISO fixed silly requirement *) END;
        databuffer[i] := BYTE ( XOR(b,v) );
    END;
END doCipher;

VAR
    salt     : ARRAY[MINSALTLEN..MAXSALTLEN-1] OF SHORTCARD; (* 0-based, bytes *)
    pp       : pptype;

(*
   check :
   - pplength + ivlength <= maxpplen
   - filelength >= SALT
*)

PROCEDURE procFile (doEncrypt:BOOLEAN;
                   whatrng,whatcipher,SALTLEN,PASSES:CARDINAL;
                   pp:pptype;source,target:pathtype ):CARDINAL;
VAR
    hin,hout:FIO.File;
    got,i,p:CARDINAL;
    userkey:pptype;
BEGIN
    (* check passphrase + salt <= 255 *)
    IF (pp.len+SALTLEN) > MAXPPLEN THEN RETURN errPPSALTLEN;END;
    IF NOT(doEncrypt) THEN
        (* check salt exists *)
        IF getFileSize(source) < LONGCARD(SALTLEN) THEN RETURN errBadSALTLEN;END;
    END;

    hin :=FIO.OpenRead(source);
    FIO.AssignBuffer(hin,ioBufferIn);
    hout :=FIO.Create(target);
    FIO.AssignBuffer(hout,ioBufferOut);

    FIO.EOF:=FALSE; (* useless safety *)

    IF doEncrypt THEN (* build salt *)
        i := MINSALTLEN;
        LOOP
            IF i >= SALTLEN THEN EXIT;END;
            salt[i]:=SHORTCARD( getRndVal(whatrng,MIN(SHORTCARD),MAX(SHORTCARD)) );
            INC(i);
        END;
        IF SALTLEN # 0 THEN FIO.WrBin(hout,salt,SALTLEN); END;
    ELSE              (* retrieve salt *)
        IF SALTLEN # 0 THEN got:=FIO.RdBin(hin,salt,SALTLEN); END;
    END;

    (* key = passphrase+salt *)
    p:=MINPPLEN;
    FOR i:=1 TO pp.len DO
        userkey.dat[p]:=pp.dat[i-1];
        INC(p);
        pp.dat[i-1]:=zerocard;
    END;
    i:=MINSALTLEN;
    LOOP
        IF i >= SALTLEN THEN EXIT;END;
        userkey.dat[p]:=CARDINAL( salt[i] );
        INC(p);
        salt[i]:=zeroshort;
        INC(i);
    END;
    userkey.len:=p;
    SALTLEN:=zerocard;

    initCipher(methodrc4,PASSES,userkey);

    LOOP
        got:=FIO.RdBin(hin,databuffer,dataBufferSize);
        IF got = 0 THEN EXIT; END;
        doCipher(methodrc4,got);
        FIO.WrBin(hout,databuffer,got);
        IF got # dataBufferSize THEN EXIT; END;
    END;

    FIO.Flush(hout);
    FIO.Close(hout);
    FIO.Close(hin);

    FOR i:= MINPPLEN TO MAXPPLEN-1 DO userkey.dat[i]:=zerocard;END;

    RETURN errNone;
END procFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE grabvalue (VAR v:CARDINAL;
                    mini,maxi:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc:LONGCARD;
    ok:BOOLEAN;
BEGIN
    ok:=GetLongCard(S,lc);
    IF ok THEN
        ok:=NOT ( lc > LONGCARD(maxi) );
        IF ok THEN
            ok:= ( lc >= LONGCARD(mini) );
            IF ok THEN v:=CARDINAL(lc);END;
        END;
    END;
    RETURN ok;
END grabvalue;

PROCEDURE chkNoPath (S:pathtype):BOOLEAN;
VAR
    u,d,n,e,R:pathtype;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Lib.MakeAllPath(R,"","",n,e);
    RETURN same(S,R);
END chkNoPath;

PROCEDURE num2str (v,base:CARDINAL;wipad:INTEGER;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr(LONGCARD(v),R,base,ok);
    IF ok THEN
        FOR i:=Str.Length(R)+1 TO CARDINAL( ABS(wipad) ) DO
            IF wipad < 0 THEN
                Str.Append(R,padchar);
            ELSE
                Str.Prepend(R,padchar);
            END;
        END;
    ELSE
        R:="*** ERROR ***";
    END;
    RETURN R;
END num2str;

PROCEDURE msg2 (quoted:BOOLEAN;S1,S2:ARRAY OF CHAR );
CONST
    wi = 10;
VAR
    i:CARDINAL;
BEGIN
    WrStr(S1);
    FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;WrStr(" : ");
    IF quoted THEN WrStr(dquote);END;
    WrStr(S2);
    IF quoted THEN WrStr(dquote);END;
    WrLn;
END msg2;

TYPE
    optype = (opNone,opEncrypt,opDecrypt);

PROCEDURE newop (VAR op:optype;wanted:optype ):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    IF ( (op = opNone) OR (op = wanted) ) THEN
        op:=wanted;
        ok:=TRUE;
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newop;

PROCEDURE strToPP (VAR pp:pptype;S:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    pp.len := Str.Length(S);
    FOR i:=1 TO pp.len DO pp.dat[i-1]:=ORD(S[i-1]);END;
END strToPP;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    dttype = RECORD
        CASE : BOOLEAN OF
        | TRUE  :
            t : CARDINAL; (* hms is low  *)
            d : CARDINAL; (* ymd is high *)
        | FALSE :
            dt : LONGCARD;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

PROCEDURE getfilestamp (VAR h:dttype  ; S:pathtype):BOOLEAN;
VAR
    hnd:FIO.File;
    rc:BOOLEAN;
BEGIN
    hnd:=FIO.OpenRead(S);
        h.dt := FIO.GetFileDate(hnd);
        rc:=TRUE;
    FIO.Close(hnd);
    RETURN rc;
END getfilestamp;

PROCEDURE setFileStamp (h:dttype;S:pathtype):BOOLEAN;
VAR
    hnd:FIO.File;
    rc:BOOLEAN;
BEGIN
    hnd:=FIO.Open(S);
        FIO.SetFileDate(hnd,h.dt);
        rc:=TRUE;
    FIO.Close(hnd);
    RETURN rc;
END setFileStamp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgPrompt1  = "Enter passphrase       : ";
    msgPrompt2  = "Enter passphrase again : ";
    strSource   = "::: Source";
    strTarget   = "+++ Target";
CONST
    msgWorking  = "Working, please wait...";
CONST
    firstparm = 1;
    maxparm   = 3;
VAR
    whatcipher,whatrng : CARDINAL;
    SALTLEN,PASSES : CARDINAL;
    op : optype;
    flagPPFROMFILE:BOOLEAN; (* if true, passphrase parm is a file *)
    flagHEX,flagREPLACEEXT,flagOVERWRITE:BOOLEAN;
    flagCOPYSTAMP,flagSECUREINPUT,flagUNWISE:BOOLEAN;
VAR
    parm : ARRAY[firstparm..maxparm] OF pathtype;
    F,source,target,S,R: pathtype;
    lastparm,parmcount,i,got,opt : CARDINAL;
    ok,DEBUG:BOOLEAN;
    ppsecurity:pptype;
    orgstamp:dttype;
BEGIN
    (* Lib.DisableBreakCheck();  *)
    FIO.IOcheck := FALSE;
    FIO.ShareMode := FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    DEBUG    := FALSE;

    flagPPFROMFILE  := FALSE;
    flagOVERWRITE   := FALSE;
    (* flagOVERWRITERO := FALSE; *)
    flagHEX         := FALSE;
    flagREPLACEEXT  := FALSE;
    flagSECUREINPUT := FALSE;
    flagUNWISE      := FALSE;
    flagCOPYSTAMP   := TRUE;
    SALTLEN         := DEFSALTLEN;
    PASSES          := DEFPASSES;
    op              := opNone;
    whatrng         := QDrng;
    whatcipher      := methodrc4;

    lastparm := firstparm-1;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "E"+delim+"ENCRYPT"+delim+"CIPHER"+delim+
                                  "D"+delim+"DECRYPT"+delim+"DECIPHER"+delim+
                                  "@"+delim+
                                  "x"+delim+"lfn"+delim+
                                  "DEBUG"+delim+

                                  "I:"+delim+"IV:"+delim+"SALT:"+delim+"VECTORSIZE:"+delim+
                                  "P:"+delim+"PASSES:"+delim+"LOOPS:"+delim+"N:"+delim+
                                  "CS1"+delim+"OLD"+delim+
                                  "CS2"+delim+"NEW"+delim+
                                  "EE"+delim+
                                  "DD"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "r"+delim+"readonly"+delim+
                                  "oo"+delim+

                                  "t"+delim+"hex"+delim+
                                  "et"+delim+
                                  "dt"+delim+
                                  "S"+delim+"SECURE"+delim+
                                  "U"+delim+"UNWISE"+delim+
                                  "F"+delim+"FILE"+delim+
                                  "Y"+delim+"STAMP"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5,6 : IF newop(op,opEncrypt)=FALSE THEN abort(errExclusive,"");END;
            | 7,8,9 : IF newop(op,opDecrypt)=FALSE THEN abort(errExclusive,"");END;
            | 10 :    flagPPFROMFILE  := TRUE; (* passphrase is file *)
            | 11,12 : ; (* useLFN          := FALSE; *)
            | 13:     DEBUG           := TRUE;

            | 14,15,16,17:IF grabvalue(SALTLEN,MINSALTLEN,MAXSALTLEN,R)=FALSE THEN abort(errSALT,sSALTLENrange);END;
            | 18,19,20,21:IF grabvalue(PASSES,MINPASSES,MAXPASSES,R)=FALSE THEN abort(errPASSES,sPASSESrange);END;
            | 22,23:     SALTLEN := SALTCS1; PASSES:=PASSESCS1;
            | 24,25:     SALTLEN := SALTCS2; PASSES:=PASSESCS2;
            | 26:        IF newop(op,opEncrypt)=FALSE THEN abort(errExclusive,"");END;
                         flagPPFROMFILE  := TRUE;
            | 27:        IF newop(op,opDecrypt)=FALSE THEN abort(errExclusive,"");END;
                         flagPPFROMFILE  := TRUE;
            | 28,29:     flagOVERWRITE   := TRUE;
            | 30,31:     ; (* flagOVERWRITERO := TRUE; *)
            | 32:        ; (* flagOVERWRITE   := TRUE;
                         flagOVERWRITERO := TRUE; *)

            | 33,34:     flagHEX         := TRUE;
            | 35:        IF newop(op,opEncrypt)=FALSE THEN abort(errExclusive,"");END;
                         flagHEX         := TRUE;
            | 36:        IF newop(op,opDecrypt)=FALSE THEN abort(errExclusive,"");END;
                         flagHEX         := TRUE;
            | 37,38:     flagSECUREINPUT := TRUE;
            | 39,40:     flagUNWISE      := TRUE;
            | 41,42 :    flagPPFROMFILE  := TRUE; (* passphrase is file *) (* same as 10 *)
            | 43,44 :    flagCOPYSTAMP   := FALSE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            parm[lastparm]:=S;
        END;
    END;
    IF op = opNone THEN abort(errMissingCommand,"");END;

    IF (flagSECUREINPUT AND flagUNWISE) THEN abort(errIllogicalInput,"");END;

    initRNG(whatrng);

    CASE lastparm OF
    | firstparm-1:
        abort(errHelp,"");
    | firstparm:
        CASE op OF
        | opEncrypt: S:="<ciphered> [passphrase]";
        | opDecrypt: S:="<original> [passphrase]";
        | opNone:    S:="<-e|-d>";
        ELSE ; (* //ISO fixed silly requirement *) END;
        abort(errExpecting,S);
    | firstparm+1:
        Str.Copy(source,parm[firstparm]);
        Str.Copy(target,parm[firstparm+1]);
        pp.len:=MINPPLEN;
    | maxparm:
        Str.Copy(source,parm[firstparm]);
        Str.Copy(target,parm[firstparm+1]);
        Str.Copy(F,parm[maxparm]);
        pp.len:=Str.Length(F);
        FOR i:= 1 TO pp.len DO pp.dat[i-1]:=ORD(F[i-1]); END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF same(source,dot) THEN source:=stardotstar;END;
    IF same(target,dot) THEN target:=stardotstar;END;

    IF chkJoker(source) THEN abort(errJoker,source);END;
    IF chkJoker(target) THEN abort(errJoker,target);END;
    IF chkNoPath(target)=FALSE THEN abort(errTargetPath,target);END;

    IF isDirectory(source) THEN abort(errIsDir,source);END;
    IF isDirectory(target) THEN abort(errIsDir,target);END;

    IF FIO.Exists(source)=FALSE THEN abort(errNoMatch,source);END;

    IF FIO.Exists(target) THEN
        IF flagOVERWRITE THEN
            IF fileIsRO(target) THEN
	    	(* 	
                IF flagOVERWRITERO THEN
                    fileSetRW(useLFN,target);
                    fileErase(useLFN,target);
                ELSE
		*)
                    abort(errTargetRO,target);
                (* END; *)
            ELSE
                FIO.Erase(target);
            END;
        ELSE
            abort(errTargetHere,target);
        END;
    END;

    IF pp.len = MINPPLEN THEN (* no passphrase nor filevault specified *)
        IF flagPPFROMFILE THEN (* yes, we could ask it from kbd *)
            abort(errMissingPPfilespec,"");
        ELSE
            input (S, flagUNWISE,flagSECUREINPUT,msgPrompt1);
            preprocessLine(S);
            strToPP(pp,S);
            IF pp.len = MINPPLEN THEN abort(errEmptyPP,"");END;

            input (S, flagUNWISE,flagSECUREINPUT,msgPrompt2);
            preprocessLine(S);
            strToPP(ppsecurity,S);

            WrLn;
            IF pp.len # ppsecurity.len THEN abort(errPPmismatch,"");END;
            opt:=0;
            FOR i:=1 TO pp.len DO
                IF pp.dat[i-1] # ppsecurity.dat[i-1] THEN INC(opt); END;
            END;
            IF opt # 0 THEN abort(errPPmismatch,"");END;
        END;
    ELSE (* passphrase or filevault *)
        IF flagPPFROMFILE THEN
            IF same(F,dot) THEN F:=stardotstar;END;
            IF chkJoker(F) THEN abort(errJoker,F);END;
            IF isDirectory(F) THEN abort(errIsDir,F);END;
            IF FIO.Exists(F)=FALSE THEN abort(errNoMatch,F);END;

            IF grabPP (pp,F)= FALSE THEN abort(errNoPPhere,F);END;
        END;
    END;

    video(msgWorking,TRUE);
    IF flagCOPYSTAMP THEN ok:=getfilestamp(orgstamp, source); END;
    i:=procFile( (op=opEncrypt),
                 whatrng,whatcipher,SALTLEN,PASSES,pp,source,target);
    IF flagCOPYSTAMP THEN ok:=setFileStamp(orgstamp,target); END;
    video(msgWorking,FALSE);

    IF i # errNone THEN abort(i,source);END;

    msg2(TRUE,strSource,source);
    msg2(TRUE,strTarget,target);

    IF DEBUG THEN
        msg2(TRUE,  "Source" ,source);
        msg2(TRUE,  "Target" ,target);
        IF flagCOPYSTAMP THEN
            S:="source date/time";
        ELSE
            S:="current date/time";
        END;
        msg2(FALSE, "Stamp"  ,S);
        msg2(FALSE, "IV"     ,num2str(SALTLEN,10,1," "));
        msg2(FALSE, "PASSES" ,num2str(PASSES,10,1," "));
(*
        IF flagHEX THEN
            S:="hex text";
        ELSE
            S:="binary";
        END;
        msg2(FALSE, "Mode"    ,S);
*)
        S:="";
        FOR i:= 1 TO pp.len DO Str.Append(S,CHR(pp.dat[i-1]));END; (* //FIXME later *)
        msg2(TRUE,  "Passphrase",S);
    END;

    SALTLEN        := zerocard;
    PASSES         := zerocard;
    pp.len         := zerocard;
    ppsecurity.len := zerocard;
    FOR i:=MINPPLEN TO MAXPPLEN-1 DO
        pp.dat[i]        :=zerocard;
        ppsecurity.dat[i]:=zerocard;
    END;

    abort(errNone,"");
END mSaber.





